/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/auxiliaryWindow","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(Z){for(var e=[],P=0,D=Z.length;P<D;P++)e[P]=ee[Z[P]];return e};define(ee[132],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function P(w,$,m){const h=D(w,$);if(h!==-1)return w[h]}e.$eb=P;function D(w,$,m=w.length-1){for(let h=m;h>=0;h--){const c=w[h];if($(c))return h}return-1}e.$fb=D;function s(w,$){const m=M(w,$);return m===-1?void 0:w[m]}e.$gb=s;function M(w,$,m=0,h=w.length){let c=m,k=h;for(;c<k;){const u=Math.floor((c+k)/2);$(w[u])?c=u+1:k=u}return c-1}e.$hb=M;function C(w,$){const m=S(w,$);return m===w.length?void 0:w[m]}e.$ib=C;function S(w,$,m=0,h=w.length){let c=m,k=h;for(;c<k;){const u=Math.floor((c+k)/2);$(w[u])?k=u:c=u+1}return c}e.$jb=S;function f(w,$,m=0,h=w.length){const c=S(w,$,m,h);return c===w.length?-1:c}e.$kb=f;class a{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(a.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!$(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const m=M(this.e,$,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$lb=a;function g(w,$){if(w.length===0)return;let m=w[0];for(let h=1;h<w.length;h++){const c=w[h];$(c,m)>0&&(m=c)}return m}e.$mb=g;function b(w,$){if(w.length===0)return;let m=w[0];for(let h=1;h<w.length;h++){const c=w[h];$(c,m)>=0&&(m=c)}return m}e.$nb=b;function p(w,$){return g(w,(m,h)=>-$(m,h))}e.$ob=p;function d(w,$){if(w.length===0)return-1;let m=0;for(let h=1;h<w.length;h++){const c=w[h];$(c,w[m])>0&&(m=h)}return m}e.$pb=d;function y(w,$){for(const m of w){const h=$(m);if(h!==void 0)return h}}e.$qb=y}),define(ee[133],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function P(C,S){const f=Object.create(null);for(const a of C){const g=S(a);let b=f[g];b||(b=f[g]=[]),b.push(a)}return f}e.$J=P;function D(C,S){const f=[],a=[];for(const g of C)S.has(g)||f.push(g);for(const g of S)C.has(g)||a.push(g);return{removed:f,added:a}}e.$K=D;function s(C,S){const f=[],a=[];for(const[g,b]of C)S.has(g)||f.push(b);for(const[g,b]of S)C.has(g)||a.push(b);return{removed:f,added:a}}e.$L=s;function M(C,S){const f=new Set;for(const a of S)C.has(a)&&f.add(a);return f}e.$M=M}),define(ee[134],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=e.$Qs=e.$Ps=void 0;function P(S,f){const a=Math.pow(10,f);return Math.round(S*a)/a}class D{constructor(f,a,g,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=P(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.r===a.r&&f.g===a.g&&f.b===a.b&&f.a===a.a}}e.$Ps=D;class s{constructor(f,a,g,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.l=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.l===a.l&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,b=f.b/255,p=f.a,d=Math.max(a,g,b),y=Math.min(a,g,b);let w=0,$=0;const m=(y+d)/2,h=d-y;if(h>0){switch($=Math.min(m<=.5?h/(2*m):h/(2-2*m),1),d){case a:w=(g-b)/h+(g<b?6:0);break;case g:w=(b-a)/h+2;break;case b:w=(a-g)/h+4;break}w*=60,w=Math.round(w)}return new s(w,$,m,p)}static i(f,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?f+(a-f)*6*g:g<1/2?a:g<2/3?f+(a-f)*(2/3-g)*6:f}static toRGBA(f){const a=f.h/360,{s:g,l:b,a:p}=f;let d,y,w;if(g===0)d=y=w=b;else{const $=b<.5?b*(1+g):b+g-b*g,m=2*b-$;d=s.i(m,$,a+1/3),y=s.i(m,$,a),w=s.i(m,$,a-1/3)}return new D(Math.round(d*255),Math.round(y*255),Math.round(w*255),p)}}e.$Qs=s;class M{constructor(f,a,g,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.v=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.v===a.v&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,b=f.b/255,p=Math.max(a,g,b),d=Math.min(a,g,b),y=p-d,w=p===0?0:y/p;let $;return y===0?$=0:p===a?$=((g-b)/y%6+6)%6:p===g?$=(b-a)/y+2:$=(a-g)/y+4,new M(Math.round($*60),w,p,f.a)}static toRGBA(f){const{h:a,s:g,v:b,a:p}=f,d=b*g,y=d*(1-Math.abs(a/60%2-1)),w=b-d;let[$,m,h]=[0,0,0];return a<60?($=d,m=y):a<120?($=y,m=d):a<180?(m=d,h=y):a<240?(m=y,h=d):a<300?($=y,h=d):a<=360&&($=d,h=y),$=Math.round(($+w)*255),m=Math.round((m+w)*255),h=Math.round((h+w)*255),new D($,m,h,p)}}e.$Rs=M;class C{static fromHex(f){return C.Format.CSS.parseHex(f)||C.red}static equals(f,a){return!f&&!a?!0:!f||!a?!1:f.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof D)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&D.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=C.k(this.rgba.r),a=C.k(this.rgba.g),g=C.k(this.rgba.b),b=.2126*f+.7152*a+.0722*g;return P(b,4)}static k(f){const a=f/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g}isDarkerThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a<g}lighten(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:a,g,b,a:p}=this.rgba;return new C(new D(a,g,b,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const a=f.rgba,g=this.rgba.a,b=a.a,p=g+b*(1-g);if(p<1e-6)return C.transparent;const d=this.rgba.r*g/p+a.r*b*(1-g)/p,y=this.rgba.g*g/p+a.g*b*(1-g)/p,w=this.rgba.b*g/p+a.b*b*(1-g)/p;return new C(new D(d,y,w,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:a,g,b,a:p}=this.rgba;return new C(new D(f.rgba.r-p*(f.rgba.r-a),f.rgba.g-p*(f.rgba.g-g),f.rgba.b-p*(f.rgba.b-b),1))}flatten(...f){const a=f.reduceRight((g,b)=>C.o(b,g));return C.o(this,a)}static o(f,a){const g=1-f.rgba.a;return new C(new D(g*a.rgba.r+f.rgba.a*f.rgba.r,g*a.rgba.g+f.rgba.a*f.rgba.g,g*a.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(f,a,g){if(f.isLighterThan(a))return f;g=g||.5;const b=f.getRelativeLuminance(),p=a.getRelativeLuminance();return g=g*(p-b)/p,f.lighten(g)}static getDarkerColor(f,a,g){if(f.isDarkerThan(a))return f;g=g||.5;const b=f.getRelativeLuminance(),p=a.getRelativeLuminance();return g=g*(b-p)/b,f.darken(g)}static{this.white=new C(new D(255,255,255,1))}static{this.black=new C(new D(0,0,0,1))}static{this.red=new C(new D(255,0,0,1))}static{this.blue=new C(new D(0,0,255,1))}static{this.green=new C(new D(0,255,0,1))}static{this.cyan=new C(new D(0,255,255,1))}static{this.lightgrey=new C(new D(211,211,211,1))}static{this.transparent=new C(new D(0,0,0,0))}}e.$Ss=C,function(S){let f;(function(a){let g;(function(b){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}b.formatRGB=p;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=d;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}b.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=w;function $(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function m(t){return`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}`}b.formatHex=m;function h(t,l=!1){return l&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}${$(Math.round(t.rgba.a*255))}`}b.formatHexA=h;function c(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}b.format=c;function k(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new S(new D(r,i,n,1))}if(l===9){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),o=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new S(new D(r,i,n,o/255))}if(l===4){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new S(new D(16*r+r,16*i+i,16*n+n))}if(l===5){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),o=u(t.charCodeAt(4));return new S(new D(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}b.parseHex=k;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(f=S.Format||(S.Format={}))}(C||(e.$Ss=C={}))}),define(ee[54],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function P(C){return(S,f,a)=>{let g=null,b=null;if(typeof a.value=="function"?(g="value",b=a.value):typeof a.get=="function"&&(g="get",b=a.get),!b)throw new Error("not supported");a[g]=C(b,f)}}function D(C,S,f){let a=null,g=null;if(typeof f.value=="function"?(a="value",g=f.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",g=f.get),!g)throw new Error("not supported");const b=`$memoize$${S}`;f[a]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,p)}),this[b]}}e.$fh=D;function s(C,S,f){return P((a,g)=>{const b=`$debounce$${g}`,p=`$debounce$result$${g}`;return function(...d){this[p]||(this[p]=f?f():void 0),clearTimeout(this[b]),S&&(this[p]=S(this[p],...d),d=[this[p]]),this[b]=setTimeout(()=>{a.apply(this,d),this[p]=f?f():void 0},C)}})}e.$gh=s;function M(C,S,f){return P((a,g)=>{const b=`$throttle$timer$${g}`,p=`$throttle$result$${g}`,d=`$throttle$lastRun$${g}`,y=`$throttle$pending$${g}`;return function(...w){if(this[p]||(this[p]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...w)),this[y])return;const $=this[d]+C;$<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0):(this[y]=!0,this[b]=setTimeout(()=>{this[y]=!1,this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0},$-Date.now()))}})}e.$hh=M}),define(ee[14],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=P,e.$W=new P;function D(u){e.$W.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=D;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(u){a(u)||e.$W.onUnexpectedError(u)}e.$Z=M;function C(u){a(u)||e.$W.onUnexpectedExternalError(u)}e.$1=C;function S(u){if(u instanceof Error){const{name:t,message:l}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.$2=S;const f="Canceled";function a(u){return u instanceof g?!0:u instanceof Error&&u.name===f&&u.message===f}e.$3=a;class g extends Error{constructor(){super(f),this.name=this.message}}e.$4=g;function b(){const u=new Error(f);return u.name=u.message,u}e.$5=b;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$6=p;function d(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$7=d;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=y;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$9=w;class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=$;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=m;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=h;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const l=new c;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=c;class k extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$bb=k}),define(ee[23],te([0,1,14,132]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(W,z=0){return W[W.length-(1+z)]}e.$rb=s;function M(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.$sb=M;function C(W,z,G=(ce,de)=>ce===de){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let ce=0,de=W.length;ce<de;ce++)if(!G(W[ce],z[ce]))return!1;return!0}e.$tb=C;function S(W,z){const G=W.length-1;z<G&&(W[z]=W[G]),W.pop()}e.$ub=S;function f(W,z,G){return a(W.length,ce=>G(W[ce],z))}e.$vb=f;function a(W,z){let G=0,ce=W-1;for(;G<=ce;){const de=(G+ce)/2|0,ue=z(de);if(ue<0)G=de+1;else if(ue>0)ce=de-1;else return de}return-(G+1)}e.$wb=a;function g(W,z,G){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const ce=z[Math.floor(z.length*Math.random())],de=[],ue=[],fe=[];for(const ye of z){const be=G(ye,ce);be<0?de.push(ye):be>0?ue.push(ye):fe.push(ye)}return W<de.length?g(W,de,G):W<de.length+fe.length?fe[0]:g(W-(de.length+fe.length),ue,G)}e.$xb=g;function b(W,z){const G=[];let ce;for(const de of W.slice(0).sort(z))!ce||z(ce[0],de)!==0?(ce=[de],G.push(ce)):ce.push(de);return G}e.$yb=b;function*p(W,z){let G,ce;for(const de of W)ce!==void 0&&z(ce,de)?G.push(de):(G&&(yield G),G=[de]),ce=de;G&&(yield G)}e.$zb=p;function d(W,z){for(let G=0;G<=W.length;G++)z(G===0?void 0:W[G-1],G===W.length?void 0:W[G])}e.$Ab=d;function y(W,z){for(let G=0;G<W.length;G++)z(G===0?void 0:W[G-1],W[G],G+1===W.length?void 0:W[G+1])}e.$Bb=y;function w(W,z,G){const ce=[];function de(ye,be,pe){if(be===0&&pe.length===0)return;const Re=ce[ce.length-1];Re&&Re.start+Re.deleteCount===ye?(Re.deleteCount+=be,Re.toInsert.push(...pe)):ce.push({start:ye,deleteCount:be,toInsert:pe})}let ue=0,fe=0;for(;;){if(ue===W.length){de(ue,0,z.slice(fe));break}if(fe===z.length){de(ue,W.length-ue,[]);break}const ye=W[ue],be=z[fe],pe=G(ye,be);pe===0?(ue+=1,fe+=1):pe<0?(de(ue,1,[]),ue+=1):pe>0&&(de(ue,0,[be]),fe+=1)}return ce}e.$Cb=w;function $(W,z,G){const ce=w(W,z,G),de=[],ue=[];for(const fe of ce)de.push(...W.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:de,added:ue}}e.$Db=$;function m(W,z,G){if(G===0)return[];const ce=W.slice(0,G).sort(z);return c(W,z,ce,G,W.length),ce}e.top=m;function h(W,z,G,ce,de){return G===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const ye=W.length,be=W.slice(0,G).sort(z);for(let pe=G,Re=Math.min(G+ce,ye);pe<ye;pe=Re,Re=Math.min(Re+ce,ye)){if(pe>G&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new P.$4;c(W,z,be,pe,Re)}return be})().then(ue,fe)})}e.$Fb=h;function c(W,z,G,ce,de){for(const ue=G.length;ce<de;ce++){const fe=W[ce];if(z(fe,G[ue-1])<0){G.pop();const ye=(0,D.$jb)(G,be=>z(fe,be)<0);G.splice(ye,0,fe)}}}function k(W){return W.filter(z=>!!z)}e.$Gb=k;function u(W){let z=0;for(let G=0;G<W.length;G++)W[G]&&(W[z]=W[G],z+=1);W.length=z}e.$Hb=u;function t(W,z,G){W.splice(G,0,W.splice(z,1)[0])}e.$Ib=t;function l(W){return!Array.isArray(W)||W.length===0}e.$Jb=l;function r(W){return Array.isArray(W)&&W.length>0}e.$Kb=r;function i(W,z=G=>G){const G=new Set;return W.filter(ce=>{const de=z(ce);return G.has(de)?!1:(G.add(de),!0)})}e.$Lb=i;function n(W){const z=new Set;return G=>{const ce=W(G);return z.has(ce)?!1:(z.add(ce),!0)}}e.$Mb=n;function o(W,z){return W.length>0?W[0]:z}e.$Nb=o;function v(W,z){return W.length>0?W[W.length-1]:z}e.$Ob=v;function R(W,z,G=(ce,de)=>ce===de){let ce=0;for(let de=0,ue=Math.min(W.length,z.length);de<ue&&G(W[de],z[de]);de++)ce++;return ce}e.$Pb=R;function A(W){return[].concat(...W)}e.$Qb=A;function E(W,z){let G=typeof z=="number"?W:0;typeof z=="number"?G=W:(G=0,z=W);const ce=[];if(G<=z)for(let de=G;de<z;de++)ce.push(de);else for(let de=G;de>z;de--)ce.push(de);return ce}e.$Rb=E;function I(W,z,G){return W.reduce((ce,de)=>(ce[z(de)]=G?G(de):de,ce),Object.create(null))}e.$Sb=I;function L(W,z){return W.push(z),()=>F(W,z)}e.$Tb=L;function F(W,z){const G=W.indexOf(z);if(G>-1)return W.splice(G,1),z}e.$Ub=F;function B(W,z,G){const ce=W.slice(0,z),de=W.slice(z);return ce.concat(G,de)}e.$Vb=B;function se(W,z){let G;if(typeof z=="number"){let ce=z;G=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else G=Math.random;for(let ce=W.length-1;ce>0;ce-=1){const de=Math.floor(G()*(ce+1)),ue=W[ce];W[ce]=W[de],W[de]=ue}}e.$Wb=se;function x(W,z){const G=W.indexOf(z);G>-1&&(W.splice(G,1),W.unshift(z))}e.$Xb=x;function ae(W,z){const G=W.indexOf(z);G>-1&&(W.splice(G,1),W.push(z))}e.$Yb=ae;function ne(W,z){for(const G of z)W.push(G)}e.$Zb=ne;function re(W,z){return Array.isArray(W)?W.map(z):z(W)}e.$1b=re;function X(W){return Array.isArray(W)?W:[W]}e.$2b=X;function K(W){return W[Math.floor(Math.random()*W.length)]}e.$3b=K;function V(W,z,G){const ce=U(W,z),de=W.length,ue=G.length;W.length=de+ue;for(let fe=de-1;fe>=ce;fe--)W[fe+ue]=W[fe];for(let fe=0;fe<ue;fe++)W[fe+ce]=G[fe]}e.$4b=V;function N(W,z,G,ce){const de=U(W,z);let ue=W.splice(de,G);return ue===void 0&&(ue=[]),V(W,de,ce),ue}e.$5b=N;function U(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var H;(function(W){function z(ue){return ue<0}W.isLessThan=z;function G(ue){return ue<=0}W.isLessThanOrEqual=G;function ce(ue){return ue>0}W.isGreaterThan=ce;function de(ue){return ue===0}W.isNeitherLessOrGreaterThan=de,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function J(W,z){return(G,ce)=>z(W(G),W(ce))}e.$6b=J;function ie(...W){return(z,G)=>{for(const ce of W){const de=ce(z,G);if(!H.isNeitherLessOrGreaterThan(de))return de}return H.neitherLessOrGreaterThan}}e.$7b=ie;const oe=(W,z)=>W-z;e.$8b=oe;const T=(W,z)=>(0,e.$8b)(W?1:0,z?1:0);e.$9b=T;function O(W){return(z,G)=>-W(z,G)}e.$0b=O;class j{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let G=this.c;for(;G<this.g.length&&z(this.g[G]);)G++;const ce=G===this.c?null:this.g.slice(this.c,G);return this.c=G,ce}takeFromEndWhile(z){let G=this.d;for(;G>=0&&z(this.g[G]);)G--;const ce=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,ce}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const G=this.g.slice(this.c,this.c+z);return this.c+=z,G}}e.$$b=j;class q{static{this.empty=new q(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(G=>(z(G),!0))}toArray(){const z=[];return this.iterate(G=>(z.push(G),!0)),z}filter(z){return new q(G=>this.iterate(ce=>z(ce)?G(ce):!0))}map(z){return new q(G=>this.iterate(ce=>G(z(ce))))}some(z){let G=!1;return this.iterate(ce=>(G=z(ce),!G)),G}findFirst(z){let G;return this.iterate(ce=>z(ce)?(G=ce,!1):!0),G}findLast(z){let G;return this.iterate(ce=>(z(ce)&&(G=ce),!0)),G}findLastMaxBy(z){let G,ce=!0;return this.iterate(de=>((ce||H.isGreaterThan(z(de,G)))&&(ce=!1,G=de),!0)),G}}e.$_b=q}),define(ee[135],te([0,1,14]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(f,a){if(!f)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function s(f,a="Unreachable"){throw new Error(a)}e.$3c=s;function M(f){if(!f)throw new P.$bb("Assertion Failed")}e.$4c=M;function C(f){if(!f()){debugger;f(),(0,P.$Z)(new P.$bb("Assertion Failed"))}}e.$5c=C;function S(f,a){let g=0;for(;g<f.length-1;){const b=f[g],p=f[g+1];if(!a(b,p))return!1;g++}return!0}e.$6c=S}),define(ee[82],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function P(D){const s=this;let M=!1,C;return function(){return M||(M=!0,C=D.apply(s,arguments)),C}}e.$cb=P}),define(ee[69],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(D){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=s;const M=Object.freeze([]);function C(){return M}D.empty=C;function*S(u){yield u}D.single=S;function f(u){return s(u)?u:S(u)}D.wrap=f;function a(u){return u||M}D.from=a;function*g(u){for(let t=u.length-1;t>=0;t--)yield u[t]}D.reverse=g;function b(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=b;function p(u){return u[Symbol.iterator]().next().value}D.first=p;function d(u,t){for(const l of u)if(t(l))return!0;return!1}D.some=d;function y(u,t){for(const l of u)if(t(l))return l}D.find=y;function*w(u,t){for(const l of u)t(l)&&(yield l)}D.filter=w;function*$(u,t){let l=0;for(const r of u)yield t(r,l++)}D.map=$;function*m(...u){for(const t of u)for(const l of t)yield l}D.concat=m;function h(u,t,l){let r=l;for(const i of u)r=t(r,i);return r}D.reduce=h;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}D.slice=c;function k(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const r=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=r.next();if(n.done)return[l,D.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return r}}]}D.consume=k})(P||(e.Iterable=P={}))}),define(ee[44],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(t,l=!1){let r=0;const i=t.length;let n="",o=0,v=16,R=0;function A(x){let ae=0,ne=0;for(;ae<x;){const re=t.charCodeAt(r);if(re>=48&&re<=57)ne=ne*16+re-48;else if(re>=65&&re<=70)ne=ne*16+re-65+10;else if(re>=97&&re<=102)ne=ne*16+re-97+10;else break;r++,ae++}return ae<x&&(ne=-1),ne}function E(x){r=x,n="",o=0,v=16,R=0}function I(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&a(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&a(t.charCodeAt(r)))for(r++;r<t.length&&a(t.charCodeAt(r));)r++;else return R=3,t.substring(x,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&a(t.charCodeAt(r))){for(r++;r<t.length&&a(t.charCodeAt(r));)r++;ae=r}else R=3;return t.substring(x,ae)}function L(){let x="",ae=r;for(;;){if(r>=i){x+=t.substring(ae,r),R=2;break}const ne=t.charCodeAt(r);if(ne===34){x+=t.substring(ae,r),r++;break}if(ne===92){if(x+=t.substring(ae,r),r++,r>=i){R=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const X=A(4);X>=0?x+=String.fromCharCode(X):R=4;break}default:R=5}ae=r;continue}if(ne>=0&&ne<=31)if(f(ne)){x+=t.substring(ae,r),R=2;break}else R=6;r++}return x}function F(){if(n="",R=0,o=r,r>=i)return o=i,v=17;let x=t.charCodeAt(r);if(S(x)){do r++,n+=String.fromCharCode(x),x=t.charCodeAt(r);while(S(x));return v=15}if(f(x))return r++,n+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),v=14;switch(x){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,n=L(),v=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(ae,r),v=12}if(t.charCodeAt(r+1)===42){r+=2;const ne=i-1;let re=!1;for(;r<ne;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,re=!0;break}r++}return re||(r++,R=1),n=t.substring(ae,r),v=13}return n+=String.fromCharCode(x),r++,v=16}case 45:if(n+=String.fromCharCode(x),r++,r===i||!a(t.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),v=11;default:for(;r<i&&B(x);)r++,x=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return n+=String.fromCharCode(x),r++,v=16}}function B(x){if(S(x)||f(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let x;do x=F();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:l?se:F,getToken:()=>v,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>R}}e.$Pm=C;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function a(t){return t>=48&&t<=57}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function b(t,l){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function R(A,E,I,L){o.value=A,o.offset=E,o.length=I,o.type=L,o.colonOffset=void 0,n=o}try{c(t,{onObjectBegin:(A,E)=>{if(l<=A)throw i;n=void 0,v=l>A,r.push("")},onObjectProperty:(A,E,I)=>{if(l<E||(R(A,E,I,"property"),r[r.length-1]=A,l<=E+I))throw i},onObjectEnd:(A,E)=>{if(l<=A)throw i;n=void 0,r.pop()},onArrayBegin:(A,E)=>{if(l<=A)throw i;n=void 0,r.push(0)},onArrayEnd:(A,E)=>{if(l<=A)throw i;n=void 0,r.pop()},onLiteralValue:(A,E,I)=>{if(l<E||(R(A,E,I,u(A)),l<=E+I))throw i},onSeparator:(A,E,I)=>{if(l<=E)throw i;if(A===":"&&n&&n.type==="property")n.colonOffset=E,v=!1,n=void 0;else if(A===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(v=!0,r[r.length-1]=""),n=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:n,isAtPropertyKey:v,matches:A=>{let E=0;for(let I=0;E<A.length&&I<r.length;I++)if(A[E]===r[I]||A[E]==="*")E++;else if(A[E]!=="**")return!1;return E===A.length}}}e.$Qm=b;function p(t,l=[],r=M.DEFAULT){let i=null,n=[];const o=[];function v(A){Array.isArray(n)?n.push(A):i!==null&&(n[i]=A)}return c(t,{onObjectBegin:()=>{const A={};v(A),o.push(n),n=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const A=[];v(A),o.push(n),n=A,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:v,onError:(A,E,I)=>{l.push({error:A,offset:E,length:I})}},r),n[0]}e.$Rm=p;function d(t,l=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function o(A){return i.children.push(A),A}c(t,{onObjectBegin:A=>{i=o({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,E,I)=>{i=o({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:E,length:I,parent:i})},onObjectEnd:(A,E)=>{i.length=A+E-i.offset,i=i.parent,n(A+E)},onArrayBegin:(A,E)=>{i=o({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,E)=>{i.length=A+E-i.offset,i=i.parent,n(A+E)},onLiteralValue:(A,E,I)=>{o({type:u(A),offset:E,length:I,parent:i,value:A}),n(E+I)},onSeparator:(A,E,I)=>{i.type==="property"&&(A===":"?i.colonOffset=E:A===","&&n(E))},onError:(A,E,I)=>{l.push({error:A,offset:E,length:I})}},r);const R=i.children[0];return R&&delete R.parent,R}e.$Sm=d;function y(t,l){if(!t)return;let r=t;for(const i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Tm=y;function w(t){if(!t.parent||!t.parent.children)return[];const l=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.$Um=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const l=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(l[r.children[0].value]=$(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Vm=$;function m(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.$Wm=m;function h(t,l,r=!1){if(m(t,l,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=h(i[n],l,r);if(o)return o}return t}}e.$Xm=h;function c(t,l,r=M.DEFAULT){const i=C(t,!1);function n(J){return J?()=>J(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(J){return J?ie=>J(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=n(l.onObjectBegin),R=o(l.onObjectProperty),A=n(l.onObjectEnd),E=n(l.onArrayBegin),I=n(l.onArrayEnd),L=o(l.onLiteralValue),F=o(l.onSeparator),B=n(l.onComment),se=o(l.onError),x=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const J=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:x||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(J){case 12:case 13:x?re(10):B();break;case 16:re(1);break;case 15:case 14:break;default:return J}}}function re(J,ie=[],oe=[]){if(se(J),ie.length+oe.length>0){let T=i.getToken();for(;T!==17;){if(ie.indexOf(T)!==-1){ne();break}else if(oe.indexOf(T)!==-1)break;T=ne()}}}function X(J){const ie=i.getTokenValue();return J?L(ie):R(ie),ne(),!0}function K(){switch(i.getToken()){case 11:{let J=0;try{J=JSON.parse(i.getTokenValue()),typeof J!="number"&&(re(2),J=0)}catch{re(2)}L(J);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return ne(),!0}function V(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(F(":"),ne(),H()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function N(){v(),ne();let J=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(J||re(4,[],[]),F(","),ne(),i.getToken()===2&&ae)break}else J&&re(6,[],[]);V()||re(4,[],[2,5]),J=!0}return A(),i.getToken()!==2?re(7,[2],[]):ne(),!0}function U(){E(),ne();let J=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(J||re(4,[],[]),F(","),ne(),i.getToken()===4&&ae)break}else J&&re(6,[],[]);H()||re(4,[],[4,5]),J=!0}return I(),i.getToken()!==4?re(8,[4],[]):ne(),!0}function H(){switch(i.getToken()){case 3:return U();case 1:return N();case 10:return X(!0);default:return K()}}return ne(),i.getToken()===17?r.allowEmptyContent?!0:(re(4,[],[]),!1):H()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$Ym=c;function k(t,l){const r=C(t),i=[];let n,o=0,v;do switch(v=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==v&&i.push(t.substring(o,v)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Zm=k;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=u}),define(ee[136],te([0,1,44]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=e.$RS=e.$QS=e.$PS=void 0;function D(a,g,b){let p,d,y,w,$;if(g){for(w=g.offset,$=w+g.length,y=w;y>0&&!f(a,y-1);)y--;let v=$;for(;v<a.length&&!f(a,v);)v++;d=a.substring(y,v),p=C(d,b)}else d=a,p=0,y=0,w=0,$=a.length;const m=S(b,a);let h=!1,c=0,k;b.insertSpaces?k=M(" ",b.tabSize||4):k="	";const u=(0,P.$Pm)(d,!1);let t=!1;function l(){return m+M(k,p+c)}function r(){let v=u.scan();for(h=!1;v===15||v===14;)h=h||v===14,v=u.scan();return t=v===16||u.getTokenError()!==0,v}const i=[];function n(v,R,A){!t&&R<$&&A>w&&a.substring(R,A)!==v&&i.push({offset:R,length:A-R,content:v})}let o=r();if(o!==17){const v=u.getTokenOffset()+y,R=M(k,p);n(R,y,v)}for(;o!==17;){let v=u.getTokenOffset()+u.getTokenLength()+y,R=r(),A="";for(;!h&&(R===12||R===13);){const I=u.getTokenOffset()+y;n(" ",v,I),v=u.getTokenOffset()+u.getTokenLength()+y,A=R===12?l():"",R=r()}if(R===2)o!==1&&(c--,A=l());else if(R===4)o!==3&&(c--,A=l());else{switch(o){case 3:case 1:c++,A=l();break;case 5:case 12:A=l();break;case 13:h?A=l():A=" ";break;case 6:A=" ";break;case 10:if(R===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?A=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}h&&(R===12||R===13)&&(A=l())}const E=u.getTokenOffset()+y;n(A,v,E),o=R}return i}e.$PS=D;function s(a,g){const b=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?b.replace(/\r\n|\r|\n/g,g.eol):b}e.$QS=s;function M(a,g){let b="";for(let p=0;p<g;p++)b+=a;return b}function C(a,g){let b=0,p=0;const d=g.tabSize||4;for(;b<a.length;){const y=a.charAt(b);if(y===" ")p++;else if(y==="	")p+=d;else break;b++}return Math.floor(p/d)}function S(a,g){for(let b=0;b<g.length;b++){const p=g.charAt(b);if(p==="\r")return b+1<g.length&&g.charAt(b+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return a&&a.eol||`
`}e.$RS=S;function f(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.$SS=f}),define(ee[137],te([0,1,44,136]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XS=e.$WS=e.$VS=e.$US=e.$TS=void 0;function s(a,g,b){return M(a,g,void 0,b)}e.$TS=s;function M(a,g,b,p,d){const y=g.slice(),w=[],$=(0,P.$Sm)(a,w);let m,h;for(;y.length>0&&(h=y.pop(),m=(0,P.$Tm)($,y),m===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(m)if(m.type==="object"&&typeof h=="string"&&Array.isArray(m.children)){const c=(0,P.$Tm)(m,[h]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const k=m.children.indexOf(c.parent);let u,t=c.parent.offset+c.parent.length;if(k>0){const l=m.children[k-1];u=l.offset+l.length}else u=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return C(a,{offset:u,length:t-u,content:""},p)}else return C(a,{offset:c.offset,length:c.length,content:JSON.stringify(b)},p);else{if(b===void 0)return[];const k=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,u=d?d(m.children.map(l=>l.children[0].value)):m.children.length;let t;if(u>0){const l=m.children[u-1];t={offset:l.offset+l.length,length:0,content:","+k}}else m.children.length===0?t={offset:m.offset+1,length:0,content:k}:t={offset:m.offset+1,length:0,content:k+","};return C(a,t,p)}}else if(m.type==="array"&&typeof h=="number"&&Array.isArray(m.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let k;if(m.children.length===0||h===0)k={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const u=h===-1||h>m.children.length?m.children.length:h,t=m.children[u-1];k={offset:t.offset+t.length,length:0,content:","+c}}return C(a,k,p)}else{const c=h,k=m.children[c];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const t=m.children[c-1],l=t.offset+t.length,r=m.offset+m.length;u={offset:l,length:r-2-l,content:""}}else u={offset:k.offset,length:m.children[c+1].offset-k.offset,content:""};return C(a,u,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${m.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(b)},p)}}e.$US=M;function C(a,g,b){let p=S(a,g),d=g.offset,y=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;d>0&&!(0,D.$SS)(p,d-1);)d--;for(;y<p.length&&!(0,D.$SS)(p,y);)y++}const w=(0,D.$PS)(p,{offset:d,length:y-d},b);for(let m=w.length-1;m>=0;m--){const h=w[m];p=S(p,h),d=Math.min(d,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const $=a.length-(p.length-y)-d;return[{offset:d,length:$,content:p.substring(d,y)}]}e.$VS=C;function S(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.$WS=S;function f(a,g){const b=g.slice(0).sort((d,y)=>{const w=d.offset-y.offset;return w===0?d.length-y.length:w});let p=a.length;for(let d=b.length-1;d>=0;d--){const y=b[d];if(y.offset+y.length<=p)a=S(a,y);else throw new Error("Overlapping edit");p=y.offset}return a}e.$XS=f}),define(ee[83],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=P}),define(ee[101],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class D{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const C=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=C}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(C){const a=this.b;this.b=S,S.prev=a,a.next=S}else{const a=this.a;this.a=S,S.next=a,a.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$1c=D}),define(ee[31],te([0,1]),function(Z,e){"use strict";var P,D,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(h,c,k){let u=h.get(c);return u===void 0&&(u=k,h.set(c,u)),u}e.$wc=M;function C(h){const c=[];return h.forEach((k,u)=>{c.push(`${u} => ${k}`)}),`Map(${h.size}) {${c.join(", ")}}`}e.$xc=C;function S(h){const c=[];return h.forEach(k=>{c.push(k)}),`Set(${h.size}) {${c.join(", ")}}`}e.$yc=S;class f{constructor(c,k){this.uri=c,this.value=k}}function a(h){return Array.isArray(h)}class g{static{this.a=c=>c.toString()}constructor(c,k){if(this[P]="ResourceMap",c instanceof g)this.b=new Map(c.b),this.c=k??g.a;else if(a(c)){this.b=new Map,this.c=k??g.a;for(const[u,t]of c)this.set(u,t)}else this.b=new Map,this.c=c??g.a}set(c,k){return this.b.set(this.c(c),new f(c,k)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,k){typeof k<"u"&&(c=c.bind(k));for(const[u,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$zc=g;class b{constructor(c,k){this[D]="ResourceSet",!c||typeof c=="function"?this.a=new g(c):(this.a=new g(k),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,k){this.a.forEach((u,t)=>c.call(k,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=b;var p;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,k=0){const u=this.a.get(c);if(u)return k!==0&&this.j(u,k),u.value}set(c,k,u=0){let t=this.a.get(c);if(t)t.value=k,u!==0&&this.j(t,u);else{switch(t={key:c,value:k,next:void 0,previous:void 0},u){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const k=this.a.get(c);if(k)return this.a.delete(c),this.i(k),this.d--,k.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,k){const u=this.e;let t=this.b;for(;t;){if(k?c.bind(k)(t.value,t.key,this):c(t.value,t.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}values(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}entries(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let k=this.b,u=this.size;for(;k&&u>c;)this.a.delete(k.key),k=k.next,u--;this.b=k,this.d=u,k&&(k.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const k=c.next,u=c.previous;if(!k||!u)throw new Error("Invalid list");k.previous=u,u.next=k}c.next=void 0,c.previous=void 0,this.e++}j(c,k){if(!this.b||!this.c)throw new Error("Invalid list");if(!(k!==1&&k!==2)){if(k===1){if(c===this.b)return;const u=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(k===2){if(c===this.c)return;const u=c.next,t=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((k,u)=>{c.push([u,k])}),c}fromJSON(c){this.clear();for(const[k,u]of c)this.set(k,u)}}e.$Bc=d;class y extends d{constructor(c,k=1){super(),this.k=c,this.l=Math.min(Math.max(0,k),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,k=2){return super.get(c,k)}peek(c){return super.get(c,0)}set(c,k){return super.set(c,k,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=y;class w{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let k=this.a.get(c)||0;return k===0?!1:(k--,k===0?this.a.delete(c):this.a.set(c,k),!0)}has(c){return this.a.has(c)}}e.$Dc=w;class ${constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[k,u]of c)this.set(k,u)}clear(){this.a.clear(),this.b.clear()}set(c,k){this.a.set(c,k),this.b.set(k,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const k=this.a.get(c);return k===void 0?!1:(this.a.delete(c),this.b.delete(k),!0)}forEach(c,k){this.a.forEach((u,t)=>{c.call(k,u,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=$;class m{constructor(){this.a=new Map}add(c,k){let u=this.a.get(c);u||(u=new Set,this.a.set(c,u)),u.add(k)}delete(c,k){const u=this.a.get(c);u&&(u.delete(k),u.size===0&&this.a.delete(c))}forEach(c,k){const u=this.a.get(c);u&&u.forEach(k)}get(c){const k=this.a.get(c);return k||new Set}}e.$Fc=m}),define(ee[2],te([0,1,23,133,31,82,69]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const S=!1;let f=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let L=this.b.get(I);return L||(L={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,L)),L}trackDisposable(I){const L=this.c(I);L.source||(L.source=new Error().stack)}setParent(I,L){const F=this.c(I);F.parent=L}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,L){const F=L.get(I);if(F)return F;const B=I.parent?this.f(this.c(I.parent),L):I;return L.set(I,B),B}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,I).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(I=10,L){let F;if(L)F=L;else{const ne=new Map,re=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,ne).isSingleton);if(re.length===0)return;const X=new Set(re.map(K=>K.value));if(F=re.filter(K=>!(K.parent&&X.has(K.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function B(ne){function re(K,V){for(;K.length>0&&V.some(N=>typeof N=="string"?N===K[0]:K[0].match(N));)K.shift()}const X=ne.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return re(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const se=new s.$Fc;for(const ne of F){const re=B(ne);for(let X=0;X<=re.length;X++)se.add(re.slice(0,X).join(`
`),ne)}F.sort((0,P.$6b)(ne=>ne.idx,P.$8b));let x="",ae=0;for(const ne of F.slice(0,I)){ae++;const re=B(ne),X=[];for(let K=0;K<re.length;K++){let V=re[K];V=`(shared with ${se.get(re.slice(0,K+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const U=se.get(re.slice(0,K).join(`
`)),H=(0,D.$J)([...U].map(J=>B(J)[K]),J=>J);delete H[re[K]];for(const[J,ie]of Object.entries(H))X.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${J}`);X.unshift(V)}x+=`


==================== Leaking disposable ${ae}/${F.length}: ${ne.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>I&&(x+=`


... and ${F.length-I} more leaking disposables

`),{leaks:F,details:x}}}e.$Gc=a;function g(E){f=E}if(e.$Hc=g,S){const E="__is_disposable_tracked__";g(new class{trackDisposable(I){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[E]||console.log(L)},3e3)}setParent(I,L){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsSingleton(I){}})}function b(E){return f?.trackDisposable(E),E}e.$Ic=b;function p(E){f?.markAsDisposed(E)}e.$Jc=p;function d(E,I){f?.setParent(E,I)}function y(E,I){if(f)for(const L of E)f.setParent(L,I)}function w(E){return f?.markAsSingleton(E),E}e.$Kc=w;function $(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Lc=$;function m(E){if(C.Iterable.is(E)){const I=[];for(const L of E)if(L)try{L.dispose()}catch(F){I.push(F)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Mc=m;function h(E){for(const I of E)$(I)&&I.dispose();return[]}e.$Nc=h;function c(...E){const I=k(()=>m(E));return y(E,I),I}e.$Oc=c;function k(E){const I=b({dispose:(0,M.$cb)(()=>{p(I),E()})});return I}e.$Pc=k;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Qc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,b(this),d(this.q,this)}dispose(){p(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=t;class l{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Sc=l;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let L=I;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,p(this))},this}}e.$Uc=i;class n{constructor(){this.a=new Map}acquire(I,...L){let F=this.a.get(I);F||(F={counter:0,object:this.b(I,...L)},this.a.set(I,F));const{object:B}=F,se=(0,M.$cb)(()=>{--F.counter===0&&(this.c(I,F.object),this.a.delete(I))});return F.counter++,{object:B,dispose:se}}}e.$Vc=n;class o{constructor(I){this.a=I}async acquire(I,...L){const F=this.a.acquire(I,...L);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(B){throw F.dispose(),B}}}e.$Wc=o;class v{constructor(I){this.object=I}dispose(){}}e.$Xc=v;function R(E){const I=new u;try{E(I)}finally{I.dispose()}}e.$Yc=R;class A{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,L,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(I)?.dispose(),this.a.set(I,L)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=A}),define(ee[84],te([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=void 0;const D=new P.$Cc(1e4);function s(a){return f(a,"NFC",D)}e.$kl=s;const M=new P.$Cc(1e4);function C(a){return f(a,"NFD",M)}e.$ll=C;const S=/[^\u0000-\u0080]/;function f(a,g,b){if(!a)return a;const p=b.get(a);if(p)return p;let d;return S.test(a)?d=a.normalize(g):d=a,b.set(a,d),d}e.$ml=function(){const a=/[\u0300-\u036f]/g;return function(g){return C(g).replace(a,"")}}()}),define(ee[138],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function P(S,f,a){return Math.min(Math.max(S,f),a)}e.$Kl=P;function D(S,f){return(f+S%f)%f}e.rot=D;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=M;class C{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const a=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=C}),function(){function Z(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function C(f){M.push(f,Date.now())}function S(){const f=[];for(let a=0;a<M.length;a+=2)f.push({name:M[a],startTime:M[a+1]});return f}return{mark:C,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(s+C.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=P(D))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var D in P)(typeof exports=="object"?exports:Z)[D]=P[D]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function P(D){if(e[D])return e[D].exports;var s=e[D]={i:D,l:!1,exports:{}};return Z[D].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=Z,P.c=e,P.d=function(D,s,M){P.o(D,s)||Object.defineProperty(D,s,{enumerable:!0,get:M})},P.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},P.t=function(D,s){if(1&s&&(D=P(D)),8&s||4&s&&typeof D=="object"&&D&&D.__esModule)return D;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:D}),2&s&&typeof D!="string")for(var C in D)P.d(M,C,function(S){return D[S]}.bind(null,C));return M},P.n=function(D){var s=D&&D.__esModule?function(){return D.default}:function(){return D};return P.d(s,"a",s),s},P.o=function(D,s){return Object.prototype.hasOwnProperty.call(D,s)},P.p="",P(P.s=0)}([function(Z,e,P){(function(D){var s;e=Z.exports=oe,s=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],a=0,g=a++;f[g]="0|[1-9]\\d*";var b=a++;f[b]="[0-9]+";var p=a++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;f[d]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var y=a++;f[y]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var w=a++;f[w]="(?:"+f[g]+"|"+f[p]+")";var $=a++;f[$]="(?:"+f[b]+"|"+f[p]+")";var m=a++;f[m]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var h=a++;f[h]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var c=a++;f[c]="[0-9A-Za-z-]+";var k=a++;f[k]="(?:\\+("+f[c]+"(?:\\."+f[c]+")*))";var u=a++,t="v?"+f[d]+f[m]+"?"+f[k]+"?";f[u]="^"+t+"$";var l="[v=\\s]*"+f[y]+f[h]+"?"+f[k]+"?",r=a++;f[r]="^"+l+"$";var i=a++;f[i]="((?:<|>)?=?)";var n=a++;f[n]=f[b]+"|x|X|\\*";var o=a++;f[o]=f[g]+"|x|X|\\*";var v=a++;f[v]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[m]+")?"+f[k]+"?)?)?";var R=a++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[k]+"?)?)?";var A=a++;f[A]="^"+f[i]+"\\s*"+f[v]+"$";var E=a++;f[E]="^"+f[i]+"\\s*"+f[R]+"$";var I=a++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=a++;f[L]="(?:~>?)";var F=a++;f[F]="(\\s*)"+f[L]+"\\s+",S[F]=new RegExp(f[F],"g");var B=a++;f[B]="^"+f[L]+f[v]+"$";var se=a++;f[se]="^"+f[L]+f[R]+"$";var x=a++;f[x]="(?:\\^)";var ae=a++;f[ae]="(\\s*)"+f[x]+"\\s+",S[ae]=new RegExp(f[ae],"g");var ne=a++;f[ne]="^"+f[x]+f[v]+"$";var re=a++;f[re]="^"+f[x]+f[R]+"$";var X=a++;f[X]="^"+f[i]+"\\s*("+l+")$|^$";var K=a++;f[K]="^"+f[i]+"\\s*("+t+")$|^$";var V=a++;f[V]="(\\s*)"+f[i]+"\\s*("+l+"|"+f[v]+")",S[V]=new RegExp(f[V],"g");var N=a++;f[N]="^\\s*("+f[v]+")\\s+-\\s+("+f[v]+")\\s*$";var U=a++;f[U]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var H=a++;f[H]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)s(J,f[J]),S[J]||(S[J]=new RegExp(f[J]));function ie(Q,le){if(Q instanceof oe)return Q;if(typeof Q!="string"||Q.length>M||!(le?S[r]:S[u]).test(Q))return null;try{return new oe(Q,le)}catch{return null}}function oe(Q,le){if(Q instanceof oe){if(Q.loose===le)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(Q,le);s("SemVer",Q,le),this.loose=le;var ge=Q.trim().match(le?S[r]:S[u]);if(!ge)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ae=+Ce;if(Ae>=0&&Ae<C)return Ae}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ie,e.valid=function(Q,le){var ge=ie(Q,le);return ge?ge.version:null},e.clean=function(Q,le){var ge=ie(Q.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Q){return s("SemVer.compare",this.version,this.loose,Q),Q instanceof oe||(Q=new oe(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},oe.prototype.compareMain=function(Q){return Q instanceof oe||(Q=new oe(Q,this.loose)),O(this.major,Q.major)||O(this.minor,Q.minor)||O(this.patch,Q.patch)},oe.prototype.comparePre=function(Q){if(Q instanceof oe||(Q=new oe(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Ce=Q.prerelease[le];if(s("prerelease compare",le,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return O(ge,Ce)}while(++le)},oe.prototype.inc=function(Q,le){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,le,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new oe(Q,ge).inc(le,Ce).version}catch{return null}},e.diff=function(Q,le){if(z(Q,le))return null;var ge=ie(Q),Ce=ie(le);if(ge.prerelease.length||Ce.prerelease.length){for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Ce[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Ce[Ae])return Ae},e.compareIdentifiers=O;var T=/^[0-9]+$/;function O(Q,le){var ge=T.test(Q),Ce=T.test(le);return ge&&Ce&&(Q=+Q,le=+le),ge&&!Ce?-1:Ce&&!ge?1:Q<le?-1:Q>le?1:0}function j(Q,le,ge){return new oe(Q,ge).compare(new oe(le,ge))}function q(Q,le,ge){return j(Q,le,ge)>0}function W(Q,le,ge){return j(Q,le,ge)<0}function z(Q,le,ge){return j(Q,le,ge)===0}function G(Q,le,ge){return j(Q,le,ge)!==0}function ce(Q,le,ge){return j(Q,le,ge)>=0}function de(Q,le,ge){return j(Q,le,ge)<=0}function ue(Q,le,ge,Ce){var Ae;switch(le){case"===":typeof Q=="object"&&(Q=Q.version),typeof ge=="object"&&(ge=ge.version),Ae=Q===ge;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof ge=="object"&&(ge=ge.version),Ae=Q!==ge;break;case"":case"=":case"==":Ae=z(Q,ge,Ce);break;case"!=":Ae=G(Q,ge,Ce);break;case">":Ae=q(Q,ge,Ce);break;case">=":Ae=ce(Q,ge,Ce);break;case"<":Ae=W(Q,ge,Ce);break;case"<=":Ae=de(Q,ge,Ce);break;default:throw new TypeError("Invalid operator: "+le)}return Ae}function fe(Q,le){if(Q instanceof fe){if(Q.loose===le)return Q;Q=Q.value}if(!(this instanceof fe))return new fe(Q,le);s("comparator",Q,le),this.loose=le,this.parse(Q),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Q,le){return O(le,Q)},e.major=function(Q,le){return new oe(Q,le).major},e.minor=function(Q,le){return new oe(Q,le).minor},e.patch=function(Q,le){return new oe(Q,le).patch},e.compare=j,e.compareLoose=function(Q,le){return j(Q,le,!0)},e.rcompare=function(Q,le,ge){return j(le,Q,ge)},e.sort=function(Q,le){return Q.sort(function(ge,Ce){return e.compare(ge,Ce,le)})},e.rsort=function(Q,le){return Q.sort(function(ge,Ce){return e.rcompare(ge,Ce,le)})},e.gt=q,e.lt=W,e.eq=z,e.neq=G,e.gte=ce,e.lte=de,e.cmp=ue,e.Comparator=fe;var ye={};function be(Q,le){if(Q instanceof be)return Q.loose===le?Q:new be(Q.raw,le);if(Q instanceof fe)return new be(Q.value,le);if(!(this instanceof be))return new be(Q,le);if(this.loose=le,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function pe(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Re(Q,le,ge,Ce,Ae,Fe,Oe,ze,We,Y,he,me,ve){return((le=pe(ge)?"":pe(Ce)?">="+ge+".0.0":pe(Ae)?">="+ge+"."+Ce+".0":">="+le)+" "+(ze=pe(We)?"":pe(Y)?"<"+(+We+1)+".0.0":pe(he)?"<"+We+"."+(+Y+1)+".0":me?"<="+We+"."+Y+"."+he+"-"+me:"<="+ze)).trim()}function Te(Q,le){for(var ge=0;ge<Q.length;ge++)if(!Q[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Q.length;ge++)if(s(Q[ge].semver),Q[ge].semver!==ye&&Q[ge].semver.prerelease.length>0){var Ce=Q[ge].semver;if(Ce.major===le.major&&Ce.minor===le.minor&&Ce.patch===le.patch)return!0}return!1}return!0}function $e(Q,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(Q)}function we(Q,le,ge,Ce){var Ae,Fe,Oe,ze,We;switch(Q=new oe(Q,Ce),le=new be(le,Ce),ge){case">":Ae=q,Fe=de,Oe=W,ze=">",We=">=";break;case"<":Ae=W,Fe=ce,Oe=q,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Q,le,Ce))return!1;for(var Y=0;Y<le.set.length;++Y){var he=le.set[Y],me=null,ve=null;if(he.forEach(function(De){De.semver===ye&&(De=new fe(">=0.0.0")),me=me||De,ve=ve||De,Ae(De.semver,me.semver,Ce)?me=De:Oe(De.semver,ve.semver,Ce)&&(ve=De)}),me.operator===ze||me.operator===We||(!ve.operator||ve.operator===ze)&&Fe(Q,ve.semver)||ve.operator===We&&Oe(Q,ve.semver))return!1}return!0}fe.prototype.parse=function(Q){var le=this.loose?S[X]:S[K],ge=Q.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Q);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=ye},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(Q){return s("Comparator.test",Q,this.loose),this.semver===ye||(typeof Q=="string"&&(Q=new oe(Q,this.loose)),ue(Q,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(Q,le){if(!(Q instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(Q.value,le),$e(this.value,ge,le);if(Q.operator==="")return ge=new be(this.value,le),$e(Q.semver,ge,le);var Ce=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Fe=this.semver.version===Q.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),ze=ue(this.semver,"<",Q.semver,le)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),We=ue(this.semver,">",Q.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Ce||Ae||Fe&&Oe||ze||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Q){var le=this.loose;Q=Q.trim(),s("range",Q,le);var ge=le?S[U]:S[N];Q=Q.replace(ge,Re),s("hyphen replace",Q),Q=Q.replace(S[V],"$1$2$3"),s("comparator trim",Q,S[V]),Q=(Q=(Q=Q.replace(S[F],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Ce=le?S[X]:S[K],Ae=Q.split(" ").map(function(Fe){return function(Oe,ze){return s("comp",Oe),Oe=function(We,Y){return We.trim().split(/\s+/).map(function(he){return function(me,ve){s("caret",me,ve);var De=ve?S[re]:S[ne];return me.replace(De,function(Ue,Le,Ne,Be,He){var Ge;return s("caret",me,Ue,Le,Ne,Be,He),pe(Le)?Ge="":pe(Ne)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Be)?Ge=Le==="0"?">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+".0 <"+(+Le+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+Be+He+" <"+Le+"."+Ne+"."+(+Be+1):">="+Le+"."+Ne+"."+Be+He+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+Be+He+" <"+(+Le+1)+".0.0"):(s("no pr"),Ge=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+Be+" <"+Le+"."+Ne+"."+(+Be+1):">="+Le+"."+Ne+"."+Be+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+Be+" <"+(+Le+1)+".0.0"),s("caret return",Ge),Ge})}(he,Y)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,Y){return We.trim().split(/\s+/).map(function(he){return function(me,ve){var De=ve?S[se]:S[B];return me.replace(De,function(Ue,Le,Ne,Be,He){var Ge;return s("tilde",me,Ue,Le,Ne,Be,He),pe(Le)?Ge="":pe(Ne)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Be)?Ge=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=">="+Le+"."+Ne+"."+Be+He+" <"+Le+"."+(+Ne+1)+".0"):Ge=">="+Le+"."+Ne+"."+Be+" <"+Le+"."+(+Ne+1)+".0",s("tilde return",Ge),Ge})}(he,Y)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,Y){return s("replaceXRanges",We,Y),We.split(/\s+/).map(function(he){return function(me,ve){me=me.trim();var De=ve?S[E]:S[A];return me.replace(De,function(Ue,Le,Ne,Be,He,Ge){s("xRange",me,Ue,Le,Ne,Be,He,Ge);var xe=pe(Ne),Ye=xe||pe(Be),it=Ye||pe(He);return Le==="="&&it&&(Le=""),xe?Ue=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Ye&&(Be=0),it&&(He=0),Le===">"?(Le=">=",Ye?(Ne=+Ne+1,Be=0,He=0):it&&(Be=+Be+1,He=0)):Le==="<="&&(Le="<",Ye?Ne=+Ne+1:Be=+Be+1),Ue=Le+Ne+"."+Be+"."+He):Ye?Ue=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":it&&(Ue=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0"),s("xRange return",Ue),Ue})}(he,Y)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,Y){return s("replaceStars",We,Y),We.trim().replace(S[H],"")}(Oe,ze),s("stars",Oe),Oe}(Fe,le)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Fe){return!!Fe.match(Ce)})),Ae=Ae.map(function(Fe){return new fe(Fe,le)})},be.prototype.intersects=function(Q,le){if(!(Q instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return Q.set.some(function(Ae){return Ae.every(function(Fe){return Ce.intersects(Fe,le)})})})})},e.toComparators=function(Q,le){return new be(Q,le).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new oe(Q,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],Q))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Q,le,ge){var Ce=null,Ae=null;try{var Fe=new be(le,ge)}catch{return null}return Q.forEach(function(Oe){Fe.test(Oe)&&(Ce&&Ae.compare(Oe)!==-1||(Ae=new oe(Ce=Oe,ge)))}),Ce},e.minSatisfying=function(Q,le,ge){var Ce=null,Ae=null;try{var Fe=new be(le,ge)}catch{return null}return Q.forEach(function(Oe){Fe.test(Oe)&&(Ce&&Ae.compare(Oe)!==1||(Ae=new oe(Ce=Oe,ge)))}),Ce},e.validRange=function(Q,le){try{return new be(Q,le).range||"*"}catch{return null}},e.ltr=function(Q,le,ge){return we(Q,le,"<",ge)},e.gtr=function(Q,le,ge){return we(Q,le,">",ge)},e.outside=we,e.prerelease=function(Q,le){var ge=ie(Q,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Q,le,ge){return Q=new be(Q,ge),le=new be(le,ge),Q.intersects(le)},e.coerce=function(Q){if(Q instanceof oe)return Q;if(typeof Q!="string")return null;var le=Q.match(S[I]);return le==null?null:ie((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(Z,e){var P,D,s=Z.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function S($){if(P===setTimeout)return setTimeout($,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout($,0);try{return P($,0)}catch{try{return P.call(null,$,0)}catch{return P.call(this,$,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var f,a=[],g=!1,b=-1;function p(){g&&f&&(g=!1,f.length?a=f.concat(a):b=-1,a.length&&d())}function d(){if(!g){var $=S(p);g=!0;for(var m=a.length;m;){for(f=a,a=[];++b<m;)f&&f[b].run();b=-1,m=a.length}f=null,g=!1,function(h){if(D===clearTimeout)return clearTimeout(h);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(h);try{D(h)}catch{try{return D.call(null,h)}catch{return D.call(this,h)}}}($)}}function y($,m){this.fun=$,this.array=m}function w(){}s.nextTick=function($){var m=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)m[h-1]=arguments[h];a.push(new y($,m)),a.length!==1||g||S(d)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ee[139],te([0,1]),function(Z,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class D{constructor(S,f,a){this.level=S,this.key=f,this.value=a,this.forward=[]}}const s=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new D(this.c,s,s)}get size(){return this.f}clear(){this.e=new D(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let a=this.e.forward[0];for(;a;)S.call(f,a.value,a.key,this),a=a.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,a){let g=S.e;for(let b=S.d-1;b>=0;b--)for(;g.forward[b]&&a(g.forward[b].key,f)<0;)g=g.forward[b];if(g=g.forward[0],g&&a(g.key,f)===0)return g}static h(S,f,a,g){const b=[];let p=S.e;for(let d=S.d-1;d>=0;d--){for(;p.forward[d]&&g(p.forward[d].key,f)<0;)p=p.forward[d];b[d]=p}if(p=p.forward[0],p&&g(p.key,f)===0)return p.value=a,!1;{const d=M.j(S);if(d>S.d){for(let y=S.d;y<d;y++)b[y]=S.e;S.d=d}p=new D(d,f,a);for(let y=0;y<d;y++)p.forward[y]=b[y].forward[y],b[y].forward[y]=p;return!0}}static j(S,f=.5){let a=1;for(;Math.random()<f&&a<S.c;)a+=1;return a}static k(S,f,a){const g=[];let b=S.e;for(let p=S.d-1;p>=0;p--){for(;b.forward[p]&&a(b.forward[p].key,f)<0;)b=b.forward[p];g[p]=b}if(b=b.forward[0],!b||a(b.key,f)!==0)return!1;for(let p=0;p<S.d&&g[p].forward[p]===b;p++)g[p].forward[p]=b.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$ur=M}),define(ee[70],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(M){return new D(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=D}),define(ee[3],te([0,1,14,82,2,101,70]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const S=!1,f=!1;var a;(function(A){A.None=()=>s.$Rc.None;function E(ue){if(f){const{onDidAddListener:fe}=ue,ye=y.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),fe?.()}}}function I(ue,fe){return K(ue,()=>{},0,void 0,!0,void 0,fe)}A.defer=I;function L(ue){return(fe,ye=null,be)=>{let pe=!1,Re;return Re=ue(Te=>{if(!pe)return Re?Re.dispose():pe=!0,fe.call(ye,Te)},null,be),pe&&Re.dispose(),Re}}A.once=L;function F(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>be.call(pe,fe(Te)),null,Re),ye)}A.map=F;function B(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>{fe(Te),be.call(pe,Te)},null,Re),ye)}A.forEach=B;function se(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>fe(Te)&&be.call(pe,Te),null,Re),ye)}A.filter=se;function x(ue){return ue}A.signal=x;function ae(...ue){return(fe,ye=null,be)=>{const pe=(0,s.$Oc)(...ue.map(Re=>Re(Te=>fe.call(ye,Te))));return X(pe,be)}}A.any=ae;function ne(ue,fe,ye,be){let pe=ye;return F(ue,Re=>(pe=fe(pe,Re),pe),be)}A.reduce=ne;function re(ue,fe){let ye;const be={onWillAddFirstListener(){ye=ue(pe.fire,pe)},onDidRemoveLastListener(){ye?.dispose()}};fe||E(be);const pe=new c(be);return fe?.add(pe),pe.event}function X(ue,fe){return fe instanceof Array?fe.push(ue):fe&&fe.add(ue),ue}function K(ue,fe,ye=100,be=!1,pe=!1,Re,Te){let $e,we,Q,le=0,ge;const Ce={leakWarningThreshold:Re,onWillAddFirstListener(){$e=ue(Fe=>{le++,we=fe(we,Fe),be&&!Q&&(Ae.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,Q=void 0,(!be||le>1)&&Ae.fire(Oe),le=0},typeof ye=="number"?(clearTimeout(Q),Q=setTimeout(ge,ye)):Q===void 0&&(Q=0,queueMicrotask(ge))})},onWillRemoveListener(){pe&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,$e.dispose()}};Te||E(Ce);const Ae=new c(Ce);return Te?.add(Ae),Ae.event}A.debounce=K;function V(ue,fe=0,ye){return A.debounce(ue,(be,pe)=>be?(be.push(pe),be):[pe],fe,void 0,!0,void 0,ye)}A.accumulate=V;function N(ue,fe=(be,pe)=>be===pe,ye){let be=!0,pe;return se(ue,Re=>{const Te=be||!fe(Re,pe);return be=!1,pe=Re,Te},ye)}A.latch=N;function U(ue,fe,ye){return[A.filter(ue,fe,ye),A.filter(ue,be=>!fe(be),ye)]}A.split=U;function H(ue,fe=!1,ye=[],be){let pe=ye.slice(),Re=ue(we=>{pe?pe.push(we):$e.fire(we)});be&&be.add(Re);const Te=()=>{pe?.forEach(we=>$e.fire(we)),pe=null},$e=new c({onWillAddFirstListener(){Re||(Re=ue(we=>$e.fire(we)),be&&be.add(Re))},onDidAddFirstListener(){pe&&(fe?setTimeout(Te):Te())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return be&&be.add($e),$e.event}A.buffer=H;function J(ue,fe){return(be,pe,Re)=>{const Te=fe(new oe);return ue(function($e){const we=Te.evaluate($e);we!==ie&&be.call(pe,we)},void 0,Re)}}A.chain=J;const ie=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ye=>(fe(ye),ye)),this}filter(fe){return this.f.push(ye=>fe(ye)?ye:ie),this}reduce(fe,ye){let be=ye;return this.f.push(pe=>(be=fe(be,pe),be)),this}latch(fe=(ye,be)=>ye===be){let ye=!0,be;return this.f.push(pe=>{const Re=ye||!fe(pe,be);return ye=!1,be=pe,Re?pe:ie}),this}evaluate(fe){for(const ye of this.f)if(fe=ye(fe),fe===ie)break;return fe}}function T(ue,fe,ye=be=>be){const be=(...$e)=>Te.fire(ye(...$e)),pe=()=>ue.on(fe,be),Re=()=>ue.removeListener(fe,be),Te=new c({onWillAddFirstListener:pe,onDidRemoveLastListener:Re});return Te.event}A.fromNodeEventEmitter=T;function O(ue,fe,ye=be=>be){const be=(...$e)=>Te.fire(ye(...$e)),pe=()=>ue.addEventListener(fe,be),Re=()=>ue.removeEventListener(fe,be),Te=new c({onWillAddFirstListener:pe,onDidRemoveLastListener:Re});return Te.event}A.fromDOMEventEmitter=O;function j(ue){return new Promise(fe=>L(ue)(fe))}A.toPromise=j;function q(ue){const fe=new c;return ue.then(ye=>{fe.fire(ye)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}A.fromPromise=q;function W(ue,fe){return fe(void 0),ue(ye=>fe(ye))}A.runAndSubscribe=W;function z(ue,fe){let ye=null;function be(Re){ye?.dispose(),ye=new s.$Qc,fe(Re,ye)}be(void 0);const pe=ue(Re=>be(Re));return(0,s.$Pc)(()=>{pe.dispose(),ye?.dispose()})}A.runAndSubscribeWithStore=z;class G{constructor(fe,ye){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ye||E(be),this.emitter=new c(be),ye&&ye.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ye){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(ue,fe){return new G(ue,fe).emitter.event}A.fromObservable=ce;function de(ue){return fe=>{let ye=0,be=!1;const pe={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ue.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(pe),ue.reportChanges(),{dispose(){ue.removeObserver(pe)}}}}A.fromObservableLight=de})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${g.f++}`,g.all.add(this)}start(E){this.g=new C.$Id,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Kd=g;let b=-1;function p(A){const E=b;return b=A,{dispose(){b=E}}}e.$Ld=p;class d{constructor(E,I=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=I,this.g=0}dispose(){this.f?.clear()}check(E,I){const L=this.threshold;if(L<=0||I<L)return;this.f||(this.f=new Map);const F=this.f.get(E.value)||0;if(this.f.set(E.value,F+1),this.g-=1,this.g<=0){this.g=L*.5;let B,se=0;for(const[x,ae]of this.f)(!B||se<ae)&&(B=x,se=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${se}):`),console.warn(B)}return()=>{const B=this.f.get(E.value)||0;this.f.set(E.value,B-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class ${constructor(E){this.value=E,this.id=w++}}const m=2,h=(A,E)=>{if(A instanceof $)E(A);else for(let I=0;I<A.length;I++){const L=A[I];L&&E(L)}};class c{constructor(E){this.w=0,this.f=E,this.g=b>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{h(E,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,I,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;I&&(E=E.bind(I));const F=new $(E);let B,se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=y.create(),B=this.g.check(F.stack,this.w+1)),S&&(F.stack=se??y.create()),this.t?this.t instanceof $?(this.u??=new u,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const x=(0,s.$Pc)(()=>{B?.(),this.x(F)});return L instanceof s.$Qc?L.add(x):Array.isArray(L)&&L.push(x),x},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,L=I.indexOf(E);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[L]=void 0;const F=this.u.current===this;if(this.w*m<=I.length){let B=0;for(let se=0;se<I.length;se++)I[se]?I[B++]=I[se]:F&&(this.u.end--,B<this.u.i&&this.u.i--);I.length=B}}y(E,I){if(!E)return;const L=this.f?.onListenerError||P.$Z;if(!L){E.value(I);return}try{E.value(I)}catch(F){L(F)}}z(E){const I=E.current.t;for(;E.i<E.end;)this.y(I[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,E);else{const I=this.u;I.enqueue(this,E,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=c;const k=()=>new u;e.$Nd=k;class u{constructor(){this.i=-1,this.end=0}enqueue(E,I,L){this.i=0,this.end=L,this.current=E,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(E,I,L){if(this.t)for(this.h||(this.h=new M.$1c),h(this.t,F=>this.h.push([F.value,E]));this.h.size>0&&!I.isCancellationRequested;){const[F,B]=this.h.shift(),se=[],x={...B,token:I,waitUntil:ae=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,F)),se.push(ae)}};try{F(x)}catch(ae){(0,P.$Z)(ae);continue}Object.freeze(se),await Promise.allSettled(se).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,P.$Z)(ne.reason)})}}}e.$Od=t;class l extends c{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$1c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Pd=l;class r extends l{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Qd=r;class i extends c{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Rd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const I={event:E,listener:null};this.h.push(I),this.g&&this.m(I);const L=()=>{this.g&&this.o(I);const F=this.h.indexOf(I);this.h.splice(F,1)};return(0,s.$Pc)((0,D.$cb)(L))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(I=>this.f.fire(I))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Sd=n;class o{constructor(E,I,L,F){this.f=new s.$Qc;const B=this.f.add(new n),se=this.f.add(new s.$Zc);function x(ae){se.set(ae,B.add(F(ae)))}for(const ae of E)x(ae);this.f.add(I(ae=>{x(ae)})),this.f.add(L(ae=>{se.deleteAndDispose(ae)})),this.event=B.event}dispose(){this.f.dispose()}}e.$Td=o;class v{constructor(){this.f=[]}wrapEvent(E){return(I,L,F)=>E(B=>{const se=this.f[this.f.length-1];se?se.push(()=>I.call(L,B)):I.call(L,B)},void 0,F)}bufferEvents(E){const I=[];this.f.push(I);const L=E();return this.f.pop(),I.forEach(F=>F()),L}}e.$Ud=v;class R{constructor(){this.f=!1,this.g=a.None,this.h=s.$Rc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=R}),define(ee[22],te([0,1,3]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const D=Object.freeze(function(S,f){const a=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(a)}}});var s;(function(S){function f(a){return a===S.None||a===S.Cancelled||a instanceof M?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new P.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$Wd=C}),define(ee[140],te([0,1,22]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class D{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$Wd,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$ve=D;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$we=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$xe=M}),define(ee[62],te([0,1,14,2]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function s(k){const u=k;return u?typeof u.read=="function":!1}e.$Xd=s;function M(k){const u=k;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$Yd=M;function C(k){const u=k;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$Zd=C;function S(k,u){return new f(k,u)}e.$1d=S;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$Z)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let l;switch(u){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,u){const t=[];let l;for(;(l=k.read())!==null;)t.push(l);return u(t)}e.$2d=a;function g(k,u,t){const l=[];let r;for(;(r=k.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return k.read()}}}e.$3d=g;function b(k,u){return new Promise((t,l)=>{const r=[];p(k,{onData:i=>{u&&r.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$4d=b;function p(k,u,t){k.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),k.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),k.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.$5d=p;function d(k,u){return new Promise((t,l)=>{const r=new D.$Qc,i=[],n=R=>{if(i.push(R),i.length>u)return r.dispose(),k.pause(),t({stream:k,buffer:i,ended:!1})},o=R=>(r.dispose(),l(R)),v=()=>(r.dispose(),t({stream:k,buffer:i,ended:!0}));r.add((0,D.$Pc)(()=>k.removeListener("error",o))),k.on("error",o),r.add((0,D.$Pc)(()=>k.removeListener("end",v))),k.on("end",v),r.add((0,D.$Pc)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$6d=d;function y(k,u){const t=S(u);return t.end(k),t}e.$7d=y;function w(){const k=S(()=>{throw new Error("not supported")});return k.end(),k}e.$8d=w;function $(k){let u=!1;return{read:()=>u?null:(u=!0,k)}}e.$9d=$;function m(k,u,t){const l=S(t);return p(k,{onData:r=>l.write(u.data(r)),onError:r=>l.error(u.error?u.error(r):r),onEnd:()=>l.end()}),l}e.$0d=m;function h(k,u,t){let l=!1;return{read:()=>{const r=u.read();return l?r:(l=!0,r!==null?t([k,r]):k)}}}e.$$d=h;function c(k,u,t){let l=!1;const r=S(t);return p(u,{onData:i=>l?r.write(i):(l=!0,r.write(t([k,i]))),onError:i=>r.error(i),onEnd:()=>{l||(l=!0,r.write(k)),r.end()}}),r}e.$_d=c}),define(ee[18],te([0,1,83,62]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const s=typeof Buffer<"u",M=new P.$U(()=>new Uint8Array(256));let C,S;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,L){return!(L?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(C||(C=new TextEncoder),new f(C.encode(I)))}static fromByteArray(I){const L=f.alloc(I.length);for(let F=0,B=I.length;F<B;F++)L.buffer[F]=I[F];return L}static concat(I,L){if(typeof L>"u"){L=0;for(let se=0,x=I.length;se<x;se++)L+=I[se].byteLength}const F=f.alloc(L);let B=0;for(let se=0,x=I.length;se<x;se++){const ae=I[se];F.set(ae,B),B+=ae.byteLength}return F}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,L){return new f(this.buffer.subarray(I,L))}set(I,L){if(I instanceof f)this.buffer.set(I.buffer,L);else if(I instanceof Uint8Array)this.buffer.set(I,L);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),L);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return p(this.buffer,I)}writeUInt32BE(I,L){d(this.buffer,I,L)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,L){w(this.buffer,I,L)}readUInt8(I){return $(this.buffer,I)}writeUInt8(I,L){m(this.buffer,I,L)}indexOf(I,L=0){return a(this.buffer,I instanceof f?I.buffer:I,L)}}e.$ae=f;function a(E,I,L=0){const F=I.byteLength,B=E.byteLength;if(F===0)return 0;if(F===1)return E.indexOf(I[0]);if(F>B-L)return-1;const se=M.value;se.fill(I.length);for(let re=0;re<I.length;re++)se[I[re]]=I.length-re-1;let x=L+I.length-1,ae=x,ne=-1;for(;x<B;)if(E[x]===I[ae]){if(ae===0){ne=x;break}x--,ae--}else x+=Math.max(I.length-ae,se[E[x]]),ae=I.length-1;return ne}e.$be=a;function g(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0}e.$ce=g;function b(E,I,L){E[L+0]=I&255,I=I>>>8,E[L+1]=I&255}e.$de=b;function p(E,I){return E[I]*2**24+E[I+1]*2**16+E[I+2]*2**8+E[I+3]}e.$ee=p;function d(E,I,L){E[L+3]=I,I=I>>>8,E[L+2]=I,I=I>>>8,E[L+1]=I,I=I>>>8,E[L]=I}e.$fe=d;function y(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0|E[I+2]<<16>>>0|E[I+3]<<24>>>0}e.$ge=y;function w(E,I,L){E[L+0]=I&255,I=I>>>8,E[L+1]=I&255,I=I>>>8,E[L+2]=I&255,I=I>>>8,E[L+3]=I&255}e.$he=w;function $(E,I){return E[I]}e.$ie=$;function m(E,I,L){E[L]=I}e.$je=m;function h(E){return D.$2d(E,I=>f.concat(I))}e.$ke=h;function c(E){return D.$9d(E)}e.$le=c;function k(E){return D.$4d(E,I=>f.concat(I))}e.$me=k;async function u(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await k(E.stream)])}e.$ne=u;function t(E){return D.$7d(E,I=>f.concat(I))}e.$oe=t;function l(E){return D.$0d(E,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$pe=l;function r(E){return D.$1d(I=>f.concat(I),E)}e.$qe=r;function i(E,I){return D.$$d(E,I,L=>f.concat(L))}e.$re=i;function n(E,I){return D.$_d(E,I,L=>f.concat(L))}e.$se=n;function o(E){let I=0,L=0,F=0;const B=new Uint8Array(Math.floor(E.length/4*3)),se=ae=>{switch(L){case 3:B[F++]=I|ae,L=0;break;case 2:B[F++]=I|ae>>>2,I=ae<<6,L=3;break;case 1:B[F++]=I|ae>>>4,I=ae<<4,L=2;break;default:I=ae<<2,L=1}};for(let ae=0;ae<E.length;ae++){const ne=E.charCodeAt(ae);if(ne>=65&&ne<=90)se(ne-65);else if(ne>=97&&ne<=122)se(ne-97+26);else if(ne>=48&&ne<=57)se(ne-48+52);else if(ne===43||ne===45)se(62);else if(ne===47||ne===95)se(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const x=F;for(;L>0;)se(0);return f.wrap(B).slice(0,x)}e.$te=o;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:E},I=!0,L=!1){const F=L?R:v;let B="";const se=E.byteLength%3;let x=0;for(;x<E.byteLength-se;x+=3){const ae=E[x+0],ne=E[x+1],re=E[x+2];B+=F[ae>>>2],B+=F[(ae<<4|ne>>>4)&63],B+=F[(ne<<2|re>>>6)&63],B+=F[re&63]}if(se===1){const ae=E[x+0];B+=F[ae>>>2],B+=F[ae<<4&63],I&&(B+="==")}else if(se===2){const ae=E[x+0],ne=E[x+1];B+=F[ae>>>2],B+=F[(ae<<4|ne>>>4)&63],B+=F[ne<<2&63],I&&(B+="=")}return B}e.$ue=A}),define(ee[27],te([0,1,140,83]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function s(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.$Ae=s;const M=/{(\d+)}/g;function C(Y,...he){return he.length===0?Y:Y.replace(M,function(me,ve){const De=parseInt(ve,10);return isNaN(De)||De<0||De>=he.length?me:he[De]})}e.$Be=C;const S=/{([^}]+)}/g;function f(Y,he){return Y.replace(S,(me,ve)=>he[ve]??me)}e.$Ce=f;function a(Y){return Y.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$De=a;function g(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=g;function b(Y,he){let me=0;const ve=he.charCodeAt(0);for(let De=Y.length-1;De>=0;De--)Y.charCodeAt(De)===ve&&me++;return me}e.$Fe=b;function p(Y,he,me="\u2026"){return Y.length<=he?Y:`${Y.substr(0,he)}${me}`}e.$Ge=p;function d(Y,he=" "){const me=y(Y,he);return w(me,he)}e.$He=d;function y(Y,he){if(!Y||!he)return Y;const me=he.length;if(me===0||Y.length===0)return Y;let ve=0;for(;Y.indexOf(he,ve)===ve;)ve=ve+me;return Y.substring(ve)}e.$Ie=y;function w(Y,he){if(!Y||!he)return Y;const me=he.length,ve=Y.length;if(me===0||ve===0)return Y;let De=ve,Ue=-1;for(;Ue=Y.lastIndexOf(he,De-1),!(Ue===-1||Ue+me!==De);){if(Ue===0)return"";De=Ue}return Y.substring(0,De)}e.$Je=w;function $(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=$;function m(Y){return Y.replace(/\*/g,"")}e.$Le=m;function h(Y,he,me={}){if(!Y)throw new Error("Cannot create regex from empty string");he||(Y=g(Y)),me.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(Y,ve)}e.$Me=h;function c(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.$Ne=c;function k(Y){return Y.split(/\r\n|\r|\n/)}e.$Oe=k;function u(Y){for(let he=0,me=Y.length;he<me;he++){const ve=Y.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.$Pe=u;function t(Y,he=0,me=Y.length){for(let ve=he;ve<me;ve++){const De=Y.charCodeAt(ve);if(De!==32&&De!==9)return Y.substring(he,ve)}return Y.substring(he,me)}e.$Qe=t;function l(Y,he=Y.length-1){for(let me=he;me>=0;me--){const ve=Y.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}e.$Re=l;function r(Y,he,me){const ve=[];let De=0;for(const Ue of Y.matchAll(he)){if(ve.push(Y.slice(De,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");De=Ue.index+Ue[0].length,ve.push(me(Ue[0],...Ue.slice(1),Ue.index,Y,Ue.groups))}return ve.push(Y.slice(De)),Promise.all(ve).then(Ue=>Ue.join(""))}e.$Se=r;function i(Y,he){return Y<he?-1:Y>he?1:0}e.$Te=i;function n(Y,he,me=0,ve=Y.length,De=0,Ue=he.length){for(;me<ve&&De<Ue;me++,De++){const Be=Y.charCodeAt(me),He=he.charCodeAt(De);if(Be<He)return-1;if(Be>He)return 1}const Le=ve-me,Ne=Ue-De;return Le<Ne?-1:Le>Ne?1:0}e.$Ue=n;function o(Y,he){return v(Y,he,0,Y.length,0,he.length)}e.$Ve=o;function v(Y,he,me=0,ve=Y.length,De=0,Ue=he.length){for(;me<ve&&De<Ue;me++,De++){let Be=Y.charCodeAt(me),He=he.charCodeAt(De);if(Be===He)continue;if(Be>=128||He>=128)return n(Y.toLowerCase(),he.toLowerCase(),me,ve,De,Ue);A(Be)&&(Be-=32),A(He)&&(He-=32);const Ge=Be-He;if(Ge!==0)return Ge}const Le=ve-me,Ne=Ue-De;return Le<Ne?-1:Le>Ne?1:0}e.$We=v;function R(Y){return Y>=48&&Y<=57}e.$Xe=R;function A(Y){return Y>=97&&Y<=122}e.$Ye=A;function E(Y){return Y>=65&&Y<=90}e.$Ze=E;function I(Y,he){return Y.length===he.length&&v(Y,he)===0}e.$1e=I;function L(Y,he){const me=he.length;return he.length>Y.length?!1:v(Y,he,0,me)===0}e.$2e=L;function F(Y,he){const me=Math.min(Y.length,he.length);let ve;for(ve=0;ve<me;ve++)if(Y.charCodeAt(ve)!==he.charCodeAt(ve))return ve;return me}e.$3e=F;function B(Y,he){const me=Math.min(Y.length,he.length);let ve;const De=Y.length-1,Ue=he.length-1;for(ve=0;ve<me;ve++)if(Y.charCodeAt(De-ve)!==he.charCodeAt(Ue-ve))return ve;return me}e.$4e=B;function se(Y){return 55296<=Y&&Y<=56319}e.$5e=se;function x(Y){return 56320<=Y&&Y<=57343}e.$6e=x;function ae(Y,he){return(Y-55296<<10)+(he-56320)+65536}e.$7e=ae;function ne(Y,he,me){const ve=Y.charCodeAt(me);if(se(ve)&&me+1<he){const De=Y.charCodeAt(me+1);if(x(De))return ae(ve,De)}return ve}e.$8e=ne;function re(Y,he){const me=Y.charCodeAt(he-1);if(x(me)&&he>1){const ve=Y.charCodeAt(he-2);if(se(ve))return ae(ve,me)}return me}class X{get offset(){return this.e}constructor(he,me=0){this.c=he,this.d=he.length,this.e=me}setOffset(he){this.e=he}prevCodePoint(){const he=re(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=ne(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$9e=X;class K{get offset(){return this.c.offset}constructor(he,me=0){this.c=new X(he,me)}nextGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let De=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ue=me.offset,Le=he.getGraphemeBreakType(me.nextCodePoint());if(we(De,Le)){me.setOffset(Ue);break}De=Le}return me.offset-ve}prevGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let De=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ue=me.offset,Le=he.getGraphemeBreakType(me.prevCodePoint());if(we(Le,De)){me.setOffset(Ue);break}De=Le}return ve-me.offset}eol(){return this.c.eol()}}e.$0e=K;function V(Y,he){return new K(Y,he).nextGraphemeLength()}e.$$e=V;function N(Y,he){return new K(Y,he).prevGraphemeLength()}e.$_e=N;function U(Y,he){he>0&&x(Y.charCodeAt(he))&&he--;const me=he+V(Y,he);return[me-N(Y,me),me]}e.$af=U;function H(Y){const he=new K(Y);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.$bf=H;let J;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Y){return J||(J=ie()),J.test(Y)}e.$cf=oe;const T=/^[\t\n\r\x20-\x7E]*$/;function O(Y){return T.test(Y)}e.$df=O,e.$ef=/[\u2028\u2029]/;function j(Y){return e.$ef.test(Y)}e.$ff=j;function q(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.$gf=q;function W(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.$hf=W;function z(Y,he){if(Y.length<he)return Y;const me=/\b/g;let ve=0;for(;me.test(Y)&&!(Y.length-me.lastIndex<he);)ve=me.lastIndex,me.lastIndex+=1;return Y.substring(ve).replace(/^\s/,"")}e.$if=z;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(Y){return Y&&(Y=Y.replace(G,"").replace(ce,"")),Y}e.$jf=de,e.$kf=String.fromCharCode(65279);function ue(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.$lf=ue;function fe(Y){return ue(Y)?Y.substr(1):Y}e.$mf=fe;function ye(Y,he){if(!Y||!he||Y.length<he.length)return!1;const me=he.length,ve=Y.toLowerCase();let De=0,Ue=-1;for(;De<me;){const Le=ve.indexOf(he[De],Ue+1);if(Le<0)return!1;Ue=Le,De++}return!0}e.$nf=ye;function be(Y,he=!1){return Y?(he&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.$of=be;function pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.$pf=pe;function Re(Y,he=1){if(he===0)return"";let me=-1;do me=Y.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?Y:(Y[me-1]==="\r"&&me--,Y.substr(0,me))}e.$qf=Re;function Te(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.$rf=Te;function $e(Y){return le.getInstance().getGraphemeBreakType(Y)}e.$sf=$e;function we(Y,he){return Y===0?he!==5&&he!==7:Y===2&&he===3?!1:Y===4||Y===2||Y===3||he===4||he===2||he===3?!0:!(Y===8&&(he===8||he===9||he===11||he===12)||(Y===11||Y===9)&&(he===9||he===10)||(Y===12||Y===10)&&he===10||he===5||he===13||he===7||Y===1||Y===13&&he===14||Y===6&&he===6)}var Q;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Q||(e.GraphemeBreakType=Q={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this.d,ve=me.length/3;let De=1;for(;De<=ve;)if(he<me[3*De])De=2*De;else if(he>me[3*De+1])De=2*De+1;else return me[3*De+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(Y,he){if(Y===0)return 0;const me=Ae(Y,he);if(me!==void 0)return me;const ve=new X(he,Y);return ve.prevCodePoint(),ve.offset}e.$tf=Ce;function Ae(Y,he){const me=new X(he,Y);let ve=me.prevCodePoint();for(;Fe(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!W(ve))return;let De=me.offset;return De>0&&me.prevCodePoint()===8205&&(De=me.offset),De}function Fe(Y){return 127995<=Y&&Y<=127999}var Oe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$uf="\xA0";class ze{static{this.c=new D.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$we(he=>{function me(Ge){const xe=new Map;for(let Ye=0;Ye<Ge.length;Ye+=2)xe.set(Ge[Ye],Ge[Ye+1]);return xe}function ve(Ge,xe){const Ye=new Map(Ge);for(const[it,nt]of xe)Ye.set(it,nt);return Ye}function De(Ge,xe){if(!Ge)return xe;const Ye=new Map;for(const[it,nt]of Ge)xe.has(it)&&Ye.set(it,nt);return Ye}const Ue=this.c.value;let Le=he.filter(Ge=>!Ge.startsWith("_")&&Ge in Ue);Le.length===0&&(Le=["_default"]);let Ne;for(const Ge of Le){const xe=me(Ue[Ge]);Ne=De(Ne,xe)}const Be=me(Ue._common),He=ve(Be,Ne);return new ze(He)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new D.$U(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$wf=We}),define(ee[55],te([0,1,27]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function D(m){return s(m,0)}e.$Bi=D;function s(m,h){switch(typeof m){case"object":return m===null?M(349,h):Array.isArray(m)?f(m,h):a(m,h);case"string":return S(m,h);case"boolean":return C(m,h);case"number":return M(m,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Ci=s;function M(m,h){return(h<<5)-h+m|0}e.$Di=M;function C(m,h){return M(m?433:863,h)}function S(m,h){h=M(149417,h);for(let c=0,k=m.length;c<k;c++)h=M(m.charCodeAt(c),h);return h}e.$Ei=S;function f(m,h){return h=M(104579,h),m.reduce((c,k)=>s(k,c),h)}function a(m,h){return h=M(181387,h),Object.keys(m).sort().reduce((c,k)=>(c=S(k,c),s(m[k],c)),h)}class g{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Fi=g;var b;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function p(m,h,c=32){const k=c-h,u=~((1<<k)-1);return(m<<h|(u&m)>>>k)>>>0}function d(m,h=0,c=m.byteLength,k=0){for(let u=0;u<c;u++)m[h+u]=k}function y(m,h,c="0"){for(;m.length<h;)m=c+m;return m}function w(m,h=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):y((m>>>0).toString(16),h/4)}e.$Gi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const c=h.length;if(c===0)return;const k=this.p;let u=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=h.charCodeAt(0),r=0);;){let i=l;if(P.$5e(l))if(r+1<c){const n=h.charCodeAt(r+1);P.$6e(n)?(r++,i=P.$7e(l,n)):i=65533}else{t=l;break}else P.$6e(l)&&(i=65533);if(u=this.w(k,u,i),r++,r<c)l=h.charCodeAt(r);else break}this.r=u,this.u=t}w(h,c,k){return k<128?h[c++]=k:k<2048?(h[c++]=192|(k&1984)>>>6,h[c++]=128|(k&63)>>>0):k<65536?(h[c++]=224|(k&61440)>>>12,h[c++]=128|(k&4032)>>>6,h[c++]=128|(k&63)>>>0):(h[c++]=240|(k&1835008)>>>18,h[c++]=128|(k&258048)>>>12,h[c++]=128|(k&4032)>>>6,h[c++]=128|(k&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,c=this.q;for(let v=0;v<64;v+=4)h.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)h.setUint32(v,p(h.getUint32(v-12,!1)^h.getUint32(v-32,!1)^h.getUint32(v-56,!1)^h.getUint32(v-64,!1),1),!1);let k=this.h,u=this.l,t=this.m,l=this.n,r=this.o,i,n,o;for(let v=0;v<80;v++)v<20?(i=u&t|~u&l,n=1518500249):v<40?(i=u^t^l,n=1859775393):v<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),o=p(k,5)+i+r+n+h.getUint32(v*4,!1)&4294967295,r=l,l=t,t=p(u,30),u=k,k=o;this.h=this.h+k&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$Hi=$}),define(ee[71],te([0,1,27]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(D||(D={})),function(s){const M="error",C="warning",S="warn",f="info",a="ignore";function g(p){return p?P.$1e(M,p)?s.Error:P.$1e(C,p)||P.$1e(S,p)?s.Warning:P.$1e(f,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function b(p){switch(p){case s.Error:return M;case s.Warning:return C;case s.Info:return f;default:return a}}s.toString=b}(D||(D={})),e.default=D}),define(ee[141],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(ee[56],te([0,1,23,27]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const y=d.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$Ph=s;class M{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,D.$Ue)(d,this.b,0,d.length,this.c,this.d):(0,D.$We)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=M;class C{constructor(d=!0,y=!0){this.f=d,this.g=y}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let y=d.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,D.$Ue)(d,this.b,0,d.length,this.d,this.e):(0,D.$We)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=C;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(d,y){this.f=d,this.g=y,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,D.$Ve)(d,this.c.scheme);if(this.d[this.e]===2)return(0,D.$Ve)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,D.$Te)(d,this.c.query);if(this.d[this.e]===5)return(0,D.$Te)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(g||(g={}));class b{static forUris(d=()=>!1,y=()=>!1){return new b(new f(d,y))}static forPaths(d=!1){return new b(new C(void 0,!d))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new M)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,y){if(y){const w=y.slice(0);(0,P.$Wb)(w);for(const $ of w)this.set($,d)}else{const w=d.slice(0);(0,P.$Wb)(w);for(const $ of w)this.set($[0],$[1])}}set(d,y){const w=this.b.reset(d);let $;this.c||(this.c=new a,this.c.segment=w.value());const m=[];for($=this.c;;){const c=w.cmp($.segment);if(c>0)$.left||($.left=new a,$.left.segment=w.value()),m.push([-1,$]),$=$.left;else if(c<0)$.right||($.right=new a,$.right.segment=w.value()),m.push([1,$]),$=$.right;else if(w.hasNext())w.next(),$.mid||($.mid=new a,$.mid.segment=w.value()),m.push([0,$]),$=$.mid;else break}const h=$.value;$.value=y,$.key=d;for(let c=m.length-1;c>=0;c--){const k=m[c][1];k.updateHeight();const u=k.balanceFactor();if(u<-1||u>1){const t=m[c][0],l=m[c+1][0];if(t===1&&l===1)m[c][1]=k.rotateLeft();else if(t===-1&&l===-1)m[c][1]=k.rotateRight();else if(t===1&&l===-1)k.right=m[c+1][1]=m[c+1][1].rotateRight(),m[c][1]=k.rotateLeft();else if(t===-1&&l===1)k.left=m[c+1][1]=m[c+1][1].rotateLeft(),m[c][1]=k.rotateRight();else throw new Error;if(c>0)switch(m[c-1][0]){case-1:m[c-1][1].left=m[c][1];break;case 1:m[c-1][1].right=m[c][1];break;case 0:m[c-1][1].mid=m[c][1];break}else this.c=m[0][1]}}return h}get(d){return this.d(d)?.value}d(d){const y=this.b.reset(d);let w=this.c;for(;w;){const $=y.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(d){const y=this.d(d);return!(y?.value===void 0&&y?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,y){const w=this.b.reset(d),$=[];let m=this.c;for(;m;){const h=w.cmp(m.segment);if(h>0)$.push([-1,m]),m=m.left;else if(h<0)$.push([1,m]),m=m.right;else if(w.hasNext())w.next(),$.push([0,m]),m=m.mid;else break}if(m){if(y?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const h=this.f(m.right);if(h.key){const{key:c,value:k,segment:u}=h;this.e(h.key,!1),m.key=c,m.value=k,m.segment=u}}else{const h=m.left??m.right;if($.length>0){const[c,k]=$[$.length-1];switch(c){case-1:k.left=h;break;case 0:k.mid=h;break;case 1:k.right=h;break}}else this.c=h}for(let h=$.length-1;h>=0;h--){const c=$[h][1];c.updateHeight();const k=c.balanceFactor();if(k>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),$[h][1]=c.rotateLeft()):k<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),$[h][1]=c.rotateRight()),h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const y=this.b.reset(d);let w=this.c,$;for(;w;){const m=y.cmp(w.segment);if(m>0)w=w.left;else if(m<0)w=w.right;else if(y.hasNext())y.next(),$=w.value||$,w=w.mid;else break}return w&&w.value||$}findSuperstr(d){return this.g(d,!1)}g(d,y){const w=this.b.reset(d);let $=this.c;for(;$;){const m=w.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(w.hasNext())w.next(),$=$.mid;else return $.mid?this.h($.mid):y?$.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[y,w]of this)d(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const y=[];return this.j(d,y),y[Symbol.iterator]()}j(d,y){d&&(d.left&&this.j(d.left,y),d.value&&y.push([d.key,d.value]),d.mid&&this.j(d.mid,y),d.right&&this.j(d.right,y))}_isBalanced(){const d=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:d(y.left)&&d(y.right)};return d(this.c)}}e.$Th=b}),define(ee[12],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function P(u){return typeof u=="string"}e.$xf=P;function D(u){return Array.isArray(u)&&u.every(t=>P(t))}e.$yf=D;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$zf=s;function M(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$Af=M;function C(u){return typeof u=="number"&&!isNaN(u)}e.$Bf=C;function S(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Cf=S;function f(u){return u===!0||u===!1}e.$Df=f;function a(u){return typeof u>"u"}e.$Ef=a;function g(u){return!b(u)}e.$Ff=g;function b(u){return a(u)||u===null}e.$Gf=b;function p(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Hf=p;function d(u){if(b(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$If=d;function y(...u){const t=[];for(let l=0;l<u.length;l++){const r=u[l];if(b(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}e.$Jf=y;const w=Object.prototype.hasOwnProperty;function $(u){if(!s(u))return!1;for(const t in u)if(w.call(u,t))return!1;return!0}e.$Kf=$;function m(u){return typeof u=="function"}e.$Lf=m;function h(...u){return u.length>0&&u.every(m)}e.$Mf=h;function c(u,t){const l=Math.min(u.length,t.length);for(let r=0;r<l;r++)k(u[r],t[r])}e.$Nf=c;function k(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(u instanceof t)return}catch{}if(!b(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=k}),define(ee[72],te([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=void 0;const D=Object.create(null);function s(S,f){if((0,P.$xf)(f)){const a=D[f];if(a===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=a}return D[S]=f,{id:S}}function M(){return D}e.$Qj=M;function C(){return Object.values(e.$Sj)}e.$Rj=C,e.$Sj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function D(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const h=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([c,k])=>{h[c]=k&&typeof k=="object"?D(k):k}),h}e.$2m=D;function s(m){if(!m||typeof m!="object")return m;const h=[m];for(;h.length>0;){const c=h.shift();Object.freeze(c);for(const k in c)if(M.call(c,k)){const u=c[k];typeof u=="object"&&!Object.isFrozen(u)&&!(0,P.$Af)(u)&&h.push(u)}}return m}e.$3m=s;const M=Object.prototype.hasOwnProperty;function C(m,h){return S(m,h,new Set)}e.$4m=C;function S(m,h,c){if((0,P.$Gf)(m))return m;const k=h(m);if(typeof k<"u")return k;if(Array.isArray(m)){const u=[];for(const t of m)u.push(S(t,h,c));return u}if((0,P.$zf)(m)){if(c.has(m))throw new Error("Cannot clone recursive data-structure");c.add(m);const u={};for(const t in m)M.call(m,t)&&(u[t]=S(m[t],h,c));return c.delete(m),u}return m}function f(m,h,c=!0){return(0,P.$zf)(m)?((0,P.$zf)(h)&&Object.keys(h).forEach(k=>{k in m?c&&((0,P.$zf)(m[k])&&(0,P.$zf)(h[k])?f(m[k],h[k],c):m[k]=h[k]):m[k]=h[k]}),m):h}e.$5m=f;function a(m,h){if(m===h)return!0;if(m==null||h===null||h===void 0||typeof m!=typeof h||typeof m!="object"||Array.isArray(m)!==Array.isArray(h))return!1;let c,k;if(Array.isArray(m)){if(m.length!==h.length)return!1;for(c=0;c<m.length;c++)if(!a(m[c],h[c]))return!1}else{const u=[];for(k in m)u.push(k);u.sort();const t=[];for(k in h)t.push(k);if(t.sort(),!a(u,t))return!1;for(c=0;c<u.length;c++)if(!a(m[u[c]],h[u[c]]))return!1}return!0}e.$6m=a;function g(m){const h=new Set;return JSON.stringify(m,(c,k)=>{if((0,P.$zf)(k)||Array.isArray(k)){if(h.has(k))return"[Circular]";h.add(k)}return k})}e.$7m=g;function b(m,h){const c=Object.create(null);return!m||!h||Object.keys(h).forEach(u=>{const t=m[u],l=h[u];a(t,l)||(c[u]=l)}),c}e.$8m=b;function p(m,h){const c=h.toLowerCase(),k=Object.keys(m).find(u=>u.toLowerCase()===c);return k?m[k]:m[h]}e.$9m=p;function d(m,h){const c=Object.create(null);for(const[k,u]of Object.entries(m))h(k,u)&&(c[k]=u);return c}e.$0m=d;function y(m){let h=[];for(;Object.prototype!==m;)h=h.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return h}e.$$m=y;function w(m){const h=[];for(const c of y(m))typeof m[c]=="function"&&h.push(c);return h}e.$_m=w;function $(m,h){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return h(u,t)},k={};for(const u of m)k[u]=c(u);return k}e.$an=$}),define(ee[102],te([0,1,72]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var D;(function(C){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}C.isThemeColor=S})(D||(e.ThemeColor=D={}));function s(C){return{id:C}}e.$Tj=s;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function f(h){const c=S.exec(h.id);if(!c)return f(P.$Sj.error);const[,k,u]=c,t=["codicon","codicon-"+k];return u&&t.push("codicon-modifier-"+u.substring(1)),t}C.asClassNameArray=f;function a(h){return f(h).join(" ")}C.asClassName=a;function g(h){return"."+f(h).join(".")}C.asCSSSelector=g;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||D.isThemeColor(h.color))}C.isThemeIcon=b;const p=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function d(h){const c=p.exec(h);if(!c)return;const[,k]=c;return{id:k}}C.fromString=d;function y(h){return{id:h}}C.fromId=y;function w(h,c){let k=h.id;const u=k.lastIndexOf("~");return u!==-1&&(k=k.substring(0,u)),c&&(k=`${k}~${c}`),{id:k}}C.modify=w;function $(h){const c=h.id.lastIndexOf("~");if(c!==-1)return h.id.substring(c+1)}C.getModifier=$;function m(h,c){return h.id===c.id&&h.color?.id===c.color?.id}C.isEqual=m})(M||(e.ThemeIcon=M={}))}),define(ee[32],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(s){return P.test(s)}e.$cg=D,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,a="";return a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a+="-",a+=C[M[f++]],a+=C[M[f++]],a+="-",a+=C[M[f++]],a+=C[M[f++]],a+="-",a+=C[M[f++]],a+=C[M[f++]],a+="-",a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a+=C[M[f++]],a}}()}),define(ee[142],te([0,1,85,45,82]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8S=void 0;async function M(C,S){if(await new Promise((g,b)=>{const p=D.createReadStream(C),d=P.createHash("sha1");p.pipe(d);const y=(0,s.$cb)((w,$)=>{p.removeAllListeners(),d.removeAllListeners(),w?b(w):g($)});p.once("error",y),p.once("end",y),d.once("error",y),d.once("data",w=>y(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$8S=M}),define(ee[143],te([0,1,28]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const S=C.replace(/\-/g,":").toLowerCase();return!D.has(S)}function M(){const C=(0,P.networkInterfaces)();for(const S in C){const f=C[S];if(f){for(const{mac:a}of f)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Mm=M}),define(ee[86],te([0,1,28,56,32,143]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=void 0,e.$Nm=new class{c(a){return this.a||(this.a=D.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(a)}value(){if(this.b===void 0){let a=0,g=0;const b=(0,P.networkInterfaces)();for(const p in b){const d=b[p];if(d)for(const{mac:y,internal:w}of d)w||(g+=1,this.c(y.toUpperCase())&&(a+=1))}this.b=g>0?a/g:0}return this.b}};let C;async function S(a){return C||(C=(async()=>await f(a)||s.$dg())()),C}e.$Om=S;async function f(a){try{const g=await new Promise((p,d)=>{Z(["crypto"],p,d)}),b=(0,M.$Mm)();return g.createHash("sha256").update(b,"utf8").digest("hex")}catch(g){a(g);return}}}),define(ee[103],te([0,1,87]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function D(S,f,a,g=1){let b=!1;return new Promise(p=>{const d=setTimeout(()=>{if(!b)return b=!0,p(0)},a);s(S,f,g,y=>{if(!b)return b=!0,clearTimeout(d),p(y)})})}e.$fg=D;function s(S,f,a,g){if(f===0)return g(0);const b=new P.Socket;b.once("connect",()=>(C(b),s(S+a,f-1,a,g))),b.once("data",()=>{}),b.once("error",p=>(C(b),p.code!=="ECONNREFUSED"?s(S+a,f-1,a,g):g(S))),b.connect(S,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,a,g="127.0.0.1"){let b=!1,p,d=1;const y=P.createServer({pauseOnConnect:!0});function w($,m){b||(b=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),m($))}return new Promise($=>{p=setTimeout(()=>{w(0,$)},a),y.on("listening",()=>{w(S,$)}),y.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&d<f?(S++,d++,y.listen(S,g)):w(0,$)}),y.on("close",()=>{w(0,$)}),y.listen(S,g)})}e.$hg=M;function C(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function Z(){function e(){return process.uncHostAllowlist}function P(f){const a=new Set;if(Array.isArray(f))for(const g of f)typeof g=="string"&&a.add(g);return Array.from(a)}function D(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const a=e();if(a)if(typeof f=="string")a.add(f.toLowerCase());else for(const g of P(f))s(g)}function M(f){if(typeof f!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const b of a){if(f.indexOf(b)!==0)continue;const d=f.indexOf("\\",b.length);if(d===-1)continue;const y=f.substring(b.length,d);if(y){g=y;break}}return g}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Z()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Z():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[144],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=e.$$S=void 0,e.$$S="vscode:contextmenu",e.$_S="vscode:onCloseContextMenu"}),define(ee[145],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gT=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$gT=P}),define(ee[146],te([11,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ee[147],te([0,1,146]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const D=60,s=D*60,M=s*24,C=M*7,S=M*30,f=M*365;function a(b,p,d,y){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,P.localize)(0,null,a(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,P.localize)(1,null);let $;return w<D?($=w,p?$===1?d?(0,P.localize)(2,null,$):(0,P.localize)(3,null,$):d?(0,P.localize)(4,null,$):(0,P.localize)(5,null,$):$===1?d?(0,P.localize)(6,null,$):(0,P.localize)(7,null,$):d?(0,P.localize)(8,null,$):(0,P.localize)(9,null,$)):w<s?($=Math.floor(w/D),p?$===1?d?(0,P.localize)(10,null,$):(0,P.localize)(11,null,$):d?(0,P.localize)(12,null,$):(0,P.localize)(13,null,$):$===1?d?(0,P.localize)(14,null,$):(0,P.localize)(15,null,$):d?(0,P.localize)(16,null,$):(0,P.localize)(17,null,$)):w<M?($=Math.floor(w/s),p?$===1?d?(0,P.localize)(18,null,$):(0,P.localize)(19,null,$):d?(0,P.localize)(20,null,$):(0,P.localize)(21,null,$):$===1?d?(0,P.localize)(22,null,$):(0,P.localize)(23,null,$):d?(0,P.localize)(24,null,$):(0,P.localize)(25,null,$)):w<C?($=Math.floor(w/M),p?$===1?(0,P.localize)(26,null,$):(0,P.localize)(27,null,$):$===1?(0,P.localize)(28,null,$):(0,P.localize)(29,null,$)):w<S?($=Math.floor(w/C),p?$===1?d?(0,P.localize)(30,null,$):(0,P.localize)(31,null,$):d?(0,P.localize)(32,null,$):(0,P.localize)(33,null,$):$===1?d?(0,P.localize)(34,null,$):(0,P.localize)(35,null,$):d?(0,P.localize)(36,null,$):(0,P.localize)(37,null,$)):w<f?($=Math.floor(w/S),p?$===1?d?(0,P.localize)(38,null,$):(0,P.localize)(39,null,$):d?(0,P.localize)(40,null,$):(0,P.localize)(41,null,$):$===1?d?(0,P.localize)(42,null,$):(0,P.localize)(43,null,$):d?(0,P.localize)(44,null,$):(0,P.localize)(45,null,$)):($=Math.floor(w/f),p?$===1?d?(0,P.localize)(46,null,$):(0,P.localize)(47,null,$):d?(0,P.localize)(48,null,$):(0,P.localize)(49,null,$):$===1?d?(0,P.localize)(50,null,$):(0,P.localize)(51,null,$):d?(0,P.localize)(52,null,$):(0,P.localize)(53,null,$))}e.$_l=a;function g(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=g}),define(ee[148],te([11,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ee[49],te([0,1,23,12,148]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function M(b,p){return p&&(b.stack||b.stacktrace)?s.localize(0,null,S(b),C(b.stack)||C(b.stacktrace)):S(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function S(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function f(b=null,p=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const d=P.$Gb(b),y=f(d[0],p);return d.length>1?s.localize(4,null,y,d.length):y}if(D.$xf(b))return b;if(b.detail){const d=b.detail;if(d.error)return M(d.error,p);if(d.exception)return M(d.exception,p)}return b.stack?M(b,p):b.message?b.message:s.localize(5,null)}e.$yi=f;function a(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.$zi=a;function g(b,p){let d;return typeof b=="string"?d=new Error(b):d=b,d.actions=p,d}e.$Ai=g}),define(ee[149],te([11,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(ee[150],te([0,1,149]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;function D(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$sp=D}),define(ee[151],te([11,10]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,151]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let D=!1,s=!1,M=!1,C=!1,S=!1,f=!1,a=!1,g=!1,b=!1,p=!1,d,y=e.$g,w=e.$g,$,m;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?h=e.$h.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",k=c&&h?.type==="renderer";if(typeof navigator=="object"&&!k)m=navigator.userAgent,D=m.indexOf("Windows")>=0,s=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,p=m?.indexOf("Mobi")>=0,f=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,y=d,w=navigator.language;else if(typeof h=="object"){D=h.platform==="win32",s=h.platform==="darwin",M=h.platform==="linux",C=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,a=c,b=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,y=e.$g;const R=h.env.VSCODE_NLS_CONFIG;if(R)try{const A=JSON.parse(R),E=A.availableLanguages["*"];d=A.locale,w=A.osLocale,y=E||e.$g,$=A._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var u;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let l=0;s?l=1:D?l=3:M&&(l=2),e.$j=D,e.$k=s,e.$l=M,e.$m=C,e.$n=S,e.$o=a,e.$p=f,e.$q=f&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=p,e.$t=b,e.$u=l,e.$v=m,e.$w=y;var r;(function(R){function A(){return e.$w}R.value=A;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}R.isDefaultVariant=E;function I(){return e.$w==="en"}R.isDefault=I})(r||(e.Language=r={})),e.$x=d,e.$y=w,e.$z=$,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const R=[];e.$h.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let I=0,L=R.length;I<L;I++){const F=R[I];if(F.id===E.data.vscodeScheduleAsyncWork){R.splice(I,1),F.callback();return}}});let A=0;return E=>{const I=++A;R.push({id:I,callback:E}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return R=>setTimeout(R)})();var i;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||g?2:D?1:3;let n=!0,o=!1;function v(){if(!o){o=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,n=new Uint16Array(R.buffer)[0]===(2<<8)+1}return n}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let D;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.process<"u"){const s=P.$h.vscode.process;D={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return P.$j?"win32":P.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$cc=D.platform,e.$dc=D.arch}),define(ee[9],te([0,1,35]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const D=65,s=97,M=90,C=122,S=46,f=47,a=92,g=58,b=63;class p extends Error{constructor(l,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let v=`The "${l}" ${o} ${n} of type ${r}`;v+=`. Received type ${typeof i}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new p(l,"string",t)}const w=P.$cc==="win32";function $(t){return t===f||t===a}function m(t){return t===f}function h(t){return t>=D&&t<=M||t>=s&&t<=C}function c(t,l,r,i){let n="",o=0,v=-1,R=0,A=0;for(let E=0;E<=t.length;++E){if(E<t.length)A=t.charCodeAt(E);else{if(i(A))break;A=f}if(i(A)){if(!(v===E-1||R===1))if(R===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",o=0):(n=n.slice(0,I),o=n.length-1-n.lastIndexOf(r)),v=E,R=0;continue}else if(n.length!==0){n="",o=0,v=E,R=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(v+1,E)}`:n=t.slice(v+1,E),o=E-v-1;v=E,R=0}else A===S&&R!==-1?++R:R=-1}return n}function k(t,l){d(l,"pathObject");const r=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${i}`:`${r}${t}${i}`:i}e.$ec={resolve(...t){let l="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=P.cwd():(o=P.env[`=${l}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===a)&&(o=`${l}\\`));const v=o.length;let R=0,A="",E=!1;const I=o.charCodeAt(0);if(v===1)$(I)&&(R=1,E=!0);else if($(I))if(E=!0,$(o.charCodeAt(1))){let L=2,F=L;for(;L<v&&!$(o.charCodeAt(L));)L++;if(L<v&&L!==F){const B=o.slice(F,L);for(F=L;L<v&&$(o.charCodeAt(L));)L++;if(L<v&&L!==F){for(F=L;L<v&&!$(o.charCodeAt(L));)L++;(L===v||L!==F)&&(A=`\\\\${B}\\${o.slice(F,L)}`,R=L)}}}else R=1;else h(I)&&o.charCodeAt(1)===g&&(A=o.slice(0,2),R=2,v>2&&$(o.charCodeAt(2))&&(E=!0,R=3));if(A.length>0)if(l.length>0){if(A.toLowerCase()!==l.toLowerCase())continue}else l=A;if(i){if(l.length>0)break}else if(r=`${o.slice(R)}\\${r}`,i=E,E&&l.length>0)break}return r=c(r,!i,"\\",$),i?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return m(o)?"\\":t;if($(o))if(n=!0,$(t.charCodeAt(1))){let R=2,A=R;for(;R<l&&!$(t.charCodeAt(R));)R++;if(R<l&&R!==A){const E=t.slice(A,R);for(A=R;R<l&&$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&!$(t.charCodeAt(R));)R++;if(R===l)return`\\\\${E}\\${t.slice(A)}\\`;R!==A&&(i=`\\\\${E}\\${t.slice(A,R)}`,r=R)}}}else r=1;else h(o)&&t.charCodeAt(1)===g&&(i=t.slice(0,2),r=2,l>2&&$(t.charCodeAt(2))&&(n=!0,r=3));let v=r<l?c(t.slice(r),!n,"\\",$):"";return v.length===0&&!n&&(v="."),v.length>0&&$(t.charCodeAt(l-1))&&(v+="\\"),i===void 0?n?`\\${v}`:v:n?`${i}\\${v}`:`${i}${v}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return $(r)||l>2&&h(r)&&t.charCodeAt(1)===g&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let o=0;o<t.length;++o){const v=t[o];y(v,"path"),v.length>0&&(l===void 0?l=r=v:l+=`\\${v}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const o=r.length;o>1&&$(r.charCodeAt(1))&&(++n,o>2&&($(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&$(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$ec.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const r=e.$ec.resolve(t),i=e.$ec.resolve(l);if(r===i||(t=r.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===a;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===a;)o--;const v=o-n;let R=0;for(;R<l.length&&l.charCodeAt(R)===a;)R++;let A=l.length;for(;A-1>R&&l.charCodeAt(A-1)===a;)A--;const E=A-R,I=v<E?v:E;let L=-1,F=0;for(;F<I;F++){const se=t.charCodeAt(n+F);if(se!==l.charCodeAt(R+F))break;se===a&&(L=F)}if(F!==I){if(L===-1)return i}else{if(E>I){if(l.charCodeAt(R+F)===a)return i.slice(R+F+1);if(F===2)return i.slice(R+F)}v>I&&(t.charCodeAt(n+F)===a?L=F:F===2&&(L=3)),L===-1&&(L=0)}let B="";for(F=n+L+1;F<=o;++F)(F===o||t.charCodeAt(F)===a)&&(B+=B.length===0?"..":"\\..");return R+=L,B.length>0?`${B}${i.slice(R,A)}`:(i.charCodeAt(R)===a&&++R,i.slice(R,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$ec.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const r=l.charCodeAt(2);if(r!==b&&r!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===g&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(l===1)return $(n)?t:".";if($(n)){if(r=i=1,$(t.charCodeAt(1))){let R=2,A=R;for(;R<l&&!$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&!$(t.charCodeAt(R));)R++;if(R===l)return t;R!==A&&(r=i=R+1)}}}}else h(n)&&t.charCodeAt(1)===g&&(r=l>2&&$(t.charCodeAt(2))?3:2,i=r);let o=-1,v=!0;for(let R=l-1;R>=i;--R)if($(t.charCodeAt(R))){if(!v){o=R;break}}else v=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,R=-1;for(o=t.length-1;o>=r;--o){const A=t.charCodeAt(o);if($(A)){if(!n){r=o+1;break}}else R===-1&&(n=!1,R=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if($(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=0,r=-1,i=0,n=-1,o=!0,v=0;t.length>=2&&t.charCodeAt(1)===g&&h(t.charCodeAt(0))&&(l=i=2);for(let R=t.length-1;R>=l;--R){const A=t.charCodeAt(R);if($(A)){if(!o){i=R+1;break}continue}n===-1&&(o=!1,n=R+1),A===S?r===-1?r=R:v!==1&&(v=1):r!==-1&&(v=-1)}return r===-1||n===-1||v===0||v===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:k.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return $(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if($(n)){if(i=1,$(t.charCodeAt(1))){let L=2,F=L;for(;L<r&&!$(t.charCodeAt(L));)L++;if(L<r&&L!==F){for(F=L;L<r&&$(t.charCodeAt(L));)L++;if(L<r&&L!==F){for(F=L;L<r&&!$(t.charCodeAt(L));)L++;L===r?i=L:L!==F&&(i=L+1)}}}}else if(h(n)&&t.charCodeAt(1)===g){if(r<=2)return l.root=l.dir=t,l;if(i=2,$(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,v=i,R=-1,A=!0,E=t.length-1,I=0;for(;E>=i;--E){if(n=t.charCodeAt(E),$(n)){if(!A){v=E+1;break}continue}R===-1&&(A=!1,R=E+1),n===S?o===-1?o=E:I!==1&&(I=1):o!==-1&&(I=-1)}return R!==-1&&(o===-1||I===0||I===1&&o===R-1&&o===v+1?l.base=l.name=t.slice(v,R):(l.name=t.slice(v,o),l.base=t.slice(v,R),l.ext=t.slice(o,R))),v>0&&v!==i?l.dir=t.slice(0,v-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const t=/\\/g;return()=>{const l=P.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>P.cwd()})();e.$fc={resolve(...t){let l="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===f)}return l=c(l,!r,"/",m),r?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=c(t,!l,"/",m),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$fc.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.$fc.resolve(t),l=e.$fc.resolve(l),t===l))return"";const r=1,i=t.length,n=i-r,o=1,v=l.length-o,R=n<v?n:v;let A=-1,E=0;for(;E<R;E++){const L=t.charCodeAt(r+E);if(L!==l.charCodeAt(o+E))break;L===f&&(A=E)}if(E===R)if(v>R){if(l.charCodeAt(o+E)===f)return l.slice(o+E+1);if(E===0)return l.slice(o+E)}else n>R&&(t.charCodeAt(r+E)===f?A=E:E===0&&(A=0));let I="";for(E=r+A+1;E<=i;++E)(E===i||t.charCodeAt(E)===f)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(o+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,R=-1;for(o=t.length-1;o>=0;--o){const A=t.charCodeAt(o);if(A===f){if(!n){r=o+1;break}}else R===-1&&(n=!1,R=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===f){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=-1,r=0,i=-1,n=!0,o=0;for(let v=t.length-1;v>=0;--v){const R=t.charCodeAt(v);if(R===f){if(!n){r=v+1;break}continue}i===-1&&(n=!1,i=v+1),R===S?l===-1?l=v:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===r+1?"":t.slice(l,i)},format:k.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===f;let i;r?(l.root="/",i=1):i=0;let n=-1,o=0,v=-1,R=!0,A=t.length-1,E=0;for(;A>=i;--A){const I=t.charCodeAt(A);if(I===f){if(!R){o=A+1;break}continue}v===-1&&(R=!1,v=A+1),I===S?n===-1?n=A:E!==1&&(E=1):n!==-1&&(E=-1)}if(v!==-1){const I=o===0&&r?1:o;n===-1||E===0||E===1&&n===v-1&&n===o+1?l.base=l.name=t.slice(I,v):(l.name=t.slice(I,n),l.base=t.slice(I,v),l.ext=t.slice(n,v))}return o>0?l.dir=t.slice(0,o-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ee[33],te([0,1,9,4,27,12]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function C(o){return o===47||o===92}e.$Pf=C;function S(o){return o.replace(/[\\/]/g,P.$fc.sep)}e.$Qf=S;function f(o){return o.indexOf("/")===-1&&(o=S(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Rf=f;function a(o,v=P.$fc.sep){if(!o)return"";const R=o.length,A=o.charCodeAt(0);if(C(A)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let I=3;const L=I;for(;I<R&&!C(o.charCodeAt(I));I++);if(L!==I&&!C(o.charCodeAt(I+1))){for(I+=1;I<R;I++)if(C(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,v)}}return v}else if(m(A)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+v:o.slice(0,2);let E=o.indexOf("://");if(E!==-1){for(E+=3;E<R;E++)if(C(o.charCodeAt(E)))return o.slice(0,E+1)}return""}e.$Sf=a;function g(o){if(!D.$j||!o||o.length<5)return!1;let v=o.charCodeAt(0);if(v!==92||(v=o.charCodeAt(1),v!==92))return!1;let R=2;const A=R;for(;R<o.length&&(v=o.charCodeAt(R),v!==92);R++);return!(A===R||(v=o.charCodeAt(R+1),isNaN(v)||v===92))}e.$Tf=g;const b=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,v=D.$j){const R=v?b:p;return!(!o||o.length===0||/^\s+$/.test(o)||(R.lastIndex=0,R.test(o))||v&&d.test(o)||o==="."||o===".."||v&&o[o.length-1]==="."||v&&o.length!==o.trim().length||o.length>255)}e.$Uf=y;function w(o,v,R){const A=o===v;return!R||A?A:!o||!v?!1:(0,s.$1e)(o,v)}e.$Vf=w;function $(o,v,R,A=P.sep){if(o===v)return!0;if(!o||!v||v.length>o.length)return!1;if(R){if(!(0,s.$2e)(o,v))return!1;if(v.length===o.length)return!0;let I=v.length;return v.charAt(v.length-1)===A&&I--,o.charAt(I)===A}return v.charAt(v.length-1)!==A&&(v+=A),o.indexOf(v)===0}e.$Wf=$;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Xf=m;function h(o,v){return D.$j&&o.endsWith(":")&&(o+=P.sep),(0,P.$hc)(o)||(o=(0,P.$ic)(v,o)),o=(0,P.$gc)(o),D.$j?(o=(0,s.$Je)(o,P.sep),o.endsWith(":")&&(o+=P.sep)):(o=(0,s.$Je)(o,P.sep),o||(o=P.sep)),o}e.$Yf=h;function c(o){const v=(0,P.$gc)(o);return D.$j?o.length>3?!1:k(v)&&(o.length===2||v.charCodeAt(2)===92):v===P.$fc.sep}e.$Zf=c;function k(o,v=D.$j){return v?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$1f=k;function u(o,v=D.$j){return k(o,v)?o[0]:void 0}e.$2f=u;function t(o,v,R){return v.length>o.length?-1:o===v?0:(R&&(o=o.toLowerCase(),v=v.toLowerCase()),o.indexOf(v))}e.$3f=t;function l(o){const v=o.split(":");let R,A,E;for(const I of v){const L=Number(I);(0,M.$Bf)(L)?A===void 0?A=L:E===void 0&&(E=L):R=R?[R,I].join(":"):I}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:A!==void 0?A:void 0,column:E!==void 0?E:A!==void 0?1:void 0}}e.$4f=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,v,R=8){let A="";for(let I=0;I<R;I++){let L;I===0&&D.$j&&!v&&(R===3||R===4)?L=i:L=r,A+=L.charAt(Math.floor(Math.random()*L.length))}let E;return v?E=`${v}-${A}`:E=A,o?(0,P.$ic)(o,E):E}e.$5f=n}),define(ee[73],te([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D||(e.Source=D={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...f){const a=f.reduce((p,d)=>(p[d]=!0,p),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!a[p]).forEach(p=>{for(let d=0;d<g.length;d++)if(p.search(g[d])!==-1){delete S[p];break}})}e.$vl=M;function C(S){S&&(delete S.DEBUG,P.$k&&delete S.DYLD_LIBRARY_PATH,P.$l&&delete S.LD_PRELOAD)}e.$wl=C}),define(ee[7],te([0,1,9,4]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function a(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const g="",b="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,v,R,A,E=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=f(n,E),this.authority=o||g,this.path=a(this.scheme,v||g),this.query=R||g,this.fragment=A||g,S(this,E))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:R,query:A,fragment:E}=n;return o===void 0?o=this.scheme:o===null&&(o=g),v===void 0?v=this.authority:v===null&&(v=g),R===void 0?R=this.path:R===null&&(R=g),A===void 0?A=this.query:A===null&&(A=g),E===void 0?E=this.fragment:E===null&&(E=g),o===this.scheme&&v===this.authority&&R===this.path&&A===this.query&&E===this.fragment?this:new $(o,v,R,A,E)}static parse(n,o=!1){const v=p.exec(n);return v?new $(v[2]||g,r(v[4]||g),r(v[5]||g),r(v[7]||g),r(v[9]||g),o):new $(g,g,g,g,g)}static file(n){let o=g;if(D.$j&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const v=n.indexOf(b,2);v===-1?(o=n.substring(2),n=b):(o=n.substring(2,v),n=n.substring(v)||b)}return new $("file",o,n,g,g)}static from(n,o){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return D.$j&&n.scheme==="file"?v=d.file(P.$ec.join(k(n,!0),...o)).path:v=P.$fc.join(n.path,...o),n.with({path:v})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const o=new $(n);return o._formatted=n.external??null,o._fsPath=n._sep===w?n.fsPath??null:null,o}}else return n}}e.URI=d;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=y;const w=D.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let v,R=-1;for(let A=0;A<i.length;A++){const E=i.charCodeAt(A);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||o&&E===91||o&&E===93||o&&E===58)R!==-1&&(v+=encodeURIComponent(i.substring(R,A)),R=-1),v!==void 0&&(v+=i.charAt(A));else{v===void 0&&(v=i.substr(0,A));const I=m[E];I!==void 0?(R!==-1&&(v+=encodeURIComponent(i.substring(R,A)),R=-1),v+=I):R===-1&&(R=A)}}return R!==-1&&(v+=encodeURIComponent(i.substring(R))),v!==void 0?v:i}function c(i){let n;for(let o=0;o<i.length;o++){const v=i.charCodeAt(o);v===35||v===63?(n===void 0&&(n=i.substr(0,o)),n+=m[v]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function k(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,D.$j&&(o=o.replace(/\//g,"\\")),o}e.$vc=k;function u(i,n){const o=n?c:h;let v="",{scheme:R,authority:A,path:E,query:I,fragment:L}=i;if(R&&(v+=R,v+=":"),(A||R==="file")&&(v+=b,v+=b),A){let F=A.indexOf("@");if(F!==-1){const B=A.substr(0,F);A=A.substr(F+1),F=B.lastIndexOf(":"),F===-1?v+=o(B,!1,!1):(v+=o(B.substr(0,F),!1,!1),v+=":",v+=o(B.substr(F+1),!1,!0)),v+="@"}A=A.toLowerCase(),F=A.lastIndexOf(":"),F===-1?v+=o(A,!1,!0):(v+=o(A.substr(0,F),!1,!0),v+=A.substr(F))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const F=E.charCodeAt(1);F>=65&&F<=90&&(E=`/${String.fromCharCode(F+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const F=E.charCodeAt(0);F>=65&&F<=90&&(E=`${String.fromCharCode(F+32)}:${E.substr(2)}`)}v+=o(E,!0,!1)}return I&&(v+="?",v+=o(I,!1,!1)),L&&(v+="#",v+=n?L:h(L,!1,!1)),v}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(ee[152],te([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Vp=e.$Up=e.$Tp=void 0;function D(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$Tp=D;function s(a){const g=[];let b;try{const p=JSON.parse(a.arguments),d=p[p.length-1];d&&d.__$stack&&(p.pop(),b=d.__$stack),g.push(...p)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:b}}e.$Up=s;function M(a){if(typeof a!="string")return M(s(a).stack);const g=a;if(g){const b=C(g),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Vp=M;function C(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function S(a,g){const{args:b,stack:p}=s(a),d=typeof b[0]=="string"&&b.length===1;let y=C(p);y&&(y=`(${y.trim()})`);let w=[];if(typeof b[0]=="string"?y&&d?w=[`%c[${g}] %c${b[0]} %c${y}`,f("blue"),f(""),f("grey")]:w=[`%c[${g}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:w=[`%c[${g}]%`,f("blue"),...b],y&&!d&&w.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,w)}e.log=S;function f(a){return`color: ${a}`}}),define(ee[74],te([0,1,18,7]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function s(f){return JSON.stringify(f,C)}e.$ih=s;function M(f){let a=JSON.parse(f);return a=S(a),a}e.$jh=M;function C(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return D.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$ae||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let g=0;g<f.length;++g)f[g]=S(f[g],a+1);else for(const g in f)Object.hasOwnProperty.call(f,g)&&(f[g]=S(f[g],a+1))}return f}e.$kh=S}),define(ee[13],te([0,1,14,4,7]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var M;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$6f="vscode-tkn",e.$7f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${M.vscodeRemoteResource}`}set(g,b,p){this.a[g]=b,this.b[g]=p}setConnectionToken(g,b){this.c[g]=b}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch($){return P.$Z($),g}const b=g.authority;let p=this.a[b];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this.b[b],y=this.c[b];let w=`path=${encodeURIComponent(g.path)}`;return typeof y=="string"&&(w+=`&${e.$7f}=${encodeURIComponent(y)}`),s.URI.from({scheme:D.$p?this.d:M.vscodeRemoteResource,authority:`${p}:${d}`,path:this.f,query:w})}}e.$8f=new C,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class S{static{this.a=e.$ag}asBrowserUri(g){const b=this.b(g,Z);return this.uriToBrowserUri(b)}uriToBrowserUri(g){return g.scheme===M.vscodeRemote?e.$8f.rewrite(g):g.scheme===M.file&&(D.$n||D.$q&&D.$h.origin===`${M.vscodeFileResource}://${S.a}`)?g.with({scheme:M.vscodeFileResource,authority:g.authority||S.a,query:null,fragment:null}):g}asFileUri(g){const b=this.b(g,Z);return this.uriToFileUri(b)}uriToFileUri(g){return g.scheme===M.vscodeFileResource?g.with({scheme:M.file,authority:g.authority!==S.a?g.authority:null,query:null,fragment:null}):g}b(g,b){return s.URI.isUri(g)?g:s.URI.parse(b.toUrl(g))}}e.$bg=new S;var f;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const b="vscode-coi";function p(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const $=w?.get(b);if($)return g.get($)}a.getHeadersFromQuery=p;function d(y,w,$){if(!globalThis.crossOriginIsolated)return;const m=w&&$?"3":$?"2":"1";y instanceof URLSearchParams?y.set(b,m):y[b]=m}a.addSearchParam=d})(f||(e.COI=f={}))}),define(ee[19],te([0,1,33,13,9,4,27,7]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function f(d){return(0,S.$vc)(d,!0)}e.$ig=f;class a{constructor(y){this.a=y}compare(y,w,$=!1){return y===w?0:(0,C.$Te)(this.getComparisonKey(y,$),this.getComparisonKey(w,$))}isEqual(y,w,$=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,$)===this.getComparisonKey(w,$)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,$=!1){if(y.scheme===w.scheme){if(y.scheme===D.Schemas.file)return P.$Wf(f(y),f(w),this.a(y))&&y.query===w.query&&($||y.fragment===w.fragment);if((0,e.$zg)(y.authority,w.authority))return P.$Wf(y.path,w.path,this.a(y),"/")&&y.query===w.query&&($||y.fragment===w.fragment)}return!1}joinPath(y,...w){return S.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$rg)(y)||y.authority}basename(y){return s.$fc.basename(y.path)}extname(y){return s.$fc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===D.Schemas.file?w=S.URI.file(s.$lc(f(y))).path:(w=s.$fc.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===D.Schemas.file?w=S.URI.file(s.$gc(f(y))).path:w=s.$fc.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$zg)(y.authority,w.authority))return;if(y.scheme===D.Schemas.file){const h=s.$kc(f(y),f(w));return M.$j?P.$Qf(h):h}let $=y.path||"/";const m=w.path||"/";if(this.a(y)){let h=0;for(const c=Math.min($.length,m.length);h<c&&!($.charCodeAt(h)!==m.charCodeAt(h)&&$.charAt(h).toLowerCase()!==m.charAt(h).toLowerCase());h++);$=m.substr(0,h)+$.substr(h)}return s.$fc.relative($,m)}resolvePath(y,w){if(y.scheme===D.Schemas.file){const $=S.URI.file(s.$jc(f(y),w));return y.with({authority:$.authority,path:$.path})}return w=P.$Rf(w),y.with({path:s.$fc.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,C.$1e)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===D.Schemas.file){const $=f(y);return $.length>P.$Sf($).length&&$[$.length-1]===w}else{const $=y.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$Ag)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let $=!1;if(y.scheme===D.Schemas.file){const m=f(y);$=m!==void 0&&m.length===P.$Sf(m).length&&m[m.length-1]===w}else{w="/";const m=y.path;$=m.length===1&&m.charCodeAt(m.length-1)===47}return!$&&!(0,e.$Ag)(y,w)?y.with({path:y.path+"/"}):y}}e.$jg=a,e.$kg=new a(()=>!1),e.$lg=new a(d=>d.scheme===D.Schemas.file?!M.$l:!0),e.$mg=new a(d=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function g(d,y){const w=[];for(let $=0;$<d.length;$++){const m=y(d[$]);d.some((h,c)=>c===$?!1:(0,e.$og)(m,y(h)))||w.push(d[$])}return w}e.$Dg=g;var b;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function y(w){const $=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[k,u]=c.split(":");k&&u&&$.set(k,u)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&$.set(d.META_DATA_MIME,h),$}d.parseMetaData=y})(b||(e.DataUri=b={}));function p(d,y,w){if(y){let $=d.path;return $&&$[0]!==s.$fc.sep&&($=s.$fc.sep+$),d.with({scheme:w,authority:y,path:$})}return d.with({scheme:w})}e.$Eg=p}),define(ee[8],te([0,1,22,14,3,2,19,4,141]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function a(O){return!!O&&typeof O.then=="function"}e.$Fg=a;function g(O){const j=new P.$Wd,q=O(j.token),W=new Promise((z,G)=>{const ce=j.token.onCancellationRequested(()=>{ce.dispose(),j.dispose(),G(new D.$4)});Promise.resolve(q).then(de=>{ce.dispose(),j.dispose(),z(de)},de=>{ce.dispose(),j.dispose(),G(de)})});return new class{cancel(){j.cancel()}then(z,G){return W.then(z,G)}catch(z){return this.then(void 0,z)}finally(z){return W.finally(z)}}}e.$Gg=g;function b(O,j,q){return new Promise((W,z)=>{const G=j.onCancellationRequested(()=>{G.dispose(),W(q)});O.then(W,z).finally(()=>G.dispose())})}e.$Hg=b;function p(O,j){return new Promise((q,W)=>{const z=j.onCancellationRequested(()=>{z.dispose(),W(new D.$4)});O.then(q,W).finally(()=>z.dispose())})}e.$Ig=p;async function d(O){let j=-1;const q=O.map((W,z)=>W.then(G=>(j=z,G)));try{return await Promise.race(q)}finally{O.forEach((W,z)=>{z!==j&&W.cancel()})}}e.$Jg=d;function y(O,j,q){let W;const z=setTimeout(()=>{W?.(void 0),q?.()},j);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(G=>W=G)])}e.$Kg=y;function w(O){return new Promise((j,q)=>{const W=O();a(W)?W.then(j,q):j(W)})}e.$Lg=w;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const q=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(q,q).then(W)})}return new Promise((q,W)=>{this.b.then(q,W)})}return this.a=j(),new Promise((q,W)=>{this.a.then(z=>{this.a=null,q(z)},z=>{this.a=null,W(z)})})}dispose(){this.f=!0}}e.$Mg=$;class m{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Ng=m;class h{constructor(){this.a=new Map}queue(j,q){const z=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(j)===z&&this.a.delete(j)});return this.a.set(j,z),z}}e.$Og=h;const c=(O,j)=>{let q=!0;const W=setTimeout(()=>{q=!1,j()},O);return{isTriggered:()=>q,dispose:()=>{clearTimeout(W),q=!1}}},k=O=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,O())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,q=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((z,G)=>{this.d=z,this.f=G}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=q===f.$Jd?k(W):c(q,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=u;class t{constructor(j){this.a=new u(j),this.b=new $}trigger(j,q){return this.a.trigger(()=>this.b.queue(j),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=t;class l{constructor(){this.a=!1,this.b=new Promise((j,q)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=l;class r extends l{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Sg=r;function i(O,j){return j?new Promise((q,W)=>{const z=setTimeout(()=>{G.dispose(),q()},O),G=j.onCancellationRequested(()=>{clearTimeout(z),G.dispose(),W(new D.$4)})}):g(q=>i(O,q))}e.$Tg=i;function n(O,j=0,q){const W=setTimeout(()=>{O(),q&&z.dispose()},j),z=(0,M.$Pc)(()=>{clearTimeout(W),q?.deleteAndLeak(z)});return q?.add(z),z}e.$Ug=n;function o(O){const j=[];let q=0;const W=O.length;function z(){return q<W?O[q++]():null}function G(ce){ce!=null&&j.push(ce);const de=z();return de?de.then(G):Promise.resolve(j)}return Promise.resolve(null).then(G)}e.$Vg=o;function v(O,j=W=>!!W,q=null){let W=0;const z=O.length,G=()=>{if(W>=z)return Promise.resolve(q);const ce=O[W++];return Promise.resolve(ce()).then(ue=>j(ue)?Promise.resolve(ue):G())};return G()}e.$Wg=v;function R(O,j=W=>!!W,q=null){if(O.length===0)return Promise.resolve(q);let W=O.length;const z=()=>{W=-1;for(const G of O)G.cancel?.()};return new Promise((G,ce)=>{for(const de of O)de.then(ue=>{--W>=0&&j(ue)?(z(),G(ue)):W===0&&G(q)}).catch(ue=>{--W>=0&&(z(),ce(ue))})})}e.$Xg=R;class A{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((q,W)=>{this.f.push({factory:j,c:q,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const q=j.factory();q.then(j.c,j.e),q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=A;class E extends A{constructor(){super(1)}}e.$Zg=E;class I{constructor(){this.a=new K,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$1g=I;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new U;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,q=C.$kg){const W=q.getComparisonKey(j);let z=this.a.get(W);if(!z){z=new E;const G=this.f++,ce=s.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(G),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(G,ce),this.a.set(W,z)}return z}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=L;class F{constructor(j,q){this.a=-1,typeof j=="function"&&typeof q=="number"&&this.setIfNotSet(j,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},q)}setIfNotSet(j,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},q))}}e.$3g=F;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,q){this.cancel(),this.a=setInterval(()=>{j()},q)}}e.$4g=B;class se{constructor(j,q){this.b=-1,this.a=j,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=se;class x{constructor(j,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=j,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=x;class ae extends se{constructor(j,q){super(j,q),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$7g=ae;class ne extends M.$Rc{constructor(j,q){super(),this.g=j,this.h=q,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of j)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=O=>{(0,S.$B)(()=>{if(j)return;const q=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$9g=(O,j)=>{const q=requestIdleCallback(O,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(q))}}}}();class re{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(q){this.g=q}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=re;async function X(O,j,q){let W;for(let z=0;z<q;z++)try{return await O()}catch(G){W=G,await i(j)}throw W}e.$$g=X;class K{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,q,W){return this.a={taskId:j,cancel:()=>W?.(),promise:q},q.then(()=>this.d(j),()=>this.d(j)),q}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let q,W;const z=new Promise((G,ce)=>{q=G,W=ce});this.b={run:j,promise:z,promiseResolve:q,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=K;class V{constructor(j,q=()=>Date.now()){this.d=j,this.f=q,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$ah=V;var N;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(N||(N={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,q)=>{this.a=j,this.b=q})}complete(j){return new Promise(q=>{this.a(j),this.d={outcome:0,value:j},q()})}error(j){return new Promise(q=>{this.b(j),this.d={outcome:1,value:j},q()})}cancel(){return this.error(new D.$4)}}e.$bh=U;var H;(function(O){async function j(W){let z;const G=await Promise.all(W.map(ce=>ce.then(de=>de,de=>{z||(z=de)})));if(typeof z<"u")throw z;return G}O.settled=j;function q(W){return new Promise(async(z,G)=>{try{await W(z,G)}catch(ce){G(ce)}})}O.withAsyncBody=q})(H||(e.Promises=H={}));var J;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(J||(J={}));class ie{static fromArray(j){return new ie(q=>{q.emitMany(j)})}static fromPromise(j){return new ie(async q=>{q.emitMany(await j)})}static fromPromises(j){return new ie(async q=>{await Promise.all(j.map(async W=>q.emitOne(await W)))})}static merge(j){return new ie(async q=>{await Promise.all(j.map(async W=>{for await(const z of W)q.emitOne(z)}))})}static{this.EMPTY=ie.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Md,queueMicrotask(async()=>{const q={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(q)),this.j()}catch(W){this.k(W)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,q){return new ie(async W=>{for await(const z of j)W.emitOne(q(z))})}map(j){return ie.map(this,j)}static filter(j,q){return new ie(async W=>{for await(const z of j)q(z)&&W.emitOne(z)})}filter(j){return ie.filter(this,j)}static coalesce(j){return ie.filter(j,q=>!!q)}coalesce(){return ie.coalesce(this)}static async toPromise(j){const q=[];for await(const W of j)q.push(W);return q}toPromise(){return ie.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$ch=ie;class oe extends ie{constructor(j,q){super(q),this.l=j}cancel(){this.l.cancel()}}e.$dh=oe;function T(O){const j=new P.$Wd,q=O(j.token);return new oe(j,async W=>{const z=j.token.onCancellationRequested(()=>{z.dispose(),j.dispose(),W.reject(new D.$4)});try{for await(const G of q){if(j.token.isCancellationRequested)return;W.emitOne(G)}z.dispose(),j.dispose()}catch(G){z.dispose(),j.dispose(),W.reject(G)}})}e.$eh=T}),define(ee[104],te([0,1,23,8,33,31,9,4,27]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function a(){return Object.create(null)}e.$pj=a,e.$qj="**",e.$rj="/";const g="[/\\\\]",b="[^/\\\\]",p=/\//g;function d(K,V){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${g}|${b}+${g}${V?`|${g}${b}+`:""})*?`}}function y(K,V){if(!K)return[];const N=[];let U=!1,H=!1,J="";for(const ie of K){switch(ie){case V:if(!U&&!H){N.push(J),J="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":H=!0;break;case"]":H=!1;break}J+=ie}return J&&N.push(J),N}e.$sj=y;function w(K){if(!K)return"";let V="";const N=y(K,e.$rj);if(N.every(U=>U===e.$qj))V=".*";else{let U=!1;N.forEach((H,J)=>{if(H===e.$qj){if(U)return;V+=d(2,J===N.length-1)}else{let ie=!1,oe="",T=!1,O="";for(const j of H){if(j!=="}"&&ie){oe+=j;continue}if(T&&(j!=="]"||!O)){let q;j==="-"?q=j:(j==="^"||j==="!")&&!O?q="^":j===e.$rj?q="":q=(0,f.$Ee)(j),O+=q;continue}switch(j){case"{":ie=!0;continue;case"[":T=!0;continue;case"}":{const W=`(?:${y(oe,",").map(z=>w(z)).join("|")})`;V+=W,ie=!1,oe="";break}case"]":{V+="["+O+"]",T=!1,O="";break}case"?":V+=b;continue;case"*":V+=d(1);continue;default:V+=(0,f.$Ee)(j)}}J<N.length-1&&(N[J+1]!==e.$qj||J+2<N.length)&&(V+=g)}U=H===e.$qj})}return V}const $=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Cc(1e4),l=function(){return!1},r=function(){return null};function i(K,V){if(!K)return r;let N;typeof K!="string"?N=K.pattern:N=K,N=N.trim();const U=`${N}_${!!V.trimForExclusions}`;let H=t.get(U);if(H)return n(H,K);let J;return $.test(N)?H=v(N.substr(4),N):(J=m.exec(o(N,V)))?H=R(J[1],N):(V.trimForExclusions?c:h).test(N)?H=A(N,V):(J=k.exec(o(N,V)))?H=E(J[1].substr(1),N,!0):(J=u.exec(o(N,V)))?H=E(J[1],N,!1):H=I(N),t.set(U,H),n(H,K)}function n(K,V){if(typeof V=="string")return K;const N=function(U,H){return(0,s.$Wf)(U,V.base,!S.$l)?K((0,f.$Ie)(U.substr(V.base.length),C.sep),H):null};return N.allBasenames=K.allBasenames,N.allPaths=K.allPaths,N.basenames=K.basenames,N.patterns=K.patterns,N}function o(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function v(K,V){return function(N,U){return typeof N=="string"&&N.endsWith(K)?V:null}}function R(K,V){const N=`/${K}`,U=`\\${K}`,H=function(ie,oe){return typeof ie!="string"?null:oe?oe===K?V:null:ie===K||ie.endsWith(N)||ie.endsWith(U)?V:null},J=[K];return H.basenames=J,H.patterns=[V],H.allBasenames=J,H}function A(K,V){const N=re(K.slice(1,-1).split(",").map(oe=>i(oe,V)).filter(oe=>oe!==r),K),U=N.length;if(!U)return r;if(U===1)return N[0];const H=function(oe,T){for(let O=0,j=N.length;O<j;O++)if(N[O](oe,T))return K;return null},J=N.find(oe=>!!oe.allBasenames);J&&(H.allBasenames=J.allBasenames);const ie=N.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function E(K,V,N){const U=C.sep===C.$fc.sep,H=U?K:K.replace(p,C.sep),J=C.sep+H,ie=C.$fc.sep+K;let oe;return N?oe=function(T,O){return typeof T=="string"&&(T===H||T.endsWith(J)||!U&&(T===K||T.endsWith(ie)))?V:null}:oe=function(T,O){return typeof T=="string"&&(T===H||!U&&T===K)?V:null},oe.allPaths=[(N?"*/":"./")+K],oe}function I(K){try{const V=new RegExp(`^${w(K)}$`);return function(N){return V.lastIndex=0,typeof N=="string"&&V.test(N)?K:null}}catch{return r}}function L(K,V,N){return!K||typeof V!="string"?!1:F(K)(V,void 0,N)}e.$tj=L;function F(K,V={}){if(!K)return l;if(typeof K=="string"||B(K)){const N=i(K,V);if(N===r)return l;const U=function(H,J){return!!N(H,J)};return N.allBasenames&&(U.allBasenames=N.allBasenames),N.allPaths&&(U.allPaths=N.allPaths),U}return ae(K,V)}e.$uj=F;function B(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$vj=B;function se(K){return K.allBasenames||[]}e.$wj=se;function x(K){return K.allPaths||[]}e.$xj=x;function ae(K,V){const N=re(Object.getOwnPropertyNames(K).map(oe=>ne(oe,K[oe],V)).filter(oe=>oe!==r)),U=N.length;if(!U)return r;if(!N.some(oe=>!!oe.requiresSiblings)){if(U===1)return N[0];const oe=function(j,q){let W;for(let z=0,G=N.length;z<G;z++){const ce=N[z](j,q);if(typeof ce=="string")return ce;(0,D.$Fg)(ce)&&(W||(W=[]),W.push(ce))}return W?(async()=>{for(const z of W){const G=await z;if(typeof G=="string")return G}return null})():null},T=N.find(j=>!!j.allBasenames);T&&(oe.allBasenames=T.allBasenames);const O=N.reduce((j,q)=>q.allPaths?j.concat(q.allPaths):j,[]);return O.length&&(oe.allPaths=O),oe}const H=function(oe,T,O){let j,q;for(let W=0,z=N.length;W<z;W++){const G=N[W];G.requiresSiblings&&O&&(T||(T=(0,C.$mc)(oe)),j||(j=T.substr(0,T.length-(0,C.$nc)(oe).length)));const ce=G(oe,T,j,O);if(typeof ce=="string")return ce;(0,D.$Fg)(ce)&&(q||(q=[]),q.push(ce))}return q?(async()=>{for(const W of q){const z=await W;if(typeof z=="string")return z}return null})():null},J=N.find(oe=>!!oe.allBasenames);J&&(H.allBasenames=J.allBasenames);const ie=N.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function ne(K,V,N){if(V===!1)return r;const U=i(K,N);if(U===r)return r;if(typeof V=="boolean")return U;if(V){const H=V.when;if(typeof H=="string"){const J=(ie,oe,T,O)=>{if(!O||!U(ie,oe))return null;const j=H.replace("$(basename)",()=>T),q=O(j);return(0,D.$Fg)(q)?q.then(W=>W?K:null):q?K:null};return J.requiresSiblings=!0,J}}return U}function re(K,V){const N=K.filter(oe=>!!oe.basenames);if(N.length<2)return K;const U=N.reduce((oe,T)=>{const O=T.basenames;return O?oe.concat(O):oe},[]);let H;if(V){H=[];for(let oe=0,T=U.length;oe<T;oe++)H.push(V)}else H=N.reduce((oe,T)=>{const O=T.patterns;return O?oe.concat(O):oe},[]);const J=function(oe,T){if(typeof oe!="string")return null;if(!T){let j;for(j=oe.length;j>0;j--){const q=oe.charCodeAt(j-1);if(q===47||q===92)break}T=oe.substr(j)}const O=U.indexOf(T);return O!==-1?H[O]:null};J.basenames=U,J.patterns=H,J.allBasenames=U;const ie=K.filter(oe=>!oe.basenames);return ie.push(J),ie}function X(K,V){return(0,P.$tb)(K,V,(N,U)=>typeof N=="string"&&typeof U=="string"?N===U:typeof N!="string"&&typeof U!="string"?N.base===U.base&&N.pattern===U.pattern:!1)}e.$yj=X}),define(ee[46],te([0,1,23,33,9,4,19,27]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=void 0;function f(i,n){const{os:o,tildify:v,relative:R}=n;if(R){const I=a(i,R,o);if(typeof I=="string")return I}let A=i.fsPath;if(o===1&&!M.$j?A=A.replace(/\//g,"\\"):o!==1&&M.$j&&(A=A.replace(/\\/g,"/")),o!==1&&v?.userHome){const I=v.userHome.fsPath;let L;i.scheme!==v.userHome.scheme&&i.path.startsWith(s.$fc.sep)?L=v.userHome.with({path:i.path}).fsPath:L=i.fsPath,A=p(L,I,o)}return(o===1?s.$ec:s.$fc).normalize(g(A,o===1))}e.$lv=f;function a(i,n,o){const v=o===1?s.$ec:s.$fc,R=o===3?C.$kg:C.$mg,A=n.getWorkspace(),E=(0,P.$Nb)(A.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path.startsWith(s.$fc.sep)&&(i=E.uri.with({path:i.path}));const I=n.getWorkspaceFolder(i);if(!I)return;let L;if(R.isEqual(I.uri,i)?L="":L=R.relativePath(I.uri,i)??"",L&&(L=v.normalize(L)),A.folders.length>1&&!n.noPrefix){const F=I.name?I.name:R.basenameOrAuthority(I.uri);L=L?`${F} \u2022 ${L}`:F}return L}function g(i,n=M.$j){return(0,D.$1f)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$mv=g;let b=Object.create(null);function p(i,n,o=M.OS){if(o===1||!i||!n)return i;let v=b.original===n?b.normalized:void 0;v||(v=n,M.$j&&(v=(0,D.$Qf)(v)),v=`${(0,S.$Je)(v,s.$fc.sep)}${s.$fc.sep}`,b={original:n,normalized:v});let R=i;return M.$j&&(R=(0,D.$Qf)(R)),(o===3?R.startsWith(v):(0,S.$2e)(R,v))?`~/${R.substr(v.length)}`:i}e.$nv=p;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$ov=d;const y="\u2026",w="\\\\",$="~";function m(i,n=s.sep){const o=new Array(i.length);let v=!1;for(let R=0;R<i.length;R++){const A=i[R];if(A===""){o[R]=`.${n}`;continue}if(!A){o[R]=A;continue}v=!0;let E="",I=A;I.indexOf(w)===0?(E=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length)):I.indexOf(n)===0?(E=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf($)===0&&(E=I.substr(0,I.indexOf($)+$.length),I=I.substr(I.indexOf($)+$.length));const L=I.split(n);for(let F=1;v&&F<=L.length;F++)for(let B=L.length-F;v&&B>=0;B--){v=!1;let se=L.slice(B,B+F).join(n);for(let x=0;!v&&x<i.length;x++)if(x!==R&&i[x]&&i[x].indexOf(se)>-1){const ae=B+F===L.length,ne=B>0&&i[x].indexOf(n)>-1?n+se:se,re=i[x].endsWith(ne);v=!ae||re}if(!v){let x="";(L[0].endsWith(":")||E!=="")&&(B===1&&(B=0,F++,se=L[0]+n+se),B>0&&(x=L[0]+n),x=E+x),B>0&&(x=x+y+n),x=x+se,B+F<L.length&&(x=x+n+y),o[R]=x}}v&&(o[R]=A)}return o}e.$pv=m;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function c(i,n=Object.create(null)){const o=[];let v=!1,R="";for(const A of i)if(A==="$"||v&&A==="{")R&&o.push({value:R,type:h.TEXT}),R="",v=!0;else if(A==="}"&&v){const E=n[R];if(typeof E=="string")E.length&&o.push({value:E,type:h.VARIABLE});else if(E){const I=o[o.length-1];(!I||I.type!==h.SEPARATOR)&&o.push({value:E.label,type:h.SEPARATOR})}R="",v=!1}else R+=A;return R&&!v&&o.push({value:R,type:h.TEXT}),o.filter((A,E)=>{if(A.type===h.SEPARATOR){const I=o[E-1],L=o[E+1];return[I,L].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(A=>A.value).join("")}e.$qv=c;function k(i,n){return M.$k||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$rv=k;function u(i,n){return M.$k||n?i.replace(/\(&&\w\)|&&/g,""):M.$j?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$sv=u;function t(i){return i.replace(/&/g,"&&")}e.$tv=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$uv=l;function r(i){const n=i.indexOf("/")!==-1?s.$fc:s.$ec,o=n.basename(i),v=n.dirname(i);return o.length?{name:o,parentPath:v}:{name:v,parentPath:""}}}),define(ee[153],te([0,1,18,7]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function s(b){return b.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:s(D.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:s(D.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:D.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Hm=M,e.$Im=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,p,d){if(!b||d>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return p.transformOutgoing(b);for(const y in b)if(Object.hasOwnProperty.call(b,y)){const w=C(b[y],p,d+1);w!==null&&(b[y]=w)}}return null}function S(b,p){const d=C(b,p,0);return d===null?b:d}e.$Jm=S;function f(b,p,d,y){if(!b||y>200)return null;if(typeof b=="object"){if(b.$mid===1)return d?D.URI.revive(p.transformIncoming(b)):p.transformIncoming(b);if(b instanceof P.$ae)return null;for(const w in b)if(Object.hasOwnProperty.call(b,w)){const $=f(b[w],p,d,y+1);$!==null&&(b[w]=$)}}return null}function a(b,p){const d=f(b,p,!1,0);return d===null?b:d}e.$Km=a;function g(b,p){const d=f(b,p,!0,0);return d===null?b:d}e.$Lm=g}),define(ee[21],te([0,1,45,28,154,8,33,84,9,4,19,7]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function d(ne,re=p.UNLINK,X){if((0,C.$Zf)(ne))throw new Error("rimraf - will refuse to recursively delete root");return re===p.UNLINK?w(ne):y(ne,X)}async function y(ne,re=(0,C.$5f)((0,D.tmpdir)())){try{try{await P.promises.rename(ne,re)}catch(X){return X.code==="ENOENT"?void 0:w(ne)}w(re).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function w(ne){return(0,s.promisify)(P.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function $(ne){if((0,C.$Zf)(ne))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function m(ne,re){return k(await(re?h(ne):(0,s.promisify)(P.readdir)(ne)))}async function h(ne){try{return await(0,s.promisify)(P.readdir)(ne,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const re=[],X=await m(ne);for(const K of X){let V=!1,N=!1,U=!1;try{const H=await e.Promises.lstat((0,f.$ic)(ne,K));V=H.isFile(),N=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}re.push({name:K,isFile:()=>V,isDirectory:()=>N,isSymbolicLink:()=>U})}return re}function c(ne){return k(P.readdirSync(ne))}e.readdirSync=c;function k(ne){return ne.map(re=>typeof re=="string"?a.$k?(0,S.$kl)(re):re:(re.name=a.$k?(0,S.$kl)(re.name):re.name,re))}async function u(ne){const re=await m(ne),X=[];for(const K of re)await l.existsDirectory((0,f.$ic)(ne,K))&&X.push(K);return X}function t(ne,re=1e3){return new Promise(X=>{let K=!1;const V=setInterval(()=>{K||(K=!0,P.access(ne,N=>{K=!1,N&&(clearInterval(V),X(void 0))}))},re)})}e.whenDeleted=t;var l;(function(ne){async function re(V){let N;try{if(N=await e.Promises.lstat(V),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(a.$j&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw U}}ne.stat=re;async function X(V){try{const{stat:N,symbolicLink:U}=await ne.stat(V);return N.isFile()&&U?.dangling!==!0}catch{}return!1}ne.existsFile=X;async function K(V){try{const{stat:N,symbolicLink:U}=await ne.stat(V);return N.isDirectory()&&U?.dangling!==!0}catch{}return!1}ne.existsDirectory=K})(l||(e.SymlinkSupport=l={}));const r=new M.$2g;function i(ne,re,X){return r.queueFor(b.URI.file(ne),g.$lg).queue(()=>{const K=A(X);return new Promise((V,N)=>v(ne,re,K,U=>U?N(U):V()))})}let n=!0;function o(ne){n=ne}e.configureFlushOnWrite=o;function v(ne,re,X,K){if(!n)return P.writeFile(ne,re,{mode:X.mode,flag:X.flag},K);P.open(ne,X.flag,X.mode,(V,N)=>{if(V)return K(V);P.writeFile(N,re,U=>{if(U)return P.close(N,()=>K(U));P.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),P.close(N,J=>K(J))))})})}function R(ne,re,X){const K=A(X);if(!n)return P.writeFileSync(ne,re,{mode:K.mode,flag:K.flag});const V=P.openSync(ne,K.flag,K.mode);try{P.writeFileSync(V,re);try{P.fdatasyncSync(V)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),o(!1)}}finally{P.closeSync(V)}}e.writeFileSync=R;function A(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function E(ne,re,X=6e4){if(ne!==re)try{a.$j&&typeof X=="number"?await I(ne,re,Date.now(),X):await(0,s.promisify)(P.rename)(ne,re)}catch(K){if(ne.toLowerCase()!==re.toLowerCase()&&K.code==="EXDEV"||ne.endsWith("."))await L(ne,re,{preserveSymlinks:!1}),await d(ne,p.MOVE);else throw K}}async function I(ne,re,X,K,V=0){try{return await(0,s.promisify)(P.rename)(ne,re)}catch(N){if(N.code!=="EACCES"&&N.code!=="EPERM"&&N.code!=="EBUSY")throw N;if(Date.now()-X>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${N}`),N;if(V===0){let U=!1;try{const{stat:H}=await l.stat(re);H.isFile()||(U=!0)}catch{}if(U)throw N}return await(0,M.$Tg)(Math.min(100,V*10)),I(ne,re,X,K,V+1)}}async function L(ne,re,X){return B(ne,re,{root:{source:ne,target:re},options:X,handledSourcePaths:new Set})}const F=511;async function B(ne,re,X){if(X.handledSourcePaths.has(ne))return;X.handledSourcePaths.add(ne);const{stat:K,symbolicLink:V}=await l.stat(ne);if(V){if(X.options.preserveSymlinks)try{return await ae(ne,re,X)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(V.dangling)return}return K.isDirectory()?se(ne,re,K.mode&F,X):x(ne,re,K.mode&F)}async function se(ne,re,X,K){await e.Promises.mkdir(re,{recursive:!0,mode:X});const V=await m(ne);for(const N of V)await B((0,f.$ic)(ne,N),(0,f.$ic)(re,N),K)}async function x(ne,re,X){await e.Promises.copyFile(ne,re),await e.Promises.chmod(re,X)}async function ae(ne,re,X){let K=await e.Promises.readlink(ne);(0,C.$Wf)(K,X.root.source,!a.$l)&&(K=(0,f.$ic)(X.root.target,K.substr(X.root.source.length+1))),await e.Promises.symlink(K,re)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ne,re,X,K,V)=>new Promise((N,U)=>{P.read(ne,re,X,K,V,(H,J,ie)=>H?U(H):N({bytesRead:J,buffer:ie}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ne,re,X,K,V)=>new Promise((N,U)=>{P.write(ne,re,X,K,V,(H,J,ie)=>H?U(H):N({bytesWritten:J,buffer:ie}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return d}get rename(){return E}get copy(){return L}}}),define(ee[105],te([0,1,45,9,4,27,21]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=void 0;function S(p){if(s.$l)return p;const d=(0,D.$lc)(p);if(p===d)return p;const y=((0,D.$mc)(p)||p).toLowerCase();try{const $=(0,C.readdirSync)(d).filter(m=>m.toLowerCase()===y);if($.length===1){const m=S(d);if(m)return(0,D.$ic)(m,$[0])}else if($.length>1){const m=$.indexOf(y);if(m>=0){const h=S(d);if(h)return(0,D.$ic)(h,$[m])}}}catch{}return null}e.$1p=S;async function f(p){if(s.$l)return p;const d=(0,D.$lc)(p);if(p===d)return p;const y=((0,D.$mc)(p)||p).toLowerCase();try{const $=(await C.Promises.readdir(d)).filter(m=>m.toLowerCase()===y);if($.length===1){const m=await f(d);if(m)return(0,D.$ic)(m,$[0])}else if($.length>1){const m=$.indexOf(y);if(m>=0){const h=await f(d);if(h)return(0,D.$ic)(h,$[m])}}}catch{}return null}e.$2p=f;async function a(p){try{return await C.Promises.realpath(p)}catch{const y=b(p);return await C.Promises.access(y,P.constants.R_OK),y}}e.$3p=a;function g(p){try{return P.realpathSync(p)}catch{const y=b(p);return P.accessSync(y,P.constants.R_OK),y}}e.$4p=g;function b(p){return(0,M.$Je)((0,D.$gc)(p),D.sep)}}),define(ee[106],te([0,1,28,9,21]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class b{constructor(u,t,l){this.exePath=u,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:k=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:k});if(!t)return null;const l=D.$ic(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const v of await s.Promises.readdir(l)){let R=-1;if(u){const E=v.indexOf("-");if(E<0)continue;const I=v.substring(0,E);if(!M.test(I)||v.substring(E+1)!=="preview")continue;R=parseInt(I,10)}else{if(!M.test(v))continue;R=parseInt(v,10)}if(R<=r)continue;const A=D.$ic(l,v,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(i=A,r=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=u?" Preview":"";return new b(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=k?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(t.test(r)){const i=D.$ic(u,r,"pwsh.exe");return new b(i,l)}return null}function w(){const k=D.$ic(P.homedir(),".dotnet","tools","pwsh.exe");return new b(k,".NET Core PowerShell Global Tool")}function $(){const k=D.$ic(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(k,"Windows PowerShell",!0)}async function*m(){let k=await d();k&&(yield k),k=await d({useAlternateBitness:!0}),k&&(yield k),k=await y(),k&&(yield k),k=w(),k&&(yield k),k=await d({findPreview:!0}),k&&(yield k),k=await y({findPreview:!0}),k&&(yield k),k=await d({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=$(),k&&(yield k)}async function*h(){for await(const k of m())await k.exists()&&(yield k)}e.$tl=h;async function c(){for await(const k of h())return k;return null}e.$ul=c}),define(ee[88],te([0,1,9,4,35,73,12,21]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(b=s.env){return b.comspec||"cmd.exe"}e.$xl=f;function a(b){let p=[],d=!1;const y=function(w){if(d){p.push(w);return}(!b.send(w,m=>{if(m&&console.error(m),d=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(c=>y(c))}})||D.$j)&&(d=!0)};return{send:y}}e.$yl=a;var g;(function(b){async function p(d,y,w){if(P.$hc(d))return d;if(y===void 0&&(y=s.cwd()),P.$lc(d)!=="."||(w===void 0&&C.$xf(s.env.PATH)&&(w=s.env.PATH.split(P.$sc)),w===void 0||w.length===0))return P.$ic(y,d);async function m(h){if(await S.Promises.exists(h)){let c;try{c=await S.Promises.stat(h)}catch(k){k.message.startsWith("EACCES")&&(c=await S.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(const h of w){let c;if(P.$hc(h)?c=P.$ic(h,d):c=P.$ic(y,h,d),await m(c))return c;let k=c+".com";if(await m(k)||(k=c+".exe",await m(k)))return k}return P.$ic(y,d)}b.findExecutable=p})(g||(e.win32=g={}))}),define(ee[107],te([0,1,47,13]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;function s(C){return new Promise((S,f)=>{let a;const g=new Map;function b(d,y,w,$,m){const h=g.get(y);if(d===C||h){const c={name:p(w),cmd:w,pid:d,ppid:y,load:$,mem:m};g.set(d,c),d===C&&(a=c),h&&(h.children||(h.children=[]),h.children.push(c),h.children.length>1&&(h.children=h.children.sort((k,u)=>k.pid-u.pid)))}}function p(d){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if($.exec(d))return"electron-crash-reporter";if(m.exec(d))return"winpty-agent";if(h.exec(d))return"conpty-agent";let k=c.exec(d);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?y.exec(d)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const u=/[a-zA-Z-]+\.js/g;let t="";do k=u.exec(d),k&&(t+=k+" ");while(k);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{Z(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(C,w=>{if(!w){f(new Error(`Root process ${C} not found`));return}y.getProcessCpuUsage(w,$=>{const m=new Map;$.forEach(h=>{const c=d(h.commandLine||"");m.set(h.pid,{name:p(c),cmd:c,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),a=m.get(C),a?(m.forEach(h=>{const c=m.get(h.ppid);c&&(c.children||(c.children=[]),c.children.push(h))}),m.forEach(h=>{h.children&&(h.children=h.children.sort((c,k)=>c.pid-k.pid))}),S(a)):f(new Error(`Root process ${C} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let d=function(){let y=[a];const w=[];for(;y.length;){const m=y.shift();m&&(w.push(m.pid),m.children&&(y=y.concat(m.children)))}let $=JSON.stringify(D.$bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+w.join(" "),(0,P.exec)($,{},(m,h,c)=>{if(m||c)f(m||new Error(c.toString()));else{const k=h.toString().split(`
`);for(let u=0;u<w.length;u++){const t=g.get(w[u]);t.load=parseFloat(k[u])}if(!a){f(new Error(`Root process ${C} not found`));return}S(a)}})};(0,P.exec)("which ps",{},(y,w,$)=>{if(y||$)if(process.platform!=="linux")f(y||new Error($.toString()));else{const m=JSON.stringify(D.$bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(m,{},(h,c,k)=>{h||k?f(h||new Error(k.toString())):(M(c,b),d())})}else{const m=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${m} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,k,u)=>{c||u&&!u.includes("screen size is bogus")?f(c||new Error(u.toString())):(M(k,b),process.platform==="linux"?d():a?S(a):f(new Error(`Root process ${C} not found`)))})}})}})}e.$yr=s;function M(C,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const g of a){const b=f.exec(g.trim());b&&b.length===6&&S(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ee[108],te([0,1,28,4,106,88]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;async function C(b,p){return b===1?D.$j?g():M.$xl(p):f(b,p)}e.$zl=C;let S=null;function f(b,p){if(D.$l&&b===2||D.$k&&b===3)return"/bin/bash";if(!S){let d;if(D.$j)d="/bin/bash";else{if(d=p.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}S=d}return S}let a=null;async function g(){return a||(a=(await(0,s.$ul)()).exePath),a}});var ke=this&&this.__decorate||function(Z,e,P,D){var s=arguments.length,M=s<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,P):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Z,e,P,D);else for(var S=Z.length-1;S>=0;S--)(C=Z[S])&&(M=(s<3?C(M):s>3?C(e,P,M):C(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(ee[42],te([0,1,23,8,18,22,54,14,3,2,74,27,12]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var d;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(d||(d={}));function y(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w||(w={}));function $(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));function h(V){let N=0;for(let U=0;;U+=7){const H=V.read(1);if(N|=(H.buffer[0]&127)<<U,!(H.buffer[0]&128))return N}}const c=r(0);function k(V,N){if(N===0){V.write(c);return}let U=0;for(let J=N;J!==0;J=J>>>7)U++;const H=s.$ae.alloc(U);for(let J=0;N!==0;J++)H.buffer[J]=N&127,N=N>>>7,N>0&&(H.buffer[J]|=128);V.write(H)}class u{constructor(N){this.b=N,this.a=0}read(N){const U=this.b.slice(this.a,this.a+N);return this.a+=U.byteLength,U}}e.$lh=u;class t{constructor(){this.a=[]}get buffer(){return s.$ae.concat(this.a)}write(N){this.a.push(N)}}e.$mh=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function r(V){const N=s.$ae.alloc(1);return N.writeUInt8(V,0),N}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function o(V,N){if(typeof N>"u")V.write(i.Undefined);else if(typeof N=="string"){const U=s.$ae.fromString(N);V.write(i.String),k(V,U.byteLength),V.write(U)}else if(n&&Buffer.isBuffer(N)){const U=s.$ae.wrap(N);V.write(i.Buffer),k(V,U.byteLength),V.write(U)}else if(N instanceof s.$ae)V.write(i.VSBuffer),k(V,N.byteLength),V.write(N);else if(Array.isArray(N)){V.write(i.Array),k(V,N.length);for(const U of N)o(V,U)}else if(typeof N=="number"&&(N|0)===N)V.write(i.Uint),k(V,N);else{const U=s.$ae.fromString(JSON.stringify(N));V.write(i.Object),k(V,U.byteLength),V.write(U)}}e.$nh=o;function v(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(h(V)).toString();case l.Buffer:return V.read(h(V)).buffer;case l.VSBuffer:return V.read(h(V));case l.Array:{const U=h(V),H=[];for(let J=0;J<U;J++)H.push(v(V));return H}case l.Object:return JSON.parse(V.read(h(V)).toString());case l.Int:return h(V)}}e.$oh=v;class R{constructor(N,U,H=null,J=1e3){this.h=N,this.j=U,this.k=H,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(N,U){this.b.set(N,U),setTimeout(()=>this.w(N),0)}m(N){switch(N.type){case 200:{const U=this.o([N.type]);this.k?.logOutgoing(U,0,1,$(N.type));return}case 201:case 202:case 204:case 203:{const U=this.o([N.type,N.id],N.data);this.k?.logOutgoing(U,N.id,1,$(N.type),N.data);return}}}o(N,U=void 0){const H=new t;return o(H,N),o(H,U),this.p(H.buffer)}p(N){try{return this.h.send(N),N.byteLength}catch{return 0}}q(N){const U=new u(N),H=v(U),J=v(U),ie=H[0];switch(ie){case 100:return this.k?.logIncoming(N.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,J),this.s({type:ie,id:H[1],channelName:H[2],name:H[3],arg:J});case 102:return this.k?.logIncoming(N.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,J),this.t({type:ie,id:H[1],channelName:H[2],name:H[3],arg:J});case 101:return this.k?.logIncoming(N.byteLength,H[1],1,`${y(ie)}`),this.u({type:ie,id:H[1]});case 103:return this.k?.logIncoming(N.byteLength,H[1],1,`${y(ie)}`),this.u({type:ie,id:H[1]})}}s(N){const U=this.b.get(N.channelName);if(!U){this.v(N);return}const H=new M.$Wd;let J;try{J=U.call(this.j,N.name,N.arg,H.token)}catch(T){J=Promise.reject(T)}const ie=N.id;J.then(T=>{this.m({id:ie,data:T,type:201})},T=>{T instanceof Error?this.m({id:ie,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:ie,data:T,type:203})}).finally(()=>{oe.dispose(),this.d.delete(N.id)});const oe=(0,a.$Pc)(()=>H.cancel());this.d.set(N.id,oe)}t(N){const U=this.b.get(N.channelName);if(!U){this.v(N);return}const H=N.id,ie=U.listen(this.j,N.name,N.arg)(oe=>this.m({id:H,data:oe,type:204}));this.d.set(N.id,ie)}u(N){const U=this.d.get(N.id);U&&(U.dispose(),this.d.delete(N.id))}v(N){let U=this.g.get(N.channelName);U||(U=[],this.g.set(N.channelName,U));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.m({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:N,timeoutTimer:H})}w(N){const U=this.g.get(N);if(U){for(const H of U)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(N)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$ph=R;var A;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class E{constructor(N,U=null){this.l=N,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=U}getChannel(N){const U=this;return{call(H,J,ie){return U.a?Promise.reject(new S.$4):U.m(N,H,J,ie)},listen(H,J){return U.a?f.Event.None:U.o(N,H,J)}}}m(N,U,H,J=M.CancellationToken.None){const ie=this.g++,T={id:ie,type:100,channelName:N,name:U,arg:H};if(J.isCancellationRequested)return Promise.reject(new S.$4);let O;return new Promise((q,W)=>{if(J.isCancellationRequested)return W(new S.$4);const z=()=>{const ue=fe=>{switch(fe.type){case 201:this.f.delete(ie),q(fe.data);break;case 202:{this.f.delete(ie);const ye=new Error(fe.data.message);ye.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ye.name=fe.data.name,W(ye);break}case 203:this.f.delete(ie),W(fe.data);break}};this.f.set(ie,ue),this.p(T)};let G=null;this.b===m.Idle?z():(G=(0,D.$Gg)(ue=>this.u()),G.then(()=>{G=null,z()}));const ce=()=>{G?(G.cancel(),G=null):this.p({id:ie,type:101}),W(new S.$4)},de=J.onCancellationRequested(ce);O=(0,a.$Oc)((0,a.$Pc)(ce),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(N,U,H){const J=this.g++,oe={id:J,type:102,channelName:N,name:U,arg:H};let T=null;const O=new f.$Md({onWillAddFirstListener:()=>{T=(0,D.$Gg)(q=>this.u()),T.then(()=>{T=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(O),this.p({id:J,type:103}))}}),j=q=>O.fire(q.data);return this.f.set(J,j),O.event}p(N){switch(N.type){case 100:case 102:{const U=this.q([N.type,N.id,N.channelName,N.name],N.arg);this.j?.logOutgoing(U,N.id,0,`${y(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const U=this.q([N.type,N.id]);this.j?.logOutgoing(U,N.id,0,y(N.type));return}}}q(N,U=void 0){const H=new t;return o(H,N),o(H,U),this.r(H.buffer)}r(N){try{return this.l.send(N),N.byteLength}catch{return 0}}s(N){const U=new u(N),H=v(U),J=v(U),ie=H[0];switch(ie){case 200:return this.j?.logIncoming(N.byteLength,0,0,$(ie)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(N.byteLength,H[1],0,$(ie),J),this.t({type:H[0],id:H[1],data:J})}}t(N){if(N.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(N.id)?.(N)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$qh=E,ke([C.$fh],E.prototype,"onDidInitializePromise",null);class I{get connections(){const N=[];return this.f.forEach(U=>N.push(U)),N}constructor(N){this.a=new Map,this.f=new Set,this.g=new f.$Md,this.onDidAddConnection=this.g.event,this.h=new f.$Md,this.onDidRemoveConnection=this.h.event,this.j=new a.$Qc,this.j.add(N(({protocol:U,onDidClientDisconnect:H})=>{const J=f.Event.once(U.onMessage);this.j.add(J(ie=>{const oe=new u(ie),T=v(oe),O=new R(U,T),j=new E(U);this.a.forEach((W,z)=>O.registerChannel(z,W));const q={channelServer:O,channelClient:j,ctx:T};this.f.add(q),this.g.fire(q),this.j.add(H(()=>{O.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(N,U){const H=this;return{call(J,ie,oe){let T;if((0,p.$Lf)(U)){const j=(0,P.$3b)(H.connections.filter(U));T=j?Promise.resolve(j):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,U))}else T=U.routeCall(H,J,ie);const O=T.then(j=>j.channelClient.getChannel(N));return F(O).call(J,ie,oe)},listen(J,ie){if((0,p.$Lf)(U))return H.k(N,U,J,ie);const oe=U.routeEvent(H,J,ie).then(T=>T.channelClient.getChannel(N));return F(oe).listen(J,ie)}}}k(N,U,H,J){const ie=this;let oe;const T=new f.$Md({onWillAddFirstListener:()=>{oe=new a.$Qc;const O=new f.$Sd,j=new Map,q=z=>{const ce=z.channelClient.getChannel(N).listen(H,J),de=O.add(ce);j.set(z,de)},W=z=>{const G=j.get(z);G&&(G.dispose(),j.delete(z))};ie.connections.filter(U).forEach(q),f.Event.filter(ie.onDidAddConnection,U)(q,void 0,oe),ie.onDidRemoveConnection(W,void 0,oe),O.event(T.fire,T,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return T.event}registerChannel(N,U){this.a.set(N,U);for(const H of this.f)H.channelServer.registerChannel(N,U)}dispose(){this.j.dispose();for(const N of this.f)N.channelClient.dispose(),N.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=I;class L{constructor(N,U,H=null){const J=new t;o(J,U),N.send(J.buffer),this.a=new E(N,H),this.d=new R(N,U,H)}getChannel(N){return this.a.getChannel(N)}registerChannel(N,U){this.d.registerChannel(N,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=L;function F(V){return{call(N,U,H){return V.then(J=>J.call(N,U,H))},listen(N,U){const H=new f.$Vd;return V.then(J=>H.input=J.listen(N,U)),H.event}}}e.$th=F;function B(V){let N=!1;return{call(U,H,J){return N?V.call(U,H,J):(0,D.$Tg)(0).then(()=>N=!0).then(()=>V.call(U,H,J))},listen(U,H){if(N)return V.listen(U,H);const J=new f.$Vd;return(0,D.$Tg)(0).then(()=>N=!0).then(()=>J.input=V.listen(U,H)),J.event}}}e.$uh=B;class se{constructor(N){this.a=N}routeCall(N){return this.b(N)}routeEvent(N){return this.b(N)}async b(N){for(const U of N.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await f.Event.toPromise(N.onDidAddConnection),await this.b(N)}}e.$vh=se;var x;(function(V){function N(ie,oe,T){const O=ie,j=T&&T.disableMarshalling,q=new Map;for(const W in O)H(W)&&q.set(W,f.Event.buffer(O[W],!0,void 0,oe));return new class{listen(W,z,G){const ce=q.get(z);if(ce)return ce;if(J(z)){const de=O[z];if(typeof de=="function")return de.call(O,G)}throw new S.$ab(`Event not found: ${z}`)}call(W,z,G){const ce=O[z];if(typeof ce=="function"){if(!j&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,g.$kh)(G[ue]);let de=ce.apply(O,G);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new S.$ab(`Method not found: ${z}`)}}}V.fromService=N;function U(ie,oe){const T=oe&&oe.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return oe?.properties?.has(j)?oe.properties.get(j):J(j)?function(q){return ie.listen(j,q)}:H(j)?ie.listen(j):async function(...q){let W;oe&&!(0,p.$Gf)(oe.context)?W=[oe.context,...q]:W=q;const z=await ie.call(j,W);return T?z:(0,g.$kh)(z)};throw new S.$ab(`Property not found: ${String(j)}`)}})}V.toService=U;function H(ie){return ie[0]==="o"&&ie[1]==="n"&&b.$Ze(ie.charCodeAt(2))}function J(ie){return/^onDynamic/.test(ie)&&b.$Ze(ie.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const N=V.toString();if(N!=="[object Object]")return N}return V}function re(V){return Array.isArray(V)?V.map(ne):ne(V)}function X(V,N,U,H,J,ie,oe){oe=re(oe);const T=ae[J],O=T[H%T.length];let j=[`%c[${V}]%c[${String(N).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ie)?(j=j.concat(oe),j.push(")")):j.push(oe),console.log.apply(console,j)}class K{constructor(N,U){this.d=N,this.f=U,this.a=0,this.b=0}logOutgoing(N,U,H,J,ie){this.b+=N,X(this.d,this.b,N,U,H,J,ie)}logIncoming(N,U,H,J,ie){this.a+=N,X(this.f,this.a,N,U,H,J,ie)}}e.$wh=K}),define(ee[155],te([0,1,18,3,42]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=e.$dT=void 0;class M{constructor(f){this.a=f,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",a=>P.$ae.wrap(a.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$dT=M;class C extends s.$sh{constructor(f,a){const g=new M(f);super(g,a),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$eT=C}),define(ee[109],te([0,1,18,3,2,42]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function v(A,E){if(!n.has(A)){const I=String(++o);n.set(A,I)}return n.get(A)}function R(A,E,I,L){if(!i.enableDiagnostics)return;const F=v(A,E);if(L instanceof P.$ae||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const B=P.$ae.alloc(L.byteLength);B.set(L),i.records.push({timestamp:Date.now(),id:F,label:E,type:I,buff:B})}else i.records.push({timestamp:Date.now(),id:F,label:E,type:I,data:L})}i.traceSocketEvent=R})(S||(e.SocketDiagnostics=S={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let a=null;function g(){return a||(a=P.$ae.alloc(0)),a}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return o&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const v=P.$ae.alloc(n);let R=0,A=0;for(;n>0;){const E=this.a[A];if(E.byteLength>n){const I=E.slice(0,n);v.set(I,R),R+=n,o&&(this.a[A]=E.slice(n),this.b-=n),n-=n}else v.set(E,R),R+=E.byteLength,o?(this.a.shift(),this.b-=E.byteLength):A++,n-=E.byteLength}return v}}e.$xh=b;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,o,v,R){this.type=n,this.id=o,this.ack=v,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Rc{constructor(n){super(),this.f=this.B(new D.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,R=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new w(v,R,A,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$ae.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const v=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,v}h(){const n=P.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Rc{constructor(n){super(),this.f=new D.$Md,this.onMessage=this.f.event,this.g=new D.$Md,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new m(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$yh=h;class c extends M.$sh{static fromSocket(n,o){return new c(new h(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,v=null){super(n,o,v),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$zh=c;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ah=k;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,v=this.a;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<l.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=l.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+l.a)*1e3;let v=0;for(let R=0;R<l.a;R++)n-this.c[R]<=o&&v++;return 1-v/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,g());this.p.write(n)}sendResume(){const n=new w(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,g());this.p.write(n);const o=this.b.toArray();for(let v=0,R=o.length;v<R;v++)this.p.write(o[v]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new w(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let v=0,R=o.length;v<R;v++)this.p.write(o[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const v=new w(1,o,this.h,n);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(n){const o=new w(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,v=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(o>=2e4&&v>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:v});return}const A=Math.max(2e4-o,2e4-v,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,g());this.p.write(n)}}e.$Bh=r}),define(ee[38],te([0,1,15,14,13]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aT=void 0;class M{constructor(){this.a=new WeakMap}on(S,f){const a=(g,...b)=>{this.b(S,g)&&f(g,...b)};return this.a.set(f,a),P.ipcMain.on(S,a),this}once(S,f){return P.ipcMain.once(S,(a,...g)=>{this.b(S,a)&&f(a,...g)}),this}handle(S,f){return P.ipcMain.handle(S,(a,...g)=>this.b(S,a)?f(a,...g):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,f){const a=this.a.get(f);return a&&(P.ipcMain.removeListener(S,a),this.a.delete(f)),this}b(S,f){if(!S||!S.startsWith("vscode:"))return(0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const a=f.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let b="unknown";try{b=new URL(g).host}catch{return(0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${g}'.`),!1}return b!==s.$ag?((0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${b}'.`),!1):a.parent!==null?((0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$aT=new M}),define(ee[156],te([0,1,15,38,144]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bT=void 0;function M(){D.$aT.on(s.$$S,(S,f,a,g,b)=>{const p=C(S,g,a);p.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{p&&S.sender.send(s.$_S,f)}})})}e.$bT=M;function C(S,f,a){const g=new P.Menu;return a.forEach(b=>{let p;b.type==="separator"?p=new P.MenuItem({type:b.type}):Array.isArray(b.submenu)?p=new P.MenuItem({submenu:C(S,f,b.submenu),label:b.label}):p=new P.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(d,y,w)=>S.sender.send(f,b.id,w)}),g.append(p)}),g}}),define(ee[157],te([0,1,38,18,3,2,42,145]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=void 0;function f(g,b){const p=s.Event.fromNodeEventEmitter(P.$aT,b,(y,w)=>({event:y,message:w})),d=s.Event.filter(p,({event:y})=>y.sender.id===g);return s.Event.map(d,({message:y})=>y&&D.$ae.wrap(y))}class a extends C.$rh{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(P.$aT,"vscode:hello",({sender:p})=>p);return s.Event.map(b,p=>{const d=p.id;a.b.get(d)?.dispose();const w=new s.$Md;a.b.set(d,(0,M.$Pc)(()=>w.fire()));const $=f(d,"vscode:message"),m=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),w.event);return{protocol:new S.$gT(p,$),onDidClientDisconnect:m}})}constructor(){super(a.d())}}e.$hT=a}),define(ee[110],te([0,1,38,3,32,155]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=e.$iT=void 0;class C extends M.$eT{constructor(a,g){super({addEventListener:(b,p)=>a.addListener(b,p),removeEventListener:(b,p)=>a.removeListener(b,p),postMessage:b=>a.postMessage(b),start:()=>a.start(),close:()=>a.close()},g)}}e.$iT=C;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$dg)();f.webContents.send("vscode:createMessageChannel",a);const g=D.Event.fromNodeEventEmitter(P.$aT,"vscode:createMessageChannelResult",(p,d)=>({nonce:d,port:p.ports[0]})),{port:b}=await D.Event.toPromise(D.Event.once(D.Event.filter(g,p=>p.nonce===a)));return b}e.$jT=S}),define(ee[158],te([0,1,47,8,18,22,152,14,3,2,37,88,73,42]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class y extends d.$ph{constructor(m){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$ae.wrap(Buffer.from(h,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$Xp=y;class w{constructor(m,h){this.i=m,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Md,this.onDidProcessExit=this.h.event;const c=h&&h.timeout?h.timeout:6e4;this.b=new D.$Pg(c),this.d=null,this.f=null}getChannel(m){const h=this;return{call(c,k,u){return h.k(m,c,k,u)},listen(c,k){return h.l(m,c,k)}}}k(m,h,c,k=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(S.$5());this.b.cancel();const u=this.n(m),t=(0,D.$Gg)(i=>u.call(h,c,i)),l=k.onCancellationRequested(()=>t.cancel()),r=(0,a.$Pc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(m,h,c){if(!this.b)return f.Event.None;this.b.cancel();let k;const u=new f.$Md({onWillAddFirstListener:()=>{k=this.n(m).listen(h,c)(u.fire,u),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,g.$2m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$wl)(h.env),this.d=(0,P.fork)(this.i,m,h);const c=new f.$Md;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$Tp)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(s.$ae.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,b.$yl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),l=c.event,r={send:t,onMessage:l};this.f=new d.$qh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(v=>(0,a.$Mc)(v)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(m){let h=this.g.get(m);return h||(h=this.m.getChannel(m),this.g.set(m,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Yp=w}),define(ee[111],te([0,1,8,3,2,74,12]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.StorageState=e.$Wo=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Wo=f;var a;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends s.$Rc{static{this.a=100}constructor(d,y=Object.create(null)){super(),this.r=d,this.s=y,this.b=this.B(new D.$Pd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new P.$Qg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((y,w)=>this.w(w,y)),d.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(d,y){if(this.c===a.Closed)return;let w=!1;(0,C.$Gf)(y)?w=this.f.delete(d):this.f.get(d)!==y&&(this.f.set(d,y),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,y){const w=this.f.get(d);return(0,C.$Gf)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,C.$Gf)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,C.$Gf)(w)?y:parseInt(w,10)}getObject(d,y){const w=this.get(d);return(0,C.$Gf)(w)?y:(0,M.$jh)(w)}async set(d,y,w=!1){if(this.c===a.Closed)return;if((0,C.$Gf)(y))return this.delete(d,w);const $=(0,C.$zf)(y)||Array.isArray(y)?(0,M.$ih)(y):String(y);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,y=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Xo=g;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((y,w)=>this.a.set(w,y)),d.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Yo=b}),define(ee[159],te([0,1,8,3,31,9,21]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,b=Object.create(null)){this.g=g,this.h=b,this.c=(0,M.$mc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,b=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(d=>b.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(g){const b=await this.f;return this.j(b,g)}j(g,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$xc)(b.insert):"0"}), delete(${b.delete?(0,s.$yc)(b.delete):"0"})`),this.t(g,()=>{const p=b.insert,d=b.delete;if(p&&p.size>0){const y=[];y.push([]);let w=0;p.forEach(($,m)=>{let h=y[w];h.length>S.b&&(w++,h=[],y.push(h)),h.push(m,$)}),y.forEach($=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,m=>m.run($),()=>{const m=[];let h=0;return p.forEach((c,k)=>{m.push(k),h+=c.length}),`Keys: ${m.join(", ")} Length: ${h}`})})}if(d&&d.size){const y=[];y.push([]);let w=0;d.forEach($=>{let m=y[w];m.length>S.b&&(w++,m=[],y.push(m)),m.push($)}),y.forEach($=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,m=>m.run($),()=>{const m=[];return d.forEach(h=>{m.push(h)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,g)}k(g,b){return new Promise((p,d)=>{g.db.close(y=>(y&&this.o(g,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?p():!g.isErroneous&&!g.isInMemory?this.l().then(p,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),p())):typeof b=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const $=()=>this.k(w,void 0);return this.j(w,{insert:b()}).then(()=>$(),m=>($(),Promise.reject(m)))})).then(p,d):d(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return C.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const b=await this.f,p=await this.r(b,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?p.integrity_check:p.quick_check;return b.isErroneous?`${d} (last error: ${b.lastError})`:b.isInMemory?`${d} (in-memory!)`:d}async n(g,b=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${b})`);try{return await this.p(g)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&b)return await(0,P.$Tg)(S.a),this.n(g,!1);try{await C.Promises.unlink(g);try{await C.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(S.IN_MEMORY_PATH)}}}o(g,b){g.isErroneous=!0,g.lastError=b,this.d.error(b)}p(g){return new Promise((b,p)=>{new Promise((d,y)=>{Z(["@vscode/sqlite3"],d,y)}).then(d=>{const y={db:new(this.d.isTracing?d.verbose().Database:d.Database)(g,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(w)):p(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(y),$=>y.db.close(()=>p($)))),isInMemory:g===S.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},p)})}q(g,b){return new Promise((p,d)=>{g.db.exec(b,y=>y?(this.o(g,`[storage ${this.c}] exec(): ${y}`),d(y)):p())})}r(g,b){return new Promise((p,d)=>{g.db.get(b,(y,w)=>y?(this.o(g,`[storage ${this.c}] get(): ${y}`),d(y)):p(w))})}s(g,b){return new Promise((p,d)=>{g.db.all(b,(y,w)=>y?(this.o(g,`[storage ${this.c}] all(): ${y}`),d(y)):p(w))})}t(g,b){return new Promise((p,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),b(),g.db.run("END TRANSACTION",y=>y?(this.o(g,`[storage ${this.c}] transaction(): ${y}`),d(y)):p())})})}u(g,b,p,d){const y=g.db.prepare(b),w=$=>{this.o(g,`[storage ${this.c}] prepare(): ${$} (${b}). Details: ${d()}`)};y.on("error",w),p(y),y.finalize($=>{$&&w($),y.removeListener("error",w)})}}e.$FT=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[f.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(ee[160],te([11,10]),function(Z,e){return Z.create("vs/code/electron-main/app",e)}),define(ee[161],te([11,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([11,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([11,10]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([11,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([11,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ee[175],te([11,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(ee[176],te([11,10]),function(Z,e){return Z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([11,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([11,10]),function(Z,e){return Z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([11,10]),function(Z,e){return Z.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([11,10]),function(Z,e){return Z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([11,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(ee[182],te([11,10]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([11,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([11,10]),function(Z,e){return Z.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([11,10]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([11,10]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wU=e.$vU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$vU=P;function D(s){return s&&s.hasOwnProperty("workspace")}e.$wU=D}),define(ee[194],te([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=e.$f6b=e.$e6b=void 0;function D(C){return typeof C?.backupFolder=="string"}e.$e6b=D;function s(C){let S=[];try{Array.isArray(C.workspaces)&&(S=C.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$f6b=s;function M(C){let S=[];try{Array.isArray(C.folders)&&(S=C.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$g6b=M}),define(ee[195],te([0,1,14,163]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,D.localize)(3,null),S=(0,D.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const b=this.d,p=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:p};this.g.push({offset:b,lexeme:p,additionalInfo:g}),this.f.push(d)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const b=this.c.substring(this.d,this.e),p=f.b.get(b);p?this.k(p):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,b=!1,p=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(S);return}const y=this.c.charCodeAt(g);if(b)b=!1;else if(y===47&&!p){g++;break}else y===91?p=!0:y===92?b=!0:y===93&&(p=!1);g++}for(;g<this.c.length&&f.a.has(this.c.charCodeAt(g));)g++;this.e=g;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=f}),define(ee[196],te([0,1,3,2]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=void 0;class s{constructor(){this.a=new P.$Md,this.b=new P.$Md,this.c=new P.$Md,this.d=new P.$Md}static{this.ChannelName="extensionhostdebugservice"}call(S,f,a){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(S,f,a){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Hn=s;class M extends D.$Rc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,a){this.b.call("attach",[S,f,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$In=M}),define(ee[197],te([0,1,147,54,13,9,35,19,7]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,M.$lc)(s.$bg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.$am)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$ug)(f.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$ic)(d,"argv.json")):(0,S.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.$jc)(d):(0,M.$gc)((0,M.$ic)(s.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,M.$jc)(d)):f.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.$jc)(d);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const w=C.env.VSCODE_PORTABLE;return w?(0,M.$ic)(w,"extensions"):(0,S.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,M.$gc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$bm.test(d))}get extensionLogLevel(){const d=[];for(const y of this.args.log||[]){const w=e.$bm.exec(y);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,S.$ug)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$ic)(d,"policy.json")):(0,S.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,y,w){this.a=d,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$cm=a,ke([D.$fh],a.prototype,"appRoot",null),ke([D.$fh],a.prototype,"userHome",null),ke([D.$fh],a.prototype,"userDataPath",null),ke([D.$fh],a.prototype,"appSettingsHome",null),ke([D.$fh],a.prototype,"tmpDir",null),ke([D.$fh],a.prototype,"cacheHome",null),ke([D.$fh],a.prototype,"stateResource",null),ke([D.$fh],a.prototype,"userRoamingDataHome",null),ke([D.$fh],a.prototype,"userDataSyncHome",null),ke([D.$fh],a.prototype,"sync",null),ke([D.$fh],a.prototype,"machineSettingsResource",null),ke([D.$fh],a.prototype,"workspaceStorageHome",null),ke([D.$fh],a.prototype,"localHistoryHome",null),ke([D.$fh],a.prototype,"keyboardLayoutResource",null),ke([D.$fh],a.prototype,"argvResource",null),ke([D.$fh],a.prototype,"isExtensionDevelopment",null),ke([D.$fh],a.prototype,"untitledWorkspacesHome",null),ke([D.$fh],a.prototype,"builtinExtensionsPath",null),ke([D.$fh],a.prototype,"extensionsPath",null),ke([D.$fh],a.prototype,"extensionDevelopmentLocationURI",null),ke([D.$fh],a.prototype,"extensionDevelopmentKind",null),ke([D.$fh],a.prototype,"extensionTestsLocationURI",null),ke([D.$fh],a.prototype,"debugExtensionHost",null),ke([D.$fh],a.prototype,"logLevel",null),ke([D.$fh],a.prototype,"extensionLogLevel",null),ke([D.$fh],a.prototype,"serviceMachineIdResource",null),ke([D.$fh],a.prototype,"disableTelemetry",null),ke([D.$fh],a.prototype,"disableWorkspaceTrust",null),ke([D.$fh],a.prototype,"useInMemorySecretStorage",null),ke([D.$fh],a.prototype,"policyFile",null);function g(p,d){return b(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId,p.extensionEnvironment)}e.$dm=g;function b(p,d,y,w,$,m){const c=Number(d||p)||(w?null:y),k=c?!!d:!1;let u;if(m)try{u=JSON.parse(m)}catch{}return{port:c,break:k,debugId:$,env:u}}e.$em=b}),define(ee[112],te([0,1,307,4,166]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Al=["tunnel","serve-web"],e.$Bl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,$,m=C){const h=w.find(o=>o.length>0&&o[0]!=="-"),c={},k=["_"],u=[],t={};let l;for(const o in $){const v=$[o];v.type==="subcommand"?o===h&&(l=v):(v.alias&&(c[o]=v.alias),v.type==="string"||v.type==="string[]"?(k.push(o),v.deprecates&&k.push(...v.deprecates)):v.type==="boolean"&&(u.push(o),v.deprecates&&u.push(...v.deprecates)),v.global&&(t[o]=v))}if(l&&h){const o=t;for(const E in l.options)o[E]=l.options[E];const v=w.filter(E=>E!==h),R=m.getSubcommandReporter?m.getSubcommandReporter(h):void 0,A=S(v,o,R);return{[h]:A,_:[]}}const r=P(w,{string:k,boolean:u,alias:c}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in $){const v=$[o];if(v.type==="subcommand")continue;v.alias&&delete n[v.alias];let R=n[o];if(v.deprecates)for(const A of v.deprecates)n.hasOwnProperty(A)&&(R||(R=n[A],R&&m.onDeprecatedOption(A,v.deprecationMessage||(0,s.localize)(37,null,o))),delete n[A]);if(typeof R<"u"){if(v.type==="string[]"){if(Array.isArray(R)||(R=[R]),!v.allowEmptyValue){const A=R.filter(E=>E.length>0);A.length!==R.length&&(m.onEmptyValue(o),R=A.length>0?A:void 0)}}else v.type==="string"&&(Array.isArray(R)?(R=R.pop(),m.onMultipleValues(o,R)):!R&&!v.allowEmptyValue&&(m.onEmptyValue(o),R=void 0));i[o]=R,v.deprecationMessage&&m.onDeprecatedOption(o,v.deprecationMessage)}delete n[o]}for(const o in n)m.onUnknownOption(o);return i}e.$Cl=S;function f(w,$){let m="";return $.args&&(Array.isArray($.args)?m=` <${$.args.join("> <")}>`:m=` <${$.args}>`),$.alias?`-${$.alias} --${w}${m}`:`--${w}${m}`}function a(w,$){const m=[];for(const h in w){const c=w[h],k=f(h,c);m.push([k,c.description])}return g(m,$)}e.$Dl=a;function g(w,$){const h=w.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if($-h<25)return w.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=$-h-1,k=[];for(const u of w){const t=u[0],l=p(u[1],c),r=b(h-t.length-2);k.push("  "+t+r+l[0]);for(let i=1;i<l.length;i++)k.push(b(h)+l[i])}return k}function b(w){return" ".repeat(w)}function p(w,$){const m=[];for(;w.length;){const h=w.length<$?w.length:w.lastIndexOf(" ",$),c=w.slice(0,h).trim();w=w.slice(h),m.push(c)}return m}function d(w,$,m,h,c){const k=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${w} ${m}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${u}`),t.push(""),c?.noPipe!==!0&&(D.$j?t.push((0,s.localize)(41,null,$)):t.push((0,s.localize)(42,null,$)),t.push(""));const l={},r=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(M[n]),t.push(...a(o,k)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...g(r.map(i=>[i.command,i.description]),k)),t.push("")),t.join(`
`)}e.$El=d;function y(w,$){return`${w||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$Fl=y}),define(ee[198],te([0,1,87,196,112]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0;class M extends D.$Hn{constructor(S){super(),this.f=S}call(S,f,a){return f==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(S,f,a)}async g(S,f){const a=(0,s.$Cl)(S,s.$Bl);a.debugRenderer=f;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!f)return{success:!0};const p=b.win;if(!p)return{success:!0};const d=p.webContents.debugger;let y=d.isAttached()?1/0:0;const w=(0,P.createServer)($=>{y++===0&&d.attach();let m=!1;const h=u=>{m||$.write(JSON.stringify(u)+"\0")},c=(u,t,l,r)=>h({method:t,params:l,sessionId:r});p.on("close",()=>{d.removeListener("message",c),$.end(),m=!0}),d.addListener("message",c);let k=Buffer.alloc(0);$.on("data",u=>{k=Buffer.concat([k,u]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let l;try{const r=k.slice(0,t).toString("utf8");k=k.slice(t+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(l.method,l.params,l.sessionId).then(r=>h({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>h({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",u=>{console.error("error on cdp pipe:",u)}),$.on("close",()=>{m=!0,--y===0&&d.detach()})});return await new Promise($=>w.listen(0,$)),p.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$n6b=M}),define(ee[63],te([0,1,308,167,112]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.$Gl=void 0;function M(b,p){const d=(c,k)=>{console.warn((0,D.localize)(0,null,c,k))},y=c=>{console.warn((0,D.localize)(1,null,c))},w=(c,k)=>{console.warn((0,D.localize)(2,null,c,k))},$=c=>({onUnknownOption:k=>{s.$Al.includes(c)||console.warn((0,D.localize)(3,null,k,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$Al.includes(c)?$:void 0}),m={onUnknownOption:c=>{console.warn((0,D.localize)(4,null,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:$},h=(0,s.$Cl)(b,s.$Bl,p?m:void 0);return h.goto&&h._.forEach(c=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,D.localize)(5,null))),h}function C(b){const p=b.findIndex(d=>!/^-/.test(d));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function S(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=C(p)||[]);const d=!g(process.env);return M(p,d)}e.$Gl=S;function f(b){let[,,...p]=b;return process.env.VSCODE_DEV&&(p=C(p)||[]),M(p,!0)}e.$Hl=f;function a(b,...p){const d=b.indexOf("--");return d===-1?b.push(...p):b.splice(d,0,...p),b}e.$Il=a;function g(b){return b.VSCODE_CLI==="1"}e.$Jl=g}),function(){"use strict";function Z(e,P,D){function s(C,S){const f=M(C,S),a=[f];return e.isAbsolute(f)||a.unshift(D),e.resolve(...a)}function M(C,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const g=C["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(P.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:s}}if(typeof define=="function")define(ee[199],te([113,28,35]),function(e,P,D){return Z(e,P,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Z(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,28,197,199]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=void 0;class M extends D.$cm{constructor(a,g){super(a,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,g.nameShort)},g)}}e.$fm=M;function C(f,a){return(0,D.$em)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.$gm=C;function S(f,a){return(0,D.$em)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.$hm=S}),define(ee[200],te([0,1,45,28,33]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;function M(C){const S=(0,s.$5f)((0,D.tmpdir)());try{return(0,P.writeFileSync)(S,""),C&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){C&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$O7b=M}),define(ee[201],te([0,1,12,169]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function s(C,S,f,a){try{M(C,S,f,a)}catch(g){C.error(g?.message??g)}return S}e.$tp=s;function M(C,S,f,a){const g=(b,p,d)=>{const y=b[p];if((0,P.$xf)(y)){const w=y,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const m=w.substr(1,$-2);let h=f[m];h===void 0&&a&&(h=a[m]);const c=typeof h=="string"?h:h?.message,k=a?.[m],u=typeof k=="string"?k:k?.message;if(!c){u||C.warn(`[${S.name}]: ${(0,D.localize)(0,null,m)}`);return}if(d&&(p==="title"||p==="category")&&u&&u!==c){const t={value:c,original:u};b[p]=t}else b[p]=c}}else if((0,P.$zf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?g(y,w,!0):g(y,w,d));else if(Array.isArray(y))for(let w=0;w<y.length;w++)g(y,w,d)};for(const b in S)S.hasOwnProperty(b)&&g(S,b)}}),define(ee[202],te([0,1,19,71,171,203]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(m){return m=m.trim(),m==="*"||C.test(m)}e.$Ho=f;function a(m){if(!f(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=m.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Io=a;function g(m){if(!m)return null;const h=m.majorBase,c=m.majorMustEqual,k=m.minorBase;let u=m.minorMustEqual;const t=m.patchBase;let l=m.patchMustEqual;m.hasCaret&&(h===0||(u=!1),l=!1);let r=0;if(m.preRelease){const i=S.exec(m.preRelease);if(i){const[,n,o,v]=i;r=Date.UTC(Number(n),Number(o)-1,Number(v))}}return{majorBase:h,majorMustEqual:c,minorBase:k,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:r}}e.$Jo=g;function b(m,h,c){let k;typeof m=="string"?k=g(a(m)):k=m;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let t;if(typeof c=="string"?t=g(a(c)):t=c,!k||!t)return!1;const l=k.majorBase,r=k.minorBase,i=k.patchBase;let n=t.majorBase,o=t.minorBase,v=t.patchBase;const R=t.notBefore;let A=t.majorMustEqual,E=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>o?!0:r<o||u&&u<R?!1:i>=v:(l===1&&n===0&&(!A||!E||!I)&&(n=1,o=0,v=0,A=!0,E=!1,I=!1),l<n?!1:l>n?!A:r<o?!1:r>o?!E:i<v?!1:i>v?!I:!(u&&u<R))}e.$Ko=b;function p(m,h,c,k,u){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([D.default.Error,s.localize(0,null)]),t;if(typeof k.name!="string")return t.push([D.default.Error,s.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([D.default.Error,s.localize(2,null,"version")]),t;if(!k.engines)return t.push([D.default.Error,s.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([D.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!$(k.extensionDependencies))return t.push([D.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!$(k.activationEvents))return t.push([D.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([D.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([D.default.Warning,s.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([D.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$ug)(c,k.main);(0,P.$og)(i,c)||t.push([D.default.Warning,s.localize(10,null,i.path,c.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([D.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$ug)(c,k.browser);(0,P.$og)(i,c)||t.push([D.default.Warning,s.localize(12,null,i.path,c.path)])}}if(!M.valid(k.version))return t.push([D.default.Error,s.localize(13,null)]),t;const l=[];if(!d(m,h,k,u,l))for(const i of l)t.push([D.default.Error,i]);return t}e.$Lo=p;function d(m,h,c,k,u){return k||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(m,h,c.engines.vscode,u)}e.$Mo=d;function y(m,h,c){return m==="*"||w(h,c,m)}e.$No=y;function w(m,h,c,k=[]){const u=g(a(c));if(!u)return k.push(s.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return k.push(s.localize(15,null,c)),!1}else if(!u.majorMustEqual)return k.push(s.localize(16,null,c)),!1;return b(m,h,u)?!0:(k.push(s.localize(17,null,m,c)),!1)}function $(m){if(!Array.isArray(m))return!1;for(let h=0,c=m.length;h<c;h++)if(typeof m[h]!="string")return!1;return!0}}),define(ee[204],te([0,1,18,32]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0;async function s(M,C,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const g=(await C.readFile(M.serviceMachineIdResource)).value.toString();f=(0,D.$cg)(g)?g:null}catch{f=null}if(!f){f=(0,D.$dg)();try{await C.writeFile(M.serviceMachineIdResource,P.$ae.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$8o=s}),define(ee[75],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class P{constructor(s,M=[],C=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$Kh=P}),define(ee[205],te([0,1,75]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const D=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,f,a){f instanceof P.$Kh||(f=new P.$Kh(f,[],!!a)),D.push([S,f])}e.$sr=M;function C(){return D}e.$tr=C}),define(ee[206],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class P{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$0p=P;class D{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(C);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const S of this.a.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let S=this.a.get(C);return S||(S=new P(C,M),this.a.set(C,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,S]of this.a)M.push(`${C}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const S=new Set([M]),f=this.c(C,S);if(f)return f}}c(M,C){for(const[S,f]of M.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const a=this.c(f,C);if(a)return a;C.delete(S)}}}e.$$p=D}),define(ee[6],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var P;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(P||(e._util=P={})),e.$Mh=s("instantiationService");function D(C,S,f){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:C,index:f}):(S[P.DI_DEPENDENCIES]=[{id:C,index:f}],S[P.DI_TARGET]=S)}function s(C){if(P.serviceIds.has(C))return P.serviceIds.get(C);const S=function(f,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(S,f,g)};return S.toString=()=>C,P.serviceIds.set(C,S),S}e.$Nh=s;function M(C){return C}e.$Oh=M}),define(ee[64],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0,e.$h6b=(0,P.$Nh)("backupMainService")}),define(ee[17],te([0,1,12,7,6]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,s.$Nh)("configurationService");function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof D.URI)}e.$ii=M;function C(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof D.URI)}e.$ji=C;var S;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=f;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.$li=a;function g(m,h){const c=Object.create(null);for(const k in m)b(c,k,m[k],h);return c}e.$mi=g;function b(m,h,c,k){const u=h.split("."),t=u.pop();let l=m;for(let r=0;r<u.length;r++){const i=u[r];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${h} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=c}catch{k(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}else k(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.$ni=b;function p(m,h){const c=h.split(".");d(m,c)}e.$oi=p;function d(m,h){const c=h.shift();if(h.length===0){delete m[c];return}if(Object.keys(m).indexOf(c)!==-1){const k=m[c];typeof k=="object"&&!Array.isArray(k)&&(d(k,h),Object.keys(k).length===0&&delete m[c])}}function y(m,h,c){function k(l,r){let i=l;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=h.split("."),t=k(m,u);return typeof t>"u"?c:t}e.$pi=y;function w(m,h,c){Object.keys(h).forEach(k=>{k!=="__proto__"&&(k in m?P.$zf(m[k])&&P.$zf(h[k])?w(m[k],h[k],c):c&&(m[k]=h[k]):m[k]=h[k])})}e.$qi=w;function $(m){return m.replace(/[\[\]]/g,"")}e.$ri=$}),define(ee[114],te([0,1,4,27,195,6,162,14]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$k),f.set("isLinux",P.$l),f.set("isWindows",P.$j),f.set("isWeb",P.$p),f.set("isMacNative",P.$k&&!P.$p),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function a(T,O){if(f.get(T)!==void 0)throw(0,S.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(T,O)}e.$Ji=a;const g=Object.prototype.hasOwnProperty;var b;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const p={regexParsingWithErrorRecovery:!0},d=(0,C.localize)(0,null),y=(0,C.localize)(1,null),w=(0,C.localize)(2,null),$=(0,C.localize)(3,null),m=(0,C.localize)(4,null),h=(0,C.localize)(5,null),c=(0,C.localize)(6,null),k=(0,C.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=p){this.k=O,this.d=new s.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const q=this.D(),W=q.type===17?h:void 0;throw this.h.push({message:m,offset:q.offset,lexeme:s.$Ii.getLexeme(q),additionalInfo:W}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,$),j?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,$),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const z=W.lexeme,G=z.lastIndexOf("/"),ce=G===z.length-1?void 0:this.w(z.substring(G+1));let de;try{de=new RegExp(z.substring(1,G),ce)}catch{throw this.B("REGEX",W)}return ne.create(j,de)}switch(W.type){case 10:case 19:{const z=[W.lexeme];this.z();let G=this.D(),ce=0;for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let be=0;be<G.lexeme.length;be++)G.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--}if(ce<0)break;z.push(s.$Ii.getLexeme(G)),this.z(),G=this.D()}const de=z.join(""),ue=de.lastIndexOf("/"),fe=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ye;try{ye=new RegExp(de.substring(1,ue),fe)}catch{throw this.B("REGEX",W)}return t.regex(j,ye)}case 18:{const z=W.lexeme;this.z();let G=null;if(!(0,D.$Ae)(z)){const ce=z.indexOf("/"),de=z.lastIndexOf("/");if(ce!==de&&ce>=0){const ue=z.slice(ce+1,de),fe=z[de+1]==="i"?"i":"";try{G=new RegExp(ue,fe)}catch{throw this.B("REGEX",W)}}}if(G===null)throw this.B("REGEX",W);return ne.create(j,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const W=this.u();return t.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(j,W);switch(W){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(j,W);switch(W){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,W)}}case 5:return this.z(),x.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),B.create(j,this.u());case 8:return this.z(),se.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:c,offset:O.offset,lexeme:"",additionalInfo:k}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,q){const W=(0,C.localize)(8,null,O,s.$Ii.getLexeme(j)),z=j.offset,G=s.$Ii.getLexeme(j);return this.h.push({message:W,offset:z,lexeme:G,additionalInfo:q}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=u;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(O){return v.create(O)}static equals(O,j){return R.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return ne.create(O,j)}static in(O,j){return A.create(O,j)}static notIn(O,j){return E.create(O,j)}static not(O){return L.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,j){return B.create(O,j)}static greaterEquals(O,j){return se.create(O,j)}static smaller(O,j){return x.create(O,j)}static smallerEquals(O,j){return ae.create(O,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Li=t;function l(T){const O=new u({regexParsingWithErrorRecovery:!1});return T.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,C.localize)(9,null,q.additionalInfo):(0,C.localize)(10,null),offset:q.offset,length:q.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}e.$Mi=l;function r(T,O){const j=T?T.substituteConstants():void 0,q=O?O.substituteConstants():void 0;return!j&&!q?!0:!j||!q?!1:j.equals(q)}e.$Ni=r;function i(T,O){return T.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.$Oi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Pi=o;class v{static create(O,j=null){const q=f.get(O);return typeof q=="boolean"?q?o.INSTANCE:n.INSTANCE:new v(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:U(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Qi=v;class R{static create(O,j,q=null){if(typeof j=="boolean")return j?v.create(O,q):L.create(O,q);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new R(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?o.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=R;class A{static create(O,j){return new A(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),q=O.getValue(this.d);return Array.isArray(j)?j.includes(q):typeof q=="string"&&typeof j=="object"&&j!==null?g.call(j,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Si=A;class E{static create(O,j){return new E(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=A.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=E;class I{static create(O,j,q=null){if(typeof j=="boolean")return j?L.create(O,q):v.create(O,q);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new I(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Ui=I;class L{static create(O,j=null){const q=f.get(O);return typeof q=="boolean"?q?n.INSTANCE:o.INSTANCE:new L(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:U(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:o.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Vi=L;function F(T,O){if(typeof T=="string"){const j=parseFloat(T);isNaN(j)||(T=j)}return typeof T=="string"||typeof T=="number"?O(T):n.INSTANCE}class B{static create(O,j,q=null){return F(j,W=>new B(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Wi=B;class se{static create(O,j,q=null){return F(j,W=>new se(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Xi=se;class x{static create(O,j,q=null){return F(j,W=>new x(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Yi=x;class ae{static create(O,j,q=null){return F(j,W=>new ae(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Zi=ae;class ne{static create(O,j){return new ne(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return j<q?-1:j>q?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return this.d===O.d&&j===q}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$1i=ne;class re{static create(O){return new re(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new re(this.c.map(O))}negate(){return this.c}}e.$2i=re;function X(T){let O=null;for(let j=0,q=T.length;j<q;j++){const W=T[j].substituteConstants();if(T[j]!==W&&O===null){O=[];for(let z=0;z<j;z++)O[z]=T[z]}O!==null&&(O[j]=W)}return O===null?T:O}class K{static create(O,j,q){return K.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,q){const W=[];let z=!1;for(const G of O)if(G){if(G.type===1){z=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){W.push(...G.expr);continue}W.push(G)}if(W.length===0&&z)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];for(;W.length>1;){const G=W[W.length-1];if(G.type!==9)break;W.pop();const ce=W.pop(),de=W.length===0,ue=V.create(G.expr.map(fe=>K.create([fe,ce],null,q)),null,de);ue&&(W.push(ue),W.sort(i))}if(W.length===1)return W[0];if(q){for(let G=0;G<W.length;G++)for(let ce=G+1;ce<W.length;ce++)if(W[G].negate().equals(W[ce]))return n.INSTANCE;if(W.length===1)return W[0]}return new K(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new K(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=V.create(O,this,!0)}return this.c}}e.$3i=K;class V{static create(O,j,q){return V.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,q){let W=[],z=!1;if(O){for(let G=0,ce=O.length;G<ce;G++){const de=O[G];if(de){if(de.type===0){z=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&z)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];if(q){for(let G=0;G<W.length;G++)for(let ce=G+1;ce<W.length;ce++)if(W[G].negate().equals(W[ce]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new V(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),q=O.shift(),W=[];for(const z of oe(j))for(const G of oe(q))W.push(K.create([z,G],null,!1));O.unshift(V.create(W,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$4i=V;class N extends v{static{this.d=[]}static all(){return N.d.values()}constructor(O,j,q){super(O,null),this.f=j,typeof q=="object"?N.d.push({...q,key:O}):q!==!0&&N.d.push({key:O,description:q,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return R.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$5i=N,e.$6i=(0,M.$Nh)("contextKeyService");function U(T,O){return T<O?-1:T>O?1:0}function H(T,O,j,q){return T<j?-1:T>j?1:O<q?-1:O>q?1:0}function J(T,O){if(T.type===0||O.type===1)return!0;if(T.type===9)return O.type===9?ie(T.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(J(T,j))return!0;return!1}if(T.type===6){if(O.type===6)return ie(O.expr,T.expr);for(const j of T.expr)if(J(j,O))return!0;return!1}return T.equals(O)}e.$7i=J;function ie(T,O){let j=0,q=0;for(;j<T.length&&q<O.length;){const W=T[j].cmp(O[q]);if(W<0)return!1;W===0&&j++,q++}return j===T.length}function oe(T){return T.type===9?T.expr:[T]}}),define(ee[90],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.ID=void 0,e.ID="diagnosticsService",e.$mm=(0,P.$Nh)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.$nm=D;class s{async getPerformanceInfo(C,S){return{}}async getSystemInfo(C,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,S){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$om=s}),define(ee[115],te([0,1,19,71,164,6,46,4,37]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.ConfirmResult=e.$xv=e.$wv=e.$vv=void 0,e.$vv=(0,M.$Nh)("dialogService");var a;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(a||(a={}));class g{a($){return this.d($,a.Confirmation)}b($){return this.d($,a.Prompt)}c($){return this.d($,a.Input)}d($,m){const h=[];switch(m){case a.Confirmation:{const c=$;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(0,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(1,null));break}case a.Prompt:{const c=$;Array.isArray(c.buttons)&&c.buttons.length>0&&h.push(...c.buttons.map(k=>k.label)),c.cancelButton&&(c.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof c.cancelButton=="string"?h.push(c.cancelButton):c.cancelButton.label?h.push(c.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case a.Input:{const c=$;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(5,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===D.default.Info?"info":$===D.default.Error?"error":$===D.default.Warning?"warning":"none"}f($,m,h){const c=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&c.push($.cancelButton);let k=c[m]?.run({checkboxChecked:h});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:h}}}e.$wv=g,e.$xv=(0,M.$Nh)("fileDialogService");var b;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const p=10;function d(w){const $=[];return $.push(...w.slice(0,p).map(m=>typeof m=="string"?m:(0,P.$rg)(m))),w.length>p&&(w.length-p===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,w.length-p))),$.push(""),$.join(`
`)}e.$yv=d;function y(w,$){const m=(0,f.$2m)(w);let h=(m.buttons??[]).map(t=>(0,C.$sv)(t)),c=(w.buttons||[]).map((t,l)=>l),k=0,u=m.cancelId??h.length-1;if(h.length>1){const t=typeof u=="number"?h[u]:void 0;if(S.$l||S.$k){if(typeof t=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,t);const l=c[u];c.splice(u,1),c.splice(1,0,l),u=1}S.$l&&h.length>1&&(h=h.reverse(),c=c.reverse(),k=h.length-1,typeof t=="string"&&(u=k-1))}else if(S.$j&&typeof t=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(t);const l=c[u];c.splice(u,1),c.push(l),u=h.length-1}}return m.buttons=h,m.defaultId=k,m.cancelId=u,m.noLink=!0,m.title=m.title||$.nameLong,{options:m,buttonIndeces:c}}e.$zv=y}),define(ee[116],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$UT=e.$TT=void 0,e.$TT=(0,P.$Nh)("encryptionService"),e.$UT=(0,P.$Nh)("encryptionMainService");var D;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$VT=M;function C(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$WT=C}),define(ee[36],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,P.$Nh)("environmentService"),e.$Vh=(0,P.$Oh)(e.$Uh)}),define(ee[117],te([0,1,168,6]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=s;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=M;function C(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=C;function S(h,c){return c==="web"&&!h.includes("web")}e.$2n=S;function f(h,c,k){return S(c,k)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===k?!0:a(k).includes(h)}e.$3n=f;function a(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=a;function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$5n=g;var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var y;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$6n=(0,D.$Nh)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class m extends Error{constructor(c,k){super(c),this.code=k,this.name=k}}e.$7n=m,e.$8n=(0,D.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,D.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,D.$Nh)("IExtensionTipsService"),e.$ao=(0,P.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0,e.$B6b=(0,P.$Nh)("extensionHostStarter"),e.$C6b="extensionHostStarter"}),define(ee[208],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UXb=e.$TXb=void 0,e.$TXb=(0,P.$Nh)("externalTerminal"),e.$UXb="Terminal.app"}),define(ee[209],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0,e.$E6b=(0,P.$Nh)("externalTerminal")}),define(ee[210],te([0,1,47,13,9,4,73,21,88,172,208]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=e.$G6b=e.$F6b=void 0;const b=a.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends p{static{this.b="cmd.exe"}openTerminal(k,u){return this.spawnTerminal(P,k,f.$xl(),u)}spawnTerminal(k,u,t,l){const r=u.windowsExec||d.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$mc(r,".exe").toLowerCase();if(i==="cmder")return k.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,v)=>{const R=$(process),A=k.spawn(t,n,{cwd:l,env:R});A.on("error",v),A.on("exit",()=>o())})}runInTerminal(k,u,t,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,o)=>{const v=`"${u} - ${b}"`,R=`""${t.join('" "')}" & pause"`,A=Object.assign({},$(process),l);Object.keys(A).filter(B=>A[B]===null).forEach(B=>delete A[B]);const E={cwd:u,env:A,windowsVerbatimArguments:!0};let I,L;s.$mc(i,".exe")==="wt"?(I=i,L=["-d",".",d.b,"/c",R]):(I=d.b,L=["/c","start",v,"/wait",i,"/c",R]),P.spawn(I,L,E).on("error",B=>{o(m(B))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$F6b=d;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(k,u){return this.spawnTerminal(P,k,u)}runInTerminal(k,u,t,l,r){const i=r.osxExec||g.$UXb;return new Promise((n,o)=>{if(i===g.$UXb||i==="iTerm.app"){const v=i===g.$UXb?"TerminalHelper":"iTermHelper",A=[D.$bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",k||b,"-w",u];for(const L of t)A.push("-a"),A.push(L);if(l){const L=Object.assign({},$(process),l);for(const F in L){const B=L[F];B===null?(A.push("-u"),A.push(F)):(A.push("-e"),A.push(`${F}=${B}`))}}let E="";const I=P.spawn(y.b,A);I.on("error",L=>{o(m(L))}),I.stderr.on("data",L=>{E+=L.toString()}),I.on("exit",L=>{if(L===0)n(void 0);else if(E){const F=E.split(`
`,1);o(new Error(F[0]))}else o(new Error(a.localize(1,null,v,L)))})}else o(new Error(a.localize(2,null,i)))})}spawnTerminal(k,u,t){const l=u.osxExec||g.$UXb;return new Promise((r,i)=>{const n=["-a",l];t&&n.push(t);const o=$(process),v=k.spawn("/usr/bin/open",n,{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})}}e.$G6b=y;class w extends p{static{this.b=a.localize(3,null)}openTerminal(k,u){return this.spawnTerminal(P,k,u)}runInTerminal(k,u,t,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const v=[];i.then(R=>{R.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const A=`${h(t)}; echo; read -p "${w.b}" -n1;`;v.push(`''${A}''`);const E=Object.assign({},$(process),l);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const I={cwd:u,env:E};let L="";const F=P.spawn(R,v,I);F.on("error",B=>{o(m(B))}),F.stderr.on("data",B=>{L+=B.toString()}),F.on("exit",B=>{if(B===0)n(void 0);else if(L){const se=L.split(`
`,1);o(new Error(se[0]))}else o(new Error(a.localize(4,null,R,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!M.$l)w.d=Promise.resolve("xterm");else{const k=await S.Promises.exists("/etc/debian_version");w.d=new Promise(u=>{k?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w.d}spawnTerminal(k,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(n=>{const o=$(process),v=k.spawn(n,[],{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})})}}e.$H6b=w;function $(c){const k={...c.env};return(0,C.$vl)(k),k}function m(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(a.localize(5,null,c.path)):c}function h(c){let k="";for(const u of c)u.indexOf(" ")>=0?k+='"'+u+'"':k+=u,k+=" ";return k}}),define(ee[16],te([0,1,56,9,27,12,7,174,6,4,13]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,f.$Nh)("fileService");function b(U){return U.create===!0}e.$0j=b;var p;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var d;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(U){return!!(U.capabilities&2)}e.$$j=w;function $(U){return!!(U.capabilities&8)}e.$_j=$;function m(U){return!!(U.capabilities&131072)}e.$ak=m;function h(U){return!!(U.capabilities&4)}e.$bk=h;function c(U){return!!(U.capabilities&16)}e.$ck=c;function k(U){return w(U)?!!(U.capabilities&16384):!1}e.$dk=k;function u(U){return w(U)?!!(U.capabilities&32768):!1}e.$ek=u;function t(U){return!!(U.capabilities&65536)}e.$fk=t;function l(U){return!!(U.capabilities&2048)}e.$gk=l;var r;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(H,J){const ie=new i(H.toString(),J);return v(ie,J),ie}constructor(H,J){super(H),this.code=J}}e.$hk=i;function n(U,H){return i.create(U,H)}e.$ik=n;function o(U){return U||n((0,S.localize)(0,null),r.Unknown)}e.$jk=o;function v(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.$kk=v;function R(U){if(!U)return r.Unknown;if(U instanceof i)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return r.Unknown;switch(H[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$lk=R;function A(U){if(U instanceof se)return U.fileOperationResult;switch(R(U)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$mk=A;var E;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class I{constructor(H,J,ie){this.resource=H,this.operation=J,this.target=ie}isOperation(H){return this.operation===H}}e.$nk=I;var L;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class F{constructor(H,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const oe of H){const T=ie.get(oe.type);switch(T?T.push([oe.resource,oe]):ie.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,T]of ie)switch(oe){case 1:this.a=P.$Th.forUris(()=>J),this.a.fill(T);break;case 0:this.b=P.$Th.forUris(()=>J),this.b.fill(T);break;case 2:this.c=P.$Th.forUris(()=>J),this.c.fill(T);break}}contains(H,...J){return this.d(H,{includeChildren:!1},...J)}affects(H,...J){return this.d(H,{includeChildren:!0},...J)}d(H,J,...ie){if(!H)return!1;const oe=ie.length>0;return!!((!oe||ie.includes(1))&&(this.a?.get(H)||J.includeChildren&&this.a?.findSuperstr(H))||(!oe||ie.includes(0))&&(this.b?.get(H)||J.includeChildren&&this.b?.findSuperstr(H))||(!oe||ie.includes(2))&&(this.c?.findSubstr(H)||J.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=F;function B(U,H,J){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==D.sep&&(H+=D.sep),J?(0,s.$2e)(U,H):U.indexOf(H)===0)}e.$pk=B;class se extends Error{constructor(H,J,ie){super(H),this.fileOperationResult=J,this.options=ie}}e.$qk=se;class x extends se{constructor(H,J,ie,oe){super(H,J,oe),this.fileOperationResult=J,this.size=ie}}e.$rk=x;class ae extends se{constructor(H,J,ie){super(H,2,ie),this.stat=J}}e.$sk=ae;var ne;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var re;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$Ak="";function X(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.$Bk=X;async function K(U,H){if(!H.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(J=>{const ie=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===U.scheme&&oe.added&&(ie.dispose(),J())})})}e.$Ck=K;class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(H){return(0,M.$Bf)(H)||(H=0),H<V.KB?(0,S.localize)(1,null,H.toFixed(0)):H<V.MB?(0,S.localize)(2,null,(H/V.KB).toFixed(2)):H<V.GB?(0,S.localize)(3,null,(H/V.MB).toFixed(2)):H<V.TB?(0,S.localize)(4,null,(H/V.GB).toFixed(2)):(0,S.localize)(5,null,(H/V.TB).toFixed(2))}}e.$Dk=V;function N(U){const H=typeof U=="string"||U?.scheme===g.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===g.Schemas.file?1024*V.MB:H?10*V.MB:a.$p?50*V.MB:1024*V.MB}e.$Ek=N}),define(ee[211],te([0,1,18,49,14,3,2,62,7,32,16]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN="localFilesystem";class b extends C.$Rc{constructor(d,y){super(),this.a=d,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Md),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.h=(0,a.$dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,y){const{buffer:w}=await this.a.call("readFile",[d,y]);return w}readFileStream(d,y,w){const $=(0,S.$1d)(h=>P.$ae.concat(h.map(c=>P.$ae.wrap(c))).buffer),m=new C.$Qc;return m.add(this.a.listen("readFileStream",[d,y])(h=>{if(h instanceof P.$ae)$.write(h.buffer);else{if(h==="end")$.end();else{let c;if(h instanceof Error)c=h;else{const k=h;c=(0,g.$ik)(k.message??(0,D.$yi)(k),k.code??g.FileSystemProviderErrorCode.Unknown)}$.error(c),$.end()}m.dispose()}})),m.add(w.onCancellationRequested(()=>{$.error((0,s.$5)()),$.end(),m.dispose()})),$}writeFile(d,y,w){return this.a.call("writeFile",[d,P.$ae.wrap(y),w])}open(d,y){return this.a.call("open",[d,y])}close(d){return this.a.call("close",[d])}async read(d,y,w,$,m){const[h,c]=await this.a.call("read",[d,y,m]);return w.set(h.buffer.slice(0,c),$),c}write(d,y,w,$,m){return this.a.call("write",[d,y,P.$ae.wrap(w),$,m])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,y){return this.a.call("delete",[d,y])}rename(d,y,w){return this.a.call("rename",[d,y,w])}copy(d,y,w){return this.a.call("copy",[d,y,w])}cloneFile(d,y){return this.a.call("cloneFile",[d,y])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const y=d;this.f.fire(y.map(w=>({resource:f.URI.revive(w.resource),type:w.type})))}else{const y=d;this.g.fire(y)}}))}watch(d,y){const w=(0,a.$dg)();return this.a.call("watch",[this.h,w,d,y]),(0,C.$Pc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$eN=b}),define(ee[118],te([0,1,18,14,175,16]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;async function C(g,b,p,d,y,w){let $;try{await S(g,b,p,d,y,w)}catch(m){$=m}finally{$&&y.errorTransformer&&($=y.errorTransformer($)),typeof $<"u"&&p.error($),p.end()}}e.$Ip=C;async function S(g,b,p,d,y,w){f(w);const $=await g.open(b,{create:!1});try{f(w);let m=0,h=0,c=y&&typeof y.length=="number"?y.length:void 0,k=P.$ae.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do h=await g.read($,u,k.buffer,t,k.byteLength-t),u+=h,t+=h,m+=h,typeof c=="number"&&(c-=h),t===k.byteLength&&(await p.write(d(k)),k=P.$ae.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),t=0);while(h>0&&(typeof c!="number"||c>0)&&f(w)&&a(m,y));if(t>0){let l=t;typeof c=="number"&&(l=Math.min(t,c)),p.write(d(k.slice(0,l)))}}catch(m){throw(0,M.$jk)(m)}finally{await g.close($)}}function f(g){if(g.isCancellationRequested)throw(0,D.$5)();return!0}function a(g,b){if(typeof b?.limits?.size=="number"&&g>b.limits.size)throw(0,M.$ik)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[76],te([0,1,104,2,9,4,7,16]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=void 0;function f(m){return m.recursive===!0}e.$Kp=f;class a extends D.$Rc{static{this.a=5}constructor(h,c,k,u){super(),this.h=h,this.j=c,this.m=k,this.n=u,this.c=this.B(new D.$Sc),this.f=void 0,this.g=0}s(){const h=new D.$Qc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(c=>this.h(c))),h.add(this.b.onDidLogMessage(c=>this.j(c))),h.add(this.b.onDidError(c=>this.t(c)))}t(h){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lp=a;class g extends a{constructor(h,c,k){super(h,c,k,{type:"node.js",restartOnError:!1})}}e.$Mp=g;class b extends a{constructor(h,c,k){super(h,c,k,{type:"universal",restartOnError:!0})}}e.$Np=b;function p(m){return m.map(h=>({type:h.type,resource:C.URI.revive(h.resource)}))}e.$Op=p;function d(m){const h=new $;for(const c of m)h.processEvent(c);return h.coalesce()}e.$Pp=d;function y(m,h){return typeof h=="string"&&!h.startsWith(P.$qj)&&!(0,s.$hc)(h)?{base:m,pattern:h}:h}e.$Qp=y;function w(m,h){const c=[];for(const k of h)c.push((0,P.$uj)(y(m,k)));return c}e.$Rp=w;class ${constructor(){this.a=new Set,this.b=new Map}c(h){return M.$l?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const c=this.b.get(this.c(h));let k=!1;if(c){const u=c.type,t=h.type;c.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?k=!0:u===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else k=!0;k&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],c=[];return Array.from(this.a).filter(k=>k.type!==2?(h.push(k),!1):!0).sort((k,u)=>k.resource.fsPath.length-u.resource.fsPath.length).filter(k=>c.some(u=>(0,S.$pk)(k.resource.fsPath,u,!M.$l))?!1:(c.push(k.resource.fsPath),!0)).concat(h)}}}),define(ee[212],te([0,1,45,8,22,33,2,84,9,4,7,105,21,76]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class y extends C.$Rc{static{this.a=100}static{this.b=75}constructor(m,h,c,k){super(),this.m=m,this.n=h,this.r=c,this.s=k,this.c=this.B(new D.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.n(u))),this.f=this.B(new D.$7g(u=>this.z(u),y.b)),this.g=(0,d.$Rp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Rp)(this.m.path,this.m.includes):void 0,this.j=new s.$Wd,this.ready=this.t()}async t(){try{const m=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await p.Promises.stat(m);this.B(await this.w(m,h.isDirectory()))}catch(m){m.code!=="ENOENT"?this.D(m):this.G(m)}}async u(m){let h=m.path;try{h=await p.Promises.realpath(m.path),m.path===h&&(h=await(0,b.$2p)(m.path)??m.path),m.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${h})`)}catch{}return h}async w(m,h){if(a.$k&&(0,M.$Wf)(m,"/Volumes/",!0))return this.D(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Rc.None;const c=new s.$Wd(this.j.token),k=new C.$Qc;try{const u=(0,f.$mc)(m),t=(0,P.watch)(m);k.add((0,C.$Pc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${m}'`);const l=new Set;if(h)try{for(const i of await p.Promises.readdir(m))l.add(i)}catch(i){this.D(i)}const r=new Map;k.add((0,C.$Pc)(()=>{for(const[,i]of r)i.dispose();r.clear()})),t.on("error",(i,n)=>{this.D(`Failed to watch ${m} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),t.on("change",(i,n)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),a.$k&&(o=(0,S.$kl)(o))),!(!o||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(o)?.dispose();const v=setTimeout(async()=>{if(r.delete(o),o===u&&!await p.Promises.exists(m)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const R=await this.C((0,f.$ic)(m,o));if(c.token.isCancellationRequested)return;let A;R?l.has(o)?A=0:(A=1,l.add(o)):(l.delete(o),A=2),this.y({resource:g.URI.file((0,f.$ic)(this.m.path,o)),type:A})},y.a);r.set(o,(0,C.$Pc)(()=>clearTimeout(v)))}else{let v;l.has(o)?v=0:(v=1,l.add(o)),this.y({resource:g.URI.file((0,f.$ic)(this.m.path,o)),type:v})}else if(i==="rename"||o!==u){const v=setTimeout(async()=>{const R=await p.Promises.exists(m);c.token.isCancellationRequested||(R?(this.y({resource:g.URI.file(this.m.path),type:0},!0),k.add(await this.w(m,!1))):(this.y({resource:g.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},y.a);k.clear(),k.add((0,C.$Pc)(()=>clearTimeout(v)))}else this.y({resource:g.URI.file(this.m.path),type:0},!0)})}catch(u){await p.Promises.exists(m)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${m} for changes using fs.watch() (${u.toString()})`)}return(0,C.$Pc)(()=>{c.dispose(!0),k.dispose()})}y(m,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!h&&this.g.some(c=>c(m.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${m.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(c=>c(m.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${m.resource.fsPath}`):this.f.work(m))}z(m){const h=(0,d.$Pp)(m);if(h.length>0){if(this.s)for(const k of h)this.G(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(m){if(a.$l)return p.Promises.exists(m);try{const h=(0,f.$mc)(m);return(await p.Promises.readdir((0,f.$lc)(m))).some(k=>k===h)}catch(h){return this.G(h),!1}}setVerboseLogging(m){this.s=m}D(m){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}F(m){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}G(m){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$5p=y;async function w($,m,h,c,k=512){const u=await p.Promises.open($,"r"),t=Buffer.allocUnsafe(k),l=new s.$Wd(c);let r,i=!1;const n={path:$,excludes:[],recursive:!1},o=new y(n,v=>{(async()=>{for(const{type:R}of v)if(R===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:A}=await p.Promises.read(u,t,0,k,null);if(!A||l.token.isCancellationRequested)break;m(t.slice(0,A))}}catch(A){r=new Error(A),l.dispose(!0)}finally{i=!1}}})()});return await o.ready,h(),new Promise((v,R)=>{l.token.onCancellationRequested(async()=>{o.dispose();try{await p.Promises.close(u)}catch(A){r=new Error(A)}r?R(r):v()})})}e.$6p=w}),define(ee[213],te([0,1,3,104,2,4,212]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class S extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new P.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Md),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(a){const g=this.j(a),b=g.filter(d=>{const y=this.c.get(d.path);return y?!(0,D.$yj)(y.request.excludes,d.excludes)||!(0,D.$yj)(y.request.includes,d.includes):!0}),p=Array.from(this.c.values()).filter(({request:d})=>!g.find(y=>y.path===d.path&&(0,D.$yj)(y.excludes,d.excludes)&&(0,D.$yj)(y.includes,d.includes))).map(({request:d})=>d.path);b.length&&this.m(`Request to start watching: ${b.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const d of p)this.h(d);for(const d of b)this.g(d)}g(a){const g=new C.$5p(a,p=>this.a.fire(p),p=>this.b.fire(p),this.f),b={request:a,instance:g};this.c.set(a.path,b)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const g=this.c.get(a);g&&(this.c.delete(a),g.instance.dispose())}j(a){const g=new Map;for(const b of a){const p=M.$l?b.path:b.path.toLowerCase();g.set(p,b)}return Array.from(g.values())}async setVerboseLogging(a){this.f=a;for(const[,g]of this.c)g.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$7p=S}),define(ee[214],te([0,1,76,213]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class s extends P.$Mp{constructor(C,S,f){super(C,S,f),this.s()}r(C){return C.add(new D.$7p)}}e.$8p=s}),define(ee[215],te([0,1,13,42,158,76]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class C extends M.$Np{constructor(f,a,g){super(f,a,g),this.s()}r(f){const a=f.add(new s.$Yp(P.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:g,signal:b})=>this.t(`terminated by itself with code ${g}, signal: ${b}`))),D.ProxyChannel.toService((0,D.$uh)(a.getChannel("watcher")))}}e.$Zp=C}),define(ee[91],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,C]of s)this.set(M,C)}set(s,M){const C=this.a.get(s);return this.a.set(s,M),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Lh=P}),define(ee[216],te([0,1,8,14,2,75,206,6,91,101]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const g=!1;class b extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class p{constructor($=new f.$Lh,m=!1,h,c=g){this.f=$,this.g=m,this.h=h,this.i=c,this.o=new Set,this.f.set(S.$Mh,this),this._globalGraph=c?h?._globalGraph??new C.$$p(k=>k):void 0}createChild($){return new p($,this.g,this,this.i)}invokeFunction($,...m){const h=y.traceInvocation(this.i,$);let c=!1;try{return $({get:u=>{if(c)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(u,h);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...m)}finally{c=!0,h.stop()}}createInstance($,...m){let h,c;return $ instanceof M.$Kh?(h=y.traceCreation(this.i,$.ctor),c=this.j($.ctor,$.staticArguments.concat(m),h)):(h=y.traceCreation(this.i,$),c=this.j($,m,h)),h.stop(),c}j($,m=[],h){const c=S._util.getServiceDependencies($).sort((t,l)=>t.index-l.index),k=[];for(const t of c){const l=this.m(t.id,h);l||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(l)}const u=c.length>0?c[0].index:m.length;if(m.length!==u){console.trace(`[createInstance] First service dependency of ${$.name} at position ${u+1} conflicts with ${m.length} static arguments`);const t=u-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,u)}return Reflect.construct($,m.concat(k))}k($,m){if(this.f.get($)instanceof M.$Kh)this.f.set($,m);else if(this.h)this.h.k($,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const m=this.f.get($);return!m&&this.h?this.h.l($):m}m($,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof M.$Kh?this.q($,h,m.branch($,!0)):(m.branch($,!1),h)}q($,m,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,m,h)}finally{this.o.delete($)}}r($,m,h){const c=new C.$$p(t=>t.id.toString());let k=0;const u=[{id:$,desc:m,_trace:h}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),k++>1e3)throw new b(c);for(const l of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${$} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof M.$Kh){const i={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:l}of t){if(this.l(l.id)instanceof M.$Kh){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}c.removeNode(l)}}return this.l($)}s($,m,h=[],c,k){if(this.f.get($)instanceof M.$Kh)return this.t($,m,h,c,k);if(this.h)return this.h.s($,m,h,c,k);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t($,m,h=[],c,k){if(c){const u=new p(void 0,this.g,this,this.i);u.c=String($);const t=new Map,l=new P.$0g(()=>{const r=u.j(m,h,k);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const v of n)o.apply(r,v)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let v=t.get(i);return v||(v=new a.$1c,t.set(i,v)),(A,E,I)=>{const L=v.push([A,E,I]);return(0,s.$Pc)(L)}}if(i in r)return r[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return l.value[i]=n,!0},getPrototypeOf(r){return m.prototype}})}else return this.j(m,h,k)}u($,m){if(m&&console.warn($),this.g)throw new Error($)}}e.$_p=p;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,m){return $?new y(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation($,m){return $?new y(1,m.name):y.c}static{this.f=0}constructor($,m){this.type=$,this.name=m,this.g=Date.now(),this.h=[]}branch($,m){const h=new y(3,$.toString());return this.h.push([$,m,h]),h}stop(){const $=Date.now()-this.g;y.f+=$;let m=!1;function h(k,u){const t=[],l=new Array(k+1).join("	");for(const[r,i,n]of u.h)if(i&&n){m=!0,t.push(`${l}CREATES -> ${r}`);const o=h(k+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];($>2||m)&&y.all.add(c.join(`
`))}}e.$aq=y}),define(ee[217],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Twb=e.IssueType=void 0;var D;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={})),e.$Twb=(0,P.$Nh)("issueService")}),define(ee[5],te([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,p.$Nh)("logService"),e.$9i=(0,p.$Nh)("loggerService");function d(){return new Date().toISOString()}function y(A){return(0,a.$Bf)(A)}e.$0i=y;var w;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$$i=w.Info;function $(A,E,I){switch(E){case w.Trace:A.trace(I);break;case w.Debug:A.debug(I);break;case w.Info:A.info(I);break;case w.Warning:A.warn(I);break;case w.Error:A.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function m(A,E=!1){let I="";for(let L=0;L<A.length;L++){let F=A[L];if(F instanceof Error&&(F=(0,P.$yi)(F,E)),typeof F=="object")try{F=JSON.stringify(F)}catch{}I+=(L>0?" ":"")+F}return I}class h extends M.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new D.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$aj=h;class c extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...I){this.f(w.Trace)&&this.g(w.Trace,m([E,...I],!0))}debug(E,...I){this.f(w.Debug)&&this.g(w.Debug,m([E,...I]))}info(E,...I){this.f(w.Info)&&this.g(w.Info,m([E,...I]))}warn(E,...I){this.f(w.Warning)&&this.g(w.Warning,m([E,...I]))}error(E,...I){if(this.f(w.Error))if(E instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=E.stack,this.g(w.Error,m(L))}else this.g(w.Error,m([E,...I]))}flush(){}}e.$bj=c;class k extends h{constructor(E=e.$$i){super(),this.setLevel(E),this.g=!S.$j}trace(E,...I){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...I):console.warn(`[main ${d()}]`,E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...I):console.error(`[main ${d()}]`,E,...I))}dispose(){}flush(){}}e.$cj=k;class u extends h{constructor(E=e.$$i,I=!0){super(),this.g=I,this.setLevel(E)}trace(E,...I){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...I):console.log(E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...I):console.log(E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...I):console.log(E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...I):console.log(E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...I):console.error(E,...I))}dispose(){}flush(){}}e.$dj=u;class t extends h{constructor(E,I=e.$$i){super(),this.g=E,this.setLevel(I)}trace(E,...I){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...I])}debug(E,...I){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...I])}info(E,...I){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...I])}warn(E,...I){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...I])}error(E,...I){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...I])}h(E){return typeof E=="string"?E:(0,P.$yi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$ej=t;class l extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const I of this.g)I.setLevel(E);super.setLevel(E)}trace(E,...I){for(const L of this.g)L.trace(E,...I)}debug(E,...I){for(const L of this.g)L.debug(E,...I)}info(E,...I){for(const L of this.g)L.info(E,...I)}warn(E,...I){for(const L of this.g)L.warn(E,...I)}error(E,...I){for(const L of this.g)L.error(E,...I)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$fj=l;class r extends M.$Rc{constructor(E,I,L){if(super(),this.h=E,this.j=I,this.b=new C.$zc,this.c=this.B(new D.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(E){return(0,a.$xf)(E)?[...this.b.values()].find(I=>I.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,I){const L=this.n(E),F=(0,a.$xf)(E)?E:I?.id??(0,s.$Bi)(L.toString()).toString(16);let B=this.b.get(L)?.logger;const se=I?.logLevel==="always"?w.Trace:I?.logLevel;B||(B=this.s(L,se??this.getLogLevel(L)??this.h,{...I,id:F}));const x={logger:B,info:{resource:L,id:F,logLevel:se,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(x.info),this.b.set(L,x),B}n(E){return(0,a.$xf)(E)?(0,f.$ug)(this.j,`${E}.log`):E}setLogLevel(E,I){if(g.URI.isUri(E)){const L=E,F=I,B=this.b.get(L);B&&F!==B.info.logLevel&&(B.info.logLevel=F===this.h?void 0:F,B.logger?.setLevel(F),this.b.set(B.info.resource,B),this.f.fire([L,F]))}else{this.h=E;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,I){const L=this.m(E);L&&I!==!L.info.hidden&&(L.info.hidden=!I,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,I]))}getLogLevel(E){let I;return E&&(I=this.b.get(E)?.info.logLevel),I??this.h}registerLogger(E){const I=this.b.get(E.resource);I?I.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const I=this.b.get(E);I&&(I.logger&&I.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=r;class i{constructor(){this.onDidChangeLogLevel=new D.$Md().event}setLevel(E){}getLevel(){return w.Info}trace(E,...I){}debug(E,...I){}info(E,...I){}warn(E,...I){}error(E,...I){}critical(E,...I){}dispose(){}flush(){}}e.$hj=i;class n extends i{}e.$ij=n;function o(A){if(A.verbose)return w.Trace;if(typeof A.logLevel=="string"){const E=R(A.logLevel.toLowerCase());if(E!==void 0)return E}return e.$$i}e.$jj=o;function v(A){switch(A){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$kj=v;function R(A){switch(A){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$lj=R,e.$mj=new b.$5i("logLevel",v(w.Info))});var _=this&&this.__param||function(Z,e){return function(P,D){e(P,D,Z)}};define(ee[218],te([0,1,15,4,5]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;const M=P.safeStorage;let C=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(f){let a;try{if(a=JSON.parse(f),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const g=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=M.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$j)return Promise.resolve("dpapi");if(D.$k)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$A6b=C,e.$A6b=C=ke([_(0,s.$8i)],C)}),define(ee[219],te([0,1,23,8,14,3,2,9,76,5]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class g extends C.$Rc{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.B(new M.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Qg(0)),this.w=[],this.y=this.B(new D.$Qg(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(p,d):this.z(p,d)}n(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,P.$Tb)(this.j,y);return this.r(),(0,C.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Z)(p))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Op)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,f.$Kp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,f.$Kp)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,P.$Tb)(this.w,y);return this.C(),(0,C.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Z)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,f.$Op)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$gc)(p.fsPath)}}e.$Sp=g}),define(ee[220],te([0,1,23,8,18,22,3,55,69,2,56,13,65,19,62,173,16,118,5,14]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let k=class extends a.$Rc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Md),this.onDidFilesChange=this.X.event,this.Y=this.B(new C.$Md),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$2g)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new a.$Qc;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),r.add(l.onDidChangeFile(i=>this.X.fire(new $.$ok(i,!this.S(l))))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,a.$Pc)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,a.$Mc)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(r){l.push(r)}}),!this.h.has(t)&&await D.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,d.$yg)(t))throw new $.$qk((0,w.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const r=new c.$ab;throw r.message=(0,w.localize)(1,null,t.toString()),r}return l}async m(t){const l=await this.j(t);if((0,$.$bk)(l)||(0,$.$$j)(l)||(0,$.$ck)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const l=await this.j(t);if((0,$.$bk)(l)||(0,$.$$j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.s(t,l)}catch(r){throw(0,$.$lk)(r)===$.FileSystemProviderErrorCode.FileNotFound?new $.$qk((0,w.localize)(2,null,this.qb(t)),1):(0,$.$jk)(r)}}async s(t,l){const r=await this.j(t),i=this.S(r),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,v=l?.resolveMetadata,R=await r.stat(t);let A;return this.t(r,t,R,void 0,!!v,(E,I)=>(A||(A=g.$Th.forUris(()=>!i),A.set(t,!0),n&&A.fill(!0,n)),A.get(E.resource)||A.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?I===1:!1))}async t(t,l,r,i,n,o){const{providerExtUri:v}=this.R(t),R={resource:l,name:v.basename(l),isFile:(r.type&$.FileType.File)!==0,isDirectory:(r.type&$.FileType.Directory)!==0,isSymbolicLink:(r.type&$.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Bk)({mtime:r.mtime,size:r.size}),children:void 0};if(R.isDirectory&&o(R,i)){try{const A=await t.readdir(l),E=await D.Promises.settled(A.map(async([I,L])=>{try{const F=v.joinPath(l,I),B=n?await t.stat(F):{type:L};return await this.t(t,F,B,A.length,n,o)}catch(F){return this.b.trace(F),null}}));R.children=(0,P.$Gb)(E)}catch(A){this.b.trace(A),R.children=[]}return R}return R}async resolveAll(t){return D.Promises.settled(t.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),r=await l.stat(t);return this.t(l,t,r,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.u(t,l)}catch(r){return r}return!0}async u(t,l){if(!l?.overwrite&&await this.exists(t))throw new $.$qk((0,w.localize)(3,null,this.qb(t)),3,l)}async createFile(t,l=s.$ae.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,l);return this.r.fire(new $.$nk(t,0,i)),i}async writeFile(t,l,r){const i=this.ob(await this.n(t),t),{providerExtUri:n}=this.R(i);let o=r;if((0,$.$ek)(i)&&!o?.atomic){const v=i.enforceAtomicWriteFile?.(t);v&&(o={...r,atomic:v})}try{await this.w(i,t,o)||await this.U(i,n.dirname(t));let R;if((0,$.$$j)(i)&&!(l instanceof s.$ae))if((0,y.$Yd)(l)){const A=await(0,y.$6d)(l,3);A.ended?R=s.$ae.concat(A.buffer):R=A}else R=(0,y.$3d)(l,A=>s.$ae.concat(A),3);else R=l;!(0,$.$bk)(i)||(0,$.$$j)(i)&&R instanceof s.$ae||(0,$.$$j)(i)&&(0,$.$ek)(i)&&o?.atomic?await this.fb(i,t,o,R):await this.bb(i,t,o,R instanceof s.$ae?(0,s.$le)(R):R),this.r.fire(new $.$nk(t,4))}catch(v){throw new $.$qk((0,w.localize)(4,null,this.qb(t),(0,$.$jk)(v).toString()),(0,$.$mk)(v),o)}return this.resolve(t,{resolveMetadata:!0})}async w(t,l,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.qb(l)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.qb(l)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.qb(l)));if(i)throw new Error((0,w.localize)(8,null,this.qb(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&$.FileType.Directory)throw new $.$qk((0,w.localize)(9,null,this.qb(l)),0,r);if(this.pb(l,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==$.$Ak&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,$.$Bk)({mtime:r.mtime,size:o.size}))throw new $.$qk((0,w.localize)(10,null),3,r);return o}async readFile(t,l,r){const i=await this.m(t);return l?.atomic?this.z(i,t,l,r):this.C(i,t,l,r)}async z(t,l,r,i){return new Promise((n,o)=>{this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{try{const v=await this.C(t,l,r,i);n(v)}catch(v){o(v)}})})}async C(t,l,r,i){const n=await this.D(t,l,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$me)(n.value)}}async readFileStream(t,l,r){const i=await this.m(t);return this.D(i,t,l,r)}async D(t,l,r,i){const n=new M.$Wd(i);let o=r;(0,$.$dk)(t)&&t.enforceAtomicReadFile?.(l)&&(o={...r,atomic:!0});const v=this.J(l,o).then(A=>A,A=>{throw n.dispose(!0),A});let R;try{return typeof o?.etag=="string"&&o.etag!==$.$Ak&&await v,o?.atomic&&(0,$.$dk)(t)||!((0,$.$bk)(t)||(0,$.$ck)(t))||(0,$.$$j)(t)&&o?.preferUnbuffered?R=this.I(t,l,o):(0,$.$ck)(t)?R=this.G(t,l,n.token,o):R=this.H(t,l,n.token,o),R.on("end",()=>n.dispose()),R.on("error",()=>n.dispose()),{...await v,value:R}}catch(A){throw R&&await(0,y.$4d)(R),this.F(A,l,o)}}F(t,l,r){const i=(0,w.localize)(11,null,this.qb(l),(0,$.$jk)(t).toString());return t instanceof $.$sk?new $.$sk(i,t.stat,r):t instanceof $.$rk?new $.$rk(i,t.fileOperationResult,t.size,t.options):new $.$qk(i,(0,$.$mk)(t),r)}G(t,l,r,i=Object.create(null)){const n=t.readFileStream(l,i,r);return(0,y.$0d)(n,{data:o=>o instanceof s.$ae?o:s.$ae.wrap(o),error:o=>this.F(o,l,i)},o=>s.$ae.concat(o))}H(t,l,r,i=Object.create(null)){const n=(0,s.$qe)();return(0,m.$Ip)(t,l,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.F(o,l,i)},r),n}I(t,l,r){const i=(0,y.$1d)(n=>s.$ae.concat(n));return(async()=>{try{let n;r?.atomic&&(0,$.$dk)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(l,n.byteLength,r),i.end(s.$ae.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,l){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new $.$qk((0,w.localize)(12,null,this.qb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==$.$Ak&&l.etag===r.etag)throw new $.$sk((0,w.localize)(13,null),r,l);return this.L(t,r.size,l),r}L(t,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new $.$rk((0,w.localize)(14,null,this.qb(t)),7,l,r)}async canMove(t,l,r){return this.M(t,l,"move",r)}async canCopy(t,l,r){return this.M(t,l,"copy",r)}async M(t,l,r,i){if(t.toString()!==l.toString())try{const n=r==="move"?this.ob(await this.n(t),t):await this.m(t),o=this.ob(await this.n(l),l);await this.Q(n,t,o,l,r,i)}catch(n){return n}return!0}async move(t,l,r){const i=this.ob(await this.n(t),t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"move",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,o==="move"?2:3,v)),v}async copy(t,l,r){const i=await this.m(t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"copy",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,o==="copy"?3:2,v)),v}async N(t,l,r,i,n,o){if(l.toString()===i.toString())return n;const{exists:v,isSameResourceWithDifferentPathCase:R}=await this.Q(t,l,r,i,n,o);if(v&&!R&&o&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,$.$_j)(t))await t.copy(l,i,{overwrite:o});else{const A=await this.resolve(l);A.isDirectory?await this.P(t,A,r,i):await this.O(t,l,r,i)}return n}else return t===r?(await t.rename(l,i,{overwrite:o}),n):(await this.N(t,l,r,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async O(t,l,r,i){if((0,$.$bk)(t)&&(0,$.$bk)(r))return this.hb(t,l,r,i);if((0,$.$bk)(t)&&(0,$.$$j)(r))return this.nb(t,l,r,i);if((0,$.$$j)(t)&&(0,$.$bk)(r))return this.lb(t,l,r,i);if((0,$.$$j)(t)&&(0,$.$$j)(r))return this.jb(t,l,r,i)}async P(t,l,r,i){await r.mkdir(i),Array.isArray(l.children)&&await D.Promises.settled(l.children.map(async n=>{const o=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,o):this.O(t,n.resource,r,o)}))}async Q(t,l,r,i,n,o){let v=!1;if(t===r){const{providerExtUri:A,isPathCaseSensitive:E}=this.R(t);if(E||(v=A.isEqual(l,i)),v&&n==="copy")throw new Error((0,w.localize)(15,null,this.qb(l),this.qb(i)));if(!v&&A.isEqualOrParent(i,l))throw new Error((0,w.localize)(16,null,this.qb(l),this.qb(i)))}const R=await this.exists(i);if(R&&!v){if(!o)throw new $.$qk((0,w.localize)(17,null,this.qb(l),this.qb(i)),4);if(t===r){const{providerExtUri:A}=this.R(t);if(A.isEqualOrParent(l,i))throw new Error((0,w.localize)(18,null,this.qb(l),this.qb(i)))}}return{exists:R,isSameResourceWithDifferentPathCase:v}}R(t){const l=this.S(t);return{providerExtUri:l?d.$kg:d.$mg,isPathCaseSensitive:l}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.ob(await this.j(t),t);await this.U(l,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,0,r)),r}async U(t,l){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.qb(l)));break}catch(n){if((0,$.$lk)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(l)),l=i.dirname(l)}for(let n=r.length-1;n>=0;n--){l=i.joinPath(l,r[n]);try{await t.mkdir(l)}catch(o){if((0,$.$lk)(o)!==$.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.W(t,l)}catch(r){return r}return!0}async W(t,l){const r=this.ob(await this.j(t),t),i=!!l?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,w.localize)(20,null,this.qb(t)));const n=l?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,w.localize)(21,null,this.qb(t)));if(i&&n)throw new Error((0,w.localize)(22,null,this.qb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.pb(t,o);else throw new $.$qk((0,w.localize)(23,null,this.qb(t)),1);if(!!!l?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,w.localize)(24,null,this.qb(t)))}return r}async del(t,l){const r=await this.W(t,l);let i=l;if((0,$.$fk)(r)&&!i?.atomic){const R=r.enforceAtomicDelete?.(t);R&&(i={...l,atomic:R})}const n=!!i?.useTrash,o=!!i?.recursive,v=i?.atomic??!1;await r.delete(t,{recursive:o,useTrash:n,atomic:v}),this.r.fire(new $.$nk(t,1))}async cloneFile(t,l){const r=await this.j(t),i=this.ob(await this.n(l),l);if(r===i&&this.R(r).providerExtUri.isEqual(t,l))return;if(r===i&&(0,$.$ak)(r))return r.cloneFile(t,l);await this.U(i,this.R(i).providerExtUri.dirname(l));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,$.$_j)(r)?n.queue(()=>r.copy(t,l,{overwrite:!0})):n.queue(()=>this.O(r,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const r=new a.$Qc;let i=!1,n=()=>{i=!0};return r.add((0,a.$Pc)(()=>n())),(async()=>{try{const o=await this.$(t,l);i?(0,a.$Mc)(o):n=()=>(0,a.$Mc)(o)}catch(o){this.b.error(o)}})(),r}async $(t,l){const r=await this.j(t),i=(0,S.$Bi)([this.R(r).providerExtUri.getComparisonKey(t),l]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,l)},this.Z.set(i,n)),n.count+=1,(0,a.$Pc)(()=>{n&&(n.count--,n.count===0&&((0,a.$Mc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,a.$Mc)(t.disposable);this.Z.clear()}async bb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,y.$Yd)(i)||(0,y.$Zd)(i)?await this.cb(t,n,i):await this.db(t,n,i)}catch(o){throw(0,$.$jk)(o)}finally{await t.close(n)}})}async cb(t,l,r){let i=0,n;if((0,y.$Zd)(r)){if(r.buffer.length>0){const o=s.$ae.concat(r.buffer);await this.eb(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,v)=>{(0,y.$5d)(n,{onData:async R=>{n.pause();try{await this.eb(t,l,R,R.byteLength,i,0)}catch(A){return v(A)}i+=R.byteLength,setTimeout(()=>n.resume())},onError:R=>v(R),onEnd:()=>o()})})}async db(t,l,r){let i=0,n;for(;(n=r.read())!==null;)await this.eb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async eb(t,l,r,i,n,o){let v=0;for(;v<i;){const R=await t.write(l,n+v,r.buffer,o+v,i-v);v+=R}}async fb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(()=>this.gb(t,l,r,i))}async gb(t,l,r,i){let n;i instanceof s.$ae?n=i:(0,y.$Yd)(i)?n=await(0,s.$me)(i):(0,y.$Zd)(i)?n=await(0,s.$ne)(i):n=(0,s.$ke)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async hb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.ib(t,l,r,i))}async ib(t,l,r,i){let n,o;try{n=await t.open(l,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const v=s.$ae.alloc(this.a);let R=0,A=0,E=0;do E=await t.read(n,R,v.buffer,A,v.byteLength-A),await this.eb(r,o,v,E,R,A),R+=E,A+=E,A===v.byteLength&&(A=0);while(E>0)}catch(v){throw(0,$.$jk)(v)}finally{await D.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async jb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.kb(t,l,r,i))}async kb(t,l,r,i){return r.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.mb(t,l,r,i))}async mb(t,l,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.eb(r,n,s.$ae.wrap(o),o.byteLength,0,0)}catch(o){throw(0,$.$jk)(o)}finally{await r.close(n)}}async nb(t,l,r,i){const n=await(0,s.$me)(this.H(t,l,M.CancellationToken.None));await this.fb(r,i,void 0,n)}ob(t,l){if(t.capabilities&2048)throw new $.$qk((0,w.localize)(25,null,this.qb(l)),6);return t}pb(t,l){if((l.permissions??0)&$.FilePermission.Readonly)throw new $.$qk((0,w.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===b.Schemas.file?t.fsPath:t.toString(!0)}};e.$Jp=k,e.$Jp=k=ke([_(0,h.$8i)],k)}),define(ee[92],te([0,1,45,309,8,31,18,3,33,2,9,4,19,62,21,177,16,118,219,49,215,214]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0,(()=>{try{(0,D.gracefulify)(P)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.$yi)(l)}`)}})();class t extends h.$Sp{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$zc(n=>p.$lg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$l&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let v;o.isSymbolicLink()?v=(await this.stat((0,p.$ug)(r,o.name))).type:v=this.M(o),n.push([o.name,v])}catch(v){this.a.trace(v)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Rg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await y.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,d.$1d)(v=>C.$ae.concat(v.map(R=>C.$ae.wrap(R))).buffer);return(0,m.$Ip)(this,r,o,v=>v.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,p.$ug)((0,p.$tg)(r),`${(0,p.$rg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,o){const v=new a.$Qc;try{v.add(await this.O(r)),v.add(await this.O(i)),await this.S(i,n,o,!0);try{await this.rename(i,r,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{v.dispose()}}async S(r,i,n,o){let v;try{const R=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(R)){if(!n.overwrite)throw(0,$.$ik)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$ik)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(r,{create:!0,unlock:n.unlock},o),await this.write(v,0,i,0,i.byteLength)}catch(R){throw await this.gb(r,R)}finally{typeof v=="number"&&await this.close(v)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const o=this.H(r);let v;(0,$.$0j)(i)&&!n&&(v=await this.O(r));let R;try{if((0,$.$0j)(i)&&i.unlock)try{const{stat:E}=await y.SymlinkSupport.stat(o);E.mode&128||await y.Promises.chmod(o,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let A;if((0,$.$0j)(i)){if(b.$j)try{await y.Promises.truncate(o,0),A="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}A||(A="w")}else A="r";R=await y.Promises.open(o,A)}catch(A){throw v?.dispose(),(0,$.$0j)(i)?await this.gb(r,A):this.fb(A)}if(this.U.set(R,0),(0,$.$0j)(i)&&this.X.set(R,r),v){const A=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${o})`),this.W.set(R,v),A&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${o})`),A.dispose())}return R}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,v){const R=this.Z(r,i);let A=null;try{A=(await y.Promises.read(r,n,o,v,R)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,R,A)}return A}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const o=this.U.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,o+n):this.U.delete(r)))}async write(r,i,n,o,v){return(0,s.$$g)(()=>this.ab(r,i,n,o,v),100,3)}async ab(r,i,n,o,v){const R=this.Z(r,i);let A=null;try{A=(await y.Promises.write(r,n,o,v,R)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,R,A)}return A}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,g.$ic)((0,g.$lc)(n),`${(0,g.$mc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let v=!1;try{const{stat:R,symbolicLink:A}=await y.SymlinkSupport.stat(n);v=R.isDirectory()&&!A}catch{}if(v)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.fb(n)}}async rename(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.bb(r,i,"move",n.overwrite),await y.Promises.rename(o,v)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(2,null,(0,g.$mc)(o),(0,g.$mc)((0,g.$lc)(v)),R.toString()))),this.fb(R)}}async copy(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.bb(r,i,"copy",n.overwrite),await y.Promises.copy(o,v,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(3,null,(0,g.$mc)(o),(0,g.$mc)((0,g.$lc)(v)),R.toString()))),this.fb(R)}}async bb(r,i,n,o){const v=this.H(r),R=this.H(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,f.$Vf)(v,R,!0)),A){if(n==="copy")throw(0,$.$ik)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,$.$ik)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!o)throw(0,$.$ik)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);I.type&$.FileType.File&&L.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const o=this.H(r),v=this.H(i),R=!!(this.capabilities&1024);if((0,f.$Vf)(o,v,!R))return;const A=new a.$Qc;try{A.add(await this.O(r)),A.add(await this.O(i)),n&&await y.Promises.mkdir((0,g.$lc)(v),{recursive:!0}),await y.Promises.copyFile(o,v)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{A.dispose()}}t(r,i,n){return new k.$Zp(o=>r(o),o=>i(o),n)}F(r,i,n){return new u.$8p(o=>r(o),o=>i(o),n)}fb(r){if(r instanceof $.$hk)return r;let i=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$ik)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,$.$ik)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$9p=t}),define(ee[221],te([0,1,3,92,2,18,62,22]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class f extends s.$Rc{constructor(b,p){super(),this.a=b,this.b=p,this.F=new Map,this.G=new Map}call(b,p,d){const y=this.c(b);switch(p){case"stat":return this.g(y,d[0]);case"readdir":return this.h(y,d[0]);case"open":return this.r(y,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(y,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(y,d[0],d[1],d[2]);case"rename":return this.z(y,d[0],d[1],d[2]);case"copy":return this.C(y,d[0],d[1],d[2]);case"cloneFile":return this.D(y,d[0],d[1]);case"mkdir":return this.w(y,d[0]);case"delete":return this.y(y,d[0],d[1]);case"watch":return this.I(y,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${p} not found`)}listen(b,p,d){const y=this.c(b);switch(p){case"fileChange":return this.H(y,d[0]);case"readFileStream":return this.m(y,d[0],d[1])}throw new Error(`Unknown event ${p}`)}g(b,p){const d=this.f(b,p,!0);return this.a.stat(d)}h(b,p){const d=this.f(b,p);return this.a.readdir(d)}async j(b,p,d){const y=this.f(b,p,!0),w=await this.a.readFile(y,d);return M.$ae.wrap(w)}m(b,p,d){const y=this.f(b,p,!0),w=new S.$Wd,$=new P.$Md({onDidRemoveLastListener:()=>{w.cancel()}}),m=this.a.readFileStream(y,d,w.token);return(0,C.$5d)(m,{onData:h=>$.fire(M.$ae.wrap(h)),onError:h=>$.fire(h),onEnd:()=>{$.fire("end"),$.dispose(),w.dispose()}}),$.event}n(b,p,d,y){const w=this.f(b,p);return this.a.writeFile(w,d.buffer,y)}r(b,p,d){const y=this.f(b,p,!0);return this.a.open(y,d)}s(b){return this.a.close(b)}async t(b,p,d){const y=M.$ae.alloc(d),w=0,$=await this.a.read(b,p,y.buffer,w,d);return[y,$]}u(b,p,d,y,w){return this.a.write(b,p,d.buffer,y,w)}w(b,p){const d=this.f(b,p);return this.a.mkdir(d)}y(b,p,d){const y=this.f(b,p);return this.a.delete(y,d)}z(b,p,d,y){const w=this.f(b,p),$=this.f(b,d);return this.a.rename(w,$,y)}C(b,p,d,y){const w=this.f(b,p),$=this.f(b,d);return this.a.copy(w,$,y)}D(b,p,d){const y=this.f(b,p),w=this.f(b,d);return this.a.cloneFile(y,w)}H(b,p){const d=new P.$Md({onWillAddFirstListener:()=>{this.F.set(p,this.L(b,d))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(p)),this.F.delete(p)}});return d.event}async I(b,p,d,y,w){const $=this.F.get(p);if($){const m=this.f(b,y),h=$.watch(d,m,w);this.G.set(p+d,h)}}async J(b,p){const d=b+p,y=this.G.get(d);y&&((0,s.$Mc)(y),this.G.delete(d))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Er=f;class a extends s.$Rc{constructor(b,p,d,y){super(),this.c=b,this.f=d,this.g=y,this.a=new Map,this.b=this.B(new D.$9p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(b){const p=this.B(new P.$Md);this.B(p.event(d=>{b.fire(d.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(d=>p.fire(d))),this.B(this.b.onDidWatchError(d=>b.fire(d)))}j(b){}m(b){}watch(b,p,d){const y=this.m(this.g);return Array.isArray(y)&&(d.excludes=[...d.excludes,...y]),this.a.set(b,this.b.watch(p,d)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Fr=a}),define(ee[222],te([0,1,15,176,4,7,16,9,221,153]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0;class g extends f.$Er{constructor(d,y,w){super(d,y),this.M=w}c(d){return a.$Im}f(d,y){return M.URI.revive(y)}async y(d,y,w){if(!w.useTrash)return super.y(d,y,w);const $=this.f(d,y),m=(0,S.$gc)($.fsPath);try{await P.shell.trashItem(m)}catch{throw(0,C.$ik)(s.$j?(0,D.localize)(0,null,(0,S.$mc)(m)):(0,D.localize)(1,null,(0,S.$mc)(m)),C.FileSystemProviderErrorCode.Unknown)}}L(d,y){return new b(d,y,this.b,this.M)}}e.$I6b=g;class b extends f.$Fr{watch(d,y,w){if(w.recursive)throw(0,C.$ik)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,w)}}}),define(ee[223],te([0,1,5]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=void 0;class D extends P.$bj{constructor(M=P.$$i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:S}of this.m)(0,P.log)(M,C,S);this.m=[]}g(M,C){this.n?(0,P.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$G3b=D}),define(ee[224],te([0,1,7,3,5,2]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0;class C extends s.$gj{constructor(b,p,d,y,w){super(p,d,y),this.r=b,this.t=w,this.B(w.listen("onDidChangeLogLevel",b)($=>{(0,s.$0i)($)?super.setLogLevel($):super.setLogLevel(P.URI.revive($[0]),$[1])})),this.B(w.listen("onDidChangeVisibility",b)(([$,m])=>super.setVisibility(P.URI.revive($),m))),this.B(w.listen("onDidChangeLoggers",b)(({added:$,removed:m})=>{for(const h of $)super.registerLogger({...h,resource:P.URI.revive(h.resource)});for(const h of m)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$ej({log:(b,p)=>{this.t.call("consoleLog",[b,p])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,p){super.setLogLevel(b,p),this.t.call("setLogLevel",[b,p])}setVisibility(b,p){super.setVisibility(b,p),this.t.call("setVisibility",[this.n(b),p])}s(b,p,d){return new S(this.t,b,p,d,this.r)}static setLogLevel(b,p,d){return b.call("setLogLevel",[p,d])}}e.$7q=C;class S extends s.$bj{constructor(b,p,d,y,w){super(y?.logLevel==="always"),this.r=b,this.s=p,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[p,y,w]).then(()=>{this.u(this.n),this.m=!0})}g(b,p){const d=[[b,p]];this.m?this.u(d):this.n.push(...d)}u(b){this.r.call("log",[this.s,b])}}class f{constructor(b,p){this.a=b,this.b=p}listen(b,p){const d=this.b(b);switch(p){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,d)),removed:[...y.removed].map(w=>this.c(w,d))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,y=>[d.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$0i)(y)?y:[d.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(b,p,d){const y=this.b(b);switch(p){case"setLogLevel":return(0,s.$0i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${p}`)}c(b,p){return{...b,resource:p.transformOutgoingURI(b.resource)}}}e.$8q=f;class a extends M.$Rc{constructor(b,p){super(),p.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(d=>p.call("setLogLevel",[d]))),p.call("getRegisteredLoggers").then(d=>{for(const y of d)b.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([d,y])=>b.setVisibility(P.URI.revive(d),y))),this.B(p.listen("onDidChangeLoggers")(({added:d,removed:y})=>{for(const w of d)b.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of y)b.deregisterLogger(w.resource)}))}}e.$9q=a}),define(ee[225],te([0,1,2,5]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class s extends P.$Rc{constructor(C,S=[]){super(),this.a=new D.$fj([C,...S]),this.B(C.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...S){this.a.trace(C,...S)}debug(C,...S){this.a.debug(C,...S)}info(C,...S){this.a.info(C,...S)}warn(C,...S){this.a.warn(C,...S)}error(C,...S){this.a.error(C,...S)}flush(){this.a.flush()}}e.$vN=s}),define(ee[226],te([0,1,31,7,5]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;class M{constructor(S){this.b=S,this.a=new P.$zc}listen(S,f,a){switch(f){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,a){switch(f){case"createLogger":this.c(D.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(D.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$0i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(D.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:D.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(a[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,a){this.a.set(S,this.b.createLogger(S,f,a))}d(S,f){let a=console.log;switch(S){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...f)}e(S,f){const a=this.a.get(S);if(!a)throw new Error("Create the logger before logging");for(const[g,b]of f)(0,s.log)(a,g,b)}}e.$E7b=M}),define(ee[227],te([0,1,16,5]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function M(a,g,b,p,d){try{const y=await new Promise(($,m)=>{Z(["@vscode/spdlog"],$,m)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(a,g,b,p);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function C(a,g,b){switch(g){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function S(a,g){switch(g){case D.LogLevel.Trace:a.setLevel(s.Trace);break;case D.LogLevel.Debug:a.setLevel(s.Debug);break;case D.LogLevel.Info:a.setLevel(s.Info);break;case D.LogLevel.Warning:a.setLevel(s.Warning);break;case D.LogLevel.Error:a.setLevel(s.Error);break;case D.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class f extends D.$bj{constructor(g,b,p,d,y){super(),this.m=[],this.setLevel(y),this.n=this.s(g,b,p,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(g,b,p,d){const y=p?6:1,w=30/y*P.$Dk.MB,$=await M(g,b,w,y,d);if($){this.r=$,S(this.r,this.getLevel());for(const{level:m,message:h}of this.m)C(this.r,m,h);this.m=[]}}g(g,b){this.r?C(this.r,g,b):this.getLevel()<=g&&this.m.push({level:g,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kN=f}),define(ee[228],te([0,1,32,5,227]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;class M extends D.$gj{s(S,f,a){return new s.$kN((0,P.$dg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.$lN=M}),define(ee[66],te([0,1,31,3,6,5,228]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=e.$56b=void 0,e.$56b=(0,s.$Oh)(M.$9i);class S extends C.$lN{constructor(){super(...arguments),this.u=new P.$zc}createLogger(a,g,b){b!==void 0&&this.u.set(this.n(a),b);try{return super.createLogger(a,g)}catch(p){throw this.u.delete(this.n(a)),p}}registerLogger(a,g){g!==void 0&&this.u.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const b of super.getRegisteredLoggers())a===this.u.get(b.resource)&&g.push(b);return g}getOnDidChangeLogLevelEvent(a){return D.Event.filter(this.onDidChangeLogLevel,g=>(0,M.$0i)(g)||this.w(g[0],a))}getOnDidChangeVisibilityEvent(a){return D.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,a))}getOnDidChangeLoggersEvent(a){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(p=>this.w(p.resource,a)),removed:[...g.removed].filter(p=>this.w(p.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,b]of this.u)b===a&&this.deregisterLogger(g)}w(a,g){const b=this.u.get(a);return b===void 0||b===g}dispose(){super.dispose(),this.u.clear()}}e.$66b=S}),define(ee[229],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=e.$X6b=e.$W6b=e.$V6b=void 0;function P(C){return C.submenu!==void 0}e.$V6b=P;function D(C){return C.id==="vscode.menubar.separator"}e.$W6b=D;function s(C){return C.uri!==void 0}e.$X6b=s;function M(C){return!P(C)&&!D(C)&&!s(C)}e.$Y6b=M}),define(ee[39],te([0,1,3,69,2,6]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=void 0,e.$dn=(0,M.$Nh)("policy");class C extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[p,d])=>({...b,[p]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[g,b])=>({...a,[g]:{definition:b,value:this.g.get(g)}}),{})}}e.$en=C;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$fn=S}),define(ee[230],te([0,1,8,3,69,12,16,5,39]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;function a(b,p){const d=[];for(const y of new Set(s.Iterable.concat(b.keys(),p.keys())))b.get(y)!==p.get(y)&&d.push(y);return d}let g=class extends f.$en{constructor(p,d,y){super(),this.m=p,this.n=d,this.s=y,this.c=this.B(new P.$Qg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(p));this.B(d.watch(p)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const d=await this.n.readFile(this.m),y=JSON.parse(d.value.toString());if(!(0,M.$zf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&p.set(w,y[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return p}async w(){const p=await this.u(),d=a(this.g,p);this.g=p,d.length>0&&this.h.fire(d)}};e.$X7b=g,e.$X7b=g=ke([_(1,C.$9j),_(2,S.$8i)],g)}),define(ee[231],te([0,1,3,2,39]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=void 0;class M{constructor(f){this.b=f,this.a=new D.$Qc}listen(f,a){switch(a){case"onDidChange":return P.Event.map(this.b.onDidChange,g=>g.reduce((b,p)=>({...b,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(f,a,g){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$x7b=M;class C extends s.$en{constructor(f,a){super(),this.a=a;for(const g in f){const{definition:b,value:p}=f[g];this.f[g]=b,p!==void 0&&this.g.set(g,p)}this.a.listen("onDidChange")(g=>{for(const b in g){const p=g[b];p===null?this.g.delete(b):this.g.set(b,p)}this.h.fire(Object.keys(g))})}async j(f){const a=await this.a.call("updatePolicyDefinitions",f);for(const g in a)this.g.set(g,a[g])}}e.$y7b=C}),define(ee[232],te([0,1,39,8,310,2,5]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=void 0;let S=class extends P.$en{constructor(a,g){super(),this.m=a,this.n=g,this.a=new D.$Mg,this.b=this.B(new M.$Sc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((g,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,p=>{this.t(p),g()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),b(p)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const b=a[g];b===void 0?this.g.delete(g):this.g.set(g,b)}this.h.fire(Object.keys(a))}};e.$W7b=S,e.$W7b=S=ke([_(0,C.$8i)],S)}),define(ee[77],te([0,1,4,35]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.context<"u"){const M=P.$h.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ee[24],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,P.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,8,5]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=void 0;let s=class{constructor(C,S,f){this.a=C,this.b=S,this.c=f}async inspect(C){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Tg)(C);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$L6b=s,e.$L6b=s=ke([_(2,D.$8i)],s)}),define(ee[78],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0,e.$O6b=(0,P.$Nh)("protocolMainService")}),define(ee[43],te([0,1,135,12]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class s{constructor(){this.a=new Map}add(C,S){P.ok(D.$xf(C)),P.ok(D.$zf(S)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,S)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$bn=new s}),define(ee[234],te([0,1,3,43]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,a){this.a[s(f)]=a,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;D.$bn.add(e.$cn.JSONContribution,C)}),define(ee[57],te([0,1,23,3,12,161,17,234,43]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$gn={Configuration:"base.contributions.configuration"};var g;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const b=f.$bn.as(S.$cn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new D.$Md,this.onDidSchemaChange=this.i.event,this.j=new D.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),b.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),b.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),b.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.$qn.test(o)){const v=this.a.get(o),R=v?.valuesSources??new Map;if(n)for(const L of Object.keys(i[o]))R.set(L,n);const A={...v?.value||{},...i[o]};this.a.set(o,{source:n,value:A,valuesSources:R});const E=(0,C.$ri)(o),I={type:"object",default:A,description:M.localize(1,null,E),$ref:e.$nn,defaultDefaultValue:A,source:s.$xf(n)?void 0:n,defaultValueSource:n};r.push(...w(o)),this.d[o]=I,this.b.properties[o]=I}else{this.a.set(o,{value:i[o],source:n});const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),v=s.$xf(i)?i:i?.id,R=s.$xf(o?.source)?o?.source:o?.source?.id;if(v===R)if(l.add(n),this.a.delete(n),e.$qn.test(n))delete this.d[n],delete this.b.properties[n];else{const A=this.d[n];A&&(this.w(n,A),this.r(n,A))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,l){const r=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,i,n=3,o){n=s.$Gf(t.scope)?n:t.scope;const v=t.properties;if(v)for(const A in v){const E=v[A];if(l&&c(A,E)){delete v[A];continue}if(E.source=r,E.defaultDefaultValue=v[A].default,this.w(A,E),e.$qn.test(A)?E.scope=void 0:(E.scope=s.$Gf(E.scope)?n:E.scope,E.restricted=s.$Gf(E.restricted)?!!i?.includes(A):E.restricted),v[A].hasOwnProperty("included")&&!v[A].included){this.f[A]=v[A],delete v[A];continue}else this.d[A]=v[A],v[A].policy?.name&&this.e.set(v[A].policy.name,A);!v[A].deprecationMessage&&v[A].markdownDeprecationMessage&&(v[A].deprecationMessage=v[A].markdownDeprecationMessage),o.add(A)}const R=t.allOf;if(R)for(const A of R)this.p(A,l,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$hn.properties[t]=l,l.scope){case 1:e.$in.properties[t]=l;break;case 2:e.$jn.properties[t]=l;break;case 6:e.$kn.properties[t]=l;break;case 3:e.$ln.properties[t]=l;break;case 4:e.$mn.properties[t]=l;break;case 5:e.$mn.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$hn.properties[t],l.scope){case 1:delete e.$in.properties[t];break;case 2:delete e.$jn.properties[t];break;case 6:delete e.$kn.properties[t];break;case 3:delete e.$ln.properties[t];break;case 4:case 5:delete e.$mn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$nn};this.w(l,r),e.$hn.properties[l]=r,e.$in.properties[l]=r,e.$jn.properties[l]=r,e.$kn.properties[l]=r,e.$ln.properties[l]=r,e.$mn.properties[l]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=t,e.$in.patternProperties[e.$pn]=t,e.$jn.patternProperties[e.$pn]=t,e.$kn.patternProperties[e.$pn]=t,e.$ln.patternProperties[e.$pn]=t,e.$mn.patternProperties[e.$pn]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Ef(i)&&(i=l.defaultDefaultValue,n=void 0),s.$Ef(i)&&(i=m(l.type)),l.default=i,l.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");e.$pn=`^(${d})+$`,e.$qn=new RegExp(e.$pn);function w(u){const t=[];if(e.$qn.test(u)){let l=y.exec(u);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=y.exec(u)}}return(0,P.$Lb)(t)}e.$rn=w;function $(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.$sn=$;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=m;const h=new p;f.$bn.add(e.$gn.Configuration,h);function c(u,t){return u.trim()?e.$qn.test(u)?M.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,u,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$un=c;function k(){const u=[],t=h.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$vn=k}),define(ee[119],te([0,1,23,3,44,2,31,37,12,7,17,57,43]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function d(l){return Object.isFrozen(l)?l:S.$3m(l)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,g.$pi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,v=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:v}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,g.$pi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Lb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Lb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$2m(this.contents),n=S.$2m(this.overrides),o=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const R of r)if(v.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(i,R.contents);for(const A of R.overrides){const[E]=n.filter(I=>P.$tb(I.identifiers,A.identifiers));E?(this.h(E.contents,A.contents),E.keys.push(...A.keys),E.keys=P.$Lb(E.keys)):n.push(S.$2m(A))}for(const A of R.keys)o.indexOf(A)===-1&&o.push(A)}return new y(i,o,n,v.every(R=>R instanceof y)?void 0:v)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of P.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let v=this.contents[o];const R=i[o];R&&(typeof v=="object"&&typeof R=="object"?(v=S.$2m(v),this.h(v,R)):v=R),n[o]=v}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$zf(r[n])&&f.$zf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$2m(i[n])}}i(r){let i=null,n=null;const o=v=>{v&&(n?this.h(n,v):n=S.$2m(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===r?i=v.contents:v.identifiers.includes(r)&&o(v.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,g.$oi)(this.contents,r),b.$qn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$tb(n.identifiers,(0,b.$rn)(r))),1))}j(r,i,n){(0,g.$ni)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$qn.test(r)&&this.overrides.push({identifiers:(0,b.$rn)(r),keys:Object.keys(this.contents[r]),contents:(0,g.$mi)(this.contents[r],o=>console.error(o))})}}e.$wn=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Gf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:v,restricted:R,hasExcludedProperties:A}=this.h(r,i);this.b=new y(n,o,v,A?[r]:void 0),this.c=R||[]}g(r){let i={},n=null,o=[];const v=[],R=[];function A(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}const E={onObjectBegin:()=>{const I={};A(I),v.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const I=[];A(I),v.push(o),o=I,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:A,onError:(I,L,F)=>{R.push({error:I,offset:L,length:F})}};if(r)try{s.$Ym(r,E),i=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return i}h(r,i){const n=p.$bn.as(b.$gn.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const v=(0,g.$mi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(r),A=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:v,keys:R,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let v=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:v};const R={},A=[];for(const E in r)if(b.$qn.test(E)&&n){const I=this.i(r[E],i,!1,o);R[E]=I.raw,v=v||I.hasExcludedProperties,A.push(...I.restricted)}else{const I=i[E],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&A.push(E),!o.exclude?.includes(E)&&(o.include?.includes(E)||(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&!(o.skipRestricted&&I?.restricted))?R[E]=r[E]:v=!0}return{raw:R,restricted:A,hasExcludedProperties:v}}j(r,i){const n=[];for(const o of Object.keys(r))if(b.$qn.test(o)){const v={};for(const R in r[o])v[R]=r[o][R];n.push({identifiers:(0,b.$rn)(o),keys:Object.keys(v),contents:(0,g.$mi)(v,i)})}return n}}e.$xn=w;class $ extends M.$Rc{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&n.isEqual(v.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=$;class m{constructor(r,i,n,o,v,R,A,E,I,L,F,B,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=v,this.f=R,this.g=A,this.h=E,this.i=I,this.j=L,this.k=F,this.l=B,this.m=se}get value(){return d(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return d(o.value)},get override(){return d(o.override)},get merged(){return d(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,n,o,v=new y,R=new y,A=new C.$zc,E=new y,I=new C.$zc){this.c=r,this.d=i,this.f=n,this.g=o,this.h=v,this.i=R,this.j=A,this.l=E,this.m=I,this.a=null,this.b=new C.$zc,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),v=this.u(i.resource,n),R=i.resource?this.m.get(i.resource)||this.l:this.l,A=new Set;for(const E of o.overrides)for(const I of E.identifiers)o.getOverrideValue(r,I)!==void 0&&A.add(I);return new m(r,i,o.getValue(r),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,v||void 0,R)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:v,removed:R}=u(this.c,r);i=[...o,...v,...R]}for(const o of i)for(const v of(0,b.$rn)(o)){const R=this.c.getKeysForOverrideIdentifier(v),A=r.getKeysForOverrideIdentifier(v),E=[...A.filter(I=>R.indexOf(I)===-1),...R.filter(I=>A.indexOf(I)===-1),...R.filter(I=>!S.$6m(this.c.override(v).getValue(I),r.override(v).getValue(I)))];n.push([v,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this.d,r),v=[...i,...n,...o];return v.length&&this.updatePolicyConfiguration(r),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.applicationConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateApplicationConfiguration(r),{keys:R,overrides:v}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.localUserConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateLocalUserConfiguration(r),{keys:R,overrides:v}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.remoteUserConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateRemoteUserConfiguration(r),{keys:R,overrides:v}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.workspaceConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateWorkspaceConfiguration(r),{keys:R,overrides:v}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:v,removed:R,overrides:A}=u(n,i),E=[...o,...v,...R];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:v,overrides:R}=u(i,void 0);return{keys:[...n,...o,...v],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const v=this.m.get(r);v&&(n=n.merge(v))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:v}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:v}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),v=this.x(r.user),R=this.x(r.workspace),A=r.folders.reduce((E,I)=>(E.set(a.URI.revive(I[0]),this.x(I[1])),E),new C.$zc);return new h(i,n,o,v,new y,R,A,new y,new C.$zc)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$zn=h;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const o of l)o.keys.forEach(v=>r.add(v)),o.overrides.forEach(([v,R])=>{const A=(0,C.$wc)(i,v,new Set);R.forEach(E=>A.add(E))});const n=[];return i.forEach((o,v)=>n.push([v,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$An=c;class k{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of r.keys)this.affectedKeys.add(v);for(const[,v]of r.overrides)for(const R of v)this.affectedKeys.add(R);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const v=o+n.length;if(v>=this.d.length)return!1;const R=this.d.charCodeAt(v);if(R!==this.b&&R!==this.c)return!1;if(i){const A=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!S.$6m(A,E)}return!0}}e.$Bn=k;function u(l,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,l?.rawConfiguration),v=[],R=l?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const E=A.filter(I=>!R.includes(I));for(const I of E)v.push([I,r.getKeysForOverrideIdentifier(I)])}if(l){const E=R.filter(I=>!A.includes(I));for(const I of E)v.push([I,l.getKeysForOverrideIdentifier(I)])}if(r&&l){for(const E of R)if(A.includes(E)){const I=t({contents:l.getOverrideValue(void 0,E)||{},keys:l.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});v.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:n,updated:o,overrides:v}}function t(l,r){const i=l?r?l.keys.filter(v=>r.keys.indexOf(v)===-1):[...l.keys]:[],n=r?l?r.keys.filter(v=>l.keys.indexOf(v)===-1):[...r.keys]:[],o=[];if(l&&r){for(const v of r.keys)if(l.keys.indexOf(v)!==-1){const R=(0,g.$pi)(r.contents,v),A=(0,g.$pi)(l.contents,v);S.$6m(R,A)||o.push(v)}}return{added:i,removed:n,updated:o}}}),define(ee[235],te([0,1,23,3,2,37,12,119,57,5,39,43]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=void 0;class p extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new S.$wn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$bn.as(f.$gn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:m})=>this.c(Array.from($),m))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,m){this.h($,b.$bn.as(f.$gn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new S.$wn;const $=b.$bn.as(f.$gn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,m){const h=this.f();for(const c of $){const k=h[c],u=m[c];k!==void 0?this.b.addValue(c,k):u?this.b.addValue(c,u.default):this.b.removeValue(c)}}}e.$Cn=p;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new S.$wn}async initialize(){return this.configurationModel}}e.$Dn=d;let y=class extends s.$Rc{get configurationModel(){return this.b}constructor($,m,h){super(),this.c=$,this.f=m,this.g=h,this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new S.$wn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const m={},h=[],c=b.$bn.as(f.$gn.Configuration).getConfigurationProperties();for(const k of $){const u=c[k];if(!u){h.push(k);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(k),m[u.policy.name]={type:u.type}}}return(0,C.$Kf)(m)||await this.f.updatePolicyDefinitions(m),h}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const m=b.$bn.as(f.$gn.Configuration).getPolicyConfigurations(),h=(0,P.$Gb)($.map(c=>m.get(c)));this.m(h,!0)}m($,m){this.g.trace("PolicyConfiguration#update",$);const h=b.$bn.as(f.$gn.Configuration).getConfigurationProperties(),c=[],k=this.b.isEmpty();for(const u of $){const t=h[u]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(k?l!==void 0:!(0,M.$6m)(this.b.getValue(u),l))&&c.push([u,l])}else this.b.getValue(u)!==void 0&&c.push([u,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const u=this.b;this.b=new S.$wn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,l]of c)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);m&&this.a.fire(this.b)}}};e.$En=y,e.$En=y=ke([_(1,g.$dn),_(2,a.$8i)],y)}),define(ee[236],te([0,1,8,3,2,19,17,119,235,39]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0;class g extends s.$Rc{constructor(p,d,y,w){super(),this.j=p,this.h=this.B(new D.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Cn),this.c=y instanceof a.$fn?new f.$Dn:this.B(new f.$En(this.b,y,w)),this.f=this.B(new S.$yn(this.j,{},M.$lg,d)),this.a=new S.$zn(this.b.configurationModel,this.c.configurationModel,new S.$wn,new S.$wn),this.g=this.B(new P.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:m})=>this.n($,m))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,d,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$zn(p,d,new S.$wn,y)}getConfigurationData(){return this.a.toData()}getValue(p,d){const y=typeof p=="string"?p:void 0,w=(0,C.$ii)(p)?p:(0,C.$ii)(d)?d:{};return this.a.getValue(y,w,void 0)}updateValue(p,d,y,w){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const d=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,d,2)}n(p,d){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(p,d);this.s(w,y,7)}r(p){const d=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,d,7)}s(p,d,y){const w=new S.$Bn(p,{data:d},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Fn=g}),define(ee[237],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=e.$J7b=void 0,e.$J7b="request",e.$K7b="remoteResourceHandler";class P{async routeCall(s,M,C){if(M!==e.$J7b)throw new Error(`Call not found: ${M}`);const S=C[0];if(S?.authority){const f=s.connections.find(a=>a.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$L7b=P}),define(ee[238],te([0,1,14,6]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,D.$Nh)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=M;class C{constructor(b,p){this.host=b,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=C;var S;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends P.$ab{static isNotAvailable(b){return b instanceof f&&b._code===S.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof f&&b._code===S.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof f&&b._code===S.NoResolverFound}static isInvalidAuthority(b){return b instanceof f&&b._code===S.InvalidAuthority}static isHandled(b){return b instanceof f&&b.isHandled}constructor(b,p=S.Unknown,d){super(b),this._message=b,this._code=p,this._detail=d,this.isHandled=p===S.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Pk=f;function a(g){const b=g.indexOf("+");return b===-1?g:g.substring(0,b)}e.$Qk=a}),define(ee[58],te([0,1,13]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function D(a){return a.scheme===P.Schemas.vscodeRemote?a.authority:void 0}e.$Rk=D;function s(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.$Sk=s;function M(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Tk=M;function C(a){const{host:g,port:b}=f(a);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:b}}e.$Uk=C;function S(a,g){let{host:b,port:p}=f(a);return typeof p>"u"&&(p=g),{host:b,port:p}}e.$Vk=S;function f(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const b=a.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=a.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:a,port:void 0}}}),define(ee[120],te([0,1,27,6,58]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Zl=M,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,m){if(typeof $>"u"||$===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof $=="string"||typeof m=="string"){const h=typeof $=="string"?$:$.value,c=typeof m=="string"?m:m.value;return P.$1e(h,c)}return $._lower===m._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$2l=f;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const m of $)this.add(m)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$3l=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,m){this.c.set(f.toKey($),m)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=g;function b(w){return p(w)}e.$5l=b;function p(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$6l=p;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$7l=d;function y(w,$){if($){const m=`onResolveRemoteAuthority:${(0,s.$Sk)($)}`;return!!w.activationEvents?.includes(m)}return!1}e.$8l=y,e.$9l=(0,D.$Nh)("IBuiltinExtensionsScannerService")}),define(ee[239],te([0,1,8,18,22,14,3,2,65,70,32,109,238,58]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.PersistentConnectionEventType=e.$3k=e.$2k=e.$1k=e.ConnectionType=void 0;const y=30*1e3;var w;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function $(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(T){const O=new s.$Wd;return setTimeout(()=>O.cancel(),T),O.token}function h(T,O){if(T.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$Wd;return T.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class c{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Qc,this.promise=new Promise((j,q)=>{this.f=j,this.g=q}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function k(T,O){const j=new c(O);return j.registerDisposable(T.onControlMessage(q=>{const W=JSON.parse(q.toString()),z=N(W);z?j.reject(z):j.resolve(W)})),j.promise}function u(T,O,j,q,W,z,G,ce){const de=new c(ce),ue=a.$Id.create(!1);return T.info(`Creating a socket (${G})...`),f.mark(`code/willCreateSocket/${z}`),O.connect(j,q,W,G).then(fe=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${z}`),T.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),de.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),T.error(fe),de.reject(fe)}),de.promise}function t(T,O){const j=new c(O);return T.then(q=>{j.didTimeout||j.resolve(q)},q=>{j.didTimeout||j.reject(q)}),j.promise}async function l(T,O,j,q){const W=ie(T,O);T.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let z;try{z=await u(T.logService,T.remoteSocketFactoryService,T.connectTo,(0,d.$Tk)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${T.reconnectionToken}`,q)}catch(fe){throw T.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),T.logService.error(fe),fe}T.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let G,ce;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(z,null),G=T.reconnectionProtocol,ce=!1):(G=new b.$Bh({socket:z}),ce=!0),T.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const de=await t(T.signService.createNewMessage((0,g.$dg)()),q),ue={type:"auth",auth:T.connectionToken||"00000000000000000000",data:de.data};G.sendControl(D.$ae.fromString(JSON.stringify(ue)));try{const fe=await k(G,h(q,m(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(T.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(T.signService.validate(de,fe.signedData),q)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const be=await t(T.signService.sign(fe.data),q),pe={type:"connectionType",commit:T.commit,signedData:be,desiredConnectionType:O};return j&&(pe.args=j),T.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(D.$ae.fromString(JSON.stringify(pe))),{protocol:G,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(T.logService.error(`${W} the handshake timed out. Error:`),T.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${W} received error control message when negotiating connection. Error:`),T.logService.error(fe)),ce&&V(G),fe}}async function r(T,O,j,q){const W=Date.now(),z=ie(T,O),{protocol:G,ownsProtocol:ce}=await l(T,O,j,q),de=new c(q);return de.registerDisposable(G.onControlMessage(ue=>{const fe=JSON.parse(ue.toString()),ye=N(fe);ye?(T.logService.error(`${z} received error control message when negotiating connection. Error:`),T.logService.error(ye),ce&&V(G),de.reject(ye)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(W)}!`),de.resolve({protocol:G,firstMessage:fe}))})),de.promise}async function i(T,O){const{protocol:j}=await r(T,1,void 0,O);return{protocol:j}}async function n(T,O,j){const{protocol:q,firstMessage:W}=await r(T,2,O,j),z=W&&W.debugPort;return{protocol:q,debugPort:z}}async function o(T,O,j){const q=Date.now(),W=ie(T,3),{protocol:z}=await l(T,3,O,j);return T.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(q)}!`),z}async function v(T,O,j){const{connectTo:q,connectionToken:W}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,connectTo:q,connectionToken:W,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:T.remoteSocketFactoryService,signService:T.signService,logService:T.logService}}async function R(T,O,j){return E(T,async q=>{const{protocol:W}=await i(q,s.CancellationToken.None);return new X(T,O,j,q.reconnectionToken,W)})}e.$1k=R;async function A(T,O){return E(T,async j=>{const{protocol:q,debugPort:W}=await n(j,O,s.CancellationToken.None);return new K(T,O,j.reconnectionToken,q,W)})}e.$2k=A;async function E(T,O){for(let q=1;;q++)try{const W=(0,g.$dg)(),z=await v(T,W,null);return await O(z)}catch(W){if(q<5)T.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(W);else throw T.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(W),re.triggerPermanentFailure(0,0,p.$Pk.isHandled(W)),W}}async function I(T,O,j){const q=await v(T,(0,g.$dg)(),null);return await o(q,{host:O,port:j},s.CancellationToken.None)}e.$3k=I;function L(T){return(0,P.$Gg)(O=>new Promise((j,q)=>{const W=setTimeout(j,T*1e3);O.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var F;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class B{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$4k=B;class se{constructor(O,j,q,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=q,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$5k=se;class x{constructor(O,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.type=2}}e.$6k=x;class ae{constructor(O,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.type=4}}e.$7k=ae;class ne{constructor(O,j,q,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.handled=W,this.type=3}}e.$8k=ne;class re extends S.$Rc{static triggerPermanentFailure(O,j,q){this._permanentFailure=!0,this.f=O,this.g=j,this.h=q,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||re._permanentFailure}constructor(O,j,q,W,z){super(),this.t=O,this.u=j,this.reconnectionToken=q,this.protocol=W,this.w=z,this.m=this.B(new C.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(G=>{const ce=J(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(G=>{const ce=J(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),re.j.push(this),this.B((0,S.$Pc)(()=>{const G=re.j.indexOf(this);G>=0&&re.j.splice(G,1)})),this.n&&this.D(re.f,re.g,re.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=J(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const W=q<j.length?j[q]:j[j.length-1];try{if(W>0){const G=L(W);this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,G)),this.u.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.u.logService.info(`${O} resolving connection...`);const z=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${z.connectTo}...`),await this.G(z,m(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(p.$Pk.isTemporarilyNotAvailable(z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,M.$3)(z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof p.$Pk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,p.$Pk.isHandled(z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.n&&!this.s)}C(O,j,q){this.w?re.triggerPermanentFailure(O,j,q):this.D(O,j,q)}D(O,j,q){this.m.fire(new ne(this.reconnectionToken,O,j,q)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9k=re;class X extends re{constructor(O,j,q,W,z){super(1,O,W,z,!0),this.client=this.B(new b.$zh(z,{remoteAuthority:j,clientId:q},O.ipcLogger))}async G(O,j){await i(O,j)}}e.$0k=X;class K extends re{constructor(O,j,q,W,z){super(2,O,q,W,!1),this.H=j,this.debugPort=z}async G(O,j){await n(O,this.H,j)}}e.$$k=K;function V(T){try{T.acceptDisconnect();const O=T.getSocket();T.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function N(T){if(T&&T.type==="error"){const O=new Error(`Connection error: ${T.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function U(T,O){for(;T.length<O;)T+=" ";return T}function H(T,O){return`[remote-connection][${U($(T),13)}][${O.substr(0,5)}\u2026]`}function J(T,O,j){return`${H(T,O)}[${j?"reconnect":"initial"}]`}function ie(T,O){return`${J(O,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.connectTo}]`}function oe(T){return`${Date.now()-T} ms`}}),define(ee[240],te([0,1,2,6]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk=(0,D.$Nh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,S){return this.a[C]??=[],this.a[C].push(S),(0,P.$Pc)(()=>{const f=this.a[C]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[C]?.splice(f,1)})}b(C){return(this.a[C.type]||[]).find(f=>f.supports(C))}connect(C,S,f,a){const g=this.b(C);if(!g)throw new Error(`No socket factory found for ${C}`);return g.connect(C,S,f,a)}}e.$Xk=s}),define(ee[241],te([0,1,28,47,21,113]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;let C;async function S(d=!1){return(C===void 0||d)&&(C=f()),C}e.$K6b=S;async function f(){const d=a();if(d===void 0)return!1;if(d>=22e3){const y=b();if(y)return new Promise(w=>{D.execFile(y,["--status"],$=>w(!$))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function g(d){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,w?"Sysnative":"System32",d)}}function b(){return g("wsl.exe")}function p(){return g("lxss\\LxssManager.dll")}}),define(ee[50],te([0,1,18,14,2,181,57,6,5,43]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Oo=(0,S.$Nh)("requestService");class g{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class b extends s.$Rc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:f.$mj.isEqualTo((0,f.$kj)(f.LogLevel.Trace)).serialize()})}async c(u,t,l){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new g(t.headers??{}));try{const i=await l();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,D.$9)(i)),i}}}e.$Po=b;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$Qo=p;function d(k){return k.res.statusCode===204}e.$Ro=d;async function y(k){return d(k)?null:(await(0,P.$me)(k.stream)).toString()}e.$So=y;async function w(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return y(k)}e.$To=w;async function $(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(d(k))return null;const t=(await(0,P.$me)(k.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Uo=$;function m(k){c(k)}e.$Vo=m;let h;function c(k){const u=a.$bn.as(C.$gn.Configuration),t=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:t?[t]:[]})}c(1)}),define(ee[242],te([0,1,18,22]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,a,g=D.CancellationToken.None){switch(f){case"request":return this.a.request(a[0],g).then(async({res:b,stream:p})=>{const d=await(0,P.$me)(p);return[{statusCode:b.statusCode,headers:b.headers},d]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Rq=s;class M{constructor(S){this.a=S}async request(S,f){const[a,g]=await this.a.call("request",[S],f);return{res:a,stream:(0,P.$oe)(g)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Sq=M}),define(ee[243],te([0,1,244,12]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;function s(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(C,S,f={}){const a=(0,P.parse)(C),g=f.proxyUrl||s(a,S);if(!g)return null;const b=(0,P.parse)(g);if(!/^https?:$/.test(b.protocol||""))return null;const p={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,D.$Df)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((d,y)=>{Z(["http-proxy-agent"],d,y)}))(p):new(await new Promise((d,y)=>{Z(["https-proxy-agent"],d,y)}))(p)}e.$Tq=M}),define(ee[245],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=e.$76b=void 0,e.$76b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$86b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$96b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ee[93],te([0,1,47,9,182,22,49,14,4,32,108,63,8,138]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0;let y;async function w(m,h,c,k){return c["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$j?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Jl)(k)&&!c["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Jl)(k)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(u,t)=>{const l=new M.$Wd;let r=1e4;const i=m.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.$Kl)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{u(await $(h,l.token))}catch(o){!(0,S.$3)(o)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,C.$yi)(o)))):u({})}finally{clearTimeout(n),l.dispose()}})),y)}e.$Pl=w;async function $(m,h){const c=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",c);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",k);const u=(0,a.$dg)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",l);const r=await(0,g.$zl)(f.OS,l);return m.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new S.$4);const o=(0,D.$mc)(r);let v,R;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(v=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,R=["-Login","-Command"]):o==="nu"?(v=`^'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,R=["-i","-l","-c"]):(v=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),v);const E=(0,P.spawn)(r,[...R,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});h.onCancellationRequested(()=>(E.kill(),n(new S.$4))),E.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,C.$yi)(F)),n(F)});const I=[];E.stdout.on("data",F=>I.push(F));const L=[];E.stderr.on("data",F=>L.push(F)),E.on("close",(F,B)=>{const se=Buffer.concat(I).toString("utf8");m.trace("getUnixShellEnvironment#raw",se);const x=Buffer.concat(L).toString("utf8");if(x.trim()&&m.trace("getUnixShellEnvironment#stderr",x),F||B)return n(new Error((0,s.localize)(2,null,F,B)));const ae=t.exec(se),ne=ae?ae[1]:"{}";try{const re=JSON.parse(ne);c?re.ELECTRON_RUN_AS_NODE=c:delete re.ELECTRON_RUN_AS_NODE,k?re.ELECTRON_NO_ATTACH_CONSOLE=k:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){m.error("getUnixShellEnvironment#errorCaught",(0,C.$yi)(re)),n(re)}})})}}),define(ee[246],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$82b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const C=String(P.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$82b=P}),define(ee[94],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk="signService",e.$Zk=(0,P.$Nh)(e.$Yk)}),define(ee[247],te([0,1,246]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0;class D extends P.$82b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>Z(["vsda"],M,C))}}e.$V7b=D}),define(ee[34],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN=(0,P.$Nh)("stateReadService"),e.$nN=(0,P.$Nh)("stateService")}),define(ee[121],te([0,1,8,18,2,12,36,16,5]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends s.$Rc{constructor(y,w,$,m){super(),this.h=y,this.j=$,this.m=m,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new P.$Qg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,w){const $=this.a[y];return(0,M.$Gf)($)?w:$}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:$,data:m}of y)this.a[$]!==m&&((0,M.$Gf)(m)?(0,M.$Ef)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=m,w=!0));w&&this.r()}removeItem(y){(0,M.$Ef)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,D.$ae.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$oN=g;let b=class extends s.$Rc{constructor(y,w,$,m){super(),this.a=this.B(new g(w.stateResource,y,$,m))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$pN=b,e.$pN=b=ke([_(1,C.$Uh),_(2,f.$8i),_(3,S.$9j)],b);class p extends b{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$qN=p}),define(ee[122],te([0,1,4,35,32]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function M(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function C(f,a,g,b,p,d,y,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,s.$dg)()+Date.now(),$.commitHash=b,$.version=p,$["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,P.$i)(P.$u),$["common.nodePlatform"]=D.$cc,$["common.nodeArch"]=g,$["common.product"]=w||"desktop",y&&($["common.msftInternal"]=y);let m=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),P.$m&&($["common.snap"]="true");const c=M(a);return c&&($["common.platformDetail"]=c),$}e.$do=C;function S(f){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return f.some(b=>g===b)}e.$eo=S}),define(ee[26],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,P.$Nh)("telemetryService"),e.$al=(0,P.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ee[248],te([0,1,28,8,44,13,9,4,7,86,21,107,90,16,24,26]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=void 0;const $=new Map;async function m(t,l){const r=`${t}::${l.join(":")}`,i=$.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,v=new Map,R=2e4;function A(I,L,F,B){const se=L.substring(I.length+1);return D.Promises.withAsyncBody(async x=>{let ae;try{ae=await g.Promises.readdir(L,{withFileTypes:!0})}catch{x();return}if(B.count>=R){B.count+=ae.length,B.maxReached=!0,x();return}let ne=ae.length;if(ne===0){x();return}let re=ae;B.count+ae.length>R&&(B.maxReached=!0,ne=R-B.count,re=ae.slice(0,ne)),B.count+=ae.length;for(const X of re)if(X.isDirectory()){if(F.includes(X.name)||await A(I,(0,C.$ic)(L,X.name),F,B),--ne===0){x();return}}else{const K=X.name.lastIndexOf(".");if(K>=0){const V=X.name.substring(K+1);V&&o.set(V,(o.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(se)!==!1&&V.filePattern.test(X.name)&&v.set(V.tag,(v.get(V.tag)??0)+1);if(--ne===0){x();return}}})}const E=D.Promises.withAsyncBody(async I=>{const L={count:0,maxReached:!1};await A(t,t,l,L);const F=await k(t);I({configFiles:h(v),fileTypes:h(o),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F})});return $.set(r,E),E}e.$zr=m;function h(t){return Array.from(t.entries(),([l,r])=>({name:l,count:r})).sort((l,r)=>r.count-l.count)}function c(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.$Dk.GB).toFixed(2)}GB (${(P.freemem()/d.$Dk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Nm.value()*100)}%`},l=P.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$Ar=c;async function k(t){try{const l=new Map,r=(0,C.$ic)(t,".vscode","launch.json"),i=await g.Promises.readFile(r),n=[],o=(0,s.$Rm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$1m)(o)==="object"&&o.configurations)for(const v of o.configurations){const R=v.type;R&&(l.has(R)?l.set(R,l.get(R)+1):l.set(R,1))}return h(l)}catch{return[]}}e.$Br=k;let u=class{constructor(l,r){this.c=l,this.d=r}f(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}g(l){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/d.$Dk.GB).toFixed(2)}GB (${(P.freemem()/d.$Dk.GB).toFixed(2)}GB free)`),S.$j||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Nm.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,b.$yr)(l.mainPID),this.k(l)]).then(async i=>{let[n,o]=i,v=this.m(l,n);return r.forEach(R=>{if((0,p.$nm)(R))v+=`
${R.errorMessage}`,o+=`
${R.errorMessage}`;else if(v+=`

Remote: ${R.hostName}`,R.processes&&(v+=`
${this.m(l,R.processes)}`),R.workspaceMetadata){o+=`
|  Remote: ${R.hostName}`;for(const A of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[A];let I=`${E.fileCount} files`;E.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${A}): ${I}`,o+=this.h(E)}}}),{processInfo:v,workspaceInfo:o}})}async getSystemInfo(l,r){const{memory:i,vmHint:n,os:o,cpus:v}=c(),R={os:o,memory:i,cpus:v,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return S.$j||(R.load=`${P.loadavg().map(A=>Math.round(A)).join(", ")}`),S.$l&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(l,r){const i=[];return(0,b.$yr)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),r.forEach(o=>{if((0,p.$nm)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(l,o.processes)),o.workspaceMetadata)for(const v of Object.keys(o.workspaceMetadata)){const R=o.workspaceMetadata[v];let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${v}): ${A}`),i.push(this.h(R))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const r=[];let n=0;const o=(E,I)=>{const L=` ${E}(${I})`;n+L.length>60?(r.push(v),v="|                 ",n=v.length):n+=L.length,v+=L};let v="|      File types:";const R=10,A=l.fileTypes.length>R?R:l.fileTypes.length;for(let E=0;E<A;E++){const I=l.fileTypes[E];o(I.name,I.count)}if(r.push(v),l.configFiles.length>=0&&(v="|      Conf files:",n=0,l.configFiles.forEach(E=>{o(E.name,E.count)}),r.push(v)),l.launchConfigFiles.length>0){let E="|      Launch Configs:";l.launchConfigFiles.forEach(I=>{const L=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;E+=L}),r.push(E)}return r.join(`
`)}j(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const r=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const v=f.URI.revive(o);if(v.scheme===M.Schemas.file){const R=v.fsPath;i.push(m(R,["node_modules",".git"]).then(A=>{let E=`${A.fileCount} files`;A.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$mc)(R)}): ${E}`),r.push(this.h(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${R} (${A.toString()})`)}))}else r.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,r){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:v})=>i.set(o,v));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(l.mainPID,i,n,r,0),n.join(`
`)}n(l,r,i,n,o){const v=o===0;let R;v?R=n.pid===l?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?R=r.get(n.pid):R=`${"  ".repeat(o)} ${n.name}`;const A=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(A/d.$Dk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(l,r,i,E,o+1))}async getWorkspaceFileExtensions(l){const r=new Set;for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(R=>r.add(R.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=f.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const o=await m(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};e.$Cr=u,e.$Cr=u=ke([_(0,w.$_k),_(1,y.$nj)],u)}),define(ee[249],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=void 0;class P{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:S,data:f}){return this.b.forEach(a=>a.log(S,f)),Promise.resolve(null)}}e.$_6b=P;class D{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$a7b=D}),define(ee[51],te([0,1,37,12,3,17,58,122,26]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$fo=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=g,e.$ho=new g;class b{async publicLog(n,o,v){}async publicLogError(n,o,v){}}e.$io=b,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(v,R)=>{const A=v?new Set([...v.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:A}},1e3,!0)(v=>{v.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$ki)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$mo=p;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$no=d;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$oo=y;function w(i){const n=i.getValue(f.$gl),o=i.getValue(f.$hl);if(i.getValue(f.$il)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=w;function $(i){const n={},o={},v={};c(i,v);for(let R in v){R=R.length>150?R.substr(R.length-149):R;const A=v[R];typeof A=="number"?o[R]=A:typeof A=="boolean"?o[R]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${A.length}`),n[R]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(n[R]=A)}return{properties:n,measurements:o}}e.$qo=$;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,C.$Sk)(i);return m.has(n)?n:"other"}e.$ro=h;function c(i,n,o=0,v){if(i)for(const R of Object.getOwnPropertyNames(i)){const A=i[R],E=v?v+R:R;Array.isArray(A)?n[E]=(0,P.$7m)(A):A instanceof Date?n[E]=A.toISOString():(0,D.$zf)(A)?o<2?c(A,n,o+1,E+"."):n[E]=(0,P.$7m)(A):n[E]=A}}function k(i,n){const o=i.msftInternalDomains||[],v=n.getValue("telemetry.internalTesting");return(0,S.$eo)(o)||v}e.$so=k;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$to=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const v=[];for(const I of n)for(;;){const L=I.exec(i);if(!L)break;v.push([L.index,I.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(o="";;){const I=A.exec(i);if(!I)break;const L=v.some(([F,B])=>I.index<B&&F<A.lastIndex);!R.test(I[0])&&!L&&(o+=i.substring(E,I.index)+"<REDACTED: user-file-path>",E=A.lastIndex)}return E<i.length&&(o+=i.substr(E)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,P.$4m)(i,o=>{if(o instanceof a||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let v=o.replaceAll("%20"," ");v=t(v,n);for(const R of n)v=v.replace(R,"");return v=l(v),v}})}e.$uo=r}),define(ee[123],te([0,1,27,117,120,4,7,14,35,51]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function g(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$Ve)(r.id,i.id)===0}e.$vo=g;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?g(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$wo=p;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=d.exec(r);return i&&i[1]?[$(i[1]),i[2]]:[$(r),void 0]}e.$xo=y;function w(r,i){return`${r}.${i}`}e.$yo=w;function $(r){return r.toLowerCase()}e.$zo=$;function m(r,i){return $(w(r??s.$Xl,i))}e.$Ao=m;function h(r,i){const n=[],o=v=>{for(const R of n)if(R.some(A=>g(i(A),i(v))))return R;return null};for(const v of r){const R=o(v);R?R.push(v):n.push([v])}return n}e.$Bo=h;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Co=c;function k(r){return{id:new a.$fo(r.identifier.id),name:new a.$fo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Do=k,e.$Eo=new s.$2l("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const v=o.shift();if(v&&n.every(R=>!g(R.identifier,{id:v}))){const R=r.filter(A=>g(A.identifier,{id:v}));R.length===1&&(n.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Fo=u;async function t(r,i){if(!M.$l)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){i.debug("Error while getting the os-release file.",(0,S.$9)(v))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,i){const n=await t(r,i),o=(0,D.$1n)(n?"alpine":M.$u,f.$dc);return i.debug("ComputeTargetPlatform:",o),o}e.$Go=l}),define(ee[250],te([0,1,204,51]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function s(M,C,S,f,a,g,b){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,D.$no)(C,S)&&(0,D.$po)(f)===3){const d=await(0,P.$8o)(S,a,g);p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=b.machineId||d}return p}e.$9o=s}),define(ee[251],te([0,1,2,37,4,27,183,17,57,77,24,43,26,51]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,h,c){this.k=h,this.l=c,this.d={},this.i=new P.$Qc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=3,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,M.$Ee)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ee)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$gl)||k.affectsConfiguration(p.$il)||k.affectsConfiguration(p.$hl))&&this.m()}))}setExperimentProperty(m,h){this.d[m]=h}m(){let m=(0,d.$po)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const c=h.usage?3:h.error?2:0;m=Math.min(m,c)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,h,c){this.g<h||(c=(0,D.$5m)(c,this.d),c=(0,d.$uo)(c,this.j),c=(0,D.$5m)(c,this.c),this.b.forEach(k=>k.log(m,c)))}publicLog(m,h){this.n(m,3,h)}publicLog2(m,h){this.publicLog(m,h)}publicLogError(m,h){this.h&&this.n(m,2,h)}publicLogError2(m,h){this.publicLogError(m,h)}};e.$Wq=y,e.$Wq=y=ke([_(1,S.$hi),_(2,g.$nj)],y);function w(){const $=(0,C.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$p?"":(0,C.localize)(3,null),c=(0,C.localize)(4,null),k=(0,C.localize)(5,null),u=(0,C.localize)(6,null),t=(0,C.localize)(7,null),l=`
|       | ${c} | ${k} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${$} ${m} ${h}

&nbsp;

${t}
${l}

&nbsp;

${r}
`}b.$bn.as(f.$gn.Configuration).registerConfiguration({id:p.$fl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[p.$gl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$bn.as(f.$gn.Configuration).registerConfiguration({id:p.$fl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[p.$il]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${p.$gl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,4,86,26]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;async function M(C,S){let f=C.getItem(s.$el);return(typeof f!="string"||P.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,D.$Om)(S.error.bind(S))),f}e.$C7b=M}),define(ee[253],te([0,1,26,252]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;async function s(M,C){const S=await(0,D.$C7b)(M,C);return M.setItem(P.$el,S),S}e.$D7b=s}),define(ee[124],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(ee[254],te([0,1,4,124]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;const s=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((b,p)=>{this.d(b,p);const d=b.map.entries();let y=d.next();for(;!y.done;){const w=y.value[1],$=y.value[0];let m=this.a.get($);if(m||(m=[],this.a.set($,m)),m.length>0&&m[0].type===D.EnvironmentVariableMutatorType.Replace){y=d.next();continue}const h={extensionIdentifier:p,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};h.scope||delete h.scope,m.unshift(h),y=d.next()}})}async applyToProcessEnvironment(g,b,p){let d;P.$j&&(d={},Object.keys(g).forEach(y=>d[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(b)){const $=P.$j&&d[y.toLowerCase()]||y;for(const m of w){const h=p?await p(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case D.EnvironmentVariableMutatorType.Append:g[$]=(g[$]||"")+h;break;case D.EnvironmentVariableMutatorType.Prepend:g[$]=h+(g[$]||"");break;case D.EnvironmentVariableMutatorType.Replace:g[$]=h;break}if(m.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${s.get(m.type)}`;g[c]=(g[c]?g[c]+":":"")+y+"="+this.c(h)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,b){const p=new Map,d=new Map,y=new Map;if(g.getVariableMap(b).forEach((w,$)=>{const m=this.getVariableMap(b).get($),h=S(w,m);h&&p.set($,h)}),this.getVariableMap(b).forEach((w,$)=>{const m=g.getVariableMap(b).get($),h=S(w,m);h&&y.set($,h)}),this.getVariableMap(b).forEach((w,$)=>{const m=g.getVariableMap(b).get($),h=f(w,m);h&&d.set($,h)}),!(p.size===0&&d.size===0&&y.size===0))return{added:p,changed:d,removed:y}}getVariableMap(g){const b=new Map;for(const p of this.a.values()){const d=p.filter(y=>C(y,g));d.length>0&&b.set(d[0].variable,d)}return b}getDescriptionMap(g){const b=new Map;for(const p of this.b.values()){const d=p.filter(y=>C(y,g,!0));for(const y of d)b.set(y.extensionIdentifier,y.description)}return b}d(g,b){if(!g.descriptionMap)return;const p=g.descriptionMap.entries();let d=p.next();for(;!d.done;){const y=d.value[1],w=d.value[0];let $=this.b.get(w);$||($=[],this.b.set(w,$));const m={extensionIdentifier:b,scope:y.scope,description:y.description};m.scope||delete m.scope,$.push(m),d=p.next()}}}e.$mr=M;function C(a,g,b=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):b?g===a.scope:!0}function S(a,g){if(!g)return a;const b=new Set;g.forEach(d=>b.add(d.extensionIdentifier));const p=[];return a.forEach(d=>{b.has(d.extensionIdentifier)||p.push(d)}),p.length===0?void 0:p}function f(a,g){if(!g)return;const b=new Map;g.forEach(d=>b.set(d.extensionIdentifier,d));const p=[];return a.forEach(d=>{const y=b.get(d.extensionIdentifier);y&&(d.type!==y.type||d.value!==y.value||d.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(ee[255],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=e.$gr=void 0;function P(f){return[...f.entries()]}e.$gr=P;function D(f){return f?[...f.entries()]:[]}e.$hr=D;function s(f){return new Map(f)}e.$ir=s;function M(f){return new Map(f??[])}e.$jr=M;function C(f){return Array.from(f.entries()).map(a=>[a[0],P(a[1].map),D(a[1].descriptionMap)])}e.$kr=C;function S(f){return new Map(f.map(a=>[a[0],{map:s(a[1]),descriptionMap:M(a[2])}]))}e.$lr=S}),define(ee[256],te([0,1,8,22,3,2,5]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;let S=class extends M.$Rc{constructor(a,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Md),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,M.$Pc)(()=>{for(const b of this.f.values())(0,M.$Mc)(b)}))}createRequest(a){return new Promise((g,b)=>{const p=++this.a;this.c.set(p,g),this.g.fire({requestId:p,...a});const d=new D.$Wd;(0,P.$Tg)(this.b,d.token).then(()=>b(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$Pc)(()=>d.cancel())])})}acceptReply(a,g){const b=this.c.get(a);b?(this.c.delete(a),(0,M.$Mc)(this.f.get(a)||[]),this.f.delete(a),b(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$0q=S,e.$0q=S=ke([_(1,C.$8i)],S)}),define(ee[125],te([0,1,6,114,43]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$3q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$2q=void 0,e.$2q=new D.$5i("terminalTabFocusMode",!1,!0);var M;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var S;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var b;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$3q=(0,P.$Nh)("ptyService");var p;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var d;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var $;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var m;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$4q={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$bn.add(e.$4q.Backend,new k),e.$5q=(0,P.$Nh)("localPtyService"),e.$6q=(0,P.$Nh)("terminalLogService")}),define(ee[257],te([0,1,72,7,185,102]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.$$q=void 0;function C(p,d){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(w=>({name:w.profileName,description:S(w)}))),d&&y.push(...d.map(w=>({name:w.title,description:f(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$$q=C;function S(p){let d=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Sj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?d+=`
- args: "${p.args}"`:d+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(d+=`
- overrideName: ${p.overrideName}`),p.color&&(d+=`
- color: ${p.color}`),p.env&&(d+=`
- env: ${JSON.stringify(p.env)}`),d}function f(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Sj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function a(p,d){if(!p&&!d)return!0;if(typeof p=="string"&&typeof d=="string")return p===d;if(Array.isArray(p)&&Array.isArray(d)){if(p.length!==d.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==d[y])return!1;return!0}return!1}e.$_q=a;function g(p,d){if(!p&&!d)return!0;if(!p||!d)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(d))return p.id===d.id&&p.color===d.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof d=="object"&&"light"in d&&"dark"in d){const y=p,w=d;if((D.URI.isUri(y.light)||b(y.light))&&(D.URI.isUri(y.dark)||b(y.dark))&&(D.URI.isUri(w.light)||b(w.light))&&(D.URI.isUri(w.dark)||b(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(D.URI.isUri(p)&&D.URI.isUri(d)||b(p)||b(d)){const y=p,w=d;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$ar=g;function b(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$br=b}),define(ee[258],te([0,1,72,4,184,57,43,257]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=void 0,e.$cr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$dr={type:"string",enum:Array.from((0,P.$Rj)(),$=>$.id),markdownEnumDescriptions:Array.from((0,P.$Rj)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$dr},color:{description:(0,s.localize)(3,null),...e.$cr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function b($){const m=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,D.$i)($),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.$bn.as(M.$gn.Configuration).registerConfiguration(p),w()}e.$er=d;let y;function w($,m){const h=C.$bn.as(M.$gn.Configuration);let c;$&&(c=(0,S.$$q)($?.profiles,m));const k=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?c?.values:void 0,markdownEnumDescriptions:$?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?c?.values:void 0,markdownEnumDescriptions:$?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?c?.values:void 0,markdownEnumDescriptions:$?.os===1?c?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:k?[k]:[]})}e.$fr=w}),define(ee[259],te([0,1,28,13,37,9,4,35,27,12,21,124,255,254]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$nr=y;async function w(i,n,o,v=S.env,R=g.Promises.exists){if(M.$hc(i))return await R(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$lc(i)!=="."){const L=M.$ic(n,i);return await R(L)?L:void 0}const E=(0,s.$9m)(v,"PATH");if(o===void 0&&(0,a.$xf)(E)&&(o=E.split(M.$sc)),o===void 0||o.length===0){const L=M.$ic(n,i);return await R(L)?L:void 0}for(const L of o){let F;if(M.$hc(L)?F=M.$ic(L,i):F=M.$ic(n,L,i),await R(F))return F;if(C.$j){let B=F+".com";if(await R(B)||(B=F+".exe",await R(B)))return B}}const I=M.$ic(n,i);return await R(I)?I:void 0}e.$or=w;function $(i,n,o,v,R){const A=C.$j&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||A)return;const E=i.args,I=S.$cc==="win32"?M.$mc(i.executable).toLowerCase():M.$mc(i.executable),L=M.$lc(D.$bg.asFileUri("").fsPath);let F;const B={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(B.VSCODE_NONCE=n.shellIntegration.nonce),C.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!E||l(E)?F=c.get(h.WindowsPwsh):t(E)&&(F=c.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,f.$Be)(F[F.length-1],L,""),{newArgs:F,envMixin:B}):void 0;v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!E||E.length===0?F=c.get(h.Bash):r(E)&&(B.VSCODE_SHELL_LOGIN="1",m(n,B),F=c.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,f.$Be)(F[F.length-1],L),{newArgs:F,envMixin:B}):void 0;case"fish":{const se=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${se}:${x}`,m(n,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!E||l(E)?F=c.get(h.Pwsh):t(E)&&(F=c.get(h.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,f.$Be)(F[F.length-1],L,""),{newArgs:F,envMixin:B}):void 0;case"zsh":{if(!E||E.length===0?F=c.get(h.Zsh):r(E)?(F=c.get(h.ZshLogin),m(n,B)):(E===c.get(h.Zsh)||E===c.get(h.ZshLogin))&&(F=E),!F)return;F=[...F],F[F.length-1]=(0,f.$Be)(F[F.length-1],L);let se;try{se=P.userInfo().username}catch{se="unknown"}const x=M.$ic(P.tmpdir(),`${se}-${R.applicationName}-zsh`);B.ZDOTDIR=x;const ae=o?.ZDOTDIR??P.homedir()??"~";B.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(x,".zshrc")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(x,".zprofile")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(x,".zshenv")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(x,".zlogin")}),{newArgs:F,envMixin:B,filesToCopy:ne}}}v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$pr=$;function m(i,n){if(C.$k&&i.environmentVariableCollections){const o=(0,p.$lr)(i.environmentVariableCollections),R=new d.$mr(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),A=[];if(R)for(const E of R)E.type===b.EnvironmentVariableMutatorType.Prepend&&A.push(E.value);A.length>0&&(n.VSCODE_PATH_PREFIX=A.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const c=new Map;c.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(h.Zsh,["-i"]),c.set(h.ZshLogin,["-il"]),c.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===1&&k.includes(i[0].toLowerCase())||i.length===2&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function r(i){return i==="string"&&k.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&k.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,72,9,4,12,21,106,259,113]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;let b,p=!0;function d(n,o,v,R,A=process.env,E,I,L,F){return E=E||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$j?y(v,E,A,I,R.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:R.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:R.getValue("terminal.integrated.defaultProfile.windows"),F,L):l(E,I,v,n&&typeof n=="object"?{...n}:R.getValue(M.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:R.getValue(M.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,L,A)}e.$qr=d;async function y(n,o,v,R,A,E,I,L,F){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let x=!1;(0,a.$nr)()>=16299&&(x=!0),await h(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:D.$Sj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$Sj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:D.$Sj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:D.$Sj.terminalBash,isAutoDetected:!0});const re=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",re],requiresPath:process.env.CMDER_ROOT?re:{path:re,isUnsafe:!0},isAutoDetected:!0})}r(E,ae);const ne=await w(ae.entries(),I,o,v,R,F);if(n&&A)try{const re=await u(`${se}\\${x?"wsl":"bash"}.exe`,I);for(const X of re)(!E||!(X.profileName in E))&&ne.push(X)}catch{p&&(R?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ne}async function w(n,o,v,R=process.env,A,E){const I=[];for(const[L,F]of n)I.push($(L,F,o,v,R,A,E));return(await Promise.all(I)).filter(L=>!!L)}async function $(n,o,v,R,A=process.env,E,I){if(o===null)return;let L,F,B;if("source"in o&&!("path"in o)){const ne=b?.get(o.source);if(!ne)return;L=ne.paths,F=o.args||ne.args,o.icon?B=m(o.icon):ne.icon&&(B=ne.icon)}else L=Array.isArray(o.path)?o.path:[o.path],F=M.$j||Array.isArray(o.args)?o.args:void 0,B=m(o.icon);let se;if(I){const ne=L.map(X=>typeof X=="string"?X:X.path),re=await I(ne);se=new Array(L.length);for(let X=0;X<L.length;X++)typeof L[X]=="string"?se[X]=re[X]:se[X]={path:re[X],isUnsafe:!0}}else se=L.slice();let x;if(o.requiresPath){let ne;if((0,C.$xf)(o.requiresPath)?ne=o.requiresPath:(ne=o.requiresPath.path,o.requiresPath.isUnsafe&&(x=ne)),!await R.existsFile(ne))return}const ae=await i(n,v,se,R,A,F,o.env,o.overrideName,o.isAutoDetected,x);if(!ae){E?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=B,ae.color=o.color,ae}function m(n){return typeof n=="string"?{id:n}:n}async function h(n){if(b&&!n)return;const[o,v]=await Promise.all([c(),n||k()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:v,icon:D.$Sj.terminalPowershell})}async function c(){const n=new Set,o=await(0,a.$or)("git.exe");if(o){const A=(0,g.dirname)(o);n.add((0,g.resolve)(A,"../.."))}function v(A,E){E&&A.add(E)}v(n,process.env.ProgramW6432),v(n,process.env.ProgramFiles),v(n,process.env["ProgramFiles(X86)"]),v(n,`${process.env.LocalAppData}\\Program`);const R=[];for(const A of n)R.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function k(){const n=[];for await(const o of(0,f.$tl)())n.push(o.exePath);return n}async function u(n,o){const v=[],R=await new Promise((I,L)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,B)=>{if(F)return L("Problem occurred when getting wsl distros");I(B)})});if(!R)return[];const A=new RegExp(/[\r?\n]/),E=R.split(A).filter(I=>I.trim().length>0&&I!=="");for(const I of E){if(I===""||I.startsWith("docker-desktop"))continue;const L=`${I} (WSL)`,F={profileName:L,path:n,args:["-d",`${I}`],isDefault:L===o,icon:t(I),isAutoDetected:!1};v.push(F)}return v}function t(n){return n.includes("Ubuntu")?D.$Sj.terminalUbuntu:n.includes("Debian")?D.$Sj.terminalDebian:D.$Sj.terminalLinux}async function l(n,o,v,R,A,E,I,L){const F=new Map;if(v){const B=(await n.readFile("/etc/shells")).toString(),se=(E||B.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),x=new Map;for(const ae of se){let ne=(0,s.$mc)(ae),re=x.get(ne)||0;re++,re>1&&(ne=`${ne} (${re})`),x.set(ne,re),F.set(ne,{path:ae,isAutoDetected:!0})}}return r(R,F),await w(F.entries(),A,n,L,o,I)}function r(n,o){if(n)for(const[v,R]of Object.entries(n))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?o.delete(v):(R.icon=R.icon||o.get(v)?.icon,o.set(v,R))}async function i(n,o,v,R,A,E,I,L,F,B){if(v.length===0)return Promise.resolve(void 0);const se=v.shift();if(se==="")return i(n,o,v,R,A,E,I,L,F);const x=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ne={profileName:n,path:ae,args:E,env:I,overrideName:L,isAutoDetected:F,isDefault:n===o,isUnsafePath:x,requiresUnsafePath:B};if((0,s.$mc)(ae)===ae){const X=A.PATH?A.PATH.split(s.$sc):void 0,K=await(0,a.$or)(ae,void 0,X,void 0,R.existsFile);return K?(ne.path=K,ne.isFromPath=!0,ne):i(n,o,v,R,A,E)}return await R.existsFile((0,s.$gc)(ae))?ne:i(n,o,v,R,A,E,I,L,F)}}),define(ee[261],te([0,1,3,2,4,42,17,5,224,93,256,125,258,260,108,70]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;var $;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})($||($={}));let m=class extends D.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,k,u,t){super(),this.M=c,this.N=k,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Md),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Md),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Md),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Md),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Md),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Md),this.onProcessData=this.D.event,this.F=this.B(new P.$Md),this.onProcessReady=this.F.event,this.G=this.B(new P.$Md),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Md),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Md),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Md),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Md),this.onProcessExit=this.L.event,(0,p.$er)(),this.B(this.M),this.B((0,D.$Pc)(()=>this.W())),this.j=this.B(new g.$0q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,a.$Pl)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),k=c.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(l=>{this.u.fire(l.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=M.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.D.fire(l))),this.B(t.onProcessReady(l=>this.F.fire(l))),this.B(t.onProcessExit(l=>this.L.fire(l))),this.B(t.onDidChangeProperty(l=>this.J.fire(l))),this.B(t.onProcessReplay(l=>this.G.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.H.fire(l))),this.B(t.onDidRequestDetach(l=>this.I.fire(l))),this.B(new f.$9q(this.P,k.getChannel(b.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,k,u,t,l,r,i,n,o,v,R){const A=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(c,k,u,t,l,r,i,n,o,v,R);return clearTimeout(A),E}updateTitle(c,k,u){return this.f.updateTitle(c,k,u)}updateIcon(c,k,u,t){return this.f.updateIcon(c,k,u,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,k){return this.f.detachFromProcess(c,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,k){return this.f.shutdown(c,k)}input(c,k){return this.f.input(c,k)}processBinary(c,k){return this.f.processBinary(c,k)}resize(c,k,u){return this.f.resize(c,k,u)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,k){return this.f.acknowledgeDataEvent(c,k)}setUnicodeVersion(c,k){return this.f.setUnicodeVersion(c,k)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new w.$Id,k=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...k]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,k){return this.f.installAutoReply(c,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,y.$zl)(c??s.OS,process.env)}async getProfiles(c,k,u,t=!1){const l=await this.S();return(0,d.$qr)(k,u,t,this.N,l,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,k){return this.f.getWslPath(c,k)}getRevivedPtyNewId(c,k){return this.f.getRevivedPtyNewId(c,k)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,k){return this.f.requestDetachInstance(c,k)}async acceptDetachInstanceReply(c,k){return this.f.acceptDetachInstanceReply(c,k)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,k,u){return this.f.reviveTerminalProcesses(c,k,u)}async refreshProperty(c,k){return this.f.refreshProperty(c,k)}async updateProperty(c,k,u){return this.f.updateProperty(c,k,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,k){return this.j.createRequest({workspaceId:c,originalText:k})}async acceptPtyHostResolvedVariables(c,k){this.j.acceptReply(c,k)}};e.$rr=m,e.$rr=m=ke([_(1,C.$hi),_(2,S.$8i),_(3,S.$9i)],m)}),define(ee[67],te([0,1,15,3,2,4,17,6,34]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=e.$_5b=void 0;const a="#FFFFFF",g="#1E1E1E",b="#000000",p="#FFFFFF",d="theme",y="themeBackground",w="windowSplash";e.$_5b=(0,S.$Nh)("themeMainService");let $=class extends s.$Rc{constructor(h,c){super(),this.b=h,this.c=c,this.a=this.B(new D.$Md),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$j){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$k){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$l&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?b:p;let c=this.b.getItem(y,null);if(!c)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":c=a;break;case"hc-black":c=b;break;case"hc-light":c=p;break;default:c=g}return M.$k&&c.toUpperCase()===g&&(c="#171717"),c}saveWindowSplash(h,c){this.b.setItems([{key:d,data:c.baseTheme},{key:y,data:c.colorInfo.background},{key:w,data:c}]),typeof h=="number"&&this.f(h,c)}f(h,c){for(const k of P.BrowserWindow.getAllWindows())if(k.id===h){k.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$a6b=$,e.$a6b=$=ke([_(0,f.$nN),_(1,C.$hi)],$)}),define(ee[126],te([0,1,3,17,6,5]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProvidedOnAutoForward=e.$6u=e.TunnelPrivacyId=e.TunnelProtocol=e.$5u=e.$4u=void 0,e.$4u=(0,s.$Nh)("tunnelService"),e.$5u=(0,s.$Nh)("sharedTunnelsService");var C;(function($){$.Http="http",$.Https="https"})(C||(e.TunnelProtocol=C={}));var S;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f($){return!!$.forwardPort}e.$6u=f;var a;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g($){if($.scheme!=="http"&&$.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(m)return{address:m[1],port:+m[2]}}e.$7u=g,e.$8u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b($){return e.$8u.indexOf($)>=0}e.$9u=b,e.$0u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p($){return e.$0u.indexOf($)>=0}e.$$u=p;function d($,m,h,c){if(h===1)return!1;if(h===2&&p(m)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(k?.length===4&&parseInt(k[1])>=18)return!1}return $<1024}e.$_u=d;class y{constructor(m,h,c){this.remoteAddress=m,this.localAddress=h,this.b=c,this.a=new P.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$av=y;let w=class{constructor(m,h){this.j=m,this.k=h,this.a=new P.$Md,this.onTunnelOpened=this.a.event,this.b=new P.$Md,this.onTunnelClosed=this.b.event,this.c=new P.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const m=this.k.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.h=m.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const m=[],h=Array.from(this.e.values());for(const c of h){const k=Array.from(c.values());for(const u of k){const t=await u.value;t&&typeof t!="string"&&m.push(t)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:h}of m.values())await h.then(c=>typeof c!="string"?c?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,h,c,k,u){this.p(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:c,privacy:k,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(p(m)||b(m))&&(m=e.$8u[0]);const c=this.r(m,h);if(c)return++c.refcount,c.value}openTunnel(m,h,c,k,u,t=!1,l,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${c} on local port ${u}.`);const i=this.f??m;if(!i)return;if(h||(h="localhost"),k||(k=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,h,c,k,u,t,l,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,c),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this.e.get(m.tunnelRemoteHost);if(h){const c=h.get(m.tunnelRemotePort);c&&(c.refcount--,await this.o(m.tunnelRemoteHost,m.tunnelRemotePort,c))}}}}async o(m,h,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const k=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(h),k}}async closeTunnel(m,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const c=this.e.get(m);if(c&&c.has(h)){const k=c.get(h);k.refcount=0,await this.o(m,h,k)}}p(m,h,c){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(h,{refcount:1,value:c})}async q(m,h){const c=this.e.get(m);if(c){const k=c.get(h),u=k?await k.value:void 0;(!u||typeof u=="string")&&c.delete(h),c.size===0&&this.e.delete(m)}}r(m,h){const c=[m];b(m)?(c.push(...e.$8u),c.push(...e.$0u)):p(m)&&c.push(...e.$0u);const k=c.map(u=>this.e.get(u));for(const u of k){const t=u?.get(h);if(t)return t}}canTunnel(m){return!!g(m)}t(m,h,c,k,u,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${c} on local port ${k}.`);const r=c;this.i.add(r);const i=k===void 0?c:k,n={elevationRequired:u?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:c},localAddressPort:k,privacy:t,public:t?t!==S.Private:void 0,protocol:l},v=m.forwardPort(o,n);return v?(this.p(h,c,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),v}};e.$bv=w,e.$bv=w=ke([_(0,M.$8i),_(1,D.$hi)],w)}),define(ee[48],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=e.$_T=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D||(e.StateType=D={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$_T={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,S)=>({type:"idle",updateType:C,error:S}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$aU=(0,P.$Nh)("updateService")}),define(ee[262],te([0,1,4,186,57,43]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$bn.as(s.$gn.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:P.$j&&!P.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[263],te([0,1,3,48]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,a){switch(f){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${f}`)}}e.$b7b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Md,this.onStateChange=this.a.event,this.b=D.$_T.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$c7b=M}),define(ee[40],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,P.$Nh)("IUriIdentityService")}),define(ee[264],te([0,1,40,205,16,19,139,3,2]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class a{static{this._clock=0}constructor(p){this.uri=p,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(p){this.g=p,this.c=new f.$Qc,this.f=2**16;const d=new Map,y=w=>{let $=d.get(w.scheme);return $===void 0&&($=p.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new M.$jg(y),this.d=new C.$ur((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$vg)(p));const d=this.d.get(p);return d?d.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new a(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let y=0;y<d;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$vr=g,e.$vr=g=ke([_(0,s.$9j)],g),(0,D.$sr)(P.$Fk,g,1)}),define(ee[127],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1T=void 0,e.$1T=(0,P.$Nh)("urlService")}),define(ee[265],te([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=e.$k7b=e.$j7b=void 0;class D{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,a){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${f}`)}}e.$j7b=D;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$k7b=s;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,a,g){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(a)&&a.length>0){const b=P.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const p=/\bwindowId=(\d+)/.exec(b.query);if(p){const d=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,b.toString(!0));const y=new RegExp(`window:${d}`),w=S.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),y.test($.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,a,g)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$l7b=M}),define(ee[266],te([0,1,8,2,7,24]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=e.$2T=void 0;class C extends D.$Rc{constructor(){super(...arguments),this.a=new Set}open(a,g){const b=[...this.a.values()];return(0,P.$Wg)(b.map(p=>()=>p.handleURL(a,g)),void 0,!1).then(p=>p||!1)}registerHandler(a){return this.a.add(a),(0,D.$Pc)(()=>this.a.delete(a))}}e.$2T=C;let S=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:g,path:b,query:p,fragment:d}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:b,query:p,fragment:d})}};e.$3T=S,e.$3T=S=ke([_(0,M.$nj)],S)}),define(ee[267],te([0,1,15,8,3,2,4,7]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;class f extends M.$Rc{constructor(g,b,p,d,y,w){if(super(),this.c=b,this.f=w,this.a=[],this.b=0,g&&(w.trace("ElectronURLListener initialUrisToHandle:",g.map(h=>h.originalUrl)),this.a=g),C.$j){const h=d.isBuilt?[]:[`"${d.appRoot}"`];h.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const $=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(h,c)=>({event:h,url:c})),({event:h,url:c})=>(h.preventDefault(),c));this.B($(h=>{const c=this.g(h);c&&this.c.open(c,{originalUrl:h})})),p.getWindows().filter(h=>h.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(p.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return S.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),g.push(b));g.length!==0&&(this.a=g,(0,D.$Ug)(()=>this.h(),500,this.q))}}e.$m7b=f}),define(ee[268],te([0,1,3,2,16,56,31]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class S extends D.$Rc{constructor(a,g,b,p,d,y){super(),this.f=a,this.g=g,this.h=b,this.j=p,this.m=d,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Md),this.onDidChangeFile=this.a.event,this.b=M.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Ac(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,b,p,d){return this.g.read(a,g,b,p,d)}write(a,g,b,p,d){return this.g.write(a,g,b,p,d)}watch(a,g){this.b.set(a,a);const b=this.g.watch(this.t(a),g);return(0,D.$Pc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,b){return this.g.rename(this.t(a),this.t(g),b)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,b){return this.g.readFileStream(this.t(a),g,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,b){return this.g.writeFile(this.t(a),g,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,b){if((0,s.$_j)(this.g))return this.g.copy(this.t(a),this.t(g),b);throw new Error("copy not supported")}cloneFile(a,g){if((0,s.$ak)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const p=this.u(b.resource);this.b.findSubstr(p)&&g.push({resource:p,type:b.type})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Y7b=S}),define(ee[269],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0,e.$F7b="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0,e.$n7b=(0,P.$Nh)("webviewManagerService")}),define(ee[271],te([0,1,15,2,13,7]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;class C extends D.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,a){try{const g=M.URI.parse(f.url),b=C.a.get(g.path);if(typeof b=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${b}`,d=s.$bg.asFileUri(p);return a({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$o7b=C}),define(ee[59],te([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(g){return!!g.workspaceUri}e.$WC=D;function s(g){return!!g.folderUri}e.$XC=s;function M(g){return!!g.fileUri}e.$YC=M;function C(g){const b=S(g),p=g.getValue("window.menuBarVisibility");return p==="default"||b==="native"&&p==="compact"||P.$k&&P.$n?"classic":p}e.$ZC=C;function S(g){if(P.$p)return"custom";const b=g.getValue("window");if(b){if(P.$k&&b.nativeTabs===!0||P.$k&&b.nativeFullScreen===!1)return"native";const y=b.titleBarStyle;if(y==="native"||y==="custom")return y}return P.$l?"native":"custom"}e.$1C=S;function f(g){return!(!P.$j||P.$p||S(g)==="native")}e.$2C=f;function a(g=0){return Math.pow(1.2,g)}e.$3C=a}),define(ee[95],te([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$W5b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var D;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(D||(e.UnloadReason=D={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$W5b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var C;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ee[272],te([0,1,8,3,2]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;class M extends s.$Rc{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:a}){super(),this.a=this.B(new s.$Qc),D.Event.latch(D.Event.any(S,f))(this.f,this,this.a),this.b=(0,P.$Gg)(()=>a()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$v7b=M}),define(ee[29],te([0,1,190,9,56,19,7,6,13]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,S.$Nh)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$Xh=a;function g(i){return typeof i?.id=="string"&&!a(i)&&!p(i)}e.$Yh=g,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$mc)(i)}:n?e.$Zh:e.$1h;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$2h=b;function p(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$3h=p;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$4h=d;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$5h=w;function $(i){const n=i;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$6h=$;class m{constructor(n,o,v,R,A){this.h=n,this.j=v,this.k=R,this.l=A,this.c=s.$Th.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Th.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=m;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$ug)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=h;function c(i){return new h({uri:i,index:0,name:(0,M.$qg)(i)},{uri:i.toString()})}e.$9h=c,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,P.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function k(i,n){return M.$lg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$bi=k;function u(i){let n;return C.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$ci=u,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$di}e.$ei=t;function l(i,n){return!k(i,n)&&!u(i)}e.$fi=l;function r(i){return(typeof i=="string"?(0,D.$nc)(i):(0,M.$sg)(i))===e.$$h}e.$gi=r}),define(ee[60],te([0,1,15,8,55,46,2,84,4,21,165,115,6,5,24,29]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=void 0,e.$o6b=(0,p.$Nh)("dialogMainService");let $=class{constructor(h,c){this.d=h,this.e=c,this.a=new Map,this.b=new Map,this.c=new D.$Zg}pickFileFolder(h,c){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},c)}pickFolder(h,c){return this.f({...h,pickFolders:!0,title:(0,g.localize)(1,null)},c)}pickFile(h,c){return this.f({...h,pickFiles:!0,title:(0,g.localize)(2,null)},c)}pickWorkspace(h,c){const k=(0,g.localize)(3,null),u=(0,M.$sv)((0,g.localize)(4,null)),t=w.$_h;return this.f({...h,pickFiles:!0,title:k,filters:t,buttonLabel:u},c)}async f(h,c){const k={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(k.properties=void 0,h.pickFiles&&h.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$k&&k.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(k,(c||P.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let c=this.b.get(h.id);return c||(c=new D.$Zg,this.b.set(h.id,c)),c}else return this.c}showMessageBox(h,c){return this.g(c).queue(async()=>{const{options:k,buttonIndeces:u}=(0,b.$zv)(h,this.e);let t;return c?t=await P.dialog.showMessageBox(c,k):t=await P.dialog.showMessageBox(k),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,c){const k=this.j(h,c);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(c).queue(async()=>{let u;return c?u=await P.dialog.showSaveDialog(c,h):u=await P.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,C.$Mc)(k)}}h(h){return h&&f.$k&&(h=(0,S.$kl)(h)),h}i(h){return h.map(c=>this.h(c))}async showOpenDialog(h,c){h.defaultPath&&(await a.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const k=this.j(h,c);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(c).queue(async()=>{let u;return c?u=await P.dialog.showOpenDialog(c,h):u=await P.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,C.$Mc)(k)}}j(h,c){if(!c)return C.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let k=this.a.get(c.id);k||(k=new Set,this.a.set(c.id,k));const u=(0,s.$Bi)(h);if(!k.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),k.add(u),(0,C.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),k?.delete(u),k?.size===0&&this.a.delete(c.id)})}};e.$p6b=$,e.$p6b=$=ke([_(0,d.$8i),_(1,y.$nj)],$)}),define(ee[273],te([0,1,3,2,74,29]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=void 0;class C extends D.$Rc{static{this.a=100}constructor(f,a){super(),this.f=f,this.g=a,this.b=this.B(new P.$Md),this.c=new Map,this.h(a.applicationStorage,this.b)}h(f,a){this.B(P.Event.debounce(f.onDidChangeStorage,(g,b)=>(g?g.push(b):g=[b],g),C.a)(g=>{g.length&&a.fire(this.j(g,f))}))}j(f,a){const g=new Map,b=new Set;return f.forEach(p=>{const d=a.get(p.key);typeof d=="string"?g.set(p.key,d):b.add(p.key)}),{changed:Array.from(g.entries()),deleted:Array.from(b.values())}}listen(f,a,g){switch(a){case"onDidChangeStorage":{const b=g.profile?(0,s.$kh)(g.profile):void 0;if(!b)return this.b.event;let p=this.c.get(b.id);return p||(p=this.B(new P.$Md),this.h(this.g.profileStorage(b),p),this.c.set(b.id,p)),p.event}}throw new Error(`Event not found: ${a}`)}async call(f,a,g){const b=g.profile?(0,s.$kh)(g.profile):void 0,p=(0,M.$4h)(g.workspace),d=await this.m(b,p);switch(a){case"getItems":return Array.from(d.items.entries());case"updateItems":{const y=g;if(y.insert)for(const[w,$]of y.insert)d.set(w,$);y.delete?.forEach(w=>d.delete(w));break}case"optimize":return d.optimize();case"isUsed":{const y=g.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async m(f,a){let g;a?g=this.g.workspaceStorage(a):f?g=this.g.profileStorage(f):g=this.g.applicationStorage;try{await g.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":f?"profile":"application"} storage due to ${b}`)}return g}}e.$$6b=C}),define(ee[41],te([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,27,12]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function k(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Gk=k,e.$Hk=(0,g.$Nh)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:n}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ik=u;function t(i,n,o,v,R,A){return{id:i,name:n,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:A&&R?.useDefaultFlags?.globalState?A.globalStorageHome:(0,M.$ug)(o,"globalStorage"),settingsResource:A&&R?.useDefaultFlags?.settings?A.settingsResource:(0,M.$ug)(o,"settings.json"),keybindingsResource:A&&R?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,M.$ug)(o,"keybindings.json"),tasksResource:A&&R?.useDefaultFlags?.tasks?A.tasksResource:(0,M.$ug)(o,"tasks.json"),snippetsHome:A&&R?.useDefaultFlags?.snippets?A.snippetsHome:(0,M.$ug)(o,"snippets"),extensionsResource:A&&R?.useDefaultFlags?.extensions?A.extensionsResource:(0,M.$ug)(o,"extensions.json"),cacheHome:(0,M.$ug)(v,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$Jk=t;let l=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,v,R){super(),this.t=n,this.u=o,this.w=v,this.y=R,this.f=!0,this.h=this.B(new D.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,h.$xf)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(t((0,M.$rg)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},n))}}catch(A){this.y.error(A)}const v=new d.$zc,R=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[E,I]of Object.entries(A.workspaces)){const L=C.URI.parse(E),F=o.find(B=>B.id===I);F&&v.set(L,F)}if(A.emptyWindows)for(const[E,I]of Object.entries(A.emptyWindows)){const L=o.find(F=>F.id===I);L&&R.set(E,L)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:v,emptyWindows:R}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",v=new RegExp(`${(0,m.$Ee)(o)}\\s(\\d+)`);let R=0;for(const E of this.profiles){const I=v.exec(E.name),L=I?parseInt(I[1]):0;R=L>R?L:R}const A=`${o} ${R+1}`;return this.createProfile((0,P.$Bi)((0,$.$dg)()).toString(16),A,{transient:!0},n)}async createNamedProfile(n,o,v){return this.createProfile((0,P.$Bi)((0,$.$dg)()).toString(16),n,o,v)}async createProfile(n,o,v,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(n,o,v);return R&&await this.setProfileForWorkspace(R,A),A}async F(n,o,v){if(!(0,h.$xf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(o);return R||(R=(async()=>{try{const A=this.profiles.find(L=>L.name===o||L.id===n);if(A)return A;const E=t(n,o,(0,M.$ug)(this.profilesHome,n),this.g,v,this.defaultProfile);await this.u.createFolder(E.location);const I=[];return this.j.fire({profile:E,join(L){I.push(L)}}),await w.Promises.settled(I),this.I([E],[],[]),E}finally{this.r.delete(o)}})(),this.r.set(o,R)),R}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(R=>R.id===n.id);if(!v)throw new Error(`Profile '${n.name}' does not exist`);return v=t(v.id,o.name??v.name,v.location,this.g,{shortName:o.shortName??v.shortName,icon:o.icon===null?void 0:o.icon??v.icon,transient:o.transient??v.isTransient,useDefaultFlags:o.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const v=[];this.m.fire({profile:o,join(R){v.push(R)}});try{await Promise.allSettled(v)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(R){(0,a.$mk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(R=>R.id===o.id);if(!v)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,v)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return C.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,p.$Xh)(n)?n.uri:(0,p.$3h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,v){const R=[...this.profiles,...n],A=[];this.s.profiles=[];for(let E of R)E.isDefault||o.some(I=>E.id===I.id)||(E=v.find(I=>E.id===I.id)??E,E.isTransient?this.s.profiles.push(E):A.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(A),this.z=void 0,this.J(n,o,v)}J(n,o,v){this.h.fire({added:n,removed:o,updated:v,all:this.profiles})}L(n,o,v){v=o?.isTransient?!0:v,v||this.L(n,void 0,!0);const R=this.G(n),A=v?this.s:this.C;C.URI.isUri(R)?(A.workspaces.delete(R),o&&A.workspaces.set(R,o)):(A.emptyWindows.delete(R),o&&A.emptyWindows.set(R,o)),v||this.M()}M(){const n={};for(const[v,R]of this.C.workspaces.entries())n[v.toString()]=R.id;const o={};for(const[v,R]of this.C.emptyWindows.entries())o[v.toString()]=R.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},v=this.D();if(n.workspaces)for(const[A,E]of Object.entries(n.workspaces)){const I=C.URI.parse(E);o[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}const R={};if(n.emptyWindows)for(const[A,E]of Object.entries(n.emptyWindows)){const I=C.URI.parse(E);R[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}return{workspaces:o,emptyWindows:R}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Kk=l,e.$Kk=l=ke([_(0,f.$Uh),_(1,a.$9j),_(2,y.$Fk),_(3,b.$8i)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Lk=r}),define(ee[79],te([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class c extends Error{constructor(r,i){super(r),this.code=i}}e.$pp=c,e.$qp=(0,b.$Nh)("IExtensionsProfileScannerService");let k=class extends s.$Rc{constructor(r,i,n,o,v,R){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=v,this.t=R,this.b=this.B(new M.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new C.$zc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.u(i,v=>{const R=[];for(const A of v)r.some(([E])=>(0,a.$vo)(E.identifier,A.identifier)&&E.manifest.version!==A.version)?n.push(A):R.push(A);for(const[A,E]of r){const I=R.findIndex(F=>(0,a.$vo)(F.identifier,A.identifier)&&F.version===A.manifest.version),L={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:E};I===-1?(o.push(L),R.push(L)):R.splice(I,1,L)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),R}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(v){throw o.length&&this.c.fire({extensions:o,error:v,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:v,profileLocation:i}),v}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const v=[];for(const R of o){const A=r.find(([E])=>(0,a.$vo)(E.identifier,R.identifier)&&E.manifest.version===R.version);A&&(R.metadata={...R.metadata,...A[1]},n.push(R)),v.push(R)}return v}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const v=[];for(const R of o)(0,a.$vo)(R.identifier,r.identifier)?n.push(R):v.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:i}),v}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],v;try{const R=await this.m.readFile(r);v=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,g.$mk)(R)!==1)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(v=await this.D()),!v&&n?.bailOutWhenFileNotFound)throw new c((0,$.$9)(R),"ERROR_PROFILE_NOT_FOUND")}if(v){Array.isArray(v)||this.w(r);let R=!1;for(const A of v){u(A)||this.w(r);let E;if((0,w.$xf)(A.relativeLocation)&&A.relativeLocation)E=this.z(A.relativeLocation);else if((0,w.$xf)(A.location))E=this.z(A.location),R=!0,A.relativeLocation=A.location,A.location=E.toJSON();else{E=S.URI.revive(A.location);const I=this.y(E);I&&(R=!0,A.relativeLocation=I)}o.push({identifier:A.identifier,location:E,version:A.version,metadata:A.metadata})}R&&await this.m.writeFile(r,D.$ae.fromString(JSON.stringify(v)))}if(i){o=i(o);const R=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,D.$ae.fromString(JSON.stringify(R)))}return o})}w(r){const i=new c(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(v){if((0,g.$mk)(v)===1)return;throw v}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const v=JSON.parse(n);Array.isArray(v)&&v.every(R=>u(R))?o=v:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",v)}catch(v){this.t.error(v)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ae.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(v){if((0,g.$mk)(v)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw v}try{await this.m.del(r)}catch(v){(0,g.$mk)(v)!==1&&this.t.error(v)}try{await this.m.del(i)}catch(v){(0,g.$mk)(v)!==1&&this.t.error(v)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Zg,this.h.set(r,i)),i}};e.$rp=k,e.$rp=k=ke([_(1,g.$9j),_(2,d.$Hk),_(3,y.$Fk),_(4,m.$_k),_(5,p.$8i)],k);function u(l){return(0,w.$zf)(l)&&(0,f.$5n)(l.identifier)&&(t(l.location)||(0,w.$xf)(l.location)&&l.location)&&((0,w.$Ef)(l.relativeLocation)||(0,w.$xf)(l.relativeLocation))&&l.version&&(0,w.$xf)(l.version)}function t(l){return l?(0,w.$xf)(l.path)&&(0,w.$xf)(l.scheme):!1}}),define(ee[128],te([0,1,23,8,37,18,14,44,150,2,13,9,4,19,203,71,12,7,170,36,123,120,202,16,6,5,24,3,74,79,41,40,201]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.Translations=void 0;var L;(function(re){function X(K,V){if(K===V)return!0;const N=Object.keys(K),U=new Set;for(const H of Object.keys(V))U.add(H);if(N.length!==U.size)return!1;for(const H of N){if(K[H]!==V[H])return!1;U.delete(H)}return U.size===0}re.equals=X})(L||(e.Translations=L={})),e.$up=(0,r.$Nh)("IExtensionsScannerService");let F=class extends a.$Rc{constructor(X,K,V,N,U,H,J,ie,oe,T,O,j){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=K,this.r=V,this.s=N,this.t=U,this.u=H,this.w=J,this.y=ie,this.z=oe,this.C=T,this.D=O,this.F=j,this.g=this.B(new o.$Md),this.onDidChangeCache=this.g.event,this.h=(0,d.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Go)(this.w,this.y)),this.G}async scanAllExtensions(X,K,V){const[N,U]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(K)]),H=V?await this.scanExtensionsUnderDevelopment(X,[...N,...U]):[];return this.L(N,U,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const K=[];K.push(this.M(!!X.useCache,X.language)),K.push(this.N(X.language,!!X.checkControlFile));const[V,N]=await Promise.all(K);return this.J([...V,...N],0,X,!1)}async scanUserExtensions(X){const K=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const V=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,N=await this.P(K,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,V),U=X.useCache&&!N.devMode&&N.excludeObsolete?this.m:this.n;let H;try{H=await U.scanExtensions(N)}catch(J){if(J instanceof R.$pp&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await U.scanExtensions(N);else throw J}return H=await this.J(H,1,X,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(X,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(N=>N.scheme===g.Schemas.file).map(async N=>{const U=await this.P(N,!1,1,!0,X.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(U)).map(J=>(J.type=K.find(ie=>(0,k.$vo)(ie.identifier,J.identifier))?.type??J.type,this.n.validate(J,U)))}))).flat();return this.J(V,"development",X,!0)}return[]}async scanExistingExtension(X,K,V){const N=await this.P(X,!1,K,!0,V.language,!0,void 0),U=await this.n.scanExtension(N);return!U||!V.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(X,K,V){const N=await this.P(X,!1,K,!0,V.language,!0,void 0),U=await this.n.scanOneOrMultipleExtensions(N);return this.J(U,K,V,!0)}async scanMetadata(X){const K=(0,d.$ug)(X,"package.json"),V=(await this.w.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(X,K){const V=(0,d.$ug)(X,"package.json"),N=(await this.w.readFile(V)).value.toString(),U=JSON.parse(N);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,U.__metadata={...U.__metadata,...K},await this.w.writeFile((0,d.$ug)(X,"package.json"),M.$ae.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof R.$pp&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ae.fromString(JSON.stringify([])))}catch(K){(0,l.$mk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,K,V,N){return V.includeAllVersions||(X=this.L(K===0?X:void 0,K===1?X:void 0,K==="development"?X:void 0,await this.getTargetPlatform(),N)),V.includeInvalid||(X=X.filter(U=>U.isValid)),X.sort((U,H)=>{const J=b.$mc(U.location.fsPath),ie=b.$mc(H.location.fsPath);return J<ie?-1:J>ie?1:0})}L(X,K,V,N,U){const H=(ie,oe,T)=>{if(ie.isValid&&!oe.isValid)return!1;if(ie.isValid===oe.isValid){if(U&&y.gt(ie.manifest.version,oe.manifest.version))return this.y.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(y.eq(ie.manifest.version,oe.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===N)return this.y.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return T?this.y.warn(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`),!0},J=new u.$4l;return X?.forEach(ie=>{const oe=J.get(ie.identifier.id);(!oe||H(oe,ie,!1))&&J.set(ie.identifier.id,ie)}),K?.forEach(ie=>{const oe=J.get(ie.identifier.id);if(!oe&&X&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!oe||H(oe,ie,!1))&&J.set(ie.identifier.id,ie)}),V?.forEach(ie=>{const oe=J.get(ie.identifier.id);(!oe||H(oe,ie,!0))&&J.set(ie.identifier.id,ie),J.set(ie.identifier.id,ie)}),[...J.values()]}async M(X,K){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),U=await(X&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",U.length),U}async N(X,K){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const N=K?await this.O():{},U=[],H=m.URI.file(b.$gc(b.$ic(g.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of V){const oe=N[ie.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":U.push((0,d.$ug)(H,ie.name));break;default:U.push(m.URI.file(oe));break}}const J=await Promise.all(U.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,X,!0,void 0))));return this.y.trace("Scanned dev system extensions:",J.length),(0,P.$Gb)(J)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,K,V,N,U,H,J){const ie=await this.f(U??p.$w),oe=await this.Q(X),T=K&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=T?await this.Q(T):void 0;return new B(X,oe,T,O,K,J,V,N,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,U,ie)}async Q(X){try{const K=await this.w.stat(X);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$vp=F,e.$vp=F=ke([_(4,A.$Hk),_(5,R.$qp),_(6,l.$9j),_(7,i.$8i),_(8,c.$Uh),_(9,n.$nj),_(10,E.$Fk),_(11,r.$Mh)],F);class B{constructor(X,K,V,N,U,H,J,ie,oe,T,O,j,q,W,z){this.location=X,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=N,this.profile=U,this.profileScanOptions=H,this.type=J,this.excludeObsolete=ie,this.validate=oe,this.productVersion=T,this.productDate=O,this.productCommit=j,this.devMode=q,this.language=W,this.translations=z}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,K){return(0,d.$ng)(X.location,K.location)&&X.mtime===K.mtime&&(0,d.$ng)(X.applicationExtensionslocation,K.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&X.profile===K.profile&&s.$6m(X.profileScanOptions,K.profileScanOptions)&&X.type===K.type&&X.excludeObsolete===K.excludeObsolete&&X.validate===K.validate&&X.productVersion===K.productVersion&&X.productDate===K.productDate&&X.productCommit===K.productCommit&&X.devMode===K.devMode&&X.language===K.language&&L.equals(X.translations,K.translations)}}e.$wp=B;let se=class extends a.$Rc{constructor(X,K,V,N,U){super(),this.f=X,this.g=K,this.h=V,this.j=N,this.m=U}async scanExtensions(X){const K=X.profile?await this.r(X):await this.n(X);let V={};if(X.excludeObsolete&&X.type===1)try{const N=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(N)}catch{}return(0,$.$Kf)(V)?K:K.filter(N=>!V[k.$wo.create(N).toString()])}async n(X){const K=await this.j.resolve(X.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async N=>{if(!N.isDirectory||X.type===1&&(0,d.$rg)(N.resource).indexOf(".")===0)return null;const U=new B(N.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(U)}));return(0,P.$Gb)(V).sort((N,U)=>N.location.path<U.location.path?-1:1)}async r(X){let K=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){K=K.filter(N=>!N.metadata?.isApplicationScoped);const V=await this.s(X.applicationExtensionslocation,N=>!!N.metadata?.isBuiltin||!!N.metadata?.isApplicationScoped,X);K.push(...V)}return K}async s(X,K,V){const N=await this.g.scanProfileExtensions(X,V.profileScanOptions);if(!N.length)return[];const U=await Promise.all(N.map(async H=>{if(K(H)){const J=new B(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(J,H.metadata)}return null}));return(0,P.$Gb)(U)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,d.$ug)(X.location,"package.json"))){const K=await this.scanExtension(X);return K?[K]:[]}else return await this.scanExtensions(X)}catch(K){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,C.$9)(K)),[]}}async scanExtension(X,K){try{let V=await this.scanExtensionManifest(X.location);if(V){V.publisher||(V.publisher=u.$Xl),K=K??V.__metadata,delete V.__metadata;const N=(0,k.$Ao)(V.publisher,V.name),U=K?.id?{id:N,uuid:K.id}:{id:N},H=K?.isSystem?0:X.type,J=H===0||!!K?.isBuiltin;V=await this.t(X.location,V,B.createNlsConfiguration(X));const ie={type:H,identifier:U,manifest:V,location:X.location,isBuiltin:J,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return X.validate?this.validate(ie,X):ie}}catch(V){X.type!==0&&this.m.error(V)}return null}validate(X,K){let V=!0;const N=(0,t.$Lo)(K.productVersion,K.productDate,K.location,X.manifest,X.isBuiltin);for(const[U,H]of N)U===w.default.Error&&(V=!1,this.m.error(this.z(K.location,H)));return X.isValid=V,X.validations=N,X}async scanExtensionManifest(X){const K=(0,d.$ug)(X,"package.json");let V;try{V=(await this.j.readFile(K)).value.toString()}catch(U){return(0,l.$mk)(U)!==1&&this.m.error(this.z(X,(0,h.localize)(0,null,K.path,U.message))),null}let N;try{N=JSON.parse(V)}catch{const H=[];(0,S.$Rm)(V,H);for(const J of H)this.m.error(this.z(X,(0,h.localize)(1,null,K.path,J.offset,J.length,(0,f.$sp)(J.error))));return null}return(0,S.$1m)(N)!=="object"?(this.m.error(this.z(X,(0,h.localize)(2,null,K.path))),null):N}async t(X,K,V){const N=await this.u(X,K,V);if(N)try{const U=[],H=await this.w(N.default,U);if(U.length>0)return U.forEach(ie=>{this.m.error(this.z(X,(0,h.localize)(3,null,N.default?.path,(0,f.$sp)(ie.error))))}),K;if((0,S.$1m)(N)!=="object")return this.m.error(this.z(X,(0,h.localize)(4,null,N.default?.path))),K;const J=N.values||Object.create(null);return(0,I.$tp)(this.m,K,J,H)}catch{}return K}async u(X,K,V){const N=(0,d.$ug)(X,"package.nls.json"),U=(oe,T)=>{T.forEach(O=>{this.m.error(this.z(X,(0,h.localize)(5,null,oe?.path,(0,f.$sp)(O.error))))})},H=oe=>{this.m.error(this.z(X,(0,h.localize)(6,null,oe?.path)))},J=`${K.publisher}.${K.name}`,ie=V.translations[J];if(ie)try{const oe=m.URI.file(ie),T=(await this.j.readFile(oe)).value.toString(),O=[],j=(0,S.$Rm)(T,O);return O.length>0?(U(oe,O),{values:void 0,default:N}):(0,S.$1m)(j)!=="object"?(H(oe),{values:void 0,default:N}):{values:j.contents?j.contents.package:void 0,default:N}}catch{return{values:void 0,default:N}}else{if(!await this.j.exists(N))return;let T;try{T=await this.y(X,V)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const O=(await this.j.readFile(T.localized)).value.toString(),j=[],q=(0,S.$Rm)(O,j);return j.length>0?(U(T.localized,j),{values:void 0,default:T.original}):(0,S.$1m)(q)!=="object"?(H(T.localized),{values:void 0,default:T.original}):{values:q,default:T.original}}catch{return{values:void 0,default:T.original}}}}async w(X,K){if(X)try{const V=(await this.j.readFile(X)).value.toString();return(0,S.$Rm)(V,K)}catch{}}y(X,K){return new Promise((V,N)=>{const U=H=>{const J=(0,d.$ug)(X,`package.nls.${H}.json`);this.j.exists(J).then(ie=>{ie&&V({localized:J,original:(0,d.$ug)(X,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?V({localized:(0,d.$ug)(X,"package.nls.json"),original:null}):(H=H.substring(0,oe),U(H))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,d.$ug)(X,"package.nls.json"),original:null});U(K.language)})}z(X,K){return`[${X.path}]: ${K}`}};se=ke([_(1,R.$qp),_(2,E.$Fk),_(3,l.$9j),_(4,i.$8i)],se);let x=class extends se{constructor(X,K,V,N,U,H,J){super(K,N,U,H,J),this.G=X,this.H=V,this.D=this.B(new D.$Qg(3e3)),this.F=this.B(new o.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(X){const K=this.M(X),V=await this.I(K);if(this.C=X,V&&V.input&&B.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),V.result.map(U=>(U.location=m.URI.revive(U.location),U));const N=await super.scanExtensions(X);return await this.J(K,{input:X,result:N}),N}async I(X){try{const K=await this.j.readFile(X),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,v.$kh)(V.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",X.path,(0,C.$9)(K))}return null}async J(X,K){try{await this.j.writeFile(X,M.$ae.fromString(JSON.stringify(K)))}catch(V){this.m.debug("Error while writing the extension cache file:",X.path,(0,C.$9)(V))}}async L(){if(!this.C)return;const X=this.M(this.C),K=await this.I(X);if(!K)return;const V=K.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$6m(N,V))try{this.m.info("Invalidating Cache",V,N),await this.j.del(X),this.F.fire()}catch(U){this.m.error(U)}}M(X){const K=this.N(X);return this.h.extUri.joinPath(K.cacheHome,X.type===0?u.$Wl:u.$Vl)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(X.location,K.extensionsResource))??this.G:this.H.defaultProfile}};x=ke([_(2,A.$Hk),_(3,R.$qp),_(4,E.$Fk),_(5,l.$9j),_(6,i.$8i)],x);function ae(re,X){const K=(0,k.$yo)(re.manifest.publisher,re.manifest.name);return{id:K,identifier:new u.$2l(K),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:X,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$xp=ae;class ne extends F{constructor(X,K,V,N,U,H,J,ie,oe,T,O,j){super(X,K,(0,d.$ug)(V,".vscode-oss-dev","extensions","control.json"),N,U,H,J,ie,oe,T,O,j),this.R=(async()=>{if(p.$z)try{const q=await this.w.readFile(m.URI.file(p.$z));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(X){return this.R}}e.$yp=ne}),define(ee[274],te([0,1,5,41,40,26,79,16,36,7]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;let g=class extends C.$rp{constructor(p,d,y,w,$,m){super(a.URI.file(p.extensionsPath),d,y,w,$,m)}};e.$uN=g,e.$uN=g=ke([_(0,f.$Vh),_(1,S.$9j),_(2,D.$Hk),_(3,s.$Fk),_(4,M.$_k),_(5,P.$8i)],g)}),define(ee[275],te([0,1,7,36,79,128,16,6,5,24,40,41]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let p=class extends M.$yp{constructor(y,w,$,m,h,c,k,u){super(P.URI.file(h.builtinExtensionsPath),P.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,w,$,m,h,c,k,u)}};e.$z7b=p,e.$z7b=p=ke([_(0,b.$Hk),_(1,s.$qp),_(2,C.$9j),_(3,f.$8i),_(4,D.$Vh),_(5,a.$nj),_(6,g.$Fk),_(7,S.$Mh)],p)}),define(ee[276],te([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let y=class extends D.$Rc{constructor($,m,h){super(),this.c=$,this.f=h,this.a=S.$Th.forPaths(!C.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=P.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(m,h)=>this.j(m,h)),$.protocol.interceptFileProtocol(s.Schemas.file,(m,h)=>this.h(m,h)),this.B((0,D.$Pc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const m=(0,M.$gc)($);return this.a.get(m)?D.$Rc.None:(this.a.set(m,!0),(0,D.$Pc)(()=>this.a.delete(m)))}h($,m){const h=f.URI.parse($.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),m({error:-3})}j($,m){const h=this.m($);let c;return this.c.crossOriginIsolated&&((0,M.$mc)(h)==="workbench.html"||(0,M.$mc)(h)==="workbench-dev.html"?c=s.COI.CoopAndCoep:c=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(h)?m({path:h,headers:c}):this.b.has((0,M.$nc)(h).toLowerCase())?m({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),m({error:-3}))}m($){const m=f.URI.parse($.url),h=s.$bg.uriToFileUri(m);return(0,M.$gc)(h.fsPath)}createIPCObjectUrl(){let $;const m=f.URI.from({scheme:"vscode",path:(0,a.$dg)()}),h=m.toString(),c=async()=>$;return g.$aT.handle(h,c),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:m,update:k=>$=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),g.$aT.removeHandler(h)}}}};e.$P7b=y,e.$P7b=y=ke([_(0,b.$Vh),_(1,d.$Hk),_(2,p.$8i)],y)}),define(ee[96],te([0,1,8,3,2,65,12,111,6,41]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2o=e.$1o=e.$Zo=void 0,e.$Zo="__$__isNewStorageMarker",e.$1o="__$__targetStorageMarker",e.$2o=(0,f.$Nh)("storageService");var g;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function d(h){const c=h.get(e.$1o);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$3o=d;class y extends s.$Rc{static{this.a=60*1e3}constructor(c={flushInterval:y.a}){super(),this.m=c,this.b=this.B(new D.$Pd),this.c=this.B(new D.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new P.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,k,u){return D.Event.filter(this.b.event,t=>t.scope===c&&(k===void 0||t.key===k),u)}n(){this.j.value=(0,P.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,k){const{key:u,external:t}=k;if(u===e.$1o){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:u,target:this.J(c)[u],external:t})}w(c){this.f.fire({reason:c})}get(c,k,u){return this.P(k)?.get(c,u)}getBoolean(c,k,u){return this.P(k)?.getBoolean(c,u)}getNumber(c,k,u){return this.P(k)?.getNumber(c,u)}getObject(c,k,u){return this.P(k)?.getObject(c,u)}storeAll(c,k){this.y(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,k)})}store(c,k,u,t,l=!1){if((0,C.$Gf)(k)){this.remove(c,u,l);return}this.y(()=>{this.z(c,u,t),this.P(u)?.set(c,k,l)})}remove(c,k,u=!1){this.y(()=>{this.z(c,k,void 0),this.P(k)?.delete(c,u)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,k){const u=[],t=this.J(c);for(const l of Object.keys(t))t[l]===k&&u.push(l);return u}z(c,k,u,t=!1){const l=this.J(k);typeof u=="number"?l[c]!==u&&(l[c]=u,this.P(k)?.set(e.$1o,JSON.stringify(l),t)):typeof l[c]=="number"&&(delete l[c],this.P(k)?.set(e.$1o,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const k=this.P(c);return k?d(k):Object.create(null)}isNew(c){return this.getBoolean(e.$Zo,c)===!0}async flush(c=g.NONE){this.f.fire({reason:c});const k=this.P(-1),u=this.P(0),t=this.P(1);switch(c){case g.NONE:await P.Promises.settled([k?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await P.Promises.settled([k?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,k=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return m(c,k,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,k){return this.w(g.NONE),(0,a.$Gk)(c)?this.R(c,k):this.S(c,k)}M(c,k){return!(c.id===k.id||w(k)&&w(c))}N(c,k,u){this.y(()=>{const t=new Set;for(const[l,r]of c)t.add(l),k.get(l)!==r&&this.u(u,{key:l,external:!0});for(const[l]of k.items)t.has(l)||this.u(u,{key:l,external:!0})})}}e.$4o=y;function w(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$5o=w;class $ extends y{constructor(){super(),this.U=this.B(new S.$Xo(new S.$Yo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Xo(new S.$Yo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Xo(new S.$Yo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$6o=$;async function m(h,c,k,u,t,l){const r=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,n=new Map;h.forEach((L,F)=>{i.set(F,L),n.set(F,r(L))});const o=new Map,v=new Map;c.forEach((L,F)=>{o.set(F,L),v.set(F,r(L))});const R=new Map,A=new Map;k.forEach((L,F)=>{R.set(F,L),A.set(F,r(L))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(i.forEach((L,F)=>{E.push({key:F,value:L})}),console.table(E),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];o.forEach((F,B)=>{L.push({key:B,value:F})}),console.table(L),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${l})`);const I=[];R.forEach((L,F)=>{I.push({key:F,value:L})}),console.table(I),console.groupEnd(),console.log(A)}e.$7o=m}),define(ee[277],te([0,1,23,8,3,2,9,70,7,21,111,159,5,96,26,29,13]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.$45b=e.$35b=e.$25b=void 0;class m extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Md),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Md),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$Xo(new g.$Yo,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$bh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(d.$Zo);i===void 0?r.set(d.$Zo,!0):i&&r.set(d.$Zo,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Id(!1);await this.w(),r.stop(),r.elapsed()>m.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([o,v])=>({key:o,length:v.length})),(o,v)=>v.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class h extends m{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$ic)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,h.y)}constructor(r,i,n,o){super(n,o),this.z=r,this.C=i}async t(){return new g.$Xo(new b.$FT(this.path??b.$FT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class c extends h{constructor(r,i,n,o){super(r,i,n,o)}}e.$25b=c;class k extends h{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$cl,void 0)===void 0&&r.set(y.$cl,new Date().toUTCString());const n=r.get(y.$bl,void 0),o=new Date().toUTCString();r.set(y.$dl,typeof n>"u"?null:n),r.set(y.$bl,o)}}e.$35b=k;class u extends m{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,i,n,o,v){super(n,v),this.C=r,this.D=i,this.F=o}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new g.$Xo(new b.$FT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:i?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$FT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),i=(0,C.$ic)(r,u.y);return await a.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$Xh)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$3h)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,C.$ic)(r,u.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$45b=u;class t extends m{get path(){}async t(){return new g.$Xo(new g.$Yo,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$55b=t}),define(ee[278],te([0,1,3,2,96]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;class M extends D.$Rc{constructor(S,f,a){super(),this.b=S,this.c=f,this.f=a;const g=this.B(new D.$Sc);this.a=this.B(new P.$Md({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new D.$Qc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,a)=>(f?f.push(a.key):f=[a.key],f),100)(f=>this.h(f))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,a)=>{f||(f=new Map);let g=f.get(a.profile.id);return g||f.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),f},100)(f=>this.j(f))),S}h(S){const f=S.includes(s.$1o)?[this.c.defaultProfile]:[],a=[];if(S=S.filter(g=>g!==s.$1o),S.length){const g=(0,s.$3o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:S.map(b=>({key:b,scope:0,target:g[b]}))})}this.m(f,a)}j(S){const f=[],a=new Map;for(const[g,b]of S.entries()){b.keys.includes(s.$1o)&&f.push(b.profile);const p=b.keys.filter(d=>d!==s.$1o);if(p.length){const d=(0,s.$3o)(b.storage.storage);a.set(g,{profile:b.profile,changes:p.map(y=>({key:y,scope:0,target:d[y]}))})}}this.m(f,[...a.values()])}m(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,a){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$B7b=M}),define(ee[279],te([0,1,7,36,16,5,34,40,41,12,121]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";var b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=void 0;let d=class extends f.$Kk{static{b=this}static{this.a="profileAssociationsMigration"}constructor(m,h,c,k,u){super(c,k,h,u),this.U=m,this.W=c}O(){return this.U.getItem(b.b,[]).map(h=>({...h,location:(0,a.$xf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):P.URI.revive(h.location)}))}Q(){const m=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?m:this.N(m)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rN=d,e.$rN=d=b=ke([_(0,C.$mN),_(1,S.$Fk),_(2,D.$Vh),_(3,s.$9j),_(4,M.$8i)],d);let y=p=class extends d{constructor(m,h,c,k,u){super(m,h,c,k,u),this.$=m}P(m){m.length?this.$.setItem(p.b,m.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(p.b)}O(){const m=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(m),this.$.setItem("userDataProfilesMigration",!0)),m}R(m){m.emptyWindows||m.workspaces?this.$.setItem(p.c,m):this.$.removeItem(p.c)}Q(){const m="workspaceAndProfileInfo",h=this.$.getItem(m,void 0);if(h){this.$.removeItem(m);const k=h.reduce((u,{workspace:t,profile:l})=>(u[P.URI.revive(t).toString()]=P.URI.revive(l).toString(),u),{});this.$.setItem(p.c,{workspaces:k})}const c=super.Q();return this.$.getItem(p.a,!1)||(this.R(c),this.$.setItem(p.a,!0)),c}};e.$sN=y,e.$sN=y=p=ke([_(0,C.$nN),_(1,S.$Fk),_(2,D.$Vh),_(3,s.$9j),_(4,M.$8i)],y);let w=class extends y{constructor(m,h,c,k){super(new g.$qN(0,h,k,c),m,h,c,k)}async init(){return await this.$.init(),super.init()}};e.$tN=w,e.$tN=w=ke([_(0,S.$Fk),_(1,D.$Vh),_(2,s.$9j),_(3,M.$8i)],w)}),define(ee[52],te([0,1,36,16,6,5,40,41,279,34]),function(Z,e,P,D,s,M,C,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=e.$65b=void 0,e.$65b=(0,s.$Oh)(S.$Hk);let g=class extends f.$sN{constructor(p,d,y,w,$){super(p,d,y,w,$)}getAssociatedEmptyWindows(){const p=[];for(const d of this.C.emptyWindows.keys())p.push({id:d});return p}};e.$75b=g,e.$75b=g=ke([_(0,a.$nN),_(1,C.$Fk),_(2,P.$Vh),_(3,D.$9j),_(4,M.$8i)],g)}),define(ee[129],te([0,1,19,7,29]),function(Z,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=e.$r6b=e.$q6b=void 0;async function M(f,a,g){for(const p of f){const d=p.openedWorkspace;if((0,s.$3h)(d)){const y=await g(d);if(y){if(y.folders.some(w=>P.$lg.isEqualOrParent(a,w.uri)))return p}else if(P.$lg.isEqualOrParent(a,d.configPath))return p}}const b=f.filter(p=>(0,s.$Xh)(p.openedWorkspace)&&P.$lg.isEqualOrParent(a,p.openedWorkspace.uri));if(b.length)return b.sort((p,d)=>-(p.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$q6b=M;function C(f,a){for(const g of f)if((0,s.$3h)(g.openedWorkspace)&&P.$lg.isEqual(g.openedWorkspace.configPath,a)||(0,s.$Xh)(g.openedWorkspace)&&P.$lg.isEqual(g.openedWorkspace.uri,a))return g}e.$r6b=C;function S(f,a){const g=b=>a.some(p=>P.$lg.isEqual(D.URI.file(p),D.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(p=>g(p)))return b}e.$s6b=S}),define(ee[97],te([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GU=e.$FU=e.$EU=e.$DU=e.$CU=e.$BU=e.$AU=e.$zU=e.$yU=e.$xU=void 0,e.$xU=(0,b.$Nh)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.$yU=y;function w(A){return A.hasOwnProperty("folderUri")}e.$zU=w;function $(A){return A.hasOwnProperty("fileUri")}e.$AU=$;function m(A){return h(A)||c(A)}e.$BU=m;function h(A){const E=A;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function c(A){const E=A;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function k(A,E,I,L,F){if(A.scheme!==L.scheme)return{name:I,uri:A.toString(!0)};let B=E?void 0:F.relativePath(L,A);if(B!==void 0)B.length===0?B=".":f.$j&&(B=u(B));else if(A.scheme===C.Schemas.file)B=A.fsPath,f.$j&&(B=u(B));else if(F.isEqualAuthority(A.authority,L.authority))B=A.path;else return{name:I,uri:A.toString(!0)};return{name:I,path:B}}e.$CU=k;function u(A){return A=(0,M.$mv)(A),(0,P.$Tf)(A)||(A=(0,P.$Qf)(A)),A}function t(A,E,I){const L=[],F=new Set,B=I.dirname(E);for(const se of A){let x;if(h(se))se.path&&(x=I.resolvePath(B,se.path));else if(c(se))try{x=g.URI.parse(se.uri),x.path[0]!==S.$fc.sep&&(x=x.with({path:S.$fc.sep+x.path}))}catch(ae){console.warn(ae)}if(x){const ae=I.getComparisonKey(x);if(!F.has(ae)){F.add(ae);const ne=se.name||I.basenameOrAuthority(x);L.push(new d.$8h({uri:x,name:ne,index:L.length},se))}}}return L}e.$DU=t;function l(A,E,I,L,F){const B=r(E,A),se=F.dirname(E),x=F.dirname(L),ae=[];for(const K of B.folders){const V=h(K)?F.resolvePath(se,K.path):g.URI.parse(K.uri);let N;I?N=!1:N=!h(K)||(0,S.$hc)(K.path),ae.push(k(V,N,K.name,x,F))}const ne={insertSpaces:!1,tabSize:4,eol:f.$l||f.$k?`
`:`\r
`},re=s.$US(A,["folders"],ae,ne);let X=s.$XS(A,re);return(0,a.$zg)(B.remoteAuthority,(0,p.$Rk)(L))&&(X=s.$XS(X,s.$TS(X,["remoteAuthority"],ne))),X}e.$EU=l;function r(A,E){const I=D.$Rm(E);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(L=>m(L));else throw new Error(`${A} looks like an invalid workspace file.`);return I}function i(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function n(A){return typeof A.folderUri=="string"}function o(A){return typeof A.fileUri=="string"}function v(A,E){const I={workspaces:[],files:[]};if(A){const L=function(B,se){for(let x=0;x<B.length;x++)try{se(B[x],x)}catch(ae){E.warn(`Error restoring recent entry ${JSON.stringify(B[x])}: ${ae.toString()}. Skip entry.`)}},F=A;Array.isArray(F.entries)&&L(F.entries,B=>{const se=B.label,x=B.remoteAuthority;i(B)?I.workspaces.push({label:se,remoteAuthority:x,workspace:{id:B.workspace.id,configPath:g.URI.parse(B.workspace.configPath)}}):n(B)?I.workspaces.push({label:se,remoteAuthority:x,folderUri:g.URI.parse(B.folderUri)}):o(B)&&I.files.push({label:se,remoteAuthority:x,fileUri:g.URI.parse(B.fileUri)})})}return I}e.$FU=v;function R(A){const E={entries:[]};for(const I of A.workspaces)w(I)?E.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):E.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of A.files)E.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return E}e.$GU=R}),define(ee[98],te([0,1,85,13,4,19]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=e.$j6b=e.$i6b=void 0,e.$i6b=128/4;function C(a){function g(){let b=a.scheme===D.Schemas.file?(0,M.$ig)(a):a.toString();return s.$l||(b=b.toLowerCase()),(0,P.createHash)("md5").update(b).digest("hex")}return{id:g(),configPath:a}}e.$j6b=C;function S(a,g){function b(){if(a.scheme!==D.Schemas.file)return(0,P.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let d;return s.$l?d=g.ino:s.$k?d=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?d=Math.floor(g.birthtimeMs):d=g.birthtime.getTime()),(0,P.createHash)("md5").update(a.fsPath).update(d?String(d):"").digest("hex")}const p=b();if(typeof p=="string")return{id:p,uri:a}}e.$k6b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$l6b=f}),define(ee[99],te([0,1,85,87,28,280,18,14,3,2,9,4,32,42,109]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class w{traceSocketEvent(E,I){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,I)}constructor(E,I=""){this.f=!0,this.debugLabel=I,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Z)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const I=L=>{this.traceSocketEvent("read",L),E(C.$ae.wrap(L))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(E){const I=L=>{E({type:0,hadError:L,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(E){const I=()=>{E()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Ch=w;var $;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var m;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(m||(m={}));class h extends a.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,I){this.socket.traceSocketEvent(E,I)}constructor(E,I,L,F){super(),this.f=this.B(new f.$Md),this.g=this.B(new f.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:L?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new c(this,I,L,F,this.f,(B,se)=>this.m(B,se))),this.B(this.a.onError(B=>{console.error(B),(0,S.$Z)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new y.$xh,this.B(this.socket.onData(B=>this.n(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let I=0;for(;I<E.byteLength;)this.a.writeMessage(E.slice(I,Math.min(I+262144,E.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(E,{compressed:I,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let F=2;E.byteLength<126?F+=0:E.byteLength<2**16?F+=2:F+=8;const B=C.$ae.alloc(F),se=I?64:0,x=L&15;if(B.writeUInt8(128|se|x,0),E.byteLength<126)B.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){B.writeUInt8(126,1);let ae=1;B.writeUInt8(E.byteLength>>>8&255,++ae),B.writeUInt8(E.byteLength>>>0&255,++ae)}else{B.writeUInt8(127,1);let ae=1;B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(E.byteLength>>>24&255,++ae),B.writeUInt8(E.byteLength>>>16&255,++ae),B.writeUInt8(E.byteLength>>>8&255,++ae),B.writeUInt8(E.byteLength>>>0&255,++ae)}this.socket.write(C.$ae.concat([B,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),L=I.readUInt8(0),F=(L&128)>>>7,B=(L&64)>>>6,se=L&15,x=I.readUInt8(1),ae=(x&128)>>>7,ne=x&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),L=I.readUInt8(1),F=(L&128)>>>7;let B=L&127,se=1;B===126?B=I.readUInt8(++se)*2**8+I.readUInt8(++se):B===127&&(B=I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*2**24+I.readUInt8(++se)*2**16+I.readUInt8(++se)*2**8+I.readUInt8(++se));let x=0;F&&(x=I.readUInt8(++se)*2**24+I.readUInt8(++se)*2**16+I.readUInt8(++se)*2**8+I.readUInt8(++se)),this.j.state=3,this.j.readLen=B,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),t(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=h;class c extends a.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ae.alloc(0)}constructor(E,I,L,F,B,se){super(),this.n=E,this.r=B,this.s=se,this.a=this.B(new f.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new k(this.n,F,L,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(E,I){this.g.push({data:E,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:I}=this.g.shift();if(this.f&&I.compressed){const L=await this.w(this.f,E);this.s(L,I)}else this.s(E,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,I){return new Promise((L,F)=>{E.write(I),E.flush(B=>L(B))})}acceptFrame(E,I,L){this.h.push({data:E,isCompressed:I,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const I=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,I,L){return new Promise((F,B)=>{E.write(I),L&&E.write(C.$ae.fromByteArray([0,0,255,255])),E.flush(se=>F(se))})}}class k extends a.$Rc{get recordedInflateBytes(){return this.j?C.$ae.concat(this.f):C.$ae.alloc(0)}constructor(E,I,L,F){super(),this.h=E,this.j=I,this.a=this.B(new f.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(F),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(C.$ae.wrap(B))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$ae.concat(this.g);this.g.length=0,E(I)})}}class u extends a.$Rc{constructor(E,I){super(),this.g=E,this.a=this.B(new f.$Md),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(C.$ae.wrap(L))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$ae.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),E(I)})}}function t(A,E){if(E===0)return;const I=A.byteLength>>>2;for(let ae=0;ae<I;ae++){const ne=A.readUInt32BE(ae*4);A.writeUInt32BE(ne^E,ae*4)}const L=I*4,F=A.byteLength-L,B=E>>>24&255,se=E>>>16&255,x=E>>>8&255;F>=1&&A.writeUInt8(A.readUInt8(L)^B,L),F>=2&&A.writeUInt8(A.readUInt8(L+1)^se,L+1),F>=3&&A.writeUInt8(A.readUInt8(L+2)^x,L+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const A=(0,p.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const E=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,s.tmpdir)(),I=(0,g.$ic)(E,`vscode-ipc-${A}.sock`);return n(I),I}e.$Fh=r;function i(A,E,I){const L=(0,P.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${I}-${E}-sock`;const F=I.substr(0,4),B=E.substr(0,6),se=L.substr(0,8);let x;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?x=(0,g.$ic)(e.$Eh,`vscode-${se}-${F}-${B}.sock`):x=(0,g.$ic)(A,`${F}-${B}.sock`),n(x),x}e.$Gh=i;function n(A){const E=l[b.$u];typeof E=="number"&&A.length>=E&&console.warn(`WARNING: IPC handle "${A}" is longer than ${E} chars, try a shorter --user-data-dir`)}class o extends d.$rh{static b(E){const I=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(I,L=>({protocol:new y.$yh(new w(L,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(L,"close"))}))}constructor(E){super(o.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=o;function v(A){return new Promise((E,I)=>{const L=(0,D.createServer)();L.on("error",I),L.listen(A,()=>{L.removeListener("error",I),E(new o(L))})})}e.$Ih=v;function R(A,E){return new Promise((I,L)=>{const F=(0,D.createConnection)(A,()=>{F.removeListener("error",L),I(y.$zh.fromSocket(new w(F,`ipc-client${E}`),E))});F.once("error",L)})}e.$Jh=R}),define(ee[25],te([0,1,54,9,4,99,36,89,6]),function(Z,e,P,D,s,M,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0,e.$X5b=(0,f.$Oh)(C.$Uh);class a extends S.$fm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,D.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Gh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const p=b.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[b]?process.env[p]=process.env[b]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$l)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$Y5b=a,ke([P.$fh],a.prototype,"cachedLanguagesPath",null),ke([P.$fh],a.prototype,"backupHome",null),ke([P.$fh],a.prototype,"mainIPCHandle",null),ke([P.$fh],a.prototype,"mainLockfile",null),ke([P.$fh],a.prototype,"disableUpdates",null),ke([P.$fh],a.prototype,"crossOriginIsolated",null),ke([P.$fh],a.prototype,"codeCachePath",null),ke([P.$fh],a.prototype,"useCodeCache",null)}),define(ee[281],te([0,1,85,33,13,9,4,19,21,194,17,25,34,16,5,193,29,98]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let c=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,t,l,r){this.j=u,this.k=t,this.l=l,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$lg,this.i={isEqual:(i,n)=>(0,D.$Vf)(i,n,!C.$l)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,a.$f6b)(u)),this.e=await this.v((0,a.$g6b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$uk.OFF}q(){return this.s()===d.$uk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$uk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const l=(0,M.$ic)(this.c,u.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(u,t){if(await f.Promises.exists(u)&&await this.z(u),await f.Promises.exists(t))try{await f.Promises.rename(t,u,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,M.$ic)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.$ic)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const r of u){const i=r.workspace;if(!(0,$.$3h)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$ic)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?l.push(r):await this.z(n):await this.x(n)}}return l}async v(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,M.$ic)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,M.$ic)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(u){try{await f.Promises.rm(u,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,m.$l6b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,m.$l6b)();return{backupFolder:u.id}}async z(u){const t=this.y(),l=(0,M.$ic)(this.c,t.backupFolder);try{await f.Promises.rename(u,l,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,a.$e6b)(u)?t=(0,M.$ic)(this.c,u.backupFolder):(0,w.$vU)(u)?t=(0,M.$ic)(this.c,this.D(u)):t=(0,M.$ic)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await f.Promises.readdir(u);for(const l of t)try{if((await f.Promises.readdir((0,M.$ic)(u,l))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return l&&(r.remoteAuthority=l),r}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const r={folderUri:t.toString()};return l&&(r.remoteAuthority=l),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const r={backupFolder:t};return l&&(r.remoteAuthority=l),r})};this.m.setItem(h.a,u)}D(u){const t=u.folderUri;let l;return t.scheme===s.Schemas.file?l=C.$l?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,P.createHash)("md5").update(l).digest("hex")}};e.$m6b=c,e.$m6b=c=h=ke([_(0,b.$X5b),_(1,g.$hi),_(2,y.$8i),_(3,p.$nN)],c)}),define(ee[20],te([0,1,15,38,8,3,2,4,35,12,6,5,34,25]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.LifecycleMainPhase=e.ShutdownReason=e.$Z5b=void 0,e.$Z5b=(0,g.$Nh)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var $;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let m=class extends C.$Rc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(c,k,u){super(),this.F=c,this.G=k,this.H=u,this.c=this.B(new M.$Md),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Md),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Md),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Md),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const c=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$k&&this.t===0&&this.L(1))};P.app.addListener("before-quit",c);const k=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$k)&&P.app.quit()};P.app.addListener("window-all-closed",k),P.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",c),P.app.removeListener("window-all-closed",k),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(c){if(this.y)return this.y;const k=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:c,join(t,l){k.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===c)return;this.S(`lifecycle (main): phase changed (value: ${c})`),this.n=c;const k=this.C.get(this.n);k&&(k.open(),this.C.delete(this.n))}async when(c){if(c<=this.n)return;let k=this.C.get(c);k||(k=new s.$Rg,this.C.set(c,k)),await k.wait()}registerWindow(c){const k=new C.$Qc;this.t++,k.add(c.onWillLoad(t=>this.g.fire({window:c,workspace:t.workspace,reason:t.reason})));const u=(0,a.$If)(c.win);u.on("close",t=>{const l=c.id;if(this.r.has(l)){this.r.delete(l);return}this.S(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(r=>{if(r){this.r.delete(l);return}this.r.add(l),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire(c),c.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.t--,k.dispose(),this.t===0&&(!S.$k||this.j)&&this.L(1)})}async reload(c,k){await this.unload(c,3)||c.reload(k)}unload(c,k){const u=this.z.get(c.id);if(u)return u;const t=this.M(c,k).finally(()=>{this.z.delete(c.id)});return this.z.set(c.id,t),t}async M(c,k){if(!c.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${c.id}`);const u=this.j?2:k,t=await this.P(c,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.N(t)):(await this.Q(c,u),!1)}N(c){return c?(this.O(!0),this.j=!1,!0):!1}O(c){this.w&&(this.w(c),this.w=void 0,this.u=void 0)}P(c,k){return new Promise(u=>{const t=this.s++,l=`vscode:ok${t}`,r=`vscode:cancel${t}`;D.$aT.once(l,()=>{u(!1)}),D.$aT.once(r,()=>{u(!0)}),c.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:k})})}Q(c,k){return new Promise(u=>{const l=`vscode:reply${this.s++}`;D.$aT.once(l,()=>u()),c.send("vscode:onWillUnload",{replyChannel:l,reason:k})})}quit(c){return this.R(c).then(k=>{if(!k&&c)try{if(S.$j){const u=(0,f.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return k})}R(c){return this.S(`Lifecycle#quit() - begin (willRestart: ${c})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(c&&this.G.setItem(y.b,!0),this.u=new Promise(k=>{this.w=k,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(c){this.H.args["enable-smoke-test-driver"]?this.F.info(c):this.F.trace(c)}setRelaunchHandler(c){this.D=c}async relaunch(c){this.S("Lifecycle#relaunch()");const k=process.argv.slice(1);if(c?.addArgs&&k.push(...c.addArgs),c?.removeArgs)for(const l of c.removeArgs){const r=k.indexOf(l);r>=0&&k.splice(r,1)}const u=()=>{this.D?.handleRelaunch(c)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:k}))};P.app.once("quit",u),await this.quit(!0)&&P.app.removeListener("quit",u)}async kill(c){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Tg)(1e3),(async()=>{for(const k of P.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let u;k.webContents&&!k.webContents.isDestroyed()?u=new Promise(t=>k.once("closed",t)):u=Promise.resolve(),k.destroy(),await u}})()]),P.app.exit(c)}};e.$15b=m,e.$15b=m=y=ke([_(0,b.$8i),_(1,p.$nN),_(2,d.$X5b)],m)}),define(ee[282],te([0,1,4,3,2,6,20]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=e.$Q6b=void 0,e.$Q6b=(0,M.$Nh)("keyboardLayoutMainService");let S=class extends s.$Rc{constructor(g){super(),this.a=this.B(new D.$Md),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((b,p)=>{Z(["native-keymap"],b,p)});this.c=f(g),P.$t||g.onDidChangeKeyboardLayout(()=>{this.c=f(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$R6b=S,e.$R6b=S=ke([_(0,C.$Z5b)],S);function f(a){const g=a.getKeyMap(),b=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:b}}}),define(ee[283],te([0,1,244,8,18,14,12,17,36,93,5,50,243,280]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;let y=class extends b.$Po{constructor(h,c,k,u){super(u),this.m=h,this.n=c,this.r=k,this.s(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,c){const{f:k,g:u}=this;let t;try{t=await(0,a.$Pl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(i)))}const l={...process.env,...t},r=h.agent?h.agent:await(0,p.$Tq)(h.url||"",l,{proxyUrl:k,strictSSL:u});return h.agent=r,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,c))}async resolveProxy(h){}};e.$Uq=y,e.$Uq=y=ke([_(0,S.$hi),_(1,f.$Vh),_(2,g.$8i),_(3,g.$9i)],y);async function w(m){return((0,P.parse)(m.url).protocol==="https:"?await new Promise((k,u)=>{Z(["https"],k,u)}):await new Promise((k,u)=>{Z(["http"],k,u)})).request}async function $(m,h){return D.Promises.withAsyncBody(async(c,k)=>{const u=(0,P.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await w(m),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,C.$Df)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password);const r=t(l,i=>{const n=(0,C.$Bf)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...m,url:i.headers.location,followRedirects:n-1},h).then(c,k);else{let o=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),c({res:i,stream:(0,s.$pe)(o)})}});r.on("error",k),m.timeout&&r.setTimeout(m.timeout),m.isChromiumNetwork&&r.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&r.write(m.data),r.end(),h.onCancellationRequested(()=>{r.abort(),k(new M.$4)})})}e.$Vq=$}),define(ee[284],te([0,1,15,283]),function(Z,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0;function s(C){return P.net.request}class M extends D.$Uq{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$U7b=M}),define(ee[80],te([0,1,7,3,2,36,16,6,20,5,96,277,41,52,40,13]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=e.$05b=e.$95b=e.$85b=void 0,e.$85b=(0,S.$Nh)("storageMainService");let $=class extends s.$Rc{constructor(c,k,u,t,l,r){super(),this.c=c,this.f=k,this.g=u,this.h=t,this.j=l,this.m=r,this.a=void 0,this.b=this.B(new D.$Md),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this.B(this.h.onWillShutdown(c=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)c.join("profileStorage",k.close());for(const[,k]of this.w)c.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(c=>{c.join((async()=>{await this.j.exists(c.profile.globalStorageHome)||await this.j.createFolder(c.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(c=>{const k=this.t.get(c.profile.id);k&&c.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const c=new b.$35b(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(c.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,g.$5o)(c))return this.applicationStorage;let k=this.t.get(c.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${c.name})`),k=this.B(this.u(c)),this.t.set(c.id,k);const u=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:c})));this.B(D.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${c.name})`),this.t.delete(c.id),u.dispose()}))}return k}u(c){return this.a===2?new b.$55b(this.c,this.j):new b.$25b(c,this.n(),this.c,this.j)}workspaceStorage(c){let k=this.w.get(c.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${c.id})`),k=this.B(this.y(c)),this.w.set(c.id,k),this.B(D.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${c.id})`),this.w.delete(c.id)}))),k}y(c){return this.a===2?new b.$55b(this.c,this.j):new b.$45b(c,this.n(),this.c,this.f,this.j)}isUsed(c){const k=P.URI.file(c);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(P.URI.file(u.path),k))return!0;return!1}};e.$95b=$,e.$95b=$=ke([_(0,a.$8i),_(1,M.$Uh),_(2,d.$65b),_(3,f.$Z5b),_(4,C.$9j),_(5,y.$Fk)],$),e.$05b=(0,S.$Nh)("applicationStorageMainService");let m=class extends g.$4o{constructor(c,k){super(),this.s=c,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(c){if(c===-1)return this.U.applicationStorage.storage}Q(c){if(c===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$$5b=m,e.$$5b=m=ke([_(0,p.$Hk),_(1,e.$85b)],m)}),define(ee[285],te([0,1,87,28,103,99,8,2,4,17,5,24,239,240,94,126,18]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=e.$R7b=e.$Q7b=void 0;async function m(t,l,r,i,n){let o;for(let v=3;v&&(o?.dispose(),o=await new h(t,l,r,i,n).waitForReady(),!(n&&s.$gg[n]||!s.$gg[o.tunnelLocalPort]));v--);return o}class h extends S.$Rc{constructor(l,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=P.createServer(),this.c=new C.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,w.$$u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$hg)(l,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(l){l.pause();const r=(0,w.$9u)(this.tunnelRemoteHost)||(0,w.$$u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$3k)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),n instanceof M.$Ch?n.socket.destroy():n.end()}),n instanceof M.$Ch?this.t(l,n):this.s(l,n),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),n.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(i=>l.write(i.buffer)),l.on("data",i=>r.write($.$ae.wrap(i))),l.resume()}t(l,r){const i=r.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$Q7b=h;let c=class extends w.$bv{constructor(l,r,i,n,o){super(r,o),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,w.$_u)(l,this.l,f.OS,D.release())}s(l,r,i,n,o,v,R,A){const E=this.r(r,i);if(E)return++E.refcount,E.value;if((0,w.$6u)(l))return this.t(l,r,i,o,v,R,A);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=m(I,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,L),L}}};e.$R7b=c,e.$R7b=c=ke([_(0,d.$Wk),_(1,g.$8i),_(2,y.$Zk),_(3,b.$nj),_(4,a.$hi)],c);let k=class extends c{constructor(l,r,i,n,o){super(l,r,i,n,o)}};e.$S7b=k,e.$S7b=k=ke([_(0,d.$Wk),_(1,g.$8i),_(2,y.$Zk),_(3,b.$nj),_(4,a.$hi)],k);let u=class extends S.$Rc{constructor(l,r,i,n,o){super(),this.b=l,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(l,r,i,n,o,v,R,A,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${v}.`),!this.a.has(l)){const I=new k(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(l,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,i,n,o,v,R,A,E)}};e.$T7b=u,e.$T7b=u=ke([_(0,d.$Wk),_(1,g.$8i),_(2,b.$nj),_(3,y.$Zk),_(4,a.$hi)],u)}),define(ee[100],te([0,1,8,22,3,17,25,20,5,24,50,48]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=void 0;function p(y,w,$){return`${$.updateUrl}/api/update/${y}/${w}/${$.commit}`}e.$d7b=p;let d=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,$,m,h,c,k){this.f=w,this.g=$,this.h=m,this.i=h,this.j=c,this.k=k,this.b=b.$_T.Uninitialized,this.c=new s.$Md,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$_T.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$_T.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$_T.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),$=this.m(w);if(!$){this.d(b.$_T.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(b.$_T.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$_T.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,m=>this.j.error(m))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$Tg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$e7b=d,e.$e7b=d=ke([_(0,S.$Z5b),_(1,M.$hi),_(2,C.$X5b),_(3,g.$Oo),_(4,f.$8i),_(5,a.$nj)],d)}),define(ee[286],te([0,1,15,54,3,2,17,25,20,5,24,50,26,48,100]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let w=class extends y.$e7b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(m,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(m,h,c)=>({url:h,version:c,productVersion:c}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(m,h,c,k)=>({releaseNotes:h,version:c,productVersion:c,date:k}))}constructor(m,h,c,k,u,t,l){super(m,h,k,u,t,l),this.z=c,this.u=new M.$Qc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.j.error("UpdateService error:",m);const h=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.d(d.$_T.Idle(1,h))}s(m){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,y.$d7b)(h,m,this.k);try{P.autoUpdater.setFeedURL({url:c})}catch(k){this.j.error("Failed to set update feed URL",k);return}return c}t(m){this.d(d.$_T.CheckingForUpdates(m)),P.autoUpdater.checkForUpdates()}E(m){this.state.type==="checking for updates"&&this.d(d.$_T.Downloading(m))}F(m){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:m.version}),this.d(d.$_T.Ready(m)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$_T.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$f7b=w,ke([D.$fh],w.prototype,"v",null),ke([D.$fh],w.prototype,"w",null),ke([D.$fh],w.prototype,"x",null),ke([D.$fh],w.prototype,"y",null),e.$f7b=w=ke([_(0,f.$Z5b),_(1,C.$hi),_(2,p.$_k),_(3,S.$X5b),_(4,b.$Oo),_(5,a.$8i),_(6,g.$nj)],w)}),define(ee[287],te([0,1,47,45,8,3,9,25,20,5,26,48]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;let p=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,$,m){if(this.f=w,this.g=m,this.a=b.$_T.Uninitialized,this.b=new M.$Md,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$_T.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(w=60*60*1e3){return(0,s.$Tg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};p=ke([_(0,f.$Z5b),_(1,S.$X5b),_(2,a.$8i)],p);let d=class extends p{constructor(w,$,m,h,c,k){super(m,h,c),this.o=w,this.p=$,this.q=k;const u=(0,D.watch)(C.$lc(this.o)),t=M.Event.fromNodeEventEmitter(u,"change",(n,o)=>o),l=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(b.$_T.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(b.$_T.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$_T.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$_T.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+C.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((m,h)=>(0,D.realpath)(`${C.$lc(this.o)}/current`,(c,k)=>c?h(c):m(k))),$=C.$mc(w);return this.p!==$}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$h7b=d,e.$h7b=d=ke([_(2,f.$Z5b),_(3,S.$X5b),_(4,a.$8i),_(5,g.$_k)],d)}),define(ee[30],te([0,1,4,6,95,59,67,24,17,25,9]),function(Z,e,P,D,s,M,C,S,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.OpenContext=e.$b6b=void 0,e.$b6b=(0,D.$Nh)("windowsMainService");var b;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(b||(e.OpenContext=b={}));function p(d,y=(0,s.$W5b)(),w){const $=d.get(C.$_5b),m=d.get(S.$nj),h=d.get(f.$hi),c=d.get(a.$X5b),k=h.getValue("window"),u={width:y.width,height:y.height,x:y.x,y:y.y,backgroundColor:$.getBackgroundColor(),minWidth:M.$VC.WIDTH,minHeight:M.$VC.HEIGHT,title:m.nameLong,...w,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.$3C)(k?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...w?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return P.$l?u.icon=(0,g.$ic)(c.appRoot,"resources/linux/code.png"):P.$j&&!c.isBuilt&&(u.icon=(0,g.$ic)(c.appRoot,"resources/win32/code_150x150.png")),P.$k&&(u.acceptFirstMouse=!0,k?.clickThroughInactive===!1&&(u.acceptFirstMouse=!1)),u}e.$c6b=p}),define(ee[288],te([0,1,15,22,3,55,2,32,116,5,80,30]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends C.$Rc{constructor(w,$,m,h){super(),this.g=w,this.h=$,this.j=m,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",($,m,h,c,k)=>({event:$,webContents:m,req:h,authInfo:c,callback:k}));this.B(w(this.r,this))}async r({event:w,authInfo:$,req:m,callback:h}){if(!$.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let c;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{c=await this.b}finally{this.b=void 0}}h(c?.username,c?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(w);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const $=String((0,M.$Bi)({scheme:w.scheme,host:w.host,port:w.port}));let m,h;try{const t=this.m.get(this.a+$,-1);if(t){const l=JSON.parse(await this.j.decrypt(t));m=l.username,h=l.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof m=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:m,password:h};const c=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!c){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const k={authInfo:w,username:this.f?.username??m,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,S.$dg)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,k),this.c=p.LoginDialogShown;const u=await new Promise(t=>{const l=async(r,i,n)=>{if(i===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const v=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+$,v,-1,1)}else this.m.remove(this.a+$,-1)}catch(v){this.g.error(v)}t({username:o.username,password:o.password})}else t(void 0)};c.win?.webContents.on("ipc-message",l)});return this.f=u,u}};e.$d6b=d,e.$d6b=d=ke([_(0,a.$8i),_(1,b.$b6b),_(2,f.$UT),_(3,g.$05b)],d)}),define(ee[289],te([0,1,15,23,4,7,21,17,63,6,5,127,30]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=e.ID=void 0,e.ID="launchMainService",e.$T6b=(0,a.$Nh)(e.ID);let d=class{constructor(w,$,m,h){this.a=w,this.b=$,this.c=m,this.d=h}async start(w,$){this.a.trace("Received data from other instance: ",w,$),s.$k&&P.app.focus({steal:!0});const m=this.e(w);if(m.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const c=(0,D.$Nb)(await this.b.openEmptyWindow({context:4}));c&&(h=c.ready())}h.then(()=>{for(const{uri:c,originalUrl:k}of m)this.c.open(c,{originalUrl:k})})}else return this.f(w,$)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,D.$Gb)(w._urls.map($=>{try{return{uri:M.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(w,$){const m=(0,f.$Jl)($)?0:4;let h=[];const c=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,k=w.remote||void 0,u={context:m,cli:w,userEnv:$,waitMarkerFileURI:c,remoteAuthority:k,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,u);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$k}if(t)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,u),h=[l]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(c&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,C.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$U6b=d,e.$U6b=d=ke([_(0,g.$8i),_(1,p.$b6b),_(2,b.$1T),_(3,S.$hi)],d)}),define(ee[290],te([0,1,2,20,52,29,8,30]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;let f=class extends P.$Rc{constructor(g,b,p){super(),this.a=b,this.b=p,this.B(g.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(g.onBeforeCloseWindow(d=>this.c(d))),this.B(new C.$5g(()=>this.g(),30*1e3)).schedule()}async c(g){const b=this.f(g),p=this.a.getProfileForWorkspace(b);p?.isTransient&&(this.a.unsetWorkspace(b,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,M.$2h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const b=this.b.getWindows().map(p=>this.f(p));for(const p of g)b.some(d=>d.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$A7b=f,e.$A7b=f=ke([_(0,D.$Z5b),_(1,s.$65b),_(2,S.$b6b)],f)}),define(ee[61],te([0,1,15,2,3,5,311,8,13,30,71,26,20,73,37,4,130]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0;function h(u){return typeof u.responseWindowId=="number"}let c=class extends D.$Rc{static{m=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(m.b.values())}constructor(t,l,r){super(),this.t=t,this.u=l,this.w=r,this.c=String(++m.a),this.f=this.B(new s.$Md),this.onStdout=this.f.event,this.g=this.B(new s.$Md),this.onStderr=this.g.event,this.h=this.B(new s.$Md),this.onMessage=this.h.event,this.j=this.B(new s.$Md),this.onExit=this.j.event,this.m=this.B(new s.$Md),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,l){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,l){case g.default.Error:this.t.error(r);break;case g.default.Warning:this.t.warn(r);break;case g.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const l=this.C(t);return l&&t.payload&&this.postMessage(t.payload),l}C(t){if(!this.z())return!1;this.s=t;const l=`${this.s.type}-${this.c}`,r=f.$bg.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,v=this.s.forceAllocationsToV8Sandbox,R="pipe",A=this.D(t);return this.y("creating new...",g.default.Info),this.n=P.utilityProcess.fork(r,i,{serviceName:l,env:A,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:v,stdio:R}),this.F(this.n,this.s,l),!0}D(t){const l=t.env?{...t.env}:{...(0,y.$2m)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$j&&((0,$.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,d.$wl)(l);for(const r of Object.keys(l))l[r]=String(l[r]);return l}F(t,l,r){if(t.stdout){const i=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&m.b.set(t.pid,{pid:t.pid,name:h(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,g.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,l){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),l())}))}postMessage(t,l){this.n&&this.n.postMessage(t,l)}connect(t){const{port1:l,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),l}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&m.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Tg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$v6b=c,e.$v6b=c=m=ke([_(0,M.$8i),_(1,b.$_k),_(2,p.$Z5b)],c);let k=class extends c{constructor(t,l,r,i){super(t,r,i),this.H=l}start(t){const l=this.H.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(t))return!1;this.I(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$w6b=k,e.$w6b=k=ke([_(0,M.$8i),_(1,a.$b6b),_(2,b.$_k),_(3,p.$Z5b)],k)}),define(ee[291],te([0,1,14,5,20,8,61,30,26]),function(Z,e,P,D,s,M,C,S,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=void 0;let g=class{static{a=this}static{this.a=0}constructor(p,d,y,w){this.d=p,this.f=d,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const d=this.b.get(p);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,P.$5)();const p=String(++a.a),d=new C.$w6b(this.d,this.g,this.h,this.f);return this.b.set(p,d),d.onExit(({pid:y,code:w,signal:$})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${$}.`),setTimeout(()=>{d.dispose(),this.b.delete(p)})}),{id:p}}async start(p,d){if(this.c)throw(0,P.$5)();this.i(p).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,P.$5)();const d=this.b.get(p);return d?d.enableInspectPort():!1}async kill(p){if(this.c)throw(0,P.$5)();const d=this.b.get(p);d&&d.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const d=[];for(const[,y]of this.b)d.push(y.waitForExit(p));return M.Promises.settled(d).then(()=>{})}};e.$D6b=g,e.$D6b=g=a=ke([_(0,D.$8i),_(1,s.$Z5b),_(2,S.$b6b),_(3,f.$_k)],g)}),define(ee[292],te([0,1,38,8,2,25,20,5,41,39,66,61,51,89,12,245,24]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=void 0;let m=class extends s.$Rc{constructor(c,k,u,t,l,r,i,n){super(),this.c=c,this.f=k,this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.r=n,this.a=new D.$Rg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$aT.on(w.$86b.request,(c,k)=>this.t(c,k,w.$86b.response)),P.$aT.on(w.$96b.request,(c,k)=>this.t(c,k,w.$96b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(c,k,u){this.j.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(u);if(c.sender.isDestroyed())return t.close();c.sender.postMessage(u,k,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$76b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const c=new D.$bh;this.b?this.b.once(w.$76b.initDone,()=>c.complete()):P.$aT.once(w.$76b.initDone,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const c=new D.$bh;this.b?this.b.once(w.$76b.ipcReady,()=>c.complete()):P.$aT.once(w.$76b.ipcReady,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$v6b(this.j,p.$ho,this.h));const c=(0,d.$hm)(this.f.args,this.f.isBuilt);let k;c.port&&(k=["--nolazy"],c.break?k.push(`--inspect-brk=${c.port}`):k.push(`--inspect=${c.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:k,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(c){return await this.z,(0,y.$If)(this.b).connect(c)}};e.$06b=m,e.$06b=m=ke([_(1,M.$X5b),_(2,f.$Hk),_(3,C.$Z5b),_(4,S.$8i),_(5,g.$56b),_(6,a.$dn),_(7,$.$nj)],m)}),define(ee[293],te([0,1,25,89,20,5,51,61,110,38,2,3,37,17,13]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;let w=class extends g.$Rc{constructor(m,h,c,k,u){super(),this.f=m,this.g=h,this.h=c,this.j=k,this.m=u,this.a=void 0,this.b=new b.$Md,this.onRequestConnection=this.b.event,this.c=new b.$Md,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$aT.on("vscode:createPtyHostMessageChannel",(t,l)=>this.r(t,l)),this.B((0,g.$Pc)(()=>{a.$aT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$v6b(this.m,C.$ho,this.j);const m=(0,D.$gm)(this.h.args,this.h.isBuilt),h=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const c=this.a.connect(),k=new f.$iT(c,"ptyHost"),u=new g.$Qc;return u.add(k),u.add((0,g.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,p.$2m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(m.VSCODE_LATENCY=String(h));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(m.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),m}r(m,h){this.b.fire();const c=this.a.connect();if(m.sender.isDestroyed()){c.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[c])}};e.$I7b=w,e.$I7b=w=ke([_(1,d.$hi),_(2,P.$X5b),_(3,s.$Z5b),_(4,M.$8i)],w)}),define(ee[294],te([0,1,2,6,5,30,61,26,55,3,8,20]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=e.$G7b=void 0,e.$G7b=(0,D.$Nh)("utilityProcessWorker");let p=class extends P.$Rc{constructor(w,$,m,h){super(),this.b=w,this.c=$,this.f=m,this.g=h,this.a=new Map}async createWorker(w){const $=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const m=this.h(w);this.a.has(m)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(w));const h=new d(this.b,this.c,this.f,this.g,w);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(m,h);const c=new g.$bh;return a.Event.once(h.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(m),c.complete({reason:k})}),c.p}h(w){return(0,f.$Bi)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const $=this.h(w),m=this.a.get($);m&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),m.kill(),this.a.delete($))}};e.$H7b=p,e.$H7b=p=ke([_(0,s.$8i),_(1,M.$b6b),_(2,S.$_k),_(3,b.$Z5b)],p);let d=class extends P.$Rc{constructor(w,$,m,h,c){super(),this.c=w,this.f=$,this.g=m,this.h=h,this.j=c,this.a=this.B(new a.$Md),this.onDidTerminate=this.a.event,this.b=new C.$w6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ke([_(0,s.$8i),_(1,M.$b6b),_(2,S.$_k),_(3,b.$Z5b)],d)}),define(ee[295],te([0,1,15,3,2,271,30]),function(Z,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;let S=class extends s.$Rc{constructor(a){super(),this.b=a,this.a=this.B(new D.$Md),this.onFoundInFrame=this.a.event,this.B(new M.$o7b)}async setIgnoreMenuShortcuts(a,g){let b;if(typeof a.windowId=="number"){const{windowId:p}=a,d=this.b.getWindowById(p);if(!d?.win)throw new Error(`Invalid windowId: ${p}`);b=d.win.webContents}else{const{webContentsId:p}=a;if(b=P.webContents.fromId(p),!b)throw new Error(`Invalid webContentsId: ${p}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,b,p){const y=this.c(a,g);if(typeof y.findInFrame=="function"){y.findInFrame(b,{findNext:p.findNext,forward:p.forward});const w=($,m)=>{m.finalUpdate&&(this.a.fire(m),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(a,g,b){const d=this.c(a,g);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(a,g){const b=this.b.getWindowById(a.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${a}`);const p=b.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===g);if(!p)throw new Error(`Unknown frame: ${g}`);return p}};e.$p7b=S,e.$p7b=S=ke([_(0,C.$b6b)],S)}),define(ee[296],te([0,1,15,13,17,25,59,30]),function(Z,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;let f=class{static open(g){return g.invokeFunction(S.$c6b,void 0,{webPreferences:{preload:D.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}constructor(g,b,p){this.a=g,this.b=b,this.c=p,this.d(),this.e()}d(){this.a.on("dom-ready",()=>{const g=this.b.getValue("window")?.zoomLevel??0;this.a.setZoomLevel(g),this.a.setZoomFactor((0,C.$3C)(g))}),this.c.args["open-devtools"]===!0&&this.a.openDevTools({mode:"bottom"})}e(){this.a.ipc.on("vscode:focusAuxiliaryWindow",()=>{this.f(g=>g.focus(),!0)}),this.a.ipc.on("vscode:moveAuxiliaryWindowTop",()=>{this.f(g=>g.moveTop(),!0)})}f(g,b){const p=P.BrowserWindow.fromWebContents(this.a);p&&(b&&p.isMinimized()&&p.restore(),g(p))}};e.$M7b=f,e.$M7b=f=ke([_(1,s.$hi),_(2,M.$X5b)],f)}),define(ee[297],te([0,1,15,2,4,19,7,17,20,5,34,30,95,29]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=e.$s7b=e.$r7b=void 0;let w=class extends D.$Rc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,l,r,i){super(),this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.b=$(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.w(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$k&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=h(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(l=>{const r=(0,d.$3h)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,d.$Xh)(u.openedWorkspace)&&l.folderUri&&M.$lg.isEqual(l.folderUri,u.openedWorkspace.uri);(r||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,d.$3h)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,d.$Xh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),l=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||l?.restoreFullscreen),r||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const v=u.workspace;if((0,d.$3h)(v)){const A=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===v.id).map(E=>E.uiState);if(A.length)return A[0]}if((0,d.$Xh)(v)){const A=this.state.openedWindows.filter(E=>E.folderUri&&M.$lg.isEqual(E.folderUri,v.uri)).map(E=>E.uiState);if(A.length)return A[0]}else if(u.backupPath){const A=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(A.length)return A[0]}const R=this.c||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let l;const r=P.screen.getAllDisplays();if(r.length===1)l=r[0];else{if(s.$k){const v=P.screen.getCursorScreenPoint();l=P.screen.getDisplayNearestPoint(v)}!l&&t&&(l=P.screen.getDisplayMatching(t.getBounds())),l||(l=P.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$W5b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const v=t.serializeWindowState();v.mode===3?i.mode=3:i=v,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.$r7b=w,e.$r7b=w=y=ke([_(0,b.$b6b),_(1,g.$nN),_(2,f.$Z5b),_(3,a.$8i),_(4,S.$hi)],w);function $(k){const u={openedWindows:[]},t=k||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>m(l))),u}e.$s7b=$;function m(k){const u={uiState:k.uiState};return k.backupPath&&(u.backupPath=k.backupPath),k.remoteAuthority&&(u.remoteAuthority=k.remoteAuthority),k.folder&&(u.folderUri=C.URI.parse(k.folder)),k.workspaceIdentifier&&(u.workspace={id:k.workspaceIdentifier.id,configPath:C.URI.parse(k.workspaceIdentifier.configURIPath)}),u}function h(k){return{lastActiveWindow:k.lastActiveWindow&&c(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&c(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(u=>c(u))}}e.$t7b=h;function c(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[53],te([0,1,15,3,44,2,13,9,19,21,192,64,60,25,6,5,52,129,29,97,98]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=void 0,e.$t6b=(0,y.$Nh)("workspacesManagementMainService");let u=class extends M.$Rc{constructor(l,r,i,n,o){super(),this.g=l,this.h=r,this.j=i,this.m=n,this.n=o,this.a=this.B(new D.$Md),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$Md),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,f.$ug)(this.c,r,h.$ai));for(const r of l){const i=(0,k.$j6b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.r(l,r=>a.Promises.readFile(r,"utf8"))}r(l,r){if(this.s(l)&&l.scheme===C.Schemas.file)try{const i=r(l.fsPath);return i instanceof Promise?i.then(n=>this.t(l,n),n=>{}):this.t(l,i)}catch{return}}s(l){return(0,h.$bi)(l,this.g)||(0,h.$gi)(l)}t(l,r){try{const i=this.u(l,r),n=(0,k.$j6b)(l);return{id:n.id,configPath:n.configPath,folders:(0,c.$DU)(i.folders,n.configPath,f.$lg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(l,r){const i=(0,s.$Rm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.$BU)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,r){const{workspace:i,storedWorkspace:n}=this.w(l,r),o=i.configPath.fsPath;return await a.Promises.mkdir((0,S.$lc)(o),{recursive:!0}),await a.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(l=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$ug)(this.c,i),o=(0,f.$ug)(n,h.$ai),v=[];for(const R of l)v.push((0,c.$CU)(R.uri,!0,R.name,n,f.$lg));return{workspace:(0,k.$j6b)(o),storedWorkspace:{folders:v,remoteAuthority:r}}}async getWorkspaceIdentifier(l){return(0,k.$j6b)(l)}isUntitledWorkspace(l){return(0,h.$bi)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.y(l),this.j.isEnabled()&&this.j.unsetWorkspace(l),this.a.fire(l))}async y(l){const r=(0,f.$ig)(l.configPath);try{await a.Promises.rm((0,S.$lc)(r));const i=(0,S.$ic)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,l.id);await a.Promises.exists(i)&&await a.Promises.writeFile((0,S.$ic)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,r,i){if(!l||!l.win||!l.isReady||!await this.z(l,r,i))return;const o=await this.C(l,(0,k.$j6b)(i));if(o)return this.b.fire({window:l,workspace:o.workspace}),o}async z(l,r,i){return i?(0,h.$3h)(l.openedWorkspace)&&f.$lg.isEqual(l.openedWorkspace.configPath,i)?!1:(0,m.$r6b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,f.$rg)(i)),detail:(0,g.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(l,r){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority})),(0,h.$3h)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=r,l.config.backupPath=i,{workspace:r,backupPath:i}}};e.$u6b=u,e.$u6b=u=ke([_(0,d.$X5b),_(1,w.$8i),_(2,$.$65b),_(3,b.$h6b),_(4,p.$o6b)],u)}),define(ee[131],te([0,1,15,38,22,6,30,29,53,12,5,61]),function(Z,e,P,D,s,M,C,S,f,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$y6b=(0,M.$Nh)(e.ID);let p=class{constructor(y,w,$){this.a=y,this.b=w,this.c=$}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async m=>{const h=m.remoteAuthority;if(!h)return;const c=`vscode:getDiagnosticInfoResponse${m.id}`,k={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(m):void 0};return new Promise(u=>{m.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:c,args:k}),D.$aT.once(c,(t,l)=>{l||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(l)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const $ of P.BrowserWindow.getAllWindows()){const m=this.a.getWindowById($.id);m?y.push(await this.d(m)):y.push(this.e($))}const w=[];for(const{pid:$,name:m}of b.$v6b.getAll())w.push({pid:$,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),$=(0,a.$If)(y.win);return this.e($,w,y.remoteAuthority)}e(y,w=[],$){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:$}}async f(y){const w=[],$=y.openedWorkspace;if((0,S.$Xh)($))w.push($.uri);else if((0,S.$3h)($)){const m=await this.b.resolveLocalWorkspace($.configPath);m&&m.folders.forEach(c=>{w.push(c.uri)})}return w}};e.$z6b=p,e.$z6b=p=ke([_(0,C.$b6b),_(1,f.$t6b),_(2,g.$8i)],p)}),define(ee[68],te([0,1,47,15,28,154,54,3,2,13,9,4,7,105,86,21,103,180,60,25,6,20,5,24,67,30,29,53,18,241,233]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=void 0,e.$M6b=(0,k.$Nh)("nativeHostMainService");let E=class extends f.$Rc{constructor(L,F,B,se,x,ae,ne,re){super(),this.a=L,this.b=F,this.c=B,this.f=se,this.g=x,this.h=ae,this.j=ne,this.m=re,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,X=>X.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:X,x:K,y:V})=>({windowId:X.id,x:K,y:V})),({windowId:X})=>!!this.a.getWindowById(X)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(X,K)=>K.id),X=>!!this.a.getWindowById(X)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(X,K)=>K.id),X=>!!this.a.getWindowById(X)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(X,K)=>K.id),X=>!!this.a.getWindowById(X)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),X=>!!X),X=>X.id),S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(X,K)=>K.id),X=>!!this.a.getWindowById(X))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$Md),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(X,K,V)=>V),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),S.Event.fromNodeEventEmitter(D.screen,"display-added"),S.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,n.$2h)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const F=D.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(F)return F.id}openWindow(L,F,B){return Array.isArray(F)?this.r(L,F,B):this.s(L,F)}async r(L,F,B=Object.create(null)){F.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:F,cli:this.f.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async s(L,F){await this.a.openEmptyWindow({context:5,contextWindowId:L},F)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const F=this.C(L);return F?.win?F.win.isMaximized():!1}async maximizeWindow(L){const F=this.C(L);F?.win&&F.win.maximize()}async unmaximizeWindow(L){const F=this.C(L);F?.win&&F.win.unmaximize()}async minimizeWindow(L){const F=this.C(L);F?.win&&F.win.minimize()}async moveWindowTop(L){const F=this.C(L);F?.win&&F.win.moveTop()}async updateWindowControls(L,F){const B=this.C(L);B&&B.updateWindowControls(F)}async focusWindow(L,F){F&&typeof F.windowId=="number"&&(L=F.windowId),this.C(L)?.focus({force:F?.force??!1})}async setMinimumSize(L,F,B){const se=this.C(L);if(se?.win){const[x,ae]=se.win.getSize(),[ne,re]=se.win.getMinimumSize(),[X,K]=[F??ne,B??re],[V,N]=[Math.max(x,X),Math.max(ae,K)];(ne!==X||re!==K)&&se.win.setMinimumSize(X,K),(x!==V||ae!==N)&&se.win.setSize(V,N)}}async saveWindowSplash(L,F){this.j.saveWindowSplash(L,F)}async installShellCommand(L){const{source:F,target:B}=await this.t();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(F);if(se&&!se.dangling){const x=await(0,d.$3p)(F);if(B===x)return}await w.Promises.unlink(F)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(B,F)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:x}=await this.showMessageBox(L,{type:"info",message:(0,m.localize)(0,null,this.h.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(x===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${F}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,m.localize)(3,null,F))}}}async uninstallShellCommand(L){const{source:F}=await this.t();try{await w.Promises.unlink(F)}catch(B){switch(B.code){case"EACCES":{const{response:se}=await this.showMessageBox(L,{type:"info",message:(0,m.localize)(4,null,this.h.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(se===0)try{const x=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(x)}catch{throw new Error((0,m.localize)(7,null,F))}break}case"ENOENT":break;default:throw B}}}async t(){const L=(0,g.$jc)(this.f.appRoot,"bin","code"),F=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists(L))throw new Error((0,m.localize)(8,null,L));return{source:F,target:L}}async showMessageBox(L,F){return this.b.showMessageBox(F,this.u(L))}async showSaveDialog(L,F){return this.b.showSaveDialog(F,this.u(L))}async showOpenDialog(L,F){return this.b.showOpenDialog(F,this.u(L))}u(L){const F=this.C(L);if(F?.win)return F.win}async pickFileFolderAndOpen(L,F){const B=await this.b.pickFileFolder(F);B&&await this.w(await Promise.all(B.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:p.URI.file(se)}:{fileUri:p.URI.file(se)})),F,L)}async pickFolderAndOpen(L,F){const B=await this.b.pickFolder(F);B&&await this.w(B.map(se=>({folderUri:p.URI.file(se)})),F,L)}async pickFileAndOpen(L,F){const B=await this.b.pickFile(F);B&&await this.w(B.map(se=>({fileUri:p.URI.file(se)})),F,L)}async pickWorkspaceAndOpen(L,F){const B=await this.b.pickWorkspace(F);B&&await this.w(B.map(se=>({workspaceUri:p.URI.file(se)})),F,L)}async w(L,F,B){await this.a.open({context:3,contextWindowId:B,cli:this.f.args,urisToOpen:L,forceNewWindow:F.forceNewWindow})}async showItemInFolder(L,F){D.shell.showItemInFolder(F)}async setRepresentedFilename(L,F){this.C(L)?.setRepresentedFilename(F)}async setDocumentEdited(L,F){this.C(L)?.setDocumentEdited(F)}async openExternal(L,F){return this.f.unsetSnapExportedVariables(),D.shell.openExternal(F),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,F){return D.shell.trashItem(F)}async isAdmin(){let L;return b.$j?L=(await new Promise((F,B)=>{Z(["native-is-elevated"],F,B)}))():L=process.getuid?.()===0,L}async writeElevated(L,F,B,se){const x=await new Promise((ae,ne)=>{Z(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const re=[`"${this.z}"`];se?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${F.fsPath}"`,`"${B.fsPath}"`);const X={name:this.h.nameLong.replace("-",""),icns:b.$k&&this.f.isBuilt?(0,g.$ic)((0,g.$lc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};x.exec(re.join(" "),X,(K,V,N)=>{V&&this.g.trace(`[sudo-prompt] received stdout: ${V}`),N&&this.g.trace(`[sudo-prompt] received stderr: ${N}`),K?ne(K):ae(void 0)})})}async isRunningUnderARM64Translation(){return b.$l||b.$j?!1:D.app.runningUnderARM64Translation}get z(){return b.$j?this.f.isBuilt?(0,g.$ic)((0,g.$lc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.bat"):b.$l?this.f.isBuilt?(0,g.$ic)((0,g.$lc)(process.execPath),"bin",`${this.h.applicationName}`):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,g.$ic)(this.f.appRoot,"bin","code"):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Nm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.$j&&(0,R.$K6b)()}async killProcess(L,F,B){process.kill(F,B)}async readClipboardText(L,F){return D.clipboard.readText(F)}async writeClipboardText(L,F,B){return D.clipboard.writeText(F,B)}async readClipboardFindText(L){return D.clipboard.readFindText()}async writeClipboardFindText(L,F){return D.clipboard.writeFindText(F)}async writeClipboardBuffer(L,F,B,se){return D.clipboard.writeBuffer(F,Buffer.from(B.buffer),se)}async readClipboardBuffer(L,F){return v.$ae.wrap(D.clipboard.readBuffer(F))}async hasClipboard(L,F,B){return D.clipboard.has(F,B)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,F){this.C(L)?.updateTouchBar(F)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,F){return this.c.relaunch(F)}async reload(L,F){const B=this.C(L);if(B){if((0,n.$3h)(B.openedWorkspace)){const se=B.openedWorkspace.configPath;if(se.scheme===a.Schemas.file&&(await this.m.resolveLocalWorkspace(se))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.c.reload(B,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,F){const B=this.C(F);if(B?.win)return B.win.close()}async quit(L){const F=this.a.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&F.win?F.win.close():this.c.quit()}async exit(L,F){await this.c.kill(F)}async resolveProxy(L,F){return this.C(L)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(L,F,B,se,x=1){return(0,$.$fg)(F,B,se,x)}async openDevTools(L,F){const B=this.C(L);B?.win&&B.win.webContents.openDevTools(F)}async toggleDevTools(L){const F=this.C(L);F?.win&&F.win.webContents.toggleDevTools();for(const B of D.BrowserWindow.getAllWindows())B.webContents.getURL()==="about:blank"&&B.webContents.toggleDevTools()}async sendInputEvent(L,F){const B=this.C(L);B?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&B.win.webContents.sendInputEvent(F)}async profileRenderer(L,F,B){const se=this.C(L);if(!se||!se.win)throw new Error;return await new A.$L6b(se.win,F,this.g).inspect(B)}async windowsGetStringRegKey(L,F,B,se){if(!b.$j)return;const x=await new Promise((ae,ne)=>{Z(["@vscode/windows-registry"],ae,ne)});try{return x.GetStringRegKey(F,B,se)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$N6b=E,ke([C.$fh],E.prototype,"z",null),e.$N6b=E=ke([_(0,i.$b6b),_(1,h.$o6b),_(2,u.$Z5b),_(3,c.$X5b),_(4,t.$8i),_(5,l.$nj),_(6,r.$_5b),_(7,o.$t6b)],E)}),define(ee[298],te([0,1,15,38,28,2,13,4,107,178,90,131,60,25,5,68,77,24,78,59,33,34,61,22,7,30,8]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=void 0;const v="issue.processExplorerWindowState";let R=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,L,F,B,se,x,ae,ne,re,X,K){this.g=I,this.h=L,this.i=F,this.j=B,this.k=se,this.l=x,this.m=ae,this.n=ne,this.o=re,this.p=X,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){D.$aT.on("vscode:listProcesses",async I=>{const L=[];try{L.push({name:(0,a.localize)(0,null),rootProcess:await(0,f.$yr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(B=>{(0,g.$nm)(B)?L.push({name:B.hostName,rootProcess:B}):B.processes&&L.push({name:B.hostName,rootProcess:B.processes})})}catch(F){this.i.error(`Listing processes failed: ${F}`)}this.t(I,"vscode:listProcessesResponse",L)}),D.$aT.on("vscode:workbenchCommand",(I,L)=>{const{id:F,from:B,args:se}=L;let x;switch(B){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${B}`)}x?.webContents.send("vscode:runAction",{id:F,from:B,args:se})}),D.$aT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),D.$aT.on("vscode:pidToNameRequest",async I=>{const L=await this.k.getMainDiagnostics(),F=[];for(const B of L.windows)F.push([B.pid,`window [${B.id}] (${B.title})`]);for(const{pid:B,name:se}of t.$v6b.getAll())F.push([B,se]);this.t(I,"vscode:pidToNameResponse",F)})}async openReporter(I){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$Qc,F=L.add(this.n.createIPCObjectUrl()),B=this.v(this.c,700,800);this.b=this.u(B,F,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:$.default}),this.b.loadURL(C.$bg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$Qc,F=L.add(this.n.createIPCObjectUrl()),B=this.p.getItem(v,void 0),se=A(B)?B:this.v(this.f,800,500);this.d=this.u(se,F,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:$.default}),this.d.loadURL(C.$bg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const x=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const re={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(v,re)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await P.contentTracing.stopRecording(`${(0,k.$5f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,I),buttons:[(0,a.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,L)}async $getSystemInfo(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,L)}async $getPerformanceInfo(){try{const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,L)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(B,se)=>{const x=new l.$Wd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:F,extensionId:I}),D.$aT.once(F,(ae,ne)=>{B(r.URI.parse(ne))});try{await(0,n.$Tg)(5e3),x.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{D.$aT.removeHandler(F)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,L,...F){I.sender.isDestroyed()||I.sender.send(L,...F)}u(I,L,F,B){const se=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:F.title,backgroundColor:F.backgroundColor||o.a,webPreferences:{preload:C.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.$3C)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}v(I,L,F){let B;const se=P.screen.getAllDisplays();if(se.length===1)B=se[0];else{if(S.$k){const ne=P.screen.getCursorScreenPoint();B=P.screen.getDisplayNearestPoint(ne)}!B&&I&&(B=P.screen.getDisplayMatching(I.getBounds())),B||(B=P.screen.getPrimaryDisplay()||se[0])}const x=B.bounds,ae={width:L,height:F,x:x.x+x.width/2-L/2,y:x.y+x.height/2-F/2};return x.width>0&&x.height>0&&(ae.x<x.x&&(ae.x=x.x),ae.y<x.y&&(ae.y=x.y),ae.x>x.x+x.width&&(ae.x=x.x),ae.y>x.y+x.height&&(ae.y=x.y),ae.width>x.width&&(ae.width=x.width),ae.height>x.height&&(ae.height=x.height)),ae}};e.$P6b=R,e.$P6b=R=o=ke([_(1,d.$X5b),_(2,y.$8i),_(3,g.$mm),_(4,b.$y6b),_(5,p.$o6b),_(6,w.$M6b),_(7,h.$O6b),_(8,m.$nj),_(9,u.$nN),_(10,i.$b6b)],R);function A(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ee[299],te([0,1,22,17,25,20,5,68,24,50,26,48,100]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;let d=class extends p.$e7b{constructor(w,$,m,h,c,k,u,t){super(w,$,h,c,k,t),this.e=m,this.u=u}s(w){return(0,p.$d7b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(b.$_T.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(a.$Uo).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(b.$_T.Idle(1))):this.d(b.$_T.AvailableForDownload($))}).then(void 0,$=>{this.j.error($),this.e.publicLog2("update:notAvailable",{explicit:!!w});const m=w?$.message||$:void 0;this.d(b.$_T.Idle(1,m))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(b.$_T.Idle(1))}};e.$g7b=d,e.$g7b=d=ke([_(0,M.$Z5b),_(1,D.$hi),_(2,g.$_k),_(3,s.$X5b),_(4,a.$Oo),_(5,C.$8i),_(6,S.$M6b),_(7,f.$nj)],d)}),define(ee[300],te([0,1,47,45,28,8,22,54,9,7,142,21,17,25,16,20,5,68,24,50,26,48,100]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;async function l(o,v=1e3){for(;!o();)await(0,M.$Tg)(v)}let r;function i(){return typeof r>"u"&&(r=D.existsSync(f.$ic(f.$lc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$e7b{get cachePath(){const v=f.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(v,{recursive:!0}).then(()=>v)}constructor(v,R,A,E,I,L,F,B,se){super(v,R,E,I,L,se),this.u=A,this.v=F,this.w=B,v.setRelaunchHandler(this)}handleRelaunch(v){return v?.addArgs||v?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$_T.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(v){let R="win32";return process.arch!=="ia32"&&(R+=`-${process.arch}`),i()===1?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,t.$d7b)(R,v,this.k)}t(v){this.a&&(this.d(u.$_T.CheckingForUpdates(v)),this.i.request({url:this.a},C.CancellationToken.None).then(c.$Uo).then(R=>{const A=i();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!v}),this.d(u.$_T.Idle(A)),Promise.resolve(null)):A===1?(this.d(u.$_T.AvailableForDownload(R)),Promise.resolve(null)):(this.d(u.$_T.Downloading(R)),this.C(R.version).then(()=>this.B(R.version).then(E=>b.Promises.exists(E).then(I=>{if(I)return Promise.resolve(E);const L=R.url,F=R.hash,B=`${E}.tmp`;return this.i.request({url:L},C.CancellationToken.None).then(se=>this.v.writeFile(a.URI.file(B),se.stream)).then(F?()=>(0,g.$8S)(B,R.hash):()=>{}).then(()=>b.Promises.rename(B,E,!1)).then(()=>E)})).then(E=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:E},I?this.k.target==="user"?this.p():this.d(u.$_T.Downloaded(R)):this.d(u.$_T.Ready(R))})))}).then(void 0,R=>{this.j.error(R),this.u.publicLog2("update:notAvailable",{explicit:!!v});const A=v?R.message||R:void 0;this.d(u.$_T.Idle(i(),A))}))}async o(v){v.update.url&&this.w.openExternal(void 0,v.update.url),this.d(u.$_T.Idle(i()))}async B(v){const R=await this.cachePath;return f.$ic(R,`CodeSetup-${this.k.quality}-${v}.exe`)}async C(v=null){const R=v?L=>!new RegExp(`${this.k.quality}-${v}\\.exe$`).test(L):()=>!0,A=await this.cachePath,I=(await b.Promises.readdir(A)).filter(R).map(async L=>{try{await b.Promises.unlink(f.$ic(A,L))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const v=this.state.update;this.d(u.$_T.Updating(v));const R=await this.cachePath;this.e.updateFilePath=f.$ic(R,`CodeSetup-${this.k.quality}-${v.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$_T.Idle(i()))});const E=`${this.k.win32MutexName}-ready`,I=await new Promise((L,F)=>{Z(["@vscode/windows-mutex"],L,F)});l(()=>I.isActive(E)).then(()=>this.d(u.$_T.Ready(v)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(v){if(this.state.type!=="idle")return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown"};this.d(u.$_T.Downloading(A)),this.e={packagePath:v},R?this.k.target==="user"?this.p():this.d(u.$_T.Downloaded(A)):this.d(u.$_T.Ready(A))}};e.$i7b=n,ke([S.$fh],n.prototype,"cachePath",null),e.$i7b=n=ke([_(0,w.$Z5b),_(1,p.$hi),_(2,k.$_k),_(3,d.$X5b),_(4,c.$Oo),_(5,$.$8i),_(6,y.$9j),_(7,m.$M6b),_(8,h.$nj)],n)}),define(ee[301],te([0,1,15,8,22,49,3,2,13,65,4,7,188,64,17,60,25,63,16,20,5,24,78,250,80,26,102,67,59,30,29,53,95,134,39,34,52,66,23,6]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,L,F,B,se,x,ae,ne){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;var X;(function(V){V[V.NONE=0]="NONE",V[V.NAVIGATING=1]="NAVIGATING",V[V.READY=2]="READY"})(X||(X={}));let K=class extends S.$Rc{static{re=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const N=this.R.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.R.getProfileForWorkspace(this.config.workspace??(0,A.$2h)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(N,U,H,J,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re){super(),this.N=U,this.O=H,this.P=J,this.Q=ie,this.R=oe,this.S=T,this.U=O,this.W=j,this.X=q,this.Y=W,this.Z=z,this.$=G,this.ab=ce,this.bb=de,this.db=ue,this.eb=fe,this.fb=ye,this.gb=be,this.hb=pe,this.b=this.B(new C.$Md),this.onWillLoad=this.b.event,this.c=this.B(new C.$Md),this.onDidSignalReady=this.c.event,this.f=this.B(new C.$Md),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new C.$Md),this.onDidClose=this.g.event,this.h=this.B(new C.$Md),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.jb=0;{const[Te,$e]=this.tb(N.state);this.s=Te,this.N.trace("window#ctor: using window state",Te);const we=this.s.mode===0||this.s.mode===3,Q=this.X.getValue("window"),le=Re.invokeFunction(R.$c6b,this.s,{show:!we,webPreferences:{preload:f.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Ab()&&(le.fullscreenable=!1);const ge=g.$k&&Q?.nativeTabs===!0;ge&&(le.tabbingIdentifier=this.eb.nameShort);const Ce=(0,v.$1C)(this.X)==="custom";if(Ce&&(le.titleBarStyle="hidden",g.$k||(le.frame=!1),(0,v.$2C)(this.X))){const Ae=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Fe=L.$Ss.fromHex(Ae).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:Ae,symbolColor:Fe},this.D=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(le),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,g.$k&&Ce&&this.m.setSheetOffset(22),Ce&&(g.$j&&(0,v.$2C)(this.X)||g.$k)){const Ae=this.hb.getItem(re.a);Ae&&this.updateWindowControls({height:Ae})}g.$j&&Ce&&this.m.hookWindowMessage(278,()=>{const[Fe,Oe]=this.m.getPosition(),ze=P.screen.getCursorScreenPoint(),We=ze.x-Fe,Y=ze.y-Oe;return(()=>!(We>30&&Y>=0&&Y<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:We,y:Y})),0}),(g.$k||g.$j)&&$e&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ae=>typeof Ae=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),we&&((0,a.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3?(this.ib("WindowMode.Fullscreen"),this.wb(!0)):this.ib("WindowMode.Maximized"),this.m.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.qb(),this.Eb(),this.kb()}ib(N){this.X.getValue("window.logFullScreenTransitions")&&this.N.info(`window-fullscreen-bug: ${N})`)}setRepresentedFilename(N){g.$k?this.m.setRepresentedFilename(N):this.z=N}getRepresentedFilename(){return g.$k?this.m.getRepresentedFilename():this.z}setDocumentEdited(N){g.$k&&this.m.setDocumentEdited(N),this.C=N}isDocumentEdited(){return g.$k?this.m.isDocumentEdited():!!this.C}focus(N){g.$k&&N?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.jb=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.F.push(N)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(N=>{function U(){H.dispose(),J.dispose(),N()}const H=this.onDidClose(()=>U()),J=this.onWillLoad(()=>U())})}kb(){this.m.on("unresponsive",()=>this.nb(1)),this.m.webContents.on("render-process-gone",(U,H)=>this.nb(2,{...H})),this.m.webContents.on("did-fail-load",(U,H,J)=>this.nb(3,{reason:J,exitCode:H})),this.m.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",U=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",U,this.m)}),this.m.on("unmaximize",U=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",U,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.ib(`enter-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.ib(`leave-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(U=>this.qb(U))),this.B(this.Z.onDidDeleteUntitledWorkspace(U=>this.pb(U)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(U,H)=>{const J=await this.mb();H({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,J)})})}mb(){return this.lb||(this.lb=(0,l.$9o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.lb}async nb(N,U){switch(N){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:N,reason:U?.reason,code:U?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.db.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:J}=await this.bb.showMessageBox({type:"warning",buttons:[(0,p.localize)(0,null),(0,p.localize)(1,null),(0,p.localize)(2,null)],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),checkboxLabel:this.r?.workspace?(0,p.localize)(5,null):void 0},this.m);if(H!==2){const ie=H===0;await this.ob(ie,J)}}else if(N===2){let H;U?H=(0,p.localize)(7,null,U.reason,U.exitCode??"<unknown>"):H=(0,p.localize)(6,null);const{response:J,checkboxChecked:ie}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,p.localize)(8,null):(0,p.localize)(9,null),(0,p.localize)(10,null)],message:H,detail:this.r?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),checkboxLabel:this.r?.workspace?(0,p.localize)(13,null):void 0},this.m),oe=J===0;await this.ob(oe,ie)}break}}async ob(N,U){const H=this.r?.workspace;if(U&&H)try{const J=this.W.workspaceStorage(H);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.N.error(J)}if(this.h.fire(),this.m?.destroy(),N&&this.r){let J,ie;(0,A.$Xh)(H)?J={folderUri:H.uri}:(0,A.$3h)(H)?J={workspaceUri:H.configPath}:ie=!0,(0,ae.$Nb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:ie,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}pb(N){this.r?.workspace?.id===N.id&&(this.r.workspace=void 0)}qb(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const U=this.Bb();U!==this.t&&(this.t=U,this.Cb(U))}if(!N||N.affectsConfiguration("http.proxy")){let U=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.H||H!==this.I)){this.H=U,this.I=H;const J=U||"",ie=H?`${H},<local>`:"<local>";this.N.trace(`Setting proxy to '${J}', bypassing '${ie}'`),this.m.webContents.session.setProxy({proxyRules:J,proxyBypassRules:ie,pacScript:""})}}}addTabbedWindow(N){g.$k&&N.win&&this.m.addTabbedWindow(N.win)}load(N,U=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!U.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.rb(N,U),this.jb===0?this.r=N:this.L=N,this.jb=1,this.m.loadURL(f.$bg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new D.$5g(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:N.workspace,reason:U.isReload?3:H?2:1})}rb(N,U){const H=(this.r??this.L)?.userEnv;if(H){const J=(0,m.$Jl)(H)&&!(0,m.$Jl)(N.userEnv),ie=this.isExtensionDevelopmentHost;(J||ie)&&(N.userEnv={...H,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(N["disable-extensions"]=U.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this.m.isMaximized(),N.partsSplash=this.Y.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),N.perfMarks=(0,a.getMarks)(),this.J.update(N)}async reload(N){const U=Object.assign({},this.r);U.workspace=await this.sb(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&N&&(U.verbose=N.verbose,U.debugId=N.debugId,U.extensionEnvironment=N.extensionEnvironment,U["inspect-extensions"]=N["inspect-extensions"],U["inspect-brk-extensions"]=N["inspect-brk-extensions"],U["extensions-dir"]=N["extensions-dir"]),U.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.Q.serialize(),U.continueOn=this.P.continueOn,U.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},U.logLevel=this.O.getLogLevel(),U.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async sb(N){if((0,A.$3h)(N.workspace)){const U=N.workspace.configPath;if(U.scheme===f.Schemas.file&&!await this.S.exists(U))return}else if((0,A.$Xh)(N.workspace)){const U=N.workspace.uri;if(U.scheme===f.Schemas.file&&!await this.S.exists(U))return}return N.workspace}serializeWindowState(){if(!this.m)return(0,I.$W5b)();if(this.isFullScreen){let H;try{H=P.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,I.$W5b)();return{mode:3,display:H?H.id:void 0,width:this.s.width||J.width,height:this.s.height||J.height,x:this.s.x||0,y:this.s.y||0}}const N=Object.create(null);let U;if(!g.$k&&this.m.isMaximized()?U=0:U=1,U===0?N.mode=0:N.mode=1,U===1||U===0){let H;U===1?H=this.getBounds():H=this.m.getNormalBounds(),N.x=H.x,N.y=H.y,N.width=H.width,N.height=H.height}return N}updateWindowControls(N){if(N.height&&this.hb.setItem(re.a,N.height),g.$j&&this.D)this.m.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if(g.$k&&N.height!==void 0){const U=(N.height-15)/2;U?this.m.setWindowButtonPosition({x:U,y:U}):this.m.setWindowButtonPosition(null)}}tb(N){(0,a.mark)("code/willRestoreCodeWindowState");let U=!1;if(N)try{const H=P.screen.getAllDisplays();U=H.length>1,N=this.ub(N,H)}catch(H){this.N.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[N||(0,I.$W5b)(),U]}ub(N,U){if(this.N.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const ie=this.vb(U[0]);if(ie){let oe=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!ie||(N.x<ie.x&&(N.x=ie.x),N.y<ie.y&&(N.y=ie.y))};this.N.trace("window#validateWindowState: 1 monitor working area",ie),oe(),N.width>ie.width&&(N.width=ie.width),N.height>ie.height&&(N.height=ie.height),N.x>ie.x+ie.width-128&&(N.x=ie.x+ie.width-N.width),N.y>ie.y+ie.height-128&&(N.y=ie.y+ie.height-N.height),oe()}return N}if(N.display&&N.mode===3){const ie=U.find(oe=>oe.id===N.display);if(ie&&typeof ie.bounds?.x=="number"&&typeof ie.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,I.$W5b)(3);return oe.x=ie.bounds.x,oe.y=ie.bounds.y,oe}}let H,J;try{H=P.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),J=this.vb(H)}catch{}if(H&&J&&N.x+N.width>J.x&&N.y+N.height>J.y&&N.x<J.x+J.width&&N.y<J.y+J.height)return this.N.trace("window#validateWindowState: multi-monitor working area",J),N}vb(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,U]=this.m.getPosition(),[H,J]=this.m.getSize();return{x:N,y:U,width:H,height:J}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(N){this.Ab()?this.xb(N):this.zb(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Cb(this.t,!1)}get isFullScreen(){if(this.ib(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.u=="boolean")return this.ib(`isFullScreen(): returning transientIsNativeFullScreen = ${this.u}`),this.u;const N=this.m.isFullScreen(),U=this.m.isSimpleFullScreen();return this.ib(`isFullScreen(): returning natively, isFullScreen = ${N}, isSimpleFullScreen = ${U}`),N||U}xb(N){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.yb(N)}yb(N){g.$k&&(this.ib(`doSetNativeFullScreen(${N}): begin at ${Date.now()}`),this.u=N,this.w=new D.$bh,Promise.race([this.w.p,(0,D.$Tg)(1e3)]).finally(()=>{this.ib(`doSetNativeFullScreen(${N}): finish at ${Date.now()}`),this.u=void 0})),this.m.setFullScreen(N)}zb(N){this.m.isFullScreen()&&this.yb(!1),this.m.setSimpleFullScreen(N),this.m.webContents.focus()}Ab(){const N=this.X.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Bb(){let N=(0,v.$ZC)(this.X);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}Cb(N,U=!0){g.$k||(N==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,p.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.Db(N)}):this.Db(N))}Db(N){const U=this.isFullScreen;switch(N){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(N,U,...H){this.isReady?this.send(N,...H):this.ready().then(()=>{U.isCancellationRequested||this.send(N,...H)})}send(N,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this.m.webContents.send(N,...U)}catch(H){this.N.warn(`Error sending IPC message to channel '${N}' of window ${this.j}: ${(0,M.$yi)(H)}`)}}}updateTouchBar(N){g.$k&&this.G.forEach((U,H)=>{const J=N[H];U.segments=this.Gb(J)})}Eb(){if(g.$k){for(let N=0;N<10;N++){const U=this.Fb();this.G.push(U)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Fb(N=[]){const U=this.Gb(N),H=new P.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[J].id,from:"touchbar"})}});return H}Gb(N=[]){return N.map(H=>{let J;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(J=P.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let ie;return typeof H.title=="string"?ie=H.title:ie=H.title.value,{id:H.id,label:J?void 0:ie,icon:J}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$q7b=K,e.$q7b=K=re=ke([_(1,k.$8i),_(2,x.$56b),_(3,$.$X5b),_(4,F.$dn),_(5,se.$65b),_(6,h.$9j),_(7,r.$05b),_(8,r.$85b),_(9,y.$hi),_(10,o.$_5b),_(11,E.$t6b),_(12,d.$h6b),_(13,i.$_k),_(14,w.$o6b),_(15,c.$Z5b),_(16,u.$nj),_(17,t.$O6b),_(18,R.$b6b),_(19,B.$nN),_(20,ne.$Mh)],K)}),define(ee[81],te([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,80,97,29,53,31]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=e.$Z6b=void 0,e.$Z6b=(0,y.$Nh)("workspacesHistoryMainService");let l=class extends S.$Rc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,v){super(),this.f=i,this.g=n,this.h=o,this.j=v,this.c=this.B(new M.$Md),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Qg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const R of i)if((0,h.$yU)(R))!this.g.isUntitledWorkspace(R.workspace)&&!this.u(n,R.workspace)&&n.push(R);else if((0,h.$zU)(R))this.w(n,R.folderUri)||n.push(R);else{const A=this.y(o,R.fileUri),E=R.fileUri.scheme===f.Schemas.file&&t.F.indexOf((0,g.$rg)(R.fileUri))>=0;!A&&!E&&(o.push(R),a.$j&&R.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(R.fileUri.fsPath))}const v=await this.n({workspaces:n,files:o});n=v.workspaces,o=v.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.s({workspaces:n,files:o}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=A=>{const E=this.t(A);for(const I of i)if(g.$lg.isEqual(I,E))return!1;return!0},o=await this.getRecentlyOpened(),v=o.workspaces.filter(n),R=o.files.filter(n);(v.length!==o.workspaces.length||R.length!==o.files.length)&&(await this.s({files:R,workspaces:v}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new u.$zc(R=>g.$lg.getComparisonKey(R));if(i?.workspaces)for(const R of i.workspaces)n.set(this.t(R),R);const o=new u.$zc(R=>g.$lg.getComparisonKey(R));if(i?.files)for(const R of i.files)o.set(this.t(R),R);const v=await this.r();for(const R of v.workspaces){const A=n.get(this.t(R));A?A.label=A.label??R.label:n.set(this.t(R),R)}for(const R of v.files){const A=o.get(this.t(R));A?A.label=A.label??R.label:o.set(this.t(R),R)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,h.$FU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,h.$GU)(i)),-1,1)}t(i){return(0,h.$zU)(i)?i.folderUri:(0,h.$AU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(o=>(0,h.$yU)(o)&&o.workspace.id===n.id)}w(i,n){return!!i.find(o=>(0,h.$zU)(o)&&g.$lg.isEqual(o.folderUri,n))}y(i,n){return!!i.find(o=>g.$lg.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$j)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const R of P.app.getJumpListSettings().removedItems){const A=R.args;if(A){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);E&&n.push(b.URI.parse(E[2]))}}await this.removeRecentlyOpened(n);let o=!1;const v=(0,D.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(R=>{const A=(0,h.$yU)(R)?R.workspace:R.folderUri,{title:E,description:I}=this.J(A,R.label);let L;return b.URI.isUri(A)?L=`--folder-uri "${A.toString()}"`:(o=!0,L=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:I.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));v.length>0&&i.push({type:"custom",name:o?(0,d.localize)(2,null):(0,d.localize)(3,null),items:v})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,C.$uv)(n).name,description:n};if(b.URI.isUri(i))return{title:(0,g.$rg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let o=(0,g.$rg)(i.configPath);return o.endsWith(c.$0h)&&(o=o.substr(0,o.length-c.$0h.length-1)),{title:(0,d.localize)(5,null,o),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,C.$mv)(i.fsPath):i.toString()}async M(){if(!a.$k)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let R=0;R<i.workspaces.length&&o<t.z;R++){const A=this.t(i.workspaces[R]);if(A.scheme===f.Schemas.file){const E=(0,g.$ig)(A);await p.Promises.exists(E)&&(n.push(E),o++)}}const v=[];for(let R=0;R<i.files.length&&o<t.C;R++){const A=this.t(i.files[R]);if(A.scheme===f.Schemas.file){const E=(0,g.$ig)(A);if(t.F.includes((0,g.$rg)(A))||n.includes(E))continue;await p.Promises.exists(E)&&(v.push(E),o++)}}v.reverse().forEach(R=>P.app.addRecentDocument(R)),n.reverse().forEach(R=>P.app.addRecentDocument(R))}};e.$16b=l,e.$16b=l=t=ke([_(0,$.$8i),_(1,k.$t6b),_(2,w.$Z5b),_(3,m.$05b)],l)}),define(ee[302],te([0,1,15,8,22,46,4,7,179,17,25,20,5,229,68,24,34,26,48,59,30,81]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=void 0;const l="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,v,R,A,E,I,L,F,B,se,x){this.n=o,this.o=v,this.p=R,this.q=A,this.r=E,this.s=I,this.t=L,this.u=F,this.v=B,this.w=se,this.x=x,this.m=Object.create(null),this.g=new D.$5g(()=>this.E(),0),this.h=new D.$5g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$k||(0,c.$1C)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,L,F)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(I,L,F)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(I,L,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(I,L,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(I,L,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const v=this.x.requestFeatureUrl;v&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(v,"openUserVoiceUrl"));const R=this.x.reportIssueUrl;R&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(R,"openReportIssues"));const A=this.x.licenseUrl;A&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const I=A.indexOf("?")>0?"&":"?";this.Z(`${A}${I}lang=${C.$w}`,"openLicenseUrl")}else this.Z(A,"openLicenseUrl")});const E=this.x.privacyStatementUrl;E&&A&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(E,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.$k)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,v){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){C.$k&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){C.$k&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=P.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(C.$k?new P.Menu:null);return}const v=new P.Menu;let R;if(C.$k){const E=new P.Menu;R=new P.MenuItem({label:this.x.nameShort,submenu:E}),this.I(E),v.append(R)}if(C.$k&&!this.c){this.c=!0;const E=new P.Menu;E.append(new P.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(E)}if(this.K("File")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(1,null)),submenu:E});this.M(E,"File"),v.append(I)}if(this.K("Edit")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(2,null)),submenu:E});this.M(E,"Edit"),v.append(I)}if(this.K("Selection")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(3,null)),submenu:E});this.M(E,"Selection"),v.append(I)}if(this.K("View")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(4,null)),submenu:E});this.M(E,"View"),v.append(I)}if(this.K("Go")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(5,null)),submenu:E});this.M(E,"Go"),v.append(I)}if(this.K("Run")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(6,null)),submenu:E});this.M(E,"Run"),v.append(I)}if(this.K("Terminal")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(7,null)),submenu:E});this.M(E,"Terminal"),v.append(I)}let A;if(this.K("Window")){const E=new P.Menu;A=new P.MenuItem({label:this.ab(f.localize(8,null)),submenu:E,role:"window"}),this.S(E)}if(A&&v.append(A),this.K("Help")){const E=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(9,null)),submenu:E,role:"help"});this.M(E,"Help"),v.append(I)}v.items&&v.items.length>0?P.Menu.setApplicationMenu(v):P.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const v=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),R=this.T();let A;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),A=new P.MenuItem({label:this.ab(f.localize(11,null)),submenu:ae})}const E=new P.Menu,I=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:E}),L=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new P.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ae,ne,re)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.J(re)&&this.w.quit(void 0)}})),x=[v];x.push(...R),A&&x.push(i(),A),x.push(i(),I,i(),L,F,B,i(),se),x.forEach(ae=>o.append(ae))}async J(o){if(this.p.getWindowCount()===0)return!0;const v=this.o.getValue("window.confirmBeforeClose");if(v==="always"||v==="keyboardOnly"&&this.Q(o)){const{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return R===0}return!0}K(o){if(!C.$k&&(0,c.$1C)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,v){v.forEach(R=>{if((0,d.$W6b)(R))o.append(i());else if((0,d.$V6b)(R)){const A=new P.Menu,E=new P.MenuItem({label:this.ab(R.label),submenu:A});this.L(A,R.submenu.items),o.append(E)}else(0,d.$X6b)(R)?o.append(this.O(R)):(0,d.$Y6b)(R)&&(R.id==="workbench.action.showAboutDialog"&&this.N(o),C.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[R.id]?o.append(new P.MenuItem(this.Y(R.id,{label:this.ab(R.label),click:this.m[R.id]}))):o.append(this.U(R.label,R.id,!1,R.checked)):o.append(this.U(R.label,R.id,R.enabled!==!1,!!R.checked)):o.append(this.U(R.label,R.id,R.enabled!==!1,!!R.checked)))})}M(o,v){this.k&&this.k[v]&&this.L(o,this.k[v].items)}N(o){const v=this.T();v.length&&(v.forEach(R=>o.append(R)),o.append(i()))}O(o){const v=S.URI.revive(o.uri),R=o.id,A=R==="openRecentFile"?{fileUri:v}:R==="openRecentWorkspace"?{workspaceUri:v}:{folderUri:v};return new P.MenuItem(this.Y(R,{label:o.label,click:async(E,I,L)=>{const F=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[A],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([v])}},!1))}P(o){return!!(o&&(!C.$k&&(o.ctrlKey||o.shiftKey)||C.$k&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,v,R){const A={label:this.ab(o),role:R,enabled:!0};return new P.MenuItem(this.X(v,A))}S(o){const v=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),R=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),A=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),E=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(i()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[v,R,i(),E,...I,i(),A].forEach(L=>o.append(L))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,v,R,A){const E=this.ab(o),I=typeof v=="function"?v:(x,ae,ne)=>{const re=x?x.userSettingsLabel:null;let X=v;Array.isArray(v)&&(X=this.P(ne)?v[1]:v[0]),re&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:re}):this.W({type:"commandId",commandId:X})},L=typeof R=="boolean"?R:this.p.getWindowCount()>0,F=typeof A=="boolean"?A:!1,B={label:E,click:I,enabled:L};F&&(B.type="checkbox",B.checked=F);let se;return typeof v=="string"?se=v:Array.isArray(v)&&(se=v[0]),C.$k&&(se==="editor.action.clipboardCutAction"?B.role="cut":se==="editor.action.clipboardCopyAction"?B.role="copy":se==="editor.action.clipboardPasteAction"&&(B.role="paste"),se==="undo"?B.click=this.V(I,{inDevTools:x=>x.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?B.click=this.V(I,{inDevTools:x=>x.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(B.click=this.V(I,{inDevTools:x=>x.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(se,B))}V(o,v){return(R,A,E)=>{const I=P.BrowserWindow.getFocusedWindow();if(!I)return v.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return v.inDevTools(I.webContents.devToolsWebContents);o(R,A||I,E)}}W(o){let v=P.BrowserWindow.getFocusedWindow();if(!v){const A=this.p.getLastActiveWindow();A?.isMinimized()&&(v=A.win)}const R=v?this.p.getWindowById(v.id):void 0;if(R){if(this.v.trace("menubar#runActionInRenderer",o),C.$k&&!this.q.isBuilt&&!R.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const A={id:o.commandId,from:"menu"};R.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:o.userSettingsLabel};R.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,v){const R=typeof o=="string"?this.l[o]:void 0;if(R?.label){if(R.isNative!==!1)v.accelerator=R.label,v.userSettingsLabel=R.userSettingsLabel;else if(typeof v.label=="string"){const A=v.label.indexOf("[");A>=0?v.label=`${v.label.substr(0,A)} [${R.label}]`:v.label=`${v.label} [${R.label}]`}}else v.accelerator=void 0;return v}Y(o,v,R=!v.accelerator){R&&(v=this.X(o,v));const A=v.click;return v.click=(E,I,L)=>{this.$(o),A?.(E,I,L)},v}Z(o,v){this.w.openExternal(void 0,o),this.$(v)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:l})}ab(o){return(0,M.$rv)(o,!this.B)}};e.$26b=r,e.$26b=r=t=ke([_(0,h.$aU),_(1,a.$hi),_(2,k.$b6b),_(3,g.$X5b),_(4,m.$_k),_(5,u.$Z6b),_(6,$.$nN),_(7,b.$Z5b),_(8,p.$8i),_(9,y.$M6b),_(10,w.$nj)],r);function i(){return new P.MenuItem({type:"separator"})}}),define(ee[303],te([0,1,6,20,5,302]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=void 0,e.$36b=(0,P.$Nh)("menubarMainService");let C=class{constructor(f,a,g){this.b=f,this.c=a,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$26b)}async updateMenubar(f,a){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(a,f)}};e.$46b=C,e.$46b=C=ke([_(0,P.$Mh),_(1,D.$Z5b),_(2,s.$8i)],C)}),define(ee[304],te([0,1,15,21,130,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,189,64,17,60,25,16,6,20,5,77,78,58,34,59,301,129,297,29,98,81,53,67,39,52,66]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,L,F,B,se,x,ae,ne,re,X,K,V,N){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;function H(oe){return(0,x.$3h)(oe?.workspace)}function J(oe){return(0,x.$Xh)(oe?.workspace)}let ie=class extends b.$Rc{static{U=this}static{this.a=[]}constructor(T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re,Te,$e,we){super(),this.m=T,this.n=O,this.r=j,this.s=q,this.t=W,this.u=z,this.w=G,this.z=ce,this.C=de,this.D=ue,this.F=fe,this.G=ye,this.H=be,this.I=pe,this.J=Re,this.L=Te,this.M=$e,this.N=we,this.b=this.B(new f.$Md),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$Md),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$Md),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$Md),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$Md),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.$r7b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(T=>this.c.fire(T.window))),this.B(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const O=new b.$Qc;if(O.add(f.Event.any(T.onDidClose,T.onDidDestroy)(()=>O.dispose())),T.config.extensionDevelopmentPath)for(const j of T.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(j));T.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,O){const j=this.w.args,q=O?.remoteAuthority||void 0,W=!0,z=O?.forceReuseWindow,G=!z;return this.open({...T,cli:j,forceEmpty:W,forceNewWindow:G,forceReuseWindow:z,remoteAuthority:q})}openExistingWindow(T,O){T.focus(),this.P(O,[T])}async open(T){this.r.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const O=[],j=[],q=[],W=[],z=[];let G,ce=0;const de=await this.X(T);this.r.trace("windowsManager#open pathsToOpen",de);for(const pe of de)J(pe)?T.addMode?O.push(pe):j.push(pe):H(pe)?q.push(pe):pe.fileUri?(G||(G={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:pe.remoteAuthority}),G.filesToOpenOrCreate.push(pe)):pe.backupPath?z.push({backupFolder:(0,d.$mc)(pe.backupPath),remoteAuthority:pe.remoteAuthority}):ce++;T.diffMode&&G&&G.filesToOpenOrCreate.length>=2&&(G.filesToDiff=G.filesToOpenOrCreate.slice(0,2),G.filesToOpenOrCreate=[]),T.mergeMode&&G&&G.filesToOpenOrCreate.length===4&&(G.filesToMerge=G.filesToOpenOrCreate.slice(0,4),G.filesToOpenOrCreate=[],G.filesToDiff=[]),G&&T.waitMarkerFileURI&&(G.filesToWait={paths:(0,C.$Gb)([...G.filesToDiff,G.filesToMerge[3],...G.filesToOpenOrCreate]),waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(W.push(...this.H.getUntitledWorkspaces()),q.push(...W),z.push(...this.D.getEmptyWindowBackups())):z.length=0;const{windows:ue,filesOpenedInWindow:fe}=await this.Q(T,q,j,z,ce,G,O);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${j.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ce})`),ue.length>1)if(fe)fe.focus();else{const pe=this.j.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Re=!0,Te=!0;if(pe){const $e=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);$e.length&&($e[0].focus(),Re=!1,Te=!1)}if(Re)for(let $e=ue.length-1;$e>=0;$e--){const we=ue[$e];if(!(we.openedWorkspace&&W.some(Q=>we.openedWorkspace&&Q.workspace.id===we.openedWorkspace.id)||we.backupPath&&z.some(Q=>we.backupPath&&Q.backupFolder===(0,d.$mc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ye=G&&G.filesToDiff.length>0,be=G&&G.filesToMerge.length>0;if(!ue.some(pe=>pe.isExtensionDevelopmentHost)&&!ye&&!be&&!T.noRecentEntry){const pe=[];for(const Re of de)H(Re)&&!Re.transient?pe.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):J(Re)?pe.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&pe.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.G.addRecentlyOpened(pe)}return this.P(T,ue),ue}P(T,O){const j=T.waitMarkerFileURI;T.context===0&&j&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(j)}catch{}})()}async Q(T,O,j,q,W,z,G){const ce=[];let de;function ue($e,we){ce.push($e),we&&(de=$e,z=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ye}=this.ib(T);if(!T.initialStartup&&G.length>0){const $e=G[0].remoteAuthority,we=this.nb($e);we&&ue(this.S(we,G.map(Q=>Q.workspace.uri)))}const be=j.length+O.length+q.length;if(z&&be===0){const $e=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],we=this.getWindows().filter(le=>z&&(0,m.$zg)(le.remoteAuthority,z.remoteAuthority));let Q;$e?.fileUri&&!ye&&((T.context===4||T.context===0||T.context===1)&&(Q=await(0,B.$q6b)(we,$e.fileUri,async le=>le.configPath.scheme===p.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),Q||(Q=this.ob(we))),Q?(0,x.$3h)(Q.openedWorkspace)?O.push({workspace:Q.openedWorkspace,remoteAuthority:Q.remoteAuthority}):(0,x.$Xh)(Q.openedWorkspace)?j.push({workspace:Q.openedWorkspace,remoteAuthority:Q.remoteAuthority}):ue(this.R(T,Q,z),!0):ue(await this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile}),!0)}const pe=(0,C.$Lb)(O,$e=>$e.workspace.id);if(pe.length>0){const $e=(0,C.$Gb)(pe.map(we=>(0,B.$r6b)(this.getWindows(),we.workspace.configPath)));if($e.length>0){const we=$e[0],Q=(0,m.$zg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;ue(this.R(T,we,Q),!!Q),fe=!0}for(const we of pe){if($e.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const Q=we.remoteAuthority,le=(0,m.$zg)(z?.remoteAuthority,Q)?z:void 0;ue(await this.W(T,we,fe,le),!!le),fe=!0}}const Re=(0,C.$Lb)(j,$e=>m.$lg.getComparisonKey($e.workspace.uri));if(Re.length>0){const $e=(0,C.$Gb)(Re.map(we=>(0,B.$r6b)(this.getWindows(),we.workspace.uri)));if($e.length>0){const we=$e[0],Q=(0,m.$zg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;ue(this.R(T,we,Q),!!Q),fe=!0}for(const we of Re){if($e.some(ge=>(0,x.$Xh)(ge.openedWorkspace)&&m.$lg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const Q=we.remoteAuthority,le=(0,m.$zg)(z?.remoteAuthority,Q)?z:void 0;ue(await this.W(T,we,fe,le),!!le),fe=!0}}const Te=(0,C.$Lb)(q,$e=>$e.backupFolder);if(Te.length>0)for(const $e of Te){const we=$e.remoteAuthority,Q=(0,m.$zg)(z?.remoteAuthority,we)?z:void 0;ue(await this.U(T,!0,we,Q,$e),!!Q),fe=!0}if(ce.length===0||z){z&&!W&&W++;const $e=z?z.remoteAuthority:T.remoteAuthority;for(let we=0;we<W;we++)ue(await this.U(T,fe,$e,z),!!z),fe=!0}return{windows:(0,C.$Lb)(ce),filesOpenedInWindow:de}}R(T,O,j){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),O.focus();const q={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",S.CancellationToken.None,q),O}S(T,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),T.focus();const j={foldersToAdd:O};return T.sendWhenReady("vscode:addFolders",S.CancellationToken.None,j),T}U(T,O,j,q,W){this.r.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:j,filesToOpen:q,forceNewWindow:O});let z;return!O&&typeof T.contextWindowId=="number"&&(z=this.getWindowById(T.contextWindowId)),this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:q,windowToUse:z,emptyWindowBackupInfo:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}W(T,O,j,q,W){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:q}),!j&&!W&&typeof T.contextWindowId=="number"&&(W=this.getWindowById(T.contextWindowId)),this.jb({workspace:O.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:q,windowToUse:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}async X(T){let O,j=!1,q=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(O=await this.Y(T),j=!0):T.forceEmpty?O=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(O=await this.Z(T.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),q=!0),!T.addMode&&j){const W=O.filter(z=>J(z));if(W.length>1){const z=W[0].remoteAuthority;if(W.every(G=>(0,m.$zg)(G.remoteAuthority,z))){const G=await this.H.createUntitledWorkspace(W.map(ce=>({uri:ce.workspace.uri})));O.push({workspace:G,remoteAuthority:z}),O=O.filter(ce=>!J(ce))}}}if(T.initialStartup&&!q&&this.F.getValue("window")?.restoreWindows==="preserve"){const W=await this.ab();O.unshift(...W.filter(z=>H(z)||J(z)||z.backupPath))}return O}async Y(T){const O={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority},j=await Promise.all((0,C.$Gb)(T.urisToOpen||[]).map(async q=>{const W=await this.cb(q,O);if(W)return W.label=q.label,W;const z=this.eb(q);this.J.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:z.scheme===p.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:z.scheme===p.Schemas.file?(0,k.localize)(3,null,(0,g.$lv)(z,{os:w.OS,tildify:this.w})):(0,k.localize)(4,null,z.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Gb)(j)}async Z(T){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:T.diff&&T._.length===2||T.merge&&T._.length===4},q=T["folder-uri"];if(q){const G=await Promise.all(q.map(ce=>{const de=this.$(ce);if(de)return this.cb({folderUri:de},j)}));O.push(...(0,C.$Gb)(G))}const W=T["file-uri"];if(W){const G=await Promise.all(W.map(ce=>{const de=this.$(ce);if(de)return this.cb((0,x.$gi)(ce)?{workspaceUri:de}:{fileUri:de},j)}));O.push(...(0,C.$Gb)(G))}const z=await Promise.all(T._.map(G=>j.remoteAuthority?this.hb(G,j):this.fb(G,j)));return O.push(...(0,C.$Gb)(z)),O}$(T){try{const O=c.URI.parse(T);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${T}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${T}, ${O.message}`)}}async ab(){const T=this.bb();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];T!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const j=await Promise.all(O.map(async q=>{if(q.workspace){const W=await this.cb({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(H(W))return W}else if(q.folderUri){const W=await this.cb({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(J(W))return W}else if(T!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,C.$Gb)(j)}}}bb(){let T;return this.C.wasRestarted?T="all":(T=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}async cb(T,O=Object.create(null)){const j=this.eb(T);return j.scheme===p.Schemas.file?((0,L.$YC)(T)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(j.fsPath,O)):this.db(T,O)}db(T,O){let j=this.eb(T);const q=(0,E.$Rk)(j)||O.remoteAuthority;if(j=(0,m.$Bg)((0,m.$vg)(j)),(0,L.$YC)(T)){if(O.gotoLineMode){const{path:W,line:z,column:G}=(0,a.$4f)(j.path);return{fileUri:j.with({path:W}),options:{selection:z?{startLineNumber:z,startColumn:G||1}:void 0},remoteAuthority:q}}return{fileUri:j,remoteAuthority:q}}else if((0,L.$WC)(T))return{workspace:(0,ae.$j6b)(j),remoteAuthority:q};return{workspace:(0,ae.$k6b)(j),remoteAuthority:q}}eb(T){return(0,L.$WC)(T)?T.workspaceUri:(0,L.$XC)(T)?T.folderUri:T.fileUri}async fb(T,O,j){let q,W;O.gotoLineMode&&({path:T,line:q,column:W}=(0,a.$4f)(T)),T=(0,a.$Yf)((0,d.$gc)(T),(0,$.cwd)());try{const z=await D.Promises.stat(T);if(z.isFile()){if(!O.forceOpenWorkspaceAsFile){const G=await this.H.resolveLocalWorkspace(c.URI.file(T));if(G)return G.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:G.id,configPath:G.configPath},type:i.FileType.File,exists:!0,remoteAuthority:G.remoteAuthority,transient:G.transient}}return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:W||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ae.$k6b)(c.URI.file(T),z),type:i.FileType.Directory,exists:!0};if(!w.$j&&T==="/dev/null")return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!j)return this.gb(T,O);const G=c.URI.file(T);if(this.G.removeRecentlyOpened([G]),O.ignoreFileNotFound)return{fileUri:G,type:i.FileType.File,exists:!1}}}async gb(T,O){const j=c.URI.file(T),{response:q,checkboxChecked:W}=await this.J.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,j.authority),detail:(0,k.localize)(9,null,(0,g.$lv)(j,{os:w.OS,tildify:this.w})),checkboxLabel:(0,k.localize)(10,null,j.authority),cancelId:1});if(q===0)return(0,s.addUNCHostToAllowlist)(j.authority),W&&this.sendToOpeningWindow("vscode:configureAllowedUNCHost",j.authority),this.fb(T,O,!0);if(q===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(T,O)}hb(T,O){const j=T.charCodeAt(0),q=O.remoteAuthority;let W,z;O.gotoLineMode&&({path:T,line:W,column:z}=(0,a.$4f)(T)),j!==47&&((0,a.$Xf)(j)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,a.$Qf)(T)),T=`/${T}`);const G=c.URI.from({scheme:p.Schemas.vscodeRemote,authority:q,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,x.$gi)(T))return O.forceOpenWorkspaceAsFile?{fileUri:G,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.$j6b)(G),remoteAuthority:q};if(O.gotoLineMode||d.$fc.basename(T).indexOf(".")!==-1)return{fileUri:G,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.$k6b)(G),remoteAuthority:q}}ib(T){const O=this.F.getValue("window"),j=O?.openFoldersInNewWindow||"default",q=O?.openFilesInNewWindow||"off";let W=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(j==="on"||j==="off")&&(W=j==="on");let z=!1;return T.forceNewWindow||T.forceReuseWindow?z=!!T.forceNewWindow&&!T.forceReuseWindow:(w.$k?T.context===1&&(z=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!T.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(z=q==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(T,O){const j=(0,B.$s6b)(this.getWindows(),T);if(j)return this.C.reload(j,O.cli),j.focus(),[j];let q=O.cli["folder-uri"]||[],W=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!q.length&&!W.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(c.URI.isUri(ue)?ue.scheme===p.Schemas.file?z=[ue.fsPath]:q=[ue.toString()]:ue.configPath.scheme===p.Schemas.file?z=[(0,m.$ig)(ue.configPath)]:W=[ue.configPath.toString()])}let G=O.remoteAuthority;for(const de of T)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=c.URI.parse(de),fe=(0,E.$Rk)(ue);fe&&(G?(0,m.$zg)(fe,G)||this.r.error("more than one extension development path authority"):G=fe)}z=z.filter(de=>{const ue=c.URI.file(de);return(0,B.$r6b)(this.getWindows(),ue)?!1:(0,m.$zg)((0,E.$Rk)(ue),G)}),q=q.filter(de=>{const ue=this.$(de);return ue&&(0,B.$r6b)(this.getWindows(),ue)?!1:ue?(0,m.$zg)((0,E.$Rk)(ue),G):!1}),W=W.filter(de=>{const ue=this.$(de);return ue&&(0,B.$r6b)(this.getWindows(),ue)?!1:ue?(0,m.$zg)((0,E.$Rk)(ue),G):!1}),O.cli._=z,O.cli["folder-uri"]=q,O.cli["file-uri"]=W;const ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!z.length&&!q.length&&!W.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:G,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ce)}async jb(T){const O=this.F.getValue("window"),j=this.getLastActiveWindow(),q=j?.profile??this.z.defaultProfile;let W;!T.forceNewWindow&&!T.forceNewTabbedWindow&&(W=T.windowToUse||j,W&&W.focus());const z={...this.w.args,...T.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,d.$ic)(this.w.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:q},homeDir:this.w.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.n,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToMerge:T.filesToOpen?.filesToMerge,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:p.Schemas.file}).fsPath,product:R.default,isInitialStartup:T.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(W){const G=W.config;!z.extensionDevelopmentPath&&G?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=G.extensionDevelopmentPath,z.extensionDevelopmentKind=G.extensionDevelopmentKind,z["enable-proposed-api"]=G["enable-proposed-api"],z.verbose=G.verbose,z["inspect-extensions"]=G["inspect-extensions"],z["inspect-brk-extensions"]=G["inspect-brk-extensions"],z.debugId=G.debugId,z.extensionEnvironment=G.extensionEnvironment,z["extensions-dir"]=G["extensions-dir"],z["disable-extensions"]=G["disable-extensions"]),z.loggers={global:z.loggers.global,window:G?.loggers.window??z.loggers.window}}else{const G=this.j.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const ce=W=this.I.createInstance(F.$q7b,{state:G,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),U.a.push(ce),this.b.fire(ce),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Qc;de.add(ce.onDidSignalReady(()=>this.c.fire(ce))),de.add(f.Event.once(ce.onDidClose)(()=>this.mb(ce,de))),de.add(f.Event.once(ce.onDidDestroy)(()=>this.f.fire(ce))),de.add(ce.onDidTriggerSystemContextMenu(({x:fe,y:ye})=>this.h.fire({window:ce,x:fe,y:ye})));const ue=(0,h.$If)(ce.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.C.reload(ce)),this.C.registerWindow(ce)}return z.windowId=W.id,W.isReady?this.C.unload(W,4).then(async G=>{G||await this.kb(W,z,T,q)}):await this.kb(W,z,T,q),W}async kb(T,O,j,q){if(O.extensionDevelopmentPath||((0,x.$3h)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,x.$Xh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,ae.$l6b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const W=O.workspace??(0,x.$2h)(O.backupPath,!1),z=this.lb(j,W,q),G=z instanceof Promise?await z:z;O.profiles.profile=G,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(W,G)}T.load(O)}lb(T,O,j){return T.forceProfile?this.z.profiles.find(q=>q.name===T.forceProfile)??this.z.createNamedProfile(T.forceProfile):T.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??j}mb(T,O){const j=U.a.indexOf(T);U.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),O.dispose()}getFocusedWindow(){const T=P.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(T){return this.ob(this.getWindows().filter(O=>(0,m.$zg)(O.remoteAuthority,T)))}ob(T){const O=Math.max.apply(Math,T.map(j=>j.lastFocusTime));return T.find(j=>j.lastFocusTime===O)}sendToFocused(T,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(T,S.CancellationToken.None,...O)}sendToOpeningWindow(T,...O){this.B(f.Event.once(this.onDidSignalReadyWindow)(j=>{j.sendWhenReady(T,S.CancellationToken.None,...O)}))}sendToAll(T,O,j){for(const q of this.getWindows())j&&j.indexOf(q.id)>=0||q.sendWhenReady(T,S.CancellationToken.None,O)}getWindows(){return U.a}getWindowCount(){return U.a.length}getWindowById(T){const O=this.getWindows().filter(j=>j.id===T);return(0,C.$Nb)(O)}getWindowByWebContents(T){const O=P.BrowserWindow.fromWebContents(T);if(O)return this.getWindowById(O.id)}};e.$u7b=ie,e.$u7b=ie=U=ke([_(2,v.$8i),_(3,N.$56b),_(4,I.$nN),_(5,K.$dn),_(6,r.$X5b),_(7,V.$65b),_(8,o.$Z5b),_(9,u.$h6b),_(10,t.$hi),_(11,ne.$Z6b),_(12,re.$t6b),_(13,n.$Mh),_(14,l.$o6b),_(15,i.$9j),_(16,A.$O6b),_(17,X.$_5b)],ie)}),define(ee[305],te([0,1,64,30,81,53]),function(Z,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;let C=class{constructor(f,a,g,b){this.a=f,this.b=a,this.c=g,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,a){const g=this.b.getWindowById(f);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),a)}createUntitledWorkspace(f,a,g){return this.a.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(f,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(f,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(f,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$w7b=C,e.$w7b=C=ke([_(0,M.$t6b),_(1,D.$b6b),_(2,s.$Z6b),_(3,P.$h6b)],C)}),define(ee[306],te([0,1,15,130,38,28,18,49,14,33,3,44,46,2,13,9,4,12,7,32,156,42,157,110,288,160,64,281,17,198,90,131,60,116,218,25,63,93,207,291,209,210,211,16,222,92,75,6,91,217,298,282,289,20,5,303,68,24,58,292,94,34,273,80,122,26,249,251,51,48,263,286,299,287,300,127,265,266,267,270,295,30,304,272,29,97,81,305,53,39,231,52,242,50,79,128,275,290,278,8,253,274,226,66,294,269,23,125,293,261,237,83,296]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,L,F,B,se,x,ae,ne,re,X,K,V,N,U,H,J,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re,Te,$e,we,Q,le,ge,Ce,Ae,Fe,Oe,ze,We,Y,he,me,ve,De,Ue,Le,Ne,Be,He,Ge,xe,Ye,it,nt,$t,wt,bt,pt,yt,vt,kt,rt,Et,Pt,St,It,ot,Rt,ht,at,Ct,At,ct,Dt,ft){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;let ut=class extends d.$Rc{static{lt=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Ie,Ee,Pe,Me,je,qe,Je,Xe,Ve,Ke,Ze){super(),this.f=Se,this.g=Ie,this.h=Ee,this.j=Pe,this.m=Me,this.n=je,this.s=qe,this.t=Je,this.u=Xe,this.w=Ve,this.y=Ke,this.z=Ze,this.C(),this.D()}C(){const Se=Ve=>Ve?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(this.y.quality==="stable"?[]:["media"]),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ve,Ke,Ze,Qe)=>Se(Qe.requestingUrl)?Ze(Ee.has(Ke)):Qe.isMainFrame&&Qe.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.$ag}/`?Ze(Ie.has(Ke)):Ze(!1)),P.session.defaultSession.setPermissionCheckHandler((Ve,Ke,Ze,Qe)=>Se(Qe.requestingUrl)?Ee.has(Ke):Qe.isMainFrame&&Qe.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.$ag}/`?Ie.has(Ke):!1);const Pe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=Ve=>{for(let Ke=Ve;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},je=Ve=>Ve.resourceType==="xhr"||Me(Ve.frame),qe=Ve=>{const Ke=Ve.frame;if(!Ke||!this.b)return!1;const Ze=P.BrowserWindow.getAllWindows();for(const Qe of Ze)if(Ke.processId===Qe.webContents.mainFrame.processId)return!0;return!1},Je=(Ve,Ke)=>{if(Ve.path!=="/index.html")return!0;const Ze=Ke.frame;if(!Ze||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&Ze.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ve,Ke)=>{const Ze=h.URI.parse(Ve.url);return Ze.scheme===y.Schemas.vscodeWebview&&!Je(Ze,Ve)?(this.j.error("Blocked vscode-webview request",Ve.url),Ke({cancel:!0})):Ze.scheme===y.Schemas.vscodeFileResource&&!qe(Ve)?(this.j.error("Blocked vscode-file request",Ve.url),Ke({cancel:!0})):Ze.path.endsWith(".svg")&&!Pe.has(Ze.scheme)?Ke({cancel:!je(Ve)}):Ke({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ve,Ke)=>{const Ze=Ve.responseHeaders,Qe=Ze["content-type"]||Ze["Content-Type"];if(Qe&&Array.isArray(Qe)){const _e=h.URI.parse(Ve.url);if(_e.path.endsWith(".svg")&&Pe.has(_e.scheme))return Ze["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Ze});if(!_e.path.endsWith(y.Schemas.vscodeRemoteResource)&&Qe.some(et=>et.toLowerCase().includes("image/svg")))return Ke({cancel:!je(Ve)})}return Ke({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.n.codeCachePath&&Xe.setCodeCachePath((0,w.$ic)(this.n.codeCachePath,"chrome")),$.$j&&(this.t.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.t.getValue("security.allowedUNCHosts")))}D(){(0,f.setUnexpectedErrorHandler)(Ee=>this.G(Ee)),process.on("uncaughtException",Ee=>{(0,f.$Y)(Ee)||(0,f.$Z)(Ee)}),process.on("unhandledRejection",Ee=>(0,f.$Z)(Ee)),this.s.onWillShutdown(()=>this.dispose()),(0,k.$bT)(),P.app.on("accessibility-support-changed",(Ee,Pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),P.app.on("activate",async(Ee,Pe)=>{this.j.trace("app#activate"),Pe||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Ee,Pe)=>{Pe?.opener?.url.startsWith(`${y.Schemas.vscodeFileResource}://${y.$ag}/`)&&this.h.createInstance(ft.$M7b,Pe),Pe.on("will-navigate",je=>{this.j.error("webContents#will-navigate: Prevented webcontent navigation"),je.preventDefault()}),Pe.setWindowOpenHandler(je=>je.url==="about:blank"?(this.j.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:ft.$M7b.open(this.h)}):(this.j.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${je.url}}`),this.c?.openExternal(void 0,je.url),{action:"deny"}))});let Se=[],Ie;P.app.on("open-file",(Ee,Pe)=>{this.j.trace("app#open-file: ",Pe),Ee.preventDefault(),Se.push((0,Ne.$gi)(Pe)?{workspaceUri:h.URI.file(Pe)}:{fileUri:h.URI.file(Pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.n.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Ie=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$aT.handle("vscode:fetchShellEnv",Ee=>{const Pe=this.b?.getWindowByWebContents(Ee.sender);let Me,je;return Pe?.config?(Me=Pe.config,je={...process.env,...Pe.config.userEnv}):(Me=this.n.args,je=process.env),this.W(Me,je,!1)}),s.$aT.handle("vscode:writeNlsFile",(Ee,Pe,Me)=>{const je=this.F([Pe]);if(!je||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.w.writeFile(je,C.$ae.fromString(Me))}),s.$aT.handle("vscode:readNlsFile",async(Ee,...Pe)=>{const Me=this.F(Pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.w.readFile(Me)).value.toString()}),s.$aT.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),s.$aT.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),s.$aT.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}F(Se){let Ie;for(const Ee of Se)typeof Ee=="string"&&(typeof Ie!="string"?Ie=Ee:Ie=(0,w.$ic)(Ie,Ee));if(!(typeof Ie!="string"||!(0,w.$hc)(Ie)||!(0,a.$Wf)(Ie,this.n.cachedLanguagesPath,!$.$l)))return h.URI.file(Ie)}G(Se){if(Se){const Ie={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.j.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.j.error(Se.stack)}async startup(){this.j.debug("Starting VS Code"),this.j.debug(`from: ${this.n.appRoot}`),this.j.debug("args:",this.n.args);const Se=this.y.win32AppUserModelId;$.$j&&Se&&P.app.setAppUserModelId(Se);try{$.$k&&this.t.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Xe){this.j.error(Xe)}const Ie=new t.$hT;this.s.onWillShutdown(Xe=>{Xe.reason===2&&Ie.dispose()}),this.j.trace("Resolving machine identifier...");const Ee=await(0,Et.$D7b)(this.u,this.j);this.j.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcessReady:Pe,sharedProcessClient:Me}=this.O(Ee),je=await this.P(Ee,Pe);this.B(je.createInstance(r.$d6b)),this.B(je.createInstance(vt.$A7b)),je.invokeFunction(Xe=>this.Q(Xe,Ie,Me));const qe=await je.invokeFunction(Xe=>this.H(Xe,Ie));this.I(Ie),this.s.phase=2,await je.invokeFunction(Xe=>this.R(Xe,qe)),this.s.phase=3,this.S(),this.B(new rt.$5g(()=>{this.B((0,rt.$9g)(()=>this.s.phase=4,2500))},2500)).schedule()}async H(Se,Ie){const Ee=this.b=Se.get(De.$b6b),Pe=Se.get(ze.$1T),Me=this.c=Se.get(G.$M6b),je=Se.get(I.$o6b),qe=this;Pe.registerHandler({async handleURL(Qe,_e){return qe.N(Ee,je,Pe,Qe,_e)}});const Je=this.B(new Le.$v7b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new u.$vh(Qe=>Je.getActiveClientId().then(_e=>Qe===_e)),Ve=new We.$l7b(Xe,this.j),Ke=Ie.getChannel("urlHandler",Ve);Pe.registerHandler(new We.$k7b(Ke));const Ze=await this.J(Ee,je);return this.B(new he.$m7b(Ze?.urls,Pe,Ee,this.n,this.y,this.j)),Ze}I(Se){const Ie=()=>({statusCode:404,data:"Not found"}),Ee=new Dt.$U(()=>Se.getChannel(ct.$K7b,new ct.$L7b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Pe,Me)=>{const je=h.URI.parse(Pe.url);if(!je.authority.startsWith("window:"))return Me(Ie());Ee.value.call(ct.$J7b,[je]).then(qe=>Me({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.j.warn("error dispatching remote resource call",qe),Me({statusCode:500,data:String(qe)})})})}async J(Se,Ie){const Ee=this.n.args["open-url"]?this.n.args._urls||[]:[];Ee.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ee);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ee.length+Pe.length===0)return;const Me=[...Ee,...Pe].map(Je=>{try{return{uri:h.URI.parse(Je),originalUrl:Je}}catch{this.j.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),je=[],qe=[];for(const Je of Me){if(!Je)continue;if(await this.L(Je.uri,Se,Ie)){this.j.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}const Xe=this.M(Je.uri);Xe?(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),Xe),je.push(Xe)):(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),qe.push(Je))}return{urls:qe,openables:je}}async L(Se,Ie,Ee){if(Se.authority!==y.Schemas.file&&Se.authority!==y.Schemas.vscodeRemote||this.t.getValue(lt.a[Se.authority])===!1)return!1;const{response:Me,checkboxChecked:je}=await Ee.showMessageBox({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,Se.authority===y.Schemas.file?(0,p.$lv)(Se,{os:$.OS,tildify:this.n}):Se.toString(!0),this.y.nameShort),detail:(0,i.localize)(3,null),checkboxLabel:(0,i.localize)(4,null),cancelId:1});return Me!==0?!0:(je&&Ie.sendToOpeningWindow("vscode:disablePromptForProtocolHandling",Se.authority===y.Schemas.file?"local":"remote"),!1)}M(Se){if(Se.path){if(Se.authority===y.Schemas.file){const Ie=h.URI.file(Se.fsPath);return(0,Ne.$gi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Se.authority===y.Schemas.vscodeRemote){const Ie=Se.path.indexOf(w.$fc.sep,1);if(Ie!==-1){const Ee=Se.path.substring(1,Ie),Pe=Se.path.substring(Ie);let Me=Se.query;const je=new URLSearchParams(Se.query);je.get("windowId")==="_blank"&&(je.delete("windowId"),Me=je.toString());const qe=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Ee,path:Pe,query:Me,fragment:Se.fragment});return(0,Ne.$gi)(Pe)?{workspaceUri:qe}:/:[\d]+$/.test(Pe)?{fileUri:qe}:{folderUri:qe}}}}}async N(Se,Ie,Ee,Pe,Me){if(this.j.trace("app#handleProtocolUrl():",Pe.toString(!0),Me),Pe.scheme===this.y.urlProtocol&&Pe.path==="workspace"&&(Pe=Pe.with({authority:"file",path:h.URI.parse(Pe.query).path,query:""})),await this.L(Pe,Se,Ie))return this.j.trace("app#handleProtocolUrl() protocol url was blocked:",Pe.toString(!0)),!0;let je=!1;const qe=new URLSearchParams(Pe.query);qe.get("windowId")==="_blank"?(this.j.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Pe.toString(!0)),qe.delete("windowId"),Pe=Pe.with({query:qe.toString()}),je=!0):$.$k&&Se.getWindowCount()===0&&(this.j.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Pe.toString(!0)),je=!0);const Je=qe.get("continueOn");Je!==null&&(this.j.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Pe.toString(!0)),qe.delete("continueOn"),Pe=Pe.with({query:qe.toString()}),this.n.continueOn=Je??void 0);const Xe=this.M(Pe);return Xe?(this.j.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,Pe.toString(!0)),(0,ht.$Nb)(await Se.open({context:5,cli:{...this.n.args},urisToOpen:[Xe],forceNewWindow:je,gotoLineMode:!0}))?.focus(),!0):je?(this.j.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Pe.toString(!0)),await(0,ht.$Nb)(await Se.open({context:5,cli:{...this.n.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Rk)(Pe)}))?.ready(),Ee.open(Pe,Me)):(this.j.trace("app#handleProtocolUrl(): not handled",Pe.toString(!0),Me),!1)}O(Se){const Ie=this.B(this.h.createInstance(ue.$06b,Se)),Ee=(async()=>{this.j.trace("Main->SharedProcess#connect");const Me=await Ie.connect();return this.j.trace("Main->SharedProcess#connect: connection established"),new l.$iT(Me,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),Ee))(),sharedProcessClient:Ee}}async P(Se,Ie){const Ee=new ie.$Lh;switch(process.platform){case"win32":Ee.set(le.$aU,new H.$Kh(Oe.$i7b));break;case"linux":$.$m?Ee.set(le.$aU,new H.$Kh(Fe.$h7b,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(le.$aU,new H.$Kh(Ae.$g7b));break;case"darwin":Ee.set(le.$aU,new H.$Kh(Ce.$f7b));break}Ee.set(De.$b6b,new H.$Kh(Ue.$u7b,[Se,this.g],!1));const Pe=new I.$p6b(this.j,this.y);Ee.set(I.$o6b,Pe),Ee.set(j.$T6b,new H.$Kh(j.$U6b,void 0,!1)),Ee.set(E.$y6b,new H.$Kh(E.$z6b,void 0,!1)),Ee.set(A.$mm,u.ProxyChannel.toService((0,u.$th)(Ie.then(Xe=>Xe.getChannel("diagnostics"))))),Ee.set(oe.$Twb,new H.$Kh(T.$P6b,[this.g])),Ee.set(L.$UT,new H.$Kh(F.$A6b)),Ee.set(O.$Q6b,new H.$Kh(O.$R6b)),Ee.set(G.$M6b,new H.$Kh(G.$N6b,void 0,!1)),Ee.set(me.$n7b,new H.$Kh(ve.$p7b)),Ee.set(z.$36b,new H.$Kh(z.$46b)),Ee.set(ae.$B6b,new H.$Kh(ne.$D6b)),Ee.set(pe.$85b,new H.$Kh(pe.$95b)),Ee.set(pe.$05b,new H.$Kh(pe.$$5b));const Me=new Ct.$I7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.t.getValue("terminal.integrated.persistentSessionScrollback")??100},this.t,this.n,this.s,this.j),je=new At.$rr(Me,this.t,this.j,this.m);Ee.set(at.$5q,je),$.$j?Ee.set(re.$E6b,new H.$Kh(X.$F6b)):$.$k?Ee.set(re.$E6b,new H.$Kh(X.$G6b)):$.$l&&Ee.set(re.$E6b,new H.$Kh(X.$H6b));const qe=new o.$m6b(this.n,this.t,this.j,this.u);Ee.set(n.$h6b,qe);const Je=new xe.$u6b(this.n,this.j,this.z,qe,Pe);if(Ee.set(xe.$t6b,Je),Ee.set(Be.$xU,new H.$Kh(Ge.$w7b,void 0,!1)),Ee.set(He.$Z6b,new H.$Kh(He.$16b,void 0,!1)),Ee.set(ze.$1T,new H.$Kh(Y.$3T,void 0,!1)),(0,Q.$no)(this.y,this.n)){const Xe=(0,Q.$so)(this.y,this.t),Ve=(0,u.$th)(Ie.then(et=>et.getChannel("telemetryAppender"))),Ke=new $e.$a7b(Ve),Ze=(0,Re.$do)((0,M.release)(),(0,M.hostname)(),process.arch,this.y.commit,this.y.version,Se,Xe),Qe=(0,Q.$to)(this.n),_e={appenders:[Ke],commonProperties:Ze,piiPaths:Qe,sendErrorTelemetry:!0};Ee.set(Te.$_k,new H.$Kh(we.$Wq,[_e],!1))}else Ee.set(Te.$_k,Q.$ho);return Ee.set(bt.$qp,new H.$Kh(Pt.$uN,void 0,!0)),Ee.set(pt.$up,new H.$Kh(yt.$z7b,void 0,!0)),Ee.set(ot.$G7b,new H.$Kh(ot.$H7b,void 0,!0)),await rt.Promises.settled([qe.initialize(),Je.initialize()]),this.h.createChild(Ee)}Q(Se,Ie,Ee){const Pe=this.B(new d.$Qc),Me=u.ProxyChannel.fromService(Se.get(j.$T6b),Pe,{disableMarshalling:!0});this.f.registerChannel("launch",Me);const je=u.ProxyChannel.fromService(Se.get(E.$y6b),Pe,{disableMarshalling:!0});this.f.registerChannel("diagnostics",je);const qe=new it.$x7b(Se.get(Ye.$dn));Ie.registerChannel("policy",qe),Ee.then(tt=>tt.registerChannel("policy",qe));const Je=this.w.getProvider(y.Schemas.file);(0,m.$Hf)(Je instanceof U.$9p);const Xe=new N.$I6b(Je,this.j,this.n);Ie.registerChannel(K.$dN,Xe),Ee.then(tt=>tt.registerChannel(K.$dN,Xe));const Ve=u.ProxyChannel.fromService(Se.get(nt.$65b),Pe);Ie.registerChannel("userDataProfiles",Ve),Ee.then(tt=>tt.registerChannel("userDataProfiles",Ve));const Ke=new $t.$Rq(Se.get(wt.$Oo));Ee.then(tt=>tt.registerChannel("request",Ke));const Ze=new ge.$b7b(Se.get(le.$aU));Ie.registerChannel("update",Ze);const Qe=u.ProxyChannel.fromService(Se.get(oe.$Twb),Pe);Ie.registerChannel("issue",Qe);const _e=u.ProxyChannel.fromService(Se.get(L.$UT),Pe);Ie.registerChannel("encryption",_e);const et=u.ProxyChannel.fromService(Se.get(fe.$Zk),Pe);Ie.registerChannel("sign",et);const st=u.ProxyChannel.fromService(Se.get(O.$Q6b),Pe);Ie.registerChannel("keyboardLayout",st),this.c=Se.get(G.$M6b);const dt=u.ProxyChannel.fromService(this.c,Pe);Ie.registerChannel("nativeHost",dt),Ee.then(tt=>tt.registerChannel("nativeHost",dt));const Ot=u.ProxyChannel.fromService(Se.get(Be.$xU),Pe);Ie.registerChannel("workspaces",Ot);const Mt=u.ProxyChannel.fromService(Se.get(z.$36b),Pe);Ie.registerChannel("menubar",Mt);const Lt=u.ProxyChannel.fromService(Se.get(ze.$1T),Pe);Ie.registerChannel("url",Lt);const jt=u.ProxyChannel.fromService(Se.get(me.$n7b),Pe);Ie.registerChannel("webview",jt);const gt=this.B(new be.$$6b(this.j,Se.get(pe.$85b)));Ie.registerChannel("storage",gt),Ee.then(tt=>tt.registerChannel("storage",gt));const Nt=this.B(new kt.$B7b(Se.get(pe.$85b),Se.get(nt.$65b),this.j));Ee.then(tt=>tt.registerChannel("profileStorageListener",Nt));const Ft=u.ProxyChannel.fromService(Se.get(at.$5q),Pe);Ie.registerChannel(at.TerminalIpcChannels.LocalPty,Ft);const Ut=u.ProxyChannel.fromService(Se.get(re.$E6b),Pe);Ie.registerChannel("externalTerminal",Ut);const mt=new St.$E7b(Se.get(It.$56b));Ie.registerChannel("logger",mt),Ee.then(tt=>tt.registerChannel("logger",mt));const Tt=new R.$n6b(Se.get(De.$b6b));Ie.registerChannel("extensionhostdebugservice",Tt);const Wt=u.ProxyChannel.fromService(Se.get(ae.$B6b),Pe);Ie.registerChannel(ae.$C6b,Wt);const zt=u.ProxyChannel.fromService(Se.get(ot.$G7b),Pe);Ie.registerChannel(Rt.$F7b,zt)}async R(Se,Ie){const Ee=this.b=Se.get(De.$b6b),Pe=(0,se.$Jl)(process.env)?0:4,Me=this.n.args;if(Ie){if(Ie.openables.length>0)return Ee.open({context:Pe,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const et of Ie.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Ee.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,qe=Me._.length,Je=!!Me["folder-uri"],Xe=!!Me["file-uri"],Ve=Me["skip-add-to-recently-opened"]===!0,Ke=Me.wait&&Me.waitMarkerFilePath?h.URI.file(Me.waitMarkerFilePath):void 0,Ze=Me.remote||void 0,Qe=Me.profile,_e=Me["profile-temp"];if(!qe&&!Je&&!Xe){if(Me["new-window"]||Qe||_e)return Ee.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Ze,forceProfile:Qe,forceTempProfile:_e});if(je.length)return Ee.open({context:1,cli:Me,urisToOpen:je.map(et=>(0,Ne.$gi)(et)?{workspaceUri:h.URI.file(et)}:{fileUri:h.URI.file(et)}),noRecentEntry:Ve,waitMarkerFileURI:Ke,initialStartup:!0})}return Ee.open({context:Pe,cli:Me,forceNewWindow:Me["new-window"]||!qe&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:Ve,waitMarkerFileURI:Ke,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:Qe,forceTempProfile:_e})}S(){this.U(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Se,Ie)=>{Ie({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.W(this.n.args,process.env,!0),this.X(),$.$k&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Se=this.y.win32MutexName;if($.$j&&Se)try{const Ie=await new Promise((Pe,Me)=>{Z(["@vscode/windows-mutex"],Pe,Me)}),Ee=new Ie.Mutex(Se);g.Event.once(this.s.onWillShutdown)(()=>Ee.release())}catch(Ie){this.j.error(Ie)}}async W(Se,Ie,Ee){try{return await(0,x.$Pl)(this.t,this.j,Se,Ie)}catch(Pe){const Me=(0,S.$yi)(Pe);Ee?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.j.error(Me)}return{}}async X(){try{const Ie=(await this.w.readFile(this.n.argvResource)).value.toString(),Ee=JSON.parse((0,b.$Zm)(Ie)),Me=(0,Q.$po)(this.t)>=1;if(Ee["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.$dg)()}"`,"}"],qe=Ie.substring(0,Ie.length-2).concat(`,
`,je.join(`
`));await this.w.writeFile(this.n.argvResource,C.$ae.fromString(qe))}else{const je=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);je!==Ie&&await this.w.writeFile(this.n.argvResource,C.$ae.fromString(je))}}catch(Se){this.j.error(Se)}}};e.$N7b=ut,e.$N7b=ut=lt=ke([_(2,J.$Mh),_(3,W.$8i),_(4,W.$9i),_(5,B.$X5b),_(6,q.$Z5b),_(7,v.$hi),_(8,ye.$nN),_(9,V.$9j),_(10,ce.$nj),_(11,nt.$65b)],ut)}),define(ee[312],te([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,306,10,17,236,248,25,63,200,16,220,92,75,216,91,20,223,5,77,24,78,276,126,285,50,284,94,247,34,51,67,52,39,232,230,2,40,264,66,225,115,121,268,262]),function(Z,e,P,D,s,M,C,S,f,a,g,b,p,d,y,w,$,m,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,L,F,B,se,x,ae,ne,re,X,K,V,N,U,H,J,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class pe{main(){try{this.a()}catch($e){console.error($e.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,we,Q,le,ge,Ce,Ae,Fe]=this.b();try{try{await this.d(Q,Fe,le,ge,Ae)}catch(Oe){throw this.f(Q,Ae,Oe),Oe}await $e.invokeFunction(async Oe=>{const ze=Oe.get(x.$8i),We=Oe.get(B.$Z5b),Y=Oe.get(R.$9j),he=Oe.get(x.$9i),me=await this.e(ze,Q,We,$e,Ae,!0);return h.Promises.writeFile(Q.mainLockfile,String(process.pid)).catch(ve=>{ze.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Ce.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),g.Event.once(We.onWillShutdown)(ve=>{Y.dispose(),le.dispose(),ve.join("instanceLockfile",h.Promises.unlink(Q.mainLockfile).catch(()=>{}))}),$e.createInstance(u.$N7b,me,we).startup()})}catch(Oe){$e.invokeFunction(this.i,Oe)}}b(){const $e=new F.$Lh,we=new z.$Qc;process.once("exit",()=>we.dispose());const Q={_serviceBrand:void 0,...ae.default};$e.set(ne.$nj,Q);const le=new n.$Y5b(this.j(),Q),ge=this.c(le);$e.set(n.$X5b,le);const Ce=new de.$66b((0,x.$jj)(le),le.logsHome);$e.set(de.$56b,Ce);const Ae=new se.$G3b(Ce.getLogLevel()),Fe=we.add(new ue.$vN(Ae,[new x.$cj(Ce.getLogLevel())]));$e.set(x.$8i,Fe);const Oe=new A.$Jp(Fe);$e.set(R.$9j,Oe);const ze=new E.$9p(Fe);Oe.registerProvider(p.Schemas.file,ze);const We=new ce.$vr(Oe);$e.set(G.$Fk,We);const Y=new ye.$qN(1,le,Fe,Oe);$e.set(ie.$mN,Y),$e.set(ie.$nN,Y);const he=new O.$75b(Y,We,le,Oe,Fe);$e.set(O.$65b,he),Oe.registerProvider(p.Schemas.vscodeUserData,new be.$Y7b(p.Schemas.file,ze,p.Schemas.vscodeUserData,he,We,Fe));const me=w.$j&&Q.win32RegValueName?we.add(new q.$W7b(Fe,Q.win32RegValueName)):le.policyFile?we.add(new W.$X7b(le.policyFile,Oe,Fe)):new j.$fn;$e.set(j.$dn,me);const ve=new r.$Fn(he.defaultProfile.settingsResource,Oe,me,Fe);return $e.set(l.$hi,ve),$e.set(B.$Z5b,new I.$Kh(B.$15b,void 0,!1)),$e.set(N.$Oo,new I.$Kh(U.$U7b,void 0,!0)),$e.set(T.$_5b,new I.$Kh(T.$a6b)),$e.set(H.$Zk,new I.$Kh(J.$V7b,void 0,!1)),$e.set(K.$4u,new I.$Kh(V.$S7b)),$e.set(re.$O6b,new X.$P7b(le,he,Fe)),[new L.$_p($e,!0),ge,le,ve,Y,Ae,Q,he]}c($e){const we={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Q=>{const le=process.env[Q];typeof le=="string"&&(we[Q]=le)}),Object.assign(process.env,we),we}async d($e,we,Q,le,ge){await C.Promises.settled([Promise.all([$e.extensionsPath,$e.codeCachePath,$e.logsHome.with({scheme:p.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,$e.backupHome].map(Ce=>Ce?h.Promises.mkdir(Ce,{recursive:!0}):void 0)),le.init(),Q.initialize()]),we.init()}async e($e,we,Q,le,ge,Ce){let Ae;try{(0,y.mark)("code/willStartMainServer"),Ae=await(0,k.$Ih)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),g.Event.once(Q.onWillShutdown)(()=>Ae.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.f(we,ge,Fe),Fe;let Oe;try{Oe=await(0,k.$Jh)(we.mainIPCHandle,"main")}catch(he){if(!Ce||w.$j||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),he;try{(0,D.unlinkSync)(we.mainIPCHandle)}catch(me){throw $e.warn("Could not delete obsolete instance handle",me),me}return this.e($e,we,Q,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw $e.error(he),Oe.dispose(),new Error(he)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const We=c.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Y=c.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new i.$Cr(oe.$ho,ge),me=await Y.getMainDiagnostics(),ve=await Y.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await he.getDiagnostics(me,ve);throw console.log(De),new f.$_});throw w.$j&&await this.h(We,$e),$e.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$_("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}f($e,we,Q){if(Q.code==="EACCES"||Q.code==="EPERM"){const le=(0,M.$Gb)([$e.userDataPath,$e.extensionsPath,k.$Eh]).map(ge=>(0,b.$lv)(s.URI.file(ge),{os:w.OS,tildify:$e}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$yi)(Q),le.join(`
`)),we)}}g($e,we,Q){P.dialog.showMessageBoxSync((0,fe.$zv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:we},Q).options)}async h($e,we){if(w.$j){const Q=await $e.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Q);try{(await new Promise((le,ge)=>{Z(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Q)}catch(le){we.error(le)}}}i($e,we){const Q=$e.get(x.$8i),le=$e.get(B.$Z5b);let ge=0;we&&(we.isExpected?we.message&&Q.trace(we.message):(ge=1,we.stack?Q.error(we.stack):Q.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const $e=this.k((0,o.$Gl)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const we=(0,v.$O7b)($e.verbose);we&&((0,o.$Il)(process.argv,"--waitMarkerFilePath",we),$e.waitMarkerFilePath=we)}return $e}k($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const we=this.l($e._,$e.goto);$e._=we}return $e}l($e,we){const Q=(0,$.cwd)(),le=$e.map(Ae=>{let Fe=String(Ae),Oe;we&&(Oe=(0,a.$4f)(Fe),Fe=Oe.path),Fe&&(Fe=this.m(Q,Fe));const ze=(0,a.$Yf)(Fe,Q),We=(0,d.$mc)(ze);return We&&!(0,a.$Uf)(We)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),ge=w.$j||w.$k,Ce=(0,M.$Lb)(le,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,M.$Gb)(Ce)}m($e,we){return w.$j&&(we=(0,m.$Je)(we,'"')),we=(0,m.$He)((0,m.$He)(we," "),"	"),w.$j&&(we=(0,d.$jc)($e,we),we=(0,m.$Je)(we,".")),we}n($e){const we=[$e.path];return typeof $e.line=="number"&&we.push(String($e.line)),typeof $e.column=="number"&&we.push(String($e.column)),we.join(":")}}new pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/874831ebcf088f59735879156f62308ce48f17d1/core/vs/code/electron-main/main.js.map
