/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const R=new Map,A=new Map,j=new Map,v=new Map;function u(d,S){d.has(S.detail)||d.set(S.detail,-S.timestamp)}function c(d,S){const w=d.get(S.detail);w&&(w>=0||d.set(S.detail,w+S.timestamp))}let b=[];typeof J=="function"&&typeof J.getStats=="function"&&(b=J.getStats().slice(0).sort((d,S)=>d.timestamp-S.timestamp));for(const d of b)switch(d.type){case 10:u(R,d);break;case 11:case 12:c(R,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(j,d);break;case 34:c(j,d);break;case 31:u(v,d);break;case 32:c(v,d);break}let O=0;j.forEach(d=>O+=d);function m(d){const S=[];return d.forEach((w,$)=>S.push([$,w])),S}return{amdLoad:m(R),amdInvoke:m(A),nodeRequire:m(j),nodeEval:m(v),nodeRequireTotal:O}}static toMarkdownTable(R,A){let j="";const v=[];return R.forEach((u,c)=>{v[c]=u.length}),A.forEach(u=>{u.forEach((c,b)=>{typeof c>"u"&&(c=u[b]="-");const O=c.toString().length;v[b]=Math.max(O,v[b])})}),R.forEach((u,c)=>{j+=`| ${u+" ".repeat(v[c]-u.toString().length)} `}),j+=`|
`,R.forEach((u,c)=>{j+=`| ${"-".repeat(v[c])} `}),j+=`|
`,A.forEach(u=>{u.forEach((c,b)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(v[b]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function L(j){return(v,u,c)=>{let b=null,O=null;if(typeof c.value=="function"?(b="value",O=c.value):typeof c.get=="function"&&(b="get",O=c.get),!O)throw new Error("not supported");c[b]=j(O,u)}}function D(j,v,u){let c=null,b=null;if(typeof u.value=="function"?(c="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",b=u.get),!b)throw new Error("not supported");const O=`$memoize$${v}`;u[c]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,m)}),this[O]}}e.$fh=D;function R(j,v,u){return L((c,b)=>{const O=`$debounce$${b}`,m=`$debounce$result$${b}`;return function(...d){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),v&&(this[m]=v(this[m],...d),d=[this[m]]),this[O]=setTimeout(()=>{c.apply(this,d),this[m]=u?u():void 0},j)}})}e.$gh=R;function A(j,v,u){return L((c,b)=>{const O=`$throttle$timer$${b}`,m=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...w){if(this[m]||(this[m]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),v&&(this[m]=v(this[m],...w)),this[S])return;const $=this[d]+j;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0):(this[S]=!0,this[O]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0},$-Date.now()))}})}e.$hh=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(u,c="Unreachable"){throw new Error(c)}e.$3c=R;function A(u){if(!u)throw new L.$bb("Assertion Failed")}e.$4c=A;function j(u){if(!u()){debugger;u(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=j;function v(u,c){let b=0;for(;b<u.length-1;){const O=u[b],m=u[b+1];if(!c(O,m))return!1;b++}return!0}e.$6c=v}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(t,a=!1){let i=0;const n=t.length;let s="",r=0,l=16,k=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function E(te){i=te,s="",r=0,l=16,k=0}function N(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return k=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else k=3;return t.substring(te,ae)}function W(){let te="",ae=i;for(;;){if(i>=n){te+=t.substring(ae,i),k=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=n){k=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):k=4;break}default:k=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),k=2;break}else k=6;i++}return te}function x(){if(s="",k=0,r=i,i>=n)return r=n,l=17;let te=t.charCodeAt(i);if(v(te)){do i++,s+=String.fromCharCode(te),te=t.charCodeAt(i);while(v(te));return l=15}if(u(te))return i++,s+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,s=W(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return s=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const le=n-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,k=1),s=t.substring(ae,i),l=13}return s+=String.fromCharCode(te),i++,l=16}case 45:if(s+=String.fromCharCode(te),i++,i===n||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),l=11;default:for(;i<n&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(s=t.substring(r,i),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(te),i++,l=16}}function _(te){if(v(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:a?ue:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>k}}e.$Pm=j;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function O(t,a){const i=[],n=new Object;let s;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(y,E,N,W){r.value=y,r.offset=E,r.length=N,r.type=W,r.colonOffset=void 0,s=r}try{I(t,{onObjectBegin:(y,E)=>{if(a<=y)throw n;s=void 0,l=a>y,i.push("")},onObjectProperty:(y,E,N)=>{if(a<E||(k(y,E,N,"property"),i[i.length-1]=y,a<=E+N))throw n},onObjectEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onArrayBegin:(y,E)=>{if(a<=y)throw n;s=void 0,i.push(0)},onArrayEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onLiteralValue:(y,E,N)=>{if(a<E||(k(y,E,N,P(y)),a<=E+N))throw n},onSeparator:(y,E,N)=>{if(a<=E)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=E,l=!1,s=void 0;else if(y===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let E=0;for(let N=0;E<y.length&&N<i.length;N++)if(y[E]===i[N]||y[E]==="*")E++;else if(y[E]!=="**")return!1;return E===y.length}}}e.$Qm=O;function m(t,a=[],i=A.DEFAULT){let n=null,s=[];const r=[];function l(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return I(t,{onObjectBegin:()=>{const y={};l(y),r.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(s),s=y,n=null},onArrayEnd:()=>{s=r.pop()},onLiteralValue:l,onError:(y,E,N)=>{a.push({error:y,offset:E,length:N})}},i),s[0]}e.$Rm=m;function d(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}I(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,E,N)=>{n=r({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:E,length:N,parent:n})},onObjectEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onArrayBegin:(y,E)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onLiteralValue:(y,E,N)=>{r({type:P(y),offset:E,length:N,parent:n,value:y}),s(E+N)},onSeparator:(y,E,N)=>{n.type==="property"&&(y===":"?n.colonOffset=E:y===","&&s(E))},onError:(y,E,N)=>{a.push({error:y,offset:E,length:N})}},i);const k=n.children[0];return k&&delete k.parent,k}e.$Sm=d;function S(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===n){i=r.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.$Tm=S;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Um=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=$(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Vm=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Wm=h;function f(t,a,i=!1){if(h(t,a,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=a;s++){const r=f(n[s],a,i);if(r)return r}return t}}e.$Xm=f;function I(t,a,i=A.DEFAULT){const n=j(t,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(K){return K?Q=>K(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(a.onObjectBegin),k=r(a.onObjectProperty),y=s(a.onObjectEnd),E=s(a.onArrayBegin),N=s(a.onArrayEnd),W=r(a.onLiteralValue),x=r(a.onSeparator),_=s(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(K){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return K}}}function ie(K,Q=[],F=[]){if(ue(K),Q.length+F.length>0){let z=n.getToken();for(;z!==17;){if(Q.indexOf(z)!==-1){le();break}else if(F.indexOf(z)!==-1)break;z=le()}}}function q(K){const Q=n.getTokenValue();return K?W(Q):k(Q),le(),!0}function G(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(ie(2),K=0)}catch{ie(2)}W(K);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return le(),!0}function T(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(x(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),le();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||ie(4,[],[]),x(","),le(),n.getToken()===2&&ae)break}else K&&ie(6,[],[]);T()||ie(4,[],[2,5]),K=!0}return y(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){E(),le();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||ie(4,[],[]),x(","),le(),n.getToken()===4&&ae)break}else K&&ie(6,[],[]);X()||ie(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(n.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return G()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Ym=I;function p(t,a){const i=j(t),n=[];let s,r=0,l;do switch(l=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:r!==l&&n.push(t.substring(r,l)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(s!==17);return n.join("")}e.$Zm=p;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=P}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function L(v,u,c){return Math.min(Math.max(v,u),c)}e.$Kl=L;function D(v,u){return(u+v%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=A;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=j}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function j(u){A.push(u,Date.now())}function v(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:j,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(R+j.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var j in D)L.d(A,j,function(v){return D[v]}.bind(null,j));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],u=e.src=[],c=0,b=c++;u[b]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var m=c++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var S=c++;u[S]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var w=c++;u[w]="(?:"+u[b]+"|"+u[m]+")";var $=c++;u[$]="(?:"+u[O]+"|"+u[m]+")";var h=c++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var P=c++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[P]="^"+t+"$";var a="[v=\\s]*"+u[S]+u[f]+"?"+u[p]+"?",i=c++;u[i]="^"+a+"$";var n=c++;u[n]="((?:<|>)?=?)";var s=c++;u[s]=u[O]+"|x|X|\\*";var r=c++;u[r]=u[b]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var k=c++;u[k]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[n]+"\\s*"+u[l]+"$";var E=c++;u[E]="^"+u[n]+"\\s*"+u[k]+"$";var N=c++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var x=c++;u[x]="(\\s*)"+u[W]+"\\s+",v[x]=new RegExp(u[x],"g");var _=c++;u[_]="^"+u[W]+u[l]+"$";var ue=c++;u[ue]="^"+u[W]+u[k]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",v[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[k]+"$";var q=c++;u[q]="^"+u[n]+"\\s*("+a+")$|^$";var G=c++;u[G]="^"+u[n]+"\\s*("+t+")$|^$";var T=c++;u[T]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[l]+")",v[T]=new RegExp(u[T],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)R(K,u[K]),v[K]||(v[K]=new RegExp(u[K]));function Q(V,Y){if(V instanceof F)return V;if(typeof V!="string"||V.length>A||!(Y?v[i]:v[P]).test(V))return null;try{return new F(V,Y)}catch{return null}}function F(V,Y){if(V instanceof F){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(V,Y);R("SemVer",V,Y),this.loose=Y;var ee=V.trim().match(Y?v[i]:v[P]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Q,e.valid=function(V,Y){var ee=Q(V,Y);return ee?ee.version:null},e.clean=function(V,Y){var ee=Q(V.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),o(this.major,V.major)||o(this.minor,V.minor)||o(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],$e=V.prerelease[Y];if(R("prerelease compare",Y,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return o(ee,$e)}while(++Y)},F.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new F(V,ee).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Z(V,Y))return null;var ee=Q(V),$e=Q(Y);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(V,Y){var ee=z.test(V),$e=z.test(Y);return ee&&$e&&(V=+V,Y=+Y),ee&&!$e?-1:$e&&!ee?1:V<Y?-1:V>Y?1:0}function g(V,Y,ee){return new F(V,ee).compare(new F(Y,ee))}function M(V,Y,ee){return g(V,Y,ee)>0}function C(V,Y,ee){return g(V,Y,ee)<0}function Z(V,Y,ee){return g(V,Y,ee)===0}function H(V,Y,ee){return g(V,Y,ee)!==0}function ce(V,Y,ee){return g(V,Y,ee)>=0}function oe(V,Y,ee){return g(V,Y,ee)<=0}function me(V,Y,ee,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Z(V,ee,$e);break;case"!=":ye=H(V,ee,$e);break;case">":ye=M(V,ee,$e);break;case">=":ye=ce(V,ee,$e);break;case"<":ye=C(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);R("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Y){return o(Y,V)},e.major=function(V,Y){return new F(V,Y).major},e.minor=function(V,Y){return new F(V,Y).minor},e.patch=function(V,Y){return new F(V,Y).patch},e.compare=g,e.compareLoose=function(V,Y){return g(V,Y,!0)},e.rcompare=function(V,Y,ee){return g(Y,V,ee)},e.sort=function(V,Y){return V.sort(function(ee,$e){return e.compare(ee,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(ee,$e){return e.rcompare(ee,$e,Y)})},e.gt=M,e.lt=C,e.eq=Z,e.neq=H,e.gte=ce,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,ee,$e,ye,Ne,Se,Le,Ie,Ae,Fe,Oe,je){return((Y=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Fe)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Fe+"-"+Oe:"<="+Le)).trim()}function be(V,Y){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function Pe(V,Y,ee){try{Y=new fe(Y,ee)}catch{return!1}return Y.test(V)}function Me(V,Y,ee,$e){var ye,Ne,Se,Le,Ie;switch(V=new F(V,$e),Y=new fe(Y,$e),ee){case">":ye=M,Ne=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,Ne=ce,Se=M,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(V,Y,$e))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var Fe=Y.set[Ae],Oe=null,je=null;if(Fe.forEach(function(De){De.semver===ge&&(De=new de(">=0.0.0")),Oe=Oe||De,je=je||De,ye(De.semver,Oe.semver,$e)?Oe=De:Se(De.semver,je.semver,$e)&&(je=De)}),Oe.operator===Le||Oe.operator===Ie||(!je.operator||je.operator===Le)&&Ne(V,je.semver)||je.operator===Ie&&Se(V,je.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?v[q]:v[G],ee=V.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Y),Pe(this.value,ee,Y);if(V.operator==="")return ee=new fe(this.value,Y),Pe(V.semver,ee,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Ne&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),R("range",V,Y);var ee=Y?v[B]:v[U];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),R("comparator trim",V,v[T]),V=(V=(V=V.replace(v[x],"$1~")).replace(v[ae],"$1^")).split(/\s+/).join(" ");var $e=Y?v[q]:v[G],ye=V.split(" ").map(function(Ne){return function(Se,Le){return R("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,je){R("caret",Oe,je);var De=je?v[ie]:v[le];return Oe.replace(De,function(Ue,ve,Ee,ke,Re){var ze;return R("caret",Oe,Ue,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,je){var De=je?v[ue]:v[_];return Oe.replace(De,function(Ue,ve,Ee,ke,Re){var ze;return R("tilde",Oe,Ue,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Fe){return function(Oe,je){Oe=Oe.trim();var De=je?v[E]:v[y];return Oe.replace(De,function(Ue,ve,Ee,ke,Re,ze){R("xRange",Oe,Ue,ve,Ee,ke,Re,ze);var qe=he(Ee),Ce=qe||he(ke),Te=Ce||he(Re);return ve==="="&&Te&&(ve=""),qe?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(ke=0),Te&&(Re=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:ke=+ke+1),Ue=ve+Ee+"."+ke+"."+Re):Ce?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ue=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),R("xRange return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(v[X],"")}(Se,Le),R("stars",Se),Se}(Ne,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ne){return!!Ne.match($e)})),ye=ye.map(function(Ne){return new de(Ne,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(Ne){return $e.intersects(Ne,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],V))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Ne=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new F($e=Se,ee)))}),$e},e.minSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var Ne=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new F($e=Se,ee)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,ee){return Me(V,Y,"<",ee)},e.gtr=function(V,Y,ee){return Me(V,Y,">",ee)},e.outside=Me,e.prerelease=function(V,Y){var ee=Q(V,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Y,ee){return V=new fe(V,ee),Y=new fe(Y,ee),V.intersects(Y)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var Y=V.match(v[N]);return Y==null?null:Q((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function v($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:j}catch{D=j}})();var u,c=[],b=!1,O=-1;function m(){b&&u&&(b=!1,u.length?c=u.concat(c):O=-1,c.length&&d())}function d(){if(!b){var $=v(m);b=!0;for(var h=c.length;h;){for(u=c,c=[];++O<h;)u&&u[O].run();O=-1,h=c.length}u=null,b=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===j||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function S($,h){this.fun=$,this.array=h}function w(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new S($,h)),c.length!==1||b||v(d)},S.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class D{constructor(v,u,c){this.level=v,this.key=u,this.value=c,this.forward=[]}}const R=void 0;class A{constructor(v,u=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(v){return!!A.g(this,v,this.comparator)}get(v){return A.g(this,v,this.comparator)?.value}set(v,u){return A.h(this,v,u,this.comparator)&&(this.f+=1),this}delete(v){const u=A.k(this,v,this.comparator);return u&&(this.f-=1),u}forEach(v,u){let c=this.e.forward[0];for(;c;)v.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",u=this.e.forward[0];for(;u;)v+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return v}static g(v,u,c){let b=v.e;for(let O=v.d-1;O>=0;O--)for(;b.forward[O]&&c(b.forward[O].key,u)<0;)b=b.forward[O];if(b=b.forward[0],b&&c(b.key,u)===0)return b}static h(v,u,c,b){const O=[];let m=v.e;for(let d=v.d-1;d>=0;d--){for(;m.forward[d]&&b(m.forward[d].key,u)<0;)m=m.forward[d];O[d]=m}if(m=m.forward[0],m&&b(m.key,u)===0)return m.value=c,!1;{const d=A.j(v);if(d>v.d){for(let S=v.d;S<d;S++)O[S]=v.e;v.d=d}m=new D(d,u,c);for(let S=0;S<d;S++)m.forward[S]=O[S].forward[S],O[S].forward[S]=m;return!0}}static j(v,u=.5){let c=1;for(;Math.random()<u&&c<v.c;)c+=1;return c}static k(v,u,c){const b=[];let O=v.e;for(let m=v.d-1;m>=0;m--){for(;O.forward[m]&&c(O.forward[m].key,u)<0;)O=O.forward[m];b[m]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let m=0;m<v.d&&b[m].forward[m]===O;m++)b[m].forward[m]=O.forward[m];for(;v.d>0&&v.e.forward[v.d-1]===R;)v.d-=1;return!0}}e.$ur=A}),define(ne[45],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function R(p){const P=p;return P?typeof P.read=="function":!1}e.$Xd=R;function A(p){const P=p;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.$Yd=A;function j(p){const P=p;return P?A(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.$Zd=j;function v(p,P){return new u(p,P)}e.$1d=v;class u{constructor(P,t){this.e=P,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(t=>t(P))}h(P){this.c.error.length===0?(0,L.$Z)(P):this.c.error.slice(0).forEach(t=>t(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,t){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(P,t){if(this.a.destroyed)return;let a;switch(P){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,P){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return P(t)}e.$2d=c;function b(p,P,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?P(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.$3d=b;function O(p,P){return new Promise((t,a)=>{const i=[];m(p,{onData:n=>{P&&i.push(n)},onError:n=>{P?a(n):t(void 0)},onEnd:()=>{t(P?P(i):void 0)}})})}e.$4d=O;function m(p,P,t){p.on("error",a=>{t?.isCancellationRequested||P.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||P.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||P.onData(a)})}e.$5d=m;function d(p,P){return new Promise((t,a)=>{const i=new D.$Qc,n=[],s=k=>{if(n.push(k),n.length>P)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},r=k=>(i.dispose(),a(k)),l=()=>(i.dispose(),t({stream:p,buffer:n,ended:!0}));i.add((0,D.$Pc)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,D.$Pc)(()=>p.removeListener("end",l))),p.on("end",l),i.add((0,D.$Pc)(()=>p.removeListener("data",s))),p.on("data",s)})}e.$6d=d;function S(p,P){const t=v(P);return t.end(p),t}e.$7d=S;function w(){const p=v(()=>{throw new Error("not supported")});return p.end(),p}e.$8d=w;function $(p){let P=!1;return{read:()=>P?null:(P=!0,p)}}e.$9d=$;function h(p,P,t){const a=v(t);return m(p,{onData:i=>a.write(P.data(i)),onError:i=>a.error(P.error?P.error(i):i),onEnd:()=>a.end()}),a}e.$0d=h;function f(p,P,t){let a=!1;return{read:()=>{const i=P.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$$d=f;function I(p,P,t){let a=!1;const i=v(t);return m(P,{onData:n=>a?i.write(n):(a=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$_d=I}),define(ne[14],re([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const R=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,v;class u{static alloc(N){return R?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return R&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,W){return!(W?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(N)):(j||(j=new TextEncoder),new u(j.encode(N)))}static fromByteArray(N){const W=u.alloc(N.length);for(let x=0,_=N.length;x<_;x++)W.buffer[x]=N[x];return W}static concat(N,W){if(typeof W>"u"){W=0;for(let ue=0,te=N.length;ue<te;ue++)W+=N[ue].byteLength}const x=u.alloc(W);let _=0;for(let ue=0,te=N.length;ue<te;ue++){const ae=N[ue];x.set(ae,_),_+=ae.byteLength}return x}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return R?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(N,W){return new u(this.buffer.subarray(N,W))}set(N,W){if(N instanceof u)this.buffer.set(N.buffer,W);else if(N instanceof Uint8Array)this.buffer.set(N,W);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),W);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return m(this.buffer,N)}writeUInt32BE(N,W){d(this.buffer,N,W)}readUInt32LE(N){return S(this.buffer,N)}writeUInt32LE(N,W){w(this.buffer,N,W)}readUInt8(N){return $(this.buffer,N)}writeUInt8(N,W){h(this.buffer,N,W)}indexOf(N,W=0){return c(this.buffer,N instanceof u?N.buffer:N,W)}}e.$ae=u;function c(E,N,W=0){const x=N.byteLength,_=E.byteLength;if(x===0)return 0;if(x===1)return E.indexOf(N[0]);if(x>_-W)return-1;const ue=A.value;ue.fill(N.length);for(let ie=0;ie<N.length;ie++)ue[N[ie]]=N.length-ie-1;let te=W+N.length-1,ae=te,le=-1;for(;te<_;)if(E[te]===N[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(N.length-ae,ue[E[te]]),ae=N.length-1;return le}e.$be=c;function b(E,N){return E[N+0]<<0>>>0|E[N+1]<<8>>>0}e.$ce=b;function O(E,N,W){E[W+0]=N&255,N=N>>>8,E[W+1]=N&255}e.$de=O;function m(E,N){return E[N]*2**24+E[N+1]*2**16+E[N+2]*2**8+E[N+3]}e.$ee=m;function d(E,N,W){E[W+3]=N,N=N>>>8,E[W+2]=N,N=N>>>8,E[W+1]=N,N=N>>>8,E[W]=N}e.$fe=d;function S(E,N){return E[N+0]<<0>>>0|E[N+1]<<8>>>0|E[N+2]<<16>>>0|E[N+3]<<24>>>0}e.$ge=S;function w(E,N,W){E[W+0]=N&255,N=N>>>8,E[W+1]=N&255,N=N>>>8,E[W+2]=N&255,N=N>>>8,E[W+3]=N&255}e.$he=w;function $(E,N){return E[N]}e.$ie=$;function h(E,N,W){E[W]=N}e.$je=h;function f(E){return D.$2d(E,N=>u.concat(N))}e.$ke=f;function I(E){return D.$9d(E)}e.$le=I;function p(E){return D.$4d(E,N=>u.concat(N))}e.$me=p;async function P(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await p(E.stream)])}e.$ne=P;function t(E){return D.$7d(E,N=>u.concat(N))}e.$oe=t;function a(E){return D.$0d(E,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}e.$pe=a;function i(E){return D.$1d(N=>u.concat(N),E)}e.$qe=i;function n(E,N){return D.$$d(E,N,W=>u.concat(W))}e.$re=n;function s(E,N){return D.$_d(E,N,W=>u.concat(W))}e.$se=s;function r(E){let N=0,W=0,x=0;const _=new Uint8Array(Math.floor(E.length/4*3)),ue=ae=>{switch(W){case 3:_[x++]=N|ae,W=0;break;case 2:_[x++]=N|ae>>>2,N=ae<<6,W=3;break;case 1:_[x++]=N|ae>>>4,N=ae<<4,W=2;break;default:N=ae<<2,W=1}};for(let ae=0;ae<E.length;ae++){const le=E.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const te=x;for(;W>0;)ue(0);return u.wrap(_).slice(0,te)}e.$te=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:E},N=!0,W=!1){const x=W?k:l;let _="";const ue=E.byteLength%3;let te=0;for(;te<E.byteLength-ue;te+=3){const ae=E[te+0],le=E[te+1],ie=E[te+2];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[(le<<2|ie>>>6)&63],_+=x[ie&63]}if(ue===1){const ae=E[te+0];_+=x[ae>>>2],_+=x[ae<<4&63],N&&(_+="==")}else if(ue===2){const ae=E[te+0],le=E[te+1];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[le<<2&63],N&&(_+="=")}return _}e.$ue=y}),define(ne[41],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function D(h){return R(h,0)}e.$Bi=D;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return v(h,f);case"boolean":return j(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Ci=R;function A(h,f){return(f<<5)-f+h|0}e.$Di=A;function j(h,f){return A(h?433:863,f)}function v(h,f){f=A(149417,f);for(let I=0,p=h.length;I<p;I++)f=A(h.charCodeAt(I),f);return f}e.$Ei=v;function u(h,f){return f=A(104579,f),h.reduce((I,p)=>R(p,I),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=v(p,I),R(h[p],I)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$Fi=b;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(h,f,I=32){const p=I-f,P=~((1<<p)-1);return(h<<f|(P&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let P=0;P<I;P++)h[f+P]=p}function S(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):S((h>>>0).toString(16),f/4)}e.$Gi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let P=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let n=a;if(L.$5e(a))if(i+1<I){const s=f.charCodeAt(i+1);L.$6e(s)?(i++,n=L.$7e(a,s)):n=65533}else{t=a;break}else L.$6e(a)&&(n=65533);if(P=this.w(p,P,n),i++,i<I)a=f.charCodeAt(i);else break}this.r=P,this.u=t}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,P=this.l,t=this.m,a=this.n,i=this.o,n,s,r;for(let l=0;l<80;l++)l<20?(n=P&t|~P&a,s=1518500249):l<40?(n=P^t^a,s=1859775393):l<60?(n=P&t|P&a|t&a,s=2400959708):(n=P^t^a,s=3395469782),r=m(p,5)+n+i+s+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=m(P,30),P=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+P&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$Hi=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",j="warning",v="warn",u="info",c="ignore";function b(m){return m?L.$1e(A,m)?R.Error:L.$1e(j,m)||L.$1e(v,m)?R.Warning:L.$1e(u,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function O(m){switch(m){case R.Error:return A;case R.Warning:return j;case R.Info:return u;default:return c}}R.toString=O}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?D(p):p}),f}e.$2m=D;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(A.call(I,p)){const P=I[p];typeof P=="object"&&!Object.isFrozen(P)&&!(0,L.$Af)(P)&&f.push(P)}}return h}e.$3m=R;const A=Object.prototype.hasOwnProperty;function j(h,f){return v(h,f,new Set)}e.$4m=j;function v(h,f,I){if((0,L.$Gf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const P=[];for(const t of h)P.push(v(t,f,I));return P}if((0,L.$zf)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const P={};for(const t in h)A.call(h,t)&&(P[t]=v(h[t],f,I));return I.delete(h),P}return h}function u(h,f,I=!0){return(0,L.$zf)(h)?((0,L.$zf)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$zf)(h[p])&&(0,L.$zf)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$5m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const P=[];for(p in h)P.push(p);P.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!c(P,t))return!1;for(I=0;I<P.length;I++)if(!c(h[P[I]],f[P[I]]))return!1}return!0}e.$6m=c;function b(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$zf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$7m=b;function O(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(P=>{const t=h[P],a=f[P];c(t,a)||(I[P]=a)}),I}e.$8m=O;function m(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(P=>P.toLowerCase()===I);return p?h[p]:h[f]}e.$9m=m;function d(h,f){const I=Object.create(null);for(const[p,P]of Object.entries(h))f(p,P)&&(I[p]=P);return I}e.$0m=d;function S(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$$m=S;function w(h){const f=[];for(const I of S(h))typeof h[I]=="function"&&f.push(I);return f}e.$_m=w;function $(h,f){const I=P=>function(){const t=Array.prototype.slice.call(arguments,0);return f(P,t)},p={};for(const P of h)p[P]=I(P);return p}e.$an=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$cg=D,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(v){for(let u=0;u<v.length;u++)v[u]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),j=[];for(let v=0;v<256;v++)j.push(v.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(j){const v=j.replace(/\-/g,":").toLowerCase();return!D.has(v)}function A(){const j=(0,L.networkInterfaces)();for(const v in j){const u=j[v];if(u){for(const{mac:c}of u)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Mm=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=void 0,e.$Nm=new class{c(c){return this.a||(this.a=D.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,b=0;const O=(0,L.networkInterfaces)();for(const m in O){const d=O[m];if(d)for(const{mac:S,internal:w}of d)w||(b+=1,this.c(S.toUpperCase())&&(c+=1))}this.b=b>0?c/b:0}return this.b}};let j;async function v(c){return j||(j=(async()=>await u(c)||R.$dg())()),j}e.$Om=v;async function u(c){try{const b=await new Promise((m,d)=>{J(["crypto"],m,d)}),O=(0,A.$Mm)();return b.createHash("sha256").update(O,"utf8").digest("hex")}catch(b){c(b);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const D=60,R=D*60,A=R*24,j=A*7,v=A*30,u=A*365;function c(O,m,d,S){typeof O!="number"&&(O=O.getTime());const w=Math.round((new Date().getTime()-O)/1e3);if(w<-30)return(0,L.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,L.localize)(1,null);let $;return w<D?($=w,m?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):w<R?($=Math.floor(w/D),m?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):w<A?($=Math.floor(w/R),m?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):w<j?($=Math.floor(w/A),m?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):w<v?($=Math.floor(w/j),m?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):w<u?($=Math.floor(w/v),m?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(w/u),m?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$_l=c;function b(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=b}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function A(O,m){return m&&(O.stack||O.stacktrace)?R.localize(0,null,v(O),j(O.stack)||j(O.stacktrace)):v(O)}function j(O){return Array.isArray(O)?O.join(`
`):O}function v(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,m=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const d=L.$Gb(O),S=u(d[0],m);return d.length>1?R.localize(4,null,S,d.length):S}if(D.$xf(O))return O;if(O.detail){const d=O.detail;if(d.error)return A(d.error,m);if(d.exception)return A(d.exception,m)}return O.stack?A(O,m):O.message?O.message:R.localize(5,null)}e.$yi=u;function c(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$zi=c;function b(O,m){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=m,d}e.$Ai=b}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$sp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var D;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(v,...u){const c=u.reduce((m,d)=>(m[d]=!0,m),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(m=>!c[m]).forEach(m=>{for(let d=0;d<b.length;d++)if(m.search(b[d])!==-1){delete v[m];break}})}e.$vl=A;function j(v){v&&(delete v.DEBUG,L.$k&&delete v.DYLD_LIBRARY_PATH,L.$l&&delete v.LD_PRELOAD)}e.$wl=j}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Vp=e.$Up=e.$Tp=void 0;function D(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$Tp=D;function R(c){const b=[];let O;try{const m=JSON.parse(c.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),O=d.__$stack),b.push(...m)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:O}}e.$Up=R;function A(c){if(typeof c!="string")return A(R(c).stack);const b=c;if(b){const O=j(b),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Vp=A;function j(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function v(c,b){const{args:O,stack:m}=R(c),d=typeof O[0]=="string"&&O.length===1;let S=j(m);S&&(S=`(${S.trim()})`);let w=[];if(typeof O[0]=="string"?S&&d?w=[`%c[${b}] %c${O[0]} %c${S}`,u("blue"),u(""),u("grey")]:w=[`%c[${b}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:w=[`%c[${b}]%`,u("blue"),...O],S&&!d&&w.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=v;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function R(u){return JSON.stringify(u,j)}e.$ih=R;function A(u){let c=JSON.parse(u);return c=v(c),c}e.$jh=A;function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$ae||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=v(u[b],c+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=v(u[b],c+1))}return u}e.$kh=v}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class j{constructor(m,d,S){this.id=m,this.dependencies=d,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,d,S)=>{typeof m!="string"&&(S=d,d=m,m=null),(typeof d!="object"||!Array.isArray(d))&&(S=d,d=null),this.c.push(new j(m,d,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const d=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!d)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(m){return new Promise((d,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),S(I)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),w.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(w)})}i(m){return new Promise((d,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),d(this.c.pop())}catch(w){S(w)}})}async j(m){try{const d=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(m).fsPath,h=d.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new S.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function b(O,m,d){if(L.$S){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const S=`${O}/${m}`;if(u.has(S))return u.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const I=`${d&&!R.$p?D.$$f:D.$0f}/${S}`;w=D.$bg.asBrowserUri(I).toString(!0)}const $=v.INSTANCE.load(w);return u.set(S,$),$}else return await new Promise((S,w)=>{J([O],S,w)})}e.$gC=b}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class O{constructor(P,t,a){this.exePath=P,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:P=!1}={}){const t=m({useAlternateBitness:p});if(!t)return null;const a=D.$ic(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const l of await R.Promises.readdir(a)){let k=-1;if(P){const E=l.indexOf("-");if(E<0)continue;const N=l.substring(0,E);if(!A.test(N)||l.substring(E+1)!=="preview")continue;k=parseInt(N,10)}else{if(!A.test(l))continue;k=parseInt(l,10)}if(k<=i)continue;const y=D.$ic(a,l,"pwsh.exe");await R.SymlinkSupport.existsFile(y)&&(n=y,i=k)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",r=P?" Preview":"";return new O(n,`PowerShell${r}${s}`,!0)}async function S({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const P=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(P))if(t.test(i)){const n=D.$ic(P,i,"pwsh.exe");return new O(n,a)}return null}function w(){const p=D.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$ic(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await S(),p&&(yield p),p=w(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$tl=f;async function I(){for await(const p of f())return p;return null}e.$ul=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$xl=u;function c(O){let m=[],d=!1;const S=function(w){if(d){m.push(w);return}(!O.send(w,h=>{if(h&&console.error(h),d=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(I=>S(I))}})||D.$j)&&(d=!0)};return{send:S}}e.$yl=c;var b;(function(O){async function m(d,S,w){if(L.$hc(d))return d;if(S===void 0&&(S=R.cwd()),L.$lc(d)!=="."||(w===void 0&&j.$xf(R.env.PATH)&&(w=R.env.PATH.split(L.$sc)),w===void 0||w.length===0))return L.$ic(S,d);async function h(f){if(await v.Promises.exists(f)){let I;try{I=await v.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await v.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of w){let I;if(L.$hc(f)?I=L.$ic(f,d):I=L.$ic(S,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$ic(S,d)}O.findExecutable=m})(b||(e.win32=b={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;async function j(O,m){return O===1?D.$j?b():A.$xl(m):u(O,m)}e.$zl=j;let v=null;function u(O,m){if(D.$l&&O===2||D.$k&&O===3)return"/bin/bash";if(!v){let d;if(D.$j)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}v=d}return v}let c=null;async function b(){return c||(c=(await(0,R.$ul)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var v=J.length-1;v>=0;v--)(j=J[v])&&(A=(R<3?j(A):R>3?j(e,L,A):j(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,R,A,j,v,u,c,b,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let U=0;for(let B=0;;B+=7){const X=T.read(1);if(U|=(X.buffer[0]&127)<<B,!(X.buffer[0]&128))return U}}const I=i(0);function p(T,U){if(U===0){T.write(I);return}let B=0;for(let K=U;K!==0;K=K>>>7)B++;const X=R.$ae.alloc(B);for(let K=0;U!==0;K++)X.buffer[K]=U&127,U=U>>>7,U>0&&(X.buffer[K]|=128);T.write(X)}class P{constructor(U){this.b=U,this.a=0}read(U){const B=this.b.slice(this.a,this.a+U);return this.a+=B.byteLength,B}}e.$lh=P;class t{constructor(){this.a=[]}get buffer(){return R.$ae.concat(this.a)}write(U){this.a.push(U)}}e.$mh=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const U=R.$ae.alloc(1);return U.writeUInt8(T,0),U}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},s=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(n.Undefined);else if(typeof U=="string"){const B=R.$ae.fromString(U);T.write(n.String),p(T,B.byteLength),T.write(B)}else if(s&&Buffer.isBuffer(U)){const B=R.$ae.wrap(U);T.write(n.Buffer),p(T,B.byteLength),T.write(B)}else if(U instanceof R.$ae)T.write(n.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(n.Array),p(T,U.length);for(const B of U)r(T,B)}else if(typeof U=="number"&&(U|0)===U)T.write(n.Uint),p(T,U);else{const B=R.$ae.fromString(JSON.stringify(U));T.write(n.Object),p(T,B.byteLength),T.write(B)}}e.$nh=r;function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const B=f(T),X=[];for(let K=0;K<B;K++)X.push(l(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$oh=l;class k{constructor(U,B,X=null,K=1e3){this.h=U,this.j=B,this.k=X,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,B){this.b.set(U,B),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const B=this.o([U.type]);this.k?.logOutgoing(B,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const B=this.o([U.type,U.id],U.data);this.k?.logOutgoing(B,U.id,1,$(U.type),U.data);return}}}o(U,B=void 0){const X=new t;return r(X,U),r(X,B),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const B=new P(U),X=l(B),K=l(B),Q=X[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}: ${X[2]}.${X[3]}`,K),this.s({type:Q,id:X[1],channelName:X[2],name:X[3],arg:K});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}: ${X[2]}.${X[3]}`,K),this.t({type:Q,id:X[1],channelName:X[2],name:X[3],arg:K});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}`),this.u({type:Q,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}`),this.u({type:Q,id:X[1]})}}s(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const X=new A.$Wd;let K;try{K=B.call(this.j,U.name,U.arg,X.token)}catch(z){K=Promise.reject(z)}const Q=U.id;K.then(z=>{this.m({id:Q,data:z,type:201})},z=>{z instanceof Error?this.m({id:Q,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Q,data:z,type:203})}).finally(()=>{F.dispose(),this.d.delete(U.id)});const F=(0,c.$Pc)(()=>X.cancel());this.d.set(U.id,F)}t(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const X=U.id,Q=B.listen(this.j,U.name,U.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(U.id,Q)}u(U){const B=this.d.get(U.id);B&&(B.dispose(),this.d.delete(U.id))}v(U){let B=this.g.get(U.channelName);B||(B=[],this.g.set(U.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:U,timeoutTimer:X})}w(U){const B=this.g.get(U);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$ph=k;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class E{constructor(U,B=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=B}getChannel(U){const B=this;return{call(X,K,Q){return B.a?Promise.reject(new v.$4):B.m(U,X,K,Q)},listen(X,K){return B.a?u.Event.None:B.o(U,X,K)}}}m(U,B,X,K=A.CancellationToken.None){const Q=this.g++,z={id:Q,type:100,channelName:U,name:B,arg:X};if(K.isCancellationRequested)return Promise.reject(new v.$4);let o;return new Promise((M,C)=>{if(K.isCancellationRequested)return C(new v.$4);const Z=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Q),M(de.data);break;case 202:{this.f.delete(Q);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(Q),C(de.data);break}};this.f.set(Q,me),this.p(z)};let H=null;this.b===h.Idle?Z():(H=(0,D.$Gg)(me=>this.u()),H.then(()=>{H=null,Z()}));const ce=()=>{H?(H.cancel(),H=null):this.p({id:Q,type:101}),C(new v.$4)},oe=K.onCancellationRequested(ce);o=(0,c.$Oc)((0,c.$Pc)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(U,B,X){const K=this.g++,F={id:K,type:102,channelName:U,name:B,arg:X};let z=null;const o=new u.$Md({onWillAddFirstListener:()=>{z=(0,D.$Gg)(M=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(F)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:K,type:103}))}}),g=M=>o.fire(M.data);return this.f.set(K,g),o.event}p(U){switch(U.type){case 100:case 102:{const B=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(B,U.id,0,`${S(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.q([U.type,U.id]);this.j?.logOutgoing(B,U.id,0,S(U.type));return}}}q(U,B=void 0){const X=new t;return r(X,U),r(X,B),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const B=new P(U),X=l(B),K=l(B),Q=X[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(Q)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,$(Q),K),this.t({type:X[0],id:X[1],data:K})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$qh=E,pe([j.$fh],E.prototype,"onDidInitializePromise",null);class N{get connections(){const U=[];return this.f.forEach(B=>U.push(B)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$Md,this.onDidAddConnection=this.g.event,this.h=new u.$Md,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:B,onDidClientDisconnect:X})=>{const K=u.Event.once(B.onMessage);this.j.add(K(Q=>{const F=new P(Q),z=l(F),o=new k(B,z),g=new E(B);this.a.forEach((C,Z)=>o.registerChannel(Z,C));const M={channelServer:o,channelClient:g,ctx:z};this.f.add(M),this.g.fire(M),this.j.add(X(()=>{o.dispose(),g.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(U,B){const X=this;return{call(K,Q,F){let z;if((0,m.$Lf)(B)){const g=(0,L.$3b)(X.connections.filter(B));z=g?Promise.resolve(g):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,B))}else z=B.routeCall(X,K,Q);const o=z.then(g=>g.channelClient.getChannel(U));return x(o).call(K,Q,F)},listen(K,Q){if((0,m.$Lf)(B))return X.k(U,B,K,Q);const F=B.routeEvent(X,K,Q).then(z=>z.channelClient.getChannel(U));return x(F).listen(K,Q)}}}k(U,B,X,K){const Q=this;let F;const z=new u.$Md({onWillAddFirstListener:()=>{F=new c.$Qc;const o=new u.$Sd,g=new Map,M=Z=>{const ce=Z.channelClient.getChannel(U).listen(X,K),oe=o.add(ce);g.set(Z,oe)},C=Z=>{const H=g.get(Z);H&&(H.dispose(),g.delete(Z))};Q.connections.filter(B).forEach(M),u.Event.filter(Q.onDidAddConnection,B)(M,void 0,F),Q.onDidRemoveConnection(C,void 0,F),o.event(z.fire,z,F),F.add(o)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return z.event}registerChannel(U,B){this.a.set(U,B);for(const X of this.f)X.channelServer.registerChannel(U,B)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=N;class W{constructor(U,B,X=null){const K=new t;r(K,B),U.send(K.buffer),this.a=new E(U,X),this.d=new k(U,B,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,B){this.d.registerChannel(U,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=W;function x(T){return{call(U,B,X){return T.then(K=>K.call(U,B,X))},listen(U,B){const X=new u.$Vd;return T.then(K=>X.input=K.listen(U,B)),X.event}}}e.$th=x;function _(T){let U=!1;return{call(B,X,K){return U?T.call(B,X,K):(0,D.$Tg)(0).then(()=>U=!0).then(()=>T.call(B,X,K))},listen(B,X){if(U)return T.listen(B,X);const K=new u.$Vd;return(0,D.$Tg)(0).then(()=>U=!0).then(()=>K.input=T.listen(B,X)),K.event}}}e.$uh=_;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const B of U.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$vh=ue;var te;(function(T){function U(Q,F,z){const o=Q,g=z&&z.disableMarshalling,M=new Map;for(const C in o)X(C)&&M.set(C,u.Event.buffer(o[C],!0,void 0,F));return new class{listen(C,Z,H){const ce=M.get(Z);if(ce)return ce;if(K(Z)){const oe=o[Z];if(typeof oe=="function")return oe.call(o,H)}throw new v.$ab(`Event not found: ${Z}`)}call(C,Z,H){const ce=o[Z];if(typeof ce=="function"){if(!g&&Array.isArray(H))for(let me=0;me<H.length;me++)H[me]=(0,b.$kh)(H[me]);let oe=ce.apply(o,H);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new v.$ab(`Method not found: ${Z}`)}}}T.fromService=U;function B(Q,F){const z=F&&F.disableMarshalling;return new Proxy({},{get(o,g){if(typeof g=="string")return F?.properties?.has(g)?F.properties.get(g):K(g)?function(M){return Q.listen(g,M)}:X(g)?Q.listen(g):async function(...M){let C;F&&!(0,m.$Gf)(F.context)?C=[F.context,...M]:C=M;const Z=await Q.call(g,C);return z?Z:(0,b.$kh)(Z)};throw new v.$ab(`Property not found: ${String(g)}`)}})}T.toService=B;function X(Q){return Q[0]==="o"&&Q[1]==="n"&&O.$Ze(Q.charCodeAt(2))}function K(Q){return/^onDynamic/.test(Q)&&O.$Ze(Q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,U,B,X,K,Q,F){F=ie(F);const z=ae[K],o=z[X%z.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(Q)?(g=g.concat(F),g.push(")")):g.push(F),console.log.apply(console,g)}class G{constructor(U,B){this.d=U,this.f=B,this.a=0,this.b=0}logOutgoing(U,B,X,K,Q){this.b+=U,q(this.d,this.b,U,B,X,K,Q)}logIncoming(U,B,X,K,Q){this.a+=U,q(this.f,this.a,U,B,X,K,Q)}}e.$wh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class S extends d.$ph{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$ae.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Xp=S;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Md,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new D.$Pg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,P){return f.k(h,I,p,P)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(v.$5());this.b.cancel();const P=this.n(h),t=(0,D.$Gg)(n=>P.call(f,I,n)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,c.$Pc)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const P=new u.$Md({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(P.fire,P),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$2m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,m.$wl)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$Md;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,j.$Tp)(s)){(0,j.log)(s,`IPC Library: ${this.j.serverName}`);return}I.fire(R.$ae.wrap(Buffer.from(s,"base64")))});const P=this.j.useQueue?(0,O.$yl)(this.d):this.d,t=s=>this.d&&this.d.connected&&P.send(s.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new d.$qh(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,r)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),s!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Yp=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.StorageState=e.$Wo=e.StorageHint=void 0;var v;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function u(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Wo=u;var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class b extends R.$Rc{static{this.a=100}constructor(d,S=Object.create(null)){super(),this.r=d,this.s=S,this.b=this.B(new D.$Pd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Qg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((S,w)=>this.w(w,S)),d.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(d,S){if(this.c===c.Closed)return;let w=!1;(0,j.$Gf)(S)?w=this.f.delete(d):this.f.get(d)!==S&&(this.f.set(d,S),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,S){const w=this.f.get(d);return(0,j.$Gf)(w)?S:w}getBoolean(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:w==="true"}getNumber(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:parseInt(w,10)}getObject(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:(0,A.$jh)(w)}async set(d,S,w=!1){if(this.c===c.Closed)return;if((0,j.$Gf)(S))return this.delete(d,w);const $=(0,j.$zf)(S)||Array.isArray(S)?(0,A.$ih)(S):String(S);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,S=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$Xo=b;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((S,w)=>this.a.set(w,S)),d.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$Yo=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,D.localize)(3,null),v=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const O=this.d,m=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:b}),this.f.push(d)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,O=!1,m=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(v);return}const S=this.c.charCodeAt(b);if(O)O=!1;else if(S===47&&!m){b++;break}else S===91?m=!0:S===92?O=!0:S===93&&(m=!1);b++}for(;b<this.c.length&&u.a.has(this.c.charCodeAt(b));)b++;this.e=b;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(R.$bg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,v.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$am)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$ug)(u.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"argv.json")):(0,v.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$jc)(d):(0,A.$gc)((0,A.$ic)(R.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$jc)(d)):u.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$jc)(d);const S=j.env.VSCODE_EXTENSIONS;if(S)return S;const w=j.env.VSCODE_PORTABLE;return w?(0,A.$ic)(w,"extensions"):(0,v.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,A.$gc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$bm.test(d))}get extensionLogLevel(){const d=[];for(const S of this.args.log||[]){const w=e.$bm.exec(S);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,v.$ug)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"policy.json")):(0,v.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,S,w){this.a=d,this.b=S,this.c=w,this.editSessionId=this.args.editSessionId}}e.$cm=c,pe([D.$fh],c.prototype,"appRoot",null),pe([D.$fh],c.prototype,"userHome",null),pe([D.$fh],c.prototype,"userDataPath",null),pe([D.$fh],c.prototype,"appSettingsHome",null),pe([D.$fh],c.prototype,"tmpDir",null),pe([D.$fh],c.prototype,"cacheHome",null),pe([D.$fh],c.prototype,"stateResource",null),pe([D.$fh],c.prototype,"userRoamingDataHome",null),pe([D.$fh],c.prototype,"userDataSyncHome",null),pe([D.$fh],c.prototype,"sync",null),pe([D.$fh],c.prototype,"machineSettingsResource",null),pe([D.$fh],c.prototype,"workspaceStorageHome",null),pe([D.$fh],c.prototype,"localHistoryHome",null),pe([D.$fh],c.prototype,"keyboardLayoutResource",null),pe([D.$fh],c.prototype,"argvResource",null),pe([D.$fh],c.prototype,"isExtensionDevelopment",null),pe([D.$fh],c.prototype,"untitledWorkspacesHome",null),pe([D.$fh],c.prototype,"builtinExtensionsPath",null),pe([D.$fh],c.prototype,"extensionsPath",null),pe([D.$fh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$fh],c.prototype,"extensionDevelopmentKind",null),pe([D.$fh],c.prototype,"extensionTestsLocationURI",null),pe([D.$fh],c.prototype,"debugExtensionHost",null),pe([D.$fh],c.prototype,"logLevel",null),pe([D.$fh],c.prototype,"extensionLogLevel",null),pe([D.$fh],c.prototype,"serviceMachineIdResource",null),pe([D.$fh],c.prototype,"disableTelemetry",null),pe([D.$fh],c.prototype,"disableWorkspaceTrust",null),pe([D.$fh],c.prototype,"useInMemorySecretStorage",null),pe([D.$fh],c.prototype,"policyFile",null);function b(m,d){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.$dm=b;function O(m,d,S,w,$,h){const I=Number(d||m)||(w?null:S),p=I?!!d:!1;let P;if(h)try{P=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:P}}e.$em=O}),function(){"use strict";function J(e,L,D){function R(j,v){const u=A(j,v),c=[u];return e.isAbsolute(u)||c.unshift(D),e.resolve(...c)}function A(j,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const b=j["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=void 0;class A extends D.$cm{constructor(c,b){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,b.nameShort)},b)}}e.$fm=A;function j(u,c){return(0,D.$em)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$gm=j;function v(u,c){return(0,D.$em)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$hm=v}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function R(j,v,u,c){try{A(j,v,u,c)}catch(b){j.error(b?.message??b)}return v}e.$tp=R;function A(j,v,u,c){const b=(O,m,d)=>{const S=O[m];if((0,L.$xf)(S)){const w=S,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],P=typeof p=="string"?p:p?.message;if(!I){P||j.warn(`[${v.name}]: ${(0,D.localize)(0,null,h)}`);return}if(d&&(m==="title"||m==="category")&&P&&P!==I){const t={value:I,original:P};O[m]=t}else O[m]=I}}else if((0,L.$zf)(S))for(const w in S)S.hasOwnProperty(w)&&(w==="commands"?b(S,w,!0):b(S,w,d));else if(Array.isArray(S))for(let w=0;w<S.length;w++)b(S,w,d)};for(const O in v)v.hasOwnProperty(O)&&b(v,O)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$Ho=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Io=c;function b(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let P=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(P=!1),a=!1);let i=0;if(h.preRelease){const n=v.exec(h.preRelease);if(n){const[,s,r,l]=n;i=Date.UTC(Number(s),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:P,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Jo=b;function O(h,f,I){let p;typeof h=="string"?p=b(c(h)):p=h;let P;f instanceof Date?P=f.getTime():typeof f=="string"&&(P=new Date(f).getTime());let t;if(typeof I=="string"?t=b(c(I)):t=I,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,n=p.patchBase;let s=t.majorBase,r=t.minorBase,l=t.patchBase;const k=t.notBefore;let y=t.majorMustEqual,E=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:i>r?!0:i<r||P&&P<k?!1:n>=l:(a===1&&s===0&&(!y||!E||!N)&&(s=1,r=0,l=0,y=!0,E=!1,N=!1),a<s?!1:a>s?!y:i<r?!1:i>r?!E:n<l?!1:n>l?!N:!(P&&P<k))}e.$Ko=O;function m(h,f,I,p,P){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([D.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,R.localize(9,null,"main")]),t;{const n=(0,L.$ug)(I,p.main);(0,L.$og)(n,I)||t.push([D.default.Warning,R.localize(10,null,n.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,R.localize(11,null,"browser")]),t;{const n=(0,L.$ug)(I,p.browser);(0,L.$og)(n,I)||t.push([D.default.Warning,R.localize(12,null,n.path,I.path)])}}if(!A.valid(p.version))return t.push([D.default.Error,R.localize(13,null)]),t;const a=[];if(!d(h,f,p,P,a))for(const n of a)t.push([D.default.Error,n]);return t}e.$Lo=m;function d(h,f,I,p,P){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:w(h,f,I.engines.vscode,P)}e.$Mo=d;function S(h,f,I){return h==="*"||w(f,I,h)}e.$No=S;function w(h,f,I,p=[]){const P=b(c(I));if(!P)return p.push(R.localize(14,null,I)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return p.push(R.localize(15,null,I)),!1}else if(!P.majorMustEqual)return p.push(R.localize(16,null,I)),!1;return O(h,f,P)?!0:(p.push(R.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0;async function R(A,j,v){let u=v&&v.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await j.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$cg)(b)?b:null}catch{u=null}if(!u){u=(0,D.$dg)();try{await j.writeFile(A.serviceMachineIdResource,L.$ae.fromString(u))}catch{}}return v?.store("storage.serviceMachineId",u,-1,1),u}e.$8o=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class L{constructor(R,A=[],j=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Kh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const D=[];var R;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(v,u,c){u instanceof L.$Kh||(u=new L.$Kh(u,[],!!c)),D.push([v,u])}e.$sr=A;function j(){return D}e.$tr=j}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$0p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const v=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(j);v.outgoing.set(u.key,u),u.incoming.set(v.key,v)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const v of this.a.values())v.outgoing.delete(j),v.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let v=this.a.get(j);return v||(v=new L(j,A),this.a.set(j,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,v]of this.a)A.push(`${j}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const v=new Set([A]),u=this.c(j,v);if(u)return u}}c(A,j){for(const[v,u]of A.outgoing){if(j.has(v))return[...j,v].join(" -> ");j.add(v);const c=this.c(u,j);if(c)return c;j.delete(v)}}}e.$$p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,R.$Nh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$ii=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$ji=j;var v;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$li=c;function b(h,f){const I=Object.create(null);for(const p in h)O(I,p,h[p],f);return I}e.$mi=b;function O(h,f,I,p){const P=f.split("."),t=P.pop();let a=h;for(let i=0;i<P.length;i++){const n=P[i];let s=a[n];switch(typeof s){case"undefined":s=a[n]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${P.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=I}catch{p(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(a)}`)}e.$ni=O;function m(h,f){const I=f.split(".");d(h,I)}e.$oi=m;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function S(h,f,I){function p(a,i){let n=a;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const P=f.split("."),t=p(h,P);return typeof t>"u"?I:t}e.$pi=S;function w(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$zf(h[p])&&L.$zf(f[p])?w(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$qi=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$ri=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(z,o){if(u.get(z)!==void 0)throw(0,v.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Ji=c;const b=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),S=(0,j.localize)(1,null),w=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),I=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class P{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=m){this.k=o,this.d=new R.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const M=this.D(),C=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:R.$Ii.getLexeme(M),additionalInfo:C}),P.c}return g}catch(g){if(g!==P.c)throw g;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const g=this.o();o.push(g)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const g=this.s();o.push(g)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,$),g?.negate()}case 17:return this.z(),W.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const g=this.l();return this.A(1,$),g}case 17:{const g=o.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Z=C.lexeme,H=Z.lastIndexOf("/"),ce=H===Z.length-1?void 0:this.w(Z.substring(H+1));let oe;try{oe=new RegExp(Z.substring(1,H),ce)}catch{throw this.B("REGEX",C)}return le.create(g,oe)}switch(C.type){case 10:case 19:{const Z=[C.lexeme];this.z();let H=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Z.push(R.$Ii.getLexeme(H)),this.z(),H=this.D()}const oe=Z.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this.w(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this.B("REGEX",C)}return t.regex(g,ge)}case 18:{const Z=C.lexeme;this.z();let H=null;if(!(0,D.$Ae)(Z)){const ce=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(ce!==oe&&ce>=0){const me=Z.slice(ce+1,oe),de=Z[oe+1]==="i"?"i":"";try{H=new RegExp(me,de)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(g,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const C=this.u();return t.notIn(g,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(g,C);switch(C){case"true":return t.has(g);case"false":return t.not(g);default:return t.equals(g,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(g,C);switch(C){case"true":return t.not(g);case"false":return t.has(g);default:return t.notEquals(g,C)}}case 5:return this.z(),te.create(g,this.u());case 6:return this.z(),ae.create(g,this.u());case 7:return this.z(),_.create(g,this.u());case 8:return this.z(),ue.create(g,this.u());case 13:return this.z(),t.in(g,this.u());default:return t.has(g)}}case 20:throw this.h.push({message:I,offset:o.offset,lexeme:"",additionalInfo:p}),P.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,g){if(this.C(o))return this.z();throw this.B(g,this.D())}B(o,g,M){const C=(0,j.localize)(8,null,o,R.$Ii.getLexeme(g)),Z=g.offset,H=R.$Ii.getLexeme(g);return this.h.push({message:C,offset:Z,lexeme:H,additionalInfo:M}),P.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=P;class t{static false(){return s.INSTANCE}static true(){return r.INSTANCE}static has(o){return l.create(o)}static equals(o,g){return k.create(o,g)}static notEquals(o,g){return N.create(o,g)}static regex(o,g){return le.create(o,g)}static in(o,g){return y.create(o,g)}static notIn(o,g){return E.create(o,g)}static not(o){return W.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,g){return _.create(o,g)}static greaterEquals(o,g){return ue.create(o,g)}static smaller(o,g){return te.create(o,g)}static smallerEquals(o,g){return ae.create(o,g)}static{this.c=new P({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Li=t;function a(z){const o=new P({regexParsingWithErrorRecovery:!1});return z.map(g=>(o.parse(g),o.lexingErrors.length>0?o.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,j.localize)(9,null,M.additionalInfo):(0,j.localize)(10,null),offset:M.offset,length:M.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Mi=a;function i(z,o){const g=z?z.substituteConstants():void 0,M=o?o.substituteConstants():void 0;return!g&&!M?!0:!g||!M?!1:g.equals(M)}e.$Ni=i;function n(z,o){return z.cmp(o)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Oi=s;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return s.INSTANCE}}e.$Pi=r;class l{static create(o,g=null){const M=u.get(o);return typeof M=="boolean"?M?r.INSTANCE:s.INSTANCE:new l(o,g)}constructor(o,g){this.key=o,this.c=g,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:B(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:s.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Qi=l;class k{static create(o,g,M=null){if(typeof g=="boolean")return g?l.create(o,M):W.create(o,M);const C=u.get(o);return typeof C=="boolean"?g===(C?"true":"false")?r.INSTANCE:s.INSTANCE:new k(o,g,M)}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const g=o?"true":"false";return this.d===g?r.INSTANCE:s.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ri=k;class y{static create(o,g){return new y(o,g)}constructor(o,g){this.d=o,this.f=g,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const g=o.getValue(this.f),M=o.getValue(this.d);return Array.isArray(g)?g.includes(M):typeof M=="string"&&typeof g=="object"&&g!==null?b.call(g,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Si=y;class E{static create(o,g){return new E(o,g)}constructor(o,g){this.d=o,this.f=g,this.type=11,this.c=y.create(o,g)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=E;class N{static create(o,g,M=null){if(typeof g=="boolean")return g?W.create(o,M):l.create(o,M);const C=u.get(o);return typeof C=="boolean"?g===(C?"true":"false")?s.INSTANCE:r.INSTANCE:new N(o,g,M)}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const g=o?"true":"false";return this.d===g?s.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ui=N;class W{static create(o,g=null){const M=u.get(o);return typeof M=="boolean"?M?s.INSTANCE:r.INSTANCE:new W(o,g)}constructor(o,g){this.c=o,this.d=g,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:B(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?s.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Vi=W;function x(z,o){if(typeof z=="string"){const g=parseFloat(z);isNaN(g)||(z=g)}return typeof z=="string"||typeof z=="number"?o(z):s.INSTANCE}class _{static create(o,g,M=null){return x(g,C=>new _(o,C,M))}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Wi=_;class ue{static create(o,g,M=null){return x(g,C=>new ue(o,C,M))}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Xi=ue;class te{static create(o,g,M=null){return x(g,C=>new te(o,C,M))}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Yi=te;class ae{static create(o,g,M=null){return x(g,C=>new ae(o,C,M))}constructor(o,g,M){this.c=o,this.d=g,this.f=M,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Zi=ae;class le{static create(o,g){return new le(o,g)}constructor(o,g){this.d=o,this.f=g,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const g=this.f?this.f.source:"",M=o.f?o.f.source:"";return g<M?-1:g>M?1:0}equals(o){if(o.type===this.type){const g=this.f?this.f.source:"",M=o.f?o.f.source:"";return this.d===o.d&&g===M}return!1}substituteConstants(){return this}evaluate(o){const g=o.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$1i=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$2i=ie;function q(z){let o=null;for(let g=0,M=z.length;g<M;g++){const C=z[g].substituteConstants();if(z[g]!==C&&o===null){o=[];for(let Z=0;Z<g;Z++)o[Z]=z[Z]}o!==null&&(o[g]=C)}return o===null?z:o}class G{static create(o,g,M){return G.d(o,g,M)}constructor(o,g){this.expr=o,this.c=g,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let g=0,M=this.expr.length;g<M;g++){const C=n(this.expr[g],o.expr[g]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].equals(o.expr[g]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].evaluate(o))return!1;return!0}static d(o,g,M){const C=[];let Z=!1;for(const H of o)if(H){if(H.type===1){Z=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&Z)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,me=T.create(H.expr.map(de=>G.create([de,ce],null,M)),null,oe);me&&(C.push(me),C.sort(n))}if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return s.INSTANCE;if(C.length===1)return C[0]}return new G(C,g)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const g of this.expr)o.push(...g.keys());return o}map(o){return new G(this.expr.map(g=>g.map(o)),null)}negate(){if(!this.c){const o=[];for(const g of this.expr)o.push(g.negate());this.c=T.create(o,this,!0)}return this.c}}e.$3i=G;class T{static create(o,g,M){return T.d(o,g,M)}constructor(o,g){this.expr=o,this.c=g,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let g=0,M=this.expr.length;g<M;g++){const C=n(this.expr[g],o.expr[g]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].equals(o.expr[g]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let g=0,M=this.expr.length;g<M;g++)if(this.expr[g].evaluate(o))return!0;return!1}static d(o,g,M){let C=[],Z=!1;if(o){for(let H=0,ce=o.length;H<ce;H++){const oe=o[H];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Z)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,g)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const g of this.expr)o.push(...g.keys());return o}map(o){return new T(this.expr.map(g=>g.map(o)),null)}negate(){if(!this.c){const o=[];for(const g of this.expr)o.push(g.negate());for(;o.length>1;){const g=o.shift(),M=o.shift(),C=[];for(const Z of F(g))for(const H of F(M))C.push(G.create([Z,H],null,!1));o.unshift(T.create(C,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$4i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(o,g,M){super(o,null),this.f=g,typeof M=="object"?U.d.push({...M,key:o}):M!==!0&&U.d.push({key:o,description:M,type:g!=null?typeof g:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return k.create(this.key,o)}notEqualsTo(o){return N.create(this.key,o)}}e.$5i=U,e.$6i=(0,A.$Nh)("contextKeyService");function B(z,o){return z<o?-1:z>o?1:0}function X(z,o,g,M){return z<g?-1:z>g?1:o<M?-1:o>M?1:0}function K(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?Q(z.expr,o.expr):!1;if(o.type===9){for(const g of o.expr)if(K(z,g))return!0;return!1}if(z.type===6){if(o.type===6)return Q(o.expr,z.expr);for(const g of z.expr)if(K(g,o))return!0;return!1}return z.equals(o)}e.$7i=K;function Q(z,o){let g=0,M=0;for(;g<z.length&&M<o.length;){const C=z[g].cmp(o[M]);if(C<0)return!1;C===0&&g++,M++}return g===z.length}function F(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Jn=(0,L.$Nh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,L.$Nh)("environmentService"),e.$Vh=(0,L.$Oh)(e.$Uh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=A;function j(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=j;function v(f,I){return I==="web"&&!f.includes("web")}e.$2n=v;function u(f,I,p){return v(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$3n=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$5n=b;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var S;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$6n=(0,D.$Nh)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$7n=h,e.$8n=(0,D.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,D.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,D.$Nh)("IExtensionTipsService"),e.$ao=(0,L.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=void 0,e.$ap=(0,L.$Nh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async v=>A(v),j))),this.a}async verify(A,j,v){let u;try{u=await this.b()}catch{return!1}return u.verify(A,j,v)}}e.$bp=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;async function j(b,O,m,d,S,w){let $;try{await v(b,O,m,d,S,w)}catch(h){$=h}finally{$&&S.errorTransformer&&($=S.errorTransformer($)),typeof $<"u"&&m.error($),m.end()}}e.$Ip=j;async function v(b,O,m,d,S,w){u(w);const $=await b.open(O,{create:!1});try{u(w);let h=0,f=0,I=S&&typeof S.length=="number"?S.length:void 0,p=L.$ae.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),P=S&&typeof S.position=="number"?S.position:0,t=0;do f=await b.read($,P,p.buffer,t,p.byteLength-t),P+=f,t+=f,h+=f,typeof I=="number"&&(I-=f),t===p.byteLength&&(await m.write(d(p)),p=L.$ae.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),t=0);while(f>0&&(typeof I!="number"||I>0)&&u(w)&&c(h,S));if(t>0){let a=t;typeof I=="number"&&(a=Math.min(t,I)),m.write(d(p.slice(0,a)))}}catch(h){throw(0,A.$jk)(h)}finally{await b.close($)}}function u(b){if(b.isCancellationRequested)throw(0,D.$5)();return!0}function c(b,O){if(typeof O?.limits?.size=="number"&&b>O.limits.size)throw(0,A.$ik)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class v extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Md),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.j(c),O=b.filter(d=>{const S=this.c.get(d.path);return S?!(0,D.$yj)(S.request.excludes,d.excludes)||!(0,D.$yj)(S.request.includes,d.includes):!0}),m=Array.from(this.c.values()).filter(({request:d})=>!b.find(S=>S.path===d.path&&(0,D.$yj)(S.excludes,d.excludes)&&(0,D.$yj)(S.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.m(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.h(d);for(const d of O)this.g(d)}g(c){const b=new j.$5p(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:c,instance:b};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}j(c){const b=new Map;for(const O of c){const m=A.$l?O.path:O.path.toLowerCase();b.set(m,O)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$7p=v}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class R extends L.$Mp{constructor(j,v,u){super(j,v,u),this.s()}r(j){return j.add(new D.$7p)}}e.$8p=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class j extends A.$Np{constructor(u,c,b){super(u,c,b),this.s()}r(u){const c=u.add(new R.$Yp(L.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:b,signal:O})=>this.t(`terminated by itself with code ${b}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$uh)(c.getChannel("watcher")))}}e.$Zp=j}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,j]of R)this.set(A,j)}set(R,A){const j=this.a.get(R);return this.a.set(R,A),j}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Lh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const b=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class m{constructor($=new u.$Lh,h=!1,f,I=b){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(v.$Mh,this),this._globalGraph=I?f?._globalGraph??new j.$$p(p=>p):void 0}createChild($){return new m($,this.g,this,this.i)}invokeFunction($,...h){const f=S.traceInvocation(this.i,$);let I=!1;try{return $({get:P=>{if(I)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(P,f);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof A.$Kh?(f=S.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=S.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=v._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of I){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const P=I.length>0?I[0].index:h.length;if(h.length!==P){console.trace(`[createInstance] First service dependency of ${$.name} at position ${P+1} conflicts with ${h.length} static arguments`);const t=P-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,P)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$Kh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$Kh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new j.$$p(t=>t.id.toString());let p=0;const P=[{id:$,desc:h,_trace:f}];for(;P.length;){const t=P.pop();if(I.lookupOrInsertNode(t),p++>1e3)throw new O(I);for(const a of v._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$Kh){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};I.insertEdge(t,n),P.push(n)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$Kh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}I.removeNode(a)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof A.$Kh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const P=new m(void 0,this.g,this,this.i);P.c=String($);const t=new Map,a=new L.$0g(()=>{const i=P.j(h,f,p);for(const[n,s]of t){const r=i[n];if(typeof r=="function")for(const l of s)r.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=t.get(n);return l||(l=new c.$1c,t.set(n,l)),(y,E,N)=>{const W=l.push([y,E,N]);return(0,R.$Pc)(W)}}if(n in i)return i[n];const s=a.value;let r=s[n];return typeof r!="function"||(r=r.bind(s),i[n]=r),r},set(i,n,s){return a.value[n]=s,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$_p=m;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new S(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation($,h){return $?new S(1,h.name):S.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new S(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;S.f+=$;let h=!1;function f(p,P){const t=[],a=new Array(p+1).join("	");for(const[i,n,s]of P.h)if(n&&s){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,s);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];($>2||h)&&S.all.add(I.join(`
`))}}e.$aq=S});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=void 0;function u(b){return b.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Nq=u,e.$Oq=(0,v.$Nh)("languagePackService");let c=class extends D.$Rc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$Wd;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const S=m.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return S.push(this.f("en","English")),S}f(O,m,d){const S=m??O;let w;if(S!==O&&(w=`(${O})`),O.toLowerCase()===R.$w.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),d?.installCount){w??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:O,label:S,description:w}}};e.$Pq=c,e.$Pq=c=pe([se(0,j.$6n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,R,A,j,v,u,c,b,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,m.$Nh)("logService"),e.$9i=(0,m.$Nh)("loggerService");function d(){return new Date().toISOString()}function S(y){return(0,c.$Bf)(y)}e.$0i=S;var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$$i=w.Info;function $(y,E,N){switch(E){case w.Trace:y.trace(N);break;case w.Debug:y.debug(N);break;case w.Info:y.info(N);break;case w.Warning:y.warn(N);break;case w.Error:y.error(N);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function h(y,E=!1){let N="";for(let W=0;W<y.length;W++){let x=y[W];if(x instanceof Error&&(x=(0,L.$yi)(x,E)),typeof x=="object")try{x=JSON.stringify(x)}catch{}N+=(W>0?" ":"")+x}return N}class f extends A.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new D.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$aj=f;class I extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...N){this.f(w.Trace)&&this.g(w.Trace,h([E,...N],!0))}debug(E,...N){this.f(w.Debug)&&this.g(w.Debug,h([E,...N]))}info(E,...N){this.f(w.Info)&&this.g(w.Info,h([E,...N]))}warn(E,...N){this.f(w.Warning)&&this.g(w.Warning,h([E,...N]))}error(E,...N){if(this.f(w.Error))if(E instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=E.stack,this.g(w.Error,h(W))}else this.g(w.Error,h([E,...N]))}flush(){}}e.$bj=I;class p extends f{constructor(E=e.$$i){super(),this.setLevel(E),this.g=!v.$j}trace(E,...N){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}debug(E,...N){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}info(E,...N){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}warn(E,...N){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...N):console.warn(`[main ${d()}]`,E,...N))}error(E,...N){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...N):console.error(`[main ${d()}]`,E,...N))}dispose(){}flush(){}}e.$cj=p;class P extends f{constructor(E=e.$$i,N=!0){super(),this.g=N,this.setLevel(E)}trace(E,...N){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...N):console.log(E,...N))}debug(E,...N){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...N):console.log(E,...N))}info(E,...N){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...N):console.log(E,...N))}warn(E,...N){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...N):console.log(E,...N))}error(E,...N){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...N):console.error(E,...N))}dispose(){}flush(){}}e.$dj=P;class t extends f{constructor(E,N=e.$$i){super(),this.g=E,this.setLevel(N)}trace(E,...N){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...N])}debug(E,...N){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...N])}info(E,...N){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...N])}warn(E,...N){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...N])}error(E,...N){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...N])}h(E){return typeof E=="string"?E:(0,L.$yi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$ej=t;class a extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const N of this.g)N.setLevel(E);super.setLevel(E)}trace(E,...N){for(const W of this.g)W.trace(E,...N)}debug(E,...N){for(const W of this.g)W.debug(E,...N)}info(E,...N){for(const W of this.g)W.info(E,...N)}warn(E,...N){for(const W of this.g)W.warn(E,...N)}error(E,...N){for(const W of this.g)W.error(E,...N)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$fj=a;class i extends A.$Rc{constructor(E,N,W){if(super(),this.h=E,this.j=N,this.b=new j.$zc,this.c=this.B(new D.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeVisibility=this.g.event,W)for(const x of W)this.b.set(x.resource,{logger:void 0,info:x})}m(E){return(0,c.$xf)(E)?[...this.b.values()].find(N=>N.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,N){const W=this.n(E),x=(0,c.$xf)(E)?E:N?.id??(0,R.$Bi)(W.toString()).toString(16);let _=this.b.get(W)?.logger;const ue=N?.logLevel==="always"?w.Trace:N?.logLevel;_||(_=this.s(W,ue??this.getLogLevel(W)??this.h,{...N,id:x}));const te={logger:_,info:{resource:W,id:x,logLevel:ue,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(te.info),this.b.set(W,te),_}n(E){return(0,c.$xf)(E)?(0,u.$ug)(this.j,`${E}.log`):E}setLogLevel(E,N){if(b.URI.isUri(E)){const W=E,x=N,_=this.b.get(W);_&&x!==_.info.logLevel&&(_.info.logLevel=x===this.h?void 0:x,_.logger?.setLevel(x),this.b.set(_.info.resource,_),this.f.fire([W,x]))}else{this.h=E;for(const[W,x]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,N){const W=this.m(E);W&&N!==!W.info.hidden&&(W.info.hidden=!N,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,N]))}getLogLevel(E){let N;return E&&(N=this.b.get(E)?.info.logLevel),N??this.h}registerLogger(E){const N=this.b.get(E.resource);N?N.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const N=this.b.get(E);N&&(N.logger&&N.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=i;class n{constructor(){this.onDidChangeLogLevel=new D.$Md().event}setLevel(E){}getLevel(){return w.Info}trace(E,...N){}debug(E,...N){}info(E,...N){}warn(E,...N){}error(E,...N){}critical(E,...N){}dispose(){}flush(){}}e.$hj=n;class s extends n{}e.$ij=s;function r(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const E=k(y.logLevel.toLowerCase());if(E!==void 0)return E}return e.$$i}e.$jj=r;function l(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$kj=l;function k(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$lj=k,e.$mj=new O.$5i("logLevel",l(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class b extends j.$Rc{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new A.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Qg(0)),this.w=[],this.y=this.B(new D.$Qg(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(m,d):this.z(m,d)}n(m,d){const S={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,L.$Tb)(this.j,S);return this.r(),(0,j.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,R.$Z)(m))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Op)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,u.$Kp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,u.$Kp)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,d){const S={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,L.$Tb)(this.w,S);return this.C(),(0,j.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,R.$Z)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,u.$Op)(m)),m=>this.G(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,v.$gc)(m.fsPath)}}e.$Sp=b}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let p=class extends c.$Rc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new j.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Md),this.onDidFilesChange=this.X.event,this.Y=this.B(new j.$Md),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$2g)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new c.$Qc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.X.fire(new $.$ok(n,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.Y.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$Mc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.$yg)(t))throw new $.$qk((0,w.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$ab;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$bk)(a)||(0,$.$$j)(a)||(0,$.$ck)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$bk)(a)||(0,$.$$j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$lk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$qk((0,w.localize)(2,null,this.qb(t)),1):(0,$.$jk)(i)}}async s(t,a){const i=await this.j(t),n=this.S(i),s=a?.resolveTo,r=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,k=await i.stat(t);let y;return this.t(i,t,k,void 0,!!l,(E,N)=>(y||(y=b.$Th.forUris(()=>!n),y.set(t,!0),s&&y.fill(!0,s)),y.get(E.resource)||y.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?N===1:!1))}async t(t,a,i,n,s,r){const{providerExtUri:l}=this.R(t),k={resource:a,name:l.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Bk)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&r(k,n)){try{const y=await t.readdir(a),E=await D.Promises.settled(y.map(async([N,W])=>{try{const x=l.joinPath(a,N),_=s?await t.stat(x):{type:W};return await this.t(t,x,_,y.length,s,r)}catch(x){return this.b.trace(x),null}}));k.children=(0,L.$Gb)(E)}catch(y){this.b.trace(y),k.children=[]}return k}return k}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$qk((0,w.localize)(3,null,this.qb(t)),3,a)}async createFile(t,a=R.$ae.fromString(""),i){await this.u(t,i);const n=await this.writeFile(t,a);return this.r.fire(new $.$nk(t,0,n)),n}async writeFile(t,a,i){const n=this.ob(await this.n(t),t),{providerExtUri:s}=this.R(n);let r=i;if((0,$.$ek)(n)&&!r?.atomic){const l=n.enforceAtomicWriteFile?.(t);l&&(r={...i,atomic:l})}try{await this.w(n,t,r)||await this.U(n,s.dirname(t));let k;if((0,$.$$j)(n)&&!(a instanceof R.$ae))if((0,S.$Yd)(a)){const y=await(0,S.$6d)(a,3);y.ended?k=R.$ae.concat(y.buffer):k=y}else k=(0,S.$3d)(a,y=>R.$ae.concat(y),3);else k=a;!(0,$.$bk)(n)||(0,$.$$j)(n)&&k instanceof R.$ae||(0,$.$$j)(n)&&(0,$.$ek)(n)&&r?.atomic?await this.fb(n,t,r,k):await this.bb(n,t,r,k instanceof R.$ae?(0,R.$le)(k):k),this.r.fire(new $.$nk(t,4))}catch(l){throw new $.$qk((0,w.localize)(4,null,this.qb(t),(0,$.$jk)(l).toString()),(0,$.$mk)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.qb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.qb(a)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.qb(a)));if(n)throw new Error((0,w.localize)(8,null,this.qb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$qk((0,w.localize)(9,null,this.qb(a)),0,i);if(this.pb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Ak&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$Bk)({mtime:i.mtime,size:r.size}))throw new $.$qk((0,w.localize)(10,null),3,i);return r}async readFile(t,a,i){const n=await this.m(t);return a?.atomic?this.z(n,t,a,i):this.C(n,t,a,i)}async z(t,a,i,n){return new Promise((s,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const l=await this.C(t,a,i,n);s(l)}catch(l){r(l)}})})}async C(t,a,i,n){const s=await this.D(t,a,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,R.$me)(s.value)}}async readFileStream(t,a,i){const n=await this.m(t);return this.D(n,t,a,i)}async D(t,a,i,n){const s=new A.$Wd(n);let r=i;(0,$.$dk)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...i,atomic:!0});const l=this.J(a,r).then(y=>y,y=>{throw s.dispose(!0),y});let k;try{return typeof r?.etag=="string"&&r.etag!==$.$Ak&&await l,r?.atomic&&(0,$.$dk)(t)||!((0,$.$bk)(t)||(0,$.$ck)(t))||(0,$.$$j)(t)&&r?.preferUnbuffered?k=this.I(t,a,r):(0,$.$ck)(t)?k=this.G(t,a,s.token,r):k=this.H(t,a,s.token,r),k.on("end",()=>s.dispose()),k.on("error",()=>s.dispose()),{...await l,value:k}}catch(y){throw k&&await(0,S.$4d)(k),this.F(y,a,r)}}F(t,a,i){const n=(0,w.localize)(11,null,this.qb(a),(0,$.$jk)(t).toString());return t instanceof $.$sk?new $.$sk(n,t.stat,i):t instanceof $.$rk?new $.$rk(n,t.fileOperationResult,t.size,t.options):new $.$qk(n,(0,$.$mk)(t),i)}G(t,a,i,n=Object.create(null)){const s=t.readFileStream(a,n,i);return(0,S.$0d)(s,{data:r=>r instanceof R.$ae?r:R.$ae.wrap(r),error:r=>this.F(r,a,n)},r=>R.$ae.concat(r))}H(t,a,i,n=Object.create(null)){const s=(0,R.$qe)();return(0,h.$Ip)(t,a,s,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,a,n)},i),s}I(t,a,i){const n=(0,S.$1d)(s=>R.$ae.concat(s));return(async()=>{try{let s;i?.atomic&&(0,$.$dk)(t)?s=await t.readFile(a,{atomic:!0}):s=await t.readFile(a),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.L(a,s.byteLength,i),n.end(R.$ae.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$qk((0,w.localize)(12,null,this.qb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$Ak&&a.etag===i.etag)throw new $.$sk((0,w.localize)(13,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$rk((0,w.localize)(14,null,this.qb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,n){if(t.toString()!==a.toString())try{const s=i==="move"?this.ob(await this.n(t),t):await this.m(t),r=this.ob(await this.n(a),a);await this.Q(s,t,r,a,i,n)}catch(s){return s}return!0}async move(t,a,i){const n=this.ob(await this.n(t),t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,r==="move"?2:3,l)),l}async copy(t,a,i){const n=await this.m(t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,r==="copy"?3:2,l)),l}async N(t,a,i,n,s,r){if(a.toString()===n.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:k}=await this.Q(t,a,i,n,s,r);if(l&&!k&&r&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),s==="copy"){if(t===i&&(0,$.$_j)(t))await t.copy(a,n,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.P(t,y,i,n):await this.O(t,a,i,n)}return s}else return t===i?(await t.rename(a,n,{overwrite:r}),s):(await this.N(t,a,i,n,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,n){if((0,$.$bk)(t)&&(0,$.$bk)(i))return this.hb(t,a,i,n);if((0,$.$bk)(t)&&(0,$.$$j)(i))return this.nb(t,a,i,n);if((0,$.$$j)(t)&&(0,$.$bk)(i))return this.lb(t,a,i,n);if((0,$.$$j)(t)&&(0,$.$$j)(i))return this.jb(t,a,i,n)}async P(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async s=>{const r=this.R(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.P(t,await this.resolve(s.resource),i,r):this.O(t,s.resource,i,r)}))}async Q(t,a,i,n,s,r){let l=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:E}=this.R(t);if(E||(l=y.isEqual(a,n)),l&&s==="copy")throw new Error((0,w.localize)(15,null,this.qb(a),this.qb(n)));if(!l&&y.isEqualOrParent(n,a))throw new Error((0,w.localize)(16,null,this.qb(a),this.qb(n)))}const k=await this.exists(n);if(k&&!l){if(!r)throw new $.$qk((0,w.localize)(17,null,this.qb(a),this.qb(n)),4);if(t===i){const{providerExtUri:y}=this.R(t);if(y.isEqualOrParent(a,n))throw new Error((0,w.localize)(18,null,this.qb(a),this.qb(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:l}}R(t){const a=this.S(t);return{providerExtUri:a?d.$kg:d.$mg,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.ob(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.qb(a)));break}catch(s){if((0,$.$lk)(s)!==$.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(a)),a=n.dirname(a)}for(let s=i.length-1;s>=0;s--){a=n.joinPath(a,i[s]);try{await t.mkdir(a)}catch(r){if((0,$.$lk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.ob(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.qb(t)));const s=a?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.qb(t)));if(n&&s)throw new Error((0,w.localize)(22,null,this.qb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.pb(t,r);else throw new $.$qk((0,w.localize)(23,null,this.qb(t)),1);if(!!!a?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,w.localize)(24,null,this.qb(t)))}return i}async del(t,a){const i=await this.W(t,a);let n=a;if((0,$.$fk)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(t);k&&(n={...a,atomic:k})}const s=!!n?.useTrash,r=!!n?.recursive,l=n?.atomic??!1;await i.delete(t,{recursive:r,useTrash:s,atomic:l}),this.r.fire(new $.$nk(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.ob(await this.n(a),a);if(i===n&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,$.$ak)(i))return i.cloneFile(t,a);await this.U(n,this.R(n).providerExtUri.dirname(a));const s=this.ab.queueFor(t,this.R(i).providerExtUri);return i===n&&(0,$.$_j)(i)?s.queue(()=>i.copy(t,a,{overwrite:!0})):s.queue(()=>this.O(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,s=()=>{n=!0};return i.add((0,c.$Pc)(()=>s())),(async()=>{try{const r=await this.$(t,a);n?(0,c.$Mc)(r):s=()=>(0,c.$Mc)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),n=(0,v.$Bi)([this.R(i).providerExtUri.getComparisonKey(t),a]);let s=this.Z.get(n);return s||(s={count:0,disposable:i.watch(t,a)},this.Z.set(n,s)),s.count+=1,(0,c.$Pc)(()=>{s&&(s.count--,s.count===0&&((0,c.$Mc)(s.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$Mc)(t.disposable);this.Z.clear()}async bb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const s=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.$Yd)(n)||(0,S.$Zd)(n)?await this.cb(t,s,n):await this.db(t,s,n)}catch(r){throw(0,$.$jk)(r)}finally{await t.close(s)}})}async cb(t,a,i){let n=0,s;if((0,S.$Zd)(i)){if(i.buffer.length>0){const r=R.$ae.concat(i.buffer);await this.eb(t,a,r,r.byteLength,n,0),n+=r.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((r,l)=>{(0,S.$5d)(s,{onData:async k=>{s.pause();try{await this.eb(t,a,k,k.byteLength,n,0)}catch(y){return l(y)}n+=k.byteLength,setTimeout(()=>s.resume())},onError:k=>l(k),onEnd:()=>r()})})}async db(t,a,i){let n=0,s;for(;(s=i.read())!==null;)await this.eb(t,a,s,s.byteLength,n,0),n+=s.byteLength}async eb(t,a,i,n,s,r){let l=0;for(;l<n;){const k=await t.write(a,s+l,i.buffer,r+l,n-l);l+=k}}async fb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.gb(t,a,i,n))}async gb(t,a,i,n){let s;n instanceof R.$ae?s=n:(0,S.$Yd)(n)?s=await(0,R.$me)(n):(0,S.$Zd)(n)?s=await(0,R.$ne)(n):s=(0,R.$ke)(n),await t.writeFile(a,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async hb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ib(t,a,i,n))}async ib(t,a,i,n){let s,r;try{s=await t.open(a,{create:!1}),r=await i.open(n,{create:!0,unlock:!1});const l=R.$ae.alloc(this.a);let k=0,y=0,E=0;do E=await t.read(s,k,l.buffer,y,l.byteLength-y),await this.eb(i,r,l,E,k,y),k+=E,y+=E,y===l.byteLength&&(y=0);while(E>0)}catch(l){throw(0,$.$jk)(l)}finally{await D.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async jb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(t,a,i,n))}async kb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(t,a,i,n))}async mb(t,a,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.eb(i,s,R.$ae.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$jk)(r)}finally{await i.close(s)}}async nb(t,a,i,n){const s=await(0,R.$me)(this.H(t,a,A.CancellationToken.None));await this.fb(i,n,void 0,s)}ob(t,a){if(t.capabilities&2048)throw new $.$qk((0,w.localize)(25,null,this.qb(a)),6);return t}pb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$qk((0,w.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$Jp=p,e.$Jp=p=pe([se(0,f.$8i)],p)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,I.$yi)(a)}`)}})();class t extends f.$Sp{static{this.I=!1}constructor(i,n){super(i,n),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$zc(s=>m.$lg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,O.$l&&(this.J|=1024)),this.J}async stat(i){try{const{stat:n,symbolicLink:s}=await S.SymlinkSupport.stat(this.H(i));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const n=await S.Promises.readdir(this.H(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,m.$ug)(i,r.name))).type:l=this.M(r),s.push([r.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(i,n){let s;return n?.dangling?s=$.FileType.Unknown:i.isFile()?s=$.FileType.File:i.isDirectory()?s=$.FileType.Directory:s=$.FileType.Unknown,n&&(s|=$.FileType.SymbolicLink),s}async O(i){const n=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const r=new R.$Rg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),s=await this.O(i));const r=this.H(i);return await S.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{s?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,n,s){const r=(0,d.$1d)(l=>j.$ae.concat(l.map(k=>j.$ae.wrap(k))).buffer);return(0,h.$Ip)(this,i,r,l=>l.buffer,{...n,bufferSize:256*1024},s),r}async writeFile(i,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(i)?this.R(i,(0,m.$ug)((0,m.$tg)(i),`${(0,m.$rg)(i)}${s.atomic.postfix}`),n,s):this.S(i,n,s)}async Q(i){try{const n=this.H(i),{symbolicLink:s}=await S.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(i,n,s,r){const l=new c.$Qc;try{l.add(await this.O(i)),l.add(await this.O(n)),await this.S(n,s,r,!0);try{await this.rename(n,i,{overwrite:!0})}catch(k){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(i,n,s,r){let l;try{const k=this.H(i);if(!s.create||!s.overwrite){if(await S.Promises.exists(k)){if(!s.overwrite)throw(0,$.$ik)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,$.$ik)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock},r),await this.write(l,0,n,0,n.byteLength)}catch(k){throw await this.gb(i,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(i){t.Y=i}async open(i,n,s){const r=this.H(i);let l;(0,$.$0j)(n)&&!s&&(l=await this.O(i));let k;try{if((0,$.$0j)(n)&&n.unlock)try{const{stat:E}=await S.SymlinkSupport.stat(r);E.mode&128||await S.Promises.chmod(r,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let y;if((0,$.$0j)(n)){if(O.$j)try{await S.Promises.truncate(r,0),y="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}y||(y="w")}else y="r";k=await S.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$0j)(n)?await this.gb(i,y):this.fb(y)}if(this.U.set(k,0),(0,$.$0j)(n)&&this.X.set(k,i),l){const y=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),y.dispose())}return k}async close(i){const n=this.W.get(i);try{if(this.U.delete(i),this.X.delete(i)&&t.Y)try{await S.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await S.Promises.close(i)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(i)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.W.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,r,l){const k=this.Z(i,n);let y=null;try{y=(await S.Promises.read(i,s,r,l,k)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(i,k,y)}return y}Z(i,n){return n===this.U.get(i)?null:n}$(i,n,s){const r=this.U.get(i);typeof r=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(i,r+s):this.U.delete(i)))}async write(i,n,s,r,l){return(0,R.$$g)(()=>this.ab(i,n,s,r,l),100,3)}async ab(i,n,s,r,l){const k=this.Z(i,n);let y=null;try{y=(await S.Promises.write(i,s,r,l,k)).bytesWritten}catch(E){throw await this.gb(this.X.get(i),E)}finally{this.$(i,k,y)}return y}async mkdir(i){try{await S.Promises.mkdir(this.H(i))}catch(n){throw this.fb(n)}}async delete(i,n){try{const s=this.H(i);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,b.$ic)((0,b.$lc)(s),`${(0,b.$mc)(s)}${n.atomic.postfix}`)),await S.Promises.rm(s,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:y}=await S.SymlinkSupport.stat(s);l=k.isDirectory()&&!y}catch{}if(l)await S.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.fb(s)}}async rename(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.bb(i,n,"move",s.overwrite),await S.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(2,null,(0,b.$mc)(r),(0,b.$mc)((0,b.$lc)(l)),k.toString()))),this.fb(k)}}async copy(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.bb(i,n,"copy",s.overwrite),await S.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(3,null,(0,b.$mc)(r),(0,b.$mc)((0,b.$lc)(l)),k.toString()))),this.fb(k)}}async bb(i,n,s,r){const l=this.H(i),k=this.H(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Vf)(l,k,!0)),y){if(s==="copy")throw(0,$.$ik)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const N=await this.L(i);if(!N)throw(0,$.$ik)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const W=await this.L(n);if(W){if(!r)throw(0,$.$ik)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);N.type&$.FileType.File&&W.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,n){return this.cb(i,n,!1)}async cb(i,n,s){const r=this.H(i),l=this.H(n),k=!!(this.capabilities&1024);if((0,u.$Vf)(r,l,!k))return;const y=new c.$Qc;try{y.add(await this.O(i)),y.add(await this.O(n)),s&&await S.Promises.mkdir((0,b.$lc)(l),{recursive:!0}),await S.Promises.copyFile(r,l)}catch(E){if(E.code==="ENOENT"&&!s)return this.cb(i,n,!0);throw this.fb(E)}finally{y.dispose()}}t(i,n,s){return new p.$Zp(r=>i(r),r=>n(r),s)}F(i,n,s){return new P.$8p(r=>i(r),r=>n(r),s)}fb(i){if(i instanceof $.$hk)return i;let n=i,s;switch(i.code){case"ENOENT":s=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=$.FileSystemProviderErrorCode.Unknown;break;default:s=$.FileSystemProviderErrorCode.Unknown}return(0,$.$ik)(n,s)}async gb(i,n){let s=this.fb(n);if(i&&s.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(i));r.mode&128||(s=(0,$.$ik)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$9p=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class R extends L.$Rc{constructor(j,v=[]){super(),this.a=new D.$fj([j,...v]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...v){this.a.trace(j,...v)}debug(j,...v){this.a.debug(j,...v)}info(j,...v){this.a.info(j,...v)}warn(j,...v){this.a.warn(j,...v)}error(j,...v){this.a.error(j,...v)}flush(){this.a.flush()}}e.$vN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,b,O,m,d){try{const S=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});S.setFlushOn(R.Trace);const w=await S.createAsyncRotatingLogger(c,b,O,m);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function j(c,b,O){switch(b){case D.LogLevel.Trace:c.trace(O);break;case D.LogLevel.Debug:c.debug(O);break;case D.LogLevel.Info:c.info(O);break;case D.LogLevel.Warning:c.warn(O);break;case D.LogLevel.Error:c.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function v(c,b){switch(b){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends D.$bj{constructor(b,O,m,d,S){super(),this.m=[],this.setLevel(S),this.n=this.s(b,O,m,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&v(this.r,w)}))}async s(b,O,m,d){const S=m?6:1,w=30/S*L.$Dk.MB,$=await A(b,O,w,S,d);if($){this.r=$,v(this.r,this.getLevel());for(const{level:h,message:f}of this.m)j(this.r,h,f);this.m=[]}}g(b,O){this.r?j(this.r,b,O):this.getLevel()<=b&&this.m.push({level:b,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;class A extends D.$gj{s(v,u,c){return new R.$kN((0,L.$dg)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$lN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=void 0,e.$dn=(0,A.$Nh)("policy");class j extends R.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(O,[m,d])=>({...O,[m]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[b,O])=>({...c,[b]:{definition:O,value:this.g.get(b)}}),{})}}e.$en=j;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$fn=v}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;function c(O,m){const d=[];for(const S of new Set(R.Iterable.concat(O.keys(),m.keys())))O.get(S)!==m.get(S)&&d.push(S);return d}let b=class extends u.$en{constructor(m,d,S){super(),this.m=m,this.n=d,this.s=S,this.c=this.B(new L.$Qg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(m));this.B(d.watch(m)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const d=await this.n.readFile(this.m),S=JSON.parse(d.value.toString());if(!(0,A.$zf)(S))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(S))this.f[w]&&m.set(w,S[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return m}async w(){const m=await this.u(),d=c(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$X7b=b,e.$X7b=b=pe([se(1,j.$9j),se(2,v.$8i)],b)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=void 0;let v=class extends L.$en{constructor(c,b){super(),this.m=c,this.n=b,this.a=new D.$Mg,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,O)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,m=>{this.t(m),b()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const O=c[b];O===void 0?this.g.delete(b):this.g.set(b,O)}this.h.fire(Object.keys(c))}};e.$W7b=v,e.$W7b=v=pe([se(0,j.$8i)],v)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,L.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class R{constructor(){this.a=new Map}add(j,v){L.ok(D.$xf(j)),L.ok(D.$zf(v)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,v)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$bn=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new L.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[R(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;D.$bn.add(e.$cn.JSONContribution,j)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$gn={Configuration:"base.contributions.configuration"};var b;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const O=u.$bn.as(v.$cn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new D.$Md,this.onDidSchemaChange=this.i.event,this.j=new D.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),O.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),O.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),O.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:s}of t)for(const r in n)if(a.add(r),e.$qn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(s)for(const W of Object.keys(n[r]))k.set(W,s);const y={...l?.value||{},...n[r]};this.a.set(r,{source:s,value:y,valuesSources:k});const E=(0,j.$ri)(r),N={type:"object",default:y,description:A.localize(1,null,E),$ref:e.$nn,defaultDefaultValue:y,source:R.$xf(s)?void 0:s,defaultValueSource:s};i.push(...w(r)),this.d[r]=N,this.b.properties[r]=N}else{this.a.set(r,{value:n[r],source:s});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const s in i){const r=this.a.get(s),l=R.$xf(n)?n:n?.id,k=R.$xf(r?.source)?r?.source:r?.source?.id;if(l===k)if(a.add(s),this.a.delete(s),e.$qn.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const s in n.properties){a.add(s);const r=this.d[s];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,i,n,s=3,r){s=R.$Gf(t.scope)?s:t.scope;const l=t.properties;if(l)for(const y in l){const E=l[y];if(a&&I(y,E)){delete l[y];continue}if(E.source=i,E.defaultDefaultValue=l[y].default,this.w(y,E),e.$qn.test(y)?E.scope=void 0:(E.scope=R.$Gf(E.scope)?s:E.scope,E.restricted=R.$Gf(E.restricted)?!!n?.includes(y):E.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const k=t.allOf;if(k)for(const y of k)this.p(y,a,i,n,s,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const r in n)this.r(r,n[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$hn.properties[t]=a,a.scope){case 1:e.$in.properties[t]=a;break;case 2:e.$jn.properties[t]=a;break;case 6:e.$kn.properties[t]=a;break;case 3:e.$ln.properties[t]=a;break;case 4:e.$mn.properties[t]=a;break;case 5:e.$mn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$hn.properties[t],a.scope){case 1:delete e.$in.properties[t];break;case 2:delete e.$jn.properties[t];break;case 6:delete e.$kn.properties[t];break;case 3:delete e.$ln.properties[t];break;case 4:case 5:delete e.$mn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$nn};this.w(a,i),e.$hn.properties[a]=i,e.$in.properties[a]=i,e.$jn.properties[a]=i,e.$kn.properties[a]=i,e.$ln.properties[a]=i,e.$mn.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=t,e.$in.patternProperties[e.$pn]=t,e.$jn.patternProperties[e.$pn]=t,e.$kn.patternProperties[e.$pn]=t,e.$ln.patternProperties[e.$pn]=t,e.$mn.patternProperties[e.$pn]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,s=i?.source;R.$Ef(n)&&(n=a.defaultDefaultValue,s=void 0),R.$Ef(n)&&(n=h(a.type)),a.default=n,a.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");e.$pn=`^(${d})+$`,e.$qn=new RegExp(e.$pn);function w(P){const t=[];if(e.$qn.test(P)){let a=S.exec(P);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(P)}}return(0,L.$Lb)(t)}e.$rn=w;function $(P){return P.reduce((t,a)=>`${t}[${a}]`,"")}e.$sn=$;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=h;const f=new m;u.$bn.add(e.$gn.Configuration,f);function I(P,t){return P.trim()?e.$qn.test(P)?A.localize(7,null,P):f.getConfigurationProperties()[P]!==void 0?A.localize(8,null,P):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,P,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$un=I;function p(){const P=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))P.push([a,t[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.$vn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,R,A,j,v,u,c,b,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function d(a){return Object.isFrozen(a)?a:v.$3m(a)}class S{constructor(i={},n=[],s=[],r){this.b=i,this.c=n,this.d=s,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof S)return n;const s=new w("");return s.parseRaw(n),s.configurationModel});this.f=i.reduce((n,s)=>s===n?s:n.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.$pi)(this.contents,i):this.contents}inspect(i,n){const s=this.rawConfiguration.getValue(i),r=n?this.rawConfiguration.getOverrideValue(i,n):void 0,l=n?this.rawConfiguration.override(n).getValue(i):s;return{value:s,override:r,merged:l}}getOverrideValue(i,n){const s=this.i(n);return s?i?(0,b.$pi)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const s of this.overrides)s.identifiers.includes(i)&&n.push(...s.keys);return L.$Lb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return L.$Lb(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=v.$2m(this.contents),s=v.$2m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of i)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(n,k.contents);for(const y of k.overrides){const[E]=s.filter(N=>L.$tb(N.identifiers,y.identifiers));E?(this.h(E.contents,y.contents),E.keys.push(...y.keys),E.keys=L.$Lb(E.keys)):s.push(v.$2m(y))}for(const y of k.keys)r.indexOf(y)===-1&&r.push(y)}return new S(n,r,s,l.every(k=>k instanceof S)?void 0:l)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r];const k=n[r];k&&(typeof l=="object"&&typeof k=="object"?(l=v.$2m(l),this.h(l,k)):l=k),s[r]=l}return new S(s,this.keys,this.overrides)}h(i,n){for(const s of Object.keys(n)){if(s in i&&u.$zf(i[s])&&u.$zf(n[s])){this.h(i[s],n[s]);continue}i[s]=v.$2m(n[s])}}i(i){let n=null,s=null;const r=l=>{l&&(s?this.h(s,l):s=v.$2m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?n=l.contents:l.identifiers.includes(i)&&r(l.contents);return r(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.$oi)(this.contents,i),O.$qn.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>L.$tb(s.identifiers,(0,O.$rn)(i))),1))}j(i,n,s){(0,b.$ni)(this.contents,i,n,r=>console.error(r)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),O.$qn.test(i)&&this.overrides.push({identifiers:(0,O.$rn)(i),keys:Object.keys(this.contents[i]),contents:(0,b.$mi)(this.contents[i],r=>console.error(r))})}}e.$wn=S;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!u.$Gf(i)){const s=this.g(i);this.parseRaw(s,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:s,keys:r,overrides:l,restricted:k,hasExcludedProperties:y}=this.h(i,n);this.b=new S(s,r,l,y?[i]:void 0),this.c=k||[]}g(i){let n={},s=null,r=[];const l=[],k=[];function y(N){Array.isArray(r)?r.push(N):s!==null&&(r[s]=N)}const E={onObjectBegin:()=>{const N={};y(N),l.push(r),r=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const N=[];y(N),l.push(r),r=N,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(N,W,x)=>{k.push({error:N,offset:W,length:x})}};if(i)try{R.$Ym(i,E),n=r[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return n}h(i,n){const s=m.$bn.as(O.$gn.Configuration).getConfigurationProperties(),r=this.i(i,s,!0,n);i=r.raw;const l=(0,b.$mi)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),k=Object.keys(i),y=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:l,keys:k,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,n,s,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const k={},y=[];for(const E in i)if(O.$qn.test(E)&&s){const N=this.i(i[E],n,!1,r);k[E]=N.raw,l=l||N.hasExcludedProperties,y.push(...N.restricted)}else{const N=n[E],W=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&y.push(E),!r.exclude?.includes(E)&&(r.include?.includes(E)||(W===void 0||r.scopes===void 0||r.scopes.includes(W))&&!(r.skipRestricted&&N?.restricted))?k[E]=i[E]:l=!0}return{raw:k,restricted:y,hasExcludedProperties:l}}j(i,n){const s=[];for(const r of Object.keys(i))if(O.$qn.test(r)){const l={};for(const k in i[r])l[k]=i[r][k];s.push({identifiers:(0,O.$rn)(r),keys:Object.keys(l),contents:(0,b.$mi)(l,n)})}return s}}e.$xn=w;class $ extends A.$Rc{constructor(i,n,s,r){super(),this.c=i,this.f=n,this.g=r,this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=$;class h{constructor(i,n,s,r,l,k,y,E,N,W,x,_,ue){this.a=i,this.b=n,this.c=s,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=y,this.h=E,this.i=N,this.j=W,this.k=x,this.l=_,this.m=ue}get value(){return d(this.c)}n(i,n,s){const r=i.inspect(n,s);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,n,s,r,l=new S,k=new S,y=new j.$zc,E=new S,N=new j.$zc){this.c=i,this.d=n,this.f=s,this.g=r,this.h=l,this.i=k,this.j=y,this.l=E,this.m=N,this.a=null,this.b=new j.$zc,this.n=null}getValue(i,n,s){return this.q(i,n,s).getValue(i)}updateValue(i,n,s={}){let r;s.resource?(r=this.m.get(s.resource),r||(r=new S,this.m.set(s.resource,r))):r=this.l,n===void 0?r.removeValue(i):r.setValue(i,n),s.resource||(this.a=null)}inspect(i,n,s){const r=this.q(i,n,s),l=this.u(n.resource,s),k=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const E of r.overrides)for(const N of E.identifiers)r.getOverrideValue(i,N)!==void 0&&y.add(N);return new h(i,n,r.getValue(i),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,k)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const s=[];if(!n){const{added:r,updated:l,removed:k}=P(this.c,i);n=[...r,...l,...k]}for(const r of n)for(const l of(0,O.$rn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),y=i.getKeysForOverrideIdentifier(l),E=[...y.filter(N=>k.indexOf(N)===-1),...k.filter(N=>y.indexOf(N)===-1),...k.filter(N=>!v.$6m(this.c.override(l).getValue(N),i.override(l).getValue(N)))];s.push([l,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:s,removed:r}=P(this.d,i),l=[...n,...s,...r];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.applicationConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateApplicationConfiguration(i),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.localUserConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateLocalUserConfiguration(i),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.remoteUserConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateRemoteUserConfiguration(i),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.workspaceConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateWorkspaceConfiguration(i),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(i,n){const s=this.p.get(i),{added:r,updated:l,removed:k,overrides:y}=P(s,n),E=[...r,...l,...k];return(E.length||!s)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:y}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:r,removed:l,overrides:k}=P(n,void 0);return{keys:[...s,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,s){let r=this.r(n,s);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},n){let s=this.s();if(n&&i){const r=n.getFolder(i);r&&(s=this.t(r.uri)||s);const l=this.m.get(i);l&&(s=s.merge(l))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const s=this.s(),r=this.j.get(i);r?(n=s.merge(r),this.b.set(i,n)):n=s}return n}u(i,n){if(n&&i){const s=n.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:s,overrides:r,keys:l}=this.j.get(n);return i.push([n,{contents:s,overrides:r,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r))),[...n.values()]}static parse(i){const n=this.x(i.defaults),s=this.x(i.policy),r=this.x(i.application),l=this.x(i.user),k=this.x(i.workspace),y=i.folders.reduce((E,N)=>(E.set(c.URI.revive(N[0]),this.x(N[1])),E),new j.$zc);return new f(n,s,r,l,new S,k,y,new S,new j.$zc)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.$zn=f;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const r of a)r.keys.forEach(l=>i.add(l)),r.overrides.forEach(([l,k])=>{const y=(0,j.$wc)(n,l,new Set);k.forEach(E=>y.add(E))});const s=[];return n.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...i.values()],overrides:s}}e.$An=I;class p{constructor(i,n,s,r){this.change=i,this.f=n,this.g=s,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,n){const s=this.a+i,r=this.d.indexOf(s);if(r<0)return!1;const l=r+s.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!v.$6m(y,E)}return!0}}e.$Bn=p;function P(a,i){const{added:n,removed:s,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],k=a?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const E=y.filter(N=>!k.includes(N));for(const N of E)l.push([N,i.getKeysForOverrideIdentifier(N)])}if(a){const E=k.filter(N=>!y.includes(N));for(const N of E)l.push([N,a.getKeysForOverrideIdentifier(N)])}if(i&&a){for(const E of k)if(y.includes(E)){const N=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});l.push([E,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:r,overrides:l}}function t(a,i){const n=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],s=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],r=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const k=(0,b.$pi)(i.contents,l),y=(0,b.$pi)(a.contents,l);v.$6m(k,y)||r.push(l)}}return{added:n,removed:s,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,R,A,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=void 0;class m extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new v.$wn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$bn.as(u.$gn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$bn.as(u.$gn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$wn;const $=O.$bn.as(u.$gn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],P=h[I];p!==void 0?this.b.addValue(I,p):P?this.b.addValue(I,P.default):this.b.removeValue(I)}}}e.$Cn=m;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new v.$wn}async initialize(){return this.configurationModel}}e.$Dn=d;let S=class extends R.$Rc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new v.$wn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=O.$bn.as(u.$gn.Configuration).getConfigurationProperties();for(const p of $){const P=I[p];if(!P){f.push(p);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}f.push(p),h[P.policy.name]={type:P.type}}}return(0,j.$Kf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$bn.as(u.$gn.Configuration).getPolicyConfigurations(),f=(0,L.$Gb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$bn.as(u.$gn.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const P of $){const t=f[P]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.$6m)(this.b.getValue(P),a))&&I.push([P,a])}else this.b.getValue(P)!==void 0&&I.push([P,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const P=this.b;this.b=new v.$wn;for(const t of P.keys)this.b.setValue(t,P.getValue(t));for(const[t,a]of I)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$En=S,e.$En=S=pe([se(1,b.$dn),se(2,c.$8i)],S)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0;class b extends R.$Rc{constructor(m,d,S,w){super(),this.j=m,this.h=this.B(new D.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Cn),this.c=S instanceof c.$fn?new u.$Dn:this.B(new u.$En(this.b,S,w)),this.f=this.B(new v.$yn(this.j,{},A.$lg,d)),this.a=new v.$zn(this.b.configurationModel,this.c.configurationModel,new v.$wn,new v.$wn),this.g=this.B(new L.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,d,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$zn(m,d,new v.$wn,S)}getConfigurationData(){return this.a.toData()}getValue(m,d){const S=typeof m=="string"?m:void 0,w=(0,j.$ii)(m)?m:(0,j.$ii)(d)?d:{};return this.a.getValue(S,w,void 0)}updateValue(m,d,S,w){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.m(m)}m(m){const d=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(m);this.s(S,d,2)}n(m,d){const S=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(m,d);this.s(w,S,7)}r(m){const d=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(m);this.s(S,d,7)}s(m,d,S){const w=new v.$Bn(m,{data:d},this.a);w.source=S,w.sourceConfig=this.t(S),this.h.fire(w)}t(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Fn=b}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Rk=D;function R(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.$Sk=R;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Tk=A;function j(c){const{host:b,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:O}}e.$Uk=j;function v(c,b){let{host:O,port:m}=u(c);return typeof m>"u"&&(m=b),{host:O,port:m}}e.$Vk=v;function u(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Zl=A,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(j||(e.ExtensionType=j={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$1e(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$2l=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$3l=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=b;function O(w){return m(w)}e.$5l=O;function m(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$6l=m;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$7l=d;function S(w,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Sk)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$8l=S,e.$9l=(0,D.$Nh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;class A extends L.$Rc{constructor(v,u,c,b,O){super(),this.a=v,this.b=u,this.c=c,this.f=O,this.B(b.onDidInstallExtensions(m=>this.g(m))),this.B(b.onDidUninstallExtension(m=>this.h(m)))}g(v){for(const u of v)u.local&&this.invalidate(u.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,v)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,D.$Vl))}catch(u){(0,R.$mk)(u)!==1&&this.f.error(u)}}}e.$Cp=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Oo=(0,v.$Nh)("requestService");class b{constructor(P){this.b=P}toJSON(){if(!this.a){const P=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?P[t]="*****":P[t]=this.b[t];this.a=P}return this.a}}class O extends R.$Rc{constructor(P){super(),this.b=0,this.a=P.createLogger("network",{name:(0,A.localize)(0,null),when:u.$mj.isEqualTo((0,u.$kj)(u.LogLevel.Trace)).serialize()})}async c(P,t,a){const i=`${P} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new b(t.headers??{}));try{const n=await a();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,D.$9)(n)),n}}}e.$Po=O;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Qo=m;function d(p){return p.res.statusCode===204}e.$Ro=d;async function S(p){return d(p)?null:(await(0,L.$me)(p.stream)).toString()}e.$So=S;async function w(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return S(p)}e.$To=w;async function $(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$me)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Uo=$;function h(p){I(p)}e.$Vo=h;let f;function I(p){const P=c.$bn.as(j.$gn.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},P.updateConfigurations({add:[f],remove:t?[t]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;let j=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,b=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,b);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const d=await(0,A.$To)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$KN=j,e.$KN=j=pe([se(0,A.$Oo),se(1,R.$9j)],j)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;function R(j,v){return j.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:j.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function A(j,v,u={}){const c=(0,L.parse)(j),b=u.proxyUrl||R(c,v);if(!b)return null;const O=(0,L.parse)(b);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.$Df)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,S)=>{J(["http-proxy-agent"],d,S)}))(m):new(await new Promise((d,S)=>{J(["https-proxy-agent"],d,S)}))(m)}e.$Tq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0;let S;async function w(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Jl)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Jl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=m.Promises.withAsyncBody(async(P,t)=>{const a=new A.$Wd;let i=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.$Kl)(n,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{P(await $(f,a.token))}catch(r){!(0,v.$3)(r)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,j.$yi)(r)))):P({})}finally{clearTimeout(s),a.dispose()}})),S)}e.$Pl=w;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const P=(0,c.$dg)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,b.$zl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(f.isCancellationRequested)return s(new v.$4);const r=(0,D.$mc)(i);let l,k;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const E=(0,L.spawn)(i,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(E.kill(),s(new v.$4))),E.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$yi)(x)),s(x)});const N=[];E.stdout.on("data",x=>N.push(x));const W=[];E.stderr.on("data",x=>W.push(x)),E.on("close",(x,_)=>{const ue=Buffer.concat(N).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),x||_)return s(new Error((0,R.localize)(2,null,x,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,j.$yi)(ie)),s(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN=(0,L.$Nh)("stateReadService"),e.$nN=(0,L.$Nh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class b extends R.$Rc{constructor(S,w,$,h){super(),this.h=S,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new L.$Qg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.j.error(S)}}getItem(S,w){const $=this.a[S];return(0,A.$Gf)($)?w:$}setItem(S,w){this.setItems([{key:S,data:w}])}setItems(S){let w=!1;for(const{key:$,data:h}of S)this.a[$]!==h&&((0,A.$Gf)(h)?(0,A.$Ef)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(S){(0,A.$Ef)(this.a[S])||(this.a[S]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.m.writeFile(this.h,D.$ae.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$oN=b;let O=class extends R.$Rc{constructor(S,w,$,h){super(),this.a=this.B(new b(w.stateResource,S,$,h))}async init(){await this.a.init()}getItem(S,w){return this.a.getItem(S,w)}};e.$pN=O,e.$pN=O=pe([se(1,j.$Uh),se(2,u.$8i),se(3,v.$9j)],O);class m extends O{setItem(S,w){this.a.setItem(S,w)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$qN=m}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function A(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,b,O,m,d,S,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$dg)()+Date.now(),$.commitHash=O,$.version=m,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$i)(L.$u),$["common.nodePlatform"]=D.$cc,$["common.nodeArch"]=b,$["common.product"]=w||"desktop",S&&($["common.msftInternal"]=S);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$m&&($["common.snap"]="true");const I=A(c);return I&&($["common.platformDetail"]=I),$}e.$do=j;function v(u){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return u.some(O=>b===O)}e.$eo=v}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,L.$Nh)("telemetryService"),e.$al=(0,L.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class c{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$fo=c;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=b,e.$ho=new b;class O{async publicLog(s,r,l){}async publicLogError(s,r,l){}}e.$io=O,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function m(n,s){return R.Event.debounce(s.onDidChangeConfiguration,(l,k)=>{const y=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$ki)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$mo=m;function d(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry)}e.$no=d;function S(n,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$oo=S;function w(n){const s=n.getValue(u.$gl),r=n.getValue(u.$hl);if(n.getValue(u.$il)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=w;function $(n){const s={},r={},l={};I(n,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const y=l[k];typeof y=="number"?r[k]=y:typeof y=="boolean"?r[k]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${y.length}`),s[k]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[k]=y)}return{properties:s,measurements:r}}e.$qo=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const s=(0,j.$Sk)(n);return h.has(s)?s:"other"}e.$ro=f;function I(n,s,r=0,l){if(n)for(const k of Object.getOwnPropertyNames(n)){const y=n[k],E=l?l+k:k;Array.isArray(y)?s[E]=(0,L.$7m)(y):y instanceof Date?s[E]=y.toISOString():(0,D.$zf)(y)?r<2?I(y,s,r+1,E+"."):s[E]=(0,L.$7m)(y):s[E]=y}}function p(n,s){const r=n.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,v.$eo)(r)||l}e.$so=p;function P(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$to=P;function t(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const l=[];for(const N of s)for(;;){const W=N.exec(n);if(!W)break;l.push([W.index,N.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(r="";;){const N=y.exec(n);if(!N)break;const W=l.some(([x,_])=>N.index<_&&x<y.lastIndex);!k.test(N[0])&&!W&&(r+=n.substring(E,N.index)+"<REDACTED: user-file-path>",E=y.lastIndex)}return E<n.length&&(r+=n.substr(E)),r}function a(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function i(n,s){return(0,L.$4m)(n,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=t(l,s);for(const k of s)l=l.replace(k,"");return l=a(l),l}})}e.$uo=i}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,L.$Ve)(i.id,n.id)===0}e.$vo=b;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,r)}static parse(n){const s=O.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,r="undefined"){this.version=s,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$wo=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const n=d.exec(i);return n&&n[1]?[$(n[1]),n[2]]:[$(i),void 0]}e.$xo=S;function w(i,n){return`${i}.${n}`}e.$yo=w;function $(i){return i.toLowerCase()}e.$zo=$;function h(i,n){return $(w(i??R.$Xl,n))}e.$Ao=h;function f(i,n){const s=[],r=l=>{for(const k of s)if(k.some(y=>b(n(y),n(l))))return k;return null};for(const l of i){const k=r(l);k?k.push(l):s.push([l])}return s}e.$Bo=f;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$Co=I;function p(i){return{id:new c.$fo(i.identifier.id),name:new c.$fo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$Do=p,e.$Eo=new R.$2l("pprice.better-merge");function P(i,n){const s=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&s.every(k=>!b(k.identifier,{id:l}))){const k=i.filter(y=>b(y.identifier,{id:l}));k.length===1&&(s.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$Fo=P;async function t(i,n){if(!A.$l)return!1;let s;try{s=(await i.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,v.$9)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const s=await t(i,n),r=(0,D.$1n)(s?"alpine":A.$u,u.$dc);return n.debug("ComputeTargetPlatform:",r),r}e.$Go=a}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,R,A,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;const m=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function S($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const P=O.$1l.map(a=>a.toLowerCase());if(f&&f!==""){if(P.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),P.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(S(a.manifest,h)))}async installExtensions(h,f,I,p){const P=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const n=(r,l,k)=>{i.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof v.URI)a.push({vsix:r,installOptions:I});else{const[l,k]=(0,b.$xo)(r);n(l,k,!1)}for(const r of f)if(r instanceof v.URI)a.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,b.$xo)(r);n(l,k,!0)}const s=await this.b.getInstalled(1,I.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,p,s);k&&t.push(k)}catch(k){this.a.error(k),P.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:l})=>{const k=s.find(y=>(0,b.$vo)(y.identifier,{id:r}));if(k){if(!p&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,u.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const y=await this.j(l,k,s);y&&t.push(y)}catch(y){this.a.error(y.message||y.stack||y),P.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),P.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$9)(t))),t}if(P.length)throw new Error((0,u.localize)(8,null,P.join(", ")))}async g(h,f,I,p){const P=await this.b.getManifest(h);if(!P)throw new Error("Invalid vsix");if(await this.l(P,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$rg)(h))),P}catch(a){if((0,D.$3)(a))return this.a.info((0,u.localize)(10,null,(0,A.$rg)(h))),null;throw a}return null}async h(h){const f=new Map,I=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),P=[];for(const t of h)c.$Tn.test(t.id)&&P.push({...t,preRelease:I});if(P.length){const t=await this.d.getExtensions(P,{targetPlatform:p},L.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:I},p,P){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const a=P.find(i=>(0,b.$vo)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,D.$3)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,I,p){if(!f){const P={id:(0,b.$Ao)(h.publisher,h.name)},t=p.find(a=>(0,b.$vo)(P,a.identifier)&&(0,j.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async t=>{if(t instanceof v.URI){const a=await this.b.getManifest(t);return S(a)}return t},P=[];for(const t of h){const a=await p(t),n=(await this.b.getInstalled(void 0,I)).filter(s=>(0,b.$vo)(s.identifier,{id:a}));if(!n.length)throw new Error(`${this.m(a)}
${d}`);if(n.some(s=>s.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&n.some(s=>s.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const s of n)await this.b.uninstall(s,{profileLocation:I}),P.push(s);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$cp=w,e.$cp=w=pe([se(1,c.$8n),se(2,c.$6n)],w)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class v extends D.$Rc{constructor(c,b,O,m,d,S,w){super(),this.f=c,this.g=b,this.h=O,this.j=m,this.m=d,this.n=S,this.r=w,this.a=this.B(new L.$Md),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$Zc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(b=>(this.c.set(b.id,(0,D.$Oc)(this.n.watch(this.m.extUri.dirname(b.extensionsResource)),this.n.watch(b.extensionsResource))),this.G(b.extensionsResource))))}catch(b){throw this.r.error(b),b}}async w(c){for(const b of c.extensions)this.I(this.L(b.identifier,b.version),c.profileLocation)}async y(c){for(const b of c.extensions){const O=this.L(b.identifier,b.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const b of c.extensions)this.J(this.L(b.identifier,b.version),c.profileLocation)}async C(c){const b=[],O=[];for(const m of c.extensions){const d=this.L(m.identifier,m.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(S=>{S?b.push(S):this.r.info("Extension not found at the location",m.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(O),b.length&&await this.H(b)}catch(m){this.r.error(m)}}D(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.F(b.extensionsResource)}async F(c){const b=[],O=[],m=await this.j.scanProfileExtensions(c),d=new Set,S=new Set;for(const[w,$]of this.b)$.has(c)&&S.add(w);for(const w of m){const $=this.L(w.identifier,w.version);d.add($),S.has($)||(b.push(w.identifier),this.I($,c))}for(const w of S)if(!d.has(w)){const $=this.M(w);$&&(O.push($.identifier),this.J(w,c))}(b.length||O.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const b=await this.j.scanProfileExtensions(c);for(const O of b)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,b){let O=this.b.get(c);O||this.b.set(c,O=new R.$Ac(m=>this.m.extUri.getComparisonKey(m))),O.add(b)}J(c,b){const O=this.b.get(c);O&&O.delete(b),O?.size||this.b.delete(c)}L(c,b){return`${j.$2l.toKey(c.id)}@${b}`}M(c){const[b,O]=(0,A.$xo)(c);return O?{identifier:{id:b},version:O}:void 0}}e.$Dp=v}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function R(A,j,v,u,c,b,O){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,D.$no)(j,v)&&(0,D.$po)(u)===3){const d=await(0,L.$8o)(v,c,b);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=O.machineId||d}return m}e.$9o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let w=class extends d.$Pq{constructor(I,p,P,t){super(P),this.h=I,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(I,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[I];return a?S.URI.file(a):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(P=>{const t=I[P];return{...this.f(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((P,t)=>P.label.localeCompare(t.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(P=>p[P]&&p[P].extensions.some(t=>(0,O.$vo)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(p);return!(0,D.$tb)(Object.keys(I),Object.keys(P))}};e.$Qq=w,e.$Qq=w=pe([se(0,b.$8n),se(1,c.$Vh),se(2,b.$6n),se(3,m.$8i)],w);let $=class extends A.$Rc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,v.$ic)(I.userDataPath,"languagepacks.json"),this.g=new R.$Zg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(P=>delete p[P]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const P of p)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.n(I,P);Object.keys(I).forEach(P=>this.r(I[P]))}n(I,p){const P=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===j.Schemas.file&&h(a)){let i=I[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},I[a.languageId]=i);const n=i.extensions.filter(s=>(0,O.$vo)(s.extensionIdentifier,P))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:P,version:p.manifest.version});for(const s of a.translations)i.translations[s.id]=(0,v.$ic)(p.location.fsPath,s.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const P of I.extensions)p.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(p=I(P),P)).then(P=>{for(const a of Object.keys(P))P[a]||delete P[a];this.c=P,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,P=>this.j.error(P))})}};$=pe([se(0,c.$Vh),se(1,m.$8i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function u(b,O,m){const d=await(0,L.$gC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,L.$gC)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,$=new S.PostChannel,h={instrumentationKey:b,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(m){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class c{constructor(O,m,d,S,w){this.e=O,this.f=m,this.g=d,this.h=w,this.c=j,this.d=v,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,D.$Z)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,R.$5m)(m,this.g),m=(0,A.$qo)(m);const d=this.f+"/"+O;try{this.i(S=>{S.pluginVersionString=m?.properties.version??"Unknown",S.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$iN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Ee)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ee)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$gl)||p.affectsConfiguration(m.$il)||p.affectsConfiguration(m.$hl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$po)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,D.$5m)(I,this.d),I=(0,d.$uo)(I,this.j),I=(0,D.$5m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Wq=S,e.$Wq=S=pe([se(1,v.$hi),se(2,b.$nj)],S);function w(){const $=(0,j.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$p?"":(0,j.localize)(3,null),I=(0,j.localize)(4,null),p=(0,j.localize)(5,null),P=(0,j.localize)(6,null),t=(0,j.localize)(7,null),a=`
|       | ${I} | ${p} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,j.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}O.$bn.as(u.$gn.Configuration).registerConfiguration({id:m.$fl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[m.$gl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$bn.as(u.$gn.Configuration).registerConfiguration({id:m.$fl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[m.$il]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${m.$gl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;async function j(b,O){const m=await O.request(b,D.CancellationToken.None),d=(await(0,L.$me)(m.stream)).toString(),S=m.res.statusCode??200;return{headers:m.res.headers,statusCode:S,responseData:d}}async function v(b){const O={method:b.type,headers:b.headers};return new Promise((d,S)=>{const w=R.request(b.url??"",O,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){S(h)})});w.write(b.data,$=>{$&&S($)}),w.end()})}async function u(b,O,m){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),S={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const w=b?await j(S,b):await v(S);m(w.statusCode,w.headers,w.responseData)}catch{m(0,{})}}class c extends A.$iN{constructor(O,m,d,S,w){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(m,d,S,w,$)}}e.$jN=c}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0;async function R(A,j){const v=Object.create(null),u=(b,O)=>{const m=JSON.parse(b);v[O]=m};if(j){const b=[],O=await D.Promises.readdir(j);for(const d of O)try{(await D.Promises.stat((0,L.$ic)(j,d))).isDirectory()&&b.push(d)}catch{}const m=[];for(const d of b)(await D.Promises.readdir((0,L.$ic)(j,d))).filter(w=>w==="telemetry.json").length===1&&m.push(d);for(const d of m){const S=(await D.Promises.readFile((0,L.$ic)(j,d,"telemetry.json"))).toString();u(S,d)}}let c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$i8b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;async function A(j,v){let u=j.getItem(R.$el);return(typeof u!="string"||L.$k&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Om)(v.error.bind(v))),u}e.$C7b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,L.$Nh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let b=class{constructor(m){this.g=m,this.c=new u.$Qc,this.f=2**16;const d=new Map,S=w=>{let $=d.get(w.scheme);return $===void 0&&($=m.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(v.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new A.$jg(S),this.d=new j.$ur((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$vg)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((S,w)=>S[1].time<w[1].time?1:S[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let S=0;S<d;S++)this.d.set(m[S][0],m[S][1].touch())}};e.$vr=b,e.$vr=b=pe([se(0,R.$9j)],b),(0,D.$sr)(L.$Fk,b,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class v extends D.$Rc{constructor(c,b,O,m,d,S){super(),this.f=c,this.g=b,this.h=O,this.j=m,this.m=d,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=A.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,b){return this.g.open(this.t(c),b)}close(c){return this.g.close(c)}read(c,b,O,m,d){return this.g.read(c,b,O,m,d)}write(c,b,O,m,d){return this.g.write(c,b,O,m,d)}watch(c,b){this.b.set(c,c);const O=this.g.watch(this.t(c),b);return(0,D.$Pc)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,b,O){return this.g.rename(this.t(c),this.t(b),O)}readFile(c,b){return this.g.readFile(this.t(c),b)}readFileStream(c,b,O){return this.g.readFileStream(this.t(c),b,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,b,O){return this.g.writeFile(this.t(c),b,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,b){return this.g.delete(this.t(c),b)}copy(c,b,O){if((0,R.$_j)(this.g))return this.g.copy(this.t(c),this.t(b),O);throw new Error("copy not supported")}cloneFile(c,b){if((0,R.$ak)(this.g))return this.g.cloneFile(this.t(c),this.t(b));throw new Error("clone not supported")}s(c){const b=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const m=this.u(O.resource);this.b.findSubstr(m)&&b.push({resource:m,type:O.type})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Y7b=v}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,v.$Nh)("contextService");function c(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.uri)}e.$Xh=c;function b(n){return typeof n?.id=="string"&&!c(n)&&!m(n)}e.$Yh=b,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function O(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$mc)(n)}:s?e.$Zh:e.$1h;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=O;function m(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.configPath)}e.$3h=m;function d(n){const s=n;if(s?.uri)return{id:s.id,uri:j.URI.revive(s.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$4h=d;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$5h=w;function $(n){const s=n;return!!(s&&typeof s=="object"&&j.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$6h=$;class h{constructor(s,r,l,k,y){this.h=s,this.j=l,this.k=k,this.l=y,this.c=R.$Th.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$Th.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=h;class f{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=f;function I(n){return new f({uri:n,index:0,name:(0,A.$qg)(n)},{uri:n.toString()})}e.$9h=I,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,L.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function p(n,s){return A.$lg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$bi=p;function P(n){let s;return j.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$ci=P,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$di}e.$ei=t;function a(n,s){return!p(n,s)&&!P(n)}e.$fi=a;function i(n){return(typeof n=="string"?(0,D.$nc)(n):(0,A.$sg)(n))===e.$$h}e.$gi=i}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var I;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&j.URI.isUri(s.location)&&j.URI.isUri(s.globalStorageHome)&&j.URI.isUri(s.settingsResource)&&j.URI.isUri(s.keybindingsResource)&&j.URI.isUri(s.tasksResource)&&j.URI.isUri(s.snippetsHome)&&j.URI.isUri(s.extensionsResource))}e.$Gk=p,e.$Hk=(0,b.$Nh)("IUserDataProfilesService");function P(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:j.URI.revive(n.location).with({scheme:s}),globalStorageHome:j.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:j.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:j.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:j.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:j.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:j.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:j.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Ik=P;function t(n,s,r,l,k,y){return{id:n,name:s,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:y&&k?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$ug)(r,"globalStorage"),settingsResource:y&&k?.useDefaultFlags?.settings?y.settingsResource:(0,A.$ug)(r,"settings.json"),keybindingsResource:y&&k?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$ug)(r,"keybindings.json"),tasksResource:y&&k?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$ug)(r,"tasks.json"),snippetsHome:y&&k?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$ug)(r,"snippets"),extensionsResource:y&&k?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$ug)(r,"extensions.json"),cacheHome:(0,A.$ug)(l,n),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Jk=t;let a=class extends R.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,l,k){super(),this.t=s,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$xf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,A.$rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const l=new d.$zc,k=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[E,N]of Object.entries(y.workspaces)){const W=j.URI.parse(E),x=r.find(_=>_.id===N);x&&l.set(W,x)}if(y.emptyWindows)for(const[E,N]of Object.entries(y.emptyWindows)){const W=r.find(x=>x.id===N);W&&k.set(E,W)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const s=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",l=new RegExp(`${(0,h.$Ee)(r)}\\s(\\d+)`);let k=0;for(const E of this.profiles){const N=l.exec(E.name),W=N?parseInt(N[1]):0;k=W>k?W:k}const y=`${r} ${k+1}`;return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,l){return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),s,r,l)}async createProfile(s,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,l);return k&&await this.setProfileForWorkspace(k,y),y}async F(s,r,l){if(!(0,f.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const y=this.profiles.find(W=>W.name===r||W.id===s);if(y)return y;const E=t(s,r,(0,A.$ug)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(E.location);const N=[];return this.j.fire({profile:E,join(W){N.push(W)}}),await w.Promises.settled(N),this.I([E],[],[]),E}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=t(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$mk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(s){return(0,m.$Xh)(s)?s.uri:(0,m.$3h)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,l){const k=[...this.profiles,...s],y=[];this.s.profiles=[];for(let E of k)E.isDefault||r.some(N=>E.id===N.id)||(E=l.find(N=>E.id===N.id)??E,E.isTransient?this.s.profiles.push(E):y.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(y),this.z=void 0,this.J(s,r,l)}J(s,r,l){this.h.fire({added:s,removed:r,updated:l,all:this.profiles})}L(s,r,l){l=r?.isTransient?!0:l,l||this.L(s,void 0,!0);const k=this.G(s),y=l?this.s:this.C;j.URI.isUri(k)?(y.workspaces.delete(k),r&&y.workspaces.set(k,r)):(y.emptyWindows.delete(k),r&&y.emptyWindows.set(k,r)),l||this.M()}M(){const s={};for(const[l,k]of this.C.workspaces.entries())s[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},l=this.D();if(s.workspaces)for(const[y,E]of Object.entries(s.workspaces)){const N=j.URI.parse(E);r[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const k={};if(s.emptyWindows)for(const[y,E]of Object.entries(s.emptyWindows)){const N=j.URI.parse(E);k[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Kk=a,e.$Kk=a=pe([se(0,u.$Uh),se(1,c.$9j),se(2,S.$Fk),se(3,O.$8i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Lk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=void 0;let p=class extends v.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,r,l,k,y,E){super(),this.z=s,this.C=r,this.D=l,this.F=k,this.G=y,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Md),this.s=this.B(new j.$Md),this.t=this.B(new j.$Md),this.u=this.B(new j.$Md),this.w=this.B(new j.$Md),this.y=[],this.B((0,v.$Pc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const r=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,m.$3n)(l,s.allTargetPlatforms,r))}async installFromGallery(s,r={}){try{const k=(await this.installGalleryExtensions([{extension:s,options:r}])).find(({identifier:y})=>(0,d.$vo)(y,s.identifier));if(k?.local)return k?.local;throw k?.error?k.error:t(new Error(`Unknown error while installing extension ${s.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new m.$7n(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(s.map(async({extension:k,options:y})=>{try{const E=await this.O(k,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...E,options:y})}catch(E){r.push({identifier:k.identifier,operation:2,source:k,error:E})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!b.URI.isUri(k.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,d.$Do)(k.source),error:k.error}));return r}async uninstall(s,r={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.Q(s,r)}async toggleAppliationScope(s,r){if((0,S.$5l)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(s,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const y=(await this.getInstalled(1,k.extensionsResource)).find(E=>(0,d.$vo)(E.identifier,s.identifier));y?this.w.fire(y):this.u.fire({identifier:s.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(s,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.X(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const r=[];return await Promise.allSettled(s.map(async l=>{try{const k=await this.J(l);r.push(...k)}catch(k){r.push({identifier:{id:(0,d.$Ao)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:s,extension:r,options:l}){const k=l.isApplicationScoped||l.isBuiltin||(0,S.$5l)(s),y={...l,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},E=te=>`${d.$wo.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!b.URI.isUri(r)){const te=this.j.get(E(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const N=[],W=[],x=[],_=this.Z(s,r,y);b.URI.isUri(r)||this.j.set(E(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",_.identifier.id),N.push({task:_,manifest:s});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,s,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.$Xn]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Lb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(B=>(0,d.$vo)({id:B},_.identifier));const T=E(q),U=this.j.get(T);if(U){if(this.L(_,U.task)){const B=U.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,_.identifier.id),U.waitingTasks.push(_),W.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,X=>X.some(K=>(0,d.$vo)(K.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,_.identifier.id),!X.find(Q=>(0,d.$vo)(Q.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$vo)(B,q.identifier))){const B=this.Z(G,q,ie);this.j.set(T,{task:B,waitingTasks:[_]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,_.identifier.id),N.push({task:B,manifest:G})}}}catch(ae){if(b.URI.isUri(_.source))(0,L.$Kb)(s.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,L.$Kb)(s.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=N.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,y,R.CancellationToken.None))),!b.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Do)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),u.$p&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}x.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw b.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Do)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.M(W),x.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),x}catch(te){if(N.forEach(({task:ae})=>ae.cancel()),x.length)try{const ae=await Promise.allSettled(x.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=x[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$9)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$9)(ae),x.map(({identifier:le})=>le.id))}return N.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of N)te.source&&!b.URI.isUri(te.source)&&this.j.delete(E(te.source))}}L(s,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===s&&(k.includes(r)||k.some(y=>this.L(y,r)))||l===r&&k[0]&&!this.L(s,k[0]))return!1;return!0}async M(s){const r=[],l=[],k=await Promise.allSettled(s);for(const y of k)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw P(l);return r}async N(s,r,l,k,y){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,y),N=[],W=[],x=async(_,ue)=>{N.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?E.find(ie=>(0,d.$vo)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$vo)({id:q},{id:ie}))||ae.every(q=>!(0,d.$vo)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>N.every(q=>!(0,d.$vo)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of ie){if(N.find(U=>(0,d.$vo)(U,q.identifier)))continue;const G=te.some(U=>(0,d.$vo)({id:U},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(U){if(G)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(U));continue}W.push({gallery:T.extension,manifest:T.manifest}),await x(T.extension.identifier,T.manifest)}}}};return await x(s,r),W}async O(s,r,l){let k;const y=await this.getExtensionsControlManifest();if(y.malicious.some(W=>(0,d.$vo)(s.identifier,W)))throw new m.$7n(O.localize(1,null,s.identifier.id),m.ExtensionManagementErrorCode.Malicious);const E=y.deprecated[s.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new m.$7n(O.localize(2,null,s.identifier.id,E.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const W=await this.getTargetPlatform();throw new m.$7n(O.localize(3,null,s.identifier.id,this.G.nameLong,(0,m.$Yn)(W)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(s,r,l),!k)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new m.$7n(O.localize(4,null,s.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$7n(O.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const N=await this.z.getManifest(k,R.CancellationToken.None);if(N===null)throw new m.$7n(`Missing manifest for extension ${k.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(N.version!==k.version)throw new m.$7n(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:N}}async P(s,r,l){const k=await this.getTargetPlatform();let y=null;return!r&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(s,l,k)&&(y=s),y||(r?y=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(s,l,k)),y}async Q(s,r){const l={...r,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(k(s.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),y.waitUntilTaskIsFinished();const E=_=>{const ue=this.$(_,l);return this.m.set(k(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),ue},N=(_,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$Co)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},W=[],x=[];try{W.push(E(s));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const ue=this.U(s,_);for(const te of ue)this.m.has(k(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):W.push(E(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.R(W.map(ue=>ue.extension),_,s),await this.M(W.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}N(ue.extension)}catch(te){const ae=te instanceof m.$7n?te:new m.$7n((0,A.$9)(te),m.ExtensionManagementErrorCode.Internal);throw N(ue.extension,ae),ae}finally{x.push(ue)}}))}catch(_){const ue=_ instanceof m.$7n?_:new m.$7n((0,A.$9)(_),m.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}x.includes(te)||N(te.extension,ue)}throw ue}finally{for(const _ of W)this.m.delete(k(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(s,r,l){for(const k of s){const y=this.W(k,r);if(y.length){const E=y.filter(N=>!s.some(W=>(0,d.$vo)(W.identifier,N.identifier)));if(E.length)throw new Error(this.S(k,E,l))}}}S(s,r,l){return l===s?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(s,r,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const k=s.manifest.extensionPack?s.manifest.extensionPack:[];if(k.length){const y=r.filter(N=>!N.isBuiltin&&k.some(W=>(0,d.$vo)({id:W},N.identifier))),E=[];for(const N of y)E.push(...this.U(N,r,l));return[...y,...E]}return[]}W(s,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,d.$vo)({id:k},s.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const s=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$lp=p,e.$lp=p=pe([se(0,m.$6n),se(1,h.$_k),se(2,f.$Fk),se(3,w.$8i),se(4,$.$nj),se(5,I.$Hk)],p);function P(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$mp=P;function t(n){if(n instanceof m.$7n)return n;const s=new m.$7n(n.message,m.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$np=t;function a(n,s,{extensionData:r,verificationStatus:l,duration:k,error:y,durationSinceUpdate:E}){let N,W;(0,c.$Ff)(l)&&(l===!0?l="Verified":(l===!1||(N=m.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),y&&(y instanceof m.$7n?(N=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&(W=y.message)):N=m.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...r,verificationStatus:l,success:!y,duration:k,errorcode:N,errorcodeDetail:W,durationSinceUpdate:E})}class i{constructor(){this.d=new D.$Rg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Gg)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Gg)(s=>new Promise((r,l)=>{const k=s.onCancellationRequested(()=>{k.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$op=i}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(i,n){super(i),this.code=n}}e.$pp=I,e.$qp=(0,O.$Nh)("IExtensionsProfileScannerService");let p=class extends R.$Rc{constructor(i,n,s,r,l,k){super(),this.j=i,this.m=n,this.n=s,this.r=r,this.s=l,this.t=k,this.b=this.B(new A.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(i,n){return this.u(i,void 0,n)}async addExtensionsToProfile(i,n){const s=[],r=[];try{return await this.u(n,l=>{const k=[];for(const y of l)i.some(([E])=>(0,c.$vo)(E.identifier,y.identifier)&&E.manifest.version!==y.version)?s.push(y):k.push(y);for(const[y,E]of i){const N=k.findIndex(x=>(0,c.$vo)(x.identifier,y.identifier)&&x.version===y.manifest.version),W={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:E};N===-1?(r.push(W),k.push(W)):k.splice(N,1,W)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),k}),r.length&&this.c.fire({extensions:r,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(i,n){const s=[];return await this.u(n,r=>{const l=[];for(const k of r){const y=i.find(([E])=>(0,c.$vo)(E.identifier,k.identifier)&&E.manifest.version===k.version);y&&(k.metadata={...k.metadata,...y[1]},s.push(k)),l.push(k)}return l}),s}async removeExtensionFromProfile(i,n){const s=[];try{await this.u(n,r=>{const l=[];for(const k of r)(0,c.$vo)(k.identifier,i.identifier)?s.push(k):l.push(k);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:n}),r}}async u(i,n,s){return this.F(i).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(i);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,b.$mk)(k)!==1)throw k;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new I((0,$.$9)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(i);let k=!1;for(const y of l){P(y)||this.w(i);let E;if((0,w.$xf)(y.relativeLocation)&&y.relativeLocation)E=this.z(y.relativeLocation);else if((0,w.$xf)(y.location))E=this.z(y.location),k=!0,y.relativeLocation=y.location,y.location=E.toJSON();else{E=v.URI.revive(y.location);const N=this.y(E);N&&(k=!0,y.relativeLocation=N)}r.push({identifier:y.identifier,location:E,version:y.version,metadata:y.metadata})}k&&await this.m.writeFile(i,D.$ae.fromString(JSON.stringify(l)))}if(n){r=n(r);const k=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(i,D.$ae.fromString(JSON.stringify(k)))}return r})}w(i){const n=new I(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(i)).value.toString()}catch(l){if((0,b.$mk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(k=>P(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.$mk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(i)}catch(l){(0,b.$mk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,b.$mk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(i){let n=this.h.get(i);return n||(n=new L.$Zg,this.h.set(i,n)),n}};e.$rp=p,e.$rp=p=pe([se(1,b.$9j),se(2,d.$Hk),se(3,S.$Fk),se(4,h.$_k),se(5,m.$8i)],p);function P(a){return(0,w.$zf)(a)&&(0,u.$5n)(a.identifier)&&(t(a.location)||(0,w.$xf)(a.location)&&a.location)&&((0,w.$Ef)(a.relativeLocation)||(0,w.$xf)(a.relativeLocation))&&a.version&&(0,w.$xf)(a.version)}function t(a){return a?(0,w.$xf)(a.path)&&(0,w.$xf)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.Translations=void 0;var W;(function(ie){function q(G,T){if(G===T)return!0;const U=Object.keys(G),B=new Set;for(const X of Object.keys(T))B.add(X);if(U.length!==B.size)return!1;for(const X of U){if(G[X]!==T[X])return!1;B.delete(X)}return B.size===0}ie.equals=q})(W||(e.Translations=W={})),e.$up=(0,i.$Nh)("IExtensionsScannerService");let x=class extends c.$Rc{constructor(q,G,T,U,B,X,K,Q,F,z,o,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=U,this.t=B,this.u=X,this.w=K,this.y=Q,this.z=F,this.C=z,this.D=o,this.F=g,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,d.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Go)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[U,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(q,[...U,...B]):[];return this.L(U,B,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(G);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await B.scanExtensions(U)}catch(K){if(K instanceof k.$pp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await B.scanExtensions(U);else throw K}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===b.Schemas.file).map(async U=>{const B=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(K=>(K.type=G.find(Q=>(0,p.$vo)(Q.identifier,K.identifier))?.type??K.type,this.n.validate(K,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanExtension(U);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(U);return this.J(B,G,T,!0)}async scanMetadata(q){const G=(0,d.$ug)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$ug)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),B=JSON.parse(U);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,B.__metadata={...B.__metadata,...G},await this.w.writeFile((0,d.$ug)(q,"package.json"),A.$ae.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$pp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ae.fromString(JSON.stringify([])))}catch(G){(0,a.$mk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,U){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,X)=>{const K=O.$mc(B.location.fsPath),Q=O.$mc(X.location.fsPath);return K<Q?-1:K>Q?1:0})}L(q,G,T,U,B){const X=(Q,F,z)=>{if(Q.isValid&&!F.isValid)return!1;if(Q.isValid===F.isValid){if(B&&S.gt(Q.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(S.eq(Q.manifest.version,F.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`),!0},K=new P.$4l;return q?.forEach(Q=>{const F=K.get(Q.identifier.id);(!F||X(F,Q,!1))&&K.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const F=K.get(Q.identifier.id);if(!F&&q&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!F||X(F,Q,!1))&&K.set(Q.identifier.id,Q)}),T?.forEach(Q=>{const F=K.get(Q.identifier.id);(!F||X(F,Q,!0))&&K.set(Q.identifier.id,Q),K.set(Q.identifier.id,Q)}),[...K.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=G?await this.O():{},B=[],X=h.URI.file(O.$gc(O.$ic(b.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of T){const F=U[Q.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":B.push((0,d.$ug)(X,Q.name));break;default:B.push(h.URI.file(F));break}}const K=await Promise.all(B.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",K.length),(0,L.$Gb)(K)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,U,B,X,K){const Q=await this.f(B??m.$w),F=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(q,F,z,o,G,K,T,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,Q)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$vp=x,e.$vp=x=pe([se(4,y.$Hk),se(5,k.$qp),se(6,a.$9j),se(7,n.$8i),se(8,I.$Uh),se(9,s.$nj),se(10,E.$Fk),se(11,i.$Mh)],x);class _{constructor(q,G,T,U,B,X,K,Q,F,z,o,g,M,C,Z){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=B,this.profileScanOptions=X,this.type=K,this.excludeObsolete=Q,this.validate=F,this.productVersion=z,this.productDate=o,this.productCommit=g,this.devMode=M,this.language=C,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$ng)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$ng)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&R.$6m(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&W.equals(q.translations,G.translations)}}e.$wp=_;let ue=class extends c.$Rc{constructor(q,G,T,U,B){super(),this.f=q,this.g=G,this.h=T,this.j=U,this.m=B}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$Kf)(T)?G:G.filter(U=>!T[p.$wo.create(U).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,d.$rg)(U.resource).indexOf(".")===0)return null;const B=new _(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Gb)(T).sort((U,B)=>U.location.path<B.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const B=await Promise.all(U.map(async X=>{if(G(X)){const K=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(K,X.metadata)}return null}));return(0,L.$Gb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$ug)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=P.$Xl),G=G??T.__metadata,delete T.__metadata;const U=(0,p.$Ao)(T.publisher,T.name),B=G?.id?{id:U,uuid:G.id}:{id:U},X=G?.isSystem?0:q.type,K=X===0||!!G?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const Q={type:X,identifier:B,manifest:T,location:q.location,isBuiltin:K,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const U=(0,t.$Lo)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,X]of U)B===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const G=(0,d.$ug)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(B){return(0,a.$mk)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,B.message))),null}let U;try{U=JSON.parse(T)}catch{const X=[];(0,v.$Rm)(T,X);for(const K of X)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,K.offset,K.length,(0,u.$sp)(K.error))));return null}return(0,v.$1m)(U)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):U}async t(q,G,T){const U=await this.u(q,G,T);if(U)try{const B=[],X=await this.w(U.default,B);if(B.length>0)return B.forEach(Q=>{this.m.error(this.z(q,(0,f.localize)(3,null,U.default?.path,(0,u.$sp)(Q.error))))}),G;if((0,v.$1m)(U)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,U.default?.path))),G;const K=U.values||Object.create(null);return(0,N.$tp)(this.m,G,K,X)}catch{}return G}async u(q,G,T){const U=(0,d.$ug)(q,"package.nls.json"),B=(F,z)=>{z.forEach(o=>{this.m.error(this.z(q,(0,f.localize)(5,null,F?.path,(0,u.$sp)(o.error))))})},X=F=>{this.m.error(this.z(q,(0,f.localize)(6,null,F?.path)))},K=`${G.publisher}.${G.name}`,Q=T.translations[K];if(Q)try{const F=h.URI.file(Q),z=(await this.j.readFile(F)).value.toString(),o=[],g=(0,v.$Rm)(z,o);return o.length>0?(B(F,o),{values:void 0,default:U}):(0,v.$1m)(g)!=="object"?(X(F),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),g=[],M=(0,v.$Rm)(o,g);return g.length>0?(B(z.localized,g),{values:void 0,default:z.original}):(0,v.$1m)(M)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:M,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$Rm)(T,G)}catch{}}y(q,G){return new Promise((T,U)=>{const B=X=>{const K=(0,d.$ug)(q,`package.nls.${X}.json`);this.j.exists(K).then(Q=>{Q&&T({localized:K,original:(0,d.$ug)(q,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?T({localized:(0,d.$ug)(q,"package.nls.json"),original:null}):(X=X.substring(0,F),B(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$ug)(q,"package.nls.json"),original:null});B(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=pe([se(1,k.$qp),se(2,E.$Fk),se(3,a.$9j),se(4,n.$8i)],ue);let te=class extends ue{constructor(q,G,T,U,B,X,K){super(G,U,B,X,K),this.G=q,this.H=T,this.D=this.B(new D.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const U=await super.scanExtensions(q);return await this.J(G,{input:q,result:U}),U}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$kh)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(G))}return null}async J(q,G){try{await this.j.writeFile(q,A.$ae.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$6m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?P.$Wl:P.$Vl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Hk),se(3,k.$qp),se(4,E.$Fk),se(5,a.$9j),se(6,n.$8i)],te);function ae(ie,q){const G=(0,p.$yo)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new P.$2l(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$xp=ae;class le extends x{constructor(q,G,T,U,B,X,K,Q,F,z,o,g){super(q,G,(0,d.$ug)(T,".vscode-oss-dev","extensions","control.json"),U,B,X,K,Q,F,z,o,g),this.R=(async()=>{if(m.$z)try{const M=await this.w.readFile(h.URI.file(m.$z));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$yp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,R,A,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let m=class extends j.$Rc{constructor(S,w){super(),this.b=S,this.f=w,this.a=new D.$Yg(5)}async postUninstall(S){const w=this.g(S,"uninstall");w&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(S))}catch($){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error($)}}g(S,w){const $=`vscode:${w}`;if(S.location.scheme===v.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[$]=="string"){const h=S.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${$} should be a node script`),null):{script:(0,u.$ic)(S.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(S,w,$,h,f){return new Promise((I,p)=>{const P=this.j(S,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):I(void 0)};P.on("error",i=>{a((0,R.$yi)(i)||"Unknown")}),P.on("exit",(i,n)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,P.kill(),p("timed out")},5e3))})}j(S,w,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(S,[`--type=extension-post-${w}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(I.stdout,"data"),P=A.Event.fromNodeEventEmitter(I.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),P(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(P,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),I}m(S){return(0,u.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$Ap=m,e.$Ap=m=pe([se(0,O.$Hk),se(1,b.$8i)],m)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;let b=class extends j.$rp{constructor(m,d,S,w,$,h){super(c.URI.file(m.extensionsPath),d,S,w,$,h)}};e.$uN=b,e.$uN=b=pe([se(0,u.$Vh),se(1,v.$9j),se(2,D.$Hk),se(3,R.$Fk),se(4,A.$_k),se(5,L.$8i)],b)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,R,A,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let m=class extends A.$yp{constructor(S,w,$,h,f,I,p,P){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,S.defaultProfile,S,w,$,h,f,I,p,P)}};e.$z7b=m,e.$z7b=m=pe([se(0,O.$Hk),se(1,R.$qp),se(2,j.$9j),se(3,u.$8i),se(4,D.$Vh),se(5,c.$nj),se(6,b.$Fk),se(7,v.$Mh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2o=e.$1o=e.$Zo=void 0,e.$Zo="__$__isNewStorageMarker",e.$1o="__$__targetStorageMarker",e.$2o=(0,u.$Nh)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(f){const I=f.get(e.$1o);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$3o=d;class S extends R.$Rc{static{this.a=60*1e3}constructor(I={flushInterval:S.a}){super(),this.m=I,this.b=this.B(new D.$Pd),this.c=this.B(new D.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new L.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,P){return D.Event.filter(this.b.event,t=>t.scope===I&&(p===void 0||t.key===p),P)}n(){this.j.value=(0,L.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:P,external:t}=p;if(P===e.$1o){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:P,target:this.J(I)[P],external:t})}w(I){this.f.fire({reason:I})}get(I,p,P){return this.P(p)?.get(I,P)}getBoolean(I,p,P){return this.P(p)?.getBoolean(I,P)}getNumber(I,p,P){return this.P(p)?.getNumber(I,P)}getObject(I,p,P){return this.P(p)?.getObject(I,P)}storeAll(I,p){this.y(()=>{for(const P of I)this.store(P.key,P.value,P.scope,P.target,p)})}store(I,p,P,t,a=!1){if((0,j.$Gf)(p)){this.remove(I,P,a);return}this.y(()=>{this.z(I,P,t),this.P(P)?.set(I,p,a)})}remove(I,p,P=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,P)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const P=[],t=this.J(I);for(const a of Object.keys(t))t[a]===p&&P.push(a);return P}z(I,p,P,t=!1){const a=this.J(p);typeof P=="number"?a[I]!==P&&(a[I]=P,this.P(p)?.set(e.$1o,JSON.stringify(a),t)):typeof a[I]=="number"&&(delete a[I],this.P(p)?.set(e.$1o,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$Zo,I)===!0}async flush(I=b.NONE){this.f.fire({reason:I});const p=this.P(-1),P=this.P(0),t=this.P(1);switch(I){case b.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,P=this.P(1)?.items??new Map;return h(I,p,P,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(b.NONE),(0,c.$Gk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||w(p)&&w(I))}N(I,p,P){this.y(()=>{const t=new Set;for(const[a,i]of I)t.add(a),p.get(a)!==i&&this.u(P,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(P,{key:a,external:!0})})}}e.$4o=S;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$5o=w;class $ extends S{constructor(){super(),this.U=this.B(new v.$Xo(new v.$Yo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$Xo(new v.$Yo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$Xo(new v.$Yo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$6o=$;async function h(f,I,p,P,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,s=new Map;f.forEach((W,x)=>{n.set(x,W),s.set(x,i(W))});const r=new Map,l=new Map;I.forEach((W,x)=>{r.set(x,W),l.set(x,i(W))});const k=new Map,y=new Map;p.forEach((W,x)=>{k.set(x,W),y.set(x,i(W))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const E=[];if(n.forEach((W,x)=>{E.push({key:x,value:W})}),console.table(E),console.groupEnd(),console.log(s),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];r.forEach((x,_)=>{W.push({key:_,value:x})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const N=[];k.forEach((W,x)=>{N.push({key:x,value:W})}),console.table(N),console.groupEnd(),console.log(y)}e.$7o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=void 0;const t=A.$p?"web":(0,O.$1n)(A.$u,j.$dc),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...o){return String(o.reduce((g,M)=>g|M,0))}var s;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(g=y){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,M=this.d.pageSize){return new E({...this.d,pageNumber:g,pageSize:M})}withFilter(g,...M){const C=[...this.d.criteria,...M.length?M.map(Z=>({filterType:g,value:Z})):[{filterType:g}]];return new E({...this.d,criteria:C})}withSortBy(g){return new E({...this.d,sortBy:g})}withSortOrder(g){return new E({...this.d,sortOrder:g})}withFlags(...g){return new E({...this.d,flags:g.reduce((M,C)=>M|C,0)})}withAssetTypes(...g){return new E({...this.d,assetTypes:g})}withSource(g){return new E({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:H,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:g,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:H}],assetTypes:oe,flags:ce}}get searchText(){const g=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(o,g){const M=(o||[]).filter(C=>C.statisticName===g)[0];return M?M.value:0}function W(o){const g="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(C=>C.assetType.indexOf(g)===0).reduce((C,Z)=>{const H=ue(o,Z.assetType);return H&&C.push([Z.assetType.substring(g.length),H]),C},[])}function x(o){if(o.properties){const g=o.properties.filter(Z=>Z.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=g.filter(Z=>M.test(Z.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,g){return o.files.filter(C=>C.assetType===g)[0]?{uri:`${o.assetUri}/${g}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${g}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,g){const M=o.properties?o.properties.filter(Z=>Z.key===g):[],C=M.length>0&&M[0].value;return C?C.split(",").map(Z=>(0,m.$zo)(Z)):[]}function ae(o){const g=o.properties?o.properties.filter(M=>M.key===l.Engine):[];return g.length>0&&g[0].value||""}function le(o){const g=o.properties?o.properties.filter(M=>M.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(o){const g=o.properties?o.properties.filter(C=>C.key===l.LocalizedLanguages):[],M=g.length>0&&g[0].value||"";return M?M.split(","):[]}function q(o){return o.properties?.find(g=>g.key===l.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,O.$Zn)(o.targetPlatform):"undefined"}function U(o){const g=(0,L.$Lb)(o.versions.map(T)),M=!!o.tags?.includes(O.$Un),C=g.indexOf("web");return M?C===-1&&g.push("web"):C!==-1&&g.splice(C,1),g}function B(o,g){const M=(0,O.$4n)(g);for(let C=0;C<o.length;C++){const Z=o[C];if(Z.version===o[C-1]?.version){let H=C;const ce=T(Z);if(ce===g)for(;H>0&&o[H-1].version===Z.version;)H--;else if(M.includes(ce))for(;H>0&&o[H-1].version===Z.version&&T(o[H-1])!==g;)H--;H!==C&&(o.splice(C,1),o.splice(H,0,Z))}}return o}e.$0o=B;function X(o,g,M){o.telemetryData={index:g,querySource:M,queryActivityId:o.queryContext?.[a]}}function K(o,g,M,C){const Z=o.versions[0],H={manifest:ue(g,r.Manifest),readme:ue(g,r.Details),changelog:ue(g,r.Changelog),license:ue(g,r.License),repository:x(g),download:_(g),icon:ue(g,r.Icon),signature:ue(g,r.Signature),coreTranslations:W(g)};return{identifier:{id:(0,m.$Ao)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:g.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:o.shortDescription||"",installCount:N(o.statistics,"install"),rating:N(o.statistics,"averagerating"),ratingCount:N(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:M,assets:H,properties:{dependencies:te(g,l.Dependency),extensionPack:te(g,l.ExtensionPack),engine:ae(g),localizedLanguages:ie(g),targetPlatform:T(g),isPreReleaseVersion:le(g)},hasPreReleaseVersion:le(Z),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!H.signature,queryContext:C}}let Q=class{constructor(g,M,C,Z,H,ce,oe,me){this.k=M,this.l=C,this.n=Z,this.o=H,this.q=ce,this.u=oe,this.w=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$9o)(oe.version,oe,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,M,C){const Z=D.CancellationToken.isCancellationToken(M)?{}:M,H=D.CancellationToken.isCancellationToken(M)?M:C,ce=[],oe=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new E().withPage(1,g.length);oe.length&&(fe=fe.withFilter(s.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(s.ExtensionName,...ce)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??t,includePreRelease:me,versions:de,compatible:!!Z.compatible},H);return Z.source&&he.forEach((we,be)=>X(we,be,Z.source)),he}async getCompatibleExtension(g,M,C){if((0,O.$2n)(g.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(g,M,C))return g;const Z=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,g.identifier.uuid),{extensions:H}=await this.z(Z,{targetPlatform:C,compatible:!0,includePreRelease:M},D.CancellationToken.None);return H[0]||null}async isExtensionCompatible(g,M,C){if(!(0,O.$3n)(g.properties.targetPlatform,g.allTargetPlatforms,C)||!M&&g.properties.isPreReleaseVersion)return!1;let Z=g.properties.engine;if(!Z){const H=await this.getManifest(g,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");Z=H.engines.vscode}return(0,d.$No)(Z,this.u.version,this.u.date)}async y(g,M,C,Z,H){if(!(0,O.$3n)(T(g),Z,H)||M!=="any"&&le(g)!==(M==="prerelease"))return!1;if(C)try{const ce=await this.E(g);if(!(0,d.$No)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,R.$9)(ce)),!1}return!0}async query(g,M){let C=g.text||"";const Z=g.pageSize??50;let H=new E().withPage(1,Z);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(H=H.withFilter(s.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(H=H.withFilter(s.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),H=H.withFilter(s.SearchText,C)),H=H.withSortBy(0)):g.ids?H=H.withFilter(s.ExtensionId,...g.ids):g.names?H=H.withFilter(s.ExtensionName,...g.names):H=H.withSortBy(4),typeof g.sortBy=="number"&&(H=H.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(H=H.withSortOrder(g.sortOrder)),g.source&&(H=H.withSource(g.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,Pe)=>X(be,(ge.pageNumber-1)*ge.pageSize+Pe,g.source)),{extensions:he,total:we}},{extensions:oe,total:me}=await ce(H,M),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$4;const{extensions:he}=await ce(H.withPage(ge+1),fe);return he};return{firstPage:oe,total:me,pageSize:H.pageSize,getPage:de}}async z(g,M,C){const Z=g.flags;g.flags&i.IncludeLatestVersionOnly&&g.flags&i.IncludeVersions&&(g=g.withFlags(g.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(g.flags&i.IncludeLatestVersionOnly)&&!(g.flags&i.IncludeVersions)&&(g=g.withFlags(g.flags,i.IncludeLatestVersionOnly)),M.versions?.length&&(g=g.withFlags(g.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),g=g.withFlags(g.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:H,total:ce,context:oe}=await this.B(g,C);if(!(g.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of H){const we=await this.A(he,M,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<H.length;fe++){const he=H[fe],we={id:(0,m.$Ao)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,m.$vo)(Me,we))?.includePreRelease;if(M.compatible&&(0,O.$2n)(U(he),M.targetPlatform))continue;const Pe=await this.A(he,M,oe);!Pe||Pe.properties.isPreReleaseVersion&&(!be||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==M.targetPlatform&&Pe.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Pe])}if(ge.size){const fe=new P.$Id,he=new E().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(s.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,M,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Pe=ge.get(be.identifier.uuid);de.push([Pe,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(g,M,C){const Z={id:(0,m.$Ao)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},H=M.versions?.find(de=>(0,m.$vo)(de,Z))?.version,ce=(0,v.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(de=>(0,m.$vo)(de,Z))?.includePreRelease,oe=U(g),me=B(g.versions,M.targetPlatform);if(M.compatible&&(0,O.$2n)(oe,M.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(H&&ge.version!==H)){if(await this.y(ge,ce?"any":"release",M.compatible,oe,M.targetPlatform))return K(g,ge,oe,C);if(H&&ge.version===H)return null}}return H||M.compatible?null:K(g,g.versions[0],oe)}async B(g,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(i.Unpublished));const C=await this.j,Z=JSON.stringify(g.raw),H={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ce=new P.$Id;let oe,me,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:H},M),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Uo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(Z.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Qo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,R.$3)(me)?"canceled":(0,R.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,M,C,Z){if(!this.isEnabled())return;const H=A.$p?this.x(`/itemName/${g}.${M}/version/${C}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${M}/${C}/stats?statType=${Z}`),ce=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:H,headers:me},D.CancellationToken.None)}catch{}}async download(g,M,C){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const Z=(0,m.$Do)(g),H=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=C===2?"install":C===3?"update":"",me=oe?{uri:`${g.assets.download.uri}${u.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${u.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[a]?{[a]:g.queryContext[a]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(M,ge.stream),ce(new Date().getTime()-H)}async downloadSignatureArchive(g,M){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const C=await this.D(g.assets.signature);await this.q.writeFile(M,C.stream)}async getReadme(g,M){if(g.assets.readme){const C=await this.D(g.assets.readme,{},M);return await(0,h.$To)(C)||""}return""}async getManifest(g,M){if(g.assets.manifest){const C=await this.D(g.assets.manifest,{},M),Z=await(0,h.$To)(C);return Z?JSON.parse(Z):null}return null}async C(g,M){const C=ue(g,r.Manifest);if(!C)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},H=await this.D(C,{headers:Z});return await(0,h.$Uo)(H)}async getCoreTranslation(g,M){const C=g.assets.coreTranslations.filter(Z=>Z[0]===M.toUpperCase())[0];if(C){const Z=await this.D(C[1]),H=await(0,h.$To)(Z);return H?JSON.parse(H):null}return null}async getChangelog(g,M){if(g.assets.changelog){const C=await this.D(g.assets.changelog,{},M);return await(0,h.$To)(C)||""}return""}async getAllCompatibleVersions(g,M,C){let Z=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?Z=Z.withFilter(s.ExtensionId,g.identifier.uuid):Z=Z.withFilter(s.ExtensionName,g.identifier.id);const{galleryExtensions:H}=await this.B(Z,D.CancellationToken.None);if(!H.length)return[];const ce=U(H[0]);if((0,O.$2n)(ce,C))return[];const oe=[];await Promise.all(H[0].versions.map(async ge=>{try{await this.y(ge,M?"any":"release",!0,ce,C)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(oe,C))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async D(g,M={},C=D.CancellationToken.None){const Z=await this.j,H={type:"GET"},ce={...Z,...M.headers||{}};M={...M,...H,headers:ce};const oe=g.uri,me=g.fallbackUri,de={...M,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$To)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$3)(ge))throw ge;const fe=(0,R.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...M,url:me};return this.k.request(he,C)}}async E(g){let M=ae(g);if(!M){const C=await this.C(g,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");M=C.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$Uo)(g),C=[],Z={},H=[];if(M){for(const ce of M.malicious)C.push({id:ce});if(M.migrateToPreRelease)for(const[ce,oe]of Object.entries(M.migrateToPreRelease))(!oe.engine||(0,d.$No)(oe.engine,this.u.version,this.u.date))&&(Z[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ce,oe]of Object.entries(M.deprecated))oe&&(Z[ce.toLowerCase()]=(0,v.$Df)(oe)?{}:oe);if(M.search)for(const ce of M.search)H.push(ce)}return{malicious:C,deprecated:Z,search:H}}};Q=pe([se(1,h.$Oo),se(2,w.$8i),se(3,b.$Uh),se(4,p.$_k),se(5,S.$9j),se(6,$.$nj),se(7,c.$hi)],Q);let F=class extends Q{constructor(g,M,C,Z,H,ce,oe,me){super(g,M,C,Z,H,ce,oe,me)}};e.$$o=F,e.$$o=F=pe([se(0,I.$2o),se(1,h.$Oo),se(2,w.$8i),se(3,b.$Uh),se(4,p.$_k),se(5,S.$9j),se(6,$.$nj),se(7,c.$hi)],F);let z=class extends Q{constructor(g,M,C,Z,H,ce,oe){super(void 0,g,M,C,Z,H,ce,oe)}};e.$_o=z,e.$_o=z=pe([se(0,h.$Oo),se(1,w.$8i),se(2,b.$Uh),se(3,p.$_k),se(4,S.$9j),se(5,$.$nj),se(6,c.$hi)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,A,j,v,u,c,b){"use strict";var O,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=void 0;let d=class extends u.$Kk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,P){super(I,p,f,P),this.U=h,this.W=I}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,c.$xf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rN=d,e.$rN=d=O=pe([se(0,j.$mN),se(1,v.$Fk),se(2,D.$Vh),se(3,R.$9j),se(4,A.$8i)],d);let S=m=class extends d{constructor(h,f,I,p,P){super(h,f,I,p,P),this.$=h}P(h){h.length?this.$.setItem(m.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(m.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(m.c,h):this.$.removeItem(m.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((P,{workspace:t,profile:a})=>(P[L.URI.revive(t).toString()]=L.URI.revive(a).toString(),P),{});this.$.setItem(m.c,{workspaces:p})}const I=super.Q();return this.$.getItem(m.a,!1)||(this.R(I),this.$.setItem(m.a,!0)),I}};e.$sN=S,e.$sN=S=m=pe([se(0,j.$nN),se(1,v.$Fk),se(2,D.$Vh),se(3,R.$9j),se(4,A.$8i)],S);let w=class extends S{constructor(h,f,I,p){super(new b.$qN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$tN=w,e.$tN=w=pe([se(0,v.$Fk),se(1,D.$Vh),se(2,R.$9j),se(3,A.$8i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.zip=e.$hp=e.$gp=void 0,e.$gp="end of central directory record signature not found";const b=new RegExp(e.$gp);class O extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.$hp=O;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function d(t){if(t instanceof O)return t;let a;return b.test(t.message)&&(a="CorruptZip"),new O(a,t)}function S(t,a,i,n,s,r){const l=R.$lc(a),k=R.$ic(n,l);if(!k.startsWith(n))return Promise.reject(new Error(v.localize(0,null,a)));const y=R.$ic(n,a);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(j.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((N,W)=>{if(!r.isCancellationRequested)try{E=(0,L.createWriteStream)(y,{mode:i}),E.once("close",()=>N()),E.once("error",W),t.once("error",W),t.pipe(E)}catch(x){W(x)}}))}function w(t,a,i,n){let s=(0,D.$Gg)(()=>Promise.resolve()),r=0;const l=n.onCancellationRequested(()=>{s.cancel(),t.close()});return new Promise((k,y)=>{const E=new D.$Ng,N=W=>{W.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>s.then(()=>{n.isCancellationRequested||t.entryCount===r?k():y(new O("Incomplete",new Error(v.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",W=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(W.fileName)){N(n);return}const x=W.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const te=R.$ic(a,x);s=(0,D.$Gg)(ae=>j.Promises.mkdir(te,{recursive:!0}).then(()=>N(ae)).then(void 0,y));return}const _=h(t,W),ue=m(W);s=(0,D.$Gg)(te=>E.queue(()=>_.then(ae=>S(ae,x,ue,a,i,te).then(()=>N(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(t,a=!1){return new Promise((i,n)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(s,r)=>{s?n(d(s)):i((0,A.$If)(r))})})}function h(t,a){return new Promise((i,n)=>{t.openReadStream(a,(s,r)=>{s?n(d(s)):i((0,A.$If)(r))})})}function f(t,a){return new Promise((i,n)=>{const s=new c.ZipFile;a.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const r=(0,L.createWriteStream)(t);s.outputStream.pipe(r),s.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>i(t))})}e.zip=f;function I(t,a,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(l=>j.Promises.rm(a).then(()=>l))),r.then(l=>w(l,a,{sourcePathRegex:s},n))}e.$jp=I;function p(t,a){return $(t).then(i=>new Promise((n,s)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(l=>n(l),l=>s(l))}),i.once("close",()=>s(new Error(v.localize(2,null,a))))}))}function P(t,a){return p(t,a).then(i=>new Promise((n,s)=>{const r=[];i.once("error",s),i.on("data",l=>r.push(l)),i.on("end",()=>n(Buffer.concat(r)))}))}e.$kp=P}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;let p=class extends R.$Rc{static{I=this}static{this.c=".sigzip"}constructor(t,a,i,n,s,r){super(),this.h=a,this.j=i,this.m=n,this.n=s,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const n=(0,j.$ug)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,a))}catch(r){throw new S.$7n(r.message,S.ExtensionManagementErrorCode.Download)}let s=!1;if(i&&this.t(t)){const r=await this.u(t);try{s=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const k=l;if(s=k.code,k.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${k.output}`),s===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.$7n(O.$gp,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:n,verificationStatus:s}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$Df)(a)?a:!0}async u(t){await this.g;const a=(0,j.$ug)(this.extensionsDownloadDir,`${this.z(t)}${I.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const n=(0,j.$ug)(this.extensionsDownloadDir,`.${(0,c.$dg)()}`);await this.h.exists(n)||await i(n);try{await b.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,D.$9)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const l of t.children)if(l.name.endsWith(I.c))n.push(l.resource);else{const k=w.$wo.parse(l.name);k&&i.push([k,l])}const s=(0,w.$Bo)(i,([l])=>l),r=[];for(const l of s)l.sort((k,y)=>v.rcompare(k[0].version,y[0].version)),a.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),a.push(...n),await L.Promises.settled(a.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$wo.create(t).toString().toLowerCase():(0,c.$dg)()}};e.$zp=p,e.$zp=p=I=pe([se(0,d.$Vh),se(1,h.$9j),se(2,S.$6n),se(3,m.$hi),se(4,$.$ap),se(5,f.$8i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function R(A){return(0,L.$kp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Bp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,N,W,x,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0,e.$Ep=(0,_.$Oh)(i.$8n);const q=".vsctmp";let G=class extends a.$lp{constructor(F,z,o,g,M,C,Z,H,ce,oe,me,de){super(F,z,me,o,oe,de),this.fb=M,this.gb=C,this.hb=Z,this.ib=ce,this.eb=new Map,this.rb=new b.$Ac;const ge=this.B(H.createInstance(k.$Ap));this.bb=this.B(H.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new E.$Cp(de,ce,me,this,this.F)),this.db=this.B(H.createInstance(l.$zp));const fe=this.B(new N.$Dp(this,this.fb,de,C,me,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Go)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.pb(F),o=await(0,I.zip)((0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)()).fsPath,z);return $.URI.file(o)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:o}=await this.lb(F),g=m.$jc(z.fsPath);try{return await(0,y.$Bp)(g)}finally{await o()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:o,cleanup:g}=await this.lb(F);try{const M=await(0,y.$Bp)(m.$jc(o.fsPath)),C=(0,n.$Ao)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,W.$No)(M.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:M,extension:o,options:z}])).find(({identifier:ce})=>(0,n.$vo)(ce,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,a.$np)(new Error(`Unknown error while installing extension ${C}`))}finally{await g()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const o=await this.bb.scanUserExtensionAtLocation(F);if(!o)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(F,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),o.toString());const g=(await this.bb.scanExtensions(1,z)).filter(M=>F.some(C=>(0,n.$vo)(C,M.identifier)));if(g.length){const M=await Promise.all(g.map(C=>this.bb.scanMetadata(C,z)));await this.ub(g.map((C,Z)=>[C,M[Z]]),o),this.F.info("Successfully installed extensions",g.map(C=>C.identifier.id),o.toString())}return g}async updateMetadata(F,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,F=await this.bb.updateMetadata(F,z,o),this.cb.invalidate(o),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(g){throw new Error(p.localize(3,null,(0,A.$yi)(g)))}return this.installFromGallery(o)}ab(F,z,o,g){return this.bb.copyExtension(F,z,o,g)}copyExtensions(F,z){return this.bb.copyExtensions(F,z)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,o){const{location:g}=await this.db.download(F,z,!o);return g}async lb(F){if(F.scheme===O.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)());return await this.hb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,z,o){if($.URI.isUri(z))return new X(F,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=n.$wo.create(z).toString();let M=this.eb.get(g);return M||(this.eb.set(g,M=new B(F,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),M}$(F,z){return new K(F,z.profileLocation,this.gb)}async pb(F){const z=async g=>{let M=await f.Promises.readdir(g);M=M.map(H=>m.$ic(g,H));const C=await Promise.all(M.map(H=>f.Promises.stat(H)));let Z=Promise.resolve([]);return C.forEach((H,ce)=>{const oe=M[ce];H.isFile()&&(Z=Z.then(me=>[...me,oe])),H.isDirectory()&&(Z=Z.then(me=>z(oe).then(de=>[...me,...de])))}),Z};return(await z(F.location.fsPath)).map(g=>({path:`extension/${m.$kc(F.location.fsPath,g)}`,localPath:g}))}async qb({added:F,removed:z}){if(z){const o=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(g=>F.extensions.every(M=>!(0,n.$vo)(M,g))):z.extensions;for(const g of o)this.F.info("Extensions removed from another source",g.id,z.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:z.profileLocation})}if(F){const g=(await this.bb.scanExtensions(1,F.profileLocation)).filter(M=>F.extensions.some(C=>(0,n.$vo)(C,M.identifier)));this.s.fire(g.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of F.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(o);g&&g.installedTimestamp===void 0&&(this.rb.add(o),z.push(g))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(F,z){const o=F.map(g=>g[0]);await this.vb(o),await this.gb.addExtensionsToProfile(F,z),this.s.fire(o.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:z})))}async vb(F){const z=await this.bb.getUninstalledExtensions();for(const o of F){const g=n.$wo.create(o);z[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Fp=G,e.$Fp=G=pe([se(0,i.$6n),se(1,ae.$_k),se(2,ue.$8i),se(3,t.$Vh),se(4,r.$up),se(5,s.$qp),se(6,P.$Jn),se(7,_.$Mh),se(8,x.$9j),se(9,te.$nj),se(10,le.$Fk),se(11,ie.$Hk)],G);let T=class extends c.$Rc{constructor(F,z,o,g,M,C){super(),this.j=F,this.m=z,this.n=o,this.s=g,this.t=M,this.u=C,this.h=this.B(new v.$Md),this.onExtract=this.h.event,this.c=(0,d.$ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Zg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z){const o={includeInvalid:!0,profileLocation:z};let g=[];return F===null||F===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):F===1&&g.push(...await this.n.scanUserExtensions(o)),g=F!==null?g.filter(M=>M.type===F):g,Promise.all(g.map(M=>this.F(M)))}async scanAllUserExtensions(F){const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,o,g,M){const C=F.toString(),Z=$.URI.file(m.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$dg)()}`)),H=$.URI.file(m.$ic(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(H);if(ce&&g){try{await this.y(F.id,H,"removeExisting")}catch{throw new i.$7n(p.localize(4,null,H.fsPath,F.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,I.$jp)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${H}:`,F.id)}catch(oe){let me=i.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$hp&&(oe.type==="CorruptZip"?me=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$7n(oe.message,me)}await this.n.updateMetadata(Z,o);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${H.fsPath}`),await this.C(Z.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(H)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(H,1)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(g=>(0,n.$vo)(g.identifier,F.identifier))}async updateMetadata(F,z,o){return o?await this.s.updateMetadata([[F,z]],o):await this.n.updateMetadata(F.location,z),this.D(F.location,F.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const z=F.map(o=>n.$wo.create(o));await this.z(o=>z.forEach(g=>{o[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(F){await this.z(z=>delete z[F.toString()])}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[n.$wo.create(F).toString()])}async copyExtension(F,z,o,g){const M=await this.w(F,z),C=await this.w(F,o);return g={...M?.metadata,...g},C?await this.s.updateMetadata([[F,{...C.metadata,...g}]],o):await this.s.addExtensionsToProfile([[F,g]],o),this.D(F.location,F.type,o)}async copyExtensions(F,z){const o=await this.scanExtensions(1,F),g=await Promise.all(o.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(g,z)}async y(F,z,o){this.u.trace(`Deleting ${o} extension from disk`,F,z.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Bi)((0,h.$dg)()).toString(16)}${q}`);await this.C(z.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,F,z.fsPath)}async z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,x.$mk)(g)!==1)throw g}let o={};if(z)try{o=JSON.parse(z)}catch{}return F&&(F(o),Object.keys(o).length?await this.m.writeFile(this.c,D.$ae.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(F,z){try{await f.Promises.rename(F,z,2*60*1e3)}catch(o){throw new i.$7n(o.message||p.localize(5,null,F,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(F,z,o){if(o){const M=(await this.n.scanUserExtensions({profileLocation:o})).find(C=>this.t.extUri.isEqual(C.location,F));if(M)return this.F(M)}else{const g=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,F.path))}async F(F){const z=await this.m.resolve(F.location);let o,g;return z.children&&(o=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,g=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:o,changelogUrl:g,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const M of z)F[n.$wo.create(M).toString()]||o.add(M.identifier.id.toLowerCase());try{const M=(0,n.$Bo)(z,C=>C.identifier);await L.Promises.settled(M.map(async C=>{const Z=C.sort((H,ce)=>S.rcompare(H.manifest.version,ce.manifest.version))[0];o.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(M){this.u.error(M)}const g=z.filter(M=>M.metadata&&F[n.$wo.create(M).toString()]);await Promise.allSettled(g.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,x.$mk)(z)!==1&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,x.$mk)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$Gp=T,e.$Gp=T=pe([se(1,x.$9j),se(2,r.$up),se(3,s.$qp),se(4,le.$Fk),se(5,ue.$8i)],T);class U extends a.$op{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$Ef)(this.options.operation)?this.l:this.options.operation}constructor(F,z,o,g,M,C,Z,H,ce){super(),this.identifier=F,this.source=z,this.options=o,this.m=g,this.n=M,this.o=C,this.p=Z,this.q=H,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[z,o]=await this.x(F);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:F,key:z,metadata:o},g,M){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,F,o,g,M),this.s.info("Extracting extension completed.",z.id)),C}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(g=>n.$wo.create(g).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class B extends U{constructor(F,z,o,g,M,C,Z,H,ce,oe){super(z.identifier,z,o,M,C,Z,H,ce,oe),this.y=z,this.z=g}async x(F){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,n.$vo)(Z.identifier,this.y.identifier));o&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$Df)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,g),g];const{location:M,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:n.$wo.create(this.y),metadata:g},!1,F),g]}catch(Z){try{await this.z.delete(M)}catch(H){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,j.$9)(H))}throw Z}}async B(F){try{await(0,y.$Bp)(F)}catch(z){throw new i.$7n((0,a.$mp)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$Hp=B;class X extends U{constructor(F,z,o,g,M,C,Z,H,ce,oe){super({id:(0,n.$Ao)(F.publisher,F.name)},z,o,M,C,Z,H,ce,oe),this.y=F,this.z=z,this.A=g}async h(F){const z=await super.h(F);return this.D(z,F),z}async x(F){const z=new n.$wo(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,n.$vo)(this.identifier,Z.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,z.equals(new n.$wo(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$jc(this.z.fsPath),key:z,metadata:M},!0,F),M]}async D(F,z){try{let[o]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:F.identifier.id}],z)),o){const g={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,g,this.options.profileLocation)}}catch{}}}class K extends a.$op{constructor(F,z,o){super(),this.extension=F,this.j=z,this.k=o}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;let S=class extends O.$Po{constructor(f,I,p,P){super(P),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:P}=this;let t;try{t=await(0,c.$Pl)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(n)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,m.$Tq)(f.url||"",a,{proxyUrl:p,strictSSL:P});return f.agent=i,f.strictSSL=P,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Uq=S,e.$Uq=S=pe([se(0,v.$hi),se(1,u.$Vh),se(2,b.$8i),se(3,b.$9i)],S);async function w(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,P)=>{J(["https"],p,P)}):await new Promise((p,P)=>{J(["http"],p,P)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(I,p)=>{const P=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:P.hostname,port:P.port?parseInt(P.port):P.protocol==="https:"?443:80,protocol:P.protocol,path:P.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$Df)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,n=>{const s=(0,j.$Bf)(h.followRedirects)?h.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)$({...h,url:n.headers.location,followRedirects:s-1},f).then(I,p);else{let r=n;!h.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),I({res:n,stream:(0,R.$pe)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$4)})})}e.$Vq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,A,j,v,u,c,b,O,m,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,N,W,x,_,ue,te,ae,le,ie,q,G,T,U,B,X,K,Q,F,z,o,g,M,C,Z,H,ce,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Pe=be.get(_.$8i),Me=be.get(r.$9j),V=be.get(h.$Vh),Y=be.get(g.$Hk);Pe.info("CLI main",this.b),this.g(Pe),await this.h(V,Me,Y,he),await Promise.all(we.map(ee=>{(0,D.$Kg)(ee.flush(),1e3)}))})}async f(){const he=new N.$Lh,we={_serviceBrand:void 0,...le.default};he.set(ie.$nj,we);const be=new f.$fm(this.b,we);he.set(h.$Vh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?m.Promises.mkdir(De,{recursive:!0}):void 0));const Pe=new ce.$lN((0,_.$jj)(be),be.logsHome);he.set(_.$9i,Pe);const Me=this.B(Pe.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];Pe.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$dj(Pe.getLogLevel()));const Y=this.B(new H.$vN(Me,V));he.set(_.$8i,Y);const ee=this.B(new l.$Jp(Y));he.set(r.$9j,ee);const $e=this.B(new k.$9p(Y));ee.registerProvider(v.Schemas.file,$e);const ye=new o.$vr(ee);he.set(z.$Fk,ye);const Ne=new T.$pN(1,be,Y,ee),Se=new M.$rN(Ne,ye,be,ee,Y);he.set(g.$Hk,Se),ee.registerProvider(v.Schemas.vscodeUserData,new me.$Y7b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Se,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$W7b(Y,we.win32RegValueName)):be.policyFile?this.B(new ue.$X7b(be.policyFile,ee,Y)):new te.$fn;he.set(te.$dn,Le);const Ie=this.B(new S.$Fn(Se.defaultProfile.settingsResource,ee,Le,Y));he.set(d.$hi,Ie),await Promise.all([Ne.init(),Ie.initialize()]);let Ae;try{Ae=await(0,C.$C7b)(Ne,Y)}catch(De){De.code!=="ENOENT"&&Y.error(De)}Se.init(),he.set(z.$Fk,new o.$vr(ee));const Fe=new G.$Uq(Ie,be,Y,Pe);he.set(q.$Oo,Fe),he.set(w.$Jn,new y.$Kh($.$KN,void 0,!0)),he.set(a.$qp,new y.$Kh(Z.$uN,void 0,!0)),he.set(i.$up,new y.$Kh(s.$z7b,void 0,!0)),he.set(P.$ap,new y.$Kh(P.$bp,void 0,!0)),he.set(n.$Ep,new y.$Kh(n.$Fp,void 0,!0)),he.set(p.$6n,new y.$Kh(I.$_o,void 0,!0)),he.set(W.$Oq,new y.$Kh(x.$Qq,void 0,!1));const Oe=[],je=(0,K.$so)(we,Ie);if((0,K.$no)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new Q.$jN(Fe,je,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,U.$do)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,je),piiPaths:(0,K.$to)(be)};he.set(B.$_k,new y.$Kh(X.$Wq,[De],!1))}else he.set(B.$_k,K.$ho);return[new E.$_p(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$yi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,be,Pe){let Me;if(he.args.profile&&(Me=be.profiles.find(Y=>Y.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Pe.createInstance(t.$cp,new _.$dj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Pe.createInstance(t.$cp,new _.$dj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(t.$cp,new _.$dj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Pe.createInstance(t.$cp,new _.$dj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$i8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$hc)(we)?we:(0,u.$ic)((0,b.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/874831ebcf088f59735879156f62308ce48f17d1/core/vs/code/node/cliProcessMain.js.map
