/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],D=0,N=te.length;D<N;D++)e[D]=oe[te[D]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const A=new Map,L=new Map,O=new Map,I=new Map;function C(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function d(c,g){const p=c.get(g.detail);p&&(p>=0||c.set(g.detail,p+g.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of P)switch(c.type){case 10:C(A,c);break;case 11:case 12:d(A,c);break;case 21:C(L,c);break;case 22:d(L,c);break;case 33:C(O,c);break;case 34:d(O,c);break;case 31:C(I,c);break;case 32:d(I,c);break}let E=0;O.forEach(c=>E+=c);function $(c){const g=[];return c.forEach((p,w)=>g.push([w,p])),g}return{amdLoad:$(A),amdInvoke:$(L),nodeRequire:$(O),nodeEval:$(I),nodeRequireTotal:E}}static toMarkdownTable(A,L){let O="";const I=[];return A.forEach((C,d)=>{I[d]=C.length}),L.forEach(C=>{C.forEach((d,P)=>{typeof d>"u"&&(d=C[P]="-");const E=d.toString().length;I[P]=Math.max(E,I[P])})}),A.forEach((C,d)=>{O+=`| ${C+" ".repeat(I[d]-C.toString().length)} `}),O+=`|
`,A.forEach((C,d)=>{O+=`| ${"-".repeat(I[d])} `}),O+=`|
`,L.forEach(C=>{C.forEach((d,P)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(I[P]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=D}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,w,h){const l=N(p,w);if(l!==-1)return p[l]}e.$eb=D;function N(p,w,h=p.length-1){for(let l=h;l>=0;l--){const u=p[l];if(w(u))return l}return-1}e.$fb=N;function A(p,w){const h=L(p,w);return h===-1?void 0:p[h]}e.$gb=A;function L(p,w,h=0,l=p.length){let u=h,b=l;for(;u<b;){const k=Math.floor((u+b)/2);w(p[k])?u=k+1:b=k}return u-1}e.$hb=L;function O(p,w){const h=I(p,w);return h===p.length?void 0:p[h]}e.$ib=O;function I(p,w,h=0,l=p.length){let u=h,b=l;for(;u<b;){const k=Math.floor((u+b)/2);w(p[k])?b=k:u=k+1}return u}e.$jb=I;function C(p,w,h=0,l=p.length){const u=I(p,w,h,l);return u===p.length?-1:u}e.$kb=C;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!w(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const h=L(this.e,w,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$lb=d;function P(p,w){if(p.length===0)return;let h=p[0];for(let l=1;l<p.length;l++){const u=p[l];w(u,h)>0&&(h=u)}return h}e.$mb=P;function E(p,w){if(p.length===0)return;let h=p[0];for(let l=1;l<p.length;l++){const u=p[l];w(u,h)>=0&&(h=u)}return h}e.$nb=E;function $(p,w){return P(p,(h,l)=>-w(h,l))}e.$ob=$;function c(p,w){if(p.length===0)return-1;let h=0;for(let l=1;l<p.length;l++){const u=p[l];w(u,p[h])>0&&(h=l)}return h}e.$pb=c;function g(p,w){for(const h of p){const l=w(h);if(l!==void 0)return l}}e.$qb=g}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(O,I){const C=Object.create(null);for(const d of O){const P=I(d);let E=C[P];E||(E=C[P]=[]),E.push(d)}return C}e.$J=D;function N(O,I){const C=[],d=[];for(const P of O)I.has(P)||C.push(P);for(const P of I)O.has(P)||d.push(P);return{removed:C,added:d}}e.$K=N;function A(O,I){const C=[],d=[];for(const[P,E]of O)I.has(P)||C.push(E);for(const[P,E]of I)O.has(P)||d.push(E);return{removed:C,added:d}}e.$L=A;function L(O,I){const C=new Set;for(const d of I)O.has(d)&&C.add(d);return C}e.$M=L}),define(oe[83],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function D(O){return(I,C,d)=>{let P=null,E=null;if(typeof d.value=="function"?(P="value",E=d.value):typeof d.get=="function"&&(P="get",E=d.get),!E)throw new Error("not supported");d[P]=O(E,C)}}function N(O,I,C){let d=null,P=null;if(typeof C.value=="function"?(d="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(d="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${I}`;C[d]=function(...$){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,$)}),this[E]}}e.$fh=N;function A(O,I,C){return D((d,P)=>{const E=`$debounce$${P}`,$=`$debounce$result$${P}`;return function(...c){this[$]||(this[$]=C?C():void 0),clearTimeout(this[E]),I&&(this[$]=I(this[$],...c),c=[this[$]]),this[E]=setTimeout(()=>{d.apply(this,c),this[$]=C?C():void 0},O)}})}e.$gh=A;function L(O,I,C){return D((d,P)=>{const E=`$throttle$timer$${P}`,$=`$throttle$result$${P}`,c=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...p){if(this[$]||(this[$]=C?C():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),I&&(this[$]=I(this[$],...p)),this[g])return;const w=this[c]+O;w<=Date.now()?(this[c]=Date.now(),d.apply(this,[this[$]]),this[$]=C?C():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[c]=Date.now(),d.apply(this,[this[$]]),this[$]=C?C():void 0},w-Date.now()))}})}e.$hh=L}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?u.isErrorNoTelemetry(t)?new u(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=D,e.$W=new D;function N(k){e.$W.setUnexpectedErrorHandler(k)}e.setUnexpectedErrorHandler=N;function A(k){if(!k||typeof k!="object")return!1;const t=k;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=A;function L(k){d(k)||e.$W.onUnexpectedError(k)}e.$Z=L;function O(k){d(k)||e.$W.onUnexpectedExternalError(k)}e.$1=O;function I(k){if(k instanceof Error){const{name:t,message:a}=k,s=k.stacktrace||k.stack;return{$isError:!0,name:t,message:a,stack:s,noTelemetry:u.isErrorNoTelemetry(k)}}return k}e.$2=I;const C="Canceled";function d(k){return k instanceof P?!0:k instanceof Error&&k.name===C&&k.message===C}e.$3=d;class P extends Error{constructor(){super(C),this.name=this.message}}e.$4=P;function E(){const k=new Error(C);return k.name=k.message,k}e.$5=E;function $(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}e.$6=$;function c(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}e.$7=c;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function p(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}e.$9=p;class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=w;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=h;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=l;class u extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof u)return t;const a=new u;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=u;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$bb=b}),define(oe[18],ae([0,1,8,125]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function A(F,J=0){return F[F.length-(1+J)]}e.$rb=A;function L(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$sb=L;function O(F,J,Z=(se,le)=>se===le){if(F===J)return!0;if(!F||!J||F.length!==J.length)return!1;for(let se=0,le=F.length;se<le;se++)if(!Z(F[se],J[se]))return!1;return!0}e.$tb=O;function I(F,J){const Z=F.length-1;J<Z&&(F[J]=F[Z]),F.pop()}e.$ub=I;function C(F,J,Z){return d(F.length,se=>Z(F[se],J))}e.$vb=C;function d(F,J){let Z=0,se=F-1;for(;Z<=se;){const le=(Z+se)/2|0,ue=J(le);if(ue<0)Z=le+1;else if(ue>0)se=le-1;else return le}return-(Z+1)}e.$wb=d;function P(F,J,Z){if(F=F|0,F>=J.length)throw new TypeError("invalid index");const se=J[Math.floor(J.length*Math.random())],le=[],ue=[],he=[];for(const $e of J){const de=Z($e,se);de<0?le.push($e):de>0?ue.push($e):he.push($e)}return F<le.length?P(F,le,Z):F<le.length+he.length?he[0]:P(F-(le.length+he.length),ue,Z)}e.$xb=P;function E(F,J){const Z=[];let se;for(const le of F.slice(0).sort(J))!se||J(se[0],le)!==0?(se=[le],Z.push(se)):se.push(le);return Z}e.$yb=E;function*$(F,J){let Z,se;for(const le of F)se!==void 0&&J(se,le)?Z.push(le):(Z&&(yield Z),Z=[le]),se=le;Z&&(yield Z)}e.$zb=$;function c(F,J){for(let Z=0;Z<=F.length;Z++)J(Z===0?void 0:F[Z-1],Z===F.length?void 0:F[Z])}e.$Ab=c;function g(F,J){for(let Z=0;Z<F.length;Z++)J(Z===0?void 0:F[Z-1],F[Z],Z+1===F.length?void 0:F[Z+1])}e.$Bb=g;function p(F,J,Z){const se=[];function le($e,de,we){if(de===0&&we.length===0)return;const Ee=se[se.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):se.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===F.length){le(ue,0,J.slice(he));break}if(he===J.length){le(ue,F.length-ue,[]);break}const $e=F[ue],de=J[he],we=Z($e,de);we===0?(ue+=1,he+=1):we<0?(le(ue,1,[]),ue+=1):we>0&&(le(ue,0,[de]),he+=1)}return se}e.$Cb=p;function w(F,J,Z){const se=p(F,J,Z),le=[],ue=[];for(const he of se)le.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:le,added:ue}}e.$Db=w;function h(F,J,Z){if(Z===0)return[];const se=F.slice(0,Z).sort(J);return u(F,J,se,Z,F.length),se}e.top=h;function l(F,J,Z,se,le){return Z===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=F.length,de=F.slice(0,Z).sort(J);for(let we=Z,Ee=Math.min(Z+se,$e);we<$e;we=Ee,Ee=Math.min(Ee+se,$e)){if(we>Z&&await new Promise(Ie=>setTimeout(Ie)),le&&le.isCancellationRequested)throw new D.$4;u(F,J,de,we,Ee)}return de})().then(ue,he)})}e.$Fb=l;function u(F,J,Z,se,le){for(const ue=Z.length;se<le;se++){const he=F[se];if(J(he,Z[ue-1])<0){Z.pop();const $e=(0,N.$jb)(Z,de=>J(he,de)<0);Z.splice($e,0,he)}}}function b(F){return F.filter(J=>!!J)}e.$Gb=b;function k(F){let J=0;for(let Z=0;Z<F.length;Z++)F[Z]&&(F[J]=F[Z],J+=1);F.length=J}e.$Hb=k;function t(F,J,Z){F.splice(Z,0,F.splice(J,1)[0])}e.$Ib=t;function a(F){return!Array.isArray(F)||F.length===0}e.$Jb=a;function s(F){return Array.isArray(F)&&F.length>0}e.$Kb=s;function n(F,J=Z=>Z){const Z=new Set;return F.filter(se=>{const le=J(se);return Z.has(le)?!1:(Z.add(le),!0)})}e.$Lb=n;function i(F){const J=new Set;return Z=>{const se=F(Z);return J.has(se)?!1:(J.add(se),!0)}}e.$Mb=i;function r(F,J){return F.length>0?F[0]:J}e.$Nb=r;function o(F,J){return F.length>0?F[F.length-1]:J}e.$Ob=o;function v(F,J,Z=(se,le)=>se===le){let se=0;for(let le=0,ue=Math.min(F.length,J.length);le<ue&&Z(F[le],J[le]);le++)se++;return se}e.$Pb=v;function y(F){return[].concat(...F)}e.$Qb=y;function f(F,J){let Z=typeof J=="number"?F:0;typeof J=="number"?Z=F:(Z=0,J=F);const se=[];if(Z<=J)for(let le=Z;le<J;le++)se.push(le);else for(let le=Z;le>J;le--)se.push(le);return se}e.$Rb=f;function m(F,J,Z){return F.reduce((se,le)=>(se[J(le)]=Z?Z(le):le,se),Object.create(null))}e.$Sb=m;function j(F,J){return F.push(J),()=>M(F,J)}e.$Tb=j;function M(F,J){const Z=F.indexOf(J);if(Z>-1)return F.splice(Z,1),J}e.$Ub=M;function T(F,J,Z){const se=F.slice(0,J),le=F.slice(J);return se.concat(Z,le)}e.$Vb=T;function U(F,J){let Z;if(typeof J=="number"){let se=J;Z=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let se=F.length-1;se>0;se-=1){const le=Math.floor(Z()*(se+1)),ue=F[se];F[se]=F[le],F[le]=ue}}e.$Wb=U;function q(F,J){const Z=F.indexOf(J);Z>-1&&(F.splice(Z,1),F.unshift(J))}e.$Xb=q;function _(F,J){const Z=F.indexOf(J);Z>-1&&(F.splice(Z,1),F.push(J))}e.$Yb=_;function K(F,J){for(const Z of J)F.push(Z)}e.$Zb=K;function Y(F,J){return Array.isArray(F)?F.map(J):J(F)}e.$1b=Y;function G(F){return Array.isArray(F)?F:[F]}e.$2b=G;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.$3b=Q;function H(F,J,Z){const se=W(F,J),le=F.length,ue=Z.length;F.length=le+ue;for(let he=le-1;he>=se;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+se]=Z[he]}e.$4b=H;function V(F,J,Z,se){const le=W(F,J);let ue=F.splice(le,Z);return ue===void 0&&(ue=[]),H(F,le,se),ue}e.$5b=V;function W(F,J){return J<0?Math.max(J+F.length,0):Math.min(J,F.length)}var ee;(function(F){function J(ue){return ue<0}F.isLessThan=J;function Z(ue){return ue<=0}F.isLessThanOrEqual=Z;function se(ue){return ue>0}F.isGreaterThan=se;function le(ue){return ue===0}F.isNeitherLessOrGreaterThan=le,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(F,J){return(Z,se)=>J(F(Z),F(se))}e.$6b=ne;function re(...F){return(J,Z)=>{for(const se of F){const le=se(J,Z);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.$7b=re;const X=(F,J)=>F-J;e.$8b=X;const B=(F,J)=>(0,e.$8b)(F?1:0,J?1:0);e.$9b=B;function S(F){return(J,Z)=>-F(J,Z)}e.$0b=S;class R{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let Z=this.c;for(;Z<this.g.length&&J(this.g[Z]);)Z++;const se=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,se}takeFromEndWhile(J){let Z=this.d;for(;Z>=0&&J(this.g[Z]);)Z--;const se=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,se}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const Z=this.g.slice(this.c,this.c+J);return this.c+=J,Z}}e.$$b=R;class z{static{this.empty=new z(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(Z=>(J(Z),!0))}toArray(){const J=[];return this.iterate(Z=>(J.push(Z),!0)),J}filter(J){return new z(Z=>this.iterate(se=>J(se)?Z(se):!0))}map(J){return new z(Z=>this.iterate(se=>Z(J(se))))}some(J){let Z=!1;return this.iterate(se=>(Z=J(se),!Z)),Z}findFirst(J){let Z;return this.iterate(se=>J(se)?(Z=se,!1):!0),Z}findLast(J){let Z;return this.iterate(se=>(J(se)&&(Z=se),!0)),Z}findLastMaxBy(J){let Z,se=!0;return this.iterate(le=>((se||ee.isGreaterThan(J(le,Z)))&&(se=!1,Z=le),!0)),Z}}e.$_b=z}),define(oe[127],ae([0,1,8]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function N(C,d){if(!C)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=N;function A(C,d="Unreachable"){throw new Error(d)}e.$3c=A;function L(C){if(!C)throw new D.$bb("Assertion Failed")}e.$4c=L;function O(C){if(!C()){debugger;C(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$5c=O;function I(C,d){let P=0;for(;P<C.length-1;){const E=C[P],$=C[P+1];if(!d(E,$))return!1;P++}return!0}e.$6c=I}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(N){const A=this;let L=!1,O;return function(){return L||(L=!0,O=N.apply(A,arguments)),O}}e.$cb=D}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function A(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}N.is=A;const L=Object.freeze([]);function O(){return L}N.empty=O;function*I(k){yield k}N.single=I;function C(k){return A(k)?k:I(k)}N.wrap=C;function d(k){return k||L}N.from=d;function*P(k){for(let t=k.length-1;t>=0;t--)yield k[t]}N.reverse=P;function E(k){return!k||k[Symbol.iterator]().next().done===!0}N.isEmpty=E;function $(k){return k[Symbol.iterator]().next().value}N.first=$;function c(k,t){for(const a of k)if(t(a))return!0;return!1}N.some=c;function g(k,t){for(const a of k)if(t(a))return a}N.find=g;function*p(k,t){for(const a of k)t(a)&&(yield a)}N.filter=p;function*w(k,t){let a=0;for(const s of k)yield t(s,a++)}N.map=w;function*h(...k){for(const t of k)for(const a of t)yield a}N.concat=h;function l(k,t,a){let s=a;for(const n of k)s=t(s,n);return s}N.reduce=l;function*u(k,t,a=k.length){for(t<0&&(t+=k.length),a<0?a+=k.length:a>k.length&&(a=k.length);t<a;t++)yield k[t]}N.slice=u;function b(k,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,k];const s=k[Symbol.iterator]();for(let n=0;n<t;n++){const i=s.next();if(i.done)return[a,N.empty()];a.push(i.value)}return[a,{[Symbol.iterator](){return s}}]}N.consume=b})(D||(e.Iterable=D={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function O(t,a=!1){let s=0;const n=t.length;let i="",r=0,o=16,v=0;function y(q){let _=0,K=0;for(;_<q;){const Y=t.charCodeAt(s);if(Y>=48&&Y<=57)K=K*16+Y-48;else if(Y>=65&&Y<=70)K=K*16+Y-65+10;else if(Y>=97&&Y<=102)K=K*16+Y-97+10;else break;s++,_++}return _<q&&(K=-1),K}function f(q){s=q,i="",r=0,o=16,v=0}function m(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&d(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&d(t.charCodeAt(s)))for(s++;s<t.length&&d(t.charCodeAt(s));)s++;else return v=3,t.substring(q,s);let _=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&d(t.charCodeAt(s))){for(s++;s<t.length&&d(t.charCodeAt(s));)s++;_=s}else v=3;return t.substring(q,_)}function j(){let q="",_=s;for(;;){if(s>=n){q+=t.substring(_,s),v=2;break}const K=t.charCodeAt(s);if(K===34){q+=t.substring(_,s),s++;break}if(K===92){if(q+=t.substring(_,s),s++,s>=n){v=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const G=y(4);G>=0?q+=String.fromCharCode(G):v=4;break}default:v=5}_=s;continue}if(K>=0&&K<=31)if(C(K)){q+=t.substring(_,s),v=2;break}else v=6;s++}return q}function M(){if(i="",v=0,r=s,s>=n)return r=n,o=17;let q=t.charCodeAt(s);if(I(q)){do s++,i+=String.fromCharCode(q),q=t.charCodeAt(s);while(I(q));return o=15}if(C(q))return s++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),o=14;switch(q){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,i=j(),o=10;case 47:{const _=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!C(t.charCodeAt(s));)s++;return i=t.substring(_,s),o=12}if(t.charCodeAt(s+1)===42){s+=2;const K=n-1;let Y=!1;for(;s<K;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Y=!0;break}s++}return Y||(s++,v=1),i=t.substring(_,s),o=13}return i+=String.fromCharCode(q),s++,o=16}case 45:if(i+=String.fromCharCode(q),s++,s===n||!d(t.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=m(),o=11;default:for(;s<n&&T(q);)s++,q=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return i+=String.fromCharCode(q),s++,o=16}}function T(q){if(I(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>s,scan:a?U:M,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>v}}e.$Pm=O;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,a){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(y,f,m,j){r.value=y,r.offset=f,r.length=m,r.type=j,r.colonOffset=void 0,i=r}try{u(t,{onObjectBegin:(y,f)=>{if(a<=y)throw n;i=void 0,o=a>y,s.push("")},onObjectProperty:(y,f,m)=>{if(a<f||(v(y,f,m,"property"),s[s.length-1]=y,a<=f+m))throw n},onObjectEnd:(y,f)=>{if(a<=y)throw n;i=void 0,s.pop()},onArrayBegin:(y,f)=>{if(a<=y)throw n;i=void 0,s.push(0)},onArrayEnd:(y,f)=>{if(a<=y)throw n;i=void 0,s.pop()},onLiteralValue:(y,f,m)=>{if(a<f||(v(y,f,m,k(y)),a<=f+m))throw n},onSeparator:(y,f,m)=>{if(a<=f)throw n;if(y===":"&&i&&i.type==="property")i.colonOffset=f,o=!1,i=void 0;else if(y===","){const j=s[s.length-1];typeof j=="number"?s[s.length-1]=j+1:(o=!0,s[s.length-1]=""),i=void 0}}})}catch(y){if(y!==n)throw y}return{path:s,previousNode:i,isAtPropertyKey:o,matches:y=>{let f=0;for(let m=0;f<y.length&&m<s.length;m++)if(y[f]===s[m]||y[f]==="*")f++;else if(y[f]!=="**")return!1;return f===y.length}}}e.$Qm=E;function $(t,a=[],s=L.DEFAULT){let n=null,i=[];const r=[];function o(y){Array.isArray(i)?i.push(y):n!==null&&(i[n]=y)}return u(t,{onObjectBegin:()=>{const y={};o(y),r.push(i),i=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const y=[];o(y),r.push(i),i=y,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:o,onError:(y,f,m)=>{a.push({error:y,offset:f,length:m})}},s),i[0]}e.$Rm=$;function c(t,a=[],s=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}u(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,f,m)=>{n=r({type:"property",offset:f,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:f,length:m,parent:n})},onObjectEnd:(y,f)=>{n.length=y+f-n.offset,n=n.parent,i(y+f)},onArrayBegin:(y,f)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,f)=>{n.length=y+f-n.offset,n=n.parent,i(y+f)},onLiteralValue:(y,f,m)=>{r({type:k(y),offset:f,length:m,parent:n,value:y}),i(f+m)},onSeparator:(y,f,m)=>{n.type==="property"&&(y===":"?n.colonOffset=f:y===","&&i(f))},onError:(y,f,m)=>{a.push({error:y,offset:f,length:m})}},s);const v=n.children[0];return v&&delete v.parent,v}e.$Sm=c;function g(t,a){if(!t)return;let s=t;for(const n of a)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$Tm=g;function p(t){if(!t.parent||!t.parent.children)return[];const a=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;a.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&a.push(s)}return a}e.$Um=p;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const a=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(a[s.children[0].value]=w(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Vm=w;function h(t,a,s=!1){return a>=t.offset&&a<t.offset+t.length||s&&a===t.offset+t.length}e.$Wm=h;function l(t,a,s=!1){if(h(t,a,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=a;i++){const r=l(n[i],a,s);if(r)return r}return t}}e.$Xm=l;function u(t,a,s=L.DEFAULT){const n=O(t,!1);function i(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ne){return ne?re=>ne(re,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),v=r(a.onObjectProperty),y=i(a.onObjectEnd),f=i(a.onArrayBegin),m=i(a.onArrayEnd),j=r(a.onLiteralValue),M=r(a.onSeparator),T=i(a.onComment),U=r(a.onError),q=s&&s.disallowComments,_=s&&s.allowTrailingComma;function K(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:q||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(ne){case 12:case 13:q?Y(10):T();break;case 16:Y(1);break;case 15:case 14:break;default:return ne}}}function Y(ne,re=[],X=[]){if(U(ne),re.length+X.length>0){let B=n.getToken();for(;B!==17;){if(re.indexOf(B)!==-1){K();break}else if(X.indexOf(B)!==-1)break;B=K()}}}function G(ne){const re=n.getTokenValue();return ne?j(re):v(re),K(),!0}function Q(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(Y(2),ne=0)}catch{Y(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return K(),!0}function H(){return n.getToken()!==10?(Y(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(M(":"),K(),ee()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function V(){o(),K();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||Y(4,[],[]),M(","),K(),n.getToken()===2&&_)break}else ne&&Y(6,[],[]);H()||Y(4,[],[2,5]),ne=!0}return y(),n.getToken()!==2?Y(7,[2],[]):K(),!0}function W(){f(),K();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||Y(4,[],[]),M(","),K(),n.getToken()===4&&_)break}else ne&&Y(6,[],[]);ee()||Y(4,[],[4,5]),ne=!0}return m(),n.getToken()!==4?Y(8,[4],[]):K(),!0}function ee(){switch(n.getToken()){case 3:return W();case 1:return V();case 10:return G(!0);default:return Q()}}return K(),n.getToken()===17?s.allowEmptyContent?!0:(Y(4,[],[]),!1):ee()?(n.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$Ym=u;function b(t,a){const s=O(t),n=[];let i,r=0,o;do switch(o=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==o&&n.push(t.substring(r,o)),a!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,a)),r=s.getPosition();break}while(i!==17);return n.join("")}e.$Zm=b;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=k}),define(oe[41],ae([0,1,35]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=e.$RS=e.$QS=e.$PS=void 0;function N(d,P,E){let $,c,g,p,w;if(P){for(p=P.offset,w=p+P.length,g=p;g>0&&!C(d,g-1);)g--;let o=w;for(;o<d.length&&!C(d,o);)o++;c=d.substring(g,o),$=O(c,E)}else c=d,$=0,g=0,p=0,w=d.length;const h=I(E,d);let l=!1,u=0,b;E.insertSpaces?b=L(" ",E.tabSize||4):b="	";const k=(0,D.$Pm)(c,!1);let t=!1;function a(){return h+L(b,$+u)}function s(){let o=k.scan();for(l=!1;o===15||o===14;)l=l||o===14,o=k.scan();return t=o===16||k.getTokenError()!==0,o}const n=[];function i(o,v,y){!t&&v<w&&y>p&&d.substring(v,y)!==o&&n.push({offset:v,length:y-v,content:o})}let r=s();if(r!==17){const o=k.getTokenOffset()+g,v=L(b,$);i(v,g,o)}for(;r!==17;){let o=k.getTokenOffset()+k.getTokenLength()+g,v=s(),y="";for(;!l&&(v===12||v===13);){const m=k.getTokenOffset()+g;i(" ",o,m),o=k.getTokenOffset()+k.getTokenLength()+g,y=v===12?a():"",v=s()}if(v===2)r!==1&&(u--,y=a());else if(v===4)r!==3&&(u--,y=a());else{switch(r){case 3:case 1:u++,y=a();break;case 5:case 12:y=a();break;case 13:l?y=a():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(t=!0);break;case 16:t=!0;break}l&&(v===12||v===13)&&(y=a())}const f=k.getTokenOffset()+g;i(y,o,f),r=v}return n}e.$PS=N;function A(d,P){const E=JSON.stringify(d,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$QS=A;function L(d,P){let E="";for(let $=0;$<P;$++)E+=d;return E}function O(d,P){let E=0,$=0;const c=P.tabSize||4;for(;E<d.length;){const g=d.charAt(E);if(g===" ")$++;else if(g==="	")$+=c;else break;E++}return Math.floor($/c)}function I(d,P){for(let E=0;E<P.length;E++){const $=P.charAt(E);if($==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return d&&d.eol||`
`}e.$RS=I;function C(d,P){return`\r
`.indexOf(d.charAt(P))!==-1}e.$SS=C}),define(oe[85],ae([0,1,35,41]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XS=e.$WS=e.$VS=e.$US=e.$TS=void 0;function A(d,P,E){return L(d,P,void 0,E)}e.$TS=A;function L(d,P,E,$,c){const g=P.slice(),p=[],w=(0,D.$Sm)(d,p);let h,l;for(;g.length>0&&(l=g.pop(),h=(0,D.$Tm)(w,g),h===void 0&&E!==void 0);)typeof l=="string"?E={[l]:E}:E=[E];if(h)if(h.type==="object"&&typeof l=="string"&&Array.isArray(h.children)){const u=(0,D.$Tm)(h,[l]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const b=h.children.indexOf(u.parent);let k,t=u.parent.offset+u.parent.length;if(b>0){const a=h.children[b-1];k=a.offset+a.length}else k=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return O(d,{offset:k,length:t-k,content:""},$)}else return O(d,{offset:u.offset,length:u.length,content:JSON.stringify(E)},$);else{if(E===void 0)return[];const b=`${JSON.stringify(l)}: ${JSON.stringify(E)}`,k=c?c(h.children.map(a=>a.children[0].value)):h.children.length;let t;if(k>0){const a=h.children[k-1];t={offset:a.offset+a.length,length:0,content:","+b}}else h.children.length===0?t={offset:h.offset+1,length:0,content:b}:t={offset:h.offset+1,length:0,content:b+","};return O(d,t,$)}}else if(h.type==="array"&&typeof l=="number"&&Array.isArray(h.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let b;if(h.children.length===0||l===0)b={offset:h.offset+1,length:0,content:h.children.length===0?u:u+","};else{const k=l===-1||l>h.children.length?h.children.length:l,t=h.children[k-1];b={offset:t.offset+t.length,length:0,content:","+u}}return O(d,b,$)}else{const u=l,b=h.children[u];let k;if(h.children.length===1)k={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===u){const t=h.children[u-1],a=t.offset+t.length,s=h.offset+h.length;k={offset:a,length:s-2-a,content:""}}else k={offset:b.offset,length:h.children[u+1].offset-b.offset,content:""};return O(d,k,$)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},$)}}e.$US=L;function O(d,P,E){let $=I(d,P),c=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;c>0&&!(0,N.$SS)($,c-1);)c--;for(;g<$.length&&!(0,N.$SS)($,g);)g++}const p=(0,N.$PS)($,{offset:c,length:g-c},E);for(let h=p.length-1;h>=0;h--){const l=p[h];$=I($,l),c=Math.min(c,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const w=d.length-($.length-g)-c;return[{offset:c,length:w,content:$.substring(c,g)}]}e.$VS=O;function I(d,P){return d.substring(0,P.offset)+P.content+d.substring(P.offset+P.length)}e.$WS=I;function C(d,P){const E=P.slice(0).sort((c,g)=>{const p=c.offset-g.offset;return p===0?c.length-g.length:p});let $=d.length;for(let c=E.length-1;c>=0;c--){const g=E[c];if(g.offset+g.length<=$)d=I(d,g);else throw new Error("Overlapping edit");$=g.offset}return d}e.$XS=C}),define(oe[86],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let L=this.a;for(;L!==D.Undefined;){const O=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,O){const I=new D(L);if(this.a===D.Undefined)this.a=I,this.b=I;else if(O){const d=this.b;this.b=I,I.prev=d,d.next=I}else{const d=this.a;this.a=I,I.next=d,d.prev=I}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==D.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const O=L.prev;O.next=L.next,L.next.prev=O}else L.prev===D.Undefined&&L.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):L.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):L.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.$1c=N}),define(oe[34],ae([0,1]),function(te,e){"use strict";var D,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(l,u,b){let k=l.get(u);return k===void 0&&(k=b,l.set(u,k)),k}e.$wc=L;function O(l){const u=[];return l.forEach((b,k)=>{u.push(`${k} => ${b}`)}),`Map(${l.size}) {${u.join(", ")}}`}e.$xc=O;function I(l){const u=[];return l.forEach(b=>{u.push(b)}),`Set(${l.size}) {${u.join(", ")}}`}e.$yc=I;class C{constructor(u,b){this.uri=u,this.value=b}}function d(l){return Array.isArray(l)}class P{static{this.a=u=>u.toString()}constructor(u,b){if(this[D]="ResourceMap",u instanceof P)this.b=new Map(u.b),this.c=b??P.a;else if(d(u)){this.b=new Map,this.c=b??P.a;for(const[k,t]of u)this.set(k,t)}else this.b=new Map,this.c=u??P.a}set(u,b){return this.b.set(this.c(u),new C(u,b)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,b){typeof b<"u"&&(u=u.bind(b));for(const[k,t]of this.b)u(t.value,t.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$zc=P;class E{constructor(u,b){this[N]="ResourceSet",!u||typeof u=="function"?this.a=new P(u):(this.a=new P(b),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,b){this.a.forEach((k,t)=>u.call(b,t,t,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var $;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})($||(e.Touch=$={}));class c{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,b=0){const k=this.a.get(u);if(k)return b!==0&&this.j(k,b),k.value}set(u,b,k=0){let t=this.a.get(u);if(t)t.value=b,k!==0&&this.j(t,k);else{switch(t={key:u,value:b,next:void 0,previous:void 0},k){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(u,t),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const b=this.a.get(u);if(b)return this.a.delete(u),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,b){const k=this.e;let t=this.b;for(;t;){if(b?u.bind(b)(t.value,t.key,this):u(t.value,t.key,this),this.e!==k)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,b=this.e;let k=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.key,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return t}values(){const u=this,b=this.e;let k=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.value,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return t}entries(){const u=this,b=this.e;let k=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:[k.key,k.value],done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return t}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let b=this.b,k=this.size;for(;b&&k>u;)this.a.delete(b.key),b=b.next,k--;this.b=b,this.d=k,b&&(b.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const b=u.next,k=u.previous;if(!b||!k)throw new Error("Invalid list");b.previous=k,k.next=b}u.next=void 0,u.previous=void 0,this.e++}j(u,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(u===this.b)return;const k=u.next,t=u.previous;u===this.c?(t.next=void 0,this.c=t):(k.previous=t,t.next=k),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(b===2){if(u===this.c)return;const k=u.next,t=u.previous;u===this.b?(k.previous=void 0,this.b=k):(k.previous=t,t.next=k),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((b,k)=>{u.push([k,b])}),u}fromJSON(u){this.clear();for(const[b,k]of u)this.set(b,k)}}e.$Bc=c;class g extends c{constructor(u,b=1){super(),this.k=u,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,b=2){return super.get(u,b)}peek(u){return super.get(u,0)}set(u,b){return super.set(u,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=g;class p{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let b=this.a.get(u)||0;return b===0?!1:(b--,b===0?this.a.delete(u):this.a.set(u,b),!0)}has(u){return this.a.has(u)}}e.$Dc=p;class w{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[b,k]of u)this.set(b,k)}clear(){this.a.clear(),this.b.clear()}set(u,b){this.a.set(u,b),this.b.set(b,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const b=this.a.get(u);return b===void 0?!1:(this.a.delete(u),this.b.delete(b),!0)}forEach(u,b){this.a.forEach((k,t)=>{u.call(b,k,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class h{constructor(){this.a=new Map}add(u,b){let k=this.a.get(u);k||(k=new Set,this.a.set(u,k)),k.add(b)}delete(u,b){const k=this.a.get(u);k&&(k.delete(b),k.size===0&&this.a.delete(u))}forEach(u,b){const k=this.a.get(u);k&&k.forEach(b)}get(u){const b=this.a.get(u);return b||new Set}}e.$Fc=h}),define(oe[2],ae([0,1,18,126,34,84,59]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const I=!1;let C=null;class d{constructor(){this.b=new Map}static{this.a=0}c(m){let j=this.b.get(m);return j||(j={parent:null,source:null,isSingleton:!1,value:m,idx:d.a++},this.b.set(m,j)),j}trackDisposable(m){const j=this.c(m);j.source||(j.source=new Error().stack)}setParent(m,j){const M=this.c(m);M.parent=j}markAsDisposed(m){this.b.delete(m)}markAsSingleton(m){this.c(m).isSingleton=!0}f(m,j){const M=j.get(m);if(M)return M;const T=m.parent?this.f(this.c(m.parent),j):m;return j.set(m,T),T}getTrackedDisposables(){const m=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,m).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(m=10,j){let M;if(j)M=j;else{const K=new Map,Y=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,K).isSingleton);if(Y.length===0)return;const G=new Set(Y.map(Q=>Q.value));if(M=Y.filter(Q=>!(Q.parent&&G.has(Q.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(K){function Y(Q,H){for(;Q.length>0&&H.some(V=>typeof V=="string"?V===Q[0]:Q[0].match(V));)Q.shift()}const G=K.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return Y(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const U=new A.$Fc;for(const K of M){const Y=T(K);for(let G=0;G<=Y.length;G++)U.add(Y.slice(0,G).join(`
`),K)}M.sort((0,D.$6b)(K=>K.idx,D.$8b));let q="",_=0;for(const K of M.slice(0,m)){_++;const Y=T(K),G=[];for(let Q=0;Q<Y.length;Q++){let H=Y[Q];H=`(shared with ${U.get(Y.slice(0,Q+1).join(`
`)).size}/${M.length} leaks) at ${H}`;const W=U.get(Y.slice(0,Q).join(`
`)),ee=(0,N.$J)([...W].map(ne=>T(ne)[Q]),ne=>ne);delete ee[Y[Q]];for(const[ne,re]of Object.entries(ee))G.unshift(`    - stacktraces of ${re.length} other leaks continue with ${ne}`);G.unshift(H)}q+=`


==================== Leaking disposable ${_}/${M.length}: ${K.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return M.length>m&&(q+=`


... and ${M.length-m} more leaking disposables

`),{leaks:M,details:q}}}e.$Gc=d;function P(f){C=f}if(e.$Hc=P,I){const f="__is_disposable_tracked__";P(new class{trackDisposable(m){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[f]||console.log(j)},3e3)}setParent(m,j){if(m&&m!==t.None)try{m[f]=!0}catch{}}markAsDisposed(m){if(m&&m!==t.None)try{m[f]=!0}catch{}}markAsSingleton(m){}})}function E(f){return C?.trackDisposable(f),f}e.$Ic=E;function $(f){C?.markAsDisposed(f)}e.$Jc=$;function c(f,m){C?.setParent(f,m)}function g(f,m){if(C)for(const j of f)C.setParent(j,m)}function p(f){return C?.markAsSingleton(f),f}e.$Kc=p;function w(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Lc=w;function h(f){if(O.Iterable.is(f)){const m=[];for(const j of f)if(j)try{j.dispose()}catch(M){m.push(M)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Mc=h;function l(f){for(const m of f)w(m)&&m.dispose();return[]}e.$Nc=l;function u(...f){const m=b(()=>h(f));return g(f,m),m}e.$Oc=u;function b(f){const m=E({dispose:(0,L.$cb)(()=>{$(m),f()})});return m}e.$Pc=b;class k{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return c(m,this),this.g?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(m),m.dispose()}}deleteAndLeak(m){m&&this.f.has(m)&&(this.f.delete(m),c(m,null))}}e.$Qc=k;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new k,E(this),c(this.q,this)}dispose(){$(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$Rc=t;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&c(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&c(m,null),m}}e.$Sc=a;class s{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=s;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(m){let j=m;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,$(this))},this}}e.$Uc=n;class i{constructor(){this.a=new Map}acquire(m,...j){let M=this.a.get(m);M||(M={counter:0,object:this.b(m,...j)},this.a.set(m,M));const{object:T}=M,U=(0,L.$cb)(()=>{--M.counter===0&&(this.c(m,M.object),this.a.delete(m))});return M.counter++,{object:T,dispose:U}}}e.$Vc=i;class r{constructor(m){this.a=m}async acquire(m,...j){const M=this.a.acquire(m,...j);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$Wc=r;class o{constructor(m){this.object=m}dispose(){}}e.$Xc=o;function v(f){const m=new k;try{f(m)}finally{m.dispose()}}e.$Yc=v;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,j,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(m)?.dispose(),this.a.set(m,j)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=y}),define(oe[88],ae([0,1,34]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=void 0;const N=new D.$Cc(1e4);function A(d){return C(d,"NFC",N)}e.$kl=A;const L=new D.$Cc(1e4);function O(d){return C(d,"NFD",L)}e.$ll=O;const I=/[^\u0000-\u0080]/;function C(d,P,E){if(!d)return d;const $=E.get(d);if($)return $;let c;return I.test(d)?c=d.normalize(P):c=d,E.set(d,c),c}e.$ml=function(){const d=/[\u0300-\u036f]/g;return function(P){return O(P).replace(d,"")}}()}),function(){function te(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function O(C){L.push(C,Date.now())}function I(){const C=[];for(let d=0;d<L.length;d+=2)C.push({name:L[d],startTime:L[d+1]});return C}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const O of performance.getEntriesByType("mark"))L.push({name:O.name,startTime:Math.round(A+O.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function D(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:te)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function D(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return te[N].call(A.exports,A,A.exports,D),A.l=!0,A.exports}return D.m=te,D.c=e,D.d=function(N,A,L){D.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:L})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,A){if(1&A&&(N=D(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var O in N)D.d(L,O,function(I){return N[I]}.bind(null,O));return L},D.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(A,"a",A),A},D.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},D.p="",D(D.s=0)}([function(te,e,D){(function(N){var A;e=te.exports=X,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],d=0,P=d++;C[P]="0|[1-9]\\d*";var E=d++;C[E]="[0-9]+";var $=d++;C[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=d++;C[c]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var g=d++;C[g]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var p=d++;C[p]="(?:"+C[P]+"|"+C[$]+")";var w=d++;C[w]="(?:"+C[E]+"|"+C[$]+")";var h=d++;C[h]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var l=d++;C[l]="(?:-?("+C[w]+"(?:\\."+C[w]+")*))";var u=d++;C[u]="[0-9A-Za-z-]+";var b=d++;C[b]="(?:\\+("+C[u]+"(?:\\."+C[u]+")*))";var k=d++,t="v?"+C[c]+C[h]+"?"+C[b]+"?";C[k]="^"+t+"$";var a="[v=\\s]*"+C[g]+C[l]+"?"+C[b]+"?",s=d++;C[s]="^"+a+"$";var n=d++;C[n]="((?:<|>)?=?)";var i=d++;C[i]=C[E]+"|x|X|\\*";var r=d++;C[r]=C[P]+"|x|X|\\*";var o=d++;C[o]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[h]+")?"+C[b]+"?)?)?";var v=d++;C[v]="[v=\\s]*("+C[i]+")(?:\\.("+C[i]+")(?:\\.("+C[i]+")(?:"+C[l]+")?"+C[b]+"?)?)?";var y=d++;C[y]="^"+C[n]+"\\s*"+C[o]+"$";var f=d++;C[f]="^"+C[n]+"\\s*"+C[v]+"$";var m=d++;C[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=d++;C[j]="(?:~>?)";var M=d++;C[M]="(\\s*)"+C[j]+"\\s+",I[M]=new RegExp(C[M],"g");var T=d++;C[T]="^"+C[j]+C[o]+"$";var U=d++;C[U]="^"+C[j]+C[v]+"$";var q=d++;C[q]="(?:\\^)";var _=d++;C[_]="(\\s*)"+C[q]+"\\s+",I[_]=new RegExp(C[_],"g");var K=d++;C[K]="^"+C[q]+C[o]+"$";var Y=d++;C[Y]="^"+C[q]+C[v]+"$";var G=d++;C[G]="^"+C[n]+"\\s*("+a+")$|^$";var Q=d++;C[Q]="^"+C[n]+"\\s*("+t+")$|^$";var H=d++;C[H]="(\\s*)"+C[n]+"\\s*("+a+"|"+C[o]+")",I[H]=new RegExp(C[H],"g");var V=d++;C[V]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var W=d++;C[W]="^\\s*("+C[v]+")\\s+-\\s+("+C[v]+")\\s*$";var ee=d++;C[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)A(ne,C[ne]),I[ne]||(I[ne]=new RegExp(C[ne]));function re(ce,ge){if(ce instanceof X)return ce;if(typeof ce!="string"||ce.length>L||!(ge?I[s]:I[k]).test(ce))return null;try{return new X(ce,ge)}catch{return null}}function X(ce,ge){if(ce instanceof X){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof X))return new X(ce,ge);A("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?I[s]:I[k]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<O)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(ce,ge){var be=re(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=re(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ce){return A("SemVer.compare",this.version,this.loose,ce),ce instanceof X||(ce=new X(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},X.prototype.compareMain=function(ce){return ce instanceof X||(ce=new X(ce,this.loose)),S(this.major,ce.major)||S(this.minor,ce.minor)||S(this.patch,ce.patch)},X.prototype.comparePre=function(ce){if(ce instanceof X||(ce=new X(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=ce.prerelease[ge];if(A("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return S(be,Se)}while(++ge)},X.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new X(ce,be).inc(ge,Se).version}catch{return null}},e.diff=function(ce,ge){if(J(ce,ge))return null;var be=re(ce),Se=re(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=S;var B=/^[0-9]+$/;function S(ce,ge){var be=B.test(ce),Se=B.test(ge);return be&&Se&&(ce=+ce,ge=+ge),be&&!Se?-1:Se&&!be?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,be){return new X(ce,be).compare(new X(ge,be))}function z(ce,ge,be){return R(ce,ge,be)>0}function F(ce,ge,be){return R(ce,ge,be)<0}function J(ce,ge,be){return R(ce,ge,be)===0}function Z(ce,ge,be){return R(ce,ge,be)!==0}function se(ce,ge,be){return R(ce,ge,be)>=0}function le(ce,ge,be){return R(ce,ge,be)<=0}function ue(ce,ge,be,Se){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=J(ce,be,Se);break;case"!=":Pe=Z(ce,be,Se);break;case">":Pe=z(ce,be,Se);break;case">=":Pe=se(ce,be,Se);break;case"<":Pe=F(ce,be,Se);break;case"<=":Pe=le(ce,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(ce,ge){if(ce instanceof he){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof he))return new he(ce,ge);A("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ce,ge){return S(ge,ce)},e.major=function(ce,ge){return new X(ce,ge).major},e.minor=function(ce,ge){return new X(ce,ge).minor},e.patch=function(ce,ge){return new X(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,be){return R(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=z,e.lt=F,e.eq=J,e.neq=Z,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=he;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof he)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ee(ce,ge,be,Se,Pe,Ue,je,ze,Fe,ie,fe,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(ze=we(Fe)?"":we(ie)?"<"+(+Fe+1)+".0.0":we(fe)?"<"+Fe+"."+(+ie+1)+".0":me?"<="+Fe+"."+ie+"."+fe+"-"+me:"<="+ze)).trim()}function Ie(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(A(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var Se=ce[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Ne(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,Se){var Pe,Ue,je,ze,Fe;switch(ce=new X(ce,Se),ge=new de(ge,Se),be){case">":Pe=z,Ue=le,je=F,ze=">",Fe=">=";break;case"<":Pe=F,Ue=se,je=z,ze="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ce,ge,Se))return!1;for(var ie=0;ie<ge.set.length;++ie){var fe=ge.set[ie],me=null,pe=null;if(fe.forEach(function(ke){ke.semver===$e&&(ke=new he(">=0.0.0")),me=me||ke,pe=pe||ke,Pe(ke.semver,me.semver,Se)?me=ke:je(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===ze||me.operator===Fe||(!pe.operator||pe.operator===ze)&&Ue(ce,pe.semver)||pe.operator===Fe&&je(ce,pe.semver))return!1}return!0}he.prototype.parse=function(ce){var ge=this.loose?I[G]:I[Q],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(ce){return A("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new X(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ce,ge){if(!(ce instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Ne(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Ne(ce.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ue=this.semver.version===ce.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),ze=ue(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Fe=ue(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Se||Pe||Ue&&je||ze||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),A("range",ce,ge);var be=ge?I[W]:I[V];ce=ce.replace(be,Ee),A("hyphen replace",ce),ce=ce.replace(I[H],"$1$2$3"),A("comparator trim",ce,I[H]),ce=(ce=(ce=ce.replace(I[M],"$1~")).replace(I[_],"$1^")).split(/\s+/).join(" ");var Se=ge?I[G]:I[Q],Pe=ce.split(" ").map(function(Ue){return function(je,ze){return A("comp",je),je=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){A("caret",me,pe);var ke=pe?I[Y]:I[K];return me.replace(ke,function(Re,Ce,De,Oe,Le){var Me;return A("caret",me,Re,Ce,De,Oe,Le),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=Ce==="0"?">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+".0 <"+(+Ce+1)+".0.0":Le?(A("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+Le+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+Le+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+Le+" <"+(+Ce+1)+".0.0"):(A("no pr"),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+" <"+(+Ce+1)+".0.0"),A("caret return",Me),Me})}(fe,ie)}).join(" ")}(je,ze),A("caret",je),je=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){var ke=pe?I[U]:I[T];return me.replace(ke,function(Re,Ce,De,Oe,Le){var Me;return A("tilde",me,Re,Ce,De,Oe,Le),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":Le?(A("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Me=">="+Ce+"."+De+"."+Oe+Le+" <"+Ce+"."+(+De+1)+".0"):Me=">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0",A("tilde return",Me),Me})}(fe,ie)}).join(" ")}(je,ze),A("tildes",je),je=function(Fe,ie){return A("replaceXRanges",Fe,ie),Fe.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var ke=pe?I[f]:I[y];return me.replace(ke,function(Re,Ce,De,Oe,Le,Me){A("xRange",me,Re,Ce,De,Oe,Le,Me);var Be=we(De),qe=Be||we(Oe),We=qe||we(Le);return Ce==="="&&We&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&We?(qe&&(Oe=0),We&&(Le=0),Ce===">"?(Ce=">=",qe?(De=+De+1,Oe=0,Le=0):We&&(Oe=+Oe+1,Le=0)):Ce==="<="&&(Ce="<",qe?De=+De+1:Oe=+Oe+1),Re=Ce+De+"."+Oe+"."+Le):qe?Re=">="+De+".0.0 <"+(+De+1)+".0.0":We&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),A("xRange return",Re),Re})}(fe,ie)}).join(" ")}(je,ze),A("xrange",je),je=function(Fe,ie){return A("replaceStars",Fe,ie),Fe.trim().replace(I[ee],"")}(je,ze),A("stars",je),je}(Ue,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Se)})),Pe=Pe.map(function(Ue){return new he(Ue,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return ce.set.some(function(Pe){return Pe.every(function(Ue){return Se.intersects(Ue,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new X(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ce))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return ce.forEach(function(je){Ue.test(je)&&(Se&&Pe.compare(je)!==-1||(Pe=new X(Se=je,be)))}),Se},e.minSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return ce.forEach(function(je){Ue.test(je)&&(Se&&Pe.compare(je)!==1||(Pe=new X(Se=je,be)))}),Se},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=re(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof X)return ce;if(typeof ce!="string")return null;var ge=ce.match(I[m]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(te,e){var D,N,A=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(w){if(D===setTimeout)return setTimeout(w,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,d=[],P=!1,E=-1;function $(){P&&C&&(P=!1,C.length?d=C.concat(d):E=-1,d.length&&c())}function c(){if(!P){var w=I($);P=!0;for(var h=d.length;h;){for(C=d,d=[];++E<h;)C&&C[E].run();E=-1,h=d.length}C=null,P=!1,function(l){if(N===clearTimeout)return clearTimeout(l);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(l);try{N(l)}catch{try{return N.call(null,l)}catch{return N.call(this,l)}}}(w)}}function g(w,h){this.fun=w,this.array=h}function p(){}A.nextTick=function(w){var h=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)h[l-1]=arguments[l];d.push(new g(w,h)),d.length!==1||P||I(c)},g.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=p,A.addListener=p,A.once=p,A.off=p,A.removeListener=p,A.removeAllListeners=p,A.emit=p,A.prependListener=p,A.prependOnceListener=p,A.listeners=function(w){return[]},A.binding=function(w){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(w){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class N{constructor(I,C,d){this.level=I,this.key=C,this.value=d,this.forward=[]}}const A=void 0;class L{constructor(I,C=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A),this.f=0}has(I){return!!L.g(this,I,this.comparator)}get(I){return L.g(this,I,this.comparator)?.value}set(I,C){return L.h(this,I,C,this.comparator)&&(this.f+=1),this}delete(I){const C=L.k(this,I,this.comparator);return C&&(this.f-=1),C}forEach(I,C){let d=this.e.forward[0];for(;d;)I.call(C,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this.e.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static g(I,C,d){let P=I.e;for(let E=I.d-1;E>=0;E--)for(;P.forward[E]&&d(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&d(P.key,C)===0)return P}static h(I,C,d,P){const E=[];let $=I.e;for(let c=I.d-1;c>=0;c--){for(;$.forward[c]&&P($.forward[c].key,C)<0;)$=$.forward[c];E[c]=$}if($=$.forward[0],$&&P($.key,C)===0)return $.value=d,!1;{const c=L.j(I);if(c>I.d){for(let g=I.d;g<c;g++)E[g]=I.e;I.d=c}$=new N(c,C,d);for(let g=0;g<c;g++)$.forward[g]=E[g].forward[g],E[g].forward[g]=$;return!0}}static j(I,C=.5){let d=1;for(;Math.random()<C&&d<I.c;)d+=1;return d}static k(I,C,d){const P=[];let E=I.e;for(let $=I.d-1;$>=0;$--){for(;E.forward[$]&&d(E.forward[$].key,C)<0;)E=E.forward[$];P[$]=E}if(E=E.forward[0],!E||d(E.key,C)!==0)return!1;for(let $=0;$<I.d&&P[$].forward[$]===E;$++)P[$].forward[$]=E.forward[$];for(;I.d>0&&I.e.forward[I.d-1]===A;)I.d-=1;return!0}}e.$ur=L}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=D&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=N}),define(oe[3],ae([0,1,8,84,2,87,60]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const I=!1,C=!1;var d;(function(y){y.None=()=>A.$Rc.None;function f(ue){if(C){const{onDidAddListener:he}=ue,$e=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function m(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}y.defer=m;function j(ue){return(he,$e=null,de)=>{let we=!1,Ee;return Ee=ue(Ie=>{if(!we)return Ee?Ee.dispose():we=!0,he.call($e,Ie)},null,de),we&&Ee.dispose(),Ee}}y.once=j;function M(ue,he,$e){return Y((de,we=null,Ee)=>ue(Ie=>de.call(we,he(Ie)),null,Ee),$e)}y.map=M;function T(ue,he,$e){return Y((de,we=null,Ee)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,Ee),$e)}y.forEach=T;function U(ue,he,$e){return Y((de,we=null,Ee)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,Ee),$e)}y.filter=U;function q(ue){return ue}y.signal=q;function _(...ue){return(he,$e=null,de)=>{const we=(0,A.$Oc)(...ue.map(Ee=>Ee(Ie=>he.call($e,Ie))));return G(we,de)}}y.any=_;function K(ue,he,$e,de){let we=$e;return M(ue,Ee=>(we=he(we,Ee),we),de)}y.reduce=K;function Y(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||f(de);const we=new u(de);return he?.add(we),we.event}function G(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,$e=100,de=!1,we=!1,Ee,Ie){let Ne,Te,ce,ge=0,be;const Se={leakWarningThreshold:Ee,onWillAddFirstListener(){Ne=ue(Ue=>{ge++,Te=he(Te,Ue),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Ie||f(Se);const Pe=new u(Se);return Ie?.add(Pe),Pe.event}y.debounce=Q;function H(ue,he=0,$e){return y.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}y.accumulate=H;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,Ee=>{const Ie=de||!he(Ee,we);return de=!1,we=Ee,Ie},$e)}y.latch=V;function W(ue,he,$e){return[y.filter(ue,he,$e),y.filter(ue,de=>!he(de),$e)]}y.split=W;function ee(ue,he=!1,$e=[],de){let we=$e.slice(),Ee=ue(Te=>{we?we.push(Te):Ne.fire(Te)});de&&de.add(Ee);const Ie=()=>{we?.forEach(Te=>Ne.fire(Te)),we=null},Ne=new u({onWillAddFirstListener(){Ee||(Ee=ue(Te=>Ne.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Ne),Ne.event}y.buffer=ee;function ne(ue,he){return(de,we,Ee)=>{const Ie=he(new X);return ue(function(Ne){const Te=Ie.evaluate(Ne);Te!==re&&de.call(we,Te)},void 0,Ee)}}y.chain=ne;const re=Symbol("HaltChainable");class X{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:re),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!he(we,de);return $e=!1,de=we,Ee?we:re}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===re)break;return he}}function B(ue,he,$e=de=>de){const de=(...Ne)=>Ie.fire($e(...Ne)),we=()=>ue.on(he,de),Ee=()=>ue.removeListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}y.fromNodeEventEmitter=B;function S(ue,he,$e=de=>de){const de=(...Ne)=>Ie.fire($e(...Ne)),we=()=>ue.addEventListener(he,de),Ee=()=>ue.removeEventListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}y.fromDOMEventEmitter=S;function R(ue){return new Promise(he=>j(ue)(he))}y.toPromise=R;function z(ue){const he=new u;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}y.fromPromise=z;function F(ue,he){return he(void 0),ue($e=>he($e))}y.runAndSubscribe=F;function J(ue,he){let $e=null;function de(Ee){$e?.dispose(),$e=new A.$Qc,he(Ee,$e)}de(void 0);const we=ue(Ee=>de(Ee));return(0,A.$Pc)(()=>{we.dispose(),$e?.dispose()})}y.runAndSubscribeWithStore=J;class Z{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||f(de),this.emitter=new u(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function se(ue,he){return new Z(ue,he).emitter.event}y.fromObservable=se;function le(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}y.fromObservableLight=le})(d||(e.Event=d={}));class P{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${P.f++}`,P.all.add(this)}start(f){this.g=new O.$Id,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Kd=P;let E=-1;function $(y){const f=E;return E=y,{dispose(){E=f}}}e.$Ld=$;class c{constructor(f,m=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=m,this.g=0}dispose(){this.f?.clear()}check(f,m){const j=this.threshold;if(j<=0||m<j)return;this.f||(this.f=new Map);const M=this.f.get(f.value)||0;if(this.f.set(f.value,M+1),this.g-=1,this.g<=0){this.g=j*.5;let T,U=0;for(const[q,_]of this.f)(!T||U<_)&&(T=q,U=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this.f.get(f.value)||0;this.f.set(f.value,T-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(f){this.value=f,this.id=p++}}const h=2,l=(y,f)=>{if(y instanceof w)f(y);else for(let m=0;m<y.length;m++){const j=y[m];j&&f(j)}};class u{constructor(f){this.w=0,this.f=f,this.g=E>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const f=this.t;queueMicrotask(()=>{l(f,m=>m.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,m,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Rc.None;if(this.m)return A.$Rc.None;m&&(f=f.bind(m));const M=new w(f);let T,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=g.create(),T=this.g.check(M.stack,this.w+1)),I&&(M.stack=U??g.create()),this.t?this.t instanceof w?(this.u??=new k,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,A.$Pc)(()=>{T?.(),this.x(M)});return j instanceof A.$Qc?j.add(q):Array.isArray(j)&&j.push(q),q},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const m=this.t,j=m.indexOf(f);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,m[j]=void 0;const M=this.u.current===this;if(this.w*h<=m.length){let T=0;for(let U=0;U<m.length;U++)m[U]?m[T++]=m[U]:M&&(this.u.end--,T<this.u.i&&this.u.i--);m.length=T}}y(f,m){if(!f)return;const j=this.f?.onListenerError||D.$Z;if(!j){f.value(m);return}try{f.value(m)}catch(M){j(M)}}z(f){const m=f.current.t;for(;f.i<f.end;)this.y(m[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,f);else{const m=this.u;m.enqueue(this,f,this.t.length),this.z(m)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=u;const b=()=>new k;e.$Nd=b;class k{constructor(){this.i=-1,this.end=0}enqueue(f,m,j){this.i=0,this.end=j,this.current=f,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends u{async fireAsync(f,m,j){if(this.t)for(this.h||(this.h=new L.$1c),l(this.t,M=>this.h.push([M.value,f]));this.h.size>0&&!m.isCancellationRequested;){const[M,T]=this.h.shift(),U=[],q={...T,token:m,waitUntil:_=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");j&&(_=j(_,M)),U.push(_)}};try{M(q)}catch(_){(0,D.$Z)(_);continue}Object.freeze(U),await Promise.allSettled(U).then(_=>{for(const K of _)K.status==="rejected"&&(0,D.$Z)(K.reason)})}}}e.$Od=t;class a extends u{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$1c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Pd=a;class s extends a{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Qd=s;class n extends u{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(m=>super.fire(m)),this.h=[]}))}}e.$Rd=n;class i{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const m={event:f,listener:null};this.h.push(m),this.g&&this.m(m);const j=()=>{this.g&&this.o(m);const M=this.h.indexOf(m);this.h.splice(M,1)};return(0,A.$Pc)((0,N.$cb)(j))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(m=>this.f.fire(m))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Sd=i;class r{constructor(f,m,j,M){this.f=new A.$Qc;const T=this.f.add(new i),U=this.f.add(new A.$Zc);function q(_){U.set(_,T.add(M(_)))}for(const _ of f)q(_);this.f.add(m(_=>{q(_)})),this.f.add(j(_=>{U.deleteAndDispose(_)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Td=r;class o{constructor(){this.f=[]}wrapEvent(f){return(m,j,M)=>f(T=>{const U=this.f[this.f.length-1];U?U.push(()=>m.call(j,T)):m.call(j,T)},void 0,M)}bufferEvents(f){const m=[];this.f.push(m);const j=f();return this.f.pop(),m.forEach(M=>M()),j}}e.$Ud=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=A.$Rc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=v}),define(oe[26],ae([0,1,3]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const N=Object.freeze(function(I,C){const d=setTimeout(I.bind(C),0);return{dispose(){clearTimeout(d)}}});var A;(function(I){function C(d){return d===I.None||d===I.Cancelled||d instanceof L?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=A.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=A.None}}e.$Wd=O}),define(oe[129],ae([0,1,26]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new D.$Wd,C=this.b(I.token);return this.a={promise:C,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$ve=N;class A{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const C=JSON.stringify(I);return this.b!==C&&(this.b=C,this.a=this.c(I)),this.a}}e.$we=A;class L{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const C=this.b(I);return this.a.set(I,C),C}}e.$xe=L}),define(oe[46],ae([0,1,8,2]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function A(b){const k=b;return k?typeof k.read=="function":!1}e.$Xd=A;function L(b){const k=b;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.$Yd=L;function O(b){const k=b;return k?L(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$Zd=O;function I(b,k){return new C(b,k)}e.$1d=I;class C{constructor(k,t){this.e=k,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(t=>t(k))}h(k){this.c.error.length===0?(0,D.$Z)(k):this.c.error.slice(0).forEach(t=>t(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,t){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(k,t){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const s=a.indexOf(t);s>=0&&a.splice(s,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(b,k){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return k(t)}e.$2d=d;function P(b,k,t){const a=[];let s;for(;(s=b.read())!==null&&a.length<t;)a.push(s);return s===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return b.read()}}}e.$3d=P;function E(b,k){return new Promise((t,a)=>{const s=[];$(b,{onData:n=>{k&&s.push(n)},onError:n=>{k?a(n):t(void 0)},onEnd:()=>{t(k?k(s):void 0)}})})}e.$4d=E;function $(b,k,t){b.on("error",a=>{t?.isCancellationRequested||k.onError(a)}),b.on("end",()=>{t?.isCancellationRequested||k.onEnd()}),b.on("data",a=>{t?.isCancellationRequested||k.onData(a)})}e.$5d=$;function c(b,k){return new Promise((t,a)=>{const s=new N.$Qc,n=[],i=v=>{if(n.push(v),n.length>k)return s.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},r=v=>(s.dispose(),a(v)),o=()=>(s.dispose(),t({stream:b,buffer:n,ended:!0}));s.add((0,N.$Pc)(()=>b.removeListener("error",r))),b.on("error",r),s.add((0,N.$Pc)(()=>b.removeListener("end",o))),b.on("end",o),s.add((0,N.$Pc)(()=>b.removeListener("data",i))),b.on("data",i)})}e.$6d=c;function g(b,k){const t=I(k);return t.end(b),t}e.$7d=g;function p(){const b=I(()=>{throw new Error("not supported")});return b.end(),b}e.$8d=p;function w(b){let k=!1;return{read:()=>k?null:(k=!0,b)}}e.$9d=w;function h(b,k,t){const a=I(t);return $(b,{onData:s=>a.write(k.data(s)),onError:s=>a.error(k.error?k.error(s):s),onEnd:()=>a.end()}),a}e.$0d=h;function l(b,k,t){let a=!1;return{read:()=>{const s=k.read();return a?s:(a=!0,s!==null?t([b,s]):b)}}}e.$$d=l;function u(b,k,t){let a=!1;const s=I(t);return $(k,{onData:n=>a?s.write(n):(a=!0,s.write(t([b,n]))),onError:n=>s.error(n),onEnd:()=>{a||(a=!0,s.write(b)),s.end()}}),s}e.$_d=u}),define(oe[15],ae([0,1,86,46]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const A=typeof Buffer<"u",L=new D.$U(()=>new Uint8Array(256));let O,I;class C{static alloc(m){return A?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return A&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,j){return!(j?.dontUseNodeBuffer||!1)&&A?new C(Buffer.from(m)):(O||(O=new TextEncoder),new C(O.encode(m)))}static fromByteArray(m){const j=C.alloc(m.length);for(let M=0,T=m.length;M<T;M++)j.buffer[M]=m[M];return j}static concat(m,j){if(typeof j>"u"){j=0;for(let U=0,q=m.length;U<q;U++)j+=m[U].byteLength}const M=C.alloc(j);let T=0;for(let U=0,q=m.length;U<q;U++){const _=m[U];M.set(_,T),T+=_.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(m,j){return new C(this.buffer.subarray(m,j))}set(m,j){if(m instanceof C)this.buffer.set(m.buffer,j);else if(m instanceof Uint8Array)this.buffer.set(m,j);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),j);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return $(this.buffer,m)}writeUInt32BE(m,j){c(this.buffer,m,j)}readUInt32LE(m){return g(this.buffer,m)}writeUInt32LE(m,j){p(this.buffer,m,j)}readUInt8(m){return w(this.buffer,m)}writeUInt8(m,j){h(this.buffer,m,j)}indexOf(m,j=0){return d(this.buffer,m instanceof C?m.buffer:m,j)}}e.$ae=C;function d(f,m,j=0){const M=m.byteLength,T=f.byteLength;if(M===0)return 0;if(M===1)return f.indexOf(m[0]);if(M>T-j)return-1;const U=L.value;U.fill(m.length);for(let Y=0;Y<m.length;Y++)U[m[Y]]=m.length-Y-1;let q=j+m.length-1,_=q,K=-1;for(;q<T;)if(f[q]===m[_]){if(_===0){K=q;break}q--,_--}else q+=Math.max(m.length-_,U[f[q]]),_=m.length-1;return K}e.$be=d;function P(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.$ce=P;function E(f,m,j){f[j+0]=m&255,m=m>>>8,f[j+1]=m&255}e.$de=E;function $(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.$ee=$;function c(f,m,j){f[j+3]=m,m=m>>>8,f[j+2]=m,m=m>>>8,f[j+1]=m,m=m>>>8,f[j]=m}e.$fe=c;function g(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.$ge=g;function p(f,m,j){f[j+0]=m&255,m=m>>>8,f[j+1]=m&255,m=m>>>8,f[j+2]=m&255,m=m>>>8,f[j+3]=m&255}e.$he=p;function w(f,m){return f[m]}e.$ie=w;function h(f,m,j){f[j]=m}e.$je=h;function l(f){return N.$2d(f,m=>C.concat(m))}e.$ke=l;function u(f){return N.$9d(f)}e.$le=u;function b(f){return N.$4d(f,m=>C.concat(m))}e.$me=b;async function k(f){return f.ended?C.concat(f.buffer):C.concat([...f.buffer,await b(f.stream)])}e.$ne=k;function t(f){return N.$7d(f,m=>C.concat(m))}e.$oe=t;function a(f){return N.$0d(f,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.$pe=a;function s(f){return N.$1d(m=>C.concat(m),f)}e.$qe=s;function n(f,m){return N.$$d(f,m,j=>C.concat(j))}e.$re=n;function i(f,m){return N.$_d(f,m,j=>C.concat(j))}e.$se=i;function r(f){let m=0,j=0,M=0;const T=new Uint8Array(Math.floor(f.length/4*3)),U=_=>{switch(j){case 3:T[M++]=m|_,j=0;break;case 2:T[M++]=m|_>>>2,m=_<<6,j=3;break;case 1:T[M++]=m|_>>>4,m=_<<4,j=2;break;default:m=_<<2,j=1}};for(let _=0;_<f.length;_++){const K=f.charCodeAt(_);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${f[_]}`)}}const q=M;for(;j>0;)U(0);return C.wrap(T).slice(0,q)}e.$te=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:f},m=!0,j=!1){const M=j?v:o;let T="";const U=f.byteLength%3;let q=0;for(;q<f.byteLength-U;q+=3){const _=f[q+0],K=f[q+1],Y=f[q+2];T+=M[_>>>2],T+=M[(_<<4|K>>>4)&63],T+=M[(K<<2|Y>>>6)&63],T+=M[Y&63]}if(U===1){const _=f[q+0];T+=M[_>>>2],T+=M[_<<4&63],m&&(T+="==")}else if(U===2){const _=f[q+0],K=f[q+1];T+=M[_>>>2],T+=M[(_<<4|K>>>4)&63],T+=M[K<<2&63],m&&(T+="=")}return T}e.$ue=y}),define(oe[27],ae([0,1,129,86]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Ae=A;const L=/{(\d+)}/g;function O(ie,...fe){return fe.length===0?ie:ie.replace(L,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$Be=O;const I=/{([^}]+)}/g;function C(ie,fe){return ie.replace(I,(me,pe)=>fe[pe]??me)}e.$Ce=C;function d(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$De=d;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=P;function E(ie,fe){let me=0;const pe=fe.charCodeAt(0);for(let ke=ie.length-1;ke>=0;ke--)ie.charCodeAt(ke)===pe&&me++;return me}e.$Fe=E;function $(ie,fe,me="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${me}`}e.$Ge=$;function c(ie,fe=" "){const me=g(ie,fe);return p(me,fe)}e.$He=c;function g(ie,fe){if(!ie||!fe)return ie;const me=fe.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(fe,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$Ie=g;function p(ie,fe){if(!ie||!fe)return ie;const me=fe.length,pe=ie.length;if(me===0||pe===0)return ie;let ke=pe,Re=-1;for(;Re=ie.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return ie.substring(0,ke)}e.$Je=p;function w(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=w;function h(ie){return ie.replace(/\*/g,"")}e.$Le=h;function l(ie,fe,me={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=P(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$Me=l;function u(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Ne=u;function b(ie){return ie.split(/\r\n|\r|\n/)}e.$Oe=b;function k(ie){for(let fe=0,me=ie.length;fe<me;fe++){const pe=ie.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Pe=k;function t(ie,fe=0,me=ie.length){for(let pe=fe;pe<me;pe++){const ke=ie.charCodeAt(pe);if(ke!==32&&ke!==9)return ie.substring(fe,pe)}return ie.substring(fe,me)}e.$Qe=t;function a(ie,fe=ie.length-1){for(let me=fe;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Re=a;function s(ie,fe,me){const pe=[];let ke=0;for(const Re of ie.matchAll(fe)){if(pe.push(ie.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(ke)),Promise.all(pe).then(Re=>Re.join(""))}e.$Se=s;function n(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Te=n;function i(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){const Oe=ie.charCodeAt(me),Le=fe.charCodeAt(ke);if(Oe<Le)return-1;if(Oe>Le)return 1}const Ce=pe-me,De=Re-ke;return Ce<De?-1:Ce>De?1:0}e.$Ue=i;function r(ie,fe){return o(ie,fe,0,ie.length,0,fe.length)}e.$Ve=r;function o(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){let Oe=ie.charCodeAt(me),Le=fe.charCodeAt(ke);if(Oe===Le)continue;if(Oe>=128||Le>=128)return i(ie.toLowerCase(),fe.toLowerCase(),me,pe,ke,Re);y(Oe)&&(Oe-=32),y(Le)&&(Le-=32);const Me=Oe-Le;if(Me!==0)return Me}const Ce=pe-me,De=Re-ke;return Ce<De?-1:Ce>De?1:0}e.$We=o;function v(ie){return ie>=48&&ie<=57}e.$Xe=v;function y(ie){return ie>=97&&ie<=122}e.$Ye=y;function f(ie){return ie>=65&&ie<=90}e.$Ze=f;function m(ie,fe){return ie.length===fe.length&&o(ie,fe)===0}e.$1e=m;function j(ie,fe){const me=fe.length;return fe.length>ie.length?!1:o(ie,fe,0,me)===0}e.$2e=j;function M(ie,fe){const me=Math.min(ie.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$3e=M;function T(ie,fe){const me=Math.min(ie.length,fe.length);let pe;const ke=ie.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(ke-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$4e=T;function U(ie){return 55296<=ie&&ie<=56319}e.$5e=U;function q(ie){return 56320<=ie&&ie<=57343}e.$6e=q;function _(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$7e=_;function K(ie,fe,me){const pe=ie.charCodeAt(me);if(U(pe)&&me+1<fe){const ke=ie.charCodeAt(me+1);if(q(ke))return _(pe,ke)}return pe}e.$8e=K;function Y(ie,fe){const me=ie.charCodeAt(fe-1);if(q(me)&&fe>1){const pe=ie.charCodeAt(fe-2);if(U(pe))return _(pe,me)}return me}class G{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=Y(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$9e=G;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new G(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,ke)){me.setOffset(Re);break}ke=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$0e=Q;function H(ie,fe){return new Q(ie,fe).nextGraphemeLength()}e.$$e=H;function V(ie,fe){return new Q(ie,fe).prevGraphemeLength()}e.$_e=V;function W(ie,fe){fe>0&&q(ie.charCodeAt(fe))&&fe--;const me=fe+H(ie,fe);return[me-V(ie,me),me]}e.$af=W;function ee(ie){const fe=new Q(ie);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$bf=ee;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(ie){return ne||(ne=re()),ne.test(ie)}e.$cf=X;const B=/^[\t\n\r\x20-\x7E]*$/;function S(ie){return B.test(ie)}e.$df=S,e.$ef=/[\u2028\u2029]/;function R(ie){return e.$ef.test(ie)}e.$ff=R;function z(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$gf=z;function F(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$hf=F;function J(ie,fe){if(ie.length<fe)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$if=J;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(Z,"").replace(se,"")),ie}e.$jf=le,e.$kf=String.fromCharCode(65279);function ue(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$lf=ue;function he(ie){return ue(ie)?ie.substr(1):ie}e.$mf=he;function $e(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const me=fe.length,pe=ie.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=pe.indexOf(fe[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$nf=$e;function de(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$of=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$pf=we;function Ee(ie,fe=1){if(fe===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$qf=Ee;function Ie(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$rf=Ie;function Ne(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$sf=Ne;function Te(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(ie,fe){if(ie===0)return 0;const me=Pe(ie,fe);if(me!==void 0)return me;const pe=new G(fe,ie);return pe.prevCodePoint(),pe.offset}e.$tf=Se;function Pe(ie,fe){const me=new G(fe,ie);let pe=me.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!F(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ue(ie){return 127995<=ie&&ie<=127999}var je;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$uf="\xA0";class ze{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$we(fe=>{function me(Me){const Be=new Map;for(let qe=0;qe<Me.length;qe+=2)Be.set(Me[qe],Me[qe+1]);return Be}function pe(Me,Be){const qe=new Map(Me);for(const[We,_e]of Be)qe.set(We,_e);return qe}function ke(Me,Be){if(!Me)return Be;const qe=new Map;for(const[We,_e]of Me)Be.has(We)&&qe.set(We,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Me=>!Me.startsWith("_")&&Me in Re);Ce.length===0&&(Ce=["_default"]);let De;for(const Me of Ce){const Be=me(Re[Me]);De=ke(De,Be)}const Oe=me(Re._common),Le=pe(Oe,De);return new ze(Le)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new N.$U(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=ze;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$wf=Fe}),define(oe[51],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function N(h){return A(h,0)}e.$Bi=N;function A(h,l){switch(typeof h){case"object":return h===null?L(349,l):Array.isArray(h)?C(h,l):d(h,l);case"string":return I(h,l);case"boolean":return O(h,l);case"number":return L(h,l);case"undefined":return L(937,l);default:return L(617,l)}}e.$Ci=A;function L(h,l){return(l<<5)-l+h|0}e.$Di=L;function O(h,l){return L(h?433:863,l)}function I(h,l){l=L(149417,l);for(let u=0,b=h.length;u<b;u++)l=L(h.charCodeAt(u),l);return l}e.$Ei=I;function C(h,l){return l=L(104579,l),h.reduce((u,b)=>A(b,u),l)}function d(h,l){return l=L(181387,l),Object.keys(h).sort().reduce((u,b)=>(u=I(b,u),A(h[b],u)),l)}class P{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=A(l,this.g),this.g}}e.$Fi=P;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function $(h,l,u=32){const b=u-l,k=~((1<<b)-1);return(h<<l|(k&h)>>>b)>>>0}function c(h,l=0,u=h.byteLength,b=0){for(let k=0;k<u;k++)h[l+k]=b}function g(h,l,u="0"){for(;h.length<l;)h=u+h;return h}function p(h,l=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),l/4)}e.$Gi=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const u=l.length;if(u===0)return;const b=this.p;let k=this.r,t=this.u,a,s;for(t!==0?(a=t,s=-1,t=0):(a=l.charCodeAt(0),s=0);;){let n=a;if(D.$5e(a))if(s+1<u){const i=l.charCodeAt(s+1);D.$6e(i)?(s++,n=D.$7e(a,i)):n=65533}else{t=a;break}else D.$6e(a)&&(n=65533);if(k=this.w(b,k,n),s++,s<u)a=l.charCodeAt(s);else break}this.r=k,this.u=t}w(l,u,b){return b<128?l[u++]=b:b<2048?(l[u++]=192|(b&1984)>>>6,l[u++]=128|(b&63)>>>0):b<65536?(l[u++]=224|(b&61440)>>>12,l[u++]=128|(b&4032)>>>6,l[u++]=128|(b&63)>>>0):(l[u++]=240|(b&1835008)>>>18,l[u++]=128|(b&258048)>>>12,l[u++]=128|(b&4032)>>>6,l[u++]=128|(b&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=w.g,u=this.q;for(let o=0;o<64;o+=4)l.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)l.setUint32(o,$(l.getUint32(o-12,!1)^l.getUint32(o-32,!1)^l.getUint32(o-56,!1)^l.getUint32(o-64,!1),1),!1);let b=this.h,k=this.l,t=this.m,a=this.n,s=this.o,n,i,r;for(let o=0;o<80;o++)o<20?(n=k&t|~k&a,i=1518500249):o<40?(n=k^t^a,i=1859775393):o<60?(n=k&t|k&a|t&a,i=2400959708):(n=k^t^a,i=3395469782),r=$(b,5)+n+s+i+l.getUint32(o*4,!1)&4294967295,s=a,a=t,t=$(k,30),k=b,b=r;this.h=this.h+b&4294967295,this.l=this.l+k&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+s&4294967295}}e.$Hi=w}),define(oe[89],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const L="error",O="warning",I="warn",C="info",d="ignore";function P($){return $?D.$1e(L,$)?A.Error:D.$1e(O,$)||D.$1e(I,$)?A.Warning:D.$1e(C,$)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function E($){switch($){case A.Error:return L;case A.Warning:return O;case A.Info:return C;default:return d}}A.toString=E}(N||(N={})),e.default=N}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class A{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const g=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.$Ph=A;class L{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$Ue)(c,this.b,0,c.length,this.c,this.d):(0,N.$We)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=L;class O{constructor(c=!0,g=!0){this.f=c,this.g=g}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let g=c.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$Ue)(c,this.b,0,c.length,this.d,this.e):(0,N.$We)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=O;var I;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(c,g){this.f=c,this.g=g,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$Ve)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ve)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$Te)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$Te)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=C;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(P||(P={}));class E{static forUris(c=()=>!1,g=()=>!1){return new E(new C(c,g))}static forPaths(c=!1){return new E(new O(void 0,!c))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new L)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,g){if(g){const p=g.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w,c)}else{const p=c.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w[0],w[1])}}set(c,g){const p=this.b.reset(c);let w;this.c||(this.c=new d,this.c.segment=p.value());const h=[];for(w=this.c;;){const u=p.cmp(w.segment);if(u>0)w.left||(w.left=new d,w.left.segment=p.value()),h.push([-1,w]),w=w.left;else if(u<0)w.right||(w.right=new d,w.right.segment=p.value()),h.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new d,w.mid.segment=p.value()),h.push([0,w]),w=w.mid;else break}const l=w.value;w.value=g,w.key=c;for(let u=h.length-1;u>=0;u--){const b=h[u][1];b.updateHeight();const k=b.balanceFactor();if(k<-1||k>1){const t=h[u][0],a=h[u+1][0];if(t===1&&a===1)h[u][1]=b.rotateLeft();else if(t===-1&&a===-1)h[u][1]=b.rotateRight();else if(t===1&&a===-1)b.right=h[u+1][1]=h[u+1][1].rotateRight(),h[u][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=h[u+1][1]=h[u+1][1].rotateLeft(),h[u][1]=b.rotateRight();else throw new Error;if(u>0)switch(h[u-1][0]){case-1:h[u-1][1].left=h[u][1];break;case 1:h[u-1][1].right=h[u][1];break;case 0:h[u-1][1].mid=h[u][1];break}else this.c=h[0][1]}}return l}get(c){return this.d(c)?.value}d(c){const g=this.b.reset(c);let p=this.c;for(;p;){const w=g.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(c){const g=this.d(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,g){const p=this.b.reset(c),w=[];let h=this.c;for(;h;){const l=p.cmp(h.segment);if(l>0)w.push([-1,h]),h=h.left;else if(l<0)w.push([1,h]),h=h.right;else if(p.hasNext())p.next(),w.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const l=this.f(h.right);if(l.key){const{key:u,value:b,segment:k}=l;this.e(l.key,!1),h.key=u,h.value=b,h.segment=k}}else{const l=h.left??h.right;if(w.length>0){const[u,b]=w[w.length-1];switch(u){case-1:b.left=l;break;case 0:b.mid=l;break;case 1:b.right=l;break}}else this.c=l}for(let l=w.length-1;l>=0;l--){const u=w[l][1];u.updateHeight();const b=u.balanceFactor();if(b>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),w[l][1]=u.rotateLeft()):b<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),w[l][1]=u.rotateRight()),l>0)switch(w[l-1][0]){case-1:w[l-1][1].left=w[l][1];break;case 1:w[l-1][1].right=w[l][1];break;case 0:w[l-1][1].mid=w[l][1];break}else this.c=w[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this.b.reset(c);let p=this.c,w;for(;p;){const h=g.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(g.hasNext())g.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(c){return this.g(c,!1)}g(c,g){const p=this.b.reset(c);let w=this.c;for(;w;){const h=p.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[g,p]of this)c(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const g=[];return this.j(c,g),g[Symbol.iterator]()}j(c,g){c&&(c.left&&this.j(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this.j(c.mid,g),c.right&&this.j(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:c(g.left)&&c(g.right)};return c(this.c)}}e.$Th=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function D(k){return typeof k=="string"}e.$xf=D;function N(k){return Array.isArray(k)&&k.every(t=>D(t))}e.$yf=N;function A(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.$zf=A;function L(k){const t=Object.getPrototypeOf(Uint8Array);return typeof k=="object"&&k instanceof t}e.$Af=L;function O(k){return typeof k=="number"&&!isNaN(k)}e.$Bf=O;function I(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.$Cf=I;function C(k){return k===!0||k===!1}e.$Df=C;function d(k){return typeof k>"u"}e.$Ef=d;function P(k){return!E(k)}e.$Ff=P;function E(k){return d(k)||k===null}e.$Gf=E;function $(k,t){if(!k)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Hf=$;function c(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.$If=c;function g(...k){const t=[];for(let a=0;a<k.length;a++){const s=k[a];if(E(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(s)}return t}e.$Jf=g;const p=Object.prototype.hasOwnProperty;function w(k){if(!A(k))return!1;for(const t in k)if(p.call(k,t))return!1;return!0}e.$Kf=w;function h(k){return typeof k=="function"}e.$Lf=h;function l(...k){return k.length>0&&k.every(h)}e.$Mf=l;function u(k,t){const a=Math.min(k.length,t.length);for(let s=0;s<a;s++)b(k[s],t[s])}e.$Nf=u;function b(k,t){if(D(t)){if(typeof k!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(k instanceof t)return}catch{}if(!E(k)&&k.constructor===t||t.length===1&&t.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=b}),define(oe[30],ae([0,1,12]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const l=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([u,b])=>{l[u]=b&&typeof b=="object"?N(b):b}),l}e.$2m=N;function A(h){if(!h||typeof h!="object")return h;const l=[h];for(;l.length>0;){const u=l.shift();Object.freeze(u);for(const b in u)if(L.call(u,b)){const k=u[b];typeof k=="object"&&!Object.isFrozen(k)&&!(0,D.$Af)(k)&&l.push(k)}}return h}e.$3m=A;const L=Object.prototype.hasOwnProperty;function O(h,l){return I(h,l,new Set)}e.$4m=O;function I(h,l,u){if((0,D.$Gf)(h))return h;const b=l(h);if(typeof b<"u")return b;if(Array.isArray(h)){const k=[];for(const t of h)k.push(I(t,l,u));return k}if((0,D.$zf)(h)){if(u.has(h))throw new Error("Cannot clone recursive data-structure");u.add(h);const k={};for(const t in h)L.call(h,t)&&(k[t]=I(h[t],l,u));return u.delete(h),k}return h}function C(h,l,u=!0){return(0,D.$zf)(h)?((0,D.$zf)(l)&&Object.keys(l).forEach(b=>{b in h?u&&((0,D.$zf)(h[b])&&(0,D.$zf)(l[b])?C(h[b],l[b],u):h[b]=l[b]):h[b]=l[b]}),h):l}e.$5m=C;function d(h,l){if(h===l)return!0;if(h==null||l===null||l===void 0||typeof h!=typeof l||typeof h!="object"||Array.isArray(h)!==Array.isArray(l))return!1;let u,b;if(Array.isArray(h)){if(h.length!==l.length)return!1;for(u=0;u<h.length;u++)if(!d(h[u],l[u]))return!1}else{const k=[];for(b in h)k.push(b);k.sort();const t=[];for(b in l)t.push(b);if(t.sort(),!d(k,t))return!1;for(u=0;u<k.length;u++)if(!d(h[k[u]],l[k[u]]))return!1}return!0}e.$6m=d;function P(h){const l=new Set;return JSON.stringify(h,(u,b)=>{if((0,D.$zf)(b)||Array.isArray(b)){if(l.has(b))return"[Circular]";l.add(b)}return b})}e.$7m=P;function E(h,l){const u=Object.create(null);return!h||!l||Object.keys(l).forEach(k=>{const t=h[k],a=l[k];d(t,a)||(u[k]=a)}),u}e.$8m=E;function $(h,l){const u=l.toLowerCase(),b=Object.keys(h).find(k=>k.toLowerCase()===u);return b?h[b]:h[l]}e.$9m=$;function c(h,l){const u=Object.create(null);for(const[b,k]of Object.entries(h))l(b,k)&&(u[b]=k);return u}e.$0m=c;function g(h){let l=[];for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.$$m=g;function p(h){const l=[];for(const u of g(h))typeof h[u]=="function"&&l.push(u);return l}e.$_m=p;function w(h,l){const u=k=>function(){const t=Array.prototype.slice.call(arguments,0);return l(k,t)},b={};for(const k of h)b[k]=u(k);return b}e.$an=w}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return D.test(A)}e.$cg=N,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let C=0,d="";return d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d+="-",d+=O[L[C++]],d+=O[L[C++]],d+="-",d+=O[L[C++]],d+=O[L[C++]],d+="-",d+=O[L[C++]],d+=O[L[C++]],d+="-",d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d+=O[L[C++]],d}}()}),define(oe[131],ae([0,1,36]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function L(){const O=(0,D.networkInterfaces)();for(const I in O){const C=O[I];if(C){for(const{mac:d}of C)if(A(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Mm=L}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=void 0,e.$Nm=new class{c(d){return this.a||(this.a=N.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,P=0;const E=(0,D.networkInterfaces)();for(const $ in E){const c=E[$];if(c)for(const{mac:g,internal:p}of c)p||(P+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=P>0?d/P:0}return this.b}};let O;async function I(d){return O||(O=(async()=>await C(d)||A.$dg())()),O}e.$Om=I;async function C(d){try{const P=await new Promise(($,c)=>{te(["crypto"],$,c)}),E=(0,L.$Mm)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){d(P);return}}}),define(oe[133],ae([0,1,268,15]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9S=void 0;class A extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$be)(this.a,this.b,d);if(P===-1)break;this.push(this.a.slice(d,P+this.c)),d=P+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$9S=A}),define(oe[134],ae([0,1,61]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function N(I,C,d,P=1){let E=!1;return new Promise($=>{const c=setTimeout(()=>{if(!E)return E=!0,$(0)},d);A(I,C,P,g=>{if(!E)return E=!0,clearTimeout(c),$(g)})})}e.$fg=N;function A(I,C,d,P){if(C===0)return P(0);const E=new D.Socket;E.once("connect",()=>(O(E),A(I+d,C-1,d,P))),E.once("data",()=>{}),E.once("error",$=>(O(E),$.code!=="ECONNREFUSED"?A(I+d,C-1,d,P):P(I))),E.connect(I,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,C,d,P="127.0.0.1"){let E=!1,$,c=1;const g=D.createServer({pauseOnConnect:!0});function p(w,h){E||(E=!0,g.removeAllListeners(),g.close(),$&&clearTimeout($),h(w))}return new Promise(w=>{$=setTimeout(()=>{p(0,w)},d),g.on("listening",()=>{p(I,w)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&c<C?(I++,c++,g.listen(I,P)):p(0,w)}),g.on("close",()=>{p(0,w)}),g.listen(I,P)})}e.$hg=L;function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mT=void 0;function D(N){return!!N.parentPort}e.$mT=D}),define(oe[136],ae([13,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,136]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const N=60,A=N*60,L=A*24,O=L*7,I=L*30,C=L*365;function d(E,$,c,g){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,D.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,D.localize)(1,null);let w;return p<N?(w=p,$?w===1?c?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):c?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?c?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):c?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):p<A?(w=Math.floor(p/N),$?w===1?c?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):c?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?c?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):c?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):p<L?(w=Math.floor(p/A),$?w===1?c?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):c?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?c?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):c?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):p<O?(w=Math.floor(p/L),$?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):p<I?(w=Math.floor(p/O),$?w===1?c?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):c?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?c?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):c?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):p<C?(w=Math.floor(p/I),$?w===1?c?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):c?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?c?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):c?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(p/C),$?w===1?c?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):c?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?c?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):c?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$_l=d;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=P}),define(oe[137],ae([13,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,137]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function L(E,$){return $&&(E.stack||E.stacktrace)?A.localize(0,null,I(E),O(E.stack)||O(E.stacktrace)):I(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function C(E=null,$=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const c=D.$Gb(E),g=C(c[0],$);return c.length>1?A.localize(4,null,g,c.length):g}if(N.$xf(E))return E;if(E.detail){const c=E.detail;if(c.error)return L(c.error,$);if(c.exception)return L(c.exception,$)}return E.stack?L(E,$):E.message?E.message:A.localize(5,null)}e.$yi=C;function d(E){const $=E;return $ instanceof Error&&Array.isArray($.actions)}e.$zi=d;function P(E,$){let c;return typeof E=="string"?c=new Error(E):c=E,c.actions=$,c}e.$Ai=P}),define(oe[138],ae([13,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;function N(A){switch(A){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$sp=N}),define(oe[140],ae([13,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let N=!1,A=!1,L=!1,O=!1,I=!1,C=!1,d=!1,P=!1,E=!1,$=!1,c,g=e.$g,p=e.$g,w,h;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?l=e.$h.vscode.process:typeof process<"u"&&(l=process);const u=typeof l?.versions?.electron=="string",b=u&&l?.type==="renderer";if(typeof navigator=="object"&&!b)h=navigator.userAgent,N=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,$=h?.indexOf("Mobi")>=0,C=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=c,p=navigator.language;else if(typeof l=="object"){N=l.platform==="win32",A=l.platform==="darwin",L=l.platform==="linux",O=L&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=u,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,g=e.$g;const v=l.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),f=y.availableLanguages["*"];c=y.locale,p=y.osLocale,g=f||e.$g,w=y._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var k;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(k||(e.Platform=k={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let a=0;A?a=1:N?a=3:L&&(a=2),e.$j=N,e.$k=A,e.$l=L,e.$m=O,e.$n=I,e.$o=d,e.$p=C,e.$q=C&&typeof e.$h.importScripts=="function",e.$r=P,e.$s=$,e.$t=E,e.$u=a,e.$v=h,e.$w=g;var s;(function(v){function y(){return e.$w}v.value=y;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=f;function m(){return e.$w==="en"}v.isDefault=m})(s||(e.Language=s={})),e.$x=c,e.$y=p,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let m=0,j=v.length;m<j;m++){const M=v[m];if(M.id===f.data.vscodeScheduleAsyncWork){v.splice(m,1),M.callback();return}}});let y=0;return f=>{const m=++y;v.push({id:m,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:m},"*")}}return v=>setTimeout(v)})();var n;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=A||P?2:N?1:3;let i=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,i=new Uint16Array(v.buffer)[0]===(2<<8)+1}return i}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let N;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const A=D.$h.vscode.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$cc=N.platform,e.$dc=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const N=65,A=97,L=90,O=122,I=46,C=47,d=92,P=58,E=63;class $ extends Error{constructor(a,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${i} of type ${s}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function c(t,a){if(t===null||typeof t!="object")throw new $(a,"Object",t)}function g(t,a){if(typeof t!="string")throw new $(a,"string",t)}const p=D.$cc==="win32";function w(t){return t===C||t===d}function h(t){return t===C}function l(t){return t>=N&&t<=L||t>=A&&t<=O}function u(t,a,s,n){let i="",r=0,o=-1,v=0,y=0;for(let f=0;f<=t.length;++f){if(f<t.length)y=t.charCodeAt(f);else{if(n(y))break;y=C}if(n(y)){if(!(o===f-1||v===1))if(v===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const m=i.lastIndexOf(s);m===-1?(i="",r=0):(i=i.slice(0,m),r=i.length-1-i.lastIndexOf(s)),o=f,v=0;continue}else if(i.length!==0){i="",r=0,o=f,v=0;continue}}a&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(o+1,f)}`:i=t.slice(o+1,f),r=f-o-1;o=f,v=0}else y===I&&v!==-1?++v:v=-1}return i}function b(t,a){c(a,"pathObject");const s=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${n}`:`${s}${t}${n}`:n}e.$ec={resolve(...t){let a="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],g(r,"path"),r.length===0)continue}else a.length===0?r=D.cwd():(r=D.env[`=${a}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,y="",f=!1;const m=r.charCodeAt(0);if(o===1)w(m)&&(v=1,f=!0);else if(w(m))if(f=!0,w(r.charCodeAt(1))){let j=2,M=j;for(;j<o&&!w(r.charCodeAt(j));)j++;if(j<o&&j!==M){const T=r.slice(M,j);for(M=j;j<o&&w(r.charCodeAt(j));)j++;if(j<o&&j!==M){for(M=j;j<o&&!w(r.charCodeAt(j));)j++;(j===o||j!==M)&&(y=`\\\\${T}\\${r.slice(M,j)}`,v=j)}}}else v=1;else l(m)&&r.charCodeAt(1)===P&&(y=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(f=!0,v=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(n){if(a.length>0)break}else if(s=`${r.slice(v)}\\${s}`,n=f,f&&a.length>0)break}return s=u(s,!n,"\\",w),n?`${a}\\${s}`:`${a}${s}`||"."},normalize(t){g(t,"path");const a=t.length;if(a===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(a===1)return h(r)?"\\":t;if(w(r))if(i=!0,w(t.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(t.charCodeAt(v));)v++;if(v<a&&v!==y){const f=t.slice(y,v);for(y=v;v<a&&w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(t.charCodeAt(v));)v++;if(v===a)return`\\\\${f}\\${t.slice(y)}\\`;v!==y&&(n=`\\\\${f}\\${t.slice(y,v)}`,s=v)}}}else s=1;else l(r)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),s=2,a>2&&w(t.charCodeAt(2))&&(i=!0,s=3));let o=s<a?u(t.slice(s),!i,"\\",w):"";return o.length===0&&!i&&(o="."),o.length>0&&w(t.charCodeAt(a-1))&&(o+="\\"),n===void 0?i?`\\${o}`:o:i?`${n}\\${o}`:`${n}${o}`},isAbsolute(t){g(t,"path");const a=t.length;if(a===0)return!1;const s=t.charCodeAt(0);return w(s)||a>2&&l(s)&&t.charCodeAt(1)===P&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,s;for(let r=0;r<t.length;++r){const o=t[r];g(o,"path"),o.length>0&&(a===void 0?a=s=o:a+=`\\${o}`)}if(a===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++i;const r=s.length;r>1&&w(s.charCodeAt(1))&&(++i,r>2&&(w(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<a.length&&w(a.charCodeAt(i));)i++;i>=2&&(a=`\\${a.slice(i)}`)}return e.$ec.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a)return"";const s=e.$ec.resolve(t),n=e.$ec.resolve(a);if(s===n||(t=s.toLowerCase(),a=n.toLowerCase(),t===a))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===d;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===d;)r--;const o=r-i;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let y=a.length;for(;y-1>v&&a.charCodeAt(y-1)===d;)y--;const f=y-v,m=o<f?o:f;let j=-1,M=0;for(;M<m;M++){const U=t.charCodeAt(i+M);if(U!==a.charCodeAt(v+M))break;U===d&&(j=M)}if(M!==m){if(j===-1)return n}else{if(f>m){if(a.charCodeAt(v+M)===d)return n.slice(v+M+1);if(M===2)return n.slice(v+M)}o>m&&(t.charCodeAt(i+M)===d?j=M:M===2&&(j=3)),j===-1&&(j=0)}let T="";for(M=i+j+1;M<=r;++M)(M===r||t.charCodeAt(M)===d)&&(T+=T.length===0?"..":"\\..");return v+=j,T.length>0?`${T}${n.slice(v,y)}`:(n.charCodeAt(v)===d&&++v,n.slice(v,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$ec.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const s=a.charCodeAt(2);if(s!==E&&s!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return t},dirname(t){g(t,"path");const a=t.length;if(a===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(a===1)return w(i)?t:".";if(w(i)){if(s=n=1,w(t.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(t.charCodeAt(v));)v++;if(v===a)return t;v!==y&&(s=n=v+1)}}}}else l(i)&&t.charCodeAt(1)===P&&(s=a>2&&w(t.charCodeAt(2))?3:2,n=s);let r=-1,o=!0;for(let v=a-1;v>=n;--v)if(w(t.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,v=-1;for(r=t.length-1;r>=s;--r){const y=t.charCodeAt(r);if(w(y)){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(n=r):(o=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(w(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let a=0,s=-1,n=0,i=-1,r=!0,o=0;t.length>=2&&t.charCodeAt(1)===P&&l(t.charCodeAt(0))&&(a=n=2);for(let v=t.length-1;v>=a;--v){const y=t.charCodeAt(v);if(w(y)){if(!r){n=v+1;break}continue}i===-1&&(r=!1,i=v+1),y===I?s===-1?s=v:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:b.bind(null,"\\"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return w(i)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(w(i)){if(n=1,w(t.charCodeAt(1))){let j=2,M=j;for(;j<s&&!w(t.charCodeAt(j));)j++;if(j<s&&j!==M){for(M=j;j<s&&w(t.charCodeAt(j));)j++;if(j<s&&j!==M){for(M=j;j<s&&!w(t.charCodeAt(j));)j++;j===s?n=j:j!==M&&(n=j+1)}}}}else if(l(i)&&t.charCodeAt(1)===P){if(s<=2)return a.root=a.dir=t,a;if(n=2,w(t.charCodeAt(2))){if(s===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let r=-1,o=n,v=-1,y=!0,f=t.length-1,m=0;for(;f>=n;--f){if(i=t.charCodeAt(f),w(i)){if(!y){o=f+1;break}continue}v===-1&&(y=!1,v=f+1),i===I?r===-1?r=f:m!==1&&(m=1):r!==-1&&(m=-1)}return v!==-1&&(r===-1||m===0||m===1&&r===v-1&&r===o+1?a.base=a.name=t.slice(o,v):(a.name=t.slice(o,r),a.base=t.slice(o,v),a.ext=t.slice(r,v))),o>0&&o!==n?a.dir=t.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(p){const t=/\\/g;return()=>{const a=D.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...t){let a="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:k();g(i,"path"),i.length!==0&&(a=`${i}/${a}`,s=i.charCodeAt(0)===C)}return a=u(a,!s,"/",h),s?`/${a}`:a.length>0?a:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C,s=t.charCodeAt(t.length-1)===C;return t=u(t,!a,"/",h),t.length===0?a?"/":s?"./":".":(s&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let a;for(let s=0;s<t.length;++s){const n=t[s];g(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.$fc.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a||(t=e.$fc.resolve(t),a=e.$fc.resolve(a),t===a))return"";const s=1,n=t.length,i=n-s,r=1,o=a.length-r,v=i<o?i:o;let y=-1,f=0;for(;f<v;f++){const j=t.charCodeAt(s+f);if(j!==a.charCodeAt(r+f))break;j===C&&(y=f)}if(f===v)if(o>v){if(a.charCodeAt(r+f)===C)return a.slice(r+f+1);if(f===0)return a.slice(r+f)}else i>v&&(t.charCodeAt(s+f)===C?y=f:f===0&&(y=0));let m="";for(f=s+y+1;f<=n;++f)(f===n||t.charCodeAt(f)===C)&&(m+=m.length===0?"..":"/..");return`${m}${a.slice(r+y)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===C){if(!n){s=i;break}}else n=!1;return s===-1?a?"/":".":a&&s===1?"//":t.slice(0,s)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let s=0,n=-1,i=!0,r;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,v=-1;for(r=t.length-1;r>=0;--r){const y=t.charCodeAt(r);if(y===C){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(n=r):(o=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===C){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let a=-1,s=0,n=-1,i=!0,r=0;for(let o=t.length-1;o>=0;--o){const v=t.charCodeAt(o);if(v===C){if(!i){s=o+1;break}continue}n===-1&&(i=!1,n=o+1),v===I?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||n===-1||r===0||r===1&&a===n-1&&a===s+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.charCodeAt(0)===C;let n;s?(a.root="/",n=1):n=0;let i=-1,r=0,o=-1,v=!0,y=t.length-1,f=0;for(;y>=n;--y){const m=t.charCodeAt(y);if(m===C){if(!v){r=y+1;break}continue}o===-1&&(v=!1,o=y+1),m===I?i===-1?i=y:f!==1&&(f=1):i!==-1&&(f=-1)}if(o!==-1){const m=r===0&&s?1:r;i===-1||f===0||f===1&&i===o-1&&i===r+1?a.base=a.name=t.slice(m,o):(a.name=t.slice(m,i),a.base=t.slice(m,o),a.ext=t.slice(i,o))}return r>0?a.dir=t.slice(0,r-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(oe[48],ae([0,1,16,6,27,12]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function O(r){return r===47||r===92}e.$Pf=O;function I(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Qf=I;function C(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Rf=C;function d(r,o=D.$fc.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(O(y)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let m=3;const j=m;for(;m<v&&!O(r.charCodeAt(m));m++);if(j!==m&&!O(r.charCodeAt(m+1))){for(m+=1;m<v;m++)if(O(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,o)}}return o}else if(h(y)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(O(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Sf=d;function P(r){if(!N.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const y=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(y===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Tf=P;const E=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=N.$j){const v=o?E:$;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&c.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Uf=g;function p(r,o,v){const y=r===o;return!v||y?y:!r||!o?!1:(0,A.$1e)(r,o)}e.$Vf=p;function w(r,o,v,y=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,A.$2e)(r,o))return!1;if(o.length===r.length)return!0;let m=o.length;return o.charAt(o.length-1)===y&&m--,r.charAt(m)===y}return o.charAt(o.length-1)!==y&&(o+=y),r.indexOf(o)===0}e.$Wf=w;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Xf=h;function l(r,o){return N.$j&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(o,r)),r=(0,D.$gc)(r),N.$j?(r=(0,A.$Je)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,A.$Je)(r,D.sep),r||(r=D.sep)),r}e.$Yf=l;function u(r){const o=(0,D.$gc)(r);return N.$j?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.$fc.sep}e.$Zf=u;function b(r,o=N.$j){return o?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$1f=b;function k(r,o=N.$j){return b(r,o)?r[0]:void 0}e.$2f=k;function t(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$3f=t;function a(r){const o=r.split(":");let v,y,f;for(const m of o){const j=Number(m);(0,L.$Bf)(j)?y===void 0?y=j:f===void 0&&(f=j):v=v?[v,m].join(":"):m}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:f!==void 0?f:y!==void 0?1:void 0}}e.$4f=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,o,v=8){let y="";for(let m=0;m<v;m++){let j;m===0&&N.$j&&!o&&(v===3||v===4)?j=n:j=s,y+=j.charAt(Math.floor(Math.random()*j.length))}let f;return o?f=`${o}-${y}`:f=y,r?(0,D.$ic)(r,f):f}e.$5f=i}),define(oe[141],ae([0,1,16]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0,e.$Lr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const E=(0,D.$nc)(P),$=N[E.toLowerCase()];return $!==void 0?$:O(P)}e.$Mr=L;function O(P){const E=(0,D.$nc)(P);return A[E.toLowerCase()]}e.$Nr=O;function I(P){for(const E in A)if(A[E]===P)return E}e.$Or=I;const C=/^(.+)\/(.+?)(;.+)?$/;function d(P,E){const $=C.exec(P);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:E?void 0:P}e.$Pr=d}),define(oe[90],ae([0,1,6]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(I,...C){const d=C.reduce(($,c)=>($[c]=!0,$),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter($=>!d[$]).forEach($=>{for(let c=0;c<P.length;c++)if($.search(P[c])!==-1){delete I[$];break}})}e.$vl=L;function O(I){I&&(delete I.DEBUG,D.$k&&delete I.DYLD_LIBRARY_PATH,D.$l&&delete I.LD_PRELOAD)}e.$wl=O}),define(oe[9],ae([0,1,16,6]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,O=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,i){return!n&&!i?"file":n}function d(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const P="",E="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(i){return i instanceof c?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,o,v,y,f=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=C(i,f),this.authority=r||P,this.path=d(this.scheme,o||P),this.query=v||P,this.fragment=y||P,I(this,f))}get fsPath(){return b(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:v,query:y,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),v===void 0?v=this.path:v===null&&(v=P),y===void 0?y=this.query:y===null&&(y=P),f===void 0?f=this.fragment:f===null&&(f=P),r===this.scheme&&o===this.authority&&v===this.path&&y===this.query&&f===this.fragment?this:new w(r,o,v,y,f)}static parse(i,r=!1){const o=$.exec(i);return o?new w(o[2]||P,s(o[4]||P),s(o[5]||P),s(o[7]||P),s(o[9]||P),r):new w(P,P,P,P,P)}static file(i){let r=P;if(N.$j&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const o=i.indexOf(E,2);o===-1?(r=i.substring(2),i=E):(r=i.substring(2,o),i=i.substring(o)||E)}return new w("file",r,i,P,P)}static from(i,r){return new w(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return N.$j&&i.scheme==="file"?o=c.file(D.$ec.join(b(i,!0),...r)).path:o=D.$fc.join(i.path,...r),i.with({path:o})}toString(i=!1){return k(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof c)return i;{const r=new w(i);return r._formatted=i.external??null,r._fsPath=i._sep===p?i.fsPath??null:null,r}}else return i}}e.URI=c;function g(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$uc=g;const p=N.$j?1:void 0;class w extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(i=!1){return i?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,i,r){let o,v=-1;for(let y=0;y<n.length;y++){const f=n.charCodeAt(y);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(o+=encodeURIComponent(n.substring(v,y)),v=-1),o!==void 0&&(o+=n.charAt(y));else{o===void 0&&(o=n.substr(0,y));const m=h[f];m!==void 0?(v!==-1&&(o+=encodeURIComponent(n.substring(v,y)),v=-1),o+=m):v===-1&&(v=y)}}return v!==-1&&(o+=encodeURIComponent(n.substring(v))),o!==void 0?o:n}function u(n){let i;for(let r=0;r<n.length;r++){const o=n.charCodeAt(r);o===35||o===63?(i===void 0&&(i=n.substr(0,r)),i+=h[o]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function b(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,N.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=b;function k(n,i){const r=i?u:l;let o="",{scheme:v,authority:y,path:f,query:m,fragment:j}=n;if(v&&(o+=v,o+=":"),(y||v==="file")&&(o+=E,o+=E),y){let M=y.indexOf("@");if(M!==-1){const T=y.substr(0,M);y=y.substr(M+1),M=T.lastIndexOf(":"),M===-1?o+=r(T,!1,!1):(o+=r(T.substr(0,M),!1,!1),o+=":",o+=r(T.substr(M+1),!1,!0)),o+="@"}y=y.toLowerCase(),M=y.lastIndexOf(":"),M===-1?o+=r(y,!1,!0):(o+=r(y.substr(0,M),!1,!0),o+=y.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}o+=r(f,!0,!1)}return m&&(o+="?",o+=r(m,!1,!1)),j&&(o+="#",o+=i?j:l(j,!1,!1)),o}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(a)?n.replace(a,i=>t(i)):n}}),define(oe[142],ae([0,1,9]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Vp=e.$Up=e.$Tp=void 0;function N(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Tp=N;function A(d){const P=[];let E;try{const $=JSON.parse(d.arguments),c=$[$.length-1];c&&c.__$stack&&($.pop(),E=c.__$stack),P.push(...$)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:E}}e.$Up=A;function L(d){if(typeof d!="string")return L(A(d).stack);const P=d;if(P){const E=O(P),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if($&&$.length===4)return{uri:D.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Vp=L;function O(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function I(d,P){const{args:E,stack:$}=A(d),c=typeof E[0]=="string"&&E.length===1;let g=O($);g&&(g=`(${g.trim()})`);let p=[];if(typeof E[0]=="string"?g&&c?p=[`%c[${P}] %c${E[0]} %c${g}`,C("blue"),C(""),C("grey")]:p=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:p=[`%c[${P}]%`,C("blue"),...E],g&&!c&&p.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}e.log=I;function C(d){return`color: ${d}`}}),define(oe[63],ae([0,1,15,9]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function A(C){return JSON.stringify(C,O)}e.$ih=A;function L(C){let d=JSON.parse(C);return d=I(d),d}e.$jh=L;function O(C,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function I(C,d=0){if(!C||d>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof D.$ae||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=I(C[P],d+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=I(C[P],d+1))}return C}e.$kh=I}),define(oe[23],ae([0,1,8,6,9]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var L;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$6f="vscode-tkn",e.$7f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,E,$){this.a[P]=E,this.b[P]=$}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(w){return D.$Z(w),P}const E=P.authority;let $=this.a[E];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const c=this.b[E],g=this.c[E];let p=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(p+=`&${e.$7f}=${encodeURIComponent(g)}`),A.URI.from({scheme:N.$p?this.d:L.vscodeRemoteResource,authority:`${$}:${c}`,path:this.f,query:p})}}e.$8f=new O,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class I{static{this.a=e.$ag}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$8f.rewrite(P):P.scheme===L.file&&(N.$n||N.$q&&N.$h.origin===`${L.vscodeFileResource}://${I.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||I.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==I.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return A.URI.isUri(P)?P:A.URI.parse(E.toUrl(P))}}e.$bg=new I;var C;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function $(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:A.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const w=p?.get(E);if(w)return P.get(w)}d.getHeadersFromQuery=$;function c(g,p,w){if(!globalThis.crossOriginIsolated)return;const h=p&&w?"3":w?"2":"1";g instanceof URLSearchParams?g.set(E,h):g[E]=h}d.addSearchParam=c})(C||(e.COI=C={}))}),define(oe[143],ae([0,1,124,23,6,9]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class O{constructor($,c,g){this.id=$,this.dependencies=c,this.callback=g}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,c,g)=>{typeof $!="string"&&(g=c,c=$,$=null),(typeof c!="object"||!Array.isArray(c))&&(g=c,c=null),this.c.push(new O($,c,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const c=await(this.a?this.i($):this.b?this.h($):this.j($));if(!c)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h($){return new Promise((c,g)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",h),p.removeEventListener("error",l)},h=u=>{w(),c(this.c.pop())},l=u=>{w(),g(u)};p.addEventListener("load",h),p.addEventListener("error",l),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((c,g)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),c(this.c.pop())}catch(p){g(p)}})}async j($){try{const c=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=L.URI.parse($).fsPath,h=c.readFileSync(w).toString(),l=p.wrap(h.replace(/^#!.*/,""));return new g.Script(l).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const C=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function P(E,$,c){if(D.$S){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const g=`${E}/${$}`;if(C.has(g))return C.get(g);let p;if(/^\w[\w\d+.-]*:\/\//.test(g))p=g;else{const u=`${c&&!A.$p?N.$$f:N.$0f}/${g}`;p=N.$bg.asBrowserUri(u).toString(!0)}const w=I.INSTANCE.load(p);return C.set(g,w),w}else return await new Promise((g,p)=>{te([E],g,p)})}e.$gC=P}),define(oe[21],ae([0,1,48,23,16,6,27,9]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function C(c){return(0,I.$vc)(c,!0)}e.$ig=C;class d{constructor(g){this.a=g}compare(g,p,w=!1){return g===p?0:(0,O.$Te)(this.getComparisonKey(g,w),this.getComparisonKey(p,w))}isEqual(g,p,w=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,w)===this.getComparisonKey(p,w)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,w=!1){if(g.scheme===p.scheme){if(g.scheme===N.Schemas.file)return D.$Wf(C(g),C(p),this.a(g))&&g.query===p.query&&(w||g.fragment===p.fragment);if((0,e.$zg)(g.authority,p.authority))return D.$Wf(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(w||g.fragment===p.fragment)}return!1}joinPath(g,...p){return I.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.$rg)(g)||g.authority}basename(g){return A.$fc.basename(g.path)}extname(g){return A.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===N.Schemas.file?p=I.URI.file(A.$lc(C(g))).path:(p=A.$fc.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===N.Schemas.file?p=I.URI.file(A.$gc(C(g))).path:p=A.$fc.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.$zg)(g.authority,p.authority))return;if(g.scheme===N.Schemas.file){const l=A.$kc(C(g),C(p));return L.$j?D.$Qf(l):l}let w=g.path||"/";const h=p.path||"/";if(this.a(g)){let l=0;for(const u=Math.min(w.length,h.length);l<u&&!(w.charCodeAt(l)!==h.charCodeAt(l)&&w.charAt(l).toLowerCase()!==h.charAt(l).toLowerCase());l++);w=h.substr(0,l)+w.substr(l)}return A.$fc.relative(w,h)}resolvePath(g,p){if(g.scheme===N.Schemas.file){const w=I.URI.file(A.$jc(C(g),p));return g.with({authority:w.authority,path:w.path})}return p=D.$Rf(p),g.with({path:A.$fc.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,O.$1e)(g,p)}hasTrailingPathSeparator(g,p=A.sep){if(g.scheme===N.Schemas.file){const w=C(g);return w.length>D.$Sf(w).length&&w[w.length-1]===p}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=A.sep){return(0,e.$Ag)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=A.sep){let w=!1;if(g.scheme===N.Schemas.file){const h=C(g);w=h!==void 0&&h.length===D.$Sf(h).length&&h[h.length-1]===p}else{p="/";const h=g.path;w=h.length===1&&h.charCodeAt(h.length-1)===47}return!w&&!(0,e.$Ag)(g,p)?g.with({path:g.path+"/"}):g}}e.$jg=d,e.$kg=new d(()=>!1),e.$lg=new d(c=>c.scheme===N.Schemas.file?!L.$l:!0),e.$mg=new d(c=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function P(c,g){const p=[];for(let w=0;w<c.length;w++){const h=g(c[w]);c.some((l,u)=>u===w?!1:(0,e.$og)(h,g(l)))||p.push(c[w])}return p}e.$Dg=P;var E;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[b,k]=u.split(":");b&&k&&w.set(b,k)});const l=p.path.substring(0,p.path.indexOf(";"));return l&&w.set(c.META_DATA_MIME,l),w}c.parseMetaData=g})(E||(e.DataUri=E={}));function $(c,g,p){if(g){let w=c.path;return w&&w[0]!==A.$fc.sep&&(w=A.$fc.sep+w),c.with({scheme:p,authority:g,path:w})}return c.with({scheme:p})}e.$Eg=$}),define(oe[5],ae([0,1,26,8,3,2,21,6,130]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function d(S){return!!S&&typeof S.then=="function"}e.$Fg=d;function P(S){const R=new D.$Wd,z=S(R.token),F=new Promise((J,Z)=>{const se=R.token.onCancellationRequested(()=>{se.dispose(),R.dispose(),Z(new N.$4)});Promise.resolve(z).then(le=>{se.dispose(),R.dispose(),J(le)},le=>{se.dispose(),R.dispose(),Z(le)})});return new class{cancel(){R.cancel()}then(J,Z){return F.then(J,Z)}catch(J){return this.then(void 0,J)}finally(J){return F.finally(J)}}}e.$Gg=P;function E(S,R,z){return new Promise((F,J)=>{const Z=R.onCancellationRequested(()=>{Z.dispose(),F(z)});S.then(F,J).finally(()=>Z.dispose())})}e.$Hg=E;function $(S,R){return new Promise((z,F)=>{const J=R.onCancellationRequested(()=>{J.dispose(),F(new N.$4)});S.then(z,F).finally(()=>J.dispose())})}e.$Ig=$;async function c(S){let R=-1;const z=S.map((F,J)=>F.then(Z=>(R=J,Z)));try{return await Promise.race(z)}finally{S.forEach((F,J)=>{J!==R&&F.cancel()})}}e.$Jg=c;function g(S,R,z){let F;const J=setTimeout(()=>{F?.(void 0),z?.()},R);return Promise.race([S.finally(()=>clearTimeout(J)),new Promise(Z=>F=Z)])}e.$Kg=g;function p(S){return new Promise((R,z)=>{const F=S();d(F)?F.then(R,z):R(F)})}e.$Lg=p;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const z=()=>{if(this.b=null,this.f)return;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(z,z).then(F)})}return new Promise((z,F)=>{this.b.then(z,F)})}return this.a=R(),new Promise((z,F)=>{this.a.then(J=>{this.a=null,z(J)},J=>{this.a=null,F(J)})})}dispose(){this.f=!0}}e.$Mg=w;class h{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$Ng=h;class l{constructor(){this.a=new Map}queue(R,z){const J=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(R)===J&&this.a.delete(R)});return this.a.set(R,J),J}}e.$Og=l;const u=(S,R)=>{let z=!0;const F=setTimeout(()=>{z=!1,R()},S);return{isTriggered:()=>z,dispose:()=>{clearTimeout(F),z=!1}}},b=S=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,S())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class k{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,z=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((J,Z)=>{this.d=J,this.f=Z}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=z===C.$Jd?b(F):u(z,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=k;class t{constructor(R){this.a=new k(R),this.b=new w}trigger(R,z){return this.a.trigger(()=>this.b.queue(R),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=t;class a{constructor(){this.a=!1,this.b=new Promise((R,z)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=a;class s extends a{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$Sg=s;function n(S,R){return R?new Promise((z,F)=>{const J=setTimeout(()=>{Z.dispose(),z()},S),Z=R.onCancellationRequested(()=>{clearTimeout(J),Z.dispose(),F(new N.$4)})}):P(z=>n(S,z))}e.$Tg=n;function i(S,R=0,z){const F=setTimeout(()=>{S(),z&&J.dispose()},R),J=(0,L.$Pc)(()=>{clearTimeout(F),z?.deleteAndLeak(J)});return z?.add(J),J}e.$Ug=i;function r(S){const R=[];let z=0;const F=S.length;function J(){return z<F?S[z++]():null}function Z(se){se!=null&&R.push(se);const le=J();return le?le.then(Z):Promise.resolve(R)}return Promise.resolve(null).then(Z)}e.$Vg=r;function o(S,R=F=>!!F,z=null){let F=0;const J=S.length,Z=()=>{if(F>=J)return Promise.resolve(z);const se=S[F++];return Promise.resolve(se()).then(ue=>R(ue)?Promise.resolve(ue):Z())};return Z()}e.$Wg=o;function v(S,R=F=>!!F,z=null){if(S.length===0)return Promise.resolve(z);let F=S.length;const J=()=>{F=-1;for(const Z of S)Z.cancel?.()};return new Promise((Z,se)=>{for(const le of S)le.then(ue=>{--F>=0&&R(ue)?(J(),Z(ue)):F===0&&Z(z)}).catch(ue=>{--F>=0&&(J(),se(ue))})})}e.$Xg=v;class y{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new A.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((z,F)=>{this.f.push({factory:R,c:z,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const z=R.factory();z.then(R.c,R.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=y;class f extends y{constructor(){super(1)}}e.$Zg=f;class m{constructor(){this.a=new Q,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$1g=m;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new W;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,z=O.$kg){const F=z.getComparisonKey(R);let J=this.a.get(F);if(!J){J=new f;const Z=this.f++,se=A.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(Z,se),this.a.set(F,J)}return J}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=j;class M{constructor(R,z){this.a=-1,typeof R=="function"&&typeof z=="number"&&this.setIfNotSet(R,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},z)}setIfNotSet(R,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},z))}}e.$3g=M;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,z){this.cancel(),this.a=setInterval(()=>{R()},z)}}e.$4g=T;class U{constructor(R,z){this.b=-1,this.a=R,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=U;class q{constructor(R,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=R,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=q;class _ extends U{constructor(R,z){super(R,z),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$7g=_;class K extends L.$Rc{constructor(R,z){super(),this.g=R,this.h=z,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of R)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=S=>{(0,I.$B)(()=>{if(R)return;const z=Date.now()+15;S(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$9g=(S,R)=>{const z=requestIdleCallback(S,typeof R=="number"?{timeout:R}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(z))}}}}();class Y{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(z){this.g=z}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=Y;async function G(S,R,z){let F;for(let J=0;J<z;J++)try{return await S()}catch(Z){F=Z,await n(R)}throw F}e.$$g=G;class Q{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,z,F){return this.a={taskId:R,cancel:()=>F?.(),promise:z},z.then(()=>this.d(R),()=>this.d(R)),z}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{let z,F;const J=new Promise((Z,se)=>{z=Z,F=se});this.b={run:R,promise:J,promiseResolve:z,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=Q;class H{constructor(R,z=()=>Date.now()){this.d=R,this.f=z,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$ah=H;var V;(function(S){S[S.Resolved=0]="Resolved",S[S.Rejected=1]="Rejected"})(V||(V={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,z)=>{this.a=R,this.b=z})}complete(R){return new Promise(z=>{this.a(R),this.d={outcome:0,value:R},z()})}error(R){return new Promise(z=>{this.b(R),this.d={outcome:1,value:R},z()})}cancel(){return this.error(new N.$4)}}e.$bh=W;var ee;(function(S){async function R(F){let J;const Z=await Promise.all(F.map(se=>se.then(le=>le,le=>{J||(J=le)})));if(typeof J<"u")throw J;return Z}S.settled=R;function z(F){return new Promise(async(J,Z)=>{try{await F(J,Z)}catch(se){Z(se)}})}S.withAsyncBody=z})(ee||(e.Promises=ee={}));var ne;(function(S){S[S.Initial=0]="Initial",S[S.DoneOK=1]="DoneOK",S[S.DoneError=2]="DoneError"})(ne||(ne={}));class re{static fromArray(R){return new re(z=>{z.emitMany(R)})}static fromPromise(R){return new re(async z=>{z.emitMany(await R)})}static fromPromises(R){return new re(async z=>{await Promise.all(R.map(async F=>z.emitOne(await F)))})}static merge(R){return new re(async z=>{await Promise.all(R.map(async F=>{for await(const J of F)z.emitOne(J)}))})}static{this.EMPTY=re.fromArray([])}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new A.$Md,queueMicrotask(async()=>{const z={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(R(z)),this.j()}catch(F){this.k(F)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(R,z){return new re(async F=>{for await(const J of R)F.emitOne(z(J))})}map(R){return re.map(this,R)}static filter(R,z){return new re(async F=>{for await(const J of R)z(J)&&F.emitOne(J)})}filter(R){return re.filter(this,R)}static coalesce(R){return re.filter(R,z=>!!z)}coalesce(){return re.coalesce(this)}static async toPromise(R){const z=[];for await(const F of R)z.push(F);return z}toPromise(){return re.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$ch=re;class X extends re{constructor(R,z){super(z),this.l=R}cancel(){this.l.cancel()}}e.$dh=X;function B(S){const R=new D.$Wd,z=S(R.token);return new X(R,async F=>{const J=R.token.onCancellationRequested(()=>{J.dispose(),R.dispose(),F.reject(new N.$4)});try{for await(const Z of z){if(R.token.isCancellationRequested)return;F.emitOne(Z)}J.dispose(),R.dispose()}catch(Z){J.dispose(),R.dispose(),F.reject(Z)}})}e.$eh=B}),define(oe[91],ae([0,1,18,5,48,34,16,6,27]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function d(){return Object.create(null)}e.$pj=d,e.$qj="**",e.$rj="/";const P="[/\\\\]",E="[^/\\\\]",$=/\//g;function c(Q,H){switch(Q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${H?`|${P}${E}+`:""})*?`}}function g(Q,H){if(!Q)return[];const V=[];let W=!1,ee=!1,ne="";for(const re of Q){switch(re){case H:if(!W&&!ee){V.push(ne),ne="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=re}return ne&&V.push(ne),V}e.$sj=g;function p(Q){if(!Q)return"";let H="";const V=g(Q,e.$rj);if(V.every(W=>W===e.$qj))H=".*";else{let W=!1;V.forEach((ee,ne)=>{if(ee===e.$qj){if(W)return;H+=c(2,ne===V.length-1)}else{let re=!1,X="",B=!1,S="";for(const R of ee){if(R!=="}"&&re){X+=R;continue}if(B&&(R!=="]"||!S)){let z;R==="-"?z=R:(R==="^"||R==="!")&&!S?z="^":R===e.$rj?z="":z=(0,C.$Ee)(R),S+=z;continue}switch(R){case"{":re=!0;continue;case"[":B=!0;continue;case"}":{const F=`(?:${g(X,",").map(J=>p(J)).join("|")})`;H+=F,re=!1,X="";break}case"]":{H+="["+S+"]",B=!1,S="";break}case"?":H+=E;continue;case"*":H+=c(1);continue;default:H+=(0,C.$Ee)(R)}}ne<V.length-1&&(V[ne+1]!==e.$qj||ne+2<V.length)&&(H+=P)}W=ee===e.$qj})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),a=function(){return!1},s=function(){return null};function n(Q,H){if(!Q)return s;let V;typeof Q!="string"?V=Q.pattern:V=Q,V=V.trim();const W=`${V}_${!!H.trimForExclusions}`;let ee=t.get(W);if(ee)return i(ee,Q);let ne;return w.test(V)?ee=o(V.substr(4),V):(ne=h.exec(r(V,H)))?ee=v(ne[1],V):(H.trimForExclusions?u:l).test(V)?ee=y(V,H):(ne=b.exec(r(V,H)))?ee=f(ne[1].substr(1),V,!0):(ne=k.exec(r(V,H)))?ee=f(ne[1],V,!1):ee=m(V),t.set(W,ee),i(ee,Q)}function i(Q,H){if(typeof H=="string")return Q;const V=function(W,ee){return(0,A.$Wf)(W,H.base,!I.$l)?Q((0,C.$Ie)(W.substr(H.base.length),O.sep),ee):null};return V.allBasenames=Q.allBasenames,V.allPaths=Q.allPaths,V.basenames=Q.basenames,V.patterns=Q.patterns,V}function r(Q,H){return H.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function o(Q,H){return function(V,W){return typeof V=="string"&&V.endsWith(Q)?H:null}}function v(Q,H){const V=`/${Q}`,W=`\\${Q}`,ee=function(re,X){return typeof re!="string"?null:X?X===Q?H:null:re===Q||re.endsWith(V)||re.endsWith(W)?H:null},ne=[Q];return ee.basenames=ne,ee.patterns=[H],ee.allBasenames=ne,ee}function y(Q,H){const V=Y(Q.slice(1,-1).split(",").map(X=>n(X,H)).filter(X=>X!==s),Q),W=V.length;if(!W)return s;if(W===1)return V[0];const ee=function(X,B){for(let S=0,R=V.length;S<R;S++)if(V[S](X,B))return Q;return null},ne=V.find(X=>!!X.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return re.length&&(ee.allPaths=re),ee}function f(Q,H,V){const W=O.sep===O.$fc.sep,ee=W?Q:Q.replace($,O.sep),ne=O.sep+ee,re=O.$fc.sep+Q;let X;return V?X=function(B,S){return typeof B=="string"&&(B===ee||B.endsWith(ne)||!W&&(B===Q||B.endsWith(re)))?H:null}:X=function(B,S){return typeof B=="string"&&(B===ee||!W&&B===Q)?H:null},X.allPaths=[(V?"*/":"./")+Q],X}function m(Q){try{const H=new RegExp(`^${p(Q)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?Q:null}}catch{return s}}function j(Q,H,V){return!Q||typeof H!="string"?!1:M(Q)(H,void 0,V)}e.$tj=j;function M(Q,H={}){if(!Q)return a;if(typeof Q=="string"||T(Q)){const V=n(Q,H);if(V===s)return a;const W=function(ee,ne){return!!V(ee,ne)};return V.allBasenames&&(W.allBasenames=V.allBasenames),V.allPaths&&(W.allPaths=V.allPaths),W}return _(Q,H)}e.$uj=M;function T(Q){const H=Q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$vj=T;function U(Q){return Q.allBasenames||[]}e.$wj=U;function q(Q){return Q.allPaths||[]}e.$xj=q;function _(Q,H){const V=Y(Object.getOwnPropertyNames(Q).map(X=>K(X,Q[X],H)).filter(X=>X!==s)),W=V.length;if(!W)return s;if(!V.some(X=>!!X.requiresSiblings)){if(W===1)return V[0];const X=function(R,z){let F;for(let J=0,Z=V.length;J<Z;J++){const se=V[J](R,z);if(typeof se=="string")return se;(0,N.$Fg)(se)&&(F||(F=[]),F.push(se))}return F?(async()=>{for(const J of F){const Z=await J;if(typeof Z=="string")return Z}return null})():null},B=V.find(R=>!!R.allBasenames);B&&(X.allBasenames=B.allBasenames);const S=V.reduce((R,z)=>z.allPaths?R.concat(z.allPaths):R,[]);return S.length&&(X.allPaths=S),X}const ee=function(X,B,S){let R,z;for(let F=0,J=V.length;F<J;F++){const Z=V[F];Z.requiresSiblings&&S&&(B||(B=(0,O.$mc)(X)),R||(R=B.substr(0,B.length-(0,O.$nc)(X).length)));const se=Z(X,B,R,S);if(typeof se=="string")return se;(0,N.$Fg)(se)&&(z||(z=[]),z.push(se))}return z?(async()=>{for(const F of z){const J=await F;if(typeof J=="string")return J}return null})():null},ne=V.find(X=>!!X.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return re.length&&(ee.allPaths=re),ee}function K(Q,H,V){if(H===!1)return s;const W=n(Q,V);if(W===s)return s;if(typeof H=="boolean")return W;if(H){const ee=H.when;if(typeof ee=="string"){const ne=(re,X,B,S)=>{if(!S||!W(re,X))return null;const R=ee.replace("$(basename)",()=>B),z=S(R);return(0,N.$Fg)(z)?z.then(F=>F?Q:null):z?Q:null};return ne.requiresSiblings=!0,ne}}return W}function Y(Q,H){const V=Q.filter(X=>!!X.basenames);if(V.length<2)return Q;const W=V.reduce((X,B)=>{const S=B.basenames;return S?X.concat(S):X},[]);let ee;if(H){ee=[];for(let X=0,B=W.length;X<B;X++)ee.push(H)}else ee=V.reduce((X,B)=>{const S=B.patterns;return S?X.concat(S):X},[]);const ne=function(X,B){if(typeof X!="string")return null;if(!B){let R;for(R=X.length;R>0;R--){const z=X.charCodeAt(R-1);if(z===47||z===92)break}B=X.substr(R)}const S=W.indexOf(B);return S!==-1?ee[S]:null};ne.basenames=W,ne.patterns=ee,ne.allBasenames=W;const re=Q.filter(X=>!X.basenames);return re.push(ne),re}function G(Q,H){return(0,D.$tb)(Q,H,(V,W)=>typeof V=="string"&&typeof W=="string"?V===W:typeof V!="string"&&typeof W!="string"?V.base===W.base&&V.pattern===W.pattern:!1)}e.$yj=G}),define(oe[92],ae([0,1,15,9]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function A(E){return E.toJSON()}class L{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:A(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:A(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Hm=L,e.$Im=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,$,c){if(!E||c>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return $.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const p=O(E[g],$,c+1);p!==null&&(E[g]=p)}}return null}function I(E,$){const c=O(E,$,0);return c===null?E:c}e.$Jm=I;function C(E,$,c,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return c?N.URI.revive($.transformIncoming(E)):$.transformIncoming(E);if(E instanceof D.$ae)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const w=C(E[p],$,c,g+1);w!==null&&(E[p]=w)}}return null}function d(E,$){const c=C(E,$,!1,0);return c===null?E:c}e.$Km=d;function P(E,$){const c=C(E,$,!0,0);return c===null?E:c}e.$Lm=P}),define(oe[31],ae([0,1,52,36,269,5,48,88,16,6,21,9]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function c(K,Y=$.UNLINK,G){if((0,O.$Zf)(K))throw new Error("rimraf - will refuse to recursively delete root");return Y===$.UNLINK?p(K):g(K,G)}async function g(K,Y=(0,O.$5f)((0,N.tmpdir)())){try{try{await D.promises.rename(K,Y)}catch(G){return G.code==="ENOENT"?void 0:p(K)}p(Y).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(K){return(0,A.promisify)(D.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function w(K){if((0,O.$Zf)(K))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function h(K,Y){return b(await(Y?l(K):(0,A.promisify)(D.readdir)(K)))}async function l(K){try{return await(0,A.promisify)(D.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const Y=[],G=await h(K);for(const Q of G){let H=!1,V=!1,W=!1;try{const ee=await e.Promises.lstat((0,C.$ic)(K,Q));H=ee.isFile(),V=ee.isDirectory(),W=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Y.push({name:Q,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>W})}return Y}function u(K){return b(D.readdirSync(K))}e.readdirSync=u;function b(K){return K.map(Y=>typeof Y=="string"?d.$k?(0,I.$kl)(Y):Y:(Y.name=d.$k?(0,I.$kl)(Y.name):Y.name,Y))}async function k(K){const Y=await h(K),G=[];for(const Q of Y)await a.existsDirectory((0,C.$ic)(K,Q))&&G.push(Q);return G}function t(K,Y=1e3){return new Promise(G=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,D.access(K,V=>{Q=!1,V&&(clearInterval(H),G(void 0))}))},Y)})}e.whenDeleted=t;var a;(function(K){async function Y(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(d.$j&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw W}}K.stat=Y;async function G(H){try{const{stat:V,symbolicLink:W}=await K.stat(H);return V.isFile()&&W?.dangling!==!0}catch{}return!1}K.existsFile=G;async function Q(H){try{const{stat:V,symbolicLink:W}=await K.stat(H);return V.isDirectory()&&W?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const s=new L.$2g;function n(K,Y,G){return s.queueFor(E.URI.file(K),P.$lg).queue(()=>{const Q=y(G);return new Promise((H,V)=>o(K,Y,Q,W=>W?V(W):H()))})}let i=!0;function r(K){i=K}e.configureFlushOnWrite=r;function o(K,Y,G,Q){if(!i)return D.writeFile(K,Y,{mode:G.mode,flag:G.flag},Q);D.open(K,G.flag,G.mode,(H,V)=>{if(H)return Q(H);D.writeFile(V,Y,W=>{if(W)return D.close(V,()=>Q(W));D.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),D.close(V,ne=>Q(ne))))})})}function v(K,Y,G){const Q=y(G);if(!i)return D.writeFileSync(K,Y,{mode:Q.mode,flag:Q.flag});const H=D.openSync(K,Q.flag,Q.mode);try{D.writeFileSync(H,Y);try{D.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{D.closeSync(H)}}e.writeFileSync=v;function y(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function f(K,Y,G=6e4){if(K!==Y)try{d.$j&&typeof G=="number"?await m(K,Y,Date.now(),G):await(0,A.promisify)(D.rename)(K,Y)}catch(Q){if(K.toLowerCase()!==Y.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await j(K,Y,{preserveSymlinks:!1}),await c(K,$.MOVE);else throw Q}}async function m(K,Y,G,Q,H=0){try{return await(0,A.promisify)(D.rename)(K,Y)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-G>=Q)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let W=!1;try{const{stat:ee}=await a.stat(Y);ee.isFile()||(W=!0)}catch{}if(W)throw V}return await(0,L.$Tg)(Math.min(100,H*10)),m(K,Y,G,Q,H+1)}}async function j(K,Y,G){return T(K,Y,{root:{source:K,target:Y},options:G,handledSourcePaths:new Set})}const M=511;async function T(K,Y,G){if(G.handledSourcePaths.has(K))return;G.handledSourcePaths.add(K);const{stat:Q,symbolicLink:H}=await a.stat(K);if(H){if(G.options.preserveSymlinks)try{return await _(K,Y,G)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(H.dangling)return}return Q.isDirectory()?U(K,Y,Q.mode&M,G):q(K,Y,Q.mode&M)}async function U(K,Y,G,Q){await e.Promises.mkdir(Y,{recursive:!0,mode:G});const H=await h(K);for(const V of H)await T((0,C.$ic)(K,V),(0,C.$ic)(Y,V),Q)}async function q(K,Y,G){await e.Promises.copyFile(K,Y),await e.Promises.chmod(Y,G)}async function _(K,Y,G){let Q=await e.Promises.readlink(K);(0,O.$Wf)(Q,G.root.source,!d.$l)&&(Q=(0,C.$ic)(G.root.target,Q.substr(G.root.source.length+1))),await e.Promises.symlink(Q,Y)}e.Promises=new class{get access(){return(0,A.promisify)(D.access)}get stat(){return(0,A.promisify)(D.stat)}get lstat(){return(0,A.promisify)(D.lstat)}get utimes(){return(0,A.promisify)(D.utimes)}get read(){return(K,Y,G,Q,H)=>new Promise((V,W)=>{D.read(K,Y,G,Q,H,(ee,ne,re)=>ee?W(ee):V({bytesRead:ne,buffer:re}))})}get readFile(){return(0,A.promisify)(D.readFile)}get write(){return(K,Y,G,Q,H)=>new Promise((V,W)=>{D.write(K,Y,G,Q,H,(ee,ne,re)=>ee?W(ee):V({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,A.promisify)(D.appendFile)}get fdatasync(){return(0,A.promisify)(D.fdatasync)}get truncate(){return(0,A.promisify)(D.truncate)}get copyFile(){return(0,A.promisify)(D.copyFile)}get open(){return(0,A.promisify)(D.open)}get close(){return(0,A.promisify)(D.close)}get symlink(){return(0,A.promisify)(D.symlink)}get readlink(){return(0,A.promisify)(D.readlink)}get chmod(){return(0,A.promisify)(D.chmod)}get mkdir(){return(0,A.promisify)(D.mkdir)}get unlink(){return(0,A.promisify)(D.unlink)}get rmdir(){return(0,A.promisify)(D.rmdir)}get realpath(){return(0,A.promisify)(D.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return k}get writeFile(){return n}get rm(){return c}get rename(){return f}get copy(){return j}}}),define(oe[144],ae([0,1,52,16,6,27,31]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=void 0;function I($){if(A.$l)return $;const c=(0,N.$lc)($);if($===c)return $;const g=((0,N.$mc)($)||$).toLowerCase();try{const w=(0,O.readdirSync)(c).filter(h=>h.toLowerCase()===g);if(w.length===1){const h=I(c);if(h)return(0,N.$ic)(h,w[0])}else if(w.length>1){const h=w.indexOf(g);if(h>=0){const l=I(c);if(l)return(0,N.$ic)(l,w[h])}}}catch{}return null}e.$1p=I;async function C($){if(A.$l)return $;const c=(0,N.$lc)($);if($===c)return $;const g=((0,N.$mc)($)||$).toLowerCase();try{const w=(await O.Promises.readdir(c)).filter(h=>h.toLowerCase()===g);if(w.length===1){const h=await C(c);if(h)return(0,N.$ic)(h,w[0])}else if(w.length>1){const h=w.indexOf(g);if(h>=0){const l=await C(c);if(l)return(0,N.$ic)(l,w[h])}}}catch{}return null}e.$2p=C;async function d($){try{return await O.Promises.realpath($)}catch{const g=E($);return await O.Promises.access(g,D.constants.R_OK),g}}e.$3p=d;function P($){try{return D.realpathSync($)}catch{const g=E($);return D.accessSync(g,D.constants.R_OK),g}}e.$4p=P;function E($){return(0,L.$Je)((0,N.$gc)($),N.sep)}}),define(oe[145],ae([0,1,16,6,37,90,12,31]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function C(E=A.env){return E.comspec||"cmd.exe"}e.$xl=C;function d(E){let $=[],c=!1;const g=function(p){if(c){$.push(p);return}(!E.send(p,h=>{if(h&&console.error(h),c=!1,$.length>0){const l=$.slice(0);$=[],l.forEach(u=>g(u))}})||N.$j)&&(c=!0)};return{send:g}}e.$yl=d;var P;(function(E){async function $(c,g,p){if(D.$hc(c))return c;if(g===void 0&&(g=A.cwd()),D.$lc(c)!=="."||(p===void 0&&O.$xf(A.env.PATH)&&(p=A.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic(g,c);async function h(l){if(await I.Promises.exists(l)){let u;try{u=await I.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(u=await I.Promises.lstat(l))}return u?!u.isDirectory():!1}return!1}for(const l of p){let u;if(D.$hc(l)?u=D.$ic(l,c):u=D.$ic(g,l,c),await h(u))return u;let b=u+".com";if(await h(b)||(b=u+".exe",await h(b)))return b}return D.$ic(g,c)}E.findExecutable=$})(P||(e.win32=P={}))}),define(oe[146],ae([0,1,64,23]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;function A(O){return new Promise((I,C)=>{let d;const P=new Map;function E(c,g,p,w,h){const l=P.get(g);if(c===O||l){const u={name:$(p),cmd:p,pid:c,ppid:g,load:w,mem:h};P.set(c,u),c===O&&(d=u),l&&(l.children||(l.children=[]),l.children.push(u),l.children.length>1&&(l.children=l.children.sort((b,k)=>b.pid-k.pid)))}}function $(c){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(w.exec(c))return"electron-crash-reporter";if(h.exec(c))return"winpty-agent";if(l.exec(c))return"conpty-agent";let b=u.exec(c);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?g.exec(c)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const k=/[a-zA-Z-]+\.js/g;let t="";do b=k.exec(c),b&&(t+=b+" ");while(b);return t&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,p)=>{te(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(O,p=>{if(!p){C(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(p,w=>{const h=new Map;w.forEach(l=>{const u=c(l.commandLine||"");h.set(l.pid,{name:$(u),cmd:u,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),d=h.get(O),d?(h.forEach(l=>{const u=h.get(l.ppid);u&&(u.children||(u.children=[]),u.children.push(l))}),h.forEach(l=>{l.children&&(l.children=l.children.sort((u,b)=>u.pid-b.pid))}),I(d)):C(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let c=function(){let g=[d];const p=[];for(;g.length;){const h=g.shift();h&&(p.push(h.pid),h.children&&(g=g.concat(h.children)))}let w=JSON.stringify(N.$bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,D.exec)(w,{},(h,l,u)=>{if(h||u)C(h||new Error(u.toString()));else{const b=l.toString().split(`
`);for(let k=0;k<p.length;k++){const t=P.get(p[k]);t.load=parseFloat(b[k])}if(!d){C(new Error(`Root process ${O} not found`));return}I(d)}})};(0,D.exec)("which ps",{},(g,p,w)=>{if(g||w)if(process.platform!=="linux")C(g||new Error(w.toString()));else{const h=JSON.stringify(N.$bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(h,{},(l,u,b)=>{l||b?C(l||new Error(b.toString())):(L(u,E),c())})}else{const h=p.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${h} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,b,k)=>{u||k&&!k.includes("screen size is bogus")?C(u||new Error(k.toString())):(L(b,E),process.platform==="linux"?c():d?I(d):C(new Error(`Root process ${O} not found`)))})}})}})}e.$yr=A;function L(O,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const P of d){const E=C.exec(P.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,D,N){var A=arguments.length,L=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,D,N);else for(var I=te.length-1;I>=0;I--)(O=te[I])&&(L=(A<3?O(L):A>3?O(e,D,L):O(e,D))||L);return A>3&&L&&Object.defineProperty(e,D,L),L};define(oe[42],ae([0,1,18,5,15,26,83,8,3,2,63,27,12]),function(te,e,D,N,A,L,O,I,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var c;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(c||(c={}));function g(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function l(H){let V=0;for(let W=0;;W+=7){const ee=H.read(1);if(V|=(ee.buffer[0]&127)<<W,!(ee.buffer[0]&128))return V}}const u=s(0);function b(H,V){if(V===0){H.write(u);return}let W=0;for(let ne=V;ne!==0;ne=ne>>>7)W++;const ee=A.$ae.alloc(W);for(let ne=0;V!==0;ne++)ee.buffer[ne]=V&127,V=V>>>7,V>0&&(ee.buffer[ne]|=128);H.write(ee)}class k{constructor(V){this.b=V,this.a=0}read(V){const W=this.b.slice(this.a,this.a+V);return this.a+=W.byteLength,W}}e.$lh=k;class t{constructor(){this.a=[]}get buffer(){return A.$ae.concat(this.a)}write(V){this.a.push(V)}}e.$mh=t;var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(a||(a={}));function s(H){const V=A.$ae.alloc(1);return V.writeUInt8(H,0),V}const n={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object),Uint:s(a.Int)},i=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(n.Undefined);else if(typeof V=="string"){const W=A.$ae.fromString(V);H.write(n.String),b(H,W.byteLength),H.write(W)}else if(i&&Buffer.isBuffer(V)){const W=A.$ae.wrap(V);H.write(n.Buffer),b(H,W.byteLength),H.write(W)}else if(V instanceof A.$ae)H.write(n.VSBuffer),b(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(n.Array),b(H,V.length);for(const W of V)r(H,W)}else if(typeof V=="number"&&(V|0)===V)H.write(n.Uint),b(H,V);else{const W=A.$ae.fromString(JSON.stringify(V));H.write(n.Object),b(H,W.byteLength),H.write(W)}}e.$nh=r;function o(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(l(H)).toString();case a.Buffer:return H.read(l(H)).buffer;case a.VSBuffer:return H.read(l(H));case a.Array:{const W=l(H),ee=[];for(let ne=0;ne<W;ne++)ee.push(o(H));return ee}case a.Object:return JSON.parse(H.read(l(H)).toString());case a.Int:return l(H)}}e.$oh=o;class v{constructor(V,W,ee=null,ne=1e3){this.h=V,this.j=W,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(V,W){this.b.set(V,W),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const W=this.o([V.type]);this.k?.logOutgoing(W,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const W=this.o([V.type,V.id],V.data);this.k?.logOutgoing(W,V.id,1,w(V.type),V.data);return}}}o(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const W=new k(V),ee=o(W),ne=o(W),re=ee[0];switch(re){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]})}}s(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=new L.$Wd;let ne;try{ne=W.call(this.j,V.name,V.arg,ee.token)}catch(B){ne=Promise.reject(B)}const re=V.id;ne.then(B=>{this.m({id:re,data:B,type:201})},B=>{B instanceof Error?this.m({id:re,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:re,data:B,type:203})}).finally(()=>{X.dispose(),this.d.delete(V.id)});const X=(0,d.$Pc)(()=>ee.cancel());this.d.set(V.id,X)}t(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=V.id,re=W.listen(this.j,V.name,V.arg)(X=>this.m({id:ee,data:X,type:204}));this.d.set(V.id,re)}u(V){const W=this.d.get(V.id);W&&(W.dispose(),this.d.delete(V.id))}v(V){let W=this.g.get(V.channelName);W||(W=[],this.g.set(V.channelName,W));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:V,timeoutTimer:ee})}w(V){const W=this.g.get(V);if(W){for(const ee of W)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$ph=v;var y;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class f{constructor(V,W=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=W}getChannel(V){const W=this;return{call(ee,ne,re){return W.a?Promise.reject(new I.$4):W.m(V,ee,ne,re)},listen(ee,ne){return W.a?C.Event.None:W.o(V,ee,ne)}}}m(V,W,ee,ne=L.CancellationToken.None){const re=this.g++,B={id:re,type:100,channelName:V,name:W,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new I.$4);let S;return new Promise((z,F)=>{if(ne.isCancellationRequested)return F(new I.$4);const J=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(re),z(he.data);break;case 202:{this.f.delete(re);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,F($e);break}case 203:this.f.delete(re),F(he.data);break}};this.f.set(re,ue),this.p(B)};let Z=null;this.b===h.Idle?J():(Z=(0,N.$Gg)(ue=>this.u()),Z.then(()=>{Z=null,J()}));const se=()=>{Z?(Z.cancel(),Z=null):this.p({id:re,type:101}),F(new I.$4)},le=ne.onCancellationRequested(se);S=(0,d.$Oc)((0,d.$Pc)(se),le),this.d.add(S)}).finally(()=>{S.dispose(),this.d.delete(S)})}o(V,W,ee){const ne=this.g++,X={id:ne,type:102,channelName:V,name:W,arg:ee};let B=null;const S=new C.$Md({onWillAddFirstListener:()=>{B=(0,N.$Gg)(z=>this.u()),B.then(()=>{B=null,this.d.add(S),this.p(X)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(S),this.p({id:ne,type:103}))}}),R=z=>S.fire(z.data);return this.f.set(ne,R),S.event}p(V){switch(V.type){case 100:case 102:{const W=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(W,V.id,0,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const W=this.q([V.type,V.id]);this.j?.logOutgoing(W,V.id,0,g(V.type));return}}}q(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const W=new k(V),ee=o(W),ne=o(W),re=ee[0];switch(re){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(re)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,w(re),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$qh=f,ye([O.$fh],f.prototype,"onDidInitializePromise",null);class m{get connections(){const V=[];return this.f.forEach(W=>V.push(W)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new C.$Md,this.onDidAddConnection=this.g.event,this.h=new C.$Md,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(V(({protocol:W,onDidClientDisconnect:ee})=>{const ne=C.Event.once(W.onMessage);this.j.add(ne(re=>{const X=new k(re),B=o(X),S=new v(W,B),R=new f(W);this.a.forEach((F,J)=>S.registerChannel(J,F));const z={channelServer:S,channelClient:R,ctx:B};this.f.add(z),this.g.fire(z),this.j.add(ee(()=>{S.dispose(),R.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(V,W){const ee=this;return{call(ne,re,X){let B;if((0,$.$Lf)(W)){const R=(0,D.$3b)(ee.connections.filter(W));B=R?Promise.resolve(R):C.Event.toPromise(C.Event.filter(ee.onDidAddConnection,W))}else B=W.routeCall(ee,ne,re);const S=B.then(R=>R.channelClient.getChannel(V));return M(S).call(ne,re,X)},listen(ne,re){if((0,$.$Lf)(W))return ee.k(V,W,ne,re);const X=W.routeEvent(ee,ne,re).then(B=>B.channelClient.getChannel(V));return M(X).listen(ne,re)}}}k(V,W,ee,ne){const re=this;let X;const B=new C.$Md({onWillAddFirstListener:()=>{X=new d.$Qc;const S=new C.$Sd,R=new Map,z=J=>{const se=J.channelClient.getChannel(V).listen(ee,ne),le=S.add(se);R.set(J,le)},F=J=>{const Z=R.get(J);Z&&(Z.dispose(),R.delete(J))};re.connections.filter(W).forEach(z),C.Event.filter(re.onDidAddConnection,W)(z,void 0,X),re.onDidRemoveConnection(F,void 0,X),S.event(B.fire,B,X),X.add(S)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return B.event}registerChannel(V,W){this.a.set(V,W);for(const ee of this.f)ee.channelServer.registerChannel(V,W)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=m;class j{constructor(V,W,ee=null){const ne=new t;r(ne,W),V.send(ne.buffer),this.a=new f(V,ee),this.d=new v(V,W,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,W){this.d.registerChannel(V,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=j;function M(H){return{call(V,W,ee){return H.then(ne=>ne.call(V,W,ee))},listen(V,W){const ee=new C.$Vd;return H.then(ne=>ee.input=ne.listen(V,W)),ee.event}}}e.$th=M;function T(H){let V=!1;return{call(W,ee,ne){return V?H.call(W,ee,ne):(0,N.$Tg)(0).then(()=>V=!0).then(()=>H.call(W,ee,ne))},listen(W,ee){if(V)return H.listen(W,ee);const ne=new C.$Vd;return(0,N.$Tg)(0).then(()=>V=!0).then(()=>ne.input=H.listen(W,ee)),ne.event}}}e.$uh=T;class U{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const W of V.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await C.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$vh=U;var q;(function(H){function V(re,X,B){const S=re,R=B&&B.disableMarshalling,z=new Map;for(const F in S)ee(F)&&z.set(F,C.Event.buffer(S[F],!0,void 0,X));return new class{listen(F,J,Z){const se=z.get(J);if(se)return se;if(ne(J)){const le=S[J];if(typeof le=="function")return le.call(S,Z)}throw new I.$ab(`Event not found: ${J}`)}call(F,J,Z){const se=S[J];if(typeof se=="function"){if(!R&&Array.isArray(Z))for(let ue=0;ue<Z.length;ue++)Z[ue]=(0,P.$kh)(Z[ue]);let le=se.apply(S,Z);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new I.$ab(`Method not found: ${J}`)}}}H.fromService=V;function W(re,X){const B=X&&X.disableMarshalling;return new Proxy({},{get(S,R){if(typeof R=="string")return X?.properties?.has(R)?X.properties.get(R):ne(R)?function(z){return re.listen(R,z)}:ee(R)?re.listen(R):async function(...z){let F;X&&!(0,$.$Gf)(X.context)?F=[X.context,...z]:F=z;const J=await re.call(R,F);return B?J:(0,P.$kh)(J)};throw new I.$ab(`Property not found: ${String(R)}`)}})}H.toService=W;function ee(re){return re[0]==="o"&&re[1]==="n"&&E.$Ze(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&E.$Ze(re.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function Y(H){return Array.isArray(H)?H.map(K):K(H)}function G(H,V,W,ee,ne,re,X){X=Y(X);const B=_[ne],S=B[ee%B.length];let R=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${S}`];/\($/.test(re)?(R=R.concat(X),R.push(")")):R.push(X),console.log.apply(console,R)}class Q{constructor(V,W){this.d=V,this.f=W,this.a=0,this.b=0}logOutgoing(V,W,ee,ne,re){this.b+=V,G(this.d,this.b,V,W,ee,ne,re)}logIncoming(V,W,ee,ne,re){this.a+=V,G(this.f,this.a,V,W,ee,ne,re)}}e.$wh=Q}),define(oe[65],ae([0,1,15,3,2,42]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function o(y,f){if(!i.has(y)){const m=String(++r);i.set(y,m)}return i.get(y)}function v(y,f,m,j){if(!n.enableDiagnostics)return;const M=o(y,f);if(j instanceof D.$ae||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const T=D.$ae.alloc(j.byteLength);T.set(j),n.records.push({timestamp:Date.now(),id:M,label:f,type:m,buff:T})}else n.records.push({timestamp:Date.now(),id:M,label:f,type:m,data:j})}n.traceSocketEvent=v})(I||(e.SocketDiagnostics=I={}));var C;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let d=null;function P(){return d||(d=D.$ae.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const f=this.a[0];return r&&(this.a.shift(),this.b-=i),f}if(this.a[0].byteLength>i){const f=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),f}const o=D.$ae.alloc(i);let v=0,y=0;for(;i>0;){const f=this.a[y];if(f.byteLength>i){const m=f.slice(0,i);o.set(m,v),v+=i,r&&(this.a[y]=f.slice(i),this.b-=i),i-=i}else o.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):y++,i-=f.byteLength}return o}}e.$xh=E;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function c(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class p{constructor(i,r,o,v){this.type=i,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends A.$Rc{constructor(i){super(),this.f=this.B(new N.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$ae.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const o=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,o}h(){const i=D.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class l extends A.$Rc{constructor(i){super(),this.f=new N.$Md,this.onMessage=this.f.event,this.g=new N.$Md,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new h(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$yh=l;class u extends L.$sh{static fromSocket(i,r){return new u(new l(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,o=null){super(i,r,o),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$zh=u;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$Ah=b;class k{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,o=this.a;for(;o;)i[r++]=o.data,o=o.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new k(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<a.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)i-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??a.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Qc,this.o=i.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,P());this.p.write(i)}sendResume(){const i=new p(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new A.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,P());this.p.write(i);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,i);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(i){const r=new p(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,P());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,P());this.p.write(i)}}e.$Bh=s}),define(oe[93],ae([0,1,64,5,15,26,142,8,3,2,30,145,90,42]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class g extends c.$ph{constructor(h){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",l=>A.$ae.wrap(Buffer.from(l,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Xp=g;class p{constructor(h,l){this.i=h,this.j=l,this.c=new Set,this.g=new Map,this.h=new C.$Md,this.onDidProcessExit=this.h.event;const u=l&&l.timeout?l.timeout:6e4;this.b=new N.$Pg(u),this.d=null,this.f=null}getChannel(h){const l=this;return{call(u,b,k){return l.k(h,u,b,k)},listen(u,b){return l.l(h,u,b)}}}k(h,l,u,b=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const k=this.n(h),t=(0,N.$Gg)(n=>k.call(l,u,n)),a=b.onCancellationRequested(()=>t.cancel()),s=(0,d.$Pc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{a.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,l,u){if(!this.b)return C.Event.None;this.b.cancel();let b;const k=new C.$Md({onWillAddFirstListener:()=>{b=this.n(h).listen(l,u)(k.fire,k),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,P.$2m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,$.$wl)(l.env),this.d=(0,D.fork)(this.i,h,l);const u=new C.$Md;C.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,O.$Tp)(i)){(0,O.log)(i,`IPC Library: ${this.j.serverName}`);return}u.fire(A.$ae.wrap(Buffer.from(i,"base64")))});const k=this.j.useQueue?(0,E.$yl)(this.d):this.d,t=i=>this.d&&this.d.connected&&k.send(i.buffer.toString("base64")),a=u.event,s={send:t,onMessage:a};this.f=new c.$qh(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(h){let l=this.g.get(h);return l||(l=this.m.getChannel(h),this.g.set(h,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Yp=p}),define(oe[147],ae([0,1,135,15,42,3,12,18]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oT=e.$nT=void 0;class C{constructor($){this.a=$,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",c=>N.$ae.wrap(c.data)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class d extends A.$rh{static b($){(0,O.$Hf)((0,D.$mT)(process),"Electron Utility Process");const c=new L.$Md;return process.parentPort.on("message",g=>{if($?.handledClientConnection(g))return;const p=(0,I.$Nb)(g.ports);p&&c.fire(p)}),L.Event.map(c.event,g=>({protocol:new C(g),onDidClientDisconnect:L.Event.fromNodeEventEmitter(g,"close")}))}constructor($){super(d.b($))}}e.$nT=d;function P(E,$,c){const g=p=>{p.data===$&&(E.removeListener("message",g),c())};E.on("message",g)}e.$oT=P}),define(oe[66],ae([0,1,5,3,2,63,12]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.StorageState=e.$Wo=e.StorageHint=void 0;var I;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function C($){const c=$;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$Wo=C;var d;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends A.$Rc{static{this.a=100}constructor(c,g=Object.create(null)){super(),this.r=c,this.s=g,this.b=this.B(new N.$Pd),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new D.$Qg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((g,p)=>this.w(p,g)),c.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(c,g){if(this.c===d.Closed)return;let p=!1;(0,O.$Gf)(g)?p=this.f.delete(c):this.f.get(c)!==g&&(this.f.set(c,g),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,g){const p=this.f.get(c);return(0,O.$Gf)(p)?g:p}getBoolean(c,g){const p=this.get(c);return(0,O.$Gf)(p)?g:p==="true"}getNumber(c,g){const p=this.get(c);return(0,O.$Gf)(p)?g:parseInt(p,10)}getObject(c,g){const p=this.get(c);return(0,O.$Gf)(p)?g:(0,L.$jh)(p)}async set(c,g,p=!1){if(this.c===d.Closed)return;if((0,O.$Gf)(g))return this.delete(c,p);const w=(0,O.$zf)(g)||Array.isArray(g)?(0,L.$ih)(g):String(g);if(this.f.get(c)!==w)return this.f.set(c,w),this.j.set(c,w),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,g=!1){if(!(this.c===d.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:g}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Xo=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((g,p)=>this.a.set(p,g)),c.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Yo=E}),define(oe[148],ae([13,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var A;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,$=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:$};this.g.push({offset:E,lexeme:$,additionalInfo:P}),this.f.push(c)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),$=C.b.get(E);$?this.k($):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,$=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(I);return}const g=this.c.charCodeAt(P);if(E)E=!1;else if(g===47&&!$){P++;break}else g===91?$=!0:g===92?E=!0:g===93&&($=!1);P++}for(;P<this.c.length&&C.a.has(this.c.charCodeAt(P));)P++;this.e=P;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=C}),define(oe[180],ae([0,1,62,83,23,16,37,21,9]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,L.$lc)(A.$bg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,L.$ic)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$am)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$ic)(this.userDataPath,"logs",c)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$ug)(C.URI.file((0,L.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?C.URI.file((0,L.$ic)(c,"argv.json")):(0,I.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,L.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,L.$jc)(c):(0,L.$gc)((0,L.$ic)(A.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?C.URI.file((0,L.$jc)(c)):C.URI.file((0,L.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,L.$jc)(c);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const p=O.env.VSCODE_PORTABLE;return p?(0,L.$ic)(p,"extensions"):(0,I.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(g=>/^[^:/?#]+?:\/\//.test(g)?C.URI.parse(g):C.URI.file((0,L.$gc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,L.$gc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$bm.test(c))}get extensionLogLevel(){const c=[];for(const g of this.args.log||[]){const p=e.$bm.exec(g);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,I.$ug)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?C.URI.file((0,L.$ic)(c,"policy.json")):(0,I.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,g,p){this.a=c,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.$cm=d,ye([N.$fh],d.prototype,"appRoot",null),ye([N.$fh],d.prototype,"userHome",null),ye([N.$fh],d.prototype,"userDataPath",null),ye([N.$fh],d.prototype,"appSettingsHome",null),ye([N.$fh],d.prototype,"tmpDir",null),ye([N.$fh],d.prototype,"cacheHome",null),ye([N.$fh],d.prototype,"stateResource",null),ye([N.$fh],d.prototype,"userRoamingDataHome",null),ye([N.$fh],d.prototype,"userDataSyncHome",null),ye([N.$fh],d.prototype,"sync",null),ye([N.$fh],d.prototype,"machineSettingsResource",null),ye([N.$fh],d.prototype,"workspaceStorageHome",null),ye([N.$fh],d.prototype,"localHistoryHome",null),ye([N.$fh],d.prototype,"keyboardLayoutResource",null),ye([N.$fh],d.prototype,"argvResource",null),ye([N.$fh],d.prototype,"isExtensionDevelopment",null),ye([N.$fh],d.prototype,"untitledWorkspacesHome",null),ye([N.$fh],d.prototype,"builtinExtensionsPath",null),ye([N.$fh],d.prototype,"extensionsPath",null),ye([N.$fh],d.prototype,"extensionDevelopmentLocationURI",null),ye([N.$fh],d.prototype,"extensionDevelopmentKind",null),ye([N.$fh],d.prototype,"extensionTestsLocationURI",null),ye([N.$fh],d.prototype,"debugExtensionHost",null),ye([N.$fh],d.prototype,"logLevel",null),ye([N.$fh],d.prototype,"extensionLogLevel",null),ye([N.$fh],d.prototype,"serviceMachineIdResource",null),ye([N.$fh],d.prototype,"disableTelemetry",null),ye([N.$fh],d.prototype,"disableWorkspaceTrust",null),ye([N.$fh],d.prototype,"useInMemorySecretStorage",null),ye([N.$fh],d.prototype,"policyFile",null);function P($,c){return E($["inspect-extensions"],$["inspect-brk-extensions"],5870,c,$.debugId,$.extensionEnvironment)}e.$dm=P;function E($,c,g,p,w,h){const u=Number(c||$)||(p?null:g),b=u?!!c:!1;let k;if(h)try{k=JSON.parse(h)}catch{}return{port:u,break:b,debugId:w,env:k}}e.$em=E}),function(){"use strict";function te(e,D,N){function A(O,I){const C=L(O,I),d=[C];return e.isAbsolute(C)||d.unshift(N),e.resolve(...d)}function L(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,D,N){return te(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=te(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=void 0;class L extends N.$cm{constructor(d,P){super(d,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,A.getUserDataPath)(d,P.nameShort)},P)}}e.$fm=L;function O(C,d){return(0,N.$em)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,d,C.extensionEnvironment)}e.$gm=O;function I(C,d){return(0,N.$em)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,d,C.extensionEnvironment)}e.$hm=I}),define(oe[183],ae([0,1,12,154]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function A(O,I,C,d){try{L(O,I,C,d)}catch(P){O.error(P?.message??P)}return I}e.$tp=A;function L(O,I,C,d){const P=(E,$,c)=>{const g=E[$];if((0,D.$xf)(g)){const p=g,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const h=p.substr(1,w-2);let l=C[h];l===void 0&&d&&(l=d[h]);const u=typeof l=="string"?l:l?.message,b=d?.[h],k=typeof b=="string"?b:b?.message;if(!u){k||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,h)}`);return}if(c&&($==="title"||$==="category")&&k&&k!==u){const t={value:u,original:k};E[$]=t}else E[$]=u}}else if((0,D.$zf)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?P(g,p,!0):P(g,p,c));else if(Array.isArray(g))for(let p=0;p<g.length;p++)P(g,p,c)};for(const E in I)I.hasOwnProperty(E)&&P(I,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=e.$S8b=void 0;class D{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$S8b=D;class N{constructor(L){this.a=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$T8b=N}),define(oe[67],ae([0,1,21,89,158,53]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(h){return h=h.trim(),h==="*"||O.test(h)}e.$Ho=C;function d(h){if(!C(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=h.match(O);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Io=d;function P(h){if(!h)return null;const l=h.majorBase,u=h.majorMustEqual,b=h.minorBase;let k=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(l===0||(k=!1),a=!1);let s=0;if(h.preRelease){const n=I.exec(h.preRelease);if(n){const[,i,r,o]=n;s=Date.UTC(Number(i),Number(r)-1,Number(o))}}return{majorBase:l,majorMustEqual:u,minorBase:b,minorMustEqual:k,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:s}}e.$Jo=P;function E(h,l,u){let b;typeof h=="string"?b=P(d(h)):b=h;let k;l instanceof Date?k=l.getTime():typeof l=="string"&&(k=new Date(l).getTime());let t;if(typeof u=="string"?t=P(d(u)):t=u,!b||!t)return!1;const a=b.majorBase,s=b.minorBase,n=b.patchBase;let i=t.majorBase,r=t.minorBase,o=t.patchBase;const v=t.notBefore;let y=t.majorMustEqual,f=t.minorMustEqual,m=t.patchMustEqual;return t.isMinimum?a>i?!0:a<i?!1:s>r?!0:s<r||k&&k<v?!1:n>=o:(a===1&&i===0&&(!y||!f||!m)&&(i=1,r=0,o=0,y=!0,f=!1,m=!1),a<i?!1:a>i?!y:s<r?!1:s>r?!f:n<o?!1:n>o?!m:!(k&&k<v))}e.$Ko=E;function $(h,l,u,b,k){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([N.default.Error,A.localize(0,null)]),t;if(typeof b.name!="string")return t.push([N.default.Error,A.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([N.default.Error,A.localize(2,null,"version")]),t;if(!b.engines)return t.push([N.default.Error,A.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([N.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!w(b.extensionDependencies))return t.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!w(b.activationEvents))return t.push([N.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([N.default.Error,A.localize(9,null,"main")]),t;{const n=(0,D.$ug)(u,b.main);(0,D.$og)(n,u)||t.push([N.default.Warning,A.localize(10,null,n.path,u.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([N.default.Error,A.localize(11,null,"browser")]),t;{const n=(0,D.$ug)(u,b.browser);(0,D.$og)(n,u)||t.push([N.default.Warning,A.localize(12,null,n.path,u.path)])}}if(!L.valid(b.version))return t.push([N.default.Error,A.localize(13,null)]),t;const a=[];if(!c(h,l,b,k,a))for(const n of a)t.push([N.default.Error,n]);return t}e.$Lo=$;function c(h,l,u,b,k){return b||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(h,l,u.engines.vscode,k)}e.$Mo=c;function g(h,l,u){return h==="*"||p(l,u,h)}e.$No=g;function p(h,l,u,b=[]){const k=P(d(u));if(!k)return b.push(A.localize(14,null,u)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return b.push(A.localize(15,null,u)),!1}else if(!k.majorMustEqual)return b.push(A.localize(16,null,u)),!1;return E(h,l,k)?!0:(b.push(A.localize(17,null,h,u)),!1)}function w(h){if(!Array.isArray(h))return!1;for(let l=0,u=h.length;l<u;l++)if(typeof h[l]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0;async function A(L,O,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await O.readFile(L.serviceMachineIdResource)).value.toString();C=(0,N.$cg)(P)?P:null}catch{C=null}if(!C){C=(0,N.$dg)();try{await O.writeFile(L.serviceMachineIdResource,D.$ae.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}e.$8o=A}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class D{constructor(A,L=[],O=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=O}}e.$Kh=D}),define(oe[185],ae([0,1,68]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const N=[];var A;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(I,C,d){C instanceof D.$Kh||(C=new D.$Kh(C,[],!!d)),N.push([I,C])}e.$sr=L;function O(){return N}e.$tr=O}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class D{constructor(L,O){this.key=L,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$0p=D;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const O of this.a.values())O.outgoing.size===0&&L.push(O);return L}insertEdge(L,O){const I=this.lookupOrInsertNode(L),C=this.lookupOrInsertNode(O);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(L){const O=this.b(L);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(L){const O=this.b(L);let I=this.a.get(O);return I||(I=new D(O,L),this.a.set(O,I)),I}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[O,I]of this.a)L.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,O]of this.a){const I=new Set([L]),C=this.c(O,I);if(C)return C}}c(L,O){for(const[I,C]of L.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const d=this.c(C,O);if(d)return d;O.delete(I)}}}e.$$p=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(D||(e._util=D={})),e.$Mh=A("instantiationService");function N(O,I,C){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:O,index:C}):(I[D.DI_DEPENDENCIES]=[{id:O,index:C}],I[D.DI_TARGET]=I)}function A(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const I=function(C,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,C,P)};return I.toString=()=>O,D.serviceIds.set(O,I),I}e.$Nh=A;function L(O){return O}e.$Oh=L}),define(oe[187],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0,e.$p8b=(0,D.$Nh)("checksumService")}),define(oe[19],ae([0,1,12,9,4]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,A.$Nh)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$ii=L;function O(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$ji=O;var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=C;function d(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$li=d;function P(h,l){const u=Object.create(null);for(const b in h)E(u,b,h[b],l);return u}e.$mi=P;function E(h,l,u,b){const k=l.split("."),t=k.pop();let a=h;for(let s=0;s<k.length;s++){const n=k[s];let i=a[n];switch(typeof i){case"undefined":i=a[n]=Object.create(null);break;case"object":break;default:b(`Ignoring ${l} as ${k.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[t]=u}catch{b(`Ignoring ${l} as ${k.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${l} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$ni=E;function $(h,l){const u=l.split(".");c(h,u)}e.$oi=$;function c(h,l){const u=l.shift();if(l.length===0){delete h[u];return}if(Object.keys(h).indexOf(u)!==-1){const b=h[u];typeof b=="object"&&!Array.isArray(b)&&(c(b,l),Object.keys(b).length===0&&delete h[u])}}function g(h,l,u){function b(a,s){let n=a;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const k=l.split("."),t=b(h,k);return typeof t>"u"?u:t}e.$pi=g;function p(h,l,u){Object.keys(l).forEach(b=>{b!=="__proto__"&&(b in h?D.$zf(h[b])&&D.$zf(l[b])?p(h[b],l[b],u):u&&(h[b]=l[b]):h[b]=l[b])})}e.$qi=p;function w(h){return h.replace(/[\[\]]/g,"")}e.$ri=w}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",D.$k),C.set("isLinux",D.$l),C.set("isWindows",D.$j),C.set("isWeb",D.$p),C.set("isMacNative",D.$k&&!D.$p),C.set("isEdge",D.$H),C.set("isFirefox",D.$F),C.set("isChrome",D.$E),C.set("isSafari",D.$G);function d(B,S){if(C.get(B)!==void 0)throw(0,I.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(B,S)}e.$Ji=d;const P=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const $={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),g=(0,O.localize)(1,null),p=(0,O.localize)(2,null),w=(0,O.localize)(3,null),h=(0,O.localize)(4,null),l=(0,O.localize)(5,null),u=(0,O.localize)(6,null),b=(0,O.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(S=$){this.k=S,this.d=new A.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(S){if(S===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(S).scan(),this.g=0,this.h=[];try{const R=this.l();if(!this.E()){const z=this.D(),F=z.type===17?l:void 0;throw this.h.push({message:h,offset:z.offset,lexeme:A.$Ii.getLexeme(z),additionalInfo:F}),k.c}return R}catch(R){if(R!==k.c)throw R;return}}l(){return this.m()}m(){const S=[this.o()];for(;this.y(16);){const R=this.o();S.push(R)}return S.length===1?S[0]:t.or(...S)}o(){const S=[this.s()];for(;this.y(15);){const R=this.s();S.push(R)}return S.length===1?S[0]:t.and(...S)}s(){if(this.y(2)){const S=this.D();switch(S.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const R=this.l();return this.A(1,w),R?.negate()}case 17:return this.z(),j.create(S.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",S)}}return this.t()}t(){const S=this.D();switch(S.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const R=this.l();return this.A(1,w),R}case 17:{const R=S.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const J=F.lexeme,Z=J.lastIndexOf("/"),se=Z===J.length-1?void 0:this.w(J.substring(Z+1));let le;try{le=new RegExp(J.substring(1,Z),se)}catch{throw this.B("REGEX",F)}return K.create(R,le)}switch(F.type){case 10:case 19:{const J=[F.lexeme];this.z();let Z=this.D(),se=0;for(let de=0;de<F.lexeme.length;de++)F.lexeme.charCodeAt(de)===40?se++:F.lexeme.charCodeAt(de)===41&&se--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let de=0;de<Z.lexeme.length;de++)Z.lexeme.charCodeAt(de)===40?se++:F.lexeme.charCodeAt(de)===41&&se--}if(se<0)break;J.push(A.$Ii.getLexeme(Z)),this.z(),Z=this.D()}const le=J.join(""),ue=le.lastIndexOf("/"),he=ue===le.length-1?void 0:this.w(le.substring(ue+1));let $e;try{$e=new RegExp(le.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return t.regex(R,$e)}case 18:{const J=F.lexeme;this.z();let Z=null;if(!(0,N.$Ae)(J)){const se=J.indexOf("/"),le=J.lastIndexOf("/");if(se!==le&&se>=0){const ue=J.slice(se+1,le),he=J[le+1]==="i"?"i":"";try{Z=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(Z===null)throw this.B("REGEX",F);return K.create(R,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const F=this.u();return t.notIn(R,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return t.equals(R,F);switch(F){case"true":return t.has(R);case"false":return t.not(R);default:return t.equals(R,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return t.notEquals(R,F);switch(F){case"true":return t.not(R);case"false":return t.has(R);default:return t.notEquals(R,F)}}case 5:return this.z(),q.create(R,this.u());case 6:return this.z(),_.create(R,this.u());case 7:return this.z(),T.create(R,this.u());case 8:return this.z(),U.create(R,this.u());case 13:return this.z(),t.in(R,this.u());default:return t.has(R)}}case 20:throw this.h.push({message:u,offset:S.offset,lexeme:"",additionalInfo:b}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const S=this.D();switch(S.type){case 17:case 18:return this.z(),S.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(S){return S.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(S){return this.C(S)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(S,R){if(this.C(S))return this.z();throw this.B(R,this.D())}B(S,R,z){const F=(0,O.localize)(8,null,S,A.$Ii.getLexeme(R)),J=R.offset,Z=A.$Ii.getLexeme(R);return this.h.push({message:F,offset:J,lexeme:Z,additionalInfo:z}),k.c}C(S){return this.D().type===S}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=k;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(S){return o.create(S)}static equals(S,R){return v.create(S,R)}static notEquals(S,R){return m.create(S,R)}static regex(S,R){return K.create(S,R)}static in(S,R){return y.create(S,R)}static notIn(S,R){return f.create(S,R)}static not(S){return j.create(S)}static and(...S){return Q.create(S,null,!0)}static or(...S){return H.create(S,null,!0)}static greater(S,R){return T.create(S,R)}static greaterEquals(S,R){return U.create(S,R)}static smaller(S,R){return q.create(S,R)}static smallerEquals(S,R){return _.create(S,R)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(S){return S==null?void 0:this.c.parse(S)}}e.$Li=t;function a(B){const S=new k({regexParsingWithErrorRecovery:!1});return B.map(R=>(S.parse(R),S.lexingErrors.length>0?S.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):S.parsingErrors.length>0?S.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Mi=a;function s(B,S){const R=B?B.substituteConstants():void 0,z=S?S.substituteConstants():void 0;return!R&&!z?!0:!R||!z?!1:R.equals(z)}e.$Ni=s;function n(B,S){return B.cmp(S)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return r.INSTANCE}}e.$Oi=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return i.INSTANCE}}e.$Pi=r;class o{static create(S,R=null){const z=C.get(S);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new o(S,R)}constructor(S,R){this.key=S,this.c=R,this.type=2}cmp(S){return S.type!==this.type?this.type-S.type:W(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=C.get(this.key);return typeof S=="boolean"?S?r.INSTANCE:i.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Qi=o;class v{static create(S,R,z=null){if(typeof R=="boolean")return R?o.create(S,z):j.create(S,z);const F=C.get(S);return typeof F=="boolean"?R===(F?"true":"false")?r.INSTANCE:i.INSTANCE:new v(S,R,z)}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=4}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=C.get(this.c);if(typeof S=="boolean"){const R=S?"true":"false";return this.d===R?r.INSTANCE:i.INSTANCE}return this}evaluate(S){return S.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(S){return S.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Ri=v;class y{static create(S,R){return new y(S,R)}constructor(S,R){this.d=S,this.f=R,this.type=10,this.c=null}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.d,this.f,S.d,S.f)}equals(S){return S.type===this.type?this.d===S.d&&this.f===S.f:!1}substituteConstants(){return this}evaluate(S){const R=S.getValue(this.f),z=S.getValue(this.d);return Array.isArray(R)?R.includes(z):typeof z=="string"&&typeof R=="object"&&R!==null?P.call(R,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(S){return S.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Si=y;class f{static create(S,R){return new f(S,R)}constructor(S,R){this.d=S,this.f=R,this.type=11,this.c=y.create(S,R)}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(S){return S.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=f;class m{static create(S,R,z=null){if(typeof R=="boolean")return R?j.create(S,z):o.create(S,z);const F=C.get(S);return typeof F=="boolean"?R===(F?"true":"false")?i.INSTANCE:r.INSTANCE:new m(S,R,z)}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=5}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=C.get(this.c);if(typeof S=="boolean"){const R=S?"true":"false";return this.d===R?i.INSTANCE:r.INSTANCE}return this}evaluate(S){return S.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(S){return S.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ui=m;class j{static create(S,R=null){const z=C.get(S);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new j(S,R)}constructor(S,R){this.c=S,this.d=R,this.type=3}cmp(S){return S.type!==this.type?this.type-S.type:W(this.c,S.c)}equals(S){return S.type===this.type?this.c===S.c:!1}substituteConstants(){const S=C.get(this.c);return typeof S=="boolean"?S?i.INSTANCE:r.INSTANCE:this}evaluate(S){return!S.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(S){return S.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Vi=j;function M(B,S){if(typeof B=="string"){const R=parseFloat(B);isNaN(R)||(B=R)}return typeof B=="string"||typeof B=="number"?S(B):i.INSTANCE}class T{static create(S,R,z=null){return M(R,F=>new T(S,F,z))}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=12}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Wi=T;class U{static create(S,R,z=null){return M(R,F=>new U(S,F,z))}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=13}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Xi=U;class q{static create(S,R,z=null){return M(R,F=>new q(S,F,z))}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=14}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=q;class _{static create(S,R,z=null){return M(R,F=>new _(S,F,z))}constructor(S,R,z){this.c=S,this.d=R,this.f=z,this.type=15}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Zi=_;class K{static create(S,R){return new K(S,R)}constructor(S,R){this.d=S,this.f=R,this.type=7,this.c=null}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.d<S.d)return-1;if(this.d>S.d)return 1;const R=this.f?this.f.source:"",z=S.f?S.f.source:"";return R<z?-1:R>z?1:0}equals(S){if(S.type===this.type){const R=this.f?this.f.source:"",z=S.f?S.f.source:"";return this.d===S.d&&R===z}return!1}substituteConstants(){return this}evaluate(S){const R=S.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const S=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${S}`}keys(){return[this.d]}map(S){return S.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$1i=K;class Y{static create(S){return new Y(S)}constructor(S){this.c=S,this.type=8}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(S){return new Y(this.c.map(S))}negate(){return this.c}}e.$2i=Y;function G(B){let S=null;for(let R=0,z=B.length;R<z;R++){const F=B[R].substituteConstants();if(B[R]!==F&&S===null){S=[];for(let J=0;J<R;J++)S[J]=B[J]}S!==null&&(S[R]=F)}return S===null?B:S}class Q{static create(S,R,z){return Q.d(S,R,z)}constructor(S,R){this.expr=S,this.c=R,this.type=6}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let R=0,z=this.expr.length;R<z;R++){const F=n(this.expr[R],S.expr[R]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].equals(S.expr[R]))return!1;return!0}return!1}substituteConstants(){const S=G(this.expr);return S===this.expr?this:Q.create(S,this.c,!1)}evaluate(S){for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].evaluate(S))return!1;return!0}static d(S,R,z){const F=[];let J=!1;for(const Z of S)if(Z){if(Z.type===1){J=!0;continue}if(Z.type===0)return i.INSTANCE;if(Z.type===6){F.push(...Z.expr);continue}F.push(Z)}if(F.length===0&&J)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(n);for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];for(;F.length>1;){const Z=F[F.length-1];if(Z.type!==9)break;F.pop();const se=F.pop(),le=F.length===0,ue=H.create(Z.expr.map(he=>Q.create([he,se],null,z)),null,le);ue&&(F.push(ue),F.sort(n))}if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let se=Z+1;se<F.length;se++)if(F[Z].negate().equals(F[se]))return i.INSTANCE;if(F.length===1)return F[0]}return new Q(F,R)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const R of this.expr)S.push(...R.keys());return S}map(S){return new Q(this.expr.map(R=>R.map(S)),null)}negate(){if(!this.c){const S=[];for(const R of this.expr)S.push(R.negate());this.c=H.create(S,this,!0)}return this.c}}e.$3i=Q;class H{static create(S,R,z){return H.d(S,R,z)}constructor(S,R){this.expr=S,this.c=R,this.type=9}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let R=0,z=this.expr.length;R<z;R++){const F=n(this.expr[R],S.expr[R]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].equals(S.expr[R]))return!1;return!0}return!1}substituteConstants(){const S=G(this.expr);return S===this.expr?this:H.create(S,this.c,!1)}evaluate(S){for(let R=0,z=this.expr.length;R<z;R++)if(this.expr[R].evaluate(S))return!0;return!1}static d(S,R,z){let F=[],J=!1;if(S){for(let Z=0,se=S.length;Z<se;Z++){const le=S[Z];if(le){if(le.type===0){J=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){F=F.concat(le.expr);continue}F.push(le)}}if(F.length===0&&J)return i.INSTANCE;F.sort(n)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let se=Z+1;se<F.length;se++)if(F[Z].negate().equals(F[se]))return r.INSTANCE;if(F.length===1)return F[0]}return new H(F,R)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const R of this.expr)S.push(...R.keys());return S}map(S){return new H(this.expr.map(R=>R.map(S)),null)}negate(){if(!this.c){const S=[];for(const R of this.expr)S.push(R.negate());for(;S.length>1;){const R=S.shift(),z=S.shift(),F=[];for(const J of X(R))for(const Z of X(z))F.push(Q.create([J,Z],null,!1));S.unshift(H.create(F,null,!1))}this.c=H.create(S,this,!0)}return this.c}}e.$4i=H;class V extends o{static{this.d=[]}static all(){return V.d.values()}constructor(S,R,z){super(S,null),this.f=R,typeof z=="object"?V.d.push({...z,key:S}):z!==!0&&V.d.push({key:S,description:z,type:R!=null?typeof R:void 0})}bindTo(S){return S.createKey(this.key,this.f)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return v.create(this.key,S)}notEqualsTo(S){return m.create(this.key,S)}}e.$5i=V,e.$6i=(0,L.$Nh)("contextKeyService");function W(B,S){return B<S?-1:B>S?1:0}function ee(B,S,R,z){return B<R?-1:B>R?1:S<z?-1:S>z?1:0}function ne(B,S){if(B.type===0||S.type===1)return!0;if(B.type===9)return S.type===9?re(B.expr,S.expr):!1;if(S.type===9){for(const R of S.expr)if(ne(B,R))return!0;return!1}if(B.type===6){if(S.type===6)return re(S.expr,B.expr);for(const R of B.expr)if(ne(R,S))return!0;return!1}return B.equals(S)}e.$7i=ne;function re(B,S){let R=0,z=0;for(;R<B.length&&z<S.length;){const F=B[R].cmp(S[z]);if(F<0)return!1;F===0&&R++,z++}return R===B.length}function X(B){return B.type===9?B.expr:[B]}}),define(oe[95],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.ID=void 0,e.ID="diagnosticsService",e.$mm=(0,D.$Nh)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}e.$nm=N;class A{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$om=A}),define(oe[96],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Jn=(0,D.$Nh)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,D.$Nh)("environmentService"),e.$Vh=(0,D.$Oh)(e.$Uh)}),define(oe[29],ae([0,1,153,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=A;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=L;function O(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=O;function I(l,u){return u==="web"&&!l.includes("web")}e.$2n=I;function C(l,u,b){return I(u,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:d(b).includes(l)}e.$3n=C;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=d;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$5n=P;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var $;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})($||(e.SortOrder=$={}));var c;(function(l){l.Install="install",l.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$6n=(0,N.$Nh)("extensionGalleryService");var p;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var w;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class h extends Error{constructor(u,b){super(u),this.code=b,this.name=b}}e.$7n=h,e.$8n=(0,N.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,N.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,N.$Nh)("IExtensionTipsService"),e.$ao=(0,D.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,D.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,9,92,29]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=void 0;function C(w,h){return w?L.URI.revive(h?h.transformIncoming(w):w):void 0}function d(w,h){return h?h.transformOutgoingURI(w):w}function P(w,h){h=h||O.$Im;const l=w.manifest;return{...(0,O.$Lm)({...w,manifest:void 0},h),manifest:l}}function E(w,h){return w?.profileLocation?(0,O.$Lm)(w,h??O.$Im):w}function $(w,h){return h?(0,A.$4m)(w,l=>l instanceof L.URI?h.transformOutgoingURI(l):void 0):w}class c{constructor(h,l){this.a=h,this.b=l,this.onInstallExtension=D.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,l){const u=this.b(h);switch(l){case"onInstallExtension":return D.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,b=>b.map(k=>({...k,local:k.local?$(k.local,u):k.local,profileLocation:k.profileLocation?d(k.profileLocation,u):k.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,b=>$(b,u))}throw new Error("Invalid listen")}async call(h,l,u){const b=this.b(h);switch(l){case"zip":{const k=P(u[0],b),t=await this.a.zip(k);return d(t,b)}case"unzip":return this.a.unzip(C(u[0],b));case"install":return this.a.install(C(u[0],b),E(u[1],b));case"installFromLocation":return this.a.installFromLocation(C(u[0],b),C(u[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],C(u[1],b),C(u[2],b));case"getManifest":return this.a.getManifest(C(u[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],E(u[1],b));case"installGalleryExtensions":{const k=u[0];return this.a.installGalleryExtensions(k.map(({extension:t,options:a})=>({extension:t,options:E(a,b)??{}})))}case"uninstall":return this.a.uninstall(P(u[0],b),E(u[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(u[0],b));case"getInstalled":return(await this.a.getInstalled(u[0],C(u[1],b))).map(t=>$(t,b));case"toggleAppliationScope":{const k=await this.a.toggleAppliationScope(P(u[0],b),C(u[1],b));return $(k,b)}case"copyExtensions":return this.a.copyExtensions(C(u[0],b),C(u[1],b));case"updateMetadata":{const k=await this.a.updateMetadata(P(u[0],b),u[1],C(u[2],b));return $(k,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$dp=c;class g extends N.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new D.$Md),this.f=this.B(new D.$Md),this.g=this.B(new D.$Md),this.h=this.B(new D.$Md),this.j=this.B(new D.$Md),this.B(this.m.listen("onInstallExtension")(l=>this.n(this.c,{...l,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(l=>this.n(this.f,l.map(u=>({...u,local:u.local?P(u.local,null):u.local,source:this.r(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(l=>this.n(this.g,{...l,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(l=>this.n(this.h,{...l,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(l=>this.j.fire(P(l,null))))}n(h,l){h.fire(l)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const l=await this.getTargetPlatform();return h.allTargetPlatforms.some(u=>(0,I.$3n)(u,h.allTargetPlatforms,l))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(l=>L.URI.revive(l)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,l){return Promise.resolve(this.m.call("install",[h,l])).then(u=>P(u,null))}installFromLocation(h,l){return Promise.resolve(this.m.call("installFromLocation",[h,l])).then(u=>P(u,null))}async installExtensionsFromProfile(h,l,u){return(await this.m.call("installExtensionsFromProfile",[h,l,u])).map(k=>P(k,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,l){return Promise.resolve(this.m.call("installFromGallery",[h,l])).then(u=>P(u,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(u=>({...u,local:u.local?P(u.local,null):u.local,source:this.r(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))}uninstall(h,l){return Promise.resolve(this.m.call("uninstall",[h,l]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(l=>P(l,null))}getInstalled(h=null,l){return Promise.resolve(this.m.call("getInstalled",[h,l])).then(u=>u.map(b=>P(b,null)))}updateMetadata(h,l,u){return Promise.resolve(this.m.call("updateMetadata",[h,l,u])).then(b=>P(b,null))}toggleAppliationScope(h,l){return this.m.call("toggleAppliationScope",[h,l]).then(u=>P(u,null))}copyExtensions(h,l){return this.m.call("copyExtensions",[h,l])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,l,u){const b=await this.m.call("download",[h,l,u]);return L.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$ep=g;class p{constructor(h){this.a=h}listen(h,l){throw new Error("Invalid listen")}call(h,l,u){switch(l){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$fp=p}),define(oe[97],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=void 0,e.$ap=(0,D.$Nh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,O)=>te(["node-vsce-sign"],async I=>L(I),O))),this.a}async verify(L,O,I){let C;try{C=await this.b()}catch{return!1}return C.verify(L,O,I)}}e.$bp=N}),define(oe[98],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uVb=e.RecommendationsNotificationResult=e.$tVb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$tVb=A;var L;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$uVb=(0,D.$Nh)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,9,160,4,6,23]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,C.$Nh)("fileService");function E(W){return W.create===!0}e.$0j=E;var $;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function p(W){return!!(W.capabilities&2)}e.$$j=p;function w(W){return!!(W.capabilities&8)}e.$_j=w;function h(W){return!!(W.capabilities&131072)}e.$ak=h;function l(W){return!!(W.capabilities&4)}e.$bk=l;function u(W){return!!(W.capabilities&16)}e.$ck=u;function b(W){return p(W)?!!(W.capabilities&16384):!1}e.$dk=b;function k(W){return p(W)?!!(W.capabilities&32768):!1}e.$ek=k;function t(W){return!!(W.capabilities&65536)}e.$fk=t;function a(W){return!!(W.capabilities&2048)}e.$gk=a;var s;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(ee,ne){const re=new n(ee.toString(),ne);return o(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.$hk=n;function i(W,ee){return n.create(W,ee)}e.$ik=i;function r(W){return W||i((0,I.localize)(0,null),s.Unknown)}e.$jk=r;function o(W,ee){return W.name=ee?`${ee} (FileSystemError)`:"FileSystemError",W}e.$kk=o;function v(W){if(!W)return s.Unknown;if(W instanceof n)return W.code;const ee=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ee)return s.Unknown;switch(ee[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$lk=v;function y(W){if(W instanceof U)return W.fileOperationResult;switch(v(W)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$mk=y;var f;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class m{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.$nk=m;var j;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class M{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const X of ee){const B=re.get(X.type);switch(B?B.push([X.resource,X]):re.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,B]of re)switch(X){case 1:this.a=D.$Th.forUris(()=>ne),this.a.fill(B);break;case 0:this.b=D.$Th.forUris(()=>ne),this.b.fill(B);break;case 2:this.c=D.$Th.forUris(()=>ne),this.c.fill(B);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...re){if(!ee)return!1;const X=re.length>0;return!!((!X||re.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!X||re.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!X||re.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=M;function T(W,ee,ne){return!W||!ee||W===ee||ee.length>W.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,A.$2e)(W,ee):W.indexOf(ee)===0)}e.$pk=T;class U extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.$qk=U;class q extends U{constructor(ee,ne,re,X){super(ee,ne,X),this.fileOperationResult=ne,this.size=re}}e.$rk=q;class _ extends U{constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.$sk=_;var K;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var Y;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Ak="";function G(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.$Bk=G;async function Q(W,ee){if(!ee.hasProvider(O.URI.from({scheme:W.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===W.scheme&&X.added&&(re.dispose(),ne())})})}e.$Ck=Q;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ee){return(0,L.$Bf)(ee)||(ee=0),ee<H.KB?(0,I.localize)(1,null,ee.toFixed(0)):ee<H.MB?(0,I.localize)(2,null,(ee/H.KB).toFixed(2)):ee<H.GB?(0,I.localize)(3,null,(ee/H.MB).toFixed(2)):ee<H.TB?(0,I.localize)(4,null,(ee/H.GB).toFixed(2)):(0,I.localize)(5,null,(ee/H.TB).toFixed(2))}}e.$Dk=H;function V(W){const ee=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*H.MB:ee?10*H.MB:d.$p?50*H.MB:1024*H.MB}e.$Ek=V});var x=this&&this.__param||function(te,e){return function(D,N){e(D,N,te)}};define(oe[189],ae([0,1,69,46,11]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0;let L=class{constructor(I){this.a=I}async checksum(I){const C=(await this.a.readFileStream(I)).value;return new Promise((d,P)=>{const E=(0,D.createHash)("md5");(0,N.$5d)(C,{onData:$=>E.update($.buffer),onError:$=>P($),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$q8b=L,e.$q8b=L=ye([x(0,A.$9j)],L)}),define(oe[190],ae([0,1,15,38,8,3,2,46,9,32,11]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN="localFilesystem";class E extends O.$Rc{constructor(c,g){super(),this.a=c,this.b=g,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Md),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Md),this.onDidWatchError=this.g.event,this.h=(0,d.$dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,g){const{buffer:p}=await this.a.call("readFile",[c,g]);return p}readFileStream(c,g,p){const w=(0,I.$1d)(l=>D.$ae.concat(l.map(u=>D.$ae.wrap(u))).buffer),h=new O.$Qc;return h.add(this.a.listen("readFileStream",[c,g])(l=>{if(l instanceof D.$ae)w.write(l.buffer);else{if(l==="end")w.end();else{let u;if(l instanceof Error)u=l;else{const b=l;u=(0,P.$ik)(b.message??(0,N.$yi)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}w.error(u),w.end()}h.dispose()}})),h.add(p.onCancellationRequested(()=>{w.error((0,A.$5)()),w.end(),h.dispose()})),w}writeFile(c,g,p){return this.a.call("writeFile",[c,D.$ae.wrap(g),p])}open(c,g){return this.a.call("open",[c,g])}close(c){return this.a.call("close",[c])}async read(c,g,p,w,h){const[l,u]=await this.a.call("read",[c,g,h]);return p.set(l.buffer.slice(0,u),w),u}write(c,g,p,w,h){return this.a.call("write",[c,g,D.$ae.wrap(p),w,h])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,g){return this.a.call("delete",[c,g])}rename(c,g,p){return this.a.call("rename",[c,g,p])}copy(c,g,p){return this.a.call("copy",[c,g,p])}cloneFile(c,g){return this.a.call("cloneFile",[c,g])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const g=c;this.f.fire(g.map(p=>({resource:C.URI.revive(p.resource),type:p.type})))}else{const g=c;this.g.fire(g)}}))}watch(c,g){const p=(0,d.$dg)();return this.a.call("watch",[this.h,p,c,g]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$eN=E}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;async function O(P,E,$,c,g,p){let w;try{await I(P,E,$,c,g,p)}catch(h){w=h}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&$.error(w),$.end()}}e.$Ip=O;async function I(P,E,$,c,g,p){C(p);const w=await P.open(E,{create:!1});try{C(p);let h=0,l=0,u=g&&typeof g.length=="number"?g.length:void 0,b=D.$ae.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),k=g&&typeof g.position=="number"?g.position:0,t=0;do l=await P.read(w,k,b.buffer,t,b.byteLength-t),k+=l,t+=l,h+=l,typeof u=="number"&&(u-=l),t===b.byteLength&&(await $.write(c(b)),b=D.$ae.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),t=0);while(l>0&&(typeof u!="number"||u>0)&&C(p)&&d(h,g));if(t>0){let a=t;typeof u=="number"&&(a=Math.min(t,u)),$.write(c(b.slice(0,a)))}}catch(h){throw(0,L.$jk)(h)}finally{await P.close(w)}}function C(P){if(P.isCancellationRequested)throw(0,N.$5)();return!0}function d(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,L.$ik)((0,A.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,91,2,16,6,9,11]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=void 0;function C(h){return h.recursive===!0}e.$Kp=C;class d extends N.$Rc{static{this.a=5}constructor(l,u,b,k){super(),this.h=l,this.j=u,this.m=b,this.n=k,this.c=this.B(new N.$Sc),this.f=void 0,this.g=0}s(){const l=new N.$Qc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(u=>this.h(u))),l.add(this.b.onDidLogMessage(u=>this.j(u))),l.add(this.b.onDidError(u=>this.t(u)))}t(l){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lp=d;class P extends d{constructor(l,u,b){super(l,u,b,{type:"node.js",restartOnError:!1})}}e.$Mp=P;class E extends d{constructor(l,u,b){super(l,u,b,{type:"universal",restartOnError:!0})}}e.$Np=E;function $(h){return h.map(l=>({type:l.type,resource:O.URI.revive(l.resource)}))}e.$Op=$;function c(h){const l=new w;for(const u of h)l.processEvent(u);return l.coalesce()}e.$Pp=c;function g(h,l){return typeof l=="string"&&!l.startsWith(D.$qj)&&!(0,A.$hc)(l)?{base:h,pattern:l}:l}e.$Qp=g;function p(h,l){const u=[];for(const b of l)u.push((0,D.$uj)(g(h,b)));return u}e.$Rp=p;class w{constructor(){this.a=new Set,this.b=new Map}c(l){return L.$l?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const u=this.b.get(this.c(l));let b=!1;if(u){const k=u.type,t=l.type;u.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?b=!0:k===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(u)):k===2&&t===1?u.type=0:k===1&&t===0||(u.type=t)}else b=!0;b&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],u=[];return Array.from(this.a).filter(b=>b.type!==2?(l.push(b),!1):!0).sort((b,k)=>b.resource.fsPath.length-k.resource.fsPath.length).filter(b=>u.some(k=>(0,I.$pk)(b.resource.fsPath,k,!L.$l))?!1:(u.push(b.resource.fsPath),!0)).concat(l)}}}),define(oe[191],ae([0,1,52,5,26,48,2,88,16,6,9,144,31,54]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class g extends O.$Rc{static{this.a=100}static{this.b=75}constructor(h,l,u,b){super(),this.m=h,this.n=l,this.r=u,this.s=b,this.c=this.B(new N.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},k=>this.n(k))),this.f=this.B(new N.$7g(k=>this.z(k),g.b)),this.g=(0,c.$Rp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,c.$Rp)(this.m.path,this.m.includes):void 0,this.j=new A.$Wd,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await $.Promises.stat(h);this.B(await this.w(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let l=h.path;try{l=await $.Promises.realpath(h.path),h.path===l&&(l=await(0,E.$2p)(h.path)??h.path),h.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async w(h,l){if(d.$k&&(0,L.$Wf)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const u=new A.$Wd(this.j.token),b=new O.$Qc;try{const k=(0,C.$mc)(h),t=(0,D.watch)(h);b.add((0,O.$Pc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${h}'`);const a=new Set;if(l)try{for(const n of await $.Promises.readdir(h))a.add(n)}catch(n){this.D(n)}const s=new Map;b.add((0,O.$Pc)(()=>{for(const[,n]of s)n.dispose();s.clear()})),t.on("error",(n,i)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),t.on("change",(n,i)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${n}"] ${i}`);let r="";if(i&&(r=i.toString(),d.$k&&(r=(0,I.$kl)(r))),!(!r||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){s.get(r)?.dispose();const o=setTimeout(async()=>{if(s.delete(r),r===k&&!await $.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.C((0,C.$ic)(h,r));if(u.token.isCancellationRequested)return;let y;v?a.has(r)?y=0:(y=1,a.add(r)):(a.delete(r),y=2),this.y({resource:P.URI.file((0,C.$ic)(this.m.path,r)),type:y})},g.a);s.set(r,(0,O.$Pc)(()=>clearTimeout(o)))}else{let o;a.has(r)?o=0:(o=1,a.add(r)),this.y({resource:P.URI.file((0,C.$ic)(this.m.path,r)),type:o})}else if(n==="rename"||r!==k){const o=setTimeout(async()=>{const v=await $.Promises.exists(h);u.token.isCancellationRequested||(v?(this.y({resource:P.URI.file(this.m.path),type:0},!0),b.add(await this.w(h,!1))):(this.y({resource:P.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},g.a);b.clear(),b.add((0,O.$Pc)(()=>clearTimeout(o)))}else this.y({resource:P.URI.file(this.m.path),type:0},!0)})}catch(k){await $.Promises.exists(h)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${k.toString()})`)}return(0,O.$Pc)(()=>{u.dispose(!0),b.dispose()})}y(h,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!l&&this.g.some(u=>u(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(u=>u(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const l=(0,c.$Pp)(h);if(l.length>0){if(this.s)for(const b of l)this.G(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(d.$l)return $.Promises.exists(h);try{const l=(0,C.$mc)(h);return(await $.Promises.readdir((0,C.$lc)(h))).some(b=>b===l)}catch(l){return this.G(l),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$5p=g;async function p(w,h,l,u,b=512){const k=await $.Promises.open(w,"r"),t=Buffer.allocUnsafe(b),a=new A.$Wd(u);let s,n=!1;const i={path:w,excludes:[],recursive:!1},r=new g(i,o=>{(async()=>{for(const{type:v}of o)if(v===0){if(n)return;n=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:y}=await $.Promises.read(k,t,0,b,null);if(!y||a.token.isCancellationRequested)break;h(t.slice(0,y))}}catch(y){s=new Error(y),a.dispose(!0)}finally{n=!1}}})()});return await r.ready,l(),new Promise((o,v)=>{a.token.onCancellationRequested(async()=>{r.dispose();try{await $.Promises.close(k)}catch(y){s=new Error(y)}s?v(s):o()})})}e.$6p=p}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class I extends A.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Md),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.j(d),E=P.filter(c=>{const g=this.c.get(c.path);return g?!(0,N.$yj)(g.request.excludes,c.excludes)||!(0,N.$yj)(g.request.includes,c.includes):!0}),$=Array.from(this.c.values()).filter(({request:c})=>!P.find(g=>g.path===c.path&&(0,N.$yj)(g.excludes,c.excludes)&&(0,N.$yj)(g.includes,c.includes))).map(({request:c})=>c.path);E.length&&this.m(`Request to start watching: ${E.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const c of $)this.h(c);for(const c of E)this.g(c)}g(d){const P=new O.$5p(d,$=>this.a.fire($),$=>this.b.fire($),this.f),E={request:d,instance:P};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}j(d){const P=new Map;for(const E of d){const $=L.$l?E.path:E.path.toLowerCase();P.set($,E)}return Array.from(P.values())}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$7p=I}),define(oe[193],ae([0,1,54,192]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class A extends D.$Mp{constructor(O,I,C){super(O,I,C),this.s()}r(O){return O.add(new N.$7p)}}e.$8p=A}),define(oe[194],ae([0,1,23,42,93,54]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class O extends L.$Np{constructor(C,d,P){super(C,d,P),this.s()}r(C){const d=C.add(new A.$Yp(D.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(d.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$uh)(d.getChannel("watcher")))}}e.$Zp=O}),define(oe[70],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class D{constructor(...A){this.a=new Map;for(const[L,O]of A)this.set(L,O)}set(A,L){const O=this.a.get(A);return this.a.set(A,L),O}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Lh=D}),define(oe[195],ae([0,1,5,8,2,68,186,4,70,87]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const P=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class ${constructor(w=new C.$Lh,h=!1,l,u=P){this.f=w,this.g=h,this.h=l,this.i=u,this.o=new Set,this.f.set(I.$Mh,this),this._globalGraph=u?l?._globalGraph??new O.$$p(b=>b):void 0}createChild(w){return new $(w,this.g,this,this.i)}invokeFunction(w,...h){const l=g.traceInvocation(this.i,w);let u=!1;try{return w({get:k=>{if(u)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(k,l);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...h)}finally{u=!0,l.stop()}}createInstance(w,...h){let l,u;return w instanceof L.$Kh?(l=g.traceCreation(this.i,w.ctor),u=this.j(w.ctor,w.staticArguments.concat(h),l)):(l=g.traceCreation(this.i,w),u=this.j(w,h,l)),l.stop(),u}j(w,h=[],l){const u=I._util.getServiceDependencies(w).sort((t,a)=>t.index-a.index),b=[];for(const t of u){const a=this.m(t.id,l);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const k=u.length>0?u[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${w.name} at position ${k+1} conflicts with ${h.length} static arguments`);const t=k-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,k)}return Reflect.construct(w,h.concat(b))}k(w,h){if(this.f.get(w)instanceof L.$Kh)this.f.set(w,h);else if(this.h)this.h.k(w,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const h=this.f.get(w);return!h&&this.h?this.h.l(w):h}m(w,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const l=this.l(w);return l instanceof L.$Kh?this.q(w,l,h.branch(w,!0)):(h.branch(w,!1),l)}q(w,h,l){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,h,l)}finally{this.o.delete(w)}}r(w,h,l){const u=new O.$$p(t=>t.id.toString());let b=0;const k=[{id:w,desc:h,_trace:l}];for(;k.length;){const t=k.pop();if(u.lookupOrInsertNode(t),b++>1e3)throw new E(u);for(const a of I._util.getServiceDependencies(t.desc.ctor)){const s=this.l(a.id);if(s||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),s instanceof L.$Kh){const n={id:a.id,desc:s,_trace:t._trace.branch(a.id,!0)};u.insertEdge(t,n),k.push(n)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:a}of t){if(this.l(a.id)instanceof L.$Kh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}u.removeNode(a)}}return this.l(w)}s(w,h,l=[],u,b){if(this.f.get(w)instanceof L.$Kh)return this.t(w,h,l,u,b);if(this.h)return this.h.s(w,h,l,u,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(w,h,l=[],u,b){if(u){const k=new $(void 0,this.g,this,this.i);k.c=String(w);const t=new Map,a=new D.$0g(()=>{const s=k.j(h,l,b);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const o of i)r.apply(s,o)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new d.$1c,t.set(n,o)),(y,f,m)=>{const j=o.push([y,f,m]);return(0,A.$Pc)(j)}}if(n in s)return s[n];const i=a.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return a.value[n]=i,!0},getPrototypeOf(s){return h.prototype}})}else return this.j(h,l,b)}u(w,h){if(h&&console.warn(w),this.g)throw new Error(w)}}e.$_p=$;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,h){return w?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(w,h){return w?new g(1,h.name):g.c}static{this.f=0}constructor(w,h){this.type=w,this.name=h,this.g=Date.now(),this.h=[]}branch(w,h){const l=new g(3,w.toString());return this.h.push([w,h,l]),l}stop(){const w=Date.now()-this.g;g.f+=w;let h=!1;function l(b,k){const t=[],a=new Array(b+1).join("	");for(const[s,n,i]of k.h)if(n&&i){h=!0,t.push(`${a}CREATES -> ${s}`);const r=l(b+1,i);r&&t.push(r)}else t.push(`${a}uses -> ${s}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(w>2||h)&&g.all.add(u.join(`
`))}}e.$aq=g}),define(oe[71],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=void 0,e.$Z7b=(0,D.$Nh)("mainProcessService");class N{constructor(L,O){this.a=L,this.b=O}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,O){this.a.registerChannel(L,O)}}e.$17b=N}),define(oe[72],ae([0,1,26,2,6,163,29,4]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=void 0;function C(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Nq=C,e.$Oq=(0,I.$Nh)("languagePackService");let d=class extends N.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new D.$Wd;setTimeout(()=>E.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=$.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],h=C(p);return{...this.f(h,w,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(E,$,c){const g=$??E;let p;if(g!==E&&(p=`(${E})`),E.toLowerCase()===A.$w.toLowerCase()&&(p??="",p+=(0,L.localize)(0,null)),c?.installCount){p??="";const w=c.installCount;let h;w>1e6?h=`${Math.floor(w/1e5)/10}M`:w>1e3?h=`${Math.floor(w/1e3)}K`:h=String(w),p+=` $(cloud-download) ${h}`}return{id:E,label:g,description:p}}};e.$Pq=d,e.$Pq=d=ye([x(0,O.$6n)],d)}),define(oe[196],ae([0,1,2,72]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0;let A=class extends D.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$m8b=A,e.$m8b=A=ye([x(0,N.$Oq)],A)}),define(oe[7],ae([0,1,38,3,51,2,34,6,21,12,9,94,4]),function(te,e,D,N,A,L,O,I,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,$.$Nh)("logService"),e.$9i=(0,$.$Nh)("loggerService");function c(){return new Date().toISOString()}function g(y){return(0,d.$Bf)(y)}e.$0i=g;var p;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$$i=p.Info;function w(y,f,m){switch(f){case p.Trace:y.trace(m);break;case p.Debug:y.debug(m);break;case p.Info:y.info(m);break;case p.Warning:y.warn(m);break;case p.Error:y.error(m);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function h(y,f=!1){let m="";for(let j=0;j<y.length;j++){let M=y[j];if(M instanceof Error&&(M=(0,D.$yi)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}m+=(j>0?" ":"")+M}return m}class l extends L.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new N.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$aj=l;class u extends l{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...m){this.f(p.Trace)&&this.g(p.Trace,h([f,...m],!0))}debug(f,...m){this.f(p.Debug)&&this.g(p.Debug,h([f,...m]))}info(f,...m){this.f(p.Info)&&this.g(p.Info,h([f,...m]))}warn(f,...m){this.f(p.Warning)&&this.g(p.Warning,h([f,...m]))}error(f,...m){if(this.f(p.Error))if(f instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=f.stack,this.g(p.Error,h(j))}else this.g(p.Error,h([f,...m]))}flush(){}}e.$bj=u;class b extends l{constructor(f=e.$$i){super(),this.setLevel(f),this.g=!I.$j}trace(f,...m){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}debug(f,...m){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}info(f,...m){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}warn(f,...m){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...m):console.warn(`[main ${c()}]`,f,...m))}error(f,...m){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...m):console.error(`[main ${c()}]`,f,...m))}dispose(){}flush(){}}e.$cj=b;class k extends l{constructor(f=e.$$i,m=!0){super(),this.g=m,this.setLevel(f)}trace(f,...m){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...m):console.log(f,...m))}debug(f,...m){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...m):console.log(f,...m))}info(f,...m){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...m):console.log(f,...m))}warn(f,...m){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...m):console.log(f,...m))}error(f,...m){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...m):console.error(f,...m))}dispose(){}flush(){}}e.$dj=k;class t extends l{constructor(f,m=e.$$i){super(),this.g=f,this.setLevel(m)}trace(f,...m){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...m])}debug(f,...m){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...m])}info(f,...m){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...m])}warn(f,...m){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...m])}error(f,...m){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...m])}h(f){return typeof f=="string"?f:(0,D.$yi)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$ej=t;class a extends l{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const m of this.g)m.setLevel(f);super.setLevel(f)}trace(f,...m){for(const j of this.g)j.trace(f,...m)}debug(f,...m){for(const j of this.g)j.debug(f,...m)}info(f,...m){for(const j of this.g)j.info(f,...m)}warn(f,...m){for(const j of this.g)j.warn(f,...m)}error(f,...m){for(const j of this.g)j.error(f,...m)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$fj=a;class s extends L.$Rc{constructor(f,m,j){if(super(),this.h=f,this.j=m,this.b=new O.$zc,this.c=this.B(new N.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Md),this.onDidChangeVisibility=this.g.event,j)for(const M of j)this.b.set(M.resource,{logger:void 0,info:M})}m(f){return(0,d.$xf)(f)?[...this.b.values()].find(m=>m.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,m){const j=this.n(f),M=(0,d.$xf)(f)?f:m?.id??(0,A.$Bi)(j.toString()).toString(16);let T=this.b.get(j)?.logger;const U=m?.logLevel==="always"?p.Trace:m?.logLevel;T||(T=this.s(j,U??this.getLogLevel(j)??this.h,{...m,id:M}));const q={logger:T,info:{resource:j,id:M,logLevel:U,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(q.info),this.b.set(j,q),T}n(f){return(0,d.$xf)(f)?(0,C.$ug)(this.j,`${f}.log`):f}setLogLevel(f,m){if(P.URI.isUri(f)){const j=f,M=m,T=this.b.get(j);T&&M!==T.info.logLevel&&(T.info.logLevel=M===this.h?void 0:M,T.logger?.setLevel(M),this.b.set(T.info.resource,T),this.f.fire([j,M]))}else{this.h=f;for(const[j,M]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,m){const j=this.m(f);j&&m!==!j.info.hidden&&(j.info.hidden=!m,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,m]))}getLogLevel(f){let m;return f&&(m=this.b.get(f)?.info.logLevel),m??this.h}registerLogger(f){const m=this.b.get(f.resource);m?m.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const m=this.b.get(f);m&&(m.logger&&m.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=s;class n{constructor(){this.onDidChangeLogLevel=new N.$Md().event}setLevel(f){}getLevel(){return p.Info}trace(f,...m){}debug(f,...m){}info(f,...m){}warn(f,...m){}error(f,...m){}critical(f,...m){}dispose(){}flush(){}}e.$hj=n;class i extends n{}e.$ij=i;function r(y){if(y.verbose)return p.Trace;if(typeof y.logLevel=="string"){const f=v(y.logLevel.toLowerCase());if(f!==void 0)return f}return e.$$i}e.$jj=r;function o(y){switch(y){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$kj=o;function v(y){switch(y){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$lj=v,e.$mj=new E.$5i("logLevel",o(p.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,21,31,14,7]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n8b=void 0;let E=class extends A.$Rc{constructor(c,g){super(),this.a=c,this.b=g,this.B(new D.$5g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,I.$rg)(this.a.logsHome),g=(0,I.$tg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,h=(await C.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),l=h.slice(0,Math.max(0,h.length-9));l.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map(u=>C.Promises.rm((0,O.$ic)(g,u)))))}catch(c){(0,N.$Z)(c)}}};e.$n8b=E,e.$n8b=E=ye([x(0,d.$Uh),x(1,P.$8i)],E)}),define(oe[198],ae([0,1,18,5,8,3,2,16,54,7]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class P extends O.$Rc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new L.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Qg(0)),this.w=[],this.y=this.B(new N.$Qg(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:c.recursive},p=(0,D.$Tb)(this.j,g);return this.r(),(0,O.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,A.$Z)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,C.$Op)(c)),c=>this.G(c),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,C.$Kp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,C.$Kp)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:!1},p=(0,D.$Tb)(this.w,g);return this.C(),(0,O.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,A.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,C.$Op)($)),$=>this.G($),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,I.$gc)($.fsPath)}}e.$Sp=P}),define(oe[199],ae([0,1,18,5,15,26,3,51,59,2,47,23,100,21,46,159,11,99,7,8]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let b=class extends d.$Rc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Md),this.onDidFilesChange=this.X.event,this.Y=this.B(new O.$Md),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$2g)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${t}`);const s=new d.$Qc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),s.add(a.onDidChangeFile(n=>this.X.fire(new w.$ok(n,!this.S(a))))),typeof a.onDidWatchError=="function"&&s.add(a.onDidWatchError(n=>this.Y.fire(new Error(n)))),s.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,d.$Mc)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(s){a.push(s)}}),!this.h.has(t)&&await N.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&a)}listCapabilities(){return C.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,c.$yg)(t))throw new w.$qk((0,p.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const s=new u.$ab;throw s.message=(0,p.localize)(1,null,t.toString()),s}return a}async m(t){const a=await this.j(t);if((0,w.$bk)(a)||(0,w.$$j)(a)||(0,w.$ck)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,w.$bk)(a)||(0,w.$$j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(s){throw(0,w.$lk)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.$qk((0,p.localize)(2,null,this.qb(t)),1):(0,w.$jk)(s)}}async s(t,a){const s=await this.j(t),n=this.S(s),i=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,v=await s.stat(t);let y;return this.t(s,t,v,void 0,!!o,(f,m)=>(y||(y=P.$Th.forUris(()=>!n),y.set(t,!0),i&&y.fill(!0,i)),y.get(f.resource)||y.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&r?m===1:!1))}async t(t,a,s,n,i,r){const{providerExtUri:o}=this.R(t),v={resource:a,name:o.basename(a),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&w.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Bk)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&r(v,n)){try{const y=await t.readdir(a),f=await N.Promises.settled(y.map(async([m,j])=>{try{const M=o.joinPath(a,m),T=i?await t.stat(M):{type:j};return await this.t(t,M,T,y.length,i,r)}catch(M){return this.b.trace(M),null}}));v.children=(0,D.$Gb)(f)}catch(y){this.b.trace(y),v.children=[]}return v}return v}async resolveAll(t){return N.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),s=await a.stat(t);return this.t(a,t,s,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(s){return s}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new w.$qk((0,p.localize)(3,null,this.qb(t)),3,a)}async createFile(t,a=A.$ae.fromString(""),s){await this.u(t,s);const n=await this.writeFile(t,a);return this.r.fire(new w.$nk(t,0,n)),n}async writeFile(t,a,s){const n=this.ob(await this.n(t),t),{providerExtUri:i}=this.R(n);let r=s;if((0,w.$ek)(n)&&!r?.atomic){const o=n.enforceAtomicWriteFile?.(t);o&&(r={...s,atomic:o})}try{await this.w(n,t,r)||await this.U(n,i.dirname(t));let v;if((0,w.$$j)(n)&&!(a instanceof A.$ae))if((0,g.$Yd)(a)){const y=await(0,g.$6d)(a,3);y.ended?v=A.$ae.concat(y.buffer):v=y}else v=(0,g.$3d)(a,y=>A.$ae.concat(y),3);else v=a;!(0,w.$bk)(n)||(0,w.$$j)(n)&&v instanceof A.$ae||(0,w.$$j)(n)&&(0,w.$ek)(n)&&r?.atomic?await this.fb(n,t,r,v):await this.bb(n,t,r,v instanceof A.$ae?(0,A.$le)(v):v),this.r.fire(new w.$nk(t,4))}catch(o){throw new w.$qk((0,p.localize)(4,null,this.qb(t),(0,w.$jk)(o).toString()),(0,w.$mk)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.qb(a)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.qb(a)));if(!(t.capabilities&2))throw new Error((0,p.localize)(7,null,this.qb(a)));if(n)throw new Error((0,p.localize)(8,null,this.qb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&w.FileType.Directory)throw new w.$qk((0,p.localize)(9,null,this.qb(a)),0,s);if(this.pb(a,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.$Ak&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,w.$Bk)({mtime:s.mtime,size:r.size}))throw new w.$qk((0,p.localize)(10,null),3,s);return r}async readFile(t,a,s){const n=await this.m(t);return a?.atomic?this.z(n,t,a,s):this.C(n,t,a,s)}async z(t,a,s,n){return new Promise((i,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const o=await this.C(t,a,s,n);i(o)}catch(o){r(o)}})})}async C(t,a,s,n){const i=await this.D(t,a,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,A.$me)(i.value)}}async readFileStream(t,a,s){const n=await this.m(t);return this.D(n,t,a,s)}async D(t,a,s,n){const i=new L.$Wd(n);let r=s;(0,w.$dk)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...s,atomic:!0});const o=this.J(a,r).then(y=>y,y=>{throw i.dispose(!0),y});let v;try{return typeof r?.etag=="string"&&r.etag!==w.$Ak&&await o,r?.atomic&&(0,w.$dk)(t)||!((0,w.$bk)(t)||(0,w.$ck)(t))||(0,w.$$j)(t)&&r?.preferUnbuffered?v=this.I(t,a,r):(0,w.$ck)(t)?v=this.G(t,a,i.token,r):v=this.H(t,a,i.token,r),v.on("end",()=>i.dispose()),v.on("error",()=>i.dispose()),{...await o,value:v}}catch(y){throw v&&await(0,g.$4d)(v),this.F(y,a,r)}}F(t,a,s){const n=(0,p.localize)(11,null,this.qb(a),(0,w.$jk)(t).toString());return t instanceof w.$sk?new w.$sk(n,t.stat,s):t instanceof w.$rk?new w.$rk(n,t.fileOperationResult,t.size,t.options):new w.$qk(n,(0,w.$mk)(t),s)}G(t,a,s,n=Object.create(null)){const i=t.readFileStream(a,n,s);return(0,g.$0d)(i,{data:r=>r instanceof A.$ae?r:A.$ae.wrap(r),error:r=>this.F(r,a,n)},r=>A.$ae.concat(r))}H(t,a,s,n=Object.create(null)){const i=(0,A.$qe)();return(0,h.$Ip)(t,a,i,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,a,n)},s),i}I(t,a,s){const n=(0,g.$1d)(i=>A.$ae.concat(i));return(async()=>{try{let i;s?.atomic&&(0,w.$dk)(t)?i=await t.readFile(a,{atomic:!0}):i=await t.readFile(a),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.L(a,i.byteLength,s),n.end(A.$ae.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async J(t,a){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new w.$qk((0,p.localize)(12,null,this.qb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==w.$Ak&&a.etag===s.etag)throw new w.$sk((0,p.localize)(13,null),s,a);return this.L(t,s.size,a),s}L(t,a,s){if(typeof s?.limits?.size=="number"&&a>s.limits.size)throw new w.$rk((0,p.localize)(14,null,this.qb(t)),7,a,s)}async canMove(t,a,s){return this.M(t,a,"move",s)}async canCopy(t,a,s){return this.M(t,a,"copy",s)}async M(t,a,s,n){if(t.toString()!==a.toString())try{const i=s==="move"?this.ob(await this.n(t),t):await this.m(t),r=this.ob(await this.n(a),a);await this.Q(i,t,r,a,s,n)}catch(i){return i}return!0}async move(t,a,s){const n=this.ob(await this.n(t),t),i=this.ob(await this.n(a),a),r=await this.N(n,t,i,a,"move",!!s),o=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$nk(t,r==="move"?2:3,o)),o}async copy(t,a,s){const n=await this.m(t),i=this.ob(await this.n(a),a),r=await this.N(n,t,i,a,"copy",!!s),o=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$nk(t,r==="copy"?3:2,o)),o}async N(t,a,s,n,i,r){if(a.toString()===n.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:v}=await this.Q(t,a,s,n,i,r);if(o&&!v&&r&&await this.del(n,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,w.$_j)(t))await t.copy(a,n,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.P(t,y,s,n):await this.O(t,a,s,n)}return i}else return t===s?(await t.rename(a,n,{overwrite:r}),i):(await this.N(t,a,s,n,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,s,n){if((0,w.$bk)(t)&&(0,w.$bk)(s))return this.hb(t,a,s,n);if((0,w.$bk)(t)&&(0,w.$$j)(s))return this.nb(t,a,s,n);if((0,w.$$j)(t)&&(0,w.$bk)(s))return this.lb(t,a,s,n);if((0,w.$$j)(t)&&(0,w.$$j)(s))return this.jb(t,a,s,n)}async P(t,a,s,n){await s.mkdir(n),Array.isArray(a.children)&&await N.Promises.settled(a.children.map(async i=>{const r=this.R(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.P(t,await this.resolve(i.resource),s,r):this.O(t,i.resource,s,r)}))}async Q(t,a,s,n,i,r){let o=!1;if(t===s){const{providerExtUri:y,isPathCaseSensitive:f}=this.R(t);if(f||(o=y.isEqual(a,n)),o&&i==="copy")throw new Error((0,p.localize)(15,null,this.qb(a),this.qb(n)));if(!o&&y.isEqualOrParent(n,a))throw new Error((0,p.localize)(16,null,this.qb(a),this.qb(n)))}const v=await this.exists(n);if(v&&!o){if(!r)throw new w.$qk((0,p.localize)(17,null,this.qb(a),this.qb(n)),4);if(t===s){const{providerExtUri:y}=this.R(t);if(y.isEqualOrParent(a,n))throw new Error((0,p.localize)(18,null,this.qb(a),this.qb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:o}}R(t){const a=this.S(t);return{providerExtUri:a?c.$kg:c.$mg,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.ob(await this.j(t),t);await this.U(a,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new w.$nk(t,0,s)),s}async U(t,a){const s=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.qb(a)));break}catch(i){if((0,w.$lk)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(a)),a=n.dirname(a)}for(let i=s.length-1;i>=0;i--){a=n.joinPath(a,s[i]);try{await t.mkdir(a)}catch(r){if((0,w.$lk)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(s){return s}return!0}async W(t,a){const s=this.ob(await this.j(t),t),n=!!a?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.qb(t)));const i=a?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.qb(t)));if(n&&i)throw new Error((0,p.localize)(22,null,this.qb(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.pb(t,r);else throw new w.$qk((0,p.localize)(23,null,this.qb(t)),1);if(!!!a?.recursive){const v=await this.resolve(t);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,p.localize)(24,null,this.qb(t)))}return s}async del(t,a){const s=await this.W(t,a);let n=a;if((0,w.$fk)(s)&&!n?.atomic){const v=s.enforceAtomicDelete?.(t);v&&(n={...a,atomic:v})}const i=!!n?.useTrash,r=!!n?.recursive,o=n?.atomic??!1;await s.delete(t,{recursive:r,useTrash:i,atomic:o}),this.r.fire(new w.$nk(t,1))}async cloneFile(t,a){const s=await this.j(t),n=this.ob(await this.n(a),a);if(s===n&&this.R(s).providerExtUri.isEqual(t,a))return;if(s===n&&(0,w.$ak)(s))return s.cloneFile(t,a);await this.U(n,this.R(n).providerExtUri.dirname(a));const i=this.ab.queueFor(t,this.R(s).providerExtUri);return s===n&&(0,w.$_j)(s)?i.queue(()=>s.copy(t,a,{overwrite:!0})):i.queue(()=>this.O(s,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const s=new d.$Qc;let n=!1,i=()=>{n=!0};return s.add((0,d.$Pc)(()=>i())),(async()=>{try{const r=await this.$(t,a);n?(0,d.$Mc)(r):i=()=>(0,d.$Mc)(r)}catch(r){this.b.error(r)}})(),s}async $(t,a){const s=await this.j(t),n=(0,I.$Bi)([this.R(s).providerExtUri.getComparisonKey(t),a]);let i=this.Z.get(n);return i||(i={count:0,disposable:s.watch(t,a)},this.Z.set(n,i)),i.count+=1,(0,d.$Pc)(()=>{i&&(i.count--,i.count===0&&((0,d.$Mc)(i.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,d.$Mc)(t.disposable);this.Z.clear()}async bb(t,a,s,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const i=await t.open(a,{create:!0,unlock:s?.unlock??!1});try{(0,g.$Yd)(n)||(0,g.$Zd)(n)?await this.cb(t,i,n):await this.db(t,i,n)}catch(r){throw(0,w.$jk)(r)}finally{await t.close(i)}})}async cb(t,a,s){let n=0,i;if((0,g.$Zd)(s)){if(s.buffer.length>0){const r=A.$ae.concat(s.buffer);await this.eb(t,a,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,o)=>{(0,g.$5d)(i,{onData:async v=>{i.pause();try{await this.eb(t,a,v,v.byteLength,n,0)}catch(y){return o(y)}n+=v.byteLength,setTimeout(()=>i.resume())},onError:v=>o(v),onEnd:()=>r()})})}async db(t,a,s){let n=0,i;for(;(i=s.read())!==null;)await this.eb(t,a,i,i.byteLength,n,0),n+=i.byteLength}async eb(t,a,s,n,i,r){let o=0;for(;o<n;){const v=await t.write(a,i+o,s.buffer,r+o,n-o);o+=v}}async fb(t,a,s,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.gb(t,a,s,n))}async gb(t,a,s,n){let i;n instanceof A.$ae?i=n:(0,g.$Yd)(n)?i=await(0,A.$me)(n):(0,g.$Zd)(n)?i=await(0,A.$ne)(n):i=(0,A.$ke)(n),await t.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async hb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.ib(t,a,s,n))}async ib(t,a,s,n){let i,r;try{i=await t.open(a,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const o=A.$ae.alloc(this.a);let v=0,y=0,f=0;do f=await t.read(i,v,o.buffer,y,o.byteLength-y),await this.eb(s,r,o,f,v,y),v+=f,y+=f,y===o.byteLength&&(y=0);while(f>0)}catch(o){throw(0,w.$jk)(o)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async jb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.kb(t,a,s,n))}async kb(t,a,s,n){return s.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.mb(t,a,s,n))}async mb(t,a,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.eb(s,i,A.$ae.wrap(r),r.byteLength,0,0)}catch(r){throw(0,w.$jk)(r)}finally{await s.close(i)}}async nb(t,a,s,n){const i=await(0,A.$me)(this.H(t,a,L.CancellationToken.None));await this.fb(s,n,void 0,i)}ob(t,a){if(t.capabilities&2048)throw new w.$qk((0,p.localize)(25,null,this.qb(a)),6);return t}pb(t,a){if((a.permissions??0)&w.FilePermission.Readonly)throw new w.$qk((0,p.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$Jp=b,e.$Jp=b=ye([x(0,l.$8i)],b)}),define(oe[200],ae([0,1,52,271,5,34,15,3,48,2,16,6,21,46,31,162,11,99,198,38,194,193]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.$yi)(a)}`)}})();class t extends l.$Sp{static{this.I=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=I.Event.None,this.N=new L.$zc(i=>$.$lg.getComparisonKey(i)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:i}=await g.SymlinkSupport.stat(this.H(s));return{type:this.M(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:w.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await g.Promises.readdir(this.H(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,$.$ug)(s,r.name))).type:o=this.M(r),i.push([r.name,o])}catch(o){this.a.trace(o)}})),i}catch(n){throw this.fb(n)}}M(s,n){let i;return n?.dangling?i=w.FileType.Unknown:s.isFile()?i=w.FileType.File:s.isDirectory()?i=w.FileType.Directory:i=w.FileType.Unknown,n&&(i|=w.FileType.SymbolicLink),i}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new A.$Rg;return this.N.set(s,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),i=await this.O(s));const r=this.H(s);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{i?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,n,i){const r=(0,c.$1d)(o=>O.$ae.concat(o.map(v=>O.$ae.wrap(v))).buffer);return(0,h.$Ip)(this,s,r,o=>o.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,$.$ug)((0,$.$tg)(s),`${(0,$.$rg)(s)}${i.atomic.postfix}`),n,i):this.S(s,n,i)}async Q(s){try{const n=this.H(s),{symbolicLink:i}=await g.SymlinkSupport.stat(n);if(i)return!1}catch{}return!0}async R(s,n,i,r){const o=new d.$Qc;try{o.add(await this.O(s)),o.add(await this.O(n)),await this.S(n,i,r,!0);try{await this.rename(n,s,{overwrite:!0})}catch(v){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(s,n,i,r){let o;try{const v=this.H(s);if(!i.create||!i.overwrite){if(await g.Promises.exists(v)){if(!i.overwrite)throw(0,w.$ik)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,w.$ik)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:i.unlock},r),await this.write(o,0,n,0,n.byteLength)}catch(v){throw await this.gb(s,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,n,i){const r=this.H(s);let o;(0,w.$0j)(n)&&!i&&(o=await this.O(s));let v;try{if((0,w.$0j)(n)&&n.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(r);f.mode&128||await g.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let y;if((0,w.$0j)(n)){if(E.$j)try{await g.Promises.truncate(r,0),y="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}y||(y="w")}else y="r";v=await g.Promises.open(r,y)}catch(y){throw o?.dispose(),(0,w.$0j)(n)?await this.gb(s,y):this.fb(y)}if(this.U.set(v,0),(0,w.$0j)(n)&&this.X.set(v,s),o){const y=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(s){const n=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await g.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(s)}catch(i){throw this.fb(i)}finally{n&&(this.W.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,o){const v=this.Z(s,n);let y=null;try{y=(await g.Promises.read(s,i,r,o,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(s,v,y)}return y}Z(s,n){return n===this.U.get(s)?null:n}$(s,n,i){const r=this.U.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.U.set(s,r+i):this.U.delete(s)))}async write(s,n,i,r,o){return(0,A.$$g)(()=>this.ab(s,n,i,r,o),100,3)}async ab(s,n,i,r,o){const v=this.Z(s,n);let y=null;try{y=(await g.Promises.write(s,i,r,o,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(s),f)}finally{this.$(s,v,y)}return y}async mkdir(s){try{await g.Promises.mkdir(this.H(s))}catch(n){throw this.fb(n)}}async delete(s,n){try{const i=this.H(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,P.$ic)((0,P.$lc)(i),`${(0,P.$mc)(i)}${n.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:y}=await g.SymlinkSupport.stat(i);o=v.isDirectory()&&!y}catch{}if(o)await g.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.fb(i)}}async rename(s,n,i){const r=this.H(s),o=this.H(n);if(r!==o)try{await this.bb(s,n,"move",i.overwrite),await g.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async copy(s,n,i){const r=this.H(s),o=this.H(n);if(r!==o)try{await this.bb(s,n,"copy",i.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async bb(s,n,i,r){const o=this.H(s),v=this.H(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,C.$Vf)(o,v,!0)),y){if(i==="copy")throw(0,w.$ik)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const m=await this.L(s);if(!m)throw(0,w.$ik)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(n);if(j){if(!r)throw(0,w.$ik)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);m.type&w.FileType.File&&j.type&w.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.cb(s,n,!1)}async cb(s,n,i){const r=this.H(s),o=this.H(n),v=!!(this.capabilities&1024);if((0,C.$Vf)(r,o,!v))return;const y=new d.$Qc;try{y.add(await this.O(s)),y.add(await this.O(n)),i&&await g.Promises.mkdir((0,P.$lc)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(f){if(f.code==="ENOENT"&&!i)return this.cb(s,n,!0);throw this.fb(f)}finally{y.dispose()}}t(s,n,i){return new b.$Zp(r=>s(r),r=>n(r),i)}F(s,n,i){return new k.$8p(r=>s(r),r=>n(r),i)}fb(s){if(s instanceof w.$hk)return s;let n=s,i;switch(s.code){case"ENOENT":i=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=w.FileSystemProviderErrorCode.Unknown;break;default:i=w.FileSystemProviderErrorCode.Unknown}return(0,w.$ik)(n,i)}async gb(s,n){let i=this.fb(n);if(s&&i.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(s));r.mode&128||(i=(0,w.$ik)(n,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$9p=t}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=e.$P8b=void 0,e.$P8b=(0,A.$Nh)("sharedProcessLifecycleService");let O=class extends N.$Rc{constructor(C){super(),this.b=C,this.a=this.B(new D.$Md),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Q8b=O,e.$Q8b=O=ye([x(0,L.$8i)],O)}),define(oe[201],ae([0,1,9,3,7,2]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0;class O extends A.$gj{constructor(E,$,c,g,p){super($,c,g),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(w=>{(0,A.$0i)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",E)(([w,h])=>super.setVisibility(D.URI.revive(w),h))),this.B(p.listen("onDidChangeLoggers",E)(({added:w,removed:h})=>{for(const l of w)super.registerLogger({...l,resource:D.URI.revive(l.resource)});for(const l of h)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new A.$ej({log:(E,$)=>{this.t.call("consoleLog",[E,$])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,$){super.setLogLevel(E,$),this.t.call("setLogLevel",[E,$])}setVisibility(E,$){super.setVisibility(E,$),this.t.call("setVisibility",[this.n(E),$])}s(E,$,c){return new I(this.t,E,$,c,this.r)}static setLogLevel(E,$,c){return E.call("setLogLevel",[$,c])}}e.$7q=O;class I extends A.$bj{constructor(E,$,c,g,p){super(g?.logLevel==="always"),this.r=E,this.s=$,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[$,g,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,$){const c=[[E,$]];this.m?this.u(c):this.n.push(...c)}u(E){this.r.call("log",[this.s,E])}}class C{constructor(E,$){this.a=E,this.b=$}listen(E,$){const c=this.b(E);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,c)),removed:[...g.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[c.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,A.$0i)(g)?g:[c.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${$}`)}async call(E,$,c){const g=this.b(E);switch($){case"setLogLevel":return(0,A.$0i)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${$}`)}c(E,$){return{...E,resource:$.transformOutgoingURI(E.resource)}}}e.$8q=C;class d extends L.$Rc{constructor(E,$){super(),$.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(c=>$.call("setLogLevel",[c]))),$.call("getRegisteredLoggers").then(c=>{for(const g of c)E.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B($.listen("onDidChangeVisibility")(([c,g])=>E.setVisibility(D.URI.revive(c),g))),this.B($.listen("onDidChangeLoggers")(({added:c,removed:g})=>{for(const p of c)E.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of g)E.deregisterLogger(p.resource)}))}}e.$9q=d}),define(oe[202],ae([0,1,2,7]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class A extends D.$Rc{constructor(O,I=[]){super(),this.a=new N.$fj([O,...I]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$vN=A}),define(oe[55],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0,e.$J6b=(0,D.$Nh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=void 0,e.$dn=(0,L.$Nh)("policy");class O extends A.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(E,[$,c])=>({...E,[$]:c}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[P,E])=>({...d,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$en=O;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$fn=I}),define(oe[203],ae([0,1,3,2,56]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=void 0;class L{constructor(C){this.b=C,this.a=new N.$Qc}listen(C,d){switch(d){case"onDidChange":return D.Event.map(this.b.onDidChange,P=>P.reduce((E,$)=>({...E,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(C,d,P){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$x7b=L;class O extends A.$en{constructor(C,d){super(),this.a=d;for(const P in C){const{definition:E,value:$}=C[P];this.f[P]=E,$!==void 0&&this.g.set(P,$)}this.a.listen("onDidChange")(P=>{for(const E in P){const $=P[E];$===null?this.g.delete(E):this.g.set(E,$)}this.h.fire(Object.keys(P))})}async j(C){const d=await this.a.call("updatePolicyDefinitions",C);for(const P in d)this.g.set(P,d[P])}}e.$y7b=O}),define(oe[102],ae([0,1,6,37]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const L=D.$h.vscode.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,D.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=void 0;let d=class extends A.$Rc{constructor(E,$,c){super(),this.b=$,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new D.$5g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),c=(0,L.$lc)(E),g=(0,L.$mc)(E),p=await O.Promises.readdir(c);await Promise.all(p.map(async w=>{if(w===g)return;const h=(0,L.$ic)(c,w),l=await O.Promises.stat(h);if(l.isDirectory()&&$-l.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(h)}))}catch($){(0,N.$Z)($)}}};e.$k8b=d,e.$k8b=d=ye([x(1,C.$nj),x(2,I.$8i)],d)}),define(oe[205],ae([0,1,5,8,2,16,31,14,7,24]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;let P=class extends A.$Rc{constructor($,c,g){super(),this.b=$,this.c=c,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$5g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,L.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const l of Object.keys(c)){const u=c[l];$[`${u.hash}.${l}`]=!0}const g=(0,L.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const w=await O.Promises.readdir(g);for(const l of w){if($[l]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${l}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${l}`),await O.Promises.rm((0,L.$ic)(g,l))}const h=Date.now();for(const l of Object.keys($)){const u=(0,L.$ic)(g,l),b=await O.Promises.readdir(u);for(const k of b){if(k==="tcf.json")continue;const t=(0,L.$ic)(u,k),a=await O.Promises.stat(t);a.isDirectory()&&h-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$ic)(l,k)}`),await O.Promises.rm(t))}}}catch($){(0,N.$Z)($)}}};e.$l8b=P,e.$l8b=P=ye([x(0,I.$Vh),x(1,C.$8i),x(2,d.$nj)],P)}),define(oe[206],ae([0,1,16,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$PE=void 0,e.$PE=(0,N.$Nh)("IV8InspectProfilingService");var A;(function(L){function O(C){return!!(C.samples&&C.timeDeltas)}L.isValidProfile=O;function I(C,d="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,D.$hc)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,D.$ic)(d,(0,D.$mc)(P.callFrame.url)));return C}L.rewriteAbsolutePaths=I})(A||(e.Utils=A={}))}),define(oe[207],ae([0,1,32]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const I=await(await new Promise((d,P)=>{te(["v8-inspect-profiler"],d,P)})).startProfiling({port:L.port,checkForPaused:!0}),C=(0,D.$dg)();return this.a.set(C,I),C}async stopProfiling(L){const O=this.a.get(L);if(!O)throw new Error(`UNKNOWN session '${L}'`);const I=await O.stop();return this.a.delete(L),I.profile}}e.$F8b=N}),define(oe[40],ae([0,1,127,12]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class A{constructor(){this.a=new Map}add(O,I){D.ok(N.$xf(O)),D.ok(N.$zf(I)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$bn=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this.b=new D.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,d){this.a[A(C)]=d,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new L;N.$bn.add(e.$cn.JSONContribution,O)}),define(oe[49],ae([0,1,18,3,12,149,19,103,40]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var d;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$gn={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const E=C.$bn.as(I.$cn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$Md,this.onDidSchemaChange=this.i.event,this.j=new N.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const s=new Set;this.n(t,a,s),E.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const a=new Set;this.o(t,a),E.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const s=new Set;this.o(a,s),this.n(t,!1,s),E.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(a.add(r),e.$qn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(i)for(const j of Object.keys(n[r]))v.set(j,i);const y={...o?.value||{},...n[r]};this.a.set(r,{source:i,value:y,valuesSources:v});const f=(0,O.$ri)(r),m={type:"object",default:y,description:L.localize(1,null,f),$ref:e.$nn,defaultDefaultValue:y,source:A.$xf(i)?void 0:i,defaultValueSource:i};s.push(...p(r)),this.d[r]=m,this.b.properties[r]=m}else{this.a.set(r,{value:n[r],source:i});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(s)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.a.get(i),o=A.$xf(n)?n:n?.id,v=A.$xf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(i),this.a.delete(i),e.$qn.test(i))delete this.d[i],delete this.b.properties[i];else{const y=this.d[i];y&&(this.w(i,y),this.r(i,y))}}this.u()}deltaConfiguration(t){let a=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,s){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,a){const s=n=>{if(n.properties)for(const i in n.properties){a.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,a=!0,s,n,i=3,r){i=A.$Gf(t.scope)?i:t.scope;const o=t.properties;if(o)for(const y in o){const f=o[y];if(a&&u(y,f)){delete o[y];continue}if(f.source=s,f.defaultDefaultValue=o[y].default,this.w(y,f),e.$qn.test(y)?f.scope=void 0:(f.scope=A.$Gf(f.scope)?i:f.scope,f.restricted=A.$Gf(f.restricted)?!!n?.includes(y):f.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.f[y]=o[y],delete o[y];continue}else this.d[y]=o[y],o[y].policy?.name&&this.e.set(o[y].policy.name,y);!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),r.add(y)}const v=t.allOf;if(v)for(const y of v)this.p(y,a,s,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$hn.properties[t]=a,a.scope){case 1:e.$in.properties[t]=a;break;case 2:e.$jn.properties[t]=a;break;case 6:e.$kn.properties[t]=a;break;case 3:e.$ln.properties[t]=a;break;case 4:e.$mn.properties[t]=a;break;case 5:e.$mn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$hn.properties[t],a.scope){case 1:delete e.$in.properties[t];break;case 2:delete e.$jn.properties[t];break;case 6:delete e.$kn.properties[t];break;case 3:delete e.$ln.properties[t];break;case 4:case 5:delete e.$mn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$nn};this.w(a,s),e.$hn.properties[a]=s,e.$in.properties[a]=s,e.$jn.properties[a]=s,e.$kn.properties[a]=s,e.$ln.properties[a]=s,e.$mn.properties[a]=s}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=t,e.$in.patternProperties[e.$pn]=t,e.$jn.patternProperties[e.$pn]=t,e.$kn.patternProperties[e.$pn]=t,e.$ln.patternProperties[e.$pn]=t,e.$mn.patternProperties[e.$pn]=t,this.i.fire()}w(t,a){const s=this.a.get(t);let n=s?.value,i=s?.source;A.$Ef(n)&&(n=a.defaultDefaultValue,i=void 0),A.$Ef(n)&&(n=h(a.type)),a.default=n,a.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.$pn=`^(${c})+$`,e.$qn=new RegExp(e.$pn);function p(k){const t=[];if(e.$qn.test(k)){let a=g.exec(k);for(;a?.length;){const s=a[1].trim();s&&t.push(s),a=g.exec(k)}}return(0,D.$Lb)(t)}e.$rn=p;function w(k){return k.reduce((t,a)=>`${t}[${a}]`,"")}e.$sn=w;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=h;const l=new $;C.$bn.add(e.$gn.Configuration,l);function u(k,t){return k.trim()?e.$qn.test(k)?L.localize(7,null,k):l.getConfigurationProperties()[k]!==void 0?L.localize(8,null,k):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,k,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$un=u;function b(){const k=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))k.push([a,t[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$vn=b}),define(oe[73],ae([0,1,18,3,35,2,34,30,12,9,19,49,40]),function(te,e,D,N,A,L,O,I,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function c(a){return Object.isFrozen(a)?a:I.$3m(a)}class g{constructor(s={},n=[],i=[],r){this.b=s,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof g)return n;const i=new p("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$pi)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,o=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:o}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,P.$pi)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return D.$Lb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return D.$Lb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=I.$2m(this.contents),i=I.$2m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of s)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(n,v.contents);for(const y of v.overrides){const[f]=i.filter(m=>D.$tb(m.identifiers,y.identifiers));f?(this.h(f.contents,y.contents),f.keys.push(...y.keys),f.keys=D.$Lb(f.keys)):i.push(I.$2m(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new g(n,r,i,o.every(v=>v instanceof g)?void 0:o)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r];const v=n[r];v&&(typeof o=="object"&&typeof v=="object"?(o=I.$2m(o),this.h(o,v)):o=v),i[r]=o}return new g(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&C.$zf(s[i])&&C.$zf(n[i])){this.h(s[i],n[i]);continue}s[i]=I.$2m(n[i])}}i(s){let n=null,i=null;const r=o=>{o&&(i?this.h(i,o):i=I.$2m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===s?n=o.contents:o.identifiers.includes(s)&&r(o.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,P.$oi)(this.contents,s),E.$qn.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>D.$tb(i.identifiers,(0,E.$rn)(s))),1))}j(s,n,i){(0,P.$ni)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),E.$qn.test(s)&&this.overrides.push({identifiers:(0,E.$rn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$mi)(this.contents[s],r=>console.error(r))})}}e.$wn=g;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!C.$Gf(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:r,overrides:o,restricted:v,hasExcludedProperties:y}=this.h(s,n);this.b=new g(i,r,o,y?[s]:void 0),this.c=v||[]}g(s){let n={},i=null,r=[];const o=[],v=[];function y(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}const f={onObjectBegin:()=>{const m={};y(m),o.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const m=[];y(m),o.push(r),r=m,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:y,onError:(m,j,M)=>{v.push({error:m,offset:j,length:M})}};if(s)try{A.$Ym(s,f),n=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return n}h(s,n){const i=$.$bn.as(E.$gn.Configuration).getConfigurationProperties(),r=this.i(s,i,!0,n);s=r.raw;const o=(0,P.$mi)(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(s),y=this.j(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:o,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,i,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:o};const v={},y=[];for(const f in s)if(E.$qn.test(f)&&i){const m=this.i(s[f],n,!1,r);v[f]=m.raw,o=o||m.hasExcludedProperties,y.push(...m.restricted)}else{const m=n[f],j=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&y.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&m?.restricted))?v[f]=s[f]:o=!0}return{raw:v,restricted:y,hasExcludedProperties:o}}j(s,n){const i=[];for(const r of Object.keys(s))if(E.$qn.test(r)){const o={};for(const v in s[r])o[v]=s[r][v];i.push({identifiers:(0,E.$rn)(r),keys:Object.keys(o),contents:(0,P.$mi)(o,n)})}return i}}e.$xn=p;class w extends L.$Rc{constructor(s,n,i,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new N.$Md),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=w;class h{constructor(s,n,i,r,o,v,y,f,m,j,M,T,U){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=y,this.h=f,this.i=m,this.j=j,this.k=M,this.l=T,this.m=U}get value(){return c(this.c)}n(s,n,i){const r=s.inspect(n,i);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,n,i,r,o=new g,v=new g,y=new O.$zc,f=new g,m=new O.$zc){this.c=s,this.d=n,this.f=i,this.g=r,this.h=o,this.i=v,this.j=y,this.l=f,this.m=m,this.a=null,this.b=new O.$zc,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new g,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const r=this.q(s,n,i),o=this.u(n.resource,i),v=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const f of r.overrides)for(const m of f.identifiers)r.getOverrideValue(s,m)!==void 0&&y.add(m);return new h(s,n,r.getValue(s),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,o||void 0,v)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:o,removed:v}=k(this.c,s);n=[...r,...o,...v]}for(const r of n)for(const o of(0,E.$rn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),y=s.getKeysForOverrideIdentifier(o),f=[...y.filter(m=>v.indexOf(m)===-1),...v.filter(m=>y.indexOf(m)===-1),...v.filter(m=>!I.$6m(this.c.override(o).getValue(m),s.override(o).getValue(m)))];i.push([o,f])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=k(this.d,s),o=[...n,...i,...r];return o.length&&this.updatePolicyConfiguration(s),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=k(this.applicationConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateApplicationConfiguration(s),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=k(this.localUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=k(this.remoteUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=k(this.workspaceConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:r,updated:o,removed:v,overrides:y}=k(i,n),f=[...r,...o,...v];return(f.length||!i)&&this.updateFolderConfiguration(s,n),{keys:f,overrides:y}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:o,overrides:v}=k(n,void 0);return{keys:[...i,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let r=this.r(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}r({resource:s},n){let i=this.s();if(n&&s){const r=n.getFolder(s);r&&(i=this.t(r.uri)||i);const o=this.m.get(s);o&&(i=i.merge(o))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),r=this.j.get(s);r?(n=i.merge(r),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:o}=this.j.get(n);return s.push([n,{contents:i,overrides:r,keys:o}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),r=this.x(s.application),o=this.x(s.user),v=this.x(s.workspace),y=s.folders.reduce((f,m)=>(f.set(d.URI.revive(m[0]),this.x(m[1])),f),new O.$zc);return new l(n,i,r,o,new g,v,y,new g,new O.$zc)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.$zn=l;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,n=new Map;for(const r of a)r.keys.forEach(o=>s.add(o)),r.overrides.forEach(([o,v])=>{const y=(0,O.$wc)(n,o,new Set);v.forEach(f=>y.add(f))});const i=[];return n.forEach((r,o)=>i.push([o,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.$An=u;class b{constructor(s,n,i,r){this.change=s,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of s.keys)this.affectedKeys.add(o);for(const[,o]of s.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,r=this.d.indexOf(i);if(r<0)return!1;const o=r+i.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,f=this.g.getValue(s,n,this.h);return!I.$6m(y,f)}return!0}}e.$Bn=b;function k(a,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const f=y.filter(m=>!v.includes(m));for(const m of f)o.push([m,s.getKeysForOverrideIdentifier(m)])}if(a){const f=v.filter(m=>!y.includes(m));for(const m of f)o.push([m,a.getKeysForOverrideIdentifier(m)])}if(s&&a){for(const f of v)if(y.includes(f)){const m=t({contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)},{contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)});o.push([f,[...m.added,...m.removed,...m.updated]])}}return{added:n,removed:i,updated:r,overrides:o}}function t(a,s){const n=a?s?a.keys.filter(o=>s.keys.indexOf(o)===-1):[...a.keys]:[],i=s?a?s.keys.filter(o=>a.keys.indexOf(o)===-1):[...s.keys]:[],r=[];if(a&&s){for(const o of s.keys)if(a.keys.indexOf(o)!==-1){const v=(0,P.$pi)(s.contents,o),y=(0,P.$pi)(a.contents,o);I.$6m(v,y)||r.push(o)}}return{added:n,removed:i,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,73,49,7,56,40]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=void 0;class $ extends A.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new I.$wn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$bn.as(C.$gn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:h})=>this.c(Array.from(w),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,h){this.h(w,E.$bn.as(C.$gn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new I.$wn;const w=E.$bn.as(C.$gn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,h){const l=this.f();for(const u of w){const b=l[u],k=h[u];b!==void 0?this.b.addValue(u,b):k?this.b.addValue(u,k.default):this.b.removeValue(u)}}}e.$Cn=$;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new I.$wn}async initialize(){return this.configurationModel}}e.$Dn=c;let g=class extends A.$Rc{get configurationModel(){return this.b}constructor(w,h,l){super(),this.c=w,this.f=h,this.g=l,this.a=this.B(new N.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new I.$wn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const h={},l=[],u=E.$bn.as(C.$gn.Configuration).getConfigurationProperties();for(const b of w){const k=u[b];if(!k){l.push(b);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}l.push(b),h[k.policy.name]={type:k.type}}}return(0,O.$Kf)(h)||await this.f.updatePolicyDefinitions(h),l}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const h=E.$bn.as(C.$gn.Configuration).getPolicyConfigurations(),l=(0,D.$Gb)(w.map(u=>h.get(u)));this.m(l,!0)}m(w,h){this.g.trace("PolicyConfiguration#update",w);const l=E.$bn.as(C.$gn.Configuration).getConfigurationProperties(),u=[],b=this.b.isEmpty();for(const k of w){const t=l[k]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(b?a!==void 0:!(0,L.$6m)(this.b.getValue(k),a))&&u.push([k,a])}else this.b.getValue(k)!==void 0&&u.push([k,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const k=this.b;this.b=new I.$wn;for(const t of k.keys)this.b.setValue(t,k.getValue(t));for(const[t,a]of u)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$En=g,e.$En=g=ye([x(1,P.$dn),x(2,d.$8i)],g)}),define(oe[209],ae([0,1,5,3,2,21,19,73,208,56]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0;class P extends A.$Rc{constructor($,c,g,p){super(),this.j=$,this.h=this.B(new N.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.$Cn),this.c=g instanceof d.$fn?new C.$Dn:this.B(new C.$En(this.b,g,p)),this.f=this.B(new I.$yn(this.j,{},L.$lg,c)),this.a=new I.$zn(this.b.configurationModel,this.c.configurationModel,new I.$wn,new I.$wn),this.g=this.B(new D.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:h})=>this.n(w,h))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,c,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$zn($,c,new I.$wn,g)}getConfigurationData(){return this.a.toData()}getValue($,c){const g=typeof $=="string"?$:void 0,p=(0,O.$ii)($)?$:(0,O.$ii)(c)?c:{};return this.a.getValue(g,p,void 0)}updateValue($,c,g,p){return Promise.reject(new Error("not supported"))}inspect($){return this.a.inspect($,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.m($)}m($){const c=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration($);this.s(g,c,2)}n($,c){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration($,c);this.s(p,g,7)}r($){const c=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration($);this.s(g,c,7)}s($,c,g){const p=new I.$Bn($,{data:c},this.a);p.source=g,p.sourceConfig=this.t(g),this.h.fire(p)}t($){switch($){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Fn=P}),define(oe[210],ae([0,1,15,3,2,65]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skb=e.$rkb=e.$qkb=e.$pkb=void 0;const O=(d,P,E)=>{const $=new Uint8Array(16);for(let p=0;p<16;p++)$[p]=Math.round(Math.random()*256);const c=(0,D.$ue)(D.$ae.wrap($));return[`GET ws://localhost${d}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$pkb=O,e.$qkb=D.$ae.fromString(`\r
\r
`);async function I(d,P,E,$,c){d.write(D.$ae.fromString((0,e.$pkb)(P,E,$)));const g=new A.$Qc;try{return await new Promise((p,w)=>{let h;g.add(d.onData(l=>{h?h=D.$ae.concat([h,l],h.byteLength+l.byteLength):h=l;const u=h.indexOf(e.$qkb);if(u===-1)return;p(d),d.pauseData();const b=h.slice(u+e.$qkb.byteLength);b.byteLength&&c.onData.fire(b)})),g.add(d.onClose(l=>w(l??new Error("socket closed")))),g.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw d.dispose(),p}finally{g.dispose()}}e.$rkb=I;class C extends A.$Rc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$Pd),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$Md),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event($=>this.a.fire($))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$skb=C}),define(oe[211],ae([0,1,8,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,N.$Nh)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=L;class O{constructor(E,$){this.host=E,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=O;var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class C extends D.$ab{static isNotAvailable(E){return E instanceof C&&E._code===I.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof C&&E._code===I.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof C&&E._code===I.NoResolverFound}static isInvalidAuthority(E){return E instanceof C&&E._code===I.InvalidAuthority}static isHandled(E){return E instanceof C&&E.isHandled}constructor(E,$=I.Unknown,c){super(E),this._message=E,this._code=$,this._detail=c,this.isHandled=$===I.NotAvailable&&c===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Pk=C;function d(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Qk=d}),define(oe[74],ae([0,1,23]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function N(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}e.$Rk=N;function A(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Sk=A;function L(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Tk=L;function O(d){const{host:P,port:E}=C(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Uk=O;function I(d,P){let{host:E,port:$}=C(d);return typeof $>"u"&&($=P),{host:E,port:$}}e.$Vk=I;function C(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const $=d.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:d,port:void 0}}}),define(oe[44],ae([0,1,27,4,74]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Zl=L,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class C{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,h){if(typeof w>"u"||w===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof w=="string"||typeof h=="string"){const l=typeof w=="string"?w:w.value,u=typeof h=="string"?h:h.value;return D.$1e(l,u)}return w._lower===h._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$2l=C;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const h of w)this.add(h)}add(w){this.c.add(C.toKey(w))}delete(w){return this.c.delete(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}}e.$3l=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(C.toKey(w))}get(w){return this.c.get(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}set(w,h){this.c.set(C.toKey(w),h)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=P;function E(p){return $(p)}e.$5l=E;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$6l=$;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$7l=c;function g(p,w){if(w){const h=`onResolveRemoteAuthority:${(0,A.$Sk)(w)}`;return!!p.activationEvents?.includes(h)}return!1}e.$8l=g,e.$9l=(0,N.$Nh)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;class L extends D.$Rc{constructor(I,C,d,P,E){super(),this.a=I,this.b=C,this.c=d,this.f=E,this.B(P.onDidInstallExtensions($=>this.g($))),this.B(P.onDidUninstallExtension($=>this.h($)))}g(I){for(const C of I)C.local&&this.invalidate(C.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,I)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Vl))}catch(C){(0,A.$mk)(C)!==1&&this.f.error(C)}}}e.$Cp=L}),define(oe[213],ae([0,1,5,15,26,8,3,2,100,60,32,65,211,74]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.PersistentConnectionEventType=e.$3k=e.$2k=e.$1k=e.ConnectionType=void 0;const g=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(B){const S=new A.$Wd;return setTimeout(()=>S.cancel(),B),S.token}function l(B,S){if(B.isCancellationRequested||S.isCancellationRequested)return A.CancellationToken.Cancelled;const R=new A.$Wd;return B.onCancellationRequested(()=>R.cancel()),S.onCancellationRequested(()=>R.cancel()),R.token}class u{get didTimeout(){return this.c==="timedout"}constructor(S){this.c="pending",this.d=new I.$Qc,this.promise=new Promise((R,z)=>{this.f=R,this.g=z}),S.isCancellationRequested?this.h():this.d.add(S.onCancellationRequested(()=>this.h()))}registerDisposable(S){this.c==="pending"?this.d.add(S):S.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const S=new Error("Time limit reached");return S.code="ETIMEDOUT",S.syscall="connect",S}resolve(S){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(S))}reject(S){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(S))}}function b(B,S){const R=new u(S);return R.registerDisposable(B.onControlMessage(z=>{const F=JSON.parse(z.toString()),J=V(F);J?R.reject(J):R.resolve(F)})),R.promise}function k(B,S,R,z,F,J,Z,se){const le=new u(se),ue=d.$Id.create(!1);return B.info(`Creating a socket (${Z})...`),C.mark(`code/willCreateSocket/${J}`),S.connect(R,z,F,Z).then(he=>{le.didTimeout?(C.mark(`code/didCreateSocketError/${J}`),B.info(`Creating a socket (${Z}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(C.mark(`code/didCreateSocketOK/${J}`),B.info(`Creating a socket (${Z}) was successful after ${ue.elapsed()} ms.`),le.resolve(he))},he=>{C.mark(`code/didCreateSocketError/${J}`),B.info(`Creating a socket (${Z}) returned an error after ${ue.elapsed()} ms.`),B.error(he),le.reject(he)}),le.promise}function t(B,S){const R=new u(S);return B.then(z=>{R.didTimeout||R.resolve(z)},z=>{R.didTimeout||R.reject(z)}),R.promise}async function a(B,S,R,z){const F=re(B,S);B.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let J;try{J=await k(B.logService,B.remoteSocketFactoryService,B.connectTo,(0,c.$Tk)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,w(S),`renderer-${w(S)}-${B.reconnectionToken}`,z)}catch(he){throw B.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),B.logService.error(he),he}B.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let Z,se;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(J,null),Z=B.reconnectionProtocol,se=!1):(Z=new E.$Bh({socket:J}),se=!0),B.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const le=await t(B.signService.createNewMessage((0,P.$dg)()),z),ue={type:"auth",auth:B.connectionToken||"00000000000000000000",data:le.data};Z.sendControl(N.$ae.fromString(JSON.stringify(ue)));try{const he=await b(Z,l(z,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(B.logService.trace(`${F} 4/6. received SignRequest control message.`),!await t(B.signService.validate(le,he.signedData),z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await t(B.signService.sign(he.data),z),we={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:S};return R&&(we.args=R),B.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(N.$ae.fromString(JSON.stringify(we))),{protocol:Z,ownsProtocol:se}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(B.logService.error(`${F} the handshake timed out. Error:`),B.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${F} received error control message when negotiating connection. Error:`),B.logService.error(he)),se&&H(Z),he}}async function s(B,S,R,z){const F=Date.now(),J=re(B,S),{protocol:Z,ownsProtocol:se}=await a(B,S,R,z),le=new u(z);return le.registerDisposable(Z.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(B.logService.error(`${J} received error control message when negotiating connection. Error:`),B.logService.error($e),se&&H(Z),le.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${X(F)}!`),le.resolve({protocol:Z,firstMessage:he}))})),le.promise}async function n(B,S){const{protocol:R}=await s(B,1,void 0,S);return{protocol:R}}async function i(B,S,R){const{protocol:z,firstMessage:F}=await s(B,2,S,R),J=F&&F.debugPort;return{protocol:z,debugPort:J}}async function r(B,S,R){const z=Date.now(),F=re(B,3),{protocol:J}=await a(B,3,S,R);return B.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${X(z)}!`),J}async function o(B,S,R){const{connectTo:z,connectionToken:F}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:z,connectionToken:F,reconnectionToken:S,reconnectionProtocol:R,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function v(B,S,R){return f(B,async z=>{const{protocol:F}=await n(z,A.CancellationToken.None);return new G(B,S,R,z.reconnectionToken,F)})}e.$1k=v;async function y(B,S){return f(B,async R=>{const{protocol:z,debugPort:F}=await i(R,S,A.CancellationToken.None);return new Q(B,S,R.reconnectionToken,z,F)})}e.$2k=y;async function f(B,S){for(let z=1;;z++)try{const F=(0,P.$dg)(),J=await o(B,F,null);return await S(J)}catch(F){if(z<5)B.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(F);else throw B.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(F),Y.triggerPermanentFailure(0,0,$.$Pk.isHandled(F)),F}}async function m(B,S,R){const z=await o(B,(0,P.$dg)(),null);return await r(z,{host:S,port:R},A.CancellationToken.None)}e.$3k=m;function j(B){return(0,D.$Gg)(S=>new Promise((R,z)=>{const F=setTimeout(R,B*1e3);S.onCancellationRequested(()=>{clearTimeout(F),R()})}))}var M;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class T{constructor(S,R){this.reconnectionToken=S,this.millisSinceLastIncomingData=R,this.type=0}}e.$4k=T;class U{constructor(S,R,z,F){this.reconnectionToken=S,this.millisSinceLastIncomingData=R,this.durationSeconds=z,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$5k=U;class q{constructor(S,R,z){this.reconnectionToken=S,this.millisSinceLastIncomingData=R,this.attempt=z,this.type=2}}e.$6k=q;class _{constructor(S,R,z){this.reconnectionToken=S,this.millisSinceLastIncomingData=R,this.attempt=z,this.type=4}}e.$7k=_;class K{constructor(S,R,z,F){this.reconnectionToken=S,this.millisSinceLastIncomingData=R,this.attempt=z,this.handled=F,this.type=3}}e.$8k=K;class Y extends I.$Rc{static triggerPermanentFailure(S,R,z){this._permanentFailure=!0,this.f=S,this.g=R,this.h=z,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(S=>S.y())}static debugPauseSocketWriting(){this.j.forEach(S=>S.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Y._permanentFailure}constructor(S,R,z,F,J){super(),this.t=S,this.u=R,this.reconnectionToken=z,this.protocol=F,this.w=J,this.m=this.B(new O.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(F.onSocketClose(Z=>{const se=ne(this.t,this.reconnectionToken,!0);Z?Z.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(Z=>{const se=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),Y.j.push(this),this.B((0,I.$Pc)(()=>{const Z=Y.j.indexOf(this);Z>=0&&Y.j.splice(Z,1)})),this.n&&this.D(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const S=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${S} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const F=z<R.length?R[z]:R[R.length-1];try{if(F>0){const Z=j(F);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,Z)),this.u.logService.info(`${S} waiting for ${F} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${S} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${S} resolving connection...`);const J=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${S} connecting to ${J.connectTo}...`),await this.G(J,h(g)),this.u.logService.info(`${S} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${S} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${S} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if($.$Pk.isTemporarilyNotAvailable(J)){this.u.logService.info(`${S} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${S} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,L.$3)(J)){this.u.logService.info(`${S} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof $.$Pk){this.u.logService.error(`${S} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,$.$Pk.isHandled(J));break}this.u.logService.error(`${S} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(S,R,z){this.w?Y.triggerPermanentFailure(S,R,z):this.D(S,R,z)}D(S,R,z){this.m.fire(new K(this.reconnectionToken,S,R,z)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9k=Y;class G extends Y{constructor(S,R,z,F,J){super(1,S,F,J,!0),this.client=this.B(new E.$zh(J,{remoteAuthority:R,clientId:z},S.ipcLogger))}async G(S,R){await n(S,R)}}e.$0k=G;class Q extends Y{constructor(S,R,z,F,J){super(2,S,z,F,!1),this.H=R,this.debugPort=J}async G(S,R){await i(S,this.H,R)}}e.$$k=Q;function H(B){try{B.acceptDisconnect();const S=B.getSocket();B.dispose(),S.dispose()}catch(S){(0,L.$Z)(S)}}function V(B){if(B&&B.type==="error"){const S=new Error(`Connection error: ${B.reason}`);return S.code="VSCODE_CONNECTION_ERROR",S}return null}function W(B,S){for(;B.length<S;)B+=" ";return B}function ee(B,S){return`[remote-connection][${W(w(B),13)}][${S.substr(0,5)}\u2026]`}function ne(B,S,R){return`${ee(B,S)}[${R?"reconnect":"initial"}]`}function re(B,S){return`${ne(S,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function X(B){return`${Date.now()-B} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk=(0,N.$Nh)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,D.$Pc)(()=>{const C=this.a[O]?.indexOf(I);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,I,C,d){const P=this.b(O);if(!P)throw new Error(`No socket factory found for ${O}`);return P.connect(O,I,C,d)}}e.$Xk=A}),define(oe[214],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=e.$C8b=void 0,e.$C8b=(0,D.$Nh)("sharedProcessTunnelService"),e.$D8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=e.$M8b=e.$L8b=e.$K8b=e.$J8b=e.TunnelStates=e.$I8b=e.$H8b=void 0,e.$H8b=(0,D.$Nh)("IRemoteTunnelService"),e.$I8b={active:!1};var A;(function(L){L.disconnected=O=>({type:"disconnected",onTokenFailed:O}),L.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),L.connecting=O=>({type:"connecting",progress:O}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$J8b="remote.tunnels.access",e.$K8b=e.$J8b+".hostNameOverride",e.$L8b=e.$J8b+".preventSleep",e.$M8b="remoteTunnelService",e.$N8b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,49,4,7,40]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Oo=(0,I.$Nh)("requestService");class P{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?k[t]="*****":k[t]=this.b[t];this.a=k}return this.a}}class E extends A.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,L.localize)(0,null),when:C.$mj.isEqualTo((0,C.$kj)(C.LogLevel.Trace)).serialize()})}async c(k,t,a){const s=`${k} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new P(t.headers??{}));try{const n=await a();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,N.$9)(n)),n}}}e.$Po=E;function $(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.$Qo=$;function c(b){return b.res.statusCode===204}e.$Ro=c;async function g(b){return c(b)?null:(await(0,D.$me)(b.stream)).toString()}e.$So=g;async function p(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);return g(b)}e.$To=p;async function w(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);if(c(b))return null;const t=(await(0,D.$me)(b.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Uo=w;function h(b){u(b)}e.$Vo=h;let l;function u(b){const k=d.$bn.as(O.$gn.Configuration),t=l;l={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[l],remove:t?[t]:[]})}u(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;let O=class{constructor(C,d){this.a=C,this.b=d}async download(C,d,P=D.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,d);return}const E={type:"GET",url:C.toString(!0)},$=await this.a.request(E,P);if($.res.statusCode===200)await this.b.writeFile(d,$.stream);else{const c=await(0,L.$To)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${c}`)}}};e.$KN=O,e.$KN=O=ye([x(0,L.$Oo),x(1,A.$9j)],O)}),define(oe[216],ae([0,1,15,26]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class A{constructor(I){this.a=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,d,P=N.CancellationToken.None){switch(C){case"request":return this.a.request(d[0],P).then(async({res:E,stream:$})=>{const c=await(0,D.$me)($);return[{statusCode:E.statusCode,headers:E.headers},c]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Rq=A;class L{constructor(I){this.a=I}async request(I,C){const[d,P]=await this.a.call("request",[I],C);return{res:d,stream:(0,D.$oe)(P)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Sq=L}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=e.$76b=void 0,e.$76b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$86b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$96b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$82b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const L=await this.c();if(L){const O=String(D.a++);return this.b.set(O,L),{id:O,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const O=this.b.get(A.id);if(!O)return!1;this.b.delete(A.id);try{return O.validate(L)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$82b=D}),define(oe[106],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk="signService",e.$Zk=(0,D.$Nh)(e.$Yk)}),define(oe[219],ae([0,1,218]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0;class N extends D.$82b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(O=>new O.signer().sign(L))}h(){return new Promise((L,O)=>te(["vsda"],L,O))}}e.$V7b=N}),define(oe[75],ae([0,1,3,2]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YCb=e.$XCb=e.$WCb=e.$VCb=void 0;class A extends N.$Rc{constructor(E,$,c){super(),this.a=E,this.b=$,this.c=c}async getItems(){const E={profile:this.b,workspace:this.c},$=await this.a.call("getItems",E);return new Map($)}updateItems(E){const $={profile:this.b,workspace:this.c};return E.insert&&($.insert=Array.from(E.insert.entries())),E.delete&&($.delete=Array.from(E.delete.values())),this.a.call("updateItems",$)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class L extends A{constructor(E,$){super(E,$,void 0),this.f=this.B(new D.$Md),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$VCb=O;class I extends L{constructor(E,$){super(E,$)}async close(){this.dispose()}}e.$WCb=I;class C extends A{constructor(E,$){super(E,void 0,$),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$XCb=C;class d{constructor(E){this.a=E}isUsed(E){const $={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$YCb=d}),define(oe[107],ae([0,1,6,37,32]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function L(C){if(D.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,d,P,E,$,c,g,p){const w=Object.create(null);w["common.machineId"]=c,w.sessionID=(0,A.$dg)()+Date.now(),w.commitHash=E,w.version=$,w["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,D.$i)(D.$u),w["common.nodePlatform"]=N.$cc,w["common.nodeArch"]=P,w["common.product"]=p||"desktop",g&&(w["common.msftInternal"]=g);let h=0;const l=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),D.$m&&(w["common.snap"]="true");const u=L(d);return u&&(w["common.platformDetail"]=u),w}e.$do=O;function I(C){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return C.some(E=>P===E)}e.$eo=I}),define(oe[22],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,D.$Nh)("telemetryService"),e.$al=(0,D.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[220],ae([0,1,36,5,35,23,16,6,9,132,31,146,95,11,24,22]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=void 0;const w=new Map;async function h(t,a){const s=`${t}::${a.join(":")}`,n=w.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function y(m,j,M,T){const U=j.substring(m.length+1);return N.Promises.withAsyncBody(async q=>{let _;try{_=await P.Promises.readdir(j,{withFileTypes:!0})}catch{q();return}if(T.count>=v){T.count+=_.length,T.maxReached=!0,q();return}let K=_.length;if(K===0){q();return}let Y=_;T.count+_.length>v&&(T.maxReached=!0,K=v-T.count,Y=_.slice(0,K)),T.count+=_.length;for(const G of Y)if(G.isDirectory()){if(M.includes(G.name)||await y(m,(0,O.$ic)(j,G.name),M,T),--K===0){q();return}}else{const Q=G.name.lastIndexOf(".");if(Q>=0){const H=G.name.substring(Q+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(U)!==!1&&H.filePattern.test(G.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--K===0){q();return}}})}const f=N.Promises.withAsyncBody(async m=>{const j={count:0,maxReached:!1};await y(t,t,a,j);const M=await b(t);m({configFiles:l(o),fileTypes:l(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:M})});return w.set(s,f),f}e.$zr=h;function l(t){return Array.from(t.entries(),([a,s])=>({name:a,count:s})).sort((a,s)=>s.count-a.count)}function u(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Dk.GB).toFixed(2)}GB (${(D.freemem()/c.$Dk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Nm.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.$Ar=u;async function b(t){try{const a=new Map,s=(0,O.$ic)(t,".vscode","launch.json"),n=await P.Promises.readFile(s),i=[],r=(0,A.$Rm)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$1m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return l(a)}catch{return[]}}e.$Br=b;let k=class{constructor(a,s){this.c=a,this.d=s}f(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}g(a){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/c.$Dk.GB).toFixed(2)}GB (${(D.freemem()/c.$Dk.GB).toFixed(2)}GB free)`),I.$j||s.push(`Load (avg):       ${D.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(d.$Nm.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,E.$yr)(a.mainPID),this.k(a)]).then(async n=>{let[i,r]=n,o=this.m(a,i);return s.forEach(v=>{if((0,$.$nm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[y];let m=`${f.fileCount} files`;f.maxFilesReached&&(m=`more than ${m}`),r+=`|    Folder (${y}): ${m}`,r+=this.h(f)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,s){const{memory:n,vmHint:i,os:r,cpus:o}=u(),v={os:r,memory:n,cpus:o,vmHint:i,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return I.$j||(v.load=`${D.loadavg().map(y=>Math.round(y)).join(", ")}`),I.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,s){const n=[];return(0,E.$yr)(a.mainPID).then(async i=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,i)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),s.forEach(r=>{if((0,$.$nm)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),n.push(`Folder (${o}): ${y}`),n.push(this.h(v))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const s=[];let i=0;const r=(f,m)=>{const j=` ${f}(${m})`;i+j.length>60?(s.push(o),o="|                 ",i=o.length):i+=j.length,o+=j};let o="|      File types:";const v=10,y=a.fileTypes.length>v?v:a.fileTypes.length;for(let f=0;f<y;f++){const m=a.fileTypes[f];r(m.name,m.count)}if(s.push(o),a.configFiles.length>=0&&(o="|      Conf files:",i=0,a.configFiles.forEach(f=>{r(f.name,f.count)}),s.push(o)),a.launchConfigFiles.length>0){let f="|      Launch Configs:";a.launchConfigFiles.forEach(m=>{const j=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`;f+=j}),s.push(f)}return s.join(`
`)}j(a){const s=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const s=[],n=[];return a.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const o=C.URI.revive(r);if(o.scheme===L.Schemas.file){const v=o.fsPath;n.push(h(v,["node_modules",".git"]).then(y=>{let f=`${y.fileCount} files`;y.maxFilesReached&&(f=`more than ${f}`),s.push(`|    Folder (${(0,O.$mc)(v)}): ${f}`),s.push(this.h(y))}).catch(y=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else s.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(a,s){const n=new Map;a.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>n.set(r,o));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(a.mainPID,n,i,s,0),i.join(`
`)}n(a,s,n,i,r){const o=r===0;let v;o?v=i.pid===a?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?v=s.get(i.pid):v=`${"  ".repeat(r)} ${i.name}`;const y=process.platform==="win32"?i.mem:D.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(y/c.$Dk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(i.children)&&i.children.forEach(f=>this.n(a,s,n,f,r+1))}async getWorkspaceFileExtensions(a){const s=new Set;for(const{uri:n}of a.folders){const i=C.URI.revive(n);if(i.scheme!==L.Schemas.file)continue;const r=i.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>s.add(v.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const n=C.URI.revive(s);if(n.scheme!==L.Schemas.file)continue;const i=n.fsPath;try{const r=await h(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Cr=k,e.$Cr=k=ye([x(0,p.$_k),x(1,g.$nj)],k)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=void 0;class D{constructor(L){this.b=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,{eventName:I,data:C}){return this.b.forEach(d=>d.log(I,C)),Promise.resolve(null)}}e.$_6b=D;class N{constructor(L){this.b=L}log(L,O){return this.b.call("log",{eventName:L,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$a7b=N}),define(oe[45],ae([0,1,30,12,3,19,74,107,22]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class d{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$fo=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=P,e.$ho=new P;class E{async publicLog(i,r,o){}async publicLogError(i,r,o){}}e.$io=E,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function $(n,i){return A.Event.debounce(i.onDidChangeConfiguration,(o,v)=>{const y=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:y}},1e3,!0)(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.$ki)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$mo=$;function c(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry)}e.$no=c;function g(n,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$oo=g;function p(n){const i=n.getValue(C.$gl),r=n.getValue(C.$hl);if(n.getValue(C.$il)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=p;function w(n){const i={},r={},o={};u(n,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const y=o[v];typeof y=="number"?r[v]=y:typeof y=="boolean"?r[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),i[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(i[v]=y)}return{properties:i,measurements:r}}e.$qo=w;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const i=(0,O.$Sk)(n);return h.has(i)?i:"other"}e.$ro=l;function u(n,i,r=0,o){if(n)for(const v of Object.getOwnPropertyNames(n)){const y=n[v],f=o?o+v:v;Array.isArray(y)?i[f]=(0,D.$7m)(y):y instanceof Date?i[f]=y.toISOString():(0,N.$zf)(y)?r<2?u(y,i,r+1,f+"."):i[f]=(0,D.$7m)(y):i[f]=y}}function b(n,i){const r=n.msftInternalDomains||[],o=i.getValue("telemetry.internalTesting");return(0,I.$eo)(r)||o}e.$so=b;function k(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$to=k;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const o=[];for(const m of i)for(;;){const j=m.exec(n);if(!j)break;o.push([j.index,m.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const m=y.exec(n);if(!m)break;const j=o.some(([M,T])=>m.index<T&&M<y.lastIndex);!v.test(m[0])&&!j&&(r+=n.substring(f,m.index)+"<REDACTED: user-file-path>",f=y.lastIndex)}return f<n.length&&(r+=n.substr(f)),r}function a(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,D.$4m)(n,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=t(o,i);for(const v of i)o=o.replace(v,"");return o=a(o),o}})}e.$uo=s}),define(oe[33],ae([0,1,27,29,44,6,9,8,37,45]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function P(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,D.$Ve)(s.id,n.id)===0}e.$vo=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,i,r)}static parse(n){const i=E.exec(n);return i&&i[1]&&i[2]?new $({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$wo=$;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const n=c.exec(s);return n&&n[1]?[w(n[1]),n[2]]:[w(s),void 0]}e.$xo=g;function p(s,n){return`${s}.${n}`}e.$yo=p;function w(s){return s.toLowerCase()}e.$zo=w;function h(s,n){return w(p(s??A.$Xl,n))}e.$Ao=h;function l(s,n){const i=[],r=o=>{for(const v of i)if(v.some(y=>P(n(y),n(o))))return v;return null};for(const o of s){const v=r(o);v?v.push(o):i.push([o])}return i}e.$Bo=l;function u(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Co=u;function b(s){return{id:new d.$fo(s.identifier.id),name:new d.$fo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Do=b,e.$Eo=new A.$2l("pprice.better-merge");function k(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&i.every(v=>!P(v.identifier,{id:o}))){const v=s.filter(y=>P(y.identifier,{id:o}));v.length===1&&(i.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$Fo=k;async function t(s,n){if(!L.$l)return!1;let i;try{i=(await s.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,I.$9)(o))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,n){const i=await t(s,n),r=(0,N.$1n)(i?"alpine":L.$u,C.$dc);return n.debug("ComputeTargetPlatform:",r),r}e.$Go=a}),define(oe[221],ae([0,1,18,2,21,9,11,24,5,3,16,6,37,33]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=e.$a5b=void 0;let g=class extends N.$Rc{constructor(u,b){super(),this.b=u,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,k])=>this.a.set(k.configPath,k))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const b=[];for(const[k,t]of this.a)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const a=(await this.b.readFile((0,A.$ug)(u,k))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(a))&&b.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return b}};e.$a5b=g,e.$a5b=g=ye([x(0,O.$9j),x(1,I.$nj)],g);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class h extends g{constructor(u,b,k,t,a,s,n,i){super(n,i),this.r=u,this.s=b,this.t=k,this.u=t,this.w=a,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],y=[],f=[];Object.entries(o.recommendations).forEach(([m,j])=>{j.important?o.important?v.push({extensionId:m,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):y.push({extensionId:m,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):f.push({extensionId:m,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:y}),f.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:f})}),(0,C.$Ug)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),b=await this.O(this.h);return[...u,...b]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),b=await this.O(this.h),k=await this.u.getInstalled();this.m=this.D(u,k),this.n=this.D(b,k)}D(u,b){const k=new Map;u.forEach(i=>k.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:a}=this.N([...k.keys()],b);for(const i of t){const r=k.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of a){const r=k.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.L(),n=new Map;for(const i of a){const r=k.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let o=n.get(r.exeName);o||(o=[],n.set(r.exeName,o)),o.push(r)}}return n}F(){if(this.m.size===0)return;const[u,b]=[...this.m.entries()][0];this.H(b).then(k=>{switch(k){case"reacted":this.M(b[0].exeName,b);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const t=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Sc);t.value=(0,C.$Ug)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),b=Date.now()-u,k=7*24*60*60*1e3;if(b<k){const s=this.B(new N.$Sc);s.value=(0,C.$Ug)(()=>{s.dispose(),this.G()},k-b);return}const[t,a]=[...this.n.entries()][0];this.H(a).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(a[0].exeName,a);const n=this.B(new N.$Sc);n.value=(0,C.$Ug)(()=>{n.dispose(),this.G()},k);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const n=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(n(()=>this.G()));break}case"toomany":{const n=this.B(new N.$Sc);n.value=(0,C.$Ug)(()=>{n.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const b=await this.u.getInstalled(1),k=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(a=>b.every(s=>!(0,c.$vo)(s.identifier,{id:a})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(w,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(w,u,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(u,b){const k=this.L();k[u]=b.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify(k),-1,0)}N(u,b){const k=[],t=[],a=b.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return u.forEach(s=>{a.has(s.toLowerCase())?k.push(s):t.push(s)}),{installed:k,uninstalled:t}}async O(u){const b=[],k=new Map;for(const t of u.keys()){const a=u.get(t);if(!a||!(0,D.$Kb)(a.recommendations))continue;const s=[];E.$j?a.windowsPath&&s.push(a.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(s.push((0,P.$ic)("/usr/local/bin",t)),s.push((0,P.$ic)("/usr/bin",t)),s.push((0,P.$ic)(this.r.fsPath,t)));for(const n of s){let i=k.get(n);if(i===void 0&&(i=await this.b.exists(L.URI.file(n)),k.set(n,i)),i)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:y}of a.recommendations)b.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:t,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:y})}}return b}}e.$b5b=h}),define(oe[222],ae([0,1,26,33]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KVb=void 0;async function A(L,O,I,C,d){try{const P=await L.getExtensionsControlManifest();if(!P.deprecated)return;const E=await L.getInstalled(1);for(const[$,c]of Object.entries(P.deprecated)){if(!c?.extension)continue;const{id:g,autoMigrate:p,preRelease:w}=c.extension;if(!p)continue;const h=E.find(u=>(0,N.$vo)(u.identifier,{id:$}));if(!h)continue;const l=(await O.getExtensions([{id:g,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!l){d.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{d.info(`Migrating '${h.identifier.id}' extension to '${g}' extension...`);const u=!C.getDisabledExtensions().some(k=>(0,N.$vo)(k,h.identifier));await L.uninstall(h),d.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let b=E.find(k=>(0,N.$vo)(k.identifier,{id:g}));(!b||!b.isPreReleaseVersion&&u)&&(b=await L.installFromGallery(l,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${b.identifier.id}'`),u||(await C.disableExtension(b.identifier),d.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$yo)(h.manifest.publisher,h.manifest.name),(0,N.$yo)(b.manifest.publisher,b.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${h.identifier.id}' extension to '${g}' extension.`)}catch(u){d.error(u)}}}catch(P){d.error(P)}}e.$KVb=A}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class I extends N.$Rc{constructor(d,P,E,$,c,g,p){super(),this.f=d,this.g=P,this.h=E,this.j=$,this.m=c,this.n=g,this.r=p,this.a=this.B(new D.$Md),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Zc),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(d){for(const P of d.extensions)this.I(this.L(P.identifier,P.version),d.profileLocation)}async y(d){for(const P of d.extensions){const E=this.L(P.identifier,P.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const P of d.extensions)this.J(this.L(P.identifier,P.version),d.profileLocation)}async C(d){const P=[],E=[];for(const $ of d.extensions){const c=this.L($.identifier,$.version);d.error?this.I(c,d.profileLocation):(this.J(c,d.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),E.push(this.f.scanInstalledExtensionAtLocation($.location).then(g=>{g?P.push(g):this.r.info("Extension not found at the location",$.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch($){this.r.error($)}}D(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(d){const P=[],E=[],$=await this.j.scanProfileExtensions(d),c=new Set,g=new Set;for(const[p,w]of this.b)w.has(d)&&g.add(p);for(const p of $){const w=this.L(p.identifier,p.version);c.add(w),g.has(w)||(P.push(p.identifier),this.I(w,d))}for(const p of g)if(!c.has(p)){const w=this.M(p);w&&(E.push(w.identifier),this.J(p,d))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const P=await this.j.scanProfileExtensions(d);for(const E of P)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,P){let E=this.b.get(d);E||this.b.set(d,E=new A.$Ac($=>this.m.extUri.getComparisonKey($))),E.add(P)}J(d,P){const E=this.b.get(d);E&&E.delete(P),E?.size||this.b.delete(d)}L(d,P){return`${O.$2l.toKey(d.id)}@${P}`}M(d){const[P,E]=(0,L.$xo)(d);return E?{identifier:{id:P},version:E}:void 0}}e.$Dp=I}),define(oe[224],ae([0,1,43,45]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function A(L,O,I,C,d,P,E){const $={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,N.$no)(O,I)&&(0,N.$po)(C)===3){const c=await(0,D.$8o)(I,d,P);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=E.machineId||c}return $}e.$9o=A}),define(oe[225],ae([0,1,69,18,5,2,23,16,31,14,29,33,7,72,9]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let p=class extends c.$Pq{constructor(u,b,k,t){super(k),this.h=u,this.j=t,this.g=this.B(new w(b,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(u,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.j.warn(`No language pack found for ${b}`);return}const a=t.translations[u];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),b=Object.keys(u).map(k=>{const t=u[k];return{...this.f(k,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((k,t)=>k.label.localeCompare(t.label)),b}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const b=await this.g.getLanguagePacks();Object.keys(b).some(k=>b[k]&&b[k].extensions.some(t=>(0,E.$vo)(t.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(b);return!(0,N.$tb)(Object.keys(u),Object.keys(k))}};e.$Qq=p,e.$Qq=p=ye([x(0,P.$8n),x(1,d.$Vh),x(2,P.$6n),x(3,$.$8i)],p);let w=class extends L.$Rc{constructor(u,b){super(),this.j=b,this.c={},this.f=(0,I.$ic)(u.userDataPath,"languagepacks.json"),this.g=new A.$Zg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(b=>{Object.keys(b).forEach(k=>delete b[k]),this.m(b,...u)}).then(()=>this.c)}m(u,...b){for(const k of b)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(u,k);Object.keys(u).forEach(k=>this.r(u[k]))}n(u,b){const k=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of t)if(b.location.scheme===O.Schemas.file&&h(a)){let s=u[a.languageId];s||(s={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},u[a.languageId]=s);const n=s.extensions.filter(i=>(0,E.$vo)(i.extensionIdentifier,k))[0];n?n.version=b.manifest.version:s.extensions.push({extensionIdentifier:k,version:b.manifest.version});for(const i of a.translations)s.translations[i.id]=(0,I.$ic)(b.location.fsPath,i.path)}}r(u){if(u){const b=(0,D.createHash)("md5");for(const k of u.extensions)b.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);u.hash=b.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let b=null;return C.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(b=u(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>b,k=>this.j.error(k))})}};w=ye([x(0,d.$Vh),x(1,$.$8i)],w);function h(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,45]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function C(P,E,$){const c=await(0,D.$gC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$gC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,w=new g.PostChannel,h={instrumentationKey:P,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if($){h.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:$};h.extensionConfig[w.identifier]=l}return p.initialize(h,[]),p.addTelemetryInitializer(l=>{E&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),p}class d{constructor(E,$,c,g,p){this.e=E,this.f=$,this.g=c,this.h=p,this.c=O,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then($=>{E($)},$=>{(0,N.$Z)($),console.error($)})}}log(E,$){if(!this.a)return;$=(0,A.$5m)($,this.g),$=(0,L.$qo)($);const c=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=$?.properties.version??"Unknown",g.track({name:c,baseData:{name:c,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$iN=d}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=void 0;let C=class extends D.$Rc{constructor(P,E,$,c,g=""){super(),this.b=g;const p=E.getLogger(I.$jo);if(p)this.a=this.B(p);else{const h=(0,I.$oo)(c,$)?" (Not Sent)":"",l=()=>(0,I.$no)(c,$)&&P.getLevel()===L.LogLevel.Trace;this.a=this.B(E.createLogger(I.$jo,{name:(0,N.localize)(0,null,h),hidden:!l()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(I.$jo,l()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,I.$qo)(E))}};e.$B4b=C,e.$B4b=C=ye([x(0,L.$8i),x(1,L.$9i),x(2,A.$Uh),x(3,O.$nj)],C)}),define(oe[110],ae([0,1,2,30,6,27,168,19,49,102,24,40,22,45]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,l,u){this.k=l,this.l=u,this.d={},this.i=new D.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,L.$Ee)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ee)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration($.$gl)||b.affectsConfiguration($.$il)||b.affectsConfiguration($.$hl))&&this.m()}))}setExperimentProperty(h,l){this.d[h]=l}m(){let h=(0,c.$po)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const u=l.usage?3:l.error?2:0;h=Math.min(h,u)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,l,u){this.g<l||(u=(0,N.$5m)(u,this.d),u=(0,c.$uo)(u,this.j),u=(0,N.$5m)(u,this.c),this.b.forEach(b=>b.log(h,u)))}publicLog(h,l){this.n(h,3,l)}publicLog2(h,l){this.publicLog(h,l)}publicLogError(h,l){this.h&&this.n(h,2,l)}publicLogError2(h,l){this.publicLogError(h,l)}};e.$Wq=g,e.$Wq=g=ye([x(1,I.$hi),x(2,P.$nj)],g);function p(){const w=(0,O.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=A.$p?"":(0,O.localize)(3,null),u=(0,O.localize)(4,null),b=(0,O.localize)(5,null),k=(0,O.localize)(6,null),t=(0,O.localize)(7,null),a=`
|       | ${u} | ${b} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,O.localize)(8,null);return`
${w} ${h} ${l}

&nbsp;

${t}
${a}

&nbsp;

${s}
`}E.$bn.as(C.$gn.Configuration).registerConfiguration({id:$.$fl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[$.$gl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$bn.as(C.$gn.Configuration).registerConfiguration({id:$.$fl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[$.$il]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${$.$gl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;async function O(P,E){const $=await E.request(P,N.CancellationToken.None),c=(await(0,D.$me)($.stream)).toString(),g=$.res.statusCode??200;return{headers:$.res.headers,statusCode:g,responseData:c}}async function I(P){const E={method:P.type,headers:P.headers};return new Promise((c,g)=>{const p=A.request(P.url??"",E,w=>{w.on("data",function(h){c({headers:w.headers,statusCode:w.statusCode??200,responseData:h.toString()})}),w.on("error",function(h){g(h)})});p.write(P.data,w=>{w&&g(w)}),p.end()})}async function C(P,E,$){const c=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:c};try{const p=P?await O(g,P):await I(g);$(p.statusCode,p.headers,p.responseData)}catch{$(0,{})}}class d extends L.$iN{constructor(E,$,c,g,p){const w={sendPOST:(h,l)=>{C(E,h,l)}};super($,c,g,p,w)}}e.$jN=d}),define(oe[228],ae([0,1,23,93,19,14,7,24,22,108,109,110]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=void 0;let $=class{constructor(g,p,w,h,l,u){this.b=g,this.c=p,this.d=w,this.e=h,this.f=l,this.g=u,this.a=new Map}h(g){if(!this.a.has(g.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[g.id,JSON.stringify(p),g.aiKey],l=new N.$Yp(D.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new d.$a7b(l),new P.$B4b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$Wq({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,p,w){this.h(g).publicLog(p,w)}publicLogError(g,p,w){this.h(g).publicLogError(p,w)}};e.$r8b=$,e.$r8b=$=ye([x(0,A.$hi),x(1,C.$_k),x(2,O.$8i),x(3,O.$9i),x(4,L.$Uh),x(5,I.$nj)],$)}),define(oe[76],ae([0,1,3,19,4,7]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProvidedOnAutoForward=e.$6u=e.TunnelPrivacyId=e.TunnelProtocol=e.$5u=e.$4u=void 0,e.$4u=(0,A.$Nh)("tunnelService"),e.$5u=(0,A.$Nh)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var I;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(I||(e.TunnelPrivacyId=I={}));function C(w){return!!w.forwardPort}e.$6u=C;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(h)return{address:h[1],port:+h[2]}}e.$7u=P,e.$8u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$8u.indexOf(w)>=0}e.$9u=E,e.$0u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(w){return e.$0u.indexOf(w)>=0}e.$$u=$;function c(w,h,l,u){if(l===1)return!1;if(l===2&&$(h)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(b?.length===4&&parseInt(b[1])>=18)return!1}return w<1024}e.$_u=c;class g{constructor(h,l,u){this.remoteAddress=h,this.localAddress=l,this.b=u,this.a=new D.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$av=g;let p=class{constructor(h,l){this.j=h,this.k=l,this.a=new D.$Md,this.onTunnelOpened=this.a.event,this.b=new D.$Md,this.onTunnelClosed=this.b.event,this.c=new D.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],l=Array.from(this.e.values());for(const u of l){const b=Array.from(u.values());for(const k of b){const t=await k.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:l}of h.values())await l.then(u=>typeof u!="string"?u?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,l,u,b,k){this.p(h,l,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:l,localAddress:u,privacy:b,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,l){($(h)||E(h))&&(h=e.$8u[0]);const u=this.r(h,l);if(u)return++u.refcount,u.value}openTunnel(h,l,u,b,k,t=!1,a,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${u} on local port ${k}.`);const n=this.f??h;if(!n)return;if(l||(l="localhost"),b||(b=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(n,l,u,b,k,t,a,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const l=this.e.get(h.tunnelRemoteHost);if(l){const u=l.get(h.tunnelRemotePort);u&&(u.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,u))}}}}async o(h,l,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${l}.`);const b=u.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(l),b}}async closeTunnel(h,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${l} `);const u=this.e.get(h);if(u&&u.has(l)){const b=u.get(l);b.refcount=0,await this.o(h,l,b)}}p(h,l,u){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(l,{refcount:1,value:u})}async q(h,l){const u=this.e.get(h);if(u){const b=u.get(l),k=b?await b.value:void 0;(!k||typeof k=="string")&&u.delete(l),u.size===0&&this.e.delete(h)}}r(h,l){const u=[h];E(h)?(u.push(...e.$8u),u.push(...e.$0u)):$(h)&&u.push(...e.$0u);const b=u.map(k=>this.e.get(k));for(const k of b){const t=k?.get(l);if(t)return t}}canTunnel(h){return!!P(h)}t(h,l,u,b,k,t,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${u} on local port ${b}.`);const s=u;this.i.add(s);const n=b===void 0?u:b,i={elevationRequired:k?this.isPortPrivileged(n):!1},r={remoteAddress:{host:l,port:u},localAddressPort:b,privacy:t,public:t?t!==I.Private:void 0,protocol:a},o=h.forwardPort(r,i);return o?(this.p(l,u,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),o}};e.$bv=p,e.$bv=p=ye([x(0,L.$8i),x(1,N.$hi)],p)}),define(oe[229],ae([0,1,7,76,2,8,5]),function(te,e,D,N,A,L,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=void 0;class C extends A.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$bh),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends A.$Rc{static{I=this}static{this.a=0}constructor(E,$){super(),this.f=E,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(E,$,c,g,p,w,h){const l=new C,u=await Promise.resolve(this.f.openTunnel(E,l,c,g,p,w,h));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${g} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),l.dispose(),await u.dispose(),(0,L.$5)();return l.setTunnel(u),this.b.set($,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${u.localAddress} (local) to ${c}:${g} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,$){const c=this.b.get(E);c&&c.setAddress($)}async destroyTunnel(E){const $=this.b.get(E);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await $.dispose();return}this.c.add(E)}};e.$E8b=d,e.$E8b=d=I=ye([x(0,N.$5u),x(1,D.$8i)],d)}),define(oe[28],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,D.$Nh)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,21,128,3,2]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class d{static{this._clock=0}constructor($){this.uri=$,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let P=class{constructor($){this.g=$,this.c=new C.$Qc,this.f=2**16;const c=new Map,g=p=>{let w=c.get(p.scheme);return w===void 0&&(w=$.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,w)),w};this.c.add(I.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new L.$jg(g),this.d=new O.$ur((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,L.$vg)($));const c=this.d.get($);return c?c.touch().uri.with({fragment:$.fragment}):(this.d.set($,new d($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);d._clock=0,this.d.clear();const c=this.f*.5;for(let g=0;g<c;g++)this.d.set($[g][0],$[g][1].touch())}};e.$vr=P,e.$vr=P=ye([x(0,A.$9j)],P),(0,N.$sr)(D.$Fk,P,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class I extends N.$Rc{constructor(d,P,E,$,c,g){super(),this.f=d,this.g=P,this.h=E,this.j=$,this.m=c,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Md),this.onDidChangeFile=this.a.event,this.b=L.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,P){return this.g.open(this.t(d),P)}close(d){return this.g.close(d)}read(d,P,E,$,c){return this.g.read(d,P,E,$,c)}write(d,P,E,$,c){return this.g.write(d,P,E,$,c)}watch(d,P){this.b.set(d,d);const E=this.g.watch(this.t(d),P);return(0,N.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,P,E){return this.g.rename(this.t(d),this.t(P),E)}readFile(d,P){return this.g.readFile(this.t(d),P)}readFileStream(d,P,E){return this.g.readFileStream(this.t(d),P,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,P,E){return this.g.writeFile(this.t(d),P,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,P){return this.g.delete(this.t(d),P)}copy(d,P,E){if((0,A.$_j)(this.g))return this.g.copy(this.t(d),this.t(P),E);throw new Error("copy not supported")}cloneFile(d,P){if((0,A.$ak)(this.g))return this.g.cloneFile(this.t(d),this.t(P));throw new Error("clone not supported")}s(d){const P=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const $=this.u(E.resource);this.b.findSubstr($)&&P.push({resource:$,type:E.type})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$Y7b=I}),define(oe[77],ae([0,1,85]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CCb=e.$BCb=e.edit=void 0;function N(O,I,C,d){const P=(0,D.$US)(O,I,C,d)[0];return P&&(O=O.substring(0,P.offset)+P.content+O.substring(P.offset+P.length)),O}e.edit=N;function A(O,I,C){let d=C;for(;d>=0;){if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1)return d+1;if(d--,I.length===2&&d>=0&&O.charAt(d)===I.charAt(0))return d+2}return 0}e.$BCb=A;function L(O,I,C){let d=C;for(;d>=0;)if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1||(d++,I.length===2&&d>=0&&O.charAt(d)===I.charAt(1)))return d;return O.length-1}e.$CCb=L}),define(oe[232],ae([0,1,30,53,12]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=void 0;function L(c,g,p,w,h,l){const u=[],b=[],k=[];if(!g){const q=c.filter(({identifier:_})=>h.every(K=>K.toLowerCase()!==_.id.toLowerCase()));return{local:{added:u,removed:b,updated:k},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}c=c.map(E),g=g.map(E),p=p?p.map(E):null;const t=new Map,a=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};c.forEach(({identifier:q})=>a(q)),g.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),w?.forEach(({identifier:q})=>a(q)),l?.forEach(q=>a(q));const s=q=>{const _=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${q.identifier.id.toLowerCase()}`},n=(q,_)=>(q.set(s(_),_),q),i=c.reduce(n,new Map),r=g.reduce(n,new Map),o=g.reduce((q,_)=>n(q,(0,D.$2m)(_)),new Map),v=p?p.reduce(n,new Map):null,y=w.reduce(n,new Map),f=h.reduce((q,_)=>{const K=t.get(_.toLowerCase());return q.add(K?`uuid:${K}`:`id:${_.toLowerCase()}`)},new Set),m=l?l.reduce((q,{id:_,uuid:K})=>(K=K??t.get(_.toLowerCase()),q.add(K?`uuid:${K}`:`id:${_.toLowerCase()}`)),new Set):null,j=O(i,r,f,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const q=O(v,i,f,!1),_=O(v,r,f,!0),K=(Y,G,Q,H)=>{let V,W,ee;return G.installed?(V=H.pinned,ee=H.preRelease,V&&(W=H.version)):(V=Q.pinned,ee=Q.preRelease,V&&(W=Q.version)),V===void 0&&(V=G.pinned,V&&(W=G.version)),ee===void 0&&(ee=G.preRelease),{...H,installed:G.installed||Q.installed,pinned:V,preRelease:ee,version:W??(Q.version&&(!G.installed||N.gt(Q.version,G.version))?Q.version:G.version),state:C(G,Q,v?.get(Y))}};for(const Y of _.removed.values()){const G=i.get(Y);if(!G)continue;const Q=(0,A.$If)(v?.get(Y)),H=m&&!m.has(Y)&&Q.installed;G.installed&&H?b.push(G.identifier):o.set(Y,G)}for(const Y of _.added.values()){const G=(0,A.$If)(r.get(Y)),Q=i.get(Y);if(Q){if(j.updated.has(Y)){const H=K(Y,Q,G,G);I(Q,G,!1,!1)||k.push($(H,Y)),o.set(Y,H)}}else G.installed&&u.push($(G,Y))}for(const Y of _.updated.values()){const G=(0,A.$If)(r.get(Y)),Q=(0,A.$If)(v?.get(Y)),H=i.get(Y);if(H)if(m&&!m.has(Y)&&Q.installed&&H.installed&&!G.installed)b.push(H.identifier);else{const W=K(Y,H,G,G);k.push($(W,Y)),o.set(Y,W)}else G.installed&&u.push($(G,Y))}for(const Y of q.added.values())_.added.has(Y)||o.set(Y,(0,A.$If)(i.get(Y)));for(const Y of q.updated.values()){if(_.removed.has(Y)||_.updated.has(Y))continue;const G=(0,A.$If)(i.get(Y)),Q=(0,A.$If)(r.get(Y));o.set(Y,K(Y,G,Q,G))}for(const Y of q.removed.values())_.updated.has(Y)||_.removed.has(Y)||y.has(Y)||(0,A.$If)(r.get(Y)).installed&&m&&(m.has(Y)||!(0,A.$If)(v?.get(Y)).installed||o.delete(Y))}const M=[],T=O(r,o,new Set,!0),U=T.added.size>0||T.updated.size>0||T.removed.size>0;return U&&o.forEach((q,_)=>M.push($(q,_))),{local:{added:u,removed:b,updated:k},remote:U?{added:[...T.added].map(q=>o.get(q)),updated:[...T.updated].map(q=>o.get(q)),removed:[...T.removed].map(q=>r.get(q)),all:M}:null}}e.$j3b=L;function O(c,g,p,w){const h=c?[...c.keys()].filter(t=>!p.has(t)):[],l=[...g.keys()].filter(t=>!p.has(t)),u=l.filter(t=>!h.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),b=h.filter(t=>!l.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),k=new Set;for(const t of h){if(b.has(t))continue;const a=c.get(t),s=g.get(t);(!s||!I(a,s,w,!0))&&k.add(t)}return{added:u,removed:b,updated:k}}function I(c,g,p,w){return!(c.disabled!==g.disabled||!!c.isApplicationScoped!=!!g.isApplicationScoped||w&&c.installed!==g.installed||c.installed&&g.installed&&(c.preRelease!==g.preRelease||c.pinned!==g.pinned||g.pinned&&c.version!==g.version)||!P(c.state,g.state)||p&&c.version!==g.version)}function C(c,g,p){const w=c.state,h=g.state,l=p?.state;if(!g.version||w&&N.gt(c.version,g.version))return w;if(h&&N.gt(g.version,c.version)||!w)return h;if(!h)return w;const u=(0,D.$2m)(w),b=l?d(l,h):{added:Object.keys(h).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},k=l?d(l,w):{added:Object.keys(w).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])u[t]=h[t];for(const t of b.removed.values())k.updated.has(t)||delete u[t];return u}function d(c,g){const p=Object.keys(c),w=Object.keys(g),h=w.filter(b=>!p.includes(b)).reduce((b,k)=>(b.add(k),b),new Set),l=p.filter(b=>!w.includes(b)).reduce((b,k)=>(b.add(k),b),new Set),u=new Set;for(const b of p){if(l.has(b))continue;const k=c[b],t=g[b];(0,D.$6m)(k,t)||u.add(b)}return{added:h,removed:l,updated:u}}function P(c={},g={}){const{added:p,removed:w,updated:h}=d(c,g);return p.size===0&&w.size===0&&h.size===0}function E(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function $(c,g){const p={...c,identifier:{id:c.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,19,4]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AEb=e.$zEb=void 0,e.$zEb=(0,A.$Nh)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==I&&P!==`-${I}`),C&&d.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(I,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==I&&P!==`-${I}`),C&&d.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(I){const C=I.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),d=this.b().map($=>$.toLowerCase()),P=[],E=[];if(Array.isArray(d))for(const $ of d)$.startsWith("-")?E.push($.substring(1)):P.push($);return(0,D.$Lb)([...C,...P].filter($=>!E.includes($)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$AEb=L,e.$AEb=L=ye([x(0,N.$hi)],L)}),define(oe[233],ae([0,1,18,35,30,94,77]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p3b=void 0;function I(b){return(0,N.$Rm)(b)||[]}async function C(b,k,t,a,s){const n=I(b),i=I(k),r=t?I(t):null,o=[...n,...i,...r||[]].map(K=>K.key),v=await s.resolveUserBindings(o),y=P(n,i,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const f=$(n),m=$(i),j=r?$(r):null,M=g(f,m,v),T=j?g(j,f,v):{added:[...f.keys()].reduce((K,Y)=>(K.add(Y),K),new Set),removed:new Set,updated:new Set},U=j?g(j,m,v):{added:[...m.keys()].reduce((K,Y)=>(K.add(Y),K),new Set),removed:new Set,updated:new Set},q=d(M,T,U);let _=b;for(const K of q.removed.values())q.conflicts.has(K)||(_=l(_,K,a));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const Y=m.get(K);if(Y.some(G=>G.command!==`-${K}`&&y.conflicts.has(v[G.key]))){q.conflicts.add(K);continue}_=h(_,Y,a)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const Y=m.get(K);if(Y.some(G=>G.command!==`-${K}`&&y.conflicts.has(v[G.key]))){q.conflicts.add(K);continue}_=u(_,K,Y,a)}return{mergeContent:_,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$p3b=C;function d(b,k,t){const a=new Set,s=new Set,n=new Set,i=new Set;for(const r of k.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(k.updated.has(r)?i.add(r):s.add(r));for(const r of k.added.values())i.has(r)||t.added.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(k.added.has(r)?b.updated.has(r)&&i.add(r):a.add(r));for(const r of k.updated.values())i.has(r)||t.updated.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(k.updated.has(r)?b.updated.has(r)&&i.add(r):n.add(r));return{added:a,removed:s,updated:n,conflicts:i}}function P(b,k,t,a){const s=new Set,n=E(b,a),i=E(k,a),r=t?E(t,a):null,o=c(n,i);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const v=r?c(r,n):{added:[...n.keys()].reduce((T,U)=>(T.add(U),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const y=r?c(r,i):{added:[...i.keys()].reduce((T,U)=>(T.add(U),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:f,removed:m,updated:j,conflicts:M}=d(o,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:m,updated:j,conflicts:M}}function E(b,k){const t=new Map;for(const a of b){const s=k[a.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(a)}return t}function $(b){const k=new Map;for(const t of b){const a=t.command[0]==="-"?t.command.substring(1):t.command;let s=k.get(a);s||(s=[],k.set(a,s)),s.push(t)}return k}function c(b,k){const t=[...b.keys()],a=[...k.keys()],s=a.filter(r=>!t.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),n=t.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const o=b.get(r).map(y=>({...y,key:r})),v=k.get(r).map(y=>({...y,key:r}));(0,D.$tb)(o,v,(y,f)=>w(y,f))||i.add(r)}return{added:s,removed:n,updated:i}}function g(b,k,t){const a=[...b.keys()],s=[...k.keys()],n=s.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),i=a.filter(o=>!s.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(i.has(o))continue;const v=b.get(o).map(f=>({...f,key:t[f.key]})),y=k.get(o).map(f=>({...f,key:t[f.key]}));p(v,y)||r.add(o)}return{added:n,removed:i,updated:r}}function p(b,k){return!(!(0,D.$tb)(b.filter(({command:t})=>t[0]!=="-"),k.filter(({command:t})=>t[0]!=="-"),(t,a)=>w(t,a))||!(0,D.$tb)(b.filter(({command:t})=>t[0]==="-"),k.filter(({command:t})=>t[0]==="-"),(t,a)=>w(t,a)))}function w(b,k){if(b.command!==k.command||b.key!==k.key)return!1;const t=L.$Li.deserialize(b.when),a=L.$Li.deserialize(k.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!A.$6m(b.args,k.args))}function h(b,k,t){for(const a of k)b=O.edit(b,[-1],a,t);return b}function l(b,k,t){const a=I(b);for(let s=a.length-1;s>=0;s--)(a[s].command===k||a[s].command===`-${k}`)&&(b=O.edit(b,[s],void 0,t));return b}function u(b,k,t,a){const s=I(b),n=s.findIndex(i=>i.command===k||i.command===`-${k}`);for(let i=s.length-1;i>=0;i--)(s[i].command===k||s[i].command===`-${k}`)&&(b=O.edit(b,[i],void 0,a));for(let i=t.length-1;i>=0;i--)b=O.edit(b,[n],t[i],a);return b}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=e.$w3b=void 0;function D(L,O,I){const C={},d={},P=new Set;if(!O)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=N(L,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(I,L),c=N(I,O),g={},p={},w=new Set,h=new Set;for(const l of $.removed.values())c.updated.has(l)?C[l]=O[l]:w.add(l);for(const l of c.removed.values())h.has(l)||($.updated.has(l)?h.add(l):P.add(l));for(const l of $.updated.values())h.has(l)||(c.updated.has(l)?E.updated.has(l)&&h.add(l):p[l]=L[l]);for(const l of c.updated.values())h.has(l)||($.updated.has(l)?E.updated.has(l)&&h.add(l):L[l]!==void 0&&(d[l]=O[l]));for(const l of $.added.values())h.has(l)||(c.added.has(l)?E.updated.has(l)&&h.add(l):g[l]=L[l]);for(const l of c.added.values())h.has(l)||($.added.has(l)?E.updated.has(l)&&h.add(l):C[l]=O[l]);return{local:{added:C,removed:[...P.values()],updated:d},remote:{added:g,removed:[...w.values()],updated:p},conflicts:[...h.values()]}}e.$w3b=D;function N(L,O){const I=L?Object.keys(L):[],C=O?Object.keys(O):[],d=C.filter($=>!I.includes($)).reduce(($,c)=>($.add(c),$),new Set),P=I.filter($=>!C.includes($)).reduce(($,c)=>($.add(c),$),new Set),E=new Set;for(const $ of I){if(P.has($))continue;const c=L[$],g=O[$];c!==g&&E.add($)}return{added:d,removed:P,updated:E}}function A(L,O){const{added:I,removed:C,updated:d}=N(L,O);return I.size===0&&C.size===0&&d.size===0}e.$x3b=A}),define(oe[235],ae([0,1,30]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=void 0;function N(L,O,I,C){const d={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!O){const $=L.filter(({id:c})=>!C.includes(c));return $.length?P.added=$:P=null,{local:d,remote:P}}const E=A(L,O,C);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const $=A(I,L,C),c=A(I,O,C);for(const g of c.removed){const p=L.find(w=>w.id===g);p&&d.removed.push(p)}for(const g of c.added){const p=O.find(w=>w.id===g);$.added.includes(g)?E.updated.includes(g)&&d.updated.push(p):d.added.push(p)}for(const g of c.updated)d.updated.push(O.find(p=>p.id===g));for(const g of $.added)c.added.includes(g)||P.added.push(L.find(p=>p.id===g));for(const g of $.updated)c.removed.includes(g)||c.updated.includes(g)||P.updated.push(L.find(p=>p.id===g));for(const g of $.removed){const p=O.find(w=>w.id===g);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:d,remote:P}}e.$e5b=N;function A(L,O,I){L=L?L.filter(({id:c})=>!I.includes(c)):[],O=O.filter(({id:c})=>!I.includes(c));const C=L.map(({id:c})=>c),d=O.map(({id:c})=>c),P=d.filter(c=>!C.includes(c)),E=C.filter(c=>!d.includes(c)),$=[];for(const{id:c,name:g,shortName:p,icon:w,useDefaultFlags:h}of L){if(E.includes(c))continue;const l=O.find(u=>u.id===c);(!l||l.name!==g||l.shortName!==p||l.icon!==w||!(0,D.$6m)(l.useDefaultFlags,h))&&$.push(c)}return{added:P,removed:E,updated:$}}}),define(oe[25],ae([0,1,18,12,174,49,29,4,103,40]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.MergeState=e.Change=e.SyncStatus=e.$Cgb=e.$Bgb=e.$Agb=e.UserDataSyncErrorCode=e.$zgb=e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=e.$sgb=e.$rgb=e.SyncResource=e.$qgb=e.$pgb=e.$ogb=e.$ngb=e.$mgb=e.$lgb=void 0;function P(){const i=d.$bn.as(L.$gn.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$lgb=P;function E(){const i=d.$bn.as(L.$gn.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(y=>!!i[y].ignoreSync),o=Object.keys(i).filter(y=>i[y].scope===2||i[y].scope===6),v=P();return(0,D.$Lb)([...r,...o,...v])}e.$mgb=E,e.$ngb="settingsSync",e.$ogb="settingsSync.keybindingsPerPlatform";function $(){const i="vscode://schemas/ignoredSettings",r=d.$bn.as(L.$gn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$ogb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:O.$Sn,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$bn.as(C.$cn.JSONContribution),v=()=>{const y=P(),f=E(),m=Object.keys(L.$hn.properties).filter(T=>!f.includes(T)),j=f.filter(T=>!y.includes(T)),M={items:{type:"string",enum:[...m,...j.map(T=>`-${T}`)]}};o.registerSchema(i,M)};return r.onDidUpdateConfiguration(()=>v())}e.$pgb=$;function c(i){return i&&(0,N.$zf)(i)&&(0,N.$xf)(i.id)&&Array.isArray(i.scopes)}e.$qgb=c;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$rgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...r){return i?[i,...r]:r}e.$sgb=p;function w(i,r,o,v){return v.joinPath(o.userDataSyncHome,...p(i,r,`lastSync${r}.json`))}e.$tgb=w,e.$ugb=(0,I.$Nh)("IUserDataSyncStoreManagementService"),e.$vgb=(0,I.$Nh)("IUserDataSyncStoreService"),e.$wgb=(0,I.$Nh)("IUserDataSyncLocalStoreService"),e.$xgb="x-operation-id",e.$ygb="X-Execution-Id";function h(i){const r={};return r[e.$ygb]=i,r}e.$zgb=h;var l;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(l||(e.UserDataSyncErrorCode=l={}));class u extends Error{constructor(r,o,v,y){super(r),this.code=o,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Agb=u;class b extends u{constructor(r,o,v,y,f){super(r,v,void 0,f),this.url=o,this.serverCode=y}}e.$Bgb=b;class k extends u{constructor(r,o){super(r,o)}}e.$Cgb=k,function(i){function r(o){if(o instanceof i)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new i(o.message,v[1],y,f)}return new i(o.message,"Unknown")}i.toUserDataSyncError=r}(u||(e.$Agb=u={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var a;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(a||(e.Change=a={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Dgb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$Egb=n,e.$Fgb=(0,I.$Nh)("IUserDataSyncEnablementService"),e.$Ggb=(0,I.$Nh)("IUserDataSyncService"),e.$Hgb=(0,I.$Nh)("IUserDataSyncResourceProviderService"),e.$Igb=(0,I.$Nh)("IUserDataAutoSyncService"),e.$Jgb=(0,I.$Nh)("IUserDataSyncUtilService"),e.$Kgb=(0,I.$Nh)("IUserDataSyncLogService"),e.$Lgb="userDataSync",e.$Mgb="vscode-userdata-sync",e.$Ngb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VDb=void 0;function A(O,I,C,d,P){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=L(O,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=C?L(C,I):{added:Object.keys(I).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},c=C?L(C,O):{added:Object.keys(O).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=D.$2m(I),w=!C;for(const l of c.added.values())l!==N.$Dgb&&w&&$.added.has(l)||(p[l]=O[l]);for(const l of c.updated.values())p[l]=O[l];for(const l of c.removed.values())d.unregistered.includes(l)||delete p[l];for(const l of $.added.values()){const u=I[l];if(d.machine.includes(l)){P.info(`GlobalState: Skipped adding ${l} in local storage because it is declared as machine scoped.`);continue}if(C&&c.added.has(l))continue;const b=O[l];b&&b.value===u.value||l===N.$Dgb&&w&&c.added.has(l)||(b?g.updated[l]=u:g.added[l]=u)}for(const l of $.updated.values()){const u=I[l];if(d.machine.includes(l)){P.info(`GlobalState: Skipped updating ${l} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(l)||c.removed.has(l))continue;const b=O[l];b&&b.value===u.value||(g.updated[l]=u)}for(const l of $.removed.values()){if(d.machine.includes(l)){P.trace(`GlobalState: Skipped removing ${l} in local storage because it is declared as machine scoped.`);continue}c.updated.has(l)||c.removed.has(l)||g.removed.push(l)}const h=L(I,p);return{local:g,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:p}}}e.$VDb=A;function L(O,I){const C=Object.keys(O),d=Object.keys(I),P=d.filter(c=>!C.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),E=C.filter(c=>!d.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),$=new Set;for(const c of C){if(E.has(c))continue;const g=O[c],p=I[c];D.$6m(g,p)||$.add(c)}return{added:P,removed:E,updated:$}}}),define(oe[237],ae([0,1,18,35,85,41,30,77,25]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ICb=e.$HCb=e.$GCb=e.$FCb=e.$ECb=e.$DCb=void 0;function d(o,v,y){let f=[];y?f=E(y):f=P(v);const m=[],j=[...(0,C.$lgb)()];if(Array.isArray(f))for(const M of f)M.startsWith("-")?j.push(M.substring(1)):m.push(M);return(0,D.$Lb)([...o,...m].filter(M=>!j.includes(M)))}e.$DCb=d;function P(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,N.$Rm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function $(o,v){const y=(0,N.$Rm)(o)||{};let f="{}";for(const m of Object.keys(y)){const j=(0,A.$US)(f,[m],y[m],v);f=(0,A.$XS)(f,j)}return f}e.$ECb=$;function c(o,v,y,f){if(y.length){const m=r(v),j=(0,N.$Rm)(v)||{},M=(0,N.$Rm)(o);if(!M)return o;const T=[];for(const U of y){const q=j[U],_=M[U];q===void 0?o=I.edit(o,[U],void 0,f):_!==void 0?o=I.edit(o,[U],q,f):T.push(t(U,m))}T.sort((U,q)=>U.startOffset-q.startOffset),T.forEach(U=>o=l(U.setting.key,v,o,f))}return o}e.$FCb=c;function g(o,v,y,f,m,j){const M=c(o,v,f,j),T=y!==M,U=y!==v;if(!T&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!U)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(U&&!T)return{conflictsSettings:[],localContent:c(v,o,f,j),remoteContent:null,hasConflicts:!1};if(y===null&&w(o)){const R=p(o,v,f)?null:c(v,o,f,j);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let q=o,_=v;const K=(0,N.$Rm)(o),Y=(0,N.$Rm)(v),G=y?(0,N.$Rm)(y):null,Q=f.reduce((R,z)=>(R.add(z),R),new Set),H=h(K,Y,Q),V=h(G,K,Q),W=h(G,Y,Q),ee=new Map,ne=new Set,re=R=>{ne.add(R);const z=m.filter(({key:F})=>F===R)[0];z?(q=I.edit(q,[R],z.value,j),_=I.edit(_,[R],z.value,j)):ee.set(R,{key:R,localValue:K[R],remoteValue:Y[R]})};for(const R of V.removed.values())W.updated.has(R)?re(R):_=I.edit(_,[R],void 0,j);for(const R of W.removed.values())ne.has(R)||(V.updated.has(R)?re(R):q=I.edit(q,[R],void 0,j));for(const R of V.updated.values())ne.has(R)||(W.updated.has(R)?H.updated.has(R)&&re(R):_=I.edit(_,[R],K[R],j));for(const R of W.updated.values())ne.has(R)||(V.updated.has(R)?H.updated.has(R)&&re(R):q=I.edit(q,[R],Y[R],j));for(const R of V.added.values())ne.has(R)||(W.added.has(R)?H.updated.has(R)&&re(R):_=l(R,q,_,j));for(const R of W.added.values())ne.has(R)||(V.added.has(R)?H.updated.has(R)&&re(R):q=l(R,_,q,j));const X=ee.size>0||!p(q,_,f),B=X||!p(q,o,[]),S=X||!p(_,v,[]);return{localContent:B?q:null,remoteContent:S?_:null,conflictsSettings:[...ee.values()],hasConflicts:X}}e.$GCb=g;function p(o,v,y){if(o===v)return!0;const f=(0,N.$Rm)(o),m=(0,N.$Rm)(v),j=y.reduce((U,q)=>(U.add(q),U),new Set),M=r(o).filter(U=>!(U.setting&&j.has(U.setting.key))),T=r(v).filter(U=>!(U.setting&&j.has(U.setting.key)));if(M.length!==T.length)return!1;for(let U=0;U<M.length;U++){const q=M[U],_=T[U];if(q.setting&&_.setting){if(q.setting.key!==_.setting.key||!O.$6m(f[q.setting.key],m[q.setting.key]))return!1}else if(!q.setting&&!_.setting){if(q.value!==_.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$HCb=w;function h(o,v,y){const f=o?Object.keys(o).filter(U=>!y.has(U)):[],m=Object.keys(v).filter(U=>!y.has(U)),j=m.filter(U=>!f.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),M=f.filter(U=>!m.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),T=new Set;if(o)for(const U of f){if(M.has(U))continue;const q=o[U],_=v[U];O.$6m(q,_)||T.add(U)}return{added:j,removed:M,updated:T}}function l(o,v,y,f){const m=(0,N.$Rm)(v),j=r(v),M=r(y),T=u(o,j,M);return b(y,o,m[o],T,M,f)}e.$ICb=l;function u(o,v,y){const f=v.findIndex(j=>j.setting?.key===o),m=v[f-1];if(m){if(m.setting){const M=t(m.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!0}}else{const M=a(f,v);if(M){const T=t(M.setting.key,y);if(T){const U=s(y.indexOf(T),y),q=n(v,M,v[f]);if(U){const _=n(y,T,U),K=i(q,_);return K?{index:y.indexOf(K),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const _=n(y,T,y[y.length-1]),K=i(q,_);return K?{index:y.indexOf(K),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const j=v[f+1];if(j)if(j.setting){const M=t(j.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!1}}else{const M=s(f,v);if(M){const T=t(M.setting.key,y);if(T){const U=a(y.indexOf(T),y),q=n(v,v[f],M);if(U){const _=n(y,U,T),K=i(q.reverse(),_.reverse());return K?{index:y.indexOf(K),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const _=n(y,y[0],T),K=i(q.reverse(),_.reverse());return K?{index:y.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function b(o,v,y,f,m,j){let M;return f.index===-1?M=(0,A.$US)(o,[v],y,j):M=k(o,v,y,f,m,j).map(T=>(0,A.$VS)(o,T,j)[0]),(0,A.$XS)(o,M)}function k(o,v,y,f,m,j){const M=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,T=(0,L.$RS)(j,o),U=m[f.index];if(f.insertAfter){const q=[];if(U.setting)q.push({offset:U.endOffset,length:0,content:","+M});else{const _=s(f.index,m),K=a(f.index,m),Y=K?.setting?.commaOffset;K&&Y===void 0&&q.push({offset:K.endOffset,length:0,content:","});const G=Y!==void 0&&Y>U.endOffset;q.push({offset:G?Y+1:U.endOffset,length:0,content:_?T+M+",":T+M})}return q}else{if(U.setting)return[{offset:U.startOffset,length:0,content:M+","}];const q=(m[f.index-1]&&!m[f.index-1].setting?T:"")+M+(s(f.index,m)?",":"")+T;return[{offset:U.startOffset,length:0,content:q}]}}function t(o,v){return v.filter(y=>y.setting?.key===o)[0]}function a(o,v){for(let y=o-1;y>=0;y--)if(v[y].setting)return v[y]}function s(o,v){for(let y=o+1;y<v.length;y++)if(v[y].setting)return v[y]}function n(o,v,y){const f=o.indexOf(v),m=o.indexOf(y);return o.filter((j,M)=>f<M&&M<m)}function i(o,v){if(o.length&&v.length){let y=0;for(;y<v.length&&y<o.length;y++)if(o[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(o){const v=[];let y=-1,f,m;const j={onObjectBegin:M=>{y++},onObjectProperty:(M,T,U)=>{y===0&&(f=T,m=M)},onObjectEnd:(M,T)=>{y--,y===0&&v.push({startOffset:f,endOffset:M+T,value:o.substring(f,M+T),setting:{key:m,commaOffset:void 0}})},onArrayBegin:(M,T)=>{y++},onArrayEnd:(M,T)=>{y--,y===0&&v.push({startOffset:f,endOffset:M+T,value:o.substring(f,M+T),setting:{key:m,commaOffset:void 0}})},onLiteralValue:(M,T,U)=>{y===0&&v.push({startOffset:f,endOffset:T+U,value:o.substring(f,T+U),setting:{key:m,commaOffset:void 0}})},onSeparator:(M,T,U)=>{if(y===0&&M===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const _=v[q];_&&v.splice(q,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:T}})}},onComment:(M,T)=>{y===0&&v.push({startOffset:M,endOffset:M+T,value:o.substring(M,M+T)})}};return(0,N.$Ym)(o,j),v}}),define(oe[78],ae([0,1,3,2,4,25]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oCb=e.$nCb=void 0,e.$nCb=(0,A.$Nh)("IUserDataSyncAccountService");let O=class extends N.$Rc{get account(){return this.a}constructor(C,d){super(),this.g=C,this.h=d,this.b=this.B(new D.$Md),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Md),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$oCb=O,e.$oCb=O=ye([x(0,L.$vgb),x(1,L.$Kgb)],O)}),define(oe[238],ae([0,1,2,9]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.$x8b=e.$w8b=e.$v8b=e.$u8b=e.$t8b=e.$s8b=void 0;class A{constructor($){this.a=$}listen($,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$s8b=A;class L{constructor($){this.a=$}listen($,c){throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$t8b=L;class O{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$u8b=O;class I{constructor($){this.a=$}listen($,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call($,c,g){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$v8b=I;class C{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$w8b=C;class d{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$x8b=d;class P extends D.$Rc{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:N.URI.revive($.url),type:$.type,defaultUrl:N.URI.revive($.defaultUrl),insidersUrl:N.URI.revive($.insidersUrl),stableUrl:N.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$y8b=P}),define(oe[239],ae([0,1,21,175,14,7,25]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BEb=void 0;let I=class extends L.$aj{constructor(d,P){super(),this.g=this.B(d.createLogger((0,D.$ug)(P.logsHome,`${O.$Lgb}.log`),{id:O.$Lgb,name:(0,N.localize)(0,null)}))}trace(d,...P){this.g.trace(d,...P)}debug(d,...P){this.g.debug(d,...P)}info(d,...P){this.g.info(d,...P)}warn(d,...P){this.g.warn(d,...P)}error(d,...P){this.g.error(d,...P)}flush(){this.g.flush()}};e.$BEb=I,e.$BEb=I=ye([x(0,L.$9i),x(1,A.$Uh)],I)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=e.$Y8b=void 0,e.$Y8b=(0,N.$Nh)("voiceRecognitionService");let L=class{constructor(I,C){this.a=I,this.b=C}async transcribe(I,C){const d=process.env.VSCODE_VOICE_MODULE_PATH;if(!d||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${I.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();try{const E=te.__$__nodeRequire(d),$=new AbortController;C.onCancellationRequested(()=>$.abort());const c=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:I},{language:"en",signal:$.signal});return this.a.info(`[voice] transcribe(${I.length}): Text "${c}", took ${Date.now()-P}ms)`),c}catch(E){throw this.a.error(`[voice] transcribe(${I.length}): Failed width "${E}", took ${Date.now()-P}ms)`),E}}};e.$Z8b=L,e.$Z8b=L=ye([x(0,D.$8i),x(1,A.$nj)],L)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,D,N,A,L,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=void 0;let C=class extends D.$Rc{static{I=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(c,g,p){super(),this.b=c,this.c=g,this.f=p,this.g()}g(){this.B(this.b(c=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${I.a})`),I.a?this.B(new P(c,this.c,this.f)):this.B(new E(c,this.c,this.f))}))}};e.$18b=C,e.$18b=C=I=ye([x(1,N.$Y8b),x(2,A.$8i)],C);class d extends D.$Rc{static{this.a=30*16e3*16*1/8}constructor(c,g,p){super(),this.b=c,this.c=g,this.f=p,this.g()}g(){const c=new L.$Wd;this.B((0,D.$Pc)(()=>c.dispose(!0)));const g=w=>{w.data instanceof Float32Array&&this.h(w.data,c.token)};this.b.on("message",g),this.B((0,D.$Pc)(()=>this.b.off("message",g))),this.b.start();let p=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),p=!0,this.dispose()}),this.B((0,D.$Pc)(()=>{p||this.b.close()}))}j(c){const g=new Float32Array(c.reduce((w,h)=>w+h.length,0));let p=0;for(const w of c)g.set(w,p),p+=w.length;return g}}class P extends d{constructor(){super(...arguments),this.m=this.B(new O.$Zg),this.n=[],this.r=new Float32Array(0)}async h(c,g){if(c.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,c]):c;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const p=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(p,g))}}async t(c,g){if(!g.isCancellationRequested){if(c.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(c.length!==0){const p=await this.c.transcribe(c,g);p&&this.n.push(p)}g.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends d{constructor(){super(...arguments),this.m=new O.$1g,this.n=void 0,this.r=0,this.s=""}async h(c,g){const p=this.n?this.j([this.n,c]):c;if(p.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=p,this.m.queue(()=>this.u(g))}async u(c){if(c.isCancellationRequested)return;const g=this.n?.slice(0);if(!g)return;let p;g.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),p=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),p=await this.c.transcribe(g,c)),this.s=p,this.r=g.length,!c.isCancellationRequested&&this.b.postMessage(p)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;class L extends A.$Rc{constructor({onDidOpenWindow:I,onDidFocusWindow:C,getActiveWindowId:d}){super(),this.a=this.B(new A.$Qc),N.Event.latch(N.Event.any(I,C))(this.f,this,this.a),this.b=(0,D.$Gg)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$v7b=L}),define(oe[113],ae([0,1,178,16,47,21,9,4,23]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,I.$Nh)("contextService");function d(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}e.$Xh=d;function P(n){return typeof n?.id=="string"&&!d(n)&&!$(n)}e.$Yh=P,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function E(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$mc)(n)}:i?e.$Zh:e.$1h;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=E;function $(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}e.$3h=$;function c(n){const i=n;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$4h=c;var g;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$5h=p;function w(n){const i=n;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$6h=w;class h{constructor(i,r,o,v,y){this.h=i,this.j=o,this.k=v,this.l=y,this.c=A.$Th.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=A.$Th.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=h;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.$ug)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=l;function u(n){return new l({uri:n,index:0,name:(0,L.$qg)(n)},{uri:n.toString()})}e.$9h=u,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,D.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function b(n,i){return L.$lg.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$bi=b;function k(n){let i;return O.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===C.Schemas.tmp}e.$ci=k,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$di}e.$ei=t;function a(n,i){return!b(n,i)&&!k(n)}e.$fi=a;function s(n){return(typeof n=="string"?(0,N.$nc)(n):(0,L.$sg)(n))===e.$$h}e.$gi=s}),define(oe[17],ae([0,1,51,3,2,21,9,169,14,11,4,7,113,34,28,5,32,27,12]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var u;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function b(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$Gk=b,e.$Hk=(0,P.$Nh)("IUserDataProfilesService");function k(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:i}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Ik=k;function t(n,i,r,o,v,y){return{id:n,name:i,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,L.$ug)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,L.$ug)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,L.$ug)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,L.$ug)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,L.$ug)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,L.$ug)(r,"extensions.json"),cacheHome:(0,L.$ug)(o,n),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Jk=t;let a=class extends A.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,r,o,v){super(),this.t=i,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new N.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),r=[i];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,l.$xf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,L.$rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},i))}}catch(y){this.y.error(y)}const o=new c.$zc,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[f,m]of Object.entries(y.workspaces)){const j=O.URI.parse(f),M=r.find(T=>T.id===m);M&&o.set(j,M)}if(y.emptyWindows)for(const[f,m]of Object.entries(y.emptyWindows)){const j=r.find(M=>M.id===m);j&&v.set(f,j)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,h.$Ee)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const m=o.exec(f.name),j=m?parseInt(m[1]):0;v=j>v?j:v}const y=`${r} ${v+1}`;return this.createProfile((0,D.$Bi)((0,w.$dg)()).toString(16),y,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,D.$Bi)((0,w.$dg)()).toString(16),i,r,o)}async createProfile(i,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(i,r,o);return v&&await this.setProfileForWorkspace(v,y),y}async F(i,r,o){if(!(0,l.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(j=>j.name===r||j.id===i);if(y)return y;const f=t(i,r,(0,L.$ug)(this.profilesHome,i),this.g,o,this.defaultProfile);await this.u.createFolder(f.location);const m=[];return this.j.fire({profile:f,join(j){m.push(j)}}),await p.Promises.settled(m),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=t(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$mk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.G(i);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(i){return(0,$.$Xh)(i)?i.uri:(0,$.$3h)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location)))}I(i,r,o){const v=[...this.profiles,...i],y=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(m=>f.id===m.id)||(f=o.find(m=>f.id===m.id)??f,f.isTransient?this.s.profiles.push(f):y.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(y),this.z=void 0,this.J(i,r,o)}J(i,r,o){this.h.fire({added:i,removed:r,updated:o,all:this.profiles})}L(i,r,o){o=r?.isTransient?!0:o,o||this.L(i,void 0,!0);const v=this.G(i),y=o?this.s:this.C;O.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),o||this.M()}M(){const i={};for(const[o,v]of this.C.workspaces.entries())i[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:i,emptyWindows:r}),this.z=void 0}N(i){const r={},o=this.D();if(i.workspaces)for(const[y,f]of Object.entries(i.workspaces)){const m=O.URI.parse(f);r[y]=this.w.extUri.isEqual(m,o.location)?o.id:this.w.extUri.basename(m)}const v={};if(i.emptyWindows)for(const[y,f]of Object.entries(i.emptyWindows)){const m=O.URI.parse(f);v[y]=this.w.extUri.isEqual(m,o.location)?o.id:this.w.extUri.basename(m)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Kk=a,e.$Kk=a=ye([x(0,C.$Uh),x(1,d.$9j),x(2,g.$Fk),x(3,E.$8i)],a);class s extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Lk=s}),define(oe[242],ae([0,1,5,2,17]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let L=class extends N.$Rc{constructor(I){super(),this.B(new D.$5g(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$G8b=L,e.$G8b=L=ye([x(0,A.$Hk)],L)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,12,9,152,29,33,44,7,24,22,28,17]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=void 0;let b=class extends I.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,r,o,v,y,f){super(),this.z=i,this.C=r,this.D=o,this.F=v,this.G=y,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Md),this.s=this.B(new O.$Md),this.t=this.B(new O.$Md),this.u=this.B(new O.$Md),this.w=this.B(new O.$Md),this.y=[],this.B((0,I.$Pc)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.m.forEach(m=>m.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,$.$3n)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const v=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:y})=>(0,c.$vo)(y,i.identifier));if(v?.local)return v?.local;throw v?.error?v.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(o){throw t(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new $.$7n(E.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(i.map(async({extension:v,options:y})=>{try{const f=await this.O(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...f,options:y})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,c.$Do)(v.source),error:v.error}));return r}async uninstall(i,r={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,r)}async toggleAppliationScope(i,r){if((0,g.$5l)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(i,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$vo)(f.identifier,i.identifier));y?this.w.fire(y):this.u.fire({identifier:i.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const r=[];return await Promise.allSettled(i.map(async o=>{try{const v=await this.J(o);r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Ao)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:i,extension:r,options:o}){const v=o.isApplicationScoped||o.isBuiltin||(0,g.$5l)(i),y={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},f=q=>`${c.$wo.create(q).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const q=this.j.get(f(r));if(q)return this.F.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const m=[],j=[],M=[],T=this.Z(i,r,y);P.URI.isUri(r)||this.j.set(f(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",T.identifier.id),m.push({task:T,manifest:i});let U=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const _=await this.N(T.identifier,i,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),K=await this.getInstalled(void 0,y.profileLocation),Y={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[$.$Xn]:!0}};for(const{gallery:G,manifest:Q}of(0,D.$Lb)(_,({gallery:H})=>H.identifier.id)){U=U||!!Q.extensionDependencies?.some(W=>(0,c.$vo)({id:W},T.identifier));const H=f(G),V=this.j.get(H);if(V){if(this.L(T,V.task)){const W=V.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,T.identifier.id),V.waitingTasks.push(T),j.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,c.$vo)(ne.identifier,W)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,T.identifier.id),!ee.find(re=>(0,c.$vo)(re.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!K.some(({identifier:W})=>(0,c.$vo)(W,G.identifier))){const W=this.Z(Q,G,Y);this.j.set(H,{task:W,waitingTasks:[T]}),this.n.fire({identifier:W.identifier,source:G,profileLocation:y.profileLocation}),this.F.info("Installing extension:",W.identifier.id,T.identifier.id),m.push({task:W,manifest:Q})}}}catch(_){if(P.URI.isUri(T.source))(0,D.$Kb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,_.message),(0,D.$Kb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,_.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),_}const q=m.reduce((_,{task:K,manifest:Y})=>(_.set(K.identifier.id.toLowerCase(),{task:K,manifest:Y}),_),new Map);for(;q.size;){let _;const K=[...q.values()].filter(({manifest:Y})=>!Y.extensionDependencies?.some(G=>q.has(G.toLowerCase())));K.length?_=q.size===1?K:K.filter(({task:Y})=>!(Y===T&&!U)):(this.F.info("Found extensions with circular dependencies",K.map(({task:Y})=>Y.identifier.id)),_=[...q.values()]),await this.M(_.map(async({task:Y})=>{const G=new Date().getTime();try{const Q=await Y.run();if(await this.M(this.y.map(H=>H.postInstall(Q,Y.source,y,A.CancellationToken.None))),!P.URI.isUri(Y.source)){const H=Y.operation===3,V=H?void 0:(new Date().getTime()-Y.source.lastUpdated)/1e3;if(a(this.C,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Do)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:V}),C.$p&&Y.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}M.push({local:Q,identifier:Y.identifier,operation:Y.operation,source:Y.source,context:Y.options.context,profileLocation:Y.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw P.URI.isUri(Y.source)||a(this.C,Y.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Do)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-G,error:Q}),this.F.error("Error while installing the extension:",Y.identifier.id),Q}finally{q.delete(Y.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),M.forEach(({identifier:_})=>this.F.info("Extension installed successfully:",_.id)),M}catch(q){if(m.forEach(({task:_})=>_.cancel()),M.length)try{const _=await Promise.allSettled(M.map(({local:K})=>this.$(K,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let K=0;K<_.length;K++){const Y=_[K],{identifier:G}=M[K];Y.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",G.id):this.F.warn("Rollback: Error while uninstalling extension",G.id,(0,L.$9)(Y.reason))}}catch(_){this.F.warn("Error while rolling back extensions",(0,L.$9)(_),M.map(({identifier:K})=>K.id))}return m.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:y.context,profileLocation:y.profileLocation,error:q}))}finally{for(const{task:q}of m)q.source&&!P.URI.isUri(q.source)&&this.j.delete(f(q.source))}}L(i,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===i&&(v.includes(r)||v.some(y=>this.L(y,r)))||o===r&&v[0]&&!this.L(i,v[0]))return!1;return!0}async M(i){const r=[],o=[],v=await Promise.allSettled(i);for(const y of v)y.status==="fulfilled"?r.push(y.value):o.push(y.reason);if(o.length)throw k(o);return r}async N(i,r,o,v,y){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,y),m=[],j=[],M=async(T,U)=>{m.push(T);const q=U.extensionDependencies||[],_=[...q];if(U.extensionPack){const K=o?f.find(Y=>(0,c.$vo)(Y.identifier,T)):void 0;for(const Y of U.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(G=>(0,c.$vo)({id:G},{id:Y}))||_.every(G=>!(0,c.$vo)({id:G},{id:Y}))&&_.push(Y)}if(_.length){const K=_.filter(Y=>m.every(G=>!(0,c.$vo)(G,{id:Y})));if(K.length){const Y=await this.z.getExtensions(K.map(G=>({id:G,preRelease:v})),A.CancellationToken.None);for(const G of Y){if(m.find(V=>(0,c.$vo)(V,G.identifier)))continue;const Q=q.some(V=>(0,c.$vo)({id:V},G.identifier));let H;try{H=await this.O(G,!1,v)}catch(V){if(Q)throw V;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,L.$9)(V));continue}j.push({gallery:H.extension,manifest:H.manifest}),await M(H.extension.identifier,H.manifest)}}}};return await M(i,r),j}async O(i,r,o){let v;const y=await this.getExtensionsControlManifest();if(y.malicious.some(j=>(0,c.$vo)(i.identifier,j)))throw new $.$7n(E.localize(1,null,i.identifier.id),$.ExtensionManagementErrorCode.Malicious);const f=y.deprecated[i.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!v)throw new $.$7n(E.localize(2,null,i.identifier.id,f.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const j=await this.getTargetPlatform();throw new $.$7n(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,$.$Yn)(j)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(i,r,o),!v)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],A.CancellationToken.None))[0]?new $.$7n(E.localize(4,null,i.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$7n(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const m=await this.z.getManifest(v,A.CancellationToken.None);if(m===null)throw new $.$7n(`Missing manifest for extension ${v.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(m.version!==v.version)throw new $.$7n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:m}}async P(i,r,o){const v=await this.getTargetPlatform();let y=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(y=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(i,o,v)&&(y=i),y||(r?y=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(i,o,v)),y}async Q(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(v(i.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const f=T=>{const U=this.$(T,o);return this.m.set(v(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),U},m=(T,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Co)(T),error:U}),this.u.fire({identifier:T.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},j=[],M=[];try{j.push(f(i));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.U(i,T);for(const q of U)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):j.push(f(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(j.map(U=>U.extension),T,i),await this.M(j.map(async U=>{try{if(await U.run(),await this.M(this.y.map(q=>q.postUninstall(U.extension,o,A.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}m(U.extension)}catch(q){const _=q instanceof $.$7n?q:new $.$7n((0,L.$9)(q),$.ExtensionManagementErrorCode.Internal);throw m(U.extension,_),_}finally{M.push(U)}}))}catch(T){const U=T instanceof $.$7n?T:new $.$7n((0,L.$9)(T),$.ExtensionManagementErrorCode.Internal);for(const q of j){try{q.cancel()}catch{}M.includes(q)||m(q.extension,U)}throw U}finally{for(const T of j)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(i,r,o){for(const v of i){const y=this.W(v,r);if(y.length){const f=y.filter(m=>!i.some(j=>(0,c.$vo)(j.identifier,m.identifier)));if(f.length)throw new Error(this.S(v,f,o))}}}S(i,r,o){return o===i?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const v=i.manifest.extensionPack?i.manifest.extensionPack:[];if(v.length){const y=r.filter(m=>!m.isBuiltin&&v.some(j=>(0,c.$vo)({id:j},m.identifier))),f=[];for(const m of y)f.push(...this.U(m,r,o));return[...y,...f]}return[]}W(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,c.$vo)({id:v},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$lp=b,e.$lp=b=ye([x(0,$.$6n),x(1,h.$_k),x(2,l.$Fk),x(3,p.$8i),x(4,w.$nj),x(5,u.$Hk)],b);function k(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$mp=k;function t(n){if(n instanceof $.$7n)return n;const i=new $.$7n(n.message,$.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$np=t;function a(n,i,{extensionData:r,verificationStatus:o,duration:v,error:y,durationSinceUpdate:f}){let m,j;(0,d.$Ff)(o)&&(o===!0?o="Verified":(o===!1||(m=$.ExtensionManagementErrorCode.Signature,j=o),o="Unverified")),y&&(y instanceof $.$7n?(m=y.code,y.code===$.ExtensionManagementErrorCode.Signature&&(j=y.message)):m=$.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!y,duration:v,errorcode:m,errorcodeDetail:j,durationSinceUpdate:f})}class s{constructor(){this.d=new N.$Rg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Gg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Gg)(i=>new Promise((r,o)=>{const v=i.onCancellationRequested(()=>{v.dispose(),o(new L.$4)})})),this.d.open()),this.g.cancel()}}e.$op=s}),define(oe[50],ae([0,1,5,15,2,3,34,9,29,33,11,4,7,17,28,12,8,22]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class u extends Error{constructor(s,n){super(s),this.code=n}}e.$pp=u,e.$qp=(0,E.$Nh)("IExtensionsProfileScannerService");let b=class extends A.$Rc{constructor(s,n,i,r,o,v){super(),this.j=s,this.m=n,this.n=i,this.r=r,this.s=o,this.t=v,this.b=this.B(new L.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.u(n,o=>{const v=[];for(const y of o)s.some(([f])=>(0,d.$vo)(f.identifier,y.identifier)&&f.manifest.version!==y.version)?i.push(y):v.push(y);for(const[y,f]of s){const m=v.findIndex(M=>(0,d.$vo)(M.identifier,y.identifier)&&M.version===y.manifest.version),j={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:f};m===-1?(r.push(j),v.push(j)):v.splice(m,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),v}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:o,profileLocation:n}),o}}async updateMetadata(s,n){const i=[];return await this.u(n,r=>{const o=[];for(const v of r){const y=s.find(([f])=>(0,d.$vo)(f.identifier,v.identifier)&&f.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},i.push(v)),o.push(v)}return o}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.u(n,r=>{const o=[];for(const v of r)(0,d.$vo)(v.identifier,s.identifier)?i.push(v):o.push(v);return i.length&&this.f.fire({extensions:i,profileLocation:n}),o}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async u(s,n,i){return this.F(s).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(s);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$mk)(v)!==1)throw v;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&i?.bailOutWhenFileNotFound)throw new u((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(s);let v=!1;for(const y of o){k(y)||this.w(s);let f;if((0,p.$xf)(y.relativeLocation)&&y.relativeLocation)f=this.z(y.relativeLocation);else if((0,p.$xf)(y.location))f=this.z(y.location),v=!0,y.relativeLocation=y.location,y.location=f.toJSON();else{f=I.URI.revive(y.location);const m=this.y(f);m&&(v=!0,y.relativeLocation=m)}r.push({identifier:y.identifier,location:f,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(s,N.$ae.fromString(JSON.stringify(o)))}if(n){r=n(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(s,N.$ae.fromString(JSON.stringify(v)))}return r})}w(s){const n=new u(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(s)).value.toString()}catch(o){if((0,P.$mk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const o=JSON.parse(i);Array.isArray(o)&&o.every(v=>k(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.$mk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(s)}catch(o){(0,P.$mk)(o)!==1&&this.t.error(o)}try{await this.m.del(n)}catch(o){(0,P.$mk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(s){let n=this.h.get(s);return n||(n=new D.$Zg,this.h.set(s,n)),n}};e.$rp=b,e.$rp=b=ye([x(1,P.$9j),x(2,c.$Hk),x(3,g.$Fk),x(4,h.$_k),x(5,$.$8i)],b);function k(a){return(0,p.$zf)(a)&&(0,C.$5n)(a.identifier)&&(t(a.location)||(0,p.$xf)(a.location)&&a.location)&&((0,p.$Ef)(a.relativeLocation)||(0,p.$xf)(a.relativeLocation))&&a.version&&(0,p.$xf)(a.version)}function t(a){return a?(0,p.$xf)(a.path)&&(0,p.$xf)(a.scheme):!1}}),define(oe[79],ae([0,1,18,5,30,15,8,35,139,2,23,16,6,21,53,89,12,9,155,14,33,44,67,11,4,7,24,3,63,50,17,28,183]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a,s,n,i,r,o,v,y,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.Translations=void 0;var j;(function(Y){function G(Q,H){if(Q===H)return!0;const V=Object.keys(Q),W=new Set;for(const ee of Object.keys(H))W.add(ee);if(V.length!==W.size)return!1;for(const ee of V){if(Q[ee]!==H[ee])return!1;W.delete(ee)}return W.size===0}Y.equals=G})(j||(e.Translations=j={})),e.$up=(0,s.$Nh)("IExtensionsScannerService");let M=class extends d.$Rc{constructor(G,Q,H,V,W,ee,ne,re,X,B,S,R){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Q,this.r=H,this.s=V,this.t=W,this.u=ee,this.w=ne,this.y=re,this.z=X,this.C=B,this.D=S,this.F=R,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,c.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Go)(this.w,this.y)),this.G}async scanAllExtensions(G,Q,H){const[V,W]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Q)]),ee=H?await this.scanExtensionsUnderDevelopment(G,[...V,...W]):[];return this.L(V,W,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Q=[];Q.push(this.M(!!G.useCache,G.language)),Q.push(this.N(G.language,!!G.checkControlFile));const[H,V]=await Promise.all(Q);return this.J([...H,...V],0,G,!1)}async scanUserExtensions(G){const Q=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const H=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Q,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,H),W=G.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ee;try{ee=await W.scanExtensions(V)}catch(ne){if(ne instanceof v.$pp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await W.scanExtensions(V);else throw ne}return ee=await this.J(ee,1,G,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(G,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const W=await this.P(V,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(ne=>(ne.type=Q.find(re=>(0,b.$vo)(re.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,W)))}))).flat();return this.J(H,"development",G,!0)}return[]}async scanExistingExtension(G,Q,H){const V=await this.P(G,!1,Q,!0,H.language,!0,void 0),W=await this.n.scanExtension(V);return!W||!H.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(G,Q,H){const V=await this.P(G,!1,Q,!0,H.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(V);return this.J(W,Q,H,!0)}async scanMetadata(G){const Q=(0,c.$ug)(G,"package.json"),H=(await this.w.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(G,Q){const H=(0,c.$ug)(G,"package.json"),V=(await this.w.readFile(H)).value.toString(),W=JSON.parse(V);Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,W.__metadata={...W.__metadata,...Q},await this.w.writeFile((0,c.$ug)(G,"package.json"),L.$ae.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$pp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ae.fromString(JSON.stringify([])))}catch(Q){(0,a.$mk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,Q,H,V){return H.includeAllVersions||(G=this.L(Q===0?G:void 0,Q===1?G:void 0,Q==="development"?G:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(G=G.filter(W=>W.isValid)),G.sort((W,ee)=>{const ne=E.$mc(W.location.fsPath),re=E.$mc(ee.location.fsPath);return ne<re?-1:ne>re?1:0})}L(G,Q,H,V,W){const ee=(re,X,B)=>{if(re.isValid&&!X.isValid)return!1;if(re.isValid===X.isValid){if(W&&g.gt(re.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,X.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===V)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${re.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${X.location.path}.`),!0},ne=new k.$4l;return G?.forEach(re=>{const X=ne.get(re.identifier.id);(!X||ee(X,re,!1))&&ne.set(re.identifier.id,re)}),Q?.forEach(re=>{const X=ne.get(re.identifier.id);if(!X&&G&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!X||ee(X,re,!1))&&ne.set(re.identifier.id,re)}),H?.forEach(re=>{const X=ne.get(re.identifier.id);(!X||ee(X,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async M(G,Q){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),W=await(G&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",W.length),W}async N(G,Q){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Q?await this.O():{},W=[],ee=h.URI.file(E.$gc(E.$ic(P.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of H){const X=V[re.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":W.push((0,c.$ug)(ee,re.name));break;default:W.push(h.URI.file(X));break}}const ne=await Promise.all(W.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,D.$Gb)(ne)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,Q,H,V,W,ee,ne){const re=await this.f(W??$.$w),X=await this.Q(G),B=Q&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=B?await this.Q(B):void 0;return new T(G,X,B,S,Q,ne,H,V,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,re)}async Q(G){try{const Q=await this.w.stat(G);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$vp=M,e.$vp=M=ye([x(4,y.$Hk),x(5,v.$qp),x(6,a.$9j),x(7,n.$8i),x(8,u.$Uh),x(9,i.$nj),x(10,f.$Fk),x(11,s.$Mh)],M);class T{constructor(G,Q,H,V,W,ee,ne,re,X,B,S,R,z,F,J){this.location=G,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=re,this.validate=X,this.productVersion=B,this.productDate=S,this.productCommit=R,this.devMode=z,this.language=F,this.translations=J}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Q){return(0,c.$ng)(G.location,Q.location)&&G.mtime===Q.mtime&&(0,c.$ng)(G.applicationExtensionslocation,Q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&G.profile===Q.profile&&A.$6m(G.profileScanOptions,Q.profileScanOptions)&&G.type===Q.type&&G.excludeObsolete===Q.excludeObsolete&&G.validate===Q.validate&&G.productVersion===Q.productVersion&&G.productDate===Q.productDate&&G.productCommit===Q.productCommit&&G.devMode===Q.devMode&&G.language===Q.language&&j.equals(G.translations,Q.translations)}}e.$wp=T;let U=class extends d.$Rc{constructor(G,Q,H,V,W){super(),this.f=G,this.g=Q,this.h=H,this.j=V,this.m=W}async scanExtensions(G){const Q=G.profile?await this.r(G):await this.n(G);let H={};if(G.excludeObsolete&&G.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,w.$Kf)(H)?Q:Q.filter(V=>!H[b.$wo.create(V).toString()])}async n(G){const Q=await this.j.resolve(G.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||G.type===1&&(0,c.$rg)(V.resource).indexOf(".")===0)return null;const W=new T(V.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(W)}));return(0,D.$Gb)(H).sort((V,W)=>V.location.path<W.location.path?-1:1)}async r(G){let Q=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(G.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,G);Q.push(...H)}return Q}async s(G,Q,H){const V=await this.g.scanProfileExtensions(G,H.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async ee=>{if(Q(ee)){const ne=new T(ee.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,D.$Gb)(W)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,c.$ug)(G.location,"package.json"))){const Q=await this.scanExtension(G);return Q?[Q]:[]}else return await this.scanExtensions(G)}catch(Q){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,O.$9)(Q)),[]}}async scanExtension(G,Q){try{let H=await this.scanExtensionManifest(G.location);if(H){H.publisher||(H.publisher=k.$Xl),Q=Q??H.__metadata,delete H.__metadata;const V=(0,b.$Ao)(H.publisher,H.name),W=Q?.id?{id:V,uuid:Q.id}:{id:V},ee=Q?.isSystem?0:G.type,ne=ee===0||!!Q?.isBuiltin;H=await this.t(G.location,H,T.createNlsConfiguration(G));const re={type:ee,identifier:W,manifest:H,location:G.location,isBuiltin:ne,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return G.validate?this.validate(re,G):re}}catch(H){G.type!==0&&this.m.error(H)}return null}validate(G,Q){let H=!0;const V=(0,t.$Lo)(Q.productVersion,Q.productDate,Q.location,G.manifest,G.isBuiltin);for(const[W,ee]of V)W===p.default.Error&&(H=!1,this.m.error(this.z(Q.location,ee)));return G.isValid=H,G.validations=V,G}async scanExtensionManifest(G){const Q=(0,c.$ug)(G,"package.json");let H;try{H=(await this.j.readFile(Q)).value.toString()}catch(W){return(0,a.$mk)(W)!==1&&this.m.error(this.z(G,(0,l.localize)(0,null,Q.path,W.message))),null}let V;try{V=JSON.parse(H)}catch{const ee=[];(0,I.$Rm)(H,ee);for(const ne of ee)this.m.error(this.z(G,(0,l.localize)(1,null,Q.path,ne.offset,ne.length,(0,C.$sp)(ne.error))));return null}return(0,I.$1m)(V)!=="object"?(this.m.error(this.z(G,(0,l.localize)(2,null,Q.path))),null):V}async t(G,Q,H){const V=await this.u(G,Q,H);if(V)try{const W=[],ee=await this.w(V.default,W);if(W.length>0)return W.forEach(re=>{this.m.error(this.z(G,(0,l.localize)(3,null,V.default?.path,(0,C.$sp)(re.error))))}),Q;if((0,I.$1m)(V)!=="object")return this.m.error(this.z(G,(0,l.localize)(4,null,V.default?.path))),Q;const ne=V.values||Object.create(null);return(0,m.$tp)(this.m,Q,ne,ee)}catch{}return Q}async u(G,Q,H){const V=(0,c.$ug)(G,"package.nls.json"),W=(X,B)=>{B.forEach(S=>{this.m.error(this.z(G,(0,l.localize)(5,null,X?.path,(0,C.$sp)(S.error))))})},ee=X=>{this.m.error(this.z(G,(0,l.localize)(6,null,X?.path)))},ne=`${Q.publisher}.${Q.name}`,re=H.translations[ne];if(re)try{const X=h.URI.file(re),B=(await this.j.readFile(X)).value.toString(),S=[],R=(0,I.$Rm)(B,S);return S.length>0?(W(X,S),{values:void 0,default:V}):(0,I.$1m)(R)!=="object"?(ee(X),{values:void 0,default:V}):{values:R.contents?R.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let B;try{B=await this.y(G,H)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const S=(await this.j.readFile(B.localized)).value.toString(),R=[],z=(0,I.$Rm)(S,R);return R.length>0?(W(B.localized,R),{values:void 0,default:B.original}):(0,I.$1m)(z)!=="object"?(ee(B.localized),{values:void 0,default:B.original}):{values:z,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(G,Q){if(G)try{const H=(await this.j.readFile(G)).value.toString();return(0,I.$Rm)(H,Q)}catch{}}y(G,Q){return new Promise((H,V)=>{const W=ee=>{const ne=(0,c.$ug)(G,`package.nls.${ee}.json`);this.j.exists(ne).then(re=>{re&&H({localized:ne,original:(0,c.$ug)(G,"package.nls.json")});const X=ee.lastIndexOf("-");X===-1?H({localized:(0,c.$ug)(G,"package.nls.json"),original:null}):(ee=ee.substring(0,X),W(ee))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,c.$ug)(G,"package.nls.json"),original:null});W(Q.language)})}z(G,Q){return`[${G.path}]: ${Q}`}};U=ye([x(1,v.$qp),x(2,f.$Fk),x(3,a.$9j),x(4,n.$8i)],U);let q=class extends U{constructor(G,Q,H,V,W,ee,ne){super(Q,V,W,ee,ne),this.G=G,this.H=H,this.D=this.B(new N.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(G){const Q=this.M(G),H=await this.I(Q);if(this.C=G,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),H.result.map(W=>(W.location=h.URI.revive(W.location),W));const V=await super.scanExtensions(G);return await this.J(Q,{input:G,result:V}),V}async I(G){try{const Q=await this.j.readFile(G),H=JSON.parse(Q.value.toString());return{result:H.result,input:(0,o.$kh)(H.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",G.path,(0,O.$9)(Q))}return null}async J(G,Q){try{await this.j.writeFile(G,L.$ae.fromString(JSON.stringify(Q)))}catch(H){this.m.debug("Error while writing the extension cache file:",G.path,(0,O.$9)(H))}}async L(){if(!this.C)return;const G=this.M(this.C),Q=await this.I(G);if(!Q)return;const H=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$6m(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(G),this.F.fire()}catch(W){this.m.error(W)}}M(G){const Q=this.N(G);return this.h.extUri.joinPath(Q.cacheHome,G.type===0?k.$Wl:k.$Vl)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(G.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([x(2,y.$Hk),x(3,v.$qp),x(4,f.$Fk),x(5,a.$9j),x(6,n.$8i)],q);function _(Y,G){const Q=(0,b.$yo)(Y.manifest.publisher,Y.manifest.name);return{id:Q,identifier:new k.$2l(Q),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:G,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}e.$xp=_;class K extends M{constructor(G,Q,H,V,W,ee,ne,re,X,B,S,R){super(G,Q,(0,c.$ug)(H,".vscode-oss-dev","extensions","control.json"),V,W,ee,ne,re,X,B,S,R),this.R=(async()=>{if($.$z)try{const z=await this.w.readFile(h.URI.file($.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$yp=K}),define(oe[244],ae([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let $=class extends O.$Rc{constructor(g,p){super(),this.b=g,this.f=p,this.a=new N.$Yg(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m(g))}catch(w){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(w)}}g(g,p){const w=`vscode:${p}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const h=g.manifest.scripts[w].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,C.$ic)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,p,w,h,l){return new Promise((u,b)=>{const k=this.j(g,p,w,l);let t;const a=s=>{t&&(clearTimeout(t),t=null),s?b(s):u(void 0)};k.on("error",s=>{a((0,A.$yi)(s)||"Unknown")}),k.on("exit",(s,n)=>{a(s?`post-${p} process exited with code ${s}`:void 0)}),h&&(t=setTimeout(()=>{t=null,k.kill(),b("timed out")},5e3))})}j(g,p,w,h){const l={silent:!0,execArgv:void 0},u=(0,D.fork)(g,[`--type=extension-post-${p}`,...w],l);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const b=L.Event.fromNodeEventEmitter(u.stdout,"data"),k=L.Event.fromNodeEventEmitter(u.stderr,"data");b(s=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,s)),k(s=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,s));const t=L.Event.any(L.Event.map(b,s=>({data:`%c${s}`,format:[""]})),L.Event.map(k,s=>({data:`%c${s}`,format:["color: red"]})));return L.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),u}m(g){return(0,C.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Ap=$,e.$Ap=$=ye([x(0,E.$Hk),x(1,P.$8i)],$)}),define(oe[245],ae([0,1,7,17,28,22,50,11,14,9]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;let P=class extends O.$rp{constructor($,c,g,p,w,h){super(d.URI.file($.extensionsPath),c,g,p,w,h)}};e.$uN=P,e.$uN=P=ye([x(0,C.$Vh),x(1,I.$9j),x(2,N.$Hk),x(3,A.$Fk),x(4,L.$_k),x(5,D.$8i)],P)}),define(oe[246],ae([0,1,9,14,50,79,11,4,7,24,28,17]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let $=class extends L.$yp{constructor(g,p,w,h,l,u,b,k){super(D.URI.file(l.builtinExtensionsPath),D.URI.file(l.extensionsPath),l.userHome,g.defaultProfile,g,p,w,h,l,u,b,k)}};e.$z7b=$,e.$z7b=$=ye([x(0,E.$Hk),x(1,A.$qp),x(2,O.$9j),x(3,C.$8i),x(4,N.$Vh),x(5,d.$nj),x(6,P.$Fk),x(7,I.$Mh)],$)}),define(oe[20],ae([0,1,5,3,2,100,12,66,4,17]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$2o=e.$1o=e.$Zo=void 0,e.$Zo="__$__isNewStorageMarker",e.$1o="__$__targetStorageMarker",e.$2o=(0,C.$Nh)("storageService");var P;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var $;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function c(l){const u=l.get(e.$1o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$3o=c;class g extends A.$Rc{static{this.a=60*1e3}constructor(u={flushInterval:g.a}){super(),this.m=u,this.b=this.B(new N.$Pd),this.c=this.B(new N.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new D.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,b,k){return N.Event.filter(this.b.event,t=>t.scope===u&&(b===void 0||t.key===b),k)}n(){this.j.value=(0,D.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,b){const{key:k,external:t}=b;if(k===e.$1o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:k,target:this.J(u)[k],external:t})}w(u){this.f.fire({reason:u})}get(u,b,k){return this.P(b)?.get(u,k)}getBoolean(u,b,k){return this.P(b)?.getBoolean(u,k)}getNumber(u,b,k){return this.P(b)?.getNumber(u,k)}getObject(u,b,k){return this.P(b)?.getObject(u,k)}storeAll(u,b){this.y(()=>{for(const k of u)this.store(k.key,k.value,k.scope,k.target,b)})}store(u,b,k,t,a=!1){if((0,O.$Gf)(b)){this.remove(u,k,a);return}this.y(()=>{this.z(u,k,t),this.P(k)?.set(u,b,a)})}remove(u,b,k=!1){this.y(()=>{this.z(u,b,void 0),this.P(b)?.delete(u,k)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,b){const k=[],t=this.J(u);for(const a of Object.keys(t))t[a]===b&&k.push(a);return k}z(u,b,k,t=!1){const a=this.J(b);typeof k=="number"?a[u]!==k&&(a[u]=k,this.P(b)?.set(e.$1o,JSON.stringify(a),t)):typeof a[u]=="number"&&(delete a[u],this.P(b)?.set(e.$1o,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const b=this.P(u);return b?c(b):Object.create(null)}isNew(u){return this.getBoolean(e.$Zo,u)===!0}async flush(u=P.NONE){this.f.fire({reason:u});const b=this.P(-1),k=this.P(0),t=this.P(1);switch(u){case P.NONE:await D.Promises.settled([b?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([b?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,b=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return h(u,b,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,b){return this.w(P.NONE),(0,d.$Gk)(u)?this.R(u,b):this.S(u,b)}M(u,b){return!(u.id===b.id||p(b)&&p(u))}N(u,b,k){this.y(()=>{const t=new Set;for(const[a,s]of u)t.add(a),b.get(a)!==s&&this.u(k,{key:a,external:!0});for(const[a]of b.items)t.has(a)||this.u(k,{key:a,external:!0})})}}e.$4o=g;function p(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$5o=p;class w extends g{constructor(){super(),this.U=this.B(new I.$Xo(new I.$Yo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Xo(new I.$Yo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Xo(new I.$Yo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$6o=w;async function h(l,u,b,k,t,a){const s=j=>{try{return JSON.parse(j)}catch{return j}},n=new Map,i=new Map;l.forEach((j,M)=>{n.set(M,j),i.set(M,s(j))});const r=new Map,o=new Map;u.forEach((j,M)=>{r.set(M,j),o.set(M,s(j))});const v=new Map,y=new Map;b.forEach((j,M)=>{v.set(M,j),y.set(M,s(j))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const f=[];if(n.forEach((j,M)=>{f.push({key:M,value:j})}),console.table(f),console.groupEnd(),console.log(i),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];r.forEach((M,T)=>{j.push({key:T,value:M})}),console.table(j),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const m=[];v.forEach((j,M)=>{m.push({key:M,value:j})}),console.table(m),console.groupEnd(),console.log(y)}e.$7o=h}),define(oe[114],ae([0,1,3,2,12,29,33,20]),function(te,e,D,N,A,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mCb=e.$lCb=void 0;let C=class extends N.$Rc{constructor(E,$){super(),this.a=new D.$Md,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B($.onDidInstallExtensions(c=>c.forEach(({local:g,operation:p})=>{g&&p===4&&this.f(g.identifier)})))}async enableExtension(E,$){return this.f(E)?(this.a.fire({extensions:[E],source:$}),!0):!1}async disableExtension(E,$){return this.c(E)?(this.a.fire({extensions:[E],source:$}),!0):!1}getDisabledExtensions(){return this.h(L.$9n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const $=this.getDisabledExtensions();return $.every(c=>!(0,O.$vo)(c,E))?($.push(E),this.g($),!0):!1}f(E){const $=this.getDisabledExtensions();for(let c=0;c<$.length;c++){const g=$[c];if((0,O.$vo)(g,E))return $.splice(c,1),this.g($),!0}return!1}g(E){this.j(L.$9n,E)}h(E){return this.b.get(E,0)}j(E,$){this.b.set(E,$,0)}};e.$lCb=C,e.$lCb=C=ye([x(0,I.$2o),x(1,L.$8n)],C);class d extends N.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$Qc))($=>this.f($)))}get(E,$){let c;return $===0?((0,A.$Gf)(this.a[E])&&(this.a[E]=this.g(E,$)),c=this.a[E]):c=this.g(E,$),JSON.parse(c)}set(E,$,c){const g=JSON.stringify($.map(({id:w,uuid:h})=>({id:w,uuid:h})));this.g(E,c)!==g&&(c===0&&($.length?this.a[E]=g:delete this.a[E]),this.h(E,$.length?g:void 0,c))}f(E){if(!(0,A.$Gf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const c=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),p=c.filter(h=>!g.some(l=>(0,O.$vo)(h,l))),w=g.filter(h=>!c.some(l=>(0,O.$vo)(l,h)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(E,$){return this.c.get(E,$,"[]")}h(E,$,c){$?this.c.store(E,$,c,1):this.c.remove(E,c)}}e.$mCb=d}),define(oe[247],ae([0,1,18,26,8,6,37,12,9,19,14,29,33,67,11,7,24,57,224,20,22,60]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=void 0;const t=L.$p?"web":(0,E.$1n)(L.$u,O.$dc),a="X-Market-Search-Activity-Id";var s;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...S){return String(S.reduce((R,z)=>R|z,0))}var i;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class f{constructor(R=y){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,z=this.d.pageSize){return new f({...this.d,pageNumber:R,pageSize:z})}withFilter(R,...z){const F=[...this.d.criteria,...z.length?z.map(J=>({filterType:R,value:J})):[{filterType:R}]];return new f({...this.d,criteria:F})}withSortBy(R){return new f({...this.d,sortBy:R})}withSortOrder(R){return new f({...this.d,sortOrder:R})}withFlags(...R){return new f({...this.d,flags:R.reduce((z,F)=>z|F,0)})}withAssetTypes(...R){return new f({...this.d,assetTypes:R})}withSource(R){return new f({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:z,pageSize:F,sortBy:J,sortOrder:Z,flags:se,assetTypes:le}=this.d;return{filters:[{criteria:R,pageNumber:z,pageSize:F,sortBy:J,sortOrder:Z}],assetTypes:le,flags:se}}get searchText(){const R=this.d.criteria.filter(z=>z.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function m(S,R){const z=(S||[]).filter(F=>F.statisticName===R)[0];return z?z.value:0}function j(S){const R="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(F=>F.assetType.indexOf(R)===0).reduce((F,J)=>{const Z=U(S,J.assetType);return Z&&F.push([J.assetType.substring(R.length),Z]),F},[])}function M(S){if(S.properties){const R=S.properties.filter(J=>J.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=R.filter(J=>z.test(J.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return U(S,r.Repository)}function T(S){return{uri:`${S.fallbackAssetUri}/${r.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${r.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function U(S,R){return S.files.filter(F=>F.assetType===R)[0]?{uri:`${S.assetUri}/${R}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${R}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function q(S,R){const z=S.properties?S.properties.filter(J=>J.key===R):[],F=z.length>0&&z[0].value;return F?F.split(",").map(J=>(0,$.$zo)(J)):[]}function _(S){const R=S.properties?S.properties.filter(z=>z.key===o.Engine):[];return R.length>0&&R[0].value||""}function K(S){const R=S.properties?S.properties.filter(z=>z.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function Y(S){const R=S.properties?S.properties.filter(F=>F.key===o.LocalizedLanguages):[],z=R.length>0&&R[0].value||"";return z?z.split(","):[]}function G(S){return S.properties?.find(R=>R.key===o.SponsorLink)?.value}function Q(S){return S.indexOf("preview")!==-1}function H(S){return S.targetPlatform?(0,E.$Zn)(S.targetPlatform):"undefined"}function V(S){const R=(0,D.$Lb)(S.versions.map(H)),z=!!S.tags?.includes(E.$Un),F=R.indexOf("web");return z?F===-1&&R.push("web"):F!==-1&&R.splice(F,1),R}function W(S,R){const z=(0,E.$4n)(R);for(let F=0;F<S.length;F++){const J=S[F];if(J.version===S[F-1]?.version){let Z=F;const se=H(J);if(se===R)for(;Z>0&&S[Z-1].version===J.version;)Z--;else if(z.includes(se))for(;Z>0&&S[Z-1].version===J.version&&H(S[Z-1])!==R;)Z--;Z!==F&&(S.splice(F,1),S.splice(Z,0,J))}}return S}e.$0o=W;function ee(S,R,z){S.telemetryData={index:R,querySource:z,queryActivityId:S.queryContext?.[a]}}function ne(S,R,z,F){const J=S.versions[0],Z={manifest:U(R,r.Manifest),readme:U(R,r.Details),changelog:U(R,r.Changelog),license:U(R,r.License),repository:M(R),download:T(R),icon:U(R,r.Icon),signature:U(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,$.$Ao)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:R.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(J),description:S.shortDescription||"",installCount:m(S.statistics,"install"),rating:m(S.statistics,"averagerating"),ratingCount:m(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:z,assets:Z,properties:{dependencies:q(R,o.Dependency),extensionPack:q(R,o.ExtensionPack),engine:_(R),localizedLanguages:Y(R),targetPlatform:H(R),isPreReleaseVersion:K(R)},hasPreReleaseVersion:K(J),hasReleaseVersion:!0,preview:Q(S.flags),isSigned:!!Z.signature,queryContext:F}}let re=class{constructor(R,z,F,J,Z,se,le,ue){this.k=z,this.l=F,this.n=J,this.o=Z,this.q=se,this.u=le,this.w=ue;const he=le.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,l.$9o)(le.version,le,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,z,F){const J=N.CancellationToken.isCancellationToken(z)?{}:z,Z=N.CancellationToken.isCancellationToken(z)?z:F,se=[],le=[],ue=[],he=[];let $e=!0;for(const Ee of R){Ee.uuid?le.push(Ee.uuid):se.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!Ie}if(!le.length&&!se.length)return[];let de=new f().withPage(1,R.length);le.length&&(de=de.withFilter(i.ExtensionId,...le)),se.length&&(de=de.withFilter(i.ExtensionName,...se)),(J.queryAllVersions||$e)&&(de=de.withFlags(de.flags,s.IncludeVersions)),J.source&&(de=de.withSource(J.source));const{extensions:we}=await this.z(de,{targetPlatform:J.targetPlatform??t,includePreRelease:ue,versions:he,compatible:!!J.compatible},Z);return J.source&&we.forEach((Ee,Ie)=>ee(Ee,Ie,J.source)),we}async getCompatibleExtension(R,z,F){if((0,E.$2n)(R.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(R,z,F))return R;const J=new f().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:Z}=await this.z(J,{targetPlatform:F,compatible:!0,includePreRelease:z},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(R,z,F){if(!(0,E.$3n)(R.properties.targetPlatform,R.allTargetPlatforms,F)||!z&&R.properties.isPreReleaseVersion)return!1;let J=R.properties.engine;if(!J){const Z=await this.getManifest(R,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");J=Z.engines.vscode}return(0,c.$No)(J,this.u.version,this.u.date)}async y(R,z,F,J,Z){if(!(0,E.$3n)(H(R),J,Z)||z!=="any"&&K(R)!==(z==="prerelease"))return!1;if(F)try{const se=await this.E(R);if(!(0,c.$No)(se,this.u.version,this.u.date))return!1}catch(se){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,A.$9)(se)),!1}return!0}async query(R,z){let F=R.text||"";const J=R.pageSize??50;let Z=new f().withPage(1,J);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(i.Category,we||de),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(i.Tag,we||de),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),Z=Z.withFilter(i.SearchText,F)),Z=Z.withSortBy(0)):R.ids?Z=Z.withFilter(i.ExtensionId,...R.ids):R.names?Z=Z.withFilter(i.ExtensionName,...R.names):Z=Z.withSortBy(4),typeof R.sortBy=="number"&&(Z=Z.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(Z=Z.withSortOrder(R.sortOrder)),R.source&&(Z=Z.withSource(R.source));const se=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:t,compatible:!1,includePreRelease:!!R.includePreRelease},de);return we.forEach((Ie,Ne)=>ee(Ie,($e.pageNumber-1)*$e.pageSize+Ne,R.source)),{extensions:we,total:Ee}},{extensions:le,total:ue}=await se(Z,z),he=async($e,de)=>{if(de.isCancellationRequested)throw new A.$4;const{extensions:we}=await se(Z.withPage($e+1),de);return we};return{firstPage:le,total:ue,pageSize:Z.pageSize,getPage:he}}async z(R,z,F){const J=R.flags;R.flags&s.IncludeLatestVersionOnly&&R.flags&s.IncludeVersions&&(R=R.withFlags(R.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(R.flags&s.IncludeLatestVersionOnly)&&!(R.flags&s.IncludeVersions)&&(R=R.withFlags(R.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(R=R.withFlags(R.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),R=R.withFlags(R.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:Z,total:se,context:le}=await this.B(R,F);if(!(R.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of Z){const Ee=await this.A(we,z,le);Ee&&de.push(Ee)}return{extensions:de,total:se}}const he=[],$e=new Map;for(let de=0;de<Z.length;de++){const we=Z[de],Ee={id:(0,$.$Ao)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,I.$Df)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Te=>(0,$.$vo)(Te,Ee))?.includePreRelease;if(z.compatible&&(0,E.$2n)(V(we),z.targetPlatform))continue;const Ne=await this.A(we,z,le);!Ne||Ne.properties.isPreReleaseVersion&&(!Ie||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==z.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Ne])}if($e.size){const de=new k.$Id,we=new f().withFlags(J&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(i.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,z,F);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of Ee){const Ne=$e.get(Ie.identifier.uuid);he.push([Ne,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:se}}async A(R,z,F){const J={id:(0,$.$Ao)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},Z=z.versions?.find(he=>(0,$.$vo)(he,J))?.version,se=(0,I.$Df)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(he=>(0,$.$vo)(he,J))?.includePreRelease,le=V(R),ue=W(R.versions,z.targetPlatform);if(z.compatible&&(0,E.$2n)(le,z.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(Z&&$e.version!==Z)){if(await this.y($e,se?"any":"release",z.compatible,le,z.targetPlatform))return ne(R,$e,le,F);if(Z&&$e.version===Z)return null}}return Z||z.compatible?null:ne(R,R.versions[0],le)}async B(R,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const F=await this.j,J=JSON.stringify(R.raw),Z={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},se=new k.$Id;let le,ue,he=0;try{if(le=await this.k.request({type:"POST",url:this.g&&R.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:Z},z),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$Uo)(le);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:le.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(J.length),duration:se.elapsed(),success:!!le&&(0,h.$Qo)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ue?(0,A.$3)(ue)?"canceled":(0,A.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(R,z,F,J){if(!this.isEnabled())return;const Z=L.$p?this.x(`/itemName/${R}.${z}/version/${F}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${z}/${F}/stats?statType=${J}`),se=L.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:se};try{await this.k.request({type:"POST",url:Z,headers:ue},N.CancellationToken.None)}catch{}}async download(R,z,F){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const J=(0,$.$Do)(R),Z=new Date().getTime(),se=de=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:de}),le=F===2?"install":F===3?"update":"",ue=le?{uri:`${R.assets.download.uri}${C.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${C.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,he=R.queryContext?.[a]?{[a]:R.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(z,$e.stream),se(new Date().getTime()-Z)}async downloadSignatureArchive(R,z){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const F=await this.D(R.assets.signature);await this.q.writeFile(z,F.stream)}async getReadme(R,z){if(R.assets.readme){const F=await this.D(R.assets.readme,{},z);return await(0,h.$To)(F)||""}return""}async getManifest(R,z){if(R.assets.manifest){const F=await this.D(R.assets.manifest,{},z),J=await(0,h.$To)(F);return J?JSON.parse(J):null}return null}async C(R,z){const F=U(R,r.Manifest);if(!F)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},Z=await this.D(F,{headers:J});return await(0,h.$Uo)(Z)}async getCoreTranslation(R,z){const F=R.assets.coreTranslations.filter(J=>J[0]===z.toUpperCase())[0];if(F){const J=await this.D(F[1]),Z=await(0,h.$To)(J);return Z?JSON.parse(Z):null}return null}async getChangelog(R,z){if(R.assets.changelog){const F=await this.D(R.assets.changelog,{},z);return await(0,h.$To)(F)||""}return""}async getAllCompatibleVersions(R,z,F){let J=new f().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?J=J.withFilter(i.ExtensionId,R.identifier.uuid):J=J.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:Z}=await this.B(J,N.CancellationToken.None);if(!Z.length)return[];const se=V(Z[0]);if((0,E.$2n)(se,F))return[];const le=[];await Promise.all(Z[0].versions.map(async $e=>{try{await this.y($e,z?"any":"release",!0,se,F)&&le.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of W(le,F))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:K($e)}));return ue}async D(R,z={},F=N.CancellationToken.None){const J=await this.j,Z={type:"GET"},se={...J,...z.headers||{}};z={...z,...Z,headers:se};const le=R.uri,ue=R.fallbackUri,he={...z,url:le};try{const $e=await this.k.request(he,F);if($e.res.statusCode===200)return $e;const de=await(0,h.$To)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,A.$3)($e))throw $e;const de=(0,A.$9)($e);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const we={...z,url:ue};return this.k.request(we,F)}}async E(R){let z=_(R);if(!z){const F=await this.C(R,N.CancellationToken.None);if(!F)throw new Error("Manifest was not found");z=F.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const R=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.$Uo)(R),F=[],J={},Z=[];if(z){for(const se of z.malicious)F.push({id:se});if(z.migrateToPreRelease)for(const[se,le]of Object.entries(z.migrateToPreRelease))(!le.engine||(0,c.$No)(le.engine,this.u.version,this.u.date))&&(J[se.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[se,le]of Object.entries(z.deprecated))le&&(J[se.toLowerCase()]=(0,I.$Df)(le)?{}:le);if(z.search)for(const se of z.search)Z.push(se)}return{malicious:F,deprecated:J,search:Z}}};re=ye([x(1,h.$Oo),x(2,p.$8i),x(3,P.$Uh),x(4,b.$_k),x(5,g.$9j),x(6,w.$nj),x(7,d.$hi)],re);let X=class extends re{constructor(R,z,F,J,Z,se,le,ue){super(R,z,F,J,Z,se,le,ue)}};e.$$o=X,e.$$o=X=ye([x(0,u.$2o),x(1,h.$Oo),x(2,p.$8i),x(3,P.$Uh),x(4,b.$_k),x(5,g.$9j),x(6,w.$nj),x(7,d.$hi)],X);let B=class extends re{constructor(R,z,F,J,Z,se,le){super(void 0,R,z,F,J,Z,se,le)}};e.$_o=B,e.$_o=B=ye([x(0,h.$Oo),x(1,p.$8i),x(2,P.$Uh),x(3,b.$_k),x(4,g.$9j),x(5,w.$nj),x(6,d.$hi)],B)}),define(oe[80],ae([0,1,4,3,2,20,33,24,18,7,12]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=void 0,e.$Ru=(0,D.$Nh)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends A.$Rc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$zo)(p.id)}@${p.version}`}static c(p){const w=$.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const h=await p.getInstalled(),l=[];for(const[u,b]of E.f(w)){const k=h.find(t=>(0,O.$vo)(t.identifier,{id:u}))?.manifest.version;for(const t of b)k!==t&&l.push(E.b({id:u,version:t}))}for(const u of l)w.remove(u,0)}static f(p){const w=new Map,h=p.keys(0,1);for(const l of h){const u=E.c(l);if(u){let b=w.get(u.id.toLowerCase());b||w.set(u.id.toLowerCase(),b=[]),b.push(u.version)}}return w}constructor(p,w,h){super(),this.j=p,this.m=w,this.n=h,this.g=this.B(new N.$Md),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Qc))(l=>this.r(l)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=E.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let h=this.h.get(w.id.toLowerCase());h||this.h.set(w.id.toLowerCase(),h=[]),h.push(w.version),this.g.fire()}return}}s(p){if((0,P.$xf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,h=p.manifest?p.manifest.name:p.name;return(0,O.$yo)(w,h)}getExtensionState(p,w){const h=this.s(p),l=this.getExtensionStateRaw(p,w);if(l)try{return JSON.parse(l)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${w}): ${u}`)}}getExtensionStateRaw(p,w){const h=this.s(p),l=this.j.get(h,w?0:1);return l&&l?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${w}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(p,w,h){const l=this.s(p);w===void 0?this.j.remove(l,h?0:1):this.j.store(l,JSON.stringify(w),h?0:1,1)}setKeysForSync(p,w){this.j.store(E.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],h=this.j.get(E.b(p),0),l=h?JSON.parse(h):void 0;return l&&w?(0,C.$Lb)([...l,...w]):l||w}addToMigrationList(p,w){if(p!==w){const h=this.t.filter(l=>!l.includes(p)&&!l.includes(w));h.push([p,w]),this.t=h}}getSourceExtensionToMigrate(p){const w=this.t.find(([,h])=>p===h);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Su=c,e.$Su=c=E=ye([x(0,L.$2o),x(1,I.$nj),x(2,d.$8i)],c)}),define(oe[248],ae([0,1,29,11,24,14,98,55,20,22,221]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=void 0;let E=class extends P.$b5b{constructor(c,g,p,w,h,l,u,b){super(c.userHome,h,g,p,w,l,u,b)}};e.$V8b=E,e.$V8b=E=ye([x(0,L.$Vh),x(1,d.$_k),x(2,D.$8n),x(3,C.$2o),x(4,I.$J6b),x(5,O.$uVb),x(6,N.$9j),x(7,A.$nj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,64,24,6,5,101,19,165,36,20,12,133,21]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=void 0;const k=[D.$K8b,D.$L8b],t="remoteTunnelSession",a="remoteTunnelIsService";let s=class extends O.$Rc{constructor(o,v,y,f,m,j,M){super(),this.y=o,this.z=v,this.C=y,this.D=j,this.F=M,this.f=new N.$Md,this.onDidTokenFailed=this.f.event,this.g=new N.$Md,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Md,this.onDidChangeMode=this.h.event,this.n=D.$I8b,this.w=!1,this.I=(T,U)=>{U?this.j.error(T):this.j.info(T)},this.j=this.B(f.createLogger((0,b.$ug)(y.logsHome,`${D.$M8b}.log`),{id:D.$M8b,name:D.$N8b})),this.t=new $.$Pg(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,I.$kj)(T)))),this.B(m.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(T=>{k.some(U=>T.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){i(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,C.$lc)((0,C.$lc)(this.C.appRoot)),this.u=(0,C.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(i(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(D.$I8b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const y=(U,q)=>{q?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],y);this.r=f;try{if(await f,this.r!==f)return;const U=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(D.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const m=this.n.active?this.n.session:void 0;if(m&&m.token){const U=m.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,m.accountLabel,m.providerId)));const q=(K,Y)=>{K=K.replaceAll(U,"*".repeat(4)),y(K,Y)},_=this.O("login",["user","login","--provider",m.providerId,"--access-token",U,"--log",(0,I.$kj)(this.j.getLevel())],q);this.r=_;try{if(await _,this.r!==_)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(m),this.G(D.TunnelStates.disconnected(m));return}}const j=this.Q();j?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,j))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const M=["--accept-server-license-terms","--log",(0,I.$kj)(this.j.getLevel())];j?M.push("--name",j):M.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(M)===!1),this.N(m,M,T)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,p.localize)(4,null);return this.j.warn(y),this.G(D.TunnelStates.connecting(y)),!1}return!0}async N(o,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const m=this.O("tunnel",v,(j,M)=>{M?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(f=!0);const T=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const U={link:T[1],domain:T[2],tunnelName:T[4],isAttached:f};this.G(D.TunnelStates.connected(U,y))}else j.match(/error refreshing token/)&&(m.cancel(),this.f.fire(o),this.G(D.TunnelStates.disconnected(o)))});this.r=m,m.finally(()=>{m===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$I8b,this.G(D.TunnelStates.disconnected()))})}O(o,v,y=this.I){return(0,$.$Gg)(f=>new Promise((m,j)=>{f.isCancellationRequested&&m(-1);let M;const T=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{M&&(this.j.info(`${o} terminating(${M.pid})`),M.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),M=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,C.$ic)(this.C.appRoot,"cli"),stdio:T});else{y(`Running tunnel CLI
`,!1);const U=this.J();y(`${o} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),M=(0,d.spawn)(U,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:T})}M.stdout.pipe(new u.$9S(`
`)).on("data",U=>{if(M){const q=U.toString();y(q,!1)}}),M.stderr.pipe(new u.$9S(`
`)).on("data",U=>{if(M){const q=U.toString();y(q,!0)}}),M.on("exit",U=>{M&&(y(`${o} exit(${M.pid}): + ${U} `,!1),M=void 0,m(U||0))}),M.on("error",U=>{M&&(y(`${o} error(${M.pid}): + ${U} `,!0),M=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$L8b)}Q(){let o=this.D.getValue(D.$K8b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(t,-1),v=this.F.getBoolean(a,-1,!1);if(o){const y=JSON.parse(o);if(y&&(0,l.$xf)(y.accountLabel)&&(0,l.$xf)(y.sessionId)&&(0,l.$xf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return D.$I8b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(t,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(a,-1)}};e.$R8b=s,e.$R8b=s=ye([x(0,A.$_k),x(1,P.$nj),x(2,L.$Vh),x(3,I.$9i),x(4,c.$P8b),x(5,g.$hi),x(6,h.$2o)],s);function n(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const i=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&n(r.session,o.session):!0}),define(oe[250],ae([0,1,5,2,23,21,66,20,75,17]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=void 0;class P extends I.$4o{constructor($,c,g,p){super(),this.bb=$,this.cb=c,this.db=g,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Qc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new C.$VCb(this.db.getChannel("storage"))),c=this.B(new O.$Xo($));return this.B(c.onDidChangeStorage(g=>this.u(-1,g))),c}gb($){this.X.clear(),this.W=$;let c;if((0,I.$5o)($))c=this.U;else{const g=this.X.add(new C.$WCb(this.db.getChannel("storage"),$));c=this.X.add(new O.$Xo(g))}return this.X.add(c.onDidChangeStorage(g=>this.u(0,g))),c}hb($){this.$.clear(),this.Z=$?.id;let c;if($){const g=this.$.add(new C.$XCb(this.db.getChannel("storage"),$));c=this.$.add(new O.$Xo(g)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$ug)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const c=this.Y,g=c.items;c!==this.U&&await c.close(),this.Y=this.gb($),await this.Y.init(),this.N(g,this.Y,0)}async S($,c){const g=this.ab,p=g?.items??new Map;await g?.close(),this.ab=this.hb($),await this.ab.init(),this.N(p,this.ab,1)}hasScope($){return(0,d.$Gk)($)?this.W.id===$.id:this.Z===$.id}}e.$W8b=P}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=void 0;class O{constructor(d,P){this.a=d,this.b=P}listen(d,P){const E=this.b(d);switch(P){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(c=>(0,L.$Jm)({...c},E)),added:$.added.map(c=>(0,L.$Jm)({...c},E)),removed:$.removed.map(c=>(0,L.$Jm)({...c},E)),updated:$.updated.map(c=>(0,L.$Jm)({...c},E))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,E){const $=this.b(d);switch(P){case"createProfile":{const c=await this.a.createProfile(E[0],E[1],E[2]);return(0,L.$Jm)({...c},$)}case"updateProfile":{let c=(0,A.$Ik)((0,L.$Km)(E[0],$),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,E[1]),(0,L.$Jm)({...c},$)}case"removeProfile":{const c=(0,A.$Ik)((0,L.$Km)(E[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${P}`)}}e.$BN=O;class I extends N.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new D.$Md),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map($=>(0,A.$Ik)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const c=$.added.map(w=>(0,A.$Ik)(w,this.profilesHome.scheme)),g=$.removed.map(w=>(0,A.$Ik)(w,this.profilesHome.scheme)),p=$.updated.map(w=>(0,A.$Ik)(w,this.profilesHome.scheme));this.a=$.all.map(w=>(0,A.$Ik)(w,this.profilesHome.scheme)),this.b.fire({added:c,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,E){const $=await this.f.call("createNamedProfile",[d,P,E]);return(0,A.$Ik)($,this.profilesHome.scheme)}async createProfile(d,P,E,$){const c=await this.f.call("createProfile",[d,P,E,$]);return(0,A.$Ik)(c,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,A.$Ik)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const E=await this.f.call("updateProfile",[d,P]);return(0,A.$Ik)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$CN=I}),define(oe[58],ae([0,1,2,66,4,20,3,75,17]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Cb=e.$1Cb=e.$ZCb=void 0,e.$ZCb=(0,A.$Nh)("IUserDataProfileStorageService");let d=class extends D.$Rc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async g=>this.b(g))}async updateStorageData(c,g,p){return this.withProfileScopedStorageService(c,async w=>this.c(w,g,p))}async withProfileScopedStorageService(c,g){if(this.a.hasScope(c))return g(this.a);const p=await this.g(c),w=new E(p);try{await w.initialize();const h=await g(w);return await w.flush(),h}finally{w.dispose(),await this.f(p)}}b(c){const g=new Map,p=w=>{for(const h of c.keys(0,w))g.set(h,{value:c.get(h,0),target:w})};return p(0),p(1),g}c(c,g,p){c.storeAll(Array.from(g.entries()).map(([w,h])=>({key:w,value:h,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,D.$Lc)(c)&&c.dispose()}}};e.$1Cb=d,e.$1Cb=d=ye([x(0,L.$2o)],d);class P extends d{constructor(c,g,p,w){super(p),this.j=c;const h=c.getChannel("profileStorageListener"),l=this.B(new D.$Sc);this.h=this.B(new O.$Md({onWillAddFirstListener:()=>{l.value=h.listen("onDidChange")(u=>{w.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(b=>(0,C.$Ik)(b,g.profilesHome.scheme)),valueChanges:u.valueChanges.map(b=>({...b,profile:(0,C.$Ik)(b.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>l.value=void 0})),this.onDidChange=this.h.event}async g(c){const g=this.j.getChannel("storage");return(0,L.$5o)(c)?new I.$VCb(g):new I.$WCb(g,c)}}e.$2Cb=P;class E extends L.$4o{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$Xo(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,20,7,17,71,58]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=void 0;let I=class extends O.$2Cb{constructor(d,P,E,$){super(d,P,E,$)}};e.$B8b=I,e.$B8b=I=ye([x(0,L.$Z7b),x(1,A.$Hk),x(2,D.$2o),x(3,N.$8i)],I)}),define(oe[39],ae([0,1,18,5,15,26,3,35,2,27,12,170,19,14,11,7,43,20,22,28,25,17]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UDb=e.$TDb=e.$SDb=e.$RDb=e.$QDb=e.$PDb=e.$ODb=void 0;function t(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$ODb=t;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$PDb=a;function s(v,y){return`${(0,d.$pf)(v)}${y.isDefault?"":` (${y.name})`}`}e.$QDb=s;let n=class extends C.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,f,m,j,M,T,U,q,_,K,Y,G){super(),this.syncResource=y,this.collection=f,this.G=m,this.H=j,this.I=M,this.J=T,this.L=U,this.M=q,this.N=_,this.O=K,this.P=Y,this.c=null,this.m="idle",this.n=this.B(new O.$Md),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Md),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Qg(50)),this.w=this.B(new O.$Md),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(y.syncResource,y.profile),this.h=G.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,b.$sgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,b.$Ngb),this.y=(0,b.$tgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,j,this.h),this.j=(0,w.$8o)(j,m,M)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const f=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,f={}){await this.U(y,!0,this.ob(),f)}async preview(y,f,m={}){return this.U(y,!1,f,m)}async apply(y,f={}){try{this.F={...f};const m=await this.ab(y);return this.S(m),this.c}finally{this.F={}}}async U(y,f,m,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let M="idle";try{const T=await this.getLastSyncUserData(),U=await this.X(y,T);return M=await this.Y(U,T,f,m),M==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(M)}}finally{this.F={}}}async replace(y){const f=this.kb(y);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const m=await this.getLastSyncUserData(),j=await this.X(null,m),M=await this.W(j),T=await this.qb({ref:j.ref,syncData:f},m,M,this.ob(),L.CancellationToken.None),U=[];for(const q of T){const _=await this.sb(q,q.remoteResource,void 0,L.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,L.CancellationToken.None);U.push([q,{..._,remoteChange:K!==0?K:2}])}await this.tb(j,m,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const f=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===f}async X(y,f){if(f){const m=y?y[this.resource]:void 0;if(f.ref===m||m===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(y,f,m,j){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new b.$Agb((0,E.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,f,m,j)}catch(M){if(M instanceof b.$Agb)switch(M.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,f,m,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(y,f,m,j)}throw M}}async Z(y,f,m,j){try{const M=await this.W(y),T=!M&&f===null&&this.gb()!==void 0,U=m&&!T;this.c||(this.c=(0,N.$Gg)(_=>this.eb(y,f,M,U,j,_)));let q=await this.c;if(m&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of q.resourcePreviews)q=await this.accept(_.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":m?await this.ab(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(y){return await this.$(y,async f=>{const m=await this.rb(f,L.CancellationToken.None);await this.G.writeFile(f.previewResource,A.$ae.fromString(m?.content||""));const j=m&&!m.hasConflicts?await this.sb(f,f.previewResource,void 0,L.CancellationToken.None):void 0;return f.acceptResult=j,f.mergeState=m.hasConflicts?"conflict":j?"accepted":"preview",f.localChange=j?j.localChange:m.localChange,f.remoteChange=j?j.remoteChange:m.remoteChange,f}),this.c}async accept(y,f){return await this.$(y,async m=>{const j=await this.sb(m,y,f,L.CancellationToken.None);return m.acceptResult=j,m.mergeState="accepted",m.localChange=j.localChange,m.remoteChange=j.remoteChange,m}),this.c}async discard(y){return await this.$(y,async f=>{const m=await this.rb(f,L.CancellationToken.None);return await this.G.writeFile(f.previewResource,A.$ae.fromString(m.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=m.localChange,f.remoteChange=m.remoteChange,f}),this.c}async $(y,f){if(!this.c)return;let m=await this.c;const j=m.resourcePreviews.findIndex(({localResource:M,remoteResource:T,previewResource:U})=>this.h.isEqual(M,y)||this.h.isEqual(T,y)||this.h.isEqual(U,y));j!==-1&&(this.c=(0,N.$Gg)(async M=>{const T=[...m.resourcePreviews];return T[j]=await f(T[j]),{...m,resourcePreviews:T}}),m=await this.c,this.cb(m.resourcePreviews),m.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(m=>[m,m.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const f=y.filter(({mergeState:m})=>m==="conflict");(0,D.$tb)(this.s,f,(m,j)=>this.h.isEqual(m.previewResource,j.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const f=this.c?await this.c:null;if(f)for(const m of f.resourcePreviews){if(this.h.isEqual(m.acceptedResource,y))return m.acceptResult?m.acceptResult.content:null;if(this.h.isEqual(m.remoteResource,y))return m.remoteContent;if(this.h.isEqual(m.localResource,y))return m.localContent;if(this.h.isEqual(m.baseResource,y))return m.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,g.$mk)(y)!==1&&this.O.error(y)}}async eb(y,f,m,j,M,T){const U=await this.qb(y,f,m,M,T),q=[];for(const _ of U){const K=_.previewResource.with({scheme:b.$Mgb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)q.push({..._,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=j?await this.rb(_,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(_.previewResource,A.$ae.fromString(Y?.content||""));const G=Y&&!Y.hasConflicts?await this.sb(_,_.previewResource,void 0,T):void 0;q.push({..._,acceptResult:G,mergeState:Y?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:Y?Y.localChange:_.localChange,remoteChange:G?G.remoteChange:Y?Y.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:m}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(y),m=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!m&&f.version!==m,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;let j,M=1;for(;j===void 0&&M++<6;)try{const T=await this.hb();T&&(T.ref===f.ref?j=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof g.$qk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof b.$Agb)throw T;this.O.error(T,M)}}if(j===void 0)try{const T=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);j=T===null?null:this.kb(T),await this.ib({ref:f.ref,syncData:j})}catch(T){if(T instanceof b.$Agb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return j===void 0?null:{...f,syncData:j}}async fb(y,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const m=this.M.getResourceSyncStateVersion(this.resource),j={ref:y.ref,version:m,...f};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const f=y?JSON.parse(y):void 0;if(t(f))return f}catch(f){this.O.error(f)}}async ib(y){await this.G.writeFile(this.y,A.$ae.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),f=JSON.parse(y.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(y){y instanceof g.$qk&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:f,content:m}=await this.lb(y);let j=null;return m!==null&&(j=this.kb(m)),{ref:f,syncData:j}}kb(y){try{const f=JSON.parse(y);if(a(f))return f}catch(f){this.O.error(f)}throw new b.$Agb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const f=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(y,f){const m=await this.j,j={version:this.pb,machineId:m,content:y};try{return f=await this.J.writeResource(this.resource,JSON.stringify(j),f,this.collection,this.F),{ref:f,syncData:j}}catch(M){throw M instanceof b.$Agb&&M.code==="TooLarge"&&(M=new b.$Agb(M.message,M.code,this.resource)),M}}async nb(y){const f={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(b.$ngb)}};e.$RDb=n,e.$RDb=n=ye([x(2,g.$9j),x(3,c.$Uh),x(4,h.$2o),x(5,b.$vgb),x(6,b.$wgb),x(7,b.$Fgb),x(8,l.$_k),x(9,b.$Kgb),x(10,$.$hi),x(11,u.$Fk)],n);let i=class extends n{constructor(y,f,m,j,M,T,U,q,_,K,Y,G,Q){super(f,m,j,M,T,U,q,_,K,Y,G,Q),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,f,m){try{f?await this.G.writeFile(this.r,A.$ae.fromString(y),m?void 0:f):await this.G.createFile(this.r,A.$ae.fromString(y),{overwrite:m})}catch(j){throw j instanceof g.$qk&&j.fileOperationResult===1||j instanceof g.$qk&&j.fileOperationResult===3?new b.$Agb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof g.$qk&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$SDb=i,e.$SDb=i=ye([x(3,g.$9j),x(4,c.$Uh),x(5,h.$2o),x(6,b.$vgb),x(7,b.$wgb),x(8,b.$Fgb),x(9,l.$_k),x(10,b.$Kgb),x(11,$.$hi),x(12,u.$Fk)],i);let r=class extends i{constructor(y,f,m,j,M,T,U,q,_,K,Y,G,Q,H){super(y,f,m,j,M,T,U,q,_,K,Y,Q,H),this.zb=G,this.Bb=void 0}Ab(y,f){const m=[],j=(0,I.$Rm)(y,m,{allowEmptyContent:!0,allowTrailingComma:!0});return m.length>0||!(0,P.$Ef)(j)&&f!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$TDb=r,e.$TDb=r=ye([x(3,g.$9j),x(4,c.$Uh),x(5,h.$2o),x(6,b.$vgb),x(7,b.$wgb),x(8,b.$Fgb),x(9,l.$_k),x(10,b.$Kgb),x(11,b.$Jgb),x(12,$.$hi),x(13,u.$Fk)],r);let o=class{constructor(y,f,m,j,M,T,U){this.resource=y,this.g=f,this.h=m,this.j=j,this.k=M,this.l=T,this.d=U.extUri,this.f=(0,b.$tgb)(void 0,this.resource,m,this.d)}async initialize({ref:y,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const m=this.m(f);if(m)try{await this.o({ref:y,syncData:m})}catch(j){this.j.error(j)}}m(y){try{const f=JSON.parse(y);if(a(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const m={ref:y.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(m),-1,1),await this.k.writeFile(this.f,A.$ae.fromString(JSON.stringify(y)))}};e.$UDb=o,e.$UDb=o=ye([x(1,k.$Hk),x(2,c.$Uh),x(3,p.$8i),x(4,g.$9j),x(5,h.$2o),x(6,u.$Fk)],o)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,19,14,114,29,33,80,44,11,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a,s,n,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o3b=e.$n3b=e.$m3b=e.$l3b=e.$k3b=void 0;async function v(T,U){const q=JSON.parse(T.content);if(T.version===1||T.version===2){const _=(await U.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)T.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),T.version===2&&_.every(Y=>!(0,c.$vo)(Y.identifier,K.identifier))&&(K.installed=!0)}return q}function y(T){return JSON.parse(T.content)}e.$k3b=y;function f(T,U){return T.sort((q,_)=>!q.identifier.uuid&&_.identifier.uuid?-1:q.identifier.uuid&&!_.identifier.uuid?1:(0,C.$Te)(q.identifier.id,_.identifier.id)),U?(0,O.$QS)(T,{}):JSON.stringify(T)}e.$l3b=f;let m=class extends s.$RDb{constructor(U,q,_,K,Y,G,Q,H,V,W,ee,ne,re,X,B,S,R){super({syncResource:"extensions",profile:U},q,K,_,Y,G,Q,ne,re,W,ee,B),this.Cb=H,this.Db=V,this.Eb=R,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Mgb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Mgb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Mgb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Mgb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:F})=>!!F)),L.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),L.Event.filter(S.onDidChange,z=>z.valueChanges.some(({profile:F,changes:J})=>this.syncResource.profile.id===F.id&&J.some(Z=>Z.key===$.$9n))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,q){const _=U.syncData?await v(U.syncData,this.Cb):null,K=q?.skippedExtensions??[],Y=q?.builtinExtensions??null,G=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:W}=(0,n.$j3b)(Q,_,G,K,H,Y),ee={local:V,remote:W,content:this.Hb(Q,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:W!==null?2:0},ne=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:Y,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ne,localResource:this.yb,localContent:ne,localExtensions:Q,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(U){const q=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Y}=(0,n.$j3b)(_,q,q,U.skippedExtensions||[],K,U.builtinExtensions||[]);return Y!==null}Hb(U,q,_,K){const Y=[...q,..._],G=new Set,Q=H=>{G.add(H.id.toLowerCase()),H.uuid&&G.add(H.uuid)};Y.forEach(({identifier:H})=>Q(H)),K.forEach(Q);for(const H of U)G.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&G.has(H.identifier.uuid)||Y.push(H);return this.Ob(Y,!1)}async rb(U,q){return{...U.previewResult,hasConflicts:!1}}async sb(U,q,_,K){if(this.h.isEqual(q,this.yb))return this.Kb(U);if(this.h.isEqual(q,this.zb))return this.Lb(U);if(this.h.isEqual(q,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(q),K=(0,n.$j3b)(U.localExtensions,null,null,U.skippedExtensions,_,U.builtinExtensions),{local:Y,remote:G}=K;return{content:U.localContent,local:Y,remote:G,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Lb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(q),K=U.remoteContent?JSON.parse(U.remoteContent):null;if(K!==null){const Y=(0,n.$j3b)(U.localExtensions,K,U.localExtensions,[],_,U.builtinExtensions),{local:G,remote:Q}=Y;return{content:U.remoteContent,local:G,remote:Q,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,q,_,K){let{skippedExtensions:Y,builtinExtensions:G,localExtensions:Q}=_[0][0];const{local:H,remote:V,localChange:W,remoteChange:ee}=_[0][1];if(W===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),W!==0&&(await this.nb(JSON.stringify(Q)),Y=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,Y,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(V.all);U=await this.mb(ne,K?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(re=>re.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(re=>re.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(re=>re.identifier.id))}.`:""}`)}q?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(Q,G),await this.fb(U,{skippedExtensions:Y,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${Y.length?` Skipped: ${JSON.stringify(Y.map(ne=>ne.identifier.id))}.`:""}`))}Nb(U,q){const _=new Set,K=[];for(const Y of U)_.add(Y.identifier.id.toLowerCase()),Y.installed||K.push(Y.identifier);if(q)for(const Y of q)_.has(Y.id.toLowerCase())||K.push(Y);return K}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const q=await this.db(U);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(U,q){return f(U,q)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$m3b=m,e.$m3b=m=ye([x(2,P.$Uh),x(3,w.$9j),x(4,b.$2o),x(5,r.$vgb),x(6,r.$wgb),x(7,$.$8n),x(8,i.$zEb),x(9,r.$Kgb),x(10,d.$hi),x(11,r.$Fgb),x(12,k.$_k),x(13,g.$Ru),x(14,t.$Fk),x(15,o.$ZCb),x(16,h.$Mh)],m);let j=class{constructor(U,q,_,K,Y,G){this.a=U,this.b=q,this.c=_,this.d=K,this.f=Y,this.g=G}async getLocalExtensions(U){const q=await this.a.getInstalled(void 0,U.extensionsResource),_=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(U,async(Y,G)=>{const Q=Y.getDisabledExtensions();return q.map(H=>{const{identifier:V,isBuiltin:W,manifest:ee,preRelease:ne,pinned:re,isApplicationScoped:X}=H,B={identifier:V,preRelease:ne,version:ee.version,pinned:!!re};X&&!(0,p.$5l)(ee)&&(B.isApplicationScoped=X),Q.some(S=>(0,c.$vo)(S,V))&&(B.disabled=!0),W||(B.installed=!0);try{const S=G.getKeysForSync({id:V.id,version:ee.version});if(S){const R=G.getExtensionState(H,!0)||{};B.state=Object.keys(R).reduce((z,F)=>(S.includes(F)&&(z[F]=R[F]),z),{})}}catch(S){this.g.info(`${(0,s.$QDb)("extensions",U)}: Error while parsing extension state`,(0,A.$9)(S))}return B})}),ignoredExtensions:_}}async updateLocalExtensions(U,q,_,K,Y){const G=(0,s.$QDb)("extensions",Y),Q=[],H=new Map,V=[],W=[],ee=await this.a.getInstalled(void 0,Y.extensionsResource);if((U.length||_.length)&&await this.j(Y,async(X,B)=>{await D.Promises.settled([...U,..._].map(async S=>{const R=ee.find(J=>(0,c.$vo)(J.identifier,S.identifier));if(R&&R.isBuiltin){S.state&&R.manifest.version===S.version&&this.h(S.state,R,R.manifest.version,B),X.getDisabledExtensions().some(Z=>(0,c.$vo)(Z,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${G}: Disabling extension...`,S.identifier.id),await X.disableExtension(S.identifier),this.g.info(`${G}: Disabled extension`,S.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,S.identifier.id),await X.enableExtension(S.identifier),this.g.info(`${G}: Enabled extension`,S.identifier.id))),V.push(S.identifier);return}const z=S.pinned?S.version:void 0,F=(await this.c.getExtensions([{...S.identifier,version:z,preRelease:z?void 0:S.preRelease}],N.CancellationToken.None))[0];if(S.state&&(R?R.manifest.version===S.version:F)&&this.h(S.state,R||F,R?.manifest.version,B),F)try{X.getDisabledExtensions().some(Z=>(0,c.$vo)(Z,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${G}: Disabling extension...`,S.identifier.id,F.version),await X.disableExtension(F.identifier),this.g.info(`${G}: Disabled extension`,S.identifier.id,F.version)):(this.g.trace(`${G}: Enabling extension...`,S.identifier.id,F.version),await X.enableExtension(F.identifier),this.g.info(`${G}: Enabled extension`,S.identifier.id,F.version))),(!R||R.preRelease!==S.preRelease||R.pinned!==S.pinned||z&&R.manifest.version!==z)&&(await this.a.canInstall(F)?(Q.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:S.pinned&&!!S.version,installPreReleaseVersion:S.preRelease,profileLocation:Y.extensionsResource,isApplicationScoped:S.isApplicationScoped,context:{[$.$Vn]:!0,[$.$Wn]:!0}}}),H.set(F.identifier.id.toLowerCase(),S)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),W.push(S)))}catch(J){W.push(S),this.g.error(J),this.g.info(`${G}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else W.push(S),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,S.identifier.id)}))}),q.length){const X=ee.filter(({identifier:B,isBuiltin:S})=>!S&&q.some(R=>(0,c.$vo)(B,R)));await D.Promises.settled(X.map(async B=>{this.g.trace(`${G}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Y.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,B.identifier.id),V.push(B.identifier)}))}const ne=await this.a.installGalleryExtensions(Q);for(const{identifier:X,local:B,error:S,source:R}of ne){const z=R;if(B)this.g.info(`${G}: Installed extension.`,X.id,z.version),V.push(X);else{const F=H.get(X.id.toLowerCase());F&&(W.push(F),this.g.info(`${G}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),S instanceof $.$7n&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(S.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):S&&this.g.error(S)}}const re=[];for(const X of K)V.some(B=>(0,c.$vo)(B,X.identifier))||re.push(X);for(const X of W)re.some(B=>(0,c.$vo)(B.identifier,X.identifier))||re.push(X);return re}h(U,q,_,K){const Y=K.getExtensionState(q,!0)||{},G=_?K.getKeysForSync({id:q.identifier.id,version:_}):void 0;G?G.forEach(Q=>{Y[Q]=U[Q]}):Object.keys(U).forEach(Q=>Y[Q]=U[Q]),K.setExtensionState(q,Y,!0)}async j(U,q){return this.b.withProfileScopedStorageService(U,async _=>{const K=new I.$Qc,Y=this.f.createChild(new l.$Lh([b.$2o,_])),G=K.add(Y.createInstance(E.$lCb)),Q=K.add(Y.createInstance(g.$Su));try{return await q(G,Q)}finally{K.dispose()}})}};e.$n3b=j,e.$n3b=j=ye([x(0,$.$8n),x(1,o.$ZCb),x(2,$.$6n),x(3,i.$zEb),x(4,h.$Mh),x(5,r.$Kgb)],j);let M=class extends s.$UDb{constructor(U,q,_,K,Y,G,Q,H){super("extensions",K,Y,G,_,Q,H),this.p=U,this.q=q}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,q){const _=[],K=[],Y=[];for(const G of U){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const Q=q.find(H=>(0,c.$vo)(H.identifier,G.identifier));Q?(_.push(Q),G.disabled&&Y.push(G.identifier)):G.installed&&(K.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Y.push(G.identifier))}return{installedExtensions:_,newExtensions:K,disabledExtensions:Y,remoteExtensions:U}}};e.$o3b=M,e.$o3b=M=ye([x(0,$.$8n),x(1,i.$zEb),x(2,w.$9j),x(3,a.$Hk),x(4,P.$Uh),x(5,u.$8i),x(6,b.$2o),x(7,t.$Fk)],M)}),define(oe[116],ae([0,1,15,8,3,35,41,6,32,19,14,11,7,43,20,22,28,39,77,236,25,17,58,4]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Db=e.$ZDb=e.$YDb=e.$XDb=e.$WDb=void 0;const s="globalState.argv.",n=["locale"];function i(m,j){const M=m.storage?Object.keys(m.storage).sort():[],T={};return M.forEach(U=>T[U]=m.storage[U]),m.storage=T,j?(0,O.$QS)(m,{}):JSON.stringify(m)}e.$WDb=i;const r=1;let o=class extends h.$RDb{constructor(j,M,T,U,q,_,K,Y,G,Q,H,V,W,ee){super({syncResource:"globalState",profile:j},M,U,Y,V,q,_,G,Q,K,H,W),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:b.$Mgb,authority:"base"}),this.xb=this.vb.with({scheme:b.$Mgb,authority:"local"}),this.yb=this.vb.with({scheme:b.$Mgb,authority:"remote"}),this.zb=this.vb.with({scheme:b.$Mgb,authority:"accepted"}),this.Ab=ee.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(U.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),A.Event.filter(T.onDidChange,ne=>!!(ne.targetChanges.some(re=>this.syncResource.profile.id===re.id)||ne.valueChanges.some(({profile:re,changes:X})=>this.syncResource.profile.id===re.id&&X.some(B=>B.target===0)))))(()=>this.Q()))}async qb(j,M,T){const U=j.syncData?JSON.parse(j.syncData.content):null;M=M===null&&T?j:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:Y,remote:G}=(0,u.$VDb)(_.storage,U?U.storage:null,q?q.storage:null,K,this.O),Q={content:null,local:Y,remote:G,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:G.all!==null?2:0},H=i(_,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):H,localResource:this.xb,localContent:H,localUserData:_,remoteResource:this.yb,remoteContent:U?i(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(M===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(M),{remote:q}=(0,u.$VDb)(T.storage,M.storage,M.storage,U,this.O);return q.all!==null}async rb(j,M){return{...j.previewResult,hasConflicts:!1}}async sb(j,M,T,U){if(this.h.isEqual(M,this.xb))return this.Gb(j);if(this.h.isEqual(M,this.yb))return this.Hb(j);if(this.h.isEqual(M,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const M=JSON.parse(j.remoteContent),{local:T,remote:U}=(0,u.$VDb)(j.localUserData.storage,M.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:T,remote:U,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,M,T,U){const{localUserData:q}=T[0][0],{local:_,remote:K,localChange:Y,remoteChange:G}=T[0][1];if(Y===0&&G===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Y!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});j=await this.mb(Q,U?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}M?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const M=await this.db(j);return M&&i(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const M=await this.Bb.readStorageData(this.syncResource.profile),T=[],U=[];for(const[K,Y]of M)Y.target===0?T.push(K):Y.target===1&&U.push(K);const q=[...T,...U],_=j?.storage?Object.keys(j.storage).filter(K=>!K.startsWith(s)&&!q.includes(K)&&M.get(K)!==void 0):[];if(!I.$p){const K=[...b.$rgb.map(Y=>(0,b.$Egb)(Y)),b.$Dgb];_.push(...K),U.push(...K)}return{user:T,machine:U,unregistered:_}}};e.$XDb=o,e.$XDb=o=ye([x(2,t.$ZCb),x(3,E.$9j),x(4,b.$vgb),x(5,b.$wgb),x(6,b.$Kgb),x(7,P.$Uh),x(8,b.$Fgb),x(9,p.$_k),x(10,d.$hi),x(11,g.$2o),x(12,w.$Fk),x(13,a.$Mh)],o);let v=class{constructor(j,M,T,U){this.a=j,this.b=M,this.c=T,this.d=U}async getLocalGlobalState(j){const M={};if(j.isDefault){const U=await this.f(),q=(0,L.$Rm)(U);for(const _ of n)q[_]!==void 0&&(M[`${s}${_}`]={version:1,value:q[_]})}const T=await this.c.readStorageData(j);for(const[U,q]of T)q.value&&q.target===0&&(M[U]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,N.$9)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:M,updated:T},U){const q=(0,h.$QDb)("globalState",U),_={},K=new Map,Y=await this.c.readStorageData(U),G=(Q,H)=>{for(const V of Q){if(V.startsWith(s)){_[V.substring(s.length)]=H?H[V].value:void 0;continue}if(H){const W=H[V];W.value!==Y.get(V)?.value&&K.set(V,W.value)}else Y.get(V)!==void 0&&K.set(V,void 0)}};if(G(Object.keys(j),j),G(Object.keys(T),T),G(M),Object.keys(_).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let H=Q;for(const V of Object.keys(_))H=(0,l.edit)(H,[V],_[V],{});Q!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$ae.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(U,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$YDb=v,e.$YDb=v=ye([x(0,E.$9j),x(1,P.$Uh),x(2,t.$ZCb),x(3,b.$Kgb)],v);let y=class extends h.$UDb{constructor(j,M,T,U,q,_){super("globalState",T,U,q,M,j,_)}async o(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},U={};for(const q of Object.keys(M.storage))q.startsWith(s)?T[q.substring(s.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(U[q]=M.storage[q].value);if(Object.keys(T).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(T))q=(0,l.edit)(q,[_],T[_],{});await this.k.writeFile(this.h.argvResource,D.$ae.fromString(q))}if(Object.keys(U).length){const q=[];for(const _ of Object.keys(U))q.push({key:_,value:U[_],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$ZDb=y,e.$ZDb=y=ye([x(0,g.$2o),x(1,E.$9j),x(2,k.$Hk),x(3,P.$Uh),x(4,b.$Kgb),x(5,w.$Fk)],y);let f=class{constructor(j,M,T,U,q){this.a=j,this.b=M,this.c=T,this.d=U,this.f=q}getSyncStoreType(j){return this.h(j)?.storage[b.$Dgb]?.value}async sync(j){const M=(0,b.$zgb)((0,C.$dg)());try{return await this.g(j,M)}catch(T){if(T instanceof b.$Agb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,M)}throw T}}async g(j,M){const T=await this.a.readResource("globalState",null,void 0,M),U=this.h(T)||{storage:{}};U.storage[b.$Dgb]={value:j,version:r};const q=await(0,c.$8o)(this.c,this.d,this.b),_={version:r,machineId:q,content:i(U,!1)};await this.a.writeResource("globalState",JSON.stringify(_),T.ref,void 0,M)}h({content:j}){if(!j)return null;const M=JSON.parse(j);if((0,h.$PDb)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.$1Db=f,e.$1Db=f=ye([x(1,g.$2o),x(2,P.$Uh),x(3,E.$9j),x(4,$.$8i)],f)}),define(oe[117],ae([0,1,18,15,3,35,6,12,171,19,14,11,20,22,28,17,39,233,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s3b=e.$r3b=e.$q3b=void 0;function u(t,a,s){try{const n=JSON.parse(t);if(!a)return(0,I.$Ef)(n.all)?null:n.all;switch(O.OS){case 2:return(0,I.$Ef)(n.mac)?null:n.mac;case 3:return(0,I.$Ef)(n.linux)?null:n.linux;case 1:return(0,I.$Ef)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$q3b=u;let b=class extends w.$TDb{constructor(a,s,n,i,r,o,v,y,f,m,j,M,T){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},s,y,f,m,n,i,v,M,r,j,o,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:l.$Mgb,authority:"base"}),this.Gb=this.Eb.with({scheme:l.$Mgb,authority:"local"}),this.Hb=this.Eb.with({scheme:l.$Mgb,authority:"remote"}),this.Ib=this.Eb.with({scheme:l.$Mgb,authority:"accepted"}),this.B(A.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,s,n,i){const r=a.syncData?u(a.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&n?a:s;const o=s?this.Ob(s):null,v=await this.vb(),y=await this.Cb();let f=null,m=!1,j=!1,M=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new l.$Agb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,h.$p3b)(q,r,o,y,this.zb);_.hasChanges&&(f=_.mergeContent,M=_.hasConflicts,m=M||_.mergeContent!==q,j=M||_.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),j=!0);const T={content:M?o:f,localChange:m?v?2:1:0,remoteChange:j?2:0,hasConflicts:M},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(a){const s=this.Ob(a);if(s===null)return!0;const n=await this.vb(),i=n?n.value.toString():"",r=await this.Cb(),o=await(0,h.$p3b)(i||"[]",s,s,r,this.zb);return o.hasConflicts||o.mergeContent!==s}async rb(a,s){return a.previewResult}async sb(a,s,n,i){if(this.h.isEqual(s,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return n===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(a,s,n,i){const{fileContent:r}=n[0][0];let{content:o,localChange:v,remoteChange:y}=n[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new l.$Agb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,i),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(f,i?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const s=(0,L.$Rm)(a.value.toString());if((0,D.$Kb)(s))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:u(a.syncData.content,this.Qb(),this.O)}Pb(a,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete n.all:n.all=a,O.OS){case 2:n.mac=a;break;case 3:n.linux=a;break;case 1:n.windows=a;break}return JSON.stringify(n)}Qb(){return!!this.P.getValue(l.$ogb)}};e.$r3b=b,e.$r3b=b=ye([x(2,l.$vgb),x(3,l.$wgb),x(4,l.$Kgb),x(5,d.$hi),x(6,l.$Fgb),x(7,E.$9j),x(8,P.$Uh),x(9,$.$2o),x(10,l.$Jgb),x(11,c.$_k),x(12,g.$Fk)],b);let k=class extends w.$UDb{constructor(a,s,n,i,r,o){super("keybindings",s,n,i,a,r,o)}async o(a){const s=a.syncData?this.p(a.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ae.fromString(s)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,L.$Rm)(a.value.toString());return!(0,D.$Kb)(s)}catch(a){return a.fileOperationResult===1}}p(a){try{return u(a,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$s3b=k,e.$s3b=k=ye([x(0,E.$9j),x(1,p.$Hk),x(2,P.$Uh),x(3,l.$Kgb),x(4,$.$2o),x(5,g.$Fk)],k)}),define(oe[118],ae([0,1,15,3,172,19,73,14,29,11,20,22,28,17,39,237,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=e.$t3b=void 0;function h(k){return k&&k.settings&&typeof k.settings=="string"&&Object.keys(k).length===1}function l(k){const t=JSON.parse(k);return h(t)?t:{settings:k}}e.$t3b=l;let u=class extends g.$TDb{constructor(t,a,s,n,i,r,o,v,y,f,m,j,M,T){super(t.settingsResource,{syncResource:"settings",profile:t},a,s,n,i,r,o,m,j,v,y,f,T),this.Eb=M,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Mgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Mgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Mgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Mgb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const a=await this.getLastSyncUserData(),s=await this.X(t,a),n=this.Lb(s),i=new O.$xn(w.$ngb);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(w.$ngb)||{}}async qb(t,a,s){const n=await this.vb(),i=await this.Cb(),r=this.Lb(t);a=a===null&&s?t:a;const o=a?this.Lb(a):null,v=await this.Pb();let y=null,f=!1,m=!1,j=!1;if(r){let q=n?n.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,p.$GCb)(q,r.settings,o?o.settings:null,v,[],i);y=_.localContent||_.remoteContent,f=_.localContent!==null,m=_.remoteContent!==null,j=_.hasConflicts}else n&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=n.value.toString().trim()||"{}",this.Qb(y),m=!0);const M=n?n.value.toString():null,T=o?.settings??null,U={content:j?T:y,localChange:f?2:0,remoteChange:m?2:0,hasConflicts:j};return[{fileContent:n,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:M,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(t){const a=this.Lb(t);if(a===null)return!0;const s=await this.vb(),n=s?s.value.toString().trim():"",i=await this.Pb(),r=await this.Cb();return(0,p.$GCb)(n||"{}",a.settings,a.settings,i,[],r).remoteContent!==null}async rb(t,a){const s=await this.Cb(),n=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$FCb)(t.previewResult.content,"{}",n,s):null}}async sb(t,a,s,n){const i=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:t.fileContent?(0,p.$FCb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$FCb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,p.$FCb)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(t,a,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:o,remoteChange:v}=s[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(r,i,n),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),f=this.Lb(t),m=await this.Pb(r);r=(0,p.$FCb)(r,f?f.settings:"{}",m,y),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(r)),n?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$HCb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let a=await super.db(t);if(a){const s=await this.Cb(),n=await this.Pb();a=(0,p.$FCb)(a,"{}",n,s)}return a}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return l(t)}catch(a){this.O.error(a)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$DCb)(a,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new w.$Agb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$u3b=u,e.$u3b=u=ye([x(2,d.$9j),x(3,I.$Uh),x(4,P.$2o),x(5,w.$vgb),x(6,w.$wgb),x(7,w.$Kgb),x(8,w.$Jgb),x(9,L.$hi),x(10,w.$Fgb),x(11,E.$_k),x(12,C.$8n),x(13,$.$Fk)],u);let b=class extends g.$UDb{constructor(t,a,s,n,i,r){super("settings",a,s,n,t,i,r)}async o(t){const a=t.syncData?this.p(t.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$ae.fromString(a.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$HCb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return l(t)}catch(a){this.j.error(a)}return null}};e.$v3b=b,e.$v3b=b=ye([x(0,d.$9j),x(1,c.$Hk),x(2,I.$Uh),x(3,w.$Kgb),x(4,P.$2o),x(5,$.$Fk)],b)}),define(oe[119],ae([0,1,15,3,30,19,14,11,20,22,28,17,39,234,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A3b=e.$z3b=e.$y3b=void 0;function p(l){return JSON.parse(l.content)}e.$y3b=p;let w=class extends $.$RDb{constructor(u,b,k,t,a,s,n,i,r,o,v,y){super({syncResource:"snippets",profile:u},b,t,k,a,s,n,o,v,i,r,y),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(k.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(u,b,k){const t=await this.Hb(),a=this.Gb(t),s=u.syncData?this.Fb(u.syncData):null;b=b===null&&k?u:b;const n=b&&b.syncData?this.Fb(b.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,c.$w3b)(a,s,n);return this.Bb(i,t,s||{},n||{})}async ub(u){const b=u.syncData?this.Fb(u.syncData):null;if(b===null)return!0;const k=await this.Hb(),t=this.Gb(k),a=(0,c.$w3b)(t,b,b);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(u,b){return u.previewResult}async sb(u,b,k,t){if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$Mgb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$Mgb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return k===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:k,localChange:k===null?u.fileContent!==null?3:0:2,remoteChange:k===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async tb(u,b,k,t){const a=k.map(([s,n])=>({...s,acceptResult:n}));a.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:s})=>s!==0)&&(await this.Cb(a),await this.Db(a,t)),a.some(({remoteChange:s})=>s!==0)&&(u=await this.Eb(a,u,t)),b?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of a)try{await this.G.del(s)}catch{}}Bb(u,b,k,t){const a=new Map;for(const s of Object.keys(u.local.added)){const n={content:u.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of Object.keys(u.local.updated)){const n={content:u.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of u.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of Object.keys(u.remote.added)){const n={content:u.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of Object.keys(u.remote.updated)){const n={content:u.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of u.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of u.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:k[s]?2:1},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}for(const s of Object.keys(b))if(!a.has(s)){const n={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:k[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Mgb,authority:"accepted"})})}return[...a.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:g.$Mgb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Mgb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Mgb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Mgb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const b={};for(const k of u)k.fileContent&&(b[this.h.basename(k.localResource)]=k.fileContent);await this.nb(JSON.stringify(this.Gb(b)))}async Db(u,b){for(const{fileContent:k,acceptResult:t,localResource:a,remoteResource:s,localChange:n}of u)if(n!==0){const i=s?this.h.basename(s):this.h.basename(a),r=this.h.joinPath(this.vb,i);n===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):n===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$ae.fromString(t.content),{overwrite:b}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$ae.fromString(t.content),b?void 0:k),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,b,k){const t=b.syncData?this.Fb(b.syncData):{},a=(0,A.$2m)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of u)if(r!==0){const o=n?this.h.basename(n):this.h.basename(i);r===3?delete a[o]:a[o]=s.content}return(0,c.$x3b)(t,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),b=await this.mb(JSON.stringify(a),k?null:b.ref),this.O.info(`${this.D}: Updated remote snippets`)),b}Fb(u){return p(u)}Gb(u){const b={};for(const k of Object.keys(u))b[k]=u[k].value.toString();return b}async Hb(){const u={};let b;try{b=await this.G.resolve(this.vb)}catch(k){if(k instanceof I.$qk&&k.fileOperationResult===1)return u;throw k}for(const k of b.children||[]){const t=k.resource,a=this.h.extname(t);if(a===".json"||a===".code-snippets"){const s=this.h.relativePath(this.vb,t),n=await this.G.readFile(t);u[s]=n}}return u}};e.$z3b=w,e.$z3b=w=ye([x(2,O.$Uh),x(3,I.$9j),x(4,C.$2o),x(5,g.$vgb),x(6,g.$wgb),x(7,g.$Kgb),x(8,L.$hi),x(9,g.$Fgb),x(10,d.$_k),x(11,P.$Fk)],w);let h=class extends $.$UDb{constructor(u,b,k,t,a,s){super("snippets",b,k,t,u,a,s)}async o(u){const b=u.syncData?JSON.parse(u.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(b)){const a=b[t];if(a){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,D.$ae.fromString(a)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$A3b=h,e.$A3b=h=ye([x(0,I.$9j),x(1,E.$Hk),x(2,O.$Uh),x(3,g.$Kgb),x(4,C.$2o),x(5,P.$Fk)],h)}),define(oe[120],ae([0,1,15,19,14,11,20,22,28,17,39,25]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=e.$C3b=e.$B3b=void 0;function $(w,h){try{return JSON.parse(w).tasks??null}catch(l){return h.error(l),null}}e.$B3b=$;let c=class extends P.$SDb{constructor(h,l,u,b,k,t,a,s,n,i,r,o){super(h.tasksResource,{syncResource:"tasks",profile:h},l,s,n,i,u,b,a,r,k,t,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Mgb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Mgb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Mgb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Mgb,authority:"accepted"})}async qb(h,l,u,b){const k=h.syncData?$(h.syncData.content,this.O):null;l=l===null&&u?h:l;const t=l?.syncData?$(l.syncData.content,this.O):null,a=await this.vb();let s=null,n=!1,i=!1,r=!1;if(h.syncData){const y=a?a.value.toString():null;if(!t||t!==y||t!==k){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(y,k,t);s=f.content,r=f.hasConflicts,n=f.hasLocalChanged,i=f.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=a.value.toString(),i=!0);const o={content:r?t:s,localChange:n?a?2:1:0,remoteChange:i?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:k,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(h){const l=h?.syncData?$(h.syncData.content,this.O):null;if(l===null)return!0;const u=await this.vb(),b=u?u.value.toString():null,k=p(b,l,l);return k.hasLocalChanged||k.hasRemoteChanged}async rb(h,l){return h.previewResult}async sb(h,l,u,b){if(this.h.isEqual(l,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(l,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(l,this.Ab))return u===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async tb(h,l,u,b){const{fileContent:k}=u[0][0],{content:t,localChange:a,remoteChange:s}=u[0][1];if(a===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),k&&await this.nb(JSON.stringify(this.Kb(k.value.toString()))),t?await this.wb(t,k,b):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const n=JSON.stringify(this.Kb(t));h=await this.mb(n,b?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}l?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$C3b=c,e.$C3b=c=ye([x(2,E.$vgb),x(3,E.$wgb),x(4,E.$Kgb),x(5,N.$hi),x(6,E.$Fgb),x(7,L.$9j),x(8,A.$Uh),x(9,O.$2o),x(10,I.$_k),x(11,C.$Fk)],c);let g=class extends P.$UDb{constructor(h,l,u,b,k,t){super("tasks",l,u,b,h,k,t),this.c=this.g.defaultProfile.tasksResource}async o(h){const l=h.syncData?$(h.syncData.content,this.j):null;if(!l){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$ae.fromString(l)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$D3b=g,e.$D3b=g=ye([x(0,L.$9j),x(1,d.$Hk),x(2,A.$Uh),x(3,E.$Kgb),x(4,O.$2o),x(5,C.$Fk)],g);function p(w,h,l){if(w===null&&h===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=l!==w,b=l!==h;return!u&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!b?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!u?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,19,14,11,20,22,28,17,39,235,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5b=e.$g5b=e.$f5b=void 0;let c=class extends P.$RDb{constructor(h,l,u,b,k,t,a,s,n,i,r,o,v){super({syncResource:"profiles",profile:h},l,b,k,t,a,s,r,o,n,i,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$Mgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Mgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Mgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Mgb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?p(h.syncData):null}async getRemoteSyncedProfiles(h){const l=await this.getLastSyncUserData(),u=await this.X(h,l);return u?.syncData?p(u.syncData):null}async qb(h,l,u){if(!this.vb.isEnabled())throw new $.$Agb("Cannot sync profiles because they are disabled","LocalError");const b=h.syncData?p(h.syncData):null,k=l?.syncData?p(l.syncData):null,t=this.Db(),{local:a,remote:s}=(0,E.$e5b)(t,b,k,[]),n={local:a,remote:s,content:k?this.Eb(k):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:s!==null?2:0},i=g(t,!1);return[{baseResource:this.baseResource,baseContent:k?this.Eb(k):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:b?this.Eb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const l=h?.syncData?p(h.syncData):null,u=this.Db(),{remote:b}=(0,E.$e5b)(u,l,l,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async rb(h,l){return{...h.previewResult,hasConflicts:!1}}async sb(h,l,u,b){if(this.h.isEqual(l,this.localResource))return this.Ab(h);if(this.h.isEqual(l,this.remoteResource))return this.Bb(h);if(this.h.isEqual(l,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async Ab(h){const l=this.Db(),u=(0,E.$e5b)(l,null,null,[]),{local:b,remote:k}=u;return{content:h.localContent,local:b,remote:k,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:k!==null?2:0}}async Bb(h){const l=h.remoteContent?JSON.parse(h.remoteContent):null,u=[],b=[];for(const k of this.Db()){const t=l?.find(a=>a.id===k.id);t&&(u.push({id:k.id,name:k.name,collection:t.collection}),b.push(k))}if(l!==null){const k=(0,E.$e5b)(b,l,u,[]),{local:t,remote:a}=k;return{content:h.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,l,u,b){const{local:k,remote:t,localChange:a,remoteChange:s}=u[0][1];a===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const n=u[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new $.$Agb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(g(this.Db(),!1));const i=[];for(const r of k.added)i.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of k.removed)i.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?i.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const o of t?.added||[]){const v=await this.J.createCollection(this.F);i.push(v),n.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of t?.removed||[])n.splice(n.findIndex(({id:v})=>o.id===v),1);for(const o of t?.updated||[]){const v=n.find(({id:y})=>o.id===y);v&&n.splice(n.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{h=await this.updateRemoteProfiles(n,b?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(o=>o.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(o=>o.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(o=>o.name))}.`:""}`)}catch(o){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of i)await this.J.deleteCollection(v,this.F)}throw o}for(const o of t?.removed||[])await this.J.deleteCollection(o.collection,this.F)}l?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,l){return this.mb(this.Eb(h),l)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const l=await this.db(h);return l&&(0,D.$QS)(JSON.parse(l),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((l,u)=>l.name.localeCompare(u.name)))}};e.$f5b=c,e.$f5b=c=ye([x(2,d.$Hk),x(3,L.$9j),x(4,A.$Uh),x(5,O.$2o),x(6,$.$vgb),x(7,$.$wgb),x(8,$.$Kgb),x(9,N.$hi),x(10,$.$Fgb),x(11,I.$_k),x(12,C.$Fk)],c);function g(w,h){const l=[...w].sort((u,b)=>u.name.localeCompare(b.name)).map(u=>({id:u.id,name:u.name}));return h?(0,D.$QS)(l,{}):JSON.stringify(l)}e.$g5b=g;function p(w){return JSON.parse(w.content)}e.$h5b=p}),define(oe[253],ae([0,1,3,2,6,14,20,22,25]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=void 0;const d="sync.enable";let P=class extends N.$Rc{constructor($,c,g,p){super(),this.c=$,this.f=c,this.g=g,this.h=p,this.a=new D.$Md,this.onDidChangeEnablement=this.a.event,this.b=new D.$Md,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:$}),this.c.store(d,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,C.$Egb)($),-1,!0)}setResourceEnablement($,c){if(this.isResourceEnabled($)!==c){const g=(0,C.$Egb)($);this.j(g,c)}}getResourceSyncStateVersion($){}j($,c){this.c.store($,c,-1,A.$p?0:1)}m($){if(d===$.key){this.a.fire(this.isEnabled());return}const c=C.$rgb.filter(g=>(0,C.$Egb)(g)===$.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$54b=P,e.$54b=P=ye([x(0,O.$2o),x(1,I.$_k),x(2,L.$Uh),x(3,C.$ugb)],P)}),define(oe[254],ae([0,1,5,15,62,2,21,19,14,11,17,25]),function(te,e,D,N,A,L,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d5b=void 0;let $=class extends L.$Rc{constructor(g,p,w,h,l){super(),this.a=g,this.b=p,this.c=w,this.f=h,this.g=l,this.h()}async h(){for(const p of this.g.profiles)for(const w of E.$rgb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(h){this.f.error(h)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,d.$mk)(p)!==1&&this.f.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(g,p,w){const h=this.j(g,p,w);try{const l=await this.b.resolve(h);if(l.children)return l.children.filter(b=>b.isFile&&!b.name.startsWith("lastSync")).sort().reverse().map(b=>({ref:b.name,created:this.n(b)}))}catch(l){if((0,d.$mk)(l)!==1)throw l}return[]}async resolveResourceContent(g,p,w,h){const l=this.j(g,w,h),u=(0,O.$ug)(l,p);try{return(await this.b.readFile(u)).value.toString()}catch(b){return this.f.error(b),null}}async writeResource(g,p,w,h,l){const u=this.j(g,h,l),b=(0,O.$ug)(u,`${(0,A.$am)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(b,N.$ae.fromString(p))}catch(k){this.f.error(k)}}j(g,p,w=this.a.userDataSyncHome){return(0,O.$ug)(w,...p?[p,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const p=await this.b.resolve(g);if(p.children){const w=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let l=w.filter(b=>Date.now()-this.n(b)>h);const u=w.length-l.length;u<10&&(l=l.slice(10-u)),await D.Promises.settled(l.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(p){this.f.error(p)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$d5b=$,e.$d5b=$=ye([x(0,C.$Uh),x(1,d.$9j),x(2,I.$hi),x(3,E.$Kgb),x(4,P.$Hk)],$)}),define(oe[81],ae([0,1,3,2,6,27,176,14,11,4,24,43,20,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgb=e.$jgb=e.$igb=void 0,e.$igb=(0,d.$Nh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",h="Chrome",l="Edge",u="Firefox",b="Android";function k(s){switch(s){case w:case h:case l:case u:case b:case(0,A.$i)(0):return!0}return!1}e.$jgb=k;function t(){return A.$G?w:A.$E?h:A.$H?l:A.$F?u:A.$I?b:(0,A.$i)(A.$p?0:A.$u)}let a=class extends N.$Rc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(n,i,r,o,v,y){super(),this.h=r,this.j=o,this.m=v,this.n=y,this.c=this.B(new D.$Md),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$8o)(n,i,r)}async getMachines(n){const i=await this.f;return(await this.s(n)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(n){const i=await this.f,r=await this.s(n);r.machines.some(({id:o})=>o===i)||(r.machines.push({id:i,name:this.r(r.machines),platform:t()}),await this.t(r))}async removeCurrentMachine(n){const i=await this.f,r=await this.s(n),o=r.machines.filter(({id:v})=>v!==i);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(n,i,r){const o=await this.s(r),v=o.machines.find(({id:y})=>y===n);if(v){v.name=i,await this.t(o);const y=await this.f;n===y&&this.h.store(p,i,-1,1)}}async setEnablements(n){const i=await this.s();for(const[r,o]of n){const v=i.machines.find(y=>y.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(i)}r(n){const i=this.h.get(p,-1);if(i)return i;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,o=new RegExp(`${(0,L.$Ee)(r)}\\s#(\\d+)`);let v=0;for(const y of n){const f=o.exec(y.name),m=f?parseInt(f[1]):0;v=m>v?m:v}return`${r} #${v+1}`}async s(n){this.g=await this.u(n);const i=this.w(this.g);if(i.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(n){const i=JSON.stringify(n),r=await this.j.writeResource(g.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async u(n){if(this.g){const i=n&&n.latest?n.latest[g.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.m.error(i)}return{version:g.a,machines:[]}}};e.$kgb=a,e.$kgb=a=g=ye([x(0,I.$Uh),x(1,C.$9j),x(2,$.$2o),x(3,c.$vgb),x(4,c.$Kgb),x(5,P.$nj)],a)}),define(oe[255],ae([0,1,5,62,38,8,3,2,6,21,9,173,24,20,22,25,78,81]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=void 0;const l="sync.disableMachineEventually",u="sync.sessionId",b="sync.storeUrl",k="sync.productQuality";let t=class extends I.$Rc{get n(){const n=this.H.get(b,-1);return n?P.URI.parse(n):void 0}set n(n){n?this.H.store(b,n.toString(),-1,1):this.H.remove(b,-1)}get s(){return this.H.get(k,-1)}set s(n){n?this.H.store(k,n,-1,1):this.H.remove(k,-1)}constructor(n,i,r,o,v,y,f,m,j,M){super(),this.u=i,this.w=r,this.y=o,this.z=v,this.C=y,this.D=f,this.F=m,this.G=j,this.H=M,this.a=this.B(new I.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Md),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Qg(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=n.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,d.$ng)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:n,message:i}=this.L();n?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$am)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(n,i,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),n?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),i)this.M(!1);else throw o}}M(n){this.y.isEnabled()!==n&&(this.y.setEnablement(n),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(n){if(!n){this.b=0;return}const i=p.$Agb.toUserDataSyncError(n);i instanceof p.$Cgb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?C.$p&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(l,!0,-1,1),await(0,D.$Tg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(l,-1,!1)}R(){this.H.remove(l,-1)}async triggerSync(n,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...n),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$j5b=t,e.$j5b=t=ye([x(0,$.$nj),x(1,p.$ugb),x(2,p.$vgb),x(3,p.$Fgb),x(4,p.$Ggb),x(5,p.$Kgb),x(6,w.$nCb),x(7,g.$_k),x(8,h.$igb),x(9,c.$2o)],t);class a extends I.$Rc{static{this.a="Interval"}constructor(n,i,r,o,v,y,f,m,j){super(),this.m=n,this.n=i,this.r=r,this.s=o,this.u=v,this.w=y,this.y=f,this.z=m,this.C=j,this.b=this.B(new I.$Sc),this.c=this.B(new O.$Md),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Md),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,D.$Ug)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(n,i){const r=(0,D.$Gg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$3)(v))return}return this.H(n,i,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$ng)(this.m,this.r.userDataSyncStore?.url)}async G(){const n=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!n&&(!(0,d.$ng)(i.defaultUrl,n.defaultUrl)||!(0,d.$ng)(i.insidersUrl,n.insidersUrl)||!(0,d.$ng)(i.stableUrl,n.stableUrl))}async H(n,i,r){this.y.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let o;try{await this.I(i,r)}catch(v){if(this.y.error(v),o=v,p.$Agb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(n,i){if(this.h=await this.u.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Cgb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$Cgb((0,E.localize)(1,null),"ServiceChanged"):new p.$Cgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Cgb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$Cgb((0,E.localize)(4,null),"ServiceChanged"):new p.$Cgb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const v=o.find(f=>f.isCurrent);if(v?.disabled)throw new p.$Cgb((0,E.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$Cgb((0,A.$yi)(f),f instanceof p.$Agb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!i.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(oe[256],ae([0,1,9,177,14,11,43,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;let s=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,r,o,v,y,f,m,j,M,T){this.e=i,this.f=r,this.g=o,this.h=y,this.i=f,this.j=m,this.k=j,this.l=M,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const r=this.L(i.content,"profiles");return(0,b.$h5b)(r)}return[]}async getLocalSyncedProfiles(i){const r=await this.f.getAllResourceRefs("profiles",void 0,i);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,i);if(o){const v=this.L(o,"profiles");return(0,b.$h5b)(v)}}return[]}async getLocalSyncedMachines(i){const r=await this.f.getAllResourceRefs("machines",void 0,i);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,i);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,r){return(await this.e.getAllResourceRefs(i,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:i,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(i,r,o){return(await this.f.getAllResourceRefs(i,r?.collection,o)).map(({created:y,ref:f})=>({created:y,uri:this.J({remote:!1,syncResource:i,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:i}){const r=this.K(i),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:i}){const r=this.K(i);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(i,o);case"keybindings":return this.u(i,o);case"tasks":return this.w(i,o);case"snippets":return this.y(i,o);case"globalState":return this.D(i,o);case"extensions":return this.A(i,o);case"profiles":return this.G(i,o);case"workspaceState":return[]}}async getMachineId({uri:i}){const r=this.K(i);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,O.$8o)(this.h,this.j,this.i)}}async resolveContent(i){const r=this.K(i);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(i,r,o,v,y){if(i){const{content:f}=await this.M(r,v,o);return f}return this.f.resolveResourceContent(r,v,o,y)}q(i,r,o){const v=this.L(r,i);switch(i){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(i,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(i){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,r){const o=this.d.joinPath(i,"settings.json"),v=r?r.settingsResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}t(i,r){switch(r){case"settings.json":return(0,c.$t3b)(i.content).settings}return null}u(i,r){const o=this.d.joinPath(i,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}v(i,r){switch(r){case"keybindings.json":return(0,g.$q3b)(i.content,!!this.l.getValue(d.$ogb),this.g)}return null}w(i,r){const o=this.d.joinPath(i,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}x(i,r){switch(r){case"tasks.json":return(0,w.$B3b)(i.content,this.g)}return null}async y(i,r){const o=await this.resolveContent(i);if(o){const v=this.L(o,"snippets");if(v){const y=(0,$.$y3b)(v),f=[];for(const m of Object.keys(y)){const j=this.d.joinPath(i,m),M=r?this.d.joinPath(r.snippetsHome,m):this.d.joinPath(i,a.a);f.push({resource:j,comparableResource:M})}return f}}return[]}z(i,r){return(0,$.$y3b)(i)[r]||null}A(i,r){const o=this.d.joinPath(i,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}B(i,r){switch(r){case"extensions.json":return(0,h.$l3b)((0,h.$k3b)(i),!0)}return null}async C(i){const{localExtensions:r}=await this.n.createInstance(h.$n3b).getLocalExtensions(i);return(0,h.$l3b)(r,!0)}D(i,r){const o=this.d.joinPath(i,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}E(i,r){switch(r){case"globalState.json":return(0,l.$WDb)(JSON.parse(i.content),!0)}return null}async F(i){const r=await this.n.createInstance(l.$YDb).getLocalGlobalState(i);return(0,l.$WDb)(r,!0)}G(i,r){const o=this.d.joinPath(i,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(i,r){switch(r){case"profiles.json":return(0,k.$QS)(JSON.parse(i.content),{})}return null}async I(i){return(0,b.$g5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(i){const r=i.remote?a.b:a.c,o=[];return i.location&&(o.push(`scheme:${i.location.scheme}`),o.push(`authority:${i.location.authority}`),o.push((0,t.$He)(i.location.path,"/"))),o.push(`syncResource:${i.syncResource}`),o.push(`profile:${i.profile}`),i.collection&&o.push(`collection:${i.collection}`),i.ref&&o.push(`ref:${i.ref}`),i.node&&o.push(i.node),this.d.joinPath(D.URI.from({scheme:d.$Mgb,authority:r,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...o)}K(i){if(i.scheme!==d.$Mgb)return;const r=[];for(;i.path!=="/";)r.unshift(this.d.basename(i)),i=this.d.dirname(i);if(r.length<2)return;const o=i.authority===a.b;let v,y;const f=[];let m,j,M,T,U;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?y=q.substring(10):q.startsWith("syncResource:")?m=q.substring(13):q.startsWith("profile:")?j=q.substring(8):q.startsWith("collection:")?M=q.substring(11):q.startsWith("ref:")?T=q.substring(4):m?U=q:f.push(q)}return{remote:o,syncResource:m,profile:j,collection:M,ref:T,node:U,location:v&&y!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:y,query:i.query,fragment:i.fragment,path:"/"}),...f):void 0}}L(i,r){try{const o=JSON.parse(i);if((0,E.$PDb)(o))return o}catch(o){this.g.error(o)}throw new d.$Agb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(i,r,o){const v=await this.e.resolveResourceContent(i,r,o);return{ref:r,content:v}}};e.$U5b=s,e.$U5b=s=a=ye([x(0,d.$vgb),x(1,d.$wgb),x(2,d.$Kgb),x(3,C.$Fk),x(4,A.$Uh),x(5,I.$2o),x(6,L.$9j),x(7,P.$Hk),x(8,p.$hi),x(9,u.$Mh)],s)}),define(oe[257],ae([0,1,18,5,26,38,3,2,21,12,32,19,29,11,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i5b=void 0;const i="sync.lastSyncTime";let r=class extends I.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(m,j,M,T,U,q,_,K,Y,G,Q){super(),this.C=m,this.D=j,this.F=M,this.G=T,this.H=U,this.I=q,this.J=_,this.L=K,this.M=Y,this.N=G,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$Md),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Md),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Md),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Md),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Md),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Md),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Md),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=M.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Pc)(()=>this.bb()))}async createSyncTask(m,j){this.cb(),this.H.info("Sync started.");const M=new Date().getTime(),T=(0,P.$dg)();try{const K=(0,n.$zgb)(T);j&&(K["Cache-Control"]="no-cache"),m=await this.D.manifest(m,K)}catch(K){const Y=n.$Agb.toUserDataSyncError(K);throw y(Y,T,this.F,this.I),Y}const U=!1,q=this;let _;return{manifest:m,async run(){if(U)throw new Error("Can run a task only once");_=(0,N.$Gg)(K=>q.P(m,!1,T,K)),await _.finally(()=>_=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-M}ms`),q.$()},stop(){return _?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new n.$Agb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const m=new Date().getTime(),j=(0,P.$dg)(),M=(0,n.$zgb)(j);let T;try{T=await this.D.manifest(null,M)}catch(_){const K=n.$Agb.toUserDataSyncError(_);throw y(K,j,this.F,this.I),K}await this.resetLocal();const U=this,q=new A.$Wd;return{id:j,async merge(){return U.P(T,!0,j,q.token)},async apply(){try{try{await U.R(T,j,q.token)}catch(_){if(n.$Agb.toUserDataSyncError(_).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(T,j,q.token);else throw _}}catch(_){throw U.H.error(_),_}U.H.info(`Sync done. Took ${new Date().getTime()-m}ms`),U.$()},async stop(){q.cancel(),await U.U(),await U.resetLocal()}}}async P(m,j,M,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,m,j,M,T));const q=U.enabled.find(_=>_.resource==="profiles");if(q){const _=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(_,m,j,M,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(m,j,M,T,U){for(const q of m){if(U.isCancellationRequested)return;const _=this.M.profiles.find(Y=>Y.id===q.id);if(!_){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(_,q);this.n.push(...await this.S(K,j,M,T,U))}for(const[q,_]of this.z.entries())this.M.profiles.some(K=>K.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(q))}async R(m,j,M){const T=this.ab();for(const Y of T){if(M.isCancellationRequested)return;await Y.apply(j,M)}const U=T.find(Y=>Y.profile.isDefault);if(!U)return;const q=U.enabled.find(Y=>Y.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles(m?.latest??null)||[]).filter(Y=>T.every(G=>G.profile.id!==Y.id));K.length&&await this.Q(K,m,!1,j,M)}async S(m,j,M,T,U){return(await m.sync(j,M,T,U)).map(([_,K])=>({profile:m.profile,syncResource:_,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(m=>m.stop()))}async resolveContent(m){const j=await this.N.resolveContent(m);if(j)return j;for(const M of this.ab())for(const T of M.enabled){const U=await T.resolveContent(m);if(U)return U}return null}async replace(m){this.cb();const j=this.N.resolveUserDataSyncResource(m);if(!j)return;const M=await this.resolveContent(m.uri);M&&await this.W(j.profile,async T=>{if(j.syncResource===T.resource)return await T.replace(M),!0})}async accept(m,j,M,T){this.cb(),await this.W(m.profile,async U=>{if(m.syncResource===U.resource)return await U.accept(j,M),T&&await U.apply((0,d.$Df)(T)?!1:T.force,(0,n.$zgb)((0,P.$dg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(m){this.H.error(m)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[m]of this.z.values())try{await m.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const m=await this.N.getRemoteSyncedProfiles(),j=m.map(q=>q.collection),M=await this.D.getAllCollections(),T=M.filter(q=>!j.includes(q));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const U=m.filter(q=>M.includes(q.collection));if(U.length!==m.length){const q=this.G.createInstance(s.$f5b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(m){this.cb();const j=await this.D.getActivityData();await this.C.writeFile(m,j)}async extractActivityData(m,j){const M=(await this.C.readFile(m)).value.toString(),T=JSON.parse(M);if(T.resources)for(const U in T.resources)for(const q of T.resources[U])await this.O.writeResource(U,q.content,new Date(q.created*1e3),void 0,j);if(T.collections)for(const U in T.collections)for(const q in T.collections[U].resources)for(const _ of T.collections[U].resources?.[q]??[])await this.O.writeResource(q,_.content,new Date(_.created*1e3),U,j)}async W(m,j){const M=new I.$Qc;try{const T=this.z.get(m.id);if(T){const Y=await this.X(T[0],j,M);return(0,d.$Ef)(Y)?null:Y}if(m.isDefault){const Y=M.add(this.G.createInstance(o,m,void 0)),G=await this.X(Y,j,M);return(0,d.$Ef)(G)?null:G}if(this.M.isEnabled())return null;const U=M.add(this.G.createInstance(s.$f5b,m,void 0)),q=await this.D.manifest(null),K=(await U.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Y=>Y.id===m.id);if(K){const Y=M.add(this.G.createInstance(o,m,K.collection)),G=await this.X(Y,j,M);return(0,d.$Ef)(G)?null:G}return null}finally{M.dispose()}}async X(m,j,M){const T=[...m.enabled,...m.disabled.reduce((U,q)=>(q!=="workspaceState"&&U.push(M.add(m.createSynchronizer(q))),U),[])];for(const U of T){const q=await j(U);if(!(0,d.$Ef)(q))return q}}Y(m){const j=this.f;this.f!==m&&(this.f=m,this.g.fire(m),j==="hasConflicts"&&this.$())}Z(){const m=this.ab().map(j=>j.conflicts).flat();(0,D.$tb)(this.j,m,(j,M)=>j.profile.id===M.profile.id&&j.syncResource===M.syncResource&&(0,D.$tb)(j.conflicts,M.conflicts,(T,U)=>(0,C.$ng)(T.previewResource,U.previewResource)))||(this.j=m,this.m.fire(m))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(m,j){let M=this.z.get(m.id);if(M&&M[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),M[1].dispose(),M=void 0,this.z.delete(m.id)),!M){const T=new I.$Qc,U=T.add(this.G.createInstance(o,m,j?.collection));T.add(U.onDidChangeStatus(q=>this.Y(q))),T.add(U.onDidChangeConflicts(q=>this.Z())),T.add(U.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(m.id,M=[U,T])}return M[0]}ab(){const m=[];for(const[j]of this.z.values())m.push(j);return m}bb(){this.z.forEach(([,m])=>m.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$i5b=r,e.$i5b=r=ye([x(0,c.$9j),x(1,n.$vgb),x(2,n.$ugb),x(3,g.$Mh),x(4,n.$Kgb),x(5,w.$_k),x(6,p.$2o),x(7,n.$Fgb),x(8,h.$Hk),x(9,n.$Hgb),x(10,n.$wgb)],r);let o=class extends I.$Rc{get enabled(){return this.f.sort((m,j)=>m[1]-j[1]).map(([m])=>m)}get disabled(){return n.$rgb.filter(m=>!this.r.isResourceEnabled(m))}get status(){return this.g}get conflicts(){return this.m}constructor(m,j,M,T,U,q,_,K,Y,G){super(),this.profile=m,this.collection=j,this.r=M,this.t=T,this.u=U,this.w=q,this.y=_,this.z=K,this.C=Y,this.D=G,this.f=[],this.g="idle",this.h=this.B(new O.$Md),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Md),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Md),this.onDidChangeConflicts=this.n.event,this.B(M.onDidChangeResourceEnablement(([Q,H])=>this.F(Q,H))),this.B((0,I.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of n.$rgb)M.isResourceEnabled(Q)&&this.G(Q)}F(m,j){j?this.G(m):this.H(m)}G(m){if(this.f.some(([U])=>U.resource===m))return;if(m==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(m==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||m==="workspaceState")return;if(m!=="profiles"&&this.profile.useDefaultFlags?.[m]){this.z.debug(`Skipping syncing ${m} in ${this.profile.name} because it is already synced by default profile`);return}const j=new I.$Qc,M=j.add(this.createSynchronizer(m));j.add(M.onDidChangeStatus(()=>this.L())),j.add(M.onDidChangeConflicts(()=>this.M())),j.add(M.onDidChangeLocal(()=>this.j.fire(m)));const T=this.N(m);this.f.push([M,T,j])}H(m){const j=this.f.findIndex(([M])=>M.resource===m);if(j!==-1){const[[M,,T]]=this.f.splice(j,1);T.dispose(),this.L(),Promise.allSettled([M.stop(),M.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(m){switch(m){case"settings":return this.t.createInstance(k.$u3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(b.$r3b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$z3b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$C3b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$XDb,this.profile,this.collection);case"extensions":return this.t.createInstance(l.$m3b,this.profile,this.collection);case"profiles":return this.t.createInstance(s.$f5b,this.profile,this.collection)}}async sync(m,j,M,T){if(T.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const q=[],_=(0,n.$zgb)(M),K=(this.collection?m?.collections?.[this.collection]?.latest:m?.latest)??null,Y=j?await this.I(K):{};for(const G of U){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(j){const Q=await G.preview(K,Y,_);if(Q)for(const H of Q.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await G.merge(H.previewResource)}else await G.sync(K,_)}catch(Q){const H=n.$Agb.toUserDataSyncError(Q);if(y(H,M,this.w,this.y),v(Q))throw H;this.z.error(Q),this.z.error(`${G.resource}: ${(0,L.$yi)(Q)}`),q.push([G.resource,H])}}return q}finally{this.L()}}async apply(m,j){const M=(0,n.$zgb)(m);for(const T of this.enabled){if(j.isCancellationRequested)return;try{await T.apply(!1,M)}catch(U){const q=n.$Agb.toUserDataSyncError(U);if(y(q,m,this.w,this.y),v(U))throw q;this.z.error(U),this.z.error(`${T.resource}: ${(0,L.$yi)(U)}`)}}}async stop(){for(const m of this.enabled)try{m.status!=="idle"&&await m.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const m of this.enabled)try{await m.resetLocal()}catch(j){this.z.error(`${m.resource}: ${(0,L.$yi)(j)}`),this.z.error(j)}}async I(m){if(!this.profile.isDefault)return{};const j=this.D.getValue(n.$ngb),M=this.enabled.find(T=>T instanceof k.$u3b);if(M){const T=await M.getRemoteUserDataSyncConfiguration(m);return{...j,...T}}return j}J(m){this.g!==m&&(this.g=m,this.h.fire(m))}L(){return this.M(),this.enabled.some(m=>m.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(m=>m.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const m=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,D.$tb)(this.m,m,(j,M)=>j.syncResource===M.syncResource&&(0,D.$tb)(j.conflicts,M.conflicts,(T,U)=>(0,C.$ng)(T.previewResource,U.previewResource)))||(this.m=m,this.n.fire(m))}N(m){switch(m){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([x(2,n.$Fgb),x(3,g.$Mh),x(4,$.$6n),x(5,n.$ugb),x(6,w.$_k),x(7,n.$Kgb),x(8,h.$Hk),x(9,E.$hi)],o);function v(f){if(f instanceof n.$Agb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(f,m,j,M){M.publicLog2("sync/error",{code:f.code,serverCode:f instanceof n.$Bgb?String(f.serverCode):void 0,url:f instanceof n.$Bgb?f.url:void 0,resource:f.resource,executionId:m,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,9,17,25]),function(te,e,D,N,A,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=void 0;function I($,c){return{...$,profile:(0,L.$Ik)($.profile,c.profilesHome.scheme)}}function C($){return{created:$.created,uri:A.URI.revive($.uri)}}class d{constructor(c,g,p){this.c=c,this.d=g,this.f=p,this.a=new Map,this.b=new D.$Md}listen(c,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(c,g,p){try{return await this.g(c,g,p)}catch(w){throw this.f.error(w),w}}async g(c,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),A.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(p[0]),A.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const w=g.substring(11),h=p[0],l=this.h(h);switch(p=p.slice(1),w){case"merge":return l.merge();case"apply":return l.apply().then(()=>this.a.delete(this.j(l.id)));case"stop":return l.stop().finally(()=>this.a.delete(this.j(l.id)))}}throw new Error("Invalid call")}h(c){const g=this.a.get(this.j(c));if(!g)throw new Error(`Manual sync taks not found: ${c}`);return g}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$z8b=d;let P=class extends N.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new D.$Md),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Md),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Md),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Md),this.onSyncErrors=this.m.event,this.a={call(p,w,h){return c.call(p,w,h).then(null,l=>{throw O.$Agb.toUserDataSyncError(l)})},listen(p,w){return c.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,h])=>{this.s(p),this.t(w),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(l=>this.s(l))),this.B(this.a.listen("onDidChangeLastSyncTime")(l=>this.u(l)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:O.$Agb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),g=this;return new E(c,{async call(w,h,l){return g.a.call(`manualSync/${w}`,[c,...Array.isArray(h)?h:[h]],l)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,g,p,w){return this.a.call("accept",[c,g,p,w])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,g){return this.a.call("extractActivityData",[c,g])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map(g=>({syncResource:g.syncResource,profile:(0,L.$Ik)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:A.URI.revive(p.baseResource),localResource:A.URI.revive(p.localResource),remoteResource:A.URI.revive(p.remoteResource),previewResource:A.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$A8b=P,e.$A8b=P=ye([x(1,L.$Hk)],P);class E extends N.$Rc{constructor(c,g){super(),this.id=c,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,21,12,9,32,19,14,11,24,57,43,20,25]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NDb=e.$MDb=e.$LDb=e.$KDb=e.$JDb=void 0;const k="configurationSync.store",t="sync.previous.store",a="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let o=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.$Dgb,-1)}set c(M){this.h.store(b.$Dgb,M,-1,C.$p?0:1)}constructor(M,T,U){super(),this.f=M,this.g=T,this.h=U,this.a=this.B(new L.$Md),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Qc);this.B(L.Event.filter(U.onDidChangeValue(-1,b.$Dgb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[k]),this.a.fire()}m(M){if(M&&(M=C.$p&&M.web?{...M,...M.web}:M,(0,P.$xf)(M.url)&&(0,P.$zf)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(T=>Array.isArray(M.authenticationProviders[T].scopes)))){const T=M,U=!!T.canSwitch,q=T.url===T.insidersUrl?"insiders":"stable",_=(U?this.c:void 0)||q,K=_==="insiders"?T.insidersUrl:_==="stable"?T.stableUrl:T.url;return{url:E.URI.parse(K),type:_,defaultType:q,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(T.authenticationProviders).reduce((Y,G)=>(Y.push({id:G,scopes:T.authenticationProviders[G].scopes}),Y),[])}}}};e.$JDb=o,e.$JDb=o=ye([x(0,w.$nj),x(1,c.$hi),x(2,u.$2o)],o);let v=class extends o{constructor(M,T,U){super(M,T,U);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const _=this.f[k];_?this.h.store(t,JSON.stringify(_),-1,1):this.h.remove(t,-1)}async switch(M){M!==this.c&&(this.c=M,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$KDb=v,e.$KDb=v=ye([x(0,w.$nj),x(1,c.$hi),x(2,u.$2o)],v);let y=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(M,T,U,q,_,K,Y){super(),this.n=U,this.r=q,this.s=Y,this.g=this.B(new L.$Md),this.onTokenFailed=this.g.event,this.h=this.B(new L.$Md),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$Md),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(M),this.c=(0,l.$8o)(_,K,Y).then(G=>{const Q={"X-Client-Name":`${T.applicationName}${C.$p?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(Q["X-Client-Commit"]=T.commit),Q}),this.f=new m(i,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(M,T){this.b={token:M,type:T}}t(M){this.a=M?(0,d.$ug)(M,"v1"):void 0}u(){const M=this.s.getNumber(a,-1);M&&Date.now()<M&&this.y(new Date(M))}y(M){this.j?.getTime()!==M?.getTime()&&(this.j=M,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,D.$Gg)(T=>(0,D.$Tg)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$ug)(this.a,"collection").toString();M={...M},M["Content-Type"]="application/json";const U=await this.D(T,{type:"GET",headers:M},[],N.CancellationToken.None);return(await(0,h.$Uo)(U))?.map(({id:q})=>q)||[]}async createCollection(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$ug)(this.a,"collection").toString();M={...M},M["Content-Type"]=I.$Lr.text;const U=await this.D(T,{type:"POST",headers:M},[],N.CancellationToken.None),q=await(0,h.$To)(U);if(!q)throw new b.$Bgb("Server did not return the collection id",T,"NoCollection",U.res.statusCode,U.res.headers[b.$xgb]);return q}async deleteCollection(M,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=M?(0,d.$ug)(this.a,"collection",M).toString():(0,d.$ug)(this.a,"collection").toString();T={...T},await this.D(U,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(M,T){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,T,M),q={},_=await this.D(U.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,h.$Uo)(_)||[]).map(({url:Y,created:G})=>({ref:(0,d.$wg)(U,U.with({path:Y})),created:G*1e3}))}async resolveResourceContent(M,T,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$ug)(this.z(this.a,U,M),T).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(_,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,h.$To)(K)}async deleteResource(M,T,U){if(!this.a)throw new Error("No settings sync store url configured.");const q=T!==null?(0,d.$ug)(this.z(this.a,U,M),T).toString():this.z(this.a,U,M).toString(),_={};await this.D(q,{type:"DELETE",headers:_},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$ug)(this.a,"resource").toString(),T={"Content-Type":I.$Lr.text};await this.D(M,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(M,T,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$ug)(this.z(this.a,U,M),"latest").toString();q={...q},q["Cache-Control"]="no-cache",T&&(q["If-None-Match"]=T.ref);const K=await this.D(_,{type:"GET",headers:q},[304],N.CancellationToken.None);let Y=null;if(K.res.statusCode===304&&(Y=T),Y===null){const G=K.res.headers.etag;if(!G)throw new b.$Bgb("Server did not return the ref",_,"NoRef",K.res.statusCode,K.res.headers[b.$xgb]);const Q=await(0,h.$To)(K);if(!Q&&K.res.statusCode===304)throw new b.$Bgb("Empty response",_,"EmptyResponse",K.res.statusCode,K.res.headers[b.$xgb]);Y={ref:G,content:Q}}return Y}async writeResource(M,T,U,q,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,M).toString();_={..._},_["Content-Type"]=I.$Lr.text,U&&(_["If-Match"]=U);const Y=await this.D(K,{type:"POST",data:T,headers:_},[],N.CancellationToken.None),G=Y.res.headers.etag;if(!G)throw new b.$Bgb("Server did not return the ref",K,"NoRef",Y.res.statusCode,Y.res.headers[b.$xgb]);return G}async manifest(M,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$ug)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",M&&(T["If-None-Match"]=M.ref);const q=await this.D(U,{type:"GET",headers:T},[304],N.CancellationToken.None);let _=null;if(q.res.statusCode===304&&(_=M),!_){const Y=q.res.headers.etag;if(!Y)throw new b.$Bgb("Server did not return the ref",U,"NoRef",q.res.statusCode,q.res.headers[b.$xgb]);const G=await(0,h.$To)(q);if(!G&&q.res.statusCode===304)throw new b.$Bgb("Empty response",U,"EmptyResponse",q.res.statusCode,q.res.headers[b.$xgb]);G&&(_={...JSON.parse(G),ref:Y})}const K=this.s.get(s,-1);return K&&_&&K!==_.session&&this.C(),_===null&&K&&this.C(),_&&this.s.store(s,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$ug)(this.a,"download").toString(),T={},U=await this.D(M,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,h.$Qo)(U))throw new b.$Bgb("Server returned "+U.res.statusCode,M,"EmptyResponse",U.res.statusCode,U.res.headers[b.$xgb]);if((0,h.$Ro)(U))throw new b.$Bgb("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[b.$xgb]);return U.stream}z(M,T,U){return T?(0,d.$ug)(M,"collection",T,"resource",U):(0,d.$ug)(M,"resource",U)}C(){this.s.remove(s,-1),this.s.remove(n,-1)}async D(M,T,U,q){if(!this.b)throw new b.$Bgb("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new b.$Bgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;T.headers={...T.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:M,type:T.type,headers:{...T.headers,authorization:void 0}});let K;try{K=await this.f.request(M,T,q)}catch(V){if(!(V instanceof b.$Bgb)){let W="RequestFailed";const ee=(0,A.$9)(V).toLowerCase();ee.includes("xhr timeout")?W="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?W="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":ee.includes("headers must be an object")?W="RequestHeadersNotObject":(0,A.$3)(V)&&(W="RequestCanceled"),V=new b.$Bgb(`Connection refused for the request '${M}'.`,M,W,void 0,void 0)}throw this.r.info("Request failed",M),V}const Y=K.res.headers[b.$xgb],G={url:M,status:K.res.statusCode,"execution-id":T.headers[b.$ygb],"operation-id":Y},Q=(0,h.$Qo)(K)||K.res.statusCode&&U.includes(K.res.statusCode);let H="";if(Q?this.r.trace("Request succeeded",G):(H=await(0,h.$So)(K)||"",this.r.info("Request failed",G,H)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new b.$Bgb(`${T.type} request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",K.res.statusCode,Y);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new b.$Bgb(`${T.type} request '${M}' failed because the access is forbidden (403).`,M,"Forbidden",K.res.statusCode,Y)}if(this.h.fire(),K.res.statusCode===404)throw new b.$Bgb(`${T.type} request '${M}' failed because the requested resource is not found (404).`,M,"NotFound",K.res.statusCode,Y);if(K.res.statusCode===405)throw new b.$Bgb(`${T.type} request '${M}' failed because the requested endpoint is not found (405). ${H}`,M,"MethodNotFound",K.res.statusCode,Y);if(K.res.statusCode===409)throw new b.$Bgb(`${T.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",K.res.statusCode,Y);if(K.res.statusCode===410)throw new b.$Bgb(`${T.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",K.res.statusCode,Y);if(K.res.statusCode===412)throw new b.$Bgb(`${T.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",K.res.statusCode,Y);if(K.res.statusCode===413)throw new b.$Bgb(`${T.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",K.res.statusCode,Y);if(K.res.statusCode===426)throw new b.$Bgb(`${T.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",K.res.statusCode,Y);if(K.res.statusCode===429){const V=K.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new b.$Bgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",K.res.statusCode,Y)):new b.$Bgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",K.res.statusCode,Y)}if(!Q)throw new b.$Bgb("Server returned "+K.res.statusCode,M,"Unknown",K.res.statusCode,Y);return K}F(M){let T=this.s.get(n,-1);T===void 0&&(T=(0,$.$dg)(),this.s.store(n,T,-1,1)),M["X-Machine-Session-Id"]=T;const U=this.s.get(s,-1);U!==void 0&&(M["X-User-Session-Id"]=U)}};e.$LDb=y,e.$LDb=y=ye([x(1,w.$nj),x(2,h.$Oo),x(3,b.$Kgb),x(4,g.$Uh),x(5,p.$9j),x(6,u.$2o)],y);let f=class extends y{constructor(M,T,U,q,_,K,Y){super(M.userDataSyncStore?.url,T,U,q,_,K,Y),this.B(M.onDidChangeUserDataSyncStore(()=>this.t(M.userDataSyncStore?.url)))}};e.$MDb=f,e.$MDb=f=ye([x(0,b.$ugb),x(1,w.$nj),x(2,h.$Oo),x(3,b.$Kgb),x(4,g.$Uh),x(5,p.$9j),x(6,u.$2o)],f);class m{constructor(M,T,U,q){this.c=M,this.d=T,this.f=U,this.g=q,this.a=[],this.b=void 0}request(M,T,U){if(this.h()&&this.i(),T.url=M,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.$Bgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(M),this.f.request(T,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$NDb=m}),define(oe[260],ae([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,D,N,A,L,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=void 0;let E=class extends I.$j5b{constructor(c,g,p,w,h,l,u,b,k,t,a){super(c,g,p,w,h,u,b,k,t,a),this.B(D.Event.debounce(D.Event.any(D.Event.map(l.onDidFocusWindow,()=>"windowFocus"),D.Event.map(l.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$U8b=E,e.$U8b=E=ye([x(0,A.$nj),x(1,C.$ugb),x(2,C.$vgb),x(3,C.$Fgb),x(4,C.$Ggb),x(5,N.$J6b),x(6,C.$Kgb),x(7,d.$nCb),x(8,O.$_k),x(9,P.$igb),x(10,L.$2o)],E)}),define(oe[261],ae([0,1,69,23,6,21]),function(te,e,D,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=e.$j6b=e.$i6b=void 0,e.$i6b=128/4;function O(d){function P(){let E=d.scheme===N.Schemas.file?(0,L.$ig)(d):d.toString();return A.$l||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:d}}e.$j6b=O;function I(d,P){function E(){if(d.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(d.toString()).digest("hex");if(!P)return;let c;return A.$l?c=P.ino:A.$k?c=P.birthtime.getTime():A.$j&&(typeof P.birthtimeMs=="number"?c=Math.floor(P.birthtimeMs):c=P.birthtime.getTime()),(0,D.createHash)("md5").update(d.fsPath).update(c?String(c):"").digest("hex")}const $=E();if(typeof $=="string")return{id:$,uri:d}}e.$k6b=I;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$l6b=C}),define(oe[262],ae([0,1,5,8,2,16,31,14,7,75,113,261,55,71,23]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=void 0;let p=class extends A.$Rc{constructor(h,l,u,b){super(),this.a=h,this.b=l,this.c=u,this.f=b,this.B(new D.$5g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,l=await O.Promises.readdir(h),u=new d.$YCb(this.f.getChannel("storage"));await Promise.all(l.map(async b=>{const k=(0,L.$ic)(h,b);b.length===E.$i6b||b===P.$Zh.id||(await this.c.getWindows()).some(s=>s.workspace?.id===b)||await u.isUsed(k)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${b} as it seems to be an unused empty workspace.`),await O.Promises.rm(k))}))}catch(h){(0,N.$Z)(h)}}};e.$o8b=p,e.$o8b=p=ye([x(0,I.$Vh),x(1,C.$8i),x(2,$.$J6b),x(3,c.$Z7b)],p)}),define(oe[82],ae([0,1,52,5,16,12,31,148,273,274]),function(te,e,D,N,A,L,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.zip=e.$hp=e.$gp=void 0,e.$gp="end of central directory record signature not found";const P=new RegExp(e.$gp);class E extends Error{constructor(a,s){let n=s.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=s}}e.$hp=E;function $(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>a&s).reduce((s,n)=>s+n,a&61440)}function c(t){if(t instanceof E)return t;let a;return P.test(t.message)&&(a="CorruptZip"),new E(a,t)}function g(t,a,s,n,i,r){const o=A.$lc(a),v=A.$ic(n,o);if(!v.startsWith(n))return Promise.reject(new Error(I.localize(0,null,a)));const y=A.$ic(n,a);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((m,j)=>{if(!r.isCancellationRequested)try{f=(0,D.createWriteStream)(y,{mode:s}),f.once("close",()=>m()),f.once("error",j),t.once("error",j),t.pipe(f)}catch(M){j(M)}}))}function p(t,a,s,n){let i=(0,N.$Gg)(()=>Promise.resolve()),r=0;const o=n.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((v,y)=>{const f=new N.$Ng,m=j=>{j.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?v():y(new E("Incomplete",new Error(I.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",j=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(j.fileName)){m(n);return}const M=j.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(M)){const q=A.$ic(a,M);i=(0,N.$Gg)(_=>O.Promises.mkdir(q,{recursive:!0}).then(()=>m(_)).then(void 0,y));return}const T=h(t,j),U=$(j);i=(0,N.$Gg)(q=>f.queue(()=>T.then(_=>g(_,M,U,a,s,q).then(()=>m(q)))).then(null,y))})}).finally(()=>o.dispose())}function w(t,a=!1){return new Promise((s,n)=>{(0,C.open)(t,a?{lazyEntries:!0}:void 0,(i,r)=>{i?n(c(i)):s((0,L.$If)(r))})})}function h(t,a){return new Promise((s,n)=>{t.openReadStream(a,(i,r)=>{i?n(c(i)):s((0,L.$If)(r))})})}function l(t,a){return new Promise((s,n)=>{const i=new d.ZipFile;a.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const r=(0,D.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=l;function u(t,a,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=w(t,!0);return s.overwrite&&(r=r.then(o=>O.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:i},n))}e.$jp=u;function b(t,a){return w(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===a&&h(s,r).then(o=>n(o),o=>i(o))}),s.once("close",()=>i(new Error(I.localize(2,null,a))))}))}function k(t,a){return b(t,a).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",o=>r.push(o)),s.on("end",()=>n(Buffer.concat(r)))}))}e.$kp=k}),define(oe[263],ae([0,1,5,8,2,23,21,53,12,32,31,82,19,14,29,33,97,11,7]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;let b=class extends A.$Rc{static{u=this}static{this.c=".sigzip"}constructor(t,a,s,n,i,r){super(),this.h=a,this.j=s,this.m=n,this.n=i,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,s){await this.g;const n=(0,O.$ug)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,a))}catch(r){throw new g.$7n(r.message,g.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.t(t)){const r=await this.u(t);try{i=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===l.LogLevel.Trace)}catch(o){const v=o;if(i=v.code,v.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${v.output}`),i===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$7n(E.$gp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,C.$Df)(a)?a:!0}async u(t){await this.g;const a=(0,O.$ug)(this.extensionsDownloadDir,`${this.z(t)}${u.c}`);return await this.w(t,a,s=>this.j.downloadSignatureArchive(t,s)),a}async w(t,a,s){if(await this.h.exists(a))return;if(a.scheme!==L.Schemas.file){await s(a);return}const n=(0,O.$ug)(this.extensionsDownloadDir,`.${(0,d.$dg)()}`);await this.h.exists(n)||await s(n);try{await P.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],s=[],n=[];for(const o of t.children)if(o.name.endsWith(u.c))n.push(o.resource);else{const v=p.$wo.parse(o.name);v&&s.push([v,o])}const i=(0,p.$Bo)(s,([o])=>o),r=[];for(const o of i)o.sort((v,y)=>I.rcompare(v[0].version,y[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...n),await D.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$wo.create(t).toString().toLowerCase():(0,d.$dg)()}};e.$zp=b,e.$zp=b=u=ye([x(0,c.$Vh),x(1,h.$9j),x(2,g.$6n),x(3,$.$hi),x(4,w.$ap),x(5,l.$8i)],b)}),define(oe[264],ae([0,1,82,157]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function A(L){return(0,D.$kp)(L,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Bp=A}),define(oe[122],ae([0,1,5,15,26,38,8,3,51,2,34,23,16,21,53,12,9,32,31,82,156,96,14,243,29,33,50,79,263,244,264,212,223,67,11,4,7,24,22,28,17]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a,s,n,i,r,o,v,y,f,m,j,M,T,U,q,_,K,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0,e.$Ep=(0,T.$Oh)(s.$8n);const G=".vsctmp";let Q=class extends a.$lp{constructor(X,B,S,R,z,F,J,Z,se,le,ue,he){super(X,B,ue,S,le,he),this.fb=z,this.gb=F,this.hb=J,this.ib=se,this.eb=new Map,this.rb=new P.$Ac;const $e=this.B(Z.createInstance(v.$Ap));this.bb=this.B(Z.createInstance(H,we=>$e.postUninstall(we))),this.cb=this.B(new f.$Cp(he,se,ue,this,this.F)),this.db=this.B(Z.createInstance(o.$zp));const de=this.B(new m.$Dp(this,this.fb,he,F,ue,se,S));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Go)(this.ib,this.F)),this.jb}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const B=await this.pb(X),S=await(0,u.zip)((0,c.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)()).fsPath,B);return w.URI.file(S)}async unzip(X){return this.F.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:B,cleanup:S}=await this.lb(X),R=$.$jc(B.fsPath);try{return await(0,y.$Bp)(R)}finally{await S()}}getInstalled(X,B=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(X??null,B)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.bb.scanUserExtensionAtLocation(X)}async install(X,B={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:S,cleanup:R}=await this.lb(X);try{const z=await(0,y.$Bp)($.$jc(S.fsPath)),F=(0,n.$Ao)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,j.$No)(z.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,F,this.G.version));const Z=(await this.I([{manifest:z,extension:S,options:B}])).find(({identifier:se})=>(0,n.$vo)(se,{id:F}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,a.$np)(new Error(`Unknown error while installing extension ${F}`))}finally{await R()}}async installFromLocation(X,B){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const S=await this.bb.scanUserExtensionAtLocation(X);if(!S)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.ub([[S,void 0]],B),this.F.info("Successfully installed extension",S.identifier.id,B.toString()),S}async installExtensionsFromProfile(X,B,S){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,B.toString(),S.toString());const R=(await this.bb.scanExtensions(1,B)).filter(z=>X.some(F=>(0,n.$vo)(F,z.identifier)));if(R.length){const z=await Promise.all(R.map(F=>this.bb.scanMetadata(F,B)));await this.ub(R.map((F,J)=>[F,z[J]]),S),this.F.info("Successfully installed extensions",R.map(F=>F.identifier.id),S.toString())}return R}async updateMetadata(X,B,S=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,X=await this.bb.updateMetadata(X,B,S),this.cb.invalidate(S),this.w.fire(X),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const B=await this.getTargetPlatform(),[S]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:B,compatible:!0},A.CancellationToken.None);if(!S)throw new Error(b.localize(2,null));await this.bb.setUninstalled(X);try{await this.bb.removeUninstalledExtension(X)}catch(R){throw new Error(b.localize(3,null,(0,L.$yi)(R)))}return this.installFromGallery(S)}ab(X,B,S,R){return this.bb.copyExtension(X,B,S,R)}copyExtensions(X,B){return this.bb.copyExtensions(X,B)}markAsUninstalled(...X){return this.bb.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(X){this.F.error(X)}}async download(X,B,S){const{location:R}=await this.db.download(X,B,!S);return R}async lb(X){if(X.scheme===E.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const B=(0,c.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)());return await this.hb.download(X,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.ib.del(B)}catch(R){this.F.error(R)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(X,B,S){if(w.URI.isUri(B))return new ee(X,B,S,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const R=n.$wo.create(B).toString();let z=this.eb.get(R);return z||(this.eb.set(R,z=new W(X,B,S,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(R))),z}$(X,B){return new ne(X,B.profileLocation,this.gb)}async pb(X){const B=async R=>{let z=await l.Promises.readdir(R);z=z.map(Z=>$.$ic(R,Z));const F=await Promise.all(z.map(Z=>l.Promises.stat(Z)));let J=Promise.resolve([]);return F.forEach((Z,se)=>{const le=z[se];Z.isFile()&&(J=J.then(ue=>[...ue,le])),Z.isDirectory()&&(J=J.then(ue=>B(le).then(he=>[...ue,...he])))}),J};return(await B(X.location.fsPath)).map(R=>({path:`extension/${$.$kc(X.location.fsPath,R)}`,localPath:R}))}async qb({added:X,removed:B}){if(B){const S=X&&this.D.extUri.isEqual(B.profileLocation,X.profileLocation)?B.extensions.filter(R=>X.extensions.every(z=>!(0,n.$vo)(z,R))):B.extensions;for(const R of S)this.F.info("Extensions removed from another source",R.id,B.profileLocation.toString()),this.u.fire({identifier:R,profileLocation:B.profileLocation})}if(X){const R=(await this.bb.scanExtensions(1,X.profileLocation)).filter(z=>X.extensions.some(F=>(0,n.$vo)(F,z.identifier)));this.s.fire(R.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,X.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:X.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(B=>this.rb.add(B)));const X=await this.ib.resolve(this.fb.userExtensionsLocation);for(const B of X.children??[])B.isDirectory&&this.rb.add(B.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(B=>this.tb(B)))}async tb(X){if(!X.affects(this.fb.userExtensionsLocation,1))return;const B=[];for(const S of X.rawAdded){if(this.rb.has(S)||!this.D.extUri.isEqual(this.D.extUri.dirname(S),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(S,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(S).startsWith(".")||!(await this.ib.stat(S)).isDirectory)continue;const R=await this.bb.scanUserExtensionAtLocation(S);R&&R.installedTimestamp===void 0&&(this.rb.add(S),B.push(R))}B.length&&(await this.ub(B.map(S=>[S,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(S=>S.identifier.id)))}async ub(X,B){const S=X.map(R=>R[0]);await this.vb(S),await this.gb.addExtensionsToProfile(X,B),this.s.fire(S.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:B})))}async vb(X){const B=await this.bb.getUninstalledExtensions();for(const S of X){const R=n.$wo.create(S);B[R.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",R.id),await this.bb.setInstalled(R),this.F.info("Removed the extension from uninstalled list:",R.id))}}};e.$Fp=Q,e.$Fp=Q=ye([x(0,s.$6n),x(1,_.$_k),x(2,U.$8i),x(3,t.$Vh),x(4,r.$up),x(5,i.$qp),x(6,k.$Jn),x(7,T.$Mh),x(8,M.$9j),x(9,q.$nj),x(10,K.$Fk),x(11,Y.$Hk)],Q);let H=class extends d.$Rc{constructor(X,B,S,R,z,F){super(),this.j=X,this.m=B,this.n=S,this.s=R,this.t=z,this.u=F,this.h=this.B(new I.$Md),this.onExtract=this.h.event,this.c=(0,c.$ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Zg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(X,B){const S={includeInvalid:!0,profileLocation:B};let R=[];return X===null||X===0?R.push(...await this.n.scanAllExtensions({includeInvalid:!0},S,!1)):X===1&&R.push(...await this.n.scanUserExtensions(S)),R=X!==null?R.filter(z=>z.type===X):R,Promise.all(R.map(z=>this.F(z)))}async scanAllUserExtensions(X){const B=await this.n.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(B.map(S=>this.F(S)))}async scanUserExtensionAtLocation(X){try{const B=await this.n.scanExistingExtension(X,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(X,B,S,R,z){const F=X.toString(),J=w.URI.file($.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$dg)()}`)),Z=w.URI.file($.$ic(this.n.userExtensionsLocation.fsPath,F));let se=await this.m.exists(Z);if(se&&R){try{await this.y(X.id,Z,"removeExisting")}catch{throw new s.$7n(b.localize(4,null,Z.fsPath,X.id),s.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.u.trace(`Started extracting the extension from ${B} to ${Z.fsPath}`),await(0,u.$jp)(B,J.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${Z}:`,X.id)}catch(le){let ue=s.ExtensionManagementErrorCode.Extract;throw le instanceof u.$hp&&(le.type==="CorruptZip"?ue=s.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$7n(le.message,ue)}await this.n.updateMetadata(J,S);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${Z.fsPath}`),await this.C(J.fsPath,Z.fsPath),this.u.info("Renamed to",Z.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(le)}. Deleted from extracted location`,J),le}this.h.fire(Z)}catch(le){try{await this.m.del(J,{recursive:!0})}catch{}throw le}return this.D(Z,1)}async scanMetadata(X,B){return B?(await this.w(X,B))?.metadata:this.n.scanMetadata(X.location)}async w(X,B){return(await this.s.scanProfileExtensions(B)).find(R=>(0,n.$vo)(R.identifier,X.identifier))}async updateMetadata(X,B,S){return S?await this.s.updateMetadata([[X,B]],S):await this.n.updateMetadata(X.location,B),this.D(X.location,X.type,S)}getUninstalledExtensions(){return this.z()}async setUninstalled(...X){const B=X.map(S=>n.$wo.create(S));await this.z(S=>B.forEach(R=>{S[R.toString()]=!0,this.u.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(X){await this.z(B=>delete B[X.toString()])}async removeExtension(X,B){if(this.t.extUri.isEqualOrParent(X.location,this.n.userExtensionsLocation))return this.y(X.identifier.id,X.location,B)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.z(B=>delete B[n.$wo.create(X).toString()])}async copyExtension(X,B,S,R){const z=await this.w(X,B),F=await this.w(X,S);return R={...z?.metadata,...R},F?await this.s.updateMetadata([[X,{...F.metadata,...R}]],S):await this.s.addExtensionsToProfile([[X,R]],S),this.D(X.location,X.type,S)}async copyExtensions(X,B){const S=await this.scanExtensions(1,X),R=await Promise.all(S.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,X)]));await this.s.addExtensionsToProfile(R,B)}async y(X,B,S){this.u.trace(`Deleting ${S} extension from disk`,X,B.fsPath);const R=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,C.$Bi)((0,h.$dg)()).toString(16)}${G}`);await this.C(B.fsPath,R.fsPath),await this.m.del(R,{recursive:!0}),this.u.info(`Deleted ${S} extension from disk`,X,B.fsPath)}async z(X){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,M.$mk)(R)!==1)throw R}let S={};if(B)try{S=JSON.parse(B)}catch{}return X&&(X(S),Object.keys(S).length?await this.m.writeFile(this.c,N.$ae.fromString(JSON.stringify(S))):await this.m.del(this.c)),S})}async C(X,B){try{await l.Promises.rename(X,B,2*60*1e3)}catch(S){throw new s.$7n(S.message||b.localize(5,null,X,B),S.code||s.ExtensionManagementErrorCode.Rename)}}async D(X,B,S){if(S){const z=(await this.n.scanUserExtensions({profileLocation:S})).find(F=>this.t.extUri.isEqual(F.location,X));if(z)return this.F(z)}else{const R=await this.n.scanExistingExtension(X,B,{includeInvalid:!0});if(R)return this.F(R)}throw new Error(b.localize(6,null,X.path))}async F(X){const B=await this.m.resolve(X.location);let S,R;return B.children&&(S=B.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,R=B.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:S,changelogUrl:R,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned}}async G(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(X));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),S=new Set;for(const z of B)X[n.$wo.create(z).toString()]||S.add(z.identifier.id.toLowerCase());try{const z=(0,n.$Bo)(B,F=>F.identifier);await D.Promises.settled(z.map(async F=>{const J=F.sort((Z,se)=>g.rcompare(Z.manifest.version,se.manifest.version))[0];S.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(z){this.u.error(z)}const R=B.filter(z=>z.metadata&&X[n.$wo.create(z).toString()]);await Promise.allSettled(R.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,M.$mk)(B)!==1&&this.u.error(B);return}if(X?.children)try{await Promise.allSettled(X.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(G))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(S){(0,M.$mk)(S)!==1&&this.u.error(S)}}}))}catch{}}};e.$Gp=H,e.$Gp=H=ye([x(1,M.$9j),x(2,r.$up),x(3,i.$qp),x(4,K.$Fk),x(5,U.$8i)],H);class V extends a.$op{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Ef)(this.options.operation)?this.l:this.options.operation}constructor(X,B,S,R,z,F,J,Z,se){super(),this.identifier=X,this.source=B,this.options=S,this.m=R,this.n=z,this.o=F,this.p=J,this.q=Z,this.s=se,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(X){const[B,S]=await this.x(X);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,S]],this.j),B}async u({zipPath:X,key:B,metadata:S},R,z){let F=await this.v(B);return F||(this.s.trace("Extracting extension...",B.id),F=await this.m.extractUserExtension(B,X,S,R,z),this.s.info("Extracting extension completed.",B.id)),F}async v(X){return await this.w(X)?(this.s.trace("Removing the extension from uninstalled list:",X.id),await this.m.setInstalled(X),this.s.info("Removed the extension from uninstalled list:",X.id),(await this.m.scanAllUserExtensions(!0)).find(R=>n.$wo.create(R).equals(X))):void 0}async w(X){return!!(await this.m.getUninstalledExtensions())[X.toString()]}}class W extends V{constructor(X,B,S,R,z,F,J,Z,se,le){super(B.identifier,B,S,z,F,J,Z,se,le),this.y=B,this.z=R}async x(X){const S=(await this.m.scanExtensions(null,this.options.profileLocation)).find(J=>(0,n.$vo)(J.identifier,this.y.identifier));S&&(this.l=3);const R={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,isSystem:S?.type===0?!0:void 0,updated:!!S,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Df)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:S?.preRelease)};if(S?.manifest.version===this.y.version)return[await this.m.updateMetadata(S,R),R];const{location:z,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$wo.create(this.y),metadata:R},!1,X),R]}catch(J){try{await this.z.delete(z)}catch(Z){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,O.$9)(Z))}throw J}}async B(X){try{await(0,y.$Bp)(X)}catch(B){throw new s.$7n((0,a.$mp)(B).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$Hp=W;class ee extends V{constructor(X,B,S,R,z,F,J,Z,se,le){super({id:(0,n.$Ao)(X.publisher,X.name)},B,S,z,F,J,Z,se,le),this.y=X,this.z=B,this.A=R}async h(X){const B=await super.h(X);return this.D(B,X),B}async x(X){const B=new n.$wo(this.identifier,this.y.version),R=(await this.m.scanExtensions(1,this.options.profileLocation)).find(J=>(0,n.$vo)(this.identifier,J.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this.l=3,B.equals(new n.$wo(R.identifier,R.manifest.version)))try{await this.m.removeExtension(R,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(R.manifest.version,this.y.version)&&await this.m.setUninstalled(R);else{const J=await this.v(B);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$jc(this.z.fsPath),key:B,metadata:z},!0,X),z]}async D(X,B){try{let[S]=await this.A.getExtensions([{id:X.identifier.id,version:X.manifest.version}],B);if(S||([S]=await this.A.getExtensions([{id:X.identifier.id}],B)),S){const R={id:S.identifier.uuid,publisherDisplayName:S.publisherDisplayName,publisherId:S.publisherId,isPreReleaseVersion:S.properties.isPreReleaseVersion,preRelease:S.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(X,R,this.options.profileLocation)}}catch{}}}class ne extends a.$op{constructor(X,B,S){super(),this.extension=X,this.j=B,this.k=S}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,80,222,122,7,20]),function(te,e,D,N,A,L,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;let d=class extends D.$Rc{constructor(E,$,c,g,p,w){super(),E.cleanUp(),(0,L.$KVb)(E,$,c,g,w),A.$Su.removeOutdatedExtensionVersions(E,p)}};e.$O8b=d,e.$O8b=d=ye([x(0,O.$Ep),x(1,N.$6n),x(2,A.$Ru),x(3,N.$$n),x(4,C.$2o),x(5,I.$8i)],d)}),define(oe[123],ae([0,1,69,61,36,275,15,8,3,2,16,6,32,42,65]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class p{traceSocketEvent(f,m){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,m)}constructor(f,m=""){this.f=!0,this.debugLabel=m,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Z)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const m=j=>{this.traceSocketEvent("read",j),f(O.$ae.wrap(j))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(f){const m=j=>{f({type:0,hadError:j,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(f){const m=()=>{f()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,I.$Z)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,I.$Z)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Ch=p;var w;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var h;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(h||(h={}));class l extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,m){this.socket.traceSocketEvent(f,m)}constructor(f,m,j,M){super(),this.f=this.B(new C.$Md),this.g=this.B(new C.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:j?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new u(this,m,j,M,this.f,(T,U)=>this.m(T,U))),this.B(this.a.onError(T=>{console.error(T),(0,I.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new g.$xh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let m=0;for(;m<f.byteLength;)this.a.writeMessage(f.slice(m,Math.min(m+262144,f.byteLength)),{compressed:!0,opcode:2}),m+=262144}m(f,{compressed:m,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let M=2;f.byteLength<126?M+=0:f.byteLength<2**16?M+=2:M+=8;const T=O.$ae.alloc(M),U=m?64:0,q=j&15;if(T.writeUInt8(128|U|q,0),f.byteLength<126)T.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(f.byteLength>>>8&255,++_),T.writeUInt8(f.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(f.byteLength>>>24&255,++_),T.writeUInt8(f.byteLength>>>16&255,++_),T.writeUInt8(f.byteLength>>>8&255,++_),T.writeUInt8(f.byteLength>>>0&255,++_)}this.socket.write(O.$ae.concat([T,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),j=m.readUInt8(0),M=(j&128)>>>7,T=(j&64)>>>6,U=j&15,q=m.readUInt8(1),_=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),j=m.readUInt8(1),M=(j&128)>>>7;let T=j&127,U=1;T===126?T=m.readUInt8(++U)*2**8+m.readUInt8(++U):T===127&&(T=m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U));let q=0;M&&(q=m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U)),this.j.state=3,this.j.readLen=T,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),t(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(m,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(m,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=l;class u extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ae.alloc(0)}constructor(f,m,j,M,T,U){super(),this.n=f,this.r=T,this.s=U,this.a=this.B(new C.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,m?(this.b=this.B(new b(this.n,M,j,{windowBits:15})),this.f=this.B(new k(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,m){this.g.push({data:f,options:m}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:m}=this.g.shift();if(this.f&&m.compressed){const j=await this.w(this.f,f);this.s(j,m)}else this.s(f,{...m,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,m){return new Promise((j,M)=>{f.write(m),f.flush(T=>j(T))})}acceptFrame(f,m,j){this.h.push({data:f,isCompressed:m,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const m=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(m)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,m,j){return new Promise((M,T)=>{f.write(m),j&&f.write(O.$ae.fromByteArray([0,0,255,255])),f.flush(U=>M(U))})}}class b extends d.$Rc{get recordedInflateBytes(){return this.j?O.$ae.concat(this.f):O.$ae.alloc(0)}constructor(f,m,j,M){super(),this.h=f,this.j=m,this.a=this.B(new C.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(M),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(O.$ae.wrap(T))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=O.$ae.concat(this.g);this.g.length=0,f(m)})}}class k extends d.$Rc{constructor(f,m){super(),this.g=f,this.a=this.B(new C.$Md),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(O.$ae.wrap(j))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=O.$ae.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),f(m)})}}function t(y,f){if(f===0)return;const m=y.byteLength>>>2;for(let _=0;_<m;_++){const K=y.readUInt32BE(_*4);y.writeUInt32BE(K^f,_*4)}const j=m*4,M=y.byteLength-j,T=f>>>24&255,U=f>>>16&255,q=f>>>8&255;M>=1&&y.writeUInt8(y.readUInt8(j)^T,j),M>=2&&y.writeUInt8(y.readUInt8(j+1)^U,j+1),M>=3&&y.writeUInt8(y.readUInt8(j+2)^q,j+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function s(){const y=(0,$.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const f=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,A.tmpdir)(),m=(0,P.$ic)(f,`vscode-ipc-${y}.sock`);return i(m),m}e.$Fh=s;function n(y,f,m){const j=(0,D.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${m}-${f}-sock`;const M=m.substr(0,4),T=f.substr(0,6),U=j.substr(0,8);let q;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?q=(0,P.$ic)(e.$Eh,`vscode-${U}-${M}-${T}.sock`):q=(0,P.$ic)(y,`${M}-${T}.sock`),i(q),q}e.$Gh=n;function i(y){const f=a[E.$u];typeof f=="number"&&y.length>=f&&console.warn(`WARNING: IPC handle "${y}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$rh{static b(f){const m=C.Event.fromNodeEventEmitter(f,"connection");return C.Event.map(m,j=>({protocol:new g.$yh(new p(j,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(j,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=r;function o(y){return new Promise((f,m)=>{const j=(0,N.createServer)();j.on("error",m),j.listen(y,()=>{j.removeListener("error",m),f(new r(j))})})}e.$Ih=o;function v(y,f){return new Promise((m,j)=>{const M=(0,N.createConnection)(y,()=>{M.removeListener("error",j),m(g.$zh.fromSocket(new p(M,`ipc-client${f}`),f))});M.once("error",j)})}e.$Jh=v}),define(oe[266],ae([0,1,61,123,210]),function(te,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=void 0,e.$X8b=new class{supports(L){return!0}connect({host:L,port:O},I,C,d){return new Promise((P,E)=>{const $=D.createConnection({host:L,port:O},()=>{$.removeListener("error",E),$.write((0,A.$pkb)(I,C,d));const c=g=>{g.toString().indexOf(`\r
\r
`)>=0&&($.off("data",c),P(new N.$Ch($,d)))};$.on("data",c)});$.setNoDelay(!0),$.once("error",E)})}}}),define(oe[267],ae([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,15]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=e.$R7b=e.$Q7b=void 0;async function h(t,a,s,n,i){let r;for(let o=3;o&&(r?.dispose(),r=await new l(t,a,s,n,i).waitForReady(),!(i&&A.$gg[i]||!A.$gg[r.tunnelLocalPort]));o--);return r}class l extends I.$Rc{constructor(a,s,n,i,r){super(),this.m=s,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=D.createServer(),this.c=new O.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,s=(0,p.$$u)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,A.$hg)(a,2,1e3,s),i=null;return this.b.listen(n,this.m),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(a){a.pause();const s=(0,p.$9u)(this.tunnelRemoteHost)||(0,p.$$u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$3k)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),i instanceof L.$Ch?i.socket.destroy():i.end()}),i instanceof L.$Ch?this.t(a,i):this.s(a,i),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),i.end()})}s(a,s){s.onClose(()=>a.destroy()),s.onEnd(()=>a.end()),s.onData(n=>a.write(n.buffer)),a.on("data",n=>s.write(w.$ae.wrap(n))),a.resume()}t(a,s){const n=s.socket;n.on("end",()=>a.end()),n.on("close",()=>a.end()),n.on("error",()=>{a.destroy()}),n.pipe(a),a.pipe(n)}}e.$Q7b=l;let u=class extends p.$bv{constructor(a,s,n,i,r){super(s,r),this.u=a,this.v=n,this.w=i}isPortPrivileged(a){return(0,p.$_u)(a,this.l,C.OS,N.release())}s(a,s,n,i,r,o,v,y){const f=this.r(s,n);if(f)return++f.refcount,f.value;if((0,p.$6u)(a))return this.t(a,s,n,r,o,v,y);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const m={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=h(m,i,s,n,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,j),j}}};e.$R7b=u,e.$R7b=u=ye([x(0,c.$Wk),x(1,P.$8i),x(2,g.$Zk),x(3,E.$nj),x(4,d.$hi)],u);let b=class extends u{constructor(a,s,n,i,r){super(a,s,n,i,r)}};e.$S7b=b,e.$S7b=b=ye([x(0,c.$Wk),x(1,P.$8i),x(2,g.$Zk),x(3,E.$nj),x(4,d.$hi)],b);let k=class extends I.$Rc{constructor(a,s,n,i,r){super(),this.b=a,this.c=s,this.f=n,this.g=i,this.h=r,this.a=new Map}async openTunnel(a,s,n,i,r,o,v,y,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${o}.`),!this.a.has(a)){const m=new b(this.b,this.c,this.g,this.f,this.h);this.B(m),this.a.set(a,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(s,n,i,r,o,v,y,f)}};e.$T7b=k,e.$T7b=k=ye([x(0,c.$Wk),x(1,P.$8i),x(2,E.$nj),x(3,g.$Zk),x(4,d.$hi)],k)}),define(oe[276],ae([0,1,36,38,8,2,23,9,18,3,42,147,204,205,196,197,262,187,189,19,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,45,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,10,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,D,N,A,L,O,I,C,d,P,E,$,c,g,p,w,h,l,u,b,k,t,a,s,n,i,r,o,v,y,f,m,j,M,T,U,q,_,K,Y,G,Q,H,V,W,ee,ne,re,X,B,S,R,z,F,J,Z,se,le,ue,he,$e,de,we,Ee,Ie,Ne,Te,ce,ge,be,Se,Pe,Ue,je,ze,Fe,ie,fe,me,pe,ke,Re,Ce,De,Oe,Le,Me,Be,qe,We,_e,ut,vt,Et,kt,St,ft,Ct,Pt,Rt,It,Dt,Ot,jt,dt,At,gt,Lt,Nt,$t,Mt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends L.$Rc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$nT(this)),this.b=void 0,this.c=this.B(new d.$Md),this.g()}g(){let ve=!1;const Ae=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,E.$oT)(process.parentPort,it.$76b.exit,Ae)}async init(){const ve=await this.h();(0,se.$pgb)(),ve.invokeFunction(Ae=>{const Ke=Ae.get(Q.$8i),Ve=Ae.get(X.$_k),Qe=Ae.get(Oe.$Hk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ae),this.m(Ke),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe)))}),this.B((0,L.$Oc)(ve.createInstance($.$k8b,this.f.codeCachePath),ve.createInstance(c.$l8b),ve.createInstance(w.$o8b),ve.createInstance(p.$n8b),ve.createInstance(g.$m8b),ve.createInstance(Et.$O8b),ve.createInstance(_e.$G8b),ve.createInstance(Mt.$18b,this.c.event)))}async h(){const ve=new K.$Lh,Ae={_serviceBrand:void 0,...V.default};ve.set(W.$nj,Ae);const Ke=new P.$vh(He=>He==="main"),Ve=new dt.$17b(this.a,Ke);ve.set(dt.$Z7b,Ve);const Qe=this.f.policiesData?new Me.$y7b(this.f.policiesData,Ve.getChannel("policy")):new Be.$fn;ve.set(Be.$dn,Qe);const Ge=new Nt.$fm(this.f.args,Ae);ve.set(n.$Vh,Ge);const xe=new H.$7q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:I.URI.revive(He.resource)})),Ve.getChannel("logger"));ve.set(Q.$9i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,kt.localize)(0,null)})),ct=this.B(new Q.$dj(st.getLevel())),Je=this.B(new St.$vN(st,[ct]));ve.set(Q.$8i,Je),this.b=this.B(new ft.$Q8b(Je)),ve.set(ft.$P8b,this.b);const Ze=this.B(new M.$Jp(Je));ve.set(j.$9j,Ze);const lt=this.B(new T.$9p(Je));Ze.registerProvider(O.Schemas.file,lt);const rt=new ie.$vr(Ze);ve.set(Fe.$Fk,rt);const Xe=this.B(new qe.$CN(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ve.set(Oe.$Hk,Xe);const ht=this.B(new me.$Y7b(O.Schemas.file,this.B(new pe.$eN(Ve.getChannel(pe.$dN),{pathCaseSensitive:fe.$l})),O.Schemas.vscodeUserData,Xe,rt,Je));Ze.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new b.$Fn(Xe.defaultProfile.settingsResource,Ze,Qe,Je));ve.set(u.$hi,Ye);const et=new At.$W8b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},Ve,Ge);ve.set(ne.$2o,et),this.B((0,L.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const bt=new Rt.$Sq(Ve.getChannel("request"));ve.set(ee.$Oo,bt),ve.set(h.$p8b,new U.$Kh(l.$q8b,void 0,!1)),ve.set(Re.$PE,new U.$Kh(ke.$F8b,void 0,!1));const wt=P.ProxyChannel.toService(Ve.getChannel("nativeHost"));ve.set(Dt.$J6b,wt),ve.set(a.$Jn,new U.$Kh(s.$KN,void 0,!0));const Tt=this.B(new ge.$v7b(wt)),Ut=new P.$vh(He=>Tt.getActiveClientId().then(at=>He===at));ve.set(m.$uVb,new It.$S8b(this.a.getChannel("extensionRecommendationNotification",Ut)));let ot;const tt=[],yt=(0,z.$so)(Ae,Ye);if((0,z.$no)(Ae,Ge)){const He=new S.$B4b(Je,xe,Ge,Ae);if(tt.push(He),!(0,z.$oo)(Ae,Ge)&&Ae.aiConfig?.ariaKey){const at=new We.$jN(bt,yt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this.B((0,L.$Pc)(()=>at.flush())),tt.push(at)}ot=new R.$Wq({appenders:tt,commonProperties:(0,re.$do)((0,D.release)(),(0,D.hostname)(),process.arch,Ae.commit,Ae.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,z.$to)(Ge)},Ye,Ae)}else{ot=z.$ho;const He=z.$lo;tt.push(He)}this.a.registerChannel("telemetryAppender",new B.$_6b(tt)),ve.set(X.$_k,ot);const zt=new F.$r8b(Ye,ot,Je,xe,Ge,Ae);ve.set(X.$al,zt),ve.set(Le.$qp,new U.$Kh(Pt.$uN,void 0,!0)),ve.set(Ce.$up,new U.$Kh(De.$z7b,void 0,!0)),ve.set(v.$ap,new U.$Kh(v.$bp,void 0,!0)),ve.set(f.$Ep,new U.$Kh(f.$Fp,void 0,!0)),ve.set(o.$6n,new U.$Kh(r.$$o,void 0,!0)),ve.set(o.$_n,new U.$Kh(jt.$V8b,void 0,!1)),ve.set(Y.$Oq,new U.$Kh(G.$Qq,void 0,!1)),ve.set(k.$mm,new U.$Kh(t.$Cr,void 0,!1)),ve.set(le.$nCb,new U.$Kh(le.$oCb,void 0,!0)),ve.set(se.$Kgb,new U.$Kh($e.$BEb,void 0,!0)),ve.set(se.$Jgb,new he.$u8b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$$n,new U.$Kh(i.$lCb,void 0,!1)),ve.set(Z.$zEb,new U.$Kh(Z.$AEb,void 0,!0)),ve.set(J.$Ru,new U.$Kh(J.$Su)),ve.set(se.$ugb,new U.$Kh(Ne.$KDb,void 0,!0)),ve.set(se.$vgb,new U.$Kh(Ne.$MDb,void 0,!0)),ve.set(de.$igb,new U.$Kh(de.$kgb,void 0,!0)),ve.set(se.$wgb,new U.$Kh(ue.$d5b,void 0,!1)),ve.set(se.$Fgb,new U.$Kh(we.$54b,void 0,!0)),ve.set(se.$Ggb,new U.$Kh(Ee.$i5b,void 0,!1)),ve.set(Te.$ZCb,new U.$Kh(ce.$B8b,void 0,!0)),ve.set(se.$Hgb,new U.$Kh(vt.$U5b,void 0,!0)),ve.set(be.$Zk,new U.$Kh(Se.$V7b,void 0,!1));const pt=new gt.$Xk;return ve.set(gt.$Wk,pt),pt.register(0,Lt.$X8b),ve.set(Pe.$5u,new U.$Kh(Ue.$T7b)),ve.set(je.$C8b,new U.$Kh(ze.$E8b)),ve.set(ut.$H8b,new U.$Kh(Ct.$R8b)),ve.set($t.$Y8b,new U.$Kh($t.$Z8b)),new _.$_p(ve)}j(ve){const Ae=this.B(new L.$Qc),Ke=new y.$dp(ve.get(o.$8n),()=>null);this.a.registerChannel("extensions",Ke);const Ve=P.ProxyChannel.fromService(ve.get(Y.$Oq),Ae);this.a.registerChannel("languagePacks",Ve);const Qe=P.ProxyChannel.fromService(ve.get(k.$mm),Ae);this.a.registerChannel("diagnostics",Qe);const Ge=new y.$fp(ve.get(o.$_n));this.a.registerChannel("extensionTipsService",Ge);const xe=P.ProxyChannel.fromService(ve.get(h.$p8b),Ae);this.a.registerChannel("checksum",xe);const st=P.ProxyChannel.fromService(ve.get(Re.$PE),Ae);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$v8b(ve.get(de.$igb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(ve.get(X.$al),Ae);this.a.registerChannel("customEndpointTelemetry",Je);const Ze=new he.$w8b(ve.get(le.$nCb));this.a.registerChannel("userDataSyncAccount",Ze);const lt=new he.$x8b(ve.get(se.$ugb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$z8b(ve.get(se.$Ggb),ve.get(Oe.$Hk),ve.get(Q.$8i));this.a.registerChannel("userDataSync",rt);const Xe=this.B(ve.get(q.$Mh).createInstance(Ot.$U8b)),ht=new he.$s8b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(ve.get(se.$Hgb),Ae));const Ye=P.ProxyChannel.fromService(ve.get(je.$C8b),Ae);this.a.registerChannel(je.$D8b,Ye);const et=P.ProxyChannel.fromService(ve.get(ut.$H8b),Ae);this.a.registerChannel("remoteTunnel",et)}m(ve){process.on("uncaughtException",Ae=>(0,A.$Z)(Ae)),process.on("unhandledRejection",Ae=>(0,A.$Z)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ke=(0,N.$yi)(Ae,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(ve,Ae){ve.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(ve){if(ve.data!==it.$96b.response)return!1;const Ae=(0,C.$Nb)(ve.ports);return Ae?(this.c.fire(Ae),!0):!1}}async function mt(nt){const ve=new Ft(nt);process.parentPort.postMessage(it.$76b.ipcReady),await ve.init(),process.parentPort.postMessage(it.$76b.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/874831ebcf088f59735879156f62308ce48f17d1/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
