/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Me=function(be){for(var e=[],w=0,M=be.length;w<M;w++)e[w]=Re[be[w]];return e};define(Re[64],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function w(R){return(l,D,g)=>{let P=null,k=null;if(typeof g.value=="function"?(P="value",k=g.value):typeof g.get=="function"&&(P="get",k=g.get),!k)throw new Error("not supported");g[P]=R(k,D)}}function M(R,l,D){let g=null,P=null;if(typeof D.value=="function"?(g="value",P=D.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",P=D.get),!P)throw new Error("not supported");const k=`$memoize$${l}`;D[g]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[k]}}e.$fh=M;function C(R,l,D){return w((g,P)=>{const k=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...p){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),l&&(this[a]=l(this[a],...p),p=[this[a]]),this[k]=setTimeout(()=>{g.apply(this,p),this[a]=D?D():void 0},R)}})}e.$gh=C;function F(R,l,D){return w((g,P)=>{const k=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[a]=l(this[a],...f)),this[$])return;const t=this[p]+R;t<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$hh=F}),define(Re[88],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$dM=w,e.$eM=new w("id#")}),define(Re[115],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(r,s=!1){let n=0;const o=r.length;let y="",d=0,I=16,S=0;function u(B){let O=0,N=0;for(;O<B;){const te=r.charCodeAt(n);if(te>=48&&te<=57)N=N*16+te-48;else if(te>=65&&te<=70)N=N*16+te-65+10;else if(te>=97&&te<=102)N=N*16+te-97+10;else break;n++,O++}return O<B&&(N=-1),N}function m(B){n=B,y="",d=0,I=16,S=0}function h(){const B=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&g(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&g(r.charCodeAt(n)))for(n++;n<r.length&&g(r.charCodeAt(n));)n++;else return S=3,r.substring(B,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&g(r.charCodeAt(n))){for(n++;n<r.length&&g(r.charCodeAt(n));)n++;O=n}else S=3;return r.substring(B,O)}function A(){let B="",O=n;for(;;){if(n>=o){B+=r.substring(O,n),S=2;break}const N=r.charCodeAt(n);if(N===34){B+=r.substring(O,n),n++;break}if(N===92){if(B+=r.substring(O,n),n++,n>=o){S=2;break}switch(r.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Z=u(4);Z>=0?B+=String.fromCharCode(Z):S=4;break}default:S=5}O=n;continue}if(N>=0&&N<=31)if(D(N)){B+=r.substring(O,n),S=2;break}else S=6;n++}return B}function W(){if(y="",S=0,d=n,n>=o)return d=o,I=17;let B=r.charCodeAt(n);if(l(B)){do n++,y+=String.fromCharCode(B),B=r.charCodeAt(n);while(l(B));return I=15}if(D(B))return n++,y+=String.fromCharCode(B),B===13&&r.charCodeAt(n)===10&&(n++,y+=`
`),I=14;switch(B){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,y=A(),I=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<o&&!D(r.charCodeAt(n));)n++;return y=r.substring(O,n),I=12}if(r.charCodeAt(n+1)===42){n+=2;const N=o-1;let te=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,te=!0;break}n++}return te||(n++,S=1),y=r.substring(O,n),I=13}return y+=String.fromCharCode(B),n++,I=16}case 45:if(y+=String.fromCharCode(B),n++,n===o||!g(r.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=h(),I=11;default:for(;n<o&&V(B);)n++,B=r.charCodeAt(n);if(d!==n){switch(y=r.substring(d,n),y){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return y+=String.fromCharCode(B),n++,I=16}}function V(B){if(l(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:m,getPosition:()=>n,scan:s?U:W,getToken:()=>I,getTokenValue:()=>y,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>S}}e.$Pm=R;function l(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function k(r,s){const n=[],o=new Object;let y;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,h,A){d.value=u,d.offset=m,d.length=h,d.type=A,d.colonOffset=void 0,y=d}try{b(r,{onObjectBegin:(u,m)=>{if(s<=u)throw o;y=void 0,I=s>u,n.push("")},onObjectProperty:(u,m,h)=>{if(s<m||(S(u,m,h,"property"),n[n.length-1]=u,s<=m+h))throw o},onObjectEnd:(u,m)=>{if(s<=u)throw o;y=void 0,n.pop()},onArrayBegin:(u,m)=>{if(s<=u)throw o;y=void 0,n.push(0)},onArrayEnd:(u,m)=>{if(s<=u)throw o;y=void 0,n.pop()},onLiteralValue:(u,m,h)=>{if(s<m||(S(u,m,h,v(u)),s<=m+h))throw o},onSeparator:(u,m,h)=>{if(s<=m)throw o;if(u===":"&&y&&y.type==="property")y.colonOffset=m,I=!1,y=void 0;else if(u===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(I=!0,n[n.length-1]=""),y=void 0}}})}catch(u){if(u!==o)throw u}return{path:n,previousNode:y,isAtPropertyKey:I,matches:u=>{let m=0;for(let h=0;m<u.length&&h<n.length;h++)if(u[m]===n[h]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Qm=k;function a(r,s=[],n=F.DEFAULT){let o=null,y=[];const d=[];function I(u){Array.isArray(y)?y.push(u):o!==null&&(y[o]=u)}return b(r,{onObjectBegin:()=>{const u={};I(u),d.push(y),y=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{y=d.pop()},onArrayBegin:()=>{const u=[];I(u),d.push(y),y=u,o=null},onArrayEnd:()=>{y=d.pop()},onLiteralValue:I,onError:(u,m,h)=>{s.push({error:u,offset:m,length:h})}},n),y[0]}e.$Rm=a;function p(r,s=[],n=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function d(u){return o.children.push(u),u}b(r,{onObjectBegin:u=>{o=d({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,h)=>{o=d({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:h,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,y(u+m)},onArrayBegin:(u,m)=>{o=d({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,y(u+m)},onLiteralValue:(u,m,h)=>{d({type:v(u),offset:m,length:h,parent:o,value:u}),y(m+h)},onSeparator:(u,m,h)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&y(m))},onError:(u,m,h)=>{s.push({error:u,offset:m,length:h})}},n);const S=o.children[0];return S&&delete S.parent,S}e.$Sm=p;function $(r,s){if(!r)return;let n=r;for(const o of s)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let y=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===o){n=d.children[1],y=!0;break}if(!y)return}else{const y=o;if(n.type!=="array"||y<0||!Array.isArray(n.children)||y>=n.children.length)return;n=n.children[y]}return n}e.$Tm=$;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;s.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&s.push(n)}return s}e.$Um=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const n of r.children){const o=n.children[1];o&&(s[n.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Vm=t;function i(r,s,n=!1){return s>=r.offset&&s<r.offset+r.length||n&&s===r.offset+r.length}e.$Wm=i;function c(r,s,n=!1){if(i(r,s,n)){const o=r.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=s;y++){const d=c(o[y],s,n);if(d)return d}return r}}e.$Xm=c;function b(r,s,n=F.DEFAULT){const o=R(r,!1);function y(Se){return Se?()=>Se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(Se){return Se?ue=>Se(ue,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=y(s.onObjectBegin),S=d(s.onObjectProperty),u=y(s.onObjectEnd),m=y(s.onArrayBegin),h=y(s.onArrayEnd),A=d(s.onLiteralValue),W=d(s.onSeparator),V=y(s.onComment),U=d(s.onError),B=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const Se=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:B||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(Se){case 12:case 13:B?te(10):V();break;case 16:te(1);break;case 15:case 14:break;default:return Se}}}function te(Se,ue=[],$e=[]){if(U(Se),ue.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ue.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Z(Se){const ue=o.getTokenValue();return Se?A(ue):S(ue),N(),!0}function ye(){switch(o.getToken()){case 11:{let Se=0;try{Se=JSON.parse(o.getTokenValue()),typeof Se!="number"&&(te(2),Se=0)}catch{te(2)}A(Se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function Ee(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(Z(!1),o.getToken()===6?(W(":"),N(),ae()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function Pe(){I(),N();let Se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Se||te(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else Se&&te(6,[],[]);Ee()||te(4,[],[2,5]),Se=!0}return u(),o.getToken()!==2?te(7,[2],[]):N(),!0}function Y(){m(),N();let Se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Se||te(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else Se&&te(6,[],[]);ae()||te(4,[],[4,5]),Se=!0}return h(),o.getToken()!==4?te(8,[4],[]):N(),!0}function ae(){switch(o.getToken()){case 3:return Y();case 1:return Pe();case 10:return Z(!0);default:return ye()}}return N(),o.getToken()===17?n.allowEmptyContent?!0:(te(4,[],[]),!1):ae()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.$Ym=b;function E(r,s){const n=R(r),o=[];let y,d=0,I;do switch(I=n.getPosition(),y=n.scan(),y){case 12:case 13:case 17:d!==I&&o.push(r.substring(d,I)),s!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,s)),d=n.getPosition();break}while(y!==17);return o.join("")}e.$Zm=E;function v(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$1m=v}),function(be,e){typeof define=="function"&&define.amd?define(Re[116],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var De=0;De<me.length;De++){var re=me[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ve,re.key,re)}}function w(ve,me,De){return me&&e(ve.prototype,me),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function M(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var De=0,re=new Array(me);De<me;De++)re[De]=ve[De];return re}function F(ve,me){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=M(ve))||me&&ve&&typeof ve.length=="number"){De&&(ve=De);var re=0;return function(){return re>=ve.length?{done:!0}:{done:!1,value:ve[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=R();function l(ve){be.defaults=ve}var D=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(me){return a[me]};function $(ve,me){if(me){if(D.test(ve))return ve.replace(g,p)}else if(P.test(ve))return ve.replace(k,p);return ve}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(f,function(me,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var De={replace:function(he,se){return se=se.source||se,se=se.replace(i,"$1"),ve=ve.replace(he,se),De},getRegex:function(){return new RegExp(ve,me)}};return De}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ve,me,De){if(ve){var re;try{re=decodeURIComponent(t(De)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}me&&!E.test(De)&&(De=y(me,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var r={},s=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){r[" "+ve]||(s.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=u(ve,"/",!0)),ve=r[" "+ve];var De=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?De?me:ve.replace(n,"$1")+me:me.charAt(0)==="/"?De?me:ve.replace(o,"$1")+me:ve+me}var d={exec:function(){}};function I(ve){for(var me=1,De,re;me<arguments.length;me++){De=arguments[me];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&(ve[re]=De[re])}return ve}function S(ve,me){var De=ve.replace(/\|/g,function(se,oe,de){for(var Ie=!1,L=oe;--L>=0&&de[L]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=De.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>me)re.splice(me);else for(;re.length<me;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function u(ve,me,De){var re=ve.length;if(re===0)return"";for(var he=0;he<re;){var se=ve.charAt(re-he-1);if(se===me&&!De)he++;else if(se!==me&&De)he++;else break}return ve.slice(0,re-he)}function m(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var De=ve.length,re=0,he=0;he<De;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])re++;else if(ve[he]===me[1]&&(re--,re<0))return he;return-1}function h(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ve,me){if(me<1)return"";for(var De="";me>1;)me&1&&(De+=ve),me>>=1,ve+=ve;return De+ve}function W(ve,me,De,re){var he=me.href,se=me.title?$(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){re.state.inLink=!0;var de={type:"link",raw:De,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,de}return{type:"image",raw:De,href:he,title:se,text:$(oe)}}function V(ve,me){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return me;var re=De[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},me.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=u(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,de,Ie,L,K,G,Q,H,_,ce,Fe,Ue=he[1].trim(),Qe=Ue.length>1,Je={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Fe=!1,!(!(he=xe.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],H=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(H)&&(se+=H+`
`,re=re.substring(H.length+1),Fe=!0),!Fe)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(_=re.split(`
`,1)[0],Q=_,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||_e.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ce+=`
`+Q.slice(Ie);else if(!K)ce+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=_+`
`,re=re.substring(_.length+1)}Je.loose||(G?Je.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(de=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:se,task:!!oe,checked:de,loose:!1,text:ce}),Je.raw+=se}Je.items[Je.items.length-1].raw=se.trimRight(),Je.items[Je.items.length-1].text=ce.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(L=0;L<ze;L++){this.lexer.state.top=!1,Je.items[L].tokens=this.lexer.blockTokens(Je.items[L].text,[]);var st=Je.items[L].tokens.filter(function(X){return X.type==="space"}),x=st.every(function(X){for(var pe=X.raw.split(""),je=0,Oe=F(pe),Xe;!(Xe=Oe()).done;){var rt=Xe.value;if(rt===`
`&&(je+=1),je>1)return!0}return!1});!Je.loose&&st.length&&x&&(Je.loose=!0,Je.items[L].loose=!0)}return Je}},me.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:S(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,de,Ie,L,K;for(de=0;de<oe;de++)/^ *-+: *$/.test(se.align[de])?se.align[de]="right":/^ *:-+: *$/.test(se.align[de])?se.align[de]="center":/^ *:-+ *$/.test(se.align[de])?se.align[de]="left":se.align[de]=null;for(oe=se.rows.length,de=0;de<oe;de++)se.rows[de]=S(se.rows[de],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],L=0;L<K.length;L++)K[L].tokens=this.lexer.inline(K[L].text);return se}}},me.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:$(he[1])}},me.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]):he[0]}},me.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=u(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var de=m(he[2],"()");if(de>-1){var Ie=he[0].indexOf("!")===0?5:4,L=Ie+he[1].length+de;he[2]=he[2].substring(0,de),he[0]=he[0].substring(0,L).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),W(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var de=se[0].charAt(0);return{type:"text",raw:de,text:de}}return W(se,oe,se[0],this.lexer)}},me.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=oe[1]||oe[2]||"";if(!de||de&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,L,K,G=Ie,Q=0,H=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=H.exec(he))!=null;)if(L=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!L){if(K=L.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var _=re.slice(1,Ie+oe.index+K);return{type:"em",raw:re.slice(0,Ie+oe.index+K+1),text:_,tokens:this.lexer.inlineTokens(_)}}var ce=re.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+K+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},me.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),de=/^ /.test(se)&&/ $/.test(se);return oe&&de&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},me.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,de;return se[2]==="@"?(oe=$(this.options.mangle?he(se[1]):se[1]),de="mailto:"+oe):(oe=$(se[1]),de=oe),{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,de;if(se[2]==="@")oe=$(this.options.mangle?he(se[0]):se[0]),de="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=$(se[0]),se[1]==="www."?de="http://"+oe:de=oe}return{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:oe=$(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=c(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=c(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=c(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=c(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=c(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=c(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:c(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=c(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(ve){var me="",De,re,he=ve.length;for(De=0;De<he;De++)re=ve.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),me+="&#"+re+";";return me}var Z=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:B.normal,inline:O.normal};this.options.pedantic?(re.block=B.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=B.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ve.lex=function(re,he){var se=new ve(he);return se.lex(re)},ve.lexInline=function(re,he){var se=new ve(he);return se.inlineTokens(re)};var me=ve.prototype;return me.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,Q,H){return Q+"    ".repeat(H.length)});for(var oe,de,Ie,L;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=re.slice(1),H=void 0;se.options.extensions.startBlock.forEach(function(_){H=_.call({lexer:this},Q),typeof H=="number"&&H>=0&&(G=Math.min(G,H))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){de=he[he.length-1],L&&de.type==="paragraph"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe),L=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&de.type==="text"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(re){var K="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},me.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,de,Ie,L=re,K,G,Q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)H.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,K.index)+"["+A("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,K.index)+"["+A("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,K.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,L,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,te)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,te))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Fe=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Fe),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ie=re.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,de=he[he.length-1],de&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(re){var _="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ve}(),ye=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(re,oe);de!=null&&de!==re&&(se=!0,re=de)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(se?re:$(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:$(re,!0))+`</code></pre>
`},me.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},me.html=function(re){return re},me.heading=function(re,he,se,oe){if(this.options.headerIds){var de=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+de+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(re,he,se){var oe=he?"ol":"ul",de=he&&se!==1?' start="'+se+'"':"";return"<"+oe+de+`>
`+re+"</"+oe+`>
`},me.listitem=function(re){return"<li>"+re+`</li>
`},me.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(re){return"<p>"+re+`</p>
`},me.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},me.tablerow=function(re){return`<tr>
`+re+`</tr>
`},me.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},me.strong=function(re){return"<strong>"+re+"</strong>"},me.em=function(re){return"<em>"+re+"</em>"},me.codespan=function(re){return"<code>"+re+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(re){return"<del>"+re+"</del>"},me.link=function(re,he,se){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+$(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(re,he,se){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(re){return re},ve}(),Ee=function(){function ve(){}var me=ve.prototype;return me.strong=function(re){return re},me.em=function(re){return re},me.codespan=function(re){return re},me.del=function(re){return re},me.html=function(re){return re},me.text=function(re){return re},me.link=function(re,he,se){return""+se},me.image=function(re,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},me.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},ve}(),Y=function(){function ve(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new Pe}ve.parse=function(re,he){var se=new ve(he);return se.parse(re)},ve.parseInline=function(re,he){var se=new ve(he);return se.parseInline(re)};var me=ve.prototype;return me.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,de,Ie,L,K,G,Q,H,_,ce,Fe,Ue,Qe,Je,xe,Ye,_e,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ce=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){se+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(H="",Q="",L=ce.header.length,de=0;de<L;de++)Q+=this.renderer.tablecell(this.parseInline(ce.header[de].tokens),{header:!0,align:ce.align[de]});for(H+=this.renderer.tablerow(Q),_="",L=ce.rows.length,de=0;de<L;de++){for(G=ce.rows[de],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ce.align[Ie]});_+=this.renderer.tablerow(Q)}se+=this.renderer.table(H,_);continue}case"blockquote":{_=this.parse(ce.tokens),se+=this.renderer.blockquote(_);continue}case"list":{for(Fe=ce.ordered,Ue=ce.start,Qe=ce.loose,L=ce.items.length,_="",de=0;de<L;de++)xe=ce.items[de],Ye=xe.checked,_e=xe.task,Je="",xe.task&&(it=this.renderer.checkbox(Ye),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Je+=it),Je+=this.parse(xe.tokens,Qe),_+=this.renderer.listitem(Je,_e,Ye);se+=this.renderer.list(_,Fe,Ue);continue}case"html":{se+=this.renderer.html(ce.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(_=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<ze&&re[oe+1].type==="text";)ce=re[++oe],_+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);se+=he?this.renderer.paragraph(_):_;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(re,he){he=he||this.renderer;var se="",oe,de,Ie,L=re.length;for(oe=0;oe<L;oe++){if(de=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){se+=Ie||"";continue}switch(de.type){case"escape":{se+=he.text(de.text);break}case"html":{se+=he.html(de.text);break}case"link":{se+=he.link(de.href,de.title,this.parseInline(de.tokens,he));break}case"image":{se+=he.image(de.href,de.title,de.text);break}case"strong":{se+=he.strong(this.parseInline(de.tokens,he));break}case"em":{se+=he.em(this.parseInline(de.tokens,he));break}case"codespan":{se+=he.codespan(de.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(de.tokens,he));break}case"text":{se+=he.text(de.text);break}default:{var K='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function ae(ve,me,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(De=me,me=null),me=I({},ae.defaults,me||{}),h(me),De){var re=me.highlight,he;try{he=Z.lex(ve,me)}catch(L){return De(L)}var se=function(K){var G;if(!K)try{me.walkTokens&&ae.walkTokens(he,me.walkTokens),G=Y.parse(he,me)}catch(Q){K=Q}return me.highlight=re,K?De(K):De(null,G)};if(!re||re.length<3||(delete me.highlight,!he.length))return se();var oe=0;ae.walkTokens(he,function(L){L.type==="code"&&(oe++,setTimeout(function(){re(L.text,L.lang,function(K,G){if(K)return se(K);G!=null&&G!==L.text&&(L.text=G,L.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function de(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(L.message+"",!0)+"</pre>";throw L}try{var Ie=Z.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(ae.walkTokens(Ie,me.walkTokens)).then(function(){return Y.parse(Ie,me)}).catch(de);ae.walkTokens(Ie,me.walkTokens)}return Y.parse(Ie,me)}catch(L){de(L)}}ae.options=ae.setOptions=function(ve){return I(ae.defaults,ve),l(ae.defaults),ae},ae.getDefaults=R,ae.defaults=be.defaults,ae.use=function(){for(var ve=arguments.length,me=new Array(ve),De=0;De<ve;De++)me[De]=arguments[De];var re=I.apply(void 0,[{}].concat(me)),he=ae.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var L=he.renderers?he.renderers[Ie.name]:null;L?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var H=Ie.renderer.apply(this,G);return H===!1&&(H=L.apply(this,G)),H}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ae.defaults.renderer||new ye,L=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ce=new Array(_),Fe=0;Fe<_;Fe++)ce[Fe]=arguments[Fe];var Ue=oe.renderer[Q].apply(Ie,ce);return Ue===!1&&(Ue=H.apply(Ie,ce)),Ue}};for(var K in oe.renderer)L(K);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ae.defaults.tokenizer||new U,L=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ce=new Array(_),Fe=0;Fe<_;Fe++)ce[Fe]=arguments[Fe];var Ue=oe.tokenizer[Q].apply(Ie,ce);return Ue===!1&&(Ue=H.apply(Ie,ce)),Ue}};for(var K in oe.tokenizer)L(K);re.tokenizer=Ie}(),oe.walkTokens){var de=ae.defaults.walkTokens;re.walkTokens=function(Ie){var L=[];return L.push(oe.walkTokens.call(this,Ie)),de&&(L=L.concat(de.call(this,Ie))),L}}se&&(re.extensions=he),ae.setOptions(re)})},ae.walkTokens=function(ve,me){for(var De=[],re=function(){var de=se.value;switch(De=De.concat(me.call(ae,de)),de.type){case"table":{for(var Ie=F(de.header),L;!(L=Ie()).done;){var K=L.value;De=De.concat(ae.walkTokens(K.tokens,me))}for(var G=F(de.rows),Q;!(Q=G()).done;)for(var H=Q.value,_=F(H),ce;!(ce=_()).done;){var Fe=ce.value;De=De.concat(ae.walkTokens(Fe.tokens,me))}break}case"list":{De=De.concat(ae.walkTokens(de.items,me));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[de.type]?ae.defaults.extensions.childTokens[de.type].forEach(function(Ue){De=De.concat(ae.walkTokens(de[Ue],me))}):de.tokens&&(De=De.concat(ae.walkTokens(de.tokens,me)))}},he=F(ve),se;!(se=he()).done;)re();return De},ae.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=I({},ae.defaults,me||{}),h(me);try{var De=Z.lexInline(ve,me);return me.walkTokens&&ae.walkTokens(De,me.walkTokens),Y.parseInline(De,me)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(re.message+"",!0)+"</pre>";throw re}},ae.Parser=Y,ae.parser=Y.parse,ae.Renderer=ye,ae.TextRenderer=Ee,ae.Lexer=Z,ae.lexer=Z.lex,ae.Tokenizer=U,ae.Slugger=Pe,ae.parse=ae;var Se=ae.options,ue=ae.setOptions,$e=ae.use,ie=ae.walkTokens,z=ae.parseInline,q=ae,le=Y.parse,we=Z.lex;be.Lexer=Z,be.Parser=Y,be.Renderer=ye,be.Slugger=Pe,be.TextRenderer=Ee,be.Tokenizer=U,be.getDefaults=R,be.lexer=we,be.marked=ae,be.options=Se,be.parse=q,be.parseInline=z,be.parser=le,be.setOptions=ue,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Re[117],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function w(l,D,g){return Math.min(Math.max(l,D),g)}e.$Kl=w;function M(l,D){return(D+l%D)%D}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=C;class F{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=F;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=R}),function(){function be(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function R(D){F.push(D,Date.now())}function l(){const D=[];for(let g=0;g<F.length;g+=2)D.push({name:F[g],startTime:F[g+1]});return D}return{mark:R,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(C+R.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:be)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return be[M].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(M,C,F){w.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:F})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,C){if(1&C&&(M=w(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var R in M)w.d(F,R,function(l){return M[l]}.bind(null,R));return F},w.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(C,"a",C),C},w.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(M){var C;e=be.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],D=e.src=[],g=0,P=g++;D[P]="0|[1-9]\\d*";var k=g++;D[k]="[0-9]+";var a=g++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=g++;D[p]="("+D[P]+")\\.("+D[P]+")\\.("+D[P]+")";var $=g++;D[$]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var f=g++;D[f]="(?:"+D[P]+"|"+D[a]+")";var t=g++;D[t]="(?:"+D[k]+"|"+D[a]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var c=g++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var b=g++;D[b]="[0-9A-Za-z-]+";var E=g++;D[E]="(?:\\+("+D[b]+"(?:\\."+D[b]+")*))";var v=g++,r="v?"+D[p]+D[i]+"?"+D[E]+"?";D[v]="^"+r+"$";var s="[v=\\s]*"+D[$]+D[c]+"?"+D[E]+"?",n=g++;D[n]="^"+s+"$";var o=g++;D[o]="((?:<|>)?=?)";var y=g++;D[y]=D[k]+"|x|X|\\*";var d=g++;D[d]=D[P]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[d]+")(?:\\.("+D[d]+")(?:\\.("+D[d]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var S=g++;D[S]="[v=\\s]*("+D[y]+")(?:\\.("+D[y]+")(?:\\.("+D[y]+")(?:"+D[c]+")?"+D[E]+"?)?)?";var u=g++;D[u]="^"+D[o]+"\\s*"+D[I]+"$";var m=g++;D[m]="^"+D[o]+"\\s*"+D[S]+"$";var h=g++;D[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=g++;D[A]="(?:~>?)";var W=g++;D[W]="(\\s*)"+D[A]+"\\s+",l[W]=new RegExp(D[W],"g");var V=g++;D[V]="^"+D[A]+D[I]+"$";var U=g++;D[U]="^"+D[A]+D[S]+"$";var B=g++;D[B]="(?:\\^)";var O=g++;D[O]="(\\s*)"+D[B]+"\\s+",l[O]=new RegExp(D[O],"g");var N=g++;D[N]="^"+D[B]+D[I]+"$";var te=g++;D[te]="^"+D[B]+D[S]+"$";var Z=g++;D[Z]="^"+D[o]+"\\s*("+s+")$|^$";var ye=g++;D[ye]="^"+D[o]+"\\s*("+r+")$|^$";var Ee=g++;D[Ee]="(\\s*)"+D[o]+"\\s*("+s+"|"+D[I]+")",l[Ee]=new RegExp(D[Ee],"g");var Pe=g++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var Y=g++;D[Y]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var ae=g++;D[ae]="(<|>)?=?\\s*\\*";for(var Se=0;Se<35;Se++)C(Se,D[Se]),l[Se]||(l[Se]=new RegExp(D[Se]));function ue(H,_){if(H instanceof $e)return H;if(typeof H!="string"||H.length>F||!(_?l[n]:l[v]).test(H))return null;try{return new $e(H,_)}catch{return null}}function $e(H,_){if(H instanceof $e){if(H.loose===_)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof $e))return new $e(H,_);C("SemVer",H,_),this.loose=_;var ce=H.trim().match(_?l[n]:l[v]);if(!ce)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Ue=+Fe;if(Ue>=0&&Ue<R)return Ue}return Fe}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ue,e.valid=function(H,_){var ce=ue(H,_);return ce?ce.version:null},e.clean=function(H,_){var ce=ue(H.trim().replace(/^[=v]+/,""),_);return ce?ce.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof $e||(H=new $e(H,this.loose)),this.compareMain(H)||this.comparePre(H)},$e.prototype.compareMain=function(H){return H instanceof $e||(H=new $e(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},$e.prototype.comparePre=function(H){if(H instanceof $e||(H=new $e(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var _=0;do{var ce=this.prerelease[_],Fe=H.prerelease[_];if(C("prerelease compare",_,ce,Fe),ce===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ce===void 0)return-1;if(ce!==Fe)return z(ce,Fe)}while(++_)},$e.prototype.inc=function(H,_){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,_,ce,Fe){typeof ce=="string"&&(Fe=ce,ce=void 0);try{return new $e(H,ce).inc(_,Fe).version}catch{return null}},e.diff=function(H,_){if(ve(H,_))return null;var ce=ue(H),Fe=ue(_);if(ce.prerelease.length||Fe.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Fe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Fe[Ue])return Ue},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(H,_){var ce=ie.test(H),Fe=ie.test(_);return ce&&Fe&&(H=+H,_=+_),ce&&!Fe?-1:Fe&&!ce?1:H<_?-1:H>_?1:0}function q(H,_,ce){return new $e(H,ce).compare(new $e(_,ce))}function le(H,_,ce){return q(H,_,ce)>0}function we(H,_,ce){return q(H,_,ce)<0}function ve(H,_,ce){return q(H,_,ce)===0}function me(H,_,ce){return q(H,_,ce)!==0}function De(H,_,ce){return q(H,_,ce)>=0}function re(H,_,ce){return q(H,_,ce)<=0}function he(H,_,ce,Fe){var Ue;switch(_){case"===":typeof H=="object"&&(H=H.version),typeof ce=="object"&&(ce=ce.version),Ue=H===ce;break;case"!==":typeof H=="object"&&(H=H.version),typeof ce=="object"&&(ce=ce.version),Ue=H!==ce;break;case"":case"=":case"==":Ue=ve(H,ce,Fe);break;case"!=":Ue=me(H,ce,Fe);break;case">":Ue=le(H,ce,Fe);break;case">=":Ue=De(H,ce,Fe);break;case"<":Ue=we(H,ce,Fe);break;case"<=":Ue=re(H,ce,Fe);break;default:throw new TypeError("Invalid operator: "+_)}return Ue}function se(H,_){if(H instanceof se){if(H.loose===_)return H;H=H.value}if(!(this instanceof se))return new se(H,_);C("comparator",H,_),this.loose=_,this.parse(H),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,_){return z(_,H)},e.major=function(H,_){return new $e(H,_).major},e.minor=function(H,_){return new $e(H,_).minor},e.patch=function(H,_){return new $e(H,_).patch},e.compare=q,e.compareLoose=function(H,_){return q(H,_,!0)},e.rcompare=function(H,_,ce){return q(_,H,ce)},e.sort=function(H,_){return H.sort(function(ce,Fe){return e.compare(ce,Fe,_)})},e.rsort=function(H,_){return H.sort(function(ce,Fe){return e.rcompare(ce,Fe,_)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=me,e.gte=De,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function de(H,_){if(H instanceof de)return H.loose===_?H:new de(H.raw,_);if(H instanceof se)return new de(H.value,_);if(!(this instanceof de))return new de(H,_);if(this.loose=_,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ie(H){return!H||H.toLowerCase()==="x"||H==="*"}function L(H,_,ce,Fe,Ue,Qe,Je,xe,Ye,_e,it,tt,ze){return((_=Ie(ce)?"":Ie(Fe)?">="+ce+".0.0":Ie(Ue)?">="+ce+"."+Fe+".0":">="+_)+" "+(xe=Ie(Ye)?"":Ie(_e)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+_e+1)+".0":tt?"<="+Ye+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function K(H,_){for(var ce=0;ce<H.length;ce++)if(!H[ce].test(_))return!1;if(_.prerelease.length){for(ce=0;ce<H.length;ce++)if(C(H[ce].semver),H[ce].semver!==oe&&H[ce].semver.prerelease.length>0){var Fe=H[ce].semver;if(Fe.major===_.major&&Fe.minor===_.minor&&Fe.patch===_.patch)return!0}return!1}return!0}function G(H,_,ce){try{_=new de(_,ce)}catch{return!1}return _.test(H)}function Q(H,_,ce,Fe){var Ue,Qe,Je,xe,Ye;switch(H=new $e(H,Fe),_=new de(_,Fe),ce){case">":Ue=le,Qe=re,Je=we,xe=">",Ye=">=";break;case"<":Ue=we,Qe=De,Je=le,xe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(H,_,Fe))return!1;for(var _e=0;_e<_.set.length;++_e){var it=_.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Fe)?tt=st:Je(st.semver,ze.semver,Fe)&&(ze=st)}),tt.operator===xe||tt.operator===Ye||(!ze.operator||ze.operator===xe)&&Qe(H,ze.semver)||ze.operator===Ye&&Je(H,ze.semver))return!1}return!0}se.prototype.parse=function(H){var _=this.loose?l[Z]:l[ye],ce=H.match(_);if(!ce)throw new TypeError("Invalid comparator: "+H);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new $e(ce[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===oe||(typeof H=="string"&&(H=new $e(H,this.loose)),he(H,this.operator,this.semver,this.loose))},se.prototype.intersects=function(H,_){if(!(H instanceof se))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new de(H.value,_),G(this.value,ce,_);if(H.operator==="")return ce=new de(this.value,_),G(H.semver,ce,_);var Fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Qe=this.semver.version===H.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),xe=he(this.semver,"<",H.semver,_)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Ye=he(this.semver,">",H.semver,_)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Fe||Ue||Qe&&Je||xe||Ye},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(H){var _=this.loose;H=H.trim(),C("range",H,_);var ce=_?l[Y]:l[Pe];H=H.replace(ce,L),C("hyphen replace",H),H=H.replace(l[Ee],"$1$2$3"),C("comparator trim",H,l[Ee]),H=(H=(H=H.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Fe=_?l[Z]:l[ye],Ue=H.split(" ").map(function(Qe){return function(Je,xe){return C("comp",Je),Je=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[te]:l[N];return tt.replace(st,function(x,X,pe,je,Oe){var Xe;return C("caret",tt,x,X,pe,je,Oe),Ie(X)?Xe="":Ie(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(je)?Xe=X==="0"?">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+".0 <"+(+X+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+je+Oe+" <"+X+"."+pe+"."+(+je+1):">="+X+"."+pe+"."+je+Oe+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+je+Oe+" <"+(+X+1)+".0.0"):(C("no pr"),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+je+" <"+X+"."+pe+"."+(+je+1):">="+X+"."+pe+"."+je+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+je+" <"+(+X+1)+".0.0"),C("caret return",Xe),Xe})}(it,_e)}).join(" ")}(Je,xe),C("caret",Je),Je=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[U]:l[V];return tt.replace(st,function(x,X,pe,je,Oe){var Xe;return C("tilde",tt,x,X,pe,je,Oe),Ie(X)?Xe="":Ie(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(je)?Xe=">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+X+"."+pe+"."+je+Oe+" <"+X+"."+(+pe+1)+".0"):Xe=">="+X+"."+pe+"."+je+" <"+X+"."+(+pe+1)+".0",C("tilde return",Xe),Xe})}(it,_e)}).join(" ")}(Je,xe),C("tildes",Je),Je=function(Ye,_e){return C("replaceXRanges",Ye,_e),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(x,X,pe,je,Oe,Xe){C("xRange",tt,x,X,pe,je,Oe,Xe);var rt=Ie(pe),mt=rt||Ie(je),wt=mt||Ie(Oe);return X==="="&&wt&&(X=""),rt?x=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(mt&&(je=0),wt&&(Oe=0),X===">"?(X=">=",mt?(pe=+pe+1,je=0,Oe=0):wt&&(je=+je+1,Oe=0)):X==="<="&&(X="<",mt?pe=+pe+1:je=+je+1),x=X+pe+"."+je+"."+Oe):mt?x=">="+pe+".0.0 <"+(+pe+1)+".0.0":wt&&(x=">="+pe+"."+je+".0 <"+pe+"."+(+je+1)+".0"),C("xRange return",x),x})}(it,_e)}).join(" ")}(Je,xe),C("xrange",Je),Je=function(Ye,_e){return C("replaceStars",Ye,_e),Ye.trim().replace(l[ae],"")}(Je,xe),C("stars",Je),Je}(Qe,_)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Fe)})),Ue=Ue.map(function(Qe){return new se(Qe,_)})},de.prototype.intersects=function(H,_){if(!(H instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Fe){return H.set.some(function(Ue){return Ue.every(function(Qe){return Fe.intersects(Qe,_)})})})})},e.toComparators=function(H,_){return new de(H,_).set.map(function(ce){return ce.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new $e(H,this.loose));for(var _=0;_<this.set.length;_++)if(K(this.set[_],H))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(H,_,ce){var Fe=null,Ue=null;try{var Qe=new de(_,ce)}catch{return null}return H.forEach(function(Je){Qe.test(Je)&&(Fe&&Ue.compare(Je)!==-1||(Ue=new $e(Fe=Je,ce)))}),Fe},e.minSatisfying=function(H,_,ce){var Fe=null,Ue=null;try{var Qe=new de(_,ce)}catch{return null}return H.forEach(function(Je){Qe.test(Je)&&(Fe&&Ue.compare(Je)!==1||(Ue=new $e(Fe=Je,ce)))}),Fe},e.validRange=function(H,_){try{return new de(H,_).range||"*"}catch{return null}},e.ltr=function(H,_,ce){return Q(H,_,"<",ce)},e.gtr=function(H,_,ce){return Q(H,_,">",ce)},e.outside=Q,e.prerelease=function(H,_){var ce=ue(H,_);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(H,_,ce){return H=new de(H,ce),_=new de(_,ce),H.intersects(_)},e.coerce=function(H){if(H instanceof $e)return H;if(typeof H!="string")return null;var _=H.match(l[h]);return _==null?null:ue((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,w(1))},function(be,e){var w,M,C=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function l(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var D,g=[],P=!1,k=-1;function a(){P&&D&&(P=!1,D.length?g=D.concat(g):k=-1,g.length&&p())}function p(){if(!P){var t=l(a);P=!0;for(var i=g.length;i;){for(D=g,g=[];++k<i;)D&&D[k].run();k=-1,i=g.length}D=null,P=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function f(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];g.push(new $(t,i)),g.length!==1||P||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Re[118],Me([1,0,9,6]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Xd=C;function F(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(r=>typeof r=="function"):!1}e.$Yd=F;function R(E){const v=E;return v?F(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$Zd=R;function l(E,v){return new D(E,v)}e.$1d=l;class D{constructor(v,r){this.e=v,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(r=>r(v))}h(v){this.c.error.length===0?(0,w.$Z)(v):this.c.error.slice(0).forEach(r=>r(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,r){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(v,r){if(this.a.destroyed)return;let s;switch(v){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const n=s.indexOf(r);n>=0&&s.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,v){const r=[];let s;for(;(s=E.read())!==null;)r.push(s);return v(r)}e.$2d=g;function P(E,v,r){const s=[];let n;for(;(n=E.read())!==null&&s.length<r;)s.push(n);return n===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return E.read()}}}e.$3d=P;function k(E,v){return new Promise((r,s)=>{const n=[];a(E,{onData:o=>{v&&n.push(o)},onError:o=>{v?s(o):r(void 0)},onEnd:()=>{r(v?v(n):void 0)}})})}e.$4d=k;function a(E,v,r){E.on("error",s=>{r?.isCancellationRequested||v.onError(s)}),E.on("end",()=>{r?.isCancellationRequested||v.onEnd()}),E.on("data",s=>{r?.isCancellationRequested||v.onData(s)})}e.$5d=a;function p(E,v){return new Promise((r,s)=>{const n=new M.$Qc,o=[],y=S=>{if(o.push(S),o.length>v)return n.dispose(),E.pause(),r({stream:E,buffer:o,ended:!1})},d=S=>(n.dispose(),s(S)),I=()=>(n.dispose(),r({stream:E,buffer:o,ended:!0}));n.add((0,M.$Pc)(()=>E.removeListener("error",d))),E.on("error",d),n.add((0,M.$Pc)(()=>E.removeListener("end",I))),E.on("end",I),n.add((0,M.$Pc)(()=>E.removeListener("data",y))),E.on("data",y)})}e.$6d=p;function $(E,v){const r=l(v);return r.end(E),r}e.$7d=$;function f(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$8d=f;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$9d=t;function i(E,v,r){const s=l(r);return a(E,{onData:n=>s.write(v.data(n)),onError:n=>s.error(v.error?v.error(n):n),onEnd:()=>s.end()}),s}e.$0d=i;function c(E,v,r){let s=!1;return{read:()=>{const n=v.read();return s?n:(s=!0,n!==null?r([E,n]):E)}}}e.$$d=c;function b(E,v,r){let s=!1;const n=l(r);return a(v,{onData:o=>s?n.write(o):(s=!0,n.write(r([E,o]))),onError:o=>n.error(o),onEnd:()=>{s||(s=!0,n.write(E)),n.end()}}),n}e.$_d=b}),define(Re[25],Me([1,0,48,118]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const C=typeof Buffer<"u",F=new w.$U(()=>new Uint8Array(256));let R,l;class D{static alloc(h){return C?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,A){return!(A?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(h)):(R||(R=new TextEncoder),new D(R.encode(h)))}static fromByteArray(h){const A=D.alloc(h.length);for(let W=0,V=h.length;W<V;W++)A.buffer[W]=h[W];return A}static concat(h,A){if(typeof A>"u"){A=0;for(let U=0,B=h.length;U<B;U++)A+=h[U].byteLength}const W=D.alloc(A);let V=0;for(let U=0,B=h.length;U<B;U++){const O=h[U];W.set(O,V),V+=O.byteLength}return W}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,A){return new D(this.buffer.subarray(h,A))}set(h,A){if(h instanceof D)this.buffer.set(h.buffer,A);else if(h instanceof Uint8Array)this.buffer.set(h,A);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),A);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return a(this.buffer,h)}writeUInt32BE(h,A){p(this.buffer,h,A)}readUInt32LE(h){return $(this.buffer,h)}writeUInt32LE(h,A){f(this.buffer,h,A)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,A){i(this.buffer,h,A)}indexOf(h,A=0){return g(this.buffer,h instanceof D?h.buffer:h,A)}}e.$ae=D;function g(m,h,A=0){const W=h.byteLength,V=m.byteLength;if(W===0)return 0;if(W===1)return m.indexOf(h[0]);if(W>V-A)return-1;const U=F.value;U.fill(h.length);for(let te=0;te<h.length;te++)U[h[te]]=h.length-te-1;let B=A+h.length-1,O=B,N=-1;for(;B<V;)if(m[B]===h[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(h.length-O,U[m[B]]),O=h.length-1;return N}e.$be=g;function P(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0}e.$ce=P;function k(m,h,A){m[A+0]=h&255,h=h>>>8,m[A+1]=h&255}e.$de=k;function a(m,h){return m[h]*2**24+m[h+1]*2**16+m[h+2]*2**8+m[h+3]}e.$ee=a;function p(m,h,A){m[A+3]=h,h=h>>>8,m[A+2]=h,h=h>>>8,m[A+1]=h,h=h>>>8,m[A]=h}e.$fe=p;function $(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0|m[h+2]<<16>>>0|m[h+3]<<24>>>0}e.$ge=$;function f(m,h,A){m[A+0]=h&255,h=h>>>8,m[A+1]=h&255,h=h>>>8,m[A+2]=h&255,h=h>>>8,m[A+3]=h&255}e.$he=f;function t(m,h){return m[h]}e.$ie=t;function i(m,h,A){m[A]=h}e.$je=i;function c(m){return M.$2d(m,h=>D.concat(h))}e.$ke=c;function b(m){return M.$9d(m)}e.$le=b;function E(m){return M.$4d(m,h=>D.concat(h))}e.$me=E;async function v(m){return m.ended?D.concat(m.buffer):D.concat([...m.buffer,await E(m.stream)])}e.$ne=v;function r(m){return M.$7d(m,h=>D.concat(h))}e.$oe=r;function s(m){return M.$0d(m,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.$pe=s;function n(m){return M.$1d(h=>D.concat(h),m)}e.$qe=n;function o(m,h){return M.$$d(m,h,A=>D.concat(A))}e.$re=o;function y(m,h){return M.$_d(m,h,A=>D.concat(A))}e.$se=y;function d(m){let h=0,A=0,W=0;const V=new Uint8Array(Math.floor(m.length/4*3)),U=O=>{switch(A){case 3:V[W++]=h|O,A=0;break;case 2:V[W++]=h|O>>>2,h=O<<6,A=3;break;case 1:V[W++]=h|O>>>4,h=O<<4,A=2;break;default:h=O<<2,A=1}};for(let O=0;O<m.length;O++){const N=m.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[O]}`)}}const B=W;for(;A>0;)U(0);return D.wrap(V).slice(0,B)}e.$te=d;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},h=!0,A=!1){const W=A?S:I;let V="";const U=m.byteLength%3;let B=0;for(;B<m.byteLength-U;B+=3){const O=m[B+0],N=m[B+1],te=m[B+2];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[(N<<2|te>>>6)&63],V+=W[te&63]}if(U===1){const O=m[B+0];V+=W[O>>>2],V+=W[O<<4&63],h&&(V+="==")}else if(U===2){const O=m[B+0],N=m[B+1];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[N<<2&63],h&&(V+="=")}return V}e.$ue=u}),define(Re[119],Me([1,0,28,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function C(...se){return function(oe,de){for(let Ie=0,L=se.length;Ie<L;Ie++){const K=se[Ie](oe,de);if(K)return K}return null}}e.or=C,e.$Aj=F.bind(void 0,!1),e.$Bj=F.bind(void 0,!0);function F(se,oe,de){if(!de||de.length<oe.length)return null;let Ie;return se?Ie=M.$2e(de,oe):Ie=de.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(se,oe){const de=oe.toLowerCase().indexOf(se.toLowerCase());return de===-1?null:[{start:de,end:de+se.length}]}e.$Cj=R;function l(se,oe){return D(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Dj=l;function D(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]===oe[Ie]){let L=null;return(L=D(se,oe,de+1,Ie+1))?i({start:Ie,end:Ie+1},L):null}return D(se,oe,de,Ie+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Ej=P;function k(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function $(se){return a(se)||p.has(se)}function f(se,oe){return se===oe||$(se)&&$(oe)}function t(se){return g(se)||P(se)||k(se)}function i(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let de=oe;de<se.length;de++){const Ie=se.charCodeAt(de);if(P(Ie)||k(Ie)||de>0&&!t(se.charCodeAt(de-1)))return de}return se.length}function b(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]!==oe[Ie].toLowerCase())return null;{let L=null,K=Ie+1;for(L=b(se,oe,de+1,Ie+1);!L&&(K=c(oe,K))<oe.length;)L=b(se,oe,de+1,K),K++;return L===null?null:i({start:Ie,end:Ie+1},L)}}function E(se){let oe=0,de=0,Ie=0,L=0,K=0;for(let ce=0;ce<se.length;ce++)K=se.charCodeAt(ce),P(K)&&oe++,g(K)&&de++,t(K)&&Ie++,k(K)&&L++;const G=oe/se.length,Q=de/se.length,H=Ie/se.length,_=L/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:H,numericPercent:_}}function v(se){const{upperPercent:oe,lowerPercent:de}=se;return de===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:de,alphaPercent:Ie,numericPercent:L}=se;return de>.2&&oe<.8&&Ie>.6&&L<.2}function s(se){let oe=0,de=0,Ie=0,L=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,g(Ie)&&de++,a(Ie)&&L++;return(oe===0||de===0)&&L===0?se.length<=30:oe<=5}function n(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const de=E(oe);if(!r(de)){if(!v(de))return null;oe=oe.toLowerCase()}let Ie=null,L=0;for(se=se.toLowerCase();L<oe.length&&(Ie=b(se,oe,0,L))===null;)L=c(oe,L+1);return Ie}e.$Fj=n;function o(se,oe,de=!1){if(!oe||oe.length===0)return null;let Ie=null,L=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();L<oe.length&&(Ie=y(se,oe,0,L,de))===null;)L=d(oe,L+1);return Ie}e.$Gj=o;function y(se,oe,de,Ie,L){if(de===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(de),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,de+1,Ie+1,L),!L)for(;!K&&(G=d(oe,G))<oe.length;)K=y(se,oe,de+1,G,L),G++;return K?se.charCodeAt(de)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function d(se,oe){for(let de=oe;de<se.length;de++)if($(se.charCodeAt(de))||de>0&&$(se.charCodeAt(de-1)))return de;return se.length}const I=C(e.$Bj,n,R),S=C(e.$Bj,n,l),u=new w.$Cc(1e4);function m(se,oe,de=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=u.get(se);Ie||(Ie=new RegExp(M.$Ke(se),"i"),u.set(se,Ie));const L=Ie.exec(oe);return L?[{start:L.index,end:L.index+L[0].length}]:de?S(se,oe):I(se,oe)}e.$Hj=m;function h(se,oe){const de=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?W(de):null}e.$Ij=h;function A(se,oe,de,Ie,L,K){const G=Math.min(13,se.length);for(;de<G;de++){const Q=le(se,oe,de,Ie,L,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Jj=A;function W(se){if(typeof se>"u")return[];const oe=[],de=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const L=se[Ie]+de,K=oe[oe.length-1];K&&K.end===L?K.end=L+1:oe.push({start:L,end:L+1})}return oe}e.$Kj=W;const V=128;function U(){const se=[],oe=[];for(let de=0;de<=V;de++)oe[de]=0;for(let de=0;de<=V;de++)se.push(oe.slice(0));return se}function B(se){const oe=[];for(let de=0;de<=se;de++)oe[de]=0;return oe}const O=B(2*V),N=B(2*V),te=U(),Z=U(),ye=U(),Ee=!1;function Pe(se,oe,de,Ie,L){function K(Q,H,_=" "){for(;Q.length<H;)Q=_+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,L+1).map(H=>K(H.toString(),3)).join("|")+`
`;return G}function Y(se,oe,de,Ie){se=se.substr(oe),de=de.substr(Ie),console.log(Pe(Z,se,se.length,de,de.length)),console.log(Pe(ye,se,se.length,de,de.length)),console.log(Pe(te,se,se.length,de,de.length))}function ae(se,oe){if(oe<0||oe>=se.length)return!1;const de=se.codePointAt(oe);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$hf(de)}}function Se(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ue(se,oe,de){return oe[se]!==de[se]}function $e(se,oe,de,Ie,L,K,G=!1){for(;oe<de&&L<K;)se[oe]===Ie[L]&&(G&&(O[oe]=L),oe+=1),L+=1;return oe===de}e.$Lj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,de){this.firstMatchCanBeWeak=oe,this.boostFullMatch=de}}e.$Mj=q;function le(se,oe,de,Ie,L,K,G=q.default){const Q=se.length>V?V:se.length,H=Ie.length>V?V:Ie.length;if(de>=Q||K>=H||Q-de>H-K||!$e(oe,de,Q,L,K,H,!0))return;we(Q,H,de,K,oe,L);let _=1,ce=1,Fe=de,Ue=K;const Qe=[!1];for(_=1,Fe=de;Fe<Q;_++,Fe++){const it=O[Fe],tt=N[Fe],ze=Fe+1<Q?N[Fe+1]:H;for(ce=it-K+1,Ue=it;Ue<ze;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,x=!1;Ue<=tt&&(st=ve(se,oe,Fe,de,Ie,L,Ue,H,K,te[_-1][ce-1]===0,Qe));let X=0;st!==Number.MAX_SAFE_INTEGER&&(x=!0,X=st+Z[_-1][ce-1]);const pe=Ue>it,je=pe?Z[_][ce-1]+(te[_][ce-1]>0?-5:0):0,Oe=Ue>it+1&&te[_][ce-1]>0,Xe=Oe?Z[_][ce-2]+(te[_][ce-2]>0?-5:0):0;if(Oe&&(!pe||Xe>=je)&&(!x||Xe>=X))Z[_][ce]=Xe,ye[_][ce]=3,te[_][ce]=0;else if(pe&&(!x||je>=X))Z[_][ce]=je,ye[_][ce]=2,te[_][ce]=0;else if(x)Z[_][ce]=X,ye[_][ce]=1,te[_][ce]=te[_-1][ce-1]+1;else throw new Error("not possible")}}if(Ee&&Y(se,de,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;_--,ce--;const Je=[Z[_][ce],K];let xe=0,Ye=0;for(;_>=1;){let it=ce;do{const tt=ye[_][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&oe[de+_-1]===L[K+ce-1]&&!ue(it+K-1,Ie,L)&&xe+1>te[_][it]&&(it=ce),it===ce?xe++:xe=1,Ye||(Ye=it),_--,ce=it-1,Je.push(ce)}H===Q&&G.boostFullMatch&&(Je[0]+=2);const _e=Ye-Q;return Je[0]-=_e,Je}e.$Nj=le;function we(se,oe,de,Ie,L,K){let G=se-1,Q=oe-1;for(;G>=de&&Q>=Ie;)L[G]===K[Q]&&(N[G]=Q,G--),Q--}function ve(se,oe,de,Ie,L,K,G,Q,H,_,ce){if(oe[de]!==K[G])return Number.MIN_SAFE_INTEGER;let Fe=1,Ue=!1;return G===de-Ie?Fe=se[de]===L[G]?7:5:ue(G,L,K)&&(G===0||!ue(G-1,L,K))?(Fe=se[de]===L[G]?7:5,Ue=!0):ae(K,G)&&(G===0||!ae(K,G-1))?Fe=5:(ae(K,G-1)||Se(K,G-1))&&(Fe=5,Ue=!0),Fe>1&&de===Ie&&(ce[0]=!0),Ue||(Ue=ue(G,L,K)||ae(K,G-1)||Se(K,G-1)),de===Ie?G>H&&(Fe-=Ue?3:5):_?Fe+=Ue?2:0:Fe+=Ue?0:1,G+1===Q&&(Fe-=Ue?3:5),Fe}function me(se,oe,de,Ie,L,K,G){return re(se,oe,de,Ie,L,K,!0,G)}e.$Oj=me;function De(se,oe,de,Ie,L,K,G){return re(se,oe,de,Ie,L,K,!1,G)}e.$Pj=De;function re(se,oe,de,Ie,L,K,G,Q){let H=le(se,oe,de,Ie,L,K,Q);if(H&&!G)return H;if(se.length>=3){const _=Math.min(7,se.length-1);for(let ce=de+1;ce<_;ce++){const Fe=he(se,ce);if(Fe){const Ue=le(Fe,Fe.toLowerCase(),de,Ie,L,K,Q);Ue&&(Ue[0]-=3,(!H||Ue[0]>H[0])&&(H=Ue))}}}return H}function he(se,oe){if(oe+1>=se.length)return;const de=se[oe],Ie=se[oe+1];if(de!==Ie)return se.slice(0,oe)+Ie+de+se.slice(oe+2)}}),define(Re[29],Me([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const F="error",R="warning",l="warn",D="info",g="ignore";function P(a){return a?w.$1e(F,a)?C.Error:w.$1e(R,a)||w.$1e(l,a)?C.Warning:w.$1e(D,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function k(a){switch(a){case C.Error:return F;case C.Warning:return R;case C.Info:return D;default:return g}}C.toString=k}(M||(M={})),e.default=M}),define(Re[120],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(Re[49],Me([1,0,18,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),f=this.b.charCodeAt(this.c);return $-f}value(){return this.b[this.c]}}e.$Ph=C;class F{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$Ue)(p,this.b,0,p.length,this.c,this.d):(0,M.$We)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=F;class R{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const f=this.b.charCodeAt($);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$Ue)(p,this.b,0,p.length,this.d,this.e):(0,M.$We)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=R;var l;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(l||(l={}));class D{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$Ve)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ve)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$Te)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$Te)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class k{static forUris(p=()=>!1,$=()=>!1){return new k(new D(p,$))}static forPaths(p=!1){return new k(new R(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new F)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const f=$.slice(0);(0,w.$Wb)(f);for(const t of f)this.set(t,p)}else{const f=p.slice(0);(0,w.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(p,$){const f=this.b.reset(p);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const b=f.cmp(t.segment);if(b>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=p;for(let b=i.length-1;b>=0;b--){const E=i[b][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const r=i[b][0],s=i[b+1][0];if(r===1&&s===1)i[b][1]=E.rotateLeft();else if(r===-1&&s===-1)i[b][1]=E.rotateRight();else if(r===1&&s===-1)E.right=i[b+1][1]=i[b+1][1].rotateRight(),i[b][1]=E.rotateLeft();else if(r===-1&&s===1)E.left=i[b+1][1]=i[b+1][1].rotateLeft(),i[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(i[b-1][0]){case-1:i[b-1][1].left=i[b][1];break;case 1:i[b-1][1].right=i[b][1];break;case 0:i[b-1][1].mid=i[b][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let f=this.c;for(;f;){const t=$.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if($.hasNext())$.next(),f=f.mid;else break}return f}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const f=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=f.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:b,value:E,segment:v}=c;this.e(c.key,!1),i.key=b,i.value=E,i.segment=v}}else{const c=i.left??i.right;if(t.length>0){const[b,E]=t[t.length-1];switch(b){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const b=t[c][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[c][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[c][1]=b.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let f=this.c,t;for(;f;){const i=$.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if($.hasNext())$.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const f=this.b.reset(p);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,f]of this)p(f,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const f=$.balanceFactor();return f<-1||f>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Th=k}),define(Re[40],Me([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var M;(function(R){function l(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(R){return{id:R}}e.$Tj=C;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(c){const b=l.exec(c.id);if(!b)return D(w.$Sj.error);const[,E,v]=b,r=["codicon","codicon-"+E];return v&&r.push("codicon-modifier-"+v.substring(1)),r}R.asClassNameArray=D;function g(c){return D(c).join(" ")}R.asClassName=g;function P(c){return"."+D(c).join(".")}R.asCSSSelector=P;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}R.isThemeIcon=k;const a=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(c){const b=a.exec(c);if(!b)return;const[,E]=b;return{id:E}}R.fromString=p;function $(c){return{id:c}}R.fromId=$;function f(c,b){let E=c.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),b&&(E=`${E}~${b}`),{id:E}}R.modify=f;function t(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}R.getModifier=t;function i(c,b){return c.id===b.id&&c.color?.id===b.color?.id}R.isEqual=i})(F||(e.ThemeIcon=F={}))}),define(Re[121],Me([1,0,119,15,40]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const F="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace(l,(c,b)=>b?c:`\\${c}`)}e.$Uj=D;const g=new RegExp(`\\\\${R.source}`,"g");function P(i){return i.replace(g,c=>`\\${c}`)}e.$Vj=P;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function a(i){return i.indexOf(F)===-1?i:i.replace(k,(c,b,E,v)=>E?c:b||v||"")}e.$Wj=a;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}e.$Xj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){$.lastIndex=0;let c="";const b=[];let E=0;for(;;){const v=$.lastIndex,r=$.exec(i),s=i.substring(v,r?.index);if(s.length>0){c+=s;for(let n=0;n<s.length;n++)b.push(E)}if(!r)break;E+=r[0].length}return{text:c,iconOffsets:b}}e.$Yj=f;function t(i,c,b=!1){const{text:E,iconOffsets:v}=c;if(!v||v.length===0)return(0,w.$Hj)(i,E,b);const r=(0,M.$Ie)(E," "),s=E.length-r.length,n=(0,w.$Hj)(i,r,b);if(n)for(const o of n){const y=v[o.start+s]+s;o.start+=y,o.end+=y}return n}e.$Zj=t}),define(Re[36],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return w.test(C)}e.$cg=M,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let D=0;D<l.length;D++)l[D]=Math.floor(Math.random()*256);return l};const F=new Uint8Array(16),R=[];for(let l=0;l<256;l++)R.push(l.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let D=0,g="";return g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g+="-",g+=R[F[D++]],g+=R[F[D++]],g+="-",g+=R[F[D++]],g+=R[F[D++]],g+="-",g+=R[F[D++]],g+=R[F[D++]],g+="-",g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g+=R[F[D++]],g}}()}),define(Re[122],Me([1,0,18,65,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=e.$Us=e.$Ts=void 0;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ts=F;function R(k,a,p){const $={id:(0,C.$dg)(),name:k,uri:a,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Us=R;class l{constructor(){this.a=new Map}get size(){let a=0;for(const p of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const p=[...this.a.keys()];return M.Iterable.some(this,([$,f])=>f.asFile())&&p.push("files"),P(D(a),p)}get(a){return this.a.get(this.b(a))?.[0]}append(a,p){const $=this.a.get(a);$?$.push(p):this.a.set(this.b(a),[p])}replace(a,p){this.a.set(this.b(a),[p])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,p]of this.a)for(const $ of p)yield[a,$]}b(a){return D(a)}}e.$Vs=l;function D(k){return k.toLowerCase()}function g(k,a){return P(D(k),a.map(D))}e.$Ws=g;function P(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,f,t]=p;return t==="*"?a.some(i=>i.startsWith(f+"/")):!1}e.$Xs=Object.freeze({create:k=>(0,w.$Lb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Xs.split(k).filter(a=>!a.startsWith("#"))})}),define(Re[123],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0,e.$Yr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[124],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.IndentAction=void 0;var w;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let D=0,g=l.notIn.length;D<g;D++)switch(l.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,D){if(l.getTokenCount()===0)return!0;const g=l.findTokenIndexAtOffset(D-2),P=l.getStandardTokenType(g);return this.isOK(P)}g(l,D){for(let g=l;g<=D;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$kt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of l)F(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),F(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),F(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),F(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&F(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$lt=C;function F(R,l,D){R.has(l)?R.get(l).push(D):R.set(l,[D])}}),define(Re[125],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7=e.$D7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$D7=w;class M{constructor(F){this.identifier=F}}e.$E7=M}),define(Re[126],Me([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Re[127],Me([1,0,5,6,126]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class F extends M.$Rc{constructor(a,p="",$="",f=!0,t){super(),this.h=this.B(new w.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=p,this.u=$,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,p){this.C&&await this.C(a)}}e.$si=F;class R extends M.$Rc{constructor(){super(...arguments),this.f=this.B(new w.$Md),this.onWillRun=this.f.event,this.m=this.B(new w.$Md),this.onDidRun=this.m.event}async run(a,p){if(!a.enabled)return;this.f.fire({action:a});let $;try{await this.u(a,p)}catch(f){$=f}this.m.fire({action:a,error:$})}async u(a,p){await a.run(p)}}e.$ti=R;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let p=[];for(const $ of a)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=l;class D{get actions(){return this.a}constructor(a,p,$,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=p,this.class=f,this.a=$}async run(){}}e.$vi=D;class g extends F{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$wi=g;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$xi=P}),define(Re[128],Me([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Re[129],Me([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0;const M=60,C=M*60,F=C*24,R=F*7,l=F*30,D=F*365;function g(k,a,p,$){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,w.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!$&&f<30)return(0,w.localize)(1,null);let t;return f<M?(t=f,a?t===1?p?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):p?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?p?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):p?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<C?(t=Math.floor(f/M),a?t===1?p?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):p?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?p?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):p?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<F?(t=Math.floor(f/C),a?t===1?p?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):p?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?p?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):p?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<R?(t=Math.floor(f/F),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<l?(t=Math.floor(f/R),a?t===1?p?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):p?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?p?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):p?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<D?(t=Math.floor(f/l),a?t===1?p?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):p?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?p?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):p?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/D),a?t===1?p?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):p?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?p?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):p?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$_l=g;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$am=P}),define(Re[130],Me([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Re[41],Me([1,0,18,16,130]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function F(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),R(k.stack)||R(k.stacktrace)):l(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function D(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=w.$Gb(k),$=D(p[0],a);return p.length>1?C.localize(4,null,$,p.length):$}if(M.$xf(k))return k;if(k.detail){const p=k.detail;if(p.error)return F(p.error,a);if(p.exception)return F(p.exception,a)}return k.stack?F(k,a):k.message?k.message:C.localize(5,null)}e.$yi=D;function g(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$zi=g;function P(k,a){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=a,p}e.$Ai=P}),define(Re[131],Me([1,0,48,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;const C=new w.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),F=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const h=S||"",A=u||"",W=C.value.collator.compare(h,A);return C.value.collatorIsNumeric&&W===0&&h!==A?h<A?-1:1:W}e.$dq=l;function D(S,u){const m=F.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$eq=D;function g(S,u){const m=F.value.collator;return S=S||"",u=u||"",n(S,u)||E(m,S,u)}e.$fq=g;function P(S,u){const m=F.value.collator;return S=S||"",u=u||"",s(S,u)||E(m,S,u)}e.$gq=P;function k(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$hq=k;function a(S,u){const[m,h]=c(S),[A,W]=c(u);let V=C.value.collator.compare(h,W);if(V===0){if(C.value.collatorIsNumeric&&h!==W)return h<W?-1:1;if(V=C.value.collator.compare(m,A),C.value.collatorIsNumeric&&V===0&&m!==A)return m<A?-1:1}return V}e.$iq=a;function p(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),A=F.value.collator,W=R.value.collator;return E(W,m,h)||E(A,S,u)}e.$jq=p;function $(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),A=F.value.collator,W=R.value.collator;return E(W,m,h)||n(S,u)||E(A,S,u)}e.$kq=$;function f(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),A=F.value.collator,W=R.value.collator;return E(W,m,h)||s(S,u)||E(A,S,u)}e.$lq=f;function t(S,u){S=S||"",u=u||"";const m=b(S).toLowerCase(),h=b(u).toLowerCase();return m!==h?m<h?-1:1:S!==u?S<u?-1:1:0}e.$mq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(S,u=!1){const m=S?i.exec(S):[];let h=[m&&m[1]||"",m&&m[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function b(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const h=S.compare(u,m);return h!==0?h:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function r(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function s(S,u){return v(S)&&r(u)?-1:r(S)&&v(u)?1:0}function n(S,u){return r(S)&&v(u)?-1:v(S)&&r(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function y(S,u,m=!1){const h=S.split(M.sep),A=u.split(M.sep),W=h.length-1,V=A.length-1;let U,B;for(let O=0;;O++){if(U=W===O,B=V===O,U&&B)return l(h[O],A[O],m);if(U)return-1;if(B)return 1;const N=o(h[O],A[O],m);if(N!==0)return N}}e.$nq=y;function d(S,u,m){const h=S.toLowerCase(),A=u.toLowerCase(),W=I(S,u,m);if(W)return W;const V=h.endsWith(m),U=A.endsWith(m);if(V!==U)return V?-1:1;const B=l(h,A);return B!==0?B:h.localeCompare(A)}e.$oq=d;function I(S,u,m){const h=S.toLowerCase(),A=u.toLowerCase(),W=h.startsWith(m),V=A.startsWith(m);if(W!==V)return W?-1:1;if(W&&V){if(h.length<A.length)return-1;if(h.length>A.length)return 1}return 0}e.$pq=I}),define(Re[42],Me([1,0,19,22,15,16]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function R(d){return d===47||d===92}e.$Pf=R;function l(d){return d.replace(/[\\/]/g,w.$fc.sep)}e.$Qf=l;function D(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Rf=D;function g(d,I=w.$fc.sep){if(!d)return"";const S=d.length,u=d.charCodeAt(0);if(R(u)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let h=3;const A=h;for(;h<S&&!R(d.charCodeAt(h));h++);if(A!==h&&!R(d.charCodeAt(h+1))){for(h+=1;h<S;h++)if(R(d.charCodeAt(h)))return d.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+I:d.slice(0,2);let m=d.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(R(d.charCodeAt(m)))return d.slice(0,m+1)}return""}e.$Sf=g;function P(d){if(!M.$j||!d||d.length<5)return!1;let I=d.charCodeAt(0);if(I!==92||(I=d.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<d.length&&(I=d.charCodeAt(S),I!==92);S++);return!(u===S||(I=d.charCodeAt(S+1),isNaN(I)||I===92))}e.$Tf=P;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(d,I=M.$j){const S=I?k:a;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||I&&p.test(d)||d==="."||d===".."||I&&d[d.length-1]==="."||I&&d.length!==d.trim().length||d.length>255)}e.$Uf=$;function f(d,I,S){const u=d===I;return!S||u?u:!d||!I?!1:(0,C.$1e)(d,I)}e.$Vf=f;function t(d,I,S,u=w.sep){if(d===I)return!0;if(!d||!I||I.length>d.length)return!1;if(S){if(!(0,C.$2e)(d,I))return!1;if(I.length===d.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,d.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),d.indexOf(I)===0}e.$Wf=t;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Xf=i;function c(d,I){return M.$j&&d.endsWith(":")&&(d+=w.sep),(0,w.$hc)(d)||(d=(0,w.$ic)(I,d)),d=(0,w.$gc)(d),M.$j?(d=(0,C.$Je)(d,w.sep),d.endsWith(":")&&(d+=w.sep)):(d=(0,C.$Je)(d,w.sep),d||(d=w.sep)),d}e.$Yf=c;function b(d){const I=(0,w.$gc)(d);return M.$j?d.length>3?!1:E(I)&&(d.length===2||I.charCodeAt(2)===92):I===w.$fc.sep}e.$Zf=b;function E(d,I=M.$j){return I?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$1f=E;function v(d,I=M.$j){return E(d,I)?d[0]:void 0}e.$2f=v;function r(d,I,S){return I.length>d.length?-1:d===I?0:(S&&(d=d.toLowerCase(),I=I.toLowerCase()),d.indexOf(I))}e.$3f=r;function s(d){const I=d.split(":");let S,u,m;for(const h of I){const A=Number(h);(0,F.$Bf)(A)?u===void 0?u=A:m===void 0&&(m=A):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$4f=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,I,S=8){let u="";for(let h=0;h<S;h++){let A;h===0&&M.$j&&!I&&(S===3||S===4)?A=o:A=n,u+=A.charAt(Math.floor(Math.random()*A.length))}let m;return I?m=`${I}-${u}`:m=u,d?(0,w.$ic)(d,m):m}e.$5f=y}),define(Re[66],Me([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0,e.$Lr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(P){const k=(0,w.$nc)(P),a=M[k.toLowerCase()];return a!==void 0?a:R(P)}e.$Mr=F;function R(P){const k=(0,w.$nc)(P);return C[k.toLowerCase()]}e.$Nr=R;function l(P){for(const k in C)if(C[k]===P)return k}e.$Or=l;const D=/^(.+)\/(.+?)(;.+)?$/;function g(P,k){const a=D.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:P}e.$Pr=g}),define(Re[67],Me([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function C(D){return JSON.stringify(D,R)}e.$ih=C;function F(D){let g=JSON.parse(D);return g=l(g),g}e.$jh=F;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function l(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof w.$ae||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=l(D[P],g+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=l(D[P],g+1))}return D}e.$kh=l}),define(Re[13],Me([1,0,9,22,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var F;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$6f="vscode-tkn",e.$7f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${F.vscodeRemoteResource}`}set(P,k,a){this.a[P]=k,this.b[P]=a}setConnectionToken(P,k){this.c[P]=k}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Z(t),P}const k=P.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const p=this.b[k],$=this.c[k];let f=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(f+=`&${e.$7f}=${encodeURIComponent($)}`),C.URI.from({scheme:M.$p?this.d:F.vscodeRemoteResource,authority:`${a}:${p}`,path:this.f,query:f})}}e.$8f=new R,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class l{static{this.a=e.$ag}asBrowserUri(P){const k=this.b(P,be);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===F.vscodeRemote?e.$8f.rewrite(P):P.scheme===F.file&&(M.$n||M.$q&&M.$h.origin===`${F.vscodeFileResource}://${l.a}`)?P.with({scheme:F.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const k=this.b(P,be);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===F.vscodeFileResource?P.with({scheme:F.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,k){return C.URI.isUri(P)?P:C.URI.parse(k.toUrl(P))}}e.$bg=new l;var D;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function a($){let f;typeof $=="string"?f=new URL($).searchParams:$ instanceof URL?f=$.searchParams:C.URI.isUri($)&&(f=new URL($.toString(!0)).searchParams);const t=f?.get(k);if(t)return P.get(t)}g.getHeadersFromQuery=a;function p($,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(k,i):$[k]=i}g.addSearchParam=p})(D||(e.COI=D={}))}),define(Re[23],Me([1,0,42,13,19,22,15,2]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function D(p){return(0,l.$vc)(p,!0)}e.$ig=D;class g{constructor($){this.a=$}compare($,f,t=!1){return $===f?0:(0,R.$Te)(this.getComparisonKey($,t),this.getComparisonKey(f,t))}isEqual($,f,t=!1){return $===f?!0:!$||!f?!1:this.getComparisonKey($,t)===this.getComparisonKey(f,t)}getComparisonKey($,f=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,f,t=!1){if($.scheme===f.scheme){if($.scheme===M.Schemas.file)return w.$Wf(D($),D(f),this.a($))&&$.query===f.query&&(t||$.fragment===f.fragment);if((0,e.$zg)($.authority,f.authority))return w.$Wf($.path,f.path,this.a($),"/")&&$.query===f.query&&(t||$.fragment===f.fragment)}return!1}joinPath($,...f){return l.URI.joinPath($,...f)}basenameOrAuthority($){return(0,e.$rg)($)||$.authority}basename($){return C.$fc.basename($.path)}extname($){return C.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let f;return $.scheme===M.Schemas.file?f=l.URI.file(C.$lc(D($))).path:(f=C.$fc.dirname($.path),$.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),f="/")),$.with({path:f})}normalizePath($){if(!$.path.length)return $;let f;return $.scheme===M.Schemas.file?f=l.URI.file(C.$gc(D($))).path:f=C.$fc.normalize($.path),$.with({path:f})}relativePath($,f){if($.scheme!==f.scheme||!(0,e.$zg)($.authority,f.authority))return;if($.scheme===M.Schemas.file){const c=C.$kc(D($),D(f));return F.$j?w.$Qf(c):c}let t=$.path||"/";const i=f.path||"/";if(this.a($)){let c=0;for(const b=Math.min(t.length,i.length);c<b&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$fc.relative(t,i)}resolvePath($,f){if($.scheme===M.Schemas.file){const t=l.URI.file(C.$jc(D($),f));return $.with({authority:t.authority,path:t.path})}return f=w.$Rf(f),$.with({path:C.$fc.resolve($.path,f)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,f){return $===f||$!==void 0&&f!==void 0&&(0,R.$1e)($,f)}hasTrailingPathSeparator($,f=C.sep){if($.scheme===M.Schemas.file){const t=D($);return t.length>w.$Sf(t).length&&t[t.length-1]===f}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,f=C.sep){return(0,e.$Ag)($,f)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,f=C.sep){let t=!1;if($.scheme===M.Schemas.file){const i=D($);t=i!==void 0&&i.length===w.$Sf(i).length&&i[i.length-1]===f}else{f="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Ag)($,f)?$.with({path:$.path+"/"}):$}}e.$jg=g,e.$kg=new g(()=>!1),e.$lg=new g(p=>p.scheme===M.Schemas.file?!F.$l:!0),e.$mg=new g(p=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function P(p,$){const f=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((c,b)=>b===t?!1:(0,e.$og)(i,$(c)))||f.push(p[t])}return f}e.$Dg=P;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,v]=b.split(":");E&&v&&t.set(E,v)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=$})(k||(e.DataUri=k={}));function a(p,$,f){if($){let t=p.path;return t&&t[0]!==C.$fc.sep&&(t=C.$fc.sep+t),p.with({scheme:f,authority:$,path:t})}return p.with({scheme:f})}e.$Eg=a}),define(Re[12],Me([1,0,21,9,5,6,23,22,120]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$Fg=g;function P(z){const q=new w.$Wd,le=z(q.token),we=new Promise((ve,me)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),q.dispose(),me(new M.$4)});Promise.resolve(le).then(re=>{De.dispose(),q.dispose(),ve(re)},re=>{De.dispose(),q.dispose(),me(re)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$Gg=P;function k(z,q,le){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(le)});z.then(we,ve).finally(()=>me.dispose())})}e.$Hg=k;function a(z,q){return new Promise((le,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new M.$4)});z.then(le,we).finally(()=>ve.dispose())})}e.$Ig=a;async function p(z){let q=-1;const le=z.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(le)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$Jg=p;function $(z,q,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$Kg=$;function f(z){return new Promise((q,le)=>{const we=z();g(we)?we.then(q,le):q(we)})}e.$Lg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=q(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Mg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ng=i;class c{constructor(){this.a=new Map}queue(q,le){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Og=c;const b=(z,q)=>{let le=!0;const we=setTimeout(()=>{le=!1,q()},z);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},E=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class v{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,le=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===D.$Jd?E(we):b(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=v;class r{constructor(q){this.a=new v(q),this.b=new t}trigger(q,le){return this.a.trigger(()=>this.b.queue(q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=r;class s{constructor(){this.a=!1,this.b=new Promise((q,le)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=s;class n extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Sg=n;function o(z,q){return q?new Promise((le,we)=>{const ve=setTimeout(()=>{me.dispose(),le()},z),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new M.$4)})}):P(le=>o(z,le))}e.$Tg=o;function y(z,q=0,le){const we=setTimeout(()=>{z(),le&&ve.dispose()},q),ve=(0,F.$Pc)(()=>{clearTimeout(we),le?.deleteAndLeak(ve)});return le?.add(ve),ve}e.$Ug=y;function d(z){const q=[];let le=0;const we=z.length;function ve(){return le<we?z[le++]():null}function me(De){De!=null&&q.push(De);const re=ve();return re?re.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Vg=d;function I(z,q=we=>!!we,le=null){let we=0;const ve=z.length,me=()=>{if(we>=ve)return Promise.resolve(le);const De=z[we++];return Promise.resolve(De()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Wg=I;function S(z,q=we=>!!we,le=null){if(z.length===0)return Promise.resolve(le);let we=z.length;const ve=()=>{we=-1;for(const me of z)me.cancel?.()};return new Promise((me,De)=>{for(const re of z)re.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(le)}).catch(he=>{--we>=0&&(ve(),De(he))})})}e.$Xg=S;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((le,we)=>{this.f.push({factory:q,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const le=q.factory();le.then(q.c,q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=u;class m extends u{constructor(){super(1)}}e.$Zg=m;class h{constructor(){this.a=new ye,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$1g=h;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Y;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,le=R.$kg){const we=le.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new m;const me=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$Zc),this.d.set(me,De),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=A;class W{constructor(q,le){this.a=-1,typeof q=="function"&&typeof le=="number"&&this.setIfNotSet(q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},le)}setIfNotSet(q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},le))}}e.$3g=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setInterval(()=>{q()},le)}}e.$4g=V;class U{constructor(q,le){this.b=-1,this.a=q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=U;class B{constructor(q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=B;class O extends U{constructor(q,le){super(q,le),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$7g=O;class N extends F.$Rc{constructor(q,le){super(),this.g=q,this.h=le,this.a=[],this.b=this.B(new F.$Sc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=z=>{(0,l.$B)(()=>{if(q)return;const le=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$9g=(z,q)=>{const le=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class te{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=te;async function Z(z,q,le){let we;for(let ve=0;ve<le;ve++)try{return await z()}catch(me){we=me,await o(q)}throw we}e.$$g=Z;class ye{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,le,we){return this.a={taskId:q,cancel:()=>we?.(),promise:le},le.then(()=>this.d(q),()=>this.d(q)),le}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let le,we;const ve=new Promise((me,De)=>{le=me,we=De});this.b={run:q,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=ye;class Ee{constructor(q,le=()=>Date.now()){this.d=q,this.f=le,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$ah=Ee;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class Y{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,le)=>{this.a=q,this.b=le})}complete(q){return new Promise(le=>{this.a(q),this.d={outcome:0,value:q},le()})}error(q){return new Promise(le=>{this.b(q),this.d={outcome:1,value:q},le()})}cancel(){return this.error(new M.$4)}}e.$bh=Y;var ae;(function(z){async function q(we){let ve;const me=await Promise.all(we.map(De=>De.then(re=>re,re=>{ve||(ve=re)})));if(typeof ve<"u")throw ve;return me}z.settled=q;function le(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(De){me(De)}})}z.withAsyncBody=le})(ae||(e.Promises=ae={}));var Se;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Se||(Se={}));class ue{static fromArray(q){return new ue(le=>{le.emitMany(q)})}static fromPromise(q){return new ue(async le=>{le.emitMany(await q)})}static fromPromises(q){return new ue(async le=>{await Promise.all(q.map(async we=>le.emitOne(await we)))})}static merge(q){return new ue(async le=>{await Promise.all(q.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ue.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$Md,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,le){return new ue(async we=>{for await(const ve of q)we.emitOne(le(ve))})}map(q){return ue.map(this,q)}static filter(q,le){return new ue(async we=>{for await(const ve of q)le(ve)&&we.emitOne(ve)})}filter(q){return ue.filter(this,q)}static coalesce(q){return ue.filter(q,le=>!!le)}coalesce(){return ue.coalesce(this)}static async toPromise(q){const le=[];for await(const we of q)le.push(we);return le}toPromise(){return ue.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$ch=ue;class $e extends ue{constructor(q,le){super(le),this.l=q}cancel(){this.l.cancel()}}e.$dh=$e;function ie(z){const q=new w.$Wd,le=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new M.$4)});try{for await(const me of le){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$eh=ie}),define(Re[37],Me([1,0,18,12,42,28,19,22,15]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function g(){return Object.create(null)}e.$pj=g,e.$qj="**",e.$rj="/";const P="[/\\\\]",k="[^/\\\\]",a=/\//g;function p(ye,Ee){switch(ye){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${Ee?`|${P}${k}+`:""})*?`}}function $(ye,Ee){if(!ye)return[];const Pe=[];let Y=!1,ae=!1,Se="";for(const ue of ye){switch(ue){case Ee:if(!Y&&!ae){Pe.push(Se),Se="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}Se+=ue}return Se&&Pe.push(Se),Pe}e.$sj=$;function f(ye){if(!ye)return"";let Ee="";const Pe=$(ye,e.$rj);if(Pe.every(Y=>Y===e.$qj))Ee=".*";else{let Y=!1;Pe.forEach((ae,Se)=>{if(ae===e.$qj){if(Y)return;Ee+=p(2,Se===Pe.length-1)}else{let ue=!1,$e="",ie=!1,z="";for(const q of ae){if(q!=="}"&&ue){$e+=q;continue}if(ie&&(q!=="]"||!z)){let le;q==="-"?le=q:(q==="^"||q==="!")&&!z?le="^":q===e.$rj?le="":le=(0,D.$Ee)(q),z+=le;continue}switch(q){case"{":ue=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${$($e,",").map(ve=>f(ve)).join("|")})`;Ee+=we,ue=!1,$e="";break}case"]":{Ee+="["+z+"]",ie=!1,z="";break}case"?":Ee+=k;continue;case"*":Ee+=p(1);continue;default:Ee+=(0,D.$Ee)(q)}}Se<Pe.length-1&&(Pe[Se+1]!==e.$qj||Se+2<Pe.length)&&(Ee+=P)}Y=ae===e.$qj})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.$Cc(1e4),s=function(){return!1},n=function(){return null};function o(ye,Ee){if(!ye)return n;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const Y=`${Pe}_${!!Ee.trimForExclusions}`;let ae=r.get(Y);if(ae)return y(ae,ye);let Se;return t.test(Pe)?ae=I(Pe.substr(4),Pe):(Se=i.exec(d(Pe,Ee)))?ae=S(Se[1],Pe):(Ee.trimForExclusions?b:c).test(Pe)?ae=u(Pe,Ee):(Se=E.exec(d(Pe,Ee)))?ae=m(Se[1].substr(1),Pe,!0):(Se=v.exec(d(Pe,Ee)))?ae=m(Se[1],Pe,!1):ae=h(Pe),r.set(Y,ae),y(ae,ye)}function y(ye,Ee){if(typeof Ee=="string")return ye;const Pe=function(Y,ae){return(0,C.$Wf)(Y,Ee.base,!l.$l)?ye((0,D.$Ie)(Y.substr(Ee.base.length),R.sep),ae):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function d(ye,Ee){return Ee.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function I(ye,Ee){return function(Pe,Y){return typeof Pe=="string"&&Pe.endsWith(ye)?Ee:null}}function S(ye,Ee){const Pe=`/${ye}`,Y=`\\${ye}`,ae=function(ue,$e){return typeof ue!="string"?null:$e?$e===ye?Ee:null:ue===ye||ue.endsWith(Pe)||ue.endsWith(Y)?Ee:null},Se=[ye];return ae.basenames=Se,ae.patterns=[Ee],ae.allBasenames=Se,ae}function u(ye,Ee){const Pe=te(ye.slice(1,-1).split(",").map($e=>o($e,Ee)).filter($e=>$e!==n),ye),Y=Pe.length;if(!Y)return n;if(Y===1)return Pe[0];const ae=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return ye;return null},Se=Pe.find($e=>!!$e.allBasenames);Se&&(ae.allBasenames=Se.allBasenames);const ue=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ue.length&&(ae.allPaths=ue),ae}function m(ye,Ee,Pe){const Y=R.sep===R.$fc.sep,ae=Y?ye:ye.replace(a,R.sep),Se=R.sep+ae,ue=R.$fc.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===ae||ie.endsWith(Se)||!Y&&(ie===ye||ie.endsWith(ue)))?Ee:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===ae||!Y&&ie===ye)?Ee:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function h(ye){try{const Ee=new RegExp(`^${f(ye)}$`);return function(Pe){return Ee.lastIndex=0,typeof Pe=="string"&&Ee.test(Pe)?ye:null}}catch{return n}}function A(ye,Ee,Pe){return!ye||typeof Ee!="string"?!1:W(ye)(Ee,void 0,Pe)}e.$tj=A;function W(ye,Ee={}){if(!ye)return s;if(typeof ye=="string"||V(ye)){const Pe=o(ye,Ee);if(Pe===n)return s;const Y=function(ae,Se){return!!Pe(ae,Se)};return Pe.allBasenames&&(Y.allBasenames=Pe.allBasenames),Pe.allPaths&&(Y.allPaths=Pe.allPaths),Y}return O(ye,Ee)}e.$uj=W;function V(ye){const Ee=ye;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.$vj=V;function U(ye){return ye.allBasenames||[]}e.$wj=U;function B(ye){return ye.allPaths||[]}e.$xj=B;function O(ye,Ee){const Pe=te(Object.getOwnPropertyNames(ye).map($e=>N($e,ye[$e],Ee)).filter($e=>$e!==n)),Y=Pe.length;if(!Y)return n;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Y===1)return Pe[0];const $e=function(q,le){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const De=Pe[ve](q,le);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,le)=>le.allPaths?q.concat(le.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const ae=function($e,ie,z){let q,le;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&z&&(ie||(ie=(0,R.$mc)($e)),q||(q=ie.substr(0,ie.length-(0,R.$nc)($e).length)));const De=me($e,ie,q,z);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},Se=Pe.find($e=>!!$e.allBasenames);Se&&(ae.allBasenames=Se.allBasenames);const ue=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ue.length&&(ae.allPaths=ue),ae}function N(ye,Ee,Pe){if(Ee===!1)return n;const Y=o(ye,Pe);if(Y===n)return n;if(typeof Ee=="boolean")return Y;if(Ee){const ae=Ee.when;if(typeof ae=="string"){const Se=(ue,$e,ie,z)=>{if(!z||!Y(ue,$e))return null;const q=ae.replace("$(basename)",()=>ie),le=z(q);return(0,M.$Fg)(le)?le.then(we=>we?ye:null):le?ye:null};return Se.requiresSiblings=!0,Se}}return Y}function te(ye,Ee){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const Y=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let ae;if(Ee){ae=[];for(let $e=0,ie=Y.length;$e<ie;$e++)ae.push(Ee)}else ae=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Se=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const le=$e.charCodeAt(q-1);if(le===47||le===92)break}ie=$e.substr(q)}const z=Y.indexOf(ie);return z!==-1?ae[z]:null};Se.basenames=Y,Se.patterns=ae,Se.allBasenames=Y;const ue=ye.filter($e=>!$e.basenames);return ue.push(Se),ue}function Z(ye,Ee){return(0,w.$tb)(ye,Ee,(Pe,Y)=>typeof Pe=="string"&&typeof Y=="string"?Pe===Y:typeof Pe!="string"&&typeof Y!="string"?Pe.base===Y.base&&Pe.pattern===Y.pattern:!1)}e.$yj=Z}),define(Re[50],Me([1,0,9,121,23,15,2]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class D{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$6)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Uj)(i):i).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,b){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(i,c){const b=new RegExp((0,F.$Ee)(c),"g");return i.replace(b,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$1j=D;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$2j=g;function P(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$3j=P;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$ng)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$4j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=a;function p(t){return t.replace(/"/g,"&quot;")}e.$6j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=$;function f(t){const i=[],c=t.split("|").map(E=>E.trim());t=c[0];const b=c[1];if(b){const E=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),r=E?E[1]:"",s=v?v[1]:"",n=isFinite(parseInt(s)),o=isFinite(parseInt(r));n&&i.push(`width="${s}"`),o&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$8j=f}),define(Re[90],Me([1,0,18,42,19,22,23,15]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=void 0;function D(o,y){const{os:d,tildify:I,relative:S}=y;if(S){const h=g(o,S,d);if(typeof h=="string")return h}let u=o.fsPath;if(d===1&&!F.$j?u=u.replace(/\//g,"\\"):d!==1&&F.$j&&(u=u.replace(/\\/g,"/")),d!==1&&I?.userHome){const h=I.userHome.fsPath;let A;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$fc.sep)?A=I.userHome.with({path:o.path}).fsPath:A=o.fsPath,u=a(A,h,d)}return(d===1?C.$ec:C.$fc).normalize(P(u,d===1))}e.$lv=D;function g(o,y,d){const I=d===1?C.$ec:C.$fc,S=d===3?R.$kg:R.$mg,u=y.getWorkspace(),m=(0,w.$Nb)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$fc.sep)&&(o=m.uri.with({path:o.path}));const h=y.getWorkspaceFolder(o);if(!h)return;let A;if(S.isEqual(h.uri,o)?A="":A=S.relativePath(h.uri,o)??"",A&&(A=I.normalize(A)),u.folders.length>1&&!y.noPrefix){const W=h.name?h.name:S.basenameOrAuthority(h.uri);A=A?`${W} \u2022 ${A}`:W}return A}function P(o,y=F.$j){return(0,M.$1f)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$mv=P;let k=Object.create(null);function a(o,y,d=F.OS){if(d===1||!o||!y)return o;let I=k.original===y?k.normalized:void 0;I||(I=y,F.$j&&(I=(0,M.$Qf)(I)),I=`${(0,l.$Je)(I,C.$fc.sep)}${C.$fc.sep}`,k={original:y,normalized:I});let S=o;return F.$j&&(S=(0,M.$Qf)(S)),(d===3?S.startsWith(I):(0,l.$2e)(S,I))?`~/${S.substr(I.length)}`:o}e.$nv=a;function p(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$ov=p;const $="\u2026",f="\\\\",t="~";function i(o,y=C.sep){const d=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){d[S]=`.${y}`;continue}if(!u){d[S]=u;continue}I=!0;let m="",h=u;h.indexOf(f)===0?(m=h.substr(0,h.indexOf(f)+f.length),h=h.substr(h.indexOf(f)+f.length)):h.indexOf(y)===0?(m=h.substr(0,h.indexOf(y)+y.length),h=h.substr(h.indexOf(y)+y.length)):h.indexOf(t)===0&&(m=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const A=h.split(y);for(let W=1;I&&W<=A.length;W++)for(let V=A.length-W;I&&V>=0;V--){I=!1;let U=A.slice(V,V+W).join(y);for(let B=0;!I&&B<o.length;B++)if(B!==S&&o[B]&&o[B].indexOf(U)>-1){const O=V+W===A.length,N=V>0&&o[B].indexOf(y)>-1?y+U:U,te=o[B].endsWith(N);I=!O||te}if(!I){let B="";(A[0].endsWith(":")||m!=="")&&(V===1&&(V=0,W++,U=A[0]+y+U),V>0&&(B=A[0]+y),B=m+B),V>0&&(B=B+$+y),B=B+U,V+W<A.length&&(B=B+y+$),d[S]=B}}I&&(d[S]=u)}return d}e.$pv=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(o,y=Object.create(null)){const d=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&d.push({value:S,type:c.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=y[S];if(typeof m=="string")m.length&&d.push({value:m,type:c.VARIABLE});else if(m){const h=d[d.length-1];(!h||h.type!==c.SEPARATOR)&&d.push({value:m.label,type:c.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&d.push({value:S,type:c.TEXT}),d.filter((u,m)=>{if(u.type===c.SEPARATOR){const h=d[m-1],A=d[m+1];return[h,A].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$qv=b;function E(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$k?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$rv=E;function v(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,""):F.$j?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$sv=v;function r(o){return o.replace(/&/g,"&&")}e.$tv=r;function s(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const d=n(o.substring(0,y));return{name:d.name,parentPath:d.parentPath+o.substring(y)}}}return n(o)}e.$uv=s;function n(o){const y=o.indexOf("/")!==-1?C.$fc:C.$ec,d=y.basename(o),I=y.dirname(o);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(Re[132],Me([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=void 0;function C(k){return k.toJSON()}class F{constructor(a){this.a=a}transformIncoming(a){const p=this.a.transformIncoming(a);return p===a?a:C(M.URI.from(p))}transformOutgoing(a){const p=this.a.transformOutgoing(a);return p===a?a:C(M.URI.from(p))}transformOutgoingURI(a){const p=this.a.transformOutgoing(a);return p===a?a:M.URI.from(p)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Hm=F,e.$Im=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,a,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const f=R(k[$],a,p+1);f!==null&&(k[$]=f)}}return null}function l(k,a){const p=R(k,a,0);return p===null?k:p}e.$Jm=l;function D(k,a,p,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof w.$ae)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=D(k[f],a,p,$+1);t!==null&&(k[f]=t)}}return null}function g(k,a){const p=D(k,a,!1,0);return p===null?k:p}e.$Km=g;function P(k,a){const p=D(k,a,!0,0);return p===null?k:p}e.$Lm=P}),define(Re[133],Me([1,0,37,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=void 0;function C(F,R,l,D,g,P){if(Array.isArray(F)){let k=0;for(const a of F){const p=C(a,R,l,D,g,P);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof F=="string")return D?F==="*"?5:F===l?10:0:0;if(F){const{language:k,pattern:a,scheme:p,hasAccessToAllModels:$,notebookType:f}=F;if(!D&&!$)return 0;f&&g&&(R=g);let t=0;if(p)if(p===R.scheme)t=10;else if(p==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,M.$gc)(a.base)},i===R.fsPath||(0,w.$tj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$kE=C}),define(Re[91],Me([1,0,25,22]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0=e.$N0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function F(k){for(let a=0,p=k.length;a<p;a+=4){const $=k[a+0],f=k[a+1],t=k[a+2],i=k[a+3];k[a+0]=i,k[a+1]=t,k[a+2]=f,k[a+3]=$}}function R(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||F(a),w.$ae.wrap(a)}function l(k){const a=k.buffer;if(M.$D()||F(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(k){const a=new Uint32Array(g(k));let p=0;if(a[p++]=k.id,k.type==="full")a[p++]=1,a[p++]=k.data.length,a.set(k.data,p),p+=k.data.length;else{a[p++]=2,a[p++]=k.deltas.length;for(const $ of k.deltas)a[p++]=$.start,a[p++]=$.deleteCount,$.data?(a[p++]=$.data.length,a.set($.data,p),p+=$.data.length):a[p++]=0}return R(a)}e.$N0=D;function g(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(a+=p.data.length)}return a}function P(k){const a=l(k);let p=0;const $=a[p++];if(a[p++]===1){const c=a[p++],b=a.subarray(p,p+c);return p+=c,{id:$,type:"full",data:b}}const t=a[p++],i=[];for(let c=0;c<t;c++){const b=a[p++],E=a[p++],v=a[p++];let r;v>0&&(r=a.subarray(p,p+v),p+=v),i[c]={start:b,deleteCount:E,data:r}}return{id:$,type:"delta",deltas:i}}e.$O0=P}),define(Re[134],Me([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Re[135],Me([1,0,18,24,22,123,136,134]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(X,pe,je,Oe){this.id=X,this.name=pe,this.defaultValue=je,this.schema=Oe}applyUpdate(X,pe){return p(X,pe)}compute(X,pe,je){return je}}class a{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=a;function p(x,X){if(typeof x!="object"||typeof X!="object"||!x||!X)return new a(X,x!==X);if(Array.isArray(x)||Array.isArray(X)){const je=Array.isArray(x)&&Array.isArray(X)&&w.$tb(x,X);return new a(X,!je)}let pe=!1;for(const je in X)if(X.hasOwnProperty(je)){const Oe=p(x[je],X[je]);Oe.didChange&&(x[je]=Oe.newValue,pe=!0)}return new a(x,pe)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return p(X,pe)}validate(X){return this.defaultValue}}class f{constructor(X,pe,je,Oe){this.id=X,this.name=pe,this.defaultValue=je,this.schema=Oe}applyUpdate(X,pe){return p(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,je){return je}}function t(x,X){return typeof x>"u"?X:x==="false"?!1:!!x}e.boolean=t;class i extends f{constructor(X,pe,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(X,pe,je,Oe)}validate(X){return t(X,this.defaultValue)}}function c(x,X,pe,je){if(typeof x>"u")return X;let Oe=parseInt(x,10);return isNaN(Oe)?X:(Oe=Math.max(pe,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=c;class b extends f{static clampedInt(X,pe,je,Oe){return c(X,pe,je,Oe)}constructor(X,pe,je,Oe,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=je,rt.minimum=Oe,rt.maximum=Xe),super(X,pe,je,rt),this.minimum=Oe,this.maximum=Xe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function E(x,X,pe,je){if(typeof x>"u")return X;const Oe=v.float(x,X);return v.clamp(Oe,pe,je)}e.clampedFloat=E;class v extends f{static clamp(X,pe,je){return X<pe?pe:X>je?je:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const je=parseFloat(X);return isNaN(je)?pe:je}constructor(X,pe,je,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=je),super(X,pe,je,Xe),this.validationFn=Oe}validate(X){return this.validationFn(v.float(X,this.defaultValue))}}class r extends f{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(X,pe,je,Oe)}validate(X){return r.string(X,this.defaultValue)}}function s(x,X,pe,je){return typeof x!="string"?X:je&&x in je?je[x]:pe.indexOf(x)===-1?X:x}e.stringSet=s;class n extends f{constructor(X,pe,je,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=je),super(X,pe,je,Xe),this.c=Oe}validate(X){return s(X,this.defaultValue,this.c)}}class o extends k{constructor(X,pe,je,Oe,Xe,rt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=Xe,mt.default=Oe),super(X,pe,je,mt),this.c=Xe,this.d=rt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function y(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,je){return je===0?X.accessibilitySupport:je}}class I extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:l.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function h(x){switch(x){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function A(x){switch(x){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class W extends ${constructor(){super(140)}compute(X,pe,je){const Oe=["monaco-editor"];return pe.get(39)&&Oe.push(pe.get(39)),X.extraEditorClassName&&Oe.push(X.extraEditorClassName),pe.get(73)==="default"?Oe.push("mouse-default"):pe.get(73)==="copy"&&Oe.push("mouse-copy"),pe.get(110)&&Oe.push("showUnused"),pe.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(X,pe,je){return je&&X.emptySelectionClipboard}}class U extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:l.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class B extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?B.OFF:X==="true"?B.ON:X:X?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?O.OFF:X==="true"?O.TRANSLATE:X:X?O.TRANSLATE:O.OFF}compute(X,pe,je){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends ${constructor(){super(50)}compute(X,pe,je){return X.fontInfo}}class te extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(X){const pe=v.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(X,pe,je){return X.fontInfo.fontSize}}class Z extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class ye extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:je,description:l.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends k{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:l.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Y extends ${constructor(){super(143)}compute(X,pe,je){return Y.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,je=Math.floor(X.paddingTop/X.lineHeight);let Oe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Oe=Math.max(Oe,pe-1));const Xe=(je+X.viewLineCount+Oe)/(X.pixelRatio*X.height),rt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:rt}}static c(X,pe){const je=X.outerWidth,Oe=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const rt=pe.stableMinimapLayoutInput,mt=rt&&X.outerHeight===rt.outerHeight&&X.lineHeight===rt.lineHeight&&X.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&X.pixelRatio===rt.pixelRatio&&X.scrollBeyondLastLine===rt.scrollBeyondLastLine&&X.paddingTop===rt.paddingTop&&X.paddingBottom===rt.paddingBottom&&X.minimap.enabled===rt.minimap.enabled&&X.minimap.side===rt.minimap.side&&X.minimap.size===rt.minimap.size&&X.minimap.showSlider===rt.minimap.showSlider&&X.minimap.renderCharacters===rt.minimap.renderCharacters&&X.minimap.maxColumn===rt.minimap.maxColumn&&X.minimap.scale===rt.minimap.scale&&X.verticalScrollbarWidth===rt.verticalScrollbarWidth&&X.isViewportWrapping===rt.isViewportWrapping,wt=X.lineHeight,Ct=X.typicalHalfwidthCharacterWidth,Zt=X.scrollBeyondLastLine,Kt=X.minimap.renderCharacters;let vt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const jt=X.minimap.maxColumn,Ft=X.minimap.size,Bt=X.minimap.side,Pt=X.verticalScrollbarWidth,At=X.viewLineCount,Nt=X.remainingWidth,Wt=X.isViewportWrapping,Ht=Kt?2:3;let Vt=Math.floor(Xe*Oe);const at=Vt/Xe;let ut=!1,Gt=!1,It=Ht*vt,Et=vt/Xe,dt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ae,extraLinesBeyondLastLine:ge,desiredRatio:J,minimapLineCount:Le}=Y.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Zt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Xe});if(At/Le>1)ut=!0,Gt=!0,vt=1,It=1,Et=vt/Xe;else{let Ge=!1,qe=vt+1;if(Ft==="fit"){const et=Math.ceil((Ae+At+ge)*It);Wt&&mt&&Nt<=pe.stableFitRemainingWidth?(Ge=!0,qe=pe.stableFitMaxMinimapScale):Ge=et>Vt}if(Ft==="fill"||Ge){ut=!0;const et=vt;It=Math.min(wt*Xe,Math.max(1,Math.floor(1/J))),Wt&&mt&&Nt<=pe.stableFitRemainingWidth&&(qe=pe.stableFitMaxMinimapScale),vt=Math.min(qe,Math.max(1,Math.floor(It/Ht))),vt>et&&(dt=Math.min(2,vt/et)),Et=vt/Xe/dt,Vt=Math.ceil(Math.max(Ce,Ae+At+ge)*It),Wt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Nt,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Et),Tt=Math.min(kt,Math.max(0,Math.floor((Nt-Pt-2)*Et/(Ct+Et)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Xe*Tt);const Ve=yt/Xe;yt=Math.floor(yt*dt);const Ot=Kt?1:2,zt=Bt==="left"?0:je-Tt-Pt;return{renderMinimap:Ot,minimapLeft:zt,minimapWidth:Tt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Gt,minimapScale:vt,minimapLineHeight:It,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:at}}static computeLayout(X,pe){const je=pe.outerWidth|0,Oe=pe.outerHeight|0,Xe=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,mt=pe.typicalHalfwidthCharacterWidth,wt=pe.maxDigitWidth,Ct=pe.pixelRatio,Zt=pe.viewLineCount,Kt=X.get(135),vt=Kt==="inherit"?X.get(134):Kt,jt=vt==="inherit"?X.get(130):vt,Ft=X.get(133),Bt=pe.isDominatedByLongLines,Pt=X.get(57),At=X.get(67).renderType!==0,Nt=X.get(68),Wt=X.get(104),Ht=X.get(83),Vt=X.get(72),at=X.get(102),ut=at.verticalScrollbarSize,Gt=at.verticalHasArrows,It=at.arrowSize,Et=at.horizontalScrollbarSize,dt=X.get(43),kt=X.get(109)!=="never";let Tt=X.get(65);dt&&kt&&(Tt+=16);let yt=0;if(At){const ft=Math.max(rt,Nt);yt=Math.round(ft*wt)}let Ve=0;Pt&&(Ve=Xe*pe.glyphMarginDecorationLaneCount);let Ot=0,zt=Ot+Ve,Ce=zt+yt,Ae=Ce+Tt;const ge=je-Ve-yt-Tt;let J=!1,Le=!1,Be=-1;vt==="inherit"&&Bt?(J=!0,Le=!0):jt==="on"||jt==="bounded"?Le=!0:jt==="wordWrapColumn"&&(Be=Ft);const Ge=Y.c({outerWidth:je,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ct,scrollBeyondLastLine:Wt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:Vt,verticalScrollbarWidth:ut,viewLineCount:Zt,remainingWidth:ge,isViewportWrapping:Le},pe.memory||new P);Ge.renderMinimap!==0&&Ge.minimapLeft===0&&(Ot+=Ge.minimapWidth,zt+=Ge.minimapWidth,Ce+=Ge.minimapWidth,Ae+=Ge.minimapWidth);const qe=ge-Ge.minimapWidth,et=Math.max(1,Math.floor((qe-ut-2)/mt)),gt=Gt?It:0;return Le&&(Be=Math.max(1,et),jt==="bounded"&&(Be=Math.min(Be,Ft))),{width:je,height:Oe,glyphMarginLeft:Ot,glyphMarginWidth:Ve,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:yt,decorationsLeft:Ce,decorationsWidth:Tt,contentLeft:Ae,contentWidth:qe,minimap:Ge,viewportColumn:et,isWordWrapMinified:J,isViewportWrapping:Le,wrappingColumn:Be,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Et,overviewRuler:{top:gt,width:ut,height:Oe-2*gt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ae extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,pe,je){return pe.get(2)===2?"advanced":je}}class Se extends k{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:l.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ue extends k{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:l.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:l.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,je){return je<0?b.clampedInt(-je*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class z extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>v.clamp(X,0,150),{markdownDescription:l.localize(63,null)})}compute(X,pe,je){return X.fontInfo.lineHeight}}class q extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:X.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:l.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(x){return x==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class we extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:l.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends ${constructor(){super(141)}compute(X,pe,je){return X.pixelRatio}}class De extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:X.comments,description:l.localize(83,null)},other:{anyOf:pe,default:X.other,description:l.localize(84,null)}},default:X,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Ct=X?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:je,strings:Oe}=X,Xe=["on","inline","off"];let rt,mt,wt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=s(pe,this.defaultValue.other,Xe),typeof je=="boolean"?mt=je?"on":"off":mt=s(je,this.defaultValue.comments,Xe),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=s(Oe,this.defaultValue.strings,Xe),{other:rt,comments:mt,strings:wt}}}var re;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(X){let pe=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,je=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:je}}}function se(x){const X=x.get(97);return X==="editable"?x.get(90):X!=="on"}e.filterValidationDecorations=se;class oe extends k{constructor(){const X=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:X,description:l.localize(93,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const je of X)if(typeof je=="number")pe.push({column:b.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;pe.push({column:b.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return pe.sort((je,Oe)=>je.column-Oe.column),pe}return this.defaultValue}}class de extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(x,X){if(typeof x!="string")return X;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class L extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:l.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,je=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,Oe,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:l.localize(111,null)}})}applyUpdate(X,pe){let je=!1;pe.allowedCharacters&&X&&(M.$6m(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},je=!0)),pe.allowedLocales&&X&&(M.$6m(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},je=!0));const Oe=super.applyUpdate(X,pe);return je?new a(Oe.newValue,!0):Oe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const je={};for(const[Oe,Xe]of Object.entries(X))Xe===!0&&(je[Oe]=!0);return je}}class G extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:l.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends k{constructor(){const X={enabled:F.$Yr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Yr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:X.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:X.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:X.highlightActiveIndentation,description:l.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(x,X,pe){const je=pe.indexOf(x);return je===-1?X:pe[je]}class ce extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:X.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:X.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,je){return pe.get(2)===2?0:je}}class Je extends ${constructor(){super(144)}compute(X,pe,je){const Oe=pe.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends k{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(x){return e.editorOptionsRegistry[x.id]=x,x}var st;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.autoClosingComments=7]="autoClosingComments",x[x.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=9]="autoClosingDelete",x[x.autoClosingOvertype=10]="autoClosingOvertype",x[x.autoClosingQuotes=11]="autoClosingQuotes",x[x.autoIndent=12]="autoIndent",x[x.automaticLayout=13]="automaticLayout",x[x.autoSurround=14]="autoSurround",x[x.bracketPairColorization=15]="bracketPairColorization",x[x.guides=16]="guides",x[x.codeLens=17]="codeLens",x[x.codeLensFontFamily=18]="codeLensFontFamily",x[x.codeLensFontSize=19]="codeLensFontSize",x[x.colorDecorators=20]="colorDecorators",x[x.colorDecoratorsLimit=21]="colorDecoratorsLimit",x[x.columnSelection=22]="columnSelection",x[x.comments=23]="comments",x[x.contextmenu=24]="contextmenu",x[x.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",x[x.cursorBlinking=26]="cursorBlinking",x[x.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",x[x.cursorStyle=28]="cursorStyle",x[x.cursorSurroundingLines=29]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",x[x.cursorWidth=31]="cursorWidth",x[x.disableLayerHinting=32]="disableLayerHinting",x[x.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",x[x.domReadOnly=34]="domReadOnly",x[x.dragAndDrop=35]="dragAndDrop",x[x.dropIntoEditor=36]="dropIntoEditor",x[x.emptySelectionClipboard=37]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",x[x.extraEditorClassName=39]="extraEditorClassName",x[x.fastScrollSensitivity=40]="fastScrollSensitivity",x[x.find=41]="find",x[x.fixedOverflowWidgets=42]="fixedOverflowWidgets",x[x.folding=43]="folding",x[x.foldingStrategy=44]="foldingStrategy",x[x.foldingHighlight=45]="foldingHighlight",x[x.foldingImportsByDefault=46]="foldingImportsByDefault",x[x.foldingMaximumRegions=47]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=49]="fontFamily",x[x.fontInfo=50]="fontInfo",x[x.fontLigatures=51]="fontLigatures",x[x.fontSize=52]="fontSize",x[x.fontWeight=53]="fontWeight",x[x.fontVariations=54]="fontVariations",x[x.formatOnPaste=55]="formatOnPaste",x[x.formatOnType=56]="formatOnType",x[x.glyphMargin=57]="glyphMargin",x[x.gotoLocation=58]="gotoLocation",x[x.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",x[x.hover=60]="hover",x[x.inDiffEditor=61]="inDiffEditor",x[x.inlineSuggest=62]="inlineSuggest",x[x.letterSpacing=63]="letterSpacing",x[x.lightbulb=64]="lightbulb",x[x.lineDecorationsWidth=65]="lineDecorationsWidth",x[x.lineHeight=66]="lineHeight",x[x.lineNumbers=67]="lineNumbers",x[x.lineNumbersMinChars=68]="lineNumbersMinChars",x[x.linkedEditing=69]="linkedEditing",x[x.links=70]="links",x[x.matchBrackets=71]="matchBrackets",x[x.minimap=72]="minimap",x[x.mouseStyle=73]="mouseStyle",x[x.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=75]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",x[x.multiCursorModifier=77]="multiCursorModifier",x[x.multiCursorPaste=78]="multiCursorPaste",x[x.multiCursorLimit=79]="multiCursorLimit",x[x.occurrencesHighlight=80]="occurrencesHighlight",x[x.overviewRulerBorder=81]="overviewRulerBorder",x[x.overviewRulerLanes=82]="overviewRulerLanes",x[x.padding=83]="padding",x[x.pasteAs=84]="pasteAs",x[x.parameterHints=85]="parameterHints",x[x.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",x[x.quickSuggestions=88]="quickSuggestions",x[x.quickSuggestionsDelay=89]="quickSuggestionsDelay",x[x.readOnly=90]="readOnly",x[x.readOnlyMessage=91]="readOnlyMessage",x[x.renameOnType=92]="renameOnType",x[x.renderControlCharacters=93]="renderControlCharacters",x[x.renderFinalNewline=94]="renderFinalNewline",x[x.renderLineHighlight=95]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=97]="renderValidationDecorations",x[x.renderWhitespace=98]="renderWhitespace",x[x.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",x[x.roundedSelection=100]="roundedSelection",x[x.rulers=101]="rulers",x[x.scrollbar=102]="scrollbar",x[x.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=104]="scrollBeyondLastLine",x[x.scrollPredominantAxis=105]="scrollPredominantAxis",x[x.selectionClipboard=106]="selectionClipboard",x[x.selectionHighlight=107]="selectionHighlight",x[x.selectOnLineNumbers=108]="selectOnLineNumbers",x[x.showFoldingControls=109]="showFoldingControls",x[x.showUnused=110]="showUnused",x[x.snippetSuggestions=111]="snippetSuggestions",x[x.smartSelect=112]="smartSelect",x[x.smoothScrolling=113]="smoothScrolling",x[x.stickyScroll=114]="stickyScroll",x[x.stickyTabStops=115]="stickyTabStops",x[x.stopRenderingLineAfter=116]="stopRenderingLineAfter",x[x.suggest=117]="suggest",x[x.suggestFontSize=118]="suggestFontSize",x[x.suggestLineHeight=119]="suggestLineHeight",x[x.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",x[x.suggestSelection=121]="suggestSelection",x[x.tabCompletion=122]="tabCompletion",x[x.tabIndex=123]="tabIndex",x[x.unicodeHighlighting=124]="unicodeHighlighting",x[x.unusualLineTerminators=125]="unusualLineTerminators",x[x.useShadowDOM=126]="useShadowDOM",x[x.useTabStops=127]="useTabStops",x[x.wordBreak=128]="wordBreak",x[x.wordSeparators=129]="wordSeparators",x[x.wordWrap=130]="wordWrap",x[x.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=133]="wordWrapColumn",x[x.wordWrapOverride1=134]="wordWrapOverride1",x[x.wordWrapOverride2=135]="wordWrapOverride2",x[x.wrappingIndent=136]="wrappingIndent",x[x.wrappingStrategy=137]="wrappingStrategy",x[x.showDeprecated=138]="showDeprecated",x[x.inlayHints=139]="inlayHints",x[x.editorClassName=140]="editorClassName",x[x.pixelRatio=141]="pixelRatio",x[x.tabFocusMode=142]="tabFocusMode",x[x.layoutInfo=143]="layoutInfo",x[x.wrappingInfo=144]="wrappingInfo",x[x.defaultColorDecorators=145]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new d),accessibilityPageSize:ze(new b(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new H),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new xe),stickyScroll:ze(new ue),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:l.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new te),fontWeight:ze(new Z),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Ee),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>v.clamp(x,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new Se),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new b(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Ye),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new L),scrollBeyondLastColumn:ze(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Fe),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",R.$Zr,{description:l.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new Y),wrappingInfo:ze(new Je),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new ae)}}),define(Re[137],Me([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[138],Me([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[139],Me([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Re[140],Me([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[141],Me([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[142],Me([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Re[143],Me([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Re[144],Me([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[145],Me([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Re[146],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Re[147],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[148],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[149],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[150],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[151],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[152],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[153],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[154],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[155],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[156],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[157],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[158],Me([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[159],Me([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Re[160],Me([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Re[161],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[162],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[163],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[164],Me([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[165],Me([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[166],Me([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[167],Me([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[168],Me([1,0,9,139]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...g){switch(g.length){case 1:return(0,M.localize)(0,null,g[0]);case 2:return(0,M.localize)(1,null,g[0],g[1]);case 3:return(0,M.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,a=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,a=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const $=this.c.charCodeAt(P);if(k)k=!1;else if($===47&&!a){P++;break}else $===91?a=!0:$===92?k=!0:$===93&&(a=!1);P++}for(;P<this.c.length&&D.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=D}),define(Re[169],Me([1,0,23,29,141,276]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Ho=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(R);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Io=g;function P(i){if(!i)return null;const c=i.majorBase,b=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(c===0||(v=!1),s=!1);let n=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,y,d,I]=o;n=Date.UTC(Number(y),Number(d)-1,Number(I))}}return{majorBase:c,majorMustEqual:b,minorBase:E,minorMustEqual:v,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$Jo=P;function k(i,c,b){let E;typeof i=="string"?E=P(g(i)):E=i;let v;c instanceof Date?v=c.getTime():typeof c=="string"&&(v=new Date(c).getTime());let r;if(typeof b=="string"?r=P(g(b)):r=b,!E||!r)return!1;const s=E.majorBase,n=E.minorBase,o=E.patchBase;let y=r.majorBase,d=r.minorBase,I=r.patchBase;const S=r.notBefore;let u=r.majorMustEqual,m=r.minorMustEqual,h=r.patchMustEqual;return r.isMinimum?s>y?!0:s<y?!1:n>d?!0:n<d||v&&v<S?!1:o>=I:(s===1&&y===0&&(!u||!m||!h)&&(y=1,d=0,I=0,u=!0,m=!1,h=!1),s<y?!1:s>y?!u:n<d?!1:n>d?!m:o<I?!1:o>I?!h:!(v&&v<S))}e.$Ko=k;function a(i,c,b,E,v){const r=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof E.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof E.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!E.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof E.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof E.main>"u"&&typeof E.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const o=(0,w.$ug)(b,E.main);(0,w.$og)(o,b)||r.push([M.default.Warning,C.localize(10,null,o.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,w.$ug)(b,E.browser);(0,w.$og)(o,b)||r.push([M.default.Warning,C.localize(12,null,o.path,b.path)])}}if(!F.valid(E.version))return r.push([M.default.Error,C.localize(13,null)]),r;const s=[];if(!p(i,c,E,v,s))for(const o of s)r.push([M.default.Error,o]);return r}e.$Lo=a;function p(i,c,b,E,v){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(i,c,b.engines.vscode,v)}e.$Mo=p;function $(i,c,b){return i==="*"||f(c,b,i)}e.$No=$;function f(i,c,b,E=[]){const v=P(g(b));if(!v)return E.push(C.localize(14,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,b)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,b)),!1;return k(i,c,v)?!0:(E.push(C.localize(17,null,i,b)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,b=i.length;c<b;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Re[68],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class w{constructor(C,F=[],R=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$Kh=w}),define(Re[69],Me([1,0,68]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(l,D,g){D instanceof w.$Kh||(D=new w.$Kh(D,[],!!g)),M.push([l,D])}e.$sr=F;function R(){return M}e.$tr=R}),define(Re[170],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class w{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$0p=w;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const l=this.lookupOrInsertNode(F),D=this.lookupOrInsertNode(R);l.outgoing.set(D.key,D),D.incoming.set(l.key,l)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const l of this.a.values())l.outgoing.delete(R),l.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let l=this.a.get(R);return l||(l=new w(R,F),this.a.set(R,l)),l}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,l]of this.a)F.push(`${R}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const l=new Set([F]),D=this.c(R,l);if(D)return D}}c(F,R){for(const[l,D]of F.outgoing){if(R.has(l))return[...R,l].join(" -> ");R.add(l);const g=this.c(D,R);if(g)return g;R.delete(l)}}}e.$$p=M}),define(Re[4],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var w;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function l(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=l})(w||(e._util=w={})),e.$Mh=C("instantiationService");function M(R,l,D){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:R,index:D}):(l[w.DI_DEPENDENCIES]=[{id:R,index:D}],l[w.DI_TARGET]=l)}function C(R){if(w.serviceIds.has(R))return w.serviceIds.get(R);const l=function(D,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,D,P)};return l.toString=()=>R,w.serviceIds.set(R,l),l}e.$Nh=C;function F(R){return R}e.$Oh=F}),define(Re[43],Me([1,0,16,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,C.$Nh)("configurationService");function F(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ii=F;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$ji=R;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$li=g;function P(i,c){const b=Object.create(null);for(const E in i)k(b,E,i[E],c);return b}e.$mi=P;function k(i,c,b,E){const v=c.split("."),r=v.pop();let s=i;for(let n=0;n<v.length;n++){const o=v[n];let y=s[o];switch(typeof y){case"undefined":y=s[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(y)}`);return}s=y}if(typeof s=="object"&&s!==null)try{s[r]=b}catch{E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(s)}`)}e.$ni=k;function a(i,c){const b=c.split(".");p(i,b)}e.$oi=a;function p(i,c){const b=c.shift();if(c.length===0){delete i[b];return}if(Object.keys(i).indexOf(b)!==-1){const E=i[b];typeof E=="object"&&!Array.isArray(E)&&(p(E,c),Object.keys(E).length===0&&delete i[b])}}function $(i,c,b){function E(s,n){let o=s;for(const y of n){if(typeof o!="object"||o===null)return;o=o[y]}return o}const v=c.split("."),r=E(i,v);return typeof r>"u"?b:r}e.$pi=$;function f(i,c,b){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in i?w.$zf(i[E])&&w.$zf(c[E])?f(i[E],c[E],b):b&&(i[E]=c[E]):i[E]=c[E])})}e.$qi=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$ri=t}),define(Re[32],Me([1,0,22,15,168,4,138,9]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",w.$k),D.set("isLinux",w.$l),D.set("isWindows",w.$j),D.set("isWeb",w.$p),D.set("isMacNative",w.$k&&!w.$p),D.set("isEdge",w.$H),D.set("isFirefox",w.$F),D.set("isChrome",w.$E),D.set("isSafari",w.$G);function g(ie,z){if(D.get(ie)!==void 0)throw(0,l.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(ie,z)}e.$Ji=g;const P=Object.prototype.hasOwnProperty;var k;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),$=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),c=(0,R.localize)(5,null),b=(0,R.localize)(6,null),E=(0,R.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=a){this.k=z,this.d=new C.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const le=this.D(),we=le.type===17?c:void 0;throw this.h.push({message:i,offset:le.offset,lexeme:C.$Ii.getLexeme(le),additionalInfo:we}),v.c}return q}catch(q){if(q!==v.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),A.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),De=me===ve.length-1?void 0:this.w(ve.substring(me+1));let re;try{re=new RegExp(ve.substring(1,me),De)}catch{throw this.B("REGEX",we)}return N.create(q,re)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),De=0;for(let de=0;de<we.lexeme.length;de++)we.lexeme.charCodeAt(de)===40?De++:we.lexeme.charCodeAt(de)===41&&De--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let de=0;de<me.lexeme.length;de++)me.lexeme.charCodeAt(de)===40?De++:we.lexeme.charCodeAt(de)===41&&De--}if(De<0)break;ve.push(C.$Ii.getLexeme(me)),this.z(),me=this.D()}const re=ve.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,M.$Ae)(ve)){const De=ve.indexOf("/"),re=ve.lastIndexOf("/");if(De!==re&&De>=0){const he=ve.slice(De+1,re),se=ve[re+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return N.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),B.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:b,offset:z.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,le){const we=(0,R.localize)(8,null,z,C.$Ii.getLexeme(q)),ve=q.offset,me=C.$Ii.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:le}),v.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=v;class r{static false(){return y.INSTANCE}static true(){return d.INSTANCE}static has(z){return I.create(z)}static equals(z,q){return S.create(z,q)}static notEquals(z,q){return h.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return u.create(z,q)}static notIn(z,q){return m.create(z,q)}static not(z){return A.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return Ee.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return B.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Li=r;function s(ie){const z=new v({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,R.localize)(9,null,le.additionalInfo):(0,R.localize)(10,null),offset:le.offset,length:le.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Mi=s;function n(ie,z){const q=ie?ie.substituteConstants():void 0,le=z?z.substituteConstants():void 0;return!q&&!le?!0:!q||!le?!1:q.equals(le)}e.$Ni=n;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.$Oi=y;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Pi=d;class I{static create(z,q=null){const le=D.get(z);return typeof le=="boolean"?le?d.INSTANCE:y.INSTANCE:new I(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=D.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$Qi=I;class S{static create(z,q,le=null){if(typeof q=="boolean")return q?I.create(z,le):A.create(z,le);const we=D.get(z);return typeof we=="boolean"?q===(we?"true":"false")?d.INSTANCE:y.INSTANCE:new S(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?d.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ri=S;class u{static create(z,q){return new u(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),le=z.getValue(this.d);return Array.isArray(q)?q.includes(le):typeof le=="string"&&typeof q=="object"&&q!==null?P.call(q,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Si=u;class m{static create(z,q){return new m(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=u.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=m;class h{static create(z,q,le=null){if(typeof q=="boolean")return q?A.create(z,le):I.create(z,le);const we=D.get(z);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:d.INSTANCE:new h(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?y.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ui=h;class A{static create(z,q=null){const le=D.get(z);return typeof le=="boolean"?le?y.INSTANCE:d.INSTANCE:new A(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=D.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Vi=A;function W(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class V{static create(z,q,le=null){return W(q,we=>new V(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Wi=V;class U{static create(z,q,le=null){return W(q,we=>new U(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Xi=U;class B{static create(z,q,le=null){return W(q,we=>new B(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=B;class O{static create(z,q,le=null){return W(q,we=>new O(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ae(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Zi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return q<le?-1:q>le?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return this.d===z.d&&q===le}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$1i=N;class te{static create(z){return new te(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new te(this.c.map(z))}negate(){return this.c}}e.$2i=te;function Z(ie){let z=null;for(let q=0,le=ie.length;q<le;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class ye{static create(z,q,le){return ye.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,le){const we=[];let ve=!1;for(const me of z)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return d.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const De=we.pop(),re=we.length===0,he=Ee.create(me.expr.map(se=>ye.create([se,De],null,le)),null,re);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return y.INSTANCE;if(we.length===1)return we[0]}return new ye(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ye(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=Ee.create(z,this,!0)}return this.c}}e.$3i=ye;class Ee{static create(z,q,le){return Ee.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,le){let we=[],ve=!1;if(z){for(let me=0,De=z.length;me<De;me++){const re=z[me];if(re){if(re.type===0){ve=!0;continue}if(re.type===1)return d.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return d.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new Ee(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),le=z.shift(),we=[];for(const ve of $e(q))for(const me of $e(le))we.push(ye.create([ve,me],null,!1));z.unshift(Ee.create(we,null,!1))}this.c=Ee.create(z,this,!0)}return this.c}}e.$4i=Ee;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,le){super(z,null),this.f=q,typeof le=="object"?Pe.d.push({...le,key:z}):le!==!0&&Pe.d.push({key:z,description:le,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return S.create(this.key,z)}notEqualsTo(z){return h.create(this.key,z)}}e.$5i=Pe,e.$6i=(0,F.$Nh)("contextKeyService");function Y(ie,z){return ie<z?-1:ie>z?1:0}function ae(ie,z,q,le){return ie<q?-1:ie>q?1:z<le?-1:z>le?1:0}function Se(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ue(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(Se(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ue(z.expr,ie.expr);for(const q of ie.expr)if(Se(q,z))return!0;return!1}return ie.equals(z)}e.$7i=Se;function ue(ie,z){let q=0,le=0;for(;q<ie.length&&le<z.length;){const we=ie[q].cmp(z[le]);if(we<0)return!1;we===0&&q++,le++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Re[171],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,w.$Nh)("environmentService"),e.$Vh=(0,w.$Oh)(e.$Uh)}),define(Re[92],Me([1,0,140,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$6n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=void 0,e.$Sn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Tn=new RegExp(e.$Sn),e.$Un="__web_extension",e.$Vn="skipWalkthrough",e.$Wn="extensionsSync",e.$Xn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Yn=C;function F(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Zn=F;function R(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$1n=R;function l(c,b){return b==="web"&&!c.includes("web")}e.$2n=l;function D(c,b,E){return l(b,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:g(E).includes(c)}e.$3n=D;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$4n=g;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$5n=P;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$6n=(0,M.$Nh)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.$7n=i,e.$8n=(0,M.$Nh)("extensionManagementService"),e.$9n="extensionsIdentifiers/disabled",e.$0n="extensionsIdentifiers/enabled",e.$$n=(0,M.$Nh)("IGlobalExtensionEnablementService"),e.$_n=(0,M.$Nh)("IExtensionTipsService"),e.$ao=(0,w.localize)(0,null),e.$bo={value:e.$ao,original:"Extensions"},e.$co={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Re[38],Me([1,0,49,19,15,16,2,142,4,22,13]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,D.$Nh)("fileService");function k(Y){return Y.create===!0}e.$0j=k;var a;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var p;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var $;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function f(Y){return!!(Y.capabilities&2)}e.$$j=f;function t(Y){return!!(Y.capabilities&8)}e.$_j=t;function i(Y){return!!(Y.capabilities&131072)}e.$ak=i;function c(Y){return!!(Y.capabilities&4)}e.$bk=c;function b(Y){return!!(Y.capabilities&16)}e.$ck=b;function E(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.$dk=E;function v(Y){return f(Y)?!!(Y.capabilities&32768):!1}e.$ek=v;function r(Y){return!!(Y.capabilities&65536)}e.$fk=r;function s(Y){return!!(Y.capabilities&2048)}e.$gk=s;var n;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class o extends Error{static create(ae,Se){const ue=new o(ae.toString(),Se);return I(ue,Se),ue}constructor(ae,Se){super(ae),this.code=Se}}e.$hk=o;function y(Y,ae){return o.create(Y,ae)}e.$ik=y;function d(Y){return Y||y((0,l.localize)(0,null),n.Unknown)}e.$jk=d;function I(Y,ae){return Y.name=ae?`${ae} (FileSystemError)`:"FileSystemError",Y}e.$kk=I;function S(Y){if(!Y)return n.Unknown;if(Y instanceof o)return Y.code;const ae=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!ae)return n.Unknown;switch(ae[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$lk=S;function u(Y){if(Y instanceof U)return Y.fileOperationResult;switch(S(Y)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$mk=u;var m;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(m||(e.FileOperation=m={}));class h{constructor(ae,Se,ue){this.resource=ae,this.operation=Se,this.target=ue}isOperation(ae){return this.operation===ae}}e.$nk=h;var A;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class W{constructor(ae,Se){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const $e of ae){const ie=ue.get($e.type);switch(ie?ie.push([$e.resource,$e]):ue.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ue)switch($e){case 1:this.a=w.$Th.forUris(()=>Se),this.a.fill(ie);break;case 0:this.b=w.$Th.forUris(()=>Se),this.b.fill(ie);break;case 2:this.c=w.$Th.forUris(()=>Se),this.c.fill(ie);break}}contains(ae,...Se){return this.d(ae,{includeChildren:!1},...Se)}affects(ae,...Se){return this.d(ae,{includeChildren:!0},...Se)}d(ae,Se,...ue){if(!ae)return!1;const $e=ue.length>0;return!!((!$e||ue.includes(1))&&(this.a?.get(ae)||Se.includeChildren&&this.a?.findSuperstr(ae))||(!$e||ue.includes(0))&&(this.b?.get(ae)||Se.includeChildren&&this.b?.findSuperstr(ae))||(!$e||ue.includes(2))&&(this.c?.findSubstr(ae)||Se.includeChildren&&this.c?.findSuperstr(ae)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=W;function V(Y,ae,Se){return!Y||!ae||Y===ae||ae.length>Y.length?!1:(ae.charAt(ae.length-1)!==M.sep&&(ae+=M.sep),Se?(0,C.$2e)(Y,ae):Y.indexOf(ae)===0)}e.$pk=V;class U extends Error{constructor(ae,Se,ue){super(ae),this.fileOperationResult=Se,this.options=ue}}e.$qk=U;class B extends U{constructor(ae,Se,ue,$e){super(ae,Se,$e),this.fileOperationResult=Se,this.size=ue}}e.$rk=B;class O extends U{constructor(ae,Se,ue){super(ae,2,ue),this.stat=Se}}e.$sk=O;var N;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var te;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Ak="";function Z(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.$Bk=Z;async function ye(Y,ae){if(!ae.hasProvider(R.URI.from({scheme:Y.scheme})))return new Promise(Se=>{const ue=ae.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Y.scheme&&$e.added&&(ue.dispose(),Se())})})}e.$Ck=ye;class Ee{static{this.KB=1024}static{this.MB=Ee.KB*Ee.KB}static{this.GB=Ee.MB*Ee.KB}static{this.TB=Ee.GB*Ee.KB}static formatSize(ae){return(0,F.$Bf)(ae)||(ae=0),ae<Ee.KB?(0,l.localize)(1,null,ae.toFixed(0)):ae<Ee.MB?(0,l.localize)(2,null,(ae/Ee.KB).toFixed(2)):ae<Ee.GB?(0,l.localize)(3,null,(ae/Ee.MB).toFixed(2)):ae<Ee.TB?(0,l.localize)(4,null,(ae/Ee.GB).toFixed(2)):(0,l.localize)(5,null,(ae/Ee.TB).toFixed(2))}}e.$Dk=Ee;function Pe(Y){const ae=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*Ee.MB:ae?10*Ee.MB:g.$p?50*Ee.MB:1024*Ee.MB}e.$Ek=Pe}),define(Re[70],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class w{constructor(...C){this.a=new Map;for(const[F,R]of C)this.set(F,R)}set(C,F){const R=this.a.get(C);return this.a.set(C,F),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Lh=w}),define(Re[172],Me([1,0,12,9,6,68,170,4,70,173]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;const P=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Lh,i=!1,c,b=P){this.f=t,this.g=i,this.h=c,this.i=b,this.o=new Set,this.f.set(l.$Mh,this),this._globalGraph=b?c?._globalGraph??new R.$$p(E=>E):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,M.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(v,c);if(!r)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...i)}finally{b=!0,c.stop()}}createInstance(t,...i){let c,b;return t instanceof F.$Kh?(c=$.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),b=this.j(t,i,c)),c.stop(),b}j(t,i=[],c){const b=l._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),E=[];for(const r of b){const s=this.m(r.id,c);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),E.push(s)}const v=b.length>0?b[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const r=v-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof F.$Kh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof F.$Kh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const b=new R.$$p(r=>r.id.toString());let E=0;const v=[{id:t,desc:i,_trace:c}];for(;v.length;){const r=v.pop();if(b.lookupOrInsertNode(r),E++>1e3)throw new k(b);for(const s of l._util.getServiceDependencies(r.desc.ctor)){const n=this.l(s.id);if(n||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),n instanceof F.$Kh){const o={id:s.id,desc:n,_trace:r._trace.branch(s.id,!0)};b.insertEdge(r,o),v.push(o)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:s}of r){if(this.l(s.id)instanceof F.$Kh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}b.removeNode(s)}}return this.l(t)}s(t,i,c=[],b,E){if(this.f.get(t)instanceof F.$Kh)return this.t(t,i,c,b,E);if(this.h)return this.h.s(t,i,c,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],b,E){if(b){const v=new a(void 0,this.g,this,this.i);v.c=String(t);const r=new Map,s=new w.$0g(()=>{const n=v.j(i,c,E);for(const[o,y]of r){const d=n[o];if(typeof d=="function")for(const I of y)d.apply(n,I)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=r.get(o);return I||(I=new g.$1c,r.set(o,I)),(u,m,h)=>{const A=I.push([u,m,h]);return(0,C.$Pc)(A)}}if(o in n)return n[o];const y=s.value;let d=y[o];return typeof d!="function"||(d=d.bind(y),n[o]=d),d},set(n,o,y){return s.value[o]=y,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,c,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$_p=a;var p;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(E,v){const r=[],s=new Array(E+1).join("	");for(const[n,o,y]of v.h)if(o&&y){i=!0,r.push(`${s}CREATES -> ${n}`);const d=c(E+1,y);d&&r.push(d)}else r.push(`${s}uses -> ${n}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(b.join(`
`))}}e.$aq=$}),define(Re[14],Me([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,a.$Nh)("logService"),e.$9i=(0,a.$Nh)("loggerService");function p(){return new Date().toISOString()}function $(u){return(0,g.$Bf)(u)}e.$0i=$;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$$i=f.Info;function t(u,m,h){switch(m){case f.Trace:u.trace(h);break;case f.Debug:u.debug(h);break;case f.Info:u.info(h);break;case f.Warning:u.warn(h);break;case f.Error:u.error(h);break;case f.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function i(u,m=!1){let h="";for(let A=0;A<u.length;A++){let W=u[A];if(W instanceof Error&&(W=(0,w.$yi)(W,m)),typeof W=="object")try{W=JSON.stringify(W)}catch{}h+=(A>0?" ":"")+W}return h}class c extends F.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new M.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==f.Off&&this.b<=m}}e.$aj=c;class b extends c{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...h){this.f(f.Trace)&&this.g(f.Trace,i([m,...h],!0))}debug(m,...h){this.f(f.Debug)&&this.g(f.Debug,i([m,...h]))}info(m,...h){this.f(f.Info)&&this.g(f.Info,i([m,...h]))}warn(m,...h){this.f(f.Warning)&&this.g(f.Warning,i([m,...h]))}error(m,...h){if(this.f(f.Error))if(m instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=m.stack,this.g(f.Error,i(A))}else this.g(f.Error,i([m,...h]))}flush(){}}e.$bj=b;class E extends c{constructor(m=e.$$i){super(),this.setLevel(m),this.g=!l.$j}trace(m,...h){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}debug(m,...h){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}info(m,...h){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}warn(m,...h){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,m,...h):console.warn(`[main ${p()}]`,m,...h))}error(m,...h){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,m,...h):console.error(`[main ${p()}]`,m,...h))}dispose(){}flush(){}}e.$cj=E;class v extends c{constructor(m=e.$$i,h=!0){super(),this.g=h,this.setLevel(m)}trace(m,...h){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...h):console.log(m,...h))}debug(m,...h){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...h):console.log(m,...h))}info(m,...h){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...h):console.log(m,...h))}warn(m,...h){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...h):console.log(m,...h))}error(m,...h){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...h):console.error(m,...h))}dispose(){}flush(){}}e.$dj=v;class r extends c{constructor(m,h=e.$$i){super(),this.g=m,this.setLevel(h)}trace(m,...h){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(m),...h])}debug(m,...h){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(m),...h])}info(m,...h){this.f(f.Info)&&this.g.log(f.Info,[this.h(m),...h])}warn(m,...h){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(m),...h])}error(m,...h){this.f(f.Error)&&this.g.log(f.Error,[this.h(m),...h])}h(m){return typeof m=="string"?m:(0,w.$yi)(m,this.f(f.Trace))}dispose(){}flush(){}}e.$ej=r;class s extends c{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const h of this.g)h.setLevel(m);super.setLevel(m)}trace(m,...h){for(const A of this.g)A.trace(m,...h)}debug(m,...h){for(const A of this.g)A.debug(m,...h)}info(m,...h){for(const A of this.g)A.info(m,...h)}warn(m,...h){for(const A of this.g)A.warn(m,...h)}error(m,...h){for(const A of this.g)A.error(m,...h)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$fj=s;class n extends F.$Rc{constructor(m,h,A){if(super(),this.h=m,this.j=h,this.b=new R.$zc,this.c=this.B(new M.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Md),this.onDidChangeVisibility=this.g.event,A)for(const W of A)this.b.set(W.resource,{logger:void 0,info:W})}m(m){return(0,g.$xf)(m)?[...this.b.values()].find(h=>h.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,h){const A=this.n(m),W=(0,g.$xf)(m)?m:h?.id??(0,C.$Bi)(A.toString()).toString(16);let V=this.b.get(A)?.logger;const U=h?.logLevel==="always"?f.Trace:h?.logLevel;V||(V=this.s(A,U??this.getLogLevel(A)??this.h,{...h,id:W}));const B={logger:V,info:{resource:A,id:W,logLevel:U,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(B.info),this.b.set(A,B),V}n(m){return(0,g.$xf)(m)?(0,D.$ug)(this.j,`${m}.log`):m}setLogLevel(m,h){if(P.URI.isUri(m)){const A=m,W=h,V=this.b.get(A);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([A,W]))}else{this.h=m;for(const[A,W]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,h){const A=this.m(m);A&&h!==!A.info.hidden&&(A.info.hidden=!h,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,h]))}getLogLevel(m){let h;return m&&(h=this.b.get(m)?.info.logLevel),h??this.h}registerLogger(m){const h=this.b.get(m.resource);h?h.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const h=this.b.get(m);h&&(h.logger&&h.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=n;class o{constructor(){this.onDidChangeLogLevel=new M.$Md().event}setLevel(m){}getLevel(){return f.Info}trace(m,...h){}debug(m,...h){}info(m,...h){}warn(m,...h){}error(m,...h){}critical(m,...h){}dispose(){}flush(){}}e.$hj=o;class y extends o{}e.$ij=y;function d(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$$i}e.$jj=d;function I(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$kj=I;function S(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$lj=S,e.$mj=new k.$5i("logLevel",I(f.Info))}),define(Re[174],Me([1,0,6,14]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class C extends w.$Rc{constructor(R,l=[]){super(),this.a=new M.$fj([R,...l]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...l){this.a.trace(R,...l)}debug(R,...l){this.a.debug(R,...l)}info(R,...l){this.a.info(R,...l)}warn(R,...l){this.a.warn(R,...l)}error(R,...l){this.a.error(R,...l)}flush(){this.a.flush()}}e.$vN=C}),define(Re[94],Me([1,0,29,143,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g($,f){return f-$}D.compare=g;const P=Object.create(null);P[D.Error]=(0,M.localize)(0,null),P[D.Warning]=(0,M.localize)(1,null),P[D.Info]=(0,M.localize)(2,null);function k($){return P[$]||""}D.toString=k;function a($){switch($){case w.default.Error:return D.Error;case w.default.Warning:return D.Warning;case w.default.Info:return D.Info;case w.default.Ignore:return D.Hint}}D.fromSeverity=a;function p($){switch($){case D.Error:return w.default.Error;case D.Warning:return w.default.Warning;case D.Info:return w.default.Info;case D.Hint:return w.default.Ignore}}D.toSeverity=p}(R||(e.MarkerSeverity=R={}));var l;(function(D){const g="";function P(a){return k(a,!0)}D.makeKey=P;function k(a,p){const $=[g];return a.source?$.push(a.source.replace("\xA6","\\\xA6")):$.push(g),a.code?typeof a.code=="string"?$.push(a.code.replace("\xA6","\\\xA6")):$.push(a.code.value.replace("\xA6","\\\xA6")):$.push(g),a.severity!==void 0&&a.severity!==null?$.push(R.toString(a.severity)):$.push(g),a.message&&p?$.push(a.message.replace("\xA6","\\\xA6")):$.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?$.push(a.startLineNumber.toString()):$.push(g),a.startColumn!==void 0&&a.startColumn!==null?$.push(a.startColumn.toString()):$.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?$.push(a.endLineNumber.toString()):$.push(g),a.endColumn!==void 0&&a.endColumn!==null?$.push(a.endColumn.toString()):$.push(g),$.push(g),$.join("\xA6")}D.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$7s=(0,C.$Nh)("markerService")}),define(Re[175],Me([1,0,5,29,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Uu=e.Severity=void 0,e.Severity=M.default,e.$Uu=(0,C.$Nh)("notificationService");var F;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class D{constructor(){this.progress=new g,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Vu=D;class g{infinite(){}done(){}total(k){}worked(k){}}e.$Wu=g}),define(Re[95],Me([1,0,15,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0T=e.$9T=e.$8T=e.$7T=e.$6T=void 0,e.$6T=(0,C.$Nh)("openerService");function F(g,P){return M.URI.isUri(g)?(0,w.$1e)(g.scheme,P):(0,w.$2e)(g,P+":")}e.$7T=F;function R(g,...P){return P.some(k=>F(g,k))}e.$8T=R;function l(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$9T=l;function D(g){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$0T=D}),define(Re[176],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,w.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,M){var C=arguments.length,F=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,M);else for(var l=be.length-1;l>=0;l--)(R=be[l])&&(F=(C<3?R(F):C>3?R(e,w,F):R(e,w))||F);return C>3&&F&&Object.defineProperty(e,w,F),F},We=this&&this.__param||function(be,e){return function(w,M){e(w,M,be)}};define(Re[71],Me([1,0,12,21,6,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.$1u=e.$Zu=e.$Yu=e.ProgressLocation=e.$Xu=void 0,e.$Xu=(0,F.$Nh)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Yu=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,a){this.e=k,this.report=a?.async?this.g.bind(this):this.f.bind(this)}f(k){this.a=k,this.e(this.a)}g(k){this.b?this.b.push(k):this.b=[k],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const k=this.b.shift();this.a=k,await this.e(this.a)}}finally{this.c=!1;const k=this.d;this.d=void 0,k?.()}}drain(){return this.c?new Promise(k=>{const a=this.d;this.d=()=>{a?.(),k()}}):Promise.resolve()}}e.$Zu=l;let D=class extends C.$Rc{constructor(k,a){super(),this.a=new w.$bh,a.withProgress(k,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$1u=D,e.$1u=D=Ke([We(1,e.$Xu)],D);class g extends C.$Rc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Qc)}start(k){this.stop();const a=++this.a,p=new M.$Wd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>p.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:a,token:p.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$2u=g,e.$3u=(0,F.$Nh)("editorProgressService")}),define(Re[30],Me([1,0,51,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0;class C{constructor(){this.a=new Map}add(R,l){w.ok(M.$xf(R)),w.ok(M.$zf(l)),w.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,l)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$bn=new C}),define(Re[72],Me([1,0,5,30]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$cn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class F{constructor(){this.b=new w.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[C(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;M.$bn.add(e.$cn.JSONContribution,R)}),define(Re[96],Me([1,0,18,5,16,137,43,72,30]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.ConfigurationScope=e.$gn=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$gn={Configuration:"base.contributions.configuration"};var P;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn="vscode://schemas/settings/resourceLanguage",e.$on="vscode://schemas/settings/configurationDefaults";const k=D.$bn.as(l.$cn.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Md,this.onDidSchemaChange=this.i.event,this.j=new M.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$nn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const n=new Set;this.n(r,s,n),k.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const s=new Set;this.o(r,s),k.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const n=new Set;this.o(s,n),this.n(r,!1,n),k.registerSchema(e.$nn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const n=[];for(const{overrides:o,source:y}of r)for(const d in o)if(s.add(d),e.$qn.test(d)){const I=this.a.get(d),S=I?.valuesSources??new Map;if(y)for(const A of Object.keys(o[d]))S.set(A,y);const u={...I?.value||{},...o[d]};this.a.set(d,{source:y,value:u,valuesSources:S});const m=(0,R.$ri)(d),h={type:"object",default:u,description:F.localize(1,null,m),$ref:e.$nn,defaultDefaultValue:u,source:C.$xf(y)?void 0:y,defaultValueSource:y};n.push(...f(d)),this.d[d]=h,this.b.properties[d]=h}else{this.a.set(d,{value:o[d],source:y});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(n)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:n,source:o}of r)for(const y in n){const d=this.a.get(y),I=C.$xf(o)?o:o?.id,S=C.$xf(d?.source)?d?.source:d?.source?.id;if(I===S)if(s.add(y),this.a.delete(y),e.$qn.test(y))delete this.d[y],delete this.b.properties[y];else{const u=this.d[y];u&&(this.w(y,u),this.r(y,u))}}this.u()}deltaConfiguration(r){let s=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,n){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(r,s){const n=o=>{if(o.properties)for(const y in o.properties){s.add(y);const d=this.d[y];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>n(y))};for(const o of r){n(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(r,s=!0,n,o,y=3,d){y=C.$Gf(r.scope)?y:r.scope;const I=r.properties;if(I)for(const u in I){const m=I[u];if(s&&b(u,m)){delete I[u];continue}if(m.source=n,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$qn.test(u)?m.scope=void 0:(m.scope=C.$Gf(m.scope)?y:m.scope,m.restricted=C.$Gf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),d.add(u)}const S=r.allOf;if(S)for(const u of S)this.p(u,s,n,o,y,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=n=>{const o=n.properties;if(o)for(const d in o)this.r(d,o[d]);n.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$hn.properties[r]=s,s.scope){case 1:e.$in.properties[r]=s;break;case 2:e.$jn.properties[r]=s;break;case 6:e.$kn.properties[r]=s;break;case 3:e.$ln.properties[r]=s;break;case 4:e.$mn.properties[r]=s;break;case 5:e.$mn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$hn.properties[r],s.scope){case 1:delete e.$in.properties[r];break;case 2:delete e.$jn.properties[r];break;case 6:delete e.$kn.properties[r];break;case 3:delete e.$ln.properties[r];break;case 4:case 5:delete e.$mn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,n={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$nn};this.w(s,n),e.$hn.properties[s]=n,e.$in.properties[s]=n,e.$jn.properties[s]=n,e.$kn.properties[s]=n,e.$ln.properties[s]=n,e.$mn.properties[s]=n}}v(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$nn};e.$hn.patternProperties[e.$pn]=r,e.$in.patternProperties[e.$pn]=r,e.$jn.patternProperties[e.$pn]=r,e.$kn.patternProperties[e.$pn]=r,e.$ln.patternProperties[e.$pn]=r,e.$mn.patternProperties[e.$pn]=r,this.i.fire()}w(r,s){const n=this.a.get(r);let o=n?.value,y=n?.source;C.$Ef(o)&&(o=s.defaultDefaultValue,y=void 0),C.$Ef(o)&&(o=i(s.type)),s.default=o,s.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$pn=`^(${p})+$`,e.$qn=new RegExp(e.$pn);function f(v){const r=[];if(e.$qn.test(v)){let s=$.exec(v);for(;s?.length;){const n=s[1].trim();n&&r.push(n),s=$.exec(v)}}return(0,w.$Lb)(r)}e.$rn=f;function t(v){return v.reduce((r,s)=>`${r}[${s}]`,"")}e.$sn=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$tn=i;const c=new a;D.$bn.add(e.$gn.Configuration,c);function b(v,r){return v.trim()?e.$qn.test(v)?F.localize(7,null,v):c.getConfigurationProperties()[v]!==void 0?F.localize(8,null,v):r.policy?.name&&c.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,v,r.policy?.name,c.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.$un=b;function E(){const v=[],r=c.getConfigurationProperties();for(const s of Object.keys(r))v.push([s,r[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$vn=E}),define(Re[177],Me([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function p(s){return Object.isFrozen(s)?s:l.$3m(s)}class ${constructor(n={},o=[],y=[],d){this.b=n,this.c=o,this.d=y,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof $)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=n.reduce((o,y)=>y===o?y:o.merge(y),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$pi)(this.contents,n):this.contents}inspect(n,o){const y=this.rawConfiguration.getValue(n),d=o?this.rawConfiguration.getOverrideValue(n,o):void 0,I=o?this.rawConfiguration.override(o).getValue(n):y;return{value:y,override:d,merged:I}}getOverrideValue(n,o){const y=this.i(o);return y?n?(0,P.$pi)(y,n):y:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const y of this.overrides)y.identifiers.includes(n)&&o.push(...y.keys);return w.$Lb(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return w.$Lb(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=l.$2m(this.contents),y=l.$2m(this.overrides),d=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of n)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=y.filter(h=>w.$tb(h.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=w.$Lb(m.keys)):y.push(l.$2m(u))}for(const u of S.keys)d.indexOf(u)===-1&&d.push(u)}return new $(o,d,y,I.every(S=>S instanceof $)?void 0:I)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const d of w.$Lb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[d];const S=o[d];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$2m(I),this.h(I,S)):I=S),y[d]=I}return new $(y,this.keys,this.overrides)}h(n,o){for(const y of Object.keys(o)){if(y in n&&D.$zf(n[y])&&D.$zf(o[y])){this.h(n[y],o[y]);continue}n[y]=l.$2m(o[y])}}i(n){let o=null,y=null;const d=I=>{I&&(y?this.h(y,I):y=l.$2m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?o=I.contents:I.identifiers.includes(n)&&d(I.contents);return d(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,P.$oi)(this.contents,n),k.$qn.test(n)&&this.overrides.splice(this.overrides.findIndex(y=>w.$tb(y.identifiers,(0,k.$rn)(n))),1))}j(n,o,y){(0,P.$ni)(this.contents,n,o,d=>console.error(d)),y=y||this.keys.indexOf(n)===-1,y&&this.keys.push(n),k.$qn.test(n)&&this.overrides.push({identifiers:(0,k.$rn)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$mi)(this.contents[n],d=>console.error(d))})}}e.$wn=$;class f{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!D.$Gf(n)){const y=this.g(n);this.parseRaw(y,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:y,keys:d,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(n,o);this.b=new $(y,d,I,u?[n]:void 0),this.c=S||[]}g(n){let o={},y=null,d=[];const I=[],S=[];function u(h){Array.isArray(d)?d.push(h):y!==null&&(d[y]=h)}const m={onObjectBegin:()=>{const h={};u(h),I.push(d),d=h,y=null},onObjectProperty:h=>{y=h},onObjectEnd:()=>{d=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(d),d=h,y=null},onArrayEnd:()=>{d=I.pop()},onLiteralValue:u,onError:(h,A,W)=>{S.push({error:h,offset:A,length:W})}};if(n)try{C.$Ym(n,m),o=d[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(n,o){const y=a.$bn.as(k.$gn.Configuration).getConfigurationProperties(),d=this.i(n,y,!0,o);n=d.raw;const I=(0,P.$mi)(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(n),u=this.j(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(n,o,y,d){let I=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in n)if(k.$qn.test(m)&&y){const h=this.i(n[m],o,!1,d);S[m]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[m],A=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(m),!d.exclude?.includes(m)&&(d.include?.includes(m)||(A===void 0||d.scopes===void 0||d.scopes.includes(A))&&!(d.skipRestricted&&h?.restricted))?S[m]=n[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(n,o){const y=[];for(const d of Object.keys(n))if(k.$qn.test(d)){const I={};for(const S in n[d])I[S]=n[d][S];y.push({identifiers:(0,k.$rn)(d),keys:Object.keys(I),contents:(0,P.$mi)(I,o)})}return y}}e.$xn=f;class t extends F.$Rc{constructor(n,o,y,d){super(),this.c=n,this.f=o,this.g=d,this.b=this.B(new M.$Md),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&y.isEqual(I.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yn=t;class i{constructor(n,o,y,d,I,S,u,m,h,A,W,V,U){this.a=n,this.b=o,this.c=y,this.overrideIdentifiers=d,this.d=I,this.f=S,this.g=u,this.h=m,this.i=h,this.j=A,this.k=W,this.l=V,this.m=U}get value(){return p(this.c)}n(n,o,y){const d=n.inspect(o,y);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,o,y,d,I=new $,S=new $,u=new R.$zc,m=new $,h=new R.$zc){this.c=n,this.d=o,this.f=y,this.g=d,this.h=I,this.i=S,this.j=u,this.l=m,this.m=h,this.a=null,this.b=new R.$zc,this.n=null}getValue(n,o,y){return this.q(n,o,y).getValue(n)}updateValue(n,o,y={}){let d;y.resource?(d=this.m.get(y.resource),d||(d=new $,this.m.set(y.resource,d))):d=this.l,o===void 0?d.removeValue(n):d.setValue(n,o),y.resource||(this.a=null)}inspect(n,o,y){const d=this.q(n,o,y),I=this.u(o.resource,y),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of d.overrides)for(const h of m.identifiers)d.getOverrideValue(n,h)!==void 0&&u.add(h);return new i(n,o,d.getValue(n),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,I||void 0,S)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const y=[];if(!o){const{added:d,updated:I,removed:S}=v(this.c,n);o=[...d,...I,...S]}for(const d of o)for(const I of(0,k.$rn)(d)){const S=this.c.getKeysForOverrideIdentifier(I),u=n.getKeysForOverrideIdentifier(I),m=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$6m(this.c.override(I).getValue(h),n.override(I).getValue(h)))];y.push([I,m])}return this.updateDefaultConfiguration(n),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:y,removed:d}=v(this.d,n),I=[...o,...y,...d];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:y,removed:d,overrides:I}=v(this.applicationConfiguration,n),S=[...o,...y,...d];return S.length&&this.updateApplicationConfiguration(n),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:y,removed:d,overrides:I}=v(this.localUserConfiguration,n),S=[...o,...y,...d];return S.length&&this.updateLocalUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:y,removed:d,overrides:I}=v(this.remoteUserConfiguration,n),S=[...o,...y,...d];return S.length&&this.updateRemoteUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:y,removed:d,overrides:I}=v(this.workspaceConfiguration,n),S=[...o,...y,...d];return S.length&&this.updateWorkspaceConfiguration(n),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(n,o){const y=this.p.get(n),{added:d,updated:I,removed:S,overrides:u}=v(y,o),m=[...d,...I,...S];return(m.length||!y)&&this.updateFolderConfiguration(n,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:y,updated:d,removed:I,overrides:S}=v(o,void 0);return{keys:[...y,...d,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,y){let d=this.r(o,y);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(d=d.merge(this.d)),d}r({resource:n},o){let y=this.s();if(o&&n){const d=o.getFolder(n);d&&(y=this.t(d.uri)||y);const I=this.m.get(n);I&&(y=y.merge(I))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const y=this.s(),d=this.j.get(n);d?(o=y.merge(d),this.b.set(n,o)):o=y}return o}u(n,o){if(o&&n){const y=o.getFolder(n);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:y,overrides:d,keys:I}=this.j.get(o);return n.push([o,{contents:y,overrides:d,keys:I}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(y=>n.add(y))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>n.add(y))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(n).forEach(d=>o.add(d))),[...o.values()]}static parse(n){const o=this.x(n.defaults),y=this.x(n.policy),d=this.x(n.application),I=this.x(n.user),S=this.x(n.workspace),u=n.folders.reduce((m,h)=>(m.set(g.URI.revive(h[0]),this.x(h[1])),m),new R.$zc);return new c(o,y,d,I,new $,S,u,new $,new R.$zc)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$zn=c;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const n=new Set,o=new Map;for(const d of s)d.keys.forEach(I=>n.add(I)),d.overrides.forEach(([I,S])=>{const u=(0,R.$wc)(o,I,new Set);S.forEach(m=>u.add(m))});const y=[];return o.forEach((d,I)=>y.push([I,[...d.values()]])),{keys:[...n.values()],overrides:y}}e.$An=b;class E{constructor(n,o,y,d){this.change=n,this.f=o,this.g=y,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,o){const y=this.a+n,d=this.d.indexOf(y);if(d<0)return!1;const I=d+y.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,m=this.g.getValue(n,o,this.h);return!l.$6m(u,m)}return!0}}e.$Bn=E;function v(s,n){const{added:o,removed:y,updated:d}=r(n?.rawConfiguration,s?.rawConfiguration),I=[],S=s?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const m=u.filter(h=>!S.includes(h));for(const h of m)I.push([h,n.getKeysForOverrideIdentifier(h)])}if(s){const m=S.filter(h=>!u.includes(h));for(const h of m)I.push([h,s.getKeysForOverrideIdentifier(h)])}if(n&&s){for(const m of S)if(u.includes(m)){const h=r({contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});I.push([m,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:y,updated:d,overrides:I}}function r(s,n){const o=s?n?s.keys.filter(I=>n.keys.indexOf(I)===-1):[...s.keys]:[],y=n?s?n.keys.filter(I=>s.keys.indexOf(I)===-1):[...n.keys]:[],d=[];if(s&&n){for(const I of n.keys)if(s.keys.indexOf(I)!==-1){const S=(0,P.$pi)(n.contents,I),u=(0,P.$pi)(s.contents,I);l.$6m(S,u)||d.push(I)}}return{added:o,removed:y,updated:d}}}),define(Re[97],Me([1,0,9,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,M.$Nh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=F;class R{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=R;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class D extends w.$ab{static isNotAvailable(k){return k instanceof D&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=l.Unknown,p){super(k),this._message=k,this._code=a,this._detail=p,this.isHandled=a===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Pk=D;function g(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$Qk=g}),define(Re[52],Me([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function M(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.$Rk=M;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Sk=C;function F(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Tk=F;function R(g){const{host:P,port:k}=D(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.$Uk=R;function l(g,P){let{host:k,port:a}=D(g);return typeof a>"u"&&(a=P),{host:k,port:a}}e.$Vk=l;function D(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Re[20],Me([1,0,15,4,52]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.TargetPlatform=e.ExtensionType=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl="extensions.user.cache",e.$Wl="extensions.builtin.cache",e.$Xl="undefined_publisher",e.$Yl=["ui","workspace","web"];function F(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Zl=F,e.$1l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var l;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,b=typeof i=="string"?i:i.value;return w.$1e(c,b)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$2l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$3l=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$4l=P;function k(f){return a(f)}e.$5l=k;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$6l=a;function p(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$7l=p;function $(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Sk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$8l=$,e.$9l=(0,M.$Nh)("IBuiltinExtensionsScannerService")}),define(Re[98],Me([1,0,9,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OE=e.$NE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,l){this.a.set(R,l)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const l=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&(l[M.$2l.toKey(D.identifier)]=g)}return l}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const l=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return l;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const P=R.contributes[D],k=Array.isArray(P)?P:[P];try{g(k,l)}catch(a){(0,w.$Z)(a)}}return l}}e.$NE=C,e.$OE=new C}),define(Re[178],Me([1,0,22,73,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;function F(D){if(w.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,P,k,a,p,$,f){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$dg)()+Date.now(),t.commitHash=k,t.version=a,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$i)(w.$u),t["common.nodePlatform"]=M.$cc,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$m&&(t["common.snap"]="true");const b=F(g);return b&&(t["common.platformDetail"]=b),t}e.$do=R;function l(D){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return D.some(k=>P===k)}e.$eo=l}),define(Re[179],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,w.$Nh)("telemetryService"),e.$al=(0,w.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Re[53],Me([1,0,24,16,5,43,52,178,179]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;class g{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$fo=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$go=P,e.$ho=new P;class k{async publicLog(y,d,I){}async publicLogError(y,d,I){}}e.$io=k,e.$jo="telemetry",e.$ko="extensionTelemetryLog",e.$lo={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.$ki)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$mo=a;function p(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$no=p;function $(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$oo=$;function f(o){const y=o.getValue(D.$gl),d=o.getValue(D.$hl);if(o.getValue(D.$il)===!1||d===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$po=f;function t(o){const y={},d={},I={};b(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?d[S]=u:typeof u=="boolean"?d[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),y[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(y[S]=u)}return{properties:y,measurements:d}}e.$qo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,R.$Sk)(o);return i.has(y)?y:"other"}e.$ro=c;function b(o,y,d=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?y[m]=(0,w.$7m)(u):u instanceof Date?y[m]=u.toISOString():(0,M.$zf)(u)?d<2?b(u,y,d+1,m+"."):y[m]=(0,w.$7m)(u):y[m]=u}}function E(o,y){const d=o.msftInternalDomains||[],I=y.getValue("telemetry.internalTesting");return(0,l.$eo)(d)||I}e.$so=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$to=v;function r(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const I=[];for(const h of y)for(;;){const A=h.exec(o);if(!A)break;I.push([A.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(d="";;){const h=u.exec(o);if(!h)break;const A=I.some(([W,V])=>h.index<V&&W<u.lastIndex);!S.test(h[0])&&!A&&(d+=o.substring(m,h.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(d+=o.substr(m)),d}function s(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of y)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function n(o,y){return(0,w.$4m)(o,d=>{if(d instanceof g||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let I=d.replaceAll("%20"," ");I=r(I,y);for(const S of y)I=I.replace(S,"");return I=s(I),I}})}e.$uo=n}),define(Re[180],Me([1,0,15,92,20,22,2,9,73,53]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;function P(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,w.$Ve)(n.id,o.id)===0}e.$vo=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const y=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,y,d)}static parse(o){const y=k.exec(o);return y&&y[1]&&y[2]?new a({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,d="undefined"){this.version=y,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$wo=a;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const o=p.exec(n);return o&&o[1]?[t(o[1]),o[2]]:[t(n),void 0]}e.$xo=$;function f(n,o){return`${n}.${o}`}e.$yo=f;function t(n){return n.toLowerCase()}e.$zo=t;function i(n,o){return t(f(n??C.$Xl,o))}e.$Ao=i;function c(n,o){const y=[],d=I=>{for(const S of y)if(S.some(u=>P(o(u),o(I))))return S;return null};for(const I of n){const S=d(I);S?S.push(I):y.push([I])}return y}e.$Bo=c;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Co=b;function E(n){return{id:new g.$fo(n.identifier.id),name:new g.$fo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Do=E,e.$Eo=new C.$2l("pprice.better-merge");function v(n,o){const y=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&y.every(S=>!P(S.identifier,{id:I}))){const S=n.filter(u=>P(u.identifier,{id:I}));S.length===1&&(y.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Fo=v;async function r(n,o){if(!F.$l)return!1;let y;try{y=(await n.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await n.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$9)(I))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(n,o){const y=await r(n,o),d=(0,M.$1n)(y?"alpine":F.$u,D.$dc);return o.debug("ComputeTargetPlatform:",d),d}e.$Go=s}),define(Re[181],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=e.$gr=void 0;function w(D){return[...D.entries()]}e.$gr=w;function M(D){return D?[...D.entries()]:[]}e.$hr=M;function C(D){return new Map(D)}e.$ir=C;function F(D){return new Map(D??[])}e.$jr=F;function R(D){return Array.from(D.entries()).map(g=>[g[0],w(g[1].map),M(g[1].descriptionMap)])}e.$kr=R;function l(D){return new Map(D.map(g=>[g[0],{map:C(g[1]),descriptionMap:F(g[2])}]))}e.$lr=l}),define(Re[182],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,R=5){const l=F(D=>{const g=typeof D=="string"?D:D.data;let P=this.a.get(C);if(P){P.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(C),R);P={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$Ikb=w}),define(Re[183],Me([1,0,12,89,40,5,16,2,144,72,30]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.IconFontDefinition=e.IconContribution=e.$Yv=void 0,e.$Yv={IconContribution:"base.contributions.icons"};var k;(function(E){function v(r,s){let n=r.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const o=$.getIcon(n.id);if(!o)return;n=o.defaults}return n}E.getDefinition=v})(k||(e.IconContribution=k={}));var a;(function(E){function v(s){return{weight:s.weight,style:s.style,src:s.src.map(n=>({format:n.format,location:n.location.toString()}))}}E.toJSONObject=v;function r(s){const n=o=>(0,R.$xf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,R.$xf)(o.format)&&(0,R.$xf)(o.location)))return{weight:n(s.weight),style:n(s.style),src:s.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class p{constructor(){this.a=new F.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,r,s,n){const o=this.b[v];if(o){if(s&&!o.description){o.description=s,this.d.properties[v].markdownDescription=`${s} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return o}const y={id:v,description:s,defaults:r,deprecationMessage:n};this.b[v]=y;const d={$ref:"#/definitions/icons"};return n&&(d.deprecationMessage=n),s&&(d.markdownDescription=`${s}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const r=this.e.enum.indexOf(v);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,r){const s=this.f[v];return s||(this.f[v]=r,this.a.fire(),r)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,y)=>o.id.localeCompare(y.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(o=>this.b[o]);for(const o of n.filter(y=>!!y.description).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of n.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const $=new p;P.$bn.add(e.$Yv.IconContribution,$);function f(E,v,r,s){return $.registerIcon(E,v,r,s)}e.$Zv=f;function t(){return $}e.$1v=t;function i(){const E=(0,M.$Qj)();for(const v in E){const r="\\"+E[v].toString(16);$.registerIcon(v,{fontCharacter:r})}}i(),e.$2v="vscode://schemas/icons";const c=P.$bn.as(g.$cn.JSONContribution);c.registerSchema(e.$2v,$.getIconSchema());const b=new w.$5g(()=>c.notifySchemaChanged(e.$2v),200);$.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.$3v=f("widget-close",M.$Sj.close,(0,D.localize)(2,null)),e.$4v=f("goto-previous-location",M.$Sj.arrowUp,(0,D.localize)(3,null)),e.$5v=f("goto-next-location",M.$Sj.arrowDown,(0,D.localize)(4,null)),e.$6v=C.ThemeIcon.modify(M.$Sj.sync,"spin"),e.$7v=C.ThemeIcon.modify(M.$Sj.loading,"spin")}),define(Re[184],Me([1,0,5,43,4,14]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProvidedOnAutoForward=e.$6u=e.TunnelPrivacyId=e.TunnelProtocol=e.$5u=e.$4u=void 0,e.$4u=(0,C.$Nh)("tunnelService"),e.$5u=(0,C.$Nh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function D(t){return!!t.forwardPort}e.$6u=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$7u=P,e.$8u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$8u.indexOf(t)>=0}e.$9u=k,e.$0u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$0u.indexOf(t)>=0}e.$$u=a;function p(t,i,c,b){if(c===1)return!1;if(c===2&&a(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$_u=p;class ${constructor(i,c,b){this.remoteAddress=i,this.localAddress=c,this.b=b,this.a=new w.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$av=$;let f=class{constructor(i,c){this.j=i,this.k=c,this.a=new w.$Md,this.onTunnelOpened=this.a.event,this.b=new w.$Md,this.onTunnelClosed=this.b.event,this.c=new w.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const b of c){const E=Array.from(b.values());for(const v of E){const r=await v.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(b=>typeof b!="string"?b?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,b,E,v){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:b,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(a(i)||k(i))&&(i=e.$8u[0]);const b=this.r(i,c);if(b)return++b.refcount,b.value}openTunnel(i,c,b,E,v,r=!1,s,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${v}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,b,E,v,r,s,n);return y?y.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,b),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(d);return(d.tunnelRemoteHost!==c||d.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&d.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const b=c.get(i.tunnelRemotePort);b&&(b.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,b))}}}}async o(i,c,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const E=b.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),E}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const b=this.e.get(i);if(b&&b.has(c)){const E=b.get(c);E.refcount=0,await this.o(i,c,E)}}p(i,c,b){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:b})}async q(i,c){const b=this.e.get(i);if(b){const E=b.get(c),v=E?await E.value:void 0;(!v||typeof v=="string")&&b.delete(c),b.size===0&&this.e.delete(i)}}r(i,c){const b=[i];k(i)?(b.push(...e.$8u),b.push(...e.$0u)):a(i)&&b.push(...e.$0u);const E=b.map(v=>this.e.get(v));for(const v of E){const r=v?.get(c);if(r)return r}}canTunnel(i){return!!P(i)}t(i,c,b,E,v,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${E}.`);const n=b;this.i.add(n);const o=E===void 0?b:E,y={elevationRequired:v?this.isPortPrivileged(o):!1},d={remoteAddress:{host:c,port:b},localAddressPort:E,privacy:r,public:r?r!==l.Private:void 0,protocol:s},I=i.forwardPort(d,y);return I?(this.p(c,b,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),I}};e.$bv=f,e.$bv=f=Ke([We(0,F.$8i),We(1,M.$hi)],f)}),define(Re[185],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$cv=void 0,e.$cv=(0,w.$Nh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[186],Me([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=void 0;function M(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}e.$GJ=M;function C(D){if(D.folders.length)return D.folders.every(g=>M(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$HJ=C;function F(D){return C(D)?.scheme}e.$IJ=F;function R(D){return C(D)?.authority}e.$JJ=R;function l(D){return C(D)!==void 0}e.$KJ=l}),define(Re[54],Me([1,0,145,19,49,23,2,4,13]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,l.$Nh)("contextService");function g(o){const y=o;return typeof y?.id=="string"&&R.URI.isUri(y.uri)}e.$Xh=g;function P(o){return typeof o?.id=="string"&&!g(o)&&!a(o)}e.$Yh=P,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function k(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$mc)(o)}:y?e.$Zh:e.$1h;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$2h=k;function a(o){const y=o;return typeof y?.id=="string"&&R.URI.isUri(y.configPath)}e.$3h=a;function p(o){const y=o;if(y?.uri)return{id:y.id,uri:R.URI.revive(y.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$4h=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$5h=f;function t(o){const y=o;return!!(y&&typeof y=="object"&&R.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$6h=t;class i{constructor(y,d,I,S,u){this.h=y,this.j=I,this.k=S,this.l=u,this.c=C.$Th.forUris(this.l,()=>!0),this.folders=d}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Th.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=i;class c{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,F.$ug)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=c;function b(o){return new c({uri:o,index:0,name:(0,F.$qg)(o)},{uri:o.toString()})}e.$9h=b,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,w.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function E(o,y){return F.$lg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$bi=E;function v(o){let y;return R.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===D.Schemas.tmp}e.$ci=v,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$di}e.$ei=r;function s(o,y){return!E(o,y)&&!v(o)}e.$fi=s;function n(o){return(typeof o=="string"?(0,M.$nc)(o):(0,F.$sg)(o))===e.$$h}e.$gi=n}),define(Re[74],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Gbc=w}),define(Re[39],Me([1,0,13,23,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0;class F{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$jg(l=>{const D=this.b.get(l.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(l,D){D===null?this.b.delete(l.scheme):this.b.set(l.scheme,D)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Ibc=F,e.$Jbc=(0,C.$Nh)("IExtHostFileSystemInfo")}),define(Re[27],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=void 0,e.$oM=(0,w.$Nh)("IExtHostInitDataService")}),define(Re[187],Me([1,0,150,14,174,27]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;let R=class extends C.$vN{constructor(D,g,P){const k=P.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):D?(0,w.localize)(1,null):(0,w.localize)(2,null);super(g.createLogger(k,{name:a}))}};e.$Pdc=R,e.$Pdc=R=Ke([We(1,M.$9i),We(2,F.$oM)],R)}),define(Re[188],Me([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=void 0;class M{constructor(R,l,D){this.h=new Map,this.a=R,this.b=l,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new w.$5g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const k of g.values())k.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,l){let D=this.f[R];return typeof D>"u"&&(D=l),D}update(R,l){this.f[R]=l;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new w.$bh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$_bc=M;class C extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,l){super(R.identifier.value,!0,l),this.j=R}}e.$acc=C}),define(Re[189],Me([1,0,5,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class C{constructor(R){this.c=R,this.a=new w.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,l,D,g){const k=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(l.value,D,g);this.b.fire(k)}$acceptDirtyStateChanged(R,l){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(l)}$acceptModelSaved(R){const l=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(l.apiNotebook)}}e.$ydc=C}),define(Re[17],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=void 0,e.$$L=(0,w.$Nh)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$_L=M}),define(Re[190],Me([1,0,20,5]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class C{#e;constructor(R,l){this.b=new M.$Md,this.onDidChange=this.b.event,this.a=w.$2l.toKey(R.identifier),this.#e=l,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,l){return this.#e.store(this.a,R,l)}delete(R){return this.#e.delete(this.a,R)}}e.$lcc=C}),define(Re[55],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0,e.$Tbc=(0,w.$Nh)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Ubc=M}),define(Re[191],Me([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcb=e.$pcb=void 0;class M{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function C(l,D){if(D.serializeBuffersForPostMessage){const g=new M,k=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add($)};if(ArrayBuffer.isView($)){const f=F($);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add($.buffer),view:{type:f,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),a=g.buffers.map(p=>{const $=new Uint8Array(p);return w.$ae.wrap($)});return{message:k,buffers:a}}else return{message:JSON.stringify(l),buffers:[]}}e.$pcb=C;function F(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(l,D){const g=D.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),P=D.length?(a,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:f}=$,t=g[f];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,P),arrayBuffers:g}}e.$qcb=R}),define(Re[99],Me([1,0,159,16,2,6,4,30,38,13,41,127,29]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aE=e.$_D=e.$$D=e.EditorsOrder=e.$0D=e.CloseDirection=e.$9D=e.$8D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.EditorInputCapabilities=e.$YD=e.SaveReason=e.Verbosity=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$MD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ND={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$OD="workbench.editor.sidebysideEditor",e.$PD="workbench.editors.textDiffEditor",e.$QD="workbench.editors.binaryResourceDiffEditor";var p;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function f(ue){const $e=ue;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$RD=f;function t(ue,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ue.matches(z.input))return z.getViewState()}e.$SD=t;function i(ue){if(d(ue))return!1;const $e=ue;return C.URI.isUri($e?.resource)}e.$TD=i;function c(ue){if(d(ue))return!1;const $e=ue;return $e?.original!==void 0&&$e.modified!==void 0}e.$UD=c;function b(ue){if(d(ue)||c(ue))return!1;const $e=ue;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$VD=b;function E(ue){if(d(ue))return!1;const $e=ue;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$WD=E;function v(ue){if(d(ue))return!1;const $e=ue;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$XD=v;var r;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class n{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$YD=new n;var o;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends F.$Rc{}e.$ZD=y;function d(ue){return ue instanceof y}e.$1D=d;function I(ue){const $e=ue;return C.URI.isUri($e?.preferredResource)}function S(ue){const $e=ue;return d($e?.primary)&&d($e?.secondary)}e.$2D=S;function u(ue){const $e=ue;return d($e?.modified)&&d($e?.original)}e.$3D=u;function m(ue,$e,ie,z,q){return Se(z,[(0,k.$xi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ue.openEditor($e,le)}}),(0,k.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$4D=m;function h(ue){return d(ue?.editor)}e.$5D=h;function A(ue){const $e=ue;return h(ue)&&$e?.group!==void 0}e.$6D=A;function W(ue){const $e=ue;return typeof $e?.groupId=="number"&&d($e.editor)}e.$7D=W;var V;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var B;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,ie){if(!$e)return;if(v($e))return e.$9D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(c($e)||b($e)||v($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return S($e)||b($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(v($e))return e.$9D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(c($e)||b($e)||v($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function te(ue,$e,ie,z){if(!ue.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$8D=te,e.$9D=new O;var Z;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(R.$Mh);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$If)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,F.$Pc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$bn.add(e.$MD.EditorFactory,new ye);async function Ee(ue,$e,ie){return!ue||!ue.length?[]:await Promise.all(ue.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?D.FileType.Directory:D.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===D.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const me={...z.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$0D=Ee;var Pe;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Y(ue){const $e=ue;if(!$e)return!1;const ie=$e;if(ie.modified)return Y(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$$D=Y;function ae(ue){return(0,P.$zi)(ue)}e.$_D=ae;function Se(ue,$e,ie){const z=(0,P.$Ai)(ue,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$aE=Se}),define(Re[192],Me([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jE=e.$iE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$hE=e.$gE=e.ViewContentGroups=e.$fE=e.$eE=e.ViewContainerLocation=e.Extensions=e.$dE=void 0,e.$dE=(0,k.$Zv)("default-view-icon",P.$Sj.window,(0,M.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$eE=[0,1,2];function $(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$fE=$;class f extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onDidRegister=this.c.event,this.f=this.B(new w.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(n,o,y){const d=this.get(n.id);if(d)return d;const I=n;return I.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,o,[]).push(I),y?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(n){for(const o of this.g.keys()){const y=this.g.get(o),d=y?.indexOf(n);if(d!==-1){y?.splice(d,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:n,viewContainerLocation:o});return}}}get(n){return this.all.filter(o=>o.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(o=>this.getViewContainerLocation(o)===n)}}l.$bn.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,n){const o=s.group??t.More,y=n.group??t.More;return o!==y?o.localeCompare(y):(s.order??5)-(n.order??5)}class c extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(n,o){this.registerViews2([{views:n,viewContainer:o}])}registerViews2(n){n.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(n)}deregisterViews(n,o){const y=this.s(n,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(n,o){for(const y of this.m.keys())if(y!==o){const d=this.s(n,y);d.length&&(this.r(d,o),this.g.fire({views:d,from:y,to:o}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const o of this.j){const y=(this.m.get(o)||[]).filter(d=>d.id===n)[0];if(y)return y}return null}getViewContainer(n){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===n)[0])return o;return null}registerViewWelcomeContent(n,o){return this.n.add(n,o),this.h.fire(n),(0,F.$Pc)(()=>{this.n.delete(n,o),this.h.fire(n)})}registerViewWelcomeContent2(n,o){const y=new Map;for(const[d,I]of o)this.n.add(n,I),y.set(d,(0,F.$Pc)(()=>{this.n.delete(n,I),this.h.fire(n)}));return this.h.fire(n),y}getViewWelcomeContent(n){const o=[];return this.n.forEach(n,y=>o.push(y)),o.sort(i)}r(n,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const d of n){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(1,null,d.id));y.push(d)}}s(n,o){const y=this.m.get(o);if(!y)return[];const d=[],I=[];for(const S of y)n.includes(S)?d.push(S):I.push(S);return d.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}l.$bn.add(a.ViewsRegistry,new c),e.$gE=(0,C.$Nh)("viewsService"),e.$hE=(0,C.$Nh)("viewDescriptorService");var b;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var E;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(n,o){this.c=!1,this.d=!1,(0,g.$5m)(this,n),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const d=await o(y);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$iE=v;class r extends Error{constructor(n){super((0,M.localize)(2,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$jE=r}),define(Re[193],Me([1,0,5,12,161]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new w.$Md,this.n=new w.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,D,g,P){const k={command:l};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const $={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};p($)}},P)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,D){return l.type!=="event"||D.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Tg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const D=l,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s(l,D){D.type=l,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((D,g)=>l.set(g,D)),await(0,M.$Tg)(500),l.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Vcb=F}),define(Re[194],Me([1,0,162,32,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$ZG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$YG=e.MemoryRangeType=e.$XG=e.State=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0,e.$VF="workbench.view.debug",e.$WF="workbench.debug.variablesView",e.$XF="workbench.debug.watchExpressionsView",e.$YF="workbench.debug.callStackView",e.$ZF="workbench.debug.loadedScriptsView",e.$1F="workbench.debug.breakPointsView",e.$2F="workbench.debug.disassemblyView",e.$3F="workbench.panel.repl",e.$4F="workbench.panel.repl.view",e.$5F=new M.$5i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$6F=new M.$5i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$7F=new M.$5i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$8F="debugUx",e.$9F=new M.$5i(e.$8F,"default",{type:"string",description:w.localize(3,null)}),e.$0F=new M.$5i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$$F=new M.$5i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$_F=new M.$5i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$aG=new M.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$bG=new M.$5i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$cG=new M.$5i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$dG=new M.$5i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$eG=new M.$5i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$fG=new M.$5i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$gG=new M.$5i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$hG=new M.$5i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$iG=new M.$5i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$jG=new M.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$kG=new M.$5i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$lG=new M.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$mG=new M.$5i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$nG=new M.$5i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$oG=new M.$5i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$pG=new M.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$qG=new M.$5i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$rG=new M.$5i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$sG=new M.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$tG=new M.$5i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$uG=new M.$5i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$vG=new M.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$wG=new M.$5i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$xG=new M.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$yG=new M.$5i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$zG=new M.$5i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$AG=new M.$5i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$BG=new M.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$CG=new M.$5i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$DG=new M.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$EG=new M.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$FG=new M.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$GG=new M.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$HG=new M.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$IG=new M.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$JG=new M.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$KG=new M.$5i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$LG=new M.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$MG=new M.$5i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$NG=new M.$5i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$OG=new M.$5i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$PG=new M.$5i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$QG=new M.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$RG=new M.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=a=>w.localize(51,null,a);e.$SG=F,e.$TG="editor.contrib.debug",e.$UG="editor.contrib.breakpoint",e.$VG="debug",e.$WG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var R;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(R||(e.State=R={}));function l(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$XG=l;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$YG="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$ZG=(0,C.$Nh)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Re[195],Me([1,0,15,2,19,24,13,44,21,18]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=void 0;const P=/{([^}]+)}/g;function k(S,u,m){return S.replace(P,function(h,A){return u&&A.length>0&&A[0]!=="_"?h:m&&m.hasOwnProperty(A)?m[A]:h})}e.$kF=k;function a(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$lF=a;function p(S){return S.configuration.request==="attach"&&!$(S)&&(!S.parentSession||p(S.parentSession))}e.$mF=p;function $(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,w.$1e)(u,"extensionhost")||(0,w.$1e)(u,"pwa-extensionhost")?S:S.parentSession?$(S.parentSession):void 0}e.$nF=$;function f(S){return S.type&&(S.label||S.program||S.runtime)}e.$oF=f;function t(S,u,m){let h,A=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=W.exec(S);){const U=V.index+1,B=U+V[0].length;if(U<=u&&B>=m){h=V[0],A=U;break}}if(h){const U=/\w+/g;let B=null;for(;(B=U.exec(h))&&!(B.index+1+A+B[0].length>=m););B&&(h=h.substring(0,U.lastIndex))}return h?{start:A,end:A+h.length-1}:{start:0,end:0}}e.$pF=t;async function i(S,u,m,h){if(S.evaluatableExpressionProvider.has(u)){const A=S.evaluatableExpressionProvider.ordered(u),W=(0,g.$Gb)(await Promise.all(A.map(async V=>{try{return await V.provideEvaluatableExpression(u,m,h??D.CancellationToken.None)}catch{return}})));if(W.length>0){let V=W[0].expression;const U=W[0].range;return V||(V=u.getLineContent(m.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const A=u.getLineContent(m.lineNumber),{start:W,end:V}=t(A,m.column,m.column),U=A.substring(W-1,V);return{matchingExpression:U,range:new l.$os(m.lineNumber,W,m.lineNumber,W+U.length)}}return null}e.$qF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(S){return!!(S&&S.match(c))}e.$rF=b;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(b(S.path))return M.URI.parse(S.path);if((0,C.$hc)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return S.path}function r(S,u){const m=u?E:v,h=(0,F.$2m)(S);return n(h,(A,W)=>{A&&W&&(W.path=m(W))}),h}e.$sF=r;function s(S,u){const m=u?E:v,h=(0,F.$2m)(S);return n(h,(A,W)=>{!A&&W&&(W.path=m(W))}),h}e.$tF=s;function n(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":m.body.sources.forEach(h=>u(!1,h));break;case"scopes":m.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":m.body?.instructions.forEach(A=>u(!1,A.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):y(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:y(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$uF=o;function y(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function d(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$vF=d;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$wF=I}),define(Re[75],Me([1,0,25,37,65,66,13,19,22,32]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=e.$kI=e.$jI=e.$iI=e.CellStatusbarAlignment=e.$hI=e.$gI=e.$fI=e.NotebookEditorPriority=e.$eI=e.$dI=e.$cI=e.$bI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aI=e.$_H=e.$$H=e.$0H=e.CellKind=e.$9H=e.$8H=e.$7H=void 0,e.$7H="workbench.editor.notebook",e.$8H="workbench.editor.notebookTextDiffEditor",e.$9H="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$0H=["application/json","application/javascript","text/html","image/svg+xml",F.$Lr.latex,F.$Lr.markdown,"image/png","image/jpeg",F.$Lr.text],e.$$H=[F.$Lr.latex,F.$Lr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Lr.text],e.$_H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aI="_notAvailable";var k;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var b;(function(N){N.scheme=R.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${te.join("")}]+`),ye=7;function Ee($e,ie){const z=ie.toString(ye),le=`${z.length<te.length?te[z.length-1]:"z"}${z}s${(0,w.$ue)(w.$ae.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:le})}N.generate=Ee;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Z,""),ye),q=(0,w.$te)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function Y($e,ie){return $e.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==R.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=Y;function ae($e){if($e.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||R.Schemas.file,fragment:null})}}N.parseCellOutputUri=ae;function Se($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=Se;function ue($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ue})(b||(e.CellUri=b={}));const E=N=>D.$j?N.replace(/\//g,"\\"):N;class v{constructor(te=[],Z=e.$0H){this.e=Z,this.d=[...new Set(te)].map(ye=>({pattern:ye,matches:M.$uj(E(ye))}))}sort(te){const Z=new Map(C.Iterable.map(te,Ee=>[Ee,E(Ee)]));let ye=[];for(const{matches:Ee}of this.d)for(const[Pe,Y]of Z)if(Ee(Y)){ye.push(Pe),Z.delete(Pe);break}return Z.size&&(ye=ye.concat([...Z.keys()].sort((Ee,Pe)=>this.e.indexOf(Ee)-this.e.indexOf(Pe)))),ye}prioritize(te,Z){const ye=this.f(te);if(ye===-1){this.d.unshift({pattern:te,matches:M.$uj(E(te))});return}const Ee=new Set(Z.map(Y=>this.f(Y,ye)));Ee.delete(-1);const Pe=Array.from(Ee).sort();this.d.splice(ye+1,0,...Pe.map(Y=>this.d[Y]));for(let Y=Pe.length-1;Y>=0;Y--)this.d.splice(Pe[Y],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,Z=this.d.length){const ye=E(te);for(let Ee=0;Ee<Z;Ee++)if(this.d[Ee].matches(ye))return Ee;return-1}}e.$bI=v;function r(N,te,Z,ye=(Ee,Pe)=>Ee===Pe){const Ee=[];function Pe(Se,ue,$e){if(ue===0&&$e.length===0)return;const ie=Ee[Ee.length-1];ie&&ie.start+ie.deleteCount===Se?(ie.deleteCount+=ue,ie.toInsert.push(...$e)):Ee.push({start:Se,deleteCount:ue,toInsert:$e})}let Y=0,ae=0;for(;;){if(Y===N.length){Pe(Y,0,te.slice(ae));break}if(ae===te.length){Pe(Y,N.length-Y,[]);break}const Se=N[Y],ue=te[ae];if(ye(Se,ue)){Y+=1,ae+=1;continue}Z(ue)?(Pe(Y,1,[]),Y+=1):(Pe(Y,0,[ue]),ae+=1)}return Ee}e.$cI=r,e.$dI=new g.$5i("notebookEditorCursorAtBoundary","none"),e.$eI=new g.$5i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function n(N){const te=N;return!!((typeof te.include=="string"||M.$vj(te.include))&&(typeof te.exclude=="string"||M.$vj(te.exclude)))}e.$fI=n;function o(N,te,Z){if(Array.isArray(N.viewType)&&N.viewType.indexOf(te)>=0||N.viewType===te)return!0;if(N.filenamePattern){const ye=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Ee=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$tj(ye,(0,l.$mc)(Z.fsPath).toLowerCase()))return!(Ee&&M.$tj(Ee,(0,l.$mc)(Z.fsPath).toLowerCase()))}return!1}e.$gI=o,e.$hI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var y;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class d{static{this.d="notebook/"}static create(te){return`${d.d}${te}`}static parse(te){if(te.startsWith(d.d))return te.substring(d.d.length)}}e.$iI=d;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$jI=I;const S=new TextDecoder;function u(N){const te=[];let Z=!1;for(const Y of N)(te.length===0||Z)&&(te.push(Y),Z=!0);let ye=A(te);const Ee=w.$ae.concat(te.map(Y=>w.$ae.wrap(Y))),Pe=O(Ee);return ye=ye||Pe.byteLength!==Ee.byteLength,{data:Pe,didCompression:ye}}e.$kI=u,e.$lI=`${String.fromCharCode(27)}[A`;const m=e.$lI.split("").map(N=>N.charCodeAt(0)),h=10;function A(N){let te=!1;return N.forEach((Z,ye)=>{if(ye===0||Z.length<e.$lI.length)return;const Ee=N[ye-1],Pe=Z.subarray(0,e.$lI.length);if(Pe[0]===m[0]&&Pe[1]===m[1]&&Pe[2]===m[2]){const Y=Ee.lastIndexOf(h);if(Y===-1)return;te=!0,N[ye-1]=Ee.subarray(0,Y),N[ye]=Z.subarray(e.$lI.length)}}),te}function W(N){let te=N;do N=te,te=N.replace(/[^\n]\x08/gm,"");while(te.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const te=N.match(/^(.*)\r+/m)[1];let Z=N.match(/\r+(.*)$/m)[1];Z=Z+te.slice(Z.length,te.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:w.$ae.fromString(V(W(S.decode(N.buffer))))}}),define(Re[7],Me([1,0,18,9,50,28,66,15,16,2,36,20,38,97,75]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$){"use strict";var f,t,i,c,b,E,v,r,s,n,o,y,d,I,S,u,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$ZL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.TestRunProfileKind=e.TestResultState=e.$GL=e.$FL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$EL=e.$DL=e.$CL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$BL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.ColorThemeKind=e.$vL=e.$uL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$tL=e.DebugConsoleMode=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$nL=e.$mL=e.FileChangeType=e.$lL=e.$kL=e.$jL=e.$iL=e.InlineCompletionTriggerKind=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.ConfigurationTarget=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$XK=e.ViewBadge=e.ProgressLocation=e.$WK=e.$VK=e.TaskScope=e.ShellQuoting=e.$UK=e.$TK=e.$SK=e.TaskPanelKind=e.TaskRevealKind=e.$RK=e.TerminalLocation=e.$QK=e.$PK=e.$OK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$NK=e.$MK=e.$LK=e.$KK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$JK=e.StatusBarAlignment=e.ViewColumn=e.$IK=e.$HK=e.$GK=e.$FK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$EK=e.$DK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.LanguageStatusSeverity=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.CodeActionTriggerKind=e.$rK=e.$qK=e.SymbolTag=e.SymbolKind=e.$pK=e.DocumentHighlightKind=e.$oK=e.$nK=e.$mK=e.$lK=e.DiagnosticSeverity=e.DiagnosticTag=e.$kK=e.$jK=e.FileEditType=e.$iK=e.$hK=e.$gK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(j){return Object.assign(j,{apply:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const ke=ne.length===1?[]:ne[1];return Reflect.construct(j,ke,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const[ke,...He]=ne;return Reflect.construct(j,He,ke.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=f=class{static from(...T){let ne=T;return new f(function(){if(ne){for(const ke of ne)ke&&typeof ke.dispose=="function"&&ke.dispose();ne=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_J=U,e.$_J=U=f=Ke([A],U);let B=t=class{static Min(...T){if(T.length===0)throw new TypeError;let ne=T[0];for(let ke=1;ke<T.length;ke++){const He=T[ke];He.isBefore(ne)&&(ne=He)}return ne}static Max(...T){if(T.length===0)throw new TypeError;let ne=T[0];for(let ke=1;ke<T.length;ke++){const He=T[ke];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:ne,character:ke}=T;return typeof ne=="number"&&typeof ke=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,ne){if(T<0)throw(0,M.$6)("line must be non-negative");if(ne<0)throw(0,M.$6)("character must be non-negative");this.c=T,this.e=ne}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,ne=0){if(T===null||ne===null)throw(0,M.$6)();let ke;return typeof T>"u"?ke=0:typeof T=="number"?ke=T:(ke=typeof T.lineDelta=="number"?T.lineDelta:0,ne=typeof T.characterDelta=="number"?T.characterDelta:0),ke===0&&ne===0?this:new t(this.line+ke,this.character+ne)}with(T,ne=this.character){if(T===null||ne===null)throw(0,M.$6)();let ke;return typeof T>"u"?ke=this.line:typeof T=="number"?ke=T:(ke=typeof T.line=="number"?T.line:this.line,ne=typeof T.character=="number"?T.character:this.character),ke===this.line&&ne===this.character?this:new t(ke,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$aK=B,e.$aK=B=t=Ke([A],B);let O=i=class{static isRange(T){return T instanceof i?!0:T?B.isPosition(T.start)&&B.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,ne,ke,He){let Ze,ot;if(typeof T=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new B(T,ne),ot=new B(ke,He)):B.isPosition(T)&&B.isPosition(ne)&&(Ze=B.of(T),ot=B.of(ne)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):B.isPosition(T)?!(B.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const ne=B.Max(T.start,this.c),ke=B.Min(T.end,this.e);if(!ne.isAfter(ke))return new i(ne,ke)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const ne=B.Min(T.start,this.c),ke=B.Max(T.end,this.end);return new i(ne,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,ne=this.end){if(T===null||ne===null)throw(0,M.$6)();let ke;return T?B.isPosition(T)?ke=T:(ke=T.start||this.start,ne=T.end||this.end):ke=this.start,ke.isEqual(this.c)&&ne.isEqual(this.end)?this:new i(ke,ne)}toJSON(){return[this.start,this.end]}};e.$bK=O,e.$bK=O=i=Ke([A],O);let N=c=class extends O{static isSelection(T){return T instanceof c?!0:T?O.isRange(T)&&B.isPosition(T.anchor)&&B.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,ne,ke,He){let Ze,ot;if(typeof T=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new B(T,ne),ot=new B(ke,He)):B.isPosition(T)&&B.isPosition(ne)&&(Ze=B.of(T),ot=B.of(ne)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cK=N,e.$cK=N=c=Ke([A],N);const te=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$6)("connectionToken")};class Z{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ne,ke){if(typeof T!="string"||T.length===0)throw(0,M.$6)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$6)("port");typeof ke<"u"&&te(ke),this.host=T,this.port=Math.round(ne),this.connectionToken=ke}}e.$dK=Z;class ye{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ne){this.makeConnection=T,this.connectionToken=ne,typeof ne<"u"&&te(ne)}}e.$eK=ye;class Ee extends Error{static NotAvailable(T,ne){return new Ee(T,p.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(T){return new Ee(T,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,ne=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(T),this._message=T,this._code=ne,this._detail=ke,Object.setPrototypeOf(this,Ee.prototype)}}e.$fK=Ee;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Y;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let ae=b=class{static isTextEdit(T){return T instanceof b?!0:T?O.isRange(T)&&typeof T.newText=="string":!1}static replace(T,ne){return new b(T,ne)}static insert(T,ne){return b.replace(new O(T,T),ne)}static delete(T){return b.replace(T,"")}static setEndOfLine(T){const ne=new b(new O(new B(0,0),new B(0,0)),"");return ne.newEol=T,ne}get range(){return this.c}set range(T){if(T&&!O.isRange(T))throw(0,M.$6)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,M.$6)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,M.$6)("newEol");this.f=T}constructor(T,ne){this.c=T,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gK=ae,e.$gK=ae=b=Ke([A],ae);let Se=E=class{static isNotebookCellEdit(T){return T instanceof E?!0:T?xt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,ne){return new E(T,ne)}static insertCells(T,ne){return new E(new xt(T,T),ne)}static deleteCells(T){return new E(T,[])}static updateCellMetadata(T,ne){const ke=new E(new xt(T,T),[]);return ke.newCellMetadata=ne,ke}static updateNotebookMetadata(T){const ne=new E(new xt(0,0),[]);return ne.newNotebookMetadata=T,ne}constructor(T,ne){this.range=T,this.newCells=ne}};e.$hK=Se,e.$hK=Se=E=Ke([A],Se);class ue{static isSnippetTextEdit(T){return T instanceof ue?!0:T?O.isRange(T.range)&&z.isSnippetString(T.snippet):!1}static replace(T,ne){return new ue(T,ne)}static insert(T,ne){return ue.replace(new O(T,T),ne)}constructor(T,ne){this.range=T,this.snippet=ne}}e.$iK=ue;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,ne,ke,He){this.c.push({_type:1,from:T,to:ne,options:ke,metadata:He})}createFile(T,ne,ke){this.c.push({_type:1,from:void 0,to:T,options:ne,metadata:ke})}deleteFile(T,ne,ke){this.c.push({_type:1,from:T,to:void 0,options:ne,metadata:ke})}e(T,ne,ke){this.c.push({_type:3,metadata:ke,uri:T,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(T,ne,ke,He){const Ze=ne.start,ot=ne.end;(Ze!==ot||ke.length>0)&&this.c.push({_type:5,uri:T,index:Ze,count:ot-Ze,cells:ke,metadata:He})}g(T,ne,ke,He){this.c.push({_type:3,metadata:He,uri:T,edit:{editType:3,index:ne,metadata:ke}})}replace(T,ne,ke,He){this.c.push({_type:2,uri:T,edit:new ae(ne,ke),metadata:He})}insert(T,ne,ke,He){this.replace(T,new O(ne,ne),ke,He)}delete(T,ne,ke){this.replace(T,ne,"",ke)}has(T){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===T.toString())}set(T,ne){if(ne)for(const ke of ne){if(!ke)continue;let He,Ze;Array.isArray(ke)?(He=ke[0],Ze=ke[1]):He=ke,Se.isNotebookCellEdit(He)?He.newCellMetadata?this.g(T,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(T,He.newNotebookMetadata,Ze):this.f(T,He.range,He.newCells,Ze):ue.isSnippetTextEdit(He)?this.c.push({_type:6,uri:T,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:T,edit:He,metadata:Ze})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===T.toString()&&(this.c[ke]=void 0);break}}(0,w.$Hb)(this.c)}}get(T){const ne=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===T.toString()&&ne.push(ke.edit);return ne}entries(){const T=new F.$zc;for(const ne of this.c)if(ne._type===2){let ke=T.get(ne.uri);ke||(ke=[ne.uri,[]],T.set(ne.uri,ke)),ke[1].push(ne.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jK=ie,e.$jK=ie=Ke([A],ie);let z=v=class{static isSnippetString(T){return T instanceof v?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=v.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,ne=this.e++){if(typeof T=="function"){const ke=new v;ke.e=this.e,T(ke),this.e=ke.e,T=ke.value}else T=v.c(T);return this.value+="${",this.value+=ne,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,ne=this.e++){const ke=T.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(T,ne){if(typeof ne=="function"){const ke=new v;ke.e=this.e,ne(ke),this.e=ke.e,ne=ke.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$kK=z,e.$kK=z=v=Ke([A],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=r=class{static isLocation(T){return T instanceof r?!0:T?O.isRange(T.range)&&g.URI.isUri(T.uri):!1}constructor(T,ne){if(this.uri=T,ne)if(O.isRange(ne))this.range=O.of(ne);else if(B.isPosition(ne))this.range=new O(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lK=we,e.$lK=we=r=Ke([A],we);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&O.isRange(T.location.range)&&g.URI.isUri(T.location.uri):!1}constructor(T,ne){this.location=T,this.message=ne}static isEqual(T,ne){return T===ne?!0:!T||!ne?!1:T.message===ne.message&&T.location.range.isEqual(ne.location.range)&&T.location.uri.toString()===ne.location.uri.toString()}};e.$mK=ve,e.$mK=ve=Ke([A],ve);let me=class{constructor(T,ne,ke=le.Error){if(!O.isRange(T))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=T,this.message=ne,this.severity=ke}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,ne){return T===ne?!0:!T||!ne?!1:T.message===ne.message&&T.severity===ne.severity&&T.code===ne.code&&T.severity===ne.severity&&T.source===ne.source&&T.range.isEqual(ne.range)&&(0,w.$tb)(T.tags,ne.tags)&&(0,w.$tb)(T.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$nK=me,e.$nK=me=Ke([A],me);let De=class{constructor(T,ne){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=ne}};e.$oK=De,e.$oK=De=Ke([A],De);var re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(T,ne=re.Text){this.range=T,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$pK=he,e.$pK=he=Ke([A],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let de=s=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,ne,ke,He,Ze){this.name=T,this.kind=ne,this.containerName=Ze,typeof ke=="string"&&(this.containerName=ke),He instanceof we?this.location=He:ke instanceof O&&(this.location=new we(He,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$qK=de,e.$qK=de=s=Ke([A],de);let Ie=n=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(n.validate)}constructor(T,ne,ke,He,Ze){this.name=T,this.detail=ne,this.kind=ke,this.range=He,this.selectionRange=Ze,this.children=[],n.validate(this)}};e.$rK=Ie,e.$rK=Ie=n=Ke([A],Ie);var L;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(L||(e.CodeActionTriggerKind=L={}));let K=class{constructor(T,ne){this.title=T,this.kind=ne}};e.$sK=K,e.$sK=K=Ke([A],K);let G=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$tK=G,e.$tK=G=o=Ke([A],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(T,ne){if(this.range=T,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$uK=Q,e.$uK=Q=Ke([A],Q);class H{constructor(T,ne,ke,He,Ze,ot){this.kind=T,this.name=ne,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$vK=H;class _{constructor(T,ne){this.fromRanges=ne,this.from=T}}e.$wK=_;class ce{constructor(T,ne){this.fromRanges=ne,this.to=T}}e.$xK=ce;var Fe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ue=class{constructor(T,ne){this.range=T,this.command=ne}get isResolved(){return!!this.command}};e.$yK=Ue,e.$yK=Ue=Ke([A],Ue);let Qe=y=class{#e;static isMarkdownString(T){return T instanceof y?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,ne=!1){this.#e=new C.$1j(T,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,ne){return this.#e.appendCodeblock(ne??"",T),this}};e.$zK=Qe,e.$zK=Qe=y=Ke([A],Qe);let Je=class{constructor(T,ne){this.label=T,this.documentation=ne}};e.$AK=Je,e.$AK=Je=Ke([A],Je);let xe=class{constructor(T,ne){this.label=T,this.documentation=ne,this.parameters=[]}};e.$BK=xe,e.$BK=xe=Ke([A],xe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$CK=Ye,e.$CK=Ye=Ke([A],Ye);var _e;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(T){this.value=T}};e.$DK=tt,e.$DK=tt=Ke([A],tt);let ze=class{constructor(T,ne,ke){this.position=T,this.label=ne,this.kind=ke}};e.$EK=ze,e.$EK=ze=Ke([A],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var x;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(x||(e.CompletionItemKind=x={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let pe=class{constructor(T,ne){this.label=T,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&x[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$FK=pe,e.$FK=pe=Ke([A],pe);let je=class{constructor(T=[],ne=!1){this.items=T,this.isIncomplete=ne}};e.$GK=je,e.$GK=je=Ke([A],je);let Oe=class{constructor(T,ne,ke){this.insertText=T,this.range=ne,this.command=ke}};e.$HK=Oe,e.$HK=Oe=Ke([A],Oe);let Xe=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$IK=Xe,e.$IK=Xe=Ke([A],Xe);var rt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var mt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function wt(j,T){return`${k.$2l.toKey(j)}.${T}`}e.$JK=wt;var Ct;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var Zt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Kt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ft;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(j){function T(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=T}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function T(ne){switch(ne){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=T}(Bt||(e.SyntaxTokenType=Bt={}));let Pt=class{constructor(T,ne){if(ne&&!g.URI.isUri(ne))throw(0,M.$6)("target");if(!O.isRange(T)||T.isEmpty)throw(0,M.$6)("range");this.range=T,this.target=ne}};e.$KK=Pt,e.$KK=Pt=Ke([A],Pt);let At=class{constructor(T,ne,ke,He){this.red=T,this.green=ne,this.blue=ke,this.alpha=He}};e.$LK=At,e.$LK=At=Ke([A],At);let Nt=class{constructor(T,ne){if(ne&&!(ne instanceof At))throw(0,M.$6)("color");if(!O.isRange(T)||T.isEmpty)throw(0,M.$6)("range");this.range=T,this.color=ne}};e.$MK=Nt,e.$MK=Nt=Ke([A],Nt);let Wt=class{constructor(T){if(!T||typeof T!="string")throw(0,M.$6)("label");this.label=T}};e.$NK=Wt,e.$NK=Wt=Ke([A],Wt);var Ht;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,ne,ke){if(this.startIndex=T,this.length=ne,this.tooltip=ke,typeof T!="number"||T<0)throw(0,M.$6)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$6)("tooltip")}}e.$OK=ut;class Gt{constructor(T){this.uri=T}}e.$PK=Gt;class It{constructor(T){this.terminalCommand=T}}e.$QK=It;var Et;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class dt{constructor(T){if(this.options=T,typeof T!="object")throw(0,M.$6)("options")}}e.$RK=dt;var kt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Tt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(T){switch(T){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(T,ne){if(this.label=ne,typeof T!="string"||typeof ne!="string")throw(0,M.$6)("name");this.c=T}get id(){return this.c}};e.$SK=yt,e.$SK=yt=d=Ke([A],yt);function Ve(j){let T="";for(let ne=0;ne<j.length;ne++)T+=j[ne].replace(/,/g,",,")+",";return T}let Ot=class{constructor(T,ne,ke){if(typeof T!="string")throw(0,M.$6)("process");this.e=[],this.c=T,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ke):this.f=ne)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,M.$6)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)T.push(ne);return Ve(T)}};e.$TK=Ot,e.$TK=Ot=Ke([A],Ot);let zt=class{constructor(T,ne,ke){if(this.f=[],Array.isArray(ne)){if(!T)throw(0,M.$6)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$6)("command");this.e=T,this.f=ne,this.g=ke}else{if(typeof T!="string")throw(0,M.$6)("commandLine");this.c=T,this.g=ne}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,M.$6)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$6)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)T.push(typeof ne=="string"?ne:ne.value);return Ve(T)}};e.$UK=zt,e.$UK=zt=Ke([A],zt);var Ce;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Ae;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ae||(e.TaskScope=Ae={}));class ge{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$dg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$VK=ge;let J=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,ne,ke,He,Ze,ot){this.j=!1,this.k=this.definition=T;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ke,this.execution=He,lt=Ze,this.j=!0):ne===Ae.Global||ne===Ae.Workspace?(this.target=ne,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,lt=ot):(this.target=ne,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof ge?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$dg)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,M.$6)("Kind can't be undefined or null");this.z(),this.k=T}get scope(){return this.l}set target(T){this.z(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,M.$6)("name");this.z(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.z(),this.n=T;const ne=this.k.type;(I.g===ne||I.e===ne||I.f===ne||I.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.z(),this.o=T,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.z(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,M.$6)("source must be a string of length > 0");this.z(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.z(),this.u=T}get detail(){return this.y}set detail(T){T===null&&(T=void 0),this.y=T}get presentationOptions(){return this.w}set presentationOptions(T){T==null&&(T=Object.create(null)),this.z(),this.w=T}get runOptions(){return this.x}set runOptions(T){T==null&&(T=Object.create(null)),this.z(),this.x=T}};e.$WK=J,e.$WK=J=I=Ke([A],J);var Le;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Le||(e.ProgressLocation=Le={}));var Be;(function(j){function T(ne){const ke=ne;return(0,D.$Bf)(ke.value)?ke.tooltip&&!(0,D.$xf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=T})(Be||(e.ViewBadge=Be={}));let Ge=S=class{static isTreeItem(T,ne){const ke=T;if(ke.checkboxState!==void 0){const He=(0,D.$Bf)(ke.checkboxState)?ke.checkboxState:(0,D.$zf)(ke.checkboxState)&&(0,D.$Bf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ze=!(0,D.$Bf)(ke.checkboxState)&&(0,D.$zf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ze!==void 0&&!(0,D.$xf)(Ze))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(T instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$xf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$xf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$xf)(ke.iconPath)&&!g.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$xf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$xf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$xf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$xf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!g.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$xf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<qe.None&&ke.collapsibleState>qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$xf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(T,ne=qe.None){this.collapsibleState=ne,g.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$XK=Ge,e.$XK=Ge=S=Ke([A],Ge);var qe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(qe||(e.TreeItemCollapsibleState=qe={}));var et;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$YK=gt,e.$YK=gt=Ke([A],gt);class ft extends gt{}e.$ZK=ft;class pt extends ft{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$1K=pt;class ht{constructor(T,ne,ke,He){this.name=T,this.uri=ne,this._itemId=ke,this.c=He}data(){return this.c()}}e.$2K=ht;let Rt=class{#e=new Map;constructor(T){for(const[ne,ke]of T??[]){const He=this.#e.get(this.#t(ne));He?He.push(ke):this.#e.set(this.#t(ne),[ke])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,ne){this.#e.set(this.#t(T),[ne])}forEach(T,ne){for(const[ke,He]of this.#e)for(const Ze of He)T.call(ne,Ze,ke,this)}*[Symbol.iterator](){for(const[T,ne]of this.#e)for(const ke of ne)yield[T,ke]}#t(T){return T.toLowerCase()}};e.$3K=Rt,e.$3K=Rt=Ke([A],Rt);let Jt=class{constructor(T){this.insertText=T}};e.$4K=Jt,e.$4K=Jt=Ke([A],Jt);let Ei=class{constructor(T,ne){this.label=ne,this.insertText=T}};e.$5K=Ei,e.$5K=Ei=Ke([A],Ei);let qt=class{constructor(T,ne){this.id=T,this.color=ne}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$6K=qt,e.$6K=qt=Ke([A],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(T){this.id=T}};e.$7K=mi,e.$7K=mi=Ke([A],mi);var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(St||(e.ConfigurationTarget=St={}));let Di=class{get base(){return this.c}set base(T){this.c=T,this.e=g.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,ne){if(typeof T!="string"&&(!T||!g.URI.isUri(T)&&!g.URI.isUri(T.uri)))throw(0,M.$6)("base");if(typeof ne!="string")throw(0,M.$6)("pattern");typeof T=="string"?this.baseUri=g.URI.file(T):g.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$8K=Di,e.$8K=Di=Ke([A],Di);const Vi=new WeakMap;function Dt(j,T){Vi.set(j,T)}e.$9K=Dt;let ii=class{constructor(T,ne,ke,He){this.enabled=typeof T=="boolean"?T:!0,typeof ne=="string"&&(this.condition=ne),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$dg)()),this.c}};e.$0K=ii,e.$0K=ii=Ke([A],ii);let $i=class extends ii{constructor(T,ne,ke,He,Ze){if(super(ne,ke,He,Ze),T===null)throw(0,M.$6)("location");this.location=T}};e.$$K=$i,e.$$K=$i=Ke([A],$i);let oi=class extends ii{constructor(T,ne,ke,He,Ze){super(ne,ke,He,Ze),this.functionName=T}};e.$_K=oi,e.$_K=oi=Ke([A],oi);let ki=class extends ii{constructor(T,ne,ke,He,Ze,ot,lt){if(super(He,Ze,ot,lt),!ne)throw(0,M.$6)("dataId");this.label=T,this.dataId=ne,this.canPersist=ke}};e.$aL=ki,e.$aL=ki=Ke([A],ki);let Si=class{constructor(T,ne,ke){this.command=T,this.args=ne||[],this.options=ke}};e.$bL=Si,e.$bL=Si=Ke([A],Si);let Mt=class{constructor(T,ne){this.port=T,this.host=ne}};e.$cL=Mt,e.$cL=Mt=Ke([A],Mt);let pi=class{constructor(T){this.path=T}};e.$dL=pi,e.$dL=pi=Ke([A],pi);let Ii=class{constructor(T){this.implementation=T}};e.$eL=Ii,e.$eL=Ii=Ke([A],Ii);let ai=class{constructor(T,ne,ke){this.session=T,this.threadId=ne,this.frameId=ke}};e.$fL=ai,e.$fL=ai=Ke([A],ai);let ci=class{constructor(T,ne){this.session=T,this.threadId=ne}};e.$gL=ci,e.$gL=ci=Ke([A],ci);let ct=class{constructor(T,ne){this.range=T,this.expression=ne}};e.$hL=ct,e.$hL=ct=Ke([A],ct);var qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Yt=class{constructor(T,ne){this.range=T,this.text=ne}};e.$iL=Yt,e.$iL=Yt=Ke([A],Yt);let ni=class{constructor(T,ne,ke=!0){this.range=T,this.variableName=ne,this.caseSensitiveLookup=ke}};e.$jL=ni,e.$jL=ni=Ke([A],ni);let vi=class{constructor(T,ne){this.range=T,this.expression=ne}};e.$kL=vi,e.$kL=vi=Ke([A],vi);let Ci=class{constructor(T,ne){this.frameId=T,this.stoppedLocation=ne}};e.$lL=Ci,e.$lL=Ci=Ke([A],Ci);var Ki;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=u=class extends Error{static FileExists(T){return new u(T,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(T){return new u(T,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(T){return new u(T,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(T){return new u(T,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(T){return new u(T,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(T){return new u(T,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(T,ne=a.FileSystemProviderErrorCode.Unknown,ke){super(g.URI.isUri(T)?T.toString(!0):T),this.code=ke?.name??"Unknown",(0,a.$kk)(this,ne),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$mL=Pi,e.$mL=Pi=u=Ke([A],Pi);let bi=class{constructor(T,ne,ke){this.start=T,this.end=ne,this.kind=ke}};e.$nL=bi,e.$nL=bi=Ke([A],bi);var Hi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Ji;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,ne=[]){this.tokenTypes=T,this.tokenModifiers=ne}}e.$oL=Ri;function cn(j){return typeof j>"u"||(0,D.$yf)(j)}class Mi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let ne=0,ke=T.tokenTypes.length;ne<ke;ne++)this.j.set(T.tokenTypes[ne],ne);for(let ne=0,ke=T.tokenModifiers.length;ne<ke;ne++)this.k.set(T.tokenModifiers[ne],ne)}}push(T,ne,ke,He,Ze){if(typeof T=="number"&&typeof ne=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(T,ne,ke,He,Ze);if(O.isRange(T)&&typeof ne=="string"&&cn(ke))return this.m(T,ne,ke);throw(0,M.$6)()}m(T,ne,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=T.start.line,Ze=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(ne);let Ut=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Ze,ot,lt,Ut)}n(T,ne,ke,He,Ze){if(this.f&&(T<this.c||T===this.c&&ne<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let si=this.g[5*ti],Bi=this.g[5*ti+1];si===0?(si=Xt,Bi+=ei):si+=Xt,this.g[5*ti]=si,this.g[5*ti+1]=Bi,Xt=si,ei=Bi}}let ot=T,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=T,this.e=ne}static o(T){const ne=[],ke=T.length/5|0;for(let lt=0;lt<ke;lt++)ne[lt]=lt;ne.sort((lt,Ut)=>{const Xt=T[5*lt],ei=T[5*Ut];if(Xt===ei){const ti=T[5*lt+1],si=T[5*Ut+1];return ti-si}return Xt-ei});const He=new Uint32Array(T.length);let Ze=0,ot=0;for(let lt=0;lt<ke;lt++){const Ut=5*ne[lt],Xt=T[Ut+0],ei=T[Ut+1],ti=T[Ut+2],si=T[Ut+3],Bi=T[Ut+4],wn=Xt-Ze,Mn=wn===0?ei-ot:ei,Wi=5*lt;He[Wi+0]=wn,He[Wi+1]=Mn,He[Wi+2]=ti,He[Wi+3]=si,He[Wi+4]=Bi,Ze=Xt,ot=ei}return He}build(T){return this.f?new ri(new Uint32Array(this.g),T):new ri(Mi.o(this.g),T)}}e.$pL=Mi;class ri{constructor(T,ne){this.resultId=ne,this.data=T}}e.$qL=ri;class un{constructor(T,ne,ke){this.start=T,this.deleteCount=ne,this.data=ke}}e.$rL=un;class ln{constructor(T,ne){this.resultId=ne,this.edits=T}}e.$sL=ln;var Gi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$tL=fi,e.$tL=fi=Ke([A],fi);var Qi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Xi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var gi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Zi{static validate(T){if(typeof T.badge=="string"){let ne=(0,l.$$e)(T.badge,0);if(ne<T.badge.length&&(ne+=(0,l.$$e)(T.badge,ne)),T.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!qt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,ne,ke){this.badge=T,this.tooltip=ne,this.color=ke}}e.$uL=Zi;let Li=class{constructor(T){this.kind=T}};e.$vL=Li,e.$vL=Li=Ke([A],Li);var Yi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class xt{static isNotebookRange(T){return T instanceof xt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,ne){if(T<0)throw(0,M.$6)("start must be positive");if(ne<0)throw(0,M.$6)("end must be positive");T<=ne?(this.c=T,this.e=ne):(this.c=ne,this.e=T)}with(T){let ne=this.c,ke=this.e;return T.start!==void 0&&(ne=T.start),T.end!==void 0&&(ke=T.end),ne===this.c&&ke===this.e?this:new xt(ne,ke)}}e.$wL=xt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(ne=>yi.isNotebookCellData(ne))}static isNotebookCellData(T){return!0}constructor(T,ne,ke,He,Ze,ot,lt){this.kind=T,this.value=ne,this.languageId=ke,this.mime=He,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$xL=yi;class hn{constructor(T){this.cells=T}}e.$yL=hn;class Qt{static isNotebookCellOutputItem(T){return T instanceof Qt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const ne={name:T.name,message:T.message,stack:T.stack};return Qt.json(ne,"application/vnd.code.notebook.error")}static stdout(T){return Qt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Qt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,ne="application/octet-stream"){return new Qt(T,ne)}static#e=new TextEncoder;static text(T,ne=R.$Lr.text){const ke=Qt.#e.encode(String(T));return new Qt(ke,ne)}static json(T,ne="text/x-json"){const ke=JSON.stringify(T,void 0,"	");return Qt.text(ke,ne)}constructor(T,ne){this.data=T,this.mime=ne;const ke=(0,R.$Pr)(ne,!0);if(!ke)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$zL=Qt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,ne=!1){const ke=new Set,He=new Set;for(let Ze=0;Ze<T.length;Ze++){const ot=T[Ze],lt=(0,R.$Pr)(ot.mime);if(!ke.has(lt)||(0,$.$jI)(lt)){ke.add(lt);continue}He.add(Ze),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?T:T.filter((Ze,ot)=>!He.has(ot))}constructor(T,ne,ke){this.items=li.ensureUniqueMimeTypes(T,!0),typeof ne=="string"?(this.id=ne,this.metadata=ke):(this.id=(0,P.$dg)(),this.metadata=ne??ke)}}e.$AL=li;var Ti;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ne;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ne||(e.NotebookCellExecutionState=Ne={}));var _t;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Fi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(T,ne){this.text=T,this.alignment=ne}}e.$BL=$t;var xi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(T,ne=[]){this.uri=T,this.provides=(0,w.$2b)(ne)}}e.$CL=en;class dn{constructor(T){this.label=T}}e.$DL=dn;let hi=class{constructor(T,ne){this.label=T,this.timestamp=ne}};e.$EL=hi,e.$EL=hi=Ke([A],hi);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,ne){this.ranges=T,this.wordPattern=ne}}e.$FL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$GL=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(T=void 0,ne=void 0,ke=void 0,He=!1){this.include=T,this.exclude=ne,this.profile=ke,this.continuous=He}};e.$HL=Ni,e.$HL=Ni=Ke([A],Ni);let Oi=m=class{static diff(T,ne,ke){const He=new m(T);return He.expectedOutput=ne,He.actualOutput=ke,He}constructor(T){this.message=T}};e.$IL=Oi,e.$IL=Oi=m=Ke([A],Oi);let zi=class{constructor(T){this.id=T}};e.$JL=zi,e.$JL=zi=Ke([A],zi);let di=class{constructor(T,ne){this.covered=T,this.total=ne}};e.$KL=di,e.$KL=di=Ke([A],di);let Ui=h=class{static fromDetails(T,ne){const ke=new di(0,0),He=new di(0,0),Ze=new di(0,0);for(const lt of ne)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const ot=new h(T,ke,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=ne,ot}constructor(T,ne,ke,He){this.uri=T,this.statementCoverage=ne,this.branchCoverage=ke,this.functionCoverage=He}};e.$LL=Ui,e.$LL=Ui=h=Ke([A],Ui);let ji=class{constructor(T,ne,ke=[]){this.executionCount=T,this.location=ne,this.branches=ke}};e.$ML=ji,e.$ML=ji=Ke([A],ji);let ee=class{constructor(T,ne){this.executionCount=T,this.location=ne}};e.$NL=ee,e.$NL=ee=Ke([A],ee);let fe=class{constructor(T,ne){this.executionCount=T,this.location=ne}};e.$OL=fe,e.$OL=fe=Ke([A],fe);var Te;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var nt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var bt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class Lt{constructor(T,ne,ke,He,Ze,ot){this.kind=T,this.name=ne,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$PL=Lt;class yn{constructor(T){this.uri=T}}e.$QL=yn;class En{constructor(T,ne){this.original=T,this.modified=ne}}e.$RL=En;class Dn{constructor(T,ne,ke,He){this.base=T,this.input1=ne,this.input2=ke,this.result=He}}e.$SL=Dn;class kn{constructor(T,ne){this.uri=T,this.viewType=ne}}e.$TL=kn;class Sn{constructor(T){this.viewType=T}}e.$UL=Sn;class In{constructor(T,ne){this.uri=T,this.notebookType=ne}}e.$VL=In;class Cn{constructor(T,ne,ke){this.original=T,this.modified=ne,this.notebookType=ke}}e.$WL=Cn;class Pn{constructor(){}}e.$XL=Pn;class An{constructor(T,ne){this.uri=T,this.inputBoxUri=ne}}e.$YL=An;var gn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(T,ne){this.role=T,this.content=ne}}e.$ZL=Rn;var bn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Re[100],Me([1,0,51,13,15,277,136,7,18]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=void 0;const g=new Map;function P($,f){f?g.set($,f):g.delete($)}e.$aM=P;function k($){return g.get($)}class a extends F.$Qu{constructor(f,t,i,c,b,E,v,r){super(t,i,c,b),this.c=f,this.m=E,this.q=v,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===M.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,w.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,w.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,b=t.end.line,E=[];E.push(this.f[c].substring(t.start.character));for(let v=c+1;v<b;v++)E.push(this.f[v]);return E.push(this.f[b].substring(0,t.end.character)),E.join(i)}t(f){let t;if(f instanceof l.$aK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new l.$aK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof l.$bK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new l.$bK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof l.$aK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const b=this.f[t].length;i<0?(i=0,c=!0):i>b&&(i=b,c=!0)}return c?new l.$aK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=k(this.m);else if((0,C.$Ne)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,R.$4r)(i.character+1,(0,R.$2r)(t),this.f[i.line],0);if(c)return new l.$bK(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$bM=a;class p{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$bK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$bK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$cM=p}),define(Re[196],Me([1,0,7,17,5]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;let F=class{constructor(l){this.a=new w.$vL(w.ColorThemeKind.Dark),this.b=new C.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(l){let D;switch(l){case"light":D=w.ColorThemeKind.Light;break;case"hcDark":D=w.ColorThemeKind.HighContrast;break;case"hcLight":D=w.ColorThemeKind.HighContrastLight;break;default:D=w.ColorThemeKind.Dark}this.a=new w.$vL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hdc=F,e.$hdc=F=Ke([We(0,M.$$L)],F)}),define(Re[197],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$nI=(0,w.$Nh)("INotebookExecutionService")}),define(Re[45],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(R,l,D=R.parent){if(R._isRoot)return new C([l]);const g=[R.id];for(let P=D;P&&P.id!==l;P=P.parent)g.push(P.id);return g.push(l),new C(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const l=R.indexOf("\0");return l===-1?R:R.slice(0,l)}static fromString(R){return new C(R.split("\0"))}static join(R,l){return new C([...R.path,l])}static joinToString(R,l){return R.toString()+"\0"+l}static parentId(R){const l=R.lastIndexOf("\0");return l===-1?void 0:R.slice(0,l)}static localId(R){const l=R.lastIndexOf("\0");return l===-1?R:R.slice(l+1)}static isChild(R,l){return l.startsWith(R)&&l[R.length]==="\0"}static compare(R,l){return R===l?0:C.isChild(R,l)?2:C.isChild(l,R)?3:1}constructor(R,l=R.length){if(this.path=R,this.d=l,R.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let l=0;l<R.d&&l<this.d;l++)if(R.path[l]!==this.path[l])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$3I=C}),define(Re[56],Me([1,0,2,44,45]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$9I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$8I=e.$7I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$6I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$5I=e.$4I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var R;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$4I=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$5I=D;var g;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$os.lift(u.range),uri:w.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var P;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(S,u)=>`${u?"s":"e"}${S}`;e.$6I=a;var p;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(S){S.serialize=u=>u.type===0?k.serialize(u):p.serialize(u),S.deserialize=u=>u.type===0?k.deserialize(u):p.deserialize(u)})($||(e.ITestMessage=$={}));var f;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(S,u)=>S+t+u;e.$7I=i;const c=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$8I=c;var b;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?M.$os.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b||(e.ITestItem=b={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$3I.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var r;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$os.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(r||(e.ITestItemUpdate=r={}));const s=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$9I=s;var n;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var d;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const m=this.p();for(const h of u)switch(h.op){case 0:this.k(v.deserialize(h.item),m);break;case 1:this.l(r.deserialize(h.item),m);break;case 3:this.m(h.itemId,m);break;case 5:this.o(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.d.set(h.tag.id,h.tag);break;case 7:this.d.delete(h.id);break}m.complete?.()}k(u,m){const h=C.$3I.parentId(u.item.extId)?.toString();let A;if(!h)A=this.q(u),this.g.add(A),this.f.set(u.item.extId,A);else if(this.f.has(h)){const W=this.f.get(h);W.children.add(u.item.extId),A=this.q(u,W),this.f.set(u.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(A),u.expand===2&&this.h++,A}l(u,m){const h=this.f.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$9I)(h,u),m.update?.(h),h}m(u,m){const h=this.f.get(u);if(!h)return;const A=C.$3I.parentId(h.item.extId)?.toString();A?this.f.get(A).children.delete(h.item.extId):this.g.delete(h);const W=[[u]];for(;W.length;)for(const V of W.pop()){const U=this.f.get(V);U&&(W.push(U.children),this.f.delete(V),m.remove?.(U,U!==h),U.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$0I=I}),define(Re[76],Me([1,0,12,5,6,51,56,45]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(c,b)=>c===b,k=Object.entries({range:(c,b)=>c===b?!0:!c||!b?!1:c.equalsRange(b),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,b)=>!(c.length!==b.length||c.some(E=>!b.includes(E)))}),a=(c,b)=>{let E;for(const[v,r]of k)r(c[v],b[v])||(E?E[v]=b[v]:E={[v]:b[v]});return E};class p extends C.$Rc{get root(){return this.s.root}constructor(b){super(),this.s=b,this.f=this.B(new w.$5g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const b=this.m;return this.m=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,R.$9I)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,R.$9I)(E.item,b.item);return}}break}}this.m.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const v=this.tree.get(b);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const r=this.L(v);return r.isOpen()?this.J(v,E-1):r.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const b of this.tree.values())this.s.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(b,E){switch(E.op){case 3:this.N(l.$3I.joinToString(b.fullId,E.id));break;case 0:this.y(E.item,b);break;case 5:for(const v of E.ops)this.u(b,v);break;case 1:this.z(E.new,E.old,b.fullId.toString());break;case 2:this.I(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.w(b.actual.uri);break;default:(0,F.$3c)(E)}}w(b){b&&this.pushDiff({op:2,uri:b,docv:this.s.getDocumentVersion(b)})}y(b,E){const v=l.$3I.fromExtHostTestItem(b,this.root.id,E?.actual),r=this.s.getApiFor(b);r.parent&&r.parent!==E?.actual&&this.s.getChildren(r.parent).delete(b.id);let s=this.tree.get(v.toString());if(!s){s={fullId:v,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(b,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(b)}}),this.H(b,s,E);return}if(s.actual===b){this.G(b,s,E);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.N(v.toString()),this.y(b,E);const n=this.s.getChildren(s.actual),o=s.actual,y=a(this.s.toITestItem(o),this.s.toITestItem(b));this.s.getApiFor(o).listener=void 0,s.actual=b,s.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(b.tags,o.tags,v.toString()),delete y.tags),this.u(s,{op:4,update:y})),this.H(b,s,E);for(const[d,I]of n)this.s.getChildren(b).get(I.id)||this.N(l.$3I.joinToString(v,I.id));this.w(s.actual.uri)}z(b,E,v){const r=new Set(E.map(s=>s.id));for(const s of b)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(s=>(0,R.$7I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$7I)(this.s.controllerId,b.id)}}))}D(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,R.$7I)(this.s.controllerId,b)}))}F(b,E){this.s.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}G(b,E,v){this.F(b,v);const r=this.s.getApiFor(b);r.parent=v?.actual,r.listener=s=>this.u(E,s),this.I(E)}H(b,E,v){this.G(b,E,v);for(const[r,s]of this.s.getChildren(b))this.y(s,E)}I(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.L(b))}J(b,E){if(E<0)return;const v=[];for(const[r,s]of this.s.getChildren(b.actual)){const n=this.expand(l.$3I.joinToString(b.fullId,s.id),E);(0,w.$Fg)(n)&&v.push(n)}if(v.length)return Promise.all(v).then(()=>{})}L(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new w.$Rg;return s.open(),s}b.expand=2,this.M(b);const E=b.resolveBarrier=new w.$Rg,v=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(s){v(s)}return(0,w.$Fg)(r)?r.catch(v).then(()=>{E.open(),this.I(b)}):(E.open(),this.I(b)),b.resolveBarrier}M(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}N(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[E];for(;v.length;){const r=v.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,n]of this.s.getChildren(r.actual))v.push(this.tree.get(l.$3I.joinToString(r.fullId,n.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.$1L=p;class $ extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.$2L=$;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$3L=f;class t extends Error{constructor(b,E,v){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$4L=t;const i=(c,b,E)=>{let v=new Map;return{get size(){return v.size},forEach(r,s){for(const n of v.values())r.call(s,n,this)},[Symbol.iterator](){return v.entries()},replace(r){const s=new Map,n=new Set(v.keys()),o={op:5,ops:[]};for(const y of r){if(!(y instanceof E))throw new f(y.id);const d=b(y).controllerId;if(d!==c.controllerId)throw new t(y.id,d,c.controllerId);if(s.has(y.id))throw new $(y.id);s.set(y.id,y),n.delete(y.id),o.ops.push({op:0,item:y})}for(const y of n.keys())o.ops.push({op:3,id:y});c.listener?.(o),v=s},add(r){if(!(r instanceof E))throw new f(r.id);v.set(r.id,r),c.listener?.({op:0,item:r})},delete(r){v.delete(r)&&c.listener?.({op:3,id:r})},get(r){return v.get(r)},toJSON(){return Array.from(v.values())}}};e.$5L=i}),define(Re[101],Me([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=void 0;const M=new WeakMap,C=(R,l)=>{const D={controllerId:l};return M.set(R,D),D};e.$6L=C;const F=R=>{const l=M.get(R);if(!l)throw new w.$3L(R?.id||"<unknown>");return l};e.$7L=F}),define(Re[77],Me([1,0,13,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function C(l,D){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(D&&D.authority&&D.isRemote&&l.scheme===w.Schemas.file&&(l=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:D.authority,path:l.path})),M.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${F(l.authority)}.${e.$Wob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$Yob=C;function F(l){return l.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R(l){return l.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$Zob=R}),define(Re[198],Me([1,0,5,6,77]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class F{constructor(l,D,g){this.d=l,this.e=D,this.f=g,this.a=0,this.b=new M.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const P=D.getVisibleTextEditors();for(const k of this.c.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,D,g,P,k){let a;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===l){a=b;break}if(!a)throw new Error("not a visible editor");const p=this,$=this.a++,f=new w.$Md,t=new w.$Md,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,C.$Yob)(b,p.f)}get cspSource(){return C.$Xob}set options(b){this.b=b,p.d.$setOptions($,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml($,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return p.d.$postMessage($,b)}},c=new class{constructor(){this.editor=l,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset($,a.id,a.value.document.uri,D+1,g,P||{},k.identifier,k.extensionLocation),this.c.set($,{editor:l,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(l){const D=this.c.get(l);D&&D.inset.dispose()}$onDidReceiveMessage(l,D){this.c.get(l)?.onDidReceiveMessage.fire(D)}}e.$Rcc=F}),define(Re[199],Me([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.VariableKind=e.$WM=void 0,e.$WM=(0,w.$Nh)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(R,l){super(l),this.variable=R}}e.$XM=C}),define(Re[200],Me([1,0,19,73,16,24,22,90,165,199,15]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,f,t){this.h=new Map,this.a=p,this.b=$,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(R.$j){const $=Object.create(null);return Object.keys(p).forEach(f=>{$[f.toLowerCase()]=p[f]}),$}return p}resolveWithEnvironment(p,$,f){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,f)}async resolveAsync(p,$){const f={env:await this.c,userHome:await this.g};return this.l(f,p?p.uri:void 0,$)}async j(p,$,f,t){const i=F.$2m($);R.$j&&i.windows?Object.keys(i.windows).forEach(b=>i[b]=i.windows[b]):R.$k&&i.osx?Object.keys(i.osx).forEach(b=>i[b]=i.osx[b]):R.$l&&i.linux&&Object.keys(i.linux).forEach(b=>i[b]=i.linux[b]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,f,t)}async resolveAnyAsync(p,$,f){return this.j(p,$,f)}async resolveAnyMap(p,$,f){const t=new Map;return{newConfig:await this.j(p,$,f,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,f,t,i){if(C.$xf(f))return this.m(p,$,f,t,i);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(p,$,c,t,i)));if(C.$zf(f)){const c=Object.create(null),b=await Promise.all(Object.keys(f).map(async E=>[await this.m(p,$,E,t,i),await this.l(p,$,f[E],t,i)]));for(const[E,v]of b)c[E]=v;return c}return f}m(p,$,f,t,i){return(0,P.$Se)(f,k.VARIABLE_REGEXP,async(c,b)=>{if(b.includes(k.VARIABLE_LHS))return c;let E=await this.o(p,c,b,$,t);return i?.set(b,E),E!==c&&C.$xf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(p,$,E,t,i)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,f,t,i){let c;const b=f.split(":");b.length>1&&(f=b[0],c=b[1]);const E=s=>{const n=this.a.getFilePath();if(n)return(0,l.$mv)(n);throw new g.$XM(s,(0,D.localize)(0,null,$))},v=s=>{const n=E(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$mv)(o)}throw new g.$XM(s,(0,D.localize)(1,null,$,w.$mc(n)))},r=s=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new g.$XM(s,(0,D.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$XM(s,(0,D.localize)(3,null,$)):new g.$XM(s,(0,D.localize)(4,null,$))};switch(f){case"env":if(c){if(p.env){const s=p.env[R.$j?c.toLowerCase():c];if(C.$xf(s))return s}return""}throw new g.$XM(g.VariableKind.Env,(0,D.localize)(5,null,$));case"config":if(c){const s=this.a.getConfigurationValue(t,c);if(C.$Gf(s))throw new g.$XM(g.VariableKind.Config,(0,D.localize)(6,null,$,c));if(C.$zf(s))throw new g.$XM(g.VariableKind.Config,(0,D.localize)(7,null,$,c));return s}throw new g.$XM(g.VariableKind.Config,(0,D.localize)(8,null,$));case"command":return this.p(g.VariableKind.Command,$,c,i,"command");case"input":return this.p(g.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const s=await this.a.getExtension(c);if(!s)throw new g.$XM(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,$,c));return this.n(s.extensionLocation)}throw new g.$XM(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,$));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,l.$mv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$mv)(this.n(r(g.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$mv)(w.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new g.$XM(g.VariableKind.UserHome,(0,D.localize)(11,null,$))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$XM(g.VariableKind.LineNumber,(0,D.localize)(12,null,$))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$XM(g.VariableKind.SelectedText,(0,D.localize)(13,null,$))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return v(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.$kc(this.n(r(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.$lc(E(g.VariableKind.RelativeFileDirname));if(t||c){const n=w.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return n.length===0?".":n}return s}case"fileDirname":return w.$lc(E(g.VariableKind.FileDirname));case"fileExtname":return w.$nc(E(g.VariableKind.FileExtname));case"fileBasename":return w.$mc(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.$mc(E(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.$nc(s).length)}case"fileDirnameBasename":return w.$mc(w.$lc(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||$}case"execInstallFolder":{const s=this.a.getAppRoot();return s||$}case"pathSeparator":return w.sep;default:try{const s=c?`${f}:${c}`:f;return this.p(g.VariableKind.Unknown,$,s,i,void 0)}catch{return $}}}}p(p,$,f,t,i){if(f&&t){const c=i===void 0?t[f]:t[i+":"+f];if(typeof c=="string")return c;throw new g.$XM(p,(0,D.localize)(14,null,$))}return $}}e.$_M=k}),define(Re[102],Me([1,0,4,99]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.OpenEditorContext=e.GroupsOrder=e.$_B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$B=void 0,e.$$B=(0,w.$Nh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var D;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g($){const f=$;return(0,M.$1D)(f?.editor)&&(0,M.$1D)(f?.replacement)}e.$_B=g;var P;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a($){const f=$;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$aC=a;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$bC=p}),define(Re[201],Me([1,0,4,102]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=void 0,e.$cC=(0,w.$Nh)("editorService"),e.$dC=-1,e.$eC=-2;function C(F){const R=F;return typeof F=="number"||(0,M.$aC)(R)}e.$fC=C}),define(Re[8],Me([1,0,18,25,122,202,50,28,116,67,66,24,16,2,44,78,94,101,99,75,45,56,201,7]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$0L=e.$9L=e.MarkdownString=e.$8L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Ae(J){const{selectionStartLineNumber:Le,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:qe}=J,et=new s.$aK(Le-1,Be-1),gt=new s.$aK(Ge-1,qe-1);return new s.$cK(et,gt)}Ce.to=Ae;function ge(J){const{anchor:Le,active:Be}=J;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ge})(n||(e.Selection=n={}));var o;(function(Ce){function Ae(J){if(!J)return;const{start:Le,end:Be}=J;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Ae;function ge(J){if(!J)return;const{startLineNumber:Le,startColumn:Be,endLineNumber:Ge,endColumn:qe}=J;return new s.$bK(Le-1,Be-1,Ge-1,qe-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Ae(ge){switch(ge){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Ae})(y||(e.TokenType=y={}));var d;(function(Ce){function Ae(J){return new s.$aK(J.lineNumber-1,J.column-1)}Ce.to=Ae;function ge(J){return{lineNumber:J.line+1,column:J.character+1}}Ce.from=ge})(d||(e.Position=d={}));var I;(function(Ce){function Ae(Le,Be,Ge){return(0,w.$Gb)((0,w.$2b)(Le).map(qe=>ge(qe,Be,Ge)))}Ce.from=Ae;function ge(Le,Be,Ge){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ge?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:J(Le.scheme,Be),pattern:st.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ge?.isBuiltin}}function J(Le,Be){return Be&&typeof Le=="string"?Be.transformOutgoingScheme(Le):Le}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Ae(J){switch(J){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Ae;function ge(J){switch(J){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Ae(J){let Le;return J.code&&((0,a.$xf)(J.code)||(0,a.$Bf)(J.code)?Le=String(J.code):Le={value:String(J.code.value),target:J.code.target}),{...o.from(J.range),message:J.message,source:J.source,code:Le,severity:h.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(m.from),tags:Array.isArray(J.tags)?(0,w.$Gb)(J.tags.map(S.from)):void 0}}Ce.from=Ae;function ge(J){const Le=new s.$nK(o.to(J),J.message,h.to(J.severity));return Le.source=J.source,Le.code=(0,a.$xf)(J.code)?J.code:J.code?.value,Le.relatedInformation=J.relatedInformation&&J.relatedInformation.map(m.to),Le.tags=J.tags&&(0,w.$Gb)(J.tags.map(S.to)),Le}Ce.to=ge})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Ae(J){return{...o.from(J.location.range),message:J.message,resource:J.location.uri}}Ce.from=Ae;function ge(J){return new s.$mK(new s.$lK(J.resource,o.to(J)),J.message)}Ce.to=ge})(m||(e.DiagnosticRelatedInformation=m={}));var h;(function(Ce){function Ae(J){switch(J){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Ae;function ge(J){switch(J){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=ge})(h||(e.DiagnosticSeverity=h={}));var A;(function(Ce){function Ae(J){return typeof J=="number"&&J>=s.ViewColumn.One?J-1:J===s.ViewColumn.Beside?r.$eC:r.$dC}Ce.from=Ae;function ge(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(A||(e.ViewColumn=A={}));function W(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$8L=V;var U;(function(Ce){function Ae(qe){return qe.map(Ce.from)}Ce.fromMany=Ae;function ge(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let et;if(ge(qe)){const{language:ht,value:Rt}=qe;et={value:"```"+ht+`
`+Rt+"\n```\n"}}else s.$zK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const gt=Object.create(null);et.uris=gt;const ft=ht=>{try{let Rt=p.URI.parse(ht,!0);Rt=Rt.with({query:Le(Rt.query,gt)}),gt[ht]=Rt}catch{}return""},pt=new D.marked.Renderer;return pt.link=ft,pt.image=ht=>typeof ht=="string"?ft(R.$8j(ht).href):"",(0,D.marked)(et.value,{renderer:pt}),et}Ce.from=J;function Le(qe,et){if(!qe)return qe;let gt;try{gt=(0,g.$jh)(qe)}catch{}if(!gt)return qe;let ft=!1;return gt=(0,k.$4m)(gt,pt=>{if(p.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=pt,ft=!0,ht}else return}),ft?JSON.stringify(gt):qe}function Be(qe){const et=new s.$zK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?p.URI.from(qe.baseUri):void 0,et}Ce.to=Be;function Ge(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function B(Ce){return V(Ce)?Ce.map(Ae=>({range:o.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?U.fromMany(Ae.hoverMessage):Ae.hoverMessage?U.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ce.map(Ae=>({range:o.from(Ae)}))}e.$9L=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$0L=O;var N;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Ae})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var te;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Ae})(te||(e.ThemableDecorationRenderOptions=te={}));var Z;(function(Ce){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Ae})(Z||(e.DecorationRangeBehavior=Z={}));var ye;(function(Ce){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Z.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?te.from(ge.light):void 0,dark:ge.dark?te.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Ae})(ye||(e.DecorationRenderOptions=ye={}));var Ee;(function(Ce){function Ae(J){return{text:J.newText,eol:J.newEol&&Ye.from(J.newEol),range:o.from(J.range)}}Ce.from=Ae;function ge(J){const Le=new s.$gK(o.to(J.range),J.text);return Le.newEol=typeof J.eol>"u"?void 0:Ye.to(J.eol),Le}Ce.to=ge})(Ee||(e.TextEdit=Ee={}));var Pe;(function(Ce){function Ae(J,Le){const Be={edits:[]};if(J instanceof s.$jK){const Ge=new l.$Ac;for(const qe of J._allEntries())qe._type===1&&p.URI.isUri(qe.to)&&qe.from===void 0&&Ge.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,M.$ue)(M.$ae.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Be.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Be.edits.push({resource:qe.uri,textEdit:Ee.from(qe.edit),versionId:Ge.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Be.edits.push({resource:qe.uri,textEdit:{range:o.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ge.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Be.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Be.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(mt.from)}})}return Be}Ce.from=Ae;function ge(J){const Le=new s.$jK,Be=new l.$zc;for(const Ge of J.edits)if(Ge.textEdit){const qe=Ge,et=p.URI.revive(qe.resource),gt=o.to(qe.textEdit.range),ft=qe.textEdit.text,pt=qe.textEdit.insertAsSnippet;let ht;pt?ht=s.$iK.replace(gt,new s.$kK(ft)):ht=s.$gK.replace(gt,ft);const Rt=Be.get(et);Rt?Rt.push(ht):Be.set(et,[ht])}else Le.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,qe]of Be)Le.set(Ge,qe);return Le}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Y;(function(Ce){const Ae=Object.create(null);Ae[s.SymbolKind.File]=0,Ae[s.SymbolKind.Module]=1,Ae[s.SymbolKind.Namespace]=2,Ae[s.SymbolKind.Package]=3,Ae[s.SymbolKind.Class]=4,Ae[s.SymbolKind.Method]=5,Ae[s.SymbolKind.Property]=6,Ae[s.SymbolKind.Field]=7,Ae[s.SymbolKind.Constructor]=8,Ae[s.SymbolKind.Enum]=9,Ae[s.SymbolKind.Interface]=10,Ae[s.SymbolKind.Function]=11,Ae[s.SymbolKind.Variable]=12,Ae[s.SymbolKind.Constant]=13,Ae[s.SymbolKind.String]=14,Ae[s.SymbolKind.Number]=15,Ae[s.SymbolKind.Boolean]=16,Ae[s.SymbolKind.Array]=17,Ae[s.SymbolKind.Object]=18,Ae[s.SymbolKind.Key]=19,Ae[s.SymbolKind.Null]=20,Ae[s.SymbolKind.EnumMember]=21,Ae[s.SymbolKind.Struct]=22,Ae[s.SymbolKind.Event]=23,Ae[s.SymbolKind.Operator]=24,Ae[s.SymbolKind.TypeParameter]=25;function ge(Le){return typeof Ae[Le]=="number"?Ae[Le]:6}Ce.from=ge;function J(Le){for(const Be in Ae)if(Ae[Be]===Le)return Number(Be);return s.SymbolKind.Property}Ce.to=J})(Y||(e.SymbolKind=Y={}));var ae;(function(Ce){function Ae(J){switch(J){case s.SymbolTag.Deprecated:return 1}}Ce.from=Ae;function ge(J){switch(J){case 1:return s.SymbolTag.Deprecated}}Ce.to=ge})(ae||(e.SymbolTag=ae={}));var Se;(function(Ce){function Ae(J){return{name:J.name,kind:Y.from(J.kind),tags:J.tags&&J.tags.map(ae.from),containerName:J.containerName,location:q.from(J.location)}}Ce.from=Ae;function ge(J){const Le=new s.$qK(J.name,Y.to(J.kind),J.containerName,q.to(J.location));return Le.tags=J.tags&&J.tags.map(ae.to),Le}Ce.to=ge})(Se||(e.WorkspaceSymbol=Se={}));var ue;(function(Ce){function Ae(J){const Le={name:J.name||"!!MISSING: name!!",detail:J.detail,range:o.from(J.range),selectionRange:o.from(J.selectionRange),kind:Y.from(J.kind),tags:J.tags?.map(ae.from)??[]};return J.children&&(Le.children=J.children.map(Ae)),Le}Ce.from=Ae;function ge(J){const Le=new s.$rK(J.name,J.detail,Y.to(J.kind),o.to(J.range),o.to(J.selectionRange));return(0,w.$Kb)(J.tags)&&(Le.tags=J.tags.map(ae.to)),J.children&&(Le.children=J.children.map(ge)),Le}Ce.to=ge})(ue||(e.DocumentSymbol=ue={}));var $e;(function(Ce){function Ae(J){const Le=new s.$vK(Y.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),o.to(J.range),o.to(J.selectionRange));return Le._sessionId=J._sessionId,Le._itemId=J._itemId,Le}Ce.to=Ae;function ge(J,Le,Be){if(Le=Le??J._sessionId,Be=Be??J._itemId,Le===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Be,name:J.name,detail:J.detail,kind:Y.from(J.kind),uri:J.uri,range:o.from(J.range),selectionRange:o.from(J.selectionRange),tags:J.tags?.map(ae.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Ae(ge){return new s.$wK($e.to(ge.from),ge.fromRanges.map(J=>o.to(J)))}Ce.to=Ae})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Ae(ge){return new s.$xK($e.to(ge.to),ge.fromRanges.map(J=>o.to(J)))}Ce.to=Ae})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Ae(J){return{range:J.range&&o.from(J.range),uri:J.uri}}Ce.from=Ae;function ge(J){return new s.$lK(p.URI.revive(J.uri),o.to(J.range))}Ce.to=ge})(q||(e.location=q={}));var le;(function(Ce){function Ae(J){const Le=J,Be=J;return{originSelectionRange:Le.originSelectionRange?o.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Be.uri,range:o.from(Le.targetRange?Le.targetRange:Be.range),targetSelectionRange:Le.targetSelectionRange?o.from(Le.targetSelectionRange):void 0}}Ce.from=Ae;function ge(J){return{targetUri:p.URI.revive(J.uri),targetRange:o.to(J.range),targetSelectionRange:J.targetSelectionRange?o.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?o.to(J.originSelectionRange):void 0}}Ce.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Ae(J){return{range:o.from(J.range),contents:U.fromMany(J.contents)}}Ce.from=Ae;function ge(J){return new s.$oK(J.contents.map(U.to),o.to(J.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Ae(J){return{range:o.from(J.range),expression:J.expression}}Ce.from=Ae;function ge(J){return new s.$hL(o.to(J.range),J.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Ae(J){if(J instanceof s.$iL)return{type:"text",range:o.from(J.range),text:J.text};if(J instanceof s.$jL)return{type:"variable",range:o.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof s.$kL)return{type:"expression",range:o.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Ae;function ge(J){switch(J.type){case"text":return{range:o.to(J.range),text:J.text};case"variable":return{range:o.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:o.to(J.range),expression:J.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var De;(function(Ce){function Ae(J){return{frameId:J.frameId,stoppedLocation:o.from(J.stoppedLocation)}}Ce.from=Ae;function ge(J){return new s.$lL(J.frameId,o.to(J.stoppedLocation))}Ce.to=ge})(De||(e.InlineValueContext=De={}));var re;(function(Ce){function Ae(J){return{range:o.from(J.range),kind:J.kind}}Ce.from=Ae;function ge(J){return new s.$pK(o.to(J.range),J.kind)}Ce.to=ge})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Ae(ge){switch(ge){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Ae})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Ae(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Ae})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Ae(J){switch(J){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Ae;function ge(J){switch(J){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var de;(function(Ce){const Ae=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ge(Be){return Ae.get(Be)??9}Ce.from=ge;const J=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Be){return J.get(Be)??s.CompletionItemKind.Property}Ce.to=Le})(de||(e.CompletionItemKind=de={}));var Ie;(function(Ce){function Ae(ge,J){const Le=new s.$FK(ge.label);return Le.insertText=ge.insertText,Le.kind=de.to(ge.kind),Le.tags=ge.tags?.map(oe.to),Le.detail=ge.detail,Le.documentation=R.$3j(ge.documentation)?U.to(ge.documentation):ge.documentation,Le.sortText=ge.sortText,Le.filterText=ge.filterText,Le.preselect=ge.preselect,Le.commitCharacters=ge.commitCharacters,$.$os.isIRange(ge.range)?Le.range=o.to(ge.range):typeof ge.range=="object"&&(Le.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Le.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Le.insertText=new s.$kK(ge.insertText):(Le.insertText=ge.insertText,Le.textEdit=Le.range instanceof s.$bK?new s.$gK(Le.range,Le.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Le.additionalTextEdits=ge.additionalTextEdits.map(Be=>Ee.to(Be))),Le.command=J&&ge.command?J.fromInternal(ge.command):void 0,Le}Ce.to=Ae})(Ie||(e.CompletionItem=Ie={}));var L;(function(Ce){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:U.fromStrict(J.documentation)}}Ce.from=Ae;function ge(J){return{label:J.label,documentation:R.$3j(J.documentation)?U.to(J.documentation):J.documentation}}Ce.to=ge})(L||(e.ParameterInformation=L={}));var K;(function(Ce){function Ae(J){return{label:J.label,documentation:U.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(L.from):[],activeParameter:J.activeParameter}}Ce.from=Ae;function ge(J){return{label:J.label,documentation:R.$3j(J.documentation)?U.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(L.to):[],activeParameter:J.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}Ce.from=Ae;function ge(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Ae(ge,J){const Le=new s.$EK(d.to(J.position),typeof J.label=="string"?J.label:J.label.map(H.to.bind(void 0,ge)),J.kind&&_.to(J.kind));return Le.textEdits=J.textEdits&&J.textEdits.map(Ee.to),Le.tooltip=R.$3j(J.tooltip)?U.to(J.tooltip):J.tooltip,Le.paddingLeft=J.paddingLeft,Le.paddingRight=J.paddingRight,Le}Ce.to=Ae})(Q||(e.InlayHint=Q={}));var H;(function(Ce){function Ae(ge,J){const Le=new s.$DK(J.label);return Le.tooltip=R.$3j(J.tooltip)?U.to(J.tooltip):J.tooltip,f.Command.is(J.command)&&(Le.command=ge.fromInternal(J.command)),J.location&&(Le.location=q.to(J.location)),Le}Ce.to=Ae})(H||(e.InlayHintLabelPart=H={}));var _;(function(Ce){function Ae(J){return J}Ce.from=Ae;function ge(J){return J}Ce.to=ge})(_||(e.InlayHintKind=_={}));var ce;(function(Ce){function Ae(J){return{range:o.from(J.range),url:J.target,tooltip:J.tooltip}}Ce.from=Ae;function ge(J){let Le;if(J.url)try{Le=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new s.$KK(o.to(J.range),Le)}Ce.to=ge})(ce||(e.DocumentLink=ce={}));var Fe;(function(Ce){function Ae(J){const Le=new s.$NK(J.label);return J.textEdit&&(Le.textEdit=Ee.to(J.textEdit)),J.additionalTextEdits&&(Le.additionalTextEdits=J.additionalTextEdits.map(Be=>Ee.to(Be))),Le}Ce.to=Ae;function ge(J){return{label:J.label,textEdit:J.textEdit?Ee.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Le=>Ee.from(Le)):void 0}}Ce.from=ge})(Fe||(e.ColorPresentation=Fe={}));var Ue;(function(Ce){function Ae(J){return new s.$LK(J[0],J[1],J[2],J[3])}Ce.to=Ae;function ge(J){return[J.red,J.green,J.blue,J.alpha]}Ce.from=ge})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Ae(J){return{range:o.from(J.range)}}Ce.from=Ae;function ge(J){return new s.$uK(o.to(J.range))}Ce.to=ge})(Qe||(e.SelectionRange=Qe={}));var Je;(function(Ce){function Ae(ge){switch(ge){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Ae})(Je||(e.TextDocumentSaveReason=Je={}));var xe;(function(Ce){function Ae(J){switch(J){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Ae;function ge(J){switch(J){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=ge})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Ye;(function(Ce){function Ae(J){if(J===s.EndOfLine.CRLF)return 1;if(J===s.EndOfLine.LF)return 0}Ce.from=Ae;function ge(J){if(J===1)return s.EndOfLine.CRLF;if(J===0)return s.EndOfLine.LF}Ce.to=ge})(Ye||(e.EndOfLine=Ye={}));var _e;(function(Ce){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Ae})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Ae(J){const Le={start:J.start+1,end:J.end+1};return J.kind&&(Le.kind=tt.from(J.kind)),Le}Ce.from=Ae;function ge(J){const Le={start:J.start-1,end:J.end-1};return J.kind&&(Le.kind=tt.to(J.kind)),Le}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Ae(J){if(J)switch(J){case s.FoldingRangeKind.Comment:return f.$dt.Comment;case s.FoldingRangeKind.Imports:return f.$dt.Imports;case s.FoldingRangeKind.Region:return f.$dt.Region}}Ce.from=Ae;function ge(J){if(J)switch(J.value){case f.$dt.Comment.value:return s.FoldingRangeKind.Comment;case f.$dt.Imports.value:return s.FoldingRangeKind.Imports;case f.$dt.Region.value:return s.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$ND.id:void 0}}Ce.from=Ae})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Ae(Be){return Be instanceof s.$8K?Be.toJSON():typeof Be=="string"?Be:ge(Be)||J(Be)?new s.$8K(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Ae;function ge(Be){const Ge=Be;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function J(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Le(Be){return typeof Be=="string"?Be:new s.$8K(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Le})(st||(e.GlobPattern=st={}));var x;(function(Ce){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const J=ge;return{language:J.language,scheme:J.scheme,pattern:st.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ce.from=Ae})(x||(e.LanguageSelector=x={}));var X;(function(Ce){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Le=>Array.isArray(Le)&&Le.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&p.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ge=>Ge instanceof s.$bK)))}Ce.is=Ae;function ge(J){return{documents:J.documents.map(Le=>Le.map(Be=>({uri:p.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ge=>o.from(Ge))})))}}Ce.from=ge})(X||(e.MappedEditsContext=X={}));var pe;(function(Ce){function Ae(J){return{start:J.start,end:J.end}}Ce.from=Ae;function ge(J){return new s.$wL(J.start,J.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var je;(function(Ce){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ce.to=Ae;function ge(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ce.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var Oe;(function(Ce){function Ae(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Ae})(Oe||(e.NotebookCellExecutionState=Oe={}));var Xe;(function(Ce){function Ae(J){switch(J){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ce.from=Ae;function ge(J){switch(J){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=ge})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Ce){function Ae(J){const Le={metadata:J.metadata??Object.create(null),cells:[]};for(const Be of J.cells)s.$xL.validate(Be),Le.cells.push(mt.from(Be));return Le}Ce.from=Ae;function ge(J){const Le=new s.$yL(J.cells.map(mt.to));return(0,a.$Kf)(J.metadata)||(Le.metadata=J.metadata),Le}Ce.to=ge})(rt||(e.NotebookData=rt={}));var mt;(function(Ce){function Ae(J){return{cellKind:Xe.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:je.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ct.from):[]}}Ce.from=Ae;function ge(J){return new s.$xL(Xe.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ct.to):void 0,J.metadata,J.internalMetadata?je.to(J.internalMetadata):void 0)}Ce.to=ge})(mt||(e.NotebookCellData=mt={}));var wt;(function(Ce){function Ae(J){return{mime:J.mime,valueBytes:M.$ae.wrap(J.data)}}Ce.from=Ae;function ge(J){return new s.$zL(J.valueBytes.buffer,J.mime)}Ce.to=ge})(wt||(e.NotebookCellOutputItem=wt={}));var Ct;(function(Ce){function Ae(J){return{outputId:J.id,items:J.items.map(wt.from),metadata:J.metadata}}Ce.from=Ae;function ge(J){const Le=J.items.map(wt.to);return new s.$AL(Le,J.outputId,J.metadata)}Ce.to=ge})(Ct||(e.NotebookCellOutput=Ct={}));var Zt;(function(Ce){function Ae(Le){return J(Le)?{include:st.from(Le.include)??void 0,exclude:st.from(Le.exclude)??void 0}:st.from(Le)??void 0}Ce.from=Ae;function ge(Le){return J(Le)?{include:st.to(Le.include),exclude:st.to(Le.exclude)}:st.to(Le)}Ce.to=ge;function J(Le){const Be=Le;return Be?!(0,a.$Gf)(Be.include)&&!(0,a.$Gf)(Be.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Kt;(function(Ce){function Ae(ge,J,Le){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Be,Le),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Ae})(Kt||(e.NotebookStatusBarItem=Kt={}));var vt;(function(Ce){function Ae(ge,J,Le){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:J.toInternal(Be,Le),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Ae})(vt||(e.NotebookKernelSourceAction=vt={}));var jt;(function(Ce){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Ae})(jt||(e.NotebookDocumentContentOptions=jt={}));var Ft;(function(Ce){function Ae(J){return{uri:J.uri,provides:J.provides}}Ce.from=Ae;function ge(J){return new s.$CL(p.URI.revive(J.uri),J.provides)}Ce.to=ge})(Ft||(e.NotebookRendererScript=Ft={}));var Bt;(function(Ce){function Ae(J){return{message:U.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:o.from(J.location.range),uri:J.location.uri}}}Ce.from=Ae;function ge(J){const Le=new s.$IL(typeof J.message=="string"?J.message:U.to(J.message));return Le.actualOutput=J.actual,Le.expectedOutput=J.expected,Le.contextValue=J.contextValue,Le.location=J.location?q.to(J.location):void 0,Le}Ce.to=ge})(Bt||(e.TestMessage=Bt={}));var Pt;(function(Ce){Ce.namespace=v.$7I,Ce.denamespace=v.$8I})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Ae(J){const Le=(0,i.$7L)(J).controllerId;return{extId:E.$3I.fromExtHostTestItem(J,Le).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Be=>Pt.namespace(Le,Be.id)),range:$.$os.lift(o.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&U.fromStrict(J.error)||null}}Ce.from=Ae;function ge(J){return{parent:void 0,error:void 0,id:E.$3I.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Le=>{const{tagId:Be}=Pt.denamespace(Le);return new s.$JL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Ce.toPlain=ge})(At||(e.TestItem=At={})),function(Ce){function Ae(J){return{id:J.id}}Ce.from=Ae;function ge(J){return new s.$JL(J.id)}Ce.to=ge}(Pt||(e.TestTag=Pt={}));var Nt;(function(Ce){const Ae=(J,Le)=>{const Be=[];for(const[qe,et]of Le)E.$3I.compare(et.item.extId,qe)===2&&(Le.delete(qe),Be.push(et));const Ge={...At.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Bt.to)})),children:Be.map(qe=>Ae(qe,Le))};for(const qe of Ge.children)qe.parent=Ge;return Ge};function ge(J){const Le=[],Be=new Map;for(const Ge of J.items){Be.set(Ge.item.extId,Ge);const qe=E.$3I.root(Ge.item.extId);J.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Ge.item.extId))&&Le.push(Ge)}return{completedAt:J.completedAt,results:Le.map(Ge=>Ae(Ge,Be))}}Ce.to=ge})(Nt||(e.TestResults=Nt={}));var Wt;(function(Ce){function Ae(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?d.from(Be):o.from(Be)}function J(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ce.fromDetailed=J;function Le(Be){return{uri:Be.uri,statement:Ae(Be.statementCoverage),branch:Be.branchCoverage&&Ae(Be.branchCoverage),function:Be.functionCoverage&&Ae(Be.functionCoverage),details:Be.detailedCoverage?.map(J)}}Ce.fromFile=Le})(Wt||(e.TestCoverage=Wt={}));var Ht;(function(Ce){function Ae(ge){switch(ge){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Ae})(Ht||(e.CodeActionTriggerKind=Ht={}));var Vt;(function(Ce){function Ae(J){const Le=new s.$PL(Y.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),o.to(J.range),o.to(J.selectionRange));return Le._sessionId=J._sessionId,Le._itemId=J._itemId,Le}Ce.to=Ae;function ge(J,Le,Be){if(Le=Le??J._sessionId,Be=Be??J._itemId,Le===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Be,kind:Y.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:o.from(J.range),selectionRange:o.from(J.selectionRange),tags:J.tags?.map(ae.from)}}Ce.from=ge})(Vt||(e.TypeHierarchyItem=Vt={}));var at;(function(Ce){function Ae(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Ae})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Ae(Be,Ge,qe){const et=Ge.fileData;return et?new s.$1K(new s.$2K(et.name,p.URI.revive(et.uri),et.id,(0,F.$cb)(()=>qe(et.id)))):Be===P.$Lr.uriList&&Ge.uriListData?new s.$ZK(Le(Ge.uriListData)):new s.$ZK(Ge.asString)}Ce.to=Ae;async function ge(Be,Ge){const qe=await Ge.asString();if(Be===P.$Lr.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const et=Ge.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=ge;function J(Be){return C.$Xs.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Le(Be){return C.$Xs.create(Be.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Gt;(function(Ce){function Ae(J,Le){const Be=J.items.map(([Ge,qe])=>[Ge,ut.to(Ge,qe,Le)]);return new s.$3K(Be)}Ce.toDataTransfer=Ae;async function ge(J){const Le={items:[]},Be=[];for(const[Ge,qe]of J)Be.push((async()=>{Le.items.push([Ge,await ut.from(Ge,qe)])})());return await Promise.all(Be),Le}Ce.from=ge})(Gt||(e.DataTransfer=Gt={}));var It;(function(Ce){function Ae(J){return{message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}Ce.to=Ae;function ge(J){return{kind:"reply",message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}Ce.from=ge})(It||(e.ChatReplyFollowup=It={}));var Et;(function(Ce){function Ae(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:It.from(ge)}Ce.from=Ae})(Et||(e.ChatFollowup=Et={}));var dt;(function(Ce){function Ae(J){const Le=new s.$ZL(kt.to(J.role),J.content);return Le.name=J.name,Le}Ce.to=Ae;function ge(J){return{role:kt.from(J.role),content:J.content,name:J.name}}Ce.from=ge})(dt||(e.ChatMessage=dt={}));var kt;(function(Ce){function Ae(J){switch(J){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Ae;function ge(J){switch(J){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=ge})(kt||(e.ChatMessageRole=kt={}));var Tt;(function(Ce){function Ae(J){return{level:yt.to(J.level),value:J.value,description:J.description}}Ce.to=Ae;function ge(J){return{level:yt.from(J.level),value:J.value,description:J.description}}Ce.from=ge})(Tt||(e.ChatVariable=Tt={}));var yt;(function(Ce){function Ae(J){switch(J){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Ae;function ge(J){switch(J){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(yt||(e.ChatVariableLevel=yt={}));var Ve;(function(Ce){function Ae(ge){switch(ge){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Ae})(Ve||(e.InteractiveEditorResponseFeedbackKind=Ve={}));var Ot;(function(Ce){function Ae(ge){return"placeholder"in ge&&"resolvedContent"in ge?{placeholder:ge.placeholder}:"responseId"in ge?{requestId:ge.responseId}:"content"in ge?{content:typeof ge.content=="string"?ge.content:U.from(ge.content)}:"documents"in ge?{documents:ge.documents.map(J=>({uri:J.uri,version:J.version,ranges:J.ranges.map(Le=>o.from(Le))}))}:"reference"in ge?{reference:"uri"in ge.reference?{uri:ge.reference.uri,range:o.from(ge.reference.range)}:ge.reference}:ge}Ce.from=Ae})(Ot||(e.ChatResponseProgress=Ot={}));var zt;(function(Ce){function Ae(ge,J,Le){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:J.toInternal(ge,Le)}Ce.from=Ae})(zt||(e.TerminalQuickFix=zt={}))}),define(Re[203],Me([1,0,2,9,7,8,173]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class l{constructor(g,P,k,a={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=k,this.g=a,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,k,a)=>{const $={dispose:this.a.push([P,k,g])};return Array.isArray(a)&&a.push($),$}}async $participateInSave(g,P){const k=w.URI.revive(g);let a=!1;const p=setTimeout(()=>a=!0,this.g.timeout),$=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(k),i=await this.h(f,{document:t,reason:F.TextDocumentSaveReason.to(P)});$.push(i)}}finally{clearTimeout(p)}return $}h([g,P,k],a){const p=this.b.get(g);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,g,P,a).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,k,a){const p=[],$=Date.now(),{document:f,reason:t}=a,{version:i}=f,c=Object.freeze({document:f,reason:t,waitUntil(b){if(Object.isFrozen(p))throw(0,M.$7)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{P.apply(k,[c])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(v),b(r)}).catch(r=>{clearTimeout(v),E(r)})}).then(b=>{const E={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(r=>r instanceof C.$gK))for(const{newText:r,newEol:s,range:n}of v)E.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:n&&F.Range.from(n),text:r,eol:s&&F.EndOfLine.from(s)}});if(E.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$3bc=l}),define(Re[204],Me([1,0,13,2,8,7,75]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=void 0;class l{constructor(k,a,p,$){this.start=k,this.deletedCount=a,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new F.$wL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,p){this.notebook=k,this.h=a,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime($){k.g=$},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,p){const $=p.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(a||(f.items.length=0),f.items.push(...$),f.items.length>1&&f.items.every(t=>R.$jI(t.mime)))){const t=new Map,i=[];f.items.forEach(c=>{let b;t.has(c.mime)?b=t.get(c.mime):(b=[],t.set(c.mime,b),i.push(c.mime)),b.push(c.data)}),f.items.length=0,i.forEach(c=>{const b=R.$kI(t.get(c));f.items.push({mime:c,data:b.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$ddc=D;class g{static{this.a=0}constructor(k,a,p,$,f){this.k=k,this.l=a,this.m=p,this.uri=$,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===w.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,p){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},f=[];for(const i of k.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const c=f[i],b=t.get(c.cell);if(b===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,E-1)}else $.cellChanges[b]={...$.cellChanges[b],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,p=k.end|0;return a<0&&(a=0),p>this.b.length&&(p=this.b.length),k.with({start:a,end:p})}p(k){k=this.o(k);const a=[];for(let p=k.start;p<k.end;p++)a.push(this.b[p]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,p){if(this.j)return;const $=[],f=[],t=[];if(k.reverse().forEach(i=>{const b=i[2].map(r=>{const s=new D(this,this.l,r);return a||f.push(D.asModelAddData(this.apiNotebook,r)),s}),E=new l(i[0],i[1],[],b),v=this.b.splice(i[0],i[1],...b);for(const r of v)t.push(r.uri),E.deletedItems.push(r.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(k,a,p,$){const f=this.b.splice(k,a);this.b.splice(p,0,...f);const t=[new l(k,a,f.map(i=>i.apiCell),[]),new l(p,0,[],f)];for(const i of t)$.push(i.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,p,$){this.b[k].setOutputItems(a,p,$)}v(k,a){const p=this.b[k];p.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(p.uri,a)}w(k,a){const p=this.b[k];p.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$edc=g}),define(Re[205],Me([1,0,5,2,8,7]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class R{constructor(D,g,P,k={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=P,this.f=k,this.a=new w.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,P,k)=>{const a=function($){g.call(P,$)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,g,P){const k=M.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(f,t)=>{const i=Date.now(),c=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof F.$jK?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const f of p){const{edits:t}=C.WorkspaceEdit.from(f);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Edc=R}),define(Re[103],Me([1,0,9,8,7]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,D,g,P,k,a){this.id=l,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=P,this.c=a}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(D){this.selections=[D]},get selections(){return l.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$wL.isNotebookRange))throw(0,w.$6)("selections");l.a=D,l.g(D)},get visibleRanges(){return l.b},revealRange(D,g){l.f.$tryRevealRange(l.id,M.NotebookRange.from(D),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$fdc=F}),define(Re[206],Me([1,0,9,5,14,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new M.$Md({onListenerError:w.$1}),this.b=new M.$Md({onListenerError:w.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const P=this.d.getEditorById(D);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(F.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(F.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(F.ViewColumn.to(D[g]))}};e.$xdc=R,e.$xdc=R=Ke([We(0,C.$8i)],R)}),define(Re[207],Me([1,0,8,71,152,21,64,9]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,p,$){const f=this.b++,{title:t,location:i,cancellable:c}=p,b={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:w.ProgressLocation.from(i),title:t,source:b,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(l.$1),this.d(f,$,!!c)}d(a,p,$){let f;$&&(f=new F.$Wd,this.c.set(a,f));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let i;try{i=p(new P(this.a,a),$&&f?f.token:F.CancellationToken.None)}catch(c){throw t(a),c}return i.then(c=>t(a),c=>t(a)),i}$acceptProgressCanceled(a){const p=this.c.get(a);p&&(p.cancel(),this.c.delete(a))}}e.$Bcc=D;function g(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class P extends M.$Zu{constructor(a,p){super($=>this.throttledReport($)),this.i=a,this.j=p}throttledReport(a){this.i.$progressReport(this.j,a)}}Ke([(0,R.$hh)(100,(k,a)=>g(k,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Re[104],Me([1,0,44,101,45,76,56,8,2]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=e.$lM=e.$kM=void 0;const g=(b,E,v,r)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(n){if(!v(s,n)){const o=s;s=n,b.listener?.(r(n,o))}}}},P=(b,E)=>b===E,k={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(b,E)=>!(b.length!==E.length||b.some(v=>!E.find(r=>v.id===r.id)))},a=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let v;const r=a(s=>({range:w.$os.lift(l.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return v},set(s){b.listener?.({op:6}),k.range(v,s)||(v=s,b.listener?.(r(s)))}}})(),label:g(b,E,k.label,a(v=>({label:v}))),description:g(b,void 0,k.description,a(v=>({description:v}))),sortText:g(b,void 0,k.sortText,a(v=>({sortText:v}))),canResolveChildren:g(b,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:g(b,!1,k.busy,a(v=>({busy:v}))),error:g(b,void 0,k.error,a(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:g(b,[],k.tags,(v,r)=>({op:1,new:v.map(l.TestTag.from),old:r.map(l.TestTag.from)}))}),$=b=>{const E=C.$3I.fromString(b.extId),v=new t(E.controllerId,E.localId,b.label,D.URI.revive(b.uri)||void 0);return v.range=l.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(r=>l.TestTag.to({id:(0,R.$8I)(r).tagId})),v},f=b=>{let E;for(const v of b.tests){const r=$(v.item);(0,M.$7L)(r).parent=E,E=r}return E};e.$kM=f;class t{constructor(E,v,r,s){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const n=(0,M.$6L)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,F.$5L)(n,M.$7L,t),enumerable:!0,writable:!1},...p(n,r)})}}e.$lM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$mM=i;class c extends F.$1L{constructor(E,v,r){super({controllerId:E,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:M.$7L,getChildren:s=>s.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$nM=c}),define(Re[105],Me([1,0,51,9,88,8,7]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.$fM=void 0;class l{static{this.c=new C.$dM("TextEditorDecorationType")}constructor(a,p,$){const f=l.c.nextId();a.$registerTextEditorDecorationType(p.identifier,f,F.DecorationRenderOptions.from($)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$fM=l;class D{constructor(a,p){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,p){this.k();let $=null;if(a instanceof R.$aK)$=new R.$bK(a,a);else if(a instanceof R.$bK)$=a;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(a,p){this.k(),this.l(new R.$bK(a,a),p,!0)}delete(a){this.k();let p=null;if(a instanceof R.$bK)p=a;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(a,p,$){const f=this.c.validateRange(a);this.g.push({range:f,text:p,forceMoveMarkers:$})}setEndOfLine(a){if(this.k(),a!==R.EndOfLine.LF&&a!==R.EndOfLine.CRLF)throw(0,M.$6)("endOfLine");this.h=a}}class g{constructor(a,p,$,f){this.c=a,this.d=p,this._accept($),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}m(a){const p=this.l(a);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}o(a){const p=this.n(a);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const p=this.p(a);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let $=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?($=!0,p.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,$=!0,p.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?($=!0,p.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,$=!0,p.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?($=!0,p.insertSpaces=f):this.h!==f&&(this.h=f,$=!0,p.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,$=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,$=!0,p.lineNumbers=F.TextEditorLineNumbersStyle.from(a.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(a,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn($)})}}e.$gM=g;class P{constructor(a,p,$,f,t,i,c,b){this.id=a,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,$),this.e=c,this.f=b;const E=this;this.value=Object.freeze({get document(){return f.value},set document(v){throw new M.$8("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof R.$cK))throw(0,M.$6)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(r=>!(r instanceof R.$cK)))throw(0,M.$6)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$8("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$8("viewColumn")},edit(v,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return v(s),E.m(s)},insertSnippet(v,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=E.c.map(o=>F.Range.from(o));else if(r instanceof R.$aK){const{lineNumber:o,column:y}=F.Position.from(r);n=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(r instanceof R.$bK)n=[F.Range.from(r)];else{n=[];for(const o of r)if(o instanceof R.$bK)n.push(F.Range.from(o));else{const{lineNumber:y,column:d}=F.Position.from(o);n.push({startLineNumber:y,startColumn:d,endLineNumber:y,endColumn:d})}}return p.$tryInsertSnippet(a,f.value.version,v.value,n,s)},setDecorations(v,r){const s=r.length===0;s&&!E.h.has(v.key)||(s?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(F.$8L(r))return p.$trySetDecorations(a,v.key,F.$9L(r));{const n=new Array(4*r.length);for(let o=0,y=r.length;o<y;o++){const d=r[o];n[4*o]=d.start.line+1,n[4*o+1]=d.start.character+1,n[4*o+2]=d.end.line+1,n[4*o+3]=d.end.character+1}return p.$trySetDecorationsFast(a,v.key,n)}}))},revealRange(v,r){E.n(()=>p.$tryRevealRange(a,F.Range.from(v),r||R.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,F.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,w.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,w.ok)(!this.g),this.f=a}_acceptSelections(a){(0,w.ok)(!this.g),this.c=a}async l(){const a=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=p.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,f,{setEndOfLine:typeof p.setEndOfLine=="number"?F.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$hM=P}),define(Re[208],Me([1,0,4,171]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=void 0,e.$uJ=(0,w.$Oh)(M.$Uh)}),define(Re[106],Me([1,0,20,5,19,6]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a4b=e.$_3b=e.$$3b=e.$03b=e.$93b=e.$83b=void 0;class R{constructor(i,c){this.versionId=i,this.removedDueToLooping=c}}e.$83b=R;class l{static isHostExtension(i,c,b){if(c.getExtensionDescription(i))return!1;const E=b.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,c){this.j=i,this.c=new M.$Md,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort($),this.f=new w.$4l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const c=this.j.readActivationEvents(i);if(Array.isArray(c))for(let b of c)b==="onUri"&&(b=`onUri:${w.$2l.toKey(i.identifier)}`),this.h.has(b)||this.h.set(b,[]),this.h.get(b).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,c){this.e=f(this.e,c),this.e=this.e.concat(i);const b=l.l(this.e);return this.e=f(this.e,b.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,b)}static l(i){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,n){this.addNode(s),this.addNode(n),this.c.has(s)?this.c.get(s).push(n):this.c.set(s,[n])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,n){const o=c.getArcs(s);for(let y=0;y<o.length;y++)if(!n.has(o[y]))return!1;return!0}getNodes(){return this.e}},b=new w.$4l;for(const s of i)if(b.set(s.identifier,s),s.extensionDependencies)for(const n of s.extensionDependencies)c.addArc(w.$2l.toKey(s.identifier),w.$2l.toKey(n));const E=new Set;c.getNodes().filter(s=>c.getArcs(s).length===0).forEach(s=>E.add(s));const v=c.getNodes().filter(s=>!E.has(s));let r;do{r=!1;for(let s=0;s<v.length;s++){const n=v[s];c.hasOnlyGoodArcs(n,E)&&(v.splice(s,1),s--,E.add(n),r=!0)}}while(r);return v.map(s=>b.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this.h.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const c=this.f.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this.g)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$93b=l;class D{constructor(i,c){this.versionId=i,this.extensions=c}}e.$03b=D,e.$$3b={readActivationEvents:t=>t.activationEvents};class g{constructor(i){this.d=new a,this.c=new l(i,[])}async acquireLock(i){const c=await this.d.acquire(i);return new P(this,c)}deltaExtensions(i,c,b){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,b)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this.c.getExtensionDescriptionByIdOrUUID(i,c)}}e.$_3b=g;class P extends F.$Rc{constructor(i,c){super(),this.f=i,this.c=!1,this.B(c)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$a4b=P;class k{constructor(i){this.name=i,this.promise=new Promise((c,b)=>{this.c=c})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const c=new k(i);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let c=!0;const b=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{c&&(clearTimeout(b),c=!1,this.d=!1,this.e())};i.resolve((0,F.$Pc)(E))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function $(t,i){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==b)return c-b;const E=C.$fc.basename(t.extensionLocation.path),v=C.$fc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function f(t,i){const c=new w.$3l(i);return t.filter(b=>!c.has(b.identifier))}}),define(Re[79],Me([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$$l=e.$0l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(g){const P=w.$ae.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$0l=R;function l(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$$l=l;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Re[57],Me([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=e.$qM=e.$pM=void 0;let p=class extends k.$Rc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new M.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:D.$ko,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(b=>{(0,C.$0i)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,b){const E=this.getTelemetryDetails(),v=new $(c,b,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,c,b){this.f=i,this.g=c,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:c["common.uikind"]="web";break;case R.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Sk)((0,D.$ro)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((b,E)=>{const v=b.filter(r=>!r.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(b=>{for(const E of b)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const E=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const r of E)r.ignoreUnhandledExtHostErrors||(r.logError(c),v=!0);return v}};e.$pM=p,e.$pM=p=Ke([We(0,F.$oM),We(1,C.$9i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,b,E,v,r,s){this.g=b,this.h=E,this.i=v,this.j=r,this.a=new M.$Md,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,D.$uo)(c,[]),this.c&&(c=(0,g.$5m)(c,this.c)),this.b||(c=(0,g.$5m)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const b={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$uo)(b,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(v,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$qM=$;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$rM=f,e.$sM=(0,w.$Nh)("IExtHostTelemetry")}),define(Re[26],Me([1,0,5,2,180,98,20,4]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cF=e.$bF=e.$aF=e.ActivationKind=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.ExtensionHostStartup=e.$7E=e.$6E=e.$5E=e.$4E=void 0,e.$4E=Object.freeze({identifier:new R.$2l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$5E="extensions.webWorker",e.$6E=(0,l.$Nh)("extensionService");class D{constructor(v){this.dependency=v}}e.$7E=D;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,r,s){this.c=v,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$OE.createActivationEventsMap(this.d)}}set(v,r,s){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const n=[],o=[],y=[],d=[],I=k(this.d),S=k(r),u=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=S.get(V.identifier);if(!U){n.push(V.identifier),I.delete(V.identifier);continue}if(!u(V,U)){n.push(V.identifier),I.delete(V.identifier);continue}}for(const V of r){const U=I.get(V.identifier);if(!U){o.push(V);continue}if(!u(U,V)){n.push(U.identifier),I.delete(U.identifier);continue}}const m=new R.$3l(this.e),h=new R.$3l(s);for(const V of this.e)h.has(V)||y.push(V);for(const V of s)m.has(V)||d.push(V);const A=F.$OE.createActivationEventsMap(o),W={versionId:v,toRemove:n,toAdd:o,addActivationEvents:A,myToRemove:y,myToAdd:d};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:n,myToAdd:o}=v,y=new R.$3l(r),d=new R.$3l(n);for(let I=0;I<this.d.length;I++)y.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)d.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const r of this.e)if(R.$2l.equals(r,v))return!0;return!1}}e.$8E=P;function k(E){const v=new R.$4l;for(const r of E)v.set(r.identifier,r);return v}function a(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$9E=a;function p(E,v){if(!a(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$0E=p;class ${constructor(v,r,s,n){this.codeLoadingTime=v,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=n}}e.$$E=$;class f{constructor(v,r){this.description=v,this.value=r}}e.$_E=f;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Ao)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$aF=i;function c(E,v){return{identifier:new R.$2l((0,C.$yo)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$bF=c;class b{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$cF=b}),define(Re[209],Me([1,0,9,106,20,26,14,12]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=e.$7bc=e.$6bc=e.$5bc=e.$4bc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,c,b,E){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=E}}e.$4bc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$5bc=g;class P{constructor(i,c,b,E,v,r){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=b,this.module=E,this.exports=v,this.subscriptions=r}}e.$6bc=P;class k extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$7bc=k;class a extends P{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8bc=a;class p extends P{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,b,E){this.g=E,this.a=i,this.b=c,this.c=b,this.d=new C.$4l,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,b]of this.d)i.push(b.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const b=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(b.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const b=this.a.getExtensionDescription(i);if(!b)throw new Error(`Extension '${i}' is not known`);return this.h([{id:b.identifier,reason:c}])}async h(i){const c=i.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(c.map(b=>b.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new p(v));return this.c.onExtensionActivationError(i.id,v,new F.$7E(i.id.value)),r}const b=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const v of E){if(this.m(v))continue;const r=this.d.get(v);if(r){b.push(r);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(v);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:i.reason}));continue}const n=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${v}'`),y=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new F.$7E(v)),y}return this.k(i,c.displayName,b,null)}k(i,c,b,E){const v=new f(i.id,c,i.reason,b,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$93b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$9bc=$,e.$9bc=$=Ke([We(3,R.$8i)],$);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,b,E,v,r,s){this.c=i,this.d=c,this.f=b,this.g=E,this.h=v,this.j=r,this.k=s,this.a=new l.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);b.detail=c.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&w.$3(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([We(6,R.$8i)],f)}),define(Re[210],Me([1,0,156,23,2,5,6,192,12,7,16,18,8,50,21,125,26]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;function i(E,v){if((0,P.$xf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let r;return Array.isArray(E.highlights)&&(r=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:E.label,highlights:r}}}class c extends R.$Rc{constructor(v,r,s){super(),this.f=v,this.g=r,this.h=s,this.a=new Map,this.b=new f.$D7;function n(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>n(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>n(y)?this.r(y):y):o})}registerTreeDataProvider(v,r,s){const n=this.createTreeView(v,{treeDataProvider:r},s);return{dispose:()=>n.dispose()}}createTreeView(v,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],y=!!r.dragAndDropController?.handleDrag,d=!!r.dragAndDropController?.handleDrop,I=this.m(v,r,s),S={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:n,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:d,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$0E)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$0E)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,p.$3j)(h)&&(0,t.$0E)(s,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&g.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,A)=>I.reveal(h,A),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,r){const s=this.a.get(v);return s?s.getChildren(r):Promise.reject(new l.$jE(v))}async $handleDrop(v,r,s,n,o,y,d,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$jE(v));const u=a.DataTransfer.toDataTransfer(s,async m=>(await this.f.$resolveDropFileData(v,r,m)).buffer);return d===v&&I&&await this.j(u,S,I,o,y),S.onDrop(u,n,o)}async j(v,r,s,n,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((d,I)=>{d&&v.set(I,d)});else if(o&&r.handleDrag){const d=r.handleDrag(s,v,n);this.b.addDragOperationTransfer(o,d),await d}return v}async $handleDrag(v,r,s,n){const o=this.a.get(v);if(!o)return Promise.reject(new l.$jE(v));const y=await this.j(new g.$3K,o,r,n,s);if(!(!y||n.isCancellationRequested))return a.DataTransfer.from(y)}async $hasResolve(v){const r=this.a.get(v);if(!r)throw new l.$jE(v);return r.hasResolve}$resolve(v,r,s){const n=this.a.get(v);if(!n)throw new l.$jE(v);return n.resolveTreeItem(r,s)}$setExpanded(v,r,s){const n=this.a.get(v);if(!n)throw new l.$jE(v);n.setExpanded(r,s)}$setSelectionAndFocus(v,r,s){const n=this.a.get(v);if(!n)throw new l.$jE(v);n.setSelectionAndFocus(r,s)}$setVisible(v,r){const s=this.a.get(v);if(!s){if(!r)return;throw new l.$jE(v)}s.setVisible(r)}$changeCheckboxState(v,r){const s=this.a.get(v);if(!s)throw new l.$jE(v);s.setCheckboxState(r)}m(v,r,s){const n=this.B(new b(v,r,this.f,this.g.converter,this.h,s));return this.a.set(v,n),n}r(v){const r=this.a.get(v.$treeViewId);return r&&"$treeItemHandle"in v?r.getExtensionElement(v.$treeItemHandle):r&&"$focusedTreeItem"in v&&v.$focusedTreeItem?r.focusedElement:null}}e.$Icc=c;class b extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,P.$Gf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,r,s,n,o,y){if(super(),this.I=v,this.J=s,this.L=n,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Wd,y.contributes&&y.contributes.views)for(const u in y.contributes.views)for(const m of y.contributes.views[u])m.id===v&&(this.P=m.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let d,I;const S=F.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(d||(d=new Promise(h=>I=h),this.G=this.G.then(()=>d)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const h=I;return d=null,this.$(m).then(()=>h())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const r=v?this.getExtensionElement(v):void 0;if(v&&!r)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let s=this.X(v);return s||(s=await this.Y(r)),s?s.map(n=>n.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,r){r=r||{select:!0,focus:!1};const s=(0,P.$Gf)(r.select)?!0:r.select,n=(0,P.$Gf)(r.focus)?!1:r.focus,o=(0,P.$Gf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(y=>this.W(v,y[y.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:y.map(I=>I.item)},{select:s,focus:n,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:s,focus:n,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=a.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,r){const s=this.getExtensionElement(v);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(v,r){const s=!(0,k.$tb)(this.s,v);this.s=v;const n=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const r=(await Promise.all(v.map(async s=>{const n=this.getExtensionElement(s.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(v,r,s){const n=[];for(const o of v){const y=this.getExtensionElement(o);y&&n.push(y)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,r,s){const n=r?this.getExtensionElement(r):void 0;if(!(!n&&r||!this.g?.handleDrop))return(0,D.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(n,v,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(v);if(s){const n=this.m.get(s);if(n){const o=await this.f.resolveTreeItem(n.extensionItem,s,r)??n.extensionItem;return this.hb(o),n.item.tooltip=this.eb(o.tooltip),n.item.command=this.fb(n.disposableStore,o.command),n.item}}}S(v){return this.U(v).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(n=>(s.push(n),s))):Promise.resolve([]))}U(v){const r=this.m.get(v);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Lg)(()=>this.f.getParent(v))}W(v,r){const s=this.m.get(v);return s?Promise.resolve(s):(0,D.$Lg)(()=>this.f.getTreeItem(v)).then(n=>this.kb(v,n,r,!0)).then(n=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(n);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let r;if(typeof v=="string"){const s=this.getExtensionElement(v);r=s?this.m.get(s):void 0}else r=v;return r&&r.children||void 0}return this.h}async Y(v){this.rb(v);const r=new $.$Wd(this.Z.token);try{const s=v?this.m.get(v):void 0,n=await this.f.getChildren(v);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Gb)(n||[]).map(async y=>{const d=await this.f.getTreeItem(y);return d&&!r.token.isCancellationRequested?this.db(y,d,s):null}));return r.token.isCancellationRequested?void 0:(0,k.$Gb)(o)}finally{r.dispose()}}$(v){if(v.some(s=>!s))return this.Z.dispose(!0),this.Z=new $.$Wd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(v);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(v){const r=new Set,s=v.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let y=o;for(;y&&y.parent&&s.findIndex(d=>y&&y.parent&&d&&d.item.handle===y.parent.item.handle)===-1;){const d=this.j.get(y.parent.item.handle);y=d?this.m.get(d):void 0}y&&!y.parent&&r.add(o.item.handle)}const n=[];return r.forEach(o=>{const y=this.j.get(o);if(y){const d=this.m.get(y);d&&(!d.parent||!r.has(d.parent.item.handle))&&n.push(o)}}),n}bb(v){const r={};return Promise.all(v.map(s=>this.cb(s).then(n=>{n&&(r[s]=n.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(v){const r=this.getExtensionElement(v);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Lg)(()=>this.f.getTreeItem(r)).then(n=>{if(n){const o=this.ib(r,n,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db(v,r,s){const n=this.ib(v,r,s);if(r.id&&this.j.has(n.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob(v,n),this.qb(n,s),n}eb(v){return g.$zK.isMarkdownString(v)?a.MarkdownString.from(v):v}fb(v,r){return r?{...this.L.toInternal(r,v),originalId:r.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let r,s,n;return typeof v.checkboxState=="number"?r=v.checkboxState:(r=v.checkboxState.state,s=v.checkboxState.tooltip,n=v.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:n}}hb(v){if(!g.$XK.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,r,s){this.hb(r);const n=this.B(new R.$Qc),o=this.kb(v,r,s),y=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(n,r.command),contextValue:r.contextValue,icon:y,iconDark:this.mb(r)||y,themeIcon:this.jb(r),collapsibleState:(0,P.$Gf)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(v){return v.iconPath instanceof g.$6K?v.iconPath:void 0}kb(v,{id:r,label:s,resourceUri:n},o,y){if(r)return`${b.b}/${r}`;const d=i(s,this.N),I=o?o.item.handle:b.a;let S=d?d.label:n?(0,M.$rg)(n):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let h,A=0;do{if(h=`${I}/${A}:${S}`,y||!this.j.has(h)||u===h)break;A++}while(A<=m.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof g.$6K))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof g.$6K)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,r){this.j.set(r.item.handle,v),this.m.set(v,r)}pb(v,r,s,n){this.j.delete(r.item.handle),this.m.delete(v),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(v,r);const o=this.X(n)||[],y=o.filter(d=>d.item.handle===s.item.handle)[0];y&&o.splice(o.indexOf(y),1,r)}qb(v,r){r?(r.children||(r.children=[]),r.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const n=this.j.get(s.item.handle);n&&this.sb(n)}r.children=void 0}}else this.tb()}sb(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const n=this.j.get(s.item.handle);n&&this.sb(n)}this.m.delete(v),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[211],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[212],Me([1,0,166,9,29,92,72,30,20,211,176,98]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=void 0;const a=l.$bn.as(R.$cn.JSONContribution);class p{constructor(v,r,s){this.a=v,this.b=r,this.c=s}d(v,r){this.a({type:v,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$XE=p;class ${static a(v){const r=new D.$3l;for(let s=0,n=v.length;s<n;s++)r.add(v[s].description.identifier);return r}static compute(v,r){if(!v||!v.length)return new $(r,[]);if(!r||!r.length)return new $([],v);const s=this.a(v),n=this.a(r),o=r.filter(d=>!s.has(d.description.identifier)),y=v.filter(d=>!n.has(d.description.identifier));return new $(o,y)}constructor(v,r){this.added=v,this.removed=r}}e.$YE=$;class f{constructor(v,r){this.name=v,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=$.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$Z)(v)}}}e.$ZE=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$1E={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$1l},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Sn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Sn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const r=new f(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,r),v.activationEventsGenerator&&k.$OE.register(v.extensionPoint,v.activationEventsGenerator),e.$1E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,a.registerSchema(i,e.$1E),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$2E=c;const b={ExtensionsRegistry:"ExtensionsRegistry"};l.$bn.add(b.ExtensionsRegistry,new c),e.$3E=l.$bn.as(b.ExtensionsRegistry),a.registerSchema(i,e.$1E),a.registerSchema(P.$oj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Re[213],Me([1,0,163,16,24,212,32,5]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var g;(function(a){function p($,f,t){if(!$)return;const i=M.$xf($.type)?$.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const b of $.required)M.$xf(b)&&c.push(b);return{extensionId:f.value,taskType:i,required:c,properties:$.properties?C.$2m($.properties):{},when:$.when?R.$Li.deserialize($.when):void 0}}a.from=p})(g||(g={}));const P=F.$3E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,p)=>{for(const $ of a)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new l.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{P.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const b of c)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const i of t.added){const c=i.value;for(const b of c){const E=g.from(b,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const f={type:"object",additionalProperties:!1};$.required.length>0&&(f.required=$.required.slice(0)),$.properties!==void 0?f.properties=C.$2m($.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[$.taskType]},p.push(f)}this.c={oneOf:p}}return this.c}}e.$KF=new k}),define(Re[214],Me([1,0,164,16,23,24,32,213]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$UF=e.JsonSchemaVersion=e.ExecutionEngine=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$OF=e.ShellQuoting=e.$NF=e.$MF=e.$LF=void 0,e.$LF="settings",e.$MF=new R.$5i("taskRunning",!1,w.localize(0,null)),e.$NF={value:w.localize(1,null),original:"Tasks"};var D;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$OF="$customized",function(O){function N(te){if(!te)return O.Strong;switch(te.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(D||(e.ShellQuoting=D={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(k||(e.RevealProblemKind=k={}));var a;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(a||(e.PanelKind=a={})),function(O){function N(te){switch(te.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(a||(e.PanelKind=a={}));var p;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function N(Z){switch(Z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function te(Z){switch(Z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=te}($||(e.RuntimeType=$={}));var f;(function(O){function N(te){return M.$xf(te)?te:te.value}O.value=N})(f||(e.CommandString=f={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Z){return Z===O.Clean._id||Z===O.Build._id||Z===O.Rebuild._id||Z===O.Test._id}O.is=N;function te(Z){if(Z!==void 0)return M.$xf(Z)?N(Z)?{_id:Z,isDefault:!1}:void 0:Z}O.from=te})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(te){switch(te){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(c||(e.TaskSourceKind=c={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b||(e.DependsOrder=b={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class r{constructor(N,te,Z,ye,Ee,Pe){this._label="",this._id=N,te&&(this._label=te),Z&&(this.type=Z),this.runOptions=ye,this.configurationProperties=Ee,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,te=!1){if(N===void 0)return!1;if(M.$xf(N))return N===this._label||N===this.configurationProperties.identifier||te&&N===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$PF=r;class s extends r{constructor(N,te,Z,ye,Ee,Pe,Y,ae){super(N,Z,void 0,Y,ae,te),this.command={},this._source=te,this.hasDefinedMatchers=Pe,Ee&&(this.command=Ee)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let te;switch(this.command?this.command.runtime:void 0){case $.Shell:te="shell";break;case $.Process:te="process";break;case $.CustomExecution:te="customExecution";break;case void 0:te="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:te,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Z={type:e.$OF,folder:N,id:te};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$QF=s;class n extends r{constructor(N,te,Z,ye,Ee,Pe,Y){super(N,Z,ye,Pe,Y,te),this._source=te,this.configures=Ee}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Z={type:e.$OF,folder:N,id:te};return JSON.stringify(Z)}}e.$RF=n;class o extends r{constructor(N,te,Z,ye,Ee,Pe,Y,ae,Se){super(N,Z,ye,ae,Se,te),this.defines=Ee,this.hasDefinedMatchers=Y,this.command=Pe,this.icon=Se.icon,this.hide=Se.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$SF=o;class y extends r{constructor(N,te,Z,ye,Ee,Pe){super(N,Z,ye,Ee,Pe,te),this._source=te}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$TF=y;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(O){O._default=O.Terminal}(d||(e.ExecutionEngine=d={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let te=0;te<N.length;te++)this.c.set(N[te].uri.toString(),te)}compare(N,te){const Z=N.getWorkspaceFolder(),ye=te.getWorkspaceFolder();if(Z&&ye){let Ee=this.c.get(Z.uri.toString());Ee=Ee===void 0?0:Ee+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,Ee===Pe?N._label.localeCompare(te._label):Ee-Pe}else return!Z&&ye?-1:Z&&!ye?1:0}}e.$UF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(O){O.SingleRun="singleRun",O.Background="background"})(m||(e.TaskRunType=m={}));var h;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var A;(function(O){function N(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function te(ae,Se,ue){return{...N(ae),kind:"start",terminalId:Se,resolvedVariables:ue}}O.start=te;function Z(ae,Se,ue){return{...N(ae),kind:"processStarted",terminalId:Se,processId:ue}}O.processStarted=Z;function ye(ae,Se,ue){return{...N(ae),kind:"processEnded",terminalId:Se,exitCode:ue}}O.processEnded=ye;function Ee(ae,Se,ue){return{...N(ae),kind:"terminated",exitReason:ue,terminalId:Se}}O.terminated=Ee;function Pe(ae,Se,ue){return{...N(Se),kind:ae,terminalId:ue}}O.general=Pe;function Y(){return{kind:"changed"}}O.changed=Y})(A||(e.TaskEvent=A={}));var W;(function(O){function N(Z){const ye=Object.keys(Z).sort();let Ee="";for(const Pe of ye){let Y=Z[Pe];Y instanceof Object?Y=N(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),Ee+=Pe+","+Y+","}return Ee}function te(Z){const Ee={_key:N(Z),type:Z.taskType};return Object.assign(Ee,Z),Ee}O.create=te})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var B;(function(O){function N(te,Z){const ye=l.$KF.get(te.type);if(ye===void 0){const ae=F.$2m(te);return delete ae._key,W.create(ae)}const Ee=Object.create(null);Ee.type=ye.taskType;const Pe=new Set;ye.required.forEach(ae=>Pe.add(ae));const Y=ye.properties;for(const ae of Object.keys(Y)){const Se=te[ae];if(Se!=null)Ee[ae]=Se;else if(Pe.has(ae)){const ue=Y[ae];if(ue.default!==void 0)Ee[ae]=F.$2m(ue.default);else switch(ue.type){case"boolean":Ee[ae]=!1;break;case"number":case"integer":Ee[ae]=0;break;case"string":Ee[ae]="";break;default:Z.error(w.localize(2,null,JSON.stringify(te,void 0,0),ae));return}}}return W.create(Ee)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Re[215],Me([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=e.$b4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,l)=>{this.b=R,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,w.$Z)(R))}then(R,l){return this.j().then(R,l)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$b4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new w.$4}}e.$c4b=C}),define(Re[46],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=void 0;class w{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++w.count}}e.$hv=w;const M=[];function C(l){const D=new w(l);return M[D.nid]=D,D}e.$iv=C;function F(l){return M[l].sid}e.$jv=F;class R{constructor(D){this.value=D}}e.$kv=R}),define(Re[3],Me([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var l;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$9J=k;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var p;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$0J={MainThreadAuthentication:(0,w.$iv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$iv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$iv)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.$iv)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$iv)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$iv)("MainThreadClipboard"),MainThreadCommands:(0,w.$iv)("MainThreadCommands"),MainThreadComments:(0,w.$iv)("MainThreadComments"),MainThreadConfiguration:(0,w.$iv)("MainThreadConfiguration"),MainThreadConsole:(0,w.$iv)("MainThreadConsole"),MainThreadDebugService:(0,w.$iv)("MainThreadDebugService"),MainThreadDecorations:(0,w.$iv)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$iv)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$iv)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$iv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$iv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$iv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$iv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$iv)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$iv)("MainThreadErrors"),MainThreadTreeViews:(0,w.$iv)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$iv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$iv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$iv)("MainThreadLanguages"),MainThreadLogger:(0,w.$iv)("MainThreadLogger"),MainThreadMessageService:(0,w.$iv)("MainThreadMessageService"),MainThreadOutputService:(0,w.$iv)("MainThreadOutputService"),MainThreadProgress:(0,w.$iv)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$iv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$iv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$iv)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$iv)("MainThreadSecretState"),MainThreadStorage:(0,w.$iv)("MainThreadStorage"),MainThreadTelemetry:(0,w.$iv)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$iv)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$iv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$iv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$iv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$iv)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$iv)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$iv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$iv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$iv)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$iv)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$iv)("MainThreadExtensionService"),MainThreadSCM:(0,w.$iv)("MainThreadSCM"),MainThreadSearch:(0,w.$iv)("MainThreadSearch"),MainThreadShare:(0,w.$iv)("MainThreadShare"),MainThreadTask:(0,w.$iv)("MainThreadTask"),MainThreadWindow:(0,w.$iv)("MainThreadWindow"),MainThreadLabelService:(0,w.$iv)("MainThreadLabelService"),MainThreadNotebook:(0,w.$iv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$iv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$iv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$iv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$iv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$iv)("MainThreadInteractive"),MainThreadChat:(0,w.$iv)("MainThreadChat"),MainThreadInlineChat:(0,w.$iv)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$iv)("MainThreadTheming"),MainThreadTunnelService:(0,w.$iv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$iv)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$iv)("MainThreadTimeline"),MainThreadTesting:(0,w.$iv)("MainThreadTesting"),MainThreadLocalization:(0,w.$iv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$iv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$iv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$iv)("MainThreadIssueReporter")},e.$$J={ExtHostCommands:(0,w.$iv)("ExtHostCommands"),ExtHostConfiguration:(0,w.$iv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$iv)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$iv)("ExtHostDebugService"),ExtHostDecorations:(0,w.$iv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$iv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$iv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$iv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$iv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$iv)("ExtHostEditors"),ExtHostTreeViews:(0,w.$iv)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$iv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$iv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$iv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$iv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$iv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$iv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$iv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$iv)("ExtHostStatusBar"),ExtHostShare:(0,w.$iv)("ExtHostShare"),ExtHostExtensionService:(0,w.$iv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$iv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$iv)("ExtHostTerminalService"),ExtHostSCM:(0,w.$iv)("ExtHostSCM"),ExtHostSearch:(0,w.$iv)("ExtHostSearch"),ExtHostTask:(0,w.$iv)("ExtHostTask"),ExtHostWorkspace:(0,w.$iv)("ExtHostWorkspace"),ExtHostWindow:(0,w.$iv)("ExtHostWindow"),ExtHostWebviews:(0,w.$iv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$iv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$iv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$iv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$iv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$iv)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$iv)("ExtHostProgress"),ExtHostComments:(0,w.$iv)("ExtHostComments"),ExtHostSecretState:(0,w.$iv)("ExtHostSecretState"),ExtHostStorage:(0,w.$iv)("ExtHostStorage"),ExtHostUrls:(0,w.$iv)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$iv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$iv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$iv)("ExtHostOutputService"),ExtHosLabelService:(0,w.$iv)("ExtHostLabelService"),ExtHostNotebook:(0,w.$iv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$iv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$iv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$iv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$iv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$iv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$iv)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$iv)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$iv)("ExtHostChat"),ExtHostChatAgents:(0,w.$iv)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$iv)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$iv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$iv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$iv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$iv)("ExtHostTheming"),ExtHostTunnelService:(0,w.$iv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$iv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$iv)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$iv)("ExtHostTimeline"),ExtHostTesting:(0,w.$iv)("ExtHostTesting"),ExtHostTelemetry:(0,w.$iv)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$iv)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$iv)("ExtHostIssueReporter")}}),define(Re[216],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(w.$0J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,l,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(l,D)??[]}getRelatedInformation(R,l,D){return this.c.$getAiRelatedInformation(l,D)}registerRelatedInformationProvider(R,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,l),new M.$_J(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Jdc=C}),define(Re[80],Me([1,0,4,14,3,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=e.$Mbc=void 0,e.$Mbc=(0,w.$Nh)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(C.$0J.MainThreadTelemetry)}report(D,g,P){const k=this.d(D,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$Nbc=R,e.$Nbc=R=Ke([We(0,F.$$L),We(1,M.$8i)],R),e.$Obc=Object.freeze(new class{report(l,D,g){}})}),define(Re[217],Me([1,0,5,3,7,20]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new w.$Md,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=g.getProxy(M.$0J.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,k,a={}){const p=F.$2l.toKey(g.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const f=g.displayName||g.name;return this.a.$getSession(P,k,p,f,a)})}async getSessions(g,P,k){const a=F.$2l.toKey(g.identifier),p=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${p}`,async()=>{await this.a.$ensureProvider(P);const $=g.displayName||g.name;return this.a.$getSessions(P,k,a,$)})}async removeSession(g,P){const k=this.b.get(g);return k?k.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,k,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===g)||this.c.push({id:g,label:P});const p=k.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(g,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,a?.supportsMultipleAccounts??!1),new C.$_J(()=>{p.dispose(),this.b.delete(g);const $=this.c.findIndex(f=>f.id===g);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,k){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$idc=R;class l{constructor(){this.a=new Map}getOrCreate(g,P){const k=this.a.get(g);if(k)return k;const a=P().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Re[218],Me([1,0,3,17,8]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;let F=class{constructor(l,D){this.a=l.getProxy(w.$0J.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,D,g){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$odc=F,e.$odc=F=Ke([We(0,M.$$L)],F)}),define(Re[219],Me([1,0,12,5,65,6,58,146,3,8]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class P{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=P.a++}}class k{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Md,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(D.$0J.MainThreadChat)}registerChatProvider(p,$,f){const t=new P(p,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,F.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const f=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof f=="number"&&this.g.$transferChatSession(f,$)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,f){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,f);if(!i)return;const c=k.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(p,$){const f=this.b.get(p);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(b=>g.ChatFollowup.from(b))}$removeRequest(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(p,$,f,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c)return;const b={session:c,message:typeof f.message=="string"?f.message:g.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))b.variables[o]=f.variables[o].map(g.ChatVariable.to);const E=R.$Id.create(!1);let v;const r={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const y=g.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this.g.$acceptResponseProgress(p,$,y),o.resolvedContent]);(0,w.$Hg)(d,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(p,$,u,S??void 0)})}else this.g.$acceptResponseProgress(p,$,y)}};let s;try{s=await i.provider.provideResponseWithProgress(b,r,t),s||(s={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const n={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:s.errorDetails,timings:n}}async $provideSlashCommands(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(b=>({...b,kind:g.CompletionItemKind.from(b.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Cdc=k}),define(Re[220],Me([1,0,12,6,71,3,8,7]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class D{static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(F.$0J.MainThreadChatAgents)}registerAgent(k,a,p,$){const f=D.a++;return this.b.set(f,{extension:k,agent:p}),this.c.$registerAgent(f,a,$),(0,M.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,a,p,$,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const b=new w.$bh;f.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,b.p);const E=t.agent({role:l.ChatMessageRole.User,content:p},{history:$.history.map(R.ChatMessage.to)},new C.$Zu(v=>{c(),this.c.$handleProgressChunk(a,{content:g(v.message)?v.message:v.message.value})}),f);try{return await(0,w.$Hg)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,b.complete()}}}e.$Ldc=D;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Re[221],Me([1,0,6,3,8,71,20]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class l{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new R.$4l,this.b=g.getProxy(M.$0J.MainThreadChatProvider)}registerProvider(g,P,k,a){const p=l.a++;return this.c.set(p,{extension:g,provider:k}),this.b.$registerProvider(p,P,{extension:g,displayName:a.name??g.value}),(0,w.$Pc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(g,P,k,a,p){const $=this.c.get(g);if(!$)return;const f=new F.$Zu(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(k.map(C.ChatMessage.to),a,f,p)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(g)},async makeRequest(a,p,$,f){if(!k.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,$);try{await k.b.$fetchResponse(g,P,t,a.map(C.ChatMessage.from),p,f)}finally{k.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$Hdc=l}),define(Re[222],Me([1,0,6,3,9,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$0J.MainThreadChatVariables)}async $resolveVariable(D,g,P){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:g},P);if(a)return a.map(F.ChatVariable.from)}catch(a){(0,C.$1)(a)}}registerVariableResolver(D,g,P,k){const a=R.a++;return this.b.set(a,{extension:D.identifier,data:{name:g,description:P},resolver:k}),this.c.$registerVariable(a,{name:g,description:P}),(0,w.$Pc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Idc=R}),define(Re[223],Me([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class M{constructor(F){const R=F.getProxy(w.$0J.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(l){return R.$writeText(l)}})}}e.$Rbc=M}),define(Re[31],Me([1,0,16,7,8,24,3,18,14,67,44,278,2,6,4,17,104,25,46,41,58,53,57]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=void 0;let s=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(R.$0J.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(R.$0J.MainThreadTelemetry),this.converter=new n(this,h=>{const A=this.c.get(h);return A?.result===y.Void?A:void 0},u),this.f=[{processArgument(h){return(0,g.$kh)(h)}},{processArgument(h){return(0,F.$4m)(h,function(A){if(P.$os.isIRange(A))return C.Range.to(A);if(k.$ns.isIPosition(A))return C.Position.to(A);if(P.$os.isIRange(A.range)&&a.URI.isUri(A.uri))return C.location.to(A);if(A instanceof i.$ae)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const h=S.args.map((W,V)=>{if(!W.validate(m[V]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof m[V]=="object"?JSON.stringify(m[V],null,"	"):m[V]} `);return W.convert(m[V])}),A=await this.executeCommand(S.internalId,...h);return S.result.convert(A,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$_J(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,h,A,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:h,metadata:A,extension:W}),S&&this.#e.$registerCommand(u),new M.$_J(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const A=(0,F.$4m)(u,function(W){if(W instanceof M.$aK)return C.Position.from(W);if(W instanceof M.$bK)return C.Range.from(W);if(W instanceof M.$lK)return C.location.from(W);if(M.$wL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return h=!0,i.$ae.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return h=!0,i.$ae.wrap(W);if(W instanceof i.$ae)return h=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,h?new c.$kv(A):A,m);return(0,g.$kh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,m){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:A,thisArg:W,metadata:V}=h;if(V?.args)for(let B=0;B<V.args.length;B++)try{(0,w.$Of)(u[B],V.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${V.args[B].name}' - ${V.args[B].description}`)}const U=E.$Id.create();try{return await A.apply(W,u)}catch(B){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(B,S,h.extension?.identifier),!m)throw B;if(h.extension?.identifier){const O=this.#i.onExtensionError(h.extension.identifier,B);this.d.trace("forwarded error to extension?",O,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.$yi)(B)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,U.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$fo(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(h=>this.f.reduce((A,W)=>W.processArgument(A,m.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:h}=m;h&&(S[u]=h)}return Promise.resolve(S)}};e.$tM=s,e.$tM=s=Ke([We(0,f.$$L),We(1,D.$8i),We(2,r.$sM)],s),e.$uM=(0,$.$Nh)("IExtHostCommands");class n{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const h=this.f(S.command);if(h)m.id=h.internalId,m.arguments=h.args.map((A,W)=>A.convert(S.arguments&&S.arguments[W]));else if((0,l.$Kb)(S.arguments)){const A=`${S.command} /${++this.c}`;this.b.set(A,S),u.add((0,p.$Pc)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),m.$ident=A,m.id=this.delegatingCommandId,m.arguments=[A],this.g.trace("CommandsConverter#CREATE",S.command,A)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$vM=n;class o{static{this.Uri=new o("uri","Uri of a text document",S=>a.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$aK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$bK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$cK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$vK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$PL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$lM,C.TestItem.from)}constructor(S,u,m,h){this.name=S,this.description=u,this.validate=m,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$wM=o;class y{static{this.Void=new y("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$xM=y;class d{constructor(S,u,m,h,A){this.id=S,this.internalId=u,this.description=m,this.args=h,this.result=A}}e.$yM=d}),define(Re[224],Me([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;const a=[new g.$yM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of DocumentHighlight-instances.",$(P.DocumentHighlight.to))),new g.$yM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$wM.Uri],new g.$xM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$Jb)(t))return;class c extends k.$qK{static to(E){const v=new c(E.name,P.SymbolKind.to(E.kind),E.containerName||"",new k.$lK(i[0],P.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=P.Range.to(E.selectionRange),v.children=E.children?E.children.map(c.to):[],v}}return t.map(c.to)})),new g.$yM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$wM.Uri,new g.$wM("options","Formatting options",t=>!0,t=>t)],new g.$xM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$yM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$wM.Uri,g.$wM.Range,new g.$wM("options","Formatting options",t=>!0,t=>t)],new g.$xM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$yM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$wM.Uri,g.$wM.Position,new g.$wM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$wM("options","Formatting options",t=>!0,t=>t)],new g.$xM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$yM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$yM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$yM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$yM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$yM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Location-instances.",$(P.location.to))),new g.$yM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of Hover-instances.",$(P.Hover.to))),new g.$yM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$wM.Uri,new g.$wM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$aK.isPosition(i)),t=>t.map(P.Position.from))],new g.$xM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const b of i.reverse())c=new k.$uK(P.Range.to(b),c);return c}))),new g.$yM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$wM.String.with("query","Search string")],new g.$xM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$yM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$yM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$wM.CallHierarchyItem],new g.$xM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$yM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$wM.CallHierarchyItem],new g.$xM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$yM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$yM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$wM.Uri,g.$wM.Position,g.$wM.String.with("newName","The new symbol name")],new g.$xM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$yM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$wM.Uri,g.$wM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$xM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$yM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$wM.Uri],new g.$xM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$oL(t.tokenTypes,t.tokenModifiers)})),new g.$yM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$wM.Uri],new g.$xM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$O0)(t);if(i.type==="full")return new k.$qL(i.data,void 0)})),new g.$yM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$wM.Uri,g.$wM.Range.optional()],new g.$xM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$oL(t.tokenTypes,t.tokenModifiers)})),new g.$yM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$wM.Uri,g.$wM.Range],new g.$xM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$O0)(t);if(i.type==="full")return new k.$qL(i.data,void 0)})),new g.$yM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$wM.Uri,g.$wM.Position,g.$wM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$wM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$xM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new k.$GK([]);const b=t.suggestions.map(E=>P.CompletionItem.to(E,c));return new k.$GK(b,t.incomplete)})),new g.$yM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$wM.Uri,g.$wM.Position,g.$wM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$xM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$yM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$wM.Uri,g.$wM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$xM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(b=>new k.$yK(P.Range.to(b.range),b.command&&c.fromInternal(b.command)))(t))),new g.$yM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$wM.Uri,new g.$wM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$bK.isRange(t),t=>k.$cK.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$wM.String.with("kind","Code action kind to return code actions for").optional(),g.$wM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$xM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(b.command)}else{const E=new k.$sK(b.title,b.kind?new k.$tK(b.kind):void 0);return b.edit&&(E.edit=P.WorkspaceEdit.to(b.edit)),b.command&&(E.command=c.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new g.$yM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$wM.Uri],new g.$xM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$MK(P.Range.to(i.range),P.Color.to(i.color))):[])),new g.$yM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$wM("color","The color to show and insert",t=>t instanceof k.$LK,P.Color.from),new g.$wM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$xM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$yM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$wM.Uri,g.$wM.Range],new g.$xM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new g.$yM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$wM.Uri],new g.$xM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$yM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$xM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new g.$yM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$wM.Uri,g.$wM.Range,new g.$wM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$bK,t=>P.InlineValueContext.from(t))],new g.$xM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$yM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$wM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$8T)(t,M.Schemas.http,M.Schemas.https),t=>t),new g.$wM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$wM.String.with("label","").optional()],g.$xM.Void),new g.$yM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$wM.Uri.with("resource","Resource to open"),g.$wM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$wM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$xM.Void),new g.$yM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$wM.Uri.with("left","Left-hand side resource of the diff editor"),g.$wM.Uri.with("right","Right-hand side resource of the diff editor"),g.$wM.String.with("title","Human readable title for the diff editor").optional(),new g.$wM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$xM.Void),new g.$yM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$wM.Uri,g.$wM.Position],new g.$xM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$yM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$wM.TypeHierarchyItem],new g.$xM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$yM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$wM.TypeHierarchyItem],new g.$xM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$yM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$wM.TestItem],g.$xM.Void),new g.$yM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$wM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$xM.Void),new g.$yM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$wM.String.with("name","The context key name"),new g.$wM("value","The context key value",()=>!0,t=>t)],g.$xM.Void),new g.$yM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$wM.Uri,g.$wM.StringArray,new g.$wM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$xM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Mi)}}e.$Qbc=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const c of t)F.$_s(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Re[225],Me([1,0,12,64,5,6,2,78,20,8,7,3,26]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;function p($,f,t){const i=$.getProxy(k.$0J.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$4l,f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const I=this.b.get(d.handle);return I?I.value:d}else if(d&&d.$mid===7){const I=this.b.get(d.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.commentUniqueId,m=S.getCommentByUniqueId(u);return m||d}else if(d&&d.$mid===11){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.text,m=d.commentUniqueId,h=S.getCommentByUniqueId(m);return h?(typeof h.body=="string"?h.body=u:h.body=new P.$zK(u),h):d}return d}})}createCommentController(d,I,S){const u=c.a++,m=new E(d,u,I,S);this.b.set(m.handle,m);const h=this.c.get(d.identifier)||[];return h.push(m),this.c.set(d.identifier,h),m.value}$createCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(d,I){this.b.get(d)?.$deleteCommentThread(I)}$provideCommentingRanges(d,I,S){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(R.URI.revive(I));return(0,w.$Lg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(m,S);let A;return Array.isArray(h)?A={ranges:h,fileComments:!1}:h?A={ranges:h.ranges||[],fileComments:h.fileComments||!1}:A=h??void 0,A}).then(h=>{let A;return h&&(A={ranges:h.ranges.map(W=>g.Range.from(W)),fileComments:h.fileComments}),A})}$toggleReaction(d,I,S,u,m){const h=this.b.get(d);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,w.$Lg)(()=>{const A=h.getCommentThread(I);if(A){const W=A.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&W&&h.reactionHandler)return h.reactionHandler(W,s(m))}return Promise.resolve(void 0)})}}class b{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,I,S,u,m,h,A,W){this.m=I,this.n=S,this.o=u,this.p=m,this.q=h,this.extensionDescription=A,this.r=W,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Sc,this.l.value=new F.$Qc,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Qc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};d("range")&&(I.range=g.Range.from(this.p)),d("label")&&(I.label=this.label),d("contextValue")&&(I.contextValue=this.contextValue??null),d("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(I.collapseState=n(this.g)),d("canReply")&&(I.canReply=this.canReply),d("state")&&(I.state=o(this.h)),d("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(d){for(const I of this.k){const S=I[0],u=I[1];if(d===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ke([(0,M.$gh)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,I,S,u){this.f=d,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,A,W){return m.createCommentThread(h,A,W).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,I,S){I===void 0&&(0,a.$0E)(this.f,"fileComments");const u=new b(this.id,this.handle,void 0,d,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,I){const S=new b(this.id,this.handle,void 0,R.URI.revive(d),g.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,I){const S=this.a.get(d);S&&(S.range=g.Range.to(I))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function v(y,d,I,S){let u=I.get(d);return u||(u=++y.commentHandle,I.set(d,u)),d.state!==void 0&&(0,a.$0E)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:g.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(m=>r(m)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?g.$0L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function s(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?R.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function n(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$Sbc=p}),define(Re[226],Me([1,0,24,3,27,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let R=class{constructor(P,k){this.a=P.getProxy(M.$0J.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,k){const a=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a.e(P,k,p,arguments)}})}e(P,k,a,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(p,this.b)}),this.c&&this.f(P,a,p)}};e.$Odc=R,e.$Odc=R=Ke([We(0,F.$$L),We(1,C.$oM)],R);const l=1e5;function D(g,P){const k=[];if(g.length)for(let a=0;a<g.length;a++){let p=g[a];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}k.push(p)}if(P){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.$7m)(k);return a.length>l?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Re[107],Me([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;let p=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(M.$0J.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=a.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(i,null);return}const E=(0,D.$2b)(b);if(E.length<=a.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(n=>({uri:n,rank:(0,g.$Fe)(n.path,"/")})),r=(0,D.$yb)(v,(n,o)=>n.rank-o.rank||(0,g.$Te)(n.uri.path,o.uri.path)),s=[];e:for(const n of r){let o;for(const y of n){const d=(0,P.$lc)(y.uri.path);if(o!==d&&(o=d,s.push(y.uri)>=a.d))break e}}this.g.$onDidChange(i,s)});return new C.$_J(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async v=>{try{const{uri:r,id:s}=v,n=await Promise.resolve(b.provideFileDecoration(w.URI.revive(r),i));if(!n)return;try{C.$uL.validate(n),n.badge&&typeof n.badge!="string"&&(0,k.$0E)(E,"codiconDecoration"),c[s]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),c}};e.$Tcc=p,e.$Tcc=p=a=Ke([We(0,R.$$L),We(1,l.$8i)],p),e.$Ucc=(0,F.$Nh)("IExtHostDecorations")}),define(Re[227],Me([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;class p{#e;#t;#i;constructor(t,i,c,b,E,v,r,s){this.d=t,this.e=i,this.f=c,this.g=b,this.h=E,this.c=!1,this.f=Math.max(b,c),this.#i=new P.$zc(n=>v.getComparisonKey(n)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let v;t=[...t].sort(p.k);for(const r of t){const[s,n]=r;if((!v||s.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=s,c.push(s),this.#i.set(s,[])),n)this.#i.get(s)?.push(...n);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const b=[];let E=0;for(const v of c){let r=[];const s=this.#i.get(v);if(s)if(s.length>this.g){r=[];const n=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of s)if(y.severity===n[o]&&r.push({...l.Diagnostic.from(y),modelVersionId:this.h(v)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(n=>({...l.Diagnostic.from(n),modelVersionId:this.h(v)}));if(b.push([v,r]),E+=r.length,E>this.f)break}this.#e.$changeMany(this.e,b)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,b]of this)t.call(i,c,b,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Kbc=p;let $=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new P.$zc;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,b){this.j=i,this.k=c,this.l=b,this.g=new Map,this.h=new D.$Qd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(F.$0J.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:b,h:E,j:v,k:r,l:s}=this,n=new class{$changeMany(d,I){b.$changeMany(d,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,I.length===0?"CLEARING":I)}$clear(d){b.$clear(d),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){b.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,a.e,a.d,d=>s.getDocument(d)?.version,r.extUri,n,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const b of this.g.values())b.forEach((E,v)=>{let r=i.get(E.toString());typeof r>"u"&&(r=c.length,i.set(E.toString(),r),c.push([E,[]])),c[r][1]=c[r][1].concat(...v)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$Lbc=$,e.$Lbc=$=a=Ke([We(1,g.$8i),We(2,k.$Jbc)],$)}),define(Re[228],Me([1,0,2,3,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class F{constructor(l){this.a=l.getProxy(M.$0J.MainThreadDialogs)}showOpenDialog(l,D){return D?.allowUIResources&&(0,C.$0E)(l,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(D=>D?w.URI.revive(D):void 0)}}e.$1bc=F}),define(Re[229],Me([1,0,9,2,7,3,13,21,15]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class g{static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(F.$0J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=g.a++;this.b.set(p,a),this.c.$registerTextContentProvider(p,k);let $;return typeof a.onDidChange=="function"&&($=a.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(p,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const c=(0,D.$Oe)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(f,t)},w.$Z)})),new C.$_J(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(k,a){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(a),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$2bc=g}),define(Re[230],Me([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;class a{constructor($,f){this.a=new w.$Md({onListenerError:k.$1}),this.b=new w.$Md({onListenerError:k.$1}),this.c=new w.$Md({onListenerError:k.$1}),this.d=new w.$Md({onListenerError:k.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Qc,this.h=new Map,this.f=$.getProxy(F.$0J.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const f=this.g.getDocument($);if(f)return f}getDocument($){const f=this.getDocumentData($);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return f.document}ensureDocumentData($){const f=this.g.getDocument($);if(f)return Promise.resolve(f);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,D.$If)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged($,f){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved($){const f=C.URI.revive($),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,f){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,f,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let b;f.isUndoing?b=P.TextDocumentChangeReason.Undo:f.isRedoing&&(b=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$3m)({document:c.document,contentChanges:f.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor($,f){(0,R.$aM)($,f)}}e.$Hbc=a}),define(Re[59],Me([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,65,48]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new p.$zc,this.d=new M.$Md,this.e=new M.$Md,this.f=new M.$Md,this.g=new M.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],r=[],s=[];if(E.removedDocuments)for(const n of E.removedDocuments){const o=F.URI.revive(n),y=this.c.get(o);y?.unref()&&(this.c.delete(o),v.push(y.value))}if(E.addedDocuments)for(const n of E.addedDocuments){const o=F.URI.revive(n.uri);let y=this.c.get(o);if(y&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new i(new D.$bM(this.h.getProxy(l.$0J.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(o,y),r.push(y.value)),y.ref()}if(E.removedEditors)for(const n of E.removedEditors){const o=this.b.get(n);this.b.delete(n),o&&s.push(o)}if(E.addedEditors)for(const n of E.addedEditors){const o=F.URI.revive(n.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const y=this.c.get(o).value,d=new P.$hM(n.id,this.h.getProxy(l.$0J.MainThreadTextEditors),this.i,new t.$U(()=>y.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(I=>k.Range.to(I)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,d)}E.newActiveEditor!==void 0&&(w.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Mc)(v),(0,C.$Mc)(s),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(r),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return f.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$iM=c,e.$iM=c=Ke([We(0,g.$$L),We(1,a.$8i)],c),e.$jM=(0,R.$Nh)("IExtHostDocumentsAndEditors")}),define(Re[60],Me([1,0,8,3,2,5,4,7,17,16,231]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=void 0,e.$Ycc=(0,R.$Nh)("IExtHostEditorTabs");class k{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$QL(C.URI.revive(this.b.input.uri));case 2:return new l.$RL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$SL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$TL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$UL(this.b.input.viewType);case 4:return new l.$VL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$WL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$XL;case 9:return new l.$YL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new F.$Md,this.c=new F.$Md,this.e=[],this.a=t.getProxy(M.$0J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,g.$If)(t.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,b)=>{const E=Array.isArray(c)?c:[c];return E.length?$(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),b=(0,P.$K)(i,c),E=this.e.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),v=[],r=[];this.e=t.map(n=>{const o=new a(n,()=>this.d);return b.added.includes(o.groupId)?v.push(o.apiObject):r.push(o.apiObject),o});const s=(0,g.$If)(t.find(n=>n.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:v,closed:E,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(b=>b.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const b of t){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const b of t){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,i)}};e.$Zcc=p,e.$Zcc=p=Ke([We(0,D.$$L)],p);function $(f){return f.tabs!==void 0}}),define(Re[232],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(w.$0J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,l,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(l,D);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(R,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider(l,g),new M.$_J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Kdc=C}),define(Re[233],Me([1,0,2,3,6,7,8,279,15,25,26,50]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,c,b=14,E=14;for(const v of f){let r=i?(0,D.$3e)(i,v):0;for(r===0?c=1:c=E;r<v.length;r++)r+1===v.length?(b=E,E=9):E+=1,t.push([c,v.toUpperCase().charCodeAt(r),E]),t.push([c,v.toLowerCase().charCodeAt(r),E]),c=E;i=v,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$QY(t)}}provideDocumentLinks(f){this.c();const t=[],i=l.$RY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of i){const b=R.DocumentLink.to(c);b.target&&t.push(b)}return t}}class p{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(M.$0J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,i);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$0E)(f,"fsChunks"),E+=4);let v;c.isReadonly&&(0,k.$3j)(c.isReadonly)&&((0,P.$0E)(f,"readonlyMessage"),v={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(b,t,E,v).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const n=[];for(const o of s){const{uri:y,type:d}=o;if(y.scheme!==t)continue;let I;switch(d){case F.FileChangeType.Changed:I=0;break;case F.FileChangeType.Created:I=1;break;case F.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:y,type:I})}this.a.$onFileSystemChange(b,n)});return(0,C.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:c,size:b,permissions:E}=f;return{type:t,ctime:i,mtime:c,size:b,permissions:E}}$stat(f,t){return Promise.resolve(this.l(f).stat(w.URI.revive(t))).then(i=>p.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(w.URI.revive(t))).then(i=>g.$ae.wrap(i))}$writeFile(f,t,i,c){return Promise.resolve(this.l(f).writeFile(w.URI.revive(t),i.buffer,c))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(w.URI.revive(t),i))}$rename(f,t,i,c){return Promise.resolve(this.l(f).rename(w.URI.revive(t),w.URI.revive(i),c))}$copy(f,t,i,c){const b=this.l(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(w.URI.revive(t),w.URI.revive(i),c))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(w.URI.revive(t)))}$watch(f,t,i,c){const b=this.l(f).watch(w.URI.revive(i),c);this.f.set(t,b)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,c){const b=this.l(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=g.$ae.alloc(c);return Promise.resolve(b.read(t,i,E.buffer,0,c)).then(v=>E.slice(0,v))}$write(f,t,i,c){const b=this.l(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,i,c.buffer,0,c.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$vcc=p}),define(Re[61],Me([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new P.$2g,this.a=t.getProxy(w.$0J.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(b){try{let E;const v=c.b.get(b.scheme);return v?(await c.a.$ensureActivation(b.scheme),E=await v.impl.stat(b)):E=await c.a.$stat(b),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readDirectory(b)).slice()):await c.a.$readdir(b)}catch(E){return p.e(E)}},async createDirectory(b){try{const E=c.b.get(b.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(E.impl,E.extUri,b)):await c.a.$mkdir(b)}catch(E){return p.e(E)}},async readFile(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readFile(b)).slice()):(await c.a.$readFile(b)).buffer}catch(E){return p.e(E)}},async writeFile(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(v.impl,v.extUri,v.extUri.dirname(b)),await c.c.queueFor(b).queue(()=>Promise.resolve(v.impl.writeFile(b,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(b,F.$ae.wrap(E))}catch(v){return p.e(v)}},async delete(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await v.impl.delete(b,{recursive:!1,...E})):await c.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return p.e(v)}},async rename(b,E,v){try{return await c.a.$rename(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},async copy(b,E,v){try{return await c.a.$copy(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},isWritableFileSystem(b){const E=i.getCapabilities(b);if(typeof E=="number")return!(E&2048)}})}async d(t,i,c){const b=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$mL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$lk(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;b.push(i.basename(c)),c=i.dirname(c)}for(let E=b.length-1;E>=0;E--){c=i.joinPath(c,b[E]);try{await t.createDirectory(c)}catch(v){if(M.$lk(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$mL)throw t;if(t instanceof M.$hk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$mL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$mL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$mL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$mL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$mL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$mL.Unavailable(t.message);default:throw new C.$mL(t.message,t.name)}if(!(t instanceof Error))throw new C.$mL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$mL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$mL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$mL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$mL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$mL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$mL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$mL.Unavailable(t.message);default:throw new C.$mL(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?k.$kg:k.$mg,isReadonly:!!c?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$kg}};e.$bcc=$,e.$bcc=$=p=Ke([We(0,l.$$L),We(1,D.$Jbc)],$),e.$ccc=(0,R.$Nh)("IExtHostConsumerFileSystem")}),define(Re[234],Me([1,0,5,37,2,3,8,7,48]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class g{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(p,$,f,t,i,c,b,E){this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md;const v=this.h(p,f,i);this.g=0,c&&(this.g+=1),b&&(this.g+=2),E&&(this.g+=4);const r=(0,M.$uj)(i),s=typeof i=="string",n=t(o=>{if(!c)for(const y of o.created){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.a.fire(d)}if(!b)for(const y of o.changed){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.b.fire(d)}if(!E)for(const y of o.deleted){const d=C.URI.revive(y);r(d.fsPath)&&(!s||$.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=l.$_J.from(v,this.a,this.b,this.c,n)}h(p,$,f){const t=l.$_J.from();if(typeof f=="string")return t;const i=p.getProxy(F.$0J.MainThreadFileSystem);let c=!1;(f.pattern.includes(M.$qj)||f.pattern.includes(M.$rj))&&(c=!0);const b=Math.random();return i.$watch($.identifier.value,b,f.baseUri,{recursive:c,excludes:[]}),l.$_J.from({dispose:()=>i.$unwatch(b)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class P{constructor(p){this.a=p,this.b=new D.$U(()=>this.a.created.map(C.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,$,f){this.j=p,this.k=$,this.l=f,this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md,this.d=new w.$Md,this.g=new w.$Od,this.h=new w.$Od,this.i=new w.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,$,f,t,i,c){return new g(this.j,p,$,this.a.event,R.GlobPattern.from(f),t,i,c)}$onFileEvent(p){this.a.fire(new P(p))}$onDidRunFileOperation(p,$){switch(p){case 2:this.b.fire(Object.freeze({files:$.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(f=>C.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(f=>C.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,$){return(f,t,i)=>{const c=function(E){f.call(t,E)};return c.extension=p,$.event(c,void 0,i)}}async $onWillRunFileOperation(p,$,f,t){switch(p){case 2:return await this.n(this.g,{files:$.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:$.map(i=>C.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:$.map(i=>C.URI.revive(i.target))},f,t)}}async n(p,$,f,t){const i=new Set,c=[];if(await p.fireAsync($,t,async(E,v)=>{const r=Date.now(),s=await Promise.resolve(E);s instanceof l.$jK&&(c.push([v.extension,s]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const b={edits:[]};for(const[,E]of c){const{edits:v}=R.WorkspaceEdit.from(E,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(v)}return{edit:b,extensionNames:Array.from(i)}}}e.$wcc=k}),define(Re[235],Me([1,0,6,2,3,8,7,31,12]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class g{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=g.a++}}class P{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,$,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$0J.MainThreadInlineChat),$.registerApiCommand(new l.$yM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$wM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?F.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?F.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?F.Position.from(i.position):void 0}})],l.$xM.Void))}registerProvider(p,$,f){const t=new g(p,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,p.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(p,$,f,t){const i=this.b.get(p);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(M.URI.revive($)),b=F.Selection.to(f),E=await i.provider.prepareInteractiveEditorSession({document:c,selection:b},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=k.a++;return this.d.set(v,new P(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:F.Range.from(E.wholeRange),message:E.message}}async $provideResponse(p,$,f,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($.id);if(!c)return;const b={prompt:f.prompt,selection:F.Selection.to(f.selection),wholeRange:F.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let E=!1;const v={report:async d=>{if(!f.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||!d.message&&!d.edits||await this.e.$handleProgressChunk(f.requestId,{message:d.message,edits:d.edits?.map(F.TextEdit.from)})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(c.session,b,v,t));let s;try{s=await(0,D.$Hg)(r,t)}finally{E=!0}if(!s)return;const n=c.responses.push(s)-1,o={wholeRange:F.Range.from(s.wholeRange),placeholder:s.placeholder};if(k.h(s))return{...o,id:n,type:"message",message:F.MarkdownString.from(s.contents)};const{edits:y}=s;return y instanceof R.$jK?{...o,id:n,type:"bulkEdit",edits:F.WorkspaceEdit.from(y)}:{...o,id:n,type:"editorEdit",edits:y.map(F.TextEdit.from)}}$handleFeedback(p,$,f,t){const i=this.b.get(p),c=this.d.get($),b=c?.responses[f];if(i&&b){const E=F.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(c.session,b,E)}}$releaseSession(p,$){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Ddc=k}),define(Re[236],Me([1,0,2,31]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class C{constructor(R,l,D,g,P){this.a=l,this.b=D,this.c=g;const k=new M.$yM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$wM("showOptions","Show Options",a=>!0,a=>a),new M.$wM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$wM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$wM("title","Interactive editor title",a=>!0,a=>a)],new M.$xM("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const p=this.a.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,l,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$zdc=C}),define(Re[237],Me([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class C{constructor(R){this.a=new Map,this.b=R.getProxy(w.$0J.MainThreadIssueReporter)}async $getIssueReporterUri(R,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(R,l){const D=R.identifier.value;return this.a.set(D,l),this.b.$registerIssueUriRequestHandler(D),new M.$_J(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$Fdc=C}),define(Re[238],Me([1,0,6,3]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(M.$0J.MainThreadLabelService)}$registerResourceLabelFormatter(R){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,R),(0,w.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$Scc=C}),define(Re[239],Me([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,74,58,9,12,26,149]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0;class n{constructor(L,K){this.d=L,this.e=K}async provideDocumentSymbols(L,K){const G=this.d.getDocument(L),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Jb)(Q))return Q[0]instanceof F.$rK?Q.map(C.DocumentSymbol.from):n.f(Q)}static f(L){L=L.slice(0).sort((Q,H)=>{let _=Q.location.range.start.compareTo(H.location.range.start);return _===0&&(_=H.location.range.end.compareTo(Q.location.range.end)),_});const K=[],G=[];for(const Q of L){const H={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(H),K.push(H);break}const _=G[G.length-1];if(g.$os.containsRange(_.range,H.range)&&!g.$os.equalsRange(_.range,H.range)){_.children?.push(H),G.push(H);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(L,K,G){this.g=L,this.h=K,this.j=G,this.e=new c.$Gbc("CodeLens"),this.f=new Map}async provideCodeLenses(L,K){const G=this.g.getDocument(L),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const H=this.e.add(Q),_=new f.$Qc;this.f.set(H,_);const ce={cacheId:H,lenses:[]};for(let Fe=0;Fe<Q.length;Fe++)ce.lenses.push({cacheId:[H,Fe],range:C.Range.from(Q[Fe].range),command:this.h.toInternal(Q[Fe].command,_)});return ce}async resolveCodeLens(L,K){const G=L.cacheId&&this.e.get(...L.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const H=L.cacheId&&this.f.get(L.cacheId[0]);if(H)return L.command=this.h.toInternal(Q.command??o.d,H),L}releaseCodeLenses(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class d{constructor(L,K){this.d=L,this.e=K}async provideDefinition(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideDefinition(Q,H,G);return y(_)}}class I{constructor(L,K){this.d=L,this.e=K}async provideDeclaration(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideDeclaration(Q,H,G);return y(_)}}class S{constructor(L,K){this.d=L,this.e=K}async provideImplementation(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideImplementation(Q,H,G);return y(_)}}class u{constructor(L,K){this.d=L,this.e=K}async provideTypeDefinition(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideTypeDefinition(Q,H,G);return y(_)}}class m{constructor(L,K){this.d=L,this.e=K}async provideHover(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideHover(Q,H,G);if(!(!_||(0,P.$Jb)(_.contents)))return _.range||(_.range=Q.getWordRangeAtPosition(H)),_.range||(_.range=new F.$bK(H,H)),C.Hover.from(_)}}class h{constructor(L,K){this.d=L,this.e=K}async provideEvaluatableExpression(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideEvaluatableExpression(Q,H,G);if(_)return C.EvaluatableExpression.from(_)}}class A{constructor(L,K){this.d=L,this.e=K}async provideInlineValues(L,K,G,Q){const H=this.d.getDocument(L),_=await this.e.provideInlineValues(H,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(_))return _.map(ce=>C.InlineValue.from(ce))}}class W{constructor(L,K){this.d=L,this.e=K}async provideDocumentHighlights(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideDocumentHighlights(Q,H,G);if(Array.isArray(_))return _.map(C.DocumentHighlight.from)}}class V{constructor(L,K){this.d=L,this.e=K}async provideLinkedEditingRanges(L,K,G){const Q=this.d.getDocument(L),H=C.Position.to(K),_=await this.e.provideLinkedEditingRanges(Q,H,G);if(_&&Array.isArray(_.ranges))return{ranges:(0,P.$Gb)(_.ranges.map(C.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(L,K){this.d=L,this.e=K}async provideReferences(L,K,G,Q){const H=this.d.getDocument(L),_=C.Position.to(K),ce=await this.e.provideReferences(H,_,G,Q);if(Array.isArray(ce))return ce.map(C.location.from)}}class B{static{this.d=1e3}constructor(L,K,G,Q,H,_,ce){this.g=L,this.h=K,this.j=G,this.k=Q,this.l=H,this.m=_,this.n=ce,this.e=new c.$Gbc("CodeAction"),this.f=new Map}async provideCodeActions(L,K,G,Q){const H=this.g.getDocument(L),_=a.$qs.isISelection(K)?C.Selection.to(K):C.Range.to(K),ce=[];for(const Ye of this.j.getDiagnostics(L))if(_.intersection(Ye.range)&&ce.push(Ye)>B.d)break;const Fe={diagnostics:ce,only:G.only?new F.$tK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(H,_,Fe,Q);if(!(0,P.$Kb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),Je=new f.$Qc;this.f.set(Qe,Je);const xe=[];for(let Ye=0;Ye<Ue.length;Ye++){const _e=Ue[Ye];_e&&(B.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Je)})):(Fe.only&&(_e.kind?Fe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Ye],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Je),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,r.$9E)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(L,K){const[G,Q]=L,H=this.e.get(G,Q);if(!H||B.o(H))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(H,K)??H;let ce;_.edit&&(ce=C.WorkspaceEdit.from(_.edit,void 0));let Fe;if(_.command){const Ue=this.f.get(G);Ue&&(Fe=this.h.toInternal(_.command,Ue))}return{edit:ce,command:Fe}}releaseCodeActions(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}static o(L){return typeof L.command=="string"&&typeof L.title=="string"}}class O{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,G,Q,H){this.d=L,this.e=K,this.f=G,this.g=Q,this.h=H}async prepareDocumentPaste(L,K,G,Q){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(L),_=K.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new E.$0});if(await this.f.prepareDocumentPaste(H,_,ce,Q),Q.isCancellationRequested)return;const Fe=Array.from(ce).filter(([,Ue])=>!(Ue instanceof F.$ZK));return C.DataTransfer.from(Fe)}async providePasteEdits(L,K,G,Q,H){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(K),ce=G.map(Qe=>C.Range.to(Qe)),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,L,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(_,ce,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(L,K){this.d=L,this.e=K}async provideDocumentFormattingEdits(L,K,G){const Q=this.d.getDocument(L),H=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(H))return H.map(C.TextEdit.from)}}class te{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeFormattingEdits(L,K,G,Q){const H=this.d.getDocument(L),_=C.Range.to(K),ce=await this.e.provideDocumentRangeFormattingEdits(H,_,G,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(L,K,G,Q){(0,k.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(L),_=K.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(H,_,G,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class Z{constructor(L,K){this.d=L,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,K,G,Q,H){const _=this.d.getDocument(L),ce=C.Position.to(K),Fe=await this.e.provideOnTypeFormattingEdits(_,ce,G,Q,H);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class ye{constructor(L,K){this.e=L,this.f=K,this.d=new c.$Gbc("WorkspaceSymbols")}async provideWorkspaceSymbols(L,K){const G=await this.e.provideWorkspaceSymbols(L,K);if(!(0,P.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),H={cacheId:Q,symbols:[]};for(let _=0;_<G.length;_++){const ce=G[_];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}H.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[Q,_]})}return H}async resolveWorkspaceSymbol(L,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const G=this.d.get(...L.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,M.$5m)(L,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(L){this.d.delete(L)}}class Ee{static supportsResolving(L){return typeof L.prepareRename=="function"}constructor(L,K,G){this.d=L,this.e=K,this.f=G}async provideRenameEdits(L,K,G,Q){const H=this.d.getDocument(L),_=C.Position.to(K);try{const ce=await this.e.provideRenameEdits(H,_,G,Q);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Fe=Ee.g(ce);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(L,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(L),H=C.Position.to(K);try{const _=await this.e.prepareRename(Q,H,G);let ce,Fe;if(F.$bK.isRange(_)?(ce=_,Fe=Q.getText(_)):(0,k.$zf)(_)&&(ce=_.range,Fe=_.placeholder),!ce||!Fe)return;if(ce.start.line>H.line||ce.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Fe}}catch(_){const ce=Ee.g(_);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(_)}}static g(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Pe{constructor(L,K){this.resultId=L,this.tokens=K}}class Y{constructor(L,K){this.f=L,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(L,K,G){const Q=this.f.getDocument(L),H=K!==0?this.d.get(K):null;let _=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,H.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return H&&this.d.delete(K),_?(_=Y.h(_),this.o(Y.n(H,_),_)):null}async releaseDocumentSemanticColoring(L){this.d.delete(L)}static h(L){return Y.j(L)?Y.k(L)?L:new F.$qL(new Uint32Array(L.data),L.resultId):Y.l(L)?Y.m(L)?L:new F.$sL(L.edits.map(K=>new F.$rL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),L.resultId):L}static j(L){return L&&!!L.data}static k(L){return L.data instanceof Uint32Array}static l(L){return L&&Array.isArray(L.edits)}static m(L){for(const K of L.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(L,K){if(!Y.j(K)||!L||!L.tokens)return K;const G=L.tokens,Q=G.length,H=K.data,_=H.length;let ce=0;const Fe=Math.min(Q,_);for(;ce<Fe&&G[ce]===H[ce];)ce++;if(ce===Q&&ce===_)return new F.$sL([],K.resultId);let Ue=0;const Qe=Fe-ce;for(;Ue<Qe&&G[Q-Ue-1]===H[_-Ue-1];)Ue++;return new F.$sL([{start:ce,deleteCount:Q-ce-Ue,data:H.subarray(ce,_-Ue)}],K.resultId)}o(L,K){if(Y.j(L)){const G=this.e++;return this.d.set(G,new Pe(L.resultId,L.data)),(0,t.$N0)({id:G,type:"full",data:L.data})}if(Y.l(L)){const G=this.e++;return Y.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(L.resultId)),(0,t.$N0)({id:G,type:"delta",deltas:(L.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ae{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeSemanticTokens(L,K,G){const Q=this.d.getDocument(L),H=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return H?this.f(H):null}f(L){return(0,t.$N0)({id:0,type:"full",data:L.data})}}class Se{static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}constructor(L,K,G,Q,H){this.f=L,this.g=K,this.h=G,this.j=Q,this.k=H,this.d=new c.$Gbc("CompletionItem"),this.e=new Map}async provideCompletionItems(L,K,G,Q){const H=this.f.getDocument(L),_=C.Position.to(K),ce=H.getWordRangeAtPosition(_)||new F.$bK(_,_),Fe=ce.with({end:_}),Ue=new b.$Id,Qe=await this.h.provideCompletionItems(H,_,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const Je=Array.isArray(Qe)?new F.$GK(Qe):Qe,xe=Se.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),Ye=new f.$Qc;this.e.set(xe,Ye);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(Fe)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Je.items.length;tt++){const ze=Je.items[tt],st=this.l(ze,[xe,tt],Fe,ce);_e.push(st)}return it}async resolveCompletionItem(L,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...L);if(!G)return;const Q=this.l(G,L),H=await this.h.resolveCompletionItem(G,K);if(!H)return;const _=this.l(H,L);return(Q.h!==_.h||Q.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==_.n||Q.o!==_.o||!(0,M.$6m)(Q.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K,G,Q){const H=this.e.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const _=this.g.toInternal(L.command,H),ce={x:K,a:L.label,b:L.kind!==void 0?C.CompletionItemKind.from(L.kind):void 0,m:L.tags&&L.tags.map(C.CompletionItemTag.from),c:L.detail,d:typeof L.documentation>"u"?void 0:C.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters?.join(""),l:L.additionalTextEdits&&L.additionalTextEdits.map(C.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};L.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=L.textEdit.newText):typeof L.insertText=="string"?ce.h=L.insertText:L.insertText instanceof F.$kK&&(ce.h=L.insertText.value,ce.i|=4);let Fe;return L.textEdit?Fe=L.textEdit.range:L.range&&(Fe=L.range),F.$bK.isRange(Fe)?ce.j=C.Range.from(Fe):Fe&&(!G?.isEqual(Fe.inserting)||!Q?.isEqual(Fe.replacing))&&(ce.j={insert:C.Range.from(Fe.inserting),replace:C.Range.from(Fe.replacing)}),ce}}class ue{async provideInlineCompletions(L,K,G,Q){}disposeCompletions(L){}handleDidShowCompletionItem(L,K,G){}handlePartialAccept(L,K,G){}}class $e extends ue{constructor(L,K,G,Q){super(),this.f=L,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$9E)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$9E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(L,K,G,Q){const H=this.g.getDocument(L),_=C.Position.to(K),ce=await this.h.provideInlineCompletionItems(H,_,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const Fe=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Fe}),items:Fe.map((Ye,_e)=>{let it;Ye.command&&(Je||(Je=new f.$Qc),it=this.j.toInternal(Ye.command,Je));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(Je||(Je=new f.$Qc),this.j.toInternal(Ye,Je))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(L){this.d.disposeReferenceId(L)?.dispose()}handleDidShowCompletionItem(L,K,G){const Q=this.d.get(L)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(L,K,G){const Q=this.d.get(L)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(L){const K=this.e++;return this.d.set(K,L),K}disposeReferenceId(L){const K=this.d.get(L);return this.d.delete(L),K}get(L){return this.d.get(L)}}class z{constructor(L,K){this.e=L,this.f=K,this.d=new c.$Gbc("SignatureHelp")}async provideSignatureHelp(L,K,G,Q){const H=this.e.getDocument(L),_=C.Position.to(K),ce=this.g(G),Fe=await this.f.provideSignatureHelp(H,_,Q,ce);if(Fe){const Ue=this.d.add([Fe]);return{...C.SignatureHelp.from(Fe),id:Ue}}}g(L){let K;if(L.activeSignatureHelp){const G=C.SignatureHelp.to(L.activeSignatureHelp),Q=this.d.get(L.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...L,activeSignatureHelp:K}}releaseSignatureHelp(L){this.d.delete(L)}}class q{constructor(L,K,G,Q,H){this.f=L,this.g=K,this.h=G,this.j=Q,this.k=H,this.d=new c.$Gbc("InlayHints"),this.e=new Map}async provideInlayHints(L,K,G){const Q=this.f.getDocument(L),H=C.Range.to(K),_=await this.h.provideInlayHints(Q,H,G);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(_);this.e.set(ce,new f.$Qc);const Fe={hints:[],cacheId:ce};for(let Ue=0;Ue<_.length;Ue++)this.l(_[Ue],H)&&Fe.hints.push(this.m(_[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Fe}async resolveInlayHint(L,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,L)}releaseHints(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K){return L.label.length===0||Array.isArray(L.label)&&L.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(K&&!K.contains(L.position))}m(L,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(L.tooltip),position:C.Position.from(L.position),textEdits:L.textEdits&&L.textEdits.map(C.TextEdit.from),kind:L.kind&&C.InlayHintKind.from(L.kind),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?Q.label=L.label:Q.label=L.label.map(H=>{const _={label:H.value};return _.tooltip=C.MarkdownString.fromStrict(H.tooltip),F.$lK.isLocation(H.location)&&(_.location=C.location.from(H.location)),H.command&&(_.command=this.g.toInternal(H.command,G)),_}),Q}}class le{constructor(L,K){this.e=L,this.f=K,this.d=new c.$Gbc("DocumentLink")}async provideLinks(L,K){const G=this.e.getDocument(L),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(le.g).map(C.DocumentLink.from)};{const H=this.d.add(Q),_={links:[],cacheId:H};for(let ce=0;ce<Q.length;ce++){if(!le.g(Q[ce]))continue;const Fe=C.DocumentLink.from(Q[ce]);Fe.cacheId=[H,ce],_.links.push(Fe)}return _}}}static g(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!le.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(L){this.d.delete(L)}}class we{constructor(L,K){this.d=L,this.e=K}async provideColors(L,K){const G=this.d.getDocument(L),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(_=>({color:C.Color.from(_.color),range:C.Range.from(_.range)})):[]}async provideColorPresentations(L,K,G){const Q=this.d.getDocument(L),H=C.Range.to(K.range),_=C.Color.to(K.color),ce=await this.e.provideColorPresentations(_,{document:Q,range:H},G);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ve{constructor(L,K){this.d=L,this.e=K}async provideFoldingRanges(L,K,G){const Q=this.d.getDocument(L),H=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(H))return H.map(C.FoldingRange.from)}}class me{constructor(L,K,G){this.d=L,this.e=K,this.f=G}async provideSelectionRanges(L,K,G){const Q=this.d.getDocument(L),H=K.map(C.Position.to),_=await this.e.provideSelectionRanges(Q,H,G);if(!(0,P.$Kb)(_))return[];if(_.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Fe=0;Fe<H.length;Fe++){const Ue=[];ce.push(Ue);let Qe=H[Fe],Je=_[Fe];for(;;){if(!Je.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Je)),!Je.parent)break;Qe=Je.range,Je=Je.parent}}return ce}}class De{constructor(L,K){this.f=L,this.g=K,this.d=new i.$dM(""),this.e=new Map}async prepareSession(L,K,G){const Q=this.f.getDocument(L),H=C.Position.to(K),_=await this.g.prepareCallHierarchy(Q,H,G);if(!_)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(_)?_.map(Fe=>this.h(ce,Fe)):[this.h(ce,_)]}async provideCallsTo(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(H)return H.map(_=>({from:this.h(L,_.from),fromRanges:_.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(H)return H.map(_=>({to:this.h(L,_.to),fromRanges:_.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(L){this.e.delete(L)}h(L,K){const G=this.e.get(L),Q=C.CallHierarchyItem.from(K,L,G.size.toString(36));return G.set(Q._itemId,K),Q}j(L,K){return this.e.get(L)?.get(K)}}class re{constructor(L,K){this.f=L,this.g=K,this.d=new i.$dM(""),this.e=new Map}async prepareSession(L,K,G){const Q=this.f.getDocument(L),H=C.Position.to(K),_=await this.g.prepareTypeHierarchy(Q,H,G);if(!_)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(_)?_.map(Fe=>this.h(ce,Fe)):[this.h(ce,_)]}async provideSupertypes(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(Q,G);if(H)return H.map(_=>this.h(L,_))}async provideSubtypes(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(Q,G);if(H)return H.map(_=>this.h(L,_))}releaseSession(L){this.e.delete(L)}h(L,K){const G=this.e.get(L),Q=C.TypeHierarchyItem.from(K,L,G.size.toString(36));return G.set(Q._itemId,K),Q}j(L,K){return this.e.get(L)?.get(K)}}class he{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,G,Q,H){this.d=L,this.e=K,this.f=G,this.g=Q,this.h=H}async provideDocumentOnDropEdits(L,K,G,Q,H){const _=this.e.getDocument(K),ce=C.Position.to(G),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,L,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(_,ce,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(L,K){this.d=L,this.e=K}async provideMappedEdits(L,K,G,Q){const H=w.URI.revive(L),_=this.d.getDocument(H),ce=G.documents.map(Qe=>Qe.map(Je=>({uri:w.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(xe=>C.Range.to(xe))}))),Fe={documents:ce,selections:ce[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(_,K,Fe,Q);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(L,K){this.adapter=L,this.extension=K}}class de{static{this.d=0}constructor(L,K,G,Q,H,_,ce,Fe){this.g=K,this.h=G,this.j=Q,this.k=H,this.l=_,this.m=ce,this.n=Fe,this.f=new Map,this.e=L.getProxy(l.$0J.MainThreadLanguageFeatures)}o(L,K){return C.DocumentSelector.from(L,this.g,K)}p(L){return new F.$_J(()=>{this.f.delete(L),this.e.$unregister(L)})}q(){return de.d++}async s(L,K,G,Q,H,_=!1){const ce=this.f.get(L);if(!ce||!(ce.adapter instanceof K))return Q;const Fe=Date.now();_||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$3)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{_||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),p.CancellationToken.isCancellationToken(H)?(0,v.$Ig)(Ue,H):Ue}t(L,K){const G=this.q();return this.f.set(G,new oe(L,K)),G}static u(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,K,G,Q){const H=this.t(new n(this.h,G),L),_=Q&&Q.label||de.u(L);return this.e.$registerDocumentSymbolProvider(H,this.o(K,L),_),this.p(H)}$provideDocumentSymbols(L,K,G){return this.s(L,n,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(L,K,G){const Q=this.q(),H=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,G),L)),this.e.$registerCodeLensSupport(Q,this.o(K,L),H);let _=this.p(Q);if(H!==void 0){const ce=G.onDidChangeCodeLenses(Fe=>this.e.$emitCodeLensEvent(H));_=F.$_J.from(_,ce)}return _}$provideCodeLenses(L,K,G){return this.s(L,o,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(L,K,G){return this.s(L,o,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(L,K){this.s(L,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(L,K,G){const Q=this.t(new d(this.h,G),L);return this.e.$registerDefinitionSupport(Q,this.o(K,L)),this.p(Q)}$provideDefinition(L,K,G,Q){return this.s(L,d,H=>H.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(L,K,G){const Q=this.t(new I(this.h,G),L);return this.e.$registerDeclarationSupport(Q,this.o(K,L)),this.p(Q)}$provideDeclaration(L,K,G,Q){return this.s(L,I,H=>H.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(L,K,G){const Q=this.t(new S(this.h,G),L);return this.e.$registerImplementationSupport(Q,this.o(K,L)),this.p(Q)}$provideImplementation(L,K,G,Q){return this.s(L,S,H=>H.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(L,K,G){const Q=this.t(new u(this.h,G),L);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,L)),this.p(Q)}$provideTypeDefinition(L,K,G,Q){return this.s(L,u,H=>H.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(L,K,G,Q){const H=this.t(new m(this.h,G),L);return this.e.$registerHoverProvider(H,this.o(K,L)),this.p(H)}$provideHover(L,K,G,Q){return this.s(L,m,H=>H.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(L,K,G,Q){const H=this.t(new h(this.h,G),L);return this.e.$registerEvaluatableExpressionProvider(H,this.o(K,L)),this.p(H)}$provideEvaluatableExpression(L,K,G,Q){return this.s(L,h,H=>H.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(L,K,G,Q){const H=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new A(this.h,G),L);this.e.$registerInlineValuesProvider(_,this.o(K,L),H);let ce=this.p(_);if(H!==void 0){const Fe=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(H));ce=F.$_J.from(ce,Fe)}return ce}$provideInlineValues(L,K,G,Q,H){return this.s(L,A,_=>_.provideInlineValues(w.URI.revive(K),G,Q,H),void 0,H)}registerDocumentHighlightProvider(L,K,G){const Q=this.t(new W(this.h,G),L);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,L)),this.p(Q)}$provideDocumentHighlights(L,K,G,Q){return this.s(L,W,H=>H.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(L,K,G){const Q=this.t(new V(this.h,G),L);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,L)),this.p(Q)}$provideLinkedEditingRanges(L,K,G,Q){return this.s(L,V,async H=>{const _=await H.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?de.w(_.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(L,K,G){const Q=this.t(new U(this.h,G),L);return this.e.$registerReferenceSupport(Q,this.o(K,L)),this.p(Q)}$provideReferences(L,K,G,Q,H){return this.s(L,U,_=>_.provideReferences(w.URI.revive(K),G,Q,H),void 0,H)}registerCodeActionProvider(L,K,G,Q){const H=new f.$Qc,_=this.t(new B(this.h,this.j.converter,this.k,G,this.l,L,this.m),L);return this.e.$registerQuickFixSupport(_,this.o(K,L),{providedKinds:Q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Q?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,H)}))},de.u(L),!!G.resolveCodeAction),H.add(this.p(_)),H}$provideCodeActions(L,K,G,Q,H){return this.s(L,B,_=>_.provideCodeActions(w.URI.revive(K),G,Q,H),void 0,H)}$resolveCodeAction(L,K,G){return this.s(L,B,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(L,K){this.s(L,B,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(L,K,G){const Q=this.t(new N(this.h,G),L);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,L),L.identifier,L.displayName||L.name),this.p(Q)}$provideDocumentFormattingEdits(L,K,G,Q){return this.s(L,N,H=>H.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(L,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",H=this.t(new te(this.h,G),L);return this.e.$registerRangeFormattingSupport(H,this.o(K,L),L.identifier,L.displayName||L.name,Q),this.p(H)}$provideDocumentRangeFormattingEdits(L,K,G,Q,H){return this.s(L,te,_=>_.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,H),void 0,H)}$provideDocumentRangesFormattingEdits(L,K,G,Q,H){return this.s(L,te,_=>_.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,H),void 0,H)}registerOnTypeFormattingEditProvider(L,K,G,Q){const H=this.t(new Z(this.h,G),L);return this.e.$registerOnTypeFormattingSupport(H,this.o(K,L),Q,L.identifier),this.p(H)}$provideOnTypeFormattingEdits(L,K,G,Q,H,_){return this.s(L,Z,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,H,_),void 0,_)}registerWorkspaceSymbolProvider(L,K){const G=this.t(new ye(K,this.l),L);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(L,K,G){return this.s(L,ye,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(L,K,G){return this.s(L,ye,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(L,K){this.s(L,ye,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(L,K,G){const Q=this.t(new Ee(this.h,G,this.l),L);return this.e.$registerRenameSupport(Q,this.o(K,L),Ee.supportsResolving(G)),this.p(Q)}$provideRenameEdits(L,K,G,Q,H){return this.s(L,Ee,_=>_.provideRenameEdits(w.URI.revive(K),G,Q,H),void 0,H)}$resolveRenameLocation(L,K,G,Q){return this.s(L,Ee,H=>H.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(L,K,G,Q){const H=this.t(new Y(this.h,G),L),_=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(K,L),Q,_);let ce=this.p(H);if(_){const Fe=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(_));ce=F.$_J.from(ce,Fe)}return ce}$provideDocumentSemanticTokens(L,K,G,Q){return this.s(L,Y,H=>H.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(L,K){this.s(L,Y,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,K,G,Q){const H=this.t(new ae(this.h,G),L);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(K,L),Q),this.p(H)}$provideDocumentRangeSemanticTokens(L,K,G,Q){return this.s(L,ae,H=>H.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(L,K,G,Q){const H=this.t(new Se(this.h,this.j.converter,G,this.m,L),L);return this.e.$registerCompletionsProvider(H,this.o(K,L),Q,Se.supportsResolving(G),L.identifier),this.p(H)}$provideCompletionItems(L,K,G,Q,H){return this.s(L,Se,_=>_.provideCompletionItems(w.URI.revive(K),G,Q,H),void 0,H)}$resolveCompletionItem(L,K,G){return this.s(L,Se,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(L,K){this.s(L,Se,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(L,K,G,Q){const H=new $e(L,this.h,G,this.j.converter),_=this.t(H,L);return this.e.$registerInlineCompletionsSupport(_,this.o(K,L),H.supportsHandleEvents,$.$2l.toKey(L.identifier.value),Q?.yieldTo?.map(ce=>$.$2l.toKey(ce))||[]),this.p(_)}$provideInlineCompletions(L,K,G,Q,H){return this.s(L,ue,_=>_.provideInlineCompletions(w.URI.revive(K),G,Q,H),void 0,H)}$handleInlineCompletionDidShow(L,K,G,Q){this.s(L,ue,async H=>{H.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(L,K,G,Q){this.s(L,ue,async H=>{H.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(L,K){this.s(L,ue,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(L,K,G,Q){const H=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,_=this.t(new z(this.h,G),L);return this.e.$registerSignatureHelpProvider(_,this.o(K,L),H),this.p(_)}$provideSignatureHelp(L,K,G,Q,H){return this.s(L,z,_=>_.provideSignatureHelp(w.URI.revive(K),G,Q,H),void 0,H)}$releaseSignatureHelp(L,K){this.s(L,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(L,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new q(this.h,this.j.converter,G,this.l,L),L);this.e.$registerInlayHintsProvider(H,this.o(K,L),typeof G.resolveInlayHint=="function",Q,de.u(L));let _=this.p(H);if(Q!==void 0){const ce=G.onDidChangeInlayHints(Fe=>this.e.$emitInlayHintsEvent(Q));_=F.$_J.from(_,ce)}return _}$provideInlayHints(L,K,G,Q){return this.s(L,q,H=>H.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(L,K,G){return this.s(L,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(L,K){this.s(L,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(L,K,G){const Q=this.t(new le(this.h,G),L);return this.e.$registerDocumentLinkProvider(Q,this.o(K,L),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(L,K,G){return this.s(L,le,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(L,K,G){return this.s(L,le,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(L,K){this.s(L,le,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(L,K,G){const Q=this.t(new we(this.h,G),L);return this.e.$registerDocumentColorProvider(Q,this.o(K,L)),this.p(Q)}$provideDocumentColors(L,K,G){return this.s(L,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(L,K,G,Q){return this.s(L,we,H=>H.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(L,K,G){const Q=this.q(),H=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),L)),this.e.$registerFoldingRangeProvider(Q,this.o(K,L),L.identifier,H);let _=this.p(Q);if(H!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));_=F.$_J.from(_,ce)}return _}$provideFoldingRanges(L,K,G,Q){return this.s(L,ve,H=>H.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(L,K,G){const Q=this.t(new me(this.h,G,this.l),L);return this.e.$registerSelectionRangeProvider(Q,this.o(K,L)),this.p(Q)}$provideSelectionRanges(L,K,G,Q){return this.s(L,me,H=>H.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(L,K,G){const Q=this.t(new De(this.h,G),L);return this.e.$registerCallHierarchyProvider(Q,this.o(K,L)),this.p(Q)}$prepareCallHierarchy(L,K,G,Q){return this.s(L,De,H=>Promise.resolve(H.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(L,K,G,Q){return this.s(L,De,H=>H.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(L,K,G,Q){return this.s(L,De,H=>H.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(L,K){this.s(L,De,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(L,K,G){const Q=this.t(new re(this.h,G),L);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,L)),this.p(Q)}$prepareTypeHierarchy(L,K,G,Q){return this.s(L,re,H=>Promise.resolve(H.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(L,K,G,Q){return this.s(L,re,H=>H.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(L,K,G,Q){return this.s(L,re,H=>H.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(L,K){this.s(L,re,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(L,K,G,Q){const H=this.q();this.f.set(H,new oe(new he(this.e,this.h,G,H,L),L));const _=(0,r.$9E)(L,"dropMetadata")&&Q?he.toInternalProviderId(L.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(K,L),_,(0,r.$9E)(L,"dropMetadata")?Q:void 0),this.p(H)}$provideDocumentOnDropEdits(L,K,G,Q,H,_){return this.s(L,he,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,H,_)),void 0,void 0)}registerMappedEditsProvider(L,K,G){const Q=this.t(new se(this.h,G),L);return this.e.$registerMappedEditsProvider(Q,this.o(K,L)),this.p(Q)}$provideMappedEdits(L,K,G,Q,H){return this.s(L,se,_=>Promise.resolve(_.provideMappedEdits(K,G,Q,H)),null,H)}registerDocumentPasteEditProvider(L,K,G,Q){const H=this.q();this.f.set(H,new oe(new O(this.e,this.h,G,H,L),L));const _=O.toInternalProviderId(L.identifier.value,Q.id);return this.e.$registerPasteEditProvider(H,this.o(K,L),_,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(L,K,G,Q,H){return this.s(L,O,_=>_.prepareDocumentPaste(w.URI.revive(K),G,Q,H),void 0,H)}$providePasteEdits(L,K,G,Q,H,_){return this.s(L,O,ce=>ce.providePasteEdits(K,w.URI.revive(G),Q,H,_),void 0,_)}static w(L){return{pattern:L.source,flags:L.flags}}static y(L){return{decreaseIndentPattern:de.w(L.decreaseIndentPattern),increaseIndentPattern:de.w(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?de.w(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?de.w(L.unIndentedLinePattern):void 0}}static z(L){return{beforeText:de.w(L.beforeText),afterText:L.afterText?de.w(L.afterText):void 0,previousLineText:L.previousLineText?de.w(L.previousLineText):void 0,action:L.action}}static B(L){return L.map(de.z)}static C(L){return{open:L.open,close:L.close,notIn:L.notIn?L.notIn.map(K=>F.SyntaxTokenType.toString(K)):void 0}}static D(L){return L.map(de.C)}setLanguageConfiguration(L,K,G){const{wordPattern:Q}=G;if(Q&&(0,D.$Ne)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const H=this.q(),_={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?de.w(G.wordPattern):void 0,indentationRules:G.indentationRules?de.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?de.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?de.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,K,_),this.p(H)}$setWordDefinitions(L){for(const K of L)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Pbc=de}),define(Re[240],Me([1,0,3,8,7,29,12,6]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class D{constructor(P,k,a,p){this.c=k,this.d=a,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$0J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,k){await this.a.$changeLanguage(P,k);const a=this.c.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,k){const a=P.version,p=M.Position.from(k),$=await this.a.$tokensAtPosition(P.uri,p),f={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(k)??new C.$bK(k.line,k.character,k.line,k.character)};if(!$)return f;const t={range:M.Range.to($.range),type:M.TokenType.to($.type)};return!t.range.contains(k)||a!==P.version?f:t}createLanguageStatusItem(P,k,a){const p=this.f++,$=this.a,f=this.g,t=`${P.identifier.value}/${k}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(t);const i={selector:a,id:k,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const b=new l.$Qc,E=()=>{if(c?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${k}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,R.$Ug)(()=>{b.clear(),this.a.$setLanguageStatus(p,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?F.default.Error:i.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:i.command&&this.d.toInternal(i.command,b),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},v={dispose(){b.dispose(),c?.dispose(),$.$removeLanguageStatus(p),f.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,E()},get selector(){return i.selector},set selector(r){i.selector=r,E()},get text(){return i.text},set text(r){i.text=r,E()},get detail(){return i.detail},set detail(r){i.detail=r,E()},get severity(){return i.severity},set severity(r){i.severity=r,E()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,E()},get command(){return i.command},set command(r){i.command=r,E()},get busy(){return i.busy},set busy(r){i.busy=r,E()}};return E(),v}}e.$xcc=D}),define(Re[81],Me([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;let P=class{constructor(a,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$0J.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===w.$g}getMessage(a,p){const{message:$,args:f,comment:t}=p;if(this.c)return(0,M.$Ce)($,f??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$Ce)(c??$,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let p;const $=await this.g(a);if(!$){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents($),t=JSON.parse(f);p=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${$}: ${f.message}`);return}p&&this.d.set(a.identifier.value,{contents:p,uri:$})}async g(a){if(a.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(p)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mcc=P,e.$mcc=P=Ke([We(0,D.$oM),We(1,g.$$L),We(2,R.$8i)],P),e.$ncc=(0,F.$Nh)("IExtHostLocalizationService")}),define(Re[241],Me([1,0,14,3,27,17,2,67]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let D=class extends w.$gj{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(p=>(0,l.$kh)(p))),this.r=k.getProxy(M.$0J.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(R.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,p){return new g(this.r,k,a,p)}};e.$Ndc=D,e.$Ndc=D=Ke([We(0,F.$$L),We(1,C.$oM)],D);class g extends w.$bj{constructor(k,a,p,$){super($?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(a,$).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const p=[[k,a]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[82],Me([1,0,3,4,6,17,25]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,M.$Nh)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(w.$0J.MainThreadManagedSockets)}setFactory(k,a){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,p=await this.c.makeConnection(),$=new C.$Qc;return this.d.set(a,new g(a,p,$)),$.add((0,C.$Pc)(()=>this.d.delete(a))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),$.dispose()})),$.add(p.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),$.dispose()})),$.add(p.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,R.$ae.wrap(f)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$pcc=l,e.$pcc=l=Ke([We(0,F.$$L)],l);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class g extends C.$Rc{constructor(k,a,p){super(),this.socketId=k,this.actual=a,this.B(p)}}}),define(Re[242],Me([1,0,3,14,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;function F(l){return l&&l.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(w.$0J.MainThreadMessageService)}showMessage(D,g,P,k,a){const p={source:{identifier:D.identifier,label:D.displayName||D.name}};let $;typeof k=="string"||F(k)?$=[k,...a]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,$=a),p.useCustom&&(0,C.$0E)(D,"resolvers");const f=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:b}=i;f.push({title:c,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,P,p,f).then(t=>{if(typeof t=="number")return $[t]})}};e.$ycc=R,e.$ycc=R=Ke([We(1,M.$8i)],R)}),define(Re[243],Me([1,0,151,25,5,6,28,15,16,2,38,74,3,31,8,7,46,204,103,9,24,13]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,o,y,d,I){this.q=y,this.r=d,this.s=I,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new C.$Md({onListenerError:b.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Md({onListenerError:b.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Md({onListenerError:b.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Md({onListenerError:b.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Gbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(a.$0J.MainThreadNotebook),this.c=n.getProxy(a.$0J.MainThreadNotebookDocuments),this.d=n.getProxy(a.$0J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,A=this.g.get(u)?.getCell(m);if(A)return A.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),r.A(o)}getEditorById(n){const o=this.h.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(n){for(const[o,y]of this.h)if(y.apiEditor===n)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,o){const y=this.g.get(n);if(!y&&!o)throw new Error(`NO notebook document for '${n}'`);return y}static t(n,o){if(!o)return;const y=o.filenamePattern.map(d=>$.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,y){const d=r.a++,I=typeof y.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(d,y),this.b.$registerNotebookCellStatusBarItemProvider(d,I,o);let S;return I!==void 0&&(S=y.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new f.$_J(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,I),S?.dispose()})}async createNotebookDocument(n){const o=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&$.NotebookData.from(n.content)});return g.URI.revive(o)}async openNotebookDocument(n){const o=this.g.get(n);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(n),d=this.g.get(g.URI.revive(y));return(0,D.$If)(d?.apiNotebook)}async showNotebookDocument(n,o){g.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let y;typeof o=="object"?y={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,y),I=d&&this.h.get(d)?.apiEditor;if(I)return I;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,y,d){const I=this.f.get(n),S=g.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(y);if(!m)return;const h=await I.provideCellStatusBarItems(m.apiCell,d);if(!h)return;const A=new F.$Qc,W=this.p.add([A]),U=(Array.isArray(h)?h:[h]).map(B=>$.NotebookStatusBarItem.from(B,this.i,A));return{cacheId:W,items:U}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,o,y,d,I){if((0,l.$Ae)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:y,options:d}),this.b.$registerNotebookSerializer(S,{id:n.identifier,location:n.extensionLocation},o,$.NotebookDocumentContentOptions.from(d),r.t(n,I)),(0,F.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(n,o,y){const d=this.w.get(n);if(!d)throw new Error("NO serializer found");const I=await d.serializer.deserializeNotebook(o.buffer,y);return new t.$kv($.NotebookData.from(I))}async $notebookToData(n,o,y){const d=this.w.get(n);if(!d)throw new Error("NO serializer found");const I=await d.serializer.serializeNotebook($.NotebookData.to(o.value),y);return M.$ae.wrap(I)}async $saveNotebook(n,o,y,d,I){const S=g.URI.revive(o),u=this.w.get(n);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new P.$qk((0,w.localize)(0,null,this.y(S)),6);await this.x(S,d);const h={metadata:(0,E.$0m)(m.apiNotebook.metadata,B=>!(u.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of m.apiNotebook.getCells()){const O=new f.$xL(B.kind,B.document.getText(),B.document.languageId,B.mime,u.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,E.$0m)(B.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),h.cells.push(O)}const A=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,A);const W=this.s.getFileSystemProviderExtUri(S.scheme),V=await this.s.value.stat(S);return{name:W.basename(S),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$Bk({mtime:V.mtime,size:V.size}),children:void 0}}async x(n,o){const y=await this.s.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$Ak&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$Bk({mtime:o.mtime,size:y.size}))throw new P.$qk((0,w.localize)(1,null),3,o)}y(n){return n.scheme===v.Schemas.file?n.fsPath:n.toString()}z(n,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new c.$fdc(o,this.d,n,y.visibleRanges.map($.NotebookRange.to),y.selections.map($.NotebookRange.to),typeof y.viewColumn=="number"?$.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,d)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const y of n.value.removedDocuments){const d=g.URI.revive(y),I=this.g.get(d);I&&(I.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(n.value.addedDocuments){const y=[];for(const d of n.value.addedDocuments){const I=g.URI.revive(d.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$edc(this.c,this.q,this.r,I,d);y.push(...d.cells.map(u=>i.$ddc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(S.apiNotebook)}}if(n.value.addedEditors)for(const y of n.value.addedEditors){if(this.h.has(y.id))return;const d=g.URI.revive(y.documentUri),I=this.g.get(d);I&&this.z(I,y.id,y)}const o=[];if(n.value.removedEditors)for(const y of n.value.removedEditors){const d=this.h.get(y);d&&(this.h.delete(y),this.k?.id===d.id&&(this.k=void 0),o.push(d))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const y=new Set;this.l.forEach(d=>y.add(d.id));for(const d of this.h.values()){const I=y.has(d.id);d._acceptVisibility(I)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const o=p.$wM.String.with("notebookType","A notebook type"),y=new p.$yM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$wM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$ae.wrap(I))],new p.$xM("Notebook Data",I=>$.NotebookData.to(I.value))),d=new p.$yM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$wM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$kv($.NotebookData.from(I)))],new p.$xM("Bytes",I=>I.buffer));n.registerApiCommand(y),n.registerApiCommand(d)}}e.$gdc=r}),define(Re[244],Me([1,0,18,12,21,5,6,28,2,20,14,3,31,8,7,77,197,26,46]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0;let b=class{constructor(d,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$zc,this.c=new l.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new F.$Md,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=d.getProxy(k.$0J.MainThreadNotebookKernels);const h=new a.$yM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$wM("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const W=this.m.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:W}}else if(A&&"notebookEditor"in A){const W=this.m.getIdByEditor(A.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return A})],a.$xM.Void);this.n.registerApiCommand(h)}createNotebookController(d,I,S,u,m,h){for(const ae of this.i.values())if(ae.controller.id===I&&g.$2l.equals(d.identifier,ae.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const A=this.j++,W=this;this.o.trace(`NotebookController[${A}], CREATED by ${d.identifier.value}, ${I}`);const V=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let U=!1;const B=new F.$Md,O=new F.$Md,N={id:o(d.identifier,I),notebookType:S,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:u||d.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let te=m??V,Z;this.a.$addKernel(A,N).catch(ae=>{console.log(ae),U=!0});let ye=0;const Ee=()=>{if(U)return;const ae=++ye;Promise.resolve().then(()=>{ae===ye&&this.a.$updateKernel(A,N)})},Pe=new l.$zc,Y={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(ae){N.label=ae??d.displayName??d.name,Ee()},get detail(){return N.detail??""},set detail(ae){N.detail=ae,Ee()},get description(){return N.description??""},set description(ae){N.description=ae,Ee()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(ae){N.supportedLanguages=ae,Ee()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){N.supportsExecutionOrder=ae,Ee()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(ae){te=ae??V},get interruptHandler(){return Z},set interruptHandler(ae){Z=ae,N.supportsInterrupt=!!ae,Ee()},createNotebookCellExecution(ae){if(U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.notebook.uri))throw W.o.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,o(d.identifier,this.id))},createNotebookExecution(ae){if((0,i.$0E)(d,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(ae.uri))throw W.o.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,o(d.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${A}], DISPOSED`),U=!0,this.i.delete(A),B.dispose(),O.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(ae,Se){Se===$.NotebookControllerAffinity2.Hidden&&(0,i.$0E)(d,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(A,ae.uri,Se)},onDidReceiveMessage:O.event,postMessage(ae,Se){return(0,i.$0E)(d,"notebookMessaging"),W.a.$postMessage(A,Se&&W.m.getIdByEditor(Se),ae)},asWebviewUri(ae){return(0,i.$0E)(d,"notebookMessaging"),(0,f.$Yob)(ae,W.l.remote)}};return this.i.set(A,{extensionId:d.identifier,controller:Y,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:Pe}),Y}getIdByController(d){for(const[I,S]of this.i)if(S.controller===d)return o(S.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(d,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let A;return m!==void 0&&(A=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),A?.dispose()}}}async $provideKernelSourceActions(d,I){const S=this.g.get(d);if(S){const u=new R.$Qc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>p.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(d,I,S){const u=this.i.get(d);if(u){const m=this.m.getNotebookDocument(D.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${d}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I)),h=[];for(const A of S){const W=m.getCell(A);W&&h.push(W.apiCell)}try{this.o.trace(`NotebookController[${d}] EXECUTE cells`,m.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,m.apiNotebook,u.controller)}catch(A){this.o.error(`NotebookController[${d}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const h of S){const A=m.getCell(h);A&&this.b.get(A.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(m.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(A=>A.dispose())}}$acceptKernelMessageFromRenderer(d,I,S){const u=this.i.get(d);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(d,I,S){const m=this.m.getNotebookDocument(D.URI.revive(d)).getCell(I);if(m){const h=S?p.NotebookCellExecutionState.to(S):$.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:m.apiCell,state:h})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const h=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),h.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(d,I){const S=this.m.getNotebookDocument(d.uri),u=d.getCells().find(A=>{const W=S.getCellFromApiCell(A);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new s(I,S,this.a),h=m.onDidChangeState(()=>{m.state===r.Resolved&&(m.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,h]),m.asApiObject()}};e.$udc=b,e.$udc=b=Ke([We(4,P.$8i)],b);var E;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(E||(E={}));class v extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Wd),this.h=new n(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new c.$kv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const S=$.$AL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(d,I,S){const u=this.w(I),m=this.y((0,w.$2b)(d));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(d,I,S){return d=$.$AL.ensureUniqueMimeTypes((0,w.$2b)(d),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(S){d.j=S,d.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(S){if(d.f===E.Resolved||d.f===E.Started)throw new Error("Cannot call start again");d.f=E.Started,d.c.fire(),d.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(d.f===E.Resolved)throw new Error("Cannot call resolve twice");d.f=E.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new c.$kv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return d.t(),d.z([],S,!1)},appendOutput(S,u){return d.t(),d.z(S,u,!0)},replaceOutput(S,u){return d.t(),d.z(S,u,!1)},appendOutputItems(S,u){return d.t(),d.C(S,u,!0)},replaceOutputItems(S,u){return d.t(),d.C(S,u,!1)}})}}var r;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(r||(r={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.h=I,this.j=S,this.b=s.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new C.$Wd),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class n{constructor(d,I){this.e=d,this.f=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$bh,this.b=Date.now(),(0,M.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>d.complete())}}function o(y,d){return`${y.value}/${d}`}e.$vdc=o}),define(Re[245],Me([1,0,5,3,103]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class F{constructor(l,D){this.c=D,this.a=new Map,this.b=l.getProxy(M.$0J.MainThreadNotebookRenderers)}$postRendererMessage(l,D,g){const P=this.c.getEditorById(l);this.a.get(D)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(l,D){if(!l.contributes?.notebookRenderer?.some(P=>P.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(P,k,a)=>this.d(D).event(P,k,a),postMessage:(P,k)=>{C.$fdc.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const a=k&&C.$fdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,P)}}}d(l){let D=this.a.get(l);return D||(D=new w.$Md({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(l)}}),this.a.set(l,D),D)}}e.$wdc=F}),define(Re[246],Me([1,0,6,16,2,26,3]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class l{constructor(g){this.b=new Map,this.a=g.getProxy(R.$0J.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,k){if((0,F.$0E)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,k),this.a.$registerProfileContentHandler(P,k.name,k.description,g.identifier.value),(0,w.$Pc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,k,a){const p=this.b.get(g);if(!p)throw new Error(`Unknown handler with id: ${g}`);return p.saveProfile(P,k,a)}async $readProfile(g,P,k){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,M.$xf)(P)?P:C.URI.revive(P),k)}}e.$Adc=l}),define(Re[247],Me([1,0,2,3,12,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(M.$0J.MainThreadQuickDiff)}$provideOriginalResource(D,g,P){const k=w.URI.revive(g),a=this.c.get(D);return a?(0,C.$Lg)(()=>a.provideOriginalResource(k,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,P,k){const a=R.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,F.DocumentSelector.from(D,this.d),P,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$Bdc=R}),define(Re[248],Me([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;function $(f,t,i){const c=f.getProxy(F.$0J.MainThreadQuickOpen);class b{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=w.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),A=++this.f,W=c.$show(A,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),V={},U=W.then(()=>V);return Promise.race([U,h]).then(B=>{if(B===V)return;const O=(0,a.$9E)(I,"quickPickItemTooltip");return h.then(N=>{const te=[];for(let Z=0;Z<N.length;Z++){const ye=N[Z];if(typeof ye=="string")te.push({label:ye,handle:Z});else if(ye.kind===l.QuickPickItemKind.Separator)te.push({type:"separator",label:ye.label});else{ye.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Ee=ye.iconPath?n(ye.iconPath):void 0;te.push({label:ye.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Z})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Z=>{u.onDidSelectItem(N[Z])}),c.$setItems(A,te),W.then(Z=>{if(typeof Z=="number")return N[Z];if(Array.isArray(Z))return Z.map(ye=>N[ye])})})}).then(void 0,B=>{if(!(0,D.$3)(B))return c.$setError(A,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=w.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,D.$3)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=S.message?P.default.Error:P.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=w.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new y(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Md,this.q=new M.$Md,this.r=new M.$Md,this.s=new M.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$tL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...n(S.iconPath),tooltip:S.tooltip,handle:S===l.$tL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function v(d){if(d instanceof l.$6K)return{id:d.id};const I=s(d),S=r(d);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof S=="string"?R.URI.file(S):S}}function r(d){return typeof d=="object"&&"light"in d?d.light:d}function s(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const I=v(d);let S,u;return"id"in I?u=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Md,this.L=[],this.M=new M.$Md,this.N=new M.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,h)=>{this.C.set(h,m),this.D.set(m,h)});const S=(0,a.$9E)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const h=I[m];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=h.iconPath?n(h.iconPath):void 0;u.push({handle:m,label:h.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?p.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((W,V)=>({...n(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,g.$Gb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,g.$Gb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class y extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new b(t,i)}e.$Ccc=$}),define(Re[249],Me([1,0,2,5,64,6,12,3,18,131,14,20,40,8,26,13]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0;function i(m){if(m)return typeof m.iconPath=="string"?w.URI.file(m.iconPath):w.URI.isUri(m.iconPath)||a.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function c(m){if(m.icon){if(w.URI.isUri(m.icon))return m.icon;if(a.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const h=m.icon;return{light:h.light,dark:h.dark}}}else return}function b(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const A=typeof m.iconPath=="string"?m.iconPath:w.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,W=typeof h.iconPath=="string"?h.iconPath:w.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,g.$nq)(A,W)}function E(m,h){let A=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(A=b(m,h),A!==0)return A;if(m.light&&h.light)A=b(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(A!==0)return A;if(m.dark&&h.dark)A=b(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return A}function v(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let A=0;A<m.arguments.length;A++){const W=m.arguments[A],V=h.arguments[A];if(W!==V)return W<V?-1:1}return 0}function r(m,h){let A=(0,g.$nq)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(A!==0)return A;if(m.command&&h.command)A=v(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(A!==0)return A;if(m.decorations&&h.decorations)A=E(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return A}function s(m,h){for(let A=0;A<m.length;A++)if(m[A]!==h[A])return!1;return!0}function n(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?s(m.arguments,h.arguments):m.arguments===h.arguments)}function o(m,h){return(0,D.$tb)(m,h,n)}function y(m,h){return m===h?!0:!m||!h?!1:m.id===h.id&&m.label===h.label&&m.upstream?.id===h.upstream?.id&&m.upstream?.label===h.upstream?.label}class d{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,$.$0E)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,$.$0E)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,$.$0E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,A,W,V,U){this.k=h,this.l=V,this.m=U,this.d="",this.e=new M.$Md,this.f="",this.h=!0,this.j=!0,this.#t=A,this.#e=W}showValidationMessage(h,A){(0,$.$0E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,A)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$Dcc=d;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,A,W,V,U){this.q=h,this.s=A,this.t=W,this.u=V,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,A){const W=this.h.get(h);return W?(0,R.$Lg)(()=>this.s.executeCommand(W.command,...W.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(r),W=(0,D.$Cb)(this.o,h,r).map(B=>{const O=B.toInsert.map(N=>{const te=this.e++;this.g.set(te,N);const Z=N.resourceUri;let ye;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const q=new F.$Qc;ye=this.s.converter.toInternal(N.command,q),this.j.set(te,q)}else this.h.set(te,N.command);const Ee=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||Ee,Y=N.decorations&&i(N.decorations.dark)||Ee,ae=[Pe,Y],Se=N.decorations&&N.decorations.tooltip||"",ue=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[te,Z,ae,Se,ue,$e,ie,ye],handle:te}});return{start:B.start,deleteCount:B.deleteCount,toInsert:O}}),V=W.map(({start:B,deleteCount:O,toInsert:N})=>[B,O,N.map(te=>te.rawResource)]),U=W.reverse();for(const{start:B,deleteCount:O,toInsert:N}of U){const te=N.map(ye=>ye.handle),Z=this.n.splice(B,O,...te);for(const ye of Z)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=h,V}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let A;(0,$.$9E)(this.y,"quickDiffProvider")&&(A=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:A})}get historyProvider(){return(0,$.$0E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,$.$0E)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new F.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{y(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,$.$0E)(this.y,"scmActionButton"),this.m.value=new F.$Qc;const A=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,A??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new F.$Qc,this.p=h;const A=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:A})}get actionButton(){return(0,$.$0E)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,$.$0E)(this.y,"scmActionButton"),this.q.value=new F.$Qc,this.s=h;const A=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(W=>W.map(V=>this.z.converter.toInternal(V,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:A??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new F.$Qc,this.u=h;const A=(h||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:A})}get selected(){return this.v}constructor(h,A,W,V,U,B,O){this.y=h,this.z=V,this.A=U,this.B=B,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Sc,this.m=new F.$Sc,this.n=void 0,this.o=new F.$Sc,this.p=void 0,this.q=new F.$Sc,this.t=new F.$Sc,this.u=void 0,this.v=!1,this.w=new M.$Md,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new d(h,A,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,U,B,O,N)}createResourceGroup(h,A){const W=new I(this.#e,this.z,this.x,h,A),V=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,V),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const h=[],A=[];for(const[W,V]of this.D){V.dispose();const U=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),U.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),h.push([W.handle,W.id,W.label,W.features]);const B=W._takeResourceStateSnapshot();B.length>0&&A.push([W.handle,B]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,h,A),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(A=>{const W=A._takeResourceStateSnapshot();W.length!==0&&h.push([A.handle,W])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$gh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$gh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,A,W,V){this.l=A,this.m=W,this.n=V,this.g=new Map,this.h=new k.$4l,this.j=new M.$Md,this.e=h.getProxy(l.$0J.MainThreadSCM),this.f=h.getProxy(l.$0J.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const B=this.g.get(U.sourceControlHandle);if(!B)return U;const O=B.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const B=this.g.get(U.sourceControlHandle);return B?B.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const B=this.g.get(U.handle);return B||U}return U}})}createSourceControl(h,A,W,V){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,A,W,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const U=t.d++,B=new S(h,this.m,this.e,this.l,A,W,V);this.g.set(U,B);const O=this.h.get(h.identifier)||[];return O.push(B),this.h.set(h.identifier,O),B}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const A=this.h.get(h.identifier),W=A&&A[A.length-1];return W&&W.inputBox}$provideOriginalResource(h,A,W){const V=w.URI.revive(A);this.n.trace("ExtHostSCM#$provideOriginalResource",h,V.toString());const U=this.g.get(h);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Lg)(()=>U.quickDiffProvider.provideOriginalResource(V,W)).then(B=>B||null)}$onInputBoxValueChange(h,A){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const W=this.g.get(h);return W&&W.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(h,A,W,V){this.n.trace("ExtHostSCM#$executeResourceCommand",h,A,W);const U=this.g.get(h);if(!U)return Promise.resolve(void 0);const B=U.getResourceGroup(A);return B?B.$executeResourceCommand(W,V):Promise.resolve(void 0)}$validateInput(h,A,W){this.n.trace("ExtHostSCM#$validateInput",h);const V=this.g.get(h);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Lg)(()=>V.inputBox.validateInput(A,W)).then(U=>{if(!U)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(U.message);return B?Promise.resolve([B,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,A,W){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(A,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,A,W,V){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(A,W,V)??void 0}async $provideHistoryItems(h,A,W,V){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(A,W,V))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:c(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(h,A,W){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(A,W)??void 0}};e.$Ecc=u,e.$Ecc=u=t=Ke([We(3,P.$8i)],u)}),define(Re[83],Me([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=void 0;class F{constructor(l){this.b=new M.$Md,this.onDidChangePassword=this.b.event,this.a=l.getProxy(w.$0J.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,D){return this.a.$getPassword(l,D)}store(l,D,g){return this.a.$setPassword(l,D,g)}delete(l,D){return this.a.$deletePassword(l,D)}}e.$jcc=F,e.$kcc=(0,C.$Nh)("IExtHostSecretState")}),define(Re[250],Me([1,0,3,8,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class F{static{this.a=0}constructor(l,D){this.d=D,this.c=new Map,this.b=l.getProxy(w.$0J.MainThreadShare)}async $provideShare(l,D,g){return await this.c.get(l)?.provideShare({selection:M.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider(l,D){const g=F.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,M.DocumentSelector.from(l,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Gdc=F}),define(Re[251],Me([1,0,7,3,153,6,8,16]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=e.$Fcc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$7K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$7K("statusBarItem.warningForeground")]])}#e;#t;constructor(a,p,$,f,t,i=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new F.$Qc,this.#e=a,this.#t=p,t&&f){this.c=(0,w.$JK)(f.identifier,t);const b=$.get(this.c);b&&(i=b.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=b.priority,this.j=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(c)}u(a){if((0,l.$Bf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new F.$Qc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,p,this.k,f,this.r?.internal,$,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Fcc=D;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const p={message:a};return this.b.unshift(p),this.c(),new w.$_J(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(a,p){this.e=new Map,this.a=a.getProxy(M.$0J.MainThreadStatusBar),this.b=p,this.c=new g(this)}$acceptStaticEntries(a){for(const p of a)this.e.set(p.entryId,p)}createStatusBarEntry(a,p,$,f){return new D(this.a,this.b,this.e,a,p,$,f)}setStatusBarMessage(a,p){const $=this.c.setMessage(a);let f;return typeof p=="number"?f=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new w.$_J(()=>{$.dispose(),clearTimeout(f)})}}e.$Gcc=P}),define(Re[84],Me([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0;class F{constructor(l,D){this.c=D,this.b=new M.$Md,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(w.$0J.MainThreadStorage)}registerExtensionStorageKeysToSync(l,D){this.a.$registerExtensionStorageKeysToSync(l,D)}async initializeExtensionStorage(l,D,g){const P=await this.a.$initializeExtensionStorage(l,D);let k;return P&&(k=this.d(l,D,P)),k||g}setValue(l,D,g){return this.a.$setValue(l,D,g)}$acceptValue(l,D,g){const P=this.d(l,D,g);P&&this.b.fire({shared:l,key:D,value:P})}d(l,D,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${l}): ${P}`)}}}e.$0bc=F,e.$$bc=(0,C.$Nh)("IExtHostStorage")}),define(Re[85],Me([1,0,4,27,14,61,2]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0,e.$dcc=(0,w.$Nh)("IExtensionStoragePaths");let l=class{constructor(g,P,k){this.d=P,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(R.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ecc=l,e.$ecc=l=Ke([We(0,M.$oM),We(1,C.$8i),We(2,F.$ccc)],l)}),define(Re[62],Me([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,12,8,31]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=e.$gcc=e.$fcc=void 0,e.$fcc=(0,C.$Nh)("IExtHostTerminalService");class b{constructor(u,m,h,A){this.l=u,this._id=m,this.m=h,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(V,U=!0){W.q(),W.l.$sendText(W._id,V,U)},show(V){W.q(),W.l.$show(W._id,V)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:y(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,h,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:f.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$gcc=b;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$Md,this.onProcessData=this.a.event,this.b=new w.$Md,this.d=new w.$Md,this.onDidChangeProperty=this.d.event,this.f=new w.$Md,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,r=class extends l.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,h){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Md,this.onDidCloseTerminal=this.H.event,this.I=new w.$Md,this.onDidOpenTerminal=this.I.event,this.J=new w.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Md,this.onDidChangeShell=this.N.event,this.O=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$0J.MainThreadTerminalService),this.y=new $.$Ikb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:A=>{const W=V=>{const U=V;return this.W(U.instanceId)?.value};switch(A?.$mid){case 15:return W(A);default:{if(Array.isArray(A))for(let V=0;V<A.length&&A[V].$mid===15;V++)A[V]=W(A[V]);return A}}}}),this.B({dispose:()=>{for(const[A,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const h=new b(this.a,(0,p.$dg)(),u,u.name),A=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,y(u.iconPath),d(u.color)).then(W=>{const V=this.S(W,A);this.h[W]=V}),this.f.push(h),h.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const A=this.f.find(W=>W.value===h);A&&(m.resolvedExtHostIdentifier=A._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const A=new E(m),W=this.S(u,A);this.h[u]=W}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:m})}async $acceptTerminalDimensions(u,m,h){const A=this.W(u);A&&A.setDimensions(m,h)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(u,m){const h=this.W(u);h&&this.P.fire({terminal:h.value,...m})}async $acceptTerminalMaximumDimensions(u,m,h){this.g.get(u)?.resize(m,h)}async $acceptTerminalTitleChange(u,m){const h=this.W(u);h&&(h.name=m)}async $acceptTerminalClosed(u,m,h){const A=this.Y(this.f,u);if(A!==null){const W=this.f.splice(A,1)[0];W.setExitStatus(m,h),this.H.fire(W.value)}}$acceptTerminalOpened(u,m,h,A){if(m){const U=this.Y(this.f,m);if(U!==null){this.f[U]._id=u,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},V=new b(this.a,u,W,h);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const h=this.W(u);if(!h)return{message:(0,g.localize)(0,null,u)};h.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async U=>{U===h.value&&(V.dispose(),W())})});const A=this.g.get(u);A?A.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const h=new l.$Qc;h.add(m.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),h.add(m.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,m.onProcessData),h.add(m.onProcessExit(W=>this.U(u,W))),this.g.set(u,m);const A=this.j[u];return A&&m instanceof E&&(m.startSendingEvents(A.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,h){try{this.g.get(u)?.resize(m,h)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new D.$_J(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,h){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,h),this.a.$registerProfileProvider(m,u.identifier.value),new D.$_J(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,m),new D.$_J(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const h=new a.$Wd().token;if(h.isCancellationRequested)return;const A=this.D.get(u);if(!A)return;const W=await A.provideTerminalQuickFixes(m,h);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new l.$Qc;if(this.w.value=V,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,V):void 0;const U=[];for(const B of W){const O=i.TerminalQuickFix.from(B,this.Q.converter,V);O&&U.push(O)}return U}async $createContributedProfileTerminal(u,m){const h=new a.$Wd().token;let A=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,m);return}this.createTerminalFromOptions(A.options,m)}}async $provideLinks(u,m){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new a.$Wd;this.G.set(u,W);const V=[],U={terminal:h.value,line:m},B=[];for(const te of this.z)B.push(t.Promises.withAsyncBody(async Z=>{W.token.onCancellationRequested(()=>Z({provider:te,links:[]}));const ye=await te.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||Z({provider:te,links:ye})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const te of O)te&&te.links.length>0&&V.push(...te.links.map(Z=>{const ye={id:v++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return N.set(ye.id,{provider:te.provider,link:Z}),ye}));return this.F.set(u,N),V}$activateLink(u,m){const h=this.F.get(u)?.get(m);h&&h.provider.handleTerminalLink(h.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const h=this.Y(u,m);return h!==null?u[h]:null}Y(u,m){const h=u.findIndex(A=>A._id===m);return h===-1?null:h}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new s,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const h=(0,k.$gr)(m.map),A=(0,k.$hr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,h.length===0?void 0:h,A)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const h=m[0],A=new s(m[1]);this.$(h,A)})}$acceptDefaultProfile(u,m){const h=this.s;this.s=u,this.u=m,h?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$hcc=r,e.$hcc=r=Ke([We(1,c.$uM),We(2,R.$$L)],r);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Md,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let h=this.a.get(m);return h||(h=new n(this,u),this.a.set(m,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,m,h,A){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:A})}append(u,m,h,A){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:A})}prepend(u,m,h,A){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:A})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,m.scope),A=this.map.get(h),W=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==m.value||A.type!==m.type||A.options?.applyAtProcessCreation!==W.applyAtProcessCreation||A.options?.applyAtShellIntegration!==W.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const V=this.g(u,m.scope),U={variable:u,...m,options:W};this.map.set(V,U),this.d.fire()}}get(u,m){const h=this.g(u,m),A=this.map.get(h);return A?I(A):void 0}g(u,m){const h=this.h(m);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[h,A]of this.map)this.h(A.scope)===this.h(u)&&m.set(A.variable,I(A));return m}delete(u,m){const h=this.g(u,m);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const h=this.h(m),A=this.descriptionMap.get(h);if(!A||A.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const V={description:W,scope:m};this.descriptionMap.set(h,V),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class n{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new w.$Md}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,h){this.b.replace(u,m,h,this.d)}append(u,m,h){this.b.append(u,m,h,this.d)}prepend(u,m,h){this.b.prepend(u,m,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((h,A)=>u.call(m,A,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(u,m){super(!1,u,m)}createTerminal(u,m,h){throw new P.$$}createTerminalFromOptions(u,m){throw new P.$$}};e.$icc=o,e.$icc=o=Ke([We(0,c.$uM),We(1,R.$$L)],o);function y(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return f.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Re[252],Me([1,0,281,12,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,56,26]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=e.$qdc=e.$pdc=void 0;let r=class{constructor(U,B,O){this.k=O,this.d=new R.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(p.$0J.MainThreadTesting),this.j=new h(this.g),this.h=new y(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const te=N,Z=te.tests[te.tests.length-1].item.extId;return this.f.get(c.$3I.root(Z))?.collection.tree.get(Z)?.actual??(0,f.$kM)(N)}case 18:{const{extId:te,message:Z}=N;return{test:this.f.get(c.$3I.root(te))?.collection.tree.get(te)?.actual,message:t.TestMessage.to(Z)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),te=Z=>{const ye=this.f.get(c.$3I.root(Z));if(ye)return c.$3I.isRoot(Z)?ye.controller:ye.collection.tree.get(Z)?.actual};return{include:N?.include.map(te).filter(k.$Ff)||[],exclude:N?.exclude.map(te).filter(k.$Ff)||[]}})}createTestController(U,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const te=new g.$Qc,Z=te.add(new f.$nM(B,O,this.k));Z.root.label=O;const ye=new Map,Ee=this.g,Pe={items:Z.root.children,get label(){return O},set label(ae){O=ae,Z.root.label=ae,Ee.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(ae){N=ae,Ee.$updateController(B,{canRefresh:!!ae})},get id(){return B},createRunProfile:(ae,Se,ue,$e,ie,z)=>{let q=(0,D.$Bi)(ae);for(;ye.has(q);)q++;return new A(this.g,ye,B,q,ae,Se,ue,$e,ie,z)},createTestItem(ae,Se,ue){return new f.$lM(B,ae,Se,ue)},createTestRun:(ae,Se,ue=!0)=>this.h.createTestRun(U,B,Z,ae,Se,ue),invalidateTestResults:ae=>{if(ae===void 0)this.g.$markTestRetired(void 0);else{const Se=ae instanceof Array?ae:[ae];this.g.$markTestRetired(Se.map(ue=>c.$3I.fromExtHostTestItem(ue,B).toString()))}},set resolveHandler(ae){Z.resolveHandler=ae},get resolveHandler(){return Z.resolveHandler},dispose:()=>{te.dispose()}};Ee.$registerTestController(B,O,!!N),te.add((0,g.$Pc)(()=>Ee.$unregisterTestController(B)));const Y={controller:Pe,collection:Z,profiles:ye,extension:U};return this.f.set(B,Y),te.add((0,g.$Pc)(()=>this.f.delete(B))),te.add(Z.onDidGenerateDiff(ae=>Ee.$publishDiff(B,ae.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,B=F.CancellationToken.None){const O=d(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(te=>c.$3I.fromExtHostTestItem(te,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(te=>te.id)},B)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,O){return(0,w.$qb)(this.h.trackers,te=>te.id===U?te.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,B,O,N){return(0,w.$qb)(this.h.trackers,Z=>Z.id===U?Z.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,B){this.f.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.f.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,P.$3m)(t.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,B){const O=this.f.get(c.$3I.fromString(U).controllerId)?.collection;O&&(await O.expand(U,B<0?1/0:B),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(E.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(O=>this.l(O,!1,B)))}async $startContinuousRun(U,B){const O=new F.$Wd(B),N=await Promise.all(U.map(te=>this.l(te,!0,O.token)));return!B.isCancellationRequested&&!N.some(te=>te.error)&&await new Promise(te=>B.onCancellationRequested(te)),O.dispose(!0),N}async l(U,B,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:te,profiles:Z,extension:ye}=N,Ee=Z.get(U.profileId);if(!Ee)return{};const Pe=U.testIds.map(ue=>te.tree.get(ue)).filter(k.$Ff),Y=U.excludeExtIds.map(ue=>N.collection.tree.get(ue)).filter(k.$Ff).filter(ue=>Pe.some($e=>$e.fullId.compare(ue.fullId)===2));if(!Pe.length)return{};const ae=new i.$HL(Pe.some(ue=>ue.actual instanceof f.$mM)?void 0:Pe.map(ue=>ue.actual),Y.map(ue=>ue.actual),Ee,B),Se=(0,E.$5I)(U)&&this.h.prepareForMainThreadTestRun(ae,I.fromInternal(U,N.collection),ye,O);try{return await Ee.runHandler(ae,O),{}}catch(ue){return{error:String(ue)}}finally{Se&&(Se.hasRunningTasks&&!O.isCancellationRequested&&await R.Event.toPromise(Se.onEnd),Se.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$pdc=r,e.$pdc=r=Ke([We(0,$.$$L)],r);const s=1e4;var n;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(n||(n={}));class o extends g.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,B,O,N){super(),this.s=U,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$Md),this.onEnd=this.m.event,this.j=this.B(new F.$Wd(N));const te=this.B(new M.$5g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const B=this.s.id,O=this.s.controllerId,N=(0,a.$dg)(),te=new S(this.u,B,N),Z=Y=>(ae,...Se)=>{if(Ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ae)&&(this.C(ae),Y(ae,...Se))},ye=(Y,ae)=>{const Se=ae instanceof Array?ae.map(t.TestMessage.from):[t.TestMessage.from(ae)];if(Se.some(ue=>ue.contextValue!==void 0)&&(0,v.$0E)(this.w,"testMessageContextValue"),Y.uri&&Y.range){const ue={range:t.Range.from(Y.range),uri:Y.uri};for(const $e of Se)$e.location=$e.location||ue}this.u.$appendTestMessagesInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),Se)};let Ee=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return te.coverageProvider},set coverageProvider(Y){te.coverageProvider=Y},enqueued:Z(Y=>{this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),1)}),skipped:Z(Y=>{this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),5)}),started:Z(Y=>{this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),2)}),errored:Z((Y,ae,Se)=>{ye(Y,ae),this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),6,Se)}),failed:Z((Y,ae,Se)=>{ye(Y,ae),this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,O).toString(),4,Se)}),passed:Z((Y,ae)=>{this.u.$updateTestStateInRun(B,N,c.$3I.fromExtHostTestItem(Y,this.s.controllerId).toString(),3,ae)}),appendOutput:(Y,ae,Se)=>{Ee||(Se&&(this.s.isIncluded(Se)?this.C(Se):Se=void 0),this.u.$appendOutputToRun(B,N,C.$ae.fromString(Y),ae&&t.location.from(ae),Se&&c.$3I.fromExtHostTestItem(Se,O).toString()))},end:()=>{Ee||(Ee=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:te}),this.u.$startedTestRunTask(B,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof f.$lM))throw new b.$3L(U.id);if(this.h.has(c.$3I.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,B,O,N){return this.g(U,B,O,N)}cancelRunById(U){for(const B of this.d.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,B,O,N,te,Z){const ye=this.d.get(N);if(ye)return ye.createRun(te);const Ee=I.fromPublic(B,O,N,Z),Pe=d(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(ae=>c.$3I.fromExtHostTestItem(ae,O.root.id).toString())??[],id:Ee.id,include:N.include?.map(ae=>c.$3I.fromExtHostTestItem(ae,O.root.id).toString())??[O.root.id],persist:Z});const Y=this.g(N,Ee,U);return R.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(Ee.id),Y.dispose()}),Y.createRun(te)}g(U,B,O,N){const te=new o(B,this.f,O,N);return this.d.set(U,te),R.Event.once(te.onEnd)(()=>this.d.delete(U)),te}}e.$qdc=y;const d=V=>{if(V.profile){if(!(V.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(U,B,O,N){return new I(U,(0,a.$dg)(),O.include?.map(te=>c.$3I.fromExtHostTestItem(te,U).toString())??[U],O.exclude?.map(te=>c.$3I.fromExtHostTestItem(te,U).toString())??[],N,B)}static fromInternal(U,B){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,O,N,te,Z){this.controllerId=U,this.id=B,this.isPersisted=te,this.colllection=Z,this.d=O.map(ye=>ye+"\0"),this.f=N.map(ye=>ye+"\0")}isIncluded(U){const B=c.$3I.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$rdc=I;class S{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,B,O){this.g=U,this.h=B,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(U,B){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const B=c.$3I.parentId(U.item.extId);if(B&&this.h.has(B.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:B,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends E.$0I{constructor(){super(...arguments),this.s=new R.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}p(){return new u(this.s)}}class h{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$cb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new m;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class A{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,O,N,te,Z,ye,Ee=!1,Pe=void 0,Y=!1){this.controllerId=O,this.profileId=N,this.f=te,this.kind=Z,this.runHandler=ye,this.g=Ee,this._tag=Pe,this.h=Y,this.#e=U,this.#t=B,B.set(N,this);const ae=W[Z];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:te,group:ae,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$sdc=A;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Re[253],Me([1,0,18,9,5,3,105,8,7]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class g{constructor(k,a){this.i=a,this.a=new C.$Md({onListenerError:M.$1}),this.b=new C.$Md({onListenerError:M.$1}),this.c=new C.$Md({onListenerError:M.$1}),this.d=new C.$Md({onListenerError:M.$1}),this.f=new C.$Md({onListenerError:M.$1}),this.g=new C.$Md({onListenerError:M.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(F.$0J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(p=>p.value)}async showTextDocument(k,a,p){let $;typeof a=="number"?$={position:l.ViewColumn.from(a),preserveFocus:p}:typeof a=="object"?$={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?l.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:$={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,$),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new R.$fM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const p=this.i.getEditor(k);if(!p)throw new Error("unknown text editor");if(a.options&&p._acceptOptions(a.options),a.selections){const $=a.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(a.visibleRanges){const $=w.$Gb(a.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(a.options&&this.b.fire({textEditor:p.value,options:{...a.options,lineNumbers:l.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const $=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:f,kind:$})}if(a.visibleRanges){const $=w.$Gb(a.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(k){for(const a in k){const p=this.i.getEditor(a);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(k[a]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Hcc=g}),define(Re[254],Me([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=void 0,e.$jdc=(0,M.$Nh)("IExtHostTimeline");class P{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$0J.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$2l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:w.URI.revive(f.uri);return this.c.get(f.source)?.get(k(i))?.get(f.handle)}else return;return f}})}async $getTimeline(p,$,f,t){return this.b.get(p)?.provider.provideTimeline(w.URI.revive($),f,t)}registerTimelineProvider(p,$,f,t){const i=new F.$Qc,c=this.d($.id,t,i).bind(this);let b;$.onDidChange&&(b=$.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:$.id}),this));const E=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(v,r,s){r?.resetCache&&(i.clear(),E.get($.id)?.clear());const n=await $.provideTimeline(v,r,s);if(n==null)return;const o=c(v,r);return{...n,source:$.id,items:n.items.map(o)}},dispose(){for(const v of E.values())v.get($.id)?.clear();b?.dispose(),i.dispose()}},f)}d(p,$,f){return(t,i)=>{let c;if(i?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=k(t);c=b.get(E),c===void 0&&(c=new Map,b.set(E,c))}return b=>{const{iconPath:E,...v}=b,r=`${p}|${b.id??b.timestamp}`;c?.set(r,b);let s,n,o;b.iconPath&&(E instanceof R.$6K?o={id:E.id,color:E.color}:w.URI.isUri(E)?(s=E,n=E):{light:s,dark:n}=E);let y;return R.$zK.isMarkdownString(v.tooltip)?y=l.MarkdownString.from(v.tooltip):(0,g.$xf)(v.tooltip)?y=v.tooltip:R.$zK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.MarkdownString.from(v.detail)):(0,g.$xf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=v.detail),{...v,id:v.id??void 0,handle:r,source:p,command:b.command?$.toInternal(b.command,f):void 0,icon:s,iconDark:n,themeIcon:o,tooltip:y,accessibilityInformation:b.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,F.$Pc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$kdc=P;function k(a){return a?.toString()}}),define(Re[86],Me([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vvb=e.$Uvb=e.TunnelDtoConverter=void 0;class p extends D.$av{}var $;(function(t){function i(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=i;function c(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==D.TunnelPrivacyId.ConstantPrivate&&b.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$Uvb=(0,R.$Nh)("IExtHostTunnelService");let f=class extends C.$Rc{constructor(i,c,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$0J.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const b=await this.a.$openTunnel(c,i.displayName);if(b){const E=new p(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const b=this.u();return this.r.set(b,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,b),new a.$_J(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(i,c,b,E,v){const r=[];for(const n of i){const o=this.r.get(n);if(!o)return[];r.push(...await Promise.all(c.map(async y=>{let d;try{d=await o.provider.providePortAttributes({port:y,pid:b,commandLine:E},v)}catch{d=await o.provider.providePortAttributes(y,b,E,v)}return{providedAttributes:d,port:y}})))}const s=r.filter(n=>!!n.providedAttributes);return s.length>0?s.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new w.$Wd().token)??void 0;const b=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(b),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const b=i.tunnelFactory??(c?this.w(c):void 0);if(b){this.b=b;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const b=this.g.get(i.host);b.has(i.port)&&(c&&b.get(i.port).disposeListener.dispose(),await b.get(i.port).tunnel.dispose(),b.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const E=await b;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),b=i.filter((E,v)=>c[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${b.map(E=>E.port).join(", ")}`),b}};e.$Vvb=f,e.$Vvb=f=Ke([We(0,k.$$L),We(1,P.$oM),We(2,l.$8i)],f)}),define(Re[255],Me([1,0,6,13,2,3]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(F.$0J.MainThreadUriOpeners)}registerExternalUriOpener(D,g,P,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=k.schemes.find(p=>!R.a.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,k.schemes,D,k.label),(0,w.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,P){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=C.URI.revive(g);return k.canOpenExternalUri(a,P)}async $openUri(D,g,P){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$tdc=R}),define(Re[256],Me([1,0,3,2,6,9,20]),function(be,e,w,M,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class l{static{this.a=0}constructor(g){this.c=new R.$3l,this.d=new Map,this.b=g.getProxy(w.$0J.MainThreadUrls)}registerUriHandler(g,P){const k=g.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=l.a++;return this.c.add(k),this.d.set(a,P),this.b.$registerUriHandler(a,k,g.displayName||g.name),(0,C.$Pc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,P){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(P))}catch(a){(0,F.$Z)(a)}return Promise.resolve(void 0)}async createAppUri(g){return M.URI.revive(await this.b.$createAppUri(g))}}e.$Jcc=l}),define(Re[63],Me([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,v,r,s,n,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Md,this._onDidDispose=this.#h.event,this.#e=E,this.#t=v,this.#r=r,this.#l=s,this.#u=n,this.#n=o,this.#c=a(o),this.#d=p(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,g.$Yob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+g.$Xob}return g.$Xob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),F.$6m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,D.$pcb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,y,d,I)=>{const S=R.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),u=(0,g.$Yob)(S,{isRemote:v,authority:r}).toString();return`${n}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,y,d,I)=>{const S=R.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),u=(0,g.$Yob)(S,{isRemote:v,authority:r}).toString();return`${n}${u}${I}`})}}e.$Kcc=k;function a(b){try{const E=(0,l.$Jo)((0,l.$Io)(b.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$Lcc=a;function p(b){try{const E=(0,l.$Jo)((0,l.$Io)(b.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Rc{constructor(E,v,r,s,n){super(),this.c=v,this.f=r,this.g=s,this.h=n,this.b=new Map,this.a=E.getProxy(P.$0J.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,r){const s=this.j(E);if(s){const{message:n}=(0,D.$qcb)(v,r.value);s._onMessageEmitter.fire(n)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,r){const s=new k(E,this.a,i(v),this.c,this.f,r,this.h);this.b.set(E,s);const n=s._onDidDispose(()=>{n.dispose(),this.deleteWebview(E)});return s}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$Mcc=$;function f(b){return{id:b.identifier,location:b.extensionLocation}}e.$Ncc=f;function t(b,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||c(b,E)}}e.$Occ=t;function i(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(E=>R.URI.from(E))}}function c(b,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),b.extensionLocation]}}),define(Re[257],Me([1,0,21,93,6,13,23,2,8,63,74,3,7]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class p{constructor(s,n){this.document=s,this.b=n,this.a=1,this.c=new P.$Gbc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,n){await this.f(s).undo(),n||this.disposeBackup()}async redo(s,n){await this.f(s).redo(),n||this.disposeBackup()}disposeEdits(s){for(const n of s)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=v(this.document.uri)+this.a++;return(0,R.$ug)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const n=this.c.get(s,0);if(!n)throw new Error("No edit found");return n}}class ${constructor(){this.a=new Map}get(s,n){return this.a.get(this.b(s,n))}add(s,n,o){const y=this.b(s,n.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${s} resource:${n.uri}`);const d=new p(n,o);return this.a.set(y,d),d}delete(s,n){const o=this.b(s,n.uri);this.a.delete(o)}b(s,n){return`${s}@@@${n}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,n,o){return this.b(0,s,n,o)}addCustomProvider(s,n,o){return this.b(1,s,n,o)}get(s){return this.a.get(s)}b(s,n,o,y){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:s,extension:o,provider:y}),new a.$_J(()=>this.a.delete(n))}}class i{constructor(s,n,o,y,d){this.d=n,this.f=o,this.g=y,this.h=d,this.b=new t,this.c=new $,this.a=s.getProxy(k.$0J.MainThreadCustomEditors)}registerCustomEditorProvider(s,n,o,y){const d=new C.$Qc;return b(o)?(d.add(this.b.addTextProvider(n,s,o)),this.a.$registerTextEditorProvider((0,g.$Ncc)(s),n,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$Lcc)(s))):(d.add(this.b.addCustomProvider(n,s,o)),c(o)&&d.add(o.onDidChangeCustomDocument(I=>{const S=this.i(n,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,n,u,I.label)}else this.a.$onContentChange(I.document.uri,n)})),this.a.$registerCustomEditorProvider((0,g.$Ncc)(s),n,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,g.$Lcc)(s))),a.$_J.from(d,new a.$_J(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(s,n,o,y,d){const I=this.b.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=l.URI.revive(s),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:y?.buffer},d);let m;return c(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(n,u,m),{editable:c(I.provider)}}async $disposeCustomDocument(s,n){const o=this.b.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const y=l.URI.revive(s),{document:d}=this.i(n,y);this.c.delete(n,d),d.dispose()}async $resolveCustomEditor(s,n,o,y,d,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(d),m=this.g.createNewWebview(n,y.contentOptions,S.extension),h=this.h.createNewWebviewPanel(n,o,y.title,u,y.options,m,y.active),A=l.URI.revive(s);switch(S.type){case 1:{const{document:W}=this.i(o,A);return S.provider.resolveCustomEditor(W,h,I)}case 0:{const W=this.d.getDocument(A);return S.provider.resolveCustomTextEditor(W,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,n,o){this.i(n,s).disposeEdits(o)}async $onMoveCustomEditor(s,n,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(s);if(!d)throw new Error("No webview found");const I=l.URI.revive(n),S=this.d.getDocument(I);await y.provider.moveCustomTextEditor(S,d,w.CancellationToken.None)}async $undo(s,n,o,y){return this.i(n,s).undo(o,y)}async $redo(s,n,o,y){return this.i(n,s).redo(o,y)}async $revert(s,n,o){const y=this.i(n,s);await this.j(n).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(s,n,o){const y=this.i(n,s);await this.j(n).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(s,n,o,y){const d=this.i(n,s);return this.j(n).saveCustomDocumentAs(d.document,l.URI.revive(o),y)}async $backup(s,n,o){const y=this.i(n,s),I=await this.j(n).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(I),I.id}i(s,n){const o=this.c.get(s,l.URI.revive(n));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$ndc=i;function c(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function E(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function v(r){const s=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,M.$Bi)(s)+""}}),define(Re[258],Me([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class P extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Md),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=f,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:R.ViewColumn.from($),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Rc{static c(){return(0,F.$dg)()}constructor($,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(D.$0J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,f,t,i,c={}){const b=typeof i=="object"?i.viewColumn:i,E={viewColumn:R.ViewColumn.from(b),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$Lcc)($),r=k.c();this.f.$createWebviewPanel((0,l.$Ncc)($),r,f,{title:t,panelOptions:a(c),webviewOptions:(0,l.$Occ)($,this.m,c),serializeBuffersForPostMessage:v},E);const s=this.j.createNewWebview(r,c,$);return this.createNewWebviewPanel(r,f,t,b,c,s,!0)}$onDidChangeWebviewPanelViewStates($){const f=Object.keys($);f.sort((t,i)=>{const c=$[t],b=$[i];return c.active?1:b.active?-1:+c.visible-+b.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:R.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:$}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,l.$Lcc)($)}),new g.$_J(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel($,f,t,i){const c=this.h.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:b,extension:E}=c,v=this.j.createNewWebview($,t.webviewOptions,E),r=this.createNewWebviewPanel($,f,t.title,i,t.panelOptions,v,t.active);await b.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel($,f,t,i,c,b,E){const v=new P($,this.f,b,{viewType:f,title:t,viewColumn:i,panelOptions:c,active:E});return this.g.set($,v),v}getWebviewPanel($){return this.g.get($)}}e.$mdc=k;function a(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Re[259],Me([1,0,5,6,63,8,3,7]),function(be,e,w,M,C,F,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class D extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,p,$,f,t){super(),this.#u=!1,this.#a=this.B(new w.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Md),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=k,this.#t=a,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$0J.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,p,$){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Ncc)(k),a,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Lcc)(k)}),new l.$_J(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,p,$,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:c}=t,b=this.d.createNewWebview(k,{},c),E=new D(k,this.a,a,p,b,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:$},f)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$ldc=g}),define(Re[108],Me([1,0,5,3,2,13,15,4,17,26]),function(be,e,w,M,C,F,R,l,D,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0;let k=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,g.$0E)(p,"windowActivity"),$.active}}}constructor(p){this.c=new w.$Md,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(M.$0J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:f})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let f;if(typeof p=="string"){f=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ae)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,f,$)}async asExternalUri(p,$){if((0,R.$Ae)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(p,$);return C.URI.from(f)}};e.$Pcc=k,e.$Pcc=k=P=Ke([We(0,D.$$L)],k),e.$Qcc=(0,l.$Nh)("IExtHostWindow")}),define(Re[260],Me([1,0,226,27,17]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;let F=class extends w.$Odc{constructor(l,D){super(l,D)}f(l,D,g){D.apply(console,g)}};e.$Vfc=F,e.$Vfc=F=Ke([We(0,C.$$L),We(1,M.$oM)],F)}),define(Re[261],Me([1,0,12,25,21,9,5,6,132,215,46]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.ResponsiveState=e.RequestInitiator=e.$e4b=e.$d4b=void 0;function a(h,A){try{return JSON.stringify(h,A)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class f{constructor(A,W){this.jsonString=A,this.referencedBuffers=W}}function t(h,A=null,W=!1){const V=[];return{jsonString:(W?a:JSON.stringify)(h,(B,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof M.$ae){const N=V.push(O)-1;return{[p]:N}}if(A)return A(B,O)}return O}),referencedBuffers:V}}e.$d4b=t;function i(h,A,W){return JSON.parse(h,(V,U)=>{if(U){const B=U[p];if(typeof B=="number")return A[B];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$e4b=i;function c(h,A){return JSON.stringify(h,A)}function b(h){return h?(A,W)=>W&&W.$mid===1?h.transformOutgoing(W):W:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const r=()=>{},s=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends l.$Rc{static{k=s}static{this.a=3*1e3}constructor(A,W=null,V=null){super(),this[k]=!0,this.b=this.B(new R.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=W,this.g=V,this.h=b(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,B=P.$hv.count;U<B;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$5g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const W=this.w[A];delete this.w[A],W.resolveErr(F.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,D.$Km)(A,this.g):A}getProxy(A){const{nid:W,sid:V}=A;return this.s[W]||(this.s[W]=this.J(W,V)),this.s[W]}J(A,W){const V={get:(U,B)=>(typeof B=="string"&&!U[B]&&B.charCodeAt(0)===36&&(U[B]=(...O)=>this.U(A,B,O)),B===n?W:U[B])};return new Proxy(Object.create(null),V)}set(A,W){return this.m[A.nid]=W,W}assertRegistered(A){for(let W=0,V=A.length;W<V;W++){const U=A[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(A){if(this.j)return;const W=A.byteLength,V=d.read(A,0),U=V.readUInt8(),B=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:te}=S.deserializeRequestJSONArgs(V);this.g&&(te=(0,D.$Km)(te,this.g)),this.M(W,B,O,N,te,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:te}=S.deserializeRequestMixedArgs(V);this.g&&(te=(0,D.$Km)(te,this.g)),this.M(W,B,O,N,te,U===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(V);this.g&&(O=(0,D.$Km)(O,this.g)),this.O(W,B,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(W,B,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(V);this.O(W,B,O);break}case 11:{let O=S.deserializeReplyErrError(V);this.g&&(O=(0,D.$Km)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,W,V,U,B,O){this.f?.logIncoming(A,W,1,`receiveRequest ${(0,P.$jv)(V)}.${U}(`,B);const N=String(W);let te,Z;if(O){const Ee=new C.$Wd;B.push(Ee.token),te=this.Q(V,U,B),Z=()=>Ee.cancel()}else te=this.Q(V,U,B),Z=r;this.u[N]=Z;const ye=S.serializeAcknowledged(W);this.f?.logOutgoing(ye.byteLength,W,1,"ack"),this.c.send(ye),te.then(Ee=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Ee,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Ee),this.c.send(Pe)},Ee=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Ee);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Ee),this.c.send(Pe)})}N(A,W){this.f?.logIncoming(A,W,1,"receiveCancel");const V=String(W);this.u[V]?.()}O(A,W,V){this.f?.logIncoming(A,W,0,"receiveReply:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U],B.resolveOk(V)}P(A,W,V){this.f?.logIncoming(A,W,0,"receiveReplyErr:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),B.resolveErr(O)}Q(A,W,V){try{return Promise.resolve(this.S(A,W,V))}catch(U){return Promise.reject(U)}}S(A,W,V){const U=this.m[A];if(!U)throw new Error("Unknown actor "+(0,P.$jv)(A));const B=U[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,P.$jv)(A));return B.apply(U,V)}U(A,W,V){if(this.j)return new g.$c4b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(F.$5());const B=S.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),te=new g.$b4b,Z=new l.$Qc;U&&Z.add(U.onCancellationRequested(()=>{const Ee=S.serializeCancel(O);this.f?.logOutgoing(Ee.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new y(te,Z),this.F(O);const ye=S.serializeRequest(O,A,W,B,!!U);return this.f?.logOutgoing(ye.byteLength,O,0,`request: ${(0,P.$jv)(A)}.${W}(`,V),this.c.send(ye),te}}e.$f4b=o;class y{constructor(A,W){this.a=A,this.b=W}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class d{static alloc(A,W,V){const U=new d(M.$ae.alloc(V+1+4),0);return U.writeUInt8(A),U.writeUInt32(W),U}static read(A,W){return new d(A,W)}get buffer(){return this.a}constructor(A,W){this.a=A,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+A).toString();return this.b+=A,V}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+A).toString();return this.b+=A,V}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+A);return this.b+=A,W}static sizeMixedArray(A){let W=0;W+=1;for(let V=0,U=A.length;V<U;V++){const B=A[V];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let W=0,V=A.length;W<V;W++){const U=A[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let B=0;B<U.buffers.length;++B)this.writeBuffer(U.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const W=new Array(A);for(let V=0;V<A;V++)switch(this.readUInt8()){case 1:W[V]=this.readLongString();break;case 2:W[V]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let te=0;te<B;++te)N.push(this.readVSBuffer());W[V]=new P.$kv(i(O,N,null));break}case 4:W[V]=void 0;break}return W}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(A){for(let W=0,V=A.length;W<V;W++)if(A[W]instanceof M.$ae||A[W]instanceof P.$kv||typeof A[W]>"u")return!0;return!1}static serializeRequestArguments(A,W){if(this.a(A)){const V=[];for(let U=0,B=A.length;U<B;U++){const O=A[U];if(O instanceof M.$ae)V[U]={type:2,value:O};else if(typeof O>"u")V[U]={type:4};else if(O instanceof P.$kv){const{jsonString:N,referencedBuffers:te}=t(O.value,W);V[U]={type:3,value:M.$ae.fromString(N),buffers:te}}else V[U]={type:1,value:M.$ae.fromString(c(O,W))}}return{type:1,args:V}}return{type:0,args:c(A,W)}}static serializeRequest(A,W,V,U,B){switch(U.type){case 0:return this.b(A,W,V,U.args,B);case 1:return this.c(A,W,V,U.args,B)}}static b(A,W,V,U,B){const O=M.$ae.fromString(V),N=M.$ae.fromString(U);let te=0;te+=d.sizeUInt8(),te+=d.sizeShortString(O),te+=d.sizeLongString(N);const Z=d.alloc(B?2:1,A,te);return Z.writeUInt8(W),Z.writeShortString(O),Z.writeLongString(N),Z.buffer}static deserializeRequestJSONArgs(A){const W=A.readUInt8(),V=A.readShortString(),U=A.readLongString();return{rpcId:W,method:V,args:JSON.parse(U)}}static c(A,W,V,U,B){const O=M.$ae.fromString(V);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(O),N+=d.sizeMixedArray(U);const te=d.alloc(B?4:3,A,N);return te.writeUInt8(W),te.writeShortString(O),te.writeMixedArray(U),te.buffer}static deserializeRequestMixedArgs(A){const W=A.readUInt8(),V=A.readShortString(),U=A.readMixedArray(),B=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const te=U[O];typeof te=="string"?B[O]=JSON.parse(te):B[O]=te}return{rpcId:W,method:V,args:B}}static serializeAcknowledged(A){return d.alloc(5,A,0).buffer}static serializeCancel(A){return d.alloc(6,A,0).buffer}static serializeReplyOK(A,W,V){if(typeof W>"u")return this.d(A);if(W instanceof M.$ae)return this.e(A,W);if(W instanceof P.$kv){const{jsonString:U,referencedBuffers:B}=t(W.value,V,!0);return this.g(A,U,B)}else return this.f(A,a(W,V))}static d(A){return d.alloc(7,A,0).buffer}static e(A,W){let V=0;V+=d.sizeVSBuffer(W);const U=d.alloc(8,A,V);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,W){const V=M.$ae.fromString(W);let U=0;U+=d.sizeLongString(V);const B=d.alloc(9,A,U);return B.writeLongString(V),B.buffer}static g(A,W,V){const U=M.$ae.fromString(W);let B=0;B+=d.sizeUInt32,B+=d.sizeLongString(U);for(const N of V)B+=d.sizeVSBuffer(N);const O=d.alloc(10,A,B);O.writeUInt32(V.length),O.writeLongString(U);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(A){const W=A.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(A,W){const V=A.readUInt32(),U=A.readLongString(),B=[];for(let O=0;O<V;++O)B.push(A.readVSBuffer());return new P.$kv(i(U,B,W))}static serializeReplyErr(A,W){const V=W?a(F.$2(W),null):void 0;if(typeof V!="string")return this.h(A);const U=M.$ae.fromString(V);let B=0;B+=d.sizeLongString(U);const O=d.alloc(11,A,B);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(A){const W=A.readLongString();return JSON.parse(W)}static h(A){return d.alloc(12,A,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(m||(m={}))}),define(Re[262],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=void 0;const w=function(F){const R=l=>{globalThis.removeEventListener("message",R);const D=l.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){D.postMessage(g,P)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(F,R,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),P=URL.createObjectURL(g),k=new MessageChannel,a=P,p={type:"_newWorker",id:a,port:k.port2,url:P,options:l};F(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set($){k.port1.onmessage=$}},onmessageerror:{get(){return k.port1.onmessageerror},set($){k.port1.onmessageerror=$}}}),k.port1.addEventListener("messageerror",$=>{const f=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",$=>{const f=new MessageEvent("message",{data:$.data});this.dispatchEvent(f)}),k.port1.start()}}e.$Xfc=M}),define(Re[263],Me([1,0,5,30,32,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.OutputChannelUpdateMode=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=void 0,e.$iJ="text/x-code-output",e.$jJ="output",e.$kJ="Log",e.$lJ="text/x-code-log-output",e.$mJ="log",e.$nJ="workbench.panel.output",e.$oJ=new C.$5i("inOutput",!1),e.$pJ=new C.$5i("activeLogOutput",!1),e.$qJ=new C.$5i("outputView.scrollLock",!1),e.$rJ=(0,F.$Nh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new w.$Md,this.onDidRegisterChannel=this.b.event,this.c=new w.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}M.$bn.add(e.$sJ.OutputChannels,new l),e.$tJ=new C.$5i("activeOutputChannel","")}),define(Re[109],Me([1,0,3,4,17,20,14,263,61,27,39,129,25,16,38,5,6]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class i extends R.$bj{get disposed(){return this.n}constructor(v,r,s,n,o){super(),this.id=v,this.name=r,this.r=s,this.s=n,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const r=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(v,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:r))}hide(){this.s.$close(this.id)}g(v,r){this.m+=a.$ae.fromString(r).byteLength,(0,R.log)(this.r,v,r),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(v){this.append(v)}}let b=class{constructor(v,r,s,n,o,y){this.i=r,this.j=s,this.k=n,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(w.$0J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,k.$am)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(v,r,s){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,o=(0,p.$xf)(r)?r:void 0;if((0,p.$xf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const d=this.i.environment.extensionLogLevel?.find(([S])=>F.$2l.equals(s.identifier,S))?.[1];d&&(y=(0,R.$lj)(d));const I=n?this.o(v,y,s):this.n(v,o,s);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),n?this.r(v,y??this.m.getLevel(),I):this.q(v,I)}async n(v,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,o=this.k.extUri.joinPath(n,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(v,o,r,s.identifier.value);return new i(d,v,y,this.a,s)}async o(v,r,s){const n=await this.p(s),o=v.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(n,`${o}.log`),d=`${s.identifier.value}.${o}`,I=this.l.createLogger(y,{id:d,name:v,logLevel:r,extensionId:s.identifier.value});return new c(d,v,I,this.a,s)}p(v){let r=this.d.get(v.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(n){if((0,$.$lk)(n)!==$.FileSystemProviderErrorCode.FileExists)throw n}return s})())}return r}q(v,r){let s=!1;const n=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return v},append(o){n(),r.then(y=>y.append(o))},appendLine(o){n(),r.then(y=>y.appendLine(o))},clear(){n(),r.then(o=>o.clear())},replace(o){n(),r.then(y=>y.replace(o))},show(o,y){n(),r.then(d=>d.show(o,y))},hide(){n(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r(v,r,s){const n=new t.$Qc,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},y=n.add(new f.$Md);function d(I){r=I,y.fire(I)}return s.then(I=>{n.add(I),I.logLevel!==r&&d(I.logLevel),n.add(I.onDidChangeLogLevel(S=>d(S)))}),{...this.q(v,s),get logLevel(){return r},onDidChangeLogLevel:y.event,trace(I,...S){o(),s.then(u=>u.trace(I,...S))},debug(I,...S){o(),s.then(u=>u.debug(I,...S))},info(I,...S){o(),s.then(u=>u.info(I,...S))},warn(I,...S){o(),s.then(u=>u.warn(I,...S))},error(I,...S){o(),s.then(u=>u.error(I,...S))},dispose(){n.dispose()}}}};e.$zcc=b,e.$zcc=b=Ke([We(0,C.$$L),We(1,g.$oM),We(2,D.$ccc),We(3,P.$Jbc),We(4,R.$9i),We(5,R.$8i)],b),e.$Acc=(0,M.$Nh)("IExtHostOutputService")}),define(Re[264],Me([1,0,4,12]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=(0,w.$Nh)("remoteAgentService"),e.$qm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let l=0;l<this.maxSampleCount;l++){const D=await C.getRoundTripTime();if(D===void 0)return;F=Math.min(F,D/2),await(0,M.$Tg)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((l,D)=>l+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((l,D)=>l+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Re[265],Me([1,0,42,13,19,22,23,2,4,186,54,208,264]),function(be,e,w,M,C,F,R,l,D,g,P,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=void 0,e.$LJ=(0,D.$Nh)("pathService");let $=p=class{constructor(t,i,c,b){this.d=t,this.e=i,this.f=c,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(b=>this.h(t,b,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Uf)(c??(0,R.$rg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,g.$IJ)(i.getWorkspace());if(c)return c;const b=i.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$ec:C.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(i=t.substring(2),t="/"):(i=t.substring(2,b),t=t.substring(b)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$MJ=$,e.$MJ=$=p=Ke([We(1,a.$pm),We(2,k.$uJ),We(3,P.$Wh)],$)}),define(Re[110],Me([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$vI=e.$uI=void 0;class w{constructor(R,l){this.line=R,this.character=l}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,l){return new w(0,0)}with(R){return new w(0,0)}}e.$uI=w;class M{constructor(R,l,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(R,l),this.end=new w(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$vI=M;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Re[47],Me([1,0,18,37,24,42,15,4,19,9,110,12]),function(be,e,w,M,C,F,R,l,D,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.SearchErrorCode=e.$KI=e.$JI=e.SearchSortOrder=e.ViewMode=e.$II=e.$HI=e.$GI=e.$FI=e.SearchCompletionExitCode=e.$EI=e.$DI=e.$CI=e.QueryType=e.SearchProviderType=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$wI="workbench.view.search",e.$xI="workbench.panel.search",e.$yI="workbench.view.search",e.$zI="search-result",e.$AI="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",$=(a.length+p.length+5)*2;e.$BI=(0,l.$Nh)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Y){return!!Y.preview}e.$CI=i;function c(Y){return!!Y.resource}e.$DI=c;function b(Y){return!!Y.message}e.$EI=b;var E;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(ae){this.resource=ae,this.results=[]}}e.$FI=v;class r{constructor(ae,Se,ue,$e){this.ranges=Se,this.webviewIndex=$e;const ie=Array.isArray(Se)?Se:[Se];if(ue&&ue.matchLines===1&&s(ie)){ae=(0,R.$qf)(ae,ue.matchLines);let z="",q=0,le=0;const we=Math.floor(ue.charsPerLine/5),ve=[];for(const me of ie){const De=Math.max(me.startColumn-we,0),re=me.startColumn+ue.charsPerLine;if(De>le+we+$){const he=a+(De-le)+p;z+=he+ae.slice(De,re),q+=De-(le+he.length)}else z+=ae.slice(le,re);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),le=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(Se)?Se[0].startLineNumber:Se.startLineNumber;this.preview={text:ae,matches:(0,w.$1b)(Se,q=>new n(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$GI=r;function s(Y){const ae=Y[0].startLineNumber;for(const Se of Y)if(Se.startLineNumber!==ae||Se.endLineNumber!==ae)return!1;return!0}class n{constructor(ae,Se,ue,$e){this.startLineNumber=ae,this.startColumn=Se,this.endLineNumber=ue,this.endColumn=$e}}e.$HI=n;class o extends n{constructor(ae,Se,ue){super(ae,Se,ae,ue)}}e.$II=o;var y;(function(Y){Y.List="list",Y.Tree="tree"})(y||(e.ViewMode=y={}));var d;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function I(Y,ae=!0){const Se=Y&&Y.files&&Y.files.exclude,ue=ae&&Y&&Y.search&&Y.search.exclude;if(!Se&&!ue)return;if(!Se||!ue)return Se||ue;let $e=Object.create(null);return $e=C.$5m($e,C.$2m(Se)),$e=C.$5m($e,C.$2m(ue),!0),$e}e.$JI=I;function S(Y,ae){return Y.excludePattern&&M.$tj(Y.excludePattern,ae)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&M.$tj(Y.includePattern,ae)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(Se=>{const ue=Se.folder.fsPath;if(F.$Wf(ae,ue)){const $e=D.$kc(ue,ae);return!Se.includePattern||!!M.$tj(Se.includePattern,$e)}else return!1}):!1:!0}e.$KI=S;var u;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(ae,Se){super(ae),this.code=Se}}e.$LI=m;function h(Y){const ae=Y.message;if((0,g.$3)(Y))return new m(ae,u.canceled);try{const Se=JSON.parse(ae);return new m(Se.message,Se.code)}catch{return new m(ae,u.other)}}e.$MI=h;function A(Y){const ae={message:Y.message,code:Y.code};return new Error(JSON.stringify(ae))}e.$NI=A;function W(Y){return Y.type==="error"?!0:Y.type==="success"}e.$OI=W;function V(Y){return Y.type==="success"}e.$PI=V;function U(Y){return!!Y.path}e.$QI=U;function B(Y,ae){const Se=Y.searchPath?Y.searchPath:Y.relativePath;return(0,R.$nf)(Se,ae)}e.$RI=B;class O{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$SI=O;function N(Y,ae){const Se={...Y||{},...ae||{}};return Object.keys(Se).filter(ue=>{const $e=Se[ue];return typeof $e=="boolean"&&$e})}e.$TI=N;class te{constructor(ae,Se){this.c=null,this.a={...ae.excludePattern||{},...Se.excludePattern||{}},this.b=M.$uj(this.a);let ue=ae.includePattern;Se.includePattern&&(ue?ue={...ue,...Se.includePattern}:ue=Se.includePattern),ue&&(this.c=M.$uj(ue))}matchesExcludesSync(ae,Se,ue){return!!(this.b&&this.b(ae,Se,ue))}includedInQuerySync(ae,Se,ue){return!(this.b&&this.b(ae,Se,ue)||this.c&&!this.c(ae,Se,ue))}includedInQuery(ae,Se,ue){const $e=this.b(ae,Se,ue),ie=()=>this.c?!!this.c(ae,Se,ue):!0;return(0,k.$Fg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$UI=te;function Z(Y){for(const ae in Y)if(typeof Y[ae]!="boolean")return!0;return!1}function ye(Y){if(!Y)return;let ae;return Se=>(ae||(ae=(Y()||Promise.resolve([])).then(ue=>ue?Pe(ue):{})),ae.then(ue=>!!ue[Se]))}e.$VI=ye;function Ee(Y){if(!Y)return;let ae;return Se=>{if(!ae){const ue=Y();ae=ue?Pe(ue):{}}return!!ae[Se]}}e.$WI=Ee;function Pe(Y){const ae={};for(const Se of Y)ae[Se]=!0;return ae}}),define(Re[33],Me([1,0,18,12,21,5,6,49,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,55,47,3]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;function y(W,V,U){return new P.$jg(B=>u(B,U)).isEqual(W,V)}function d(W,V,U){return y(W.uri,V.uri,U)?0:(0,k.$Te)(W.uri.toString(),V.uri.toString())}function I(W,V,U){return W.index!==V.index?W.index<V.index?-1:1:y(W.uri,V.uri,U)?(0,k.$Te)(W.name,V.name):(0,k.$Te)(W.uri.toString(),V.uri.toString())}function S(W,V,U,B){const O=W.slice(0).sort((te,Z)=>U(te,Z,B)),N=V.slice(0).sort((te,Z)=>U(te,Z,B));return(0,w.$Db)(O,N,(te,Z)=>U(te,Z,B))}function u(W,V){const U=V.getCapabilities(W.scheme);return!(U&&U&1024)}class m extends i.$7h{static toExtHostWorkspace(V,U,B,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:te,folders:Z,configuration:ye,transient:Ee,isUntitled:Pe}=V,Y=[],ae=U;U?Z.forEach((ie,z)=>{const q=a.URI.revive(ie.uri),le=m.o(B||U,q,O);le?(le.name=ie.name,le.index=ie.index,Y.push(le)):Y.push({uri:q,name:ie.name,index:z})}):Y.push(...Z.map(({uri:ie,name:z,index:q})=>({uri:a.URI.revive(ie),name:z,index:q}))),Y.sort((ie,z)=>ie.index<z.index?-1:1);const Se=new m(N,te,Y,!!Ee,ye?a.URI.revive(ye):null,!!Pe,ie=>u(ie,O)),{added:ue,removed:$e}=S(ae?ae.workspaceFolders:[],Se.workspaceFolders,d,O);return{workspace:Se,added:ue,removed:$e}}static o(V,U,B){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(y(N.uri,U,B))return N}}constructor(V,U,B,O,N,te,Z){super(V,B.map(ye=>new i.$8h(ye)),O,N,Z),this.t=U,this.u=te,this.q=[],this.s=l.$Th.forUris(Z),B.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$tg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let h=class{constructor(V,U,B,O,N){this.c=new F.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Od,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new g.$Ml,this.k=new M.$Rg,this.o=V.getProxy(o.$0J.MainThreadWorkspace),this.q=V.getProxy(o.$0J.MainThreadMessageService);const te=U.workspace;this.l=te?new m(te.id,te.name,[],!!te.transient,te.configuration?a.URI.revive(te.configuration):null,!!te.isUntitled,Z=>u(Z,B)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,P.$rg)((0,P.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some(Y=>y(Y.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$qg)(Pe.uri)})}),this.n||[U,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(U+B>te.length)return!1;const Z=te.slice(0);Z.splice(U,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$qg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Z.length;Pe++){const Y=Z[Pe];if(Z.some((ae,Se)=>Se!==Pe&&y(Y.uri,ae.uri,this.s)))return!1}Z.forEach((Pe,Y)=>Pe.index=Y);const{added:ye,removed:Ee}=S(te,Z,I,this.s);if(ye.length===0&&Ee.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,B,N).then(void 0,Y=>{this.n=void 0;const ae={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,Y.toString()),ae,[])})}return this.y(Z),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let B,O="";if(typeof V=="string"?(B=a.URI.file(V),O=V):typeof V<"u"&&(B=V,O=V.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let te=(0,P.$wg)(N.uri,B);return U&&N.name&&(te=`${N.name}/${te}`),te}y(V){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:B,removed:O}=m.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(U===null?te=!1:U&&(typeof U=="string"?te=U:te=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:ye}=A(v.GlobPattern.from(V));return this.o.$startFileSearch(Z??null,ye??null,te??null,B??null,N).then(Ee=>Array.isArray(Ee)?Ee.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),Z=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:Ee}=A(v.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Y={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Z,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:Pe},ae=!1;if(this.u[te]=Se=>{if(ae)return;const ue=a.URI.revive(Se.resource);Se.results.forEach($e=>{(0,n.$CI)($e)?B({uri:ue,preview:{text:$e.preview.text,matches:(0,w.$1b)($e.preview.matches,ie=>new r.$bK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$1b)($e.ranges,ie=>new r.$bK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):B({uri:ue,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(V,Ee??null,Y,te,N);return delete this.u[te],Se||{}}catch(Se){throw delete this.u[te],Se}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return a.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return a.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,R.$Pc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const B=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,U,B,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const te=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!te),!te)return;const Z=await te.provideEditSessionIdentityMatch?.(U,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(V){return(U,B,O)=>{const N=function(Z){U.call(B,Z)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,U,B){const O=await this.resolveWorkspaceFolder(a.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,te)=>{const Z=Date.now();await Promise.resolve(N),Date.now()-Z>B&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,R.$Pc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,U,B){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(a.URI.revive(V),U,B);if(N)return N}async $provideCanonicalUri(V,U,B){return this.provideCanonicalUri(a.URI.revive(V),{targetScheme:U},B)}};e.$Vbc=h,e.$Vbc=h=Ke([We(0,E.$$L),We(1,b.$oM),We(2,c.$Jbc),We(3,f.$8i),We(4,s.$Tbc)],h),e.$Wbc=(0,$.$Nh)("IExtHostWorkspace");function A(W){let V,U;return W&&(typeof W=="string"?V=W:(V=W.pattern,U=a.URI.revive(W.baseUri))),{includePattern:V,folder:U}}}),define(Re[34],Me([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=void 0;function f(s,n){if(n){const o=n.split(".");let y=s;for(let d=0;y&&d<o.length;d++)y=y[o[d]];return y}}function t(s){return s instanceof $.URI}function i(s){return s&&s.uri instanceof $.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof $.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function E(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(n,o,y){this.a=n.getProxy(F.$0J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(n,o))}};e.$Xbc=v,e.$Xbc=v=Ke([We(0,a.$$L),We(1,C.$Wbc),We(2,p.$8i)],v);class r{constructor(n,o,y,d){this.a=new M.$Md,this.b=n,this.f=d,this.c=o,this.e=l.$zn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$zn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(n,o,y){const d=E(o)||{},I=this.g(n?f(this.e.getValue(void 0,d,this.c.workspace),n):this.e.getValue(void 0,d,this.c.workspace));n&&this.h(n,d,y?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof f(I,m)<"u"},get:(m,h)=>{this.h(n?`${n}.${m}`:m,d,y?.identifier);let A=f(I,m);if(typeof A>"u")A=h;else{let W;const V=(U,B)=>{if((0,g.$zf)(U)){let O;const N=()=>{W=W||(0,w.$2m)(I),O=O||f(W,B)};return new Proxy(U,{get:(te,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||f(W,B),O[Z];const ye=te[Z];return typeof Z=="string"?V(ye,`${B}.${Z}`):ye},set:(te,Z,ye)=>(N(),O&&(O[Z]=ye),!0),deleteProperty:(te,Z)=>(N(),O&&delete O[Z],!0),defineProperty:(te,Z,ye)=>(N(),O&&Object.defineProperty(O,Z,ye),!0)})}return Array.isArray(U)?(0,w.$2m)(U):U};A=V(A,m)}return A},update:(m,h,A,W)=>{m=n?`${n}.${m}`:m;const V=S(A);return h!==void 0?this.b.$updateConfigurationOption(V,m,h,d,W):this.b.$removeConfigurationOption(V,m,d,W)},inspect:m=>{m=n?`${n}.${m}`:m;const h=this.e.inspect(m,d,this.c.workspace);if(h)return{key:m,defaultValue:(0,w.$2m)(h.policy?.value??h.default?.value),globalValue:(0,w.$2m)(h.user?.value??h.application?.value),workspaceValue:(0,w.$2m)(h.workspace?.value),workspaceFolderValue:(0,w.$2m)(h.workspaceFolder?.value),defaultLanguageValue:(0,w.$2m)(h.default?.override),globalLanguageValue:(0,w.$2m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,w.$2m)(h.workspace?.override),workspaceFolderLanguageValue:(0,w.$2m)(h.workspaceFolder?.override),languageIds:(0,w.$2m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.$5m)(u,I,!1),Object.freeze(u)}g(n){const o=y=>(0,g.$zf)(y)?new Proxy(y,{get:(d,I)=>o(d[I]),set:(d,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(d,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(d,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(n)}h(n,o,y){const d=D.$qn.test(n)?4:this.d.get(n),I=y?`[${y.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,o){const y=new l.$Bn(n,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,I)=>y.affectsConfiguration(d,E(I))})}k(n){return n.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$Ybc=r,e.$Zbc=(0,k.$Nh)("IExtHostConfiguration")}),define(Re[111],Me([1,0,2,12,5,3,7,33,59,34,21,62,17,27,4,13,22,14,80,214,9]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=e.$Vcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(v||(v={}));var r;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(r||(r={}));var s;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(s||(s={}));var n;(function(V){function U(N){if(N){const te=N;return te&&!!te.process}else return!1}V.is=U;function B(N){if(N==null)return;const te={process:N.process,args:N.args};return N.options&&(te.options=s.from(N.options)),te}V.from=B;function O(N){if(N!=null)return new R.$TK(N.process,N.args,N.options)}V.to=O})(n||(n={}));var o;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(o||(o={}));var y;(function(V){function U(N){if(N){const te=N;return te&&(!!te.commandLine||!!te.command)}else return!1}V.is=U;function B(N){if(N==null)return;const te={};return N.commandLine!==void 0?te.commandLine=N.commandLine:(te.command=N.command,te.args=N.args),N.options&&(te.options=o.from(N.options)),te}V.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$UK(N.commandLine,N.options):new R.$UK(N.command,N.args?N.args:[],N.options)}V.to=O})(y||(y={}));var d;(function(V){function U(N){if(N){const te=N;return te&&te.customExecution==="customExecution"}else return!1}V.is=U;function B(N){return{customExecution:"customExecution"}}V.from=B;function O(N,te){return te.get(N)}V.to=O})(d||(e.CustomExecutionDTO=d={}));var I;(function(V){function U(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=b.$LF),{id:B._id,workspaceFolder:N}}V.from=U})(I||(e.TaskHandleDTO=I={}));var S;(function(V){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}V.from=U})(S||(S={}));var u;(function(V){function U(N,te){if(N==null)return[];const Z=[];for(const ye of N){const Ee=B(ye,te);Ee&&Z.push(Ee)}return Z}V.fromMany=U;function B(N,te){if(N==null)return;let Z;N.execution instanceof R.$TK?Z=n.from(N.execution):N.execution instanceof R.$UK?Z=y.from(N.execution):N.execution&&N.execution instanceof R.$VK&&(Z=d.from(N.execution));const ye=v.from(N.definition);let Ee;return N.scope?typeof N.scope=="number"?Ee=N.scope:Ee=N.scope.uri:Ee=R.TaskScope.Workspace,!ye||!Ee?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:te.identifier.value,label:N.source,scope:Ee},execution:Z,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=B;async function O(N,te,Z){if(N==null)return;let ye;n.is(N.execution)?ye=n.to(N.execution):y.is(N.execution)?ye=y.to(N.execution):d.is(N.execution)&&(ye=d.to(N._id,Z));const Ee=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await te.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=R.TaskScope.Workspace),!Ee||!Pe)return;const Y=new R.$WK(Ee,Pe,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(Y.isBackground=N.isBackground),N.group!==void 0&&(Y.group=R.$SK.from(N.group._id),Y.group&&N.group.isDefault&&(Y.group=new R.$SK(Y.group.id,Y.group.label),N.group.isDefault===!0&&(Y.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Y.presentationOptions=r.to(N.presentationOptions)),N._id&&(Y._id=N._id),N.detail&&(Y.detail=N.detail),Y}V.to=O})(u||(e.TaskDTO=u={}));var m;(function(V){function U(O){return O}V.from=U;function B(O){if(O)return Object.assign(Object.create(null),O)}V.to=B})(m||(m={}));class h{#e;constructor(U,B,O){this._id=B,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let A=class{constructor(U,B,O,N,te,Z,ye,Ee){this.q=new C.$Md,this.r=new C.$Md,this.s=new C.$Md,this.t=new C.$Md,this.a=U.getProxy(F.$0J.MainThreadTask),this.b=O,this.c=N,this.d=te,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,O){if(!O)return new R.$_J(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:U}),this.a.$registerTaskProvider(N,B),new R.$_J(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(m.from(U)).then(async B=>{const O=[];for(const N of B){const te=await u.to(N,this.b,this.m);te&&O.push(te)}return O})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],te=(0,M.$Lg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(Z=>this.u(B,N,O,Z));return new Promise(Z=>{te.then(ye=>{Promise.all(N).then(()=>{Z(ye)})})})}async $resolveTask(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const te=await O.provider.resolveTask(N,P.CancellationToken.None);if(!te)return;this.z(te,O);const Z=u.from(te,O.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Z.execution)&&await this.x(Z,te,!0),await this.v(Z)}w(){return this.h++}async x(U,B,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(U,B){if(typeof U=="string"){const te=this.l.get(U);if(!te)throw new E.$ab("Unexpected: The specified task is missing an execution");return te}const O=this.l.get(U.id);if(O)return O;const N=new Promise((te,Z)=>{function ye(Ee,Pe,Y){Y?te(new h(Ee,Pe.id,Y)):Z("Unexpected: Task does not exist.")}B?ye(this,U,B):u.to(U.task,this.b,this.m).then(Ee=>ye(this,U,Ee))});return this.l.set(U.id,N),N.then(te=>(this.k.set(U.id,te),te),te=>Promise.reject(te))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$Vcc=A,e.$Vcc=A=Ke([We(0,a.$$L),We(1,p.$oM),We(2,l.$Wbc),We(3,D.$jM),We(4,g.$Zbc),We(5,k.$fcc),We(6,i.$8i),We(7,c.$Mbc)],A);let W=class extends A{constructor(U,B,O,N,te,Z,ye,Ee){super(U,B,O,N,te,Z,ye,Ee),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(B,U);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.x(O,B,!1);else throw new E.$$;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(te=>{throw new Error(te)}),N}u(U,B,O,N){const te=[];if(N)for(const Z of N){this.z(Z,O),(!Z.definition||!U[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=u.from(Z,O.extension);ye&&d.is(ye.execution)?(te.push(ye),B.push(this.x(ye,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:te,extension:O.extension}}async v(U){if(d.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,O){}};e.$Wcc=W,e.$Wcc=W=Ke([We(0,a.$$L),We(1,p.$oM),We(2,l.$Wbc),We(3,D.$jM),We(4,g.$Zbc),We(5,k.$fcc),We(6,i.$8i),We(7,c.$Mbc)],W),e.$Xcc=(0,$.$Nh)("IExtHostTask")}),define(Re[266],Me([1,0,19,21,41,37,23,58,47]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class g{constructor(a,p,$){this.k=a,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&F.$uj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&F.$uj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const p=this.k.folderQueries||[];return new Promise(($,f)=>{const t=i=>{this.f++,a(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),b=w.$mc(c);this.j&&this.j(c,b)||this.v(t,{base:i,basename:b})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,C.$yi)(i)))})})}async p(a,p){const $=new M.$Wd,f=this.q(a),t=this.r(),i=new D.$UI(this.k,a),c=!i.hasSiblingExcludeClauses();let b;try{this.h.add($),b=l.$Id.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,$.token),v=b.elapsed(),r=l.$Id.create();return this.g&&!this.e||(E&&E.forEach(s=>{const n=w.$fc.relative(a.folder.path,s.path);if(c){const o=w.$mc(s.path);this.v(p,{base:a.folder,relativePath:n,basename:o});return}this.s(t,a.folder,n,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:v,postProcessTime:r.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(a){const p=(0,D.$TI)(this.k.includePattern,a.includePattern),$=(0,D.$TI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:$,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},p,$,f){if($===this.a){const i=w.$mc(this.a);this.v(f,{base:p,relativePath:this.a,basename:i})}function t(i){const c=w.$mc(i),b=w.$lc(i);let E=a[b];E||(E=a[b]=[],t(b)),E.push({base:p,relativePath:i,basename:c})}t($)}u({rootEntries:a,pathToEntries:p},$,f){const t=this,i=this.a;function c(b){const E=(0,D.$WI)(()=>b.map(v=>v.basename));for(let v=0,r=b.length;v<r;v++){const s=b[v],{relativePath:n,basename:o}=s;if($.matchesExcludesSync(n,o,i!==o?E:void 0))continue;const y=p[n];if(y)c(y);else{if(n===i)continue;t.v(f,s)}if(t.e)break}}c(a)}v(a,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,p,$,f){const t=this.c(a.cacheKey),i=new g(a,p,t&&t.token);let c=0;const b=E=>{c+=E.length,$(E.map(v=>this.d(v)))};return this.e(i,P.a,b,f).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Wd),this.b.get(a)}d(a){return a.relativePath?{resource:R.$ug(a.base,a.relativePath)}:{resource:a.base}}e(a,p,$,f){const t=f.onCancellationRequested(()=>{a.cancel()}),i=b=>{b&&(c.push(b),p>0&&c.length>=p&&($(c),c=[]))};let c=[];return a.search(i).then(b=>(c.length&&$(c),t.dispose(),b),b=>(c.length&&$(c),t.dispose(),Promise.reject(b)))}}e.$8cc=P}),define(Re[267],Me([1,0,18,231,37,90,28,13,19,23,15,16,2,282,167,43,14,54,102,265,47]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=void 0;let v=class{constructor(m,h,A,W,V){this.a=m,this.b=h,this.c=A,this.d=W,this.e=V}text(m,h,A={}){m=this.f(m,A);const W=this.a.getValue(),V=h&&h.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(h?.map(i.$9h),A),type:2,contentPattern:m,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(m,h){const A=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const W={...m,wordSeparators:A.editor.wordSeparators};return this.j(m,h)&&(W.isCaseSensitive=!0),this.k(m)&&(W.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),W}file(m,h={}){return{...this.h(m,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(m,h){return m?(m=Array.isArray(m)?m.map(y):y(m),h?this.parseSearchPaths(m):{pattern:s(...Array.isArray(m)?m:[m])}):{}}h(m=[],h={}){const A=this.g(h.includePattern,h.expandPatterns),W=this.g(h.excludePattern,h.expandPatterns),V=m.length>1,U=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(N=>this.q(N,h,W)):m.map(N=>this.r(N,h,W,V))).filter(N=>!!N),B={_reason:h._reason,folderQueries:U,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:W.pattern,includePattern:A.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=w.$Gb(w.$Qb(this.c.groups.map(ye=>ye.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const te=N.filter(ye=>(0,E.$KI)(B,ye.fsPath)),Z=this.i(te);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...B,...Z}}const O=h.extraFileResources&&h.extraFileResources.filter(N=>(0,E.$KI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(m){const h=[],A=new R.$zc,W={};let V=!1;return m.forEach(U=>{if(U.scheme===l.Schemas.walkThrough)return;if((0,g.$yg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$lc(U.fsPath)});let N=A.get(O);N||(V=!0,N={folder:O,includePattern:{}},h.push(N),A.set(O,N));const te=D.$kc(O.fsPath,U.fsPath);(0,k.$If)(N.includePattern)[te.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,W[U.fsPath]=!0)}),{folderQueries:h,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(m,h){if(h.isSmartCase){if(m.isRegExp){if(P.$of(m.pattern,!0))return!0}else if(P.$of(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.$oB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const h=Z=>D.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),W=(Array.isArray(m)?m:n(m)).map(Z=>{const ye=this.e.resolvedUserHome;return ye?(0,F.$ov)(Z,ye.scheme===l.Schemas.file?ye.fsPath:ye.path):Z}),V=M.$J(W,Z=>h(Z)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Z=>P.$Je(Z,"/")).map(Z=>P.$Je(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),o(Z))),B={},O=this.m(V.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=w.$Qb(U),te=s(...N);return te&&(B.pattern=te),B}l(m,h){return h.disregardExcludeSettings?void 0:(0,E.$JI)(m,!h.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const h=m.flatMap(W=>{let{pathPortion:V,globPortion:U}=r(W);return U&&(U=d(U)),this.n(V).flatMap(O=>this.o(O,U))}),A=new Map;return h.forEach(W=>{const V=W.searchPath.toString(),U=A.get(V);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):A.set(V,{searchPath:W.searchPath,pattern:W.pattern?s(W.pattern):void 0})}),Array.from(A.values())}n(m){if(D.$hc(m)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:m})}]:[{searchPath:a.URI.file(D.$gc(m))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(m=y(m),m.startsWith("../")||m===".."){const W=D.$fc.resolve(h.path,m);return[{searchPath:h.with({path:W})}]}const A=d(m);return[{searchPath:h,pattern:A}]}else{if(m==="./"||m===".\\")return[];{const h=m.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const U=h.match(new RegExp(`^${P.$Ee(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(k.$Ff);if(W.length)return W.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&d(U)}});{const V=m.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:m,B=$.localize(0,null,U);throw new Error(B)}}}}o(m,h){const A=m.pattern&&h?`${m.pattern}/${h}`:m.pattern||h,W=[{searchPath:m.searchPath,pattern:A}];return A&&!A.endsWith("**")&&W.push({searchPath:m.searchPath,pattern:A+"/**"}),W}q(m,h,A){const W=this.r((0,i.$9h)(m.searchPath),h,A,!1);return W?{...W,includePattern:m.pattern}:null}r(m,h,A,W){let V;const U=a.URI.isUri(m)?m:m.uri;if(A.searchPaths){const Z=A.searchPaths.filter(ye=>(0,g.$ng)(ye.searchPath,U))[0];if(Z&&!Z.pattern)return null;Z&&(V=Z.pattern)}const B=this.a.getValue({resource:U}),N={...this.l(B,h)||{},...V||{}},te=a.URI.isUri(m)?(0,g.$rg)(m):m.name;return{folder:U,folderName:W?te:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!B.search.followSymlinks}}};e.$NJ=v,e.$NJ=v=Ke([We(0,f.$hi),We(1,i.$Wh),We(2,c.$$B),We(3,t.$8i),We(4,b.$LJ)],v);function r(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const h=m.index,A=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(A){let W=u.substr(0,A.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((A.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((m,h)=>(m[h]=!0,m),Object.create(null)):void 0}function n(u){return C.$sj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function y(u){return u.replace(/\\/g,"/")}function d(u){return y(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=w.$Lb(u,W=>W.toString());const h=[],A=m.getWorkspace();return u&&u.forEach(W=>{let V;if(m.getWorkbenchState()===2)V=(0,g.$wg)(A.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const U=m.getWorkspaceFolder(W);if(U){const B=U.name;if(A.folders.filter(N=>N.name===B).length===1){const N=(0,g.$wg)(U.uri,W);N===""?V=`./${U.name}`:V=`./${U.name}/${N}`}else V=W.fsPath}}V&&h.push(I(V))}),h}e.$OJ=S}),define(Re[268],Me([1,0,23,2,21,9,4,267,47,54]),function(be,e,w,M,C,F,R,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plb=e.$olb=void 0;const P=7e3;function k(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],b=[];for(const o of i)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?b.push(y):c.push(y)}if(c.length===0&&b.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,y)=>{E=o}),r=o=>E({activationEvent:o}),s=Promise.all(c.map(o=>a(f,o,r))).then(()=>{}),n=p(f,t.identifier,b,r);return Promise.all([s,n]).then(()=>{E(void 0)}),v}e.$olb=k;async function a(f,t,i){for(const c of f.folders)if(await f.exists(w.$ug(M.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(f,t,i,c){if(i.length===0)return Promise.resolve(void 0);const b=new C.$Wd,E=f.checkExists(f.folders,i,b.token),v=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let r=!1;try{r=await E}catch(s){F.$3(s)||F.$Z(s)}b.dispose(),clearTimeout(v),r&&c(`workspaceContains:${i.join(",")}`)}function $(f,t,i,c){const b=f.get(R.$Mh),E=f.get(D.$BI),r=b.createInstance(l.$NJ).file(t.map(s=>(0,g.$9h)(M.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(r,c).then(s=>!!s.limitHit,s=>F.$3(s)?!1:Promise.reject(s))}e.$plb=$}),define(Re[35],Me([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,70,86,62,5,268,83,190,13,81,58,22,82]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s,n,o,y,d,I,S,u,m,h,A,W,V,U,B,O,N){"use strict";var te;Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0,e.$qcc=(0,n.$Nh)("IHostUtils");let Z=te=class extends l.$Rc{constructor(ie,z,q,le,we,ve,me,De,re,he,se,oe){super(),this.X=oe,this.a=this.B(new m.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=me,this.j=le,this.m=we,this.s=ve,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(k.$0J.MainThreadWorkspace),this.z=this.g.getProxy(k.$0J.MainThreadTelemetry),this.C=this.g.getProxy(k.$0J.MainThreadExtensionService),this.D=new R.$Rg,this.F=new R.$Rg,this.G=new R.$Rg,this.H=new R.$Rg,this.I=new ue(this.f.extensions.activationEvents),this.L=new i.$93b(this.I,this.f.extensions.allExtensions);const de=new b.$3l(this.f.extensions.myExtensions);this.J=new i.$93b(this.I,ae(this.L,de)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$0bc(this.g,this.s),this.N=new A.$jcc(this.g),this.O=De,this.h=ie.createChild(new I.$Lh([$.$$bc,this.M],[A.$kcc,this.N])),this.P=this.B(new p.$9bc(this.J,this.L,{onExtensionActivationError:(Ie,L,K)=>{this.C.$onExtensionActivationError(Ie,c.$2(L),K)},actualActivateExtension:async(Ie,L)=>{if(i.$93b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,L),new p.$8bc;const K=this.J.getExtensionDescription(Ie);return this.db(K,L)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Z(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const q=this.Y();Promise.race([(0,R.$Tg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new b.$2l(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return g.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Se(ie))),this.Q}async bb(ie){const z=D.$Th.forUris(q=>F.$lg.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const le=await this.ab(q.extensionLocation);z.set(le,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$Mc)(q.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const le=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,z),this.eb(ie,z,"success",le),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,le){const we=Ee(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:q})}fb(ie,z){const q=Ee(ie,z);this.z.$publicLog2("activatePlugin",q);const le=this.ub(ie);if(!le)return Promise.resolve(new p.$7bc(p.$4bc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new p.$5bc(z.startup);return Promise.all([this.vb(ie,(0,F.$ug)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),te.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new v.$acc(ie,this.M),q=new v.$_bc(ie.identifier.value,!1,this.M),le=new W.$lcc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let De,re;const he=(0,t.$9E)(ie,"ipc")?this.f.messagePorts?.get(b.$2l.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return M.$ic(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return M.$ic(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return g.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new Y(me,ie.identifier,ie,ve,!1)),De},get extensionRuntime(){return(0,t.$0E)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=m.Event.buffer(m.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,q,le,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,le,we).then(ve=>new p.$6bc(!1,null,we.build(),q,ve,le.subscriptions))}static ib(ie,z,q,le,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(De=>(we.activateResolveStop(),De))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const le=Date.now();(0,O.$B)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const le of q)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),le=this.pb(),we=Promise.all([le,ie,q]).then(()=>{});return Promise.race([we,(0,R.$Tg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,De)=>this.y.$checkExists(ve,me,De)},we=await(0,h.$olb)(le,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new p.$5bc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((le,we)=>{const ve=(re,he)=>{re?(O.$t&&this.s.error("Test runner called back with error",re),we(re)):(O.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},me=(0,F.$ig)(z),De=q.run(me,ve);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),le(0)}).catch(re=>{O.$t&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,l.$Pc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$fK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=B.$Id.create(!1),le=()=>`[resolveAuthority(${(0,s.$Qk)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${le()}${Q}`),ve=Q=>this.s.warn(`${le()}${Q}`),me=(Q,H=void 0)=>this.s.error(`${le()}${Q}`,H),De=Q=>{if(Q instanceof r.$fK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:H,authorityPrefix:_}=await this.sb(Q);if(!H)throw me(`no resolver for ${_}`),new r.$fK(`No remote extension installed to resolve ${_}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:_,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$fK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return De(Q)}const oe=new R.$4g;oe.cancelAndSet(()=>we("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:H,resolver:_,remoteAuthority:ce}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),de=await _.resolve(ce,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,r.$eK.isManagedResolvedAuthority(de)?de:void 0));else{if(we(`invoking resolveExecServer() for ${ce}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await _.resolveExecServer?.(ce,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$fK(`Exec server was not available for ${ce}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Fe){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),me("returned an error",Fe),oe.dispose(),De(Fe)}oe.dispose();const L={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},K={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$eK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let G;if(r.$eK.isManagedResolvedAuthority(de)){const Q=z;this.X.setFactory(Q,de.makeConnection),G={authority:ie,connectTo:new s.$Nk(Q),connectionToken:de.connectionToken}}else G={authority:ie,connectTo:new s.$Ok(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:L}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Qk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const le=g.URI.revive(z);if(typeof q.getCanonicalURI>"u")return le;const we=await(0,R.$Lg)(()=>q.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=g.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=g.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie),le=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=E.$ae.alloc(ie),q=Math.random()%256;for(let le=0;le<ie;le++)z.writeUInt8(q,le);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$rcc=Z,e.$rcc=Z=te=Ke([We(0,n.$Mh),We(1,e.$qcc),We(2,d.$$L),We(3,f.$Wbc),We(4,a.$Zbc),We(5,P.$8i),We(6,o.$oM),We(7,y.$dcc),We(8,S.$Uvb),We(9,u.$fcc),We(10,U.$ncc),We(11,N.$occ)],Z);function ye($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const le=new i.$93b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(q.toAdd,q.toRemove);const we=new b.$3l(z.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=ae(le,we);return{globalRegistry:le,myExtensions:ve}}function Ee($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$scc=(0,n.$Nh)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(ie,z,q,le,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=M.$gc((0,F.$ig)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tcc=Y;function ae($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Se{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$ucc=Se;class ue{constructor(ie){this.a=new b.$4l,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Re[269],Me([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let f=class{constructor(E,v,r,s,n,o,y){this.c=E,this.d=v,this.e=r,this.f=s,this.g=n,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$Qdc=f,e.$Qdc=f=Ke([We(2,P.$Mh),We(3,F.$Zbc),We(4,k.$scc),We(5,g.$oM),We(6,a.$8i)],f);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const v=(0,p.$Ee)(this.c(E.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${n}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,r,s,n]=v,o=$.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+n}c(E){return E.replace(/\\/g,"/")}};t=$=Ke([We(0,g.$oM)],t);class i{constructor(E,v,r,s,n){this.c=E,this.d=v,this.e=r,this.f=s,this.g=n,this.nodeModuleName="vscode",this.a=new l.$4l}load(E,v){const r=this.d.findSubstr(v);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((n,o)=>s+=`	${o} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$4E,this.e,this.f)}return this.b}}let c=class{constructor(E,v,r){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$0J.MainThreadTelemetry);const s=r.getProxy(C.$0J.MainThreadWindow);this.c=(n,o)=>{const y=M.URI.parse(n);return o?this.g(n,o):y.scheme==="http"||y.scheme==="https"?s.$openUri(y,n,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?s.$openUri(y,n,{}):this.g(n,o)}}load(E,v,r){const s=this.e.findSubstr(v);return s&&(this.a=s.identifier.value,this.h()),this.b=r(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([We(2,D.$$L)],c)}),define(Re[112],Me([1,0,48,6,19,73,4,59,60,35,7,33,200,34]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0,e.$1cc=(0,R.$Nh)("IExtHostVariableResolverProvider");class $ extends a.$_M{constructor(i,c,b,E,v,r,s){function n(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const y=E.tabGroups.all.find(d=>d.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$RL||y.input instanceof P.$WL)return y.input.modified;if(y.input instanceof P.$QL||y.input instanceof P.$VL||y.input instanceof P.$TL)return y.input.uri}}}super({getFolderUri:o=>{const y=r.folders.filter(d=>d.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,y)=>v.getConfiguration(void 0,o).get(y),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return C.$gc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=n();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$gc(y.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let f=class extends M.$Rc{constructor(i,c,b,E,v){super(),this.b=i,this.c=c,this.g=b,this.h=E,this.j=v,this.a=new w.$U(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,r,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$2cc=f,e.$2cc=f=Ke([We(0,g.$scc),We(1,k.$Wbc),We(2,l.$jM),We(3,p.$Zbc),We(4,D.$Ycc)],f)}),define(Re[113],Me([1,0,12,5,2,4,3,60,35,17,7,33,193,195,34,112]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=e.$5cc=e.$4cc=e.$3cc=void 0,e.$3cc=(0,F.$Nh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,n,o,y,d,I){this.E=n,this.F=o,this.G=y,this.H=d,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Md,this.n=new M.$Md,this.o=new M.$Md,this.u=new M.$Md,this.k=s.getProxy(R.$0J.MainThreadDebugService),this.y=new M.$Md,this.A=new M.$Md,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(s,n){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,d="?";return n&&(y+=`${d}session=${encodeURIComponent(n.id)}`,d="&"),y+=`${d}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const n=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const d of y)(0,p.$oF)(d)&&n.push(d.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(n=>s.push(n)),s}addBreakpoints(s){const n=s.filter(d=>{const I=d.id;return this.w.has(I)?!1:(this.w.set(I,d),!0)});this.U(n,[],[]);const o=[],y=new Map;for(const d of n)if(d instanceof P.$$K){let I=y.get(d.location.uri.toString());I||(I={type:"sourceMulti",uri:d.location.uri,lines:[]},y.set(d.location.uri.toString(),I),o.push(I)),I.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof P.$_K&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const n=s.filter(I=>this.w.delete(I.id));this.U([],n,[]);const o=n.filter(I=>I instanceof P.$$K).map(I=>I.id),y=n.filter(I=>I instanceof P.$_K).map(I=>I.id),d=n.filter(I=>I instanceof P.$aL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,y,d)}startDebugging(s,n,o){return this.k.$startDebugging(s?s.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,n,o){if(!n)return new P.$_J(()=>{});const y=this.d++;return this.f.push({type:s,handle:y,provider:n}),this.k.$registerDebugConfigurationProvider(s,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$_J(()=>{this.f=this.f.filter(d=>d.provider!==n),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(s,n,o){if(!o)return new P.$_J(()=>{});if(!this.Q(s,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:n,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(n,y),new P.$_J(()=>{this.h=this.h.filter(d=>d.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(s,n){if(!n)return new P.$_J(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:n}),new P.$_J(()=>{this.j=this.j.filter(y=>y.factory!==n)})}async $runInTerminal(s,n){return Promise.resolve(void 0)}async $substituteVariables(s,n){let o;const y=await this.W(s);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,n)}K(s,n){if(s.type==="implementation")return new E(s.implementation)}L(){}async $startDASession(s,n){const o=this,y=await this.V(n);return this.S(this.N(y.type),y).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.M(d),S=this.K(I,y);if(!S)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const u=S;return this.B.set(s,u),this.R(y).then(m=>(m&&this.C.set(s,m),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const A=h,W={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(A.arguments.value);W.body={signature:V},u.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,u.sendResponse(W)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(h),h=(0,p.$tF)(h,!0),o.k.$acceptDAMessage(s,h)}),u.onError(h=>{m&&m.onError&&m.onError(h),this.k.$acceptDAError(s,h.name,h.message,h.stack)}),u.onExit(h=>{m&&m.onExit&&m.onExit(h??void 0,void 0),this.k.$acceptDAExit(s,h??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,n){n=(0,p.$sF)(n,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this.B.get(s)?.sendMessage(n)}$stopDASession(s){const n=this.C.get(s);this.C.delete(s),n&&n.onWillStopSession&&n.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const n=[],o=[],y=[];if(s.added)for(const d of s.added){const I=d.id;if(I&&!this.w.has(I)){let S;if(d.type==="function")S=new P.$_K(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new P.$aL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=C.URI.revive(d.uri);S=new P.$$K(new P.$lK(u,new P.$aK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,P.$9K)(S,I),this.w.set(I,S),n.push(S)}}if(s.removed)for(const d of s.removed){const I=this.w.get(d);I&&(this.w.delete(d),o.push(I))}if(s.changed){for(const d of s.changed)if(d.id){const I=this.w.get(d.id);if(I){if(I instanceof P.$_K&&d.type==="function"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(I instanceof P.$$K&&d.type==="source"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new P.$lK(C.URI.revive(d.uri),new P.$aK(d.line,d.character))}y.push(I)}}}this.U(n,o,y)}async $acceptStackFrameFocus(s){let n;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?n=new P.$gL(o,s.threadId):n=new P.$fL(o,s.threadId,s.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(s,n,o){return(0,w.$Lg)(async()=>{const y=this.P(s);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(n);return y.provideDebugConfigurations(d,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(s,n,o,y){return(0,w.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(n);return d.resolveDebugConfiguration(I,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(s,n,o,y){return(0,w.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(n);return d.resolveDebugConfigurationWithSubstitutedVariables(I,o,y)})}async $provideDebugAdapter(s,n){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(n);return this.S(o,y).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(s){const n=await this.V(s);this.m.fire(n)}async $acceptDebugSessionTerminated(s){const n=await this.V(s);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,n){(await this.V(s))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(s,n){const y={session:await this.V(s),event:n.event,body:n.body};this.u.fire(y)}M(s){if(s instanceof P.$bL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$cL)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$dL)return{type:"pipeServer",path:s.path};if(s instanceof P.$eL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const n=this.h.filter(o=>o.type===s);if(n.length>0)return n[0].factory}O(s){const n=this.h.filter(o=>o.handle===s);if(n.length>0)return n[0].factory}P(s){const n=this.f.filter(o=>o.handle===s);if(n.length>0)return n[0].provider}Q(s,n){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===n)return!0}}return!1}R(s){const o=s.configuration.type,y=this.j.filter(d=>d.type===o||d.type==="*").map(d=>(0,w.$Lg)(()=>d.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(d=>{const I=d.filter(S=>!!S);if(I.length>0)return new b(I)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(s,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$cL(o));if(s){const d=await this.F.getExtensionRegistry();return(0,w.$Lg)(()=>s.createDebugAdapterDescriptor(n,this.T(n,d))).then(I=>{if(I)return I})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,y))}T(s,n){}U(s,n,o){(s.length>0||n.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:n,changed:o}))}async V(s){if(s)if(typeof s=="string"){const n=this.l.get(s);if(n)return n}else{let n=this.l.get(s.id);if(!n){const o=await this.W(s.folderUri),y=s.parent?this.l.get(s.parent):void 0;n=new i(this.k,s.id,s.type,s.name,o,s.configuration,y),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(s){if(s){const n=C.URI.revive(s);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$4cc=t,e.$4cc=t=Ke([We(0,g.$$L),We(1,k.$Wbc),We(2,D.$scc),We(3,$.$Zbc),We(4,l.$Ycc),We(5,f.$1cc)],t);class i{constructor(s,n,o,y,d,I,S){this.d=s,this.f=n,this.g=o,this.h=y,this.i=d,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,n){return this.d.$customDebugAdapterRequest(this.f,s,n)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$5cc=i;class c{constructor(s){this.value=Object.freeze({append(n){s.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$6cc=c;class b{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(n=>n.onError?n.onError(s):void 0)}onExit(s,n){this.d.forEach(o=>o.onExit?o.onExit(s,n):void 0)}}class E extends a.$Vcb{constructor(s){super(),this.h=s,s.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(s,n,o,y,d,I){super(s,n,o,y,d,I)}};e.$7cc=v,e.$7cc=v=Ke([We(0,g.$$L),We(1,k.$Wbc),We(2,D.$scc),We(3,$.$Zbc),We(4,l.$Ycc),We(5,f.$1cc)],v)}),define(Re[270],Me([1,0,9,87,2,3,261,14,69,70,27,172,17,55,35,57]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const E=b.get(l.$8i),r=b.get(a.$$L).getProxy(F.$0J.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{E.error(s);const n=w.$2(s);r.$onUnexpectedError(n)})}static async installFullHandler(b){const E=b.get(l.$8i),v=b.get(a.$$L),r=b.get($.$scc),s=b.get(f.$sM),n=v.getProxy(F.$0J.MainThreadExtensionService),o=v.getProxy(F.$0J.MainThreadErrors),y=await r.getExtensionPathIndex(),d=new WeakMap;function I(m,h){if(d.has(m))return d.get(m).stack;let A="",W,V;for(const B of h)A+=`
	at ${B.toString()}`,V=B.getFileName(),!W&&V&&(W=y.findSubstr(C.URI.file(V)));const U=`${m.name||"Error"}: ${m.message||""}${A}`;return d.set(m,{extensionIdentifier:W?.identifier,stack:U}),U}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(h,A){return I(h,A),m.call(Error,h,A)},Object.assign(u,{[S]:!0})}}),w.setUnexpectedErrorHandler(m=>{E.error(m);const h=w.$2(m),A=d.get(m);if(!A?.extensionIdentifier){o.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(A.extensionIdentifier,h);const W=s.onExtensionError(A.extensionIdentifier,m);E.trace("forwarded error to extension?",W,A)})}}e.$Rdc=t;class i{constructor(b,E,v,r,s){this.a=v,this.b=new R.$f4b(b,null,r),E=i.e(E,this.b);const n=new g.$Lh(...(0,D.$tr)());n.set(P.$oM,{_serviceBrand:void 0,...E,messagePorts:s}),n.set(a.$$L,new a.$_L(this.b)),n.set(p.$Tbc,new p.$Ubc(r)),n.set($.$qcc,v);const o=new k.$_p(n,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(l.$8i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(y=>y.get($.$scc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(F.$0J.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(E.transformIncomingURIs(r.extensionLocation))}),b.environment.appRoot=C.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(r=>C.URI.revive(E.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.$Sdc=i}),define(Re[271],Me([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=e.$0cc=e.$9cc=void 0;class k{constructor(c,b,E,v){this.d=c,this.e=b,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(c,b){const E=this.d.folderQueries||[],v=new C.$Wd(b);return new Promise((r,s)=>{this.a=new p(c);let n=!1;const o=(y,d)=>{if(!n&&!this.b){const I=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,n=!0,v.cancel(),y=this.j(y,this.d.maxResults-this.c));const S=this.h(y);this.c+=S,(S>0||!f(y))&&this.a.add(y,d)}};Promise.all(E.map((y,d)=>this.k(y,I=>o(I,d),v.token))).then(y=>{v.dispose(),this.a.flush();const d=y.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||d,messages:(0,w.$Qb)(y.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},y=>{v.dispose();const d=(0,F.$yi)(y);s(new Error(d))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,b){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],v=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,b),preview:{matches:v.slice(0,b),text:c.preview.text},uri:c.uri}}async k(c,b,E){const v=new P.$UI(this.d,c),r=[],s={report:y=>{if(!this.l(y))return;const d=c.folder.scheme===R.Schemas.file?(0,P.$VI)(()=>this.f.readdir(D.$tg(y.uri))):void 0,I=D.$wg(c.folder,y.uri);if(I){const S=v.includedInQuery(I,l.$mc(I),d);(0,M.$Fg)(S)?r.push(S.then(u=>{u&&b(y)})):S&&b(y)}}},n=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),n,s,E);return r.length&&await Promise.all(r),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const b=(0,P.$TI)(this.d.includePattern,c.includePattern),E=(0,P.$TI)(this.d.excludePattern,c.excludePattern),v={folder:g.URI.from(c.folder),excludes:E,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$9cc=k;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(c,b){this.d&&(this.b!==b||!D.$ng(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$0cc=p;function $(i){return f(i)?{preview:{matches:(0,w.$1b)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,w.$1b)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$$cc=f;class t{static{this.a=4e3}static{this.b=50}constructor(c,b){this.g=c,this.h=b,this.c=0,this.d=[],this.e=0}addItem(c,b){c&&this.j(c,b)}addItems(c,b){c&&this.k(c,b)}j(c,b){this.d.push(c),this.e+=b,this.l()}k(c,b){this.d=this.d.concat(c),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$_cc=t}),define(Re[114],Me([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.$adc=void 0,e.$adc=(0,C.$Nh)("IExtHostSearch");let k=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(M.$0J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$8cc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,w.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,w.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,c){const b=a(i),E=this.h.get(f);if(E)return this.j.fileSearch(b,E,v=>{this.c.$handleFileMatch(f,t,v.map(r=>r.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,c){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const E=a(i);return this.q(E,b).search(r=>this.c.$handleTextMatch(f,t,r),c)}$enableExtensionHostSearch(){}q(f,t){return new P.$9cc(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$bdc=k,e.$bdc=k=Ke([We(0,R.$$L),We(1,l.$Tbc),We(2,D.$8i)],k);function a($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(f=>g.URI.revive(f))}}e.$cdc=a;function p($){return{...$,folder:g.URI.revive($.folder)}}}),define(Re[272],Me([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,59,35,233,234,239,240,242,109,207,248,249,251,84,62,253,210,8,7,53,256,63,108,33,20,198,238,52,107,111,113,114,14,55,17,27,243,196,86,80,217,254,85,61,259,257,258,218,39,252,255,83,60,57,244,110,245,13,95,206,189,236,6,26,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s,n,o,y,d,I,S,u,m,h,A,W,V,U,B,O,N,te,Z,ye,Ee,Pe,Y,ae,Se,ue,$e,ie,z,q,le,we,ve,me,De,re,he,se,oe,de,Ie,L,K,G,Q,H,_,ce,Fe,Ue,Qe,Je,xe,Ye,_e,it,tt,ze,st,x,X,pe,je,Oe,Xe,rt,mt,wt,Ct,Zt,Kt,vt,jt,Ft,Bt,Pt,At,Nt,Wt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;function Vt(at){const ut=at.get(re.$oM),Gt=at.get(Fe.$Jbc),It=at.get(G.$ccc),Et=at.get(o.$scc),dt=at.get(ae.$Wbc),kt=at.get(Ye.$sM),Tt=at.get(c.$Zbc),yt=at.get(me.$Tbc),Ve=at.get(De.$$L),Ot=at.get(U.$$bc),zt=at.get(K.$dcc),Ce=at.get(ve.$9i),Ae=at.get(ve.$8i),ge=at.get(oe.$Uvb),J=at.get(de.$Mbc),Le=at.get(Y.$Qcc),Be=at.get(Je.$kcc),Ge=at.get(xe.$Ycc),qe=at.get(Ft.$occ);Ve.set(a.$$J.ExtHostFileSystemInfo,Gt),Ve.set(a.$$J.ExtHostLogLevelServiceShape,Ce),Ve.set(a.$$J.ExtHostWorkspace,dt),Ve.set(a.$$J.ExtHostConfiguration,Tt),Ve.set(a.$$J.ExtHostExtensionService,Et),Ve.set(a.$$J.ExtHostStorage,Ot),Ve.set(a.$$J.ExtHostTunnelService,ge),Ve.set(a.$$J.ExtHostWindow,Le),Ve.set(a.$$J.ExtHostSecretState,Be),Ve.set(a.$$J.ExtHostTelemetry,kt),Ve.set(a.$$J.ExtHostEditorTabs,Ge),Ve.set(a.$$J.ExtHostManagedSockets,qe);const et=Ve.set(a.$$J.ExtHostDecorations,at.get(z.$Ucc)),gt=Ve.set(a.$$J.ExtHostDocumentsAndEditors,at.get(n.$jM)),ft=Ve.set(a.$$J.ExtHostCommands,at.get(t.$uM)),pt=Ve.set(a.$$J.ExtHostTerminalService,at.get(B.$fcc)),ht=Ve.set(a.$$J.ExtHostDebugService,at.get(le.$3cc)),Rt=Ve.set(a.$$J.ExtHostSearch,at.get(we.$adc)),Jt=Ve.set(a.$$J.ExtHostTask,at.get(q.$Xcc)),Ei=Ve.set(a.$$J.ExtHostOutputService,at.get(m.$Acc)),qt=Ve.set(a.$$J.ExtHostLocalization,at.get(rt.$ncc)),mi=Ve.set(a.$$J.ExtHostUrls,new Ee.$Jcc(Ve)),St=Ve.set(a.$$J.ExtHostDocuments,new s.$Hbc(Ve,gt)),Di=Ve.set(a.$$J.ExtHostDocumentContentProviders,new v.$2bc(Ve,gt,Ae)),Vi=Ve.set(a.$$J.ExtHostDocumentSaveParticipant,new r.$3bc(Ae,St,Ve.getProxy(a.$0J.MainThreadBulkEdits))),Dt=Ve.set(a.$$J.ExtHostNotebook,new he.$gdc(Ve,ft,gt,St,It)),ii=Ve.set(a.$$J.ExtHostNotebookDocuments,new X.$ydc(Dt)),$i=Ve.set(a.$$J.ExtHostNotebookEditors,new x.$xdc(Ae,Dt)),oi=Ve.set(a.$$J.ExtHostNotebookKernels,new _e.$udc(Ve,ut,Dt,ft,Ae)),ki=Ve.set(a.$$J.ExtHostNotebookRenderers,new tt.$wdc(Ve,Dt)),Si=Ve.set(a.$$J.ExtHostNotebookDocumentSaveParticipant,new vt.$Edc(Ae,Dt,Ve.getProxy(a.$0J.MainThreadBulkEdits))),Mt=Ve.set(a.$$J.ExtHostEditors,new O.$Hcc(Ve,gt)),pi=Ve.set(a.$$J.ExtHostTreeViews,new N.$Icc(Ve.getProxy(a.$0J.MainThreadTreeViews),ft,Ae)),Ii=Ve.set(a.$$J.ExtHostEditorInsets,new ue.$Rcc(Ve.getProxy(a.$0J.MainThreadEditorInsets),Mt,ut.remote)),ai=Ve.set(a.$$J.ExtHostDiagnostics,new b.$Lbc(Ve,Ae,Gt,gt)),ci=Ve.set(a.$$J.ExtHostLanguages,new S.$xcc(Ve,St,ft.converter,yt)),ct=Ve.set(a.$$J.ExtHostLanguageFeatures,new I.$Pbc(Ve,yt,St,ft,ai,Ae,J,kt)),qi=Ve.set(a.$$J.ExtHostFileSystem,new y.$vcc(Ve,ct)),Yt=Ve.set(a.$$J.ExtHostFileSystemEventService,new d.$wcc(Ve,Ae,gt)),ni=Ve.set(a.$$J.ExtHostQuickOpen,(0,A.$Ccc)(Ve,dt,ft)),vi=Ve.set(a.$$J.ExtHostSCM,new W.$Ecc(Ve,ft,St,Ae)),Ci=Ve.set(a.$$J.ExtHostQuickDiff,new Ct.$Bdc(Ve,yt)),Ki=Ve.set(a.$$J.ExtHostShare,new Bt.$Gdc(Ve,yt)),Pi=Ve.set(a.$$J.ExtHostComments,(0,i.$Sbc)(Ve,ft,St)),bi=Ve.set(a.$$J.ExtHostProgress,new h.$Bcc(Ve.getProxy(a.$0J.MainThreadProgress))),Hi=Ve.set(a.$$J.ExtHosLabelService,new $e.$Scc(Ve)),Ai=Ve.set(a.$$J.ExtHostTheming,new se.$hdc(Ve)),ui=Ve.set(a.$$J.ExtHostAuthentication,new Ie.$idc(Ve)),Ji=Ve.set(a.$$J.ExtHostTimeline,new L.$kdc(Ve,ft)),wi=Ve.set(a.$$J.ExtHostWebviews,new Pe.$Mcc(Ve,ut.remote,dt,Ae,J)),Ri=Ve.set(a.$$J.ExtHostWebviewPanels,new _.$mdc(Ve,wi,dt)),cn=Ve.set(a.$$J.ExtHostCustomEditors,new H.$ndc(Ve,St,zt,wi,Ri)),Mi=Ve.set(a.$$J.ExtHostWebviewViews,new Q.$ldc(Ve,wi)),ri=Ve.set(a.$$J.ExtHostTesting,new Ue.$pdc(Ve,ft,gt)),un=Ve.set(a.$$J.ExtHostUriOpeners,new Qe.$tdc(Ve)),ln=Ve.set(a.$$J.ExtHostProfileContentHandlers,new wt.$Adc(Ve));Ve.set(a.$$J.ExtHostInteractive,new pe.$zdc(Ve,Dt,gt,ft,Ae));const Gi=Ve.set(a.$$J.ExtHostInlineChat,new Kt.$Ddc(Ve,ft,St,Ae)),fi=Ve.set(a.$$J.ExtHostChatProvider,new Pt.$Hdc(Ve,Ae)),Qi=Ve.set(a.$$J.ExtHostChatAgents,new Ht.$Ldc(Ve,fi,Ae)),Xi=Ve.set(a.$$J.ExtHostChatVariables,new At.$Idc(Ve)),gi=Ve.set(a.$$J.ExtHostChat,new Zt.$Cdc(Ve,Ae)),Zi=Ve.set(a.$$J.ExtHostAiRelatedInformation,new Nt.$Jdc(Ve)),Li=Ve.set(a.$$J.ExtHostAiEmbeddingVector,new Wt.$Kdc(Ve)),Yi=Ve.set(a.$$J.ExtHostIssueReporter,new jt.$Fdc(Ve)),xt=Ve.set(a.$$J.ExtHostStatusBar,new V.$Gcc(Ve,ft.converter)),yi=Object.values(a.$$J);Ve.assertRegistered(yi);const hn=new ce.$odc(Ve,gt),Qt=new f.$Rbc(Ve),li=new u.$ycc(Ve,Ae),Ti=new E.$1bc(Ve);return $.$Qbc.register(ft),function(Ne,_t,Fi){const $t=function(){let ee=!Ne.isUnderDevelopment;function fe(){ee||(Ae.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Te(nt){if(Array.isArray(nt))nt.forEach(Te);else if(typeof nt=="string")fe();else{const bt=nt;typeof bt.scheme>"u"&&fe(),typeof bt.exclusive=="boolean"&&(0,Oe.$0E)(Ne,"documentFiltersExclusive")}return nt}}(),xi={getSession(ee,fe,Te){return ui.getSession(Ne,ee,fe,Te)},getSessions(ee,fe){return(0,Oe.$0E)(Ne,"authGetSessions"),ui.getSessions(Ne,ee,fe)},async hasSession(ee,fe){return(0,Oe.$0E)(Ne,"authSession"),!!await ui.getSession(Ne,ee,fe,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,fe,Te,nt){return ui.registerAuthenticationProvider(ee,fe,Te,nt)}},_i={registerCommand(ee,fe,Te){return ft.registerCommand(!0,ee,fe,Te,void 0,Ne)},registerTextEditorCommand(ee,fe,Te){return ft.registerCommand(!0,ee,(...nt)=>{const bt=Mt.getActiveTextEditor();if(!bt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(Lt=>{fe.apply(Te,[bt,Lt,...nt])}).then(Lt=>{Lt||Ae.warn("Edits from command "+ee+" were not applied.")},Lt=>{Ae.warn("An error occurred while running command "+ee,Lt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ee,fe,Te)=>((0,Oe.$0E)(Ne,"diffCommand"),ft.registerCommand(!0,ee,async(...nt)=>{const bt=gt.activeEditor(!0);if(!bt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(bt.id);fe.apply(Te,[Lt,...nt])},void 0,void 0,Ne)),executeCommand(ee,...fe){return ft.executeCommand(ee,...fe)},getCommands(ee=!1){return ft.getCommands(ee)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Qt.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return pt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$0E)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$0E)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$rM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,fe){return Ye.$qM.validateSender(ee),kt.instantiateLogger(Ne,ee,fe)},openExternal(ee,fe){return Le.openUri(ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ut.environment.appUriScheme)return mi.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$7T)(ee,ze.Schemas.http)||(0,st.$7T)(ee,ze.Schemas.https))return ee;throw fe}},get remoteName(){return(0,ie.$Sk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$0E)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return Ae.getLevel()},get onDidChangeLogLevel(){return Ae.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Oe.$0E)(Ne,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Ne,ee)},get appQuality(){return(0,Oe.$0E)(Ne,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$0E)(Ne,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(ee,fe,Te){return ri.createTestController(Ne,ee,fe,Te)},createTestObserver(){return(0,Oe.$0E)(Ne,"testObserver"),ri.createTestObserver()},runTests(ee){return(0,Oe.$0E)(Ne,"testObserver"),ri.runTests(ee)},get onDidChangeTestResults(){return(0,Oe.$0E)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Oe.$0E)(Ne,"testObserver"),ri.results}},hi=ut.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,tn={getExtension(ee,fe){(0,Oe.$9E)(Ne,"extensionsAny")||(fe=!1);const Te=_t.mine.getExtensionDescription(ee);if(Te)return new o.$tcc(Et,Ne.identifier,Te,hi,!1);if(fe){const nt=_t.all.getExtensionDescription(ee);if(nt)return new o.$tcc(Et,Ne.identifier,nt,hi,!0)}},get all(){const ee=[];for(const fe of _t.mine.getAllExtensionDescriptions())ee.push(new o.$tcc(Et,Ne.identifier,fe,hi,!1));return ee},get allAcrossExtensionHosts(){(0,Oe.$0E)(Ne,"extensionsAny");const ee=new Se.$3l(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of _t.all.getAllExtensionDescriptions()){const nt=!ee.has(Te.identifier);fe.push(new o.$tcc(Et,Ne.identifier,Te,hi,nt))}return fe},get onDidChange(){return(0,Oe.$9E)(Ne,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Ne.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,fe){return ci.changeLanguage(ee.uri,fe)},match(ee,fe){const Te=St.getDocumentData(fe.uri)?.notebook;return(0,P.$kE)(te.LanguageSelector.from(ee),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(ee,fe,Te){return ct.registerCodeActionProvider(Ne,$t(ee),fe,Te)},registerDocumentPasteEditProvider(ee,fe,Te){return(0,Oe.$0E)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,$t(ee),fe,Te)},registerCodeLensProvider(ee,fe){return ct.registerCodeLensProvider(Ne,$t(ee),fe)},registerDefinitionProvider(ee,fe){return ct.registerDefinitionProvider(Ne,$t(ee),fe)},registerDeclarationProvider(ee,fe){return ct.registerDeclarationProvider(Ne,$t(ee),fe)},registerImplementationProvider(ee,fe){return ct.registerImplementationProvider(Ne,$t(ee),fe)},registerTypeDefinitionProvider(ee,fe){return ct.registerTypeDefinitionProvider(Ne,$t(ee),fe)},registerHoverProvider(ee,fe){return ct.registerHoverProvider(Ne,$t(ee),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ee,fe){return ct.registerEvaluatableExpressionProvider(Ne,$t(ee),fe,Ne.identifier)},registerInlineValuesProvider(ee,fe){return ct.registerInlineValuesProvider(Ne,$t(ee),fe,Ne.identifier)},registerDocumentHighlightProvider(ee,fe){return ct.registerDocumentHighlightProvider(Ne,$t(ee),fe)},registerLinkedEditingRangeProvider(ee,fe){return ct.registerLinkedEditingRangeProvider(Ne,$t(ee),fe)},registerReferenceProvider(ee,fe){return ct.registerReferenceProvider(Ne,$t(ee),fe)},registerRenameProvider(ee,fe){return ct.registerRenameProvider(Ne,$t(ee),fe)},registerDocumentSymbolProvider(ee,fe,Te){return ct.registerDocumentSymbolProvider(Ne,$t(ee),fe,Te)},registerWorkspaceSymbolProvider(ee){return ct.registerWorkspaceSymbolProvider(Ne,ee)},registerDocumentFormattingEditProvider(ee,fe){return ct.registerDocumentFormattingEditProvider(Ne,$t(ee),fe)},registerDocumentRangeFormattingEditProvider(ee,fe){return ct.registerDocumentRangeFormattingEditProvider(Ne,$t(ee),fe)},registerOnTypeFormattingEditProvider(ee,fe,Te,...nt){return ct.registerOnTypeFormattingEditProvider(Ne,$t(ee),fe,[Te].concat(nt))},registerDocumentSemanticTokensProvider(ee,fe,Te){return ct.registerDocumentSemanticTokensProvider(Ne,$t(ee),fe,Te)},registerDocumentRangeSemanticTokensProvider(ee,fe,Te){return ct.registerDocumentRangeSemanticTokensProvider(Ne,$t(ee),fe,Te)},registerSignatureHelpProvider(ee,fe,Te,...nt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Ne,$t(ee),fe,Te):ct.registerSignatureHelpProvider(Ne,$t(ee),fe,typeof Te>"u"?[]:[Te,...nt])},registerCompletionItemProvider(ee,fe,...Te){return ct.registerCompletionItemProvider(Ne,$t(ee),fe,Te)},registerInlineCompletionItemProvider(ee,fe,Te){return fe.handleDidShowCompletionItem&&(0,Oe.$0E)(Ne,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$0E)(Ne,"inlineCompletionsAdditions"),Te&&(0,Oe.$0E)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,$t(ee),fe,Te)},registerDocumentLinkProvider(ee,fe){return ct.registerDocumentLinkProvider(Ne,$t(ee),fe)},registerColorProvider(ee,fe){return ct.registerColorProvider(Ne,$t(ee),fe)},registerFoldingRangeProvider(ee,fe){return ct.registerFoldingRangeProvider(Ne,$t(ee),fe)},registerSelectionRangeProvider(ee,fe){return ct.registerSelectionRangeProvider(Ne,ee,fe)},registerCallHierarchyProvider(ee,fe){return ct.registerCallHierarchyProvider(Ne,ee,fe)},registerTypeHierarchyProvider(ee,fe){return ct.registerTypeHierarchyProvider(Ne,ee,fe)},setLanguageConfiguration:(ee,fe)=>ct.setLanguageConfiguration(Ne,ee,fe),getTokenInformationAtPosition(ee,fe){return(0,Oe.$0E)(Ne,"tokenInformation"),ci.tokenAtPosition(ee,fe)},registerInlayHintsProvider(ee,fe){return ct.registerInlayHintsProvider(Ne,ee,fe)},createLanguageStatusItem(ee,fe){return ci.createLanguageStatusItem(Ne,ee,fe)},registerDocumentDropEditProvider(ee,fe,Te){return ct.registerDocumentOnDropEditProvider(Ne,ee,fe,(0,Oe.$9E)(Ne,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(ee,fe,Te){const nt=await(R.URI.isUri(ee)?Promise.resolve(sn.openTextDocument(ee)):Promise.resolve(ee));return Mt.showTextDocument(nt,fe,Te)},createTextEditorDecorationType(ee){return Mt.createTextEditorDecorationType(Ne,ee)},onDidChangeActiveTextEditor(ee,fe,Te){return Mt.onDidChangeActiveTextEditor(ee,fe,Te)},onDidChangeVisibleTextEditors(ee,fe,Te){return Mt.onDidChangeVisibleTextEditors(ee,fe,Te)},onDidChangeTextEditorSelection(ee,fe,Te){return Mt.onDidChangeTextEditorSelection(ee,fe,Te)},onDidChangeTextEditorOptions(ee,fe,Te){return Mt.onDidChangeTextEditorOptions(ee,fe,Te)},onDidChangeTextEditorVisibleRanges(ee,fe,Te){return Mt.onDidChangeTextEditorVisibleRanges(ee,fe,Te)},onDidChangeTextEditorViewColumn(ee,fe,Te){return Mt.onDidChangeTextEditorViewColumn(ee,fe,Te)},onDidCloseTerminal(ee,fe,Te){return pt.onDidCloseTerminal(ee,fe,Te)},onDidOpenTerminal(ee,fe,Te){return pt.onDidOpenTerminal(ee,fe,Te)},onDidChangeActiveTerminal(ee,fe,Te){return pt.onDidChangeActiveTerminal(ee,fe,Te)},onDidChangeTerminalDimensions(ee,fe,Te){return(0,Oe.$0E)(Ne,"terminalDimensions"),pt.onDidChangeTerminalDimensions(ee,fe,Te)},onDidChangeTerminalState(ee,fe,Te){return pt.onDidChangeTerminalState(ee,fe,Te)},onDidWriteTerminalData(ee,fe,Te){return(0,Oe.$0E)(Ne,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(ee,fe,Te)},onDidExecuteTerminalCommand(ee,fe,Te){return(0,Oe.$0E)(Ne,"terminalExecuteCommandEvent"),pt.onDidExecuteTerminalCommand(ee,fe,Te)},get state(){return Le.getState(Ne)},onDidChangeWindowState(ee,fe,Te){return Le.onDidChangeWindowState(ee,fe,Te)},showInformationMessage(ee,...fe){return li.showMessage(Ne,F.default.Info,ee,fe[0],fe.slice(1))},showWarningMessage(ee,...fe){return li.showMessage(Ne,F.default.Warning,ee,fe[0],fe.slice(1))},showErrorMessage(ee,...fe){return li.showMessage(Ne,F.default.Error,ee,fe[0],fe.slice(1))},showQuickPick(ee,fe,Te){return ni.showQuickPick(Ne,ee,fe,Te)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,fe){return ni.showInput(ee,fe)},showOpenDialog(ee){return Ti.showOpenDialog(Ne,ee)},showSaveDialog(ee){return Ti.showSaveDialog(ee)},createStatusBarItem(ee,fe,Te){let nt,bt,Lt;return typeof ee=="string"?(nt=ee,bt=fe,Lt=Te):(bt=ee,Lt=fe),xt.createStatusBarEntry(Ne,nt,bt,Lt)},setStatusBarMessage(ee,fe){return xt.setStatusBarMessage(ee,fe)},withScmProgress(ee){return J.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),bi.withProgress(Ne,{location:Z.ProgressLocation.SourceControl},(fe,Te)=>ee({report(nt){}}))},withProgress(ee,fe){return bi.withProgress(Ne,ee,fe)},createOutputChannel(ee,fe){return Ei.createOutputChannel(ee,fe,Ne)},createWebviewPanel(ee,fe,Te,nt){return Ri.createWebviewPanel(Ne,ee,fe,Te,nt)},createWebviewTextEditorInset(ee,fe,Te,nt){return(0,Oe.$0E)(Ne,"editorInsets"),Ii.createWebviewEditorInset(ee,fe,Te,nt,Ne)},createTerminal(ee,fe,Te){return typeof ee=="object"?"pty"in ee?pt.createExtensionTerminal(ee):pt.createTerminalFromOptions(ee):pt.createTerminal(ee,fe,Te)},registerTerminalLinkProvider(ee){return pt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,fe){return pt.registerProfileProvider(Ne,ee,fe)},registerTerminalQuickFixProvider(ee,fe){return(0,Oe.$0E)(Ne,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(ee,Ne.identifier.value,fe)},registerTreeDataProvider(ee,fe){return pi.registerTreeDataProvider(ee,fe,Ne)},createTreeView(ee,fe){return pi.createTreeView(ee,fe,Ne)},registerWebviewPanelSerializer:(ee,fe)=>Ri.registerWebviewPanelSerializer(Ne,ee,fe),registerCustomEditorProvider:(ee,fe,Te={})=>cn.registerCustomEditorProvider(Ne,ee,fe,Te),registerFileDecorationProvider(ee){return et.registerFileDecorationProvider(ee,Ne)},registerUriHandler(ee){return mi.registerUriHandler(Ne,ee)},createQuickPick(){return ni.createQuickPick(Ne)},createInputBox(){return ni.createInputBox(Ne)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ee,fe,Te){return Ai.onDidChangeActiveColorTheme(ee,fe,Te)},registerWebviewViewProvider(ee,fe,Te){return Mi.registerWebviewViewProvider(Ne,ee,fe,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,fe,Te){return Dt.onDidChangeActiveNotebookEditor(ee,fe,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,fe,Te){return $i.onDidChangeNotebookEditorSelection(ee,fe,Te)},onDidChangeNotebookEditorVisibleRanges(ee,fe,Te){return $i.onDidChangeNotebookEditorVisibleRanges(ee,fe,Te)},showNotebookDocument(ee,fe){return Dt.showNotebookDocument(ee,fe)},registerExternalUriOpener(ee,fe,Te){return(0,Oe.$0E)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,ee,fe,Te)},registerProfileContentHandler(ee,fe){return(0,Oe.$0E)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,ee,fe)},registerQuickDiffProvider(ee,fe,Te,nt){return(0,Oe.$0E)(Ne,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(ee),fe,Te,nt)},get tabGroups(){return Ge.tabGroups},registerShareProvider(ee,fe){return(0,Oe.$0E)(Ne,"shareProvider"),Ki.registerShareProvider($t(ee),fe)}},sn={get rootPath(){return J.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$8("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$8("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$8("workspaceFile")},updateWorkspaceFolders:(ee,fe,...Te)=>dt.updateWorkspaceFolders(Ne,ee,fe||0,...Te),onDidChangeWorkspaceFolders:function(ee,fe,Te){return dt.onDidChangeWorkspace(ee,fe,Te)},asRelativePath:(ee,fe)=>dt.getRelativePath(ee,fe),findFiles:(ee,fe,Te,nt)=>dt.findFiles(ee,fe,Te,Ne.identifier,nt),findTextInFiles:(ee,fe,Te,nt)=>{(0,Oe.$0E)(Ne,"findTextInFiles");let bt,Lt;return typeof fe=="object"?(bt=fe,Lt=Te):(bt={},Lt=fe,nt=Te),dt.findTextInFiles(ee,bt||{},Lt,Ne.identifier,nt)},save:ee=>((0,Oe.$0E)(Ne,"saveEditor"),dt.save(ee)),saveAs:ee=>((0,Oe.$0E)(Ne,"saveEditor"),dt.saveAs(ee)),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,fe){return hn.applyWorkspaceEdit(ee,Ne,fe)},createFileSystemWatcher:(ee,fe,Te,nt)=>Yt.createFileSystemWatcher(dt,Ne,ee,fe,Te,nt),get textDocuments(){return St.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$8("textDocuments")},openTextDocument(ee){let fe;const Te=ee;if(typeof ee=="string")fe=Promise.resolve(R.URI.file(ee));else if(R.URI.isUri(ee))fe=Promise.resolve(ee);else if(!Te||typeof Te=="object")fe=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>St.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(ee,fe,Te)=>St.onDidAddDocument(ee,fe,Te),onDidCloseTextDocument:(ee,fe,Te)=>St.onDidRemoveDocument(ee,fe,Te),onDidChangeTextDocument:(ee,fe,Te)=>St.onDidChangeDocument(ee,fe,Te),onDidSaveTextDocument:(ee,fe,Te)=>St.onDidSaveDocument(ee,fe,Te),onWillSaveTextDocument:(ee,fe,Te)=>Vi.getOnWillSaveTextDocumentEvent(Ne)(ee,fe,Te),get notebookDocuments(){return Dt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,fe){let Te;if(R.URI.isUri(ee))Te=ee,await Dt.openNotebookDocument(ee);else if(typeof ee=="string")Te=R.URI.revive(await Dt.createNotebookDocument({viewType:ee,content:fe}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(ee,fe,Te){return ii.onDidSaveNotebookDocument(ee,fe,Te)},onDidChangeNotebookDocument(ee,fe,Te){return ii.onDidChangeNotebookDocument(ee,fe,Te)},onWillSaveNotebookDocument(ee,fe,Te){return Si.getOnWillSaveNotebookDocumentEvent(Ne)(ee,fe,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,fe,Te,nt){return Dt.registerNotebookSerializer(Ne,ee,fe,Te,(0,Oe.$9E)(Ne,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(ee,fe,Te)=>Fi.onDidChangeConfiguration(ee,fe,Te),getConfiguration(ee,fe){return fe=arguments.length===1?void 0:fe,Fi.getConfiguration(ee,fe,Ne)},registerTextDocumentContentProvider(ee,fe){return Di.registerTextDocumentContentProvider(ee,fe)},registerTaskProvider:(ee,fe)=>(J.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Ne,ee,fe)),registerFileSystemProvider(ee,fe,Te){return(0,je.$Oc)(qi.registerFileSystemProvider(Ne,ee,fe,Te),It.addFileSystemProvider(ee,fe,Te))},get fs(){return It.value},registerFileSearchProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"fileSearchProvider"),Rt.registerFileSearchProvider(ee,fe)),registerTextSearchProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"textSearchProvider"),Rt.registerTextSearchProvider(ee,fe)),registerRemoteAuthorityResolver:(ee,fe)=>((0,Oe.$0E)(Ne,"resolvers"),Et.registerRemoteAuthorityResolver(ee,fe)),registerResourceLabelFormatter:ee=>((0,Oe.$0E)(Ne,"resolvers"),Hi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Oe.$0E)(Ne,"resolvers"),Et.getRemoteExecServer(ee)),onDidCreateFiles:(ee,fe,Te)=>Yt.onDidCreateFile(ee,fe,Te),onDidDeleteFiles:(ee,fe,Te)=>Yt.onDidDeleteFile(ee,fe,Te),onDidRenameFiles:(ee,fe,Te)=>Yt.onDidRenameFile(ee,fe,Te),onWillCreateFiles:(ee,fe,Te)=>Yt.getOnWillCreateFileEvent(Ne)(ee,fe,Te),onWillDeleteFiles:(ee,fe,Te)=>Yt.getOnWillDeleteFileEvent(Ne)(ee,fe,Te),onWillRenameFiles:(ee,fe,Te)=>Yt.getOnWillRenameFileEvent(Ne)(ee,fe,Te),openTunnel:ee=>((0,Oe.$0E)(Ne,"tunnels"),ge.openTunnel(Ne,ee).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$0E)(Ne,"tunnels"),ge.getTunnels()},onDidChangeTunnels:(ee,fe,Te)=>((0,Oe.$0E)(Ne,"tunnels"),ge.onDidChangeTunnels(ee,fe,Te)),registerPortAttributesProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"portsAttributes"),ge.registerPortsAttributesProvider(ee,fe)),registerTunnelProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"tunnelFactory"),ge.registerTunnelProvider(ee,fe)),registerTimelineProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"timeline"),Ji.registerTimelineProvider(ee,fe,Ne.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Oe.$0E)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,fe,Te)=>dt.onDidGrantWorkspaceTrust(ee,fe,Te),registerEditSessionIdentityProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,fe)),onWillCreateEditSessionIdentity:(ee,fe,Te)=>((0,Oe.$0E)(Ne,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ne)(ee,fe,Te)),registerCanonicalUriProvider:(ee,fe)=>((0,Oe.$0E)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,fe)),getCanonicalUri:(ee,fe,Te)=>((0,Oe.$0E)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(ee,fe,Te))},fn={get inputBox(){return J.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ne)},createSourceControl(ee,fe,Te){return vi.createSourceControl(Ne,ee,fe,Te)}},on={createCommentController(ee,fe){return Pi.createCommentController(Ne,ee,fe)}},an={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(ee,fe,Te){return ht.onDidStartDebugSession(ee,fe,Te)},onDidTerminateDebugSession(ee,fe,Te){return ht.onDidTerminateDebugSession(ee,fe,Te)},onDidChangeActiveDebugSession(ee,fe,Te){return ht.onDidChangeActiveDebugSession(ee,fe,Te)},onDidReceiveDebugSessionCustomEvent(ee,fe,Te){return ht.onDidReceiveDebugSessionCustomEvent(ee,fe,Te)},onDidChangeBreakpoints(ee,fe,Te){return ht.onDidChangeBreakpoints(ee,fe,Te)},onDidChangeStackFrameFocus(ee,fe,Te){return(0,Oe.$0E)(Ne,"debugFocus"),ht.onDidChangeStackFrameFocus(ee,fe,Te)},registerDebugConfigurationProvider(ee,fe,Te){return ht.registerDebugConfigurationProvider(ee,fe,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,fe){return ht.registerDebugAdapterDescriptorFactory(Ne,ee,fe)},registerDebugAdapterTrackerFactory(ee,fe){return ht.registerDebugAdapterTrackerFactory(ee,fe)},startDebugging(ee,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ht.startDebugging(ee,fe,{parentSession:Te}):ht.startDebugging(ee,fe,Te||{})},stopDebugging(ee){return ht.stopDebugging(ee)},addBreakpoints(ee){return ht.addBreakpoints(ee)},removeBreakpoints(ee){return ht.removeBreakpoints(ee)},asDebugSourceUri(ee,fe){return ht.asDebugSourceUri(ee,fe)}},Ni={registerTaskProvider:(ee,fe)=>Jt.registerTaskProvider(Ne,ee,fe),fetchTasks:ee=>Jt.fetchTasks(ee),executeTask:ee=>Jt.executeTask(Ne,ee),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(ee,fe,Te)=>Jt.onDidStartTask(ee,fe,Te),onDidEndTask:(ee,fe,Te)=>Jt.onDidEndTask(ee,fe,Te),onDidStartTaskProcess:(ee,fe,Te)=>Jt.onDidStartTaskProcess(ee,fe,Te),onDidEndTaskProcess:(ee,fe,Te)=>Jt.onDidEndTaskProcess(ee,fe,Te)},Oi={createNotebookController(ee,fe,Te,nt,bt){return oi.createNotebookController(Ne,ee,fe,Te,nt,(0,Oe.$9E)(Ne,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,fe)=>Dt.registerNotebookCellStatusBarItemProvider(Ne,ee,fe),createRendererMessaging(ee){return ki.createRendererMessaging(Ne,ee)},createNotebookControllerDetectionTask(ee){return(0,Oe.$0E)(Ne,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ne,ee)},registerKernelSourceActionProvider(ee,fe){return(0,Oe.$0E)(Ne,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ne,ee,fe)},onDidChangeNotebookCellExecutionState(ee,fe,Te){return(0,Oe.$0E)(Ne,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,fe,Te)}},zi={t(...ee){if(typeof ee[0]=="string"){const fe=ee.shift(),Te=!ee||typeof ee[0]!="object"?ee:ee[0];return qt.getMessage(Ne.identifier.value,{message:fe,args:Te})}return qt.getMessage(Ne.identifier.value,ee[0])},get bundle(){return qt.getBundle(Ne.identifier.value)},get uri(){return qt.getBundleUri(Ne.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(ee,fe){return(0,Oe.$0E)(Ne,"interactive"),Gi.registerProvider(Ne,ee,fe={label:fe?.label??Ne.displayName??Ne.name})},registerInteractiveSessionProvider(ee,fe){return(0,Oe.$0E)(Ne,"interactive"),gi.registerChatProvider(Ne,ee,fe)},sendInteractiveRequestToProvider(ee,fe){return(0,Oe.$0E)(Ne,"interactive"),gi.sendInteractiveRequestToProvider(ee,fe)},get onDidPerformUserAction(){return(0,Oe.$0E)(Ne,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ee,fe){return(0,Oe.$0E)(Ne,"interactive"),gi.transferChatSession(ee,fe)}},Ui={getRelatedInformation(ee,fe){return(0,Oe.$0E)(Ne,"aiRelatedInformation"),Zi.getRelatedInformation(Ne,ee,fe)},registerRelatedInformationProvider(ee,fe){return(0,Oe.$0E)(Ne,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Ne,ee,fe)},registerEmbeddingVectorProvider(ee,fe){return(0,Oe.$0E)(Ne,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Ne,ee,fe)}},ji={registerChatResponseProvider(ee,fe,Te){return(0,Oe.$0E)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,ee,fe,Te)},requestChatAccess(ee){return(0,Oe.$0E)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,ee)},registerVariable(ee,fe,Te){return(0,Oe.$0E)(Ne,"chatVariables"),Xi.registerVariableResolver(Ne,ee,fe,Te)},registerMappedEditsProvider(ee,fe){return(0,Oe.$0E)(Ne,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ne,ee,fe)},registerAgent(ee,fe,Te){return(0,Oe.$0E)(Ne,"chatAgents"),Qi.registerAgent(Ne.identifier,ee,fe,Te)}};return{version:ut.version,ai:Ui,authentication:xi,commands:_i,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:Z.$0K,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatMessage:Z.$ZL,ChatMessageRole:Z.ChatMessageRole,ChatVariableLevel:Z.ChatVariableLevel,CallHierarchyIncomingCall:Z.$wK,CallHierarchyItem:Z.$vK,CallHierarchyOutgoingCall:Z.$xK,CancellationError:M.$4,CancellationTokenSource:w.$Wd,CandidatePortSource:a.CandidatePortSource,CodeAction:Z.$sK,CodeActionKind:Z.$tK,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$yK,Color:Z.$LK,ColorInformation:Z.$MK,ColorPresentation:Z.$NK,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CompletionItem:Z.$FK,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$GK,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$VK,DebugAdapterExecutable:Z.$bL,DebugAdapterInlineImplementation:Z.$eL,DebugAdapterNamedPipeServer:Z.$dL,DebugAdapterServer:Z.$cL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$nK,DiagnosticRelatedInformation:Z.$mK,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$_J,DocumentHighlight:Z.$pK,DocumentHighlightKind:Z.DocumentHighlightKind,DocumentLink:Z.$KK,DocumentSymbol:Z.$rK,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$hL,InlineValueText:Z.$iL,InlineValueVariableLookup:Z.$jL,InlineValueEvaluatableExpression:Z.$kL,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:C.$Md,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$uL,FileDecoration2:Z.$uL,FileSystemError:Z.$mL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Z.$nL,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$_K,InlineCompletionItem:Z.$HK,InlineCompletionList:Z.$IK,Hover:Z.$oK,IndentAction:g.IndentAction,Location:Z.$lK,MarkdownString:Z.$zK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:Z.$AK,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$aK,ProcessExecution:Z.$TK,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$tL,Range:Z.$bK,RelativePattern:Z.$8K,Selection:Z.$cK,SelectionRange:Z.$uK,SemanticTokens:Z.$qL,SemanticTokensBuilder:Z.$pL,SemanticTokensEdit:Z.$rL,SemanticTokensEdits:Z.$sL,SemanticTokensLegend:Z.$oL,ShellExecution:Z.$UK,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$CK,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$BK,SnippetString:Z.$kK,SourceBreakpoint:Z.$$K,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$qK,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$WK,TaskGroup:Z.$SK,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$OK,TerminalQuickFixExecuteTerminalCommand:Z.$QK,TerminalQuickFixOpener:Z.$PK,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$RK,TerminalExitReason:Z.TerminalExitReason,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$gK,SnippetTextEdit:Z.$iK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$7K,ThemeIcon:Z.$6K,TreeItem:Z.$XK,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$PL,UIKind:p.UIKind,Uri:R.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$jK,DocumentDropEdit:Z.$4K,DocumentPasteEdit:Z.$5K,InlayHint:Z.$EK,InlayHintLabelPart:Z.$DK,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$fK,ResolvedAuthority:Z.$dK,ManagedResolvedAuthority:Z.$eK,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$EL,NotebookRange:Z.$wL,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$xL,NotebookData:Z.$yL,NotebookRendererScript:Z.$CL,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$AL,NotebookCellOutputItem:Z.$zL,NotebookCellStatusBarItem:Z.$BL,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$hK,NotebookKernelSourceAction:Z.$DL,PortAttributes:Z.$GL,LinkedEditingRanges:Z.$FL,TestResultState:Z.TestResultState,TestRunRequest:Z.$HL,TestMessage:Z.$IL,TestMessage2:Z.$IL,TestTag:Z.$JL,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Z.$3K,DataTransferItem:Z.$YK,CoveredCount:Z.$KL,FileCoverage:Z.$LL,StatementCoverage:Z.$ML,BranchCoverage:Z.$NL,FunctionCoverage:Z.$OL,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$QL,TabInputTextDiff:Z.$RL,TabInputTextMerge:Z.$SL,TabInputCustom:Z.$TL,TabInputNotebook:Z.$VL,TabInputNotebookDiff:Z.$WL,TabInputWebview:Z.$UL,TabInputTerminal:Z.$XL,TabInputInteractiveWindow:Z.$YL,TelemetryTrustedValue:ye.$fo,LogLevel:ve.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Z.$fL,ThreadFocus:Z.$gL,RelatedInformationType:Z.RelatedInformationType}}}e.$Mdc=Vt}),define(Re[273],Me([1,0,69,109,33,107,34,31,59,62,111,113,114,84,86,80,108,61,39,83,57,60,241,14,112,81,82]),function(be,e,w,M,C,F,R,l,D,g,P,k,a,p,$,f,t,i,c,b,E,v,r,s,n,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$sr)(o.$ncc,o.$mcc,1),(0,w.$sr)(s.$9i,r.$Ndc,1),(0,w.$sr)(f.$Mbc,f.$Nbc,1),(0,w.$sr)(l.$uM,l.$tM,0),(0,w.$sr)(R.$Zbc,R.$Xbc,0),(0,w.$sr)(i.$ccc,i.$bcc,0),(0,w.$sr)(k.$3cc,k.$7cc,0),(0,w.$sr)(F.$Ucc,F.$Tcc,0),(0,w.$sr)(D.$jM,D.$iM,0),(0,w.$sr)(y.$occ,y.$pcc,0),(0,w.$sr)(c.$Jbc,c.$Ibc,0),(0,w.$sr)(M.$Acc,M.$zcc,1),(0,w.$sr)(a.$adc,a.$bdc,0),(0,w.$sr)(p.$$bc,p.$0bc,0),(0,w.$sr)(P.$Xcc,P.$Wcc,0),(0,w.$sr)(g.$fcc,g.$icc,0),(0,w.$sr)($.$Uvb,$.$Vvb,0),(0,w.$sr)(t.$Qcc,t.$Pcc,0),(0,w.$sr)(C.$Wbc,C.$Vbc,0),(0,w.$sr)(b.$kcc,b.$jcc,0),(0,w.$sr)(E.$sM,E.$pM,0),(0,w.$sr)(v.$Ycc,v.$Zcc,0),(0,w.$sr)(n.$1cc,n.$2cc,0)}),define(Re[274],Me([1,0,272,35,2,269,7,12,260]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;class g extends F.$Qdc{j(){}getModule(p,$){for(const f of this.b){const t=f(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends M.$rcc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Vfc);const p=this.h.invokeFunction(w.$Mdc);this.r=this.h.createInstance(g,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,f){$=$.with({path:k($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const b=await c.text(),E=`${$.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${E}`;let r;try{r=new Function("module","exports","require",v)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${$.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const s={},n={exports:s},o=y=>{const d=this.r.getModule(y,$);if(d===void 0)throw new Error(`Cannot load module '${y}'`);return d};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,s,o),n.exports!==s?n.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Tg)(10)}}e.$Wfc=P;function k(a,p){return a.endsWith(p)?a:a+p}}),define(Re[275],Me([1,0,68,69,14,35,187,85,274]),function(be,e,w,M,C,F,R,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$sr)(C.$8i,new w.$Kh(R.$Pdc,[!0],!0)),(0,M.$sr)(F.$scc,D.$Wfc,0),(0,M.$sr)(l.$dcc,l.$ecc,0)}),define(Re[284],Me([1,0,25,5,79,270,262,19,87,13,2,273,275]),function(be,e,w,M,C,F,R,l,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const $=fetch.bind(self);function f(r){self.fetch=async function(s,n){return s instanceof Request||p(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),$(s,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,n,o,y,d){(async()=>(p(n.toString())&&(n=(await r(P.URI.parse(n.toString()))).toString(!0)),super.open(s,n,o??!0,y,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,n){if(/^file:/i.test(s.toString()))s=g.$bg.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(u){function m(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const h=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?h(W,V):h(m(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,U,B,O){return super.open(W,m(V),U??!0,B,O)}};const A=importScripts.bind(self);self.importScripts=(...W)=>{A(...W.map(m))},A(u)}.toString()}('${s}'))`;n=n||{},n.name=n.name||l.$mc(s.toString());const d=new Blob([y],{type:"application/javascript"}),I=URL.createObjectURL(d);return new r(I,n)}}else self.Worker=class extends R.$Xfc{constructor(r,s){super(a,r,{name:l.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){k()}};class i{constructor(){const s=new MessageChannel,n=new M.$Md;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=y=>{const{data:d}=y;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const I=w.$ae.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$$l)(I,2)){o=!0,b("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:y=>{if(!o){const d=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);s.port1.postMessage(d,[d])}}}}}function c(r){return new Promise(s=>{const n=r.onMessage(o=>{n.dispose();const y=JSON.parse(o.toString());r.send((0,C.$0l)(0)),s({protocol:r,initData:y})});r.send((0,C.$0l)(1))})}let b=r=>k();function E(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function v(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){E(s)&&c(r.protocol).then(n=>{D.mark("code/extHost/didWaitForInitData");const o=new F.$Sdc(n.protocol,n.initData,t,null,s.data);f(y=>o.asBrowserUri(y)),b=y=>o.terminate(y)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/874831ebcf088f59735879156f62308ce48f17d1/core/vs/workbench/api/worker/extensionHostWorker.js.map
