/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(z){for(var e=[],I=0,k=z.length;I<k;I++)e[I]=q[z[I]];return e};define(q[21],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const y=new Map,O=new Map,s=new Map,l=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function r(u,n){const i=u.get(n.detail);i&&(i>=0||u.set(n.detail,i+n.timestamp))}let o=[];typeof z=="function"&&typeof z.getStats=="function"&&(o=z.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of o)switch(u.type){case 10:t(y,u);break;case 11:case 12:r(y,u);break;case 21:t(O,u);break;case 22:r(O,u);break;case 33:t(s,u);break;case 34:r(s,u);break;case 31:t(l,u);break;case 32:r(l,u);break}let h=0;s.forEach(u=>h+=u);function g(u){const n=[];return u.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(y),amdInvoke:g(O),nodeRequire:g(s),nodeEval:g(l),nodeRequireTotal:h}}static toMarkdownTable(y,O){let s="";const l=[];return y.forEach((t,r)=>{l[r]=t.length}),O.forEach(t=>{t.forEach((r,o)=>{typeof r>"u"&&(r=t[o]="-");const h=r.toString().length;l[o]=Math.max(h,l[o])})}),y.forEach((t,r)=>{s+=`| ${t+" ".repeat(l[r]-t.toString().length)} `}),s+=`|
`,y.forEach((t,r)=>{s+=`| ${"-".repeat(l[r])} `}),s+=`|
`,O.forEach(t=>{t.forEach((r,o)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(l[o]-r.toString().length)} `)}),s+=`|
`}),s}}e.$T=I}),define(q[4],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qd=e.$pd=e.$od=void 0;let I;function k(i){I=i}e.$od=k;function y(){return I}e.$pd=y;class O{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([l(u("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[l(" "),r(o(a.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),r(o(a.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),r(o(a.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(a,v){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(v=>v.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleDerivedRecomputed(a,v){const A=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),this.formatChanges(A),{data:[{fn:a._computeFn}]}])),A.clear()}handleFromEventObservableTriggered(a,v){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleAutorunTriggered(a){const v=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(v),{data:[{fn:a._runFn}]}])),v.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let v=a.getDebugName();v===void 0&&(v=""),console.log(...this.b([t("transaction"),r(v,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$qd=O;function s(i){const a=new Array,v=[];let A="";function B(T){if("length"in T)for(const $ of T)$&&B($);else"text"in T?(A+=`%c${T.text}`,a.push(T.style),T.data&&v.push(...T.data)):"data"in T&&v.push(...T.data)}B(i);const N=[A,...a];return N.push(...v),N}function l(i){return r(i,{color:"black"})}function t(i){return r(n(`${i}: `,10),{color:"black",bold:!0})}function r(i,a={color:"black"}){function v(B){return Object.entries(B).reduce((N,[T,$])=>`${N}${T}:${$};`,"")}const A={color:a.color};return a.strikeThrough&&(A["text-decoration"]="line-through"),a.bold&&(A["font-weight"]="bold"),{text:i,style:v(A)}}function o(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?h(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function h(i,a){let v="[ ",A=!0;for(const B of i){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${o(B,a-v.length)}`}return v+=" ]",v}function g(i,a){let v="{ ",A=!0;for(const[B,N]of Object.entries(i)){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${B}: ${o(N,a-v.length)}`}return v+=" }",v}function u(i,a){let v="";for(let A=1;A<=a;A++)v+=i;return v}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(q[5],W([0,1,4]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;let k;function y(m){k=m}e.$wd=y;class O{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,w){const j=w===void 0?void 0:c,f=w===void 0?c:w;return k({owner:j,debugName:()=>{const S=A(f);if(S!==void 0)return S;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(D)return`${this.debugName}.${D[2]}`;if(!j)return`${this.debugName} (mapped)`}},S=>f(this.read(S),S))}}e.$xd=O;class s extends O{constructor(){super(...arguments),this.c=new Set}addObserver(c){const w=this.c.size;this.c.add(c),w===0&&this.f()}removeObserver(c){this.c.delete(c)&&this.c.size===0&&this.g()}f(){}g(){}}e.$yd=s;function l(m,c){const w=new r(m,c);try{m(w)}finally{w.finish()}}e.$zd=l;function t(m,c,w){m?c(m):l(c,w)}e.$Ad=t;class r{constructor(c,w){this._fn=c,this.b=w,this.a=[],(0,I.$pd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():A(this._fn)}updateObserver(c,w){this.a.push({observer:c,observable:w}),c.beginUpdate(w)}finish(){const c=this.a;this.a=null;for(const{observer:w,observable:j}of c)w.endUpdate(j);(0,I.$pd)()?.handleEndTransaction()}}e.$Bd=r;const o=new Map,h=new WeakMap;function g(m,c,w,j,f){const S=h.get(m);if(S)return S;const L=u(m,c,w,j,f);if(L){let D=o.get(L)??0;D++,o.set(L,D);const C=D===1?L:`${L}#${D}`;return h.set(m,C),C}}e.$Cd=g;function u(m,c,w,j,f){const S=h.get(m);if(S)return S;const L=j?a(j)+".":"";let D;if(c!==void 0)if(typeof c=="function"){if(D=c(),D!==void 0)return L+D}else return L+c;if(w!==void 0&&(D=A(w),D!==void 0))return L+D;if(j!==void 0){for(const C in j)if(j[C]===f)return L+C}}const n=new Map,i=new WeakMap;function a(m){const c=i.get(m);if(c)return c;const w=v(m);let j=n.get(w)??0;j++,n.set(w,j);const f=j===1?w:`${w}#${j}`;return i.set(m,f),f}function v(m){const c=m.constructor;return c?c.name:"Object"}function A(m){const c=m.toString(),j=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(c);return(j?j[1]:void 0)?.trim()}e.$Dd=A;function B(m,c){return typeof m=="string"?new N(void 0,m,c):new N(m,void 0,c)}e.$Ed=B;class N extends s{get debugName(){return g(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(c,w,j){super(),this.b=c,this.d=w,this.a=j}get(){return this.a}set(c,w,j){if(this.a===c)return;let f;w||(w=f=new r(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.a;this.e(c),(0,I.$pd)()?.handleObservableChanged(this,{oldValue:S,newValue:c,change:j,didChange:!0,hadValue:!0});for(const L of this.c)w.updateObserver(L,this),L.handleChange(this,j)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(c){this.a=c}}e.$Fd=N;function T(m,c){return typeof m=="string"?new $(void 0,m,c):new $(m,void 0,c)}e.$Gd=T;class $ extends N{e(c){this.a!==c&&(this.a&&this.a.dispose(),this.a=c)}dispose(){this.a?.dispose()}}e.$Hd=$}),define(q[9],W([0,1,42,2,5,4]),function(z,e,I,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;function s(n,i){return new g(n.debugName,i,void 0,void 0)}e.$7c=s;function l(n){return new g(void 0,n,void 0,void 0)}e.$8c=l;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$9c=t;function r(n,i){const a=new k.$Qc,v=t({debugName:n.debugName??(()=>(0,y.$Dd)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(A,B)=>{a.clear(),i(A,B,a)});return(0,k.$Pc)(()=>{v.dispose(),a.dispose()})}e.$0c=r;function o(n){const i=new k.$Qc,a=s({debugName:()=>(0,y.$Dd)(n)||"(anonymous)"},v=>{i.clear(),n(v,i)});return(0,k.$Pc)(()=>{a.dispose(),i.dispose()})}e.$$c=o;var h;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const i=(0,y.$Dd)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,v,A){this.h=i,this._runFn=a,this.i=v,this.j=A,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$pd)()?.handleAutorunCreated(this),this.k(),(0,k.$Ic)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$Jc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$pd)()?.handleAutorunTriggered(this);const a=this.g;this.g=this.i?.(),this._runFn(this,a)}}finally{(0,O.$pd)()?.handleAutorunFinished(this);for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,I.$5c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,a){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:a,didChange:A=>A===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const a=i.get();return this.e.add(i),this.f.delete(i),a}}e.$_c=g,function(n){n.Observer=g}(l||(e.$8c=l={}));function u(n,i){let a;return s({debugName:()=>(0,y.$Dd)(i)},v=>{const A=n.read(v),B=a;a=A,i({lastValue:B,newValue:A})})}e.$ad=u}),define(q[10],W([0,1,6,2,5,4]),function(z,e,I,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=void 0;const s=(u,n)=>u===n;function l(u,n){return n!==void 0?new g(u,void 0,n,void 0,void 0,void 0,s):new g(void 0,void 0,u,void 0,void 0,void 0,s)}e.$rd=l;function t(u,n){return new g(u.owner,u.debugName,n,void 0,void 0,void 0,u.equalityComparer??s)}e.$sd=t;function r(u,n){return new g(u.owner,u.debugName,n,u.createEmptyChangeSummary,u.handleChange,void 0,u.equalityComparer??s)}e.$td=r;function o(u,n){let i,a;n===void 0?(i=u,a=void 0):(a=u,i=n);const v=new k.$Qc;return new g(a,()=>(0,y.$Dd)(i)??"(anonymous)",A=>(v.clear(),i(A,v)),void 0,void 0,()=>v.dispose(),s)}e.$ud=o,(0,y.$wd)(t);var h;(function(u){u[u.initial=0]="initial",u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(h||(h={}));class g extends y.$yd{get debugName(){return(0,y.$Cd)(this,this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,a,v,A,B=void 0,N){super(),this.m=n,this.n=i,this._computeFn=a,this.p=v,this.q=A,this.s=B,this.t=N,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,O.$pd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,a=this.h;this.e=3;const v=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,v)}finally{for(const B of this.k)B.removeObserver(this);this.k.clear()}const A=i&&!this.t(a,this.h);if((0,O.$pd)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.h,change:void 0,didChange:A,hadValue:i}),A)for(const B of this.c)B.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const a of this.c)a.handlePossibleChange(this);if(i)for(const a of this.c)a.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const a of i)a.endUpdate(this)}if(this.i<0)throw new I.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const a=this.q?this.q({changedObservable:n,change:i,didChange:A=>A===n},this.l):!0,v=this.e===3;if(a&&(this.e===1||v)&&(this.e=2,v))for(const A of this.c)A.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$vd=g}),define(q[22],W([0,1,2,9,5,10,4]),function(z,e,I,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function l(c){return new t(c)}e.$bd=l;class t extends y.$xd{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function r(c){const w=(0,y.$Ed)("promiseValue",{});return c.then(j=>{w.set({value:j},void 0)}),w}e.$cd=r;function o(c,w){return new Promise(j=>{let f=!1,S=!1;const L=(0,k.$8c)(D=>{const C=c.read(D);w(C)&&(f?L.dispose():S=!0,j(C))});f=!0,S&&L.dispose()})}e.$dd=o;function h(c,w){return new g(c,w)}e.$ed=h;class g extends y.$yd{constructor(w,j){super(),this.h=w,this._getValue=j,this.b=!1,this.k=f=>{const S=this._getValue(f),L=!this.b||this.a!==S;(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:S,change:void 0,didChange:L,hadValue:this.b}),L&&(this.a=S,this.b&&(0,y.$zd)(D=>{for(const C of this.c)D.updateObserver(C,this),C.handleChange(this,void 0)},()=>{const D=this.i();return"Event fired"+(D?`: ${D}`:"")}),this.b=!0)}}i(){return(0,y.$Dd)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$fd=g,function(c){c.Observer=g}(h||(e.$ed=h={}));function u(c,w){return new n(c,w)}e.$gd=u;class n extends y.$yd{constructor(w,j){super(),this.debugName=w,this.b=j,this.h=()=>{(0,y.$zd)(f=>{for(const S of this.c)f.updateObserver(S,this),S.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(c){return typeof c=="string"?new a(c):new a(void 0,c)}e.$hd=i;class a extends y.$yd{get debugName(){return(0,y.$Cd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(w,j){super(),this.a=w,this.b=j}trigger(w,j){if(!w){(0,y.$zd)(f=>{this.trigger(f,j)},()=>`Trigger signal ${this.debugName}`);return}for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,j)}get(){}}function v(c,w,j){const f=(0,y.$Ed)("debounced",void 0);let S;return j.add((0,k.$8c)(L=>{const D=c.read(L);S&&clearTimeout(S),S=setTimeout(()=>{(0,y.$zd)(C=>{f.set(D,C)})},w)})),f}e.$id=v;function A(c,w,j){const f=(0,y.$Ed)("triggeredRecently",!1);let S;return j.add(c(()=>{f.set(!0,void 0),S&&clearTimeout(S),S=setTimeout(()=>{f.set(!1,void 0)},w)})),f}e.$jd=A;function B(c){const w=new T(!1);return c.addObserver(w),(0,I.$Pc)(()=>{c.removeObserver(w)})}e.$kd=B;function N(c){const w=new T(!0);return c.addObserver(w),c.reportChanges(),(0,I.$Pc)(()=>{c.removeObserver(w)})}e.$ld=N;class T{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,j){}}function $(c){let w;return(0,O.$rd)(f=>(w=c(f,w),w))}e.$md=$;function m(c,w){let j;const f=(0,y.$Ed)("derivedObservableWithWritableCache.counter",0),S=(0,O.$rd)(c,L=>(f.read(L),j=w(L,j),j));return Object.assign(S,{clearCache:L=>{j=void 0,f.set(f.get()+1,L)}})}e.$nd=m}),define(q[11],W([0,1,5,10,9,22,4]),function(z,e,I,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return I.$Ed}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return I.$Gd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return I.$zd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return I.$Ad}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$rd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$sd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$td}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$ud}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$ad}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$7c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$bd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$nd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$kd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$ld}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$ed}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$cd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$hd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$gd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$dd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$jd}}),!1&&(0,s.$od)(new s.$qd)}),define(q[23],W([0,1,6,2]),function(z,e,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function y(N){const T=N;return T?typeof T.read=="function":!1}e.$Xd=y;function O(N){const T=N;return T?[T.on,T.pause,T.resume,T.destroy].every($=>typeof $=="function"):!1}e.$Yd=O;function s(N){const T=N;return T?O(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$Zd=s;function l(N,T){return new t(N,T)}e.$1d=l;class t{constructor(T,$){this.e=T,this.f=$,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise($=>this.d.push($))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach($=>$(T))}h(T){this.c.error.length===0?(0,I.$Z)(T):this.c.error.slice(0).forEach($=>$(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,$){if(!this.a.destroyed)switch(T){case"data":this.c.data.push($),this.resume();break;case"end":this.c.end.push($),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push($),this.a.flowing&&this.k();break}}removeListener(T,$){if(this.a.destroyed)return;let m;switch(T){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const c=m.indexOf($);c>=0&&m.splice(c,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const $=[...this.d];this.d.length=0,$.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(N,T){const $=[];let m;for(;(m=N.read())!==null;)$.push(m);return T($)}e.$2d=r;function o(N,T,$){const m=[];let c;for(;(c=N.read())!==null&&m.length<$;)m.push(c);return c===null&&m.length>0?T(m):{read:()=>{if(m.length>0)return m.shift();if(typeof c<"u"){const w=c;return c=void 0,w}return N.read()}}}e.$3d=o;function h(N,T){return new Promise(($,m)=>{const c=[];g(N,{onData:w=>{T&&c.push(w)},onError:w=>{T?m(w):$(void 0)},onEnd:()=>{$(T?T(c):void 0)}})})}e.$4d=h;function g(N,T,$){N.on("error",m=>{$?.isCancellationRequested||T.onError(m)}),N.on("end",()=>{$?.isCancellationRequested||T.onEnd()}),N.on("data",m=>{$?.isCancellationRequested||T.onData(m)})}e.$5d=g;function u(N,T){return new Promise(($,m)=>{const c=new k.$Qc,w=[],j=L=>{if(w.push(L),w.length>T)return c.dispose(),N.pause(),$({stream:N,buffer:w,ended:!1})},f=L=>(c.dispose(),m(L)),S=()=>(c.dispose(),$({stream:N,buffer:w,ended:!0}));c.add((0,k.$Pc)(()=>N.removeListener("error",f))),N.on("error",f),c.add((0,k.$Pc)(()=>N.removeListener("end",S))),N.on("end",S),c.add((0,k.$Pc)(()=>N.removeListener("data",j))),N.on("data",j)})}e.$6d=u;function n(N,T){const $=l(T);return $.end(N),$}e.$7d=n;function i(){const N=l(()=>{throw new Error("not supported")});return N.end(),N}e.$8d=i;function a(N){let T=!1;return{read:()=>T?null:(T=!0,N)}}e.$9d=a;function v(N,T,$){const m=l($);return g(N,{onData:c=>m.write(T.data(c)),onError:c=>m.error(T.error?T.error(c):c),onEnd:()=>m.end()}),m}e.$0d=v;function A(N,T,$){let m=!1;return{read:()=>{const c=T.read();return m?c:(m=!0,c!==null?$([N,c]):N)}}}e.$$d=A;function B(N,T,$){let m=!1;const c=l($);return g(T,{onData:w=>m?c.write(w):(m=!0,c.write($([N,w]))),onError:w=>c.error(w),onEnd:()=>{m||(m=!0,c.write(N)),c.end()}}),c}e.$_d=B}),define(q[12],W([0,1,43,23]),function(z,e,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const y=typeof Buffer<"u",O=new I.$U(()=>new Uint8Array(256));let s,l;class t{static alloc(b){return y?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return y&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(b)):(s||(s=new TextEncoder),new t(s.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let K=0,V=b.length;K<V;K++)U.buffer[K]=b[K];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let G=0,H=b.length;G<H;G++)U+=b[G].byteLength}const K=t.alloc(U);let V=0;for(let G=0,H=b.length;G<H;G++){const p=b[G];K.set(p,V),V+=p.byteLength}return K}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return y?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){u(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,U){v(this.buffer,b,U)}indexOf(b,U=0){return r(this.buffer,b instanceof t?b.buffer:b,U)}}e.$ae=t;function r(C,b,U=0){const K=b.byteLength,V=C.byteLength;if(K===0)return 0;if(K===1)return C.indexOf(b[0]);if(K>V-U)return-1;const G=O.value;G.fill(b.length);for(let J=0;J<b.length;J++)G[b[J]]=b.length-J-1;let H=U+b.length-1,p=H,_=-1;for(;H<V;)if(C[H]===b[p]){if(p===0){_=H;break}H--,p--}else H+=Math.max(b.length-p,G[C[H]]),p=b.length-1;return _}e.$be=r;function o(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0}e.$ce=o;function h(C,b,U){C[U+0]=b&255,b=b>>>8,C[U+1]=b&255}e.$de=h;function g(C,b){return C[b]*2**24+C[b+1]*2**16+C[b+2]*2**8+C[b+3]}e.$ee=g;function u(C,b,U){C[U+3]=b,b=b>>>8,C[U+2]=b,b=b>>>8,C[U+1]=b,b=b>>>8,C[U]=b}e.$fe=u;function n(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0|C[b+2]<<16>>>0|C[b+3]<<24>>>0}e.$ge=n;function i(C,b,U){C[U+0]=b&255,b=b>>>8,C[U+1]=b&255,b=b>>>8,C[U+2]=b&255,b=b>>>8,C[U+3]=b&255}e.$he=i;function a(C,b){return C[b]}e.$ie=a;function v(C,b,U){C[U]=b}e.$je=v;function A(C){return k.$2d(C,b=>t.concat(b))}e.$ke=A;function B(C){return k.$9d(C)}e.$le=B;function N(C){return k.$4d(C,b=>t.concat(b))}e.$me=N;async function T(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await N(C.stream)])}e.$ne=T;function $(C){return k.$7d(C,b=>t.concat(b))}e.$oe=$;function m(C){return k.$0d(C,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$pe=m;function c(C){return k.$1d(b=>t.concat(b),C)}e.$qe=c;function w(C,b){return k.$$d(C,b,U=>t.concat(U))}e.$re=w;function j(C,b){return k.$_d(C,b,U=>t.concat(U))}e.$se=j;function f(C){let b=0,U=0,K=0;const V=new Uint8Array(Math.floor(C.length/4*3)),G=p=>{switch(U){case 3:V[K++]=b|p,U=0;break;case 2:V[K++]=b|p>>>2,b=p<<6,U=3;break;case 1:V[K++]=b|p>>>4,b=p<<4,U=2;break;default:b=p<<2,U=1}};for(let p=0;p<C.length;p++){const _=C.charCodeAt(p);if(_>=65&&_<=90)G(_-65);else if(_>=97&&_<=122)G(_-97+26);else if(_>=48&&_<=57)G(_-48+52);else if(_===43||_===45)G(62);else if(_===47||_===95)G(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${C[p]}`)}}const H=K;for(;U>0;)G(0);return t.wrap(V).slice(0,H)}e.$te=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:C},b=!0,U=!1){const K=U?L:S;let V="";const G=C.byteLength%3;let H=0;for(;H<C.byteLength-G;H+=3){const p=C[H+0],_=C[H+1],J=C[H+2];V+=K[p>>>2],V+=K[(p<<4|_>>>4)&63],V+=K[(_<<2|J>>>6)&63],V+=K[J&63]}if(G===1){const p=C[H+0];V+=K[p>>>2],V+=K[p<<4&63],b&&(V+="==")}else if(G===2){const p=C[H+0],_=C[H+1];V+=K[p>>>2],V+=K[(p<<4|_>>>4)&63],V+=K[_<<2&63],b&&(V+="=")}return V}e.$ue=D}),define(q[24],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(q[13],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.StringEOL=void 0;var I;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function k(y){let O=0,s=0,l=0,t=0;for(let r=0,o=y.length;r<o;r++){const h=y.charCodeAt(r);h===13?(O===0&&(s=r),O++,r+1<o&&y.charCodeAt(r+1)===10?(t|=2,r++):t|=3,l=r+1):h===10&&(t|=1,O===0&&(s=r),O++,l=r+1)}return O===0&&(s=y.length),[O,s,y.length-l,t]}e.$1s=k}),define(q[14],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(I||(e.LanguageId=I={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class l{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let h="mtk"+this.getForeground(r);const g=this.getFontStyle(r);return g&1&&(h+=" mtki"),g&2&&(h+=" mtkb"),g&4&&(h+=" mtku"),g&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(r,o){const h=this.getForeground(r),g=this.getFontStyle(r);let u=`color: ${o[h]};`;g&1&&(u+="font-style: italic;"),g&2&&(u+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(r){const o=this.getForeground(r),h=this.getFontStyle(r);return{foreground:o,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$Ys=l}),define(q[25],W([0,1,26]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DB=void 0;class k{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,l){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=l}replace(s,l,t){if(s>=this.a.length)return;if(l===0){this.insert(s,t);return}else if(t===0){this.delete(s,l);return}const r=this.a.slice(0,s),o=this.a.slice(s+l),h=y(t,this.b);this.a=r.concat(h,o)}delete(s,l){l===0||s>=this.a.length||this.a.splice(s,l)}insert(s,l){if(l===0||s>=this.a.length)return;const t=[];for(let r=0;r<l;r++)t[r]=this.b;this.a=(0,I.$Vb)(this.a,s,t)}}e.$DB=k;function y(O,s){const l=[];for(let t=0;t<O;t++)l[t]=s;return l}}),define(q[7],W([0,1,14]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,l){const t=k.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new k(r,s,l)}constructor(s,l,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(s){return s instanceof k?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,l,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=l<<1,o=r+(t<<1);for(let h=r;h<o;h++)if(this.a[h]!==s.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const l=this.a[(s<<1)+1],t=I.$Ys.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const l=this.a[(s<<1)+1];return I.$Ys.getTokenType(l)}getForeground(s){const l=this.a[(s<<1)+1];return I.$Ys.getForeground(l)}getClassName(s){const l=this.a[(s<<1)+1];return I.$Ys.getClassNameFromMetadata(l)}getInlineStyle(s,l){const t=this.a[(s<<1)+1];return I.$Ys.getInlineStyleFromMetadata(t,l)}getPresentation(s){const l=this.a[(s<<1)+1];return I.$Ys.getPresentationFromMetadata(l)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return k.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,l,t){return new y(this,s,l,t)}static convertToEndOffset(s,l){const r=(s.length>>>1)-1;for(let o=0;o<r;o++)s[o<<1]=s[o+1<<1];s[r<<1]=l}static findIndexInTokensArray(s,l){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const o=t+Math.floor((r-t)/2),h=s[o<<1];if(h===l)return o+1;h<l?t=o+1:h>l&&(r=o)}return t}withInserted(s){if(s.length===0)return this;let l=0,t=0,r="";const o=new Array;let h=0;for(;;){const g=l<this.b?this.a[l<<1]:-1,u=t<s.length?s[t]:null;if(g!==-1&&(u===null||g<=u.offset)){r+=this.c.substring(h,g);const n=this.a[(l<<1)+1];o.push(r.length,n),l++,h=g}else if(u){if(u.offset>h){r+=this.c.substring(h,u.offset);const n=this.a[(l<<1)+1];o.push(r.length,n),h=u.offset}r+=u.text,o.push(r.length,u.tokenMetadata),t++}else break}return new k(new Uint32Array(o),r,this.d)}}e.$2s=k;class y{constructor(s,l,t,r){this.a=s,this.b=l,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(l),this.f=0;for(let o=this.e,h=s.getCount();o<h&&!(s.getStartOffset(o)>=t);o++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const l=this.a.getEndOffset(this.e+s);return Math.min(this.c,l)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,l){return this.a.getInlineStyle(this.e+s,l)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(q[27],W([0,1,7]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=e.$3s=void 0,e.$3s=new Uint32Array(0).buffer;class k{static deleteBeginning(s,l){return s===null||s===e.$3s?s:k.delete(s,0,l)}static deleteEnding(s,l){if(s===null||s===e.$3s)return s;const t=y(s),r=t[t.length-2];return k.delete(s,l,r)}static delete(s,l,t){if(s===null||s===e.$3s||l===t)return s;const r=y(s),o=r.length>>>1;if(l===0&&r[r.length-2]===t)return e.$3s;const h=I.$2s.findIndexInTokensArray(r,l),g=h>0?r[h-1<<1]:0,u=r[h<<1];if(t<u){const A=t-l;for(let B=h;B<o;B++)r[B<<1]-=A;return s}let n,i;g!==l?(r[h<<1]=l,n=h+1<<1,i=l):(n=h<<1,i=g);const a=t-l;for(let A=h+1;A<o;A++){const B=r[A<<1]-a;B>i&&(r[n++]=B,r[n++]=r[(A<<1)+1],i=B)}if(n===r.length)return s;const v=new Uint32Array(n);return v.set(r.subarray(0,n),0),v.buffer}static append(s,l){if(l===e.$3s)return s;if(s===e.$3s)return l;if(s===null)return s;if(l===null)return null;const t=y(s),r=y(l),o=r.length>>>1,h=new Uint32Array(t.length+r.length);h.set(t,0);let g=t.length;const u=t[t.length-2];for(let n=0;n<o;n++)h[g++]=r[n<<1]+u,h[g++]=r[(n<<1)+1];return h.buffer}static insert(s,l,t){if(s===null||s===e.$3s)return s;const r=y(s),o=r.length>>>1;let h=I.$2s.findIndexInTokensArray(r,l);h>0&&r[h-1<<1]===l&&h--;for(let g=h;g<o;g++)r[g<<1]+=t;return s}}e.$4s=k;function y(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$5s=y}),define(q[28],W([0,1,26,12,44,13,27,15]),function(z,e,I,k,y,O,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=void 0;class t{static deserialize(o,h,g){const u=new Uint32Array(o.buffer),n=(0,k.$ee)(o,h);h+=4;const i=(0,k.$ee)(o,h);h+=4;const a=[];for(let v=0;v<i;v++){const A=(0,k.$ee)(o,h);h+=4,a.push(u.subarray(h/4,h/4+A/4)),h+=A}return g.push(new t(n,a)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,h){this.a=o,this.b=h}getLineRange(){return new l.$xs(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let h=0;h<this.b.length;h++){const g=this.b[h];if(!(g instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=g.byteLength}return o}serialize(o,h){(0,k.$fe)(o,this.a,h),h+=4,(0,k.$fe)(o,this.b.length,h),h+=4;for(let g=0;g<this.b.length;g++){const u=this.b[g];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,k.$fe)(o,u.byteLength,h),h+=4,o.set(new Uint8Array(u.buffer),h),h+=u.byteLength}return h}applyEdit(o,h){const[g,u]=(0,O.$1s)(h);this.c(o),this.d(new y.$ns(o.startLineNumber,o.startColumn),g,u)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const h=o.startLineNumber-this.a,g=o.endLineNumber-this.a;if(g<0){const u=g-h;this.a-=u;return}if(!(h>=this.b.length)){if(h<0&&g>=this.b.length){this.a=0,this.b=[];return}if(h===g){this.b[h]=s.$4s.delete(this.b[h],o.startColumn-1,o.endColumn-1);return}if(h>=0)if(this.b[h]=s.$4s.deleteEnding(this.b[h],o.startColumn-1),g<this.b.length){const u=s.$4s.deleteBeginning(this.b[g],o.endColumn-1);this.b[h]=s.$4s.append(this.b[h],u),this.b.splice(h+1,g-h)}else this.b[h]=s.$4s.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const u=-h;this.a-=u,this.b[g]=s.$4s.deleteBeginning(this.b[g],o.endColumn-1),this.b=this.b.slice(g)}}}d(o,h,g){if(h===0&&g===0)return;const u=o.lineNumber-this.a;if(u<0){this.a+=h;return}if(!(u>=this.b.length)){if(h===0){this.b[u]=s.$4s.insert(this.b[u],o.column-1,g);return}this.b[u]=s.$4s.deleteEnding(this.b[u],o.column-1),this.b[u]=s.$4s.insert(this.b[u],o.column-1,g),this.e(o.lineNumber,h)}}e(o,h){if(h===0)return;const g=[];for(let u=0;u<h;u++)g[u]=null;this.b=I.$Vb(this.b,o,g)}}e.$6s=t}),define(q[16],W([0,1,12,28]),function(z,e,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EB=void 0;class y{static deserialize(s){let l=0;const t=(0,I.$ee)(s,l);l+=4;const r=[];for(let o=0;o<t;o++)l=k.$6s.deserialize(s,l,r);return r}constructor(){this.a=[]}add(s,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(l);return}}this.a.push(new k.$6s(s,[l]))}finalize(){return this.a}serialize(){const s=this.b(),l=new Uint8Array(s);return this.c(l),l}b(){let s=0;s+=4;for(let l=0;l<this.a.length;l++)s+=this.a[l].serializeSize();return s}c(s){let l=0;(0,I.$fe)(s,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(s,l)}}e.$EB=y}),define(q[29],W([0,1,30,3,31,45]),function(z,e,I,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function s(f){return f===47||f===92}e.$Pf=s;function l(f){return f.replace(/[\\/]/g,I.$fc.sep)}e.$Qf=l;function t(f){return f.indexOf("/")===-1&&(f=l(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Rf=t;function r(f,S=I.$fc.sep){if(!f)return"";const L=f.length,D=f.charCodeAt(0);if(s(D)){if(s(f.charCodeAt(1))&&!s(f.charCodeAt(2))){let b=3;const U=b;for(;b<L&&!s(f.charCodeAt(b));b++);if(U!==b&&!s(f.charCodeAt(b+1))){for(b+=1;b<L;b++)if(s(f.charCodeAt(b)))return f.slice(0,b+1).replace(/[\\/]/g,S)}}return S}else if(v(D)&&f.charCodeAt(1)===58)return s(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let C=f.indexOf("://");if(C!==-1){for(C+=3;C<L;C++)if(s(f.charCodeAt(C)))return f.slice(0,C+1)}return""}e.$Sf=r;function o(f){if(!k.$j||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const D=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(D===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$Tf=o;const h=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,S=k.$j){const L=S?h:g;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&u.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$Uf=n;function i(f,S,L){const D=f===S;return!L||D?D:!f||!S?!1:(0,y.$1e)(f,S)}e.$Vf=i;function a(f,S,L,D=I.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,y.$2e)(f,S))return!1;if(S.length===f.length)return!0;let b=S.length;return S.charAt(S.length-1)===D&&b--,f.charAt(b)===D}return S.charAt(S.length-1)!==D&&(S+=D),f.indexOf(S)===0}e.$Wf=a;function v(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Xf=v;function A(f,S){return k.$j&&f.endsWith(":")&&(f+=I.sep),(0,I.$hc)(f)||(f=(0,I.$ic)(S,f)),f=(0,I.$gc)(f),k.$j?(f=(0,y.$Je)(f,I.sep),f.endsWith(":")&&(f+=I.sep)):(f=(0,y.$Je)(f,I.sep),f||(f=I.sep)),f}e.$Yf=A;function B(f){const S=(0,I.$gc)(f);return k.$j?f.length>3?!1:N(S)&&(f.length===2||S.charCodeAt(2)===92):S===I.$fc.sep}e.$Zf=B;function N(f,S=k.$j){return S?v(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$1f=N;function T(f,S=k.$j){return N(f,S)?f[0]:void 0}e.$2f=T;function $(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$3f=$;function m(f){const S=f.split(":");let L,D,C;for(const b of S){const U=Number(b);(0,O.$Bf)(U)?D===void 0?D=U:C===void 0&&(C=U):L=L?[L,b].join(":"):b}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:D!==void 0?D:void 0,column:C!==void 0?C:D!==void 0?1:void 0}}e.$4f=m;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function j(f,S,L=8){let D="";for(let b=0;b<L;b++){let U;b===0&&k.$j&&!S&&(L===3||L===4)?U=w:U=c,D+=U.charAt(Math.floor(Math.random()*U.length))}let C;return S?C=`${S}-${D}`:C=D,f?(0,I.$ic)(f,C):C}e.$5f=j}),define(q[17],W([0,1,6,3,8]),function(z,e,I,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var O;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$6f="vscode-tkn",e.$7f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${O.vscodeRemoteResource}`}set(o,h,g){this.a[o]=h,this.b[o]=g}setConnectionToken(o,h){this.c[o]=h}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(a){return I.$Z(a),o}const h=o.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[h],n=this.c[h];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$7f}=${encodeURIComponent(n)}`),y.URI.from({scheme:k.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:i})}}e.$8f=new s,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class l{static{this.a=e.$ag}asBrowserUri(o){const h=this.b(o,z);return this.uriToBrowserUri(h)}uriToBrowserUri(o){return o.scheme===O.vscodeRemote?e.$8f.rewrite(o):o.scheme===O.file&&(k.$n||k.$q&&k.$h.origin===`${O.vscodeFileResource}://${l.a}`)?o.with({scheme:O.vscodeFileResource,authority:o.authority||l.a,query:null,fragment:null}):o}asFileUri(o){const h=this.b(o,z);return this.uriToFileUri(h)}uriToFileUri(o){return o.scheme===O.vscodeFileResource?o.with({scheme:O.file,authority:o.authority!==l.a?o.authority:null,query:null,fragment:null}):o}b(o,h){return y.URI.isUri(o)?o:y.URI.parse(h.toUrl(o))}}e.$bg=new l;var t;(function(r){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(o.get("3"));const h="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:y.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(h);if(a)return o.get(a)}r.getHeadersFromQuery=g;function u(n,i,a){if(!globalThis.crossOriginIsolated)return;const v=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(h,v):n[h]=v}r.addSearchParam=u})(t||(e.COI=t={}))}),define(q[32],W([0,1,21,17,3,8]),function(z,e,I,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class s{constructor(g,u,n){this.id=g,this.dependencies=u,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,n)=>{typeof g!="string"&&(n=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new s(g,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",v),i.removeEventListener("error",A)},v=B=>{a(),u(this.c.pop())},A=B=>{a(),n(B)};i.addEventListener("load",v),i.addEventListener("error",A),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((u,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(i){n(i)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=O.URI.parse(g).fsPath,v=u.readFileSync(a).toString(),A=i.wrap(v.replace(/^#!.*/,""));return new n.Script(A).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function o(h,g,u){if(I.$S){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[h]&&(h=r[h]);const n=`${h}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const B=`${u&&!y.$p?k.$$f:k.$0f}/${n}`;i=k.$bg.asBrowserUri(B).toString(!0)}const a=l.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{z([h],n,i)})}e.$gC=o}),define(q[18],W([0,1,29,17,30,3,31,8]),function(z,e,I,k,y,O,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function t(u){return(0,l.$vc)(u,!0)}e.$ig=t;class r{constructor(n){this.a=n}compare(n,i,a=!1){return n===i?0:(0,s.$Te)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return I.$Wf(t(n),t(i),this.a(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.$zg)(n.authority,i.authority))return I.$Wf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$rg)(n)||n.authority}basename(n){return y.$fc.basename(n.path)}extname(n){return y.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(y.$lc(t(n))).path:(i=y.$fc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(y.$gc(t(n))).path:i=y.$fc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$zg)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const A=y.$kc(t(n),t(i));return O.$j?I.$Qf(A):A}let a=n.path||"/";const v=i.path||"/";if(this.a(n)){let A=0;for(const B=Math.min(a.length,v.length);A<B&&!(a.charCodeAt(A)!==v.charCodeAt(A)&&a.charAt(A).toLowerCase()!==v.charAt(A).toLowerCase());A++);a=v.substr(0,A)+a.substr(A)}return y.$fc.relative(a,v)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const a=l.URI.file(y.$jc(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=I.$Rf(i),n.with({path:y.$fc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.$1e)(n,i)}hasTrailingPathSeparator(n,i=y.sep){if(n.scheme===k.Schemas.file){const a=t(n);return a.length>I.$Sf(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=y.sep){return(0,e.$Ag)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=y.sep){let a=!1;if(n.scheme===k.Schemas.file){const v=t(n);a=v!==void 0&&v.length===I.$Sf(v).length&&v[v.length-1]===i}else{i="/";const v=n.path;a=v.length===1&&v.charCodeAt(v.length-1)===47}return!a&&!(0,e.$Ag)(n,i)?n.with({path:n.path+"/"}):n}}e.$jg=r,e.$kg=new r(()=>!1),e.$lg=new r(u=>u.scheme===k.Schemas.file?!O.$l:!0),e.$mg=new r(u=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function o(u,n){const i=[];for(let a=0;a<u.length;a++){const v=n(u[a]);u.some((A,B)=>B===a?!1:(0,e.$og)(v,n(A)))||i.push(u[a])}return i}e.$Dg=o;var h;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(B=>{const[N,T]=B.split(":");N&&T&&a.set(N,T)});const A=i.path.substring(0,i.path.indexOf(";"));return A&&a.set(u.META_DATA_MIME,A),a}u.parseMetaData=n})(h||(e.DataUri=h={}));function g(u,n,i){if(n){let a=u.path;return a&&a[0]!==y.$fc.sep&&(a=y.$fc.sep+a),u.with({scheme:i,authority:n,path:a})}return u.with({scheme:i})}e.$Eg=g}),define(q[19],W([0,1,46,6,33,2,18,3,24]),function(z,e,I,k,y,O,s,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function r(M){return!!M&&typeof M.then=="function"}e.$Fg=r;function o(M){const d=new I.$Wd,E=M(d.token),P=new Promise((R,F)=>{const Y=d.token.onCancellationRequested(()=>{Y.dispose(),d.dispose(),F(new k.$4)});Promise.resolve(E).then(Q=>{Y.dispose(),d.dispose(),R(Q)},Q=>{Y.dispose(),d.dispose(),F(Q)})});return new class{cancel(){d.cancel()}then(R,F){return P.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return P.finally(R)}}}e.$Gg=o;function h(M,d,E){return new Promise((P,R)=>{const F=d.onCancellationRequested(()=>{F.dispose(),P(E)});M.then(P,R).finally(()=>F.dispose())})}e.$Hg=h;function g(M,d){return new Promise((E,P)=>{const R=d.onCancellationRequested(()=>{R.dispose(),P(new k.$4)});M.then(E,P).finally(()=>R.dispose())})}e.$Ig=g;async function u(M){let d=-1;const E=M.map((P,R)=>P.then(F=>(d=R,F)));try{return await Promise.race(E)}finally{M.forEach((P,R)=>{R!==d&&P.cancel()})}}e.$Jg=u;function n(M,d,E){let P;const R=setTimeout(()=>{P?.(void 0),E?.()},d);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(F=>P=F)])}e.$Kg=n;function i(M){return new Promise((d,E)=>{const P=M();r(P)?P.then(d,E):d(P)})}e.$Lg=i;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(d){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=d,!this.b){const E=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(E,E).then(P)})}return new Promise((E,P)=>{this.b.then(E,P)})}return this.a=d(),new Promise((E,P)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,P(R)})})}dispose(){this.f=!0}}e.$Mg=a;class v{constructor(){this.a=Promise.resolve(null)}queue(d){return this.a=this.a.then(()=>d(),()=>d())}}e.$Ng=v;class A{constructor(){this.a=new Map}queue(d,E){const R=(this.a.get(d)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(d)===R&&this.a.delete(d)});return this.a.set(d,R),R}}e.$Og=A;const B=(M,d)=>{let E=!0;const P=setTimeout(()=>{E=!1,d()},M);return{isTriggered:()=>E,dispose:()=>{clearTimeout(P),E=!1}}},N=M=>{let d=!0;return queueMicrotask(()=>{d&&(d=!1,M())}),{isTriggered:()=>d,dispose:()=>{d=!1}}};class T{constructor(d){this.defaultDelay=d,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(d,E=this.defaultDelay){this.g=d,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$Jd?N(P):B(E,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=T;class ${constructor(d){this.a=new T(d),this.b=new a}trigger(d,E){return this.a.trigger(()=>this.b.queue(d),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=$;class m{constructor(){this.a=!1,this.b=new Promise((d,E)=>{this.d=d})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=m;class c extends m{constructor(d){super(),this.f=setTimeout(()=>this.open(),d)}open(){clearTimeout(this.f),super.open()}}e.$Sg=c;function w(M,d){return d?new Promise((E,P)=>{const R=setTimeout(()=>{F.dispose(),E()},M),F=d.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),P(new k.$4)})}):o(E=>w(M,E))}e.$Tg=w;function j(M,d=0,E){const P=setTimeout(()=>{M(),E&&R.dispose()},d),R=(0,O.$Pc)(()=>{clearTimeout(P),E?.deleteAndLeak(R)});return E?.add(R),R}e.$Ug=j;function f(M){const d=[];let E=0;const P=M.length;function R(){return E<P?M[E++]():null}function F(Y){Y!=null&&d.push(Y);const Q=R();return Q?Q.then(F):Promise.resolve(d)}return Promise.resolve(null).then(F)}e.$Vg=f;function S(M,d=P=>!!P,E=null){let P=0;const R=M.length,F=()=>{if(P>=R)return Promise.resolve(E);const Y=M[P++];return Promise.resolve(Y()).then(X=>d(X)?Promise.resolve(X):F())};return F()}e.$Wg=S;function L(M,d=P=>!!P,E=null){if(M.length===0)return Promise.resolve(E);let P=M.length;const R=()=>{P=-1;for(const F of M)F.cancel?.()};return new Promise((F,Y)=>{for(const Q of M)Q.then(X=>{--P>=0&&d(X)?(R(),F(X)):P===0&&F(E)}).catch(X=>{--P>=0&&(R(),Y(X))})})}e.$Xg=L;class D{constructor(d){this.a=0,this.d=d,this.f=[],this.b=0,this.g=new y.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(d){return this.a++,new Promise((E,P)=>{this.f.push({factory:d,c:E,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const d=this.f.shift();this.b++;const E=d.factory();E.then(d.c,d.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=D;class C extends D{constructor(){super(1)}}e.$Zg=C;class b{constructor(){this.a=new x,this.b=0}queue(d){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,d())):this.a.run(this.b++,d())}}e.$1g=b;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const d=new te;return this.b.add(d),d.p}g(){for(const[,d]of this.a)if(d.size>0)return!1;return!0}queueFor(d,E=s.$kg){const P=E.getComparisonKey(d);let R=this.a.get(P);if(!R){R=new C;const F=this.f++,Y=y.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(P),this.h(),this.d?.deleteAndDispose(F),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$Zc),this.d.set(F,Y),this.a.set(P,R)}return R}h(){this.g()&&this.j()}j(){for(const d of this.b)d.complete();this.b.clear()}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=U;class K{constructor(d,E){this.a=-1,typeof d=="function"&&typeof E=="number"&&this.setIfNotSet(d,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(d,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,d()},E)}setIfNotSet(d,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,d()},E))}}e.$3g=K;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(d,E){this.cancel(),this.a=setInterval(()=>{d()},E)}}e.$4g=V;class G{constructor(d,E){this.b=-1,this.a=d,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(d=this.d){this.cancel(),this.b=setTimeout(this.f,d)}get delay(){return this.d}set delay(d){this.d=d}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=G;class H{constructor(d,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=d,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(d=this.b){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(d/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=H;class p extends G{constructor(d,E){super(d,E),this.j=[]}work(d){this.j.push(d),this.isScheduled()||this.schedule()}h(){const d=this.j;this.j=[],this.a?.(d)}dispose(){this.j=[],super.dispose()}}e.$7g=p;class _ extends O.$Rc{constructor(d,E){super(),this.g=d,this.h=E,this.a=[],this.b=this.B(new O.$Sc),this.f=!1}get pending(){return this.a.length}work(d){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+d.length>this.g.maxBufferedWork)return!1}else if(this.pending+d.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of d)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=M=>{(0,l.$B)(()=>{if(d)return;const E=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let d=!1;return{dispose(){d||(d=!0)}}}:e.$9g=(M,d)=>{const E=requestIdleCallback(M,typeof d=="number"?{timeout:d}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(E))}}}}();class J{constructor(d){this.d=!1,this.a=()=>{try{this.f=d()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=J;async function re(M,d,E){let P;for(let R=0;R<E;R++)try{return await M()}catch(F){P=F,await w(d)}throw P}e.$$g=re;class x{isRunning(d){return typeof d=="number"?this.a?.taskId===d:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(d,E,P){return this.a={taskId:d,cancel:()=>P?.(),promise:E},E.then(()=>this.d(d),()=>this.d(d)),E}d(d){this.a&&d===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const d=this.b;this.b=void 0,d.run().then(d.promiseResolve,d.promiseReject)}}queue(d){if(this.b)this.b.run=d;else{let E,P;const R=new Promise((F,Y)=>{E=F,P=Y});this.b={run:d,promise:R,promiseResolve:E,promiseReject:P}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=x;class ae{constructor(d,E=()=>Date.now()){this.d=d,this.f=E,this.a=0,this.b=0}increment(){const d=this.f();return d-this.a>this.d&&(this.a=d,this.b=0),this.b++,this.b}}e.$ah=ae;var ee;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((d,E)=>{this.a=d,this.b=E})}complete(d){return new Promise(E=>{this.a(d),this.d={outcome:0,value:d},E()})}error(d){return new Promise(E=>{this.b(d),this.d={outcome:1,value:d},E()})}cancel(){return this.error(new k.$4)}}e.$bh=te;var ne;(function(M){async function d(P){let R;const F=await Promise.all(P.map(Y=>Y.then(Q=>Q,Q=>{R||(R=Q)})));if(typeof R<"u")throw R;return F}M.settled=d;function E(P){return new Promise(async(R,F)=>{try{await P(R,F)}catch(Y){F(Y)}})}M.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class Z{static fromArray(d){return new Z(E=>{E.emitMany(d)})}static fromPromise(d){return new Z(async E=>{E.emitMany(await d)})}static fromPromises(d){return new Z(async E=>{await Promise.all(d.map(async P=>E.emitOne(await P)))})}static merge(d){return new Z(async E=>{await Promise.all(d.map(async P=>{for await(const R of P)E.emitOne(R)}))})}static{this.EMPTY=Z.fromArray([])}constructor(d){this.a=0,this.b=[],this.d=null,this.f=new y.$Md,queueMicrotask(async()=>{const E={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(d(E)),this.j()}catch(P){this.k(P)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let d=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(d<this.b.length)return{done:!1,value:this.b[d++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(d,E){return new Z(async P=>{for await(const R of d)P.emitOne(E(R))})}map(d){return Z.map(this,d)}static filter(d,E){return new Z(async P=>{for await(const R of d)E(R)&&P.emitOne(R)})}filter(d){return Z.filter(this,d)}static coalesce(d){return Z.filter(d,E=>!!E)}coalesce(){return Z.coalesce(this)}static async toPromise(d){const E=[];for await(const P of d)E.push(P);return E}toPromise(){return Z.toPromise(this)}g(d){this.a===0&&(this.b.push(d),this.f.fire())}h(d){this.a===0&&(this.b=this.b.concat(d),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(d){this.a===0&&(this.a=2,this.d=d,this.f.fire())}}e.$ch=Z;class se extends Z{constructor(d,E){super(E),this.l=d}cancel(){this.l.cancel()}}e.$dh=se;function he(M){const d=new I.$Wd,E=M(d.token);return new se(d,async P=>{const R=d.token.onCancellationRequested(()=>{R.dispose(),d.dispose(),P.reject(new k.$4)});try{for await(const F of E){if(d.token.isCancellationRequested)return;P.emitOne(F)}R.dispose(),d.dispose()}catch(F){R.dispose(),d.dispose(),P.reject(F)}})}e.$eh=he}),define(q[20],W([0,1,34]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CB=e.$BB=e.$AB=void 0,e.$AB=new class{clone(){return this}equals(O){return this===O}};function k(O,s){return new I.$9s([new I.$8s(0,"",O)],s)}e.$BB=k;function y(O,s){const l=new Uint32Array(2);return l[0]=0,l[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new I.$0s(l,s===null?e.$AB:s)}e.$CB=y}),define(q[35],W([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,I,k,y,O,s,l,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=void 0;var u;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor($,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new a($)}getStartState($){return this.store.getStartState($,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$FB=n;class i extends n{constructor($,m,c,w){super($,m),this._textModel=c,this._languageIdCodec=w}updateTokensUntilLine($,m){const c=this._textModel.getLanguageId();for(;;){const w=this.getFirstInvalidLine();if(!w||w.lineNumber>m)break;const j=this._textModel.getLineContent(w.lineNumber),f=B(this._languageIdCodec,c,this.tokenizationSupport,j,!0,w.startState);$.add(w.lineNumber,f.tokens),this.store.setEndState(w.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter($,m){const c=this.getStartState($.lineNumber);if(!c)return 0;const w=this._textModel.getLanguageId(),j=this._textModel.getLineContent($.lineNumber),f=j.substring(0,$.column-1)+m+j.substring($.column-1),S=B(this._languageIdCodec,w,this.tokenizationSupport,f,!0,c),L=new g.$2s(S.tokens,f,this._languageIdCodec);if(L.getCount()===0)return 0;const D=L.findTokenIndexAtOffset($.column-1);return L.getStandardTokenType(D)}tokenizeLineWithEdit($,m,c){const w=$.lineNumber,j=$.column,f=this.getStartState(w);if(!f)return null;const S=this._textModel.getLineContent(w),L=S.substring(0,j-1)+c+S.substring(j-1+m),D=this._textModel.getLanguageIdAtPosition(w,0),C=B(this._languageIdCodec,D,this.tokenizationSupport,L,!0,f);return new g.$2s(C.tokens,L,this._languageIdCodec)}isCheapToTokenize($){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return $<m||$===m&&this._textModel.getLineLength($)<2048}tokenizeHeuristically($,m,c){if(c<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine($,c),{heuristicTokens:!1};let w=this.b(m);const j=this._textModel.getLanguageId();for(let f=m;f<=c;f++){const S=this._textModel.getLineContent(f),L=B(this._languageIdCodec,j,this.tokenizationSupport,S,!0,w);$.add(f,L.tokens),w=L.endState}return{heuristicTokens:!0}}b($){let m=this._textModel.getLineFirstNonWhitespaceColumn($);const c=[];let w=null;for(let S=$-1;m>1&&S>=1;S--){const L=this._textModel.getLineFirstNonWhitespaceColumn(S);if(L!==0&&L<m&&(c.push(this._textModel.getLineContent(S)),m=L,w=this.getStartState(S),w))break}w||(w=this.tokenizationSupport.getInitialState()),c.reverse();const j=this._textModel.getLanguageId();let f=w;for(const S of c)f=B(this._languageIdCodec,j,this.tokenizationSupport,S,!1,f).endState;return f}}e.$GB=i;class a{constructor($){this.d=$,this.a=new v,this.b=new A,this.b.addRange(new t.$vs(1,$+1))}getEndState($){return this.a.getEndState($)}setEndState($,m){if(!m)throw new k.$bb("Cannot set null/undefined state");this.b.delete($);const c=this.a.setEndState($,m);return c&&$<this.d&&this.b.addRange(new t.$vs($+1,$+2)),c}acceptChange($,m){this.d+=m-$.length,this.a.acceptChange($,m),this.b.addRangeAndResize(new t.$vs($.startLineNumber,$.endLineNumberExclusive),m)}acceptChanges($){for(const m of $){const[c]=(0,s.$1s)(m.text);this.acceptChange(new l.$xs(m.range.startLineNumber,m.range.endLineNumber+1),c+1)}}invalidateEndStateRange($){this.b.addRange(new t.$vs($.startLineNumber,$.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState($,m){return $===1?m:this.getEndState($-1)}getFirstInvalidLine($){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const c=this.getStartState(m,$);if(!c)throw new k.$bb("Start state must be defined");return{lineNumber:m,startState:c}}}e.$HB=a;class v{constructor(){this.a=new o.$DB(null)}getEndState($){return this.a.get($)}setEndState($,m){const c=this.a.get($);return c&&c.equals(m)?!1:(this.a.set($,m),!0)}acceptChange($,m){let c=$.length;m>0&&c>0&&(c--,m--),this.a.replace($.startLineNumber,c,m)}acceptChanges($){for(const m of $){const[c]=(0,s.$1s)(m.text);this.acceptChange(new l.$xs(m.range.startLineNumber,m.range.endLineNumber+1),c+1)}}}e.$IB=v;class A{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const $=this.a[0];return $.start+1===$.endExclusive?this.a.shift():this.a[0]=new t.$vs($.start+1,$.endExclusive),$.start}delete($){const m=this.a.findIndex(c=>c.contains($));if(m!==-1){const c=this.a[m];c.start===$?c.endExclusive===$+1?this.a.splice(m,1):this.a[m]=new t.$vs($+1,c.endExclusive):c.endExclusive===$+1?this.a[m]=new t.$vs(c.start,$):this.a.splice(m,1,new t.$vs(c.start,$),new t.$vs($+1,c.endExclusive))}}addRange($){t.$vs.addRange($,this.a)}addRangeAndResize($,m){let c=0;for(;!(c>=this.a.length||$.start<=this.a[c].endExclusive);)c++;let w=c;for(;!(w>=this.a.length||$.endExclusive<this.a[w].start);)w++;const j=m-$.length;for(let f=w;f<this.a.length;f++)this.a[f]=this.a[f].delta(j);if(c===w){const f=new t.$vs($.start,$.start+m);f.isEmpty||this.a.splice(c,0,f)}else{const f=Math.min($.start,this.a[c].start),S=Math.max($.endExclusive,this.a[w-1].endExclusive),L=new t.$vs(f,S+j);L.isEmpty?this.a.splice(c,w-c):this.a.splice(c,w-c,L)}}toString(){return this.a.map($=>$.toString()).join(" + ")}}e.$JB=A;function B(T,$,m,c,w,j){let f=null;if(m)try{f=m.tokenizeEncoded(c,w,j.clone())}catch(S){(0,k.$Z)(S)}return f||(f=(0,r.$CB)(T.encodeLanguageId($),j)),g.$2s.convertToEndOffset(f.tokens,c.length),f}class N{constructor($,m){this.b=$,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,I.$9g)($=>{this.f=!1,this.h($)}))}h($){const m=Date.now()+$.timeRemaining(),c=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,y.$B)(c):this.g())};c()}j(){const $=this.b._textModel.getLineCount(),m=new h.$EB,c=O.$Id.create(!1);do if(c.elapsed()>1||this.l(m)>=$)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l($){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine($,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens($,m){this.b.store.invalidateEndStateRange(new l.$xs($,m))}}e.$KB=N}),define(q[37],W([0,1,33,2,36,14,34]),function(z,e,I,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bEb=void 0;class l extends k.$Rc{constructor(r,o,h,g,u,n,i){super(),this.c=r,this.f=o,this.g=h,this.h=g,this.j=u,this.m=n,this.n=i,this.a=[],this.b=this.B(new I.$Md),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,o,h){throw new Error("Not supported!")}createBackgroundTokenizer(r,o){if(this.h)return this.h(r,o)}tokenizeEncoded(r,o,h){const g=Math.random()*1e4<1,u=this.n||g,n=u?new y.$Id(!0):void 0,i=this.c.tokenizeLine2(r,h,500);if(u){const v=n.elapsed();(g||v>32)&&this.m(v,r.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$0s(i.tokens,h);if(this.g){const v=this.a,A=i.tokens;for(let B=0,N=A.length>>>1;B<N;B++){const T=A[(B<<1)+1],$=O.$Ys.getLanguageId(T);v[$]||(v[$]=!0,this.b.fire($))}}let a;return h.equals(i.ruleStack)?a=h:a=i.ruleStack,new s.$0s(i.tokens,a)}}e.$bEb=l}),define(q[38],W([0,1,20,2,11]),function(z,e,I,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cEb=void 0;class O extends k.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,r){super(),this.a=l,this.b=t,this.c=r,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,r){throw new Error("Not supported!")}tokenizeEncoded(l,t,r){return l.length>=this.c.get()?(0,I.$CB)(this.a,r):this.b.tokenizeEncoded(l,t,r)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$cEb=O}),define(q[39],W([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,I,k,y,O,s,l,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hEb=void 0;class u extends l.$Qu{constructor(a,v,A,B,N,T,$,m){super(a,v,A,B),this.s=N,this.t=T,this.u=$,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new k.$5g(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,v){this.t=a,this.u=v,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,v){this.a&&(this.a.store.invalidateEndStateRange(new s.$xs(a,v)),this.q.schedule())}async v(){this.a=null;const a=this.t,v=this.u,A=await this.s.getOrCreateGrammar(a,v);if(!(this.b||a!==this.t||v!==this.u||!A)){if(A.grammar){const B=new g.$cEb(this.u,new h.$bEb(A.grammar,A.initialState,!1,void 0,()=>!1,(N,T,$)=>{this.s.reportTokenizationTime(N,a,A.sourceExtensionId,T,$)},!1),this.c);this.a=new t.$FB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:v}=await(0,I.$gC)("vscode-textmate","release/main.js");this.m=v}const a=new Date().getTime();for(;;){let v=0;const A=new r.$EB,B=new n;for(;;){const $=this.a.getFirstInvalidLine();if($===null||v>200)break;v++;const m=this.f[$.lineNumber-1],c=this.a.tokenizationSupport.tokenizeEncoded(m,!0,$.startState);if(this.a.store.setEndState($.lineNumber,c.endState)){const j=this.m($.startState,c.endState);B.setState($.lineNumber,j)}else B.setState($.lineNumber,null);if(o.$2s.convertToEndOffset(c.tokens,m.length),A.add($.lineNumber,c.tokens),new Date().getTime()-a>20)break}if(v===0)break;const N=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,A.serialize(),N),new Date().getTime()-a>20){(0,O.$B)(()=>this.w());return}}}}e.$hEb=u;class n{constructor(){this.a=-1,this.b=[]}setState(a,v){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(v):this.b.push({startLineNumber:a,stateDeltas:[v]}),this.a=a}getStateDeltas(){return this.b}}}),define(q[40],W([0,1,18]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eEb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const s=this.a[O.scopeName];I.$ng(s.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$eEb=k}),define(q[41],W([0,1,2,40]),function(z,e,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gEb=e.$fEb=void 0,e.$fEb="No TM Grammar registered for this language.";class y extends I.$Rc{constructor(s,l,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new k.$eEb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async o=>{const h=this.c.getGrammarDefinition(o);if(!h)return this.a.logTrace(`No grammar found for scope ${o}`),null;const g=h.location;try{const u=await this.a.readFile(g);return t.parseRawGrammar(u,g.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${g}`,u),null}},getInjections:o=>{const h=o.split(".");let g=[];for(let u=1;u<=h.length;u++){const n=h.slice(0,u).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const o of l){if(this.c.register(o),o.injectTo){for(const h of o.injectTo){let g=this.f[h];g||(this.f[h]=g=[]),g.push(o.scopeName)}if(o.embeddedLanguages)for(const h of o.injectTo){let g=this.g[h];g||(this.g[h]=g=[]),g.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(s){return this.h.has(s)}setTheme(s,l){this.j.setTheme(s,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,l){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$fEb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$fEb);const o=r.embeddedLanguages;if(this.g[t]){const u=this.g[t];for(const n of u)for(const i of Object.keys(n))o[i]=n[i]}const h=Object.keys(o).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:o,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$fEb):u}return{languageId:s,grammar:g,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:r.sourceExtensionId}}}e.$gEb=y}),define(q[49],W([0,1,8,41,39]),function(z,e,I,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(l,t){return new s(l,t)}e.create=O;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const o=r.grammarDefinitions.map(h=>({location:I.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(o)}async g(t){const r=this.f.textmateMainUri,o=await new Promise((i,a)=>{z([r],i,a)}),h=await new Promise((i,a)=>{z([this.f.onigurumaMainUri],i,a)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(u);const n=Promise.resolve({createOnigScanner:i=>h.createOnigScanner(i),createOnigString:i=>h.createOnigString(i)});return new k.$gEb({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const r=I.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new y.$hEb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,g){const u=await o.d;return u?(o.c[g]||(o.c[g]=u.createGrammar(h,g)),o.c[g]):Promise.resolve(null)},setTokensAndStates(h,g,u){o.a.setTokensAndStates(t.controllerId,h,g,u)},reportTokenizationTime(h,g,u,n,i){o.a.reportTokenizationTime(h,g,u,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,o){this.b.get(t).retokenize(r,o)}acceptModelLanguageChanged(t,r,o){this.b.get(t).onLanguageId(r,o)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/874831ebcf088f59735879156f62308ce48f17d1/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
